/* A Bison parser, made by GNU Bison 3.0.4.  */

/* Bison implementation for Yacc-like parsers in C

   Copyright (C) 1984, 1989-1990, 2000-2015 Free Software Foundation, Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Bison version.  */
#define YYBISON_VERSION "3.0.4"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 1

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1


/* Substitute the variable and function names.  */
#define yyparse         base_yyparse
#define yylex           base_yylex
#define yyerror         base_yyerror
#define yydebug         base_yydebug
#define yynerrs         base_yynerrs


/* Copy the first part of user declarations.  */
#line 1 "gram.y" /* yacc.c:339  */


/*#define YYDEBUG 1*/
/*-------------------------------------------------------------------------
 *
 * gram.y
 *	  POSTGRESQL BISON rules/actions
 *
 * Portions Copyright (c) 2003-2022, PgPool Global Development Group
 * Portions Copyright (c) 1996-2022, PostgreSQL Global Development Group
 * Portions Copyright (c) 1994, Regents of the University of California
 *
 *
 * IDENTIFICATION
 *	  src/backend/parser/gram.y
 *
 * HISTORY
 *	  AUTHOR			DATE			MAJOR EVENT
 *	  Andrew Yu			Sept, 1994		POSTQUEL to SQL conversion
 *	  Andrew Yu			Oct, 1994		lispy code conversion
 *
 * NOTES
 *	  CAPITALS are used to represent terminal symbols.
 *	  non-capitals are used to represent non-terminals.
 *
 *	  In general, nothing in this file should initiate database accesses
 *	  nor depend on changeable state (such as SET variables).  If you do
 *	  database accesses, your code will fail when we have aborted the
 *	  current transaction and are just parsing commands to find the next
 *	  ROLLBACK or COMMIT.  If you make use of SET variables, then you
 *	  will do the wrong thing in multi-query strings like this:
 *			SET constraint_exclusion TO off; SELECT * FROM foo;
 *	  because the entire string is parsed by gram.y before the SET gets
 *	  executed.  Anything that depends on the database or changeable state
 *	  should be handled during parse analysis so that it happens at the
 *	  right time not the wrong time.
 *
 * WARNINGS
 *	  If you use a list, make sure the datum is a node so that the printing
 *	  routines work.
 *
 *	  Sometimes we assign constants to makeStrings. Make sure we don't free
 *	  those.
 *
 *-------------------------------------------------------------------------
 */

#include "pool_parser.h"
#include "utils/elog.h"
#include "utils/palloc.h"
#include <ctype.h>
#include <limits.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "nodes.h"
#include "keywords.h"
#include "gramparse.h"
#include "makefuncs.h"
#include "parser.h"
#include "pg_class.h"
#include "pg_trigger.h"

/*
 * Definition taken from
 * postgreSQL source code file: src/include/commands/trigger.h
 */
#define TRIGGER_FIRES_ON_ORIGIN                         'O'
#define TRIGGER_FIRES_ALWAYS                            'A'
#define TRIGGER_FIRES_ON_REPLICA                        'R'
#define TRIGGER_DISABLED                                'D'

/*
 * Definition taken from
 * postgreSQL source code file: src/include/catalog/pg_class.h
 */

#define           REPLICA_IDENTITY_DEFAULT      'd'
#define           REPLICA_IDENTITY_NOTHING      'n'
#define           REPLICA_IDENTITY_FULL         'f'
#define           REPLICA_IDENTITY_INDEX        'i'

/*
 * Definition taken from
 * postgreSQL source code file: src/include/catalog/pg_attribute.h
 */
#define		  ATTRIBUTE_IDENTITY_ALWAYS	'a'
#define		  ATTRIBUTE_IDENTITY_BY_DEFAULT 'd'

/*
 * Definition taken from
 * postgreSQL source code file: src/include/utils/xml.h
 */
typedef enum
{
	XML_STANDALONE_YES,
	XML_STANDALONE_NO,
	XML_STANDALONE_NO_VALUE,
	XML_STANDALONE_OMITTED
} XmlStandaloneType;

/*
 * Location tracking support --- simpler than bison's default, since we only
 * want to track the start position not the end position of each nonterminal.
 */
#define YYLLOC_DEFAULT(Current, Rhs, N) \
	do { \
		if ((N) > 0) \
			(Current) = (Rhs)[1]; \
		else \
			(Current) = (-1); \
	} while (0)

/*
 * The above macro assigns -1 (unknown) as the parse location of any
 * nonterminal that was reduced from an empty rule, or whose leftmost
 * component was reduced from an empty rule.  This is problematic
 * for nonterminals defined like
 *		OptFooList: / * EMPTY * / { ... } | OptFooList Foo { ... } ;
 * because we'll set -1 as the location during the first reduction and then
 * copy it during each subsequent reduction, leaving us with -1 for the
 * location even when the list is not empty.  To fix that, do this in the
 * action for the nonempty rule(s):
 *		if (@$ < 0) @$ = @2;
 * (Although we have many nonterminals that follow this pattern, we only
 * bother with fixing @$ like this when the nonterminal's parse location
 * is actually referenced in some rule.)
 *
 * A cleaner answer would be to make YYLLOC_DEFAULT scan all the Rhs
 * locations until it's found one that's not -1.  Then we'd get a correct
 * location for any nonterminal that isn't entirely empty.  But this way
 * would add overhead to every rule reduction, and so far there's not been
 * a compelling reason to pay that overhead.
 */

/*
 * Bison doesn't allocate anything that needs to live across parser calls,
 * so we can easily have it use palloc instead of malloc.  This prevents
 * memory leaks if we error out during parsing.  Note this only works with
 * bison >= 2.0.  However, in bison 1.875 the default is to use alloca()
 * if possible, so there's not really much problem anyhow, at least if
 * you're building with gcc.
 */
#define YYMALLOC palloc
#define YYFREE   pfree

/* Private struct for the result of privilege_target production */
typedef struct PrivTarget
{
	GrantTargetType targtype;
	ObjectType	objtype;
	List	   *objs;
} PrivTarget;

/* Private struct for the result of import_qualification production */
typedef struct ImportQual
{
	ImportForeignSchemaType type;
	List	   *table_names;
} ImportQual;

/* Private struct for the result of opt_select_limit production */
typedef struct SelectLimit
{
	Node	   *limitOffset;
	Node	   *limitCount;
	LimitOption limitOption;
} SelectLimit;

/* Private struct for the result of group_clause production */
typedef struct GroupClause
{
	bool		distinct;
	List	   *list;
} GroupClause;

/* Private structs for the result of key_actions and key_action productions */
typedef struct KeyAction
{
	char		action;
	List	   *cols;
} KeyAction;

typedef struct KeyActions
{
	KeyAction *updateAction;
	KeyAction *deleteAction;
} KeyActions;

/* ConstraintAttributeSpec yields an integer bitmask of these flags: */
#define CAS_NOT_DEFERRABLE			0x01
#define CAS_DEFERRABLE				0x02
#define CAS_INITIALLY_IMMEDIATE		0x04
#define CAS_INITIALLY_DEFERRED		0x08
#define CAS_NOT_VALID				0x10
#define CAS_NO_INHERIT				0x20


#define parser_yyerror(msg)  scanner_yyerror(msg, yyscanner)
#define parser_errposition(pos)  scanner_errposition(pos, yyscanner)

static void base_yyerror(YYLTYPE *yylloc, core_yyscan_t yyscanner,
						 const char *msg);
static RawStmt *makeRawStmt(Node *stmt, int stmt_location);
static void updateRawStmtEnd(RawStmt *rs, int end_location);
static Node *makeColumnRef(char *colname, List *indirection,
						   int location, core_yyscan_t yyscanner);
static Node *makeStringConst(char *str, int location);
static Node *makeFloatConst(char *str, int location);
static Node *makeBoolAConst(bool state, int location);
static Node *makeBitStringConst(char *str, int location);
static Node *makeNullAConst(int location);
static Node *makeAConst(Node *v, int location);
static RoleSpec *makeRoleSpec(RoleSpecType type, int location);
static void check_qualified_name(List *names, core_yyscan_t yyscanner);
static List *check_func_name(List *names, core_yyscan_t yyscanner);
static List *check_indirection(List *indirection, core_yyscan_t yyscanner);
static List *extractArgTypes(List *parameters);
static List *extractAggrArgTypes(List *aggrargs);
static List *makeOrderedSetArgs(List *directargs, List *orderedargs,
								core_yyscan_t yyscanner);
static void insertSelectOptions(SelectStmt *stmt,
								List *sortClause, List *lockingClause,
								SelectLimit *limitClause,
								WithClause *withClause,
								core_yyscan_t yyscanner);
static Node *makeSetOp(SetOperation op, bool all, Node *larg, Node *rarg);
static Node *doNegate(Node *n, int location);
static void doNegateFloat(Float *v);
static Node *makeAndExpr(Node *lexpr, Node *rexpr, int location);
static Node *makeOrExpr(Node *lexpr, Node *rexpr, int location);
static Node *makeNotExpr(Node *expr, int location);
static Node *makeAArrayExpr(List *elements, int location);
static Node *makeSQLValueFunction(SQLValueFunctionOp op, int32 typmod,
								  int location);
static Node *makeXmlExpr(XmlExprOp op, char *name, List *named_args,
						 List *args, int location);
static List *mergeTableFuncParameters(List *func_args, List *columns);
static TypeName *TableFuncTypeName(List *columns);
static RangeVar *makeRangeVarFromAnyName(List *names, int position, core_yyscan_t yyscanner);
static RangeVar *makeRangeVarFromQualifiedName(char *name, List *rels,
											   int location,
											   core_yyscan_t yyscanner);
static void SplitColQualList(List *qualList,
							 List **constraintList, CollateClause **collClause,
							 core_yyscan_t yyscanner);
static void processCASbits(int cas_bits, int location, const char *constrType,
			   bool *deferrable, bool *initdeferred, bool *not_valid,
			   bool *no_inherit, core_yyscan_t yyscanner);
static void preprocess_pubobj_list(List *pubobjspec_list,
								   core_yyscan_t yyscanner);
static Node *makeRecursiveViewSelect(char *relname, List *aliases, Node *query);


#line 328 "gram.c" /* yacc.c:339  */

# ifndef YY_NULLPTR
#  if defined __cplusplus && 201103L <= __cplusplus
#   define YY_NULLPTR nullptr
#  else
#   define YY_NULLPTR 0
#  endif
# endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

/* In a future release of Bison, this section will be replaced
   by #include "y.tab.h".  */
#ifndef YY_BASE_YY_Y_TAB_H_INCLUDED
# define YY_BASE_YY_Y_TAB_H_INCLUDED
/* Debug traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif
#if YYDEBUG
extern int base_yydebug;
#endif

/* Token type.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
  enum yytokentype
  {
    IDENT = 258,
    UIDENT = 259,
    FCONST = 260,
    SCONST = 261,
    USCONST = 262,
    BCONST = 263,
    XCONST = 264,
    Op = 265,
    ICONST = 266,
    PARAM = 267,
    TYPECAST = 268,
    DOT_DOT = 269,
    COLON_EQUALS = 270,
    EQUALS_GREATER = 271,
    LESS_EQUALS = 272,
    GREATER_EQUALS = 273,
    NOT_EQUALS = 274,
    ABORT_P = 275,
    ABSOLUTE_P = 276,
    ACCESS = 277,
    ACTION = 278,
    ADD_P = 279,
    ADMIN = 280,
    AFTER = 281,
    AGGREGATE = 282,
    ALL = 283,
    ALSO = 284,
    ALTER = 285,
    ALWAYS = 286,
    ANALYSE = 287,
    ANALYZE = 288,
    AND = 289,
    ANY = 290,
    ARRAY = 291,
    AS = 292,
    ASC = 293,
    ASENSITIVE = 294,
    ASSERTION = 295,
    ASSIGNMENT = 296,
    ASYMMETRIC = 297,
    ATOMIC = 298,
    AT = 299,
    ATTACH = 300,
    ATTRIBUTE = 301,
    AUTHORIZATION = 302,
    BACKWARD = 303,
    BEFORE = 304,
    BEGIN_P = 305,
    BETWEEN = 306,
    BIGINT = 307,
    BINARY = 308,
    BIT = 309,
    BOOLEAN_P = 310,
    BOTH = 311,
    BREADTH = 312,
    BY = 313,
    CACHE = 314,
    CALL = 315,
    CALLED = 316,
    CASCADE = 317,
    CASCADED = 318,
    CASE = 319,
    CAST = 320,
    CATALOG_P = 321,
    CHAIN = 322,
    CHAR_P = 323,
    CHARACTER = 324,
    CHARACTERISTICS = 325,
    CHECK = 326,
    CHECKPOINT = 327,
    CLASS = 328,
    CLOSE = 329,
    CLUSTER = 330,
    COALESCE = 331,
    COLLATE = 332,
    COLLATION = 333,
    COLUMN = 334,
    COLUMNS = 335,
    COMMENT = 336,
    COMMENTS = 337,
    COMMIT = 338,
    COMMITTED = 339,
    COMPRESSION = 340,
    CONCURRENTLY = 341,
    CONFIGURATION = 342,
    CONFLICT = 343,
    CONNECTION = 344,
    CONSTRAINT = 345,
    CONSTRAINTS = 346,
    CONTENT_P = 347,
    CONTINUE_P = 348,
    CONVERSION_P = 349,
    COPY = 350,
    COST = 351,
    CREATE = 352,
    CROSS = 353,
    CSV = 354,
    CUBE = 355,
    CURRENT_P = 356,
    CURRENT_CATALOG = 357,
    CURRENT_DATE = 358,
    CURRENT_ROLE = 359,
    CURRENT_SCHEMA = 360,
    CURRENT_TIME = 361,
    CURRENT_TIMESTAMP = 362,
    CURRENT_USER = 363,
    CURSOR = 364,
    CYCLE = 365,
    DATA_P = 366,
    DATABASE = 367,
    DAY_P = 368,
    DEALLOCATE = 369,
    DEC = 370,
    DECIMAL_P = 371,
    DECLARE = 372,
    DEFAULT = 373,
    DEFAULTS = 374,
    DEFERRABLE = 375,
    DEFERRED = 376,
    DEFINER = 377,
    DELETE_P = 378,
    DELIMITER = 379,
    DELIMITERS = 380,
    DEPENDS = 381,
    DEPTH = 382,
    DESC = 383,
    DETACH = 384,
    DICTIONARY = 385,
    DISABLE_P = 386,
    DISCARD = 387,
    DISTINCT = 388,
    DO = 389,
    DOCUMENT_P = 390,
    DOMAIN_P = 391,
    DOUBLE_P = 392,
    DROP = 393,
    EACH = 394,
    ELSE = 395,
    ENABLE_P = 396,
    ENCODING = 397,
    ENCRYPTED = 398,
    END_P = 399,
    ENUM_P = 400,
    ESCAPE = 401,
    EVENT = 402,
    EXCEPT = 403,
    EXCLUDE = 404,
    EXCLUDING = 405,
    EXCLUSIVE = 406,
    EXECUTE = 407,
    EXISTS = 408,
    EXPLAIN = 409,
    EXPRESSION = 410,
    EXTENSION = 411,
    EXTERNAL = 412,
    EXTRACT = 413,
    FALSE_P = 414,
    FAMILY = 415,
    FETCH = 416,
    FILTER = 417,
    FINALIZE = 418,
    FIRST_P = 419,
    FLOAT_P = 420,
    FOLLOWING = 421,
    FOR = 422,
    FORCE = 423,
    FOREIGN = 424,
    FORWARD = 425,
    FREEZE = 426,
    FROM = 427,
    FULL = 428,
    FUNCTION = 429,
    FUNCTIONS = 430,
    GENERATED = 431,
    GLOBAL = 432,
    GRANT = 433,
    GRANTED = 434,
    GREATEST = 435,
    GROUP_P = 436,
    GROUPING = 437,
    GROUPS = 438,
    HANDLER = 439,
    HAVING = 440,
    HEADER_P = 441,
    HOLD = 442,
    HOUR_P = 443,
    IDENTITY_P = 444,
    IF_P = 445,
    ILIKE = 446,
    IMMEDIATE = 447,
    IMMUTABLE = 448,
    IMPLICIT_P = 449,
    IMPORT_P = 450,
    IN_P = 451,
    INCLUDE = 452,
    INCLUDING = 453,
    INCREMENT = 454,
    INDEX = 455,
    INDEXES = 456,
    INHERIT = 457,
    INHERITS = 458,
    INITIALLY = 459,
    INLINE_P = 460,
    INNER_P = 461,
    INOUT = 462,
    INPUT_P = 463,
    INSENSITIVE = 464,
    INSERT = 465,
    INSTEAD = 466,
    INT_P = 467,
    INTEGER = 468,
    INTERSECT = 469,
    INTERVAL = 470,
    INTO = 471,
    INVOKER = 472,
    IS = 473,
    ISNULL = 474,
    ISOLATION = 475,
    JOIN = 476,
    KEY = 477,
    LABEL = 478,
    LANGUAGE = 479,
    LARGE_P = 480,
    LAST_P = 481,
    LATERAL_P = 482,
    LEADING = 483,
    LEAKPROOF = 484,
    LEAST = 485,
    LEFT = 486,
    LEVEL = 487,
    LIKE = 488,
    LIMIT = 489,
    LISTEN = 490,
    LOAD = 491,
    LOCAL = 492,
    LOCALTIME = 493,
    LOCALTIMESTAMP = 494,
    LOCATION = 495,
    LOCK_P = 496,
    LOCKED = 497,
    LOGGED = 498,
    MAPPING = 499,
    MATCH = 500,
    MATCHED = 501,
    MATERIALIZED = 502,
    MAXVALUE = 503,
    MERGE = 504,
    METHOD = 505,
    MINUTE_P = 506,
    MINVALUE = 507,
    MODE = 508,
    MONTH_P = 509,
    MOVE = 510,
    NAME_P = 511,
    NAMES = 512,
    NATIONAL = 513,
    NATURAL = 514,
    NCHAR = 515,
    NEW = 516,
    NEXT = 517,
    NFC = 518,
    NFD = 519,
    NFKC = 520,
    NFKD = 521,
    NO = 522,
    NONE = 523,
    NORMALIZE = 524,
    NORMALIZED = 525,
    NOT = 526,
    NOTHING = 527,
    NOTIFY = 528,
    NOTNULL = 529,
    NOWAIT = 530,
    NULL_P = 531,
    NULLIF = 532,
    NULLS_P = 533,
    NUMERIC = 534,
    OBJECT_P = 535,
    OF = 536,
    OFF = 537,
    OFFSET = 538,
    OIDS = 539,
    OLD = 540,
    ON = 541,
    ONLY = 542,
    OPERATOR = 543,
    OPTION = 544,
    OPTIONS = 545,
    OR = 546,
    ORDER = 547,
    ORDINALITY = 548,
    OTHERS = 549,
    OUT_P = 550,
    OUTER_P = 551,
    OVER = 552,
    OVERLAPS = 553,
    OVERLAY = 554,
    OVERRIDING = 555,
    OWNED = 556,
    OWNER = 557,
    PARALLEL = 558,
    PARAMETER = 559,
    PARSER = 560,
    PARTIAL = 561,
    PARTITION = 562,
    PASSING = 563,
    PASSWORD = 564,
    PGPOOL = 565,
    PLACING = 566,
    PLANS = 567,
    POLICY = 568,
    POSITION = 569,
    PRECEDING = 570,
    PRECISION = 571,
    PRESERVE = 572,
    PREPARE = 573,
    PREPARED = 574,
    PRIMARY = 575,
    PRIOR = 576,
    PRIVILEGES = 577,
    PROCEDURAL = 578,
    PROCEDURE = 579,
    PROCEDURES = 580,
    PROGRAM = 581,
    PUBLICATION = 582,
    QUOTE = 583,
    RANGE = 584,
    READ = 585,
    REAL = 586,
    REASSIGN = 587,
    RECHECK = 588,
    RECURSIVE = 589,
    REF = 590,
    REFERENCES = 591,
    REFERENCING = 592,
    REFRESH = 593,
    REINDEX = 594,
    RELATIVE_P = 595,
    RELEASE = 596,
    RENAME = 597,
    REPEATABLE = 598,
    REPLACE = 599,
    REPLICA = 600,
    RESET = 601,
    RESTART = 602,
    RESTRICT = 603,
    RETURN = 604,
    RETURNING = 605,
    RETURNS = 606,
    REVOKE = 607,
    RIGHT = 608,
    ROLE = 609,
    ROLLBACK = 610,
    ROLLUP = 611,
    ROUTINE = 612,
    ROUTINES = 613,
    ROW = 614,
    ROWS = 615,
    RULE = 616,
    SAVEPOINT = 617,
    SCHEMA = 618,
    SCHEMAS = 619,
    SCROLL = 620,
    SEARCH = 621,
    SECOND_P = 622,
    SECURITY = 623,
    SELECT = 624,
    SEQUENCE = 625,
    SEQUENCES = 626,
    SERIALIZABLE = 627,
    SERVER = 628,
    SESSION = 629,
    SESSION_USER = 630,
    SET = 631,
    SETS = 632,
    SETOF = 633,
    SHARE = 634,
    SHOW = 635,
    SIMILAR = 636,
    SIMPLE = 637,
    SKIP = 638,
    SMALLINT = 639,
    SNAPSHOT = 640,
    SOME = 641,
    SQL_P = 642,
    STABLE = 643,
    STANDALONE_P = 644,
    START = 645,
    STATEMENT = 646,
    STATISTICS = 647,
    STDIN = 648,
    STDOUT = 649,
    STORAGE = 650,
    STORED = 651,
    STRICT_P = 652,
    STRIP_P = 653,
    SUBSCRIPTION = 654,
    SUBSTRING = 655,
    SUPPORT = 656,
    SYMMETRIC = 657,
    SYSID = 658,
    SYSTEM_P = 659,
    TABLE = 660,
    TABLES = 661,
    TABLESAMPLE = 662,
    TABLESPACE = 663,
    TEMP = 664,
    TEMPLATE = 665,
    TEMPORARY = 666,
    TEXT_P = 667,
    THEN = 668,
    TIES = 669,
    TIME = 670,
    TIMESTAMP = 671,
    TO = 672,
    TRAILING = 673,
    TRANSACTION = 674,
    TRANSFORM = 675,
    TREAT = 676,
    TRIGGER = 677,
    TRIM = 678,
    TRUE_P = 679,
    TRUNCATE = 680,
    TRUSTED = 681,
    TYPE_P = 682,
    TYPES_P = 683,
    UESCAPE = 684,
    UNBOUNDED = 685,
    UNCOMMITTED = 686,
    UNENCRYPTED = 687,
    UNION = 688,
    UNIQUE = 689,
    UNKNOWN = 690,
    UNLISTEN = 691,
    UNLOGGED = 692,
    UNTIL = 693,
    UPDATE = 694,
    USER = 695,
    USING = 696,
    VACUUM = 697,
    VALID = 698,
    VALIDATE = 699,
    VALIDATOR = 700,
    VALUE_P = 701,
    VALUES = 702,
    VARCHAR = 703,
    VARIADIC = 704,
    VARYING = 705,
    VERBOSE = 706,
    VERSION_P = 707,
    VIEW = 708,
    VIEWS = 709,
    VOLATILE = 710,
    WHEN = 711,
    WHERE = 712,
    WHITESPACE_P = 713,
    WINDOW = 714,
    WITH = 715,
    WITHIN = 716,
    WITHOUT = 717,
    WORK = 718,
    WRAPPER = 719,
    WRITE = 720,
    XML_P = 721,
    XMLATTRIBUTES = 722,
    XMLCONCAT = 723,
    XMLELEMENT = 724,
    XMLEXISTS = 725,
    XMLFOREST = 726,
    XMLNAMESPACES = 727,
    XMLPARSE = 728,
    XMLPI = 729,
    XMLROOT = 730,
    XMLSERIALIZE = 731,
    XMLTABLE = 732,
    YEAR_P = 733,
    YES_P = 734,
    ZONE = 735,
    NOT_LA = 736,
    NULLS_LA = 737,
    WITH_LA = 738,
    MODE_TYPE_NAME = 739,
    MODE_PLPGSQL_EXPR = 740,
    MODE_PLPGSQL_ASSIGN1 = 741,
    MODE_PLPGSQL_ASSIGN2 = 742,
    MODE_PLPGSQL_ASSIGN3 = 743,
    UMINUS = 744
  };
#endif
/* Tokens.  */
#define IDENT 258
#define UIDENT 259
#define FCONST 260
#define SCONST 261
#define USCONST 262
#define BCONST 263
#define XCONST 264
#define Op 265
#define ICONST 266
#define PARAM 267
#define TYPECAST 268
#define DOT_DOT 269
#define COLON_EQUALS 270
#define EQUALS_GREATER 271
#define LESS_EQUALS 272
#define GREATER_EQUALS 273
#define NOT_EQUALS 274
#define ABORT_P 275
#define ABSOLUTE_P 276
#define ACCESS 277
#define ACTION 278
#define ADD_P 279
#define ADMIN 280
#define AFTER 281
#define AGGREGATE 282
#define ALL 283
#define ALSO 284
#define ALTER 285
#define ALWAYS 286
#define ANALYSE 287
#define ANALYZE 288
#define AND 289
#define ANY 290
#define ARRAY 291
#define AS 292
#define ASC 293
#define ASENSITIVE 294
#define ASSERTION 295
#define ASSIGNMENT 296
#define ASYMMETRIC 297
#define ATOMIC 298
#define AT 299
#define ATTACH 300
#define ATTRIBUTE 301
#define AUTHORIZATION 302
#define BACKWARD 303
#define BEFORE 304
#define BEGIN_P 305
#define BETWEEN 306
#define BIGINT 307
#define BINARY 308
#define BIT 309
#define BOOLEAN_P 310
#define BOTH 311
#define BREADTH 312
#define BY 313
#define CACHE 314
#define CALL 315
#define CALLED 316
#define CASCADE 317
#define CASCADED 318
#define CASE 319
#define CAST 320
#define CATALOG_P 321
#define CHAIN 322
#define CHAR_P 323
#define CHARACTER 324
#define CHARACTERISTICS 325
#define CHECK 326
#define CHECKPOINT 327
#define CLASS 328
#define CLOSE 329
#define CLUSTER 330
#define COALESCE 331
#define COLLATE 332
#define COLLATION 333
#define COLUMN 334
#define COLUMNS 335
#define COMMENT 336
#define COMMENTS 337
#define COMMIT 338
#define COMMITTED 339
#define COMPRESSION 340
#define CONCURRENTLY 341
#define CONFIGURATION 342
#define CONFLICT 343
#define CONNECTION 344
#define CONSTRAINT 345
#define CONSTRAINTS 346
#define CONTENT_P 347
#define CONTINUE_P 348
#define CONVERSION_P 349
#define COPY 350
#define COST 351
#define CREATE 352
#define CROSS 353
#define CSV 354
#define CUBE 355
#define CURRENT_P 356
#define CURRENT_CATALOG 357
#define CURRENT_DATE 358
#define CURRENT_ROLE 359
#define CURRENT_SCHEMA 360
#define CURRENT_TIME 361
#define CURRENT_TIMESTAMP 362
#define CURRENT_USER 363
#define CURSOR 364
#define CYCLE 365
#define DATA_P 366
#define DATABASE 367
#define DAY_P 368
#define DEALLOCATE 369
#define DEC 370
#define DECIMAL_P 371
#define DECLARE 372
#define DEFAULT 373
#define DEFAULTS 374
#define DEFERRABLE 375
#define DEFERRED 376
#define DEFINER 377
#define DELETE_P 378
#define DELIMITER 379
#define DELIMITERS 380
#define DEPENDS 381
#define DEPTH 382
#define DESC 383
#define DETACH 384
#define DICTIONARY 385
#define DISABLE_P 386
#define DISCARD 387
#define DISTINCT 388
#define DO 389
#define DOCUMENT_P 390
#define DOMAIN_P 391
#define DOUBLE_P 392
#define DROP 393
#define EACH 394
#define ELSE 395
#define ENABLE_P 396
#define ENCODING 397
#define ENCRYPTED 398
#define END_P 399
#define ENUM_P 400
#define ESCAPE 401
#define EVENT 402
#define EXCEPT 403
#define EXCLUDE 404
#define EXCLUDING 405
#define EXCLUSIVE 406
#define EXECUTE 407
#define EXISTS 408
#define EXPLAIN 409
#define EXPRESSION 410
#define EXTENSION 411
#define EXTERNAL 412
#define EXTRACT 413
#define FALSE_P 414
#define FAMILY 415
#define FETCH 416
#define FILTER 417
#define FINALIZE 418
#define FIRST_P 419
#define FLOAT_P 420
#define FOLLOWING 421
#define FOR 422
#define FORCE 423
#define FOREIGN 424
#define FORWARD 425
#define FREEZE 426
#define FROM 427
#define FULL 428
#define FUNCTION 429
#define FUNCTIONS 430
#define GENERATED 431
#define GLOBAL 432
#define GRANT 433
#define GRANTED 434
#define GREATEST 435
#define GROUP_P 436
#define GROUPING 437
#define GROUPS 438
#define HANDLER 439
#define HAVING 440
#define HEADER_P 441
#define HOLD 442
#define HOUR_P 443
#define IDENTITY_P 444
#define IF_P 445
#define ILIKE 446
#define IMMEDIATE 447
#define IMMUTABLE 448
#define IMPLICIT_P 449
#define IMPORT_P 450
#define IN_P 451
#define INCLUDE 452
#define INCLUDING 453
#define INCREMENT 454
#define INDEX 455
#define INDEXES 456
#define INHERIT 457
#define INHERITS 458
#define INITIALLY 459
#define INLINE_P 460
#define INNER_P 461
#define INOUT 462
#define INPUT_P 463
#define INSENSITIVE 464
#define INSERT 465
#define INSTEAD 466
#define INT_P 467
#define INTEGER 468
#define INTERSECT 469
#define INTERVAL 470
#define INTO 471
#define INVOKER 472
#define IS 473
#define ISNULL 474
#define ISOLATION 475
#define JOIN 476
#define KEY 477
#define LABEL 478
#define LANGUAGE 479
#define LARGE_P 480
#define LAST_P 481
#define LATERAL_P 482
#define LEADING 483
#define LEAKPROOF 484
#define LEAST 485
#define LEFT 486
#define LEVEL 487
#define LIKE 488
#define LIMIT 489
#define LISTEN 490
#define LOAD 491
#define LOCAL 492
#define LOCALTIME 493
#define LOCALTIMESTAMP 494
#define LOCATION 495
#define LOCK_P 496
#define LOCKED 497
#define LOGGED 498
#define MAPPING 499
#define MATCH 500
#define MATCHED 501
#define MATERIALIZED 502
#define MAXVALUE 503
#define MERGE 504
#define METHOD 505
#define MINUTE_P 506
#define MINVALUE 507
#define MODE 508
#define MONTH_P 509
#define MOVE 510
#define NAME_P 511
#define NAMES 512
#define NATIONAL 513
#define NATURAL 514
#define NCHAR 515
#define NEW 516
#define NEXT 517
#define NFC 518
#define NFD 519
#define NFKC 520
#define NFKD 521
#define NO 522
#define NONE 523
#define NORMALIZE 524
#define NORMALIZED 525
#define NOT 526
#define NOTHING 527
#define NOTIFY 528
#define NOTNULL 529
#define NOWAIT 530
#define NULL_P 531
#define NULLIF 532
#define NULLS_P 533
#define NUMERIC 534
#define OBJECT_P 535
#define OF 536
#define OFF 537
#define OFFSET 538
#define OIDS 539
#define OLD 540
#define ON 541
#define ONLY 542
#define OPERATOR 543
#define OPTION 544
#define OPTIONS 545
#define OR 546
#define ORDER 547
#define ORDINALITY 548
#define OTHERS 549
#define OUT_P 550
#define OUTER_P 551
#define OVER 552
#define OVERLAPS 553
#define OVERLAY 554
#define OVERRIDING 555
#define OWNED 556
#define OWNER 557
#define PARALLEL 558
#define PARAMETER 559
#define PARSER 560
#define PARTIAL 561
#define PARTITION 562
#define PASSING 563
#define PASSWORD 564
#define PGPOOL 565
#define PLACING 566
#define PLANS 567
#define POLICY 568
#define POSITION 569
#define PRECEDING 570
#define PRECISION 571
#define PRESERVE 572
#define PREPARE 573
#define PREPARED 574
#define PRIMARY 575
#define PRIOR 576
#define PRIVILEGES 577
#define PROCEDURAL 578
#define PROCEDURE 579
#define PROCEDURES 580
#define PROGRAM 581
#define PUBLICATION 582
#define QUOTE 583
#define RANGE 584
#define READ 585
#define REAL 586
#define REASSIGN 587
#define RECHECK 588
#define RECURSIVE 589
#define REF 590
#define REFERENCES 591
#define REFERENCING 592
#define REFRESH 593
#define REINDEX 594
#define RELATIVE_P 595
#define RELEASE 596
#define RENAME 597
#define REPEATABLE 598
#define REPLACE 599
#define REPLICA 600
#define RESET 601
#define RESTART 602
#define RESTRICT 603
#define RETURN 604
#define RETURNING 605
#define RETURNS 606
#define REVOKE 607
#define RIGHT 608
#define ROLE 609
#define ROLLBACK 610
#define ROLLUP 611
#define ROUTINE 612
#define ROUTINES 613
#define ROW 614
#define ROWS 615
#define RULE 616
#define SAVEPOINT 617
#define SCHEMA 618
#define SCHEMAS 619
#define SCROLL 620
#define SEARCH 621
#define SECOND_P 622
#define SECURITY 623
#define SELECT 624
#define SEQUENCE 625
#define SEQUENCES 626
#define SERIALIZABLE 627
#define SERVER 628
#define SESSION 629
#define SESSION_USER 630
#define SET 631
#define SETS 632
#define SETOF 633
#define SHARE 634
#define SHOW 635
#define SIMILAR 636
#define SIMPLE 637
#define SKIP 638
#define SMALLINT 639
#define SNAPSHOT 640
#define SOME 641
#define SQL_P 642
#define STABLE 643
#define STANDALONE_P 644
#define START 645
#define STATEMENT 646
#define STATISTICS 647
#define STDIN 648
#define STDOUT 649
#define STORAGE 650
#define STORED 651
#define STRICT_P 652
#define STRIP_P 653
#define SUBSCRIPTION 654
#define SUBSTRING 655
#define SUPPORT 656
#define SYMMETRIC 657
#define SYSID 658
#define SYSTEM_P 659
#define TABLE 660
#define TABLES 661
#define TABLESAMPLE 662
#define TABLESPACE 663
#define TEMP 664
#define TEMPLATE 665
#define TEMPORARY 666
#define TEXT_P 667
#define THEN 668
#define TIES 669
#define TIME 670
#define TIMESTAMP 671
#define TO 672
#define TRAILING 673
#define TRANSACTION 674
#define TRANSFORM 675
#define TREAT 676
#define TRIGGER 677
#define TRIM 678
#define TRUE_P 679
#define TRUNCATE 680
#define TRUSTED 681
#define TYPE_P 682
#define TYPES_P 683
#define UESCAPE 684
#define UNBOUNDED 685
#define UNCOMMITTED 686
#define UNENCRYPTED 687
#define UNION 688
#define UNIQUE 689
#define UNKNOWN 690
#define UNLISTEN 691
#define UNLOGGED 692
#define UNTIL 693
#define UPDATE 694
#define USER 695
#define USING 696
#define VACUUM 697
#define VALID 698
#define VALIDATE 699
#define VALIDATOR 700
#define VALUE_P 701
#define VALUES 702
#define VARCHAR 703
#define VARIADIC 704
#define VARYING 705
#define VERBOSE 706
#define VERSION_P 707
#define VIEW 708
#define VIEWS 709
#define VOLATILE 710
#define WHEN 711
#define WHERE 712
#define WHITESPACE_P 713
#define WINDOW 714
#define WITH 715
#define WITHIN 716
#define WITHOUT 717
#define WORK 718
#define WRAPPER 719
#define WRITE 720
#define XML_P 721
#define XMLATTRIBUTES 722
#define XMLCONCAT 723
#define XMLELEMENT 724
#define XMLEXISTS 725
#define XMLFOREST 726
#define XMLNAMESPACES 727
#define XMLPARSE 728
#define XMLPI 729
#define XMLROOT 730
#define XMLSERIALIZE 731
#define XMLTABLE 732
#define YEAR_P 733
#define YES_P 734
#define ZONE 735
#define NOT_LA 736
#define NULLS_LA 737
#define WITH_LA 738
#define MODE_TYPE_NAME 739
#define MODE_PLPGSQL_EXPR 740
#define MODE_PLPGSQL_ASSIGN1 741
#define MODE_PLPGSQL_ASSIGN2 742
#define MODE_PLPGSQL_ASSIGN3 743
#define UMINUS 744

/* Value type.  */
#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED

union YYSTYPE
{
#line 266 "gram.y" /* yacc.c:355  */

	core_YYSTYPE core_yystype;
	/* these fields must match core_YYSTYPE: */
	int			ival;
	char	   *str;
	const char *keyword;

	char		chr;
	bool		boolean;
	JoinType	jtype;
	DropBehavior dbehavior;
	OnCommitAction oncommit;
	List	   *list;
	Node	   *node;
	ObjectType	objtype;
	TypeName   *typnam;
	FunctionParameter *fun_param;
	FunctionParameterMode fun_param_mode;
	ObjectWithArgs *objwithargs;
	DefElem	   *defelt;
	SortBy	   *sortby;
	WindowDef  *windef;
	JoinExpr   *jexpr;
	IndexElem  *ielem;
	StatsElem  *selem;
	Alias	   *alias;
	RangeVar   *range;
	IntoClause *into;
	WithClause *with;
	InferClause	*infer;
	OnConflictClause *onconflict;
	A_Indices  *aind;
	ResTarget  *target;
	struct PrivTarget *privtarget;
	AccessPriv *accesspriv;
	struct ImportQual *importqual;
	InsertStmt *istmt;
	VariableSetStmt *vsetstmt;
	PartitionElem *partelem;
	PartitionSpec *partspec;
	PartitionBoundSpec *partboundspec;
	RoleSpec   *rolespec;
	PublicationObjSpec *publicationobjectspec;
	struct SelectLimit *selectlimit;
	SetQuantifier setquantifier;
	struct GroupClause *groupclause;
	MergeWhenClause *mergewhen;
	struct KeyActions *keyactions;
	struct KeyAction *keyaction;

#line 1397 "gram.c" /* yacc.c:355  */
};

typedef union YYSTYPE YYSTYPE;
# define YYSTYPE_IS_TRIVIAL 1
# define YYSTYPE_IS_DECLARED 1
#endif

/* Location type.  */
#if ! defined YYLTYPE && ! defined YYLTYPE_IS_DECLARED
typedef struct YYLTYPE YYLTYPE;
struct YYLTYPE
{
  int first_line;
  int first_column;
  int last_line;
  int last_column;
};
# define YYLTYPE_IS_DECLARED 1
# define YYLTYPE_IS_TRIVIAL 1
#endif



int base_yyparse (core_yyscan_t yyscanner);

#endif /* !YY_BASE_YY_Y_TAB_H_INCLUDED  */

/* Copy the second part of user declarations.  */

#line 1427 "gram.c" /* yacc.c:358  */

#ifdef short
# undef short
#endif

#ifdef YYTYPE_UINT8
typedef YYTYPE_UINT8 yytype_uint8;
#else
typedef unsigned char yytype_uint8;
#endif

#ifdef YYTYPE_INT8
typedef YYTYPE_INT8 yytype_int8;
#else
typedef signed char yytype_int8;
#endif

#ifdef YYTYPE_UINT16
typedef YYTYPE_UINT16 yytype_uint16;
#else
typedef unsigned short int yytype_uint16;
#endif

#ifdef YYTYPE_INT16
typedef YYTYPE_INT16 yytype_int16;
#else
typedef short int yytype_int16;
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif ! defined YYSIZE_T
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned int
# endif
#endif

#define YYSIZE_MAXIMUM ((YYSIZE_T) -1)

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif

#ifndef YY_ATTRIBUTE
# if (defined __GNUC__                                               \
      && (2 < __GNUC__ || (__GNUC__ == 2 && 96 <= __GNUC_MINOR__)))  \
     || defined __SUNPRO_C && 0x5110 <= __SUNPRO_C
#  define YY_ATTRIBUTE(Spec) __attribute__(Spec)
# else
#  define YY_ATTRIBUTE(Spec) /* empty */
# endif
#endif

#ifndef YY_ATTRIBUTE_PURE
# define YY_ATTRIBUTE_PURE   YY_ATTRIBUTE ((__pure__))
#endif

#ifndef YY_ATTRIBUTE_UNUSED
# define YY_ATTRIBUTE_UNUSED YY_ATTRIBUTE ((__unused__))
#endif

#if !defined _Noreturn \
     && (!defined __STDC_VERSION__ || __STDC_VERSION__ < 201112)
# if defined _MSC_VER && 1200 <= _MSC_VER
#  define _Noreturn __declspec (noreturn)
# else
#  define _Noreturn YY_ATTRIBUTE ((__noreturn__))
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(E) ((void) (E))
#else
# define YYUSE(E) /* empty */
#endif

#if defined __GNUC__ && 407 <= __GNUC__ * 100 + __GNUC_MINOR__
/* Suppress an incorrect diagnostic about yylval being uninitialized.  */
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN \
    _Pragma ("GCC diagnostic push") \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")\
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# define YY_IGNORE_MAYBE_UNINITIALIZED_END \
    _Pragma ("GCC diagnostic pop")
#else
# define YY_INITIAL_VALUE(Value) Value
#endif
#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif


#if ! defined yyoverflow || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's 'empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
             && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* ! defined yyoverflow || YYERROR_VERBOSE */


#if (! defined yyoverflow \
     && (! defined __cplusplus \
         || (defined YYLTYPE_IS_TRIVIAL && YYLTYPE_IS_TRIVIAL \
             && defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yytype_int16 yyss_alloc;
  YYSTYPE yyvs_alloc;
  YYLTYPE yyls_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (yytype_int16) + sizeof (YYSTYPE) + sizeof (YYLTYPE)) \
      + 2 * YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)                           \
    do                                                                  \
      {                                                                 \
        YYSIZE_T yynewbytes;                                            \
        YYCOPY (&yyptr->Stack_alloc, Stack, yysize);                    \
        Stack = &yyptr->Stack_alloc;                                    \
        yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
        yyptr += yynewbytes / sizeof (*yyptr);                          \
      }                                                                 \
    while (0)

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, (Count) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYSIZE_T yyi;                         \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (0)
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  906
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   112248

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  507
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  688
/* YYNRULES -- Number of rules.  */
#define YYNRULES  3210
/* YYNSTATES -- Number of states.  */
#define YYNSTATES  6100

/* YYTRANSLATE[YYX] -- Symbol number corresponding to YYX as returned
   by yylex, with out-of-bounds checking.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   744

#define YYTRANSLATE(YYX)                                                \
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[TOKEN-NUM] -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex, without out-of-bounds checking.  */
static const yytype_uint16 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,   496,     2,     2,
     501,   502,   494,   492,   505,   493,   503,   495,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,   506,   504,
     489,   491,   490,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,   499,     2,   500,   497,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,   116,   117,   118,   119,   120,   121,   122,   123,   124,
     125,   126,   127,   128,   129,   130,   131,   132,   133,   134,
     135,   136,   137,   138,   139,   140,   141,   142,   143,   144,
     145,   146,   147,   148,   149,   150,   151,   152,   153,   154,
     155,   156,   157,   158,   159,   160,   161,   162,   163,   164,
     165,   166,   167,   168,   169,   170,   171,   172,   173,   174,
     175,   176,   177,   178,   179,   180,   181,   182,   183,   184,
     185,   186,   187,   188,   189,   190,   191,   192,   193,   194,
     195,   196,   197,   198,   199,   200,   201,   202,   203,   204,
     205,   206,   207,   208,   209,   210,   211,   212,   213,   214,
     215,   216,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,   246,   247,   248,   249,   250,   251,   252,   253,   254,
     255,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,   431,   432,   433,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446,   447,   448,   449,   450,   451,   452,   453,   454,
     455,   456,   457,   458,   459,   460,   461,   462,   463,   464,
     465,   466,   467,   468,   469,   470,   471,   472,   473,   474,
     475,   476,   477,   478,   479,   480,   481,   482,   483,   484,
     485,   486,   487,   488,   498
};

#if YYDEBUG
  /* YYRLINE[YYN] -- Source line where rule number YYN was defined.  */
static const yytype_uint16 yyrline[] =
{
       0,   891,   891,   895,   899,   904,   912,   920,   940,   952,
     966,   967,   971,   972,   973,   974,   975,   976,   977,   978,
     979,   980,   981,   982,   983,   984,   985,   986,   987,   988,
     989,   990,   991,   992,   993,   994,   995,   996,   997,   998,
     999,  1000,  1001,  1002,  1003,  1004,  1005,  1006,  1007,  1008,
    1009,  1010,  1011,  1012,  1013,  1014,  1015,  1016,  1017,  1018,
    1019,  1020,  1021,  1022,  1023,  1024,  1025,  1026,  1027,  1028,
    1029,  1030,  1031,  1032,  1033,  1034,  1035,  1036,  1037,  1038,
    1039,  1040,  1041,  1042,  1043,  1044,  1045,  1046,  1047,  1048,
    1049,  1050,  1051,  1052,  1053,  1054,  1055,  1056,  1057,  1058,
    1059,  1060,  1061,  1062,  1063,  1064,  1065,  1066,  1067,  1068,
    1069,  1070,  1071,  1072,  1073,  1074,  1075,  1076,  1077,  1078,
    1079,  1080,  1081,  1082,  1083,  1084,  1085,  1086,  1087,  1088,
    1089,  1090,  1091,  1092,  1093,  1094,  1096,  1105,  1121,  1133,
    1134,  1135,  1144,  1145,  1149,  1150,  1154,  1159,  1163,  1173,
    1181,  1185,  1189,  1194,  1198,  1246,  1248,  1252,  1256,  1260,
    1264,  1278,  1297,  1306,  1318,  1319,  1323,  1332,  1341,  1350,
    1372,  1380,  1388,  1396,  1404,  1412,  1430,  1449,  1461,  1462,
    1473,  1484,  1495,  1511,  1530,  1531,  1535,  1542,  1550,  1551,
    1552,  1553,  1554,  1555,  1569,  1576,  1583,  1590,  1600,  1609,
    1618,  1622,  1631,  1640,  1648,  1659,  1660,  1669,  1681,  1689,
    1698,  1710,  1719,  1728,  1736,  1746,  1757,  1758,  1762,  1763,
    1766,  1768,  1772,  1773,  1774,  1775,  1779,  1780,  1781,  1787,
    1799,  1803,  1807,  1824,  1832,  1833,  1834,  1838,  1839,  1840,
    1844,  1845,  1849,  1850,  1859,  1860,  1868,  1876,  1887,  1895,
    1906,  1907,  1912,  1913,  1919,  1925,  1931,  1938,  1945,  1952,
    1959,  1970,  1981,  1982,  1986,  1987,  1995,  2011,  2018,  2025,
    2032,  2039,  2059,  2069,  2079,  2089,  2099,  2111,  2123,  2133,
    2143,  2153,  2165,  2177,  2187,  2197,  2207,  2217,  2227,  2237,
    2249,  2261,  2271,  2284,  2285,  2290,  2304,  2317,  2333,  2350,
    2360,  2370,  2380,  2390,  2400,  2409,  2418,  2427,  2437,  2447,
    2463,  2473,  2483,  2493,  2503,  2520,  2530,  2540,  2550,  2561,
    2575,  2591,  2600,  2609,  2624,  2633,  2644,  2655,  2663,  2672,
    2681,  2689,  2697,  2706,  2715,  2724,  2732,  2740,  2749,  2757,
    2765,  2774,  2783,  2792,  2801,  2810,  2819,  2830,  2838,  2847,
    2856,  2865,  2874,  2883,  2892,  2900,  2908,  2916,  2923,  2934,
    2935,  2939,  2940,  2941,  2945,  2954,  2958,  2959,  2963,  2971,
    2979,  2987,  2998,  3001,  3002,  3006,  3007,  3012,  3016,  3020,
    3025,  3032,  3034,  3039,  3043,  3047,  3058,  3066,  3119,  3132,
    3146,  3158,  3165,  3169,  3183,  3196,  3197,  3202,  3212,  3223,
    3234,  3261,  3268,  3302,  3338,  3361,  3362,  3366,  3367,  3376,
    3377,  3378,  3381,  3382,  3387,  3388,  3392,  3396,  3400,  3404,
    3408,  3412,  3416,  3420,  3424,  3428,  3432,  3436,  3440,  3449,
    3453,  3457,  3461,  3465,  3466,  3471,  3475,  3482,  3489,  3490,
    3491,  3492,  3493,  3497,  3501,  3509,  3520,  3540,  3560,  3581,
    3602,  3623,  3657,  3658,  3659,  3660,  3661,  3668,  3675,  3676,
    3680,  3681,  3685,  3686,  3690,  3694,  3701,  3705,  3712,  3713,
    3714,  3718,  3719,  3722,  3745,  3764,  3786,  3787,  3791,  3792,
    3796,  3797,  3801,  3809,  3810,  3811,  3843,  3851,  3859,  3872,
    3884,  3897,  3909,  3919,  3943,  3963,  3964,  3965,  3969,  3970,
    3989,  3997,  4005,  4013,  4025,  4037,  4038,  4039,  4043,  4044,
    4045,  4046,  4047,  4048,  4049,  4050,  4051,  4052,  4061,  4069,
    4073,  4087,  4105,  4121,  4138,  4154,  4174,  4197,  4198,  4202,
    4203,  4207,  4208,  4211,  4217,  4218,  4221,  4225,  4233,  4238,
    4244,  4245,  4249,  4254,  4261,  4262,  4266,  4276,  4286,  4294,
    4303,  4316,  4328,  4335,  4343,  4351,  4359,  4367,  4377,  4378,
    4382,  4383,  4386,  4398,  4399,  4402,  4413,  4424,  4438,  4439,
    4444,  4445,  4446,  4449,  4450,  4451,  4452,  4455,  4456,  4459,
    4460,  4463,  4481,  4494,  4516,  4517,  4520,  4526,  4532,  4549,
    4558,  4580,  4594,  4611,  4627,  4628,  4629,  4641,  4655,  4672,
    4686,  4687,  4699,  4720,  4731,  4745,  4754,  4766,  4767,  4770,
    4771,  4774,  4775,  4778,  4782,  4786,  4790,  4794,  4798,  4802,
    4806,  4810,  4814,  4818,  4823,  4827,  4831,  4837,  4838,  4842,
    4843,  4844,  4851,  4854,  4855,  4867,  4883,  4899,  4900,  4908,
    4909,  4913,  4914,  4918,  4919,  4923,  4924,  4928,  4929,  4939,
    4951,  4952,  4965,  4973,  4991,  5000,  5012,  5015,  5019,  5023,
    5027,  5034,  5046,  5057,  5060,  5064,  5077,  5087,  5097,  5107,
    5117,  5127,  5137,  5147,  5157,  5167,  5177,  5187,  5197,  5216,
    5228,  5229,  5230,  5231,  5235,  5236,  5240,  5241,  5251,  5260,
    5273,  5274,  5278,  5282,  5290,  5294,  5298,  5305,  5309,  5314,
    5319,  5326,  5333,  5338,  5348,  5361,  5377,  5378,  5383,  5384,
    5388,  5389,  5399,  5409,  5418,  5436,  5457,  5478,  5500,  5534,
    5550,  5551,  5555,  5564,  5579,  5589,  5602,  5603,  5615,  5624,
    5642,  5667,  5685,  5700,  5701,  5705,  5706,  5710,  5711,  5715,
    5716,  5720,  5734,  5738,  5739,  5743,  5744,  5745,  5746,  5747,
    5757,  5769,  5770,  5781,  5804,  5836,  5837,  5838,  5842,  5844,
    5866,  5868,  5870,  5872,  5874,  5879,  5880,  5884,  5885,  5889,
    5901,  5902,  5906,  5915,  5919,  5923,  5928,  5938,  5939,  5943,
    5944,  5948,  5949,  5953,  5954,  5958,  5959,  5960,  5964,  5968,
    5969,  5970,  5974,  5975,  5980,  5981,  6008,  6009,  6010,  6011,
    6012,  6013,  6026,  6037,  6052,  6054,  6059,  6064,  6066,  6071,
    6082,  6083,  6084,  6085,  6096,  6115,  6127,  6140,  6151,  6162,
    6174,  6183,  6191,  6199,  6209,  6219,  6229,  6239,  6249,  6260,
    6270,  6283,  6286,  6287,  6290,  6294,  6301,  6302,  6303,  6304,
    6305,  6306,  6309,  6312,  6313,  6321,  6328,  6329,  6332,  6334,
    6345,  6357,  6369,  6381,  6395,  6396,  6412,  6428,  6429,  6433,
    6446,  6457,  6466,  6476,  6486,  6487,  6490,  6491,  6494,  6495,
    6496,  6499,  6513,  6518,  6529,  6539,  6552,  6553,  6557,  6566,
    6579,  6590,  6604,  6615,  6638,  6649,  6668,  6679,  6690,  6701,
    6712,  6723,  6734,  6745,  6756,  6767,  6778,  6789,  6804,  6805,
    6806,  6807,  6808,  6809,  6810,  6811,  6812,  6813,  6814,  6815,
    6816,  6826,  6827,  6828,  6829,  6830,  6834,  6835,  6836,  6837,
    6838,  6839,  6840,  6841,  6846,  6847,  6848,  6852,  6853,  6856,
    6857,  6860,  6862,  6867,  6868,  6879,  6891,  6892,  6893,  6903,
    6912,  6921,  6930,  6939,  6948,  6957,  6966,  6975,  6984,  6998,
    7007,  7016,  7025,  7034,  7043,  7052,  7061,  7073,  7074,  7088,
    7099,  7110,  7121,  7132,  7143,  7154,  7165,  7176,  7187,  7200,
    7201,  7204,  7205,  7215,  7222,  7231,  7240,  7249,  7258,  7267,
    7276,  7285,  7294,  7303,  7312,  7321,  7330,  7339,  7348,  7357,
    7366,  7377,  7378,  7381,  7382,  7392,  7410,  7426,  7454,  7456,
    7458,  7460,  7468,  7478,  7479,  7482,  7490,  7498,  7506,  7513,
    7524,  7528,  7535,  7539,  7550,  7559,  7568,  7577,  7586,  7595,
    7604,  7613,  7622,  7631,  7640,  7649,  7658,  7666,  7675,  7684,
    7693,  7702,  7711,  7720,  7729,  7742,  7743,  7747,  7748,  7753,
    7754,  7764,  7778,  7789,  7802,  7803,  7806,  7807,  7817,  7828,
    7829,  7833,  7837,  7841,  7852,  7866,  7881,  7899,  7900,  7901,
    7902,  7903,  7904,  7916,  7948,  7983,  7984,  7988,  7989,  7993,
    7994,  7998,  7999,  8002,  8003,  8008,  8020,  8039,  8044,  8049,
    8056,  8057,  8060,  8061,  8064,  8065,  8068,  8069,  8072,  8073,
    8074,  8077,  8078,  8079,  8095,  8109,  8124,  8138,  8155,  8156,
    8159,  8160,  8164,  8165,  8169,  8170,  8175,  8189,  8197,  8205,
    8221,  8222,  8226,  8227,  8242,  8252,  8262,  8272,  8282,  8295,
    8296,  8297,  8298,  8299,  8305,  8309,  8324,  8325,  8331,  8341,
    8345,  8350,  8358,  8400,  8404,  8408,  8412,  8420,  8421,  8425,
    8437,  8438,  8443,  8444,  8449,  8450,  8457,  8461,  8465,  8469,
    8473,  8477,  8481,  8485,  8489,  8493,  8497,  8501,  8505,  8509,
    8513,  8517,  8522,  8529,  8533,  8537,  8541,  8545,  8551,  8552,
    8558,  8568,  8572,  8583,  8589,  8598,  8604,  8605,  8609,  8610,
    8614,  8615,  8618,  8631,  8635,  8650,  8659,  8668,  8681,  8682,
    8687,  8688,  8705,  8716,  8727,  8738,  8749,  8760,  8774,  8785,
    8799,  8810,  8824,  8832,  8834,  8836,  8841,  8843,  8848,  8849,
    8854,  8873,  8883,  8884,  8888,  8892,  8904,  8916,  8928,  8942,
    8943,  8944,  8948,  8961,  8962,  8972,  8985,  8989,  8993,  8997,
    9004,  9025,  9038,  9051,  9064,  9079,  9080,  9083,  9084,  9085,
    9095,  9105,  9123,  9133,  9143,  9153,  9163,  9173,  9183,  9193,
    9203,  9213,  9223,  9233,  9243,  9254,  9265,  9275,  9285,  9295,
    9305,  9315,  9325,  9336,  9347,  9358,  9369,  9380,  9391,  9402,
    9413,  9424,  9435,  9446,  9457,  9469,  9481,  9493,  9505,  9517,
    9529,  9540,  9551,  9563,  9575,  9586,  9597,  9606,  9616,  9626,
    9636,  9646,  9656,  9666,  9676,  9686,  9696,  9711,  9712,  9715,
    9716,  9726,  9736,  9746,  9756,  9767,  9777,  9789,  9790,  9800,
    9810,  9820,  9830,  9840,  9850,  9860,  9870,  9880,  9890,  9900,
    9910,  9920,  9930,  9940,  9950,  9960,  9970,  9980,  9990, 10000,
   10010, 10020, 10030, 10040, 10050, 10060, 10079, 10089, 10090, 10093,
   10095, 10101, 10102, 10103, 10104, 10105, 10117, 10133, 10142, 10151,
   10160, 10169, 10178, 10187, 10196, 10205, 10214, 10223, 10232, 10241,
   10250, 10259, 10268, 10277, 10286, 10295, 10304, 10313, 10322, 10331,
   10340, 10368, 10376, 10385, 10411, 10420, 10427, 10433, 10460, 10471,
   10480, 10488, 10490, 10512, 10520, 10530, 10540, 10559, 10578, 10588,
   10598, 10608, 10619, 10630, 10641, 10652, 10663, 10681, 10690, 10707,
   10725, 10726, 10727, 10732, 10738, 10747, 10748, 10749, 10750, 10751,
   10755, 10756, 10759, 10760, 10761, 10762, 10766, 10767, 10768, 10780,
   10791, 10792, 10795, 10805, 10812, 10832, 10841, 10849, 10858, 10867,
   10875, 10883, 10891, 10899, 10907, 10915, 10923, 10934, 10942, 10953,
   10954, 10955, 10959, 10962, 10965, 10968, 10971, 10978, 10980, 10982,
   10987, 10989, 10993, 10994, 10995, 11007, 11021, 11035, 11054, 11076,
   11077, 11078, 11079, 11089, 11106, 11117, 11118, 11122, 11123, 11127,
   11131, 11135, 11153, 11154, 11155, 11156, 11157, 11158, 11159, 11166,
   11167, 11178, 11186, 11194, 11203, 11213, 11231, 11240, 11249, 11258,
   11270, 11274, 11285, 11297, 11315, 11322, 11339, 11353, 11363, 11372,
   11381, 11391, 11403, 11415, 11426, 11427, 11438, 11449, 11461, 11473,
   11485, 11497, 11507, 11520, 11521, 11535, 11560, 11572, 11581, 11593,
   11607, 11608, 11620, 11641, 11652, 11664, 11676, 11680, 11687, 11688,
   11692, 11699, 11700, 11704, 11705, 11706, 11710, 11711, 11715, 11716,
   11719, 11720, 11723, 11724, 11728, 11729, 11733, 11740, 11742, 11747,
   11748, 11761, 11769, 11780, 11788, 11799, 11800, 11801, 11802, 11803,
   11804, 11805, 11806, 11807, 11808, 11818, 11829, 11830, 11834, 11835,
   11836, 11837, 11838, 11848, 11856, 11874, 11894, 11895, 11905, 11912,
   11919, 11926, 11943, 11961, 11965, 11973, 11979, 11986, 11992, 11999,
   12008, 12009, 12013, 12015, 12020, 12031, 12041, 12051, 12057, 12066,
   12075, 12081, 12082, 12093, 12108, 12109, 12120, 12131, 12132, 12135,
   12136, 12137, 12138, 12139, 12140, 12141, 12142, 12145, 12146, 12150,
   12151, 12152, 12163, 12181, 12182, 12186, 12191, 12215, 12226, 12227,
   12239, 12257, 12258, 12262, 12269, 12276, 12283, 12293, 12306, 12307,
   12311, 12324, 12337, 12346, 12355, 12364, 12373, 12385, 12397, 12409,
   12412, 12413, 12414, 12415, 12416, 12417, 12420, 12421, 12422, 12470,
   12471, 12475, 12476, 12491, 12492, 12499, 12507, 12515, 12523, 12531,
   12539, 12550, 12551, 12583, 12599, 12616, 12617, 12636, 12640, 12644,
   12659, 12666, 12673, 12683, 12684, 12687, 12703, 12704, 12705, 12709,
   12719, 12730, 12736, 12748, 12761, 12767, 12768, 12772, 12784, 12792,
   12797, 12802, 12807, 12812, 12820, 12828, 12833, 12838, 12845, 12846,
   12850, 12851, 12852, 12859, 12860, 12864, 12865, 12869, 12870, 12874,
   12875, 12879, 12883, 12884, 12887, 12896, 12909, 12914, 12919, 12923,
   12935, 12936, 12940, 12949, 12965, 12974, 12983, 12992, 13004, 13007,
   13012, 13013, 13021, 13041, 13042, 13044, 13049, 13050, 13054, 13055,
   13058, 13059, 13084, 13093, 13103, 13104, 13108, 13109, 13110, 13111,
   13112, 13116, 13129, 13136, 13143, 13150, 13151, 13155, 13156, 13160,
   13161, 13165, 13166, 13170, 13182, 13183, 13184, 13185, 13189, 13190,
   13200, 13207, 13226, 13227, 13231, 13232, 13238, 13243, 13252, 13260,
   13269, 13276, 13284, 13320, 13346, 13350, 13376, 13380, 13394, 13415,
   13437, 13450, 13467, 13473, 13478, 13484, 13491, 13492, 13502, 13508,
   13516, 13520, 13524, 13531, 13539, 13544, 13545, 13546, 13547, 13551,
   13552, 13567, 13571, 13579, 13586, 13593, 13600, 13607, 13618, 13619,
   13632, 13636, 13644, 13658, 13672, 13673, 13688, 13699, 13712, 13717,
   13718, 13721, 13722, 13725, 13726, 13731, 13732, 13737, 13738, 13747,
   13752, 13753, 13757, 13761, 13767, 13792, 13803, 13817, 13818, 13822,
   13836, 13893, 13907, 13909, 13914, 13916, 13918, 13920, 13925, 13927,
   13932, 13940, 13960, 13965, 13972, 13977, 13983, 13988, 13997, 13999,
   14002, 14006, 14007, 14008, 14009, 14010, 14011, 14016, 14036, 14037,
   14038, 14039, 14050, 14056, 14064, 14065, 14071, 14076, 14081, 14086,
   14091, 14096, 14101, 14106, 14112, 14118, 14124, 14131, 14153, 14162,
   14166, 14174, 14178, 14186, 14198, 14219, 14223, 14229, 14233, 14246,
   14254, 14264, 14266, 14268, 14270, 14272, 14274, 14279, 14280, 14287,
   14296, 14304, 14313, 14324, 14332, 14333, 14334, 14338, 14340, 14342,
   14344, 14346, 14348, 14350, 14355, 14360, 14366, 14374, 14379, 14386,
   14393, 14397, 14401, 14437, 14438, 14440, 14449, 14465, 14467, 14469,
   14471, 14473, 14475, 14477, 14479, 14481, 14483, 14485, 14487, 14489,
   14491, 14494, 14496, 14499, 14501, 14503, 14505, 14508, 14513, 14522,
   14527, 14536, 14541, 14550, 14555, 14565, 14574, 14583, 14592, 14611,
   14620, 14629, 14638, 14647, 14664, 14673, 14682, 14691, 14700, 14709,
   14718, 14722, 14726, 14734, 14742, 14750, 14758, 14779, 14802, 14814,
   14821, 14837, 14842, 14848, 14855, 14862, 14870, 14878, 14904, 14906,
   14908, 14910, 14912, 14914, 14916, 14918, 14920, 14922, 14924, 14926,
   14928, 14930, 14932, 14934, 14936, 14938, 14940, 14944, 14948, 14953,
   14969, 14970, 14971, 14988, 15001, 15003, 15005, 15017, 15042, 15054,
   15066, 15074, 15085, 15096, 15106, 15112, 15121, 15131, 15141, 15154,
   15164, 15195, 15231, 15242, 15243, 15250, 15257, 15261, 15265, 15269,
   15273, 15277, 15281, 15285, 15289, 15293, 15297, 15301, 15305, 15309,
   15313, 15317, 15319, 15326, 15333, 15340, 15347, 15358, 15372, 15382,
   15393, 15409, 15419, 15426, 15433, 15440, 15444, 15452, 15461, 15470,
   15474, 15478, 15482, 15486, 15490, 15499, 15503, 15513, 15517, 15521,
   15526, 15541, 15543, 15547, 15549, 15551, 15554, 15557, 15560, 15561,
   15564, 15572, 15582, 15583, 15586, 15587, 15588, 15593, 15597, 15601,
   15605, 15612, 15613, 15621, 15622, 15626, 15627, 15635, 15636, 15640,
   15641, 15646, 15655, 15657, 15672, 15675, 15703, 15704, 15707, 15708,
   15716, 15724, 15732, 15741, 15751, 15769, 15815, 15824, 15833, 15842,
   15851, 15863, 15864, 15865, 15866, 15867, 15881, 15882, 15883, 15886,
   15887, 15890, 15893, 15894, 15895, 15898, 15899, 15902, 15903, 15904,
   15905, 15906, 15907, 15908, 15909, 15910, 15911, 15912, 15913, 15916,
   15918, 15923, 15925, 15930, 15932, 15934, 15936, 15938, 15940, 15952,
   15956, 15963, 15967, 15973, 15977, 15987, 15999, 16000, 16003, 16004,
   16007, 16011, 16015, 16021, 16022, 16027, 16037, 16038, 16039, 16040,
   16041, 16042, 16043, 16044, 16048, 16049, 16050, 16051, 16056, 16061,
   16070, 16091, 16095, 16100, 16111, 16128, 16134, 16135, 16136, 16139,
   16147, 16157, 16172, 16173, 16177, 16189, 16190, 16193, 16194, 16197,
   16201, 16208, 16212, 16216, 16225, 16237, 16238, 16242, 16243, 16247,
   16248, 16251, 16252, 16262, 16263, 16267, 16268, 16271, 16279, 16287,
   16295, 16318, 16319, 16330, 16334, 16340, 16342, 16347, 16349, 16351,
   16361, 16363, 16374, 16378, 16382, 16386, 16390, 16399, 16407, 16439,
   16443, 16450, 16458, 16462, 16466, 16472, 16473, 16475, 16476, 16477,
   16481, 16522, 16550, 16554, 16558, 16564, 16566, 16580, 16616, 16629,
   16630, 16633, 16634, 16651, 16652, 16653, 16658, 16659, 16660, 16665,
   16666, 16667, 16668, 16674, 16675, 16676, 16677, 16678, 16684, 16685,
   16705, 16706, 16707, 16708, 16709, 16710, 16711, 16712, 16713, 16714,
   16715, 16716, 16717, 16718, 16719, 16720, 16721, 16722, 16723, 16724,
   16725, 16726, 16727, 16728, 16729, 16730, 16731, 16732, 16733, 16734,
   16735, 16736, 16737, 16738, 16739, 16740, 16741, 16742, 16743, 16744,
   16745, 16746, 16747, 16748, 16749, 16750, 16751, 16752, 16753, 16754,
   16755, 16756, 16757, 16758, 16759, 16760, 16761, 16762, 16763, 16764,
   16765, 16766, 16767, 16768, 16769, 16770, 16771, 16772, 16773, 16774,
   16775, 16776, 16777, 16778, 16779, 16780, 16781, 16782, 16783, 16784,
   16785, 16786, 16787, 16788, 16789, 16790, 16791, 16792, 16793, 16794,
   16795, 16796, 16797, 16798, 16799, 16800, 16801, 16802, 16803, 16804,
   16805, 16806, 16807, 16808, 16809, 16810, 16811, 16812, 16813, 16814,
   16815, 16816, 16817, 16818, 16819, 16820, 16821, 16822, 16823, 16824,
   16825, 16826, 16827, 16828, 16829, 16830, 16831, 16832, 16833, 16834,
   16835, 16836, 16837, 16838, 16839, 16840, 16841, 16842, 16843, 16844,
   16845, 16846, 16847, 16848, 16849, 16850, 16851, 16852, 16853, 16854,
   16855, 16856, 16857, 16858, 16859, 16860, 16861, 16862, 16863, 16864,
   16865, 16866, 16867, 16868, 16869, 16870, 16871, 16872, 16873, 16874,
   16875, 16876, 16877, 16878, 16879, 16880, 16881, 16882, 16883, 16884,
   16885, 16886, 16887, 16888, 16889, 16890, 16891, 16892, 16893, 16894,
   16895, 16896, 16897, 16898, 16899, 16900, 16901, 16902, 16903, 16904,
   16905, 16906, 16907, 16908, 16909, 16910, 16911, 16912, 16913, 16914,
   16915, 16916, 16917, 16918, 16919, 16920, 16921, 16922, 16923, 16924,
   16925, 16926, 16927, 16928, 16929, 16930, 16931, 16932, 16933, 16934,
   16935, 16936, 16937, 16938, 16939, 16940, 16941, 16942, 16943, 16944,
   16945, 16946, 16947, 16948, 16949, 16950, 16951, 16952, 16953, 16954,
   16955, 16956, 16957, 16958, 16959, 16960, 16961, 16962, 16963, 16964,
   16965, 16966, 16967, 16968, 16969, 16970, 16971, 16972, 16973, 16974,
   16975, 16976, 16977, 16978, 16979, 16980, 16981, 16982, 16983, 16984,
   16985, 16986, 16987, 16988, 16989, 16990, 16991, 16992, 16993, 16994,
   16995, 16996, 16997, 16998, 16999, 17000, 17001, 17002, 17003, 17004,
   17005, 17006, 17007, 17008, 17009, 17010, 17011, 17012, 17013, 17027,
   17028, 17029, 17030, 17031, 17032, 17033, 17034, 17035, 17036, 17037,
   17038, 17039, 17040, 17041, 17042, 17043, 17044, 17045, 17046, 17047,
   17048, 17049, 17050, 17051, 17052, 17053, 17054, 17055, 17056, 17057,
   17058, 17059, 17060, 17061, 17062, 17063, 17064, 17065, 17066, 17067,
   17068, 17069, 17070, 17071, 17072, 17073, 17074, 17075, 17076, 17077,
   17091, 17092, 17093, 17094, 17095, 17096, 17097, 17098, 17099, 17100,
   17101, 17102, 17103, 17104, 17105, 17106, 17107, 17108, 17109, 17110,
   17111, 17112, 17113, 17123, 17124, 17125, 17126, 17127, 17128, 17129,
   17130, 17131, 17132, 17133, 17134, 17135, 17136, 17137, 17138, 17139,
   17140, 17141, 17142, 17143, 17144, 17145, 17146, 17147, 17148, 17149,
   17150, 17151, 17152, 17153, 17154, 17155, 17156, 17157, 17158, 17159,
   17160, 17161, 17162, 17163, 17164, 17165, 17166, 17167, 17168, 17169,
   17170, 17171, 17172, 17173, 17174, 17175, 17176, 17177, 17178, 17179,
   17180, 17181, 17182, 17183, 17184, 17185, 17186, 17187, 17188, 17189,
   17190, 17191, 17192, 17193, 17194, 17195, 17196, 17197, 17198, 17199,
   17212, 17213, 17214, 17215, 17216, 17217, 17218, 17219, 17220, 17221,
   17222, 17223, 17224, 17225, 17226, 17227, 17228, 17229, 17230, 17231,
   17232, 17233, 17234, 17235, 17236, 17237, 17238, 17239, 17240, 17241,
   17242, 17243, 17244, 17245, 17246, 17247, 17248, 17249, 17250, 17251,
   17252, 17253, 17254, 17255, 17256, 17257, 17258, 17259, 17260, 17261,
   17262, 17263, 17264, 17265, 17266, 17267, 17268, 17269, 17270, 17271,
   17272, 17273, 17274, 17275, 17276, 17277, 17278, 17279, 17280, 17281,
   17282, 17283, 17284, 17285, 17286, 17287, 17288, 17289, 17290, 17291,
   17292, 17293, 17294, 17295, 17296, 17297, 17298, 17299, 17300, 17301,
   17302, 17303, 17304, 17305, 17306, 17307, 17308, 17309, 17310, 17311,
   17312, 17313, 17314, 17315, 17316, 17317, 17318, 17319, 17320, 17321,
   17322, 17323, 17324, 17325, 17326, 17327, 17328, 17329, 17330, 17331,
   17332, 17333, 17334, 17335, 17336, 17337, 17338, 17339, 17340, 17341,
   17342, 17343, 17344, 17345, 17346, 17347, 17348, 17349, 17350, 17351,
   17352, 17353, 17354, 17355, 17356, 17357, 17358, 17359, 17360, 17361,
   17362, 17363, 17364, 17365, 17366, 17367, 17368, 17369, 17370, 17371,
   17372, 17373, 17374, 17375, 17376, 17377, 17378, 17379, 17380, 17381,
   17382, 17383, 17384, 17385, 17386, 17387, 17388, 17389, 17390, 17391,
   17392, 17393, 17394, 17395, 17396, 17397, 17398, 17399, 17400, 17401,
   17402, 17403, 17404, 17405, 17406, 17407, 17408, 17409, 17410, 17411,
   17412, 17413, 17414, 17415, 17416, 17417, 17418, 17419, 17420, 17421,
   17422, 17423, 17424, 17425, 17426, 17427, 17428, 17429, 17430, 17431,
   17432, 17433, 17434, 17435, 17436, 17437, 17438, 17439, 17440, 17441,
   17442, 17443, 17444, 17445, 17446, 17447, 17448, 17449, 17450, 17451,
   17452, 17453, 17454, 17455, 17456, 17457, 17458, 17459, 17460, 17461,
   17462, 17463, 17464, 17465, 17466, 17467, 17468, 17469, 17470, 17471,
   17472, 17473, 17474, 17475, 17476, 17477, 17478, 17479, 17480, 17481,
   17482, 17483, 17484, 17485, 17486, 17487, 17488, 17489, 17490, 17491,
   17492, 17493, 17494, 17495, 17496, 17497, 17498, 17499, 17500, 17501,
   17502, 17503, 17504, 17505, 17506, 17507, 17508, 17509, 17510, 17511,
   17512, 17513, 17514, 17515, 17516, 17517, 17518, 17519, 17520, 17521,
   17522, 17523, 17524, 17525, 17526, 17527, 17528, 17529, 17530, 17531,
   17532, 17533, 17534, 17535, 17536, 17537, 17538, 17539, 17540, 17541,
   17542, 17543, 17544, 17545, 17546, 17547, 17548, 17549, 17550, 17551,
   17552, 17553, 17554, 17555, 17556, 17557, 17558, 17559, 17560, 17561,
   17562, 17563, 17564, 17565, 17566, 17567, 17568, 17569, 17570, 17571,
   17572, 17573, 17574, 17575, 17576, 17577, 17578, 17579, 17580, 17581,
   17582, 17583, 17584, 17585, 17586, 17587, 17588, 17589, 17590, 17591,
   17592, 17593, 17594, 17595, 17596, 17597, 17598, 17599, 17600, 17601,
   17602, 17603, 17604, 17605, 17606, 17607, 17608, 17609, 17610, 17611,
   17612, 17613, 17614, 17615, 17616, 17617, 17618, 17619, 17620, 17621,
   17622, 17623, 17624, 17625, 17626, 17627, 17628, 17629, 17630, 17631,
   17632
};
#endif

#if YYDEBUG || YYERROR_VERBOSE || 0
/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "IDENT", "UIDENT", "FCONST", "SCONST",
  "USCONST", "BCONST", "XCONST", "Op", "ICONST", "PARAM", "TYPECAST",
  "DOT_DOT", "COLON_EQUALS", "EQUALS_GREATER", "LESS_EQUALS",
  "GREATER_EQUALS", "NOT_EQUALS", "ABORT_P", "ABSOLUTE_P", "ACCESS",
  "ACTION", "ADD_P", "ADMIN", "AFTER", "AGGREGATE", "ALL", "ALSO", "ALTER",
  "ALWAYS", "ANALYSE", "ANALYZE", "AND", "ANY", "ARRAY", "AS", "ASC",
  "ASENSITIVE", "ASSERTION", "ASSIGNMENT", "ASYMMETRIC", "ATOMIC", "AT",
  "ATTACH", "ATTRIBUTE", "AUTHORIZATION", "BACKWARD", "BEFORE", "BEGIN_P",
  "BETWEEN", "BIGINT", "BINARY", "BIT", "BOOLEAN_P", "BOTH", "BREADTH",
  "BY", "CACHE", "CALL", "CALLED", "CASCADE", "CASCADED", "CASE", "CAST",
  "CATALOG_P", "CHAIN", "CHAR_P", "CHARACTER", "CHARACTERISTICS", "CHECK",
  "CHECKPOINT", "CLASS", "CLOSE", "CLUSTER", "COALESCE", "COLLATE",
  "COLLATION", "COLUMN", "COLUMNS", "COMMENT", "COMMENTS", "COMMIT",
  "COMMITTED", "COMPRESSION", "CONCURRENTLY", "CONFIGURATION", "CONFLICT",
  "CONNECTION", "CONSTRAINT", "CONSTRAINTS", "CONTENT_P", "CONTINUE_P",
  "CONVERSION_P", "COPY", "COST", "CREATE", "CROSS", "CSV", "CUBE",
  "CURRENT_P", "CURRENT_CATALOG", "CURRENT_DATE", "CURRENT_ROLE",
  "CURRENT_SCHEMA", "CURRENT_TIME", "CURRENT_TIMESTAMP", "CURRENT_USER",
  "CURSOR", "CYCLE", "DATA_P", "DATABASE", "DAY_P", "DEALLOCATE", "DEC",
  "DECIMAL_P", "DECLARE", "DEFAULT", "DEFAULTS", "DEFERRABLE", "DEFERRED",
  "DEFINER", "DELETE_P", "DELIMITER", "DELIMITERS", "DEPENDS", "DEPTH",
  "DESC", "DETACH", "DICTIONARY", "DISABLE_P", "DISCARD", "DISTINCT", "DO",
  "DOCUMENT_P", "DOMAIN_P", "DOUBLE_P", "DROP", "EACH", "ELSE", "ENABLE_P",
  "ENCODING", "ENCRYPTED", "END_P", "ENUM_P", "ESCAPE", "EVENT", "EXCEPT",
  "EXCLUDE", "EXCLUDING", "EXCLUSIVE", "EXECUTE", "EXISTS", "EXPLAIN",
  "EXPRESSION", "EXTENSION", "EXTERNAL", "EXTRACT", "FALSE_P", "FAMILY",
  "FETCH", "FILTER", "FINALIZE", "FIRST_P", "FLOAT_P", "FOLLOWING", "FOR",
  "FORCE", "FOREIGN", "FORWARD", "FREEZE", "FROM", "FULL", "FUNCTION",
  "FUNCTIONS", "GENERATED", "GLOBAL", "GRANT", "GRANTED", "GREATEST",
  "GROUP_P", "GROUPING", "GROUPS", "HANDLER", "HAVING", "HEADER_P", "HOLD",
  "HOUR_P", "IDENTITY_P", "IF_P", "ILIKE", "IMMEDIATE", "IMMUTABLE",
  "IMPLICIT_P", "IMPORT_P", "IN_P", "INCLUDE", "INCLUDING", "INCREMENT",
  "INDEX", "INDEXES", "INHERIT", "INHERITS", "INITIALLY", "INLINE_P",
  "INNER_P", "INOUT", "INPUT_P", "INSENSITIVE", "INSERT", "INSTEAD",
  "INT_P", "INTEGER", "INTERSECT", "INTERVAL", "INTO", "INVOKER", "IS",
  "ISNULL", "ISOLATION", "JOIN", "KEY", "LABEL", "LANGUAGE", "LARGE_P",
  "LAST_P", "LATERAL_P", "LEADING", "LEAKPROOF", "LEAST", "LEFT", "LEVEL",
  "LIKE", "LIMIT", "LISTEN", "LOAD", "LOCAL", "LOCALTIME",
  "LOCALTIMESTAMP", "LOCATION", "LOCK_P", "LOCKED", "LOGGED", "MAPPING",
  "MATCH", "MATCHED", "MATERIALIZED", "MAXVALUE", "MERGE", "METHOD",
  "MINUTE_P", "MINVALUE", "MODE", "MONTH_P", "MOVE", "NAME_P", "NAMES",
  "NATIONAL", "NATURAL", "NCHAR", "NEW", "NEXT", "NFC", "NFD", "NFKC",
  "NFKD", "NO", "NONE", "NORMALIZE", "NORMALIZED", "NOT", "NOTHING",
  "NOTIFY", "NOTNULL", "NOWAIT", "NULL_P", "NULLIF", "NULLS_P", "NUMERIC",
  "OBJECT_P", "OF", "OFF", "OFFSET", "OIDS", "OLD", "ON", "ONLY",
  "OPERATOR", "OPTION", "OPTIONS", "OR", "ORDER", "ORDINALITY", "OTHERS",
  "OUT_P", "OUTER_P", "OVER", "OVERLAPS", "OVERLAY", "OVERRIDING", "OWNED",
  "OWNER", "PARALLEL", "PARAMETER", "PARSER", "PARTIAL", "PARTITION",
  "PASSING", "PASSWORD", "PGPOOL", "PLACING", "PLANS", "POLICY",
  "POSITION", "PRECEDING", "PRECISION", "PRESERVE", "PREPARE", "PREPARED",
  "PRIMARY", "PRIOR", "PRIVILEGES", "PROCEDURAL", "PROCEDURE",
  "PROCEDURES", "PROGRAM", "PUBLICATION", "QUOTE", "RANGE", "READ", "REAL",
  "REASSIGN", "RECHECK", "RECURSIVE", "REF", "REFERENCES", "REFERENCING",
  "REFRESH", "REINDEX", "RELATIVE_P", "RELEASE", "RENAME", "REPEATABLE",
  "REPLACE", "REPLICA", "RESET", "RESTART", "RESTRICT", "RETURN",
  "RETURNING", "RETURNS", "REVOKE", "RIGHT", "ROLE", "ROLLBACK", "ROLLUP",
  "ROUTINE", "ROUTINES", "ROW", "ROWS", "RULE", "SAVEPOINT", "SCHEMA",
  "SCHEMAS", "SCROLL", "SEARCH", "SECOND_P", "SECURITY", "SELECT",
  "SEQUENCE", "SEQUENCES", "SERIALIZABLE", "SERVER", "SESSION",
  "SESSION_USER", "SET", "SETS", "SETOF", "SHARE", "SHOW", "SIMILAR",
  "SIMPLE", "SKIP", "SMALLINT", "SNAPSHOT", "SOME", "SQL_P", "STABLE",
  "STANDALONE_P", "START", "STATEMENT", "STATISTICS", "STDIN", "STDOUT",
  "STORAGE", "STORED", "STRICT_P", "STRIP_P", "SUBSCRIPTION", "SUBSTRING",
  "SUPPORT", "SYMMETRIC", "SYSID", "SYSTEM_P", "TABLE", "TABLES",
  "TABLESAMPLE", "TABLESPACE", "TEMP", "TEMPLATE", "TEMPORARY", "TEXT_P",
  "THEN", "TIES", "TIME", "TIMESTAMP", "TO", "TRAILING", "TRANSACTION",
  "TRANSFORM", "TREAT", "TRIGGER", "TRIM", "TRUE_P", "TRUNCATE", "TRUSTED",
  "TYPE_P", "TYPES_P", "UESCAPE", "UNBOUNDED", "UNCOMMITTED",
  "UNENCRYPTED", "UNION", "UNIQUE", "UNKNOWN", "UNLISTEN", "UNLOGGED",
  "UNTIL", "UPDATE", "USER", "USING", "VACUUM", "VALID", "VALIDATE",
  "VALIDATOR", "VALUE_P", "VALUES", "VARCHAR", "VARIADIC", "VARYING",
  "VERBOSE", "VERSION_P", "VIEW", "VIEWS", "VOLATILE", "WHEN", "WHERE",
  "WHITESPACE_P", "WINDOW", "WITH", "WITHIN", "WITHOUT", "WORK", "WRAPPER",
  "WRITE", "XML_P", "XMLATTRIBUTES", "XMLCONCAT", "XMLELEMENT",
  "XMLEXISTS", "XMLFOREST", "XMLNAMESPACES", "XMLPARSE", "XMLPI",
  "XMLROOT", "XMLSERIALIZE", "XMLTABLE", "YEAR_P", "YES_P", "ZONE",
  "NOT_LA", "NULLS_LA", "WITH_LA", "MODE_TYPE_NAME", "MODE_PLPGSQL_EXPR",
  "MODE_PLPGSQL_ASSIGN1", "MODE_PLPGSQL_ASSIGN2", "MODE_PLPGSQL_ASSIGN3",
  "'<'", "'>'", "'='", "'+'", "'-'", "'*'", "'/'", "'%'", "'^'", "UMINUS",
  "'['", "']'", "'('", "')'", "'.'", "';'", "','", "':'", "$accept",
  "parse_toplevel", "stmtmulti", "toplevel_stmt", "stmt", "CallStmt",
  "CreateRoleStmt", "opt_with", "OptRoleList", "AlterOptRoleList",
  "AlterOptRoleElem", "CreateOptRoleElem", "CreateUserStmt",
  "AlterRoleStmt", "opt_in_database", "AlterRoleSetStmt", "DropRoleStmt",
  "CreateGroupStmt", "AlterGroupStmt", "add_drop", "CreateSchemaStmt",
  "OptSchemaName", "OptSchemaEltList", "schema_stmt", "VariableSetStmt",
  "set_rest", "generic_set", "set_rest_more", "var_name", "var_list",
  "var_value", "iso_level", "opt_boolean_or_string", "zone_value",
  "opt_encoding", "NonReservedWord_or_Sconst", "VariableResetStmt",
  "reset_rest", "generic_reset", "SetResetClause",
  "FunctionSetResetClause", "VariableShowStmt", "ConstraintsSetStmt",
  "constraints_set_list", "constraints_set_mode", "CheckPointStmt",
  "DiscardStmt", "AlterTableStmt", "alter_table_cmds", "partition_cmd",
  "index_partition_cmd", "alter_table_cmd", "alter_column_default",
  "opt_drop_behavior", "opt_collate_clause", "alter_using",
  "replica_identity", "reloptions", "opt_reloptions", "reloption_list",
  "reloption_elem", "alter_identity_column_option_list",
  "alter_identity_column_option", "PartitionBoundSpec",
  "hash_partbound_elem", "hash_partbound", "AlterCompositeTypeStmt",
  "alter_type_cmds", "alter_type_cmd", "ClosePortalStmt", "CopyStmt",
  "copy_from", "opt_program", "copy_file_name", "copy_options",
  "copy_opt_list", "copy_opt_item", "opt_binary", "copy_delimiter",
  "opt_using", "copy_generic_opt_list", "copy_generic_opt_elem",
  "copy_generic_opt_arg", "copy_generic_opt_arg_list",
  "copy_generic_opt_arg_list_item", "CreateStmt", "OptTemp",
  "OptTableElementList", "OptTypedTableElementList", "TableElementList",
  "TypedTableElementList", "TableElement", "TypedTableElement",
  "columnDef", "columnOptions", "column_compression",
  "opt_column_compression", "ColQualList", "ColConstraint",
  "ColConstraintElem", "opt_unique_null_treatment", "generated_when",
  "ConstraintAttr", "TableLikeClause", "TableLikeOptionList",
  "TableLikeOption", "TableConstraint", "ConstraintElem", "opt_no_inherit",
  "opt_column_list", "columnList", "columnElem", "opt_c_include",
  "key_match", "ExclusionConstraintList", "ExclusionConstraintElem",
  "OptWhereClause", "key_actions", "key_update", "key_delete",
  "key_action", "OptInherit", "OptPartitionSpec", "PartitionSpec",
  "part_params", "part_elem", "table_access_method_clause", "OptWith",
  "OnCommitOption", "OptTableSpace", "OptConsTableSpace", "ExistingIndex",
  "CreateStatsStmt", "stats_params", "stats_param", "AlterStatsStmt",
  "CreateAsStmt", "create_as_target", "opt_with_data", "CreateMatViewStmt",
  "create_mv_target", "OptNoLog", "RefreshMatViewStmt", "CreateSeqStmt",
  "AlterSeqStmt", "OptSeqOptList", "OptParenthesizedSeqOptList",
  "SeqOptList", "SeqOptElem", "opt_by", "NumericOnly", "NumericOnly_list",
  "CreatePLangStmt", "opt_trusted", "handler_name", "opt_inline_handler",
  "validator_clause", "opt_validator", "opt_procedural",
  "CreateTableSpaceStmt", "OptTableSpaceOwner", "DropTableSpaceStmt",
  "CreateExtensionStmt", "create_extension_opt_list",
  "create_extension_opt_item", "AlterExtensionStmt",
  "alter_extension_opt_list", "alter_extension_opt_item",
  "AlterExtensionContentsStmt", "CreateFdwStmt", "fdw_option",
  "fdw_options", "opt_fdw_options", "AlterFdwStmt",
  "create_generic_options", "generic_option_list", "alter_generic_options",
  "alter_generic_option_list", "alter_generic_option_elem",
  "generic_option_elem", "generic_option_name", "generic_option_arg",
  "CreateForeignServerStmt", "opt_type", "foreign_server_version",
  "opt_foreign_server_version", "AlterForeignServerStmt",
  "CreateForeignTableStmt", "ImportForeignSchemaStmt",
  "import_qualification_type", "import_qualification",
  "CreateUserMappingStmt", "auth_ident", "DropUserMappingStmt",
  "AlterUserMappingStmt", "CreatePolicyStmt", "AlterPolicyStmt",
  "RowSecurityOptionalExpr", "RowSecurityOptionalWithCheck",
  "RowSecurityDefaultToRole", "RowSecurityOptionalToRole",
  "RowSecurityDefaultPermissive", "RowSecurityDefaultForCmd",
  "row_security_cmd", "CreateAmStmt", "am_type", "CreateTrigStmt",
  "TriggerActionTime", "TriggerEvents", "TriggerOneEvent",
  "TriggerReferencing", "TriggerTransitions", "TriggerTransition",
  "TransitionOldOrNew", "TransitionRowOrTable", "TransitionRelName",
  "TriggerForSpec", "TriggerForOptEach", "TriggerForType", "TriggerWhen",
  "FUNCTION_or_PROCEDURE", "TriggerFuncArgs", "TriggerFuncArg",
  "OptConstrFromTable", "ConstraintAttributeSpec",
  "ConstraintAttributeElem", "CreateEventTrigStmt",
  "event_trigger_when_list", "event_trigger_when_item",
  "event_trigger_value_list", "AlterEventTrigStmt", "enable_trigger",
  "CreateAssertionStmt", "DefineStmt", "definition", "def_list",
  "def_elem", "def_arg", "old_aggr_definition", "old_aggr_list",
  "old_aggr_elem", "opt_enum_val_list", "enum_val_list", "AlterEnumStmt",
  "opt_if_not_exists", "CreateOpClassStmt", "opclass_item_list",
  "opclass_item", "opt_default", "opt_opfamily", "opclass_purpose",
  "opt_recheck", "CreateOpFamilyStmt", "AlterOpFamilyStmt",
  "opclass_drop_list", "opclass_drop", "DropOpClassStmt",
  "DropOpFamilyStmt", "DropOwnedStmt", "ReassignOwnedStmt", "DropStmt",
  "object_type_any_name", "object_type_name", "drop_type_name",
  "object_type_name_on_any_name", "any_name_list", "any_name", "attrs",
  "type_name_list", "TruncateStmt", "opt_restart_seqs", "CommentStmt",
  "comment_text", "SecLabelStmt", "opt_provider", "security_label",
  "FetchStmt", "fetch_args", "from_in", "opt_from_in", "GrantStmt",
  "RevokeStmt", "privileges", "privilege_list", "privilege",
  "parameter_name_list", "parameter_name", "privilege_target",
  "grantee_list", "grantee", "opt_grant_grant_option", "GrantRoleStmt",
  "RevokeRoleStmt", "opt_grant_admin_option", "opt_granted_by",
  "AlterDefaultPrivilegesStmt", "DefACLOptionList", "DefACLOption",
  "DefACLAction", "defacl_privilege_target", "IndexStmt", "opt_unique",
  "opt_concurrently", "opt_index_name", "access_method_clause",
  "index_params", "index_elem_options", "index_elem", "opt_include",
  "index_including_params", "opt_collate", "opt_class", "opt_asc_desc",
  "opt_nulls_order", "CreateFunctionStmt", "opt_or_replace", "func_args",
  "func_args_list", "function_with_argtypes_list",
  "function_with_argtypes", "func_args_with_defaults",
  "func_args_with_defaults_list", "func_arg", "arg_class", "param_name",
  "func_return", "func_type", "func_arg_with_default", "aggr_arg",
  "aggr_args", "aggr_args_list", "aggregate_with_argtypes",
  "aggregate_with_argtypes_list", "opt_createfunc_opt_list",
  "createfunc_opt_list", "common_func_opt_item", "createfunc_opt_item",
  "func_as", "ReturnStmt", "opt_routine_body", "routine_body_stmt_list",
  "routine_body_stmt", "transform_type_list", "opt_definition",
  "table_func_column", "table_func_column_list", "AlterFunctionStmt",
  "alterfunc_opt_list", "opt_restrict", "RemoveFuncStmt", "RemoveAggrStmt",
  "RemoveOperStmt", "oper_argtypes", "any_operator",
  "operator_with_argtypes_list", "operator_with_argtypes", "DoStmt",
  "dostmt_opt_list", "dostmt_opt_item", "CreateCastStmt", "cast_context",
  "DropCastStmt", "opt_if_exists", "CreateTransformStmt",
  "transform_element_list", "DropTransformStmt", "ReindexStmt",
  "reindex_target_type", "reindex_target_multitable", "AlterTblSpcStmt",
  "RenameStmt", "opt_column", "opt_set_data", "AlterObjectDependsStmt",
  "opt_no", "AlterObjectSchemaStmt", "AlterOperatorStmt",
  "operator_def_list", "operator_def_elem", "operator_def_arg",
  "AlterTypeStmt", "AlterOwnerStmt", "CreatePublicationStmt",
  "PublicationObjSpec", "pub_obj_list", "AlterPublicationStmt",
  "CreateSubscriptionStmt", "AlterSubscriptionStmt",
  "DropSubscriptionStmt", "RuleStmt", "RuleActionList", "RuleActionMulti",
  "RuleActionStmt", "RuleActionStmtOrEmpty", "event", "opt_instead",
  "NotifyStmt", "notify_payload", "ListenStmt", "UnlistenStmt",
  "TransactionStmt", "TransactionStmtLegacy", "opt_transaction",
  "transaction_mode_item", "transaction_mode_list",
  "transaction_mode_list_or_empty", "opt_transaction_chain", "ViewStmt",
  "opt_check_option", "LoadStmt", "CreatedbStmt", "createdb_opt_list",
  "createdb_opt_items", "createdb_opt_item", "createdb_opt_name",
  "opt_equal", "AlterDatabaseStmt", "AlterDatabaseSetStmt", "DropdbStmt",
  "drop_option_list", "drop_option", "AlterCollationStmt",
  "AlterSystemStmt", "CreateDomainStmt", "AlterDomainStmt", "opt_as",
  "AlterTSDictionaryStmt", "AlterTSConfigurationStmt", "any_with",
  "CreateConversionStmt", "ClusterStmt", "cluster_index_specification",
  "VacuumStmt", "AnalyzeStmt", "utility_option_list", "analyze_keyword",
  "utility_option_elem", "utility_option_name", "utility_option_arg",
  "opt_analyze", "opt_verbose", "opt_full", "opt_freeze", "opt_name_list",
  "vacuum_relation", "vacuum_relation_list", "opt_vacuum_relation_list",
  "ExplainStmt", "ExplainableStmt", "PrepareStmt", "prep_type_clause",
  "PreparableStmt", "ExecuteStmt", "execute_param_clause",
  "DeallocateStmt", "InsertStmt", "insert_target", "insert_rest",
  "override_kind", "insert_column_list", "insert_column_item",
  "opt_on_conflict", "opt_conf_expr", "returning_clause", "DeleteStmt",
  "using_clause", "LockStmt", "opt_lock", "lock_type", "opt_nowait",
  "opt_nowait_or_skip", "UpdateStmt", "set_clause_list", "set_clause",
  "set_target", "set_target_list", "MergeStmt", "merge_when_list",
  "merge_when_clause", "opt_merge_when_condition", "merge_update",
  "merge_delete", "merge_insert", "merge_values_clause",
  "DeclareCursorStmt", "cursor_name", "cursor_options", "opt_hold",
  "SelectStmt", "select_with_parens", "select_no_parens", "select_clause",
  "simple_select", "with_clause", "cte_list", "common_table_expr",
  "opt_materialized", "opt_search_clause", "opt_cycle_clause",
  "opt_with_clause", "into_clause", "OptTempTableName", "opt_table",
  "set_quantifier", "distinct_clause", "opt_all_clause",
  "opt_distinct_clause", "opt_sort_clause", "sort_clause", "sortby_list",
  "sortby", "select_limit", "opt_select_limit", "limit_clause",
  "offset_clause", "select_limit_value", "select_offset_value",
  "select_fetch_first_value", "I_or_F_const", "row_or_rows",
  "first_or_next", "group_clause", "group_by_list", "group_by_item",
  "empty_grouping_set", "rollup_clause", "cube_clause",
  "grouping_sets_clause", "having_clause", "for_locking_clause",
  "opt_for_locking_clause", "for_locking_items", "for_locking_item",
  "for_locking_strength", "locked_rels_list", "values_clause",
  "from_clause", "from_list", "table_ref", "joined_table", "alias_clause",
  "opt_alias_clause", "opt_alias_clause_for_join_using",
  "func_alias_clause", "join_type", "opt_outer", "join_qual",
  "relation_expr", "extended_relation_expr", "relation_expr_list",
  "relation_expr_opt_alias", "tablesample_clause", "opt_repeatable_clause",
  "func_table", "rowsfrom_item", "rowsfrom_list", "opt_col_def_list",
  "opt_ordinality", "where_clause", "where_or_current_clause",
  "OptTableFuncElementList", "TableFuncElementList", "TableFuncElement",
  "xmltable", "xmltable_column_list", "xmltable_column_el",
  "xmltable_column_option_list", "xmltable_column_option_el",
  "xml_namespace_list", "xml_namespace_el", "Typename", "opt_array_bounds",
  "SimpleTypename", "ConstTypename", "GenericType", "opt_type_modifiers",
  "Numeric", "opt_float", "Bit", "ConstBit", "BitWithLength",
  "BitWithoutLength", "Character", "ConstCharacter", "CharacterWithLength",
  "CharacterWithoutLength", "character", "opt_varying", "ConstDatetime",
  "ConstInterval", "opt_timezone", "opt_interval", "interval_second",
  "a_expr", "b_expr", "c_expr", "func_application", "func_expr",
  "func_expr_windowless", "func_expr_common_subexpr", "xml_root_version",
  "opt_xml_root_standalone", "xml_attributes", "xml_attribute_list",
  "xml_attribute_el", "document_or_content", "xml_whitespace_option",
  "xmlexists_argument", "xml_passing_mech", "within_group_clause",
  "filter_clause", "window_clause", "window_definition_list",
  "window_definition", "over_clause", "window_specification",
  "opt_existing_window_name", "opt_partition_clause", "opt_frame_clause",
  "frame_extent", "frame_bound", "opt_window_exclusion_clause", "row",
  "explicit_row", "implicit_row", "sub_type", "all_Op", "MathOp",
  "qual_Op", "qual_all_Op", "subquery_Op", "expr_list", "func_arg_list",
  "func_arg_expr", "func_arg_list_opt", "type_list", "array_expr",
  "array_expr_list", "extract_list", "extract_arg", "unicode_normal_form",
  "overlay_list", "position_list", "substr_list", "trim_list", "in_expr",
  "case_expr", "when_clause_list", "when_clause", "case_default",
  "case_arg", "columnref", "indirection_el", "opt_slice_bound",
  "indirection", "opt_indirection", "opt_asymmetric", "opt_target_list",
  "target_list", "target_el", "qualified_name_list", "qualified_name",
  "name_list", "name", "attr_name", "file_name", "func_name", "AexprConst",
  "Iconst", "Sconst", "SignedIconst", "RoleId", "RoleSpec", "role_list",
  "PLpgSQL_Expr", "PLAssignStmt", "plassign_target", "plassign_equals",
  "ColId", "type_function_name", "NonReservedWord", "ColLabel",
  "BareColLabel", "unreserved_keyword", "col_name_keyword",
  "type_func_name_keyword", "reserved_keyword", "bare_label_keyword", YY_NULLPTR
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[NUM] -- (External) token number corresponding to the
   (internal) symbol number NUM (which must be that of a token).  */
static const yytype_uint16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,   431,   432,   433,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446,   447,   448,   449,   450,   451,   452,   453,   454,
     455,   456,   457,   458,   459,   460,   461,   462,   463,   464,
     465,   466,   467,   468,   469,   470,   471,   472,   473,   474,
     475,   476,   477,   478,   479,   480,   481,   482,   483,   484,
     485,   486,   487,   488,   489,   490,   491,   492,   493,   494,
     495,   496,   497,   498,   499,   500,   501,   502,   503,   504,
     505,   506,   507,   508,   509,   510,   511,   512,   513,   514,
     515,   516,   517,   518,   519,   520,   521,   522,   523,   524,
     525,   526,   527,   528,   529,   530,   531,   532,   533,   534,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,   552,   553,   554,
     555,   556,   557,   558,   559,   560,   561,   562,   563,   564,
     565,   566,   567,   568,   569,   570,   571,   572,   573,   574,
     575,   576,   577,   578,   579,   580,   581,   582,   583,   584,
     585,   586,   587,   588,   589,   590,   591,   592,   593,   594,
     595,   596,   597,   598,   599,   600,   601,   602,   603,   604,
     605,   606,   607,   608,   609,   610,   611,   612,   613,   614,
     615,   616,   617,   618,   619,   620,   621,   622,   623,   624,
     625,   626,   627,   628,   629,   630,   631,   632,   633,   634,
     635,   636,   637,   638,   639,   640,   641,   642,   643,   644,
     645,   646,   647,   648,   649,   650,   651,   652,   653,   654,
     655,   656,   657,   658,   659,   660,   661,   662,   663,   664,
     665,   666,   667,   668,   669,   670,   671,   672,   673,   674,
     675,   676,   677,   678,   679,   680,   681,   682,   683,   684,
     685,   686,   687,   688,   689,   690,   691,   692,   693,   694,
     695,   696,   697,   698,   699,   700,   701,   702,   703,   704,
     705,   706,   707,   708,   709,   710,   711,   712,   713,   714,
     715,   716,   717,   718,   719,   720,   721,   722,   723,   724,
     725,   726,   727,   728,   729,   730,   731,   732,   733,   734,
     735,   736,   737,   738,   739,   740,   741,   742,   743,    60,
      62,    61,    43,    45,    42,    47,    37,    94,   744,    91,
      93,    40,    41,    46,    59,    44,    58
};
# endif

#define YYPACT_NINF -5579

#define yypact_value_is_default(Yystate) \
  (!!((Yystate) == (-5579)))

#define YYTABLE_NINF -2820

#define yytable_value_is_error(Yytable_value) \
  (!!((Yytable_value) == (-2820)))

  /* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
     STATE-NUM.  */
static const int yypact[] =
{
   11031,     3, 19823, -5579, -5579,     3, 66498, -5579, 75580,   -26,
     155,    69,   191, 18609, 76058, 85618,   242,   361, 18461,     3,
   85618,  1269, 57416, 71756,   280, 85618,  1099,   707, 57416, 85618,
    2050, 86096,   848,  1041,  1371, 86574, 76536, 70322,  1405, 85618,
    1076,  1045, 87052, 77014,   937, 77492,   707, 53616,   143,  1006,
   87530, 85618,109448,  1045, 77970, 77970, 77970,    32,  1545,   921,
   -5579, -5579, -5579, -5579, -5579, -5579, -5579, -5579, -5579, -5579,
   -5579, -5579, -5579, -5579, -5579, -5579, -5579, -5579, -5579, -5579,
   -5579, -5579, -5579, -5579, -5579, -5579, -5579, -5579, -5579, -5579,
   -5579, -5579, -5579, -5579, -5579, -5579, -5579, -5579, -5579, -5579,
   -5579, -5579, -5579, -5579, -5579, -5579, -5579, -5579, -5579, -5579,
   -5579, -5579, -5579, -5579, -5579, -5579, -5579, -5579, -5579, -5579,
   -5579, -5579, -5579, -5579, -5579, -5579, -5579, -5579, -5579, -5579,
   -5579, -5579, -5579, -5579, -5579, -5579, -5579, -5579, -5579, -5579,
   -5579, -5579, -5579, -5579, -5579, -5579, -5579, -5579, -5579, -5579,
   -5579, -5579, -5579, -5579, -5579, -5579, -5579, -5579, -5579, -5579,
   -5579, -5579, -5579, -5579, -5579, -5579, -5579, -5579, -5579, -5579,
   -5579, -5579, -5579, -5579, -5579, -5579,  1255, -5579, -5579, -5579,
   -5579, -5579, -5579, -5579, -5579, -5579, -5579, -5579,  2353, -5579,
     818,  2526,  1372,   368,  1053, -5579, -5579,  1590, 66498, 85618,
   85618, 85618,  1465, 85618,  1378, 85618,   211, 66498, 62674, 78448,
    1448,  1262, 49690, 88008, -5579, 66498, 85618, 60284, 66498, 85618,
   85618, 88486, 85618, 88964, 85618,  1600, 74146, 85618,  1475, 85618,
   85618, 60762, 89442,  1636,  1565,   253, -5579, -5579, -5579, -5579,
   -5579, -5579, -5579, -5579, -5579, -5579, -5579, -5579, -5579, -5579,
   -5579, -5579, -5579, -5579, -5579, -5579, -5579, -5579, -5579, -5579,
   -5579, -5579, -5579, -5579, -5579, -5579, -5579, -5579, -5579, -5579,
   -5579, -5579, -5579, -5579, -5579, -5579, -5579, -5579, -5579, -5579,
   -5579, -5579, -5579, -5579, -5579, -5579, -5579, -5579, -5579, -5579,
   -5579, -5579, -5579, -5579, -5579, -5579, -5579, -5579, -5579, -5579,
   -5579, -5579, -5579, -5579, -5579, -5579, -5579, -5579, -5579, -5579,
   -5579, -5579, -5579, -5579, -5579, -5579, -5579, -5579, -5579, -5579,
   -5579, -5579, -5579, -5579, -5579, -5579, -5579, -5579, -5579, -5579,
   -5579, -5579, -5579, -5579, -5579, -5579, -5579, -5579, -5579, -5579,
   -5579, -5579, -5579, -5579, -5579, -5579, -5579, -5579, -5579, -5579,
   -5579, -5579, -5579, -5579, -5579, -5579, -5579, -5579, -5579, -5579,
   -5579, -5579, -5579, -5579, -5579, -5579, -5579, -5579, -5579, -5579,
   -5579, -5579, -5579, -5579, -5579, -5579, -5579, -5579, -5579, -5579,
   -5579, -5579, -5579, -5579, -5579, -5579, -5579, -5579, -5579, -5579,
   -5579, -5579, -5579, -5579, -5579, -5579, -5579, -5579, -5579, -5579,
   -5579, -5579, -5579, -5579, -5579, -5579, -5579, -5579, -5579, -5579,
   -5579, -5579, -5579, -5579, -5579, -5579, -5579, -5579, -5579, -5579,
   -5579, -5579, -5579, -5579, -5579, -5579, -5579, -5579, -5579, -5579,
   -5579, -5579, -5579, -5579, -5579, -5579, -5579, -5579, -5579, -5579,
   -5579, -5579, -5579, -5579, -5579, -5579, -5579, -5579, -5579, -5579,
   -5579, -5579, -5579, -5579, -5579, -5579, -5579, -5579, -5579, -5579,
   -5579, -5579, -5579, -5579, -5579, -5579, -5579, -5579, -5579, -5579,
   -5579, -5579, -5579, -5579, -5579, -5579, -5579, -5579, -5579, -5579,
   -5579, -5579, -5579, -5579, -5579, -5579, -5579, -5579, -5579, -5579,
   -5579, -5579, -5579, -5579, -5579, -5579, -5579, -5579, -5579, -5579,
   -5579, -5579, -5579, -5579, -5579, -5579, -5579, -5579, -5579, -5579,
   -5579, -5579, -5579, -5579, -5579, -5579, -5579, -5579, -5579, -5579,
   -5579, -5579, -5579, -5579, -5579, -5579, -5579, -5579, -5579, -5579,
   -5579, -5579, -5579, -5579, -5579, -5579, -5579, -5579, -5579, -5579,
   -5579, -5579, -5579, -5579, -5579, -5579, -5579, -5579, -5579, -5579,
   -5579, -5579, -5579, -5579, -5579, -5579, -5579, -5579, -5579, -5579,
   -5579, -5579, -5579, -5579, -5579, -5579, -5579, -5579, -5579, -5579,
   -5579, -5579, -5579, -5579, -5579, -5579, -5579, -5579, -5579, -5579,
   -5579, -5579, -5579, -5579, -5579, -5579, -5579, -5579, -5579, -5579,
   -5579, -5579, -5579, -5579, -5579, -5579, -5579, -5579, -5579, -5579,
   -5579, -5579, -5579, -5579, -5579, -5579, -5579, -5579, -5579, -5579,
   -5579, -5579, -5579, -5579, -5579, -5579, -5579, -5579, -5579, -5579,
    1390,  1958, -5579,   261, -5579, -5579, -5579, -5579, -5579, -5579,
   -5579, -5579, -5579, 65064, 85618, 12589,  1099,  1590, -5579,    32,
   85618,  1709, 85618,  1466, 89920, 85618, -5579, 85618,  1654, 90398,
     501,  1795, 62674,  1886, 50185,  1794, 85618, 85618, 62674, 90876,
   91354, 91832, 85618, 85618, -5579, -5579,  1779, 85618, -5579,  1913,
   63152,  1737,  1971,  2094,  2032,  1483, -5579, 78926, -5579, -5579,
   -5579, -5579, -5579, -5579, -5579, -5579, 66020,   361, -5579, -5579,
    2086, 66976,  2183, -5579, -5579, 92310,109912,  1825, -5579,   822,
   67454, 63630,  2311,  1998, 50680,  2346, -5579, 67932, -5579, 64108,
   68410, -5579, -5579, -5579, -5579, -5579, 92788, -5579, 93266,  2092,
    2183, -5579,110376, 64586, -5579,  2253, 93744, 94222, 94700,  1590,
    1991,  1865,  1217, 44346, -5579, -5579, -5579,  2045, -5579, -5579,
   -5579, -5579, -5579, -5579, -5579, -5579, -5579,   317,  1887,   238,
     215,   264, -5579, -5579,   218,   254,   255,   317,  2488,  2488,
   -5579, 85618, -5579, -5579,  1887,   625,  2099,  2040,  2040,  2040,
    2229,   860, -5579,  2040,  2186, -5579, -5579, -5579, -5579, 77492,
   -5579,  2056, 79404, 85618, 79882,  1099,  2077,  2510,  2139, -5579,
   -5579, -5579, -5579, -5579, 65064,  2523,  2523, 85618, -5579, -5579,
    2550,  2125,  2414,  2151, -5579, -5579, -5579,  2389,  2400,  2398,
     127,  1099,   250, -5579,  2534, -5579,  2420, 30640, 30640,  1099,
   80360, 95178,   233, 66020,  1099, 80838,  2215,  1293,  2425, -5579,
   -5579, -5579,   708, -5579,  2689,  2270,  2545,  2151,  1565, 46274,
   -5579, -5579,  2261,  1958, 77492, -5579, -5579, -5579, 65064,  2628,
   33110, 85618,  2290, -5579,  2334,  2290, -5579, -5579,  2362, -5579,
    2362,  2362,  2338,  2338,  2539,  2350, -5579, -5579, -5579,  2395,
    2362,  2338, -5579,111304, -5579,  1806,  1834, -5579, -5579,  2830,
   -5579, -5579, -5579, -5579, -5579, -5579, -5579, -5579,  2370, -5579,
     870,  1969, -5579, -5579, -5579, 30640, -5579, -5579, -5579, -5579,
   -5579, -5579, -5579,  2374,  2378,  1372, -5579,  6943, 65064, 85618,
    1046,  1046,  2836,  1046,  1691,  1714, -5579,  2586, -5579,  2728,
    2696,  2702, 77492,  2431,   881, -5579,  1857,  2439,  1851,  2423,
    1877,  1402, -5579,  1384, 85618,   257,  2508, 81316,  8107,  2491,
    1958,  2537, -5579, -5579, -5579, -5579,  2667,   380, -5579, -5579,
   -5579, -5579,  2771,  2864,  6777,   302, 81794, -5579, -5579, -5579,
   -5579, 85618, 85618, -5579, -5579, -5579, -5579, -5579, -5579, -5579,
   -5579, -5579,  2559,  1605, -5579, -5579,  2546,  2901,  2805, 12196,
    1453,  2905,  2764,  1809, 13851,  2842,  1524,  2998,  9720,  1463,
    3016,  1914,  2072, 79404, 85618,  2986,  3032,  4071,  1882,   313,
    2900,  1393,  2905,  3023,  2849,  1809,  3039,  3109, 85618, -5579,
    2964,  3079,    87, -5579,   258, -5579, 24271, 33110, 53138, -5579,
    1958,  1938, -5579, -5579, 56460, -5579,  2773,  2919,    47, 66498,
    2711, 85618, 85618, -5579,109448, 66498, -5579,  2935, 51175, 66498,
   -5579, 66498, -5579, -5579,  3049,109448, 85618, 85618, -5579, 85618,
   -5579, -5579,  2717, -5579, -5579, -5579, -5579, -5579,  2040, 85618,
    3149,109448,  2950,   146,   635,  3187, 85618,  2955,   635,  2765,
   95656, -5579, -5579,   635, -5579, -5579, -5579, 85618, 85618,  2729,
    1109,  2945,   427,   635,  2961,  3186,  3188,  2970,  2816,  2973,
    2334,  3156,  2944,   542,   208,  1785,   635,  2795, 96134, 96612,
   85618,  2796, 85618,  2523, 66498,  2829, 66498, 66498, 85618,  3085,
   85618, -5579,  2930, -5579, -5579,  1733, -5579, -5579, -5579, -5579,
   -5579,  3101, -5579,   201,  3103,  2756,  3105,  1612,  3107,   216,
   -5579, -5579,  2798, -5579,  3111,   220, -5579,  3113, -5579,  2767,
   97090, -5579, 97568, 98046,  3125,   239, -5579, 62674,  3126,   220,
    3127,  2767,  3130,   220,  3131,   845,  3134, -5579,   872,  3121,
    3137,   216,  3138,  1789,  2767, -5579,  3144,   267, -5579,  3145,
     278, -5579,  3146,  3015, -5579, 33110, -5579,  2899, -5579,  1006,
    1989,  1217,  1887, -5579, 85618,  1887, 85618,  1887, 85618,  1887,
   85618,  1887, 85618, 85618, 85618,  1887, -5579, -5579, -5579, 85618,
    2804, 85618, -5579, 85618, -5579, -5579, -5579, 73190, 62674, 73668,
   -5579, 85618, -5579,   378,  1099, -5579, -5579, -5579,   -33, -5579,
    2151, -5579,109448,  3270, 62674,  2523,  2014, -5579, 85618, 85618,
   -5579, -5579, -5579,  3077, 85618,  3147,  3148, 73190, 62674, -5579,
   98524, -5579, 66020,  3026,  2815, -5579, -5579, -5579, -5579, -5579,
    1932,  3311,   284,  3312, 33110,  2820,   284,   284,  2821,  3157,
   -5579, -5579, -5579,   273,  2822,  2825, -5579,   240,   240, -5579,
    2826,  2828, -5579,   277,  2832,  2833,  3325,  3340,   281,  2848,
    2854,  2855,  2395,   284,  2856, 33110, -5579,  2858,   240,  2859,
    2860,  2861,  3344,  2863, -5579,  3359,  2866,   304,   314,  2867,
    2868, -5579,  3092, -5579,   285,  2870,  2874,  2878,  2881,  2884,
    2887,  2888,  2890, 33110, 33110, 33110, -5579, 28165,  1958,  1099,
   -5579, -5579, -5579, -5579, -5579, -5579, -5579, -5579,   288, 49195,
   -5579,  2932, -5579, -5579,  3096, -5579, -5579, 33110, -5579, -5579,
     125, -5579,   289, -5579, -5579, -5579,  1958,  3180,  2892, -5579,
   -5579,  1778,  2895, -5579,  2008, -5579, -5579, -5579, -5579, -5579,
   -5579, 65542,  3364, -5579,   306,  1099,   258,  1992,  3301, 55504,
   55982, -5579, -5579,  3171, -5579, 85618, -5579, -5579,  1958,   179,
    2028, -5579,  2045, 17231,  2034,  2290, 85618, 85618,  3367, -5579,
    2907, -5579, -5579, 33110, -5579, -5579, -5579,  2488, -5579,  2362,
    2362, -5579, -5579,  3370,  2994,  3000,  2488, -5579,  2488, -5579,
    2914,  2917,  2488,  3001,  3002,  3003, -5579,  2920,  3006,  2488,
   -5579, -5579, 58372,  2073, -5579,  3250,   342, -5579, -5579, -5579,
    2053, -5579,  2921, -5579,  2334, -5579, -5579,  1372,  1372, 33110,
    1372,   858,  1867, 31134, 33604,  3258,  3153,  1449,  1635,  3260,
   -5579,  3150,  1691,  1714, 77492, 85618, 77492, 99002,  3052, 33110,
   -5579,  3363,  3017,  3020,  3076, 54572, -5579,  3028,  2991,  3030,
    3089,  2953,  3031,  3036,  3095, -5579,  3226, -5579, -5579,  3044,
    3117,  3386,  3050, 99480, -5579, -5579,  1396, -5579, -5579, -5579,
    1396, -5579,  2977,  1273,   430,   974,  3053,   452,   941,  3379,
   -5579,  1361, -5579, -5579,  3108, -5579,  3477, 85618,  3319,  5344,
    3189,   302,  3106, -5579, -5579, -5579,  3247,  3066, 85618,  3067,
    3210,   302,  1205, 99958, -5579, -5579, 85618, -5579, -5579, -5579,
   -5579,  7007,  3361, 27237, -5579,  1951,  3071,  3057,  3081, 85618,
   69366,   365,  3183,  3206,  1558,   369,   791,  3141, 85618,  1918,
    3212, 85618,  3004,  3084,  3093,  3313,  3008,   660,  3416,  3007,
   -5579, -5579, -5579,  3381, -5579,  1953,  2304,  3209, -5579,  3317,
    3362,  8584,  3073,  3075,108056, -5579,  3100,    26, 51670, 85618,
   85618,  3102,  3104,100436,  7007,  3392, 72234, 72234,  3110,  3112,
   45310,  3410,  1863,  3114, -5579, -5579, -5579,  1863,  3115,  3120,
  100914,  7007,  3397, 85618,  3122,  3129, 85618,111304,   302, -5579,
    3468,   302,   302,  1892,  3470,  3132,   321,  3285,   706,   635,
    3007,  3295, -5579,  3133,  3135,   319, -5579,  3254, 85618,  3140,
    3152,    65,  3221,  1099, -5579,  3224, -5579,  3159,  3227,  3176,
     699,  2729, -5579, -5579,  3155, 77492,  3251,  3257,  1918,   225,
     797,  3007, -5579,  3178,  3185,  3008,  3008, 85618, 85618, 85618,
   85618, 85618,   210,  3515,  3519,  3190,   175,  1039,  3062, -5579,
    1863, 61240,  3191, -5579,  1863, 85618,   206,   977,  3007,  1767,
    1956, -5579, -5579, -5579,  1565, -5579, 33110, 33110, 33110,  3064,
   -5579,  2519, 17231,   665, -5579,   290,  8339,  3068, -5579, -5579,
   -5579, -5579, -5579, -5579, -5579, -5579, -5579, -5579, -5579, -5579,
   -5579, -5579, -5579, -5579, -5579, -5579, -5579, -5579, -5579, -5579,
   -5579, -5579, -5579, -5579, -5579, -5579, -5579, -5579, -5579, -5579,
   -5579, -5579, -5579, -5579, -5579, -5579, -5579, -5579, -5579, -5579,
   -5579, -5579, -5579, -5579, -5579, -5579, -5579, -5579, -5579, -5579,
   -5579, -5579, -5579, -5579, -5579, -5579, -5579, -5579, -5579, -5579,
   -5579, -5579, -5579, -5579, -5579, -5579, -5579, -5579, -5579, -5579,
   -5579, -5579, -5579, -5579, -5579, -5579, -5579, -5579, -5579, -5579,
   -5579, -5579, -5579, -5579, 85618, 65064, -5579, -5579, -5579, -5579,
   -5579, -5579, -5579, 85618, -5579, 85618,  3355,109448,  3357,  3318,
    3385,  3387,   302, 85618, 85618,  3388,  3391,  3394,109448,  3396,
    3398,  3401,  3334,  3204,   166,  3195,  3142,  3586,  3473, 85618,
   58372, -5579,  1396, -5579,109448,  3341,  3475, -5579, 85618,  3360,
      43, -5579,  3512,  3194, -5579, -5579,    75, 85618, 72712,  2729,
   -5579, -5579,  3479, 62674,   954,  3483,  1099,  3192,  3485,  3353,
    1099, 62674,  3407, 85618, 85618, 85618, 85618,   169, -5579, 61240,
    3377, -5579, 85618,  3378,  3295,  3383,  3604,    89,  2040,101392,
    3489,101870,  3160, 85618,  3165,  3165,  3613,109448,  1485,  3433,
   -5579, -5579,  2200, -5579,  3293, -5579, 66498, -5579, -5579, 66498,
   -5579, -5579,109448, 85618,  3166,109448,109448, -5579, -5579, 66498,
   66498, -5579, 62674, 62674,  3506,   267,  3516,  3229,  3521,  3231,
   51670, 51670, -5579,   301, 66498, -5579, 62674, 66498, -5579, 85618,
   -5579, 85618, -5579, -5579, -5579, -5579,109448,109448, -5579, 62674,
   61240,  3522, 85618, 85618, -5579, 85618, 85618, -5579, 85618, 85618,
    2055,102348,  1217, -5579, 85618, -5579, 85618, -5579, 85618, -5579,
   85618, -5579, 85618, -5579, -5579, -5579, 85618, -5579, 85618,  2057,
   -5579, -5579,  2061,  1331, 85618, 85618,   228, 66498, 85618,  3399,
   85618, 66498, 66498, 85618, 85618, 85618, 85618, 85618,  3259,  2895,
    1334, -5579,   924,   803, 77492,  3403, -5579, -5579,  2067,    32,
     925, 85618,   953, -5579, -5579, -5579, -5579, 73668, 71756,  3508,
     338, 85618, -5579, -5579,  9321, 33110,  1958, 30141, -5579, -5579,
   17231,  3228, 33110, 33110,  3181,  2488,  2488, -5579,  1003, 33110,
   33110, 33110,  2488,  2488, 33110,  8990, 33110, 51670, 33110, 38544,
   25271, 33110, 33110, 28659,  1487,  2826, 33110,  3427, 39526, 33110,
    1992,  3431, 33110,  1992,  8990,  3675,  3675,  2591,  4812,  3193,
    1958, -5579,  2488,  1052, -5579,   449,109448, 33110, 33110, 33110,
   -5579, -5579, -5579, -5579, -5579, -5579, -5579, -5579, -5579, -5579,
   -5579, -5579, -5579, -5579, 33110, -5579, 58372, -5579, -5579, -5579,
   -5579, -5579, -5579,  3275, -5579, -5579, -5579, -5579, -5579, -5579,
    3158, -5579, -5579, -5579, -5579, -5579, -5579, -5579, -5579, -5579,
   -5579, -5579, -5579, -5579, -5579, -5579, -5579, -5579, -5579, -5579,
   -5579, -5579, -5579, -5579, 85618, -5579, -5579, -5579, -5579, -5579,
   -5579, -5579, -5579, -5579, -5579, -5579, -5579, -5579, -5579, -5579,
   -5579, -5579, -5579, -5579, -5579, -5579, -5579, -5579, -5579, -5579,
   -5579, -5579, -5579, -5579, -5579, -5579, -5579, -5579, -5579, -5579,
   -5579, -5579, -5579, -5579, -5579, -5579, -5579, -5579, -5579, -5579,
   -5579, -5579, -5579, -5579, -5579, -5579, -5579, -5579, -5579, -5579,
   -5579, -5579, -5579, -5579, -5579, -5579, -5579, -5579, -5579, -5579,
   -5579, -5579, -5579, -5579, -5579, -5579, -5579, -5579, -5579, -5579,
   -5579, -5579, -5579, -5579, -5579, -5579, -5579, -5579, -5579, -5579,
   -5579, -5579, -5579, -5579, -5579, -5579, -5579, -5579, -5579, -5579,
   -5579, -5579, -5579, -5579, -5579, -5579, -5579, 29153, -5579, -5579,
   -5579, -5579,  3198, -5579, -5579, -5579, -5579, -5579, -5579, -5579,
   -5579, -5579, -5579, -5579, -5579, -5579, -5579, -5579, -5579, -5579,
   -5579, -5579,  3466, -5579, -5579, -5579, -5579, -5579, -5579, -5579,
   -5579, -5579, -5579, -5579, -5579, -5579, -5579, 29647, -5579, -5579,
   -5579, -5579, -5579, -5579, -5579, -5579, -5579, -5579, -5579, -5579,
   -5579, -5579, -5579, -5579, -5579, -5579, -5579, -5579, -5579, -5579,
   -5579, -5579, -5579, -5579, -5579, -5579, -5579, -5579, -5579, -5579,
   -5579, -5579, -5579, -5579, -5579, -5579, -5579, -5579, -5579, -5579,
   -5579, -5579, -5579, -5579, -5579, -5579, -5579,  3199, -5579, -5579,
   33110, -5579, -5579, -5579, -5579, -5579, -5579, -5579, -5579, -5579,
   -5579, -5579, -5579, -5579, -5579, -5579, -5579, -5579, -5579, -5579,
   -5579, -5579, -5579, -5579, -5579, -5579, -5579, -5579, -5579, -5579,
   -5579, -5579, -5579, -5579, -5579, -5579, -5579, -5579, -5579, -5579,
   -5579, -5579, -5579, -5579, -5579, -5579, -5579, -5579, -5579, -5579,
   -5579, -5579, -5579, -5579, -5579, -5579, -5579, -5579, -5579, -5579,
   -5579, -5579, -5579, -5579, -5579, -5579, -5579, -5579, -5579, -5579,
   -5579, -5579, -5579, -5579, -5579, -5579, -5579, -5579, -5579, -5579,
   -5579, -5579, -5579,  3276, -5579, -5579, -5579, -5579, -5579, -5579,
   -5579, -5579, -5579, -5579, -5579, -5579, -5579, -5579, -5579, -5579,
   -5579, -5579, -5579, -5579, -5579, -5579, -5579, -5579, -5579, -5579,
   -5579, -5579, -5579, -5579, -5579, -5579, -5579, -5579, -5579, -5579,
   -5579, -5579, -5579, -5579, -5579, -5579, -5579, -5579, -5579, -5579,
   -5579, -5579, -5579, -5579, -5579, -5579, -5579, -5579, -5579, -5579,
   -5579, -5579, -5579, -5579, -5579, -5579, -5579, -5579, -5579, -5579,
   -5579, -5579, -5579, -5579, -5579, -5579, -5579, -5579, -5579, -5579,
   -5579, -5579, -5579, -5579, -5579, -5579, -5579, -5579, -5579, -5579,
   -5579, -5579, -5579, -5579,   880, 33110, 33110, 33110, 33110, 33110,
   33110, 33110, 33110, 33110, -5579, 33110,   479, -5579, -5579,  3511,
    3532,    38,   481, 82272, 30640,  3250, 24271, -5579,   252,  3250,
   -5579, -5579, -5579, 85618,  3364, -5579, -5579,  3277, -5579, -5579,
   -5579, -5579, -5579,   291, -5579, -5579, -5579, -5579, -5579, -5579,
   -5579,  3196, -5579, -5579, -5579, -5579,  3196, -5579,  3201,  3518,
    3520,   845, 85618,  2552, 33110,  3275,   279, 85618, 33110,  3198,
    3466, 33110,  3199, 33110,  3276, -5579, 33110, -5579,  2078,  1930,
   33110,  2108,  3202, -5579, -5579,  3211,  2917,  3215,  3225,  3213,
    3216,  2488,   205,  3217,  1103,   142,  3345,  2488,  3454,  3218,
   -5579, 58372, -5579, 41454,  3256, -5579, -5579, -5579,  1045, 85618,
   85618, -5579,  3497, -5579,  3223, -5579, 11083,  3497, -5579, -5579,
   39035,  3335,  3500,  3436, -5579, -5579, -5579,  3230, 17231, 34098,
   34098, -5579,  2279, 17231,  2372, -5579, -5579, -5579, -5579, -5579,
   -5579,  1274, -5579, 85618,   123,  3258,  1635,  3297,   761,  3689,
    3299, 85618, -5579, 46756,  2109, -5579, 62674, 85618, 85618,  3448,
   -5579,  3686, -5579,111304, -5579,  3243, -5579,110840,106650, -5579,
   -5579,    51, -5579,  1101, 62674, -5579, 85618, 85618, 62674, 85618,
   85618, -5579, 62674,  3294, 85618, 85618, -5579, -5579, -5579, -5579,
   -5579, 56938,  1254, 71756,  3384, 70800, -5579, -5579,  3248, 85618,
    3307,  3528,  3529,   753, -5579, -5579,102826, -5579,  3481, 62674,
   85618, 85618, 33110,  3482, 85618, 85618, -5579,   549,  3336,  3338,
   -5579, 85618,  3342, 66498,  3261,109448, 66498, 52165, 66498, 66498,
    3593,109448, 85618, 85618,  1455, 77492,   221,   998,  3007,  3487,
   -5579,  1557, -5579, 62674, -5579, 85618,  3480, -5579, -5579, -5579,
   82750,  3714,  3389, -5579, -5579, -5579,103304, -5579, -5579,  3486,
   -5579,  2113, -5579, 62674, 62674, 85618,  9117,103782,  1032,  3502,
   -5579, -5579,109448, -5579, 85618, 83228, 85618, 85618,  3543, 85618,
   74624,104260,104738,   914,  1311,  3545, 85618, 75102,  3546, -5579,
    3421, 85618, -5579, -5579, 58850, 62674, 85618,   835, 58372, -5579,
    3533, -5579, 85618, -5579,   297, -5579, 85618,  7745,  3496, -5579,
   -5579,  3368,  3376, 85618,   269,  1028,  3007,  3661, 85618, 85618,
    3283,  2114, 62674, 85618, 58372, -5579,  3503,    79, 62674, 85618,
   82750, -5579,  3504,  3393, -5579, 77492, -5579,  3298,  2040,  2261,
    1972,  3298, 62674, 85618, -5579,  3298, 85618, 95178, -5579, 62674,
    1135, -5579, 62674, 85618, 82750, -5579,  3523,  3456, 62674, 85618,
   11682, -5579, -5579, -5579,   302, -5579, -5579, -5579, -5579, -5579,
   85618, 85618,   302, 85618, 85618,   302,  1035, -5579, 62674, 85618,
   -5579, -5579, -5579,  3429, 62674, 85618, 85618,   317, 85618, -5579,
   85618, 62674,  3346, 85618, 85618, -5579, -5579, 85618,  6048, 85618,
   85618, 85618, 85618, 85618, 85618, 62674, 85618, -5579, -5579,  1425,
    1412,  1917,  1929,  1388, 85618,  3617, 85618,105216, 62674, 85618,
   85618,  1099, 85618, 58372,  1768, -5579, -5579,  3435, -5579, 62674,
    1135, -5579,  9759, 85618, 85618, 85618,  3395,  3400,   209,  3484,
   -5579, -5579, -5579,   725,   725,  3524, -5579, 33110, 33110, 31628,
    3308, -5579, -5579, 33110,  2773, -5579, -5579, -5579,   330,  3774,
     330,105694,   330,   330,  3595,  3374,  3380,   330,   330,   330,
    3594,   330,   330,   330, 85618,  3493, -5579, -5579,  3493,   889,
   33110,109448, 85618, -5579,  2123, -5579,  3329, -5579, -5579, 58372,
   85618,   203,   829,  3669,  3547, 69844,  2561,  3659, 85618,  3382,
   85618,  3790,  3423,  1732, -5579,  2561, 85618, -5579,  2025, 71756,
   -5579, -5579, -5579, -5579, -5579, -5579, -5579, 85618, -5579, -5579,
    3663, 85618, 41936,  3509, -5579,  1099,  2729,  2729,  2729,  2729,
    3332,  2729, 85618,  3457,  3688,  2561,  3343,  3690, -5579,  3295,
    3692,  1817, 85618,  3561, 69844,  3408,  3402,  3577,  3814,  2040,
    1099,  3581,  3567, -5579, 55038, -5579,  2729,  3828, 27701,  6216,
    8208,  3569,  3632, -5579, -5579,  3576,   979, 85618,  3671,  3672,
    3693, -5579,   201, -5579,  3824,  1612,  3695,   216, -5579,   220,
   -5579,  2767, -5579, 85618, -5579, 85618, 85618, 85618, 85618,   239,
   -5579, -5579,   220,  2767,   220,   845, -5579,  3640,   216,  2767,
    3495,  3703,   267, -5579,   278, -5579,  3589,   845, -5579,  3601,
    2040, -5579, -5579, -5579, -5579, -5579, -5579, -5579,  2130, -5579,
   85618, -5579,  3681,  3683,  3684,  3685,  3687,  3390,  3405,  3422,
   85618,  3406,  3390,   302,  3409,  3404, -5579,  3406,  3406,  3390,
    2895,  2895,  3390,  3405, 61718,  3862,  3709, -5579,  3476,  3411,
    3720,   176, -5579,   196,   703,  3641, -5579, -5579, -5579, -5579,
  109448, -5579, 62674,  3438,  2523,  2523,   192,  3610,  3412, 61718,
    3841,   845, -5579, 66498, 85618,109448, 66498,  3620, 66498, 66498,
  109448, 85618, 85618,  2142, -5579,   -60, -5579,  1350, 33110,   168,
   -5579, 13129,  2144, 33110,  3413,  3417, -5579, -5579, -5579, -5579,
   -5579, -5579, -5579,  3418,  3730, -5579,  2153,  2164,  2165,  3419,
    3420,  6129,  6210,  3425, 13501,  3426,  3430,  3432,  3424, 38544,
   38544, 28165,  1444, -5579, 38544,  3434,  3605,  2166, 12541,  3437,
    3439, 13877, 32122, 33110, 32122, 32122, 14014,  3428,  3440, -5579,
    3772, -5579,  2170, 58372,  3615, 14068,  2175, -5579, 33110, 58372,
    6262, 33110, -5579, 33110,  3442, -5579, -5579,  5024,  5024,  5024,
    8990, -5579,  3444, -5579, 38544, 38544, -5579,  1435, 28165, -5579,
   -5579,  3741, -5579, -5579, -5579, -5579, -5579, -5579, -5579,  3005,
   -5579, -5579, -5579,  3648,  2580, 51670,  7163, 33110,   311, 33110,
    3198, 33110,  3530,  5024,  5024,  5024,   490,   490,   229,   229,
     229,  2128,   481, -5579, -5579, -5579,  3445,  3449,  3450,  3631,
    3474, 33110, -5579,  2285,  2332, 85618,  1375,  3970,  4020, -5579,
   -5579, -5579,  3256,   665,  3256, -5579,  1565,  2488,  1052, 56460,
   -5579, -5579, -5579, -5579, -5579, -5579, 85618, 17231, -5579, -5579,
    3691,  3491,  2177, -5579, -5579,  2488, -5579, -5579,  1248,  1248,
    3458, -5579,  3469, -5579, -5579, -5579, -5579, -5579, -5579, -5579,
    3447, -5579, -5579, -5579, 42418,  3765,  3492, 40972, 83706,  3471,
    2699, -5579, 83706, 84184, 83706, -5579,  3488, -5579,  1958, 33110,
    3759, -5579, -5579, -5579, 33110, -5579, -5579,   590,  3498,   908,
     869,  2373,  2373,  2279,   923, -5579, -5579,  3539, -5579, 33110,
    2502, -5579,  2621, -5579, -5579, -5579, -5579,  2895, -5579,  3739,
   -5579, -5579, -5579, 41454,  3526,  3538,  1417, 45792,  3700, -5579,
   85618, 41454, -5579, 85618,   318, -5579,  3499, -5579, -5579, -5579,
   -5579, -5579, -5579,106650,  1969, -5579,110840, -5579,110840, -5579,
    1969,  3930, -5579,106650,  1838, -5579, -5579, -5579, -5579, -5579,
   -5579, -5579, -5579, -5579, -5579, -5579, -5579, -5579, 62674, 62674,
    3708, 85618,  3706,  3710, 33110,   266, 85618,  3507,  3514,  1330,
    3797,  3525, -5579,  3845,   845, -5579, -5579,  3583, -5579, 17231,
   -5579, -5579, -5579, -5579, -5579, 62674, 85618, -5579, 66020, -5579,
   -5579,109448, -5579, -5579, 85618, 85618, -5579, -5579, -5579,109448,
   -5579, -5579, -5579, 85618,   804,  3584,  3588, 85618, -5579,  1072,
    3254, 10014, 85618, 85618, 85618,  3795, -5579, -5579, -5579, -5579,
    3731, -5579,  3853, -5579,106650, -5579,  2767,  1406,  3599,  3007,
    3748, -5579,  3857,  3927, -5579,  3649,   691, -5579, -5579,  3656,
   -5579, -5579, -5579, -5579,  3874,   845,  3875,   845, 85618, 85618,
   85618, 85618,  3662, -5579, -5579, -5579, -5579,  3664,  3801, -5579,
   58372, 58372, 58372,  2208, -5579, -5579,  1099, -5579, -5579, -5579,
   -5579, -5579, -5579,  3834, -5579,  2213, -5579,  1469, 85618, -5579,
   -5579, -5579, -5579, -5579,  3883, 62674, 85618, 10375, 85618, 85618,
   85618,  3754,  1961,  1491,109448, -5579,108520, -5579, -5579,  2214,
   -5579,  3550, 85618,  3625, 62674,  3602, -5579, -5579, -5579,  3888,
    3849,  2040, 72234,  3591,  3591,  1975, -5579, -5579, -5579, -5579,
   -5579,  3812,  3740, -5579,   963,  3742, 62674,  3612, -5579, -5579,
   -5579, -5579,  3896,  3636, -5579, -5579,  3637,  1038,  3007,  3295,
   -5579, -5579, -5579, -5579, -5579, -5579, -5579, -5579, -5579,  3665,
   -5579, -5579, -5579, -5579,  1736,  1736, -5579, -5579, -5579,  1736,
    1550,   312,  1087,  3007, -5579,  1655,  1442,  3638, -5579,  3642,
   -5579, -5579, -5579,  3817,  3818,  3819,  3647,  3653,  3702,  3654,
    3657,  3713, -5579,  3666,  3715,  3667,  3716,  3668,  3940,   845,
  109448,  3802,  1099,  3704,  3929,   845, -5579,  3670, -5579,  3677,
   -5579,  2222,  4040, -5579, 85618, -5579,   329,  1089,  3007, -5579,
    3679, -5579, 62674, 85618, -5579, -5579, -5579, 33110,  3587,  3590,
    3596, 17231, 17231, 33110, -5579, -5579, 17231,  3597, -5579, -5579,
   -5579, -5579,109448, -5579, 85618,  3870, -5579, -5579,   330, 85618,
   85618, -5579, -5579, -5579, 85618, -5579, -5579, -5579,  3881, -5579,
     456,   456, -5579, -5579,  3918,  6639,  3603,   147, -5579, 58372,
   48205,  2011,   420,   635, -5579, 66020, 85618, 66020, -5579,   829,
    3813, 85618, 85618, 85618,  3606,  3607, -5579, -5579, -5579, -5579,
   62674,  1243, 62674,  2488, -5579, -5579,  3682, -5579, 85618,  2040,
    4103,  3943,   723, -5579,  4064,  3188,   954,  1812,   212,  2816,
    4002,  2334, 33110,   325, -5579, -5579,  1958, 85618,  3402, -5579,
   -5579, -5579, -5579,  1099, -5579,  3618,  3609, -5579, 85618,  3948,
   85618, 85618, 85618, 85618,  3438,  3621, 85618,  3622,109448, 85618,
    2289,  3008,  4082,  3972,    32,  3408,  3711,  3973, 77492,  3639,
    2223, -5579, -5579,   979, -5579,  2228,   144, -5579,  1099, 66020,
  107592,  3956, -5579,   561,  8208, -5579, -5579,   561,   794, 85618,
   -5579, -5579, -5579, -5579,  3848,  1997, -5579,  3949, -5579, -5579,
      32, -5579,109448,  3633, -5579,  2240, -5579, -5579, -5579,   267,
    3694,   845,  3712,   845, -5579, -5579, -5579, -5579, 85618, -5579,
   85618, 61240, -5579, -5579, 85618, -5579,  3979, -5579, -5579,  3773,
    3778,  3780,  3781,  3782, 85618,  3390, -5579,  3645, 85618, 85618,
   62674,  1775, -5579, -5579,  3858, -5579, -5579, 77492,  3779, -5579,
   -5579, -5579, -5579,  4003,  4005, -5579, -5579, -5579,   268, -5579,
   85618, 85618, 62674, 73190,   352, 62674, -5579,  3939,  3941,  3944,
    3946,   302,  3947,  3951,  3952,  3953,  3954, -5579, -5579, -5579,
    3674, 14256, 33110, -5579,  4014,109448, -5579,  7012, -5579, -5579,
   -5579, 33110, -5579, -5579, -5579, -5579, -5579, -5579,  2258, 33110,
   -5579, 33110, -5579, -5579, 25771,  4148,  4148,  3673,109448, 38544,
   38544, 38544, 38544,  1341,  2859, 38544, 38544, 38544, 38544, 38544,
   38544, 38544, 38544, 38544, 38544,   498, -5579,  3868, 33110, 33110,
   32616, -5579, -5579,109448,  3680,  3428,  3701,  3705, 33110, -5579,
   -5579, -5579,  2254, 40008,  3717, 58372, -5579, 33110, 12938,  2262,
    3723, 14597,  1958,  7073,  1099, 33110,  1154,  1830, 33110,  2268,
   33110,  3995, -5579, -5579, -5579, -5579, -5579, -5579,  3907, -5579,
   33110,  3718,  2985, 38544, 38544,  4844, -5579,  5360, 33110, 28165,
   -5579,  3524,  3722, 47238, -5579, 26271,  3678,   707,   707,   707,
     707, -5579, 85618, 85618, 85618,  3759,  3719,  3759,   258,  3721,
   -5579, -5579, -5579, -5579,    32, -5579,  3696, -5579, -5579, -5579,
   -5579, -5579, 83706, 84184, 83706,  3707, 40490, 26754,  2699,  3724,
   85618, -5579, -5579,  3728, 41454,  3964,  3890, -5579, 41454,  3890,
    1681,  3890,  3967,  3784, 47720, -5579, -5579,  3729, -5579,  3900,
   -5579,  1951, 17231,  4131,  4009, -5579,  3732, -5579,  3498,  1585,
   -5579, -5579, -5579,  1139, -5579,  3783, -5579, -5579, -5579,  3471,
   34592,  3856, -5579, -5579, -5579,  3749,  2272, -5579, -5579,  4122,
    3856, -5579,  3061, -5579,  2276, 46756,  3526, 33110,  1958,  2278,
    1994, -5579, -5579,106650, -5579,  3786,  2767,  2767,  1772,  3390,
    4047,  1772,  7561, -5579, -5579, 42900, 85618, 85618, -5579, 85618,
   85618,  1348, 85618, -5579, 85618, -5579, -5579, -5579,  4178,  3791,
    3794,  3998, -5579,  2423, -5579, -5579, 62674, 85618, -5579, -5579,
   -5579,   385,  1095,  3007, -5579,  3807, -5579, -5579,  4017, 85618,
   -5579,  4173,  3829, 85618,  4085, 85618, 84662, -5579,  3813,  1348,
    3854,  4065,  1346,  3008,   321,  7281, -5579,    85, -5579, -5579,
    3821, -5579, 85618, -5579, 85618, -5579, -5579, -5579, -5579, -5579,
   -5579, -5579,  3872, -5579, -5579, -5579, -5579, 58850, -5579, -5579,
   85618, -5579, 58372, 48205, 58372, -5579, 85618, -5579,  1597,   404,
    1117,  3007, -5579,  3832, -5579,  4095,  3835,  3838,  3894,   827,
    1495,  3842,  3843,  3895,  3761,  3762,  3763, -5579, 58372, 48700,
    3919, 85618,  2767,  3766,  3808, 85618,  3906,  3591, -5579,  3769,
   -5579, -5579,  3591,   317,  1099, -5579, -5579,  1099,  2767,  1099,
   85618, 85618, 85618, 85618,   317, -5579, -5579, -5579,  4213,  3864,
   85618, 85618, 85618, 85618, -5579,  3827, -5579, -5579, -5579, 85618,
   85618,  4108,   956,  2191, 62674, 85618, 85618, 62674, 85618, 85618,
   85618, 85618, 85618, 85618, 85618,  3990, -5579,  4200,  4125,  2340,
    4168,  3855, 85618, -5579, 85618,  1099, -5579,  3254, 85618, 85618,
   85618, 85618, -5579, -5579, -5579, -5579, -5579,  3524, -5579,  3785,
    4062,   330, -5579,  4063,  4066,  4067,   330, -5579, -5579,   635,
   -5579,   375, 85618, -5579,  2328, 85618, -5579, -5579, -5579,  3732,
    1953,  2304, -5579, -5579, -5579, -5579, -5579, -5579,  3789, 85618,
   85618, 38544, -5579,  1919,  1874,   272, -5579,  4070, 85618,  3092,
   -5579, -5579, -5579,   960, 85618, -5579, -5579, -5579, -5579,  3792,
   -5579,    59,  3621, -5579,  4083, 69844,  2767, 62674, 62674,  2767,
   -5579,109448,  3796,  3402, -5579,   591,  3879, -5579, 62674,   954,
  106172,  3192,  3836,  4012,  7688, 41454, 41936,  1736, -5579,  3799,
    3800, -5579, -5579, 85618,  3813, 61240,  2282,  3295,  4262,   796,
    1991, -5579, 71278,  3997,  3621,  4083, -5579,  3008,  4024,  4025,
   -5579,    32, 85618,  3438,  3402,  1099, 85618,  3307, 48205, -5579,
    4307,  2146, -5579,106650, 33110, 33110, -5579,  3809, -5579,  3815,
    8208, -5579,  3886,  3810,  4274, 33110, -5579, -5579, -5579, -5579,
   -5579, -5579, -5579, -5579,  3901,  3820, 85618, 85618,   979, 85618,
   -5579,  3831,  3695, -5579,  3695, -5579, 85618, -5579, 85618, -5579,
     845, -5579,  3950,   845, 85618, 85618, 85618, 85618, 85618, 85618,
    3390,   302,  3404, -5579, -5579,  4152, 61718,  3709, -5579,  2287,
   85618, -5579, -5579, -5579,  4215, -5579, -5579,   338,  4159,   845,
   -5579,   994,   994,   994,   994,  4117,   994,   994,   994,   994,
     994, -5579, 33110, 17231, -5579,  3837, -5579, 17231,  3839,  8196,
   14721, -5579,  2299, 33110, -5579,   552,   552,   552,  2494,  4164,
   -5579,  2694,   552,   552,   552,   403,   403,   223,   223,   223,
    4148,   498, 14881, 15148, 16234,  3844, -5579, -5579, -5579,  3428,
   -5579, 35086,    78,  4285, 39526, -5579, -5579, -5579,  3887,  3891,
    3846, -5579, 33110, 35580,  3851,111304,  4046, -5579,   390, 33110,
   33110,  3300, -5579, 15604, 33110, -5579,  3300,   502, 33110,  2352,
    2589, 33110, 33110,  5383,  8530,  3852, 33110,107114, -5579, -5579,
   -5579,  2301, 33110, 85618, 85618, 85618, 85618, -5579, -5579, -5579,
    4009,  1099,  4009,  1099,  3860, -5579, -5579, -5579, -5579, 59328,
    3859,  3615, 83706,  3863, 85618,  2699, 41454, -5579, -5579,  2367,
   -5579, 41454,  4129, -5579, 41454, 66498, -5579, 85618,  3865, 85618,
   -5579,  1046, 33110,  3898, 51670, -5579, -5579, -5579, -5579,  3945,
   -5579,  4077, 17231, 30640, -5579,    32,  2727, 85618,  1958,    58,
   -5579, 33110,  3876, 85618, -5579,  3856, 17231, -5579,  3936,  2312,
   -5579, -5579, -5579, -5579, -5579, -5579, -5579,  3957, 71756,  4193,
   -5579, 33110,  2317, -5579,  3908,  4292,   180,  2319,  2326,  1348,
   -5579,  2331, -5579,  1970,  4169,   431, -5579,   845, -5579,109448,
   85618, 85618, 85618,  2953, -5579, -5579, 85618, 85618, 85618, 85618,
   -5579, -5579, 62674, 85618, -5579, 85618, -5579, -5579, -5579, -5579,
     317,  1919,  4186,  4187,  4104, -5579,   302, -5579,  1919,  4107,
     317, 85618, -5579, -5579, -5579,  2201, -5579,109448,   845,   845,
   -5579, -5579, -5579, -5579, -5579,  3893, -5579,  4321,  3978, 85618,
   85618, 85618, 85618, 85618, 62674, 85618, 85618,  2488,  2488,109448,
    3882, -5579,  2488,  2488,  3884, -5579, 62674, 85618, 85618, -5579,
   -5579, -5579, -5579, -5579, -5579, -5579, -5579, -5579, -5579, -5579,
    3971, -5579, 33110,  4319, -5579, -5579, 85140, -5579, 33110, -5579,
   -5579, -5579, -5579, -5579, -5579, -5579, -5579, -5579, -5579, 62674,
   85618,  3974, -5579,  3976, -5579,   807, -5579, -5579, 85618, 85618,
   85618, 85618,  4241, -5579, -5579, -5579, -5579, -5579, -5579, -5579,
   -5579, -5579, -5579, -5579,  4240, 85618, -5579, -5579,  1099,  1099,
  109448,   845,   845, -5579, -5579, -5579,  3980, -5579, -5579,  3902,
    4188,   330, -5579,   330,   330,   330, -5579,  3904, -5579,   635,
    4282, -5579,  1348,  1974,  4236, -5579, 33110, -5579,  1878,  2494,
   -5579,  4293,  4375, -5579, -5579, -5579, -5579,  3346,  2040,  3346,
   -5579, -5579, 66498,   360, -5579,  4219,   203, 58372,  4137, 69844,
    1655,  1665,  3920,  4050, -5579,  2767,  2767,  3985, 85618,  4391,
   -5579, -5579, -5579, -5579, -5579, -5579, 62674,  3602, -5579,  4160,
     966,  4264, 85618, 41936, -5579,  3471, -5579, -5579, -5579,  1099,
   -5579, -5579,  4061,  3402, -5579,  1941, 85618,  4154, 69844,  3438,
    2348, -5579, -5579, -5579,  3981,  4378,  3408, -5579,  1655,  3997,
   -5579, -5579,  4360,  4037,  3986,  4413, -5579,  4037,  4280,  4170,
    3958, -5579,  3639, -5579, 85618, -5579, 17231, 17231,  1099,111768,
     561,109448,  4288, -5579, 17231, 85618,   843,  3955,  4120, -5579,
    4253,   845,  2354, -5579,   845,   845, -5579, 85618, -5579,  3390,
    3390,  3390,  3390,  3390, -5579,  4172, -5579, -5579, -5579,  4247,
   -5579,   845, 61718, -5579, -5579, -5579, -5579, -5579, -5579, -5579,
     994, -5579, -5579, -5579, -5579, -5579, 17231, -5579, -5579, -5579,
   33110, -5579,  8722, 38544,  4294, -5579, 33110, 33110, 33110, -5579,
    3963,  2355,  2380, -5579, -5579,    78, -5579,  4285, -5579, -5579,
   -5579,  9047,  4019, 17231,  4078,  3966,  3968,  3300,  3300, 15604,
    3300, 33110, 33110,  3300,  3300, 33110, -5579, -5579,  9421,  4171,
   -5579, -5579,  9852, -5579, -5579, -5579, -5579,  3898, -5579,  3898,
   -5579,  4105, -5579,  2386,  4439, 37556,  4401, -5579, 85618,  2391,
   -5579, 33110,  3982, -5579, -5579, 41454,  2367,  3983,  2393, 85618,
    2397,109448, 36074, 17231, 85618,  3524,  3984, -5579, 85618,  2892,
   -5579,  1417, -5579, -5579,  4392, 42900,  4351, 16387, 33110, -5579,
   -5579, -5579, -5579, 61718,  4201, 61718,  1348, 10177,  4291, 42900,
   52660, 85618, -5579, 85618, -5579,  4153,  4291,  4291, -5579, -5579,
   -5579, -5579, -5579, -5579,  3989, -5579, -5579, -5579, -5579,  4075,
   -5579, -5579,   887,  3403, -5579,  2011, -5579,  4456,  4341,  4342,
   -5579, -5579, -5579, -5579, -5579, -5579,  4200, -5579, -5579, 48205,
   62674, 85618, -5579,  4079, -5579, -5579, -5579, -5579, -5579, -5579,
   44828, 51670, -5579,   827,  3999,  4000,  1495, -5579, -5579, -5579,
   85618, 10404,  4001, -5579, -5579, 10933,  1245,  3403, 85618, 85618,
    4004,  4010,  4011,   -29,  1399,  1915,  3390,  4332, 85618, -5579,
   -5579, -5579,  4200, -5579, -5579, 85618, -5579,   330, -5579, -5579,
   -5579, -5579, 58372, -5579,  2084,  3904,  1099, 66498,  4466,  4466,
   11184,  4228, -5579, -5579,   384,  4069,  4261,  4069,  4013, 85618,
     960,  4016,  2399, -5579, 85618,  4018,  4155,  1008,  1008, 85618,
   85618, 85618,  2404,    32,  2767,  3808,   954,  4372, 69844,  4415,
    3813,   333, -5579, 85618,  4493, 85618,  3438,  3621, 85618,  4029,
   -5579, -5579, 71278,  4242,  2011, 85618,  2289,  3997,  3408,   968,
   85618, -5579,  1509, -5579,    32, -5579, 85618, 77492, 42900,  4361,
   -5579,110840, -5579,  2409, -5579, -5579, -5579,  4109, 19513,  3256,
    4147,  4150,  4033,  1987,  4371, 85618,   740, -5579, -5579, -5579,
   -5579, -5579, -5579, 85618, -5579,   352, -5579, 16944, -5579,  3090,
   38544, 17231, 17231, 17231, 33110, -5579, 33110, -5579, -5579, -5579,
   -5579,   656, -5579, -5579,  3300,  3300,  3300, -5579,  4481,  3524,
   -5579, -5579, -5579,  1682,  4430,  3488, 59328,  4041, -5579, 38544,
    2411, -5579,  1674, 85618,  2426, -5579, 17231, 85618, -5579, -5579,
   33110, -5579,  2455, -5579,  4042,    22,  4043, 24771,  4036, -5579,
   -5579, -5579, -5579, -5579, 17231,  4044, -5579,  4508,  1635, -5579,
   -5579,  4100, 85618,  2460, -5579,   101,  1707,  4091, -5579, 17231,
    1775,  1772,   323,  4292,  4049,  3346, -5579,  4051, -5579, -5579,
    3008,   391, 85618,  3346,  3346, -5579, 85618,  4140, -5579,  4362,
   -5579, -5579,  4112, -5579,  1261,  3403, 85618,109448, -5579,   167,
    4387, -5579,109448,109448, -5579, -5579, -5579, 33110, -5579,  4149,
   -5579, -5579, -5579, 33110, 33110, 68888, -5579, -5579, 85618, 85618,
   85618, 85618, 85618, -5579,   845, -5579, -5579,  2466, -5579, 43864,
   -5579, -5579,  3187,  1099,  3187,  2002, -5579, -5579,  3187,  3187,
   -5579,  3256, -5579,  4466,   986, -5579, -5579,  4289,  4058, 33110,
    4363, -5579,  1122,  4276, -5579,  4068, -5579, 66498,  4554, -5579,
   58372,  3621,  4083, 85618, -5579, -5579, -5579, -5579, -5579, -5579,
   -5579, -5579, -5579, -5579, -5579, -5579,  2471,  3813,  4404,  3402,
    3986, -5579, 85618,  4101, -5579, 41454,  3813,    32,  1991, -5579,
    3997,  3621,  4083, -5579, -5579,  4074,  4025,  3408,  2289,  4208,
   -5579,  4211, -5579,  4501,  4287,  4509,  3438, -5579,  3307,  2477,
   85618, -5579, -5579,  8208,111768,109448, -5579, -5579, -5579,  4080,
    4445,  4121,  4123, -5579, -5579, -5579,  1987, -5579,  1705,  4448,
    4133, -5579,  4158, 85618, -5579, -5579,  3813,   845, 33110,  3090,
    2492,  2501,  4146, -5579, 33110,  1306,  4429,  4431, 85618, -5579,
   -5579, -5579, 85618,  2494,  4092, 37556, 58372,  2503, -5579,108984,
   -5579,  2505,  2509, -5579, 33110,  4098, 33110, -5579, 36074, 85618,
    4099,  3258,    32, -5579,  3256, 42900, -5579,  4229,  4570,  4364,
   -5579, -5579,  4434, -5579, -5579, 85618,  4069, 51670,   391,  3498,
    2040,  4069,  4069, -5579, 85618,  4058, 33110, -5579,  4199, -5579,
   -5579,  2511,  1671,  4278,  4278,  2516,  2528, 11275, 85618,  2529,
    2535, -5579,  2541,  2488,  3405,  1915,  3405, -5579,  3390, -5579,
   -5579, 58372, -5579, 62196, -5579, -5579, -5579,  1099, -5579,  1099,
    4336, 85618, 54094,  1099,  1099, -5579, -5579, -5579, -5579,  4412,
   -5579,  3295, -5579, 11826,  4209, -5579, -5579, -5579,   454, -5579,
    4330,  4333, -5579,  4126, -5579,  2548, -5579,  1655,  4248,  3813,
   -5579, -5579, 85618,  4585,  4586, -5579,  1113, 85618,  3471, -5579,
    3986,  3438,  3408,  1655,  3997,  2011, 43382,  4037,  2289,  4025,
   -5579, -5579,  4337, -5579,  4343, -5579,  4130,  4433, -5579,  2027,
     561, -5579, -5579, -5579,   935,  4459,  4460, -5579, -5579, -5579,
    3187, -5579,  1479,  4136,  4486, -5579, -5579, -5579, -5579, 17231,
   -5579, -5579, -5579,  3428, 36568, 36568, 36568,  4138,  4581,  4583,
    1276,  2553, 39526, -5579, -5579, -5579, 85618,  4350,   320,  4608,
    4305,  2554, 36074,  2562, -5579, -5579, -5579, -5579, -5579, -5579,
   -5579, 46756, 33110,  4238,  4570, 61718,  2587,  3591,  4151,  3498,
   -5579,  4261, -5579, -5579,  3403, -5579, 17231, 85618, 66498,  4591,
   -5579, -5579, -5579, -5579, -5579, -5579, -5579,  3403,  4235, -5579,
   -5579, 68888, -5579, 85618, -5579, -5579,  2600, -5579, -5579, -5579,
   85618,  3955, -5579,  3955, -5579, -5579, -5579,  2563,  4258, 85618,
     877,   877,  4533, -5579,  4220, -5579,  4156, -5579,  4654,  4295,
   85618, -5579, -5579,   827,    32, 69844,  3813, -5579, -5579,  2289,
    3997,  3408, 33110,  2609, -5579,  4292,   180, -5579,  4025,  4037,
   -5579, -5579, 42900,  4161,  3092,  4522, -5579, -5579, -5579,  2565,
   66498, 66498, 85618, -5579, -5579, -5579, 33110,   960, 38050,  4306,
     981, 13066,  4515, -5579,  4515,  4515, -5579, 85618, 85618, 85618,
   -5579,  3615, -5579, -5579, 38544, 38544,  4393, -5579,   320, -5579,
   85618, -5579,  4175, -5579, -5579,  2610, -5579,   -34, 17231,   413,
    4257,   323, -5579, -5579, -5579, -5579,  4276,  1348,  1348, -5579,
    3403, -5579, 85618, -5579,  4176, -5579, -5579, -5579, 62196,  3955,
   -5579, -5579, -5579, -5579,  4649, -5579,   262, -5579, -5579, -5579,
   -5579, 85618,  3813,  3882,  3986, -5579,  4025,  3408,  2289, 11903,
   -5579, 43382, 85618, 85618,  4037, -5579,  2611, 42900,  3402,  4314,
   -5579,  3151, -5579, -5579, -5579, -5579, -5579, -5579, -5579,   971,
    4177,  4180, -5579, -5579, 11948, 66498,  4640, -5579, -5579, -5579,
   -5579, -5579,  1328, -5579, -5579, -5579,  1294,  1312,  1850,  4600,
    2494,  2494, -5579, -5579, -5579, 33110, -5579, -5579, -5579,  4409,
    4310, -5579, -5579,  1403, -5579,  1348, -5579, -5579, -5579, 33110,
   -5579, -5579,  2040,  2040,  3813, -5579, -5579,  4037,  2289,  4025,
    4292, -5579, -5579, -5579, -5579, -5579,  4433, -5579,  2618,  4037,
    4133,  2382, -5579, -5579,  2415,  2378,  4266,  4517, -5579,  4189,
   37062,  4328, -5579,  4397, -5579, 85618, 85618, 59806, 85618, 85618,
   12443, -5579, 46756,  4420,   156, -5579,  1348,  2619, -5579, -5579,
   -5579, -5579,  4025,  4037, 85618,  3092, -5579, 42900,  3256,  4544,
   -5579,  3151,  4311,  4312, 57894, -5579, -5579, -5579, -5579, -5579,
     292,  4579, -5579,  2620, -5579,  4195, -5579,  4254,  1417,  4202,
   85618, -5579, -5579,  4037, -5579, -5579,  3402, -5579, -5579,   960,
   -5579,  4245,  4250, -5579,  2624, -5579, -5579, -5579, -5579, 33110,
   59806, -5579, -5579,  4256, 33110,  2625, -5579,  4037, 66498,  4537,
    4538, -5579, 57894,   725,  4275,  4260,  2639,   964,  3256,  4214,
   66498, 66498, -5579,  4216, 85618, -5579, -5579,  1417, -5579, -5579,
   57894, -5579, -5579,  1099, -5579,  4271,  2666,  4260, -5579, -5579
};

  /* YYDEFACT[STATE-NUM] -- Default reduction number in state STATE-NUM.
     Performed when YYTABLE does not specify something else to do.  Zero
     means the default is an error.  */
static const yytype_uint16 yydefact[] =
{
    1696,  1441,   648,  1529,  1528,  1441,     0,   266,     0,  1539,
       0,  1441,   430,  1099,     0,     0,     0,     0,   648,  1441,
       0,  1696,     0,     0,     0,     0,     0,  1709,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1441,     0,
       0,  1716,     0,     0,     0,     0,  1709,     0,  1541,     0,
       0,     0,     0,  1716,     0,     0,     0,     0,     0,     2,
       9,    10,    45,    80,    81,    38,    37,    98,    63,    24,
      71,   133,   132,   134,    50,    46,    88,    33,    35,    47,
      51,    73,    75,    40,    53,    64,   110,    72,    31,    70,
      76,    96,    58,    19,    20,    59,    21,    60,    22,    61,
     106,    82,    99,    43,    69,    30,    52,    78,    79,    12,
      54,    86,    18,    65,    66,    68,    91,    92,    93,   116,
      94,   128,    49,   125,   103,   104,   122,   105,   123,    16,
     107,    62,    23,   119,   118,   120,    89,    55,    90,    77,
      97,   117,    34,   121,    25,    26,    28,    29,    27,    67,
      36,    74,    39,    95,   124,   114,   109,   129,   127,    11,
     135,   111,    83,    14,    15,   100,    13,    32,    57,    17,
      42,    41,    56,    48,   131,    44,  1539,   102,   115,   101,
      84,   108,    87,   112,   130,   113,    85,   126,  1660,  1659,
    1720,  1663,  1695,     0,  1675,  1440,  1439,  1454,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   647,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1451,  2313,  2330,  2331,  2332,  2333,
    2334,  2335,  2336,  2337,  2338,  2339,  2340,  2341,  2342,  2343,
    2345,  2344,  2346,  2347,  2690,  2348,  2349,  2350,  2639,  2640,
    2691,  2641,  2642,  2351,  2352,  2353,  2354,  2355,  2356,  2357,
    2358,  2359,  2643,  2644,  2360,  2361,  2362,  2363,  2364,  2645,
    2692,  2365,  2366,  2367,  2368,  2369,  2370,  2693,  2371,  2372,
    2373,  2374,  2375,  2376,  2377,  2378,  2379,  2694,  2380,  2381,
    2382,  2695,  2383,  2384,  2385,  2386,  2387,  2388,  2646,  2647,
    2389,  2390,  2391,  2392,  2393,  2394,  2395,  2396,  2397,  2398,
    2399,  2400,  2401,  2402,  2403,  2404,  2405,  2406,  2407,  2408,
    2409,  2410,  2411,  2412,  2413,  2414,  2415,  2416,  2648,  2417,
    2418,  2419,  2420,  2649,  2421,  2422,  2423,  2424,  2650,  2425,
    2426,  2427,  2696,  2697,  2428,  2429,  2430,  2431,  2432,  2651,
    2652,  2433,  2434,  2435,  2436,  2437,  2438,  2439,  2698,  2440,
    2441,  2442,  2443,  2444,  2445,  2446,  2447,  2448,  2449,  2450,
    2451,  2699,  2653,  2452,  2453,  2454,  2455,  2654,  2655,  2656,
    2456,  2700,  2701,  2457,  2702,  2458,  2459,  2460,  2461,  2462,
    2463,  2657,  2703,  2464,  2704,  2465,  2466,  2467,  2468,  2469,
    2470,  2471,  2472,  2473,  2474,  2475,  2476,  2477,  2478,  2479,
    2480,  2481,  2482,  2483,  2484,  2485,  2658,  2705,  2659,  2486,
    2487,  2488,  2489,  2490,  2491,  2492,  2660,  2661,  2493,  2494,
    2495,  2706,  2496,  2662,  2497,  2663,  2498,  2499,  2500,  2501,
    2502,  2503,  2504,  2505,  2506,  2507,  2664,  2707,  2508,  2708,
    2665,  2509,  2510,  2511,  2512,  2513,  2514,  2515,  2516,  2517,
    2518,  2519,  2520,  2666,  2521,  2667,  2524,  2522,  2523,  2525,
    2526,  2527,  2528,  2529,  2530,  2531,  2532,  2533,  2534,  2668,
    2535,  2536,  2537,  2538,  2539,  2540,  2541,  2542,  2543,  2544,
    2545,  2546,  2547,  2548,  2549,  2550,  2551,  2552,  2553,  2709,
    2554,  2555,  2556,  2557,  2558,  2669,  2559,  2560,  2561,  2562,
    2563,  2564,  2565,  2566,  2567,  2568,  2569,  2570,  2571,  2572,
    2573,  2574,  2670,  2575,  2576,  2710,  2577,  2578,  2671,  2579,
    2580,  2581,  2582,  2583,  2584,  2585,  2586,  2587,  2588,  2589,
    2590,  2591,  2592,  2672,  2593,  2594,  2595,  2596,  2711,  2597,
    2598,  2599,  2600,  2601,  2602,  2673,  2674,  2603,  2604,  2675,
    2605,  2676,  2606,  2607,  2608,  2609,  2610,  2611,  2612,  2613,
    2614,  2615,  2616,  2617,  2618,  2619,  2620,  2621,  2622,  2623,
    2677,  2678,  2624,  2712,  2625,  2626,  2627,  2628,  2629,  2630,
    2631,  2632,  2633,  2634,  2635,  2679,  2680,  2681,  2682,  2683,
    2684,  2685,  2686,  2687,  2688,  2689,  2636,  2637,  2638,   137,
       0,     0,  2280,  2314,  2315,  2318,  2313,   402,   401,  1649,
    2277,  2314,  1538,     0,  1518,   648,     0,  1454,   429,  1696,
       0,     0,     0,     0,     0,     0,   864,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   185,
       0,     0,     0,     0,   453,   452,     0,     0,  1065,   458,
       0,     0,     0,     0,     0,   638,  1580,  2522,  1578,  1650,
     267,   270,   271,   268,   269,  2296,     0,  1211,  1212,  1214,
       0,     0,  1224,   904,   905,     0,     0,     0,   918,     0,
       0,     0,   902,     0,     0,     0,   924,     0,   921,     0,
       0,   925,   922,   899,   923,   906,     0,   898,     0,     0,
    1224,   926,     0,     0,   900,     0,     0,     0,     0,  1454,
    1577,   459,  1696,     0,  1561,  1562,  1563,  1539,  1551,  1564,
    1556,  1558,  1557,  1559,  1560,  1555,  2295,  2331,   994,   994,
     994,   994,   991,   992,   994,   994,   994,  2542,     0,     0,
     973,     0,   975,  2297,   994,   999,  2339,   530,   530,   530,
       0,   998,  1003,   530,     0,  1422,  1463,  2279,  1708,     0,
     974,  1421,     0,     0,     0,  2603,  1567,     0,     0,  1239,
    1235,  1237,  1238,  1236,     0,  1068,  1068,  2561,  1431,   249,
    2572,  2673,  2603,   248,   242,   244,   216,  2335,     0,     0,
     998,     0,  1454,  1429,   970,  1715,  1713,     0,  2264,  2358,
    2374,  2467,   239,  2554,  2562,  2572,  2673,  2603,  2635,   195,
     205,   200,     0,   260,  2572,  2673,  2603,   256,  1451,     0,
    1676,  1824,  1823,  2273,     0,  1424,  1423,  1540,     0,  1543,
       0,  2537,  1680,  1683,  1545,  1681,  2316,  1899,  1928,  1906,
    1928,  1928,  1895,  1895,  2404,  1908,  1896,  1897,  1933,     0,
    1928,  1895,  1900,     0,  1898,  1936,  1936,  1923,     3,  1880,
    1881,  1882,  1883,  1909,  1910,  1884,  1915,  1916,  1920,  1885,
    1950,  1895,  2317,  1717,  1718,  2264,     4,  2310,     5,  2259,
    2309,     6,     7,  1672,     0,     0,     1,  1696,     0,  1550,
    1712,  1712,     0,  1712,     0,  1664,  1672,  1667,  1671,     0,
       0,     0,     0,     0,     0,  1425,     0,     0,     0,   929,
       0,  1466,  1050,     0,     0,     0,     0,     0,  1308,     0,
    1108,  1107,  2319,  2302,  2303,  2304,     0,  2300,  2301,  2320,
    2321,  2322,     0,  2439,  1308,     0,     0,  2175,  2186,  2187,
    2188,  2362,  2421,  2183,  2184,  2185,  2177,  2178,  2179,  2180,
    2181,  2182,     0,     0,  1206,  2176,     0,  2439,     0,  1308,
       0,   164,     0,   141,  1308,     0,     0,  2439,     0,     0,
    2439,     0,     0,     0,     0,     0,  2439,     0,     0,     0,
       0,     0,   164,  2472,     0,   141,  2439,     0,     0,  1445,
       0,     0,     0,  1447,  1450,  1437,     0,  2256,     0,  2257,
    2281,     0,  1532,  1526,  1535,  1531,  1521,     0,  2273,     0,
       0,     0,     0,   912,     0,     0,   902,     0,     0,     0,
     913,     0,   914,   915,     0,     0,     0,     0,   911,     0,
    1435,  1427,     0,  1569,  1571,  1570,  1572,  1568,   530,     0,
       0,     0,  2439,     0,   141,  1505,     0,  2439,   141,     0,
       0,   457,   456,   141,  2300,   455,   454,  2362,  2421,     0,
    1098,     0,  1181,   141,  2439,     0,   187,  2439,   707,  2439,
    1545,     0,   651,     0,   819,  2472,   141,     0,     0,     0,
       0,     0,     0,  1068,     0,     0,     0,     0,     0,     0,
       0,   637,   648,  1581,  1579,     0,  1215,   241,   240,  1213,
     916,  2439,  1140,   363,     0,     0,  2439,  1486,  2439,   363,
     933,   917,     0,   903,  2439,   363,  1104,  2439,  2305,   174,
       0,   901,  2362,  2421,  2439,   363,  1208,     0,  2439,   363,
    2439,   170,  2439,   363,  2439,   363,  2439,   652,     0,     0,
    2439,   363,  2439,  2472,   172,   920,  2439,   363,   927,  2439,
     363,  2275,  2439,     0,  1438,     0,  1573,     0,  1553,  2677,
       0,  1696,   994,   993,     0,   994,     0,   994,     0,   994,
       0,   994,     0,     0,     0,   994,  2298,  2299,   976,     0,
    1000,     0,  1008,     0,  1007,  1006,  1005,     0,     0,     0,
    1009,     0,  1828,  1608,     0,  1419,   243,   194,     0,   255,
     254,  1434,     0,     0,     0,  1068,     0,  1067,     0,     0,
    1430,   247,   245,     0,     0,     0,     0,     0,     0,  1436,
       0,  1428,     0,     0,     0,  2283,  2285,  2286,  2189,  2259,
       0,  2640,  2641,  2642,  2248,     0,  2643,  2644,  2645,  2692,
    2079,  2066,  2075,  2080,  2067,  2069,  2076,  2646,  2647,  2017,
    2648,  2649,  2293,  2650,  2651,  2652,  2654,  2655,  2656,  2657,
    2071,  2073,  2658,  2659,  2661,     0,  2294,  2662,  2663,  2503,
    2665,  2666,  2668,  2669,  2077,  2671,  2672,  2673,  2674,  2675,
    2676,  2292,   497,  2078,  2678,  2680,  2681,  2682,  2683,  2685,
    2686,  2687,  2688,     0,     0,     0,  2270,     0,  2046,     0,
    1888,  1889,  1911,  1912,  1890,  1917,  1918,  1891,     0,  2269,
    1953,  2134,  2045,  2062,     0,  2051,  2052,     0,  2044,  2040,
    1698,  2265,     0,  2041,  2282,  2284,  2249,  1698,  2263,   208,
     262,     0,   263,  2271,  2572,   196,   238,   210,   237,   211,
     209,     0,  2360,   197,     0,     0,   198,     0,     0,     0,
       0,   259,   257,     0,  1426,     0,  1826,  1825,  2274,   938,
       0,  1542,  1539,  2199,     0,  1682,     0,     0,     0,  1927,
    1914,  1922,  1921,     0,  1904,  1903,  1902,     0,  1901,  1928,
    1928,  1926,  1905,  1880,     0,     0,     0,  1932,     0,  1930,
    1876,  1872,     0,  1939,  1940,  1941,  1938,  1951,  1937,     0,
    1886,  1942,     0,  1895,  1892,  1783,     0,  1662,  1661,     8,
       0,  1547,  1549,  1524,  1545,  1710,  1711,     0,     0,     0,
       0,     0,     0,     0,     0,  1770,  1728,  1729,  1731,  1767,
    1771,  1779,     0,  1668,     0,     0,     0,  1830,     0,     0,
    1452,     0,     0,     0,     0,     0,  1139,     0,     0,     0,
       0,   930,     0,     0,     0,  1472,     0,  1474,  1475,  1476,
       0,     0,     0,     0,  1477,  1478,  1466,   251,  1485,  1482,
    1465,  1467,  1480,     0,     0,     0,     0,     0,     0,     0,
    1497,     0,   178,   179,     0,   664,   648,     0,  2439,     0,
       0,     0,     0,  1149,  1156,  1307,     0,     0,     0,     0,
       0,     0,     0,     0,  1150,  1148,     0,  1151,   253,  1161,
    1188,  1191,     0,     0,  1106,  1109,     0,     0,     0,     0,
       0,  1298,     0,     0,     0,  1298,     0,     0,     0,  1307,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   278,
     280,   293,   358,     0,   629,     0,     0,     0,   632,     0,
    2439,  1308,     0,     0,     0,  1210,     0,     0,     0,     0,
       0,     0,     0,     0,  1191,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   139,   140,   145,     0,     0,     0,
       0,  1191,     0,     0,     0,     0,     0,     0,     0,   615,
     628,     0,     0,     0,     0,     0,   625,     0,     0,   141,
     283,   605,   611,     0,     0,     0,   714,   713,     0,     0,
       0,     0,     0,     0,  1395,     0,  1394,     0,     0,     0,
       0,     0,  1495,  1494,     0,     0,     0,     0,     0,  1298,
       0,   272,   274,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   394,   395,
       0,     0,     0,   145,     0,     0,  1298,     0,   285,     0,
       0,  1446,  1443,  1444,     0,  1449,     0,     0,     0,     0,
    2054,     0,  2203,  1720,  2201,  1124,  2255,     0,  2323,  2713,
    2714,  2715,  2716,  2717,  2718,  2719,  2720,  2721,  2722,  2723,
    2724,  2725,  2726,  2727,  2728,  2729,  2730,  2731,  2732,  2733,
    2734,  2735,  2736,  2737,  2738,  2739,  2740,  2741,  2742,  2743,
    2744,  2745,  2746,  2747,  2748,  2749,  2750,  2751,  2752,  2753,
    2754,  2755,  2756,  2757,  2758,  2759,  2760,  2761,  2762,  2763,
    2764,  2765,  2766,  2767,  2768,  2769,  2770,  2771,  2772,  2773,
    2774,  2775,  2776,  2777,  2778,  2779,  2780,  2781,  2782,  2783,
    2784,  2785,  2786,  2787,  2788,  2789,  2252,  2251,  2278,  2324,
    2325,  2326,  2327,  2258,     0,     0,   227,   228,   226,  1533,
     229,  1534,  1530,     0,  1516,     0,     0,     0,     0,     0,
       0,     0,     0,  2362,  2421,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   827,  1466,  1504,     0,     0,     0,   657,     0,  2439,
       0,   143,   865,     0,   817,   458,     0,     0,     0,     0,
    1371,   143,     0,     0,   181,     0,     0,   711,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   818,     0,
       0,   143,     0,  2439,   608,  2439,     0,   530,   530,     0,
       0,  1070,     0,     0,     0,     0,     0,     0,     0,     0,
    1654,  1653,  1656,  1655,     0,  1652,     0,   361,   362,     0,
    1198,  1223,     0,     0,     0,     0,     0,   894,   919,     0,
       0,  1192,     0,     0,  2439,   363,  2439,     0,  2439,     0,
       0,     0,  1200,   363,     0,  1194,     0,     0,  1196,     0,
    1397,     0,   910,   908,   907,   909,     0,     0,   892,     0,
       0,     0,     0,     0,   887,     0,     0,   889,     0,     0,
       0,     0,  1696,  1552,     0,   984,     0,   988,     0,   979,
       0,   985,     0,   980,   977,   978,     0,   983,     0,     0,
     531,   533,     0,     0,  2386,  2403,     0,  2428,  2460,  2461,
    2513,  2528,  2557,  2562,  2568,     0,  2597,  2608,     0,  1014,
    1045,  1004,   723,     0,     0,  1618,  1420,  2208,     0,  1696,
       0,     0,     0,  1231,  1232,   246,   217,     0,     0,     0,
    1047,  2561,  1433,   969,   648,     0,  2042,     0,  2049,  2050,
    2247,     0,     0,     0,     0,     0,     0,  2048,     0,     0,
       0,     0,     0,     0,     0,  1975,     0,     0,  2207,     0,
       0,  2207,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1976,  1957,  1958,  2046,  2199,     0,
    2047,  2289,     0,  1950,  2328,  2189,     0,  2186,  2187,  2188,
    2790,  2791,  2792,  2793,  2794,  2795,  2796,  2797,  2798,  2799,
    2800,  2801,  2802,  2803,  2804,  2805,     0,  2806,  2807,  2808,
    2809,  2810,  2812,  2811,  2813,  2814,  2815,  2816,  2817,  2818,
    2262,  2820,  2821,  2822,  2823,  2824,  2825,  2826,  2827,  2828,
    2829,  2830,  2831,  2832,  2833,  2834,  2835,  2836,  2837,  2838,
    2839,  2840,  2841,  2842,  2843,  2844,  2845,  2846,  2847,  2848,
    2849,  2850,  2851,  2852,  2853,  2854,  2855,  2856,  2857,  2858,
    2859,  2860,  2861,  2862,  2863,  2864,  2865,  2866,  2867,  2868,
    2869,  2870,  2871,  2872,  2873,  2874,  2875,  2876,  2877,  2878,
    2879,  2880,  2881,  2882,  2883,  2884,  2885,  2886,  2887,  2888,
    2889,  2890,  2891,  2892,  2893,  2894,  2895,  2896,  2897,  2898,
    2899,  2900,  2901,  2902,  2903,  2904,  2905,  2906,  2907,  2908,
    2909,  2910,  2911,  2912,  2913,  2914,  2915,  2916,  2917,  2918,
    2919,  2920,  2921,  2922,  2923,  2924,  2925,  2926,  2927,  2928,
    2929,  2930,  2931,  2932,  2933,  2934,  2935,  2936,  2937,  2938,
    2939,  2940,  2941,  2942,  2943,  2944,  2945,  2946,  2947,  2948,
    2949,  2950,  2951,  2952,  2953,  2954,  2955,  2956,  2957,  2958,
    2959,  2960,  2961,  2962,  2963,  2964,  2965,  2966,  2967,  2968,
    2969,  2970,  2971,  1990,  2972,  2973,  2974,  2975,  2976,  2977,
    2978,  2979,  2980,  2981,  2982,  2983,  2984,  2985,  2986,  2987,
    2988,  2989,  2990,  2991,  2992,  2993,  2994,  2995,  2996,  2997,
    2998,  2999,  3000,  3001,  3002,  3003,  3004,  3005,  3006,  3007,
    3008,  3009,  3010,  3011,  3012,  3013,  3014,  3015,  3016,  3017,
    3018,  3019,  3020,  3021,  3022,  1992,  3023,  3024,  3025,  3026,
    3027,  3028,  3029,  3030,  3031,  3032,  3033,  3034,  3035,  3036,
    3037,  3038,  3039,  3040,  3041,  3042,  3043,  3044,  3045,  3046,
    3047,  3048,  3049,  3050,  3051,  3052,  3053,  3054,  3055,  3056,
    3057,  3060,  3058,  3059,  3061,  3062,  3063,  3064,  3065,  3066,
    3067,  3068,  3069,  3070,  3071,  3072,  3073,  3074,  3075,  3076,
    3077,  3078,  3079,  3080,  3081,  3082,  3083,  3084,  3085,  3086,
    3087,  3088,  3089,  3090,  3091,  3092,  3093,  3094,  3095,  3096,
    3097,  3098,  3099,  3100,  3101,  3102,  3103,  3104,  3105,  3106,
    3107,  3108,  3109,  3110,  3111,  3112,  3113,  3114,  3115,  3117,
    3116,  3118,  3119,  3120,  3121,  3122,  3123,  3124,  3125,  3126,
    3127,  3128,  3129,  3130,  3131,  3132,  3133,  3134,  3135,  3136,
    3137,  3138,  3139,  3140,  3141,  3142,  3143,  3144,  3145,  3146,
    3147,  3148,  3149,  3150,  3151,  3152,  3153,  3154,  3155,  3156,
    3157,  3158,  3159,  3160,  3161,  3162,  3163,  3164,  3165,  3166,
    3167,  3168,  3169,  3170,  3171,  3172,  3173,  3174,  3175,  3176,
    3177,  3178,  3179,  3180,  3181,  3182,  3183,  3184,  3185,  3186,
    3187,  3188,  3189,  3190,  3191,  3192,  3193,  3194,  3195,  3196,
    3197,  3198,  3199,  3200,  3201,  3202,  3203,  3204,  3205,  3206,
    3207,  3208,  3209,  3210,     0,  2183,  2184,  2185,  2177,  2178,
    2179,  2180,  2181,  2182,  2193,     0,     0,  2268,  2329,     0,
    2136,     0,  1972,     0,     0,  1783,     0,  2287,  2250,  1783,
     264,   265,   261,     0,     0,   213,   212,     0,   231,   235,
     236,   207,   234,     0,   230,   215,  2123,  2122,   214,   206,
     203,   201,   218,   220,   221,   204,   202,   258,     0,     0,
       0,   363,  1550,  1537,     0,     0,  2262,     0,  2197,     0,
       0,  2195,     0,     0,     0,  1780,     0,  1684,     0,  1688,
       0,     0,     0,  1925,  1924,  1877,  1873,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     931,     0,  1893,     0,  1846,  2311,  2312,  2260,  1716,  1550,
       0,  1546,  1679,  1678,  1721,  1722,  1090,  1677,  1750,  1751,
       0,     0,     0,     0,  1776,  1774,  1741,  1732,  1740,     0,
       0,  1738,     0,  1742,  1953,  1769,  1666,  1726,  1727,  1730,
    1665,     0,  1772,     0,  1621,  1770,  1731,  1605,     0,  1583,
       0,     0,  1831,     0,     0,  1453,     0,     0,     0,  1119,
    1121,     0,  1120,     0,  1123,     0,  1132,     0,     0,  1118,
    1137,     0,  1126,  1124,     0,  1493,     0,     0,     0,     0,
       0,  1473,     0,     0,     0,  2597,   250,  1476,  1481,  1468,
    1479,     0,     0,     0,     0,     0,  1049,  1048,     0,     0,
    1072,     0,     0,   497,  1500,   519,     0,   360,     0,     0,
       0,     0,     0,     0,     0,     0,   813,   810,     0,     0,
     809,     0,   662,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   687,     0,  1298,     0,   291,     0,
    1158,     0,  1157,     0,  1162,     0,     0,  1159,  1154,  1155,
    2562,  2572,  2603,   252,  1160,  1190,     0,  1189,  1185,     0,
    1101,     0,  1102,     0,     0,     0,     0,     0,  2413,  2439,
     299,   322,     0,  1297,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   344,
       0,     0,   347,   346,     0,     0,     0,     0,     0,   352,
       0,   330,     0,   331,     0,   351,     0,     0,     0,   630,
     631,     0,     0,     0,  1298,     0,   287,     0,     0,     0,
       0,     0,     0,     0,     0,  1207,     0,   740,     0,     0,
    2562,  1186,     0,     0,  1380,     0,  1381,  1384,   530,     0,
     530,  1386,     0,     0,  1383,  1385,     0,     0,   167,     0,
     162,   166,     0,     0,  2562,  1187,     0,     0,     0,     0,
       0,   613,   614,   627,     0,   618,   619,   616,   620,   621,
       0,     0,     0,     0,     0,     0,     0,   612,     0,     0,
     709,   708,   712,     0,     0,     0,     0,     0,     0,  1389,
       0,     0,  1181,     0,     0,  1388,  1396,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1241,  1240,     0,
       0,     0,     0,  1308,     0,   855,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   169,   727,     0,   726,     0,
     163,   168,     0,     0,     0,     0,     0,     0,     0,     0,
     225,  1442,  1448,  1720,  1720,  1720,  2060,     0,     0,     0,
       0,  1719,  2253,  2256,  1521,  1527,  1520,  1519,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   408,   405,   406,   408,     0,
       0,     0,     0,   829,     0,   832,   835,  1464,   481,     0,
       0,   654,   687,     0,     0,   461,   176,     0,     0,     0,
       0,   742,     0,  1181,  1180,   138,   185,   187,   459,     0,
     186,   188,   190,   191,   192,   189,   193,     0,   706,   710,
       0,     0,     0,     0,   650,     0,     0,     0,     0,     0,
       0,     0,  1851,     0,     0,   161,     0,     0,   603,   607,
       0,     0,     0,     0,   461,   569,   374,  2439,     0,   530,
       0,  2439,     0,  1069,     0,   816,     0,     0,     0,  1143,
    1143,     0,     0,   756,   755,     0,     0,     0,     0,     0,
       0,  1651,   363,  1141,     0,  1487,     0,   363,   934,   363,
    1105,   175,  2306,     0,   896,     0,     0,     0,     0,   363,
    1209,   884,   363,   171,   363,   363,   653,     0,   363,   173,
       0,     0,   363,   928,   363,  2276,     0,   363,  1576,  2439,
     530,  1554,   981,   990,   989,   987,   986,   982,     0,  1001,
       0,   529,     0,     0,     0,     0,     0,  1022,  1023,     0,
       0,  1019,  1024,     0,  1026,  1010,  1012,  1020,  1021,  1027,
    1016,  1015,  1028,  1029,     0,     0,  1047,   721,     0,     0,
       0,     0,  1615,     0,  1613,     0,  1829,  1617,  1606,  1566,
       0,  1565,     0,   596,  1068,  1068,     0,     0,   998,     0,
       0,   363,  1432,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  2212,     0,  2213,     0,     0,  2246,
    2242,     0,     0,     0,     0,     0,  2216,  2219,  2220,  2221,
    2218,  2222,  2217,     0,     0,  2223,     0,     0,     0,     0,
       0,     0,     0,     0,  2203,  2206,     0,     0,  2669,     0,
       0,     0,     0,  2018,     0,     0,  2170,     0,  2203,     0,
       0,     0,     0,     0,     0,     0,  2199,  2238,     0,   495,
       0,  2010,     0,     0,     0,  2121,     0,  2118,     0,     0,
       0,     0,  2259,     0,     0,  2290,  1954,  1968,  1969,  1970,
    1973,  2267,     0,  2261,     0,     0,  1955,  1981,     0,  2239,
    2006,     0,  2011,  1996,  2224,  2225,  2226,  2227,  2013,     0,
    1989,  1994,  1998,     0,  1977,     0,  1974,     0,  2262,  2198,
       0,  2196,     0,  1965,  1966,  1967,  1959,  1960,  1961,  1962,
    1963,  1964,  1971,  2174,  2172,  2173,     0,     0,     0,  2144,
       0,     0,  1993,  2431,  2467,     0,  1709,  1709,  1709,  1697,
    1707,  2266,  1846,  1720,  1846,  2272,     0,     0,  1950,     0,
    1827,   936,   937,   935,  1523,  1536,  1550,  2200,  1544,  1686,
       0,     0,     0,  1894,  1907,     0,  1935,  1934,  1936,  1936,
       0,  1878,     0,  1919,  1944,  1945,  1946,  1947,  1948,  1949,
       0,  1943,  1887,   932,     0,  2559,  2689,     0,  1807,  1782,
    1784,  1794,  1807,  1814,  1807,  2063,  1844,  2064,  2273,     0,
    1753,  2308,  1525,  1548,     0,  1088,  1089,     0,  1093,  2669,
    2559,     0,     0,     0,     0,  1743,  1777,     0,  1768,     0,
    2283,  1744,  2282,  1745,  1748,  1749,  1739,  1778,  1619,     0,
    1773,  1670,  1669,     0,  1849,     0,     0,     0,  1597,  1585,
       0,     0,  1832,     0,  1783,  1623,     0,  2259,  1781,  1347,
    1242,  1309,  1122,     0,  1895,  1133,     0,  1117,     0,  1116,
    1895,     0,  1134,     0,  1895,  1348,  1243,  1310,  1349,  1244,
    1311,  1350,  1484,  1245,  1483,  1471,  1470,  1469,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   794,  2439,   363,  1498,  1351,     0,  1246,   359,
    1499,  1312,  1503,   812,   811,     0,     0,  1313,     0,   663,
     668,     0,   670,   671,  2362,  2421,   672,   675,   676,     0,
     678,   667,   666,     0,     0,     0,     0,     0,   684,   689,
       0,     0,     0,     0,     0,     0,  1152,  1153,  1352,  1249,
       0,  1314,     0,  1100,     0,  1250,   177,     0,     0,   279,
    2439,   301,     0,   479,   794,     0,  1300,   298,   328,     0,
     343,   338,   339,   337,  2439,   363,  2439,   363,     0,     0,
       0,     0,     0,   340,   335,   336,   332,     0,     0,   345,
    2334,  2405,  2573,     0,   695,   697,     0,   702,   348,  1270,
     370,   369,   368,     0,   353,     0,   375,   378,     0,   350,
     329,   327,   324,   294,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1202,     0,  1355,  1315,     0,
    1337,     0,     0,     0,     0,   734,  1358,  1256,  1318,     0,
       0,   530,     0,   545,   545,   530,  1369,  1257,   165,  1287,
     154,     0,     0,   150,     0,     0,     0,     0,   144,  1359,
    1258,  1319,     0,     0,  1360,  1259,     0,     0,   284,   606,
     617,   622,  1264,   626,   623,  1327,   624,  1367,  1260,     0,
    1363,  1290,  1322,   589,  1181,  1181,  1370,  1390,  1261,  1181,
       0,  1298,     0,   273,   275,     0,  1068,     0,  1262,     0,
    1320,  1362,  1289,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1506,     0,     0,     0,     0,     0,     0,   363,
       0,     0,     0,  1300,  2439,   363,  1361,     0,  1295,     0,
    1335,     0,     0,   396,     0,  1288,  1298,     0,   286,  1266,
       0,  1329,     0,     0,   223,   222,   224,     0,     0,     0,
       0,  2204,  2205,     0,  2202,  2055,  2255,     0,  1517,   958,
     944,   957,     0,   940,  2403,     0,   943,   945,     0,     0,
       0,   946,   950,   951,     0,   942,   939,   941,     0,   407,
       0,     0,   751,   752,     0,     0,     0,     0,   831,     0,
       0,  1496,     0,   141,   661,     0,     0,     0,   656,   686,
     691,     0,     0,     0,     0,   460,   464,   468,   469,   470,
       0,     0,     0,     0,   155,   142,     0,   873,     0,   530,
       0,   744,  1181,  1373,     0,   187,   180,     0,     0,   707,
       0,  1545,     0,     0,   584,   587,   586,     0,   374,   826,
     824,   823,   825,   847,   822,     0,  1850,  1852,     0,     0,
       0,     0,     0,     0,   596,   463,     0,     0,   533,     0,
     572,     0,     0,     0,     0,   569,     0,     0,     0,  2316,
       0,   843,   815,     0,  1111,     0,  1129,  1112,     0,     0,
       0,     0,  1166,  1173,  1142,  1167,  1144,  1173,     0,     0,
     757,   761,   760,   764,   762,     0,   758,   635,  1657,  1658,
       0,  1199,     0,     0,  1492,     0,  1490,   895,  1193,   363,
       0,   363,     0,   363,  1201,  1195,  1197,  1398,     0,   893,
       0,     0,   886,   888,     0,   890,     0,  1002,   532,     0,
       0,     0,     0,     0,     0,  1018,   633,  1025,     0,     0,
       0,  1040,  1035,  1037,     0,  1041,   720,     0,     0,  1616,
    1609,  1611,  1610,     0,     0,  1607,  2209,   885,     0,   602,
       0,     0,     0,     0,  1047,     0,  1042,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1714,  2210,  2211,
       0,     0,     0,  2243,     0,     0,  2096,     0,  2068,  2070,
    2082,     0,  2097,  2053,  2098,  2072,  2074,  2083,     0,     0,
    2190,     0,  2086,  2085,     0,  2020,  2021,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  2035,  2087,  2169,     0,     0,
       0,  2089,  2088,     0,     0,  2237,     0,     0,     0,  2094,
     496,  2099,     0,     0,     0,     0,  2105,     0,  2126,     0,
       0,     0,  2043,  2200,     0,     0,     0,     0,     0,     0,
       0,     0,  2012,  1997,  2015,  1991,  1995,  1999,     0,  2014,
       0,     0,  1985,     0,     0,  1983,  2007,  1979,     0,     0,
    2008,     0,     0,     0,  2061,     0,     0,  1709,  1709,  1709,
    1709,  1706,     0,     0,     0,  1753,     0,  1753,   199,     0,
     232,   219,  1522,  1687,  1696,  1913,     0,  1931,  1929,  1874,
    1879,  1952,  1807,  1814,  1807,     0,     0,  1672,     0,  1794,
       0,  1806,  1792,  1805,     0,     0,  1820,  1818,     0,  1820,
       0,  1820,     0,  1786,     0,  1810,  1788,  1805,  1790,     0,
    1836,  2274,  1845,     0,  1766,  1723,     0,  2191,  1093,     0,
    1725,  1747,  1746,     0,  1736,     0,  1775,  1733,  1620,  1604,
       0,  1602,  1589,  1591,  1590,     0,     0,  1592,  2259,     0,
    1602,  1584,     0,  1628,     0,     0,  1849,     0,  1627,     0,
    1895,  1114,  1115,     0,  1138,     0,  1052,  1053,     0,  1051,
       0,     0,     0,   518,  1071,     0,     0,     0,   794,     0,
       0,   522,     0,  1501,     0,  1368,  1286,   665,     0,     0,
       0,     0,   680,   639,   681,   683,     0,     0,   682,   685,
     688,  1298,     0,   292,  1272,     0,  1333,  1146,     0,     0,
    1103,     0,     0,     0,     0,     0,     0,   478,   691,   323,
       0,     0,     0,     0,   383,     0,   303,   315,   381,   321,
       0,   355,     0,   326,     0,   319,   341,   333,   342,   334,
     354,   356,     0,   699,   700,   698,   694,     0,   701,   703,
       0,   372,     0,     0,     0,   349,     0,  1354,     0,  1298,
       0,   288,  1268,     0,  1331,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1336,     0,     0,
       0,     0,   739,     0,   736,     0,     0,   545,  1382,     0,
    1379,  1377,   545,     0,     0,   147,   146,     0,   153,     0,
       0,     0,     0,     0,     0,  1391,  1392,  1393,     0,     0,
       0,     0,     0,     0,   390,     0,   295,   297,   296,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   397,   365,     0,   850,
       0,     0,     0,   399,     0,     0,  1346,     0,     0,     0,
       0,     0,  1353,  1251,  2058,  2059,  2056,  1720,  2254,     0,
       0,     0,   955,     0,     0,     0,     0,   410,   411,   141,
     409,   432,     0,   794,     0,     0,   828,   833,   841,  2503,
    2177,  2178,   839,   834,   836,   838,   840,   837,     0,     0,
       0,     0,   500,     0,     0,     0,   487,     0,     0,   497,
     480,   483,   484,     0,     0,   657,   660,   658,   659,     0,
     679,     0,   463,   507,   559,     0,   157,     0,     0,   158,
     156,     0,     0,   374,   741,     0,   738,  1372,     0,   183,
       0,   711,     0,     0,     0,     0,     0,  1181,   649,     0,
     846,   848,   820,     0,   691,     0,     0,   608,     0,   530,
    1577,   591,     0,   561,   463,   559,   568,     0,     0,   576,
     373,     0,     0,   596,   374,     0,     0,  1072,     0,   842,
       0,     0,  1110,     0,     0,     0,  1163,  1168,  1164,     0,
    1143,  1125,     0,  1165,     0,     0,  1171,  1096,  1145,  1097,
    1414,  1415,  1412,  1413,     0,     0,     0,     0,     0,     0,
    1648,     0,     0,  1488,     0,   897,     0,   880,     0,   882,
     363,   728,     0,   363,     0,     0,     0,     0,     0,     0,
    1017,     0,  1011,  1013,  1038,     0,     0,  1047,  1044,     0,
       0,  1614,  1612,   594,     0,  1233,  1234,  1047,     0,   363,
    1046,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  2214,     0,  2245,  2241,     0,  2065,  2215,     0,     0,
       0,  2170,     0,     0,  2019,  2031,  2032,  2033,  2230,     0,
    2038,     0,  2028,  2029,  2030,  2022,  2023,  2024,  2025,  2026,
    2027,  2034,  2234,  2233,     0,     0,  2091,  2092,  2093,  2236,
    2100,     0,  2352,  2127,     0,  2104,  2120,  2119,     0,     0,
       0,  2107,     0,     0,  2116,     0,  2171,  2291,  1956,     0,
       0,  1982,  2240,  2000,     0,  2016,  1978,  2190,     0,     0,
       0,     0,     0,  1987,     0,     0,     0,  2147,  2142,  2143,
    2167,     0,     0,     0,     0,     0,     0,  1700,  1699,  1705,
    1766,  2055,  1766,     0,     0,  1875,  1793,  1789,  1791,     0,
    2684,     0,  1796,  1803,     0,  1785,     0,  1819,  1815,     0,
    1816,     0,     0,  1817,     0,     0,  1787,     0,  1803,     0,
    1843,  1712,     0,  2138,     0,  1724,  1091,  1092,  1734,     0,
    1737,  2382,  1847,     0,  1603,     0,     0,     0,  1594,  1600,
    1582,     0,     0,     0,  1624,  1602,  1625,  1135,     0,     0,
    1127,  1058,  1059,  1062,  1060,  1057,  1061,     0,     0,     0,
     794,     0,     0,   540,     0,  1085,  1085,     0,     0,   524,
     581,     0,   797,     0,     0,     0,   795,   363,  1247,     0,
       0,     0,     0,   640,  1366,  1248,     0,     0,     0,     0,
    1147,  1301,     0,     0,  1271,     0,   300,   477,   476,   481,
       0,     0,   306,   316,     0,   311,     0,  1299,     0,     0,
       0,     0,   310,   313,   385,     0,   382,     0,   363,   363,
     357,   696,   371,   376,   377,   380,  1306,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     874,   857,     0,     0,   875,   876,     0,     0,     0,  1204,
    1205,  1203,  1338,  1339,  1344,  1341,  1340,  1343,  1345,  1342,
       0,  1254,     0,     0,   732,  1302,     0,  1374,     0,  1378,
     151,   148,   149,   152,  1303,  1284,  1265,  1328,   590,     0,
       0,     0,  1263,     0,  1321,     0,  1280,  1274,     0,     0,
       0,     0,     0,  1365,  1294,  1326,  1364,  1292,  1324,  1291,
    1323,  1293,  1325,  1285,     0,     0,  1854,   854,     0,     0,
       0,   363,   363,   853,   730,  1267,     0,  1330,  1276,     0,
       0,     0,   947,     0,     0,     0,   949,   415,   433,   141,
       0,   750,   814,     0,     0,   830,     0,   485,     0,   491,
     498,     0,     0,   502,   503,   501,   486,  1181,   530,  1181,
     783,   784,     0,     0,   804,     0,   655,     0,     0,   461,
       0,   504,     0,     0,   465,   160,   159,     0,     0,     0,
     745,   749,   747,   746,   748,   743,     0,   734,   187,  2439,
       0,     0,     0,     0,   588,   582,   585,  1387,   821,     0,
    1853,   724,     0,   374,   604,     0,     0,     0,   461,   596,
       0,   466,   471,   472,   481,     0,   569,   560,     0,   561,
     570,   571,     0,   578,  1462,     0,   597,   578,     0,     0,
       0,   845,     0,   844,     0,  1113,  1130,  1131,     0,     0,
    1173,     0,     0,  1175,  1170,     0,     0,   763,   766,   759,
     642,   363,     0,  1491,   363,   363,  1230,     0,   891,  1032,
    1033,  1034,  1031,  1030,   634,     0,  1036,   995,   722,     0,
     595,   363,     0,   996,   972,   964,   971,   960,   963,   965,
       0,   967,   968,   962,   959,   961,  2244,  2081,  2084,  2095,
       0,  2169,  2200,     0,     0,  2039,     0,     0,     0,  2090,
    2679,     0,     0,  2131,  2132,     0,  2128,  2129,  2124,  2125,
    2106,     0,  2492,  2111,     0,     0,     0,  2004,  2002,  2001,
    1986,     0,     0,  1984,  1980,     0,  2009,  2133,     0,  2149,
    2146,  2166,  2200,  1704,  1703,  1702,  1701,  2138,  2288,  2138,
     233,  1691,  1839,     0,  1842,     0,     0,  1795,     0,     0,
    1797,     0,     0,  1799,  1801,     0,     0,     0,     0,     0,
       0,  2277,     0,  1765,     0,  1720,     0,  1735,     0,  1601,
    1586,     0,  1587,  1593,     0,     0,     0,     0,     0,  1629,
    1622,  1128,  1136,     0,     0,     0,   520,     0,   535,     0,
       0,     0,  1078,  1087,  1077,     0,   535,   535,   799,   798,
     801,   796,   800,  1502,     0,   673,   674,   677,  1273,     0,
    1334,  1282,     0,  1618,   302,   473,   309,     0,     0,     0,
     304,   384,   386,   305,   308,   312,   365,   325,   318,     0,
       0,     0,  1269,     0,  1332,  1278,  1305,  1356,  1252,  1316,
       0,     0,   863,     0,     0,     0,     0,  1357,  1253,  1317,
       0,     0,     0,  1376,  1375,     0,     0,  1618,     0,     0,
       0,     0,     0,     0,     0,     0,  1511,     0,     0,   364,
     852,   851,   365,   398,  1296,     0,  2057,     0,   948,   953,
     954,   952,     0,   404,   412,   415,     0,     0,  1221,  1221,
       0,     0,   482,   499,     0,   580,   539,   580,     0,     0,
       0,     0,     0,   692,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   737,   736,   182,     0,   461,     0,
     691,     0,   849,     0,     0,     0,   596,   463,     0,     0,
    1574,   462,     0,     0,   474,     0,   572,   561,   569,     0,
       0,   593,     0,  1455,     0,   599,     0,     0,     0,   793,
    1169,     0,  1183,     0,  1124,  1094,  1178,     0,  1696,  1846,
       0,     0,     0,     0,   776,     0,   646,  1222,  1489,   881,
     883,   729,  1039,     0,  1043,  1047,   966,  2229,  2171,  2036,
       0,  2232,  2231,  2235,     0,  2101,     0,  2102,  2130,  2108,
    2112,     0,  2109,  2110,  2005,  2003,  1988,  2135,     0,  1720,
    2168,  1674,  1673,     0,  1694,  1844,     0,     0,  1838,     0,
       0,  1868,     0,     0,     0,  1804,  1822,     0,  1800,  1798,
       0,  1811,     0,  1813,  2381,  2652,  2556,     0,  1752,  1754,
    1757,  1759,  1758,  1760,  1756,  2137,  2139,     0,  1731,  2192,
    1848,     0,     0,     0,  1073,     0,     0,  1630,  1631,  1626,
    1040,     0,   363,  1085,     0,  1181,   541,  2503,   542,  1084,
    1086,  1090,     0,  1181,  1181,   669,     0,     0,   281,     0,
     307,   317,   367,   379,     0,  1618,     0,     0,   861,   870,
     870,   858,     0,     0,   877,  1255,   733,     0,   544,     0,
     276,  1281,  1275,     0,     0,     0,  1513,  1514,     0,     0,
       0,     0,     0,  1304,   363,  1277,   956,     0,   435,   442,
     416,   420,  1505,     0,  1505,     0,   417,   421,  1505,  1505,
     414,  1846,   431,  1221,     0,  1218,  1217,   528,   610,     0,
       0,   489,     0,   550,   488,     0,   805,     0,     0,   690,
       0,   463,   559,     0,   517,   508,   509,   510,   511,   513,
     512,   514,   515,   516,   506,   505,     0,   691,   867,   374,
    1462,   731,     0,     0,   704,     0,   691,     0,  1577,   592,
     561,   463,   559,   467,   481,     0,   576,   569,   572,     0,
     573,     0,   577,     0,     0,     0,   596,  1515,  1072,     0,
       0,   794,  1182,  1143,     0,     0,  1172,  1176,  1177,     0,
       0,     0,     0,  1225,   770,   771,   765,   767,     0,   778,
     782,   641,     0,     0,   645,   636,   691,   363,     0,  2037,
       0,     0,  2114,  2113,     0,  2153,     0,     0,     0,  1685,
    1837,  1840,     0,  1871,     0,     0,     0,     0,  1857,     0,
    1802,     0,     0,  1812,     0,     0,     0,  1761,     0,     0,
       0,  1770,     0,  1599,  1846,     0,  1596,     0,  1639,     0,
    1632,  1054,     0,  1055,  1079,     0,   580,     0,  1090,  1093,
     530,   580,   580,  1283,     0,   610,     0,   320,     0,   289,
    1279,     0,     0,   872,   872,     0,     0,     0,     0,     0,
       0,   392,     0,     0,  1507,     0,  1508,  1509,  1512,   400,
     413,     0,   440,     0,   438,   437,   439,     0,   428,     0,
       0,     0,     0,     0,     0,   403,  1216,  1220,  1219,     0,
     490,     0,   492,     0,     0,   536,   537,   538,     0,   494,
     546,   547,   802,     0,   807,     0,   693,     0,     0,   691,
     558,   715,     0,     0,     0,  1456,     0,     0,   583,   725,
    1462,   596,   569,     0,   561,   475,     0,   578,   572,   576,
     574,   575,     0,  1459,     0,   598,     0,  1081,   792,     0,
    1173,  1184,  1179,  1174,  1418,     0,     0,   768,   773,   772,
    1505,   777,     0,     0,     0,   644,   643,   719,   997,  2228,
    2117,  2103,  2115,  2148,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1869,  1870,  1855,     0,     0,  1859,  1809,
    1835,     0,     0,     0,  1755,  2140,  2141,  2307,  1588,  1598,
    1074,     0,     0,     0,  1639,     0,     0,   545,     0,  1093,
    1075,   539,   794,   794,  1618,   314,   366,     0,     0,     0,
     868,   871,   859,   860,   879,   878,   735,  1618,     0,   388,
     387,     0,   391,     0,   436,   445,     0,   443,   418,   423,
       0,   427,   425,   424,   419,   422,   527,     0,     0,     0,
       0,     0,     0,   548,     0,   549,     0,   806,     0,     0,
       0,   717,   866,     0,     0,   461,   691,  1457,  1575,   572,
     561,   569,     0,     0,   563,  1085,  1085,   448,   576,   578,
    1460,  1461,     0,     0,   497,     0,  1095,  1417,  1416,  1696,
       0,     0,     0,   779,   780,   775,     0,     0,  2639,  2382,
    2611,     0,  2165,  2154,  2165,  2165,  2145,     0,     0,     0,
    1841,     0,  1858,  1861,     0,     0,     0,  1867,  1860,  1862,
       0,  1821,     0,  1833,  1763,     0,  1762,  1846,  1638,     0,
       0,   363,   534,   794,   543,  1076,   550,   523,   521,   282,
    1618,   862,     0,   277,     0,   393,  1510,   441,     0,   426,
     609,   493,   579,   555,     0,   554,     0,   552,   551,   803,
     808,     0,   691,   856,  1462,   705,   576,   569,   572,     0,
     562,     0,  1087,  1087,   578,   446,     0,     0,   374,     0,
    1400,  1696,  1399,  1401,  1409,  1406,  1408,  1407,  1405,     0,
    1228,  1229,   769,   774,     0,     0,     0,  2158,  2157,  2156,
    2160,  2159,     0,  2152,  2150,  2151,     0,     0,     0,     0,
    1864,  1865,  1866,  1863,  1808,     0,  1764,  1595,  1641,     0,
       0,  1633,  1634,     0,  1056,   525,   794,   290,   869,     0,
     444,   553,   530,   530,   691,   716,  1458,   578,   572,   576,
    1085,   564,  1086,   566,   565,   450,  1081,  1082,     0,   578,
     782,     0,  1410,  1404,  1672,  1659,     0,     0,   781,     0,
       0,     0,  2162,     0,  2163,     0,     0,     0,     0,     0,
       0,  1636,     0,     0,     0,  1635,   526,     0,   557,   556,
     718,   449,   576,   578,  1087,   497,  1080,     0,  1846,     0,
    1402,  1696,     0,     0,   787,  2155,  2161,  2164,  1690,  1689,
       0,     0,  1693,     0,  1834,  1640,  1637,     0,     0,     0,
       0,  1642,   389,   578,   447,   567,   374,  1083,  1063,     0,
    1403,     0,     0,   789,     0,   785,   788,   790,   791,     0,
       0,  1856,  1646,     0,     0,     0,   451,   578,     0,     0,
       0,   753,     0,  1720,     0,     0,     0,     0,  1846,     0,
       0,     0,   786,     0,     0,  1643,  1647,     0,  1644,  1064,
     787,  1226,  1227,     0,  1692,     0,     0,     0,   754,  1645
};

  /* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
   -5579, -5579, -5579,  3816,  -548, -5579, -5579,  -958, -1408,  3046,
   -2424, -5579, -5579, -5579,  1389, -5579, -5579, -5579, -5579,  3775,
   -5579,  1738, -2855, -5579, -5579,   137,  -431, -1387,   161,  3356,
    1416, -5579, -1011, -5579, -5579,  -628,     1, -5579,  -411,   465,
   -5579, -5579, -5579, -5579, -5579, -5579, -5579, -5579,  -832,  1849,
   -5579,  1943,  1216,  1250, -3446, -5579, -5579, -1503, -3685, -5579,
     512, -5579,   538, -4691, -1023, -5579, -5579, -5579,  1833, -5579,
   -5579, -5579,  1781,  1010,  -453, -5579, -5579, -5579, -5579, -5579,
   -5579,  -868, -5579, -5579, -1134,     5,  -650, -2887, -4216, -5579,
   -5579,   362,  -497, -1478, -5579,   551, -5579, -4542, -5579,  -109,
   -2631, -4282, -5579, -5579, -5579,  -467, -1456,  1307, -5579,  -728,
   -1124,  1656, -2019,  -987, -5579,  -342, -3487, -1108,  -882,  -879,
   -1019, -4276, -4748, -5579, -5579, -1138, -3740, -5003, -5251, -4775,
   -4720,  1315, -5579,  -137,   359, -5579,     6, -3609, -3693,     7,
     335, -5579,    11,    14, -5579,   351,  -815,  -964, -1578, -5579,
    -901, -5579, -5579, -5579, -3391, -5579, -5579, -5579,   140, -5579,
   -5579, -5579, -5579,   396, -5579, -5579, -5579, -5579, -5579, -5579,
   -2534,  1800,  1801, -5579, -4079, -5579,  -934, -5579,   557, -3383,
    1238, -5579, -5579,  1001,  3798,   382, -5579, -5579, -5579, -5579,
   -5579, -5579, -1772, -5579, -5579, -5579, -5579,  -116,  -441, -5579,
   -5579, -5579, -5579, -5579, -5579, -5579,    17, -5579,   962,   322,
   -5579, -5579,  -725, -5579, -5579, -5579, -5579, -5579, -5579, -1192,
   -5024, -1298, -1278, -5579, -3375, -5579, -5579, -5579,  -414, -5579,
   -5579, -5579, -5579, -5579,  -903, -5579,  1057, -4069, -5579, -5579,
     357, -5579, -5579, -5579, -5579, -5579,  -995,  -354,  2968, -5579,
    -589,  -792, -5579, -5579, -5579,  -353, -5579, -5579, -5579, -5579,
   -5579,  -517, -1292,  4786,  4174, -1081, 11638,  -835,  -575, -5579,
   -5579, -5579, -2720, -5579, -5579, -4158, -5579,  4777,  2365,  1234,
      18, -5579,   -12,    77,  3598, -5579,   918, -1165, -3037,   315,
    -552, -5579, -5579, -5579, -3041, -5579, -5579, -5579, -5579, -4011,
      19, -5579,  -717, -5579, -4297, -5060, -4492, -4046, -1166, -5579,
   -5429, -4113, -4391, -3994, -5579,  1824, -5579, -5579,  -540,  -181,
    2938, -5579, -1469,  2167, -1404, -5579, -2550,   371,  1394,  2946,
   -3228,  -138,  2933, -2966, -5579,  -731,   982, -5579,  -445, -3736,
   -5579, -5579, -5579, -2753,  -678, -5579, -5579,  1462,   838, -5579,
   -5579, -5579, -5579,  -638,  2922,  -190, -5579, -5579,  4157, -5579,
   -4857, -5579,  4113, -5579, -5579, -5579, -5579,  2835,  2843, -5579,
   -5579, -1450,  1161, -5579,  -806, -5579, -5579,  1933,   589, -5579,
   -5579, -5579, -5579,  1246, -1241, -5579, -5579, -5579, -5579, -5579,
   -5579, -5579,  -979, -1180, -5579, -5579, -4823, -5579, -5579, -5579,
   -5579, -5579,  2371,  -949,  -754,  4007,   947,    28, -5218, -5579,
   -5579, -1183, -5579,  3352, -5579, -5579, -5579, -5579, -5579,   376,
     373, -5579, -5579, -5579, -5579, -3863, -5579, -5579, -4914, -5579,
   -5579,  1909, -5579, -5579,   640,     8,  3070, -5579, -5579, -5579,
     -35, -5579, -5579, -1027,  2259, -5579, -2355, -5579,  -597, -5579,
   -5579, -1896,    30, -4275, -5579,     2, -5579, -5579, -4930, -1189,
     207, -5579, -5579, -3920,    21, -5579, -5579, -5579, -5579, -4920,
   -5579,    27, -5400,   728, -3279, -5579,     4, -5579,  -499,  -874,
   -5579, -5579, -5579, -3662,    31,   129, -5579, -5579,    23,   324,
     -45,   -59,   -42,    15,   120,  3494, -5579, -5579, -5579, -4688,
    3527, -5579,    -2,  -862,  4824,  4827, -5579,  -885,  -157, -5579,
    1505,  -709, -2555,  3446,  3441, -5579,  1493,  2273, -2426, -2432,
   -5579,  -977,  -852,  -681, -5579, -5579, -5579, -5579, -1515,  -704,
   -2559, -5579,  3443, -5579, -5579, -5579, -2341, -3301, -3219,  1528,
   -3232, -3135, -5579,   815,   799,  -944,  -185,    60, -1470,  -787,
    1716, -5579, -5579,  1538,  -433, -5579, -5579,  -430, -3224,   758,
   -5579, -4476, -2781,  1542, -1105,  -825, -5579,  -952, -5579,  -646,
     437,  3501,  -823, -5579, -5579,  -795, 13772, -5579, -5579, -5579,
   14441, 14708, -5579, -5579, 15136, 15763, -5579,  -620, 16058, 12816,
    -785, -1926,   -66, 18047, -1617, -1024,   102, -5579, -2856, -2377,
   -5579, -5579, -5579,  -394,   904,   340, -5579, -4490, -4339, -5579,
   -5579, -1874, -5579,  -657, -5579,  -655, -5579, -5579, -5579, -2560,
   -5445, -2657,  2402, -5579, -5579, -5579,  -202, -5579, 18348, -3195,
   -5579,  -695, -1013, -1586,  2875, -3108, -1881, -5579, -5579, -5579,
   -3071, -5579, -5579, -5579,  -683,  1637, -5579, -5579,  1739, -5579,
   -5579, -5579,  -931,  1976,  -757, -1167,  1643,  4021,  -782,  2408,
    -800, 16468,  -718, 10971, -1288, -5579,  4571, -5578,  7054,  7287,
      20,  -148,  1786,  -549,  2325,  3124, -5579, -5579,  4928,  8833,
    -543,  -948, -5579,    -6, 13206, 12160, -3618, -5579
};

  /* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
      -1,    58,    59,    60,    61,    62,    63,  1596,  2976,  2830,
    3764,  3765,    64,    65,  1592,    66,    67,    68,    69,  1506,
      70,  1085,  1844,  2990,    71,  2666,   830,   831,   832,  2531,
    2532,  2921,  2533,  2521,  1357,  1790,  1528,   804,   805,  1488,
    1529,    73,    74,  1351,  2512,    75,    76,    77,  1559,  1652,
    1560,  1561,  1500,  1890,  4826,  5587,  3554,  2785,  3812,  3555,
    3556,  4197,  4198,  4286,  5601,  5602,    78,  1668,  1669,    79,
      80,  2958,  3730,  4339,  5193,  5194,  5430,   640,  4849,  4850,
    5417,  5418,  5615,  5766,  5767,  2991,   671,  3807,  4423,  3755,
    4920,  3756,  4921,  3757,  4922,  4187,  4188,  3741,  4370,  4371,
    2035,  4862,  4372,  3758,  4881,  5464,  3759,  2685,  5630,  3025,
    1962,  1960,  5365,  5443,  4682,  4683,  4260,  5639,  5640,  5641,
    5887,  4883,  4926,  4927,  5803,  5804,  3810,  4429,  4933,  5251,
    5441,  3452,    82,  3783,  3784,    83,   734,  1866,  3909,   735,
    3028,   672,   736,  2992,    88,  3018,  5632,  3019,  1622,  2844,
    4352,  3887,    89,  1112,  4162,  5276,  5524,  5525,   725,    90,
    1852,    91,    92,  2971,  3748,    93,  2702,  3469,    94,    95,
    3488,  3489,  3490,    96,  4380,  5212,  1562,  3543,  3544,  3545,
    3546,  4218,    97,  1847,  2999,  3000,    98,    99,   100,  3129,
    3130,   101,  2907,   102,   103,   104,   105,  4254,  4784,  4897,
    3585,  3771,  4396,  4895,   106,  3734,  2993,  3046,  3845,  3846,
    5274,  5516,  5517,  5518,  5690,  5922,  5520,  5692,  5825,  5694,
    4872,  6054,  6055,  5501,  4151,  4696,   108,  4873,  4874,  5645,
     109,  2700,   110,   111,  1821,  2964,  2965,  4353,  3035,  3820,
    3821,  4409,  4410,   112,  3672,   113,  4760,  4761,   673,  5653,
    5593,  5752,   114,   115,  4764,  4765,   116,   117,   118,   119,
     120,   726,  1047,  1048,   728,  1167,  1168,  3424,  1129,   121,
    2541,   122,  3710,   123,  1243,  4985,   124,   760,  1183,  1184,
    2994,   126,   770,  3148,   772,  3114,  3115,  1978,  3891,  3892,
    4497,   127,   128,  3126,  3151,   129,  1493,  2676,  2677,  4677,
    2995,   674,  1228,  3032,  3447,  5353,  5102,  5354,  5814,  5978,
    5103,  5371,  3368,  4100,   131,   675,  1534,  2741,  1135,  1136,
    3039,  3825,  2646,  2647,  1691,  4450,  2649,  3827,  2650,  1466,
    2651,  1122,  1123,  3833,  3834,  3835,  3836,  4446,  4456,  4457,
    5268,  5509,  4453,  1840,  5262,  5263,   132,  1531,  2738,   133,
     134,   135,  1575,   972,  1145,  1146,   136,   687,   688,   137,
    5435,   138,  1125,   139,  5272,   140,   141,   795,   796,   142,
     143,  2755,  4200,   144,  1532,   145,   146,  3579,  3580,  4776,
     147,   148,   149,  2816,  2817,   150,   151,   152,   153,   154,
    5912,  5981,  5982,  5983,  4464,  5819,   155,  1215,   156,   157,
     158,   159,   197,  1013,  1014,  1015,   925,  2996,  5253,   161,
     162,  1489,  1490,  1491,  1492,  2671,   163,   164,   165,  3855,
    3856,   166,   167,   168,   169,  1824,   170,   171,  5408,   172,
     173,  1794,   174,   175,  1021,  1022,  1023,  1024,  1792,  3316,
     634,   849,  1382,  1388,  1431,  1432,  1433,   177,   738,   178,
    1223,  1052,   739,  1176,   180,   740,  2628,  3398,  4115,  4116,
    4117,  4120,  5086,  4654,   741,  3394,   183,  1985,  3135,  3138,
    3390,   742,  3404,  3405,  3406,  4124,   743,  5357,  5358,  5733,
    5951,  5952,  6005,  6041,   744,   762,  1115,  3050,   745,  1318,
     189,   190,   191,   905,   852,   853,  3321,  5314,  5539,   193,
    2505,  3299,   779,  1437,   893,   894,   895,   914,  2931,  2594,
    2595,  2619,  2620,  1446,  1447,  2607,  2611,  2612,  3381,  3374,
    2600,  4094,  5338,  5339,  5340,  5341,  5342,  5343,  4643,  2615,
    2616,  1449,  1450,  1451,  2624,   194,  2584,  3349,  3350,  3351,
    4071,  4072,  5851,  4086,  4082,  4628,  5063,  3352,   841,  1213,
    1458,  4636,  5853,  3353,  5052,  5053,  5318,  4090,  3360,  4111,
    3795,  3796,  3797,  3354,  5547,  5548,  5848,  5849,  5320,  5321,
    2652,  1411,   879,  1319,   880,  1424,  1320,  1398,   882,  1321,
    1322,  1323,   885,  1324,  1325,  1326,   888,  1390,  1327,  1328,
    1407,  1420,  1421,  1383,  5322,  1330,  1331,  1332,  3356,  1333,
    4574,  5025,  5011,  3226,  3227,  2528,  4570,  3994,  4564,  2500,
    3289,  5075,  5345,  5346,  4034,  4598,  5039,  5309,  5707,  5832,
    5833,  5933,  1334,  1335,  1336,  3286,  2494,   975,  1337,  4355,
    2496,  3217,  3195,  1694,  3196,  1988,  2009,  3167,  3183,  3184,
    3263,  3197,  3205,  3210,  3218,  3250,  1338,  3169,  3170,  3934,
    2011,  1339,  1019,  1697,  1020,  1426,  3245,  1347,  1348,  1341,
    1979,   842,  5059,  1171,  1777,   776,  1342,  1343,  1344,  1345,
    1568,   946,  1138,  1139,   896,   898,   899,  2588,   630,   622,
     948,  3547,  2497,   631,   624,   625,  1782,  2498
};

  /* YYTABLE[YYPACT[STATE-NUM]] -- What to do in state STATE-NUM.  If
     positive, shift that token.  If negative, reduce the rule whose
     number is the opposite.  If YYTABLE_NINF, syntax error.  */
static const yytype_int16 yytable[] =
{
     623,    72,   181,  1693,   185,    81,    84,    85,   176,  1170,
     974,    86,   904,  1789,    87,   192,  1079,   107,   125,   130,
    1352,   182,   973,   187,  1621,   809,   938,   184,   160,   737,
     179,   186,  1452,   915,   979,  1340,   192,   984,  2684,  1204,
    1205,  1206,   764,  2857,   844,  1210,   892,  1673,   764,  1438,
    1403,  1440,  3451,  2779,  1567,  1626,  1423,  1379,  1116,  1905,
     926,  2648,  2750,  1849,  2742,  1685,  3391,  1394,  1395,   982,
    1778,  3392,  1999,  1366,  3837,  4434,  1402,  1959,  4045,  1229,
    4047,  1177,  2006,  1004,  2751,  3895,  1378,  3013,  3754,  1783,
    1025,  1409,  4109,  3141,  1471,  2762,  4168,  3417,  3419,  4684,
     771,  4459,  2925,  4408,  4645,   840,  1822,  4261,   619,  4719,
    1827,  4421,  3914,  3669,   810,  1831,  2818,  2818,  1046,  3637,
    2818,  4085,  4357,  1791,  4123,  1841,  3166,  3235,  4068,  2648,
    4679,  5056,  3776,   917,  2580,  1178,  2733,   628,  1861,  4189,
    4940,   909,   233,  1118,   679,  4919,  3785,  1161,  1563,  4929,
     918,  5351,  2887,  2888,  4744,  1384,  1620,  4213,  3080,  4215,
    1151,  5068,  5255,  5070,  3302,  1651,  4880,  1149,  3304,  1894,
    1153,   855,  4098,  1585,  1164,  1678,  1834,  5125,  1602,   829,
    3386,  5248,  4122,  1535,  3383,  4129,  5447,  3314,  4018,  5216,
    1025,  1858,   623,  4418,  5104,  1359,  2733,   803,  5499,  2883,
    4660,   623,   949,  5378,   837,  1445,  3357,  1530,  4928,   623,
    1448,   949,   623,  2733,  2713, -2424,   746,  4083, -2462,  4088,
    3713,  2899,  3716,  3717,  5016,   949,  2914,  3721,  3722,  3723,
    3773,  3725,  3726,  3727,  3362,  5667,  3958,  5247, -2348,   685,
    1391,  1392,  2056,  5486,   638,  1857, -1895,  5400,  1530,   746,
    1401,  1025,  5655,  1530, -2487, -2525,  2894,  5101, -2281, -2316,
    5410,  5411,  4444,  1887, -2427,  3744,  1185, -2317, -2316, -2316,
     680,  1378,  2539,  2545,  6037,   746, -2317, -2317,  1887, -2695,
    1118,  1502,  1887, -1908,   924,  2753,   997, -1933, -2695, -2695,
   -1928, -1923,  1189,  3694,   685,   685, -2280,   685,   685,  1238,
    2753,  1887,  1105,  2668,  2753,  1025,  2547,  1564,  3932,  2518,
   -1936,  1564,   685,   746,  3010,  2881,   847,   746,  1819,  4345,
   -1936,  3243,   936,  5844,   188,   685,  -141,  3899,   746,  1887,
    1814,  5857,  -141, -2277,  5592,  4911,   685,  2678,  2956,  3109,
    1887,  2503,  5436,  3421,  5084,   188,  2821,  3901,  2753,  2825,
    2974,  1356,  1217,  3243,  4987,  4988,  4989,  2585,  4991,  4992,
    4993,  4994,  4995,  1887,  3912,  1025,  4878,   685,  2818,  4941,
    3022,  1216,  3560,  5566,  1682,  3745,  5902,  5903,  1009,  4503,
    5962,   903,  5244,  5926,  1369,  1887,  1871,   752,   636,  2803,
     752,  2753,  4865,  3337,  5209,  1503,  3023,  3290,  3388,  5555,
    1657,    41,  4280,  2056,  1502, -2485,  3608,  2591,  2753,  2979,
     752,   753,  3202,  5013,   753,  2680,  3958,  1685,  5809,  6031,
    2614,  3583,   195,  3359,  2519,   632,   752,   752,  2866,  3365,
    1836,  5406,  4194,  2985,   753,  2681,   752,    45,  5845,  5127,
    3928,   635,  5797,  1658,  2753,  2556,  5132,  1783,  2753,   774,
     753,   753,   974,  3015,  5407,  2754,  6038,  2867,  1370,  2761,
     753,  4735,   685,  2522,  2753,  5589,   196,  2547,  2534,  2534,
    1234,  4125,  1394,  1395,  1778,   633,  1936, -2175,  1010,    49,
    1940,  1118,  6074,  2753, -2175,  5669,  3608,  5444,   195,   878,
    2583,   919,    50,  1402,  2056,  2587,  3584,  4405,  3011,  5487,
    -434,  2678,   974,  2056,  1073,  5475,  3389,  3283,  1991,  1417,
    1083,  3958,  5210,  1409,  3284,    51,   916,  3150,  1503,  3366,
    2679,   868,  1096,  2020,  5014,  2545,  2540,  2804,  2980,  1011,
   -2194,  3150,   196,    57,  2545,  4504,  5948, -2194,  5963,  3291,
    5567,  6014,  2690,  2520,  2975,  6025,  1017,  5949,  4866,  1888,
    1018,  5111,  1683,  3422,   681,  3900,  3423,  5904,  2547,  5085,
    4879,  2050,  1248,  1643,  1888,  3958,  3746,  2547,  1888, -2820,
   -2820, -2820,  4373,  5438,  1983,  3902,  5626,  5780,   920,  2680,
    3463,  3561,  1642,  2957,  1943,   686,  2682,  1888,  1012,  2508,
    3024,  5846,  2900,  5332,  1838,  2860,  5847,  2983,  1913,  2681,
     957,  3110,  6035,  6039,  1783,  4357,  3709,   958,   959,   960,
    2720,  4454,  1069,   682,  2003,  1888,   937,   921,  1659,  4890,
    2727,  2901,  2049,  2913,  3168,  3357,  1888,   949,  2582,  1853,
    2504,  4779,  1209,  1504,  1110,  4445,  1391,  1392,  3492,  2967,
    3695,  1053,  2882,  1056,   848,  5967,   949,  1820,  1820,  1888,
   -2485,   683,   949,   684,   192,  3747,  2895,  6040,  2852,  1980,
    1054,  2855,  1057,  1401,   949,  5808,  1055,  1240,  1574,  2558,
    3012,  1888,  1854,  2923,  2924,  1990,  5966,  2718,  5298,  1017,
     949,  3244,  2780,  1018,  1984,   623,  3568,  2824,   904,  2000,
     892,  5763,   639,  2862,   623,   949,  1505,  1209,  2561,  1118,
    2683,   623,  1181,   949,   623,  3331,  1889,  2842,  4889,  1820,
    2845,  2846,  3162,  4023,  4891,  4191,   892,   949,  6013, -2424,
    3973,  1896, -2462,  1660, -2485,  1900,  2493,   949,  2780,  4281,
     758,   759,  5662,  2516,  1389,  2922, -2485,  2875,  2876,  2796,
    4936,  1393, -2348,  2625,  1911,  5090,  4318,   192,  2626,  4937,
    2682,  1017,  5906, -2281, -2316,  1018,   758,   759, -2487, -2525,
    1453,  6043, -2317,  1684,  2634,  2797,  1404,  1182, -2427,  1187,
    4787,  1191,  1933,  4689, -2695,  4789,  1404,  1195,  1397,  2563,
    2564,  1594, -1933,  1936,  2841, -1928, -1923,  1405,   949,  2052,
    2506, -2280,  3307,  6059,  1565,  1566,  5896,  1405,  1565,  1566,
    2737,  4892,  4706,  5925,  1595,  1406,  1903,   922,  2930,   758,
     759,   623,   623,  -141,  -141,  1408,  4848,   949,  1118,  2780,
    4357,  4749,  2763,  4125,  5869,  3131,  1118,  1118,  4496,  4192,
    4406,  4085,  5286,  2586,  3098, -2175,   974,  5873,  4406,  1212,
    3964,  1017,   949,  1903,   623,  1018,   917,  1855,  1805,  4337,
    4338,  3082,  5950,  2737,  1801,  4625,  5737,  4496,  1806,  4629,
    1807,  5742,  5743,   918,  2683,  3285,  4131,   892,  4132,  2691,
    2737,  5574,  2966,  4509,  5112,  4418,  4374,  4528,  4096,  3395,
    1368,  4275,  4276,  1984,  3108,  5439,  4277,  1839, -2194,   623,
    1198,  1796,  5807,  5781,  3464,  5969,  3123,  3970,  3971,  3972,
    3973,  2944,   949,  2781,  1212,  4669,  1070,  1887,    72,   181,
    4455,   185,    81,    84,    85,   176,  5801,  4460,    86,  4256,
    4399,    87,   192,  5532,   107,   125,   130,  4616,   182,  4618,
     187,  3268,  1487,  1132,   184,   160,  2984,   179,   186,  5883,
    2805,  4103,  5665,   803,  1218,  1220,  3383,  1200,  1460,  2781,
    5957,  4851,  1856,  3550,  3132,  4169,  5789,   912,  1355,  1922,
    4893,  4052,  1363,   188,  5817,  6012,   910,  3357,  4852,   685,
    3357,  1385,  5800,  2488,  2489,  2490,  2491,  2492,  2493,  5170,
    5579,  1552,  1457,  1413,  2490,  2491,  2492,  2493,  4164,  2712,
    3968,  3969,  3970,  3971,  3972,  3973,  5914,  1509,  4332,  2780,
     685,  4757,  1923,  5171,  4461,  3203,  3176,  5522,  3551,   685,
     623,   623,  1779,  3483,  3224,  5270,  3357,   912,   949,  4397,
    2780,  5480,  2598,   623,  3357,  6068,  2874,  5627,   892,   623,
    4894,  2034,   911,   623,  5905,   623,  5454,  4193,  4194,   892,
    2781, -2820, -2820, -2820,  3968,  3969,  3970,  3971,  3972,  3973,
    2780,  2988,  5897,  4684,  4777,   892,   188,   903,  1414,  2692,
    2780,  3396,  3903,  4126,  2686,   789,  5711,  4195,  2782,  2854,
    5383,  3269,  3127,   815,  1435,  2587,  3270,  4916,  4960,   963,
     964,   965,   966,   967,   968,   969,   970,   971,  5914,  3732,
    5455,  5489,  2687,  5456,   919,  1594,  3484,  2783,   623,  5457,
     623,   623,  3841,  4917,  4905,   685,  5490,  3552,  6063,  2780,
     912,  2780,   778,  3271,  2782,  4758,  3177,  2780,  1595,  1783,
    2599,  1415,  2784,  4809,  1416,  1369,  1201,  5458,  3241,  5975,
      41,  5919,  2989,  1130,  4870,  5533,  2764, -1895,  3600,  2780,
    3026,   949,  3904,  2783,  5884,  2847,  5818,  5928,  1461,   787,
    2765,  5474,  2766,   790,   803,  1218, -1749,  6095,  3128,  1130,
    2884,  2778,  3133,  4462,  1248,  1413,    45,  3958,  2784,   623,
    2929,  3959,  3960,  3961,  3120,  3121,  5648,  1924,   816,  1436,
    5628,   920,  3134,  1839,  5459,  5523,  5246,  5739,  4579,  3842,
    4354,  3178,  6011,  1888,  3450, -1748,   192,  5460,  5914,  1370,
    1820,  5676,   949,  5661,  6018,  2782,  5664,  2778,    49,  5461,
    4104,  1234,  2693,  2767,  5265,  4169,   892,  3084,   949, -1895,
    2781,    50,  4759,  5919,  3601,  5885,  5240,  1133,  5234,   916,
    3697,   188,   949,  4463,  2783,  5647,   949,  1417,  6044,  4265,
    1414,  2781,  1025,  3416,    51,  2688,  3107,  3022,   623,  4165,
    3112,   913,  1879,  5886,  3179,  3119,  3483,  3180,  3122,  2784,
    5271,  3272,  3397,  5377,  6087,  5663,  3493,  5172,  6066,  3511,
    4984,  2781,   904,  3023,  3487,  3528,  3553,  1208,  3602,   623,
    4451,  2781,  1925,  2848,  4871,  5491,   651,  2849,   788,  4685,
    2050,  3334,  6078,  3343,  3733,  5635,  5929,  4918,  2778,   814,
    4810,     3,     4,  1415,  2694,  5096,  1416,   623,   623,   623,
    3163,   623,  3165,  1945,   731,  1947,   791,  1949,  3172,  1951,
    3057,  1953,  1954,  1955,  3186,  3187,  3188,  2728,  1957, -1749,
    2781,   623,  2781,  5919,    15,  3207,  3529,  3603,  2781,  3484,
    2915,  3222,  3142,  3704,  3569,  3091,   653,  2543,  1418,  2733,
    5572,  5939,  3078,  3061,  3335,   949,   838,   792,   793,  3059,
    2781,  3494,  -686,   949,   949,  1209,   731,  3073, -1748,    20,
    3181,  1419,  3963,  1180,  3072, -2598,   974,  3074,  2592,  2593,
    3079,  2597,  4050,  4105,  5089,  2782,    15,   623,  5651,  3193,
    5057,  3570,  1903, -1895,  4916,   918,   918,  5659,   918,  1475,
    5462,  4273,  2902,  5463,  3843,  1475,  2782,  5060,  1494,  3954,
     922,  6039,  5064,  1009,  2783,  5066,  1779,  1662,  3844,  1417,
    4917,    20,  2729,  1663,  4387,   907,  4648,  3111,  5636,  5991,
    1903,  3117,  3118,   623,  1226,  2783,  2782,   623,   623,  2784,
    2672,  2857,  3964,  -459,  3604,  2055,  2782,  5697,  2056,  3653,
    4283,  2673,  4320,   623,  1248,  3654,  4977,  3958,  4708,   892,
    2784,  3959,  3960,  3961,  2687,  2783,  4981,  5228,  4692,  2674,
    1417,  1800, -2598,  3446,  4539,  2783,  4540,  1586,  2778,  2545,
    4751,  3182,  1809,   789,  4950,  1476, -2820,  3161,  1380,  5704,
    2784,  1476,  2696,  3303,  5213,  2782,  2601,  2782,  1817,  2778,
    2784,  4722,  2697,  2782,  5637,   188,  3102,   850,  5488,  5992,
    1104,  3043,  2547,  1010,  1457,  4239,  1457,  3487,   664,  5730,
     665,  4357,  1495, -2598,  2783,  2782,  2783,   892,  1227,  2778,
    1418,  1664,  2783, -1072,  3044,  4723, -2598,  6003,  1477,  2778,
    2903,  2602, -2598,  5479,  1477,   906,  1835, -2598,  1430,  2784,
    3785,  2784,  4693, -2598,  2783,    33, -2598,  2784,   923,  5617,
   -2598,  5619,  -459,  3655,  1011,  5623,  5624,  3605,   892,  3826,
    5791,   790,  5493,  1105,  2008,  3606,  3375,  1783,  3607,  2784,
    5494,  4008,  3955,  3956,  1051,  5740,    41,  3975,  2778, -2598,
    2778,  1587, -1895,  1487,  2017,  5993,  2778,  4388,  1487,  4649,
   -1895,   892,  1393, -1895,  1422,  4287, -1895,    33,  3438, -2598,
    1441,  4842,  4541,  6004,  5795,  4694,  4846,  4724,  2778,  4695,
    3219,  5399,    45,  1012,   924,  2675, -2820,  4006,  4007,  4240,
    2648, -2820,  4910,  1778,  2648,  5705,  1478,  5588,    41,  3483,
    3962,  2047,  1478,  3965,  3966,  3967,  3968,  3969,  3970,  3971,
    3972,  3973,  5839,  2604,  4907,  1515,  3103,  1106, -2598,  1987,
    3436, -2598,  3963,  2698,    49,   949,  5706, -2598, -2820,  4762,
    5995,  1487,  3530,  4354,    45,  1487,  1174,    50,  1365,  3496,
     623,   623,   623,  1443,  1248,  1009,  1496,  3958,  5996,  3104,
    5382,  3959,  3960,  3961,  3439,  1665,  3045,  3357,  2667,  4775,
      51,  3357,  3105,  2699,  1479,  2878,   632,  4181,   974,   974,
    1404,  5546,  1480,  2605,  3659,   956,    49,  5895,    57,  3060,
     732,  3070,  3484,  2552,   811, -2598,  1497,  3656,   955,    50,
    3667,  1405,  3964,  3531,   791,  1666,  5414,  3106,  4869,  5536,
    1481,    41,  5994,  5409,  1482,  5865,  5495,  5668,    36,  4646,
    1903,  3053,    51,  1552,  3660,  1588,   908,  3485,  3220,  1241,
    1498,   916,   916,  5054,   916,  1623,  1903,  3657,  3357,  1667,
     733,  3450,  1880,  4284,  3497,   792,   793,    45,  1483,   949,
     778,  3100,  4182,  4763,  5654,  1010,  1881,   932,  3661,  5973,
    5974,   892,  3682,  4241,  3125,  1589,  1441,  3486,  1663,  3100,
     934,  3658,   892,  5675,  1484,  1624,  1485,  1107, -2598,  5537,
    1484,  4647,  1485,  5965,  1779,  5217, -2820,  3100,   892,    49,
    1403,  4113,  4285,  3387,   195,   974,  1604,  5822,  1499,  1590,
    3557,  4147, -2598,  4242, -2598, -2598,  1011,   949,  5823,  1903,
    1248,   999,  1882,  3958,  1108,   949,  5328,  3959,  3960,  3961,
    3929,  4278,  1441,   949,  4076,  3930,  3581,  4114,  1442,  5406,
    1008,  5977,  1486,  5218,  4580,  3322,  1605,  4243,   196,  1443,
    5824,   892,   794,    57, -2598, -1719,  3619, -2598, -2598, -2598,
     623, -1719,  5407,   623,  5521,  6010,   892,  4077,  4354,   892,
     892,  1016,  3963,   623,   623,  1012,   949,   949,  4747,  2510,
    3487,  6045,  4631,  1109,  1936,  1110,  1664,  1576,   623,  1111,
     949,   623,  4079,  1820,  3509,  1625, -2820,  2758,  1444,  2759,
     892,   892,  5799,   949,   949,  1443,  4279,  2488,  2489,  2490,
    2491,  2492,  2493,  3965,  3966,  3967,  3968,  3969,  3970,  3971,
    3972,  3973,  1883,  3620,  5816,  5285,   993,  4671, -1719,  4358,
    4860,  3623,  1859,  5568,  3626,  3581,  1930,   192,  2789,  1059,
    4223,   623,  3964,  5749,   746,   623,   623,  1061,  5798,  3803,
    2511,  6047,  4224,  4748,  1444,  1860,   994,  4861,  5569,  1931,
    2760,  1577,  3859,  1186,  1188,  1190,  3147,  3662,  1192,  1193,
    1194,  1053,  5215,  1056,   947,  4863,  4361, -1719,  1199,   623,
    1884,   623,  2847,   983,   192,  1591,   623,   623,  3618,  2648,
    1054,  2801,  1057,   623,   623,   623,  1055,  1005,   623,  2648,
     623,  3742,   623,   623,   623,   623,   623,   623,  3357,  3357,
     623,  5239,   623,   623,  4081,  4180,   623,  5750,  3698,  3699,
    3700,  2857,   651,  5226,  3136,  5510,  3643,  3785,  3963,  4521,
     892,   623,   623,   623,  4363,  1361,  5360,  2828,  5362,   752,
    2770,  5898,  2831,  3595,  5688,  4002,  4864,  5646,   623,  2916,
    1779,  1097,  1594,  3092,  3146,  3093,  1066,  3094,  2514,  3095,
    3688,  3096,  4358,   753,  2526,  3097,  2770,  3668,  4359,  2601,
    3593,  5108,  3594,  5235,  2771,  1595,  1632,  3853,  1885,  4482,
    2648,  4360,   653,  3789,  3790,  3791,  3792,  1098,  3794,  2917,
    5689,  3704,  -601,  -141,  5205, -1099,  5207,  4327,  3964,  -164,
    2771,  5188,  2818,  5189,  5190,  5191,  5679,  2527,  1118,  4361,
    4672,  4362,  5696,  3822,  2602,  2905,  4673,  5420,  1080,  2911,
    2848,  2056,  1099,  4674,  2849,  1093,  1097,  4692,  5197,  5201,
    3634, -2300,  3635,  1467,  4366,  -164,  3639,  5968,  4614,  1462,
    -600,  1633,  5109,  3965,  3966,  3967,  3968,  3969,  3970,  3971,
    3972,  3973,  2545,  1480,  5658,  3203,  3203,  3319,  4675,  1472,
    3203,  5198,  1098,  5421,  1653,  -164,    41,  4363,  1102,  1468,
    1100,  4282,  1839,  1469,  5815,  3506,  1839,  2603,  4367,  1463,
    4676,  3320,   651,  1634,  1071,  2547,  1072,  5625,  5422,    36,
    1635,   623,  3886,  1636,  4368,  4364,  1629,  4400,  1101,  1473,
    3203,  3203,    45,  5979,  1654, -1066,  5423,  1470,  1655,  4685,
    5424,  4693,  1103,  1464,  2939,  4495,  4319,  3592,  1607,  2827,
    4128,  1936,  3357,  4685,  5527,  2950,  2604,  1131,  5514,  3357,
    5863,   623,  5425,  1474,  3357,  5426,  1630,  3357,  1656,  3663,
    1608,  2968,   653,  4236,    49,  1100,   188,  5997,  1404,  1594,
    5427,  3665,  5515,  5620,   664,  3992,   665,    50,  5621,  5591,
    4496,  3999,  4365,  4467,  5595,  5596,  2918,  4366,  4468,  1405,
    1631,  5998,  1595,  3664,  4694,  1075,  1404,  1076,  4695,  2919,
      51,  3815,   669,  4237,   623,  3666,  2605,  1406,  4430,  2790,
      41,  1609,  4369,   188,  3042,   746,   655,  1405,    57,  3965,
    3966,  3967,  3968,  3969,  3970,  3971,  3972,  3973,  2920,  3054,
    5622,  4367,  1130,  3058,  4135,  1408,  1120,  4238,  3777,  1393,
    5729,  2581,  4535,  4536,  4537,  4538,    45,  4368,  4542,  4543,
    4544,  4545,  4546,  4547,  4548,  4549,  4550,  4551,  4811,  3221,
    5428,  6067,  1248,  3077,  1130,  3958,  4828,  5867,  5868,  3959,
    3960,  3961,  1597,  1124,  1637,  5406,   234,  4728,  4101,  1897,
    3228,  4812,   637,  3231,   746,  1901,  5031,   761,    49,  4829,
     729,  1670,  3885,   761,  1674,  1912,   782,  1140,  5407,  1915,
    1610,    50,  4685,  1918,  1147,  1920,  4589,  4590,  2534,   812,
    1638,  1928,  5429,  6085,  1639,  6088,  1944,  1934,  4046,  1946,
    1937,  1948,  2811,  1950,    51,  1952,   783,  3910,  3911,  1956,
     784,  2007,  4944,    57,   664,  6099,   665,  4468,  1074,  2835,
    1784,  1584,    57,  1785,  1074,  4369,  1601, -1099,  1640,  1611,
    1017,  1141, -2281,  1612,  1018,  1641,  1074,  1017,  1158,   668,
    5054,  1018,  1835,  1399,  1400,  4075, -2273,  5416,  2856, -2274,
    1393,  1017,  1422,  1203,  1017,  1018,  1203,  1165,  1018,   623,
     623,   623,   623,   623,   623,   623,   623,   623,  5955,   623,
    4668,  1942,  1175,  3236,  1785,  1393,   632,  2581,   623,   746,
     623, -1672,  1614,  1202,  1248,   974,  3957,  3958,  3336,  3338,
    3339,  3959,  3960,  3961, -1672,  1207,  1992,  3476,  3985,  1785,
   -1672,  3254,  3255,  3256,  3257,  3473,  3357,  3477,  3478,  3984,
    2542,  3986,  3987,  1785,  2927,  2928,  2555,  5680,   623,  2556,
    4076,  1203,   623,  4057,  4058,   623,  3249,   623,  1616,  1211,
     623,  3315,  4048,  4009,   623,  2589,  4170,  3088,  1785,  3099,
    2556,  1214,  3100,  3101,  3600,  3470,  3100, -1672,  1224,  3139,
    3963,  1617,  3140,  4077,  1393,  1779,  2581,   623,  1222,  4130,
    3318,  6006,  4199,  1936,     3,     4,  3760, -1672,  4078,  4354,
    2055,  1619,  1225,  2056,   623,  3505,  4036,  1231,  4079,  1248,
    1607,  4091,  3958,   623,   623,  1232,  3959,  3960,  3961,  1227,
    3323,  3408,  5576,  2556,  2556,  3503,  3575,  4734,  3504,  3576,
    5581,  5582,  1608,  5032,  2545,  3738,  4080,  4021,  3739,  2582,
     949, -2820,  3877,  5947,  1233,  3100, -1672,   892,  3384,  3385,
    3964,   892,   892,  4912,  3927, -1672,  3936,  2556,   949,  2556,
    3601,  3399,   949,  5061,  1234,  3942,   949,  2547,  2556,  4173,
    3048,  3440,  3049,  3443,  1783,   949,  3943,  3944,  3977,  2556,
    2556,  2556,  3991,  1609, -1671,  2556,  4416,  3996,  1235,  4055,
    3997,  3599,  2556,   949,  1237,  3355,   623, -1671,  3357,  1236,
    4725,  3437,  4732, -1671,  4037,  1364,  4038,   623,  5861,   892,
     623,  1242,   623,   623,  3602,   892,  1244,  4716,  3357,  4685,
    4216,  5502,  3963,  4217,  1367,  4221,  4247,   949,  4222,  4248,
    4081,  4707,  3357,  4139,  4316,  4439,  4020,  4248,  4440,  2648,
    4442, -1743, -1743,  4443,   910,  4231,  1371,   949,   949, -1672,
   -1671,  4039,  4473,  4040,  4859,  4474,   892, -1720,  4508,  4427,
    1372,  4428, -1672, -1720,  4403,  1377,  4560,  3761, -1672,  4561,
   -1671,  3685,  1610,  3603,  4571,  1373,  1118,  4572,  1779,   949,
    4582, -2820,  1779,  2556,  4656,  3491, -2820,  4657,  4662,  4750,
    4667,  4663,  3964,  3423,  4913,  4375, -1672,  3100,  4853,  4978,
    4854,  2966,  1984,  5561,  6048,  1386,   949,  4075,  1779,  1381,
     911,  5001,   949,  5041,  2556, -1672,  2556,  3963,  5062, -1671,
    5805,  1611,  1389, -2820,  5092,  1612,   949,  3423, -1671,  5098,
   -1720,  5105,  5099,   949,  3100, -1672,   949,  5004,  5106,  5005,
    2856,  3100,   949,  5107,  4346,  1387,  3100,  5910,    29,  1393,
    4157,  3965,  3966,  3967,  3968,  3969,  3970,  3971,  3972,  3973,
    5241,  1397,   949,  5242,  6089,  1396,  5278,  5295,   949,  4474,
    5296, -1747, -1747,  4257,  1614,   949,  1410,  4262,  2552, -1720,
    3604,  1412,  4076,  3249, -1672,  3591,  1427,  3964,   912,   949,
    1428,  3357,  5297, -1672,  6020,  2556,  6021,  3633,  5315,  4136,
    4137,  5316,   949,  5325,  1439,  5331,  1936,  1779,  4413,  5333,
    1454,  5449,  4413,   949,  5450,  4077,  5469,  3348,  5239,  3100,
    1616,  5503,  1455,  5544,  5504,  3762,  5545,  1427,  1456, -1660,
    4078,   623,   623,   623,  4930,  1118,  1422,   623,  5550,  4288,
    4079,  1936,  1459,  1617,    41,  3203,  3203,  3203,  3203,  3357,
    1465,  3203,  3203,  3203,  3203,  3203,  3203,  3203,  3203,  3203,
    3203,  4658,   188,  1619,   623,   892,  4685,  5553,  4080, -1671,
    4413, -2820,  5564,  1779,  3763,  5565,  4923,  1538,  5610,  4563,
      45,  5611,  1507,  5650,  3826,  3920,  2513,  3922,  3923,  5677,
   -1746, -1746,  5565,  3965,  3966,  3967,  3968,  3969,  3970,  3971,
    3972,  3973,  1533,  3605,  5700,  2055,   623,  3997,  2056,  3203,
    3203,  3606,  5727,  5701,  3607,  5715,  2556,  5719,  5716,  1536,
    1936,  5720,    49,  5748,  2556,  3917,  3140,  1539,  5754,   913,
    4515,  3140,  4687,  4688, -1672,    50,  4691,  5081,   892,  2545,
    5755,  5758,   892,  3140,  2556,  4252, -2820,  5759, -2318,  2648,
    2556,  4393,  4621,  5760,  3804,  5805,  5761,  4566,    51,  1578,
    5787,  4685,  4081,  5788,  1579,  5840,  5854,  4268,  4413,  2556,
    1574, -2820,  2547,   974,  5856,  5880,  5911,  2556,  4610,  4407,
    4612,  2587,  2488,  2489,  2490,  2491,  2492,  2493,  3965,  3966,
    3967,  3968,  3969,  3970,  3971,  3972,  3973,  5373,  5374,  5862,
    1017,  1580,  3100,  1427,  1018,  5047,    41,  5049,  3357,  1685,
    1248,  1591,  5877,  3958,  3355,  5878,  1593,  3959,  3960,  3961,
    4499,  5900,  5946,  5976,  5901,  5558,  5565,  4376,   949,  4378,
    6016,  6042,  6061,  6017,  2556,  5716,  6071,  6077,  1603,  6072,
    4657,  4588,    45,  1540,   892,  4630,   949,  4633,  4011,  1541,
    4012,  6086,  3472,   949,  2556,  5834,  5835,   623,  3480,   892,
     623,  1606,   623,   623,   892,  3064,   904,  4734, -2819,  4075,
    1783,  4685,   623,  3071,  4013,  4097,  4490,   623,  6098,  1628,
    2627,  6072,  2630,  5311,    49,  5312, -2820,  5934,  5935,   901,
     902, -2820,  1644,  5908,  1543,  1645,  1661,    50,  3357,  3513,
    1671,  1672,  1675,   623,   623,   623,  1680,  2587,   623,  1681,
    3243,  4448,  1118,   904,  1118,  1795,   623,   623,   623,   623,
      51,  4386,  1797,  4389,  1793,  1802,  1808,  1779, -2820,  1813,
    1816,  1818,   623,  1779,  1823,   623,  1826,   623,    57,  1828,
    1820,  1837,  1842,  1843,  4076,  -184,  4726,  5124,   623,   623,
    1544,  1845,   623,  1846,  1848,  1850,  1851,  1545,  1862,  1869,
    1546,  1873,  1877,   214,  1886, -2819,  1891,  1892,  1893,  4532,
    1895,   623,  1898,   623,  1899,   623,  1902,  4077,  3254,  3255,
    3256,  3257,  1903,  2552,  3557,  4014,  4745,  1547,  1910,  1914,
    1916,  4015,  4078,  1917,  1919,   623,  1118,  1921,  1926,  3357,
    1927,  1929,  4079,  4559,  4042,  4043,  4044,  1932,  1935,  1938,
    3581,  1939,   904,   949,  1941,  1958, -2819,  1989, -2820,  1995,
    2055,  1548,  2004,  2056,  1997,  1998,  2005, -1899, -1906, -2819,
    4080,  2012,  2013,  2015,  2014, -2819,  2016,    57,  4703,  2018,
   -2819, -1896,  1607,  2019,  2020,  2582, -2819,  3203,   623, -2819,
    4601,   623,  4957, -2819,  2545,   188, -1897,  4661,  4774,  2021,
   -1900, -2820,   904,   623,  1608,  2022,  2023,  2024,   623,  2026,
    2027,  2028,  2029,  4507,  2030, -1898, -2820,  2031,  2032,  2033,
    2034,  2036, -2819,   623, -2819,  2037,  1648,  2547,  3964,  2038,
    1550,  4847,  2039,  4834,  6046,  2040,  5289,   623,  2041,  2042,
    1551,  2043, -2819,  2499,  2501,   623,  2503,  2504,  3736,  1552,
    2513,  2517,  2529,  2537,  2559,  1609,  2565,   892,  2560,  2567,
     892,  1553,   892,  2571,  4081,  2568,  2572,   892,  2574,  2575,
    2576,  2577,  2583,  2578,    29,  1442,  2590,  2621,  2633,  4016,
    2635,  2623,   949,   949,  2636,  3357,  1444,  2637,   623,  2638,
    4017, -2819,  4839,  2655, -2819,  2654,  3355,  2656,  2658,  3355,
   -2819,  1676,  2657,  2659,  1555,  1556,  2581,  2908,  2660,   949,
    2661,  2662,   949,   782,  2663,   892, -2820,  2664,  2670,  2695,
    2689,  2701,  2715,   892,  2721,  2719,  2722,  2488,  2489,  2490,
    2491,  2492,  2493,  2723,  2725,  1677,  2726,  2739,  2743,  2745,
    2756, -2820,  2757,  2772,  1610,  3355, -2820,  2744,   892,   690,
    2768,  2775,  2777,  3355,  2703,  2774,  2786,  2788, -2819,  2778,
    2776,  2791,  2787,  2792,  2798,  2793,  2799,  2802,  2812,  2808,
      41,  2809,  2826,  2836,  3357,  2047,  2843,  2822,  2850,  2823,
    3357,  2829,  2832, -2820,  1779,  1779,  1779,  2833,  4097,  2838,
    5017,  2853,  2704,  1611,  1552,  5261,  2839,  1612,  2868,  2851,
    2858,  2870,  2859,  1558,  2872,   693,    45,  2864,  2879,   949,
    3244,  2896,  2856,  2877,  2880,  2897,  2926,  2904,   892,  2865,
     892,   694,  2047,  2938,  2933,  2940,  2871,  3906,   949,  3965,
    3966,  3967,  3968,  3969,  3970,  3971,  3972,  3973,  2552,  1033,
    4974, -2819,  3919,  2873,  3249,  2885,  1614,  3924,    49,  3251,
     949,  3252,  2886,  2942,  2941,  2943,  2947,  2898,  2909,  2948,
    4030,    50,  2949,  2705,  2951, -2819,  2952, -2819, -2819,  2953,
    2954,  2955,  2959,  2961,   697,  3253,  2962,  2969,  2970,  2987,
     646,  2973,  2986,   698,    51,  2978,  2997,  3004,  3001,  3002,
    3357,  3021,  1616,  2960,  1625,  2908,   699,  3005,  3014,  3017,
    3041,  2706,    57, -1411,  3020, -1411,  3030,  3047,  3051,  3063,
   -2819,  3034, -2819, -2819,   892,  1617,  3038,  3056,  4062,  3065,
    3066,  4067,  3068,  5529,  3067,  3081,  3124,  1036,  3137,  3113,
    3149, -2820,  3173,  3223,  3168,  1619,   949,  3229,  2056,  3062,
    3242,   623,  3287,  3267,  3288,  3326,  3306,   623,  3233,  3248,
    3265,  3309,  5543,  3310,  3324,  3327,   892,  3311,  3341,  3312,
    3325,   911,  1417,  3359,  3376,  3328,  2908,  3348,  3329,  3333,
    3342,   903,  3377,  3378,   703,  3348,  3400,  2587,  3364,  3254,
    3255,  3256,  3257,  1779,   892,  3379,  3258,  3259,  3393,   949,
    3401,   949,  3260,  3412,  3413,  3415,  3432,  3441,  3446,  3444,
    3448,  3449,  5026,  3465,   949,  3466,   949,  3455,  3460,  3468,
    3479,  1361,  3471,  3495,  5222,  2707,  3500,  4969,  4970,  4971,
    4972,  4973,  3502,  3512,  1365,  3519,   623,  3532,  3537,  5072,
    3538, -2820,  3564,  3558,  3566,  3565,  4923,  3571,  3574,  3582,
    3589,  3313,  2488,  2489,  2490,  2491,  2492,  2493,  3613,  3590,
     214,  2708,   892,  3592,   708,  3629,  1839,  3671,  3684,  3612,
    3705,  3712,  3692,  3718,  3696,  3719,   912,  3693,  3724,  3729,
    3740,  3720,  3751,   949,   892,  5131,  3766,  3770,  3752,  3772,
    3798,  1040,  3780,  3793,  2709,  3768,  3787,  4433,  4885,  4886,
     712,  3799,  3806,  3801,  3800,  3802,   892,   713,  3813,  3809,
     714,  3814,  3817,  3818,  3823,  3838,  3839,  3840,  3848,  3849,
    3850,  3852,  3811,  3854,  3868,   949,  5012,  5578,  3870,   715,
    3871,  5079,  3876,  4470,  4595,  3874,  1042,  3879,  4437,  3880,
    3881,  3882,   717,  3883,   949,  1043,  3884,  3894,  3150,   719,
    3261,  5195,  3898,  3896,  3905,  1936,  3913,  2710,  3908,  3915,
    3921,  3262,  3941, -2167,  2711,  3990,   949,  3889,  4158,   949,
    1933,  1900,  3897,  4010,  3888,  3938,  4161,  1209,  4019,  3939,
    3940,  3945,  3946,  3993,  4005,  3954,   623,  3950,  4033,   892,
     724,  3697,  3952,  2556,  3953,   623,  3976,  4065,  4053,  3981,
    4093,  3982,  3989,   623,  4004,   623,  4029,  4028,   623,  4061,
    4031,  4032,   892,   623,   623,   623,   623,  1212,  4059,   623,
     623,   623,   623,   623,   623,   623,   623,   623,   623,  4060,
   -2600,  4089,   623,   623,   623,  4035,  4074,   892,  4106,  3203,
    4099,  4108,   623,  4110,   904,  4112,  4119,   623,  4133,  1779,
    4127,   623,  4054,  4066,  4138,  4140,  4141,  4149,  4152,   623,
    4154,  4166,   623,  4177,   623,  4167,  5076,  4178,  4145,  4179,
    4185,  4244,  4186,  4246,   623,  4146,  4183,   623,   623,  4184,
   -2616,  4097,   623,   623,  4201,  4190,  4150,  4202,  4204,   623,
    4210,  3203,  4211,  4212,  4220,  4603,  4604,  4605,  4606,  4226,
    4235,  4249,  4251,  4253,  4255,  4256,  4263,  4097,  4259,  4264,
    4269,  4267,  4270,  4271,  4272,  4289,  1053,  4274,  1056,  4290,
     623,  4291,  4292,  4293,  4294,  4296,  4305, -2600,   623,   192,
    4295,  4297,   623,  4308,  4298,  1054,  4299,  1057,  4301,  4303,
    4310,  1055,  4312,  4300,  4302,  4304,  2894,  4314,  4331,  4324,
    5173,  5174,  4325,  5176,  4315,  1540,  4321,  4328,  4326,  4336,
    5261,  1541,  4342,  4379,   623,  4344,  4394,  4307,  4384,  4391,
    4395,  4398,  4385,  4402,  4413,  4415,  1646, -2616, -2600,  4431,
    4412,   623,  4422,  4452,  4425,  4432,  4436,   892,  4435,  4466,
    4438, -2600,  4484,  4469,  4472,  4476,  4485, -2600,   188,   623,
    5206,  4486, -2600,  4487,  4488,  4489,  1543,  4498, -2600,  4329,
    4491, -2600,  4500,  4478,  4501, -2600,  4502,  4511,  4524,  4512,
     949,  3958,  4513,  5122,  4514,  4516, -2166,  4584, -2616,  4517,
    4518,  4519,  4520,  2007,   188,  4573,  3355,  4585,  4533,  4596,
    3355, -2616,  4556,  4602, -2600,  4626,  4627, -2616,  4634,  4641,
    5348,  4635, -2616,  4640,  4642,  4655,  4615,  4650, -2616,  2857,
    1647, -2616,  1544,  4557, -2600, -2616,  4653,  4558,  4619,  1545,
    4659,  1779,  1546,  4670,  4678,  4699,  1779,   892,  1779,  4565,
    4587,  4611,  4702,  4613,  4709,  4710,  4622,  5940,  5941,  4624,
    4639,  4712,  4700,  4644, -2616,  4701,  4097,  4713,  4715,  1547,
    4740,  4721,  1779,   892,  5419,  3513,  4720,  3355,  4737,  4752,
    5166,  4753,  4754, -2600, -2616,  4755, -2600,  4756,  4768,  4766,
    4767,  4780, -2600,  4769,  4770,  4771,  3203,  4782,  4783,  4786,
    4788,  4799,  4800,  1548,  4805,  4808,  4824,  4825,  4827,  4727,
    4841,  4843,  4830,  4790,  4844,  4845,  4882,  4840,   949,  4471,
    4856,   949,  4867,  4877,  4798,  3203,  4896,  4888,  4903,  4915,
    4902,  4908,  3851, -2616,  4925,  4909, -2616,  3857,  4931,  3858,
    4942,  4932, -2616,  4951,  4948,  4952,  4949,  4953,  4955,  3864,
   -2600,  4956,  3865,  4967,  3866,  3867,  4980,  5604,  3869,  5606,
    4975,  4982,  3872,  4961,  3873,  4990,  5003,  3875,  1648,  4997,
    5324,  4998,  1550,  5015, -2168,  5018,  5009,  5224,  5020,  5019,
    5065,  5324,  1551,  2047,  5037,   623,  5024,  5074,  5078,  5077,
    5055,  1552,  5051,  5091,  5058,  5095,  5069,  5088,  5100,  5101,
   -2616,  5110,  4525,  1553,  5093,   778,  5128,  5129,   188,  5140,
    5130,   949,   949,  5133,  5139,   892,  5141,  5153,  5160,  5156,
    5162,  5168,   949,  5169,  5177,  4534,  5178,  5185,  3348,   623,
     623,  3916,  3348, -2600,  5186,  5192,  5187,  5196,  5614,   949,
    5199,  5203,  5204,  1649,  5710,  5211,  1555,  1556,  5214,  5466,
    4555,  5219,  3409,  5220,  5535,   778,  5221, -2600,  5223, -2600,
   -2600,  5227,   892,  5229,  5233,  5238,  5245,   892,   623,   623,
    3425,  5243,   974,  5249,  3428,  5250,  5252,  1650,  3431,   623,
    5254,  5736,  5256, -2616,  4934,  5267,  5257,  5273,  5275,  5258,
    3100,  5282,  5368,  5283,  5294,  5300,  5290,  5301,  5302, -2600,
    5303,  5313, -2600, -2600, -2600,  3456,  5317, -2616,  5308, -2616,
   -2616,  5323,  5352,  5327,  5330,  5355,  5349,  5361,  5364,  5372,
     949,  5375,  5376,  5379,  5380,  5381,  5386,  5771,  5773,  5412,
    5392,  5393,  5397,  5434,  4866,  5403,  5442,  3355,  3355,  3498,
    5440,  5404,  5405,  5389,  5445,  1558,   623,  5448,  5616, -2616,
    5452,  3203, -2616, -2616, -2616,  5472,  5473,   623,  5453,  1074,
    5477,  5482,  5484,  5500,  5511,  5513,  5505,  5512,  5519,  5534,
    5538,  5558,  5542,  5554,  5556,  5560,  5562,  5356,  5584,  5559,
    5575,  5585,  5577,  5586,  5592,   623,  5629,  5598,   623,  5631,
    5644,  3548,  5638,  5634,  5652,  5657,   623,   623,  5670,   892,
    5642,  5671,  5672,   623,   623,  5666,  5673,   620,   623,  5684,
    5674,  5685,   623,  5686,  5683,   623,   623,  5691,  3577,  5693,
     623,  5384,  5702,  5708,  3586,  5709,   623,  5712,  5714,  5722,
    4597,  5531,  5765,  5695,  5732,  5731,  5735,  5747,  3596,  5551,
    5734,  5751,  5770,   623,  5776,  1074,  5782,  5779,  3609,  5784,
     623,  5790,  5793,  5794,  3614,   623,  5810,  5786,   623,   623,
    5813,  5812,  5811,  5820,  5821,  5552,   623,  5826,  5827,  5837,
    5836,  5838,  2049,  5843,  3627,  5850,  5879,   623,  5852,  5872,
    3630,  5859,  5874,  5864,  5881,   623,  5780,  3636,  5889,  5781,
    5890,  5909,  5907,  5419,  5932,  5927,  5094,  5777,  5891,  5942,
    5953,  3651,  5961,  5980,  5990,   623,  5945,  5959,  5080,  5082,
    5999,  6001,  5986,  6022,  3676,  5987,  6002,  6026,  5841,  6023,
    6024,  6027,  6036,   892,  5608,  1074,  6049,  6060,  6051,  6052,
    4125,  6062,  6075,  6064,  4153,  6069,   949,  6039,  5599,  5600,
    6070,  6080,  6081,  5936,  5937,  6090,  6084,  6097,  6093,  2910,
    5507,  3355,  1537,  1429,  3774,  4051,  2536,  3644,  3355,  3348,
    3563,   892,  4196,  3355,  4743,  4736,  3355,  3683,  5875,  3731,
    5126,  4341,  5431,  5764,  5960,  5483,  4733,  4884,   949,  5202,
    5134,  5465,  4143,   892,  5866,   188,  3878,  5366,  5956,  5785,
     949,  5783,  5888,  5971,  4148,  4906,  5231,  4935,  4914,   927,
    5745,  4876,  3749,  3750,  4741,  4203,   623,  4205,   939,  4214,
    4401,  5225,   623,  4901,  5471,  4441,   939,  1627,  6019,   939,
    4959,  5687,  6096,   949,  6082,  5446,  4347,  4943,  5893,  5391,
    2977,  5594,  5753,  5394,   727,   780,  4492,  1981,  5571,  1049,
    6015,  4976,  3778,  3040,  4945,  3418,  4458,  4134,  3036,  3052,
    3203,  3203,  2055,  5508,   892,  2056,  5681,  3144,  4887,  2057,
    2058,  2059,  3069,  1159,  4311,  3145,  3681,  4772,  4258,  5703,
    5913,  6050,  2669,  3708,  1119,  1374,  2544,  4963,  4962,  3363,
     623,  6065,  5741,  4664,  2055,  2935,  2545,  2056,  5570,  5721,
    5860,  5723,  5603,  2546,  5083,   817,   623,  5765,   818,  4095,
    5855,  1779,  4107,  3373,  2509,  4069,  1118,  5724,  4617,  4632,
    2557,  5329,  4063,  5541,  4665,  5540,  4064,  2617,  2545,  2547,
     949,  5842,  2622,  2618,  6033, -2820,  5943,   623,   974,  5713,
    5530,  4567,  5725,  3292,  2566,  5726,  3209,  4026,  3933,  3707,
    3893,  4024,  3301,  3361,     0,     0,  1425,     0,     0,  4306,
       0,  2547,     0,     0,     0,  4313,     0,     0,  3907,     0,
       0,     0,     0,     0,   621,  3893,     0,  4097,  5236,  5738,
       0,     0,     0,   892,     0,   892,     0,     0,     0,   974,
    3348,   773,     0,   775,     0,  3348,     0,   781,  3348,     0,
       0,  5390,     0,   798,   806,   773,     0,   813,     0,  5388,
     806,   806,     0,   843,     0,   846,   949,     0,     0,   188,
     188,     0,   900,   900,   900,     0,     0,     0,     0,     0,
    4591,     0,     0,     0,   623,     0,     0,   623,     0,     0,
     623,   623,   623,  2548,     0,  3355,     0,     0,  2549,     0,
       0,     0,     0,     0,     0,     0,  5433,     0,     0,     0,
       0,     0,     0,     0,     0,   623,   623,     0,     0,   623,
    2550,  2243,     0,     0,  2055, -2820,     0,  2056,     0,     0,
   -2820, -2820, -2820, -2820,     0,  2551,  6073,     0,     0,   623,
       0,     0,     0,     0,     0,   623,     0,     0,     0,   623,
       0,     0,     0,     0,     0,   892,   623,     0,  2545,     0,
    1118,     0,     0,     0,     0,  2546,  6058, -2820,     0,   623,
       0,     0,   623,     0,     0,     0,  2295,   949,     0,   949,
       0,     0,     0,   623,     0,     0,     0,     0,     0,     0,
    2552,  2547,     0,  2553,     0,     0,     0,     0,     0,  4475,
       0,  4477,     0,  4479,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  6058,     0,   621,   929,   929,     0,
       0,   929,  2552,   892,   949,   940,  5114,   843,     0,     0,
     976,     0,  6058,   940,   623,     0,   940,     0,     0,   843,
       0,   929,     0,     0,   843,     0,     0,     0,   929,     0,
     843,     0,     0,     0,     0,     0,     0,  3355,     0,     0,
       0,     0,     0,     0,  5136,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1779,  3355,  6083,     0,
       0,   623,     0,  2554,     0,     0,  5152,     0,     0,     0,
       0,  3355,     0,     0,     0,     0,     0,  5350,     0,     0,
       0,     0,     0,     0,     0,  2548,     0,     0,  5603,     0,
    2549,     0,     0,     0,     0, -2820,     0,     0,     0,     0,
       0,     0,     0,     0,  6008,  6009,     0,     0,     0,   188,
       0,     0,     0,     0,     0,     0,  5470,     0,     0,     0,
       0,  4155,   623,     0,     0,   892,     0,  2551,     0,     0,
       0,     0,   927,     0,  6007,     0,     0,  5182,     0,    72,
     181,   939,   185,    81,    84,    85,   176,  5496,   939,    86,
       0,   939,    87,   192,   623,   107,   125,   130,   623,   182,
     623,   187,   904,  2484,     0,   184,   160,     0,   179,   186,
       0,  2485,  2486,  2487,  2488,  2489,  2490,  2491,  2492,  2493,
     623,     0,  2552,   623,  3232,     0,     0,  5498,     0,     0,
       0,     0,     0,     0,   623, -2820,     0,     0,     0,     0,
       0,   623,     0,     0,     0,  1118,  2488,  2489,  2490,  2491,
    2492,  2493,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  4227,     0,     0,     0,     0,     0,     0,     0,     0,
    3355,     0,     0,     0,     0,     0,     0,     0,  1540,  6076,
    2055,     0,     0,  2056,  1541,   974,     0,     0,     0,     0,
       0,   892,     0,     0,     0,     0,   892,   892,  5266,  3348,
       0,   623,     0,  2055,     0,     0,  2056,   623,   623,   949,
       0,     0,     0,     0,  2545,  2554,     0,     0,     0,     0,
       0, -2820,     0,   949,     0,     0,     0,     0,  3355,  1543,
       0,     0,     0,     0,     0,     0,     0,  2545,     0,     0,
       0,     0,     0,   623, -2820,     0,     0,  2547,     0,     0,
       0,   623,     0,     0,  1779,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    2547,     0,     0,     0,     0,     0,     0,     0,     0,   623,
       0,     0,     0,     0,     0,  1544,     0,     0,  4322,     0,
       0,     0,  1545,     0,     0,  1546,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   892,   892,
    5660,     0,     0,     0,     0,  2484,  4592,     0,  4307,     0,
       0,     0,  1547, -2820, -2820, -2820,  2488,  2489,  2490,  2491,
    2492,  2493,   623,     0,     0,     0,     0,     0,   623,  5035,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   623,
    1779,     0,     0,   892,     0,     0,  1548,   188,   623,     0,
     623, -2820,   623,     0,     0,     0, -2820,     0,     0,   623,
       0,     0,  1028,     0,     0,     0,     0,  5871,   843,     0,
     929,     0,   929,     0, -2820,   929,     0,  3355,   188, -2820,
     623,     0,   976,     0,     0,  5728,     0,  1086,     0,   929,
       0,     0,   188, -2820,     0,   929,     0,     0,     0,     0,
     927,     0,     0,     0,     0,  1779,   939,   949,     0,     0,
     939,  1648,   939,     0,     0,  1550, -2820,     0,     0,   621,
       0,     0,     0,     0,     0,  1551,     0,     0,   940,     0,
       0,     0,   976,     0,  1552,   940,     0,     0,   940,  5920,
    5921,     0,     0,     0,     0,     0,  1553,     0,  2552,     0,
       0,     0,     0,     0,   929,     0,     0,  2908,     0,     0,
     623,  2047,     0,     0,     0,     0,     0,  3355,     0,     0,
       0,  2552,     0,     0,     0,  1872,  4494,  1874,  1875,     0,
       0,     0,     0,     0,     0,     0,  2716,     0,     0,  1555,
    1556,     0,     0,     0,     0,     0,     0,     0,   623,   623,
     623,  4510,     0,     0,     0,     0,   623,   843,     0,     0,
     806,   806,   806,     0,     0,     0,   623,     0,     0,     0,
    2717,     0,     0,     0,     0,  1230,   623,     0,     0,   949,
    4966,     0,     0,  4968,     0,     0,     0,     0,     0,     0,
       0, -2820,   623,     0,     0,  1346,  1346,     0,   843,   806,
       0,     0,     0,   806,     0,   949,     0,     0,     0,  4983,
       0,     0,     0,     0, -2820,     0,     0,   843,  3355,     0,
       0,     0,   843,     0,     0,     0,     0,     0,  1346,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1558,     0,
       0,     0,     0,     0,     0,     0,   623,     0,     0,  3348,
       0,   188,     0,     0,     0,     0,   623,     0,     0,     0,
       0,     0,     0,     0,   623,   623,     0,  5894,     0,     0,
     623,  5915,   623,  1346,  1987,     0,     0,     0,     0,  1987,
    1987,     0,     0,     0,   192,     0,     0,   843,   623,   623,
    5916, -2820,  5918,     0,     0,     0,  5917,     0,     0,     0,
     843,     0,  2488,  2489,  2490,  2491,  2492,  2493,     0,     0,
       0,     0,     0,     0, -2820,   843,  5985,     0,     0,     0,
       0,     0,   949,     0,     0,  2488,  2489,  2490,  2491,  2492,
    2493,     0,     0,     0,   843,     0,   188,     0,     0,   929,
     929,     0,     0,     0,     0,   623,     0,     0,     0,  6091,
    6092,   623,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  5915,  3355,     0,     0,     0,     0,   623,
       0,   806,   806,     0,     0,     0,   192,     0,     0,     0,
       0,     0,  5916,     0,  5918,     0,     0,     0,  5917,   623,
       0,     0,  5682,     0,  1346,  1346,     0,  5113,     0,     0,
       0,     0,  4704,   623,     0,     0,     0,   621,     0,   929,
       0,     0,     0,   940,     0,     0,   976,   940,     0,   940,
       0,     0,     0,     0,   929,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   623,     0,  5718,     0,  5137,  5138,
       0,   623,     0,     0,     0,     0,     0,     0,   843,     0,
       0,     0,     0,  3355,     0,   929,   929,     0,     0,  3355,
       0,   623,     0,     0,     0,     0,     0,     0,  1779,     0,
       0,     0,     0,  5915,     0,     0,   843,   843,   843,     0,
     929,     0,   621,     0,   621,   621,   192,     0,     0,     0,
       0,     0,  5916,     0,  5918,     0,     0,     0,  5917,     0,
       0,     0,     0,   623,   623,     0,     0,     0,   623,     0,
       0,     0,   623,     0,     0,     0,  1779,     0,   929,     0,
     929,   929,  1540,     0,   623,   623,     0,     0,  1541,     0,
    4813,  5183,  5184,  4816,  1779,     0,     0,     0,     0,     0,
       0,     0,     0,  1646,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1346,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   188,  3355,
       0,     0,     0,  1543,     0,     0,     0,     0,     0,  1961,
       0,  1961,     0,     0,     0,   843,     0,   773,     0,  2055,
       0,     0,  2056,   188,     0,     0,  2057,  2058,  2059,     0,
       0,     0,     0,     0,     0,     0,   843,     0,     0,     0,
       0,     0,  1996,  2544,     0,   843,     0,     0,  2002,     0,
       0,     0,     0,  2545,     0,     0,     0,  1647,     0,  1544,
    2546,     0,  1346,     0,  4898,     0,  1545,     0,     0,  1546,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  2908,     0,     0,     0,     0,  2547,     0,     0,     0,
       0,  5277,     0,  1346,  5279,  5280,  1547,     0,     0,     0,
    2055,     0,     0,  2056,     0,     0,     0,  2057,  2058,  2059,
       0,  5284,     0,     0,     0,  5984,     0,     0,     0,     0,
       0,  1346,  1346,  1346,  2544,  1346,     0,     0,     0,     0,
    1548,     0,     0,  3828,  2545,     0,     0,     0,     0,     0,
       0,  2546,     0,     0,     0,  1346,     0,     0,     0,     0,
       0,     0,  2055,     0,     0,  2056,     0,  1510,     0,  2057,
    2058,  2059,  3893,     0,     0,     0,     0,  2547,     0,     0,
       0,     0,     0,     0,     0,     0,  2544,     0,     0,     0,
       0,     0,     0,   843,     0,     0,  2545,     0,     0,     0,
       0,     0,  1511,  2546,     0,  1648,     0,     0,     0,  1550,
    2548,  1346,     0,     0,     0,  2549,     0,     0,     0,  1551,
       0,     0,     0,     0,     0,     0,     0,     0,  1552,  2547,
       0,     0,     0,     0,     0,   188,     0,  2550,  2243,     0,
    1553,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  2551,     0,     0,     0,     0,  1346,     0,     0,
       0,  1346,  1346,  1512,     0,     0,     0,     0,     0,     0,
       0,     0,   843,   843,   843,  2632,     0,  1346,     0,     0,
    3641,     0,     0,  1555,  1556,     0,     0,     0,     0,     0,
       0,  2548,     0,  2295,     0,     0,  2549,     0,     0,  1513,
       0,   806,     0,     0,     0,     0,     0,  2552,     0,     0,
    2553,     0,     0,     0,  3642,     0,     0,     0,  2550,  2243,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    3829,     0,     0,  2551,     0,  1514,  2724,     0,     0,     0,
       0,   806,     0,  2548,   929,     0,     0,   927,  2549,     0,
     927,     0,     0,     0,     0,     0,     0,   843,  2752,     0,
     939,   939,     0,     0,     0,     0,   843,     0,     0,   929,
    2550,  2243,     0,     0,  2295,   939,     0,  1516,   939,     0,
       0,     0,  1558,     0,     0,  2551,     0,     0,  2552,     0,
       0,  2553,     0,     0,     0,     0,   976,     0,   843,     0,
    2554,   806,     0,     0,  2820,  2820,     0,     0,  2820,  1518,
       0,     0,     0,     0,     0,     0,  1480,     0,   806,     0,
       0,   843,     0,     0,   843,     0,  2295,     0,   939,     0,
    5147,     0,   939,   939,     0,     0,     0,     0,     0,     0,
    2552,     0,  5157,  2553,     0,     0,   929,     0,     0,     0,
       0,     0,    36,     0,     0,     0,     0,  3830,     0,     0,
       0,     0,     0,   843,     0,     0,  1521,     0,     0,     0,
       0,     0,     0,     0,  1522,   929,   929,   929,   929,   843,
       0,  2554,  2736,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   843,  1524,     0,     0,     0,     0,     0,
    2484,     0,  5573,  1525,  1346,  1346,  1346,  1526,  2485,  2486,
    2487,  2488,  2489,  2490,  2491,  2492,  2493,     0,     0,     0,
       0,  3947,     0,     0,  3948,     0,  3831,     0,     0,     0,
       0,     0,     0,  2554,     0,     0,     0,     0,     0,  2055,
       0,     0,  2056,     0,     0,     0,  2057,  2058,  2059,     0,
       0,     0,     0,     0,  5609,     0,     0,     0,     0,     0,
       0,  1527,     0,  2544,     0,  3832,     0,     0,     0,     0,
       0,     0,     0,  2545,     0,     0,     0,     0,     0,     0,
    2546,  2484,     0,     0,     0,     0,     0,     0,     0,  2485,
    2486,  2487,  2488,  2489,  2490,  2491,  2492,  2493,     0,     0,
       0,     0,   843,     0,     0,  3949,  2547,     0,     0,     0,
       0,     0,     0,   843,     0,     0,     0,     0,     0,     0,
       0,   929,   929,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  2484,     0,     0,     0,   929,     0,     0,
       0,  2485,  2486,  2487,  2488,  2489,  2490,  2491,  2492,  2493,
       0,     0,     0,     0,     0,   843,  2820,  4000,  3893,     0,
       0,     0,     0,     0,     0,     0,     0,  5698,     0,     0,
       0,   929,   929,   929,   929,     0,     0,     0,     0,     0,
     843,     0,     0,     0,     0,     0,     0,   843,     0,     0,
       0,  1540,     0,     0,     0,     0,     0,  1541,     0,     0,
       0,     0,     0,     0,   621,     0,     0,   621,     0,     0,
       0,     0,  1542,     0,     0,     0,     0,   940,   940,     0,
    2548,     0,     0,     0,     0,  2549,     0,     0,   976,   976,
       0,     0,   940,     0,     0,   940,     0,     0,     0,     0,
       0,     0,  1543,     0,     0,     0,     0,  2550,  2243,     0,
     929,   929,     0,     0,     0,     0,     0,   929,     0,   843,
       0,     0,  2551,     0,     0,     0,     0,     0,     0,  3893,
       0,  3893,     0,     0,     0,     0,  1961,     0,     0,     0,
       0,     0,     0,   929,     0,   940,     0,     0,  3116,   940,
     940,     0,   843,   843,     0,   929,     0,     0,  1544,     0,
       0,     0,   843,  2295,     0,  1545,     0,     0,  1546,   843,
       0,     0,     0,     0,     0,   773,   773,  2552,     0,  3152,
    2553,     0,     0,  1346,     0,  1346,     0,     0,     0,     0,
    1346,  1346,     0,  -136,     0,  1547,     0,  1346,  1346,  1346,
       0,     0,  1346,     0,  1346,   976,  1346,  1346,  1346,  1346,
    1346,  1346,     0,     1,  1346,     0,  1346,  1346,     0,     0,
    1346,     0,     0,     2,     0,     3,     4,     0,     0,  1548,
       0,     0,     0,     0,     0,  1346,  1346,  1346,     0,     0,
       0,     0,     0,     5,     0,     0,     0,     0,     0,     0,
       0,     0,  1346,     6,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     7,     0,     8,     9,     0,
    2554,     0,  2055,     0,    10,  2056,    11,     0,     0,  2057,
    2058,  2059,     0,     0,     0,     0,     0,     0,    12,     0,
      13,     0,   929,     0,  1549,     0,  2544,     0,  1550,     0,
       0,     0,     0,     0,     0,     0,  2545,    14,  1551,     0,
      15,     0,     0,  2546,     0,     0,     0,  1552,  1510,     0,
       0,     0,     0,     0,     0,    16,   763,    17,     0,  1553,
       0,    18,   763,  2055,     0,     0,  2056,    19,     0,  2547,
    2057,  2058,  2059,     0,     0,    20,     0,    21,     0,     0,
       0,     0,     0,  1511,    22,     0,     0,  2544,     0,     0,
       0,  5954,     0,     0,     0,     0,     0,  2545,     0,  1554,
    2484,    23,  1555,  1556,  2546,     0,     0,     0,  2485,  2486,
    2487,  2488,  2489,  2490,  2491,  2492,  2493,     0,    24,     0,
       0,  4343,     0,     0,     0,  1346,     0,     0,     0,     0,
    2547,     0,     0,  1557,   620,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1512,     0,     0,     0,     0,     0,
       0,     0,     0,  2055,     0,     0,  2056,     0,    25,    26,
    2057,  2058,  2059,     0,    27,  1346,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  2544,    28,     0,
    1513,     0,     0,  2548,     0,     0,     0,  2545,  2549,     0,
       0,     0,     0,     0,  2546,     0,    29,     0,     0,     0,
       0,  1558,     0,     0,     0,     0,     0,     0,     0,     0,
    2550,  2243,     0,     0,     0,     0,  1514,     0,  1346,     0,
    2547,     0,     0,     0,     0,  2551,     0,     0,     0,     0,
       0,     0,     0,    30,     0,     0,     0,     0,     0,     0,
       0,    31,     0,     0,  2548,     0,     0,     0,     0,  2549,
       0,     0,     0,     0,   927,    32,     0,   939,  1516,   939,
     939,    33,    34,     0,    35,     0,  2295,     0,     0,    36,
       0,  2550,  2243,     0,     0,    37,     0,     0,    38,     0,
    2552,     0,     0,  2553,   689,    39,  2551,     0,     0,     0,
    1518,    40,    41,   777,     0,     0,     0,  1480,  1607,    42,
       0,     0,     0,    43,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    44,     0,     0,     0,     0,     0,     0,
    1608,     0,     0,     0,     0,     0,     0,  2295,    45,     0,
       0,     0,     0,    36,  2548,  2735,     0,     0,  1520,  2549,
       0,  2552,     0,     0,  2553,     0,  4186,  1521,    46,     0,
       0,     0,     0,     0,     0,  1522,     0,     0,     0,    47,
       0,  2550,  2243,  2736,     0,    48,     0,     0,     0,     0,
      49,  1609,  4727,  2554,     0,  1524,  2551,     0,     0,  2692,
       0,     0,     0,    50,  1525,     0,     0,     0,  1526,     0,
       0,     0,     0,  1346,  1346,  1346,  1346,  1346,  1346,  1346,
    1346,  1346,     0,  1346,     0,     0,    51,     0,     0,     0,
       0,   843,  1346,     0,  1346,     0,     0,  2295,     0,     0,
       0,   843,     0,     0,    57,     0,     0,  -136,     0,     0,
       0,  2552,     0,     0,  2554,     0,     0,  4728,     0,     0,
       0,     0,  1527,     0,     0,     0,     0,     0,     0,     0,
     843,     0,  1346,     0,     0,   929,  1346,     0,     0,  1346,
    1610,  1346,     0,     0,  1346,     0,     0,     0,  1346,     0,
       0,     0,     0,  2484,     0,     0,     0,     0,     0,     0,
       0,  2485,  2486,  2487,  2488,  2489,  2490,  2491,  2492,  2493,
       0,  3358,     0,     0,  4526,     0,     0,   843,   843,     0,
       0,  3893,     0,     0,     0,     0,     0,     0,  1346,  1611,
       0,     0,     0,  1612,     0,     0,     0,  1346,  1346,     0,
       0,     0,     0,     0,  2554,     0,     0,     0,  2856,     0,
       0,   843,  4729,     0,  2484,     0,     0,     0,     0,  3402,
       0,  3407,  2485,  2486,  2487,  2488,  2489,  2490,  2491,  2492,
    2493,  2055,     0,   620,  2056,  4576,     0,     0,  2057,  2058,
    2059,     0,  1614,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  2544,     0,     0,     0,     0,
       0,   773,     0,   773,     0,  2545,     0,     0,     0,     0,
       0,     0,  2546,     0,     0,     0,     0,     0,     0,     0,
    1346,     0,     0,     0,     0,     0,     0,     0,  1616,     0,
       0,   621,     0,     0,   940,   976,   940,   940,  2547,     0,
     929,     0,     0,   843,  2484,     0,     0,     0,     0,     0,
       0,  1617,  2485,  2486,  2487,  2488,  2489,  2490,  2491,  2492,
    2493,     0,     0,     0,   806,     0,     0,     0,     0,     0,
       0,  1619,     0,  4730,     0,  2752,  4731,     0,     0,     0,
       0,     0,     0,  3516,   843,     0,     0,     0,     0,     0,
    3527,     0,     0,     0,     0,     0,     0,     0,  2055,   843,
       0,  2056,     0,     0,     0,  2057,  2058,  2059,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   843,  2544,     0,   927,     0,     0,   939,     0,   939,
     939,     0,  2545,     0,     0,     0,     0,     0,     0,  2546,
       0,     0,     0,   843,     0,     0,     0,     0,     0,     0,
       0,     0,  2548,     0,     0,   806,     0,  2549,     0,     0,
       0,     0,     0,     0,     0,  2547,     0,     0,     0,  1540,
       0,     0,     0,     0,     0,  1541,     0,     0,   929,  2550,
    2243,   929,  2778,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  2551,     0,     0,     0,     0,     0,
       0,   763,     0,   763,     0,   763,     0,   843,   843,     0,
       0,   763,  1196,  1197,     0,     0,     0,     0,     0,     0,
    1543,     0,  3670,     0,  3673,  3675,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  2295,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  2552,
       0,     0,  2553,     0,     0,  1346,  1346,  1346,     0,     0,
       0,  1346,     0,     0,     0,     0,     0,     0,     0,   929,
       0,     0,     0,     0,     0,     0,  1544,     0,     0,  2548,
       0,     0,   929,  1545,  2549,     0,  1546,     0,  1346,     0,
     929,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  2752,     0,     0,  2550,  2243,   843,     0,
       0,     0,     0,  1547,  3775,   620,     0,   773,   620,     0,
       0,  2551,     0,  1050,     0,     0,     0,     0,     0,   929,
    3786,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    3670,     0,  2554,     0,     0,     0,     0,  1548,     0,     0,
     929,     0,  3808,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  2295,     0,   620,     0,     0,     0,     0,     0,
       0,     0,   620,  1117,   689,     0,  2552,     0,     0,  2553,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   929,     0,   929,     0,   929,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   763,
       0,     0,  1648,     0,     0,     0,  1550,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1551,     0,  1961,     0,
       0,     0,     0,     0,     0,  1552,     0,     0,     0,     0,
       0,     0,  2484,     0,     0,     0,     0,  1553,     0,     0,
    2485,  2486,  2487,  2488,  2489,  2490,  2491,  2492,  2493,     0,
       0,     0,     0,  4680,     0,     0,     0,     0,     0,  2554,
       0,     0,  1221,     0,     0,     0,     0,     0,   763,     0,
       0,   621,   929,     0,   940,     0,   940,   940,     0,   929,
    1555,  1556,     0,     0,     0,     0,  1346,     0,  1239,     0,
       0,  1346,     0,     0,     0,     0,  1349,     0,     0,  1358,
    1117,  1360,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1557,     0,     0,     0,     0,     0,  1346,  1346,  1346,
       0,     0,  1346,     0,     0,     0,     0,     0,     0,     0,
    1346,  1346,  1346,  1346,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1346,     0,     0,  1346,
       0,  1346,     0,     0,     0,     0,     0,     0,  1510,  2484,
       0,     0,  1346,  1346,     0,     0,  1346,  2485,  2486,  2487,
    2488,  2489,  2490,  2491,  2492,  2493,     0,     0,     0,  1558,
    4904,     0,     0,   976,     0,  1346,     0,  1346,     0,  1346,
       0,     0,     0,  1511,     0,     0,  2055,     0,     0,  2056,
       0,     0,     0,  2057,  2058,  2059,     0,     0,     0,  1346,
       0,     0,     0,   843,     0,     0,     0,     0,     0,     0,
    2544,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    2545,     0,     0,     0,   843,  3828,     0,  2546,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1512,     0,     0,     0,     0,  1510,
       0,     0,   621,  2547,     0,  3358,  4073,     0,     0,     0,
    4073,  4087,  4073,     0,     0,     0,     0,  1346,     0,     0,
       0,     0,  1346,     0,     0,     0,     0,     0,     0,     0,
    1513,     0,     0,     0,  1511,     0,     0,  1346,     0,     0,
       0,  1117,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  3358,     0,     0,     0,  4118,     0,     0,  4121,  3358,
       0,  3407,     0,     0,     0,     0,  1514,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  2055,
       0,     0,  2056,     0,     0,     0,  2057,  2058,  2059,     0,
       0,     0,     0,     0,     0,  1512,     0,     0,     0,     0,
       0,     0,  1346,  2544,  1515,     0,     0,     0,  1516,     0,
       0,     0,     0,  2545,     0,     0,     0,  2548,     0,     0,
    2546,     0,  2549,     0,     0,     0,     0,     0,     0,     0,
       0,  1513,   929,   929,     0,     0,     0,     0,     0,  1517,
    1518,     0,     0,     0,  2550,  2243,  2547,  1480,   763,     0,
       0,     0,     0,   763,   763,     0,     0,     0,     0,  2551,
       0,     0,  3829,     0,     0,     0,     0,  1514,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1519,
       0,  2562,     0,    36,     0,     0,     0,     0,  1520,     0,
    2569,     0,  2570,     0,     0,     0,  2573,  1521,     0,     0,
    2295,     0,     0,  2579,     0,  1522,     0,     0,     0,  1516,
       0,     0,     0,  1523,  2552,     0,     0,  2553,     0,     0,
       0,     0,     0,     0,     0,  1524,     0,     0,     0,     0,
       0,  1986,     0,     0,  1525,     0,     0,     0,  1526,     0,
     843,  1518,     0,     0,     0,     0,     0,     0,  1480,     0,
    2820,     0,     0,     0,     0,     0,     0,     0,     0,  1117,
    2548,     0,     0,     0,     0,  2549,     0,     0,     0,     0,
    2055,     0,     0,  2056,     0,     0,     0,  2057,  2058,  2059,
       0,     0,     0,     0,    36,     0,     0,  2550,  2243,  1520,
       0,     0,  1527,     0,  2544,   763,     0,     0,  1521,     0,
       0,     0,  2551,     0,  2545,   763,  1522,  2554,     0,     0,
       0,  2546,     0,     0,  2736,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1524,     0,     0,     0,
       0,     0,     0,     0,     0,  1525,  2051,  2547,  1540,  1526,
       0,     0,     0,  2295,  1541,  2053,     0,     0,     0,  1196,
    1197,     0,     0,     0,     0,  1346,     0,  2552,  3831,  2507,
    2553,  1346,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   929,     0,     0,   620,     0,     0,  1117,   620,
       0,  2524,  2525,     0,     0,     0,  1117,  1117,     0,  1543,
       0,     0,   763,  1527,     0,   763,   763,  3832,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  2484,     0,   843,
     843,   843,     0,     0,     0,  2485,  2486,  2487,  2488,  2489,
    2490,  2491,  2492,  2493,     0,     0,   843,     0,  4999,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1346,     0,     0,     0,     0,  1544,   620,     0,     0,     0,
    2554,  2548,  1545,     0,     0,  1546,  2549,     0,  1961,   843,
     843,     0,  2055,     0,   843,  2056,     0,     0,     0,  2057,
    2058,  2059,     0,     0,     0,     0,   843,     0,  2550,  2243,
       0,     0,  1547,     0,     0,     0,  2544,     0,     0,     0,
       0,     0,     0,  2551,     0,     0,  2545,     0,     0,     0,
       0,     0,     0,  2546,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1548,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  2547,
       0,     0,   929,     0,  2295,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  3116,  4493,  2552,     0,
    2484,  2553,     0,     0,     0,   843,     0,     0,  2485,  2486,
    2487,  2488,  2489,  2490,  2491,  2492,  2493,     0,   843,  2932,
       0,   843,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1549,     0,     0,     0,  1550,   763,     0,     0,     0,
    1346,     0,     0,     0,     0,  1551,     0,     0,     0,  1346,
       0,     0,     0,     0,  1552,     0,     0,  1346,     0,  1346,
       0,     0,  1346,     0,     0,   891,  1553,  1346,  1346,  1346,
    1346,     0,     0,  1346,  1346,  1346,  1346,  1346,  1346,  1346,
    1346,  1346,  1346,     0,     0,     0,  1346,  1346,  1346,     0,
       0,  2554,  2861,  2548,     0,     0,  1346,     0,  2549,     0,
    2869,  1346,     0,     0,     0,  1346,  2794,     0,     0,  1555,
    1556,     0,     0,  1346,     0,     0,  1346,     0,  1346,     0,
    2550,  2243,     0,     0,     0,     0,     0,     0,  1346,     0,
       0,  1346,  1346,     0,     0,  2551,  1346,  1346,     0,     0,
    2795,  4599,     0,  1346,     0,     0,     0,     0,     0,     0,
     843,   843,   843,     0,     0,     0,   620,   620,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    4073,  4087,  4073,     0,  1346,  4073,  2295,     0,  4623,     0,
    2055,     0,  3358,  2056,     0,     0,  3358,  2057,  2058,  2059,
    2552,  2484,  4638,  2553,     0,     0,     0,     0,     0,  2485,
    2486,  2487,  2488,  2489,  2490,  2491,  2492,  2493,  1558,     0,
       0,     0,  5036,     0,  2545,     0,     0,     0,  1346,     0,
       0,  2546,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  3407,     0,  1346,     0,  2055,     0,     0,
    2056,     0,     0,     0,  2057,  2058,  2059,  2547,     0,  3174,
    3175,     0,     0,  4686,  1961,  1961,  3189,  3190,  1961,     0,
       0,  2544,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  2545,     0,     0,     0,     0,     0,     0,  2546,     0,
       0,     0,     0,  2554,     0,     0,  3234,     0,     0,     0,
       0,     0,     0,  2752,  4718,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  2547,     0,     0,     0,     0,     0,
       0,     0,  4739,  2998,     0,     0,     0,  3003,     0,     0,
       0,  1540,     0,     0,     0,     0,     0,  1541,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  2548,     0,     0,     0,     0,  2549,     0,     0,     0,
     620,     0,  1543,     0,     0,     0,     0,   620,     0,     0,
       0,     0,   620,  2484,     0,   620,  5067,     0,  2550,  2243,
       0,  2485,  2486,  2487,  2488,  2489,  2490,  2491,  2492,  2493,
       0,     0,     0,  2551,  5288,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  2548,     0,
    4831,     0,     0,  2549,     0,     0,     0,     0,  1544,     0,
       0,     0,     0,     0,     0,  1545,     0,     0,  1546,     0,
       0,     0,     0,     0,  2295,  2550,  2243,     0,     0,     0,
       0,     0,     0,   929,     0,     0,     0,     0,  2552,     0,
    2551,     0,     0,     0,     0,  1547,     0,   929,     0,  1346,
       0,     0,     0,     0,     0,     0,   843,     0,     0,     0,
       0,     0,  4875,     0,     0,  3185,     0,     0,     0,     0,
       0,     0,     0,  2752,     0,     0,     0,     0,     0,  1548,
       0,  2295,     0,     0,     0,     0,     0,     0,   843,     0,
       0,     0,     0,  3358,  3786,  2552,     0,     0,  2553,     0,
       0,  3670,     0,   690,     0,     0,     0,     0,  3153,     0,
    4924,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     843,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  2554,  1346,  1346,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1346,  1648,     0,     0,     0,  1550,     0,
       0,     0,     0,     0,  1961,   843,     0,     0,  1551,   693,
    3154,     0,     0,     0,     0,     0,     0,  1552,     0,     0,
       0,     0,   843,     0,     0,   694,     0,     0,     0,  1553,
       0,     0,     0,     0,     0,     0,     0,     0,  2554,     0,
       0,  2055,     0,  1033,  2056,     0,     0,     0,  2057,  2058,
    2059,     0,     0,  5208,     0,     0,     0,     0,     0,     0,
    1346,     0,     0,     0,     0,  2544,     0,  3155,     0,  3508,
       0,  1346,  1555,  1556,     0,  2545,     0,     0,   697,     0,
       0,  2484,  2546,     0,   620,     0,     0,   698,     0,  2485,
    2486,  2487,  2488,  2489,  2490,  2491,  2492,  2493,     0,  1346,
     699,     0,  1346,  1557,     0,  3156,     0,     0,  2547,     0,
    1346,  1346,     0,     0,     0,     0,     0,  1346,  1346,     0,
       0,     0,  1346,     0,     0,     0,  1346,     0,     0,  1346,
    1346,  1036,     0,     0,  1346,  5040,     0,     0,  2484,   891,
    1346,   843,   843,   843,   843,     0,  2485,  2486,  2487,  2488,
    2489,  2490,  2491,  2492,  2493,     0,  3157,   621,     0,  5299,
    4073,     0,     0,     0,  3358,   891,     0,     0,     0,  3358,
       0,  1558,  3358,   621,     0,  3670,     0,  5071,   703,     0,
    1346,     0,   976,     0,     0,     0,     0,     0,     0,     0,
       0,  1346,     0,     0,     0,  4118,     0,     0,     0,  1346,
       0,  3407,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   773,     0,     0,  1346,
       0,     0,  2548,     0,     0,     0,     0,  2549,     0,     0,
       0,     0,     0,     0,     0,  3330,  3332,     0,     0,     0,
       0,  3340,     0,     0,     0,     0,   620,     0,     0,  2550,
    2243,     0,     0,  2752,   214,  3158,     0,     0,   708,     0,
       0,     0,     0,     0,  2551,     0,   620,     0,     0,  5135,
       0,     0,     0,  3382,  3382,     0,     0,     0,     0,     0,
     620,     0,     0,     0,     0,  1040,     0,     0,  3159,     0,
       0,     0,     0,     0,   712,     0,     0,     0,     0,     0,
       0,   713,     0,     0,   714,  2295,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   891,     0,     0,  2552,
    1346,     0,  2553,   715,  5164,     0,  1346,     0,     0,     0,
    1042,   939,     0,     0,     0,   763,   717,     0,     0,  1043,
       0,     0,     0,   719,     0,     0,     0,     0,   929,     0,
       0,     0,     0,     0,  1540,     0,     0,     0,  3160,     0,
    1541,     0,     0,   929,     0,     0,     0,  1607,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   939,     0,
       0,     0,     0,     0,   724,     0,     0,     0,     0,  1608,
       0,     0,     0,  1540,  1346,     0,     0,     0,     0,  1541,
       0,     0,     0,     0,     0,  1543,     0,     0,     0,     0,
     621,     0,  2554,     0,     0,     0,     0,  2752,     0,  3515,
    3308,     0,     0,     0,     0,     0,  1961,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   620,
    1609,  3786,     0,     0,  1543,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   929,     0,  3808,     0,     0,  1695,
       0,  1544,     0,     0,     0,     0,     0,     0,  1545,     0,
       0,  1546,  2055,     0,     0,  2056,     0,   891,     0,  2057,
    2058,  2059,   843,     0,     0,     0,     0,     0,   891,     0,
       0,     0,     0,   843,     0,     0,  2544,   620,  1547,     0,
    1544,     0,     0,     0,   891,     0,  2545,  1545,   763,     0,
    1546,     0,  2484,  2546,     0,     0,   763,     0,     0,   763,
    2485,  2486,  2487,  2488,  2489,  2490,  2491,  2492,  2493,  1610,
       0,   763,  1548,  5307,     0,     0,     0,  1547,  1346,  2547,
       0,  1346,     0,     0,  1346,  1346,  1346,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1117,  1346,
    1346,  1548,     0,  1346,     0,     0,     0,     0,  1611,     0,
       0,     0,  1612,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1346,     0,     0,     0,  1613,     0,  1346,
       0,  1550,     0,  3358,     0,     0,     0,  5071,     0,     0,
    1346,  1551,  5347,     0,     0,     0,     0,     0,     0,     0,
    1552,     0,     0,  4686,     0,     0,  1346,  1360,  5643,     0,
       0,  1614,  1553,     0,     0,     0,  1648,  4686,   976,   929,
    1550,   929,     0,     0,     0,     0,     0,     0,  1540,     0,
    1551,     0,     0,  2548,  1541,     0,   620,     0,  2549,  1552,
       0,     0,     0,     0,     0,   891,     0,     0,     0,     0,
       0,  1553,  1615,     0,     0,  1555,  1556,  1616,     0,     0,
    2550,  2243,     0,     0,     0,     0,     0,     0,   940,   976,
       0,     0,     0,     0,     0,  2551,     0,     0,     0,  1543,
    1617,     0,     0,     0,     0,     0,  1618,  1360,     0,     0,
       0,  3686,     0,     0,  1555,  1556,     0,     0,     0,     0,
    1619,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1360,     0,     0,     0,   940,  2295,     0,     0,     0,
       0,     0,     0,     0,     0,  3687,   620,  4875,     0,     0,
    2552,     0,   843,  2553,     0,  1544,     0,   843,     0,     0,
       0,     0,  1545,     0,     0,  1546,  2752,     0,     0,     0,
       0,     0,     0,     0,  1558,     0,   843,   763,     0,     0,
    4924,     0,     0,  5485,     0,     0,     0,     0,     0,     0,
       0,     0,  1547,     0,   929,   843,  4686,  2055,  3679,     0,
    2056,     0,     0,     0,  2057,  2058,  2059,     0,     0,     0,
       0,     0,     0,  1558,     0,     0,     0,     0,     0,     0,
       0,  2544,     0,     0,     0,     0,  1548,     0,  1346,     0,
       0,  2545,  1346,     0,  1346,  3711,     0,  3711,  2546,  3711,
    3711,     0,     0,  2554,  3711,  3711,  3711,   620,  3711,  3711,
    3711,     0,     0,     0,   621,     0,     0,  1346,     0,     0,
       0,  5549,     0,     0,  2547,     0,     0,     0,  1346,     0,
       0,     0,     0,     0,     0,  1346,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1648,     0,     0,     0,  1550,     0,     0,     0,     0,
       0,     0,  3788,     0,     0,  1551,     0,     0,  2653,     0,
     843,     0,     0,     0,  1552,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1553,  3816,     0,   939,
       0,     0,     0,     0,     0,  1346,     0,     0,     0,     0,
       0,  1346,  1346,  2484,     0,     0,   929,   929,   929,   929,
       0,  2485,  2486,  2487,  2488,  2489,  2490,  2491,  2492,  2493,
       0,     0,     0,     0,  5310,     0,  4171,     0,     0,  1555,
    1556,  4049,     0,   763,     0,     0,  2653,  1346,  2548,     0,
       0,     0,     0,  2549,     0,   621,     0,     0,     0,  4056,
       0,     0,     0,   620,     0,     0,     0,     0,     0,     0,
    4172,   939,   939,     0,     0,  2550,  2243,     0,     0,  1540,
     843,     0,     0,  3358,     0,  1541,     0,   891,     0,     0,
    2551,     0,     0,     0,  2055,     0,     0,  2056,     0,     0,
       0,  2057,  2058,  2059,     0,  4102,  4102,     0,   843,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  2544,     0,
     891,     0,     0,     0,     0,     0,     0,     0,  2545,     0,
    1543,  2295,     0,     0,     0,  2546,  1346,     0,  1558,     0,
       0,     0,  1346,     0,     0,  2552,  1961,     0,  2553,     0,
    3670,     0,   620,  1346,     0,     0,     0,     0,   620,     0,
       0,  2547,  1346,     0,  1346,     0,  1346,  5347,     0,     0,
       0,     0,     0,  4686,     0,     0,  5989,     0,     0,     0,
       0,     0,     0,  1961,     0,   976,  1544,     0,     0,     0,
       0,     0,     0,  1545,  1346,     0,  1546,     0,     0,  1695,
    1695,  1695,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1547,     0,     0,     0,     0,     0,  1961,
    1961,     0,     0,     0,     0,     0,     0,     0,  2554,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  6030,     0,
       0,     0,     0,     0,     0,     0,     0,  1548,     0,     0,
     929,     0,     0,     0,     0,     0,     0,     0,   620,     0,
       0,     0,     0,     0,  5806,  2548,  1117,     0,     0,     0,
    2549,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  2550,  2243,     0,     0,     0,     0,     0,     0,
     891,  6030,  1346,  1346,  1346,     0,     0,  2551,     0,  6079,
    1346,   891,  1648,     0,  5549,     0,  1550,     0,     0,     0,
    1346,   939,   939,     0,     0,     0,  1551,   891,  2484,  3407,
    1346,     0,     0,     0,     0,  1552,  2485,  2486,  2487,  2488,
    2489,  2490,  2491,  2492,  2493,     0,   940,  1553,  2295,  5363,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   929,  2552,     0,     0,  2553,     0,     0,  1961,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     891,     0,     0,     0,     0,     0,     0,  4229,     0,     0,
    1555,  1556,     0,  2752,     0,   891,     0,     0,   891,   891,
    1346,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    4686,     0,     0,     0,     0,     0,     0,     0,   940,   940,
    5923,  4230,     0,     0,  1346,  1117,  1346,     0,     0,   891,
     891,     0,     0,     0,     0,  1961,  1961,  5938,     0,     0,
       0,     0,  1346,  1346,     0,     0,     0,     0,  5944,     0,
       0,     0,     0,     0,     0,  2554,     0,     0,     0,     0,
       0,     0,     0,     0,   763,     0,     0,     0,     0,     0,
     929,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  4390,     0,  1558,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  5806,
     929,   929,     0,  4219,     0,  4686,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   621,     0,     0,     0,     0,     0,     0,
       0,  1695,     0,     0,  1695,     0,     0,     0,     0,     0,
       0,     0,     0,  1346,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  2484,     0,  1346,     0,   891,
       0,  4266,     0,  2485,  2486,  2487,  2488,  2489,  2490,  2491,
    2492,  2493,     0,     0,     0,     0,  5396,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1346,     0,
       0,     0,     0,  6028,  6029,   621,  6032,  5549,     0,     0,
    3407,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   929,  2055,     0,  4686,  2056,     0,     0,     0,
    2057,  2058,  2059,     0,     0,     0,     0,     0,     0,  4309,
       0,     0,     0,     0,     0,     0,     0,  2544,  4118,     0,
       0,     0,     0,     0,     0,   763,     0,  2545,     0,   629,
       0,     0,     0,     0,  2546,   678,   629,  1346,   621,     0,
       0,   730,  1346,   629,     0,     0,   621,     0,     0,   629,
       0,     0,   786,     0,     0,  3711,     0,     0,   940,   940,
    2547,     0,  6094,     0,     0,     0,     0,  4340,  4340,     0,
       0,   854,   854,     0,     0,     0,     0,  4356,     0,     0,
       0,  -136,  1117,     0,  1117,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     1,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     2,     0,     3,     4,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    4411,     5,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     6,     0,  2055,     0,     0,  2056,     0,     0,     0,
    2057,  2058,  2059,     7,     0,     8,     9,     0,     0,     0,
       0,     0,    10,     0,    11,  4447,  1117,  2544,     0,     0,
       0,  3365,     0,     0,  2548,     0,    12,  2545,    13,  2549,
       0,     0,     0,     0,  2546,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    14,     0,     0,    15,     0,
       0,  2550,  2243,     0,     0,     0,     0,     0,     0,     0,
    2547,     0,     0,    16,     0,    17,  2551,     0,     0,    18,
       0,     0,   931,     0,     0,    19,   935,     0,     0,     0,
       0,     0,     0,    20,   978,    21,     0,   980,     0,     0,
     985,   986,    22,   989,  2055,   992,     0,  2056,   998,     0,
    1000,  2057,  2058,  2059,     0,     0,     0,  2295,     0,    23,
       0,  3366,     0,     0,     0,     0,     0,     0,  2544,     0,
       0,  2552,     0,     0,  2553,     0,    24,     0,  2545,     0,
       0,     0,     0,     0,     0,  2546,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  2547,     0,     0,     0,     0,    25,    26,     0,     0,
       0,     0,    27,     0,  2548,     0,     0,   763,     0,  2549,
       0,     0,     0,     0,     0,  2055,    28,     0,  2056,     0,
       0,  4577,  2057,  2058,  2059,     0,     0,     0,     0,     0,
       0,  2550,  2243,   763,    29,     0,     0,     0,     0,  2544,
       0,     0,     0,     0,  2554,     0,  2551,   763,     0,  2545,
       0,     0,     0,     0,     0,     0,  2546,     0,   763,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1695,
       0,    30,     0,     0,     0,     0,     0,     0,     0,    31,
       0,     0,  2547,     0,     0,     0,     0,  2295,     0,     0,
       0,     0,     0,    32,     0,     0,     0,     0,     0,    33,
      34,  2552,    35,     0,  2553,  2548,     0,    36,     0,     0,
    2549,     0,     0,    37,     0,     0,    38,     0,     0,     0,
       0,     0,     0,    39,     0,     0,     0,     0,     0,    40,
      41,     0,  2550,  2243,  1196,  1197,     0,    42,     0,     0,
       0,    43,     0,     0,  2484,     0,     0,  2551,     0,     0,
       0,    44,  2485,  2486,  2487,  2488,  2489,  2490,  2491,  2492,
    2493,     0,     0,     0,     0,  5398,    45,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    46,     0,  2295,     0,
       0,     0,     0,     0,  2554,     0,  2548,    47,     0,     0,
       0,  2549,  2552,    48,     0,  2553,  3414,     0,    49,     0,
    2653,  3420,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    50,   763,  2550,  2243,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  2551,     0,
    4356,     0,     0,     0,    51,    52,    53,    54,    55,    56,
       0,     0,     0,     0,  3367,     0,     0,     0,     0,     0,
       0,     0,    57,     0,     0,  -136,  4778,     0,   891,     0,
       0,     0,     0,     0,   891,   763,     0,     0,     0,  2295,
       0,  4791,     0,     0,  4792,     0,  4793,     0,     0,     0,
       0,     0,     0,  2552,  2484,  2554,  2553,     0,     0,     0,
       0,     0,  2485,  2486,  2487,  2488,  2489,  2490,  2491,  2492,
    2493,     0,     0,     0,     0,   891,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  4833,     0,     0,  1027,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1064,     0,  3711,     0,
    1068,     0,     0,  3711,     0,     0,     0,  1081,  1082,     0,
       0,  1088,     0,  1091,  1092,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1114,     0,
       0,     0,     0,     0,     0,     0,  2554,     0,     0,     0,
       0,     0,     0,     0,     0,  2484,  1127,     0,     0,     0,
       0,     0,     0,  2485,  2486,  2487,  2488,  2489,  2490,  2491,
    2492,  2493,     0,     0,     0,     0,  5437,  1155,     0,  1157,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1173,
       0,     0,     0,     0,     0,     0,  1540,     0,     0,     0,
       0,     0,  1541,     0,     0,     0,     0,     0,     0,  1607,
       0,     0,  4938,     0,     0,  4356,     0,     0,     0,     0,
       0,     0,   629,     0,     0,     0,     0,     0,     0,     0,
       0,  1608,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  2484,  1543,     0,     0,
       0,     0,  1695,     0,  2485,  2486,  2487,  2488,  2489,  2490,
    2491,  2492,  2493,     0,   763,     0,     0,  5756,     0,     0,
     763,     0,     0,     0,   763,     0,     0,     0,     0,     0,
       0,     0,  1609,     0,   891,     0,     0,     0,  4986,  4986,
    4986,  4986,     0,  4986,  4986,  4986,  4986,  4986,     0,     0,
       0,  5150,  5151,  1544,     0,     0,  5154,  5155,     0,     0,
    1545,     0,   854,  1546,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  2055,   928,   930,  2056,
       0,   933,     0,  2057,  2058,  2059,     0,     0,     0,     0,
    1547,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    2544,   991,     0,     0,     0,     0,     0,  2653,  1001,     0,
    2545,  2653,     0,     0,     0,     0,     0,  2546,     0,     0,
       0,  1610,     0,     0,  1548,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  5048,     0,
    5050,     0,     0,  2547,     0,  1501,     0,     0,     0,     0,
       0,     0,     0,  2055,     0,     0,  2056,     0,     0,     0,
    2057,  2058,  2059,     0,     0,     0,     0,     0,     0,     0,
    1611,     0,     0,     0,  1612,     0,     0,  2544,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  2545,     0,  1613,
       0,     0,     0,  1550,  2546,     0,     0,     0,  2055,     0,
       0,  2056,     0,  1551,     0,  2057,  2058,  2059,     0,     0,
       0,     0,  1552,   891,     0,     0,     0,     0,     0,  1679,
    2547,     0,  2544,  1614,  1553,     0,     0,     0,   891,     0,
       0,     0,  2545,   891,     0,     0,     0,     0,     0,  2546,
       0,     0,     0,  1799,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  2548,  1811,     0,
    1812,     0,  2549,     0,  3616,  2547,     0,  1555,  1556,  1616,
    1815,     0,     0,     0,     0,     0,     0,  1825,     0,     0,
       0,     0,     0,     0,  2550,  2243,     0,     0,     0,     0,
       0,     0,  1617,     0,     0,     0,     0,     0,  3617,  2551,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1619,     0,     0,     0,     0,     0,     0,  1876,
       0,  1878,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  2548,     0,     0,     0,     0,  2549,
    2295,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  2552,  5180,  5181,  2553,     0,     0,
       0,  2550,  2243,     0,     0,     0,  1558,     0,  3711,     0,
    3711,  3711,  3711,     0,     0,     0,  2551,     0,     0,  2548,
       0,     0,     0,     0,  2549,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   629,     0,   629,     0,   629,
       0,   629,     0,   629,   629,   629,  2550,  2243,     0,     0,
     629,     0,     0,     0,     0,     0,     0,  2295,     0,     0,
       0,  2551,  1982,     0,     0,     0,     0,     0,     0,     0,
       0,  2552,     0,   763,  2553,     0,  5232,     0,     0,     0,
    1994,     0,     0,     0,     0,     0,     0,  2554,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  2295,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  5260,  2552,     0,     0,  2553,
       0,     0,     0,     0,     0,     0,  2653,     0,     0,  3420,
       0,  3420,     0,     0,     0,     0,  2653,  1510,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  4986,     0,     0,
    1060,     0,  1063,     0,  2554,  1065,     0,     0,     0,     0,
       0,     0,  1511,     0,     0,     0,     0,     0,     0,  1090,
       0,     0,     0,     0,   891,  1094,     0,  2484,     0,     0,
       0,     0,   891,     0,     0,  2485,  2486,  2487,  2488,  2489,
    2490,  2491,  2492,  2493,     0,     0,     0,     0,  5778,  2554,
       0,     0,     0,     0,     0,     0,     0,  2653,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1512,     0,     0,     0,   854,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   941,   951,     0,
       0,     0,     0,     0,     0,   941,     0,   951,   941,     0,
       0,     0,     0,     0,  2484,     0,     0,     0,     0,  1513,
       0,   951,  2485,  2486,  2487,  2488,  2489,  2490,  2491,  2492,
    2493,     0,     0,     0,     0,  5970,     0,   891,     0,   891,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1514,  4356,     0,     0,  2484,
       0,     0,     0,     0,     0,     0,     0,  2485,  2486,  2487,
    2488,  2489,  2490,  2491,  2492,  2493,     0,     0,     0,     0,
    5988,     0,     0,  2055,     0,     0,  2056,     0,     0,     0,
    2057,  2058,  2059,  1515,     0,     0,     0,  1516,     0,     0,
       0,     0,     0,   763,  3711,     0,     0,  2544,  2714,     0,
       0,     0,     0,  5432,     0,     0,     0,  2545,     0,     0,
       0,     0,     0,     0,  2546,     0,     0,     0,  1581,  1518,
       0,     0,     0,   891,     0,     0,  1480,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    2547,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1695,     0,     0,     0,     0,     0,  1695,     0,  1582,     0,
       0,     0,    36,     0,     0,   891,     0,  1520,     0,     0,
    2806,  2055,     0,     0,  2056,     0,  1521,     0,  2057,  2058,
    2059,     0,     0,     0,  1522,     0,     0,     0,     0,     0,
       0,     0,  1583,  3420,     0,  2544,     0,     0,     0,     0,
       0,     0,     0,     0,  1524,  2545,     0,     0,     0,     0,
       0,     0,  2546,  1525,     0,     0,     0,  1526,     0,  1572,
    1573,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   690,     0,     0,     0,     0,  1029,     0,  2547,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  2548,     0,     0,     0,     0,  2549,
       0,   891,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1527,     0,     0,  1030,     0,     0,  5762,     0,     0,
       0,  2550,  2243,  3420,     0,     0,     0,   693,  1031,  1798,
       0,     0,     0,     0,     0,     0,  2551,     0,     0,  1032,
       0,     0,     0,   694,  1810,   891,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1033,     0,     0,     0,     0,  1117,     0,  3978,     0,
    5618,     0,     0,  3979,     0,  1832,  1833,  2295,     0,     0,
       0,     0,     0,     0,     0,  1034,     0,     0,     0,     0,
       0,  2552,  2548,     0,  2553,     0,   697,  2549,     0,     0,
    1870,     0,     0,     0,     0,   698,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   699,  2550,
    2243,     0,     0,  1035,  2936,     0,     0,     0,   891,     0,
       0,     0,     0,     0,  2551,     0,     0,     0,     0,     0,
    1907,  1909,     0,     0,     0,     0,     0,     0,     0,  1036,
       0,   891,     0,   951,     0,     0,     0,     0,     0,  2972,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   951,     0,  1037,  2295,   891,     0,   951,     0,
       0,     0,     0,     0,  2554,     0,     0,     0,     0,  2552,
     951,     0,  2553,     0,     0,     0,   703,     0,     0,     0,
       0,     0,  3033,     0,  3037,     0,   951,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     941,   951,     0,     0,  3055,     0,     0,   941,   890,   951,
     941,     0,     0,     0,     0,     0,     0,  1038,     0,     0,
       0,     0,     0,   951,     0,     0,     0,     0,     0,     0,
    3075,     0,  3076,   951,     0,     0,     0,     0,     0,     0,
    1117,     0,   706,     0,  5768,     0,  5769,  3085,     0,  3086,
    5774,  5775,   214,  1039,     0,   629,   708,   629,     0,   629,
       0,   629,  3980,   629,  2484,     0,     0,   629,     0,     0,
       0,     0,  2485,  2486,  2487,  2488,  2489,  2490,  2491,  2492,
    2493,     0,     0,  1040,     0,  6034,  1041,     0,  2055,     0,
     711,  2056,   712,     0,   951,  2057,  2058,  2059,     0,   713,
       0,     0,   714,     0,     0,     0,  2653,     0,     0,     0,
       0,     0,  2544,     0,     0,     0,     0,     0,     0,     0,
       0,   715,  2545,   951,     0,     0,     0,     0,  1042,  2546,
       0,     0,     0,     0,   717,     0,     0,  1043,     0,     0,
       0,   719,     0,     0,     0,     0,     0,     0,   951,  1044,
       0,   721,     0,     0,     0,  2547,  1045,     0,     0,     0,
       0,     0,  2484,     0,     0,     0,     0,     0,     0,     0,
    2485,  2486,  2487,  2488,  2489,  2490,  2491,  2492,  2493,     0,
       0,     0,   724,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  3420,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   951,     0,
       0,     0,     0,     0,     0,     0,  2055,     0,  6056,  2056,
       0,     0,  3420,  2057,  2058,  2059,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    2544,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    2545,     0,     0,     0,     0,     0,     0,  2546,     0,     0,
       0,     0,     0,     0,     0,     0,  6056,     0,     0,  2548,
       0,     0,     0,     0,  2549,     0,     0,     0,     0,  2055,
       0,     0,  2056,  2547,  6056,     0,  2057,  2058,  2059,     0,
       0,     0,     0,     0,     0,     0,  2550,  2243,     0,     0,
       0,     0,     0,  2544,  2734,  1117,  3935,     0,     0,     0,
       0,  2551,     0,  2545,     0,     0,     0,     0,  1781,     0,
    2546,     0,     0,     0,   951,     0,     0,     0,     0,  2773,
       0,     0,     0,     0,     0,   941,     0,     0,     0,   941,
       0,   941,     0,     0,     0,     0,  2547,     0,     0,     0,
       0,     0,  2295,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   891,     0,  2552,     0,     0,  2553,
       0,     0,  5930,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  4568,     0,  2548,     0,     0,
       0,     0,  2549,     0,     0,     0,  2863,     0,     0,     0,
       0,  3420,     0,     0,     0,     0,  2653,     0,     0,     0,
       0,     0,     0,     0,  2550,  2243,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  2889,  2890,  2891,  2892,  2551,
       0,     0,     0,     0,     0,     0,     0,   951,     0,     0,
       0,  6057,     0,     0,     0,     0,     0,  2507,     0,  2554,
    2548,     0,     0,     0,     0,  2549,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  4569,     0,     0,     0,
    2295,     0,     0,     0,     0,     0,     0,  2550,  2243,     0,
       0,     0,     0,     0,  2552,     0,     0,  2553,     0,  6057,
       0,     0,  2551,     0,     0,     0,     0,     0,   951,     0,
       0,     0,     0,     0,     0,     0,     0,  6057,     0,     0,
    5048,  5931,     0,     0,   951,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   951,     0,
       0,     0,   951,  2295,     0,     0,     0,     0,   891,     0,
       0,     0,     0,     0,   950,     0,     0,  2552,     0,  2484,
    2553,     0,     0,   950,     0,     0,     0,  2485,  2486,  2487,
    2488,  2489,  2490,  2491,  2492,  2493,     0,   950,     0,     0,
       0,  2945,  2946,     0,     0,     0,     0,  2554,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  2963,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  3006,  3007,  3008,  3009,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    2554,  2055,   890,     0,  2056,     0,     0,     0,  2057,  2058,
    2059,   951,     0,     0,     0,     0,     0,     0,     0,   951,
     951,     0,   891,     0,     0,  2544,     0,     0,   890,     0,
       0,     0,     0,     0,     0,  2545,     0,  2484,     0,     0,
       0,     0,  2546,     0,     0,  2485,  2486,  2487,  2488,  2489,
    2490,  2491,  2492,  2493,     0,     0,     0,     0,     0,     0,
     891,  3083,     0,     0,     0,     0,     0,  3087,  2547,     0,
       0,     0,  1781,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   891,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  3410,  3411,
    2484,     0,     0,     0,     0,     0,     0,     0,  2485,  2486,
    2487,  2488,  2489,  2490,  2491,  2492,  2493,  3426,  3427,     0,
    3429,  3430,     0,     0,     0,  3433,  3434,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    3445,     0,     0,     0,     0,     0,     0,  3454,     0,     0,
       0,  3457,  3458,   891,     0,  3461,  3462,     0,     0,     0,
       0,     0,  3467,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  3482,     0,     0,     0,     0,   890,
       0,     0,  2548,     0,     0,     0,  3499,  2549,     0,     0,
       0,  3501,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  3507,     0,     0,  2550,
    2243,     0,     0,     0,     0,  3514,     0,     0,  3518,     0,
    3520,  3523,  3525,     0,  2551,     0,     0,  3533,  3536,     0,
       0,     0,     0,     0,     0,     0,     0,  3549,     0,     0,
       0,     0,  3246,  3559,     0,     0,     0,  3562,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  3572,
    3573,     0,     0,     0,  3578,  2295,     0,     0,     0,     0,
    3587,  3588,  5264,     0,   891,     0,     0,     0,     0,  2552,
       0,     0,  2553,     0,  3597,     0,     0,  3598,     0,     0,
       0,     0,     0,     0,  3610,  3611,     0,     0,     0,     0,
    3615,     0,  3951,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  3622,     0,   881,  3625,     0,     0,     0,     0,
    3628,   951,     0,     0,     0,     0,  3631,  3632,     0,   950,
       0,     0,     0,     0,  3638,     0,     0,     0,  3640,     0,
     890,     0,  3647,  3648,  3649,  3650,     0,  3652,   950,     0,
       0,   890,     0,     0,   950,     0,     0,     0,     0,     0,
    3677,  3678,     0,  3680,     0,     0,   950,   890,     0,     0,
       0,     0,  2554,     0,  3689,  3690,  3691,  2055,     0,     0,
    2056,     0,   950,     0,  2057,  2058,  2059,     0,     0,     0,
       0,     0,     0,     0,   891,     0,     0,   950,     0,     0,
       0,  2544,  1510,     0,  3983,   950,     0,     0,     0,     0,
       0,  2545,     0,     0,     0,     0,     0,     0,  2546,   950,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   950,
       0,  3743,     0,     0,     0,   951,     0,  1511,     0,  3767,
       0,     0,     0,     0,  2547,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  3779,     0,
       0,     0,  3420,     0,     0,     0,     0,     0,     0,     0,
    1781,     0,  2484,     0,     0,     0,     0,     0,     0,     0,
    2485,  2486,  2487,  2488,  2489,  2490,  2491,  2492,  2493,     0,
     950,     0,     0,   951,     0,     0,     0,     0,  1512,     0,
       0,   951,     0,     0,     0,     0,     0,     0,  3847,   951,
       0,     0,     0,     0,  2055,     0,     0,  2056,     0,   950,
       0,  2057,  2058,  2059,     0,     0,     0,  3861,   890,  3863,
       0,     0,     0,     0,  1513,     0,     0,     0,  2544,     0,
       0,     0,     0,     0,   950,     0,     0,     0,  2545,   941,
     941,     0,   951,   951,     0,  2546,     0,     0,  2548,     0,
       0,     0,     0,  2549,   941,     0,   951,   941,  2055,     0,
    1514,  2056,     0,     0,     0,  2057,  2058,  2059,     0,   951,
     951,  2547,     0,     0,  3420,  2550,  2243,     0,     0,     0,
       0,     0,  2544,     0,     0,  3995,     0,     0,     0,     0,
    2551,     0,  2545,     0,   950,     0,     0,     0,  1515,  2546,
       0,     0,  1516,     0,     0,     0,     0,   941,     0,     0,
       0,   941,   941,  3926,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  2547,     0,     0,     0,     0,
       0,  2295,     0,  1598,  1518,     0,     0,     0,     0,     0,
       0,  1480,     0,     0,     0,  2552,     0,     0,  2553,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    2523,     0,     0,     0,     0,  3246,  3988,     0,     0,     0,
       0,     0,     0,  1599,     0,     0,     0,    36,     0,     0,
       0,     0,  1520,     0,     0,  2548,     0,     0,     0,     0,
    2549,  1521,     0,     0,     0,     0,     0,     0,     0,  1522,
     891,     0,     0,     0,  1780,   891,   891,  1600,     0,     0,
     950,     0,  2550,  2243,     0,     0,  1781,     0,     0,  1524,
       0,     0,     0,     0,     0,     0,     0,  2551,  1525,     0,
       0,     0,  1526,     0,     0,     0,     0,     0,  2554,  2548,
       0,     0,     0,     0,  2549,     0,  2055,     0,     0,  2056,
       0,     0,     0,  2057,  2058,  2059,     0,     0,     0,     0,
       0,   890,     0,     0,     0,     0,  2550,  2243,  2295,     0,
    2544,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    2545,  2551,  2552,     0,     0,  2553,  1527,  2546,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  2547,     0,     0,     0,  5264,   891,     0,
       0,     0,  2295,     0,     0,     0,     0,     0,     0,   890,
    3481,     0,     0,   950,     0,     0,  2552,     0,  2484,  2553,
       0,     0,     0,     0,     0,     0,  2485,  2486,  2487,  2488,
    2489,  2490,  2491,  2492,  2493,     0,     0,     0,     0,     0,
       0,     0,   891,     0,     0,     0,     0,     0,     0,     0,
     890,     0,     0,     0,     0,  2554,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   950,     0,     0,  4144,     0,     0,
       0,     0,     0,   890,     0,     0,     0,     0,     0,     0,
     950,     0,     0,     0,     0,     0,     0,  4156,     0,     0,
       0,     0,     0,     0,   950,     0,     0,  2548,   950,  2554,
       0,     0,  2549,     0,  4163,     0,     0,     0,  4163,     0,
       0,     0,     0,  4174,  4175,  4176,     0,     0,   881,     0,
       0,     0,     0,     0,  2550,  2243,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  3621,  2551,
       0,  3624,     0,   883,   881,  2484,     0,     0,     0,  4206,
    4207,  4208,  4209,  2485,  2486,  2487,  2488,  2489,  2490,  2491,
    2492,  2493,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  4225,
    2295,     0,     0,     0,     0,     0,     0,  4228,     0,  4232,
    4233,  4234,     0,     0,  2552,     0,     0,  2553,     0,  2484,
       0,     0,     0,     0,     0,     0,     0,  2485,  2486,  2487,
    2488,  2489,  2490,  2491,  2492,  2493,     0,   950,     0,     0,
       0,     0,     0,     0,     0,   950,   950,     0,     0,  3715,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  3728,     0,     0,     0,     0,     0,     0,     0,
    3737,     0,     0,     0,     0,     0,     0,  2055,     0,     0,
    2056,     0,     0,   890,  2057,  2058,  2059,     0,     0,     0,
       0,     0,     0,     0,   890,     0,     0,     0,  1780,     0,
       0,  2544,     0,     0,  4575,     0,     0,  2554,     0,  3781,
     890,  2545,     0,     0,     0,   881,     0,     0,  2546,     0,
       0,     0,     0,     0,     0,  4317,     0,     0,     0,     0,
    3805,     0,     0,     0,  4323,     0,     0,     0,     0,  4522,
       0,     0,     0,     0,  2547,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    4333,  4334,     0,   890,     0,  4335,     0,     0,     0,     0,
       0,     0,     0,  3860,     0,  3862,     0,     0,   890,     0,
       0,   890,   890,     0,     0,     0,     0,  4377,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  2055,     0,     0,  2056,     0,     0,  2484,  2057,  2058,
    2059,  1781,   890,   890,     0,  2485,  2486,  2487,  2488,  2489,
    2490,  2491,  2492,  2493,     0,  2544,     0,     0,     0,     0,
     884,     0,     0,     0,     0,  2545,     0,     0,     0,  4414,
       0,     0,  2546,     0,  4420,     0,     0,     0,     0,     0,
    4426,     0,     0,     0,     0,     0,     0,     0,  2548,     0,
       0,     0,  3918,  2549,     0,     0,   951,     0,  2547,  3925,
       0,     0,     0,     0,     0,     0,   881,     0,     0,     0,
    4465,     0,     0,     0,   951,  2550,  2243,   881,   951,     0,
       0,     0,   951,     0,     0,     0,     0,     0,     0,     0,
    2551,   951,     0,   881,     0,     0,     0,     0,     0,  4480,
       0,  4481,     0,     0,     0,     0,     0,     0,     0,   951,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   941,     0,   941,   941,
       0,  2295,   890,     0,     0,     0,     0,   950,     0,     0,
       0,     0,  4506,   951,     0,  2552,     0,     0,  2553,     0,
       0,  2055,  1695,  5000,  2056,     0,     0,     0,  2057,  2058,
    2059,     0,     0,   951,   951,     0,     0,     0,     0,     0,
       0,     0,  2548,     0,     0,  2544,     0,  2549,     0,     0,
       0,     0,     0,     0,     0,  2545,     0,     0,     0,     0,
       0,     0,  2546,     0,  1781,   951,     0,     0,  1781,  2550,
    2243,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  2551,     0,     0,     0,  2547,     0,
       0,     0,   951,     0,  1781,     0,     0,     0,   951,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  2554,     0,
       0,     0,   951,     0,     0,     0,     0,     0,     0,   951,
       0,   950,   951,     0,   881,  2295,     0,     0,   951,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  2552,
       0,     0,  2553,     0,     0,     0,     0,     0,   951,     0,
       0,     0,     0,     0,   951,     0,  1780,     0,     0,     0,
       0,   951,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   951,     0,     0,     0,   950,
       0,     0,     0,  5006,     0,     0,     0,   950,   951,     0,
       0,     0,     0,  1781,     0,   950,     0,     0,     0,   951,
       0,     0,  2548,     0,     0,     0,     0,  2549,  2484,     0,
       0,     0,     0,     0,     0,     0,  2485,  2486,  2487,  2488,
    2489,  2490,  2491,  2492,  2493,     0,     0,     0,     0,  2550,
    2243,     0,  2554,     0,     0,     0,     0,     0,   950,   950,
       0,     0,  4159,  4160,  2551,     0,     0,     0,     0,     0,
    4690,     0,   950,  4697,     0,  4698,     0,     0,     0,  1781,
       0,     0,     0,     0,     0,   950,   950,   883,  4705,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    4711,     0,     0,     0,  4714,  2295,     0,     0,  2055,     0,
       0,  2056,     0,   883,     0,  2057,  2058,  2059,     0,  2552,
       0,     0,  2553,  4738,     0,     0,     0,     0,     0,     0,
       0,     0,  2544,     0,     0,     0,     0,     0,   886,     0,
       0,  4742,  2545,     0,     0,     0,     0,  4746,     0,  2546,
       0,     0,  2484,     0,     0,     0,     0,     0,     0,     0,
    2485,  2486,  2487,  2488,  2489,  2490,  2491,  2492,  2493,     0,
       0,     0,  4781,     0,     0,  2547,  4785,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   881,     0,     0,
       0,  4794,  4795,  4796,  4797,     0,     0,     0,     0,     0,
       0,  4801,  4802,  4803,  4804,     0,     0,     0,     0,     0,
    4806,  4807,  2554,     0,     0,     0,  4814,  4815,     0,  4817,
    4818,  4819,  4820,  4821,  4822,  4823,     0,     0,     0,     0,
       0,     0,  1780,     0,   951,  4832,     0,     0,     0,  4835,
    4836,  4837,  4838,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   951,     0,     0,   881,     0,     0,     0,   951,
       0,     0,     0,  4163,   883,  5007,   941,     0,   941,   941,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  4858,     0,     0,     0,     0,     0,     0,     0,  2548,
       0,     0,     0,     0,  2549,     0,   881,     0,     0,     0,
       0,     0,  4330,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  2484,     0,     0,     0,  2550,  2243,     0,     0,
    2485,  2486,  2487,  2488,  2489,  2490,  2491,  2492,  2493,   881,
       0,  2551,     0,  1781,     0,     0,     0,     0,     0,  1781,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   884,     0,     0,  4939,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  2295,     0,     0,     0,     0,     0,     0,     0,
     884,     0,     0,     0,     0,     0,  2552,     0,     0,  2553,
    4163,     0,     0,     0,     0,     0,     0,  4964,     0,  4965,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   890,
       0,     0,     0,   890,   890,     0,     0,     0,     0,   951,
       0,  4979,     0,     0,     0,   883,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   883,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   883,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  4483,     0,     0,     0,     0,     0,     0,     0,
       0,   890,     0,     0,     0,     0,     0,   890,     0,  2554,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   890,   881,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     881,   884,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   881,     0,   951,   951,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  2055,     0,     0,  2056,     0,     0,
       0,  2057,  2058,  2059,     0,   951,     0,     0,   951,  2484,
       0,     0,     0,     0,     0,     0,     0,  2485,  2486,  2487,
    2488,  2489,  2490,  2491,  2492,  2493,     0,     0,  2545,   881,
       0,     0,     0,     0,     0,  2546,     0,     0,     0,     0,
       0,     0,     0,   883,   881,     0,     0,   881,   881,     0,
       0,  5115,  5116,  5117,     0,     0,     0,  5118,  5119,  5120,
    5121,  2547,     0,     0,  5123,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   881,   881,
    1781,  1781,  1781,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    5142,  5143,  5144,  5145,  5146,   951,  5148,  5149,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  5158,  5159,
       0,     0,   884,     0,   951,     0,     0,     0,     0,     0,
       0,     0,     0,   884,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   951,     0,     0,   884,
       0,  5167,     0,     0,     0,     0,     0,   890,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1780,     0,     0,
       0,     0,     0,     0,     0,  2548,     0,     0,     0,     0,
    2549,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   887,     0,     0,     0,     0,
       0,     0, -2820, -2820,     0,     0,     0,     0,   881,     0,
       0,     0,   886,     0,     0,     0,     0,  2551,     0,     0,
       0,     0,   950,     0,     0,     0,     0,     0,     0,     0,
     890,     0,   951,     0,   890,     0,     0,     0,   886,     0,
     950,     0,     0,     0,   950,     0,     0,     0,   950,     0,
       0,     0,     0,  5230,     0,     0,     0,   950, -2820,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  2552,     0,     0,   950,     0,     0,     0,  1781,
       0,     0,     0,     0,     0,   951,   883,   951,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     951,     0,   951,     0,     0,     0,     0,     0,     0,   950,
     884,     0,     0,     0,     0,     0,     0,     0,  5281,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   950,
     950,     0,     0,     0,     0,     0,   890,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   890,     0,     0,   883,     0,   890,     0,     0,     0,
    1780,   950,     0,  4855,  1780,  2554,     0,     0,     0,   951,
       0,     0,     0,     0,     0,     0,     0,  4857,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   950,   886,
    1780,     0,     0,     0,   950,   883,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   950,     0,
       0,   951,     0,     0,     0,   950,     0,     0,   950,     0,
       0,     0,     0,     0,   950,     0,     0,     0,   883,   629,
     951,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   950,     0,     0,     0,     0,     0,
     950,     0,   951,     0,     0,   951,     0,   950,     0,     0,
       0,     0,     0,     0,     0,  2484,     0,     0,     0,     0,
       0,   950,     0,  2485,  2486,  2487,  2488,  2489,  2490,  2491,
    2492,  2493,     0,     0,   950,     0,     0,     0,     0,  1780,
     889,     0,  5385,     0,     0,   950,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  5395,     0,     0,     0,     0,     0,     0,     0,  5401,
    5402,     0,     0,     0,     0,     0,     0,     0,     0,  5413,
       0,     0,     0,     0,     0,  1781,  5415,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     886,     0,     0,   884,     0,  1780,     0,     0,     0,     0,
       0,   886,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  5467,  5468,     0,     0,     0,     0,   886,     0,     0,
       0,     0,     0,     0,  5476,     0,  5478,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  5492,     0,     0,     0,     0,     0,     0,     0,   890,
       0,     0,   890,     0,   890,     0,     0,     0,   883,   890,
       0,   884,     0,     0,  2055,     0,  4163,  2056,     0,   883,
       0,  2057,  2058,  2059,  5526,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   883,     0,     0,  2544,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  2545,     0,
       0,     0,   884,     0,     0,  2546,     0,   890,     0,     0,
       0,     0,     0,     0,     0,   890,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  2547,     0,     0,     0,   884,     0,     0,   883,     0,
     890,     0,     0,  5563,     0,     0,   951,     0,     0,     0,
     950,     0,     0,   883,     0,     0,   883,   883,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  5583,   950,     0,
       0,     0,     0,     0,     0,   950,     0,  5590,   886,     0,
       0,     0,     0,     0,     0,     0,     0,   883,   883,     0,
       0,     0,     0,     0,     0,     0,     0,  1781,     0,     0,
    5008,     0,  1781,     0,  1781,     0,     0,     0,     0,     0,
     890,     0,   890,     0,     0,     0,     0,  2055,     0,     0,
    2056,     0,     0,     0,  2057,  2058,  2059,     0,  1781,     0,
       0,     0,     0,     0,     0,   881,     0,     0,     0,   881,
     881,  2544,     0,     0,  5649,  2548,     0,     0,     0,  1780,
    2549,  2545,     0,     0,     0,  1780,     0,     0,  2546,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  5175,     0,
       0,     0,  2550,  2243,   951,     0,     0,   951,     0,   887,
       0,     0,     0,  5179,  2547,     0,     0,  2551,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   881,     0,     0,
       0,     0,     0,   881,     0,   887,   890,     0,     0,     0,
       0,     0,     0,     0,  4163,     0,     0,   883,     0,     0,
       0,     0,     0,     0,     0,   884,     0,     0,  2295,     0,
       0,     0,     0,     0,     0,   950,   884,     0,     0,     0,
       0,     0,  2552,     0,   881,  2553,     0,     0,   890,     0,
       0,     0,   884,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   951,   951,     0,
       0,     0,     0,     0,  5237,  5744,   890,     0,   951,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  5757,
       0,     0,     0,     0,     0,   951,     0,     0,  2548,     0,
       0,     0,     0,  2549,     0,   884,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     884,   886,     0,   884,   884,  2550,  2243,     0,     0,     0,
       0,     0,     0,     0,     0,  2554,     0,     0,     0,     0,
    2551,     0,     0,     0,   890,     0,     0,     0,  5796,     0,
       0,     0,     0,     0,   884,   884,   887,     0,     0,     0,
       0,     0,     0,     0,   950,   950,   890,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   951,     0,     0,     0,
       0,  2295,     0,     0,     0,     0,     0,     0,   890,   886,
       0,   950,     0,     0,   950,  2552,     0,   954,  2553,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   988,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1007,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     886,     0,     0,     0,     0,  2484,     0,     0,  5870,     0,
       0,     0,     0,  2485,  2486,  2487,  2488,  2489,  2490,  2491,
    2492,  2493,     0,   881,     0,     0,     0,     0,     0,  5369,
       0,  5370,     0,   886,     0,     0,  1780,  1780,  1780,     0,
    5882,   890,     0,     0,   889,     0,     0,     0,     0,     0,
       0,  5892,     0,     0,   884,     0,     0,     0,  2554,     0,
       0,   950,     0,     0,   890,     0,     0,     0,     0,     0,
     889,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     950,     0,     0,     0,     0,     0,     0,   887,     0,   890,
       0,     0,     0,     0,     0,     0,   881,     0,   887,     0,
     881,     0,   950,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   887,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  5356,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  5964,     0,     0,     0,     0,     0,  2484,     0,
       0,     0,   951,     0,     0,     0,  2485,  2486,  2487,  2488,
    2489,  2490,  2491,  2492,  2493,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  5497,     0,     0,     0,   950,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   881,     0,   951,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   951,   881,     0,     0,
       0,   889,   881,   886,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   886,  1780,     0,     0,     0,   890,
       0,   950,     0,   950,  2055,     0,     0,  2056,     0,   951,
     886,  2057,  2058,  2059,     0,     0,   950,     0,   950,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  2544,     0,
       0,     0,     0,     0,     0,   887,     0,     0,  2545,     0,
       0,     0,     0,     0,     0,  2546,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   886,     0,     0,     0,     0,     0,     0,
       0,  2547,     0,     0,     0,     0,     0,     0,   886,     0,
       0,   886,   886,     0,     0,   950,     0,  1781,     0,   890,
       0,     0,     0,     0,     0,     0,     0,  5605,     0,  5607,
       0,     0,     0,     0,     0,     0,   951,     0,     0,     0,
       0,     0,   886,   886,     0,   890,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   950,     0,     0,
       0,     0,     0,     0,   883,     0,     0,     0,   883,   883,
       0,     0,   889,     0,     0,     0,   950,     0,     0,     0,
       0,     0,  1026,   889,     0,     0,     0,     0,  1058,     0,
       0,  5528,     0,     0,     0,     0,     0,     0,   950,   889,
       0,   950,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  2548,     0,     0,     0,     0,
    2549,     0,   951,     0,     0,     0,   883,     0,     0,     0,
       0,     0,   883,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  2550,  2243,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  2551,     0,     0,
       0,     0,     0,     0,     0,   881,     0,     0,   881,     0,
     881,     0,   886,   883,     0,   881,     0,     0,     0,     0,
       0,  1780,     0,     0,     0,     0,     0,   890,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  2295,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   887,     0,
       0,     0,  2552,     0,     0,  2553,     0,     0,     0,     0,
       0,  2055,     0,   881,  2056,     0,     0,     0,  2057,  2058,
    2059,   881,     0,   951,   890,   951,     0,     0,     0,   890,
       0,     0,     0,     0,     0,  2544,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  2545,   881,     0,     0,     0,
     889,     0,  2546,     0,     0,     0,     0,     0,  1353,     0,
    5792,     0,     0,     0,     0,     0,   887,     0,     0,     0,
     951,     0,     0,     0,     0,     0,     0,  1376,  2547,     0,
     941,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  2554,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   887,     0,     0,
       0,     0,     0,     0,     0,     0,   881,     0,   881,     0,
       0,   884,  1781,     0,     0,   884,   884,   941,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     887,     0,   950,     0,     0,     0,     0,  1434,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   890,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  5876,   883,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   884,     0,     0,     0,     0,     0,   884,
       0,     0,  2548,  1780,  1571,  2484,     0,  2549,  1780,     0,
    1780,     0,     0,  2485,  2486,  2487,  2488,  2489,  2490,  2491,
    2492,  2493,   881,     0,     0,     0,     0,     0,     0,  2550,
    2243,     0,     0,     0,  1780,     0,     0,     0,     0,     0,
     884,     0,     0,     0,  2551,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   883,     0,     0,     0,   883,
       0,     0,     0,     0,   881,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     950,     0,     0,   950,     0,  2295,     0,     0,     0,     0,
    5958,     0,   881,     0,     0,   890,     0,     0,     0,  2552,
       0,     0,  2553,   889,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1830,     0,
    5972,  5972,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   890,     0,     0,     0,     0,     0,     0,
     887,     0,     0,     0,     0,   951,  1864,  1867,  1868,     0,
       0,   887,     0,     0,     0,   890,     0,     0,     0,   951,
     881,   883,     0,     0,     0,     0,     0,   887,     0,     0,
       0,   889,     0,   950,   950,     0,   883,     0,     0,     0,
       0,   883,   881,     0,   950,     0,     0,     0,     0,     0,
    1781,     0,  2554,     0,     0,     0,     0,     0,     0,     0,
       0,   950,     0,     0,   881,     0,     0,     0,     0,     0,
       0,     0,   889,     0,     0,     0,     0,     0,     0,     0,
     887,     0,     0,     0,     0,     0,   890,     0,     0,     0,
       0,     0,  5972,     0,     0,   887,     0,     0,   887,   887,
       0,     0,     0,     0,     0,   889,     0,     0,     0,   884,
       0,     0,     0,     0,     0,  1353,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   887,
     887,     0,     0,     0,     0,     0,  1993,     0,     0,     0,
       0,     0,   950,     0,     0,  1353,  1781,   881,     0,     0,
       0,     0,  2484,     0,     0,     0,     0,     0,     0,     0,
    2485,  2486,  2487,  2488,  2489,  2490,  2491,  2492,  2493,     0,
     881,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   884,     0,     0,     0,   884,     0,     0,     0,
       0,     0,     0,     0,     0,   881,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   890,     0,     0,
       0,  1781,     0,   951,     0,     0,     0,     0,     0,   886,
       0,     0,     0,   886,   886,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   887,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   886,     0,  2538,     0,     0,     0,   886,   884,     0,
       0,     0,     0,     0,   883,   889,     0,   883,     0,   883,
       0,     0,     0,   884,   883,     0,   889,     0,   884,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   889,     0,     0,     0,     0,   890,   886,     0,
       0,     0,     0,     0,     0,   951,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   881,     0,     0,   941,     0,
       0,     0,   883,     0,     0,     0,     0,     0,   950,     0,
     883,   951,     0,  2629,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   889,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   883,     0,     0,     0,     0,
     889,     0,     0,   889,   889,   890,     0,     0,     0,     0,
     950,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   950,     0,     0,     0,     0,     0,     0,     0,
     941,   941,     0,     0,   889,   889,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   881,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   950,     0,  2746,     0,     0,
       0,     0,     0,     0,     0,   883,  2769,   883,     0,     0,
       0,   881,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   951,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  2807,     0,
       0,     0,     0,     0,  2819,  2819,     0,     0,  2819,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  2837,     0,     0,  2840,     0,     0,   890,     0,     0,
       0,     0,     0,  1780,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   886,     0,     0,
       0,     0,   950,     0,     0,     0,     0,     0,     0,     0,
       0,   883,     0,     0,   889,     0,     0,     0,     0,     0,
       0,   884,     0,     0,   884,     0,   884,     0,     0,  2893,
       0,   884,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  2912,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   883,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   881,     0,     0,     0,     0,     0,     0,
     886,     0,     0,     0,   886,     0,     0,     0,     0,   884,
       0,   883,     0,     0,  1781,     0,     0,   884,   950,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   890,     0,     0,     0,     0,   890,   890,
     881,     0,   884,     0,     0,   881,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1781,     0,     0,     0,     0,     0,     0,     0,
     941,   941,     0,     0,     0,     0,     0,     0,     0,   883,
    1781,     0,  2934,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  2937,     0,     0,     0,     0,     0,     0,
       0,   883,     0,     0,     0,     0,   886,     0,     0,     0,
       0,     0,   884,     0,   884,     0,     0,     0,     0,     0,
       0,   886,     0,   883,     0,     0,   886,     0,     0,   950,
       0,   950,     0,     0,     0,  2981,  2819,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   890,     0,     0,     0,     0,     0,     0,     0,     0,
    3016,     0,     0,     0,     0,     0,     0,  3029,     0,     0,
       0,     0,     0,     0,     0,     0,   950,   881,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   890,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   883,     0,   884,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1780,   883,
       0,     0,     0,     0,     0,     0,   887,     0,     0,  3090,
     887,   887,     0,     0,     0,     0,     0,     0,     0,     0,
     884,     0,     0,     0,   883,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1353,  1353,     0,     0,     0,     0,   884,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  3143,
       0,     0,     0,     0,     0,     0,     0,     0,   887,     0,
       0,   881,     0,     0,   887,     0,     0,     0,     0,     0,
       0,     0,     0,   690,     0,     0,     0,     0,   691,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   881,
       0,     0,     0,     0,     0,   887,   884,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   692,     0,     0,     0,
       0,   881,     0,     0,     0,     0,     0,     0,   884,   693,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   886,
       0,     0,   886,     0,   886,   694,     0,     0,     0,   886,
     884,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   695,   883,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   696,     0,     0,
       0,     0,   881,     0,     0,     0,     0,   886,   697,     0,
       0,   950,     0,     0,     0,   886,     0,   698,     0,     0,
       0,     0,     0,     0,     0,   950,     0,     0,     0,     0,
     699,   641,     0,     0,     0,   700,     0,     0,     0,     0,
     886,     0,   701,   884,     0,     0,     0,     0,     0,   642,
       0,     0,     0,     0,     0,     0,  1780,     0,     0,     0,
       0,   702,     0,     0,   883,     0,   884,     0,     0,     0,
       0,     0,     0,     0,   643,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   644,     0,     0,
     883,   884,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   889,     0,  -865,     0,   889,   889,     0,   703,     0,
     886,     0,   886,     0,     0,     0,     0,     0,     0,     0,
       0,   645,     0,   881,   887,     0,     0,   646,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   647,     0,     0,     0,   704,
       0,     0,  1780,     0,     0,     0,   648,     0,     0,     0,
       0,     0,   705,   889,     0,   649,     0,     0,     0,   889,
       0,     0,     0,     0,   706,     0,     0,     0,   650,     0,
       0,     0,     0,     0,   214,   707,   651,     0,   708,     0,
     652,     0,     0,     0,     0,     0,     0,   887,     0,     0,
       0,   887,     0,     0,     0,     0,   886,     0,     0, -1066,
     889,     0,     0,     0,     0,   709,     0,  1780,   710,   950,
       0,     0,   711,     0,   712,     0,     0,     0,     0,     0,
       0,   713,   883,     0,   714,     0,     0,     0,     0,     0,
       0,   884,     0,   881,     0,     0,   653,     0,   886,     0,
       0,     0,     0,   715,     0,     0,  -601,     0,     0,     0,
     716,     0,     0,     0,  1329,  1329,   717,     0,     0,   718,
       0,     0,     0,   719,     0,     0,   886,     0,     0,   883,
       0,   720,     0,   721,   883,     0,     0,     0,   722,     0,
       0,     0,     0,     0,     0,     0,     0,   654,     0,     0,
     655,   723,     0,   887,     0,     0,     0,     0,     0,     0,
       0,   881,     0,     0,   724,     0,     0,     0,   887,     0,
       0,     0,   656,   887,     0,     0,     0,     0,     0,     0,
       0,   884,     0,     0,     0,     0,   657,     0,     0,     0,
       0,   950,  1329,  -459,   886,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   884,     0,     0,
       0,     0,     0,   658,     0,     0,   886,   950,     0,     0,
       0,  3300,   659,     0,     0,     0,     0,     0,     0,  -459,
       0,  3305,   660,     0,     0,     0,     0,     0,   886,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   661,     0,     0,     0,     0,     0,     0,   662,     0,
    1434,     0,     0,     0,  -459,     0,   883,   663,   664,   889,
     665,   666,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   881,     0,     0,   667,     0,     0,     0,
       0,     0,     0,   668,     0,     0,   669,     0,     0,   670,
       0,     0,     0,     0,     0,     0,     0,  1434,  1434,     0,
       0,     0,  -459,  1692,  1696,     0,     0,     0,     0,     0,
       0,   886,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   950,     0,     0,     0,     0,     0,
       0,  1353,   889,     0,   886,     0,   889,     0,     0,   884,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   886,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     883,     0,     0,     0,     0,     0,   884,     0,     0,     0,
       0,   884,     0,     0,     0,     0,     0,     0,     0,   881,
       0,     0,     0,     0,   881,   881,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   887,     0,   883,   887,
       0,   887,     0,     0,     0,     0,   887,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   889,     0,
     883,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   889,     0,     0,     0,     0,   889,     0,
       0,     0,     0,     0,  3517,     0,     0,     0,     0,     0,
    1780,     0,     0,     0,   887,     0,     0,     0,     0,  3539,
       0,     0,   887,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  3567,     0,     0,     0,     0,     0,   887,     0,   886,
       0,   883,     0,     0,     0,     0,     0,   881,  1780,     0,
       0,     0,     0,   884,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1780,     0,     0,     0,
       0,  2010,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   881,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  2025,     0,     0,     0,     0,   887,     0,   887,
       0,     0,     0,     0,     0,     0,     0,  3645,  3646,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   886,
    2044,  2045,  2046,     0,  2048,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  2502,   886,     0,     0,     0,     0,
       0,     0,   883,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   884,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   887,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   884,     0,     0,  3769,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   884,     0,     0,
       0,   889,     0,     0,   889,   887,   889,     0,     0,     0,
       0,   889,     0,     0,     0,     0,  2596,     0,     0,     0,
    2608,  2613,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   887,     0,     0,     0,     0,     0,     0,
       0,     0,   883,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   886,     0,   889,
       0,     0,     0,     1,     0,     0,     0,   889,   884,     0,
       0,     0,     0,     2,     0,     3,     4,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   889,     0,     0,     0,     0,     0,     0,     0,
       0,   887,     0,     6,   886,     0,     0,     0,     0,   886,
     883,     0,     0,     0,     0,     7,     0,     8,     9,     0,
       0,     0,     0,   887,    10,     0,    11,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    12,     0,
      13,     0,     0,     0,     0,   887,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    14,     0,     0,
      15,     0,   889,     0,   889,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    16,     0,    17,     0,     0,
       0,    18,     0,     0,     0,     0,     0,  5506,     0,   884,
       0,     0,     0,     0,     0,    20,     0,    21,     0,     0,
       0,     0,     0,     0,    22,     0,     0,  2495,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    23,     0,     0,     0,     0,     0,     0,   887,     0,
       0,     0,   883,     0,     0,     0,     0,     0,    24,     0,
       0,   886,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   887,     0,     0,     0,     0,     0,     0,   889,     0,
       0,  2495,     0,  1692,  1692,  1692,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   887,     0,    25,    26,
       0,     0,     0,     0,    27,     0,     0,     0,     0,     0,
       0,     0,     0,  4041,     0,     0,     0,     0,    28,     0,
     889,     0,     0,     0,     0,     0,     0,     0,     0,   884,
       0,     0,     0,     0,  1434,     0,    29,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   889,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    30,     0,     0,     0,     0,   883,     0,
       0,    31,     0,   883,   883,   886,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    32,     0,   884,     0,     0,
     198,    33,    34,     0,    35,     0,     0,     0,     0,    36,
       0,     0,  4455,     0,     0,    37,   889,     0,    38,     0,
       0,     0,     0,   886,     0,    39,     0,     0,     0,     0,
       0,    40,    41,     0,     0,     0,     0,     0,   889,    42,
       0,     0,     0,    43,     0,   886,   887,     0,     0,     0,
       0,   199,     0,    44,     0,     0,     0,     0,     0,     0,
     889,     0,     0,     0,     0,     0,     0,   200,    45,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   201,     0,     0,    46,     0,
       0,   202,     0,     0,     0,     0,   883,     0,     0,    47,
       0,     0,     0,     0,     0,    48,     0,     0,     0,   203,
      49,     0,     0,     0,     0,     0,   886,     0,     0,   884,
     204,     0,     0,    50,     0,     0,     0,     0,     0,   205,
       0,     0,     0,     0,     0,     0,   887,     0,     0,     0,
     883,     0,   206,   889,     0,     0,    51,   207,     0,     0,
       0,     0,     0,     0,   208,     0,     0,     0,     0,     0,
       0,     0,   887,     0,    57,     0,   889,  -136,     0,     0,
       0,     0,     0,   209,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    2495,   889,     0,     0,  2495,     0,     0,     0,   210,     0,
    4250,     0,     0,     0,     0,     0,     0,     0,     0,  3171,
    2819,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     211,  3191,     0,  3192,     0,  3194,     0,     0,  3208,  3211,
    3216,     0,     0,     0,     0,     0,  3225,   886,     0,  3230,
       0,     0,     0,     0,     0,   884,     0,     0,     0,     0,
     884,   884,     0,     0,  3237,  3238,  3239,     0,     0,     0,
       0,   212,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  3240,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   213,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   214,   215,     0,     0,
     216,     0,     0,     0,   887,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   217,     0,     0,
     218,     0,     0,     0,   219,     0,   220,     0,     0,     0,
       0,   889,     0,   221,     0,     0,   222,     0,     0,     0,
       0,   887,     0,     0,     0,     0,   887,   886,     0,     0,
       0,     0,     0,   884,     0,   223,     0,     0,     0,  4381,
    4382,  4383,   224,     0,     0,     0,     0,   225,   226,     0,
       0,   227,     0,     0,     0,   228,  4392,     0,     0,     0,
       0,     0,     0,     0,     0,   229,     0,     0,     0,     0,
     230,     0,     0,     0,     0,     0,     0,   884,     0,     0,
       0,     0,     0,   231,  3247,     0,     0,     0,     0,  4417,
    4419,     0,     0,     0,  4424,   886,   232,     0,     0,     0,
       0,   889,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  3264,     0,     0,   889,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   887,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  3266,  2495,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  2495,     0,     0,     0,  3204,  4505,     0,
       0,  1353,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  2495,  2495,  2495,     0,  2495,   886,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   889,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   887,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   889,     0,     0,     0,
     887,   889,     0,     0,     0,     0,     0,     0,     0,     0,
    4607,  4608,  4609,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   887,   886,     0,     0,     0,     0,   886,   886,
       0,     0,  3273,  3274,  3275,  3276,  3277,  3278,  3279,  3280,
    3281,     0,  3282,     0,     0,     0,     0,     0,     0,     0,
       0,  1329,     0,  1692,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  3240,     0,   887,     0,  3247,     0,     0,  3264,     0,
    3266,     0,     0,  3317,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   889,     0,     0,     0,     0,     0,     0,
       0,   886,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  2045,  2046,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   886,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   887,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  3459,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   889,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   889,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   889,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   887,     0,  4868,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    2495,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  4900,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   889,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    3029,     0,   887,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  4958,     0,     0,     0,     0,
       0,     0,     0,     0,  2495,     0,     0,     0,     0,     0,
       0,     0,  3090,     0,     0,     0,  2495,     0,     0,     0,
       0,  2495,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  3701,  3702,  1692,     0,     0,     0,
    3706,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  3735,     0,   889,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   887,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  5043,  5044,  5045,  5046,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   889,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     887,     0,     0,     0,     0,   887,   887,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   889,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  3931,     0,     0,     0,     0,
    3937,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  2048,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  3216,
       0,  3216,  3216,     0,     0,     0,     0,     0,   887,     0,
       0,     0,     0,     0,     0,  3998,     0,     0,  4001,     0,
    4003,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   887,     0,  4022,     0,  4025,     0,  4027,   889,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  4092,     0,     0,     0,
       0,  2596,  5259,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  5269,     0,     0,  2613,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   889,     0,     0,     0,     0,
     889,   889,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  4142,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  2495,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  2495,
    2495,     0,  2495,     0,     0,     0,     0,  3204,  3204,     0,
    3974,     0,  3204,     0,     0,     0,  2495,     0,     0,  2495,
       0,     0,     0,   889,  2495,     0,     0,     0,     0,     0,
       0,     0,     0,  2495,     0,     0,     0,     0,  2495,     0,
       0,     0,     0,     0,     0,  2495,  2495,  2495,  2495,     0,
       0,     0,  3204,  3204,     0,  2495,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   889,     0,     0,
       0,     0,  2495,     0,  2495,     0,     0,     0,     0,     0,
       0,  2495,  2495,  2495,  2495,  2495,  2495,  2495,  2495,  2495,
    2495,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  2495,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  5451,     0,     0,     0,     0,  1353,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  5481,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1692,     0,     0,     0,     0,     0,
    1692,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  2495,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  4404,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    5580,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    5656,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  5678,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  4523,
       0,     0,     0,     0,     0,     0,     0,     0,  4527,     0,
       0,     0,     0,     0,     0,     0,  4529,     0,  4530,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  4552,  4553,  4554,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  3225,     0,     0,     0,     0,  2495,
    2495,     0,  4578,     0,  2495,  4581,     0,  4583,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  4586,     0,     0,
       0,     0,     0,     0,     0,  4593,  4594,     0,     0,     0,
       0,     0,     0,  2495,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  4652,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  4666,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  2495,
       0,     0,     0,     0,     0,  2495,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  3974,  3974,     0,     0,  3204,  3204,  3204,
    3204,     0,     0,  3204,  3204,  3204,  3204,  3204,  3204,  3204,
    3204,  3204,  3204,  3974,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  2495,     0,     0,  2495,
       0,  2495,     0,     0,  3974,  3974,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    2495,  3204,  3204,  2495,     0,  2495,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    2495,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    2495,  4946,  4947,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  4954,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  4996,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    5002,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  5021,
    5023,     0,     0,     0,     0,     0,  5027,  5028,     0,     0,
       0,  5029,     0,     0,     0,  5030,     0,     0,  5033,  5034,
       0,     0,     0,  5038,     0,     0,     0,     0,     0,  5042,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  5073,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1329,     0,     0,     0,     0,     0,     0,     0,  5087,  3204,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  5097,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  2495,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  5161,
       0,     0,     0,     0,     0,  5165,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  2495,     0,     0,     0,  2495,     0,  2495,  2495,     0,
       0,     0,     0,  3974,  3974,  3974,  3974,     0,     0,     0,
    3974,  3974,  3974,  3974,  3974,  3974,  3974,  3974,  3974,  3974,
    2495,  2495,  2495,  5200,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  2495,     0,     0,  2495,
       0,  2495,     0,     0,  2495,     0,     0,  3974,  3974,     0,
       0,  2495,  2495,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    2495,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  2495,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  5287,     0,     0,
       0,     0,     0,  5291,  5292,  5293,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  5304,  5305,
       0,     0,  5306,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  5326,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  5344,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  5359,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  3974,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  2495,  2495,     0,     0,     0,     0,
       0,     0,  2495,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  3225,     0,     0,  2495,     0,     0,     0,     0,     0,
    2495,  3204,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  2495,
       0,  2495,     0,     0,     0,  2495,  2495,  2495,  2495,     0,
       0,  2495,  2495,     0,  2048,     0,  2495,     0,     0,     0,
    2495,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  3204,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  2495,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  2495,     0,     0,     0,     0,
       0,     0,     0,     0,  5597,  2495,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  5633,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  2495,
       0,     0,     0,  2495,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  2495,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  5699,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  5344,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  5746,     0,  2495,     0,  3974,  3204,  2495,
    2495,  2495,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  2495,  2495,  2495,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  3204,     0,     0,
    3974,     0,     0,     0,  2495,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  2495,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  2495,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  5831,  5831,  5831,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  5344,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  5858,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  5899,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  5924,     0,  5831,     0,  3974,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  3974,     0,  3204,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  2495,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  2495,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  6000,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  5831,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  2495,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  2495,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1692,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  2495,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  3204,  3204,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  2495,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  2495,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  2495,     0,   235,     0,  1245,   685,     0,  1246,
    1247,  1248,   746,  1249,     0,     0,     0,     0,  3974,  3974,
       0,   236,   237,   238,   239,   240,   241,   242,   243,  1686,
     244,   245,   246,     0,     0,     0,     0,  1250,     0,     0,
     247,   248,   249,     0,   250,   251,   252,   253,   254,   255,
     256,   257,   258,  1251,   260,  1252,  1253,     0,   263,   264,
     265,   266,   267,   268,   269,  1254,  1255,   270,   271,  1256,
    1257,   274,     0,   275,   276,   277,   278,  1258,  2495,  1259,
       0,   281,   282,   283,   284,   285,   286,   287,   288,   289,
     290,     0,   291,   292,   293,   294,   295,   296,     0,   297,
     298,   299,   300,  1260,  1261,  1262,  1263,  1264,  1265,  1266,
     302,   303,   304,   305,   306,   307,  1267,  1268,   310,  1269,
     311,     0,   312,   313,   314,   315,   316,   317,   318,     0,
     319,   320,   321,   322,  1687,     0,   323,   324,   864,   326,
     327,     0,   328,   329,   330,     0,   331,   332,   333,     0,
     334,   335,   336,   337,  1270,   339,   340,   341,   342,  1271,
    1272,   344,     0,   345,   346,   347,  1273,   349,     0,   350,
       0,   351,   352,     0,   353,   354,   355,   356,   357,     0,
     358,  1274,     0,  1275,   361,   362,     0,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,     0,   373,   374,
     375,   376,   377,   378,   379,     0,   380,   381,   382,   383,
     384,   385,   386,  1276,  1277,     0,  1278,     0,   390,   391,
     392,   393,   394,   395,   396,   397,   398,   399,     0,     0,
     400,  1279,   402,   403,   404,     0,   405,   406,   407,  1280,
    1281,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,   419,   420,   421,   422,   423,   424,   425,  1282,
     427,  1283,   429,   430,   431,   432,   433,   434,   435,   436,
    1284,   438,  1285,   439,   440,   441,   442,  1286,  1287,   444,
    1288,   446,   447,   448,     0,   449,   450,     0,     0,  1289,
     452,   453,     0,     0,   454,   455,   456,   457,   458,   459,
    1290,   461,   462,   463,   464,   465,   466,   467,   468,   469,
     470,     0,     0,   471,   472,  1291,   474,   475,   476,   477,
     478,     0,   479,   480,   481,   482,   483,   484,   485,   486,
     487,   488,  1292,   490,   491,   492,   493,     0,   494,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
     506,     0,   507,   508,   509,   510,   511,   512,   513,   514,
    1293,   516,   517,   518,   519,   520,   521,   522,   523,   524,
       0,   525,   526,   527,   528,   529,  1294,   530,   531,   532,
     533,   534,   535,   536,   537,  1295,   539,     0,   540,   541,
     542,   543,   544,   545,   546,   547,   548,   549,   550,   551,
     552,  1296,   554,     0,   555,   556,     0,   557,   558,   559,
     560,   561,   562,   563,     0,   564,  1297,  1298,     0,     0,
     567,   568,  1299,   570,  1300,  1301,   572,   573,   574,   575,
     576,   577,   578,   579,     0,  1302,   580,   581,   582,   583,
     584,  1303,     0,   585,   586,   587,   588,   589,   590,  1304,
    1688,   592,   593,   594,   595,   596,   597,     0,     0,   598,
       0,     0,   599,   600,   601,   602,   603,   604,   605,  1305,
    1306,  1307,  1308,   610,  1309,  1310,  1311,  1312,   615,   616,
     617,   618,  1313,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1314,  1315,  1689,     0,     0,     0,     0,
       0,     0,  1317,  1690,   235,     0,  1245,   685,     0,  1246,
    1247,  1248,   746,  1249,     0,     0,     0,     0,     0,     0,
       0,   236,   237,   238,   239,   240,   241,   242,   243,     0,
     244,   245,   246,     0,     0,     0,     0,  1250,     0,     0,
     247,   248,   249,     0,   250,   251,   252,   253,   254,   255,
     256,   257,   258,  1251,   260,  1252,  1253,     0,   263,   264,
     265,   266,   267,   268,   269,  1254,  1255,   270,   271,  1256,
    1257,   274,     0,   275,   276,   277,   278,  1258,     0,  1259,
       0,   281,   282,   283,   284,   285,   286,   287,   288,   289,
     290,     0,   291,   292,   293,   294,   295,   296,     0,   297,
     298,   299,   300,  1260,  1261,  1262,  1263,  1264,  1265,  1266,
     302,   303,   304,   305,   306,   307,  1267,  1268,   310,  1269,
     311,     0,   312,   313,   314,   315,   316,   317,   318,     0,
     319,   320,   321,   322,     0,     0,   323,   324,   864,   326,
     327,     0,   328,   329,   330,     0,   331,   332,   333,     0,
     334,   335,   336,   337,  1270,   339,   340,   341,   342,  1271,
    1272,   344,     0,   345,   346,   347,  1273,   349,     0,   350,
       0,   351,   352,     0,   353,   354,   355,   356,   357,     0,
     358,  1274,     0,  1275,   361,   362,     0,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,     0,   373,   374,
     375,   376,   377,   378,   379,     0,   380,   381,   382,   383,
     384,   385,   386,  1276,  1277,     0,  1278,     0,   390,   391,
     392,   393,   394,   395,   396,   397,   398,   399,     0,     0,
     400,  1279,   402,   403,   404,     0,   405,   406,   407,  1280,
    1281,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,   419,   420,   421,   422,   423,   424,   425,  1282,
     427,  1283,   429,   430,   431,   432,   433,   434,   435,   436,
    1284,   438,  1285,   439,   440,   441,   442,  1286,  1287,   444,
    1288,   446,   447,   448,     0,   449,   450,     0,     0,  1289,
     452,   453,     0,     0,   454,   455,   456,   457,   458,   459,
    1290,   461,   462,   463,   464,   465,   466,   467,   468,   469,
     470,     0,     0,   471,   472,  1291,   474,   475,   476,   477,
     478,     0,   479,   480,   481,   482,   483,   484,   485,   486,
     487,   488,  1292,   490,   491,   492,   493,     0,   494,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
     506,     0,   507,   508,   509,   510,   511,   512,   513,   514,
    1293,   516,   517,   518,   519,   520,   521,   522,   523,   524,
      41,   525,   526,   527,   528,   529,  1294,   530,   531,   532,
     533,   534,   535,   536,   537,  1295,   539,     0,   540,   541,
     542,   543,   544,   545,   546,   547,   548,   549,   550,   551,
     552,  1296,   554,     0,   555,   556,    45,   557,   558,   559,
     560,   561,   562,   563,     0,   564,  1297,  1298,     0,     0,
     567,   568,  1299,   570,  1300,  1301,   572,   573,   574,   575,
     576,   577,   578,   579,     0,  1302,   580,   581,   582,   583,
     584,  1303,     0,   585,   586,   587,   588,   589,  1179,  1304,
       0,   592,   593,   594,   595,   596,   597,     0,     0,   598,
       0,    50,   599,   600,   601,   602,   603,   604,   605,  1305,
    1306,  1307,  1308,   610,  1309,  1310,  1311,  1312,   615,   616,
     617,   618,  1313,     0,    51,     0,     0,     0,     0,     0,
       0,     0,     0,  1314,  1315,     0,     0,     0,     0,     0,
       0,     0,  1317,  5557,   235,     0,  1245,   685,     0,  1246,
    1247,  1248,   746,  1249,     0,     0,     0,     0,     0,     0,
       0,   236,   237,   238,   239,   240,   241,   242,   243,     0,
     244,   245,   246,     0,     0,     0,     0,  1250,     0,     0,
     247,   248,   249,     0,   250,   251,   252,   253,   254,   255,
     256,   257,   258,  1251,   260,  1252,  1253,     0,   263,   264,
     265,   266,   267,   268,   269,  1254,  1255,   270,   271,  1256,
    1257,   274,     0,   275,   276,   277,   278,  1258,     0,  1259,
       0,   281,   282,   283,   284,   285,   286,   287,   288,   289,
     290,     0,   291,   292,   293,   294,   295,   296,     0,   297,
     298,   299,   300,  1260,  1261,  1262,  1263,  1264,  1265,  1266,
     302,   303,   304,   305,   306,   307,  1267,  1268,   310,  1269,
     311,     0,   312,   313,   314,   315,   316,   317,   318,     0,
     319,   320,   321,   322,     0,     0,   323,   324,   864,   326,
     327,     0,   328,   329,   330,     0,   331,   332,   333,     0,
     334,   335,   336,   337,  1270,   339,   340,   341,   342,  1271,
    1272,   344,     0,   345,   346,   347,  1273,   349,     0,   350,
       0,   351,   352,     0,   353,   354,   355,   356,   357,     0,
     358,  1274,     0,  1275,   361,   362,     0,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,     0,   373,   374,
     375,   376,   377,   378,   379,     0,   380,   381,   382,   383,
     384,   385,   386,  1276,  1277,     0,  1278,     0,   390,   391,
     392,   393,   394,   395,   396,   397,   398,   399,     0,     0,
     400,  1279,   402,   403,   404,     0,   405,   406,   407,  1280,
    1281,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,   419,   420,   421,   422,   423,   424,   425,  1282,
     427,  1283,   429,   430,   431,   432,   433,   434,   435,   436,
    1284,   438,  1285,   439,   440,   441,   442,  1286,  1287,   444,
    1288,   446,   447,   448,     0,   449,   450,     0,     0,  1289,
     452,   453,     0,     0,   454,   455,   456,   457,   458,   459,
    1290,   461,   462,   463,   464,   465,   466,   467,   468,   469,
     470,     0,     0,   471,   472,  1291,   474,   475,   476,   477,
     478,     0,   479,   480,   481,   482,   483,   484,   485,   486,
     487,   488,  1292,   490,   491,   492,   493,     0,   494,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
     506,     0,   507,   508,   509,   510,   511,   512,   513,   514,
    1293,   516,   517,   518,   519,   520,   521,   522,   523,   524,
       0,   525,   526,   527,   528,   529,  1294,   530,   531,   532,
     533,   534,   535,   536,   537,  1295,   539,     0,   540,   541,
     542,   543,   544,   545,   546,   547,   548,   549,   550,   551,
     552,  1296,   554,     0,   555,   556,     0,   557,   558,   559,
     560,   561,   562,   563,     0,   564,  1297,  1298,     0,     0,
     567,   568,  1299,   570,  1300,  1301,   572,   573,   574,   575,
     576,   577,   578,   579,     0,  1302,   580,   581,   582,   583,
     584,  1303,     0,   585,   586,   587,   588,   589,   590,  1304,
       0,   592,   593,   594,   595,   596,   597,     0,     0,   598,
       0,     0,   599,   600,   601,   602,   603,   604,   605,  1305,
    1306,  1307,  1308,   610,  1309,  1310,  1311,  1312,   615,   616,
     617,   618,  1313,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1314,  1315,     0,     0,     0,     0,     0,
       0,     0,  1317,  3206,   235,     0,  1245,   685,     0,  1246,
    1247,  1248,   746,  1249,     0,     0,     0,     0,     0,     0,
       0,   236,   237,   238,   239,   240,   241,   242,   243,     0,
     244,   245,   246,     0,     0,     0,     0,  1250,     0,     0,
     247,   248,   249,     0,   250,   251,   252,   253,   254,   255,
     256,   257,   258,  1251,   260,  1252,  1253,     0,   263,   264,
     265,   266,   267,   268,   269,  1254,  1255,   270,   271,  1256,
    1257,   274,     0,   275,   276,   277,   278,  1258,     0,  1259,
       0,   281,   282,   283,   284,   285,   286,   287,   288,   289,
     290,     0,   291,   292,   293,   294,   295,   296,     0,   297,
     298,   299,   300,  1260,  1261,  1262,  1263,  1264,  1265,  1266,
     302,   303,   304,   305,   306,   307,  1267,  1268,   310,  1269,
     311,     0,   312,   313,   314,   315,   316,   317,   318,     0,
     319,   320,   321,   322,     0,     0,   323,   324,   864,   326,
     327,     0,   328,   329,   330,     0,   331,   332,   333,     0,
     334,   335,   336,   337,  1270,   339,   340,   341,   342,  1271,
    1272,   344,     0,   345,   346,   347,  1273,   349,     0,   350,
       0,   351,   352,     0,   353,   354,   355,   356,   357,     0,
     358,  1274,     0,  1275,   361,   362,     0,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,     0,   373,   374,
     375,   376,   377,   378,   379,     0,   380,   381,   382,   383,
     384,   385,   386,  1276,  1277,     0,  1278,     0,   390,   391,
     392,   393,   394,   395,   396,   397,   398,   399,     0,     0,
     400,  1279,   402,   403,   404,     0,   405,   406,   407,  1280,
    1281,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,   419,   420,   421,   422,   423,   424,   425,  1282,
     427,  1283,   429,   430,   431,   432,   433,   434,   435,   436,
    1284,   438,  1285,   439,   440,   441,   442,  1286,  1287,   444,
    1288,   446,   447,   448,     0,   449,   450,     0,     0,  1289,
     452,   453,     0,     0,   454,   455,   456,   457,   458,   459,
    1290,   461,   462,   463,   464,   465,   466,   467,   468,   469,
     470,     0,     0,   471,   472,  1291,   474,   475,   476,   477,
     478,     0,   479,   480,   481,   482,   483,   484,   485,   486,
     487,   488,  1292,   490,   491,   492,   493,     0,   494,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
     506,     0,   507,   508,   509,   510,   511,   512,   513,   514,
    1293,   516,   517,   518,   519,   520,   521,   522,   523,   524,
       0,   525,   526,   527,   528,   529,  1294,   530,   531,   532,
     533,   534,   535,   536,   537,  1295,   539,     0,   540,   541,
     542,   543,   544,   545,   546,   547,   548,   549,   550,   551,
     552,  1296,   554,     0,   555,   556,     0,   557,   558,   559,
     560,   561,   562,   563,     0,   564,  1297,  1298,     0,     0,
     567,   568,  1299,   570,  1300,  1301,   572,   573,   574,   575,
     576,   577,   578,   579,     0,  1302,   580,   581,   582,   583,
     584,  1303,     0,   585,   586,   587,   588,   589,   590,  1304,
       0,   592,   593,   594,   595,   596,   597,     0,     0,   598,
       0,     0,   599,   600,   601,   602,   603,   604,   605,  1305,
    1306,  1307,  1308,   610,  1309,  1310,  1311,  1312,   615,   616,
     617,   618,  1313,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1314,  1315,     0,     0,     0,     0,     0,
       0,     0,  1317,  4531,   235,     0,  1245,   685,     0,  1246,
    1247,  1248,   746,  1249,     0,     0,     0,     0,     0,     0,
       0,   236,   237,   238,   239,   240,   241,   242,   243,     0,
     244,   245,   246,     0,     0,     0,     0,  1250,     0,     0,
     247,   248,   249,     0,   250,   251,   252,   253,   254,   255,
     256,   257,   258,  1251,   260,  1252,  1253,     0,   263,   264,
     265,   266,   267,   268,   269,  1254,  1255,   270,   271,  1256,
    1257,   274,     0,   275,   276,   277,   278,  1258,     0,  1259,
       0,   281,   282,   283,   284,   285,   286,   287,   288,   289,
     290,     0,   291,   292,   293,   294,   295,   296,     0,   297,
     298,   299,   300,  1260,  1261,  1262,  1263,  1264,  1265,  1266,
     302,   303,   304,   305,   306,   307,  1267,  1268,   310,  1269,
     311,     0,   312,   313,   314,   315,   316,   317,   318,     0,
     319,   320,   321,   322,     0,     0,   323,   324,   864,   326,
     327,     0,   328,   329,   330,     0,   331,   332,   333,     0,
     334,   335,   336,   337,  1270,   339,   340,   341,   342,  1271,
    1272,   344,     0,   345,   346,   347,  1273,   349,     0,   350,
       0,   351,   352,     0,   353,   354,   355,   356,   357,     0,
     358,  1274,     0,  1275,   361,   362,     0,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,     0,   373,   374,
     375,   376,   377,   378,   379,     0,   380,   381,   382,   383,
     384,   385,   386,  1276,  1277,     0,  1278,     0,   390,   391,
     392,   393,   394,   395,   396,   397,   398,   399,     0,     0,
     400,  1279,   402,   403,   404,     0,   405,   406,   407,  1280,
    1281,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,   419,   420,   421,   422,   423,   424,   425,  1282,
     427,  1283,   429,   430,   431,   432,   433,   434,   435,   436,
    1284,   438,  1285,   439,   440,   441,   442,  1286,  1287,   444,
    1288,   446,   447,   448,     0,   449,   450,     0,     0,  1289,
     452,   453,     0,     0,   454,   455,   456,   457,   458,   459,
    1290,   461,   462,   463,   464,   465,   466,   467,   468,   469,
     470,     0,     0,   471,   472,  1291,   474,   475,   476,   477,
     478,     0,   479,   480,   481,   482,   483,   484,   485,   486,
     487,   488,  1292,   490,   491,   492,   493,     0,   494,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
     506,     0,   507,   508,   509,   510,   511,   512,   513,   514,
    1293,   516,   517,   518,   519,   520,   521,   522,   523,   524,
       0,   525,   526,   527,   528,   529,  1294,   530,   531,   532,
     533,   534,   535,   536,   537,  1295,   539,     0,   540,   541,
     542,   543,   544,   545,   546,   547,   548,   549,   550,   551,
     552,  1296,   554,     0,   555,   556,     0,   557,   558,   559,
     560,   561,   562,   563,     0,   564,  1297,  1298,     0,     0,
     567,   568,  1299,   570,  1300,  1301,   572,   573,   574,   575,
     576,   577,   578,   579,     0,  1302,   580,   581,   582,   583,
     584,  1303,     0,   585,   586,   587,   588,   589,   590,  1304,
       0,   592,   593,   594,   595,   596,   597,     0,     0,   598,
       0,     0,   599,   600,   601,   602,   603,   604,   605,  1305,
    1306,  1307,  1308,   610,  1309,  1310,  1311,  1312,   615,   616,
     617,   618,  1313,     0,     0,     0,     0,   626,     0,     0,
       0,     0,     0,  1314,  1315,     0,     0,     0,     0,     0,
       0,     0,  1317,  4600,   236,   237,   238,   239,   240,   241,
     242,   243,     0,   244,   245,   246,     0,     0,     0,     0,
       0,  4070,     0,   247,   248,   249,     0,   250,   251,   252,
     253,     0,   255,   256,   257,   258,   259,     0,   261,   262,
       0,   263,   264,   265,   266,   267,   268,   269,     0,     0,
     270,   271,   272,   273,   274,     0,   275,   276,   277,   278,
     279,     0,     0,     0,   281,   282,   283,   284,   285,   286,
       0,   288,   289,   290,     0,   291,   292,   293,   294,   295,
     296,     0, -1807,   298,   299,   300,     0,     0,     0,     0,
       0,     0,     0,   302,   303,   304,   305,   306,   307,   308,
     309,   310,     0,   311,     0,   312,   313,   314,   315,   316,
     317,   318,     0,   319,   320,   321,   322,     0,     0,   323,
     324,   325,   326,   327,     0,   328,   329,   330,     0,   331,
     332,   333,     0,   334,   335,   336,   337,   338,   339,   340,
     341,   342,   343,     0,   344,     0,   345,   346,   347,   348,
     349,     0,   350,     0,   351,     0,     0, -1807,   354,   355,
     356,   357,     0,   358,   359,     0,   360,   361,   362,     0,
     363,   364,   365,   366,   367,     0,   369,   370,   371,   372,
       0,   373,   374,   375,   376,   377,   378,   379,     0,   380,
   -1807,   382,   383,   384,   385,   386,   387,   388,     0,   389,
       0,   390,     0,     0,   393, -1807,   395,   396,   397,   398,
     399,     0,     0,   400,   401, -1807,   403,     0,     0,   405,
     406,   407,     0,     0,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426, -1807,   428,   429,   430,   431,   432,   433,
     434,   435,   436,   437,   438,     0,   439,   440,     0,   442,
       0,   443,   444,   445,   446,   447,   448,     0,   449,   450,
       0,     0,   451,   452,   453,     0,     0,   454,   455,   456,
       0,   458,     0,   460,   461,   462,   463,   464,   465,   466,
     467,   468,   469,   470,     0,     0,   471,   472,   473,   474,
     475,   476,   477,   478,     0,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   490,   491,   492,   493,
       0,   494,   495,   496,   497,   498,   499,   500,   501,   502,
     503,   504,   505,   506,     0,   507,   508, -1807,   510,   511,
     512,   513,   514,   515,   516,   517,   518,   519,   520,   521,
     522,   523,   524,     0,   525,   526,   527,   528,   529,     0,
     530,   531,   532,   533,   534,     0,   536,   537,   538,   539,
       0,   540,   541,   542,   543,   544,   545,   546,   547,   548,
     549,   550,   551,   552,   553,   554,     0,   555,   556,     0,
     557,     0,   559,   560,   561,   562,   563,     0,   564,   565,
     566,     0,     0,   567,   568,   569,   570,   571,     0,   572,
     573,   574,   575,   576,   577,   578,   579,     0,     0,   580,
     581,   582,   583,   584,     0,     0,   585,   586,   587,   588,
     589,   590,   591,     0,   592,     0,   594,   595,   596,   597,
       0,     0,   598,     0,     0,   599,   600,   601,   602,   603,
     604,   605,   606,   607,   608,   609,   610,   611,   612,   613,
     614,   615,   616,   617,   618,     0,     0,     0,     0,     0,
     856,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1427,   236,   237,   238,
     239,   240,   241,   242,   243,     0,   244,   245,   246,     0,
       0,     0,     0,     0,     0,     0,   247,   248,   249,     0,
     250,   251,   252,   253,   254,   255,   256,   257,     0,   857,
     260,   858,   859,     0,   263,   264,   265,   266,   267,   268,
     269,     0,     0,   270,   271,   860,   861,   274,     0,   275,
     276,   277,   278,     0,     0,   280,     0,   281,   282,   283,
     284,   285,   286,   287,   288,   289,   290,     0,   291,   292,
     293,   294,   295,   296,     0,   297,   298,   299,   300,     0,
       0,     0,   301,     0,     0,     0,   302,   303,   304,   305,
     306,   307,   862,   863,   310,     0,   311,     0,   312,   313,
     314,   315,   316,   317,   318,     0,   319,   320,   321,   322,
       0,     0,   323,   324,   864,   326,   327,     0,   328,   329,
     330,     0,   331,   332,   333,     0,   334,   335,   336,   337,
       0,   339,   340,   341,   342,     0,     0,   344,     0,   345,
     346,   347,   865,   349,     0,   350,     0,   351,   352,     0,
     353,   354,   355,   356,   357,     0,   358,     0,     0,     0,
     361,   362,     0,   363,   364,   365,   366,   367,   368,   369,
     370,   371,   372,  2639,   373,   374,   375,   376,   377,   378,
     379,     0,   380,   381,  2640,   383,   384,   385,   386,   866,
     867,     0,   868,     0,   390,   391,   392,   393,   394,   395,
     396,   397,   398,   399,     0,     0,   400,     0,   402,   403,
     404,     0,   405,   406,   407,     0,     0,   408,   409,   410,
     411,   412,   413,   414,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   869,   427,   870,   429,   430,
     431,   432,   433,   434,   435,     0,     0,   438,     0,   439,
     440,   441,   442,     0,     0,   444,   871,   446,   447,   448,
       0,   449,   450,     0,     0,   451,   452,   453,     0,     0,
     454,   455,  2642,   457,   458,   459,     0,   461,   462,   463,
     464,   465,   466,   467,   468,   469,   470,     0,     0,   471,
     472,     0,   474,     0,   476,   477,   478,     0,   479,   480,
     481,   482,   483,   484,   485,   486,   487,   488,   872,   490,
     491,   492,   493,     0,   494,   495,   496,   497,   498,   499,
     500,   501,   502,   503,   504,   505,   506,     0,   507,   508,
     509,   510,   511,   512,   513,   514,     0,   516,   517,   518,
     519,   520,   521,   522,   523,   524,     0,   525,   526,   527,
     528,   529,     0,   530,   531,  2643,   533,   534,   535,   536,
     537,   874,   539,     0,   540,   541,   542,   543,   544,   545,
     546,   547,   548,   549,   550,   551,   552,     0,   554,     0,
     555,   556,     0,   557,   558,   559,   560,   561,   562,   563,
       0,   564,   875,   876,     0,     0,   567,   568,     0,   570,
       0,     0,   572,   573,   574,   575,   576,   577,   578,   579,
       0,     0,   580,   581,   582,   583,   584,     0,     0,   585,
     586,   587,   588,   589,     0,   877,  2644,   592,   593,   594,
     595,   596,   597,     0,     0,   598,     0,     0,   599,   600,
     601,   602,   603,   604,   856,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   616,   617,   618,     0,     0,
       0,   236,   237,   238,   239,   240,   241,   242,   243,     0,
     244,   245,   246,     0,     0,     0,     0,     0,     0,  2740,
     247,   248,   249,     0,   250,   251,   252,   253,   254,   255,
     256,   257,     0,   857,   260,   858,   859,     0,   263,   264,
     265,   266,   267,   268,   269,     0,     0,   270,   271,   860,
     861,   274,     0,   275,   276,   277,   278,     0,     0,   280,
       0,   281,   282,   283,   284,   285,   286,   287,   288,   289,
     290,     0,   291,   292,   293,   294,   295,   296,     0,   297,
     298,   299,   300,     0,     0,     0,   301,     0,     0,     0,
     302,   303,   304,   305,   306,   307,   862,   863,   310,     0,
     311,     0,   312,   313,   314,   315,   316,   317,   318,     0,
     319,   320,   321,   322,     0,     0,   323,   324,   864,   326,
     327,     0,   328,   329,   330,     0,   331,   332,   333,     0,
     334,   335,   336,   337,     0,   339,   340,   341,   342,     0,
       0,   344,     0,   345,   346,   347,   865,   349,     0,   350,
       0,   351,   352,     0,   353,   354,   355,   356,   357,     0,
     358,     0,     0,     0,   361,   362,     0,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,  2639,   373,   374,
     375,   376,   377,   378,   379,     0,   380,   381,  2640,   383,
     384,   385,   386,   866,   867,     0,   868,     0,   390,   391,
     392,   393,   394,   395,   396,   397,   398,   399,     0,     0,
     400,     0,   402,   403,   404,     0,   405,   406,   407,     0,
       0,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,   419,   420,   421,   422,   423,   424,   425,   869,
     427,   870,   429,   430,   431,   432,   433,   434,   435,     0,
       0,   438,     0,   439,   440,   441,   442,     0,     0,   444,
     871,   446,   447,   448,     0,   449,   450,     0,     0,   451,
     452,   453,     0,     0,   454,   455,  2642,   457,   458,   459,
       0,   461,   462,   463,   464,   465,   466,   467,   468,   469,
     470,     0,     0,   471,   472,     0,   474,     0,   476,   477,
     478,     0,   479,   480,   481,   482,   483,   484,   485,   486,
     487,   488,   872,   490,   491,   492,   493,     0,   494,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
     506,     0,   507,   508,   509,   510,   511,   512,   513,   514,
       0,   516,   517,   518,   519,   520,   521,   522,   523,   524,
       0,   525,   526,   527,   528,   529,     0,   530,   531,  2643,
     533,   534,   535,   536,   537,   874,   539,     0,   540,   541,
     542,   543,   544,   545,   546,   547,   548,   549,   550,   551,
     552,     0,   554,     0,   555,   556,     0,   557,   558,   559,
     560,   561,   562,   563,     0,   564,   875,   876,     0,     0,
     567,   568,     0,   570,     0,     0,   572,   573,   574,   575,
     576,   577,   578,   579,     0,     0,   580,   581,   582,   583,
     584,     0,     0,   585,   586,   587,   588,   589,     0,   877,
    2644,   592,   593,   594,   595,   596,   597,     0,     0,   598,
       0,     0,   599,   600,   601,   602,   603,   604,   235,     0,
    1245,   685,     0,  1246,  1247,  1248,   746,  1249,     0,   616,
     617,   618,     0,     0,     0,   236,   237,   238,   239,   240,
     241,   242,   243,     0,   244,   245,   246,     0,     0,     0,
       0,  1250,     0,  3824,   247,   248,   249,     0,   250,   251,
     252,   253,   254,   255,   256,   257,   258,  1251,   260,  1252,
    1253,     0,   263,   264,   265,   266,   267,   268,   269,  1254,
    1255,   270,   271,  1256,  1257,   274,     0,   275,   276,   277,
     278,  1258,     0,  1259,     0,   281,   282,   283,   284,   285,
     286,   287,   288,   289,   290,     0,   291,   292,   293,   294,
     295,   296,     0,   297,   298,   299,   300,  1260,  1261,  1262,
    1263,  1264,  1265,  1266,   302,   303,   304,   305,   306,   307,
    1267,  1268,   310,  1269,   311,     0,   312,   313,   314,   315,
     316,   317,   318,     0,   319,   320,   321,   322,     0,     0,
     323,   324,   864,   326,   327,     0,   328,   329,   330,     0,
     331,   332,   333,     0,   334,   335,   336,   337,  1270,   339,
     340,   341,   342,  1271,  1272,   344,     0,   345,   346,   347,
    1273,   349,     0,   350,     0,   351,   352,     0,   353,   354,
     355,   356,   357,     0,   358,  1274,     0,  1275,   361,   362,
       0,   363,   364,   365,   366,   367,   368,   369,   370,   371,
     372,     0,   373,   374,   375,   376,   377,   378,   379,     0,
     380,   381,   382,   383,   384,   385,   386,  1276,  1277,     0,
    1278,     0,   390,   391,   392,   393,   394,   395,   396,   397,
     398,   399,     0,     0,   400,  1279,   402,   403,   404,     0,
     405,   406,   407,  1280,  1281,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,   418,   419,   420,   421,   422,
     423,   424,   425,  1282,   427,  1283,   429,   430,   431,   432,
     433,   434,   435,   436,  1284,   438,  1285,   439,   440,   441,
     442,  1286,  1287,   444,  1288,   446,   447,   448,     0,   449,
     450,     0,     0,  1289,   452,   453,     0,     0,   454,   455,
     456,   457,   458,   459,  1290,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,     0,     0,   471,   472,  1291,
     474,   475,   476,   477,   478,     0,   479,   480,   481,   482,
     483,   484,   485,   486,   487,   488,  1292,   490,   491,   492,
     493,     0,   494,   495,   496,   497,   498,   499,   500,   501,
     502,   503,   504,   505,   506,     0,   507,   508,   509,   510,
     511,   512,   513,   514,  1293,   516,   517,   518,   519,   520,
     521,   522,   523,   524,    41,   525,   526,   527,   528,   529,
    1294,   530,   531,   532,   533,   534,   535,   536,   537,  1295,
     539,     0,   540,   541,   542,   543,   544,   545,   546,   547,
     548,   549,   550,   551,   552,  1296,   554,     0,   555,   556,
      45,   557,   558,   559,   560,   561,   562,   563,     0,   564,
    1297,  1298,     0,     0,   567,   568,  1299,   570,  1300,  1301,
     572,   573,   574,   575,   576,   577,   578,   579,     0,  1302,
     580,   581,   582,   583,   584,  1303,     0,   585,   586,   587,
     588,   589,  1179,  1304,     0,   592,   593,   594,   595,   596,
     597,     0,     0,   598,     0,    50,   599,   600,   601,   602,
     603,   604,   605,  1305,  1306,  1307,  1308,   610,  1309,  1310,
    1311,  1312,   615,   616,   617,   618,  1313,     0,    51,     0,
       0,     0,     0,     0,     0,     0,     0,  1314,  1315,     0,
       0,     0,   235,     0,  1245,   685,  1317,  1246,  1247,  1248,
     746,  1249,     0,     0,     0,     0,     0,     0,     0,   236,
     237,   238,   239,   240,   241,   242,   243,     0,   244,   245,
     246,     0,     0,     0,     0,  1250,     0,     0,   247,   248,
     249,     0,   250,   251,   252,   253,   254,   255,   256,   257,
     258,  1251,   260,  1252,  1253,  3212,   263,   264,   265,   266,
     267,   268,   269,  1254,  1255,   270,   271,  1256,  1257,   274,
       0,   275,   276,   277,   278,  1258,     0,  1259,     0,   281,
     282,   283,   284,   285,   286,   287,   288,   289,   290,     0,
     291,   292,   293,   294,   295,   296,     0,   297,   298,   299,
     300,  1260,  1261,  1262,  1263,  1264,  1265,  1266,   302,   303,
     304,   305,   306,   307,  1267,  1268,   310,  1269,   311,     0,
     312,   313,   314,   315,   316,   317,   318,     0,   319,   320,
     321,   322,     0,     0,   323,   324,   864,   326,   327,     0,
     328,   329,   330,     0,   331,   332,   333,     0,   334,   335,
     336,   337,  1270,   339,   340,   341,   342,  1271,  1272,   344,
       0,   345,   346,   347,  1273,   349,     0,   350,     0,   351,
     352,  3213,   353,   354,   355,   356,   357,     0,   358,  1274,
       0,  1275,   361,   362,     0,   363,   364,   365,   366,   367,
     368,   369,   370,   371,   372,     0,   373,   374,   375,   376,
     377,   378,   379,     0,   380,   381,   382,   383,   384,   385,
     386,  1276,  1277,     0,  1278,     0,   390,   391,   392,   393,
     394,   395,   396,   397,   398,   399,     0,  3214,   400,  1279,
     402,   403,   404,     0,   405,   406,   407,  1280,  1281,   408,
     409,   410,   411,   412,   413,   414,   415,   416,   417,   418,
     419,   420,   421,   422,   423,   424,   425,  1282,   427,  1283,
     429,   430,   431,   432,   433,   434,   435,   436,  1284,   438,
    1285,   439,   440,   441,   442,  1286,  1287,   444,  1288,   446,
     447,   448,     0,   449,   450,     0,     0,  1289,   452,   453,
       0,     0,   454,   455,   456,   457,   458,   459,  1290,   461,
     462,   463,   464,   465,   466,   467,   468,   469,   470,     0,
       0,   471,   472,  1291,   474,   475,   476,   477,   478,     0,
     479,   480,   481,   482,   483,   484,   485,   486,   487,   488,
    1292,   490,   491,   492,   493,     0,   494,   495,   496,   497,
     498,   499,   500,   501,   502,   503,   504,   505,   506,     0,
     507,   508,   509,   510,   511,   512,   513,   514,  1293,   516,
     517,   518,   519,   520,   521,   522,   523,   524,     0,   525,
     526,   527,   528,   529,  1294,   530,   531,   532,   533,   534,
     535,   536,   537,  1295,   539,     0,   540,   541,   542,   543,
     544,   545,   546,   547,   548,   549,   550,   551,   552,  1296,
     554,     0,   555,   556,     0,   557,   558,   559,   560,   561,
     562,   563,     0,   564,  1297,  1298,     0,  3215,   567,   568,
    1299,   570,  1300,  1301,   572,   573,   574,   575,   576,   577,
     578,   579,     0,  1302,   580,   581,   582,   583,   584,  1303,
       0,   585,   586,   587,   588,   589,   590,  1304,     0,   592,
     593,   594,   595,   596,   597,     0,     0,   598,     0,     0,
     599,   600,   601,   602,   603,   604,   605,  1305,  1306,  1307,
    1308,   610,  1309,  1310,  1311,  1312,   615,   616,   617,   618,
    1313,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1314,  1315,     0,     0,     0,   235,     0,  1245,   685,
    1317,  1246,  1247,  1248,   746,  1249,     0,     0,     0,     0,
       0,     0,     0,   236,   237,   238,   239,   240,   241,   242,
     243, -2197,   244,   245,   246,     0,     0,     0, -2197,  1250,
       0,     0,   247,   248,   249,     0,   250,   251,   252,   253,
     254,   255,   256,   257,   258,  1251,   260,  1252,  1253,     0,
     263,   264,   265,   266,   267,   268,   269,  1254,  1255,   270,
     271,  1256,  1257,   274,     0,   275,   276,   277,   278,  1258,
       0,  1259,     0,   281,   282,   283,   284,   285,   286,   287,
     288,   289,   290,     0,   291,   292,   293,   294,   295,   296,
       0,   297,   298,   299,   300,  1260,  1261,  1262,  1263,  1264,
    1265,  1266,   302,   303,   304,   305,   306,   307,  1267,  1268,
     310,  1269,   311,     0,   312,   313,   314,   315,   316,   317,
     318,     0,   319,   320,   321,   322,     0,     0,   323,   324,
     864,   326,   327,     0,   328,   329,   330,     0,   331,   332,
     333,     0,   334,   335,   336,   337,  1270,   339,   340,   341,
     342,  1271,  1272,   344,     0,   345,   346,   347,  1273,   349,
       0,   350,     0,   351,   352,     0,   353,   354,   355,   356,
     357,     0,   358,  1274,     0,  1275,   361,   362,     0,   363,
     364,   365,   366,   367,   368,   369,   370,   371,   372,     0,
     373,   374,   375,   376,   377,   378,   379,     0,   380,   381,
     382,   383,   384,   385,   386,  1276,  1277,     0,  1278,     0,
     390,   391,   392,   393,   394,   395,   396,   397,   398,   399,
       0,     0,   400,  1279,   402,   403,   404,     0,   405,   406,
     407,  1280,  1281,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,  1282,   427,  1283,   429,   430,   431,   432,   433,   434,
     435,   436,  1284,   438,  1285,   439,   440,   441,   442,  1286,
    1287,   444,  1288,   446,   447,   448,     0,   449,   450,     0,
       0,  1289,   452,   453,     0,     0,   454,   455,   456,   457,
     458,   459,  1290,   461,   462,   463,   464,   465,   466,   467,
     468,   469,   470,     0,     0,   471,   472,  1291,   474,   475,
     476,   477,   478,     0,   479,   480,   481,   482,   483,   484,
     485,   486,   487,   488,  1292,   490,   491,   492,   493,     0,
     494,   495,   496,   497,   498,   499,   500,   501,   502,   503,
     504,   505,   506,     0,   507,   508,   509,   510,   511,   512,
     513,   514,  1293,   516,   517,   518,   519,   520,   521,   522,
     523,   524,     0,   525,   526,   527,   528,   529,  1294,   530,
     531,   532,   533,   534,   535,   536,   537,  1295,   539, -2197,
     540,   541,   542,   543,   544,   545,   546,   547,   548,   549,
     550,   551,   552,  1296,   554,     0,   555,   556,     0,   557,
     558,   559,   560,   561,   562,   563,     0,   564,  1297,  1298,
       0,     0,   567,   568,  1299,   570,  1300,  1301,   572,   573,
     574,   575,   576,   577,   578,   579,     0,  1302,   580,   581,
     582,   583,   584,  1303,     0,   585,   586,   587,   588,   589,
     590,  1304,     0,   592,   593,   594,   595,   596,   597,     0,
       0,   598,     0,     0,   599,   600,   601,   602,   603,   604,
     605,  1305,  1306,  1307,  1308,   610,  1309,  1310,  1311,  1312,
     615,   616,   617,   618,  1313,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1314,  1315,     0,     0,     0,
     235,     0,  1245,   685,  1317,  1246,  1247,  1248,   746,  1249,
       0,     0,     0,     0,     0,     0,     0,   236,   237,   238,
     239,   240,   241,   242,   243, -2195,   244,   245,   246,     0,
       0,     0, -2195,  1250,     0,     0,   247,   248,   249,     0,
     250,   251,   252,   253,   254,   255,   256,   257,   258,  1251,
     260,  1252,  1253,     0,   263,   264,   265,   266,   267,   268,
     269,  1254,  1255,   270,   271,  1256,  1257,   274,     0,   275,
     276,   277,   278,  1258,     0,  1259,     0,   281,   282,   283,
     284,   285,   286,   287,   288,   289,   290,     0,   291,   292,
     293,   294,   295,   296,     0,   297,   298,   299,   300,  1260,
    1261,  1262,  1263,  1264,  1265,  1266,   302,   303,   304,   305,
     306,   307,  1267,  1268,   310,  1269,   311,     0,   312,   313,
     314,   315,   316,   317,   318,     0,   319,   320,   321,   322,
       0,     0,   323,   324,   864,   326,   327,     0,   328,   329,
     330,     0,   331,   332,   333,     0,   334,   335,   336,   337,
    1270,   339,   340,   341,   342,  1271,  1272,   344,     0,   345,
     346,   347,  1273,   349,     0,   350,     0,   351,   352,     0,
     353,   354,   355,   356,   357,     0,   358,  1274,     0,  1275,
     361,   362,     0,   363,   364,   365,   366,   367,   368,   369,
     370,   371,   372,     0,   373,   374,   375,   376,   377,   378,
     379,     0,   380,   381,   382,   383,   384,   385,   386,  1276,
    1277,     0,  1278,     0,   390,   391,   392,   393,   394,   395,
     396,   397,   398,   399,     0,     0,   400,  1279,   402,   403,
     404,     0,   405,   406,   407,  1280,  1281,   408,   409,   410,
     411,   412,   413,   414,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,  1282,   427,  1283,   429,   430,
     431,   432,   433,   434,   435,   436,  1284,   438,  1285,   439,
     440,   441,   442,  1286,  1287,   444,  1288,   446,   447,   448,
       0,   449,   450,     0,     0,  1289,   452,   453,     0,     0,
     454,   455,   456,   457,   458,   459,  1290,   461,   462,   463,
     464,   465,   466,   467,   468,   469,   470,     0,     0,   471,
     472,  1291,   474,   475,   476,   477,   478,     0,   479,   480,
     481,   482,   483,   484,   485,   486,   487,   488,  1292,   490,
     491,   492,   493,     0,   494,   495,   496,   497,   498,   499,
     500,   501,   502,   503,   504,   505,   506,     0,   507,   508,
     509,   510,   511,   512,   513,   514,  1293,   516,   517,   518,
     519,   520,   521,   522,   523,   524,     0,   525,   526,   527,
     528,   529,  1294,   530,   531,   532,   533,   534,   535,   536,
     537,  1295,   539, -2195,   540,   541,   542,   543,   544,   545,
     546,   547,   548,   549,   550,   551,   552,  1296,   554,     0,
     555,   556,     0,   557,   558,   559,   560,   561,   562,   563,
       0,   564,  1297,  1298,     0,     0,   567,   568,  1299,   570,
    1300,  1301,   572,   573,   574,   575,   576,   577,   578,   579,
       0,  1302,   580,   581,   582,   583,   584,  1303,     0,   585,
     586,   587,   588,   589,   590,  1304,     0,   592,   593,   594,
     595,   596,   597,     0,     0,   598,     0,     0,   599,   600,
     601,   602,   603,   604,   605,  1305,  1306,  1307,  1308,   610,
    1309,  1310,  1311,  1312,   615,   616,   617,   618,  1313,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1314,
    1315,     0,     0,     0,   235,     0,  1245,   685,  1317,  1246,
    1247,  1248,   746,  1249,     0,     0,     0,     0,     0,     0,
       0,   236,   237,   238,   239,   240,   241,   242,   243,     0,
     244,   245,   246,     0,     0,     0,     0,  1250,     0,     0,
     247,   248,   249,     0,   250,   251,   252,   253,   254,   255,
     256,   257,   258,  1251,   260,  1252,  1253,     0,   263,   264,
     265,   266,   267,   268,   269,  1254,  1255,   270,   271,  1256,
    1257,   274,     0,   275,   276,   277,   278,  1258,     0,  1259,
       0,   281,   282,   283,   284,   285,   286,   287,   288,   289,
     290,     0,   291,   292,   293,   294,   295,   296,     0,   297,
     298,   299,   300,  1260,  1261,  1262,  1263,  1264,  1265,  1266,
     302,   303,   304,   305,   306,   307,  1267,  1268,   310,  1269,
     311,     0,   312,   313,   314,   315,   316,   317,   318,     0,
     319,   320,   321,   322,     0,     0,   323,   324,   864,   326,
     327,     0,   328,   329,   330,     0,   331,   332,   333,     0,
     334,   335,   336,   337,  1270,   339,   340,   341,   342,  1271,
    1272,   344,     0,   345,   346,   347,  1273,   349,     0,   350,
       0,   351,   352,     0,   353,   354,   355,   356,   357,     0,
     358,  1274,     0,  1275,   361,   362,     0,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,     0,   373,   374,
     375,   376,   377,   378,   379,     0,   380,   381,   382,   383,
     384,   385,   386,  1276,  1277,     0,  1278,     0,   390,   391,
     392,   393,   394,   395,   396,   397,   398,   399,     0,     0,
     400,  1279,   402,   403,   404,     0,   405,   406,   407,  1280,
    1281,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,   419,   420,   421,   422,   423,   424,   425,  1282,
     427,  1283,   429,   430,   431,   432,   433,   434,   435,   436,
    1284,   438,  1285,   439,   440,   441,   442,  1286,  1287,   444,
    1288,   446,   447,   448,     0,   449,   450,     0,     0,  1289,
     452,   453,     0,     0,   454,   455,   456,   457,   458,   459,
    1290,   461,   462,   463,   464,   465,   466,   467,   468,   469,
     470,     0,     0,   471,   472,  1291,   474,   475,   476,   477,
     478,     0,   479,   480,   481,   482,   483,   484,   485,   486,
     487,   488,  1292,   490,   491,   492,   493,     0,   494,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
     506,     0,   507,   508,   509,   510,   511,   512,   513,   514,
    1293,   516,   517,   518,   519,   520,   521,   522,   523,   524,
       0,   525,   526,   527,   528,   529,  1294,   530,   531,   532,
     533,   534,   535,   536,   537,  1295,   539,     0,   540,   541,
     542,   543,   544,   545,   546,   547,   548,   549,   550,   551,
     552,  1296,   554,     0,   555,   556,     0,   557,   558,   559,
     560,   561,   562,   563,     0,   564,  1297,  1298,     0,     0,
     567,   568,  1299,   570,  1300,  1301,   572,   573,   574,   575,
     576,   577,   578,   579,     0,  1302,   580,   581,   582,   583,
     584,  1303,     0,   585,   586,   587,   588,   589,   590,  1304,
       0,   592,   593,   594,   595,   596,   597,     0,     0,   598,
       0,     0,   599,   600,   601,   602,   603,   604,   605,  1305,
    1306,  1307,  1308,   610,  1309,  1310,  1311,  1312,   615,   616,
     617,   618,  1313,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1314,  1315,     0,     0,     0,     0,     0,
    2007,  3164,  1317,   235,     0,  1245,   685,     0,  1246,  1247,
    1248,   746,  1249,     0,     0,     0,     0,     0,     0,     0,
     236,   237,   238,   239,   240,   241,   242,   243,     0,   244,
     245,   246,     0,     0,     0,     0,  1250,     0,     0,   247,
     248,   249,     0,   250,   251,   252,   253,   254,   255,   256,
     257,   258,  1251,   260,  1252,  1253,     0,   263,   264,   265,
     266,   267,   268,   269,  1254,  1255,   270,   271,  1256,  1257,
     274,     0,   275,   276,   277,   278,  1258,     0,  1259,     0,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
       0,   291,   292,   293,   294,   295,   296,     0,   297,   298,
     299,   300,  1260,  1261,  1262,  1263,  1264,  1265,  1266,   302,
     303,   304,   305,   306,   307,  1267,  1268,   310,  1269,   311,
       0,   312,   313,   314,   315,   316,   317,   318,     0,   319,
     320,   321,   322,     0,     0,   323,   324,   864,   326,   327,
       0,   328,   329,   330,     0,   331,   332,   333,     0,   334,
     335,   336,   337,  1270,   339,   340,   341,   342,  1271,  1272,
     344,     0,   345,   346,   347,  1273,   349,     0,   350,     0,
     351,   352,     0,   353,   354,   355,   356,   357,     0,   358,
    1274,     0,  1275,   361,   362,     0,   363,   364,   365,   366,
     367,   368,   369,   370,   371,   372,     0,   373,   374,   375,
     376,   377,   378,   379,     0,   380,   381,   382,   383,   384,
     385,   386,  1276,  1277,     0,  1278,     0,   390,   391,   392,
     393,   394,   395,   396,   397,   398,   399,     0,     0,   400,
    1279,   402,   403,   404,     0,   405,   406,   407,  1280,  1281,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,  1282,   427,
    1283,   429,   430,   431,   432,   433,   434,   435,   436,  1284,
     438,  1285,   439,   440,   441,   442,  1286,  1287,   444,  1288,
     446,   447,   448,     0,   449,   450,     0,     0,  1289,   452,
     453,     0,     0,   454,   455,   456,   457,   458,   459,  1290,
     461,   462,   463,   464,   465,   466,   467,   468,   469,   470,
       0,     0,   471,   472,  1291,   474,   475,   476,   477,   478,
       0,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,  1292,   490,   491,   492,   493,     0,   494,   495,   496,
     497,   498,   499,   500,   501,   502,   503,   504,   505,   506,
       0,   507,   508,   509,   510,   511,   512,   513,   514,  1293,
     516,   517,   518,   519,   520,   521,   522,   523,   524,     0,
     525,   526,   527,   528,   529,  1294,   530,   531,   532,   533,
     534,   535,   536,   537,  1295,   539,     0,   540,   541,   542,
     543,   544,   545,   546,   547,   548,   549,   550,   551,   552,
    1296,   554,     0,   555,   556,     0,   557,   558,   559,   560,
     561,   562,   563,     0,   564,  1297,  1298,     0,     0,   567,
     568,  1299,   570,  1300,  1301,   572,   573,   574,   575,   576,
     577,   578,   579,     0,  1302,   580,   581,   582,   583,   584,
    1303,     0,   585,   586,   587,   588,   589,   590,  1304,     0,
     592,   593,   594,   595,   596,   597,     0,     0,   598,     0,
       0,   599,   600,   601,   602,   603,   604,   605,  1305,  1306,
    1307,  1308,   610,  1309,  1310,  1311,  1312,   615,   616,   617,
     618,  1313,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1314,  1315,  1316,     0,     0,   235,     0,  1245,
     685,  1317,  1246,  1247,  1248,   746,  1249,     0,     0,     0,
       0,     0,     0,     0,   236,   237,   238,   239,   240,   241,
     242,   243,  2606,   244,   245,   246,     0,     0,     0,     0,
    1250,     0,     0,   247,   248,   249,     0,   250,   251,   252,
     253,   254,   255,   256,   257,   258,  1251,   260,  1252,  1253,
       0,   263,   264,   265,   266,   267,   268,   269,  1254,  1255,
     270,   271,  1256,  1257,   274,     0,   275,   276,   277,   278,
    1258,     0,  1259,     0,   281,   282,   283,   284,   285,   286,
     287,   288,   289,   290,     0,   291,   292,   293,   294,   295,
     296,     0,   297,   298,   299,   300,  1260,  1261,  1262,  1263,
    1264,  1265,  1266,   302,   303,   304,   305,   306,   307,  1267,
    1268,   310,  1269,   311,     0,   312,   313,   314,   315,   316,
     317,   318,     0,   319,   320,   321,   322,     0,     0,   323,
     324,   864,   326,   327,     0,   328,   329,   330,     0,   331,
     332,   333,     0,   334,   335,   336,   337,  1270,   339,   340,
     341,   342,  1271,  1272,   344,     0,   345,   346,   347,  1273,
     349,     0,   350,     0,   351,   352,     0,   353,   354,   355,
     356,   357,     0,   358,  1274,     0,  1275,   361,   362,     0,
     363,   364,   365,   366,   367,   368,   369,   370,   371,   372,
       0,   373,   374,   375,   376,   377,   378,   379,     0,   380,
     381,   382,   383,   384,   385,   386,  1276,  1277,     0,  1278,
       0,   390,   391,   392,   393,   394,   395,   396,   397,   398,
     399,     0,     0,   400,  1279,   402,   403,   404,     0,   405,
     406,   407,  1280,  1281,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,  1282,   427,  1283,   429,   430,   431,   432,   433,
     434,   435,   436,  1284,   438,  1285,   439,   440,   441,   442,
    1286,  1287,   444,  1288,   446,   447,   448,     0,   449,   450,
       0,     0,  1289,   452,   453,     0,     0,   454,   455,   456,
     457,   458,   459,  1290,   461,   462,   463,   464,   465,   466,
     467,   468,   469,   470,     0,     0,   471,   472,  1291,   474,
     475,   476,   477,   478,     0,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,  1292,   490,   491,   492,   493,
       0,   494,   495,   496,   497,   498,   499,   500,   501,   502,
     503,   504,   505,   506,     0,   507,   508,   509,   510,   511,
     512,   513,   514,  1293,   516,   517,   518,   519,   520,   521,
     522,   523,   524,     0,   525,   526,   527,   528,   529,  1294,
     530,   531,   532,   533,   534,   535,   536,   537,  1295,   539,
       0,   540,   541,   542,   543,   544,   545,   546,   547,   548,
     549,   550,   551,   552,  1296,   554,     0,   555,   556,     0,
     557,   558,   559,   560,   561,   562,   563,     0,   564,  1297,
    1298,     0,     0,   567,   568,  1299,   570,  1300,  1301,   572,
     573,   574,   575,   576,   577,   578,   579,     0,  1302,   580,
     581,   582,   583,   584,  1303,     0,   585,   586,   587,   588,
     589,   590,  1304,     0,   592,   593,   594,   595,   596,   597,
       0,     0,   598,     0,     0,   599,   600,   601,   602,   603,
     604,   605,  1305,  1306,  1307,  1308,   610,  1309,  1310,  1311,
    1312,   615,   616,   617,   618,  1313,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1314,  1315,     0,     0,
       0,   235,     0,  1245,   685,  1317,  1246,  1247,  1248,   746,
    1249,     0,     0,     0,     0,     0,     0,     0,   236,   237,
     238,   239,   240,   241,   242,   243,     0,   244,   245,   246,
       0,     0,     0,     0,  1250,     0,     0,   247,   248,   249,
       0,   250,   251,   252,   253,   254,   255,   256,   257,   258,
    1251,   260,  1252,  1253,     0,   263,   264,   265,   266,   267,
     268,   269,  1254,  1255,   270,   271,  1256,  1257,   274,     0,
     275,   276,   277,   278,  1258,     0,  1259,     0,   281,   282,
     283,   284,   285,   286,   287,   288,   289,   290,     0,   291,
     292,   293,   294,   295,   296,     0,   297,   298,   299,   300,
    1260,  1261,  1262,  1263,  1264,  1265,  1266,   302,   303,   304,
     305,   306,   307,  1267,  1268,   310,  1269,   311,     0,   312,
     313,   314,   315,   316,   317,   318,     0,   319,   320,   321,
     322,     0,     0,   323,   324,   864,   326,   327,     0,   328,
     329,   330,     0,   331,   332,   333,     0,   334,   335,   336,
     337,  1270,   339,   340,   341,   342,  1271,  1272,   344,     0,
     345,   346,   347,  1273,   349,     0,   350,     0,   351,   352,
       0,   353,   354,   355,   356,   357,     0,   358,  1274,     0,
    1275,   361,   362,     0,   363,   364,   365,   366,   367,   368,
     369,   370,   371,   372,     0,   373,   374,   375,   376,   377,
     378,   379,     0,   380,   381,   382,   383,   384,   385,   386,
    1276,  1277,     0,  1278,     0,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,     0,     0,   400,  1279,   402,
     403,   404,     0,   405,   406,   407,  1280,  1281,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,  1282,   427,  1283,   429,
     430,   431,   432,   433,   434,   435,   436,  1284,   438,  1285,
     439,   440,   441,   442,  1286,  1287,   444,  1288,   446,   447,
     448,     0,   449,   450,     0,     0,  1289,   452,   453,     0,
       0,   454,   455,   456,   457,   458,   459,  1290,   461,   462,
     463,   464,   465,   466,   467,   468,   469,   470,     0,     0,
     471,   472,  1291,   474,   475,   476,   477,   478,     0,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,  1292,
     490,   491,   492,   493,     0,   494,   495,   496,   497,   498,
     499,   500,   501,   502,   503,   504,   505,   506,     0,   507,
     508,   509,   510,   511,   512,   513,   514,  1293,   516,   517,
     518,   519,   520,   521,   522,   523,   524,     0,   525,   526,
     527,   528,   529,  1294,   530,   531,   532,   533,   534,   535,
     536,   537,  1295,   539,     0,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,   552,  1296,   554,
       0,   555,   556,     0,   557,   558,   559,   560,   561,   562,
     563,     0,   564,  1297,  1298,     0,     0,   567,   568,  1299,
     570,  1300,  1301,   572,   573,   574,   575,   576,   577,   578,
     579,     0,  1302,   580,   581,   582,   583,   584,  1303,     0,
     585,   586,   587,   588,   589,   590,  1304,  3703,   592,   593,
     594,   595,   596,   597,     0,     0,   598,     0,     0,   599,
     600,   601,   602,   603,   604,   605,  1305,  1306,  1307,  1308,
     610,  1309,  1310,  1311,  1312,   615,   616,   617,   618,  1313,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1314,  1315,     0,     0,     0,   235,     0,  1245,   685,  1317,
    1246,  1247,  1248,   746,  1249,     0,     0,     0,     0,     0,
       0,     0,   236,   237,   238,   239,   240,   241,   242,   243,
       0,   244,   245,   246,     0,     0,     0,     0,  1250,     0,
       0,   247,   248,   249,     0,   250,   251,   252,   253,   254,
     255,   256,   257,   258,  1251,   260,  1252,  1253,     0,   263,
     264,   265,   266,   267,   268,   269,  1254,  1255,   270,   271,
    1256,  1257,   274,     0,   275,   276,   277,   278,  1258,     0,
    1259,     0,   281,   282,   283,   284,   285,   286,   287,   288,
     289,   290,     0,   291,   292,   293,   294,   295,   296,     0,
     297,   298,   299,   300,  1260,  1261,  1262,  1263,  1264,  1265,
    1266,   302,   303,   304,   305,   306,   307,  1267,  1268,   310,
    1269,   311,     0,   312,   313,   314,   315,   316,   317,   318,
       0,   319,   320,   321,   322,     0,     0,   323,   324,   864,
     326,   327,     0,   328,   329,   330,     0,   331,   332,   333,
       0,   334,   335,   336,   337,  1270,   339,   340,   341,   342,
    1271,  1272,   344,     0,   345,   346,   347,  1273,   349,     0,
     350,     0,   351,   352,  3213,   353,   354,   355,   356,   357,
       0,   358,  1274,     0,  1275,   361,   362,     0,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,     0,   373,
     374,   375,   376,   377,   378,   379,     0,   380,   381,   382,
     383,   384,   385,   386,  1276,  1277,     0,  1278,     0,   390,
     391,   392,   393,   394,   395,   396,   397,   398,   399,     0,
       0,   400,  1279,   402,   403,   404,     0,   405,   406,   407,
    1280,  1281,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
    1282,   427,  1283,   429,   430,   431,   432,   433,   434,   435,
     436,  1284,   438,  1285,   439,   440,   441,   442,  1286,  1287,
     444,  1288,   446,   447,   448,     0,   449,   450,     0,     0,
    1289,   452,   453,     0,     0,   454,   455,   456,   457,   458,
     459,  1290,   461,   462,   463,   464,   465,   466,   467,   468,
     469,   470,     0,     0,   471,   472,  1291,   474,   475,   476,
     477,   478,     0,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,  1292,   490,   491,   492,   493,     0,   494,
     495,   496,   497,   498,   499,   500,   501,   502,   503,   504,
     505,   506,     0,   507,   508,   509,   510,   511,   512,   513,
     514,  1293,   516,   517,   518,   519,   520,   521,   522,   523,
     524,     0,   525,   526,   527,   528,   529,  1294,   530,   531,
     532,   533,   534,   535,   536,   537,  1295,   539,     0,   540,
     541,   542,   543,   544,   545,   546,   547,   548,   549,   550,
     551,   552,  1296,   554,     0,   555,   556,     0,   557,   558,
     559,   560,   561,   562,   563,     0,   564,  1297,  1298,     0,
       0,   567,   568,  1299,   570,  1300,  1301,   572,   573,   574,
     575,   576,   577,   578,   579,     0,  1302,   580,   581,   582,
     583,   584,  1303,     0,   585,   586,   587,   588,   589,   590,
    1304,     0,   592,   593,   594,   595,   596,   597,     0,     0,
     598,     0,     0,   599,   600,   601,   602,   603,   604,   605,
    1305,  1306,  1307,  1308,   610,  1309,  1310,  1311,  1312,   615,
     616,   617,   618,  1313,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1314,  1315,     0,     0,     0,   235,
       0,  1245,   685,  1317,  1246,  1247,  1248,   746,  1249,     0,
       0,     0,     0,     0,     0,     0,   236,   237,   238,   239,
     240,   241,   242,   243,     0,   244,   245,   246,     0,     0,
       0,     0,  1250,     0,     0,   247,   248,   249,     0,   250,
     251,   252,   253,   254,   255,   256,   257,   258,  1251,   260,
    1252,  1253,     0,   263,   264,   265,   266,   267,   268,   269,
    1254,  1255,   270,   271,  1256,  1257,   274,     0,   275,   276,
     277,   278,  1258,     0,  1259,     0,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,     0,   291,   292,   293,
     294,   295,   296,     0,   297,   298,   299,   300,  1260,  1261,
    1262,  1263,  1264,  1265,  1266,   302,   303,   304,   305,   306,
     307,  1267,  1268,   310,  1269,   311,     0,   312,   313,   314,
     315,   316,   317,   318,     0,   319,   320,   321,   322,     0,
       0,   323,   324,   864,   326,   327,     0,   328,   329,   330,
       0,   331,   332,   333,     0,   334,   335,   336,   337,  1270,
     339,   340,   341,   342,  1271,  1272,   344,     0,   345,   346,
     347,  1273,   349,     0,   350,     0,   351,   352,     0,   353,
     354,   355,   356,   357,     0,   358,  1274,     0,  1275,   361,
     362,     0,   363,   364,   365,   366,   367,   368,   369,   370,
     371,   372,     0,   373,   374,   375,   376,   377,   378,   379,
       0,   380,   381,   382,   383,   384,   385,   386,  1276,  1277,
       0,  1278,     0,   390,   391,   392,   393,   394,   395,   396,
     397,   398,   399,     0,     0,   400,  1279,   402,   403,   404,
       0,   405,   406,   407,  1280,  1281,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,  1282,   427,  1283,   429,   430,   431,
     432,   433,   434,   435,   436,  1284,   438,  1285,   439,   440,
     441,   442,  1286,  1287,   444,  1288,   446,   447,   448,     0,
     449,   450,     0,     0,  1289,   452,   453,     0,     0,   454,
     455,   456,   457,   458,   459,  1290,   461,   462,   463,   464,
     465,   466,   467,   468,   469,   470,     0,     0,   471,   472,
    1291,   474,   475,   476,   477,   478,     0,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,  1292,   490,   491,
     492,   493,     0,   494,   495,   496,   497,   498,   499,   500,
     501,   502,   503,   504,   505,   506,     0,   507,   508,   509,
     510,   511,   512,   513,   514,  1293,   516,   517,   518,   519,
     520,   521,   522,   523,   524,     0,   525,   526,   527,   528,
     529,  1294,   530,   531,   532,   533,   534,   535,   536,   537,
    1295,   539,     0,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,   551,   552,  1296,   554,     0,   555,
     556,     0,   557,   558,   559,   560,   561,   562,   563,     0,
     564,  1297,  1298,  3267,     0,   567,   568,  1299,   570,  1300,
    1301,   572,   573,   574,   575,   576,   577,   578,   579,     0,
    1302,   580,   581,   582,   583,   584,  1303,     0,   585,   586,
     587,   588,   589,   590,  1304,     0,   592,   593,   594,   595,
     596,   597,     0,     0,   598,     0,     0,   599,   600,   601,
     602,   603,   604,   605,  1305,  1306,  1307,  1308,   610,  1309,
    1310,  1311,  1312,   615,   616,   617,   618,  1313,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1314,  1315,
       0,     0,     0,   235,     0,  1245,   685,  1317,  1246,  1247,
    1248,   746,  1249,     0,     0,     0,     0,     0,     0,     0,
     236,   237,   238,   239,   240,   241,   242,   243,     0,   244,
     245,   246,     0,     0,     0,     0,  1250,     0,     0,   247,
     248,   249,     0,   250,   251,   252,   253,   254,   255,   256,
     257,   258,  1251,   260,  1252,  1253,     0,   263,   264,   265,
     266,   267,   268,   269,  1254,  1255,   270,   271,  1256,  1257,
     274,     0,   275,   276,   277,   278,  1258,     0,  1259,     0,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
       0,   291,   292,   293,   294,   295,   296,     0,   297,   298,
     299,   300,  1260,  1261,  1262,  1263,  1264,  1265,  1266,   302,
     303,   304,   305,   306,   307,  1267,  1268,   310,  1269,   311,
       0,   312,   313,   314,   315,   316,   317,   318,     0,   319,
     320,   321,   322,     0,     0,   323,   324,   864,   326,   327,
       0,   328,   329,   330,     0,   331,   332,   333,     0,   334,
     335,   336,   337,  1270,   339,   340,   341,   342,  1271,  1272,
     344,     0,   345,   346,   347,  1273,   349,     0,   350,     0,
     351,   352,     0,   353,   354,   355,   356,   357,     0,   358,
    1274,     0,  1275,   361,   362,     0,   363,   364,   365,   366,
     367,   368,   369,   370,   371,   372,     0,   373,   374,   375,
     376,   377,   378,   379,     0,   380,   381,   382,   383,   384,
     385,   386,  1276,  1277,     0,  1278,     0,   390,   391,   392,
     393,   394,   395,   396,   397,   398,   399,     0,     0,   400,
    1279,   402,   403,   404,     0,   405,   406,   407,  1280,  1281,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,  1282,   427,
    1283,   429,   430,   431,   432,   433,   434,   435,   436,  1284,
     438,  1285,   439,   440,   441,   442,  1286,  1287,   444,  1288,
     446,   447,   448,     0,   449,   450,     0,     0,  1289,   452,
     453,     0,     0,   454,   455,   456,   457,   458,   459,  1290,
     461,   462,   463,   464,   465,   466,   467,   468,   469,   470,
       0,     0,   471,   472,  1291,   474,   475,   476,   477,   478,
       0,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,  1292,   490,   491,   492,   493,     0,   494,   495,   496,
     497,   498,   499,   500,   501,   502,   503,   504,   505,   506,
       0,   507,   508,   509,   510,   511,   512,   513,   514,  1293,
     516,   517,   518,   519,   520,   521,   522,   523,   524,     0,
     525,   526,   527,   528,   529,  1294,   530,   531,   532,   533,
     534,   535,   536,   537,  1295,   539,     0,   540,   541,   542,
     543,   544,   545,   546,   547,   548,   549,   550,   551,   552,
    1296,   554,     0,   555,   556,     0,   557,   558,   559,   560,
     561,   562,   563,     0,   564,  1297,  1298,     0,     0,   567,
     568,  1299,   570,  1300,  1301,   572,   573,   574,   575,   576,
     577,   578,   579,     0,  1302,   580,   581,   582,   583,   584,
    1303,     0,   585,   586,   587,   588,   589,   590,  1304,     0,
     592,   593,   594,   595,   596,   597,     0,     0,   598,     0,
       0,   599,   600,   601,   602,   603,   604,   605,  1305,  1306,
    1307,  1308,   610,  1309,  1310,  1311,  1312,   615,   616,   617,
     618,  1313,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1314,  1315,     0,     0,     0,   235,     0,  1245,
     685,  1317,  1246,  1247,  1248,   746,  1249,     0,     0,     0,
       0,     0,     0,     0,   236,   237,   238,   239,   240,   241,
     242,   243,     0,   244,   245,   246,     0,     0,     0,     0,
    1250,     0,     0,   247,   248,   249,     0,   250,   251,   252,
     253,   254,   255,   256,   257,   258,  1251,   260,  1252,  1253,
       0,   263,   264,   265,   266,   267,   268,   269,  1254,  1255,
     270,   271,  1256,  1257,   274,     0,   275,   276,   277,   278,
    1258,     0,  1259,     0,   281,   282,   283,   284,   285,   286,
     287,   288,   289,   290,     0,   291,   292,   293,   294,   295,
     296,     0,   297,   298,   299,   300,  1260,  1261,  1262,  1263,
    1264,  1265,  1266,   302,   303,   304,   305,   306,   307,  1267,
    1268,   310,  1269,   311,     0,   312,   313,   314,   315,   316,
     317,   318,     0,   319,   320,   321,   322,     0,     0,   323,
     324,   864,   326,   327,     0,   328,   329,   330,     0,   331,
     332,   333,     0,   334,   335,   336,   337,  1270,   339,   340,
     341,   342,  1271,  1272,   344,     0,   345,   346,   347,  1273,
     349,     0,   350,     0,   351,   352,     0,   353,   354,   355,
     356,   357,     0,   358,  1274,     0,  1275,   361,   362,     0,
     363,   364,   365,   366,   367,   368,   369,   370,   371,   372,
       0,   373,   374,   375,   376,   377,   378,   379,     0,   380,
     381,   382,   383,   384,   385,   386,  1276,  1277,     0,  1278,
       0,   390,   391,   392,   393,   394,   395,   396,   397,   398,
     399,     0,     0,   400,  1279,   402,   403,   404,     0,   405,
     406,   407,  1280,  1281,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,  1282,   427,  1283,   429,   430,   431,   432,   433,
     434,   435,   436,  1284,   438,  1285,   439,   440,   441,   442,
    1286,  1287,   444,  1288,   446,   447,   448,     0,   449,   450,
       0,     0,  1289,   452,   453,     0,     0,   454,   455,   456,
     457,   458,   459,  1290,   461,   462,   463,   464,   465,   466,
     467,   468,   469,   470,     0,     0,   471,   472,  1291,   474,
     475,   476,   477,   478,     0,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,  1292,   490,   491,   492,   493,
       0,   494,   495,   496,   497,   498,   499,   500,   501,   502,
     503,   504,   505,   506,     0,   507,   508,   509,   510,   511,
     512,   513,   514,  1293,   516,   517,   518,   519,   520,   521,
     522,   523,   524,     0,   525,   526,   527,   528,   529,  1294,
     530,   531,   532,   533,   534,   535,   536,   537,  1295,   539,
       0,   540,   541,   542,   543,   544,   545,   546,   547,   548,
     549,   550,   551,   552,  1296,   554,     0,   555,   556,     0,
     557,   558,   559,   560,   561,   562,   563,     0,   564,  1297,
    1298,     0,     0,   567,   568,  1299,   570,  1300,  1301,   572,
     573,   574,   575,   576,   577,   578,   579,     0,  1302,   580,
     581,   582,   583,   584,  1303,     0,   585,   586,   587,   588,
     589,   590,  1304,     0,   592,   593,   594,   595,   596,   597,
       0,     0,   598,     0,     0,   599,   600,   601,   602,   603,
     604,   605,  1305,  1306,  1307,  1308,   610,  1309,  1310,  1311,
    1312,   615,   616,   617,   618,  1313,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  2609,  2610,     0,     0,
       0,   235,     0,  3380,   685,  1317,  1246,  1247,  1248,   746,
    1249,     0,     0,     0,     0,     0,     0,     0,   236,   237,
     238,   239,   240,   241,   242,   243,     0,   244,   245,   246,
       0,     0,     0,     0,  1250,     0,     0,   247,   248,   249,
       0,   250,   251,   252,   253,   254,   255,   256,   257,   258,
    1251,   260,  1252,  1253,     0,   263,   264,   265,   266,   267,
     268,   269,  1254,  1255,   270,   271,  1256,  1257,   274,     0,
     275,   276,   277,   278,  1258,     0,  1259,     0,   281,   282,
     283,   284,   285,   286,   287,   288,   289,   290,     0,   291,
     292,   293,   294,   295,   296,     0,   297,   298,   299,   300,
    1260,  1261,  1262,  1263,  1264,  1265,  1266,   302,   303,   304,
     305,   306,   307,  1267,  1268,   310,  1269,   311,     0,   312,
     313,   314,   315,   316,   317,   318,     0,   319,   320,   321,
     322,     0,     0,   323,   324,   864,   326,   327,     0,   328,
     329,   330,     0,   331,   332,   333,     0,   334,   335,   336,
     337,  1270,   339,   340,   341,   342,  1271,  1272,   344,     0,
     345,   346,   347,  1273,   349,     0,   350,     0,   351,   352,
       0,   353,   354,   355,   356,   357,     0,   358,  1274,     0,
    1275,   361,   362,     0,   363,   364,   365,   366,   367,   368,
     369,   370,   371,   372,     0,   373,   374,   375,   376,   377,
     378,   379,     0,   380,   381,   382,   383,   384,   385,   386,
    1276,  1277,     0,  1278,     0,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,     0,     0,   400,  1279,   402,
     403,   404,     0,   405,   406,   407,  1280,  1281,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,  1282,   427,  1283,   429,
     430,   431,   432,   433,   434,   435,   436,  1284,   438,  1285,
     439,   440,   441,   442,  1286,  1287,   444,  1288,   446,   447,
     448,     0,   449,   450,     0,     0,  1289,   452,   453,     0,
       0,   454,   455,   456,   457,   458,   459,  1290,   461,   462,
     463,   464,   465,   466,   467,   468,   469,   470,     0,     0,
     471,   472,  1291,   474,   475,   476,   477,   478,     0,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,  1292,
     490,   491,   492,   493,     0,   494,   495,   496,   497,   498,
     499,   500,   501,   502,   503,   504,   505,   506,     0,   507,
     508,   509,   510,   511,   512,   513,   514,  1293,   516,   517,
     518,   519,   520,   521,   522,   523,   524,     0,   525,   526,
     527,   528,   529,  1294,   530,   531,   532,   533,   534,   535,
     536,   537,  1295,   539,     0,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,   552,  1296,   554,
       0,   555,   556,     0,   557,   558,   559,   560,   561,   562,
     563,     0,   564,  1297,  1298,     0,     0,   567,   568,  1299,
     570,  1300,  1301,   572,   573,   574,   575,   576,   577,   578,
     579,     0,  1302,   580,   581,   582,   583,   584,  1303,     0,
     585,   586,   587,   588,   589,   590,  1304,     0,   592,   593,
     594,   595,   596,   597,     0,     0,   598,     0,     0,   599,
     600,   601,   602,   603,   604,   605,  1305,  1306,  1307,  1308,
     610,  1309,  1310,  1311,  1312,   615,   616,   617,   618,  1313,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1314,  1315,     0,     0,     0,   235,     0,  1245,   685,  1317,
    1246,  1247,  1248,   746,  1249,     0,     0,     0,     0,     0,
       0,     0,   236,   237,   238,   239,   240,   241,   242,   243,
       0,   244,   245,   246,     0,     0,     0,     0,  1250,     0,
       0,   247,   248,   249,     0,   250,   251,   252,   253,   254,
     255,   256,   257,   258,  1251,   260,  1252,  1253,     0,   263,
     264,   265,   266,   267,   268,   269,  1254,  1255,   270,   271,
    1256,  1257,   274,     0,   275,   276,   277,   278,  1258,     0,
    1259,     0,   281,   282,   283,   284,   285,   286,   287,   288,
     289,   290,     0,   291,   292,   293,   294,   295,   296,     0,
     297,   298,   299,  4651,  1260,  1261,  1262,  1263,  1264,  1265,
    1266,   302,   303,   304,   305,   306,   307,  1267,  1268,   310,
    1269,   311,     0,   312,   313,   314,   315,   316,   317,   318,
       0,   319,   320,   321,   322,     0,     0,   323,   324,   864,
     326,   327,     0,   328,   329,   330,     0,   331,   332,   333,
       0,   334,   335,   336,   337,  1270,   339,   340,   341,   342,
    1271,  1272,   344,     0,   345,   346,   347,  1273,   349,     0,
     350,     0,   351,   352,     0,   353,   354,   355,   356,   357,
       0,   358,  1274,     0,  1275,   361,   362,     0,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,     0,   373,
     374,   375,   376,   377,   378,   379,     0,   380,   381,   382,
     383,   384,   385,   386,  1276,  1277,     0,  1278,     0,   390,
     391,   392,   393,   394,   395,   396,   397,   398,   399,     0,
       0,   400,  1279,   402,   403,   404,     0,   405,   406,   407,
    1280,  1281,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
    1282,   427,  1283,   429,   430,   431,   432,   433,   434,   435,
     436,  1284,   438,  1285,   439,   440,   441,   442,  1286,  1287,
     444,  1288,   446,   447,   448,     0,   449,   450,     0,     0,
    1289,   452,   453,     0,     0,   454,   455,   456,   457,   458,
     459,  1290,   461,   462,   463,   464,   465,   466,   467,   468,
     469,   470,     0,     0,   471,   472,  1291,   474,   475,   476,
     477,   478,     0,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,  1292,   490,   491,   492,   493,     0,   494,
     495,   496,   497,   498,   499,   500,   501,   502,   503,   504,
     505,   506,     0,   507,   508,   509,   510,   511,   512,   513,
     514,  1293,   516,   517,   518,   519,   520,   521,   522,   523,
     524,     0,   525,   526,   527,   528,   529,  1294,   530,   531,
     532,   533,   534,   535,   536,   537,  1295,   539,     0,   540,
     541,   542,   543,   544,   545,   546,   547,   548,   549,   550,
     551,   552,  1296,   554,     0,   555,   556,     0,   557,   558,
     559,   560,   561,   562,   563,     0,   564,  1297,  1298,     0,
       0,   567,   568,  1299,   570,  1300,  1301,   572,   573,   574,
     575,   576,   577,   578,   579,     0,  1302,   580,   581,   582,
     583,   584,  1303,     0,   585,   586,   587,   588,   589,   590,
    1304,     0,   592,   593,   594,   595,   596,   597,     0,     0,
     598,     0,     0,   599,   600,   601,   602,   603,   604,   605,
    1305,  1306,  1307,  1308,   610,  1309,  1310,  1311,  1312,   615,
     616,   617,   618,  1313,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1314,  1315,     0,     0,     0,   235,
       0,  1245,   685,  1317,  1246,  1247,  1248,   746,  1249,     0,
       0,     0,     0,     0,     0,     0,   236,   237,   238,   239,
     240,   241,   242,   243,     0,   244,   245,   246,     0,     0,
       0,     0,  1250,     0,     0,   247,   248,   249,     0,   250,
     251,   252,   253,   254,   255,   256,   257,   258,  1251,   260,
    1252,  1253,     0,   263,   264,   265,   266,   267,   268,   269,
    1254,  1255,   270,   271,  1256,  1257,   274,     0,   275,   276,
     277,   278,  1258,     0,  1259,     0,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,     0,   291,   292,   293,
     294,   295,   296,     0,   297,   298,   299,   300,  1260,  1261,
    1262,  1263,  1264,  1265,  1266,   302,   303,   304,   305,   306,
     307,  1267,  1268,   310,  1269,   311,     0,   312,   313,   314,
     315,   316,   317,   318,     0,   319,   320,   321,   322,     0,
       0,   323,   324,   864,   326,   327,     0,   328,   329,   330,
       0,   331,   332,   333,     0,   334,   335,   336,   337,  1270,
     339,   340,   341,   342,  1271,  1272,   344,     0,   345,   346,
     347,  1273,   349,     0,   350,     0,   351,   352,     0,   353,
     354,   355,   356,   357,     0,   358,  1274,     0,  1275,   361,
     362,     0,   363,   364,   365,   366,   367,   368,   369,   370,
     371,   372,     0,   373,   374,   375,   376,   377,   378,   379,
       0,   380,   381,   382,   383,   384,   385,   386,  1276,  1277,
       0,  1278,     0,   390,   391,   392,   393,   394,   395,   396,
     397,   398,   399,     0,     0,   400,  1279,   402,   403,   404,
       0,   405,   406,   407,  1280,  1281,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,  1282,   427,  1283,   429,   430,   431,
     432,   433,   434,   435,   436,  1284,   438,  1285,   439,   440,
     441,   442,  1286,  1287,   444,  1288,   446,   447,   448,     0,
     449,   450,     0,     0,  1289,   452,   453,     0,     0,   454,
     455,   456,   457,   458,   459,  1290,   461,   462,   463,   464,
     465,   466,   467,   468,   469,   470,     0,     0,   471,   472,
    1291,   474,   475,   476,   477,   478,     0,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,  1292,   490,   491,
     492,   493,     0,   494,   495,   496,   497,   498,   499,   500,
     501,   502,   503,   504,   505,   506,     0,   507,   508,   509,
     510,   511,   512,   513,   514,  1293,   516,   517,   518,   519,
     520,   521,   522,   523,   524,     0,   525,   526,   527,   528,
     529,  1294,   530,   531,   532,   533,   534,   535,   536,   537,
    1295,   539,     0,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,   551,   552,  1296,   554,     0,   555,
     556,     0,   557,   558,   559,   560,   561,   562,   563,     0,
     564,  1297,  1298,     0,     0,   567,   568,  1299,   570,  1300,
    1301,   572,   573,   574,   575,   576,   577,   578,   579,     0,
    1302,   580,   581,   582,   583,   584,  1303,     0,   585,   586,
     587,   588,   589,   590,  1304,     0,   592,   593,   594,   595,
     596,   597,     0,     0,   598,     0,     0,   599,   600,   601,
     602,   603,   604,  5010,  1305,  1306,  1307,  1308,   610,  1309,
    1310,  1311,  1312,   615,   616,   617,   618,  1313,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1314,  1315,
       0,     0,     0,   235,     0,  1245,   685,  1317,  1246,  1247,
    1248,   746,  1249,     0,     0,     0,     0,     0,     0,     0,
     236,   237,   238,   239,   240,   241,   242,   243,     0,   244,
     245,   246,     0,     0,     0,     0,  1250,     0,     0,   247,
     248,   249,     0,   250,   251,   252,   253,   254,   255,   256,
     257,   258,  1251,   260,  1252,  1253,     0,   263,   264,   265,
     266,   267,   268,   269,  1254,  1255,   270,   271,  1256,  1257,
     274,     0,   275,   276,   277,   278,  1258,     0,  1259,     0,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
       0,   291,   292,   293,   294,   295,   296,     0,   297,   298,
     299,   300,  1260,  1261,  1262,  1263,  1264,  1265,  1266,   302,
     303,   304,   305,   306,   307,  1267,  1268,   310,  1269,   311,
       0,   312,   313,   314,   315,   316,   317,   318,     0,   319,
     320,   321,   322,     0,     0,   323,   324,   864,   326,   327,
       0,   328,   329,   330,     0,   331,   332,   333,     0,   334,
     335,   336,   337,  1270,   339,   340,   341,   342,  1271,  1272,
     344,     0,   345,   346,   347,  1273,   349,     0,   350,     0,
     351,   352,     0,   353,   354,   355,   356,   357,     0,   358,
    1274,     0,  1275,   361,   362,     0,   363,   364,   365,   366,
     367,   368,   369,   370,   371,   372,     0,   373,   374,   375,
     376,   377,   378,   379,     0,   380,   381,   382,   383,   384,
     385,   386,  1276,  1277,     0,  1278,     0,   390,   391,   392,
     393,   394,   395,   396,   397,   398,   399,     0,     0,   400,
    1279,   402,   403,   404,     0,   405,   406,   407,  1280,  1281,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,  1282,   427,
    1283,   429,   430,   431,   432,   433,   434,  5022,   436,  1284,
     438,  1285,   439,   440,   441,   442,  1286,  1287,   444,  1288,
     446,   447,   448,     0,   449,   450,     0,     0,  1289,   452,
     453,     0,     0,   454,   455,   456,   457,   458,   459,  1290,
     461,   462,   463,   464,   465,   466,   467,   468,   469,   470,
       0,     0,   471,   472,  1291,   474,   475,   476,   477,   478,
       0,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,  1292,   490,   491,   492,   493,     0,   494,   495,   496,
     497,   498,   499,   500,   501,   502,   503,   504,   505,   506,
       0,   507,   508,   509,   510,   511,   512,   513,   514,  1293,
     516,   517,   518,   519,   520,   521,   522,   523,   524,     0,
     525,   526,   527,   528,   529,  1294,   530,   531,   532,   533,
     534,   535,   536,   537,  1295,   539,     0,   540,   541,   542,
     543,   544,   545,   546,   547,   548,   549,   550,   551,   552,
    1296,   554,     0,   555,   556,     0,   557,   558,   559,   560,
     561,   562,   563,     0,   564,  1297,  1298,     0,     0,   567,
     568,  1299,   570,  1300,  1301,   572,   573,   574,   575,   576,
     577,   578,   579,     0,  1302,   580,   581,   582,   583,   584,
    1303,     0,   585,   586,   587,   588,   589,   590,  1304,     0,
     592,   593,   594,   595,   596,   597,     0,     0,   598,     0,
       0,   599,   600,   601,   602,   603,   604,   605,  1305,  1306,
    1307,  1308,   610,  1309,  1310,  1311,  1312,   615,   616,   617,
     618,  1313,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1314,  1315,     0,     0,     0,   235,     0,  1245,
     685,  1317,  1246,  1247,  1248,   746,  1249,     0,     0,     0,
       0,     0,     0,     0,   236,   237,   238,   239,   240,   241,
     242,   243,     0,   244,   245,   246,     0,     0,     0,     0,
    1250,     0,     0,   247,   248,   249,     0,   250,   251,   252,
     253,   254,   255,   256,   257,   258,  1251,   260,  1252,  1253,
       0,   263,   264,   265,   266,   267,   268,   269,  1254,  1255,
     270,   271,  1256,  1257,   274,     0,   275,   276,   277,   278,
    1258,     0,  1259,     0,   281,   282,   283,   284,   285,   286,
     287,   288,   289,   290,     0,   291,   292,   293,   294,   295,
     296,     0,   297,   298,  5334,   300,  1260,  1261,  1262,  1263,
    1264,  1265,  1266,   302,   303,   304,   305,   306,   307,  1267,
    1268,   310,  1269,   311,     0,   312,   313,   314,   315,   316,
     317,   318,     0,   319,   320,   321,   322,     0,     0,   323,
     324,   864,   326,   327,     0,   328,   329,   330,     0,   331,
     332,   333,     0,   334,   335,   336,   337,  1270,   339,   340,
     341,   342,  1271,  1272,   344,     0,   345,   346,   347,  1273,
     349,     0,   350,     0,   351,   352,     0,   353,   354,   355,
     356,   357,     0,   358,  1274,     0,  5335,   361,   362,     0,
     363,   364,   365,   366,   367,   368,   369,   370,   371,   372,
       0,   373,   374,   375,   376,   377,   378,   379,     0,   380,
     381,   382,   383,   384,   385,   386,  1276,  1277,     0,  1278,
       0,   390,   391,   392,   393,   394,   395,   396,   397,   398,
     399,     0,     0,   400,  1279,   402,   403,   404,     0,   405,
     406,   407,  1280,  1281,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,  1282,   427,  1283,   429,   430,   431,   432,   433,
     434,   435,   436,  1284,   438,  1285,   439,   440,   441,   442,
    1286,  1287,   444,  1288,   446,   447,   448,     0,   449,   450,
       0,     0,  1289,   452,   453,     0,     0,   454,   455,   456,
     457,   458,   459,  1290,   461,   462,   463,   464,   465,   466,
     467,   468,   469,   470,     0,     0,   471,   472,  1291,   474,
     475,   476,   477,   478,     0,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,  1292,   490,   491,   492,   493,
       0,   494,   495,   496,   497,   498,   499,   500,   501,   502,
     503,   504,   505,   506,     0,   507,   508,   509,   510,   511,
    5336,   513,   514,  1293,   516,   517,   518,   519,   520,   521,
     522,   523,   524,     0,   525,   526,   527,   528,   529,  1294,
     530,   531,   532,   533,   534,   535,   536,   537,  1295,   539,
       0,   540,   541,   542,   543,   544,   545,   546,   547,   548,
     549,   550,   551,   552,  1296,   554,     0,   555,   556,     0,
     557,   558,   559,   560,   561,   562,   563,     0,   564,  1297,
    1298,     0,     0,   567,   568,  1299,   570,  1300,  1301,   572,
     573,   574,   575,   576,   577,   578,   579,     0,  1302,   580,
     581,   582,   583,   584,  1303,     0,   585,   586,   587,   588,
     589,   590,  1304,     0,   592,   593,   594,   595,   596,   597,
       0,     0,   598,     0,     0,   599,   600,   601,   602,   603,
     604,   605,  1305,  1306,  1307,  1308,   610,  1309,  1310,  1311,
    1312,   615,   616,   617,   618,  1313,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1314,  1315,     0,     0,
       0,   235,     0,  1245,   685,  5337,  1246,  1247,  1248,   746,
    1249,     0,     0,     0,     0,     0,     0,     0,   236,   237,
     238,   239,   240,   241,   242,   243,     0,   244,   245,   246,
       0,     0,     0,     0,  1250,     0,     0,   247,   248,   249,
       0,   250,   251,   252,   253,   254,   255,   256,   257,  5828,
    1251,   260,  1252,  1253,     0,   263,   264,   265,   266,   267,
     268,   269,  1254,  1255,   270,   271,  1256,  1257,   274,     0,
     275,   276,   277,   278,  1258,     0,  1259,     0,   281,   282,
     283,   284,   285,   286,   287,   288,   289,   290,     0,   291,
     292,   293,   294,   295,   296,     0,   297,   298,   299,  5829,
    1260,  1261,  1262,  1263,  1264,  1265,  1266,   302,   303,   304,
     305,   306,   307,  1267,  1268,   310,  1269,   311,     0,   312,
     313,   314,   315,   316,   317,   318,     0,   319,   320,   321,
     322,     0,     0,   323,   324,   864,   326,   327,     0,   328,
     329,   330,     0,   331,   332,   333,     0,   334,   335,   336,
     337,  1270,   339,   340,   341,   342,  1271,  1272,   344,     0,
     345,   346,   347,  1273,   349,     0,   350,     0,   351,   352,
       0,   353,   354,   355,   356,   357,     0,   358,  1274,     0,
    1275,   361,   362,     0,   363,   364,   365,   366,   367,   368,
     369,   370,   371,   372,     0,   373,   374,   375,   376,   377,
     378,   379,     0,   380,   381,   382,   383,   384,   385,   386,
    1276,  1277,     0,  1278,     0,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,     0,     0,   400,  1279,   402,
     403,   404,     0,   405,   406,   407,  1280,  1281,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,  1282,   427,  1283,   429,
     430,   431,   432,   433,   434,   435,   436,  1284,   438,  1285,
     439,   440,   441,   442,  1286,  1287,   444,  1288,   446,   447,
     448,     0,   449,   450,     0,     0,  1289,   452,   453,     0,
       0,   454,   455,   456,   457,   458,   459,  1290,   461,   462,
     463,   464,   465,   466,   467,   468,   469,   470,     0,     0,
     471,   472,  1291,   474,   475,   476,   477,   478,     0,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,  1292,
     490,   491,   492,   493,     0,   494,   495,   496,   497,   498,
     499,   500,   501,   502,   503,   504,   505,   506,     0,   507,
     508,   509,   510,   511,   512,   513,   514,  1293,   516,   517,
     518,   519,   520,   521,   522,   523,   524,     0,   525,   526,
     527,   528,   529,  1294,   530,   531,   532,   533,   534,   535,
     536,   537,  1295,   539,     0,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,   552,  1296,   554,
       0,   555,   556,     0,   557,   558,   559,   560,   561,   562,
     563,     0,   564,  1297,  1298,     0,     0,   567,   568,  1299,
     570,  1300,  1301,   572,   573,   574,   575,   576,  5830,   578,
     579,     0,  1302,   580,   581,   582,   583,   584,  1303,     0,
     585,   586,   587,   588,   589,   590,  1304,     0,   592,   593,
     594,   595,   596,   597,     0,     0,   598,     0,     0,   599,
     600,   601,   602,   603,   604,   605,  1305,  1306,  1307,  1308,
     610,  1309,  1310,  1311,  1312,   615,   616,   617,   618,  1313,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1314,  1315,     0,     0,     0,   235,     0,  1245,   685,  1317,
    1246,  1247,  1248,   746,  1249,     0,     0,     0,     0,     0,
       0,     0,   236,   237,   238,   239,   240,   241,   242,   243,
       0,   244,   245,   246,     0,     0,     0,     0,  1250,     0,
       0,   247,   248,   249,     0,   250,   251,   252,   253,   254,
     255,   256,   257,   258,  1251,   260,  1252,  1253,     0,   263,
     264,   265,   266,   267,   268,   269,  1254,  1255,   270,   271,
    1256,  1257,   274,     0,   275,   276,   277,   278,  1258,     0,
    1259,     0,   281,   282,   283,   284,   285,   286,   287,   288,
     289,   290,     0,   291,   292,   293,   294,   295,   296,     0,
     297,   298,   299,  5829,  1260,  1261,  1262,  1263,  1264,  1265,
    1266,   302,   303,   304,   305,   306,   307,  1267,  1268,   310,
    1269,   311,     0,   312,   313,   314,   315,   316,   317,   318,
       0,   319,   320,   321,   322,     0,     0,   323,   324,   864,
     326,   327,     0,   328,   329,   330,     0,   331,   332,   333,
       0,   334,   335,   336,   337,  1270,   339,   340,   341,   342,
    1271,  1272,   344,     0,   345,   346,   347,  1273,   349,     0,
     350,     0,   351,   352,     0,   353,   354,   355,   356,   357,
       0,   358,  1274,     0,  1275,   361,   362,     0,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,     0,   373,
     374,   375,   376,   377,   378,   379,     0,   380,   381,   382,
     383,   384,   385,   386,  1276,  1277,     0,  1278,     0,   390,
     391,   392,   393,   394,   395,   396,   397,   398,   399,     0,
       0,   400,  1279,   402,   403,   404,     0,   405,   406,   407,
    1280,  1281,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
    1282,   427,  1283,   429,   430,   431,   432,   433,   434,   435,
     436,  1284,   438,  1285,   439,   440,   441,   442,  1286,  1287,
     444,  1288,   446,   447,   448,     0,   449,   450,     0,     0,
    1289,   452,   453,     0,     0,   454,   455,   456,   457,   458,
     459,  1290,   461,   462,   463,   464,   465,   466,   467,   468,
     469,   470,     0,     0,   471,   472,  1291,   474,   475,   476,
     477,   478,     0,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,  1292,   490,   491,   492,   493,     0,   494,
     495,   496,   497,   498,   499,   500,   501,   502,   503,   504,
     505,   506,     0,   507,   508,   509,   510,   511,   512,   513,
     514,  1293,   516,   517,   518,   519,   520,   521,   522,   523,
     524,     0,   525,   526,   527,   528,   529,  1294,   530,   531,
     532,   533,   534,   535,   536,   537,  1295,   539,     0,   540,
     541,   542,   543,   544,   545,   546,   547,   548,   549,   550,
     551,   552,  1296,   554,     0,   555,   556,     0,   557,   558,
     559,   560,   561,   562,   563,     0,   564,  1297,  1298,     0,
       0,   567,   568,  1299,   570,  1300,  1301,   572,   573,   574,
     575,   576,  5830,   578,   579,     0,  1302,   580,   581,   582,
     583,   584,  1303,     0,   585,   586,   587,   588,   589,   590,
    1304,     0,   592,   593,   594,   595,   596,   597,     0,     0,
     598,     0,     0,   599,   600,   601,   602,   603,   604,   605,
    1305,  1306,  1307,  1308,   610,  1309,  1310,  1311,  1312,   615,
     616,   617,   618,  1313,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1314,  1315,     0,     0,     0,   235,
       0,  1245,   685,  1317,  1246,  1247,  1248,   746,  1249,     0,
       0,     0,     0,     0,     0,     0,   236,   237,   238,   239,
     240,   241,   242,   243,     0,   244,   245,   246,     0,     0,
       0,     0,  1250,     0,     0,   247,   248,   249,     0,   250,
     251,   252,   253,   254,   255,   256,   257,   258,  1251,   260,
    1252,  1253,     0,   263,   264,   265,   266,   267,   268,   269,
    1254,  1255,   270,   271,  1256,  1257,   274,     0,   275,   276,
     277,   278,  1258,     0,  1259,     0,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,     0,   291,   292,   293,
     294,   295,   296,     0,   297,   298,   299,   300,  1260,  1261,
    1262,  1263,  1264,  1265,  1266,   302,   303,   304,   305,   306,
     307,  1267,  1268,   310,  5319,   311,     0,   312,   313,   314,
     315,   316,   317,   318,     0,   319,   320,   321,   322,     0,
       0,   323,   324,   864,   326,   327,     0,   328,   329,   330,
       0,   331,   332,   333,     0,   334,   335,   336,   337,  1270,
     339,   340,   341,   342,  1271,  1272,   344,     0,   345,   346,
     347,  1273,   349,     0,   350,     0,   351,   352,     0,   353,
     354,   355,   356,   357,     0,   358,  1274,     0,  1275,   361,
     362,     0,   363,   364,   365,   366,   367,   368,   369,   370,
     371,   372,     0,   373,   374,   375,   376,   377,   378,   379,
       0,   380,   381,   382,   383,   384,   385,   386,  1276,  1277,
       0,  1278,     0,   390,   391,   392,   393,   394,   395,   396,
     397,   398,   399,     0,     0,   400,  1279,   402,   403,   404,
       0,   405,   406,   407,  1280,  1281,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,  1282,   427,  1283,   429,   430,   431,
     432,   433,   434,   435,   436,  1284,   438,     0,   439,   440,
     441,   442,  1286,  1287,   444,  1288,   446,   447,   448,     0,
     449,   450,     0,     0,  1289,   452,   453,     0,     0,   454,
     455,   456,   457,   458,   459,  1290,   461,   462,   463,   464,
     465,   466,   467,   468,   469,   470,     0,     0,   471,   472,
    1291,   474,   475,   476,   477,   478,     0,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,  1292,   490,   491,
     492,   493,     0,   494,   495,   496,   497,   498,   499,   500,
     501,   502,   503,   504,   505,   506,     0,   507,   508,   509,
     510,   511,   512,   513,   514,  3198,   516,   517,   518,   519,
     520,   521,   522,   523,   524,     0,   525,   526,   527,   528,
     529,  1294,   530,   531,   532,   533,   534,   535,   536,   537,
    1295,   539,     0,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,   551,   552,  1296,   554,     0,   555,
     556,     0,   557,   558,   559,   560,   561,   562,   563,     0,
     564,  1297,  1298,     0,     0,   567,   568,  1299,   570,  1300,
    1301,   572,   573,   574,   575,   576,   577,   578,   579,     0,
       0,   580,   581,   582,   583,   584,  1303,     0,   585,   586,
     587,   588,   589,   590,  1304,     0,   592,   593,   594,   595,
     596,   597,     0,     0,   598,     0,     0,   599,   600,   601,
     602,   603,   604,   605,  1305,  1306,  1307,  1308,   610,  1309,
    1310,  1311,  1312,   615,   616,   617,   618,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  3199,  3200,
       0,     0,     0,   235,     0,  1245,   685,  3201,  1246,  1247,
    1248,   746,  1249,     0,     0,     0,     0,     0,     0,     0,
     236,   237,   238,   239,   240,   241,   242,   243,     0,   244,
     245,   246,     0,     0,     0,     0,  1250,     0,     0,   247,
     248,   249,     0,   250,   251,   252,   253,   254,   255,   256,
     257, -2820,  1251,   260,  1252,  1253,     0,   263,   264,   265,
     266,   267,   268,   269,  1254,  1255,   270,   271,  1256,  1257,
     274,     0,   275,   276,   277,   278,  1258,     0,  1259,     0,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
       0,   291,   292,   293,   294,   295,   296,     0,   297,   298,
     299,  5829,  1260,  1261,  1262,  1263,  1264,  1265,  1266,   302,
     303,   304,   305,   306,   307,  1267,  1268,   310,  1269,   311,
       0,   312,   313,   314,   315,   316,   317,   318,     0,   319,
     320,   321,   322,     0,     0,   323,   324,   864,   326,   327,
       0,   328,   329,   330,     0,   331,   332,   333,     0,   334,
     335,   336,   337,  1270,   339,   340,   341,   342,  1271,  1272,
     344,     0,   345,   346,   347,  1273,   349,     0,   350,     0,
     351,   352,     0,   353,   354,   355,   356,   357,     0,   358,
    1274,     0,  1275,   361,   362,     0,   363,   364,   365,   366,
     367, -2820,   369,   370,   371,   372,     0,   373,   374,   375,
     376,   377,   378,   379,     0,   380,   381,   382,   383,   384,
     385,   386,  1276,  1277,     0,  1278,     0,   390,     0,     0,
     393,   394,   395,   396,   397,   398,   399,     0,     0,   400,
    1279,   402,   403, -2820,     0,   405,   406,   407,  1280,  1281,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,  1282,   427,
    1283,   429,   430,   431,   432,   433,   434,   435,   436,  1284,
     438,  1285,   439,   440,     0,   442,  1286,  1287,   444,  1288,
     446,   447,   448,     0,   449,   450,     0,     0,  1289,   452,
     453,     0,     0,   454,   455,   456,   457,   458,   459,  1290,
     461,   462,   463,   464,   465,   466,   467,   468,   469,   470,
       0,     0,   471,   472,  1291,   474,   475,   476,   477,   478,
       0,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,  1292,   490,   491,   492,   493,     0,   494,   495,   496,
     497,   498,   499,   500,   501,   502,   503,   504,   505,   506,
       0,   507,   508,   509,   510,   511,   512,   513,   514,  1293,
     516,   517,   518,   519,   520,   521,   522,   523,   524,     0,
     525,   526,   527,   528,   529,  1294,   530,   531,   532,   533,
     534, -2820,   536,   537,  1295,   539,     0,   540,   541,   542,
     543,   544,   545,   546,   547,   548,   549,   550,   551,   552,
    1296,   554,     0,   555,   556,     0,   557,   558,   559,   560,
     561,   562,   563,     0,   564,  1297,  1298,     0,     0,   567,
     568,  1299,   570,  1300,  1301,   572,   573,   574,   575,   576,
    5830,   578,   579,     0,  1302,   580,   581,   582,   583,   584,
    1303,     0,   585,   586,   587,   588,   589,   590,  1304,     0,
     592,   593,   594,   595,   596,   597,     0,     0,   598,     0,
       0,   599,   600,   601,   602,   603,   604,   605,  1305,  1306,
    1307,  1308,   610,  1309,  1310,  1311,  1312,   615,   616,   617,
     618, -2820,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1314,  1315,     0,     0,     0,   235,     0,  1245,
     685,  1317,  1246,  1247,  1248,   746,  1249,     0,     0,     0,
       0,     0,     0,     0,   236,   237,   238,   239,   240,   241,
     242,   243,     0,   244,   245,   246,     0,     0,     0,     0,
    1250,     0,     0,   247,   248,   249,     0,   250,   251,   252,
     253,   254,   255,   256,   257,   258,  1251,   260,  1252,  1253,
       0,   263,   264,   265,   266,   267,   268,   269,  1254,  1255,
     270,   271,  1256,  1257,   274,     0,   275,   276,   277,   278,
    1258,     0,  1259,     0,   281,   282,   283,   284,   285,   286,
     287,   288,   289,   290,     0,   291,   292,   293,   294,   295,
     296,     0,   297,   298,   299,   300,  1260,  1261,  1262,  1263,
    1264,  1265,  1266,   302,   303,   304,   305,   306,   307,  1267,
    1268,   310,     0,   311,     0,   312,   313,   314,   315,   316,
     317,   318,     0,   319,   320,   321,   322,     0,     0,   323,
     324,   864,   326,   327,     0,   328,   329,   330,     0,   331,
     332,   333,     0,   334,   335,   336,   337,  1270,   339,   340,
     341,   342,  1271,  1272,   344,     0,   345,   346,   347,  1273,
     349,     0,   350,     0,   351,   352,     0,   353,   354,   355,
     356,   357,     0,   358,  1274,     0,  1275,   361,   362,     0,
     363,   364,   365,   366,   367,   368,   369,   370,   371,   372,
       0,   373,   374,   375,   376,   377,   378,   379,     0,   380,
     381,   382,   383,   384,   385,   386,  1276,  1277,     0,  1278,
       0,   390,   391,   392,   393,   394,   395,   396,   397,   398,
     399,     0,     0,   400,  1279,   402,   403,   404,     0,   405,
     406,   407,  1280,  1281,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,  1282,   427,  1283,   429,   430,   431,   432,   433,
     434,   435,   436,  1284,   438,     0,   439,   440,   441,   442,
    1286,  1287,   444,  1288,   446,   447,   448,     0,   449,   450,
       0,     0,  1289,   452,   453,     0,     0,   454,   455,   456,
     457,   458,   459,  1290,   461,   462,   463,   464,   465,   466,
     467,   468,   469,   470,     0,     0,   471,   472,  1291,   474,
     475,   476,   477,   478,     0,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,  1292,   490,   491,   492,   493,
       0,   494,   495,   496,   497,   498,   499,   500,   501,   502,
     503,   504,   505,   506,     0,   507,   508,   509,   510,   511,
     512,   513,   514,  3198,   516,   517,   518,   519,   520,   521,
     522,   523,   524,     0,   525,   526,   527,   528,   529,  1294,
     530,   531,   532,   533,   534,   535,   536,   537,  1295,   539,
       0,   540,   541,   542,   543,   544,   545,   546,   547,   548,
     549,   550,   551,   552,  1296,   554,     0,   555,   556,     0,
     557,   558,   559,   560,   561,   562,   563,     0,   564,  1297,
    1298,     0,     0,   567,   568,  1299,   570,  1300,  1301,   572,
     573,   574,   575,   576,   577,   578,   579,     0,     0,   580,
     581,   582,   583,   584,  1303,     0,   585,   586,   587,   588,
     589,   590,  1304,     0,   592,   593,   594,   595,   596,   597,
       0,     0,   598,     0,     0,   599,   600,   601,   602,   603,
     604,   605,  1305,  1306,  1307,  1308,   610,  1309,  1310,  1311,
    1312,   615,   616,   617,   618,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  3199,  3200,   235,     0,
    1245,   685,     0,  1246,  1247,  3201,   746,  1249,     0,     0,
       0,     0,     0,     0,     0,   236,   237,   238,   239,   240,
     241,   242,   243,     0,   244,   245,   246,     0,     0,     0,
       0,  1250,     0,     0,   247,   248,   249,     0,   250,   251,
     252,   253,   254,   255,   256,   257,   258,  1251,   260,  1252,
    1253,     0,   263,   264,   265,   266,   267,   268,   269,  1254,
    1255,   270,   271,  1256,  1257,   274,     0,   275,   276,   277,
     278,  1258,     0,  1259,     0,   281,   282,   283,   284,   285,
     286,   287,   288,   289,   290,     0,   291,   292,   293,   294,
     295,   296,     0,   297,   298,   299,   300,  1260,  1261,  1262,
    1263,  1264,  1265,  1266,   302,   303,   304,   305,   306,   307,
    1267,  1268,   310,     0,   311,     0,   312,   313,   314,   315,
     316,   317,   318,     0,   319,   320,   321,   322,     0,     0,
     323,   324,   864,   326,   327,     0,   328,   329,   330,     0,
     331,   332,   333,     0,   334,   335,   336,   337,  1270,   339,
     340,   341,   342,  1271,  1272,   344,     0,   345,   346,   347,
    1273,   349,     0,   350,     0,   351,   352,     0,   353,   354,
     355,   356,   357,     0,   358,  1274,     0,  1275,   361,   362,
       0,   363,   364,   365,   366,   367,   368,   369,   370,   371,
     372,     0,   373,   374,   375,   376,   377,   378,   379,     0,
     380,   381,   382,   383,   384,   385,   386,  1276,  1277,     0,
    1278,     0,   390,   391,   392,   393,   394,   395,   396,   397,
     398,   399,     0,     0,   400,  1279,   402,   403,   404,     0,
     405,   406,   407,  1280,  1281,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,   418,   419,   420,   421,   422,
     423,   424,   425,  1282,   427,  1283,   429,   430,   431,   432,
     433,   434,   435,   436,  1284,   438,     0,   439,   440,   441,
     442,  1286,  1287,   444,  1288,   446,   447,   448,     0,   449,
     450,     0,     0,   451,   452,   453,     0,     0,   454,   455,
     456,   457,   458,   459,  1290,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,     0,     0,   471,   472,  1291,
     474,   475,   476,   477,   478,     0,   479,   480,   481,   482,
     483,   484,   485,   486,   487,   488,  1292,   490,   491,   492,
     493,     0,   494,   495,   496,   497,   498,   499,   500,   501,
     502,   503,   504,   505,   506,     0,   507,   508,   509,   510,
     511,   512,   513,   514,  3369,  3370,   517,   518,   519,   520,
     521,   522,   523,   524,     0,   525,   526,   527,   528,   529,
    1294,   530,   531,   532,   533,   534,   535,   536,   537,  1295,
     539,     0,   540,   541,   542,   543,   544,   545,   546,   547,
     548,   549,   550,   551,   552,  1296,   554,     0,   555,   556,
       0,   557,   558,   559,   560,   561,   562,   563,     0,   564,
    1297,  1298,     0,     0,   567,   568,  1299,   570,  1300,  1301,
     572,   573,   574,   575,   576,   577,   578,   579,     0,     0,
     580,   581,   582,   583,   584,  1303,     0,   585,   586,   587,
     588,   589,   590,  1304,     0,   592,   593,   594,   595,   596,
     597,     0,     0,   598,     0,     0,   599,   600,   601,   602,
     603,   604,   605,  1305,  1306,  1307,  1308,   610,  1309,  1310,
    1311,  1312,   615,   616,   617,   618,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  3371,  3372,   235,
       0,  1245,   685,     0,  1246,  1247,  3201,   746,  1249,     0,
       0,     0,     0,     0,     0,     0,   236,   237,   238,   239,
     240,   241,   242,   243,     0,   244,   245,   246,     0,     0,
       0,     0,  1250,     0,     0,   247,   248,   249,     0,   250,
     251,   252,   253,   254,   255,   256,   257,   258,  1251,   260,
    1252,  1253,     0,   263,   264,   265,   266,   267,   268,   269,
    1254,  1255,   270,   271,  1256,  1257,   274,     0,   275,   276,
     277,   278,  1258,     0,  1259,     0,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,     0,   291,   292,   293,
     294,   295,   296,     0,   297,   298,   299,   300,  1260,  1261,
    1262,  1263,  1264,  1265,  1266,   302,   303,   304,   305,   306,
     307,  1267,  1268,   310,     0,   311,     0,   312,   313,   314,
     315,   316,   317,   318,     0,   319,   320,   321,   322,     0,
       0,   323,   324,   864,   326,   327,     0,   328,   329,   330,
       0,   331,   332,   333,     0,   334,   335,   336,   337,  1270,
     339,   340,   341,   342,  1271,  1272,   344,     0,   345,   346,
     347,  1273,   349,     0,   350,     0,   351,   352,     0,   353,
     354,   355,   356,   357,     0,   358,  1274,     0,  1275,   361,
     362,     0,   363,   364,   365,   366,   367,   368,   369,   370,
     371,   372,     0,   373,   374,   375,   376,   377,   378,   379,
       0,   380,   381,   382,   383,   384,   385,   386,  1276,  1277,
       0,  1278,     0,   390,   391,   392,   393,   394,   395,   396,
     397,   398,   399,     0,     0,   400,  1279,   402,   403,   404,
       0,   405,   406,   407,  1280,  1281,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,  1282,   427,  1283,   429,   430,   431,
     432,   433,   434,   435,   436,  1284,   438,     0,   439,   440,
     441,   442,  1286,  1287,   444,  1288,   446,   447,   448,     0,
     449,   450,     0,     0,   451,   452,   453,     0,     0,   454,
     455,   456,   457,   458,   459,  1290,   461,   462,   463,   464,
     465,   466,   467,   468,   469,   470,     0,     0,   471,   472,
    1291,   474,   475,   476,   477,   478,     0,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,  1292,   490,   491,
     492,   493,     0,   494,   495,   496,   497,   498,   499,   500,
     501,   502,   503,   504,   505,   506,     0,   507,   508,   509,
     510,   511,   512,   513,   514,  3198,   516,   517,   518,   519,
     520,   521,   522,   523,   524,     0,   525,   526,   527,   528,
     529,  1294,   530,   531,   532,   533,   534,   535,   536,   537,
    1295,   539,     0,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,   551,   552,  1296,   554,     0,   555,
     556,     0,   557,   558,   559,   560,   561,   562,   563,     0,
     564,  1297,  1298,     0,     0,   567,   568,  1299,   570,  1300,
    1301,   572,   573,   574,   575,   576,   577,   578,   579,     0,
       0,   580,   581,   582,   583,   584,  1303,     0,   585,   586,
     587,   588,   589,   590,  1304,     0,   592,   593,   594,   595,
     596,   597,     0,     0,   598,     0,     0,   599,   600,   601,
     602,   603,   604,   605,  1305,  1306,  1307,  1308,   610,  1309,
    1310,  1311,  1312,   615,   616,   617,   618,     0,     0,     0,
       0,   235,     0,  1245,   685,     0,  1246,  1247,     0,   746,
    1249,     0,     0,     0,     0,     0,     0,  3201,   236,   237,
     238,   239,   240,   241,   242,   243,     0,   244,   245,   246,
       0,     0,     0,     0,  1250,     0,     0,   247,   248,   249,
       0,   250,   251,   252,   253,   254,   255,   256,   257,   258,
    1251,   260,  1252,  1253,     0,   263,  4562,   265,   266,   267,
     268,   269,  1254,  1255,   270,   271,  1256,  1257,   274,     0,
     275,   276,   277,   278,  1258,     0,  1259,     0,   281,   282,
     283,   284,   285,   286,   287,   288,   289,   290,     0,   291,
     292,   293,   294,   295,   296,     0,   297,   298,   299,   300,
    1260,  1261,  1262,  1263,  1264,  1265,  1266,   302,   303,   304,
     305,   306,   307,  1267,  1268,   310,     0,   311,     0,   312,
     313,   314,   315,   316,   317,   318,     0,   319,   320,   321,
     322,     0,     0,   323,   324,   864,   326,   327,     0,   328,
     329,   330,     0,   331,   332,   333,     0,   334,   335,   336,
     337,  1270,   339,   340,   341,   342,  1271,  1272,   344,     0,
     345,   346,   347,  1273,   349,     0,   350,     0,   351,   352,
       0,   353,   354,   355,   356,   357,     0,   358,  1274,     0,
    1275,   361,   362,     0,   363,   364,   365,   366,   367,   368,
     369,   370,   371,   372,     0,   373,   374,   375,   376,   377,
     378,   379,     0,   380,   381,   382,   383,   384,   385,   386,
    1276,  1277,     0,  1278,     0,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,     0,     0,   400,  1279,   402,
     403,   404,     0,   405,   406,   407,  1280,  1281,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,  1282,   427,  1283,   429,
     430,   431,   432,   433,   434,   435,   436,  1284,   438,     0,
     439,   440,   441,   442,  1286,  1287,   444,  1288,   446,   447,
     448,     0,   449,   450,     0,     0,   451,   452,   453,     0,
       0,   454,   455,   456,   457,   458,   459,  1290,   461,   462,
     463,   464,   465,   466,   467,   468,   469,   470,     0,     0,
     471,   472,  1291,   474,   475,   476,   477,   478,     0,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,  1292,
     490,   491,   492,   493,     0,   494,   495,   496,   497,   498,
     499,   500,   501,   502,   503,   504,   505,   506,     0,   507,
     508,   509,   510,   511,   512,   513,   514,  3198,   516,   517,
     518,   519,   520,   521,   522,   523,   524,     0,   525,   526,
     527,   528,   529,  1294,   530,   531,   532,   533,   534,   535,
     536,   537,  1295,   539,     0,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,   552,  1296,   554,
       0,   555,   556,     0,   557,   558,   559,   560,   561,   562,
     563,     0,   564,  1297,  1298,     0,     0,   567,   568,  1299,
     570,  1300,  1301,   572,   573,   574,   575,   576,   577,   578,
     579,     0,     0,   580,   581,   582,   583,   584,  1303,     0,
     585,   586,   587,   588,   589,   590,  1304,     0,   592,   593,
     594,   595,   596,   597,     0,     0,   598,     0,     0,   599,
     600,   601,   602,   603,   604,   605,  1305,  1306,  1307,  1308,
     610,  1309,  1310,  1311,  1312,   615,   616,   617,   618,     0,
       0,     0,     0,   235,     0,  1245,   685,     0,  1246,  1247,
       0,   746,  1249,     0,     0,     0,     0,     0,     0,  3201,
     236,   237,   238,   239,   240,   241,   242,   243,     0,   244,
     245,   246,     0,     0,     0,     0,  1250,     0,     0,   247,
     248,   249,     0,   250,   251,   252,   253,   254,   255,   256,
     257,   258,  1251,   260,  1252,  1253,     0,   263,   264,   265,
     266,   267,   268,   269,  1254,  1255,   270,   271,  1256,  1257,
     274,     0,   275,   276,   277,   278,  1258,     0,  1259,     0,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
       0,   291,   292,   293,   294,   295,   296,     0,   297,   298,
     299,   300,  1260,  1261,  1262,  1263,  1264,  1265,  1266,   302,
     303,   304,   305,   306,   307,  1267,  1268,   310,     0,   311,
       0,   312,   313,   314,   315,   316,   317,   318,     0,   319,
     320,   321,   322,     0,     0,   323,   324,   864,   326,   327,
       0,   328,   329,   330,     0,   331,   332,   333,     0,   334,
     335,   336,   337,  1270,   339,   340,   341,   342,  1271,  1272,
     344,     0,   345,   346,   347,  1273,   349,     0,   350,     0,
     351,   352,     0,   353,   354,   355,   356,   357,     0,   358,
    1274,     0,  1275,   361,   362,     0,   363,   364,   365,   366,
     367,   368,   369,   370,   371,   372,     0,   373,   374,   375,
     376,   377,   378,   379,     0,   380,   381,   382,   383,   384,
     385,   386,  1276,  1277,     0,  1278,     0,   390,   391,   392,
     393,   394,   395,   396,   397,   398,   399,     0,     0,   400,
    1279,   402,   403,   404,     0,   405,   406,   407,  1280,  1281,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,  1282,   427,
    1283,   429,   430,   431,   432,   433,   434,   435,   436,  1284,
     438,     0,   439,   440,   441,   442,  1286,  1287,   444,  1288,
     446,   447,   448,     0,   449,   450,     0,     0,   451,   452,
     453,     0,     0,   454,   455,   456,   457,   458,   459,  1290,
     461,   462,   463,   464,   465,   466,   467,   468,   469,   470,
       0,     0,   471,   472,  1291,   474,   475,   476,   477,   478,
       0,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,  1292,   490,   491,   492,   493,     0,   494,   495,   496,
     497,   498,   499,   500,   501,   502,   503,   504,   505,   506,
       0,   507,   508,   509,   510,   511,   512,   513,   514,  3198,
     516,   517,   518,   519,   520,   521,   522,   523,   524,     0,
     525,   526,   527,   528,   529,  1294,   530,   531,   532,   533,
     534,   535,   536,   537,  1295,   539,     0,   540,   541,   542,
     543,   544,   545,   546,   547,   548,   549,   550,   551,   552,
    1296,   554,     0,   555,   556,     0,   557,   558,   559,   560,
     561,   562,   563,     0,   564,  1297,  1298,     0,     0,   567,
     568,  1299,   570,  1300,  1301,   572,   573,   574,   575,   576,
     577,   578,   579,     0,     0,   580,   581,   582,   583,   584,
    1303,     0,   585,   586,   587,   588,   589,   590,  1304,     0,
     592,   593,   594,   595,   596,   597,     0,     0,   598,     0,
       0,   599,   600,   601,   602,   603,   604,   605,  1305,  1306,
    1307,  1308,  4620,  1309,  1310,  1311,  1312,   615,   616,   617,
     618,     0,     0,     0,     0,   235,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  3201,   236,   237,   238,   239,   240,   241,   242,   243,
       0,   244,   245,   246,     0,     0,     0,     0,     0,     0,
       0,   247,   248,   249,     0,   250,   251,   252,   253,   254,
     255,   256,   257,   258,   259,   260,   261,   262,     0,   263,
     264,   265,   266,   267,   268,   269,     0,  1255,   270,   271,
     272,   273,   274,     0,   275,   276,   277,   278,  1258,     0,
    1259,     0,   281,   282,   283,   284,   285,   286,   287,   288,
     289,   290,     0,   291,   292,   293,   294,   295,   296,     0,
     297,   298,   299,   300,  1260,  1261,  1262,  1263,  1264,  1265,
    1266,   302,   303,   304,   305,   306,   307,   308,   309,   310,
       0,   311,     0,   312,   313,   314,   315,   316,   317,   318,
       0,   319,   320,   321,   322,     0,     0,   323,   324,   325,
     326,   327,     0,   328,   329,   330,     0,   331,   332,   333,
       0,   334,   335,   336,   337,   338,   339,   340,   341,   342,
    1271,     0,   344,     0,   345,   346,   347,   348,   349,     0,
     350,     0,   351,   352,     0,   353,   354,   355,   356,   357,
       0,   358,  1274,     0,   360,   361,   362,     0,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,     0,   373,
     374,   375,   376,   377,   378,   379,     0,   380,   381,   382,
     383,   384,   385,   386,   387,   388,     0,   389,     0,   390,
     391,   392,   393,   394,   395,   396,   397,   398,   399,  3344,
       0,   400,  1279,   402,   403,   404,     0,   405,   406,   407,
    1280,  1281,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,  1284,   438,     0,   439,   440,   441,   442,     0,  1287,
     444,   445,   446,   447,   448,     0,   449,   450,     0,   839,
     451,   452,   453,     0,     0,   454,   455,   456,   457,   458,
     459,  1290,   461,   462,   463,   464,   465,   466,   467,   468,
     469,   470,     0,     0,   471,   472,  1291,   474,   475,   476,
     477,   478,     0,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,   492,   493,     0,   494,
     495,   496,   497,   498,   499,   500,   501,   502,   503,   504,
     505,   506,     0,   507,   508,   509,   510,   511,   512,   513,
     514,   515,  3345,   517,   518,   519,   520,   521,   522,   523,
     524,    41,   525,   526,   527,   528,   529,  1294,   530,   531,
     532,   533,   534,   535,   536,   537,   538,   539,     0,   540,
     541,   542,   543,   544,   545,   546,   547,   548,   549,   550,
     551,   552,  1296,   554,     0,   555,   556,    45,   557,   558,
     559,   560,   561,   562,   563,     0,   564,   565,   566,     0,
       0,   567,   568,  1299,   570,  1300,     0,   572,   573,   574,
     575,   576,   577,   578,   579,     0,     0,   580,   581,   582,
     583,   584,  1303,     0,   585,   586,   587,   588,   589,  1179,
     591,     0,   592,   593,   594,   595,   596,   597,     0,     0,
     598,     0,    50,   599,   600,   601,   602,   603,   604,   605,
    1305,  1306,  1307,  1308,   610,  1309,  1310,  1311,  1312,  3346,
     616,   617,   618,     0,     0,    51,     0,   235,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  3347,   236,   237,   238,   239,   240,   241,
     242,   243,     0,   244,   245,   246,     0,     0,     0,     0,
       0,     0,     0,   247,   248,   249,     0,   250,   251,   252,
     253,   254,   255,   256,   257,   258,   259,   260,   261,   262,
       0,   263,   264,   265,   266,   267,   268,   269,     0,  1255,
     270,   271,   272,   273,   274,     0,   275,   276,   277,   278,
    1258,     0,  1259,     0,   281,   282,   283,   284,   285,   286,
     287,   288,   289,   290,     0,   291,   292,   293,   294,   295,
     296,     0,   297,   298,   299,   300,  1260,  1261,  1262,  1263,
    1264,  1265,  1266,   302,   303,   304,   305,   306,   307,   308,
     309,   310,     0,   311,     0,   312,   313,   314,   315,   316,
     317,   318,     0,   319,   320,   321,   322,     0,     0,   323,
     324,   325,   326,   327,     0,   328,   329,   330,     0,   331,
     332,   333,     0,   334,   335,   336,   337,   338,   339,   340,
     341,   342,  1271,     0,   344,     0,   345,   346,   347,   348,
     349,     0,   350,     0,   351,   352,     0,   353,   354,   355,
     356,   357,     0,   358,  1274,     0,   360,   361,   362,     0,
     363,   364,   365,   366,   367,   368,   369,   370,   371,   372,
       0,   373,   374,   375,   376,   377,   378,   379,     0,   380,
     381,   382,   383,   384,   385,   386,   387,   388,     0,   389,
       0,   390,   391,   392,   393,   394,   395,   396,   397,   398,
     399,  3344,     0,   400,  1279,   402,   403,   404,     0,   405,
     406,   407,  1280,  1281,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   431,   432,   433,
     434,   435,   436,  1284,   438,     0,   439,   440,   441,   442,
       0,  1287,   444,   445,   446,   447,   448,     0,   449,   450,
       0,   839,   451,   452,   453,     0,     0,   454,   455,   456,
     457,   458,   459,  1290,   461,   462,   463,   464,   465,   466,
     467,   468,   469,   470,     0,     0,   471,   472,  1291,   474,
     475,   476,   477,   478,     0,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   490,   491,   492,   493,
       0,   494,   495,   496,   497,   498,   499,   500,   501,   502,
     503,   504,   505,   506,     0,   507,   508,   509,   510,   511,
     512,   513,   514,   515,  3345,   517,   518,   519,   520,   521,
     522,   523,   524,     0,   525,   526,   527,   528,   529,  1294,
     530,   531,   532,   533,   534,   535,   536,   537,   538,   539,
       0,   540,   541,   542,   543,   544,   545,   546,   547,   548,
     549,   550,   551,   552,  1296,   554,     0,   555,   556,     0,
     557,   558,   559,   560,   561,   562,   563,     0,   564,   565,
     566,     0,     0,   567,   568,  1299,   570,  1300,     0,   572,
     573,   574,   575,   576,   577,   578,   579,     0,     0,   580,
     581,   582,   583,   584,  1303,     0,   585,   586,   587,   588,
     589,   590,   591,     0,   592,   593,   594,   595,   596,   597,
       0,     0,   598,     0,     0,   599,   600,   601,   602,   603,
     604,   605,  1305,  1306,  1307,  1308,   610,  1309,  1310,  1311,
    1312,  3346,   616,   617,   618,     0,     0,     0,     0,   235,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  3347,   236,   237,   238,   239,
     240,   241,   242,   243,     0,   244,   245,   246,     0,     0,
       0,     0,     0,     0,     0,   247,   248,   249,     0,   250,
     251,   252,   253,   254,   255,   256,   257,   258,   259,   260,
     261,   262,     0,   263,   264,   265,   266,   267,   268,   269,
       0,  1255,   270,   271,   272,   273,   274,     0,   275,   276,
     277,   278,  1258,     0,  1259,     0,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,     0,   291,   292,   293,
     294,   295,   296,     0,   297,   298,   299,   300,  1260,  1261,
    1262,  1263,  1264,  1265,  1266,   302,   303,   304,   305,   306,
     307,   308,   309,   310,     0,   311,     0,   312,   313,   314,
     315,   316,   317,   318,     0,   319,   320,   321,   322,     0,
       0,   323,   324,   325,   326,   327,     0,   328,   329,   330,
       0,   331,   332,   333,     0,   334,   335,   336,   337,   338,
     339,   340,   341,   342,  1271,     0,   344,     0,   345,   346,
     347,   348,   349,     0,   350,     0,   351,   352,     0,   353,
     354,   355,   356,   357,     0,   358,  1274,     0,   360,   361,
     362,     0,   363,   364,   365,   366,   367,   368,   369,   370,
     371,   372,     0,   373,   374,   375,   376,   377,   378,   379,
       0,   380,   381,   382,   383,   384,   385,   386,   387,   388,
       0,   389,     0,   390,   391,   392,   393,   394,   395,   396,
     397,   398,   399,     0,     0,   400,  1279,   402,   403,   404,
       0,   405,   406,   407,  1280,  1281,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,   427,   428,   429,   430,   431,
     432,   433,   434,   435,   436,  1284,   438,     0,   439,   440,
     441,   442,     0,  1287,   444,   445,   446,   447,   448,     0,
     449,   450,     0,     0,   451,   452,   453,     0,     0,   454,
     455,   456,   457,   458,   459,  1290,   461,   462,   463,   464,
     465,   466,   467,   468,   469,   470,     0,     0,   471,   472,
    1291,   474,   475,   476,   477,   478,     0,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,   490,   491,
     492,   493,     0,   494,   495,   496,   497,   498,   499,   500,
     501,   502,   503,   504,   505,   506,     0,   507,   508,   509,
     510,   511,   512,   513,   514,   515,   516,   517,   518,   519,
     520,   521,   522,   523,   524,     0,   525,   526,   527,   528,
     529,  1294,   530,   531,   532,   533,   534,   535,   536,   537,
     538,   539,     0,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,   551,   552,  1296,   554,     0,   555,
     556,     0,   557,   558,   559,   560,   561,   562,   563,     0,
     564,   565,   566,     0,     0,   567,   568,  1299,   570,  1300,
       0,   572,   573,   574,   575,   576,   577,   578,   579,     0,
       0,   580,   581,   582,   583,   584,  1303,     0,   585,   586,
     587,   588,   589,   590,   591,     0,   592,   593,   594,   595,
     596,   597,     0,     0,   598,     0,     0,   599,   600,   601,
     602,   603,   604,   605,  1305,  1306,  1307,  1308,   610,  1309,
    1310,  1311,  1312,   615,   616,   617,   618,     0,     0,     0,
       0,   235,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  3782,   236,   237,
     238,   239,   240,   241,   242,   243,     0,   244,   245,   246,
       0,     0,     0,     0,     0,     0,     0,   247,   248,   249,
       0,   250,   251,   252,   253,   254,   255,   256,   257,   258,
     259,   260,   261,   262,     0,   263,   264,   265,   266,   267,
     268,   269,     0,  1255,   270,   271,   272,   273,   274,     0,
     275,   276,   277,   278,  1258,     0,  1259,     0,   281,   282,
     283,   284,   285,   286,   287,   288,   289,   290,     0,   291,
     292,   293,   294,   295,   296,     0,   297,   298,   299,   300,
    1260,  1261,  1262,  1263,  1264,  1265,  1266,   302,   303,   304,
     305,   306,   307,   308,   309,   310,     0,   311,     0,   312,
     313,   314,   315,   316,   317,   318,     0,   319,   320,   321,
     322,     0,     0,   323,   324,   325,   326,   327,     0,   328,
     329,   330,     0,   331,   332,   333,     0,   334,   335,   336,
     337,   338,   339,   340,   341,   342,  1271,     0,   344,     0,
     345,   346,   347,   348,   349,     0,   350,     0,   351,   352,
       0,   353,   354,   355,   356,   357,     0,   358,  1274,     0,
     360,   361,   362,     0,   363,   364,   365,   366,   367,   368,
     369,   370,   371,   372,     0,   373,   374,   375,   376,   377,
     378,   379,     0,   380,   381,   382,   383,   384,   385,   386,
     387,   388,     0,   389,     0,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,     0,     0,   400,  1279,   402,
     403,   404,     0,   405,   406,   407,  1280,  1281,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,   432,   433,   434,   435,   436,  1284,   438,     0,
     439,   440,   441,   442,     0,  1287,   444,   445,   446,   447,
     448,     0,   449,   450,     0,     0,   451,   452,   453,     0,
       0,   454,   455,   456,   457,   458,   459,  1290,   461,   462,
     463,   464,   465,   466,   467,   468,   469,   470,     0,     0,
     471,   472,  1291,   474,   475,   476,   477,   478,     0,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,   493,     0,   494,   495,   496,   497,   498,
     499,   500,   501,   502,   503,   504,   505,   506,     0,   507,
     508,   509,   510,   511,   512,   513,   514,   515,  3345,   517,
     518,   519,   520,   521,   522,   523,   524,     0,   525,   526,
     527,   528,   529,  1294,   530,   531,   532,   533,   534,   535,
     536,   537,   538,   539,     0,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,   552,  1296,   554,
       0,   555,   556,     0,   557,   558,   559,   560,   561,   562,
     563,     0,   564,   565,   566,     0,     0,   567,   568,  1299,
     570,  1300,     0,   572,   573,   574,   575,   576,   577,   578,
     579,     0,     0,   580,   581,   582,   583,   584,  1303,     0,
     585,   586,   587,   588,   589,   590,   591,     0,   592,   593,
     594,   595,   596,   597,     0,     0,   598,     0,     0,   599,
     600,   601,   602,   603,   604,   605,  1305,  1306,  1307,  1308,
     610,  1309,  1310,  1311,  1312,  3346,   616,   617,   618,     0,
       0,     0,     0,   235,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    57,
     236,   237,   238,   239,   240,   241,   242,   243,     0,   244,
     245,   246,     0,     0,     0,     0,     0,     0,     0,   247,
     248,   249,     0,   250,   251,   252,   253,   254,   255,   256,
     257,   258,   259,   260,   261,   262,     0,   263,   264,   265,
     266,   267,   268,   269,     0,  1255,   270,   271,   272,   273,
     274,     0,   275,   276,   277,   278,  1258,     0,  1259,     0,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
       0,   291,   292,   293,   294,   295,   296,     0,   297,   298,
     299,   300,  1260,  1261,  1262,  1263,  1264,  1265,  1266,   302,
     303,   304,   305,   306,   307,   308,   309,   310,     0,   311,
       0,   312,   313,   314,   315,   316,   317,   318,     0,   319,
     320,   321,   322,     0,     0,   323,   324,   325,   326,   327,
       0,   328,   329,   330,     0,   331,   332,   333,     0,   334,
     335,   336,   337,   338,   339,   340,   341,   342,  1271,     0,
     344,     0,   345,   346,   347,   348,   349,     0,   350,     0,
     351,   352,     0,   353,   354,   355,   356,   357,     0,   358,
    1274,     0,   360,   361,   362,     0,   363,   364,   365,   366,
     367,   368,   369,   370,   371,   372,     0,   373,   374,   375,
     376,   377,   378,   379,     0,   380,   381,   382,   383,   384,
     385,   386,   387,   388,     0,   389,     0,   390,   391,   392,
     393,   394,   395,   396,   397,   398,   399,     0,     0,   400,
    1279,   402,   403,   404,     0,   405,   406,   407,  1280,  1281,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,  1284,
     438,     0,   439,   440,   441,   442,     0,  1287,   444,   445,
     446,   447,   448,     0,   449,   450,     0,     0,   451,   452,
     453,     0,     0,   454,   455,   456,   457,   458,   459,  1290,
     461,   462,   463,   464,   465,   466,   467,   468,   469,   470,
       0,     0,   471,   472,  1291,   474,   475,   476,   477,   478,
       0,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,   490,   491,   492,   493,     0,   494,   495,   496,
     497,   498,   499,   500,   501,   502,   503,   504,   505,   506,
       0,   507,   508,   509,   510,   511,   512,   513,   514,   515,
     516,   517,   518,   519,   520,   521,   522,   523,   524,     0,
     525,   526,   527,   528,   529,  1294,   530,   531,   532,   533,
     534,   535,   536,   537,   538,   539,     0,   540,   541,   542,
     543,   544,   545,   546,   547,   548,   549,   550,   551,   552,
    1296,   554,     0,   555,   556,     0,   557,   558,   559,   560,
     561,   562,   563,     0,   564,   565,   566,     0,     0,   567,
     568,  1299,   570,  1300,     0,   572,   573,   574,   575,   576,
     577,   578,   579,     0,     0,   580,   581,   582,   583,   584,
    1303,     0,   585,   586,   587,   588,   589,   590,   591,     0,
     592,   593,   594,   595,   596,   597,     0,     0,   598,     0,
       0,   599,   600,   601,   602,   603,   604,   605,  1305,  1306,
    1307,  1308,   610,  1309,  1310,  1311,  1312,   615,   616,   617,
     618,     0,     0,     0,     0,   235,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  4681,   236,   237,   238,   239,   240,   241,   242,   243,
       0,   244,   245,   246,     0,     0,     0,     0,     0,     0,
       0,   247,   248,   249,     0,   250,   251,   252,   253,   254,
     255,   256,   257,   258,   259,   260,   261,   262,     0,   263,
     264,   265,   266,   267,   268,   269,     0,  1255,   270,   271,
     272,   273,   274,     0,   275,   276,   277,   278,  1258,     0,
    1259,     0,   281,   282,   283,   284,   285,   286,   287,   288,
     289,   290,     0,   291,   292,   293,   294,   295,   296,     0,
     297,   298,   299,   300,  1260,  1261,  1262,  1263,  1264,  1265,
    1266,   302,   303,   304,   305,   306,   307,   308,   309,   310,
       0,   311,     0,   312,   313,   314,   315,   316,   317,   318,
       0,   319,   320,   321,   322,     0,     0,   323,   324,   325,
     326,   327,     0,   328,   329,   330,     0,   331,   332,   333,
       0,   334,   335,   336,   337,   338,   339,   340,   341,   342,
    1271,     0,   344,     0,   345,   346,   347,   348,   349,     0,
     350,     0,   351,   352,     0,   353,   354,   355,   356,   357,
       0,   358,  1274,     0,   360,   361,   362,     0,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,     0,   373,
     374,   375,   376,   377,   378,   379,     0,   380,   381,   382,
     383,   384,   385,   386,   387,   388,     0,   389,     0,   390,
     391,   392,   393,   394,   395,   396,   397,   398,   399,     0,
       0,   400,  1279,   402,   403,   404,     0,   405,   406,   407,
    1280,  1281,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,  1284,   438,     0,   439,   440,   441,   442,     0,  1287,
     444,   445,   446,   447,   448,     0,   449,   450,     0,     0,
     451,   452,   453,     0,     0,   454,   455,   456,   457,   458,
     459,  1290,   461,   462,   463,   464,   465,   466,   467,   468,
     469,   470,     0,     0,   471,   472,  1291,   474,   475,   476,
     477,   478,     0,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,   492,   493,     0,   494,
     495,   496,   497,   498,   499,   500,   501,   502,   503,   504,
     505,   506,     0,   507,   508,   509,   510,   511,   512,   513,
     514,   515,   516,   517,   518,   519,   520,   521,   522,   523,
     524,     0,   525,   526,   527,   528,   529,  1294,   530,   531,
     532,   533,   534,   535,   536,   537,   538,   539,     0,   540,
     541,   542,   543,   544,   545,   546,   547,   548,   549,   550,
     551,   552,  1296,   554,     0,   555,   556,     0,   557,   558,
     559,   560,   561,   562,   563,     0,   564,   565,   566,     0,
       0,   567,   568,  1299,   570,  1300,     0,   572,   573,   574,
     575,   576,   577,   578,   579,     0,     0,   580,   581,   582,
     583,   584,  1303,     0,   585,   586,   587,   588,   589,   590,
     591,     0,   592,   593,   594,   595,   596,   597,     0,     0,
     598,     0,     0,   599,   600,   601,   602,   603,   604,   605,
    1305,  1306,  1307,  1308,   610,  1309,  1310,  1311,  1312,   615,
     616,   617,   618,     0,     0,     0,     0,   942,     0,  1564,
     685,     0,     0,     0,     0,   746,     0,     0,     0,     0,
       0,     0,     0,  5802,   236,   237,   238,   239,   240,   241,
     242,   243,     0,   244,   245,   246,     0,     0,     0,     0,
       0,     0,     0,   247,   248,   249,     0,   250,   251,   252,
     253,   254,   255,   256,   257,   258,   259,   260,   261,   262,
       0,   263,   264,   265,   266,   267,   268,   269,     0,     0,
     270,   271,   272,   273,   274,     0,   275,   276,   277,   278,
     279,     0,   280,     0,   281,   282,   283,   284,   285,   286,
     287,   288,   289,   290,     0,   291,   292,   293,   294,   295,
     296,     0,   297,   298,   299,   300,     0,     0,     0,   301,
       0,     0,     0,   302,   303,   304,   305,   306,   307,   308,
     309,   310,     0,   311,     0,   312,   313,   314,   315,   316,
     317,   318,     0,   319,   320,   321,   322,     0,     0,   323,
     324,   325,   326,   327,     0,   328,   329,   330,     0,   331,
     332,   333,     0,   334,   335,   336,   337,   338,   339,   340,
     341,   342,   343,  1786,   344,     0,   345,   346,   347,   348,
     349,     0,   350,     0,   351,   352,     0,   353,   354,   355,
     356,   357,     0,   358,   359,     0,   360,   361,   362,     0,
     363,   364,   365,   366,   367,   368,   369,   370,   371,   372,
       0,   373,   374,   375,   376,   377,   378,   379,     0,   380,
     381,   382,   383,   384,   385,   386,   387,   388,     0,   389,
       0,   390,   391,   392,   393,   394,   395,   396,   397,   398,
     399,     0,     0,   400,   401,   402,   403,   404,     0,   405,
     406,   407,     0,     0,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   431,   432,   433,
     434,   435,   436,   437,   438,     0,   439,   440,   441,   442,
       0,   443,   444,   445,   446,   447,   448,     0,   449,   450,
    1787,     0,   451,   452,   453,     0,     0,   454,   455,   456,
     457,   458,   459,   460,   461,   462,   463,   464,   465,   466,
     467,   468,   469,   470,     0,     0,   471,   472,   473,   474,
     475,   476,   477,   478,     0,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   490,   491,   492,   493,
       0,   494,   495,   496,   497,   498,   499,   500,   501,   502,
     503,   504,   505,   506,     0,   507,   508,   509,   510,   511,
     512,   513,   514,   515,   516,   517,   518,   519,   520,   521,
     522,   523,   524,     0,   525,   526,   527,   528,   529,     0,
     530,   531,   532,   533,   534,   535,   536,   537,   538,   539,
       0,   540,   541,   542,   543,   544,   545,   546,   547,   548,
     549,   550,   551,   552,   553,   554,     0,   555,   556,     0,
     557,   558,   559,   560,   561,   562,   563,     0,   564,   565,
     566,     0,     0,   567,   568,   569,   570,   571,  1788,   572,
     573,   574,   575,   576,   577,   578,   579,     0,     0,   580,
     581,   582,   583,   584,     0,     0,   585,   586,   587,   588,
     589,   590,   591,     0,   592,   593,   594,   595,   596,   597,
       0,     0,   598,     0,     0,   599,   600,   601,   602,   603,
     604,   605,   606,   607,   608,   609,   610,   611,   612,   613,
     614,   615,   616,   617,   618,     0,     0,     0,     0,   942,
       0,     0,     0,     0,     0,     0,  1565,  1566,  5612,     0,
       0,     0,     0,     0,     0,  5613,   236,   237,   238,   239,
     240,   241,   242,   243,     0,   244,   245,   246,     3,     4,
       0,     0,     0,     0,     0,   247,   248,   249,     0,   250,
     251,   252,   253,   254,   255,   256,   257,   258,   259,   260,
     261,   262,     0,   263,   264,   265,   266,   267,   268,   269,
       0,     0,   270,   271,   272,   273,   274,     0,   275,   276,
     277,   278,   279,     0,   280,     0,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,     0,   291,   292,   293,
     294,   295,   296,     0,   297,   298,   299,   300,     0,     0,
       0,   301,     0,     0,     0,   302,   303,   304,   305,   306,
     307,   308,   309,   310,     0,   311,     0,   312,   313,   314,
     315,   316,   317,   318,     0,   319,   320,   321,   322,     0,
       0,   323,   324,   325,   326,   327,     0,   328,   329,   330,
       0,   331,   332,   333,     0,   334,   335,   336,   337,   338,
     339,   340,   341,   342,   343,     0,   344,     0,   345,   346,
     347,   348,   349,     0,   350,     0,   351,   352,     0,   353,
     354,   355,   356,   357,     0,   358,   359,     0,   360,   361,
     362,     0,   363,   364,   365,   366,   367,   368,   369,   370,
     371,   372,     0,   373,   374,   375,   376,   377,   378,   379,
       0,   380,   381,   382,   383,   384,   385,   386,   387,   388,
       0,   389,     0,   390,   391,   392,   393,   394,   395,   396,
     397,   398,   399,     0,     0,   400,   401,   402,   403,   404,
       0,   405,   406,   407,     0,     0,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,   427,   428,   429,   430,   431,
     432,   433,   434,   435,   436,   437,   438,     0,   439,   440,
     441,   442,     0,   443,   444,   445,   446,   447,   448,     0,
     449,   450,     0,     0,   451,   452,   453,     0,     0,   454,
     455,   456,   457,   458,   459,   460,   461,   462,   463,   464,
     465,   466,   467,   468,   469,   470,     0,     0,   471,   472,
     473,   474,   475,   476,   477,   478,     0,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,   490,   491,
     492,   493,     0,   494,   495,   496,   497,   498,   499,   500,
     501,   502,   503,   504,   505,   506,     0,   507,   508,   509,
     510,   511,   512,   513,   514,   515,   516,   517,   518,   519,
     520,   521,   522,   523,   524,    41,   525,   526,   527,   528,
     529,     0,   530,   531,   532,   533,   534,   535,   536,   537,
     538,   539,     0,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,   551,   552,   553,   554,     0,   555,
     556,    45,   557,   558,   559,   560,   561,   562,   563,     0,
     564,   565,   566,     0,     0,   567,   568,   569,   570,   571,
       0,   572,   573,   574,   575,   576,   577,   578,   579,     0,
       0,   580,   581,   582,   583,   584,     0,     0,   585,   586,
     587,   588,   589,  1179,   591,     0,   592,   593,   594,   595,
     596,   597,     0,     0,   598,     0,    50,   599,   600,   601,
     602,   603,   604,   605,   606,   607,   608,   609,   610,   611,
     612,   613,   614,   615,   616,   617,   618,     0,     0,    51,
       0,   235,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    57,   236,   237,
     238,   239,   240,   241,   242,   243,     0,   244,   245,   246,
       0,     0,     0,     0,     0,     0,     0,   247,   248,   249,
       0,   250,   251,   252,   253,   254,   255,   256,   257,   258,
     259,   260,   261,   262,     0,   263,   264,   265,   266,   267,
     268,   269,     0,     0,   270,   271,   272,   273,   274,     0,
     275,   276,   277,   278,   279,     0,   280,     0,   281,   282,
     283,   284,   285,   286,   287,   288,   289,   290,     0,   291,
     292,   293,   294,   295,   296,     0,   297,   298,   299,   300,
       0,     0,     0,   301,     0,     0,     0,   302,   303,   304,
     305,   306,   307,   308,   309,   310,     0,   311,     0,   312,
     313,   314,   315,   316,   317,   318,     0,   319,   320,   321,
     322,     0,     0,   323,   324,   325,   326,   327,     0,   328,
     329,   330,     0,   331,   332,   333,     0,   334,   335,   336,
     337,   338,   339,   340,   341,   342,   343,     0,   344,     0,
     345,   346,   347,   348,   349,     0,   350,     0,   351,   352,
       0,   353,   354,   355,   356,   357,     0,   358,   359,     0,
     360,   361,   362,     0,   363,   364,   365,   366,   367,   368,
     369,   370,   371,   372,     0,   373,   374,   375,   376,   377,
     378,   379,     0,   380,   381,   382,   383,   384,   385,   386,
     387,   388,     0,   389,     0,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,     0,     0,   400,   401,   402,
     403,   404,     0,   405,   406,   407,     0,     0,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,   432,   433,   434,   435,   436,   437,   438,     0,
     439,   440,   441,   442,     0,   443,   444,   445,   446,   447,
     448,     0,   449,   450,     0,     0,   451,   452,   453,     0,
       0,   454,   455,   456,   457,   458,   459,   460,   461,   462,
     463,   464,   465,   466,   467,   468,   469,   470,     0,     0,
     471,   472,   473,   474,   475,   476,   477,   478,     0,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,   493,     0,   494,   495,   496,   497,   498,
     499,   500,   501,   502,   503,   504,   505,   506,     0,   507,
     508,   509,   510,   511,   512,   513,   514,   515,   516,   517,
     518,   519,   520,   521,   522,   523,   524,     0,   525,   526,
     527,   528,   529,     0,   530,   531,   532,   533,   534,   535,
     536,   537,   538,   539,     0,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,   552,   553,   554,
       0,   555,   556,     0,   557,   558,   559,   560,   561,   562,
     563,     0,   564,   565,   566,     0,     0,   567,   568,   569,
     570,   571,     0,   572,   573,   574,   575,   576,   577,   578,
     579,     0,     0,   580,   581,   582,   583,   584,     0,     0,
     585,   586,   587,   588,   589,   590,   591,     0,   592,   593,
     594,   595,   596,   597,     0,     0,   598,     0,     0,   599,
     600,   601,   602,   603,   604,   605,   606,   607,   608,   609,
     610,   611,   612,   613,   614,   615,   616,   617,   618,     0,
       0,     0,     0,   626,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  5387,
     236,   237,   238,   239,   240,   241,   242,   243,  2813,   244,
     245,   246,     0,     0,     0,     0,     0,     0,     0,   247,
     248,   249,     0,   250,   251,   252,   253,     0,   255,   256,
     257,   258,   259,     0,   261,   262,     0,   263,   264,   265,
     266,   267,   268,   269,     0,     0,   270,   271,   272,   273,
     274,     0,   275,   276,   277,   278,   279,     0,     0,     0,
     281,   282,   283,   284,   285,   286,     0,   288,   289,   290,
       0,   291,   292,   293,   294,   295,   296,     0,     0,   298,
     299,   300,     0,     0,     0,  2814,     0,     0,     0,   302,
     303,   304,   305,   306,   307,   308,   309,   310,     0,   311,
       0,   312,   313,   314,   315,   316,   317,   318,     0,   319,
     320,   321,   322,     0,     0,   323,   324,   325,   326,   327,
       0,   328,   329,   330,     0,   331,   332,   333,     0,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,     0,
     344,     0,   345,   346,   347,   348,   349,     0,   350,     0,
     351,     0,     0,     0,   354,   355,   356,   357,     0,   358,
     359,     0,   360,   361,   362,     0,   363,   364,   365,   366,
     367,     0,   369,   370,   371,   372,     0,   373,   374,   375,
     376,   377,   378,   379,     0,   380,     0,   382,   383,   384,
     385,   386,   387,   388,     0,   389,     0,   390,     0,     0,
     393,     0,   395,   396,   397,   398,   399,     0,     0,   400,
     401,     0,   403,     0,     0,   405,   406,   407,     0,     0,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,     0,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
     438,     0,   439,   440,     0,   442,     0,   443,   444,   445,
     446,   447,   448,     0,   449,   450,     0,   839,   451,   452,
     453,     0,     0,   454,   455,   456,     0,   458,     0,   460,
     461,   462,   463,   464,   465,   466,   467,   468,   469,   470,
       0,     0,   471,   472,   473,   474,   475,   476,   477,   478,
       0,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,   490,   491,   492,   493,     0,   494,   495,   496,
     497,   498,   499,   500,   501,   502,   503,   504,   505,   506,
       0,   507,   508,     0,   510,   511,   512,   513,   514,   515,
     516,   517,   518,   519,   520,   521,   522,   523,   524,     0,
     525,   526,   527,   528,   529,     0,   530,   531,   532,   533,
     534,     0,   536,   537,   538,   539,     0,   540,   541,   542,
     543,   544,   545,   546,   547,   548,   549,   550,   551,   552,
     553,   554,     0,   555,   556,  2815,   557,     0,   559,   560,
     561,   562,   563,     0,   564,   565,   566,     0,     0,   567,
     568,   569,   570,   571,     0,   572,   573,   574,   575,   576,
     577,   578,   579,     0,     0,   580,   581,   582,   583,   584,
       0,     0,   585,   586,   587,   588,   589,   590,   591,     0,
     592,     0,   594,   595,   596,   597,     0,     0,   598,     0,
       0,   599,   600,   601,   602,   603,   604,   605,   606,   607,
     608,   609,   610,   611,   612,   613,   614,   615,   616,   617,
     618,     0,     0,     0,     0,   626,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1820,   236,   237,   238,   239,   240,   241,   242,   243,
       0,   244,   245,   246,     0,     0,     0,     0,     0,     0,
       0,   247,   248,   249,     0,   250,   251,   252,   253,     0,
     255,   256,   257,   258,   259,     0,   261,   262,     0,   263,
     264,   265,   266,   267,   268,   269,     0,     0,   270,   271,
     272,   273,   274,     0,   275,   276,   277,   278,   279,     0,
       0,     0,   281,   282,   283,   284,   285,   286,     0,   288,
     289,   290,     0,   291,   292,   293,   294,   295,   296,     0,
       0,   298,   299,   300,     0,     0,     0,     0,     0,     0,
       0,   302,   303,   304,   305,   306,   307,   308,   309,   310,
       0,   311,     0,   312,   313,   314,   315,   316,   317,   318,
       0,   319,   320,   321,   322,     0,     0,   323,   324,   325,
     326,   327,     0,   328,   329,   330,     0,   331,   332,   333,
       0,   334,   335,   336,   337,   338,   339,   340,   341,   342,
     343,     0,   344,     0,   345,   346,   347,   348,   349,     0,
     350,     0,   351,     0,     0,     0,   354,   355,   356,   357,
       0,   358,   359,     0,   360,   361,   362,     0,   363,   364,
     365,   366,   367,     0,   369,   370,   371,   372,     0,   373,
     374,   375,   376,   377,   378,   379,     0,   380,     0,   382,
     383,   384,   385,   386,   387,   388,     0,   389,     0,   390,
       0,     0,   393,     0,   395,   396,   397,   398,   399,     0,
       0,   400,   401,     0,   403,     0,     0,   405,   406,   407,
       0,     0,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,     0,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438,     0,   439,   440,     0,   442,     0,   443,
     444,   445,   446,   447,   448,     0,   449,   450,     0,     0,
     451,   452,   453,     0,     0,   454,   455,   456,     0,   458,
       0,   460,   461,   462,   463,   464,   465,   466,   467,   468,
     469,   470,     0,     0,   471,   472,   473,   474,   475,   476,
     477,   478,     0,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,   492,   493,     0,   494,
     495,   496,   497,   498,   499,   500,   501,   502,   503,   504,
     505,   506,     0,   507,   508,     0,   510,   511,   512,   513,
     514,   515,   516,   517,   518,   519,   520,   521,   522,   523,
     524,    41,   525,   526,   527,   528,   529,     0,   530,   531,
     532,   533,   534,     0,   536,   537,   538,   539,     0,   540,
     541,   542,   543,   544,   545,   546,   547,   548,   549,   550,
     551,   552,   553,   554,     0,   555,   556,    45,   557,     0,
     559,   560,   561,   562,   563,     0,   564,   565,   566,     0,
       0,   567,   568,   569,   570,   571,     0,   572,   573,   574,
     575,   576,   577,   578,   579,     0,     0,   580,   581,   582,
     583,   584,     0,     0,   585,   586,   587,   588,   589,  1179,
     591,     0,   592,     0,   594,   595,   596,   597,     0,     0,
     598,     0,    50,   599,   600,   601,   602,   603,   604,   605,
     606,   607,   608,   609,   610,   611,   612,   613,   614,   615,
     616,   617,   618,     0,     0,    51,     0,   626,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    57,   236,   237,   238,   239,   240,   241,
     242,   243,     0,   244,   245,   246,     0,     0,     0,     0,
       0,     0,     0,   247,   248,   249,     0,   250,   251,   252,
     253,     0,   255,   256,   257,   258,   259,     0,   261,   262,
       0,   263,   264,   265,   266,   267,   268,   269,     0,     0,
     270,   271,   272,   273,   274,     0,   275,   276,   277,   278,
     279,     0,     0,     0,   281,   282,   283,   284,   285,   286,
       0,   288,   289,   290,     0,   291,   292,   293,   294,   295,
     296,     0,     0,   298,   299,   300,     0,     0,     0,     0,
       0,     0,     0,   302,   303,   304,   305,   306,   307,   308,
     309,   310,     0,   311,     0,   312,   313,   314,   315,   316,
     317,   318,     0,   319,   320,   321,   322,     0,     0,   323,
     324,   325,   326,   327,     0,   328,   329,   330,     0,   331,
     332,   333,     0,   334,   335,   336,   337,   338,   339,   340,
     341,   342,   343,     0,   344,     0,   345,   346,   347,   348,
     349,     0,   350,     0,   351,     0,     0,     0,   354,   355,
     356,   357,     0,   358,   359,     0,   360,   361,   362,     0,
     363,   364,   365,   366,   367,     0,   369,   370,   371,   372,
       0,   373,   374,   375,   376,   377,   378,   379,     0,   380,
       0,   382,   383,   384,   385,   386,   387,   388,     0,   389,
       0,   390,     0,     0,   393,     0,   395,   396,   397,   398,
     399,     0,     0,   400,   401,     0,   403,     0,     0,   405,
     406,   407,     0,     0,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,     0,   428,   429,   430,   431,   432,   433,
     434,   435,   436,   437,   438,     0,   439,   440,     0,   442,
       0,   443,   444,   445,   446,   447,   448,     0,   449,   450,
       0,     0,   451,   452,   453,     0,     0,   454,   455,   456,
       0,   458,     0,   460,   461,   462,   463,   464,   465,   466,
     467,   468,   469,   470,     0,     0,   471,   472,   473,   474,
     475,   476,   477,   478,     0,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   490,   491,   492,   493,
       0,   494,   495,   496,   497,   498,   499,   500,   501,   502,
     503,   504,   505,   506,     0,   507,   508,     0,   510,   511,
     512,   513,   514,   515,   516,   517,   518,   519,   520,   521,
     522,   523,   524,     0,   525,   526,   527,   528,   529,     0,
     530,   531,   532,   533,   534,     0,   536,   537,   538,   539,
       0,   540,   541,   542,   543,   544,   545,   546,   547,   548,
     549,   550,   551,   552,   553,   554,     0,   555,   556,     0,
     557,     0,   559,   560,   561,   562,   563,     0,   564,   565,
     566,     0,     0,   567,   568,   569,   570,   571,     0,   572,
     573,   574,   575,   576,   577,   578,   579,     0,     0,   580,
     581,   582,   583,   584,     0,     0,   585,   586,   587,   588,
     589,   590,   591,     0,   592,     0,   594,   595,   596,   597,
       0,     0,   598,     0,     0,   599,   600,   601,   602,   603,
     604,   605,   606,   607,   608,   609,   610,   611,   612,   613,
     614,   615,   616,   617,   618,     0,     0,     0,     0,   626,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1375,   236,   237,   238,   239,
     240,   241,   242,   243,     0,   244,   245,   246,     0,     0,
       0,     0,     0,     0,     0,   247,   248,   249,     0,   250,
     251,   252,   253,     0,   255,   256,   257,   258,   259,     0,
     261,   262,     0,   263,   264,   265,   266,   267,   268,   269,
       0,     0,   270,   271,   272,   273,   274,     0,   275,   276,
     277,   278,   279,     0,     0,     0,   281,   282,   283,   284,
     285,   286,     0,   288,   289,   290,     0,   291,   292,   293,
     294,   295,   296,     0,     0,   298,   299,   300,     0,     0,
       0,     0,     0,     0,     0,   302,   303,   304,   305,   306,
     307,   308,   309,   310,     0,   311,     0,   312,   313,   314,
     315,   316,   317,   318,     0,   319,   320,   321,   322,     0,
       0,   323,   324,   325,   326,   327,     0,   328,   329,   330,
       0,   331,   332,   333,     0,   334,   335,   336,   337,   338,
     339,   340,   341,   342,   343,     0,   344,     0,   345,   346,
     347,   348,   349,     0,   350,     0,   351,     0,     0,     0,
     354,   355,   356,   357,     0,   358,   359,     0,   360,   361,
     362,     0,   363,   364,   365,   366,   367,     0,   369,   370,
     371,   372,     0,   373,   374,   375,   376,   377,   378,   379,
       0,   380,     0,   382,   383,   384,   385,   386,   387,   388,
       0,   389,     0,   390,     0,     0,   393,     0,   395,   396,
     397,   398,   399,     0,     0,   400,   401,     0,   403,     0,
       0,   405,   406,   407,     0,     0,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,     0,   428,   429,   430,   431,
     432,   433,   434,   435,   436,   437,   438,     0,   439,   440,
       0,   442,     0,   443,   444,   445,   446,   447,   448,     0,
     449,   450,     0,     0,   451,   452,   453,     0,     0,   454,
     455,   456,     0,   458,     0,   460,   461,   462,   463,   464,
     465,   466,   467,   468,   469,   470,     0,     0,   471,   472,
     473,   474,   475,   476,   477,   478,     0,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,   490,   491,
     492,   493,     0,   494,   495,   496,   497,   498,   499,   500,
     501,   502,   503,   504,   505,   506,     0,   507,   508,     0,
     510,   511,   512,   513,   514,   515,   516,   517,   518,   519,
     520,   521,   522,   523,   524,     0,   525,   526,   527,   528,
     529,     0,   530,   531,   532,   533,   534,     0,   536,   537,
     538,   539,     0,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,   551,   552,   553,   554,     0,   555,
     556,     0,   557,     0,   559,   560,   561,   562,   563,     0,
     564,   565,   566,     0,     0,   567,   568,   569,   570,   571,
       0,   572,   573,   574,   575,   576,   577,   578,   579,     0,
       0,   580,   581,   582,   583,   584,     0,     0,   585,   586,
     587,   588,   589,   590,   591,     0,   592,     0,   594,   595,
     596,   597,     0,     0,   598,     0,     0,   599,   600,   601,
     602,   603,   604,   605,   606,   607,   608,   609,   610,   611,
     612,   613,   614,   615,   616,   617,   618,     0,     0,     0,
       0,   626,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  3403,   236,   237,
     238,   239,   240,   241,   242,   243,     0,   244,   245,   246,
       0,     0,     0,     0,     0,     0,     0,   247,   248,   249,
       0,   250,   251,   252,   253,     0,   255,   256,   257,   258,
     259,     0,   261,   262,     0,   263,   264,   265,   266,   267,
     268,   269,     0,     0,   270,   271,   272,   273,   274,     0,
     275,   276,   277,   278,   279,     0,     0,     0,   281,   282,
     283,   284,   285,   286,     0,   288,   289,   290,     0,   291,
     292,   293,   294,   295,   296,     0,     0,   298,   299,   300,
       0,     0,     0,     0,     0,     0,     0,   302,   303,   304,
     305,   306,   307,   308,   309,   310,     0,   311,     0,   312,
     313,   314,   315,   316,   317,   318,     0,   319,   320,   321,
     322,     0,     0,   323,   324,   325,   326,   327,     0,   328,
     329,   330,     0,   331,   332,   333,     0,   334,   335,   336,
     337,   338,   339,   340,   341,   342,   343,     0,   344,     0,
     345,   346,   347,   348,   349,     0,   350,     0,   351,     0,
       0,     0,   354,   355,   356,   357,     0,   358,   359,     0,
     360,   361,   362,     0,   363,   364,   365,   366,   367,     0,
     369,   370,   371,   372,     0,   373,   374,   375,   376,   377,
     378,   379,     0,   380,     0,   382,   383,   384,   385,   386,
     387,   388,     0,   389,     0,   390,     0,     0,   393,     0,
     395,   396,   397,   398,   399,     0,     0,   400,   401,     0,
     403,     0,     0,   405,   406,   407,     0,     0,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,     0,   428,   429,
     430,   431,   432,   433,   434,   435,   436,   437,   438,     0,
     439,   440,     0,   442,     0,   443,   444,   445,   446,   447,
     448,     0,   449,   450,     0,     0,   451,   452,   453,     0,
       0,   454,   455,   456,     0,   458,     0,   460,   461,   462,
     463,   464,   465,   466,   467,   468,   469,   470,     0,     0,
     471,   472,   473,   474,   475,   476,   477,   478,     0,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,   493,     0,   494,   495,   496,   497,   498,
     499,   500,   501,   502,   503,   504,   505,   506,     0,   507,
     508,     0,   510,   511,   512,   513,   514,   515,   516,   517,
     518,   519,   520,   521,   522,   523,   524,     0,   525,   526,
     527,   528,   529,     0,   530,   531,   532,   533,   534,     0,
     536,   537,   538,   539,     0,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,   552,   553,   554,
       0,   555,   556,     0,   557,     0,   559,   560,   561,   562,
     563,     0,   564,   565,   566,     0,     0,   567,   568,   569,
     570,   571,     0,   572,   573,   574,   575,   576,   577,   578,
     579,     0,     0,   580,   581,   582,   583,   584,     0,     0,
     585,   586,   587,   588,   589,   590,   591,     0,   592,     0,
     594,   595,   596,   597,     0,     0,   598,     0,     0,   599,
     600,   601,   602,   603,   604,   605,   606,   607,   608,   609,
     610,   611,   612,   613,   614,   615,   616,   617,   618,     0,
       0,     0,     0,   626,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  4597,
     236,   237,   238,   239,   240,   241,   242,   243,     0,   244,
     245,   246,     0,     0,     0,     0,     0,     0,     0,   247,
     248,   249,     0,   250,   251,   252,   253,     0,   255,   256,
     257,   258,   259,     0,   261,   262,     0,   263,   264,   265,
     266,   267,   268,   269,     0,     0,   270,   271,   272,   273,
     274,     0,   275,   276,   277,   278,   279,     0,     0,     0,
     281,   282,   283,   284,   285,   286,     0,   288,   289,   290,
       0,   291,   292,   293,   294,   295,   296,     0,     0,   298,
     299,   300,     0,     0,     0,     0,     0,     0,     0,   302,
     303,   304,   305,   306,   307,   308,   309,   310,     0,   311,
       0,   312,   313,   314,   315,   316,   317,   318,     0,   319,
     320,   321,   322,     0,     0,   323,   324,   325,   326,   327,
       0,   328,   329,   330,     0,   331,   332,   333,     0,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,     0,
     344,     0,   345,   346,   347,   348,   349,     0,   350,     0,
     351,     0,     0,     0,   354,   355,   356,   357,     0,   358,
     359,     0,   360,   361,   362,     0,   363,   364,   365,   366,
     367,     0,   369,   370,   371,   372,     0,   373,   374,   375,
     376,   377,   378,   379,     0,   380,     0,   382,   383,   384,
     385,   386,   387,   388,     0,   389,     0,   390,     0,     0,
     393,     0,   395,   396,   397,   398,   399,     0,     0,   400,
     401,     0,   403,     0,     0,   405,   406,   407,     0,     0,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,     0,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
     438,     0,   439,   440,     0,   442,     0,   443,   444,   445,
     446,   447,   448,     0,   449,   450,     0,     0,   451,   452,
     453,     0,     0,   454,   455,   456,     0,   458,     0,   460,
     461,   462,   463,   464,   465,   466,   467,   468,   469,   470,
       0,     0,   471,   472,   473,   474,   475,   476,   477,   478,
       0,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,   490,   491,   492,   493,     0,   494,   495,   496,
     497,   498,   499,   500,   501,   502,   503,   504,   505,   506,
       0,   507,   508,     0,   510,   511,   512,   513,   514,   515,
     516,   517,   518,   519,   520,   521,   522,   523,   524,     0,
     525,   526,   527,   528,   529,     0,   530,   531,   532,   533,
     534,     0,   536,   537,   538,   539,     0,   540,   541,   542,
     543,   544,   545,   546,   547,   548,   549,   550,   551,   552,
     553,   554,     0,   555,   556,     0,   557,     0,   559,   560,
     561,   562,   563,     0,   564,   565,   566,     0,     0,   567,
     568,   569,   570,   571,     0,   572,   573,   574,   575,   576,
     577,   578,   579,     0,     0,   580,   581,   582,   583,   584,
       0,     0,   585,   586,   587,   588,   589,   590,   591,     0,
     592,     0,   594,   595,   596,   597,     0,     0,   598,     0,
       0,   599,   600,   601,   602,   603,   604,   605,   606,   607,
     608,   609,   610,   611,   612,   613,   614,   615,   616,   617,
     618,     0,     0,     0,     0,     0,     0,     0,   856,     0,
    1564,   685,     0,     0,     0,   957,   746,     0,     0,     0,
       0,  4637,   958,   959,   960,   236,   237,   238,   239,   240,
     241,   242,   243,  1699,   244,   245,   246,  1700,  1701,  1702,
    1703,  1704,  1705,  1706,   247,   248,   249,  1707,   250,   251,
     252,   253,   254,   255,   256,   257,     0,   857,   260,   858,
     859,  1708,   263,   264,   265,   266,   267,   268,   269,  1709,
    1710,   270,   271,   860,   861,   274,  1711,   275,   276,   277,
     278,     0,  1712,   280,  1713,   281,   282,   283,   284,   285,
     286,   287,   288,   289,   290,  1714,   291,   292,   293,   294,
     295,   296,  1715,   297,   298,   299,   300,  1716,  1717,  1718,
     301,  1719,  1720,  1721,   302,   303,   304,   305,   306,   307,
     862,   863,   310,  1722,   311,  1723,   312,   313,   314,   315,
     316,   317,   318,  1724,   319,   320,   321,   322,  1725,  1726,
     323,   324,   864,   326,   327,  1727,   328,   329,   330,  1728,
     331,   332,   333,  1729,   334,   335,   336,   337,     0,   339,
     340,   341,   342,     0,  1730,   344,  1731,   345,   346,   347,
     865,   349,  1732,   350,  1733,   351,   352,  1734,   353,   354,
     355,   356,   357,  1735,   358,     0,  1736,     0,   361,   362,
    1737,   363,   364,   365,   366,   367,   368,   369,   370,   371,
     372,  1738,   373,   374,   375,   376,   377,   378,   379,  1739,
     380,   381,     0,   383,   384,   385,   386,   866,   867,  1740,
     868,  1741,   390,   391,   392,   393,   394,   395,   396,   397,
     398,   399,  1742,  1743,   400,     0,   402,   403,   404,  1744,
     405,   406,   407,  1745,  1746,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,   418,   419,   420,   421,   422,
     423,   424,   425,   869,   427,   870,   429,   430,   431,   432,
     433,   434,   435,  4348,     0,   438,  1747,   439,   440,   441,
     442,  1748,     0,   444,   871,   446,   447,   448,  1749,   449,
     450,  1750,  1751,  4349,   452,   453,  1752,  1753,   454,   455,
       0,   457,   458,   459,     0,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,     0,  1754,   471,   472,     0,
     474,     0,   476,   477,   478,  1755,   479,   480,   481,   482,
     483,   484,   485,   486,   487,   488,   872,   490,   491,   492,
     493,  1756,   494,   495,   496,   497,   498,   499,   500,   501,
     502,   503,   504,   505,   506,  1757,   507,   508,   509,   510,
     511,   512,   513,   514,     0,   516,   517,   518,   519,   520,
     521,   522,   523,   524,  1758,   525,   526,   527,   528,   529,
    1759,   530,   531,  2643,   533,   534,   535,   536,   537,   874,
     539,  1760,   540,   541,   542,   543,   544,   545,   546,   547,
     548,   549,   550,   551,   552,     0,   554,  1761,   555,   556,
    1762,   557,   558,   559,   560,   561,   562,   563,  1763,   564,
     875,   876,  1764,  1765,   567,   568,     0,   570,     0,  1766,
     572,   573,   574,   575,   576,   577,   578,   579,  1767,  1768,
     580,   581,   582,   583,   584,  1769,  1770,   585,   586,   587,
     588,   589,     0,   877,  1771,   592,   593,   594,   595,   596,
     597,  1772,  1773,   598,  1774,  1775,   599,   600,   601,   602,
     603,   604,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   616,   617,   618,     0,     0,     0,     0,
       0,     0,     0,     0,   963,   964,   965,  4350,  4351,   968,
     969,   970,   971,   856,     0,  1564,   685,     0,     0,     0,
     957,   746,     0,     0,     0,     0,     0,   958,   959,   960,
     236,   237,   238,   239,   240,   241,   242,   243,  1699,   244,
     245,   246,  1700,  1701,  1702,  1703,  1704,  1705,  1706,   247,
     248,   249,  1707,   250,   251,   252,   253,   254,   255,   256,
     257,     0,   857,   260,   858,   859,  1708,   263,   264,   265,
     266,   267,   268,   269,  1709,  1710,   270,   271,   860,   861,
     274,  1711,   275,   276,   277,   278,     0,  1712,   280,  1713,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
    1714,   291,   292,   293,   294,   295,   296,  1715,   297,   298,
     299,   300,  1716,  1717,  1718,   301,  1719,  1720,  1721,   302,
     303,   304,   305,   306,   307,   862,   863,   310,  1722,   311,
    1723,   312,   313,   314,   315,   316,   317,   318,  1724,   319,
     320,   321,   322,  1725,  1726,   323,   324,   864,   326,   327,
    1727,   328,   329,   330,  1728,   331,   332,   333,  1729,   334,
     335,   336,   337,     0,   339,   340,   341,   342,     0,  1730,
     344,  1731,   345,   346,   347,   865,   349,  1732,   350,  1733,
     351,   352,  1734,   353,   354,   355,   356,   357,  1735,   358,
       0,  1736,     0,   361,   362,  1737,   363,   364,   365,   366,
     367,   368,   369,   370,   371,   372,  1738,   373,   374,   375,
     376,   377,   378,   379,  1739,   380,   381,     0,   383,   384,
     385,   386,   866,   867,  1740,   868,  1741,   390,   391,   392,
     393,   394,   395,   396,   397,   398,   399,  1742,  1743,   400,
       0,   402,   403,   404,  1744,   405,   406,   407,  1745,  1746,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   869,   427,
     870,   429,   430,   431,   432,   433,   434,   435,  4773,     0,
     438,  1747,   439,   440,   441,   442,  1748,     0,   444,   871,
     446,   447,   448,  1749,   449,   450,  1750,  1751,  4349,   452,
     453,  1752,  1753,   454,   455,     0,   457,   458,   459,     0,
     461,   462,   463,   464,   465,   466,   467,   468,   469,   470,
       0,  1754,   471,   472,     0,   474,     0,   476,   477,   478,
    1755,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   872,   490,   491,   492,   493,  1756,   494,   495,   496,
     497,   498,   499,   500,   501,   502,   503,   504,   505,   506,
    1757,   507,   508,   509,   510,   511,   512,   513,   514,     0,
     516,   517,   518,   519,   520,   521,   522,   523,   524,  1758,
     525,   526,   527,   528,   529,  1759,   530,   531,  2643,   533,
     534,   535,   536,   537,   874,   539,  1760,   540,   541,   542,
     543,   544,   545,   546,   547,   548,   549,   550,   551,   552,
       0,   554,  1761,   555,   556,  1762,   557,   558,   559,   560,
     561,   562,   563,  1763,   564,   875,   876,  1764,  1765,   567,
     568,     0,   570,     0,  1766,   572,   573,   574,   575,   576,
     577,   578,   579,  1767,  1768,   580,   581,   582,   583,   584,
    1769,  1770,   585,   586,   587,   588,   589,     0,   877,  1771,
     592,   593,   594,   595,   596,   597,  1772,  1773,   598,  1774,
    1775,   599,   600,   601,   602,   603,   604,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   616,   617,
     618,     0,     0,     0,     0,     0,     0,     0,     0,   963,
     964,   965,  4350,  4351,   968,   969,   970,   971,  2054,     0,
       0,     0,     0,     0,     0,  2055,     0,     0,  2056,     0,
       0,     0,  2057,  2058,  2059,  2060,  2061,  2062,  2063,  2064,
    2065,  2066,  2067,  2068,  2069,  2070,  2071,  2072,  2073,  2074,
    2075,     0,  2076,  2077,  2078,  2079,  2080,  2081,  2082,  2083,
    2084,  2085,  2086,  2087,  2088,  2089,  2090,  2091,  2092,  2093,
    2094,  2095,  2096,  2097,  2098,  2099,  2100,  2101,  2102,  2103,
    2104,  2105,  2106,     0,     0,  2107,  2108,  2109,  2110,  2111,
    2112,  2113,  2114,  2115,  2116,  2117,  2118,  2119,  2120,  2121,
    2122,  2123,  2124,  2125,  2126,  2127,  2128,  2129,  2130,  2131,
    2132,  2133,     0,  2134,  2135,  2136,  2137,  2138,  2139,  2140,
    2141,  2142,  2143,  2144,  2145,  2146,  2147,  2148,     0,  2149,
    2150,  2151,  2152,  2153,  2154,  2155,  2156,  2157,  2158,  2159,
    2160,  2161,  2162,  2163,  2164,  2165,  2166,  2167,  2168,  2169,
    2170,  2171,  2172,  2173,  2174,  2175,  2176,  2177,  2178,  2179,
    2180,  2181,  2182,     0,  2183,  2184,  2185,  2186,  2187,  2188,
    2189,  2190,  2191,  2192,  2193,  2194,     0,     0,  2195,  2196,
    2197,  2198,     0,  2199,  2200,  2201,  2202,     0,  2203,  2204,
    2205,  2206,  2207,     0,  2208,  2209,     0,  2210,  2211,  2212,
       0,  2213,  2214,     0,  2215,  2216,  2217,  2218,  2219,  2220,
    2221,  2222,  2223,  2224,  2225,  2226,  2227,  2228,  2229,  2230,
    2231,  2232,  2233,  2234,  2235,  2236,  2237,  2238,  2239,     0,
    2240,     0,  2241,  2242,  2243,  2244,  2245,  2246,  2247,  2248,
    2249,  2250,  2251,  2252,  2253,  2254,  2255,  2256,  2257,     0,
    2258,  2259,  2260,  2261,  2262,  2263,  2264,  2265,  2266,  2267,
    2268,  2269,  2270,  2271,  2272,  2273,     0,  2274,  2275,     0,
    2276,  2277,  2278,  2279,  2280,  2281,  2282,  2283,  2284,  2285,
    2286,  2287,  2288,  2289,  2290,  2291,  2292,  2293,  2294,  2295,
    2296,  2297,  2298,  2299,  2300,  2301,  2302,  2303,     0,  2304,
    2305,     0,  2306,  2307,  2308,  2309,  2310,     0,  2311,  2312,
    2313,  2314,     0,     0,  2315,  2316,  2317,  2318,  2319,  2320,
    2321,  2322,  2323,  2324,  2325,     0,  2326,  2327,  2328,  2329,
    2330,     0,  2331,  2332,  2333,  2334,  2335,  2336,  2337,  2338,
    2339,  2340,  2341,  2342,  2343,  2344,  2345,  2346,  2347,  2348,
    2349,  2350,  2351,  2352,  2353,  2354,  2355,  2356,  2357,  2358,
    2359,  2360,  2361,  2362,  2363,     0,  2364,  2365,  2366,  2367,
    2368,  2369,  2370,  2371,  2372,  2373,  2374,  2375,  2376,  2377,
    2378,  2379,     0,  2380,  2381,  2382,  2383,  2384,  2385,  2386,
    2387,  2388,  2389,  2390,  2391,  2392,  2393,  2394,  2395,  2396,
    2397,  2398,  2399,  2400,  2401,  2402,  2403,  2404,  2405,  2406,
    2407,  2408,  2409,  2410,  2411,  2412,  2413,  2414,  2415,  2416,
    2417,  2418,  2419,  2420,  2421,  2422,  2423,  2424,  2425,  2426,
    2427,  2428,     0,  2429,  2430,  2431,  2432,  2433,  2434,  2435,
    2436,  2437,  2438,  2439,  2440,  2441,  2442,  2443,     0,  2444,
    2445,  2446,  2447,  2448,  2449,  2450,  2451,  2452,  2453,  2454,
    2455,  2456,  2457,  2458,  2459,     0,  2460,  2461,  2462,  2463,
    2464,  2465,     0,  2466,     0,     0,     0,     0,  2467,  2468,
    2469,  2470,  2471,  2472,  2473,  2474,  2475,  2476,  2477,  2478,
    2479,  2480,  2481,     0,  2482,  2483,  2484,     0,     0,     0,
       0,     0,     0,     0,  2485,  2486,  2487,  2488,  2489,  2490,
    2491,  2492,  2493,   626,     0,     0,     0,     0,     0,     0,
     957,     0,     0,     0,     0,     0,     0,   958,   959,   960,
     236,   237,   238,   239,   240,   241,   242,   243,     0,   244,
     245,   246,     0,     0,     0,     0,     0,     0,     0,   247,
     248,   249,     0,   250,   251,   252,   253,     0,   255,   256,
     257,   258,   259,     0,   261,   262,     0,   263,   264,   265,
     266,   267,   268,   269,     0,     0,   270,   271,   272,   273,
     274,     0,   275,   961,   277,   278,   279,     0,     0,     0,
     281,   282,   283,   284,   285,   286,     0,   288,   289,   290,
       0,   291,   292,   293,   294,   295,   296,     0,     0,   298,
     299,   300,     0,     0,     0,     0,     0,     0,     0,   302,
     303,   304,   305,   306,   307,   308,   309,   310,     0,   311,
       0,   312,   313,   314,   315,   316,   317,   318,     0,   319,
     320,   321,   322,     0,     0,   323,   324,   325,   326,   327,
       0,   328,   329,   330,     0,   331,   332,   333,     0,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,     0,
     962,     0,   345,   346,   347,   348,   349,     0,   350,     0,
     351,     0,     0,     0,   354,   355,   356,   357,     0,   358,
     359,     0,   360,   361,   362,     0,   363,   364,   365,   366,
     367,     0,   369,   370,   371,   372,     0,   373,   374,   375,
     376,   377,   378,   379,     0,   380,     0,   382,   383,   384,
     385,   386,   387,   388,     0,   389,     0,   390,     0,     0,
     393,     0,   395,   396,   397,   398,   399,     0,     0,   400,
     401,     0,   403,     0,     0,   405,   406,   407,     0,     0,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,     0,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
     438,     0,   439,   440,     0,   442,     0,   443,   444,   445,
     446,   447,   448,     0,   449,   450,     0,     0,   451,   452,
     453,     0,     0,   454,   455,   456,     0,   458,     0,   460,
     461,   462,   463,   464,   465,   466,   467,   468,   469,   470,
       0,     0,   471,   472,   473,   474,   475,   476,   477,   478,
       0,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,   490,   491,   492,   493,     0,   494,   495,   496,
     497,   498,   499,   500,   501,   502,   503,   504,   505,   506,
       0,   507,   508,     0,   510,   511,   512,   513,   514,   515,
     516,   517,   518,   519,   520,   521,   522,   523,   524,     0,
     525,   526,   527,   528,   529,     0,   530,   531,   532,   533,
     534,     0,   536,   537,   538,   539,     0,   540,   541,   542,
     543,   544,   545,   546,   547,   548,   549,   550,   551,   552,
     553,   554,     0,   555,   556,     0,   557,     0,   559,   560,
     561,   562,   563,     0,   564,   565,   566,     0,     0,   567,
     568,   569,   570,   571,     0,   572,   573,   574,   575,   576,
     577,   578,   579,     0,     0,   580,   581,   582,   583,   584,
       0,     0,   585,   586,   587,   588,   589,   590,   591,     0,
     592,     0,   594,   595,   596,   597,     0,     0,   598,     0,
       0,   599,   600,   601,   602,   603,   604,   605,   606,   607,
     608,   609,   610,   611,   612,   613,   614,   615,   616,   617,
     618,     0,     0,     0,     0,     0,     0,     0,     0,   963,
     964,   965,   966,   967,   968,   969,   970,   971,   626,     0,
       0,     0,     0,     0,     0,   957,     0,     0,     0,     0,
       0,     0,   958,   959,   960,   236,   237,   238,   239,   240,
     241,   242,   243,     0,   244,   245,   246,     0,     0,     0,
       0,     0,     0,     0,   247,   248,   249,     0,   250,   251,
     252,   253,     0,   255,   256,   257,   258,   259,     0,   261,
     262,     0,   263,   264,   265,   266,   267,   268,   269,     0,
       0,   270,   271,   272,   273,   274,     0,   275,  1077,   277,
     278,   279,     0,     0,     0,   281,   282,   283,   284,   285,
     286,     0,   288,   289,   290,     0,   291,   292,   293,   294,
     295,   296,     0,     0,   298,   299,   300,     0,     0,     0,
       0,     0,     0,     0,   302,   303,   304,   305,   306,   307,
     308,   309,   310,     0,   311,     0,   312,   313,   314,   315,
     316,   317,   318,     0,   319,   320,   321,   322,     0,     0,
     323,   324,   325,   326,   327,     0,   328,   329,   330,     0,
     331,   332,   333,     0,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,     0,  1078,     0,   345,   346,   347,
     348,   349,     0,   350,     0,   351,     0,     0,     0,   354,
     355,   356,   357,     0,   358,   359,     0,   360,   361,   362,
       0,   363,   364,   365,   366,   367,     0,   369,   370,   371,
     372,     0,   373,   374,   375,   376,   377,   378,   379,     0,
     380,     0,   382,   383,   384,   385,   386,   387,   388,     0,
     389,     0,   390,     0,     0,   393,     0,   395,   396,   397,
     398,   399,     0,     0,   400,   401,     0,   403,     0,     0,
     405,   406,   407,     0,     0,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,   418,   419,   420,   421,   422,
     423,   424,   425,   426,     0,   428,   429,   430,   431,   432,
     433,   434,   435,   436,   437,   438,     0,   439,   440,     0,
     442,     0,   443,   444,   445,   446,   447,   448,     0,   449,
     450,     0,     0,   451,   452,   453,     0,     0,   454,   455,
     456,     0,   458,     0,   460,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,     0,     0,   471,   472,   473,
     474,   475,   476,   477,   478,     0,   479,   480,   481,   482,
     483,   484,   485,   486,   487,   488,   489,   490,   491,   492,
     493,     0,   494,   495,   496,   497,   498,   499,   500,   501,
     502,   503,   504,   505,   506,     0,   507,   508,     0,   510,
     511,   512,   513,   514,   515,   516,   517,   518,   519,   520,
     521,   522,   523,   524,     0,   525,   526,   527,   528,   529,
       0,   530,   531,   532,   533,   534,     0,   536,   537,   538,
     539,     0,   540,   541,   542,   543,   544,   545,   546,   547,
     548,   549,   550,   551,   552,   553,   554,     0,   555,   556,
       0,   557,     0,   559,   560,   561,   562,   563,     0,   564,
     565,   566,     0,     0,   567,   568,   569,   570,   571,     0,
     572,   573,   574,   575,   576,   577,   578,   579,     0,     0,
     580,   581,   582,   583,   584,     0,     0,   585,   586,   587,
     588,   589,   590,   591,     0,   592,     0,   594,   595,   596,
     597,     0,     0,   598,     0,     0,   599,   600,   601,   602,
     603,   604,   605,   606,   607,   608,   609,   610,   611,   612,
     613,   614,   615,   616,   617,   618,     0,     0,     0,     0,
       0,     0,     0,     0,   963,   964,   965,   966,   967,   968,
     969,   970,   971,   626,     0,     0,     0,     0,     0,     0,
     957,     0,     0,     0,     0,     0,     0,   958,   959,   960,
     236,   237,   238,   239,   240,   241,   242,   243,     0,   244,
     245,   246,     0,     0,     0,     0,     0,     0,     0,   247,
     248,   249,     0,   250,   251,   252,   253,     0,   255,   256,
     257,   258,   259,     0,   261,   262,     0,   263,   264,   265,
     266,   267,   268,   269,     0,     0,   270,   271,   272,   273,
     274,     0,   275,  1142,   277,   278,   279,     0,     0,     0,
     281,   282,   283,   284,   285,   286,     0,   288,   289,   290,
       0,   291,   292,   293,   294,   295,   296,     0,     0,   298,
     299,   300,     0,     0,     0,     0,     0,     0,     0,   302,
     303,   304,   305,   306,   307,   308,   309,   310,     0,   311,
       0,   312,   313,   314,   315,   316,   317,   318,     0,   319,
     320,   321,   322,     0,     0,   323,   324,   325,   326,   327,
       0,   328,   329,   330,     0,   331,   332,   333,     0,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,     0,
    1143,     0,   345,   346,   347,   348,   349,     0,   350,     0,
     351,     0,     0,     0,   354,   355,   356,   357,     0,   358,
     359,     0,   360,   361,   362,     0,   363,   364,   365,   366,
    1144,     0,   369,   370,   371,   372,     0,   373,   374,   375,
     376,   377,   378,   379,     0,   380,     0,   382,   383,   384,
     385,   386,   387,   388,     0,   389,     0,   390,     0,     0,
     393,     0,   395,   396,   397,   398,   399,     0,     0,   400,
     401,     0,   403,     0,     0,   405,   406,   407,     0,     0,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,     0,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
     438,     0,   439,   440,     0,   442,     0,   443,   444,   445,
     446,   447,   448,     0,   449,   450,     0,     0,   451,   452,
     453,     0,     0,   454,   455,   456,     0,   458,     0,   460,
     461,   462,   463,   464,   465,   466,   467,   468,   469,   470,
       0,     0,   471,   472,   473,   474,   475,   476,   477,   478,
       0,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,   490,   491,   492,   493,     0,   494,   495,   496,
     497,   498,   499,   500,   501,   502,   503,   504,   505,   506,
       0,   507,   508,     0,   510,   511,   512,   513,   514,   515,
     516,   517,   518,   519,   520,   521,   522,   523,   524,     0,
     525,   526,   527,   528,   529,     0,   530,   531,   532,   533,
     534,     0,   536,   537,   538,   539,     0,   540,   541,   542,
     543,   544,   545,   546,   547,   548,   549,   550,   551,   552,
     553,   554,     0,   555,   556,     0,   557,     0,   559,   560,
     561,   562,   563,     0,   564,   565,   566,     0,     0,   567,
     568,   569,   570,   571,     0,   572,   573,   574,   575,   576,
     577,   578,   579,     0,     0,   580,   581,   582,   583,   584,
       0,     0,   585,   586,   587,   588,   589,   590,   591,     0,
     592,     0,   594,   595,   596,   597,     0,     0,   598,     0,
       0,   599,   600,   601,   602,   603,   604,   605,   606,   607,
     608,   609,   610,   611,   612,   613,   614,   615,   616,   617,
     618,     0,     0,     0,     0,     0,     0,     0,     0,   963,
     964,   965,   966,   967,   968,   969,   970,   971,   626,     0,
       0,     0,     0,     0,     0,   957,     0,     0,     0,     0,
       0,     0,   958,   959,   960,   236,   237,   238,   239,   240,
     241,   242,   243,     0,   244,   245,   246,     0,     0,     0,
       0,     0,     0,     0,   247,   248,   249,     0,   250,   251,
     252,   253,     0,   255,   256,   257,   258,   259,     0,   261,
     262,     0,   263,   264,   265,   266,   267,   268,   269,     0,
       0,   270,   271,   272,   273,   274,     0,   275,  1803,   277,
     278,   279,     0,     0,     0,   281,   282,   283,   284,   285,
     286,     0,   288,   289,   290,     0,   291,   292,   293,   294,
     295,   296,     0,     0,   298,   299,   300,     0,     0,     0,
       0,     0,     0,     0,   302,   303,   304,   305,   306,   307,
     308,   309,   310,     0,   311,     0,   312,   313,   314,   315,
     316,   317,   318,     0,   319,   320,   321,   322,     0,     0,
     323,   324,   325,   326,   327,     0,   328,   329,   330,     0,
     331,   332,   333,     0,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,     0,  1804,     0,   345,   346,   347,
     348,   349,     0,   350,     0,   351,     0,     0,     0,   354,
     355,   356,   357,     0,   358,   359,     0,   360,   361,   362,
       0,   363,   364,   365,   366,   367,     0,   369,   370,   371,
     372,     0,   373,   374,   375,   376,   377,   378,   379,     0,
     380,     0,   382,   383,   384,   385,   386,   387,   388,     0,
     389,     0,   390,     0,     0,   393,     0,   395,   396,   397,
     398,   399,     0,     0,   400,   401,     0,   403,     0,     0,
     405,   406,   407,     0,     0,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,   418,   419,   420,   421,   422,
     423,   424,   425,   426,     0,   428,   429,   430,   431,   432,
     433,   434,   435,   436,   437,   438,     0,   439,   440,     0,
     442,     0,   443,   444,   445,   446,   447,   448,     0,   449,
     450,     0,     0,   451,   452,   453,     0,     0,   454,   455,
     456,     0,   458,     0,   460,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,     0,     0,   471,   472,   473,
     474,   475,   476,   477,   478,     0,   479,   480,   481,   482,
     483,   484,   485,   486,   487,   488,   489,   490,   491,   492,
     493,     0,   494,   495,   496,   497,   498,   499,   500,   501,
     502,   503,   504,   505,   506,     0,   507,   508,     0,   510,
     511,   512,   513,   514,   515,   516,   517,   518,   519,   520,
     521,   522,   523,   524,     0,   525,   526,   527,   528,   529,
       0,   530,   531,   532,   533,   534,     0,   536,   537,   538,
     539,     0,   540,   541,   542,   543,   544,   545,   546,   547,
     548,   549,   550,   551,   552,   553,   554,     0,   555,   556,
       0,   557,     0,   559,   560,   561,   562,   563,     0,   564,
     565,   566,     0,     0,   567,   568,   569,   570,   571,     0,
     572,   573,   574,   575,   576,   577,   578,   579,     0,     0,
     580,   581,   582,   583,   584,     0,     0,   585,   586,   587,
     588,   589,   590,   591,     0,   592,     0,   594,   595,   596,
     597,     0,     0,   598,     0,     0,   599,   600,   601,   602,
     603,   604,   605,   606,   607,   608,   609,   610,   611,   612,
     613,   614,   615,   616,   617,   618,     0,     0,     0,     0,
       0,     0,     0,     0,   963,   964,   965,   966,   967,   968,
     969,   970,   971,   626,     0,     0,     0,     0,     0,     0,
     957,     0,     0,     0,     0,     0,     0,   958,   959,   960,
     236,   237,   238,   239,   240,   241,   242,   243,     0,   244,
     245,   246,     0,     0,     0,     0,     0,     0,     0,   247,
     248,   249,     0,   250,   251,   252,   253,     0,   255,   256,
     257,   258,   259,     0,   261,   262,     0,   263,   264,   265,
     266,   267,   268,   269,     0,     0,   270,   271,   272,   273,
     274,     0,   275,   276,   277,   278,   279,     0,     0,     0,
     281,   282,   283,   284,   285,   286,     0,   288,   289,   290,
       0,   291,   292,   293,   294,   295,   296,     0,     0,   298,
     299,   300,     0,     0,     0,     0,     0,     0,     0,   302,
     303,   304,   305,   306,   307,   308,   309,   310,     0,   311,
       0,   312,   313,   314,   315,   316,   317,   318,     0,   319,
     320,   321,   322,     0,     0,   323,   324,   325,   326,   327,
       0,   328,   329,   330,     0,   331,   332,   333,     0,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,     0,
     344,     0,   345,   346,   347,   348,   349,     0,   350,     0,
     351,     0,     0,     0,   354,   355,   356,   357,     0,   358,
     359,     0,   360,   361,   362,     0,   363,   364,   365,   366,
     367,     0,   369,   370,   371,   372,     0,   373,   374,   375,
     376,   377,   378,   379,     0,   380,     0,   382,   383,   384,
     385,   386,   387,   388,     0,   389,     0,   390,     0,     0,
     393,     0,   395,   396,   397,   398,   399,     0,     0,   400,
     401,     0,   403,     0,     0,   405,   406,   407,     0,     0,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,     0,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
     438,     0,   439,   440,     0,   442,     0,   443,   444,   445,
     446,   447,   448,     0,   449,   450,     0,     0,   451,   452,
     453,     0,     0,   454,   455,   456,     0,   458,     0,   460,
     461,   462,   463,   464,   465,   466,   467,   468,   469,   470,
       0,     0,   471,   472,   473,   474,   475,   476,   477,   478,
       0,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,   490,   491,   492,   493,     0,   494,   495,   496,
     497,   498,   499,   500,   501,   502,   503,   504,   505,   506,
       0,   507,   508,     0,   510,   511,   512,   513,   514,   515,
     516,   517,   518,   519,   520,   521,   522,   523,   524,     0,
     525,   526,   527,   528,   529,     0,   530,   531,   532,   533,
     534,     0,   536,   537,   538,   539,     0,   540,   541,   542,
     543,   544,   545,   546,   547,   548,   549,   550,   551,   552,
     553,   554,     0,   555,   556,     0,   557,     0,   559,   560,
     561,   562,   563,     0,   564,   565,   566,     0,     0,   567,
     568,   569,   570,   571,     0,   572,   573,   574,   575,   576,
     577,   578,   579,     0,     0,   580,   581,   582,   583,   584,
       0,     0,   585,   586,   587,   588,   589,   590,   591,     0,
     592,     0,   594,   595,   596,   597,     0,     0,   598,     0,
       0,   599,   600,   601,   602,   603,   604,   605,   606,   607,
     608,   609,   610,   611,   612,   613,   614,   615,   616,   617,
     618,     0,     0,     0,     0,     0,     0,     0,     0,   963,
     964,   965,   966,   967,   968,   969,   970,   971,   626,     0,
       0,     0,     0,     0,     0,   957,     0,     0,     0,     0,
       0,     0,   958,   959,   960,   236,   237,   238,   239,   240,
     241,   242,   243,     0,   244,   245,   246,     0,     0,     0,
       0,     0,     0,     0,   247,   248,   249,     0,   250,   251,
     252,   253,     0,   255,   256,   257,   258,   259,     0,   261,
     262,     0,   263,   264,   265,   266,   267,   268,   269,     0,
       0,   270,   271,   272,   273,   274,     0,   275,  3474,   277,
     278,   279,     0,     0,     0,   281,   282,   283,   284,   285,
     286,     0,   288,   289,   290,     0,   291,   292,   293,   294,
     295,   296,     0,     0,   298,   299,   300,     0,     0,     0,
       0,     0,     0,     0,   302,   303,   304,   305,   306,   307,
     308,   309,   310,     0,   311,     0,   312,   313,   314,   315,
     316,   317,   318,     0,   319,   320,   321,   322,     0,     0,
     323,   324,   325,   326,   327,     0,   328,   329,   330,     0,
     331,   332,   333,     0,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,     0,  3475,     0,   345,   346,   347,
     348,   349,     0,   350,     0,   351,     0,     0,     0,   354,
     355,   356,   357,     0,   358,   359,     0,   360,   361,   362,
       0,   363,   364,   365,   366,   367,     0,   369,   370,   371,
     372,     0,   373,   374,   375,   376,   377,   378,   379,     0,
     380,     0,   382,   383,   384,   385,   386,   387,   388,     0,
     389,     0,   390,     0,     0,   393,     0,   395,   396,   397,
     398,   399,     0,     0,   400,   401,     0,   403,     0,     0,
     405,   406,   407,     0,     0,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,   418,   419,   420,   421,   422,
     423,   424,   425,   426,     0,   428,   429,   430,   431,   432,
     433,   434,   435,   436,   437,   438,     0,   439,   440,     0,
     442,     0,   443,   444,   445,   446,   447,   448,     0,   449,
     450,     0,     0,   451,   452,   453,     0,     0,   454,   455,
     456,     0,   458,     0,   460,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,     0,     0,   471,   472,   473,
     474,   475,   476,   477,   478,     0,   479,   480,   481,   482,
     483,   484,   485,   486,   487,   488,   489,   490,   491,   492,
     493,     0,   494,   495,   496,   497,   498,   499,   500,   501,
     502,   503,   504,   505,   506,     0,   507,   508,     0,   510,
     511,   512,   513,   514,   515,   516,   517,   518,   519,   520,
     521,   522,   523,   524,     0,   525,   526,   527,   528,   529,
       0,   530,   531,   532,   533,   534,     0,   536,   537,   538,
     539,     0,   540,   541,   542,   543,   544,   545,   546,   547,
     548,   549,   550,   551,   552,   553,   554,     0,   555,   556,
       0,   557,     0,   559,   560,   561,   562,   563,     0,   564,
     565,   566,     0,     0,   567,   568,   569,   570,   571,     0,
     572,   573,   574,   575,   576,   577,   578,   579,     0,     0,
     580,   581,   582,   583,   584,     0,     0,   585,   586,   587,
     588,   589,   590,   591,     0,   592,     0,   594,   595,   596,
     597,     0,     0,   598,     0,     0,   599,   600,   601,   602,
     603,   604,   605,   606,   607,   608,   609,   610,   611,   612,
     613,   614,   615,   616,   617,   618,     0,     0,     0,     0,
       0,     0,     0,     0,   963,   964,   965,   966,   967,   968,
     969,   970,   971,   626,     0,     0,     0,     0,     0,     0,
     957,     0,     0,     0,     0,     0,     0,   958,   959,   960,
     236,   237,   238,   239,   240,   241,   242,   243,     0,   244,
     245,   246,     0,     0,     0,     0,     0,     0,     0,   247,
     248,   249,     0,   250,   251,   252,   253,     0,   255,   256,
     257,   258,   259,     0,   261,   262,     0,   263,   264,   265,
     266,   267,   268,   269,     0,     0,   270,   271,   272,   273,
     274,     0,   275,   276,   277,   278,   279,     0,     0,     0,
     281,   282,   283,   284,   285,   286,     0,   288,   289,   290,
       0,   291,   292,   293,   294,   295,   296,     0,     0,   298,
     299,   300,     0,     0,     0,     0,     0,     0,     0,   302,
     303,   304,   305,   306,   307,   308,   309,   310,     0,   311,
       0,   312,   313,   314,   315,   316,   317,   318,     0,   319,
     320,   321,   322,     0,     0,   323,   324,   325,   326,   327,
       0,   328,   329,   330,     0,   331,   332,   333,     0,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,     0,
     344,     0,   345,   346,   347,   348,   349,     0,   350,     0,
     351,     0,     0,     0,   354,   355,   356,   357,     0,   358,
     359,     0,   360,   361,   362,     0,   363,   364,   365,   366,
     367,     0,   369,   370,   371,   372,     0,   373,   374,   375,
     376,   377,   378,   379,     0,   380,     0,   382,   383,   384,
     385,   386,   387,   388,     0,   389,     0,   390,     0,     0,
     393,     0,   395,   396,   397,   398,   399,     0,     0,   400,
     401,     0,   403,     0,     0,   405,   406,   407,     0,     0,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,     0,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
     438,     0,   439,   440,     0,   442,     0,   443,   444,   445,
     446,   447,   448,     0,   449,   450,     0,     0,  5367,   452,
     453,     0,     0,   454,   455,   456,     0,   458,     0,   460,
     461,   462,   463,   464,   465,   466,   467,   468,   469,   470,
       0,     0,   471,   472,   473,   474,   475,   476,   477,   478,
       0,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,   490,   491,   492,   493,     0,   494,   495,   496,
     497,   498,   499,   500,   501,   502,   503,   504,   505,   506,
       0,   507,   508,     0,   510,   511,   512,   513,   514,   515,
     516,   517,   518,   519,   520,   521,   522,   523,   524,     0,
     525,   526,   527,   528,   529,     0,   530,   531,   532,   533,
     534,     0,   536,   537,   538,   539,     0,   540,   541,   542,
     543,   544,   545,   546,   547,   548,   549,   550,   551,   552,
     553,   554,     0,   555,   556,     0,   557,     0,   559,   560,
     561,   562,   563,     0,   564,   565,   566,     0,     0,   567,
     568,   569,   570,   571,     0,   572,   573,   574,   575,   576,
     577,   578,   579,     0,     0,   580,   581,   582,   583,   584,
       0,     0,   585,   586,   587,   588,   589,   590,   591,     0,
     592,     0,   594,   595,   596,   597,     0,     0,   598,     0,
       0,   599,   600,   601,   602,   603,   604,   605,   606,   607,
     608,   609,   610,   611,   612,   613,   614,   615,   616,   617,
     618,  1698,     0,     0,     0,     0,     0,     0,     0,   963,
     964,   965,   966,   967,   968,   969,   970,   971,   236,   237,
     238,   239,   240,   241,   242,   243,  1699,   244,   245,   246,
    1700,  1701,  1702,  1703,  1704,  1705,  1706,   247,   248,   249,
    1707,   250,   251,   252,   253,   254,   255,   256,   257,   258,
     259,   260,   261,   262,  1708,   263,   264,   265,   266,   267,
     268,   269,  1709,  1710,   270,   271,   272,   273,   274,  1711,
     275,   276,   277,   278,   279,  1712,   280,  1713,   281,   282,
     283,   284,   285,   286,   287,   288,   289,   290,  1714,   291,
     292,   293,   294,   295,   296,  1715,   297,   298,   299,   300,
    1716,  1717,  1718,   301,  1719,  1720,  1721,   302,   303,   304,
     305,   306,   307,   308,   309,   310,  1722,   311,  1723,   312,
     313,   314,   315,   316,   317,   318,  1724,   319,   320,   321,
     322,  1725,  1726,   323,   324,   325,   326,   327,  1727,   328,
     329,   330,  1728,   331,   332,   333,  1729,   334,   335,   336,
     337,   338,   339,   340,   341,   342,   343,  1730,   344,  1731,
     345,   346,   347,   348,   349,  1732,   350,  1733,   351,   352,
    1734,   353,   354,   355,   356,   357,  1735,   358,   359,  1736,
     360,   361,   362,  1737,   363,   364,   365,   366,   367,   368,
     369,   370,   371,   372,  1738,   373,   374,   375,   376,   377,
     378,   379,  1739,   380,   381,   382,   383,   384,   385,   386,
     387,   388,  1740,   389,  1741,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,  1742,  1743,   400,   401,   402,
     403,   404,  1744,   405,   406,   407,  1745,  1746,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,   432,   433,   434,   435,   436,   437,   438,  1747,
     439,   440,   441,   442,  1748,   443,   444,   445,   446,   447,
     448,  1749,   449,   450,  1750,  1751,   451,   452,   453,  1752,
    1753,   454,   455,   456,   457,   458,   459,   460,   461,   462,
     463,   464,   465,   466,   467,   468,   469,   470,     0,  1754,
     471,   472,   473,   474,   475,   476,   477,   478,  1755,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,   493,  1756,   494,   495,   496,   497,   498,
     499,   500,   501,   502,   503,   504,   505,   506,  1757,   507,
     508,   509,   510,   511,   512,   513,   514,   515,   516,   517,
     518,   519,   520,   521,   522,   523,   524,  1758,   525,   526,
     527,   528,   529,  1759,   530,   531,   532,   533,   534,   535,
     536,   537,   538,   539,  1760,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,   552,   553,   554,
    1761,   555,   556,  1762,   557,   558,   559,   560,   561,   562,
     563,  1763,   564,   565,   566,  1764,  1765,   567,   568,   569,
     570,   571,  1766,   572,   573,   574,   575,   576,   577,   578,
     579,  1767,  1768,   580,   581,   582,   583,   584,  1769,  1770,
     585,   586,   587,   588,   589,   590,   591,  1771,   592,   593,
     594,   595,   596,   597,  1772,  1773,   598,  1774,  1775,   599,
     600,   601,   602,   603,   604,   605,   606,   607,   608,   609,
     610,   611,   612,   613,   614,   615,   616,   617,   618,   626,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1776,     0,     0,     0,   236,   237,   238,   239,
     240,   241,   242,   243,     0,   244,   245,   246,     0,     0,
       0,     0,     0,     0,     0,   247,   248,   249,     0,   250,
     251,   252,   253,     0,   255,   256,   257,   258,   259,     0,
     261,   262,     0,   263,   264,   265,   266,   267,   268,   269,
       0,     0,   270,   271,   272,   273,   274,     0,   275,   276,
     277,   278,   279,     0,     0,     0,   281,   282,   283,   284,
     285,   286,     0,   288,   289,   290,     0,   291,   292,   293,
     294,   295,   296,     0,     0,   298,   299,   300,     0,     0,
       0,     0,     0,     0,     0,   302,   303,   304,   305,   306,
     307,   308,   309,   310,     0,   311,     0,   312,   313,   314,
     315,   316,   317,   318,     0,   319,   320,   321,   322,     0,
       0,   323,   324,   325,   326,   327,     0,   328,   329,   330,
       0,   331,   332,   333,     0,   334,   335,   336,   337,   338,
     339,   340,   341,   342,   343,     0,   344,     0,   345,   346,
     347,   348,   349,     0,   350,     0,   351,     0,     0,     0,
     354,   355,   356,   357,     0,   358,   359,     0,   360,   361,
     362,     0,   363,   364,   365,   366,   367,     0,   369,   370,
     371,   372,     0,   373,   374,   375,   376,   377,   378,   379,
       0,   380,     0,   382,   383,   384,   385,   386,   387,   388,
       0,   389,     0,   390,     0,     0,   393,     0,   395,   396,
     397,   398,   399,     0,     0,   400,   401,     0,   403,     0,
       0,   405,   406,   407,     0,     0,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,     0,   428,   429,   430,   431,
     432,   433,   434,   435,   436,   437,   438,     0,   439,   440,
       0,   442,     0,   443,   444,   445,   446,   447,   448,     0,
     449,   450,     0,     0,   451,   452,   453,     0,     0,   454,
     455,   456,     0,   458,     0,   460,   461,   462,   463,   464,
     465,   466,   467,   468,   469,   470,     0,     0,   471,   472,
     473,   474,   475,   476,   477,   478,     0,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,   490,   491,
     492,   493,     0,   494,   495,   496,   497,   498,   499,   500,
     501,   502,   503,   504,   505,   506,     0,   507,   508,     0,
     510,   511,   512,   513,   514,   515,   516,   517,   518,   519,
     520,   521,   522,   523,   524,     0,   525,   526,   527,   528,
     529,     0,   530,   531,   532,   533,   534,     0,   536,   537,
     538,   539,     0,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,   551,   552,   553,   554,     0,   555,
     556,     0,   557,     0,   559,   560,   561,   562,   563,     0,
     564,   565,   566,     0,     0,   567,   568,   569,   570,   571,
       0,   572,   573,   574,   575,   576,   577,   578,   579,     0,
       0,   580,   581,   582,   583,   584,     0,     0,   585,   586,
     587,   588,   589,   590,   591,     0,   592,     0,   594,   595,
     596,   597,     0,     0,   598,     0,     0,   599,   600,   601,
     602,   603,   604,   605,   606,   607,   608,   609,   610,   611,
     612,   613,   614,   615,   616,   617,   618,   626,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     845,     0,     0,     0,   236,   237,   238,   239,   240,   241,
     242,   243,     0,   244,   245,   246,     0,     0,     0,     0,
       0,     0,     0,   247,   248,   249,     0,   250,   251,   252,
     253,     0,   255,   256,   257,   258,   259,     0,   261,   262,
       0,   263,   264,   265,   266,   267,   268,   269,     0,     0,
     270,   271,   272,   273,   274,     0,   275,   276,   277,   278,
     279,     0,     0,     0,   281,   282,   283,   284,   285,   286,
       0,   288,   289,   290,     0,   291,   292,   293,   294,   295,
     296,     0,     0,   298,   299,   300,     0,     0,     0,     0,
       0,     0,     0,   302,   303,   304,   305,   306,   307,   308,
     309,   310,     0,   311,     0,   312,   313,   314,   315,   316,
     317,   318,     0,   319,   320,   321,   322,     0,     0,   323,
     324,   325,   326,   327,     0,   328,   329,   330,     0,   331,
     332,   333,     0,   334,   335,   336,   337,   338,   339,   340,
     341,   342,   343,     0,   344,     0,   345,   346,   347,   348,
     349,     0,   350,     0,   351,     0,     0,     0,   354,   355,
     356,   357,     0,   358,   359,     0,   360,   361,   362,     0,
     363,   364,   365,   366,   367,     0,   369,   370,   371,   372,
       0,   373,   374,   375,   376,   377,   378,   379,     0,   380,
       0,   382,   383,   384,   385,   386,   387,   388,     0,   389,
       0,   390,     0,     0,   393,     0,   395,   396,   397,   398,
     399,     0,     0,   400,   401,     0,   403,     0,     0,   405,
     406,   407,     0,     0,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,     0,   428,   429,   430,   431,   432,   433,
     434,   435,   436,   437,   438,     0,   439,   440,     0,   442,
       0,   443,   444,   445,   446,   447,   448,     0,   449,   450,
       0,     0,   451,   452,   453,     0,     0,   454,   455,   456,
       0,   458,     0,   460,   461,   462,   463,   464,   465,   466,
     467,   468,   469,   470,     0,     0,   471,   472,   473,   474,
     475,   476,   477,   478,     0,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   490,   491,   492,   493,
       0,   494,   495,   496,   497,   498,   499,   500,   501,   502,
     503,   504,   505,   506,     0,   507,   508,     0,   510,   511,
     512,   513,   514,   515,   516,   517,   518,   519,   520,   521,
     522,   523,   524,     0,   525,   526,   527,   528,   529,     0,
     530,   531,   532,   533,   534,     0,   536,   537,   538,   539,
       0,   540,   541,   542,   543,   544,   545,   546,   547,   548,
     549,   550,   551,   552,   553,   554,     0,   555,   556,     0,
     557,     0,   559,   560,   561,   562,   563,     0,   564,   565,
     566,     0,     0,   567,   568,   569,   570,   571,     0,   572,
     573,   574,   575,   576,   577,   578,   579,     0,     0,   580,
     581,   582,   583,   584,     0,     0,   585,   586,   587,   588,
     589,   590,   591,     0,   592,     0,   594,   595,   596,   597,
       0,     0,   598,     0,     0,   599,   600,   601,   602,   603,
     604,   605,   606,   607,   608,   609,   610,   611,   612,   613,
     614,   615,   616,   617,   618,   856,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  5772,     0,
       0,     0,   236,   237,   238,   239,   240,   241,   242,   243,
       0,   244,   245,   246,     0,     0,     0,     0,     0,     0,
       0,   247,   248,   249,     0,   250,   251,   252,   253,   254,
     255,   256,   257,     0,   857,   260,   858,   859,     0,   263,
     264,   265,   266,   267,   268,   269,     0,     0,   270,   271,
     860,   861,   274,     0,   275,   276,   277,   278,     0,     0,
     280,     0,   281,   282,   283,   284,   285,   286,   287,   288,
     289,   290,     0,   291,   292,   293,   294,   295,   296,     0,
     297,   298,   299,   300,     0,     0,     0,   301,     0,     0,
       0,   302,   303,   304,   305,   306,   307,   862,   863,   310,
       0,   311,     0,   312,   313,   314,   315,   316,   317,   318,
       0,   319,   320,   321,   322,     0,     0,   323,   324,   864,
     326,   327,     0,   328,   329,   330,     0,   331,   332,   333,
       0,   334,   335,   336,   337,     0,   339,   340,   341,   342,
       0,     0,   344,     0,   345,   346,   347,   865,   349,     0,
     350,     0,   351,   352,     0,   353,   354,   355,   356,   357,
       0,   358,     0,     0,     0,   361,   362,     0,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,  2639,   373,
     374,   375,   376,   377,   378,   379,     0,   380,   381,  2640,
     383,   384,   385,   386,   866,   867,     0,   868,     0,   390,
     391,   392,   393,   394,   395,   396,   397,   398,   399,     0,
       0,   400,     0,   402,   403,   404,     0,   405,   406,   407,
       0,     0,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     869,   427,   870,   429,   430,   431,   432,   433,   434,   435,
       0,     0,   438,     0,   439,   440,   441,   442,     0,     0,
     444,   871,   446,   447,   448,     0,   449,   450,     0,     0,
     451,   452,   453,     0,  2641,   454,   455,  2642,   457,   458,
     459,     0,   461,   462,   463,   464,   465,   466,   467,   468,
     469,   470,     0,     0,   471,   472,     0,   474,     0,   476,
     477,   478,     0,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   872,   490,   491,   492,   493,     0,   494,
     495,   496,   497,   498,   499,   500,   501,   502,   503,   504,
     505,   506,     0,   507,   508,   509,   510,   511,   512,   513,
     514,     0,   516,   517,   518,   519,   520,   521,   522,   523,
     524,     0,   525,   526,   527,   528,   529,     0,   530,   531,
    2643,   533,   534,   535,   536,   537,   874,   539,     0,   540,
     541,   542,   543,   544,   545,   546,   547,   548,   549,   550,
     551,   552,     0,   554,     0,   555,   556,     0,   557,   558,
     559,   560,   561,   562,   563,     0,   564,   875,   876,     0,
       0,   567,   568,     0,   570,     0,     0,   572,   573,   574,
     575,   576,   577,   578,   579,     0,     0,   580,   581,   582,
     583,   584,     0,     0,   585,   586,   587,   588,   589,     0,
     877,  2644,   592,   593,   594,   595,   596,   597,     0,     0,
     598,     0,     0,   599,   600,   601,   602,   603,   604,     0,
       0,  3819,     0,     0,     0,     0,     0,     0,     0,     0,
     616,   617,   618,     0,     0,     0,     0,     0,   236,   237,
     238,   239,   240,   241,   242,   243,  2645,   244,   245,   246,
       0,     0,     0,     0,     0,     0,     0,   247,   248,   249,
       0,   250,   251,   252,   253,   254,   255,   256,   257,     0,
     857,   260,   858,   859,     0,   263,   264,   265,   266,   267,
     268,   269,     0,     0,   270,   271,   860,   861,   274,     0,
     275,   276,   277,   278,     0,     0,   280,     0,   281,   282,
     283,   284,   285,   286,   287,   288,   289,   290,     0,   291,
     292,   293,   294,   295,   296,     0,   297,   298,   299,   300,
       0,     0,     0,   301,     0,     0,     0,   302,   303,   304,
     305,   306,   307,   862,   863,   310,     0,   311,     0,   312,
     313,   314,   315,   316,   317,   318,     0,   319,   320,   321,
     322,     0,     0,   323,   324,   864,   326,   327,     0,   328,
     329,   330,     0,   331,   332,   333,     0,   334,   335,   336,
     337,     0,   339,   340,   341,   342,     0,     0,   344,     0,
     345,   346,   347,   865,   349,     0,   350,     0,   351,   352,
       0,   353,   354,   355,   356,   357,     0,   358,     0,     0,
       0,   361,   362,     0,   363,   364,   365,   366,   367,   368,
     369,   370,   371,   372,  2639,   373,   374,   375,   376,   377,
     378,   379,     0,   380,   381,  2640,   383,   384,   385,   386,
     866,   867,     0,   868,     0,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,     0,     0,   400,     0,   402,
     403,   404,     0,   405,   406,   407,     0,     0,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   869,   427,   870,   429,
     430,   431,   432,   433,   434,   435,     0,     0,   438,     0,
     439,   440,   441,   442,     0,     0,   444,   871,   446,   447,
     448,     0,   449,   450,     0,     0,   451,   452,   453,     0,
    2641,   454,   455,  2642,   457,   458,   459,     0,   461,   462,
     463,   464,   465,   466,   467,   468,   469,   470,     0,     0,
     471,   472,     0,   474,     0,   476,   477,   478,     0,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   872,
     490,   491,   492,   493,     0,   494,   495,   496,   497,   498,
     499,   500,   501,   502,   503,   504,   505,   506,     0,   507,
     508,   509,   510,   511,   512,   513,   514,     0,   516,   517,
     518,   519,   520,   521,   522,   523,   524,     0,   525,   526,
     527,   528,   529,     0,   530,   531,  2643,   533,   534,   535,
     536,   537,   874,   539,     0,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,   552,     0,   554,
       0,   555,   556,     0,   557,   558,   559,   560,   561,   562,
     563,     0,   564,   875,   876,     0,     0,   567,   568,     0,
     570,     0,     0,   572,   573,   574,   575,   576,   577,   578,
     579,     0,     0,   580,   581,   582,   583,   584,     0,     0,
     585,   586,   587,   588,   589,     0,   877,  2644,   592,   593,
     594,   595,   596,   597,     0,     0,   598,     0,     0,   599,
     600,   601,   602,   603,   604,     0,     0,   942,     0,  1564,
     685,     0,     0,     0,     0,   746,   616,   617,   618,     0,
       0,     0,     0,     0,   236,   237,   238,   239,   240,   241,
     242,   243,  2645,   244,   245,   246,     0,     0,     0,     0,
       0,     0,     0,   247,   248,   249,     0,   250,   251,   252,
     253,   254,   255,   256,   257,   258,   259,   260,   261,   262,
       0,   263,   264,   265,   266,   267,   268,   269,     0,     0,
     270,   271,   272,   273,   274,     0,   275,   276,   277,   278,
     279,     0,   280,     0,   281,   282,   283,   284,   285,   286,
     287,   288,   289,   290,     0,   291,   292,   293,   294,   295,
     296,     0,   297,   298,   299,   300,     0,     0,     0,   301,
       0,     0,     0,   302,   303,   304,   305,   306,   307,   308,
     309,   310,  2530,   311,     0,   312,   313,   314,   315,   316,
     317,   318,     0,   319,   320,   321,   322,     0,     0,   323,
     324,   325,   326,   327,     0,   328,   329,   330,     0,   331,
     332,   333,     0,   334,   335,   336,   337,   338,   339,   340,
     341,   342,   343,  1786,   344,     0,   345,   346,   347,   348,
     349,     0,   350,     0,   351,   352,     0,   353,   354,   355,
     356,   357,     0,   358,   359,     0,   360,   361,   362,     0,
     363,   364,   365,   366,   367,   368,   369,   370,   371,   372,
       0,   373,   374,   375,   376,   377,   378,   379,     0,   380,
     381,   382,   383,   384,   385,   386,   387,   388,     0,   389,
       0,   390,   391,   392,   393,   394,   395,   396,   397,   398,
     399,     0,     0,   400,   401,   402,   403,   404,     0,   405,
     406,   407,     0,     0,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   431,   432,   433,
     434,   435,   436,   437,   438,     0,   439,   440,   441,   442,
       0,   443,   444,   445,   446,   447,   448,     0,   449,   450,
    1787,     0,   451,   452,   453,     0,     0,   454,   455,   456,
     457,   458,   459,   460,   461,   462,   463,   464,   465,   466,
     467,   468,   469,   470,     0,     0,   471,   472,   473,   474,
     475,   476,   477,   478,     0,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   490,   491,   492,   493,
       0,   494,   495,   496,   497,   498,   499,   500,   501,   502,
     503,   504,   505,   506,     0,   507,   508,   509,   510,   511,
     512,   513,   514,   515,   516,   517,   518,   519,   520,   521,
     522,   523,   524,     0,   525,   526,   527,   528,   529,     0,
     530,   531,   532,   533,   534,   535,   536,   537,   538,   539,
       0,   540,   541,   542,   543,   544,   545,   546,   547,   548,
     549,   550,   551,   552,   553,   554,     0,   555,   556,     0,
     557,   558,   559,   560,   561,   562,   563,     0,   564,   565,
     566,     0,     0,   567,   568,   569,   570,   571,  1788,   572,
     573,   574,   575,   576,   577,   578,   579,     0,     0,   580,
     581,   582,   583,   584,     0,     0,   585,   586,   587,   588,
     589,   590,   591,     0,   592,   593,   594,   595,   596,   597,
       0,     0,   598,     0,     0,   599,   600,   601,   602,   603,
     604,   605,   606,   607,   608,   609,   610,   611,   612,   613,
     614,   615,   616,   617,   618,   942,     0,  1564,   685,     0,
       0,     0,     0,   746,     0,     0,  1565,  1566,     0,     0,
       0,     0,   236,   237,   238,   239,   240,   241,   242,   243,
       0,   244,   245,   246,     0,     0,     0,     0,     0,     0,
       0,   247,   248,   249,     0,   250,   251,   252,   253,   254,
     255,   256,   257,   258,   259,   260,   261,   262,     0,   263,
     264,   265,   266,   267,   268,   269,     0,     0,   270,   271,
     272,   273,   274,     0,   275,   276,   277,   278,   279,     0,
     280,     0,   281,   282,   283,   284,   285,   286,   287,   288,
     289,   290,     0,   291,   292,   293,   294,   295,   296,     0,
     297,   298,   299,   300,     0,     0,     0,   301,     0,     0,
       0,   302,   303,   304,   305,   306,   307,   308,   309,   310,
    2535,   311,     0,   312,   313,   314,   315,   316,   317,   318,
       0,   319,   320,   321,   322,     0,     0,   323,   324,   325,
     326,   327,     0,   328,   329,   330,     0,   331,   332,   333,
       0,   334,   335,   336,   337,   338,   339,   340,   341,   342,
     343,  1786,   344,     0,   345,   346,   347,   348,   349,     0,
     350,     0,   351,   352,     0,   353,   354,   355,   356,   357,
       0,   358,   359,     0,   360,   361,   362,     0,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,     0,   373,
     374,   375,   376,   377,   378,   379,     0,   380,   381,   382,
     383,   384,   385,   386,   387,   388,     0,   389,     0,   390,
     391,   392,   393,   394,   395,   396,   397,   398,   399,     0,
       0,   400,   401,   402,   403,   404,     0,   405,   406,   407,
       0,     0,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438,     0,   439,   440,   441,   442,     0,   443,
     444,   445,   446,   447,   448,     0,   449,   450,  1787,     0,
     451,   452,   453,     0,     0,   454,   455,   456,   457,   458,
     459,   460,   461,   462,   463,   464,   465,   466,   467,   468,
     469,   470,     0,     0,   471,   472,   473,   474,   475,   476,
     477,   478,     0,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,   492,   493,     0,   494,
     495,   496,   497,   498,   499,   500,   501,   502,   503,   504,
     505,   506,     0,   507,   508,   509,   510,   511,   512,   513,
     514,   515,   516,   517,   518,   519,   520,   521,   522,   523,
     524,     0,   525,   526,   527,   528,   529,     0,   530,   531,
     532,   533,   534,   535,   536,   537,   538,   539,     0,   540,
     541,   542,   543,   544,   545,   546,   547,   548,   549,   550,
     551,   552,   553,   554,     0,   555,   556,     0,   557,   558,
     559,   560,   561,   562,   563,     0,   564,   565,   566,     0,
       0,   567,   568,   569,   570,   571,  1788,   572,   573,   574,
     575,   576,   577,   578,   579,     0,     0,   580,   581,   582,
     583,   584,     0,     0,   585,   586,   587,   588,   589,   590,
     591,     0,   592,   593,   594,   595,   596,   597,     0,     0,
     598,     0,     0,   599,   600,   601,   602,   603,   604,   605,
     606,   607,   608,   609,   610,   611,   612,   613,   614,   615,
     616,   617,   618,   942,     0,  1564,   685,     0,     0,     0,
       0,   746,     0,     0,  1565,  1566,     0,     0,     0,     0,
     236,   237,   238,   239,   240,   241,   242,   243,     0,   244,
     245,   246,     0,     0,     0,     0,     0,     0,     0,   247,
     248,   249,     0,   250,   251,   252,   253,   254,   255,   256,
     257,   258,   259,   260,   261,   262,     0,   263,   264,   265,
     266,   267,   268,   269,     0,     0,   270,   271,   272,   273,
     274,     0,   275,   276,   277,   278,   279,     0,   280,     0,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
       0,   291,   292,   293,   294,   295,   296,     0,   297,   298,
     299,   300,     0,     0,     0,   301,     0,     0,     0,   302,
     303,   304,   305,   306,   307,   308,   309,   310,     0,   311,
       0,   312,   313,   314,   315,   316,   317,   318,     0,   319,
     320,   321,   322,     0,     0,   323,   324,   325,   326,   327,
       0,   328,   329,   330,     0,   331,   332,   333,     0,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,  1786,
     344,     0,   345,   346,   347,   348,   349,     0,   350,     0,
     351,   352,     0,   353,   354,   355,   356,   357,     0,   358,
     359,     0,   360,   361,   362,     0,   363,   364,   365,   366,
     367,   368,   369,   370,   371,   372,     0,   373,   374,   375,
     376,   377,   378,   379,     0,   380,   381,   382,   383,   384,
     385,   386,   387,   388,     0,   389,     0,   390,   391,   392,
     393,   394,   395,   396,   397,   398,   399,     0,     0,   400,
     401,   402,   403,   404,     0,   405,   406,   407,     0,     0,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
     438,     0,   439,   440,   441,   442,     0,   443,   444,   445,
     446,   447,   448,     0,   449,   450,  1787,     0,   451,   452,
     453,     0,     0,   454,   455,   456,   457,   458,   459,   460,
     461,   462,   463,   464,   465,   466,   467,   468,   469,   470,
       0,     0,   471,   472,   473,   474,   475,   476,   477,   478,
       0,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,   490,   491,   492,   493,     0,   494,   495,   496,
     497,   498,   499,   500,   501,   502,   503,   504,   505,   506,
       0,   507,   508,   509,   510,   511,   512,   513,   514,   515,
     516,   517,   518,   519,   520,   521,   522,   523,   524,     0,
     525,   526,   527,   528,   529,     0,   530,   531,   532,   533,
     534,   535,   536,   537,   538,   539,     0,   540,   541,   542,
     543,   544,   545,   546,   547,   548,   549,   550,   551,   552,
     553,   554,     0,   555,   556,     0,   557,   558,   559,   560,
     561,   562,   563,     0,   564,   565,   566,     0,     0,   567,
     568,   569,   570,   571,  1788,   572,   573,   574,   575,   576,
     577,   578,   579,     0,     0,   580,   581,   582,   583,   584,
       0,     0,   585,   586,   587,   588,   589,   590,   591,     0,
     592,   593,   594,   595,   596,   597,     0,     0,   598,     0,
       0,   599,   600,   601,   602,   603,   604,   605,   606,   607,
     608,   609,   610,   611,   612,   613,   614,   615,   616,   617,
     618,   942,     0,     0,   685,     0,     0,     0,     0,   746,
       0,     0,  1565,  1566,     0,     0,     0,     0,   236,   237,
     238,   239,   240,   241,   242,   243,     0,   244,   245,   246,
       0,     0,     0,     0,     0,     0,     0,   247,   248,   249,
       0,   250,   251,   252,   253,   254,   255,   256,   257,   258,
     259,   260,   261,   262,     0,   263,   264,   265,   266,   267,
     268,   269,     0,     0,   270,   271,   272,   273,   274,     0,
     275,   276,   277,   278,   279,     0,   280,     0,   281,   282,
     283,   284,   285,   286,   287,   288,   289,   290,     0,   291,
     292,   293,   294,   295,   296,     0,   297,   298,   299,   300,
       0,     0,     0,   301,     0,     0,     0,   302,   303,   304,
     305,   306,   307,   308,   309,   310,  3435,   311,     0,   312,
     313,   314,   315,   316,   317,   318,     0,   319,   320,   321,
     322,     0,     0,   323,   324,   325,   326,   327,     0,   328,
     329,   330,     0,   331,   332,   333,     0,   334,   335,   336,
     337,   338,   339,   340,   341,   342,   343,  1786,   344,     0,
     345,   346,   347,   348,   349,     0,   350,     0,   351,   352,
       0,   353,   354,   355,   356,   357,     0,   358,   359,     0,
     360,   361,   362,     0,   363,   364,   365,   366,   367,   368,
     369,   370,   371,   372,     0,   373,   374,   375,   376,   377,
     378,   379,     0,   380,   381,   382,   383,   384,   385,   386,
     387,   388,     0,   389,     0,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,     0,     0,   400,   401,   402,
     403,   404,     0,   405,   406,   407,     0,     0,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,   432,   433,   434,   435,   436,   437,   438,     0,
     439,   440,   441,   442,     0,   443,   444,   445,   446,   447,
     448,     0,   449,   450,  1787,     0,   451,   452,   453,     0,
       0,   454,   455,   456,   457,   458,   459,   460,   461,   462,
     463,   464,   465,   466,   467,   468,   469,   470,     0,     0,
     471,   472,   473,   474,   475,   476,   477,   478,     0,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,   493,     0,   494,   495,   496,   497,   498,
     499,   500,   501,   502,   503,   504,   505,   506,     0,   507,
     508,   509,   510,   511,   512,   513,   514,   515,   516,   517,
     518,   519,   520,   521,   522,   523,   524,     0,   525,   526,
     527,   528,   529,     0,   530,   531,   532,   533,   534,   535,
     536,   537,   538,   539,     0,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,   552,   553,   554,
       0,   555,   556,     0,   557,   558,   559,   560,   561,   562,
     563,     0,   564,   565,   566,     0,     0,   567,   568,   569,
     570,   571,  1788,   572,   573,   574,   575,   576,   577,   578,
     579,     0,     0,   580,   581,   582,   583,   584,     0,     0,
     585,   586,   587,   588,   589,   590,   591,     0,   592,   593,
     594,   595,   596,   597,     0,     0,   598,     0,     0,   599,
     600,   601,   602,   603,   604,   605,   606,   607,   608,   609,
     610,   611,   612,   613,   614,   615,   616,   617,   618,   626,
       0,     0,     0,     0,     0,     0,     0,   746,     0,     0,
     758,   759,     0,     0,     0,     0,   236,   747,   238,   239,
     240,   241,   242,   243,   748,   244,   245,   246,     0,     0,
       0,     0,     0,     0,     0,   247,   248,   249,     0,   250,
     251,   252,   253,     0,   749,   256,   257,   258,   259,     0,
     261,   262,     0,   263,   264,   265,   266,   267,   268,   269,
       0,     0,   270,   271,   272,   273,   274,     0,   275,   276,
     277,   278,   279,     0,     0,     0,   281,   282,   283,   284,
     285,   286,     0,   288,   289,   290,     0,   291,   292,   293,
     294,   295,   296,     0,     0,   298,   299,   300,     0,     0,
       0,     0,     0,     0,     0,   302,   303,   304,   305,   306,
     307,   308,   309,   310,     0,   311,     0,   312,   313,   314,
     315,   316,   317,   318,     0,   319,   320,   321,   322,     0,
       0,   323,   324,   325,   326,   327,     0,   328,   329,   330,
       0,   331,   332,   333,     0,   334,   335,   336,   337,   338,
     339,   340,   341,   342,   343,     0,   344,     0,   345,   346,
     750,   348,   349,     0,   350,     0,   751,     0,   752,     0,
     354,   355,   356,   357,     0,   358,   359,     0,   360,   361,
     362,     0,   363,   364,   365,   366,   367,     0,   369,   370,
     371,   372,   753,   373,   374,   375,   376,   377,   378,   379,
       0,   380,     0,   382,   383,   384,   385,   386,   387,   388,
       0,   389,     0,   390,     0,     0,   393,     0,   395,   396,
     397,   398,   754,     0,     0,   400,   401,     0,   403,     0,
       0,   405,   406,   407,     0,     0,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,     0,   428,   429,   755,   431,
     432,   433,   434,   435,   436,   437,   438,     0,   439,   440,
       0,   442,     0,   443,   444,   445,   446,   447,   448,     0,
     449,   450,     0,     0,   451,   452,   453,     0,     0,   454,
     455,   456,     0,   458,     0,   460,   461,   462,   463,   464,
     465,   466,   467,   468,   469,   470,     0,     0,   471,   472,
     473,   474,   475,   476,   477,   478,     0,   756,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,   490,   491,
     492,   493,     0,   494,   495,   496,   757,   498,   499,   500,
     501,   502,   503,   504,   505,   506,     0,   507,   508,     0,
     510,   511,   512,   513,   514,   515,   516,   517,   518,   519,
     520,   521,   522,   523,   524,     0,   525,   526,   527,   528,
     529,     0,   530,   531,   532,   533,   534,     0,   536,   537,
     538,   539,     0,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,   551,   552,   553,   554,     0,   555,
     556,     0,   557,     0,   559,   560,   561,   562,   563,     0,
     564,   565,   566,     0,     0,   567,   568,   569,   570,   571,
       0,   572,   573,   574,   575,   576,   577,   578,   579,     0,
       0,   580,   581,   582,   583,   584,     0,     0,   585,   586,
     587,   588,   589,   590,   591,     0,   592,     0,   594,   595,
     596,   597,     0,     0,   598,     0,     0,   599,   600,   601,
     602,   603,   604,   605,   606,   607,   608,   609,   610,   611,
     612,   613,   614,   615,   616,   617,   618,  1698,     0,  6053,
     685,     0,     0,     0,     0,   746,     0,     0,   758,   759,
       0,     0,     0,     0,   236,   237,   238,   239,   240,   241,
     242,   243,  1699,   244,   245,   246,  1700,  1701,  1702,  1703,
    1704,  1705,  1706,   247,   248,   249,  1707,   250,   251,   252,
     253,   254,   255,   256,   257,   258,   259,   260,   261,   262,
    1708,   263,   264,   265,   266,   267,   268,   269,  1709,  1710,
     270,   271,   272,   273,   274,  1711,   275,   276,   277,   278,
     279,  1712,   280,  1713,   281,   282,   283,   284,   285,   286,
     287,   288,   289,   290,  1714,   291,   292,   293,   294,   295,
     296,  1715,   297,   298,   299,   300,  1716,  1717,  1718,   301,
    1719,  1720,  1721,   302,   303,   304,   305,   306,   307,   308,
     309,   310,  1722,   311,  1723,   312,   313,   314,   315,   316,
     317,   318,  1724,   319,   320,   321,   322,  1725,  1726,   323,
     324,   325,   326,   327,  1727,   328,   329,   330,  1728,   331,
     332,   333,  1729,   334,   335,   336,   337,   338,   339,   340,
     341,   342,   343,  1730,   344,  1731,   345,   346,   347,   348,
     349,  1732,   350,  1733,   351,   352,  1734,   353,   354,   355,
     356,   357,  1735,   358,   359,  1736,   360,   361,   362,  1737,
     363,   364,   365,   366,   367,   368,   369,   370,   371,   372,
    1738,   373,   374,   375,   376,   377,   378,   379,  1739,   380,
     381,   382,   383,   384,   385,   386,   387,   388,  1740,   389,
    1741,   390,   391,   392,   393,   394,   395,   396,   397,   398,
     399,  1742,  1743,   400,   401,   402,   403,   404,  1744,   405,
     406,   407,  1745,  1746,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   431,   432,   433,
     434,   435,   436,   437,   438,  1747,   439,   440,   441,   442,
    1748,   443,   444,   445,   446,   447,   448,  1749,   449,   450,
    1750,  1751,   451,   452,   453,  1752,  1753,   454,   455,   456,
     457,   458,   459,   460,   461,   462,   463,   464,   465,   466,
     467,   468,   469,   470,     0,  1754,   471,   472,   473,   474,
     475,   476,   477,   478,  1755,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   490,   491,   492,   493,
    1756,   494,   495,   496,   497,   498,   499,   500,   501,   502,
     503,   504,   505,   506,  1757,   507,   508,   509,   510,   511,
     512,   513,   514,   515,   516,   517,   518,   519,   520,   521,
     522,   523,   524,  1758,   525,   526,   527,   528,   529,  1759,
     530,   531,   532,   533,   534,   535,   536,   537,   538,   539,
    1760,   540,   541,   542,   543,   544,   545,   546,   547,   548,
     549,   550,   551,   552,   553,   554,  1761,   555,   556,  1762,
     557,   558,   559,   560,   561,   562,   563,  1763,   564,   565,
     566,  1764,  1765,   567,   568,   569,   570,   571,  1766,   572,
     573,   574,   575,   576,   577,   578,   579,  1767,  1768,   580,
     581,   582,   583,   584,  1769,  1770,   585,   586,   587,   588,
     589,   590,   591,  1771,   592,   593,   594,   595,   596,   597,
    1772,  1773,   598,  1774,  1775,   599,   600,   601,   602,   603,
     604,   605,   606,   607,   608,   609,   610,   611,   612,   613,
     614,   615,   616,   617,   618,  1698,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   236,   237,   238,   239,   240,   241,   242,   243,
    1699,   244,   245,   246,  1700,  1701,  1702,  1703,  1704,  1705,
    1706,   247,   248,   249,  1707,   250,   251,   252,   253,   254,
     255,   256,   257,   258,   259,   260,   261,   262,  1708,   263,
     264,   265,   266,   267,   268,   269,  1709,  1710,   270,   271,
     272,   273,   274,  1711,   275,   276,   277,   278,   279,  1712,
     280,  1713,   281,   282,   283,   284,   285,   286,   287,   288,
     289,   290,  1714,   291,   292,   293,   294,   295,   296,  1715,
     297,   298,   299,   300,  1716,  1717,  1718,   301,  1719,  1720,
    1721,   302,   303,   304,   305,   306,   307,   308,   309,   310,
    1722,   311,  1723,   312,   313,   314,   315,   316,   317,   318,
    1724,   319,   320,   321,   322,  1725,  1726,   323,   324,   325,
     326,   327,  1727,   328,   329,   330,  1728,   331,   332,   333,
    1729,   334,   335,   336,   337,   338,   339,   340,   341,   342,
     343,  1730,   344,  1731,   345,   346,   347,   348,   349,  1732,
     350,  1733,   351,   352,  1734,   353,   354,   355,   356,   357,
    1735,   358,   359,  1736,   360,   361,   362,  1737,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,  1738,   373,
     374,   375,   376,   377,   378,   379,  1739,   380,   381,   382,
     383,   384,   385,   386,   387,   388,  1740,   389,  1741,   390,
     391,   392,   393,   394,   395,   396,   397,   398,   399,  1742,
    1743,   400,   401,   402,   403,   404,  1744,   405,   406,   407,
    1745,  1746,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438,  1747,   439,   440,   441,   442,  1748,   443,
     444,   445,   446,   447,   448,  1749,   449,   450,  1750,  1751,
     451,   452,   453,  1752,  1753,   454,   455,   456,   457,   458,
     459,   460,   461,   462,   463,   464,   465,   466,   467,   468,
     469,   470,     0,  1754,   471,   472,   473,   474,   475,   476,
     477,   478,  1755,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,   492,   493,  1756,   494,
     495,   496,   497,   498,   499,   500,   501,   502,   503,   504,
     505,   506,  1757,   507,   508,   509,   510,   511,   512,   513,
     514,   515,   516,   517,   518,   519,   520,   521,   522,   523,
     524,  1758,   525,   526,   527,   528,   529,  1759,   530,   531,
     532,   533,   534,   535,   536,   537,   538,   539,  1760,   540,
     541,   542,   543,   544,   545,   546,   547,   548,   549,   550,
     551,   552,   553,   554,  1761,   555,   556,  1762,   557,   558,
     559,   560,   561,   562,   563,  1763,   564,   565,   566,  1764,
    1765,   567,   568,   569,   570,   571,  1766,   572,   573,   574,
     575,   576,   577,   578,   579,  1767,  1768,   580,   581,   582,
     583,   584,  1769,  1770,   585,   586,   587,   588,   589,   590,
     591,  1771,   592,   593,   594,   595,   596,   597,  1772,  1773,
     598,  1774,  1775,   599,   600,   601,   602,   603,   604,   605,
     606,   607,   608,   609,   610,   611,   612,   613,   614,   615,
     616,   617,   618,  1698,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     236,   237,   238,   239,  3540,   241,   242,   243,  1699,   244,
     245,   246,  1700,  1701,  1702,  1703,  1704,  1705,  1706,   247,
     248,   249,  1707,   250,   251,   252,   253,   254,   255,   256,
     257,   258,   259,   260,   261,   262,  1708,   263,   264,   265,
     266,   267,   268,   269,  1709,  1710,   270,   271,   272,   273,
     274,  1711,   275,   276,   277,   278,   279,  1712,   280,  1713,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
    1714,   291,   292,   293,   294,   295,   296,  1715,   297,   298,
     299,   300,  1716,  1717,  1718,   301,  1719,  1720,  1721,   302,
     303,   304,   305,   306,   307,   308,   309,   310,  1722,   311,
    1723,   312,   313,   314,   315,   316,   317,   318,  1724,   319,
     320,   321,   322,  1725,  1726,   323,   324,   325,  3541,   327,
    1727,   328,   329,   330,  1728,   331,   332,   333,  1729,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,  1730,
     344,  1731,   345,   346,   347,   348,   349,  1732,   350,  1733,
     351,   352,  1734,   353,   354,   355,   356,   357,  1735,   358,
     359,  1736,   360,   361,   362,  1737,   363,   364,   365,   366,
     367,   368,   369,   370,   371,   372,  1738,   373,   374,   375,
     376,   377,   378,   379,  1739,   380,   381,   382,   383,   384,
     385,   386,   387,   388,  1740,   389,  1741,   390,   391,   392,
     393,   394,   395,   396,   397,   398,   399,  1742,  1743,   400,
     401,   402,   403,   404,  1744,   405,   406,   407,  1745,  1746,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
     438,  1747,   439,   440,   441,   442,  1748,   443,   444,   445,
     446,   447,   448,  1749,   449,   450,  1750,  1751,   451,   452,
     453,  1752,  1753,   454,   455,   456,   457,   458,   459,   460,
     461,   462,   463,   464,   465,   466,   467,   468,   469,   470,
       0,  1754,   471,   472,   473,   474,   475,   476,   477,   478,
    1755,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,   490,   491,   492,   493,  1756,   494,   495,   496,
     497,   498,   499,   500,   501,   502,   503,   504,   505,   506,
    1757,   507,   508,   509,   510,   511,   512,   513,   514,   515,
     516,   517,   518,   519,   520,   521,   522,   523,   524,  1758,
     525,   526,   527,   528,   529,  1759,  3542,   531,   532,   533,
     534,   535,   536,   537,   538,   539,  1760,   540,   541,   542,
     543,   544,   545,   546,   547,   548,   549,   550,   551,   552,
     553,   554,  1761,   555,   556,  1762,   557,   558,   559,   560,
     561,   562,   563,  1763,   564,   565,   566,  1764,  1765,   567,
     568,   569,   570,   571,  1766,   572,   573,   574,   575,   576,
     577,   578,   579,  1767,  1768,   580,   581,   582,   583,   584,
    1769,  1770,   585,   586,   587,   588,   589,   590,   591,  1771,
     592,   593,   594,   595,   596,   597,  1772,  1773,   598,  1774,
    1775,   599,   600,   601,   602,   603,   604,   605,   606,   607,
     608,   609,   610,   611,   612,   613,   614,   615,   616,   617,
     618,   235,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   236,   237,
     238,   239,   240,   241,   242,   243,     0,   244,   245,   246,
       0,     0,     0,     0,     0,     0,     0,   247,   248,   249,
       0,   250,   251,   252,   253,   254,   255,   256,   257,   258,
     259,   260,   261,   262,     0,   263,   264,   265,   266,   267,
     268,   269,     0,  1255,   270,   271,   272,   273,   274,     0,
     275,   276,   277,   278,  1258,     0,  1259,     0,   281,   282,
     283,   284,   285,   286,   287,   288,   289,   290,     0,   291,
     292,   293,   294,   295,   296,     0,   297,   298,   299,   300,
    1260,  1261,  1262,  1263,  1264,  1265,  1266,   302,   303,   304,
     305,   306,   307,   308,   309,   310,     0,   311,     0,   312,
     313,   314,   315,   316,   317,   318,     0,   319,   320,   321,
     322,     0,     0,   323,   324,   325,   326,   327,     0,   328,
     329,   330,     0,   331,   332,   333,     0,   334,   335,   336,
     337,   338,   339,   340,   341,   342,  1271,     0,   344,     0,
     345,   346,   347,   348,   349,     0,   350,     0,   351,   352,
       0,   353,   354,   355,   356,   357,     0,   358,  1274,     0,
     360,   361,   362,     0,   363,   364,   365,   366,   367,   368,
     369,   370,   371,   372,     0,   373,   374,   375,   376,   377,
     378,   379,     0,   380,   381,   382,   383,   384,   385,   386,
     387,   388,     0,   389,     0,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,     0,     0,   400,  1279,   402,
     403,   404,     0,   405,   406,   407,  1280,  1281,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,   432,   433,   434,   435,   436,  1284,   438,     0,
     439,   440,   441,   442,     0,  1287,   444,   445,   446,   447,
     448,     0,   449,   450,     0,     0,   451,   452,   453,     0,
       0,   454,   455,   456,   457,   458,   459,  1290,   461,   462,
     463,   464,   465,   466,   467,   468,   469,   470,     0,     0,
     471,   472,  1291,   474,   475,   476,   477,   478,     0,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,   493,     0,   494,   495,   496,   497,   498,
     499,   500,   501,   502,   503,   504,   505,   506,     0,   507,
     508,   509,   510,   511,   512,   513,   514,   515,   516,   517,
     518,   519,   520,   521,   522,   523,   524,     0,   525,   526,
     527,   528,   529,  1294,   530,   531,   532,   533,   534,   535,
     536,   537,   538,   539,     0,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,   552,  1296,   554,
       0,   555,   556,     0,   557,   558,   559,   560,   561,   562,
     563,     0,   564,   565,   566,     0,     0,   567,   568,  1299,
     570,  1300,     0,   572,   573,   574,   575,   576,   577,   578,
     579,     0,     0,   580,   581,   582,   583,   584,  1303,     0,
     585,   586,   587,   588,   589,   590,   591,     0,   592,   593,
     594,   595,   596,   597,     0,     0,   598,     0,     0,   599,
     600,   601,   602,   603,   604,   605,  1305,  1306,  1307,  1308,
     610,  1309,  1310,  1311,  1312,   615,   616,   617,   618,   235,
       0,  1245,   685,     0,  1246,  1247,     0,   746,     0,     0,
       0,     0,     0,     0,     0,     0,   236,   237,   238,   239,
     240,   241,   242,   243,     0,   244,   245,   246,     0,     0,
       0,     0,     0,     0,     0,   247,   248,   249,     0,   250,
     251,   252,   253,   254,   255,   256,   257,   258,  1251,   260,
    1252,  1253,     0,   263,   264,   265,   266,   267,   268,   269,
       0,     0,   270,   271,  1256,  1257,   274,     0,   275,   276,
     277,   278,   279,     0,   280,     0,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,     0,   291,   292,   293,
     294,   295,   296,     0,   297,   298,   299,   300,     0,     0,
       0,   301,     0,     0,     0,   302,   303,   304,   305,   306,
     307,  1267,  1268,   310,     0,   311,     0,   312,   313,   314,
     315,   316,   317,   318,     0,   319,   320,   321,   322,     0,
       0,   323,   324,   864,   326,   327,     0,   328,   329,   330,
       0,   331,   332,   333,     0,   334,   335,   336,   337,   338,
     339,   340,   341,   342,   343,  1272,   344,     0,   345,   346,
     347,  1273,   349,     0,   350,     0,   351,   352,     0,   353,
     354,   355,   356,   357,     0,   358,   359,     0,   360,   361,
     362,     0,   363,   364,   365,   366,   367,   368,   369,   370,
     371,   372,     0,   373,   374,   375,   376,   377,   378,   379,
       0,   380,   381,   382,   383,   384,   385,   386,  1276,  1277,
       0,  1278,     0,   390,   391,   392,   393,   394,   395,   396,
     397,   398,   399,     0,     0,   400,   401,   402,   403,   404,
       0,   405,   406,   407,     0,     0,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,  1282,   427,  1283,   429,   430,   431,
     432,   433,   434,   435,   436,   437,   438,     0,   439,   440,
     441,   442,  1286,   443,   444,  1288,   446,   447,   448,     0,
     449,   450,     0,     0,   451,   452,   453,     0,     0,   454,
     455,   456,   457,   458,   459,   460,   461,   462,   463,   464,
     465,   466,   467,   468,   469,   470,     0,     0,   471,   472,
     473,   474,   475,   476,   477,   478,     0,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,  1292,   490,   491,
     492,   493,     0,   494,   495,   496,   497,   498,   499,   500,
     501,   502,   503,   504,   505,   506,     0,   507,   508,   509,
     510,   511,   512,   513,   514,   515,   516,   517,   518,   519,
     520,   521,   522,   523,   524,     0,   525,   526,   527,   528,
     529,     0,   530,   531,   532,   533,   534,   535,   536,   537,
    1295,   539,     0,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,   551,   552,   553,   554,     0,   555,
     556,     0,   557,   558,   559,   560,   561,   562,   563,     0,
     564,  1297,  1298,     0,     0,   567,   568,   569,   570,   571,
    1301,   572,   573,   574,   575,   576,   577,   578,   579,     0,
       0,   580,   581,   582,   583,   584,     0,     0,   585,   586,
     587,   588,   589,   590,  1304,     0,   592,   593,   594,   595,
     596,   597,     0,     0,   598,     0,     0,   599,   600,   601,
     602,   603,   604,   605,   606,   607,   608,   609,   610,   611,
     612,   613,   614,   615,   616,   617,   618,   942,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   236,   237,   238,   239,   240,   241,
     242,   243,   981,   244,   245,   246,     0,     0,     0,     0,
       0,     0,     0,   247,   248,   249,     0,   250,   251,   252,
     253,   254,   255,   256,   257,   258,   259,   260,   261,   262,
       0,   263,   264,   265,   266,   267,   268,   269,     0,     0,
     270,   271,   272,   273,   274,     0,   275,   276,   277,   278,
     279,     0,   280,     0,   281,   282,   283,   284,   285,   286,
     287,   288,   289,   290,     0,   291,   292,   293,   294,   295,
     296,     0,   297,   298,   299,   300,     0,     0,   943,   301,
       0,     0,   944,   302,   303,   304,   305,   306,   307,   308,
     309,   310,     0,   311,     0,   312,   313,   314,   315,   316,
     317,   318,     0,   319,   320,   321,   322,     0,     0,   323,
     324,   325,   326,   327,     0,   328,   329,   330,     0,   331,
     332,   333,     0,   334,   335,   336,   337,   338,   339,   340,
     341,   342,   343,     0,   344,     0,   345,   346,   347,   348,
     349,     0,   350,     0,   351,   352,     0,   353,   354,   355,
     356,   357,     0,   358,   359,     0,   360,   361,   362,     0,
     363,   364,   365,   366,   367,   368,   369,   370,   371,   372,
       0,   373,   374,   375,   376,   377,   378,   379,     0,   380,
     381,   382,   383,   384,   385,   386,   387,   388,     0,   389,
       0,   390,   391,   392,   393,   394,   395,   396,   397,   398,
     399,     0,     0,   400,   401,   402,   403,   404,     0,   405,
     406,   407,     0,     0,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   431,   432,   433,
     434,   435,   436,   437,   438,     0,   439,   440,   441,   442,
       0,   443,   444,   445,   446,   447,   448,     0,   449,   450,
       0,     0,   451,   452,   453,     0,     0,   454,   455,   456,
     457,   458,   459,   460,   461,   462,   463,   464,   465,   466,
     467,   468,   469,   470,     0,     0,   471,   472,   473,   474,
     475,   476,   477,   478,     0,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   490,   491,   492,   493,
       0,   494,   495,   496,   497,   498,   499,   500,   501,   502,
     503,   504,   505,   506,     0,   507,   508,   509,   510,   511,
     512,   513,   514,   515,   516,   517,   518,   519,   520,   521,
     522,   523,   524,     0,   525,   526,   527,   528,   529,   945,
     530,   531,   532,   533,   534,   535,   536,   537,   538,   539,
       0,   540,   541,   542,   543,   544,   545,   546,   547,   548,
     549,   550,   551,   552,   553,   554,     0,   555,   556,     0,
     557,   558,   559,   560,   561,   562,   563,     0,   564,   565,
     566,     0,     0,   567,   568,   569,   570,   571,     0,   572,
     573,   574,   575,   576,   577,   578,   579,     0,     0,   580,
     581,   582,   583,   584,     0,     0,   585,   586,   587,   588,
     589,   590,   591,     0,   592,   593,   594,   595,   596,   597,
       0,     0,   598,     0,     0,   599,   600,   601,   602,   603,
     604,   605,   606,   607,   608,   609,   610,   611,   612,   613,
     614,   615,   616,   617,   618,   942,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   236,   237,   238,   239,   240,   241,   242,   243,
    1002,   244,   245,   246,     0,     0,     0,     0,     0,     0,
       0,   247,   248,   249,     0,   250,   251,   252,   253,   254,
     255,   256,   257,   258,   259,   260,   261,   262,     0,   263,
     264,   265,   266,   267,   268,   269,     0,     0,   270,   271,
     272,   273,   274,     0,   275,   276,   277,   278,   279,     0,
     280,     0,   281,   282,   283,   284,   285,   286,   287,   288,
     289,   290,     0,   291,   292,   293,   294,   295,   296,     0,
     297,   298,   299,   300,     0,     0,   943,   301,     0,     0,
     944,   302,   303,   304,   305,   306,   307,   308,   309,   310,
       0,   311,     0,   312,   313,   314,   315,   316,   317,   318,
       0,   319,   320,   321,   322,     0,     0,   323,   324,   325,
     326,   327,     0,   328,   329,   330,     0,   331,   332,   333,
       0,   334,   335,   336,   337,   338,   339,   340,   341,   342,
     343,     0,   344,     0,   345,   346,   347,   348,   349,     0,
     350,     0,   351,   352,     0,   353,   354,   355,   356,   357,
       0,   358,   359,     0,   360,   361,   362,     0,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,     0,   373,
     374,   375,   376,   377,   378,   379,     0,   380,   381,   382,
     383,   384,   385,   386,   387,   388,     0,   389,     0,   390,
     391,   392,   393,   394,   395,   396,   397,   398,   399,     0,
       0,   400,   401,   402,   403,   404,     0,   405,   406,   407,
       0,     0,   408,   409,   410,   411,  1003,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438,     0,   439,   440,   441,   442,     0,   443,
     444,   445,   446,   447,   448,     0,   449,   450,     0,     0,
     451,   452,   453,     0,     0,   454,   455,   456,   457,   458,
     459,   460,   461,   462,   463,   464,   465,   466,   467,   468,
     469,   470,     0,     0,   471,   472,   473,   474,   475,   476,
     477,   478,     0,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,   492,   493,     0,   494,
     495,   496,   497,   498,   499,   500,   501,   502,   503,   504,
     505,   506,     0,   507,   508,   509,   510,   511,   512,   513,
     514,   515,   516,   517,   518,   519,   520,   521,   522,   523,
     524,     0,   525,   526,   527,   528,   529,   945,   530,   531,
     532,   533,   534,   535,   536,   537,   538,   539,     0,   540,
     541,   542,   543,   544,   545,   546,   547,   548,   549,   550,
     551,   552,   553,   554,     0,   555,   556,     0,   557,   558,
     559,   560,   561,   562,   563,     0,   564,   565,   566,     0,
       0,   567,   568,   569,   570,   571,     0,   572,   573,   574,
     575,   576,   577,   578,   579,     0,     0,   580,   581,   582,
     583,   584,     0,     0,   585,   586,   587,   588,   589,   590,
     591,     0,   592,   593,   594,   595,   596,   597,     0,     0,
     598,     0,     0,   599,   600,   601,   602,   603,   604,   605,
     606,   607,   608,   609,   610,   611,   612,   613,   614,   615,
     616,   617,   618,   942,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     236,   237,   238,   239,   240,   241,   242,   243,     0,   244,
     245,   246,     0,     0,     0,     0,     0,     0,     0,   247,
     248,   249,     0,   250,   251,   252,   253,   254,   255,   256,
     257,   258,   259,   260,   261,   262,     0,   263,   264,   265,
     266,   267,   268,   269,     0,     0,   270,   271,   272,   273,
     274,     0,   275,   276,   277,   278,   279,     0,   280,     0,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
       0,   291,   292,   293,   294,   295,   296,     0,   297,   298,
     299,   300,     0,     0,   943,   301,     0,     0,   944,   302,
     303,   304,   305,   306,   307,   308,   309,   310,     0,   311,
       0,   312,   313,   314,   315,   316,   317,   318,     0,   319,
     320,   321,   322,     0,     0,   323,   324,   325,   326,   327,
       0,   328,   329,   330,     0,   331,   332,   333,     0,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,     0,
     344,     0,   345,   346,   347,   348,   349,     0,   350,     0,
     351,   352,     0,   353,   354,   355,   356,   357,     0,   358,
     359,     0,   360,   361,   362,     0,   363,   364,   365,   366,
     367,   368,   369,   370,   371,   372,     0,   373,   374,   375,
     376,   377,   378,   379,     0,   380,   381,   382,   383,   384,
     385,   386,   387,   388,     0,   389,     0,   390,   391,   392,
     393,   394,   395,   396,   397,   398,   399,     0,     0,   400,
     401,   402,   403,   404,     0,   405,   406,   407,     0,     0,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
     438,     0,   439,   440,   441,   442,     0,   443,   444,   445,
     446,   447,   448,     0,   449,   450,     0,     0,   451,   452,
     453,     0,     0,   454,   455,   456,   457,   458,   459,   460,
     461,   462,   463,   464,   465,   466,   467,   468,   469,   470,
       0,     0,   471,   472,   473,   474,   475,   476,   477,   478,
       0,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,   490,   491,   492,   493,     0,   494,   495,   496,
     497,   498,   499,   500,   501,   502,   503,   504,   505,   506,
       0,   507,   508,   509,   510,   511,   512,   513,   514,   515,
     516,   517,   518,   519,   520,   521,   522,   523,   524,     0,
     525,   526,   527,   528,   529,   945,   530,   531,   532,   533,
     534,   535,   536,   537,   538,   539,     0,   540,   541,   542,
     543,   544,   545,   546,   547,   548,   549,   550,   551,   552,
     553,   554,     0,   555,   556,     0,   557,   558,   559,   560,
     561,   562,   563,     0,   564,   565,   566,     0,     0,   567,
     568,   569,   570,   571,     0,   572,   573,   574,   575,   576,
     577,   578,   579,     0,     0,   580,   581,   582,   583,   584,
    2906,     0,   585,   586,   587,   588,   589,   590,   591,     0,
     592,   593,   594,   595,   596,   597,     0,     0,   598,     0,
       0,   599,   600,   601,   602,   603,   604,   605,   606,   607,
     608,   609,   610,   611,   612,   613,   614,   615,   616,   617,
     618,   942,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   236,   237,
     238,   239,   240,   241,   242,   243,     0,   244,   245,   246,
       0,     0,     0,     0,     0,     0,     0,   247,   248,   249,
       0,   250,   251,   252,   253,   254,   255,   256,   257,   258,
     259,   260,   261,   262,     0,   263,   264,   265,   266,   267,
     268,   269,     0,     0,   270,   271,   272,   273,   274,     0,
     275,   276,   277,   278,   279,     0,   280,     0,   281,   282,
     283,   284,   285,   286,   287,   288,   289,   290,     0,   291,
     292,   293,   294,   295,   296,     0,   297,   298,   299,   300,
       0,     0,   943,   301,     0,     0,   944,   302,   303,   304,
     305,   306,   307,   308,   309,   310,     0,   311,     0,   312,
     313,   314,   315,   316,   317,   318,     0,   319,   320,   321,
     322,     0,     0,   323,   324,   325,   326,   327,     0,   328,
     329,   330,     0,   331,   332,   333,     0,   334,   335,   336,
     337,   338,   339,   340,   341,   342,   343,     0,   344,     0,
     345,   346,   347,   348,   349,     0,   350,     0,   351,   352,
       0,   353,   354,   355,   356,   357,     0,   358,   359,  3890,
     360,   361,   362,     0,   363,   364,   365,   366,   367,   368,
     369,   370,   371,   372,     0,   373,   374,   375,   376,   377,
     378,   379,     0,   380,   381,   382,   383,   384,   385,   386,
     387,   388,     0,   389,     0,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,     0,     0,   400,   401,   402,
     403,   404,     0,   405,   406,   407,     0,     0,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,   432,   433,   434,   435,   436,   437,   438,     0,
     439,   440,   441,   442,     0,   443,   444,   445,   446,   447,
     448,     0,   449,   450,     0,     0,   451,   452,   453,     0,
       0,   454,   455,   456,   457,   458,   459,   460,   461,   462,
     463,   464,   465,   466,   467,   468,   469,   470,     0,     0,
     471,   472,   473,   474,   475,   476,   477,   478,     0,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,   493,     0,   494,   495,   496,   497,   498,
     499,   500,   501,   502,   503,   504,   505,   506,     0,   507,
     508,   509,   510,   511,   512,   513,   514,   515,   516,   517,
     518,   519,   520,   521,   522,   523,   524,     0,   525,   526,
     527,   528,   529,   945,   530,   531,   532,   533,   534,   535,
     536,   537,   538,   539,     0,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,   552,   553,   554,
       0,   555,   556,     0,   557,   558,   559,   560,   561,   562,
     563,     0,   564,   565,   566,     0,     0,   567,   568,   569,
     570,   571,     0,   572,   573,   574,   575,   576,   577,   578,
     579,     0,     0,   580,   581,   582,   583,   584,     0,     0,
     585,   586,   587,   588,   589,   590,   591,     0,   592,   593,
     594,   595,   596,   597,     0,     0,   598,     0,     0,   599,
     600,   601,   602,   603,   604,   605,   606,   607,   608,   609,
     610,   611,   612,   613,   614,   615,   616,   617,   618,   942,
       0,     0,   685,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   236,   237,   238,   239,
     240,   241,   242,   243,     0,   244,   245,   246,     0,     0,
       0,     0,     0,     0,     0,   247,   248,   249,     0,   250,
     251,   252,   253,   254,   255,   256,   257,   258,   259,   260,
     261,   262,     0,   263,   264,   265,   266,   267,   268,   269,
       0,     0,   270,   271,   272,   273,   274,     0,   275,   276,
     277,   278,   279,     0,   280,     0,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,     0,   291,   292,   293,
     294,   295,   296,     0,   297,   298,   299,   300,     0,     0,
       0,   301,     0,     0,     0,   302,   303,   304,   305,   306,
     307,   308,   309,   310,     0,   311,     0,   312,   313,   314,
     315,   316,   317,   318,     0,   319,   320,   321,   322,     0,
       0,   323,   324,   325,   326,   327,     0,   328,   329,   330,
       0,   331,   332,   333,     0,   334,   335,   336,   337,   338,
     339,   340,   341,   342,   343,  1786,   344,     0,   345,   346,
     347,   348,   349,     0,   350,     0,   351,   352,     0,   353,
     354,   355,   356,   357,     0,   358,   359,     0,   360,   361,
     362,     0,   363,   364,   365,   366,   367,   368,   369,   370,
     371,   372,     0,   373,   374,   375,   376,   377,   378,   379,
       0,   380,   381,   382,   383,   384,   385,   386,   387,   388,
       0,   389,     0,   390,   391,   392,   393,   394,   395,   396,
     397,   398,   399,     0,     0,   400,   401,   402,   403,   404,
       0,   405,   406,   407,     0,     0,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,   427,   428,   429,   430,   431,
     432,   433,   434,   435,   436,   437,   438,     0,   439,   440,
     441,   442,     0,   443,   444,   445,   446,   447,   448,     0,
     449,   450,  1787,     0,   451,   452,   453,     0,     0,   454,
     455,   456,   457,   458,   459,   460,   461,   462,   463,   464,
     465,   466,   467,   468,   469,   470,     0,     0,   471,   472,
     473,   474,   475,   476,   477,   478,     0,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,   490,   491,
     492,   493,     0,   494,   495,   496,   497,   498,   499,   500,
     501,   502,   503,   504,   505,   506,     0,   507,   508,   509,
     510,   511,   512,   513,   514,   515,   516,   517,   518,   519,
     520,   521,   522,   523,   524,     0,   525,   526,   527,   528,
     529,     0,   530,   531,   532,   533,   534,   535,   536,   537,
     538,   539,     0,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,   551,   552,   553,   554,     0,   555,
     556,     0,   557,   558,   559,   560,   561,   562,   563,     0,
     564,   565,   566,     0,     0,   567,   568,   569,   570,   571,
    1788,   572,   573,   574,   575,   576,   577,   578,   579,     0,
       0,   580,   581,   582,   583,   584,     0,     0,   585,   586,
     587,   588,   589,   590,   591,     0,   592,   593,   594,   595,
     596,   597,     0,     0,   598,     0,     0,   599,   600,   601,
     602,   603,   604,   605,   606,   607,   608,   609,   610,   611,
     612,   613,   614,   615,   616,   617,   618,   942,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   236,   237,   238,   239,   240,   241,
     242,   243,     0,   244,   245,   246,     0,     0,     0,     0,
       0,     0,     0,   247,   248,   249,     0,   250,   251,   252,
     253,   254,   255,   256,   257,   258,   259,   260,   261,   262,
       0,   263,   264,   265,   266,   267,   268,   269,     0,     0,
     270,   271,   272,   273,   274,     0,   275,   276,   277,   278,
     279,     0,   280,     0,   281,   282,   283,   284,   285,   286,
     287,   288,   289,   290,     0,   291,   292,   293,   294,   295,
     296,     0,   297,   298,   299,   300,     0,     0,   943,   301,
       0,     0,   944,   302,   303,   304,   305,   306,   307,   308,
     309,   310,     0,   311,     0,   312,   313,   314,   315,   316,
     317,   318,     0,   319,   320,   321,   322,     0,     0,   323,
     324,   325,   326,   327,     0,   328,   329,   330,     0,   331,
     332,   333,     0,   334,   335,   336,   337,   338,   339,   340,
     341,   342,   343,     0,   344,     0,   345,   346,   347,   348,
     349,     0,   350,     0,   351,   352,     0,   353,   354,   355,
     356,   357,     0,   358,   359,     0,   360,   361,   362,     0,
     363,   364,   365,   366,   367,   368,   369,   370,   371,   372,
       0,   373,   374,   375,   376,   377,   378,   379,     0,   380,
     381,   382,   383,   384,   385,   386,   387,   388,     0,   389,
       0,   390,   391,   392,   393,   394,   395,   396,   397,   398,
     399,     0,     0,   400,   401,   402,   403,   404,     0,   405,
     406,   407,     0,     0,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   431,   432,   433,
     434,   435,   436,   437,   438,     0,   439,   440,   441,   442,
       0,   443,   444,   445,   446,   447,   448,     0,   449,   450,
       0,     0,   451,   452,   453,     0,     0,   454,   455,   456,
     457,   458,   459,   460,   461,   462,   463,   464,   465,   466,
     467,   468,   469,   470,     0,     0,   471,   472,   473,   474,
     475,   476,   477,   478,     0,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   490,   491,   492,   493,
       0,   494,   495,   496,   497,   498,   499,   500,   501,   502,
     503,   504,   505,   506,     0,   507,   508,   509,   510,   511,
     512,   513,   514,   515,   516,   517,   518,   519,   520,   521,
     522,   523,   524,     0,   525,   526,   527,   528,   529,   945,
     530,   531,   532,   533,   534,   535,   536,   537,   538,   539,
       0,   540,   541,   542,   543,   544,   545,   546,   547,   548,
     549,   550,   551,   552,   553,   554,     0,   555,   556,     0,
     557,   558,   559,   560,   561,   562,   563,     0,   564,   565,
     566,     0,     0,   567,   568,   569,   570,   571,     0,   572,
     573,   574,   575,   576,   577,   578,   579,     0,     0,   580,
     581,   582,   583,   584,     0,     0,   585,   586,   587,   588,
     589,   590,   591,     0,   592,   593,   594,   595,   596,   597,
       0,     0,   598,     0,     0,   599,   600,   601,   602,   603,
     604,   605,   606,   607,   608,   609,   610,   611,   612,   613,
     614,   615,   616,   617,   618,   942,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   236,   237,   238,   239,   240,   241,   242,   243,
       0,   244,   245,   246,     0,     0,     0,     0,     0,     0,
       0,   247,   248,   249,     0,   250,   251,   252,   253,   254,
     255,   256,   257,   258,   259,   260,   261,   262,     0,   263,
     264,   265,   266,   267,   268,   269,     0,     0,   270,   271,
     272,   273,   274,     0,   275,   276,   277,   278,   279,     0,
     280,     0,   281,   282,   283,   284,   285,   286,   287,   288,
     289,   290,     0,   291,   292,   293,   294,   295,   296,     0,
     297,   298,   299,   300,     0,     0,   943,   301,     0,     0,
     944,   302,   303,   304,   305,   306,   307,   308,   309,   310,
       0,   311,     0,   312,   313,   314,   315,   316,   317,   318,
       0,   319,   320,   321,   322,     0,     0,   323,   324,   325,
     326,   327,     0,   328,   329,   330,     0,   331,   332,   333,
       0,   334,   335,   336,   337,   338,   339,   340,   341,   342,
     343,     0,   344,     0,   345,   346,   347,   348,   349,     0,
     350,     0,   351,   352,     0,   353,   354,   355,   356,   357,
       0,   358,   359,     0,   360,   361,   362,     0,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,     0,   373,
     374,   375,   376,   377,   378,   379,     0,   380,   381,   382,
     383,   384,   385,   386,   387,   388,     0,   389,     0,   390,
     391,   392,   393,   394,   395,   396,   397,   398,   399,     0,
       0,   400,   401,   402,   403,   404,     0,   405,   406,   407,
       0,     0,   408,   409,   410,   411,  1095,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438,     0,   439,   440,   441,   442,     0,   443,
     444,   445,   446,   447,   448,     0,   449,   450,     0,     0,
     451,   452,   453,     0,     0,   454,   455,   456,   457,   458,
     459,   460,   461,   462,   463,   464,   465,   466,   467,   468,
     469,   470,     0,     0,   471,   472,   473,   474,   475,   476,
     477,   478,     0,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,   492,   493,     0,   494,
     495,   496,   497,   498,   499,   500,   501,   502,   503,   504,
     505,   506,     0,   507,   508,   509,   510,   511,   512,   513,
     514,   515,   516,   517,   518,   519,   520,   521,   522,   523,
     524,     0,   525,   526,   527,   528,   529,   945,   530,   531,
     532,   533,   534,   535,   536,   537,   538,   539,     0,   540,
     541,   542,   543,   544,   545,   546,   547,   548,   549,   550,
     551,   552,   553,   554,     0,   555,   556,     0,   557,   558,
     559,   560,   561,   562,   563,     0,   564,   565,   566,     0,
       0,   567,   568,   569,   570,   571,     0,   572,   573,   574,
     575,   576,   577,   578,   579,     0,     0,   580,   581,   582,
     583,   584,     0,     0,   585,   586,   587,   588,   589,   590,
     591,     0,   592,   593,   594,   595,   596,   597,     0,     0,
     598,     0,     0,   599,   600,   601,   602,   603,   604,   605,
     606,   607,   608,   609,   610,   611,   612,   613,   614,   615,
     616,   617,   618,   942,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     236,   237,   238,   239,   240,   241,   242,   243,     0,   244,
     245,   246,     0,     0,     0,     0,     0,     0,     0,   247,
     248,   249,     0,   250,   251,   252,   253,   254,   255,   256,
     257,   258,   259,   260,   261,   262,     0,   263,   264,   265,
     266,   267,   268,   269,     0,     0,   270,   271,   272,   273,
     274,     0,   275,   276,   277,   278,   279,     0,   280,     0,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
       0,   291,   292,   293,   294,   295,   296,     0,   297,   298,
     299,   300,     0,     0,   943,   301,     0,     0,   944,   302,
     303,   304,   305,   306,   307,   308,   309,   310,     0,   311,
       0,   312,   313,   314,   315,   316,   317,   318,     0,   319,
     320,   321,   322,     0,     0,   323,   324,   325,   326,   327,
       0,   328,   329,   330,     0,   331,   332,   333,     0,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,     0,
     344,     0,   345,   346,   347,   348,   349,     0,   350,     0,
     351,   352,     0,   353,   354,   355,   356,   357,     0,   358,
     359,     0,   360,   361,   362,     0,   363,   364,   365,   366,
    1137,   368,   369,   370,   371,   372,     0,   373,   374,   375,
     376,   377,   378,   379,     0,   380,   381,   382,   383,   384,
     385,   386,   387,   388,     0,   389,     0,   390,   391,   392,
     393,   394,   395,   396,   397,   398,   399,     0,     0,   400,
     401,   402,   403,   404,     0,   405,   406,   407,     0,     0,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
     438,     0,   439,   440,   441,   442,     0,   443,   444,   445,
     446,   447,   448,     0,   449,   450,     0,     0,   451,   452,
     453,     0,     0,   454,   455,   456,   457,   458,   459,   460,
     461,   462,   463,   464,   465,   466,   467,   468,   469,   470,
       0,     0,   471,   472,   473,   474,   475,   476,   477,   478,
       0,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,   490,   491,   492,   493,     0,   494,   495,   496,
     497,   498,   499,   500,   501,   502,   503,   504,   505,   506,
       0,   507,   508,   509,   510,   511,   512,   513,   514,   515,
     516,   517,   518,   519,   520,   521,   522,   523,   524,     0,
     525,   526,   527,   528,   529,   945,   530,   531,   532,   533,
     534,   535,   536,   537,   538,   539,     0,   540,   541,   542,
     543,   544,   545,   546,   547,   548,   549,   550,   551,   552,
     553,   554,     0,   555,   556,     0,   557,   558,   559,   560,
     561,   562,   563,     0,   564,   565,   566,     0,     0,   567,
     568,   569,   570,   571,     0,   572,   573,   574,   575,   576,
     577,   578,   579,     0,     0,   580,   581,   582,   583,   584,
       0,     0,   585,   586,   587,   588,   589,   590,   591,     0,
     592,   593,   594,   595,   596,   597,     0,     0,   598,     0,
       0,   599,   600,   601,   602,   603,   604,   605,   606,   607,
     608,   609,   610,   611,   612,   613,   614,   615,   616,   617,
     618,   942,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   236,   237,
     238,   239,   240,   241,   242,   243,     0,   244,   245,   246,
       0,     0,     0,     0,     0,     0,     0,   247,   248,   249,
       0,   250,   251,   252,   253,   254,   255,   256,   257,   258,
     259,   260,   261,   262,     0,   263,   264,   265,   266,   267,
     268,   269,     0,     0,   270,   271,   272,   273,   274,     0,
     275,   276,   277,   278,   279,     0,   280,     0,   281,   282,
     283,   284,   285,   286,   287,   288,   289,   290,     0,   291,
     292,   293,   294,   295,   296,     0,   297,   298,   299,   300,
       0,     0,   943,   301,     0,     0,   944,   302,   303,   304,
     305,   306,   307,   308,   309,   310,     0,   311,     0,   312,
     313,   314,   315,   316,   317,   318,     0,   319,   320,   321,
     322,     0,     0,   323,   324,   325,   326,   327,     0,   328,
     329,   330,     0,   331,   332,   333,     0,   334,   335,   336,
     337,   338,   339,   340,   341,   342,   343,     0,   344,     0,
     345,   346,   347,   348,   349,     0,   350,     0,   351,   352,
       0,   353,   354,   355,   356,   357,     0,   358,   359,     0,
     360,   361,   362,     0,   363,   364,   365,   366,  1150,   368,
     369,   370,   371,   372,     0,   373,   374,   375,   376,   377,
     378,   379,     0,   380,   381,   382,   383,   384,   385,   386,
     387,   388,     0,   389,     0,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,     0,     0,   400,   401,   402,
     403,   404,     0,   405,   406,   407,     0,     0,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,   432,   433,   434,   435,   436,   437,   438,     0,
     439,   440,   441,   442,     0,   443,   444,   445,   446,   447,
     448,     0,   449,   450,     0,     0,   451,   452,   453,     0,
       0,   454,   455,   456,   457,   458,   459,   460,   461,   462,
     463,   464,   465,   466,   467,   468,   469,   470,     0,     0,
     471,   472,   473,   474,   475,   476,   477,   478,     0,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,   493,     0,   494,   495,   496,   497,   498,
     499,   500,   501,   502,   503,   504,   505,   506,     0,   507,
     508,   509,   510,   511,   512,   513,   514,   515,   516,   517,
     518,   519,   520,   521,   522,   523,   524,     0,   525,   526,
     527,   528,   529,   945,   530,   531,   532,   533,   534,   535,
     536,   537,   538,   539,     0,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,   552,   553,   554,
       0,   555,   556,     0,   557,   558,   559,   560,   561,   562,
     563,     0,   564,   565,   566,     0,     0,   567,   568,   569,
     570,   571,     0,   572,   573,   574,   575,   576,   577,   578,
     579,     0,     0,   580,   581,   582,   583,   584,     0,     0,
     585,   586,   587,   588,   589,   590,   591,     0,   592,   593,
     594,   595,   596,   597,     0,     0,   598,     0,     0,   599,
     600,   601,   602,   603,   604,   605,   606,   607,   608,   609,
     610,   611,   612,   613,   614,   615,   616,   617,   618,   942,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   236,   237,   238,   239,
     240,   241,   242,   243,     0,   244,   245,   246,     0,     0,
       0,     0,     0,     0,     0,   247,   248,   249,     0,   250,
     251,   252,   253,   254,   255,   256,   257,   258,   259,   260,
     261,   262,     0,   263,   264,   265,   266,   267,   268,   269,
       0,     0,   270,   271,   272,   273,   274,     0,   275,   276,
     277,   278,   279,     0,   280,     0,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,     0,   291,   292,   293,
     294,   295,   296,     0,   297,   298,   299,   300,     0,     0,
     943,   301,     0,     0,   944,   302,   303,   304,   305,   306,
     307,   308,   309,   310,     0,   311,     0,   312,   313,   314,
     315,   316,   317,   318,     0,   319,   320,   321,   322,     0,
       0,   323,   324,   325,   326,   327,     0,   328,   329,   330,
       0,   331,   332,   333,     0,   334,   335,   336,   337,   338,
     339,   340,   341,   342,   343,     0,   344,     0,   345,   346,
     347,   348,   349,     0,   350,     0,   351,   352,     0,   353,
     354,   355,   356,   357,     0,   358,   359,     0,   360,   361,
     362,     0,   363,   364,   365,   366,  1162,   368,   369,   370,
     371,   372,     0,   373,   374,   375,   376,   377,   378,   379,
       0,   380,   381,   382,   383,   384,   385,   386,   387,   388,
       0,   389,     0,   390,   391,   392,   393,   394,   395,   396,
     397,   398,   399,     0,     0,   400,   401,   402,   403,   404,
       0,   405,   406,   407,     0,     0,   408,   409,   410,   411,
    1163,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,   427,   428,   429,   430,   431,
     432,   433,   434,   435,   436,   437,   438,     0,   439,   440,
     441,   442,     0,   443,   444,   445,   446,   447,   448,     0,
     449,   450,     0,     0,   451,   452,   453,     0,     0,   454,
     455,   456,   457,   458,   459,   460,   461,   462,   463,   464,
     465,   466,   467,   468,   469,   470,     0,     0,   471,   472,
     473,   474,   475,   476,   477,   478,     0,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,   490,   491,
     492,   493,     0,   494,   495,   496,   497,   498,   499,   500,
     501,   502,   503,   504,   505,   506,     0,   507,   508,   509,
     510,   511,   512,   513,   514,   515,   516,   517,   518,   519,
     520,   521,   522,   523,   524,     0,   525,   526,   527,   528,
     529,   945,   530,   531,   532,   533,   534,   535,   536,   537,
     538,   539,     0,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,   551,   552,   553,   554,     0,   555,
     556,     0,   557,   558,   559,   560,   561,   562,   563,     0,
     564,   565,   566,     0,     0,   567,   568,   569,   570,   571,
       0,   572,   573,   574,   575,   576,   577,   578,   579,     0,
       0,   580,   581,   582,   583,   584,     0,     0,   585,   586,
     587,   588,   589,   590,   591,     0,   592,   593,   594,   595,
     596,   597,     0,     0,   598,     0,     0,   599,   600,   601,
     602,   603,   604,   605,   606,   607,   608,   609,   610,   611,
     612,   613,   614,   615,   616,   617,   618,   942,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   236,   237,   238,   239,   240,   241,
     242,   243,     0,   244,   245,   246,     3,     4,     0,     0,
       0,     0,     0,   247,   248,   249,     0,   250,   251,   252,
     253,   254,   255,   256,   257,   258,   259,   260,   261,   262,
       0,   263,   264,   265,   266,   267,   268,   269,     0,     0,
     270,   271,   272,   273,   274,     0,   275,   276,   277,   278,
     279,     0,   280,     0,   281,   282,   283,   284,   285,   286,
     287,   288,   289,   290,     0,   291,   292,   293,   294,   295,
     296,     0,   297,   298,   299,   300,     0,     0,     0,   301,
       0,     0,     0,   302,   303,   304,   305,   306,   307,   308,
     309,   310,     0,   311,     0,   312,   313,   314,   315,   316,
     317,   318,     0,   319,   320,   321,   322,     0,     0,   323,
     324,   325,   326,   327,     0,   328,   329,   330,     0,   331,
     332,   333,     0,   334,   335,   336,   337,   338,   339,   340,
     341,   342,   343,     0,   344,     0,   345,   346,   347,   348,
     349,     0,   350,     0,   351,   352,     0,   353,   354,   355,
     356,   357,     0,   358,   359,     0,   360,   361,   362,     0,
     363,   364,   365,   366,   367,   368,   369,   370,   371,   372,
       0,   373,   374,   375,   376,   377,   378,   379,     0,   380,
     381,   382,   383,   384,   385,   386,   387,   388,     0,   389,
       0,   390,   391,   392,   393,   394,   395,   396,   397,   398,
     399,     0,     0,   400,   401,   402,   403,   404,     0,   405,
     406,   407,     0,     0,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   431,   432,   433,
     434,   435,   436,   437,   438,     0,   439,   440,   441,   442,
       0,   443,   444,   445,   446,   447,   448,     0,   449,   450,
       0,     0,   451,   452,   453,     0,     0,   454,   455,   456,
     457,   458,   459,   460,   461,   462,   463,   464,   465,   466,
     467,   468,   469,   470,     0,     0,   471,   472,   473,   474,
     475,   476,   477,   478,     0,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   490,   491,   492,   493,
       0,   494,   495,   496,   497,   498,   499,   500,   501,   502,
     503,   504,   505,   506,     0,   507,   508,   509,   510,   511,
     512,   513,   514,   515,   516,   517,   518,   519,   520,   521,
     522,   523,   524,     0,   525,   526,   527,   528,   529,     0,
     530,   531,   532,   533,   534,   535,   536,   537,   538,   539,
       0,   540,   541,   542,   543,   544,   545,   546,   547,   548,
     549,   550,   551,   552,   553,   554,     0,   555,   556,     0,
     557,   558,   559,   560,   561,   562,   563,     0,   564,   565,
     566,     0,     0,   567,   568,   569,   570,   571,     0,   572,
     573,   574,   575,   576,   577,   578,   579,     0,     0,   580,
     581,   582,   583,   584,     0,     0,   585,   586,   587,   588,
     589,   590,   591,     0,   592,   593,   594,   595,   596,   597,
       0,     0,   598,     0,     0,   599,   600,   601,   602,   603,
     604,   605,   606,   607,   608,   609,   610,   611,   612,   613,
     614,   615,   616,   617,   618,   942,     0,     0,   685,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   236,   237,   238,   239,   240,   241,   242,   243,
       0,   244,   245,   246,     0,     0,     0,     0,     0,     0,
       0,   247,   248,   249,     0,   250,   251,   252,   253,   254,
     255,   256,   257,   258,   259,   260,   261,   262,     0,   263,
     264,   265,   266,   267,   268,   269,     0,     0,   270,   271,
     272,   273,   274,     0,   275,   276,   277,   278,   279,     0,
     280,     0,   281,   282,   283,   284,   285,   286,   287,   288,
     289,   290,     0,   291,   292,   293,   294,   295,   296,     0,
     297,   298,   299,   300,     0,     0,     0,   301,     0,     0,
       0,   302,   303,   304,   305,   306,   307,   308,   309,   310,
    2515,   311,     0,   312,   313,   314,   315,   316,   317,   318,
       0,   319,   320,   321,   322,     0,     0,   323,   324,   325,
     326,   327,     0,   328,   329,   330,     0,   331,   332,   333,
       0,   334,   335,   336,   337,   338,   339,   340,   341,   342,
     343,     0,   344,     0,   345,   346,   347,   348,   349,     0,
     350,     0,   351,   352,     0,   353,   354,   355,   356,   357,
       0,   358,   359,     0,   360,   361,   362,     0,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,     0,   373,
     374,   375,   376,   377,   378,   379,     0,   380,   381,   382,
     383,   384,   385,   386,   387,   388,     0,   389,     0,   390,
     391,   392,   393,   394,   395,   396,   397,   398,   399,     0,
       0,   400,   401,   402,   403,   404,     0,   405,   406,   407,
       0,     0,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438,     0,   439,   440,   441,   442,     0,   443,
     444,   445,   446,   447,   448,     0,   449,   450,     0,     0,
     451,   452,   453,     0,     0,   454,   455,   456,   457,   458,
     459,   460,   461,   462,   463,   464,   465,   466,   467,   468,
     469,   470,     0,     0,   471,   472,   473,   474,   475,   476,
     477,   478,     0,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,   492,   493,     0,   494,
     495,   496,   497,   498,   499,   500,   501,   502,   503,   504,
     505,   506,     0,   507,   508,   509,   510,   511,   512,   513,
     514,   515,   516,   517,   518,   519,   520,   521,   522,   523,
     524,     0,   525,   526,   527,   528,   529,     0,   530,   531,
     532,   533,   534,   535,   536,   537,   538,   539,     0,   540,
     541,   542,   543,   544,   545,   546,   547,   548,   549,   550,
     551,   552,   553,   554,     0,   555,   556,     0,   557,   558,
     559,   560,   561,   562,   563,     0,   564,   565,   566,     0,
       0,   567,   568,   569,   570,   571,     0,   572,   573,   574,
     575,   576,   577,   578,   579,     0,     0,   580,   581,   582,
     583,   584,     0,     0,   585,   586,   587,   588,   589,   590,
     591,     0,   592,   593,   594,   595,   596,   597,     0,     0,
     598,     0,     0,   599,   600,   601,   602,   603,   604,   605,
     606,   607,   608,   609,   610,   611,   612,   613,   614,   615,
     616,   617,   618,   942,     0,     0,   685,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     236,   237,   238,   239,   240,   241,   242,   243,     0,   244,
     245,   246,     0,     0,     0,     0,     0,     0,     0,   247,
     248,   249,     0,   250,   251,   252,   253,   254,   255,   256,
     257,   258,   259,   260,   261,   262,     0,   263,   264,   265,
     266,   267,   268,   269,     0,     0,   270,   271,   272,   273,
     274,     0,   275,   276,   277,   278,   279,     0,   280,     0,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
       0,   291,   292,   293,   294,   295,   296,     0,   297,   298,
     299,   300,     0,     0,     0,   301,     0,     0,     0,   302,
     303,   304,   305,   306,   307,   308,   309,   310,     0,   311,
       0,   312,   313,   314,   315,   316,   317,   318,     0,   319,
     320,   321,   322,     0,     0,   323,   324,   325,   326,   327,
       0,   328,   329,   330,     0,   331,   332,   333,     0,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,     0,
     344,     0,   345,   346,   347,   348,   349,     0,   350,     0,
     351,   352,     0,   353,   354,   355,   356,   357,     0,   358,
     359,     0,   360,   361,   362,     0,   363,   364,   365,   366,
     367,   368,   369,   370,   371,   372,     0,   373,   374,   375,
     376,   377,   378,   379,     0,   380,   381,   382,   383,   384,
     385,   386,   387,   388,     0,   389,     0,   390,   391,   392,
     393,   394,   395,   396,   397,   398,   399,     0,     0,   400,
     401,   402,   403,   404,     0,   405,   406,   407,     0,     0,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
     438,     0,   439,   440,   441,   442,     0,   443,   444,   445,
     446,   447,   448,     0,   449,   450,     0,     0,   451,   452,
     453,     0,     0,   454,   455,   456,   457,   458,   459,   460,
     461,   462,   463,   464,   465,   466,   467,   468,   469,   470,
       0,     0,   471,   472,   473,   474,   475,   476,   477,   478,
       0,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,   490,   491,   492,   493,     0,   494,   495,   496,
     497,   498,   499,   500,   501,   502,   503,   504,   505,   506,
       0,   507,   508,   509,   510,   511,   512,   513,   514,   515,
     516,   517,   518,   519,   520,   521,   522,   523,   524,     0,
     525,   526,   527,   528,   529,     0,   530,   531,   532,   533,
     534,   535,   536,   537,   538,   539,     0,   540,   541,   542,
     543,   544,   545,   546,   547,   548,   549,   550,   551,   552,
     553,   554,     0,   555,   556,     0,   557,   558,   559,   560,
     561,   562,   563,     0,   564,   565,   566,     0,     0,   567,
     568,   569,   570,   571,     0,   572,   573,   574,   575,   576,
     577,   578,   579,     0,     0,   580,   581,   582,   583,   584,
       0,     0,   585,   586,   587,   588,   589,   590,   591,     0,
     592,   593,   594,   595,   596,   597,     0,     0,   598,     0,
       0,   599,   600,   601,   602,   603,   604,   605,   606,   607,
     608,   609,   610,   611,   612,   613,   614,   615,   616,   617,
     618,   235,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   236,   237,
     238,   239,   240,   241,   242,   243,     0,   244,   245,   246,
       0,     0,     0,     0,     0,     0,     0,   247,   248,   249,
       0,   250,   251,   252,   253,   254,   255,   256,   257,   258,
     259,   260,   261,   262,     0,   263,   264,   265,   266,   267,
     268,   269,     0,     0,   270,   271,   272,   273,   274,     0,
     275,   276,   277,   278,   279,     0,   280,     0,   281,   282,
     283,   284,   285,   286,   287,   288,   289,   290,     0,   291,
     292,   293,   294,   295,   296,     0,   297,   298,   299,   300,
       0,     0,     0,   301,     0,     0,     0,   302,   303,   304,
     305,   306,   307,   308,   309,   310,     0,   311,     0,   312,
     313,   314,   315,   316,   317,   318,     0,   319,   320,   321,
     322,     0,     0,   323,   324,   325,   326,   327,     0,   328,
     329,   330,     0,   331,   332,   333,     0,   334,   335,   336,
     337,   338,   339,   340,   341,   342,   343,     0,   344,     0,
     345,   346,   347,   348,   349,     0,   350,     0,   351,   352,
       0,   353,   354,   355,   356,   357,     0,   358,   359,     0,
     360,   361,   362,     0,   363,   364,   365,   366,   367,   368,
     369,   370,   371,   372,     0,   373,   374,   375,   376,   377,
     378,   379,     0,   380,   381,   382,   383,   384,   385,   386,
     387,   388,     0,   389,     0,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,     0,     0,   400,   401,   402,
     403,   404,     0,   405,   406,   407,     0,     0,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,   432,   433,   434,   435,   436,   437,   438,     0,
     439,   440,   441,   442,     0,   443,   444,   445,   446,   447,
     448,     0,   449,   450,     0,     0,   451,   452,   453,     0,
       0,   454,   455,   456,   457,   458,   459,   460,   461,   462,
     463,   464,   465,   466,   467,   468,   469,   470,     0,     0,
     471,   472,   473,   474,   475,   476,   477,   478,     0,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,   493,     0,   494,   495,   496,   497,   498,
     499,   500,   501,   502,   503,   504,   505,   506,     0,   507,
     508,   509,   510,   511,   512,   513,   514,   515,   516,   517,
     518,   519,   520,   521,   522,   523,   524,     0,   525,   526,
     527,   528,   529,     0,   530,   531,   532,   533,   534,   535,
     536,   537,   538,   539,     0,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,   552,   553,   554,
       0,   555,   556,     0,   557,   558,   559,   560,   561,   562,
     563,     0,   564,   565,   566,     0,     0,   567,   568,   569,
     570,   571,     0,   572,   573,   574,   575,   576,   577,   578,
     579,     0,     0,   580,   581,   582,   583,   584,     0,     0,
     585,   586,   587,   588,   589,   590,   591,     0,   592,   593,
     594,   595,   596,   597,     0,     0,   598,     0,     0,   599,
     600,   601,   602,   603,   604,   605,   606,   607,   608,   609,
     610,   611,   612,   613,   614,   615,   616,   617,   618,   235,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   236,   237,   238,   239,
     240,   241,   242,   243,     0,   244,   245,   246,     0,     0,
       0,     0,     0,     0,     0,   247,   248,   249,     0,   250,
     251,   252,   253,   254,   255,   256,   257,   258,   259,   260,
     261,   262,     0,   263,   264,   265,   266,   267,   268,   269,
       0,     0,   270,   271,   272,   273,   274,     0,   275,   276,
     277,   278,   279,     0,   280,     0,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,     0,   291,   292,   293,
     294,   295,   296,     0,   297,   298,   299,   300,     0,     0,
       0,   301,     0,     0,     0,   302,   303,   304,   305,   306,
     307,   308,   309,   310,     0,   311,     0,   312,   313,   314,
     315,   316,   317,   318,     0,   319,   320,   321,   322,     0,
       0,   323,   324,   325,   326,   327,     0,   328,   329,   330,
       0,   331,   332,   333,     0,   334,   335,   336,   337,   338,
     339,   340,   341,   342,   343,     0,   344,     0,   345,   346,
     347,   348,   349,     0,   350,     0,   351,   352,     0,   353,
     354,   355,   356,   357,     0,   358,   359,     0,   360,   361,
     362,     0,   363,   364,   365,   366,  1121,   368,   369,   370,
     371,   372,     0,   373,   374,   375,   376,   377,   378,   379,
       0,   380,   381,   382,   383,   384,   385,   386,   387,   388,
       0,   389,     0,   390,   391,   392,   393,   394,   395,   396,
     397,   398,   399,     0,     0,   400,   401,   402,   403,   404,
       0,   405,   406,   407,     0,     0,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,   427,   428,   429,   430,   431,
     432,   433,   434,   435,   436,   437,   438,     0,   439,   440,
     441,   442,     0,   443,   444,   445,   446,   447,   448,     0,
     449,   450,     0,     0,   451,   452,   453,     0,     0,   454,
     455,   456,   457,   458,   459,   460,   461,   462,   463,   464,
     465,   466,   467,   468,   469,   470,     0,     0,   471,   472,
     473,   474,   475,   476,   477,   478,     0,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,   490,   491,
     492,   493,     0,   494,   495,   496,   497,   498,   499,   500,
     501,   502,   503,   504,   505,   506,     0,   507,   508,   509,
     510,   511,   512,   513,   514,   515,   516,   517,   518,   519,
     520,   521,   522,   523,   524,     0,   525,   526,   527,   528,
     529,     0,   530,   531,   532,   533,   534,   535,   536,   537,
     538,   539,     0,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,   551,   552,   553,   554,     0,   555,
     556,     0,   557,   558,   559,   560,   561,   562,   563,     0,
     564,   565,   566,     0,     0,   567,   568,   569,   570,   571,
       0,   572,   573,   574,   575,   576,   577,   578,   579,     0,
       0,   580,   581,   582,   583,   584,     0,     0,   585,   586,
     587,   588,   589,   590,   591,     0,   592,   593,   594,   595,
     596,   597,     0,     0,   598,     0,     0,   599,   600,   601,
     602,   603,   604,   605,   606,   607,   608,   609,   610,   611,
     612,   613,   614,   615,   616,   617,   618,   235,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   236,   237,   238,   239,   240,   241,
     242,   243,     0,   244,   245,   246,     0,     0,     0,     0,
       0,     0,     0,   247,   248,   249,     0,   250,   251,   252,
     253,   254,   255,   256,   257,   258,   259,   260,   261,   262,
       0,   263,   264,   265,   266,   267,   268,   269,     0,     0,
     270,   271,   272,   273,   274,     0,   275,   276,   277,   278,
     279,     0,   280,     0,   281,   282,   283,   284,   285,   286,
     287,   288,   289,   290,     0,   291,   292,   293,   294,   295,
     296,     0,   297,   298,   299,   300,     0,     0,     0,   301,
       0,     0,     0,   302,   303,   304,   305,   306,   307,   308,
     309,   310,     0,   311,     0,   312,   313,   314,   315,   316,
     317,   318,     0,   319,   320,   321,   322,     0,     0,   323,
     324,   325,   326,   327,     0,   328,   329,   330,     0,   331,
     332,   333,     0,   334,   335,   336,   337,   338,   339,   340,
     341,   342,   343,     0,   344,     0,   345,   346,   347,   348,
     349,     0,   350,     0,   351,   352,     0,   353,   354,   355,
     356,   357,     0,   358,   359,     0,   360,   361,   362,     0,
     363,   364,   365,   366,  1134,   368,   369,   370,   371,   372,
       0,   373,   374,   375,   376,   377,   378,   379,     0,   380,
     381,   382,   383,   384,   385,   386,   387,   388,     0,   389,
       0,   390,   391,   392,   393,   394,   395,   396,   397,   398,
     399,     0,     0,   400,   401,   402,   403,   404,     0,   405,
     406,   407,     0,     0,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   431,   432,   433,
     434,   435,   436,   437,   438,     0,   439,   440,   441,   442,
       0,   443,   444,   445,   446,   447,   448,     0,   449,   450,
       0,     0,   451,   452,   453,     0,     0,   454,   455,   456,
     457,   458,   459,   460,   461,   462,   463,   464,   465,   466,
     467,   468,   469,   470,     0,     0,   471,   472,   473,   474,
     475,   476,   477,   478,     0,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   490,   491,   492,   493,
       0,   494,   495,   496,   497,   498,   499,   500,   501,   502,
     503,   504,   505,   506,     0,   507,   508,   509,   510,   511,
     512,   513,   514,   515,   516,   517,   518,   519,   520,   521,
     522,   523,   524,     0,   525,   526,   527,   528,   529,     0,
     530,   531,   532,   533,   534,   535,   536,   537,   538,   539,
       0,   540,   541,   542,   543,   544,   545,   546,   547,   548,
     549,   550,   551,   552,   553,   554,     0,   555,   556,     0,
     557,   558,   559,   560,   561,   562,   563,     0,   564,   565,
     566,     0,     0,   567,   568,   569,   570,   571,     0,   572,
     573,   574,   575,   576,   577,   578,   579,     0,     0,   580,
     581,   582,   583,   584,     0,     0,   585,   586,   587,   588,
     589,   590,   591,     0,   592,   593,   594,   595,   596,   597,
       0,     0,   598,     0,     0,   599,   600,   601,   602,   603,
     604,   605,   606,   607,   608,   609,   610,   611,   612,   613,
     614,   615,   616,   617,   618,   235,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   236,   237,   238,   239,   240,   241,   242,   243,
       0,   244,   245,   246,     0,     0,     0,     0,     0,     0,
       0,   247,   248,   249,     0,   250,   251,   252,   253,   254,
     255,   256,   257,   258,   259,   260,   261,   262,     0,   263,
     264,   265,   266,   267,   268,   269,     0,     0,   270,   271,
     272,   273,   274,     0,   275,   276,   277,   278,   279,     0,
     280,     0,   281,   282,   283,   284,   285,   286,   287,   288,
     289,   290,     0,   291,   292,   293,   294,   295,   296,     0,
     297,   298,   299,   300,     0,     0,     0,   301,     0,     0,
       0,   302,   303,   304,   305,   306,   307,   308,   309,   310,
       0,   311,     0,   312,   313,   314,   315,   316,   317,   318,
       0,   319,   320,   321,   322,     0,     0,   323,   324,   325,
     326,   327,     0,   328,   329,   330,     0,   331,   332,   333,
       0,   334,   335,   336,   337,   338,   339,   340,   341,   342,
     343,     0,   344,     0,   345,   346,   347,   348,   349,     0,
     350,     0,   351,   352,     0,   353,   354,   355,   356,   357,
       0,   358,   359,     0,   360,   361,   362,     0,   363,   364,
     365,   366,  1148,   368,   369,   370,   371,   372,     0,   373,
     374,   375,   376,   377,   378,   379,     0,   380,   381,   382,
     383,   384,   385,   386,   387,   388,     0,   389,     0,   390,
     391,   392,   393,   394,   395,   396,   397,   398,   399,     0,
       0,   400,   401,   402,   403,   404,     0,   405,   406,   407,
       0,     0,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438,     0,   439,   440,   441,   442,     0,   443,
     444,   445,   446,   447,   448,     0,   449,   450,     0,     0,
     451,   452,   453,     0,     0,   454,   455,   456,   457,   458,
     459,   460,   461,   462,   463,   464,   465,   466,   467,   468,
     469,   470,     0,     0,   471,   472,   473,   474,   475,   476,
     477,   478,     0,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,   492,   493,     0,   494,
     495,   496,   497,   498,   499,   500,   501,   502,   503,   504,
     505,   506,     0,   507,   508,   509,   510,   511,   512,   513,
     514,   515,   516,   517,   518,   519,   520,   521,   522,   523,
     524,     0,   525,   526,   527,   528,   529,     0,   530,   531,
     532,   533,   534,   535,   536,   537,   538,   539,     0,   540,
     541,   542,   543,   544,   545,   546,   547,   548,   549,   550,
     551,   552,   553,   554,     0,   555,   556,     0,   557,   558,
     559,   560,   561,   562,   563,     0,   564,   565,   566,     0,
       0,   567,   568,   569,   570,   571,     0,   572,   573,   574,
     575,   576,   577,   578,   579,     0,     0,   580,   581,   582,
     583,   584,     0,     0,   585,   586,   587,   588,   589,   590,
     591,     0,   592,   593,   594,   595,   596,   597,     0,     0,
     598,     0,     0,   599,   600,   601,   602,   603,   604,   605,
     606,   607,   608,   609,   610,   611,   612,   613,   614,   615,
     616,   617,   618,   235,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     236,   237,   238,   239,   240,   241,   242,   243,     0,   244,
     245,   246,     0,     0,     0,     0,     0,     0,     0,   247,
     248,   249,     0,   250,   251,   252,   253,   254,   255,   256,
     257,   258,   259,   260,   261,   262,     0,   263,   264,   265,
     266,   267,   268,   269,     0,     0,   270,   271,   272,   273,
     274,     0,   275,   276,   277,   278,   279,     0,   280,     0,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
       0,   291,   292,   293,   294,   295,   296,     0,   297,   298,
     299,   300,     0,     0,     0,   301,     0,     0,     0,   302,
     303,   304,   305,   306,   307,   308,   309,   310,     0,   311,
       0,   312,   313,   314,   315,   316,   317,   318,     0,   319,
     320,   321,   322,     0,     0,   323,   324,   325,   326,   327,
       0,   328,   329,   330,     0,   331,   332,   333,     0,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,     0,
     344,     0,   345,   346,   347,   348,   349,     0,   350,     0,
     351,   352,     0,   353,   354,   355,   356,   357,     0,   358,
     359,     0,   360,   361,   362,     0,   363,   364,   365,   366,
    1152,   368,   369,   370,   371,   372,     0,   373,   374,   375,
     376,   377,   378,   379,     0,   380,   381,   382,   383,   384,
     385,   386,   387,   388,     0,   389,     0,   390,   391,   392,
     393,   394,   395,   396,   397,   398,   399,     0,     0,   400,
     401,   402,   403,   404,     0,   405,   406,   407,     0,     0,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
     438,     0,   439,   440,   441,   442,     0,   443,   444,   445,
     446,   447,   448,     0,   449,   450,     0,     0,   451,   452,
     453,     0,     0,   454,   455,   456,   457,   458,   459,   460,
     461,   462,   463,   464,   465,   466,   467,   468,   469,   470,
       0,     0,   471,   472,   473,   474,   475,   476,   477,   478,
       0,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,   490,   491,   492,   493,     0,   494,   495,   496,
     497,   498,   499,   500,   501,   502,   503,   504,   505,   506,
       0,   507,   508,   509,   510,   511,   512,   513,   514,   515,
     516,   517,   518,   519,   520,   521,   522,   523,   524,     0,
     525,   526,   527,   528,   529,     0,   530,   531,   532,   533,
     534,   535,   536,   537,   538,   539,     0,   540,   541,   542,
     543,   544,   545,   546,   547,   548,   549,   550,   551,   552,
     553,   554,     0,   555,   556,     0,   557,   558,   559,   560,
     561,   562,   563,     0,   564,   565,   566,     0,     0,   567,
     568,   569,   570,   571,     0,   572,   573,   574,   575,   576,
     577,   578,   579,     0,     0,   580,   581,   582,   583,   584,
       0,     0,   585,   586,   587,   588,   589,   590,   591,     0,
     592,   593,   594,   595,   596,   597,     0,     0,   598,     0,
       0,   599,   600,   601,   602,   603,   604,   605,   606,   607,
     608,   609,   610,   611,   612,   613,   614,   615,   616,   617,
     618,   942,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   236,   237,
     238,   239,   240,   241,   242,   243,     0,   244,   245,   246,
       0,     0,     0,     0,     0,     0,     0,   247,   248,   249,
       0,   250,   251,   252,   253,   254,   255,   256,   257,   258,
     259,   260,   261,   262,     0,   263,   264,   265,   266,   267,
     268,   269,     0,     0,   270,   271,   272,   273,   274,     0,
     275,   276,   277,   278,   279,     0,   280,     0,   281,   282,
     283,   284,   285,   286,   287,   288,   289,   290,     0,   291,
     292,   293,   294,   295,   296,     0,   297,   298,   299,   300,
       0,     0,     0,   301,     0,     0,     0,   302,   303,   304,
     305,   306,   307,   308,   309,   310,     0,   311,     0,   312,
     313,   314,   315,   316,   317,   318,     0,   319,   320,   321,
     322,     0,     0,   323,   324,   325,   326,   327,     0,   328,
     329,   330,     0,   331,   332,   333,     0,   334,   335,   336,
     337,   338,   339,   340,   341,   342,   343,     0,   344,     0,
     345,   346,   347,   348,   349,     0,   350,     0,   351,   352,
       0,   353,   354,   355,   356,   357,     0,   358,   359,     0,
     360,   361,   362,     0,   363,   364,   365,   366,   367,   368,
     369,   370,   371,   372,     0,   373,   374,   375,   376,   377,
     378,   379,     0,   380,   381,   382,   383,   384,   385,   386,
     387,   388,     0,   389,     0,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,     0,     0,   400,   401,   402,
     403,   404,     0,   405,   406,   407,     0,     0,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,   432,   433,   434,   435,   436,   437,   438,     0,
     439,   440,   441,   442,     0,   443,   444,   445,   446,   447,
     448,     0,   449,   450,     0,     0,   451,   452,   453,     0,
       0,   454,   455,   456,   457,   458,   459,   460,   461,   462,
     463,   464,   465,   466,   467,   468,   469,   470,     0,     0,
     471,   472,   473,   474,   475,   476,   477,   478,     0,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,   493,     0,   494,   495,   496,   497,   498,
     499,   500,   501,   502,   503,   504,   505,   506,     0,   507,
     508,   509,   510,   511,   512,   513,   514,   515,   516,   517,
     518,   519,   520,   521,   522,   523,   524,     0,   525,   526,
     527,   528,   529,     0,   530,   531,   532,   533,   534,   535,
     536,   537,   538,   539,     0,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,   552,   553,   554,
       0,   555,   556,     0,   557,   558,   559,   560,   561,   562,
     563,     0,   564,   565,   566,     0,     0,   567,   568,   569,
     570,   571,     0,   572,   573,   574,   575,   576,   577,   578,
     579,     0,     0,   580,   581,   582,   583,   584,     0,     0,
     585,   586,   587,   588,   589,   590,   591,     0,   592,   593,
     594,   595,   596,   597,     0,     0,   598,     0,     0,   599,
     600,   601,   602,   603,   604,   605,   606,   607,   608,   609,
     610,   611,   612,   613,   614,   615,   616,   617,   618,   626,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   236,   237,   238,   239,
     240,   241,   242,   243,     0,   244,   245,   246,     0,     0,
       0,     0,     0,     0,     0,   247,   248,   249,     0,   250,
     251,   252,   253,     0,   255,   256,   257,   258,   259,     0,
     261,   262,     0,   263,   264,   265,   266,   267,   268,   269,
       0,     0,   270,   271,   272,   273,   274,  2678,   275,   276,
     277,   278,   279,     0,     0,  2747,   281,   282,   283,   284,
     285,   286,     0,   288,   289,   290,  2679,   291,   292,   293,
     294,   295,   296,     0,     0,   298,   299,   300,     0,     0,
       0,     0,     0,     0,     0,   302,   303,   304,   305,   306,
     307,   308,   309,   310,     0,   311,     0,   312,   313,   314,
     315,   316,   317,   318,     0,   319,   320,   321,   322,     0,
       0,   323,   324,   325,   326,   327,     0,   328,   329,   330,
       0,   331,   332,   333,     0,  2748,   335,   336,   337,   338,
     339,   340,   341,   342,   343,     0,   344,     0,   345,   346,
     347,   348,   349,     0,   350,  2681,   351,     0,     0,     0,
     354,   355,   356,   357,     0,   358,   359,     0,   360,   361,
     362,     0,   363,   364,   365,   366,  2749,     0,   369,   370,
     371,   372,     0,   373,   374,   375,   376,   377,   378,   379,
       0,   380,     0,   382,   383,   384,   385,   386,   387,   388,
       0,   389,     0,   390,     0,     0,   393,     0,   395,   396,
     397,   398,   399,     0,     0,   400,   401,     0,   403,     0,
       0,   405,   406,   407,     0,     0,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,     0,   428,   429,   430,   431,
     432,   433,   434,   435,   436,   437,   438,     0,   439,   440,
       0,   442,     0,   443,   444,   445,   446,   447,   448,     0,
     449,   450,     0,     0,   451,   452,   453,     0,     0,   454,
     455,   456,     0,   458,     0,   460,   461,   462,   463,   464,
     465,   466,   467,   468,   469,   470,     0,     0,   471,   472,
     473,   474,   475,   476,   477,   478,  2682,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,   490,   491,
     492,   493,     0,   494,   495,   496,   497,   498,   499,   500,
     501,   502,   503,   504,   505,   506,     0,   507,   508,     0,
     510,   511,   512,   513,   514,   515,   516,   517,   518,   519,
     520,   521,   522,   523,   524,     0,   525,   526,   527,   528,
     529,     0,   530,   531,   532,   533,   534,     0,   536,   537,
     538,   539,     0,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,   551,   552,   553,   554,     0,   555,
     556,     0,   557,     0,   559,   560,   561,   562,   563,     0,
     564,   565,   566,     0,     0,   567,   568,   569,   570,   571,
       0,   572,   573,   574,   575,   576,   577,   578,   579,     0,
    2683,   580,   581,   582,   583,   584,     0,     0,   585,   586,
     587,   588,   589,   590,   591,     0,   592,     0,   594,   595,
     596,   597,     0,     0,   598,     0,     0,   599,   600,   601,
     602,   603,   604,   605,   606,   607,   608,   609,   610,   611,
     612,   613,   614,   615,   616,   617,   618,   626,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   236,   237,   238,   239,   240,   241,
     242,   243,     0,   244,   245,   246,     0,     0,     0,     0,
       0,     0,     0,   247,   248,   249,     0,   250,   251,   252,
     253,     0,   255,   256,   257,   258,   259,     0,   261,   262,
       0,   263,   264,   265,   266,   267,   268,   269,     0,     0,
     270,   271,   272,   273,   274,  2678,   275,   276,   277,   278,
     279,     0,     0,     0,   281,   282,   283,   284,   285,   286,
       0,   288,   289,   290,  2679,   291,   292,   293,   294,   295,
     296,     0,     0,   298,   299,   300,     0,     0,     0,     0,
       0,     0,     0,   302,   303,   304,   305,   306,   307,   308,
     309,   310,     0,   311,     0,   312,   313,   314,   315,   316,
     317,   318,     0,   319,   320,   321,   322,     0,     0,   323,
     324,   325,   326,   327,     0,   328,   329,   330,     0,   331,
     332,   333,     0,  2748,   335,   336,   337,   338,   339,   340,
     341,   342,   343,     0,   344,     0,   345,   346,   347,   348,
     349,     0,   350,  2681,   351,     0,     0,     0,   354,   355,
     356,   357,     0,   358,   359,     0,   360,   361,   362,     0,
     363,   364,   365,   366,   367,     0,   369,   370,   371,   372,
       0,   373,   374,   375,   376,   377,   378,   379,     0,   380,
       0,   382,   383,   384,   385,   386,   387,   388,     0,   389,
       0,   390,     0,     0,   393,     0,   395,   396,   397,   398,
     399,     0,     0,   400,   401,     0,   403,  3753,     0,   405,
     406,   407,     0,     0,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,     0,   428,   429,   430,   431,   432,   433,
     434,   435,   436,   437,   438,     0,   439,   440,     0,   442,
       0,   443,   444,   445,   446,   447,   448,     0,   449,   450,
       0,     0,   451,   452,   453,     0,     0,   454,   455,   456,
       0,   458,     0,   460,   461,   462,   463,   464,   465,   466,
     467,   468,   469,   470,     0,     0,   471,   472,   473,   474,
     475,   476,   477,   478,  2682,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   490,   491,   492,   493,
       0,   494,   495,   496,   497,   498,   499,   500,   501,   502,
     503,   504,   505,   506,     0,   507,   508,     0,   510,   511,
     512,   513,   514,   515,   516,   517,   518,   519,   520,   521,
     522,   523,   524,     0,   525,   526,   527,   528,   529,     0,
     530,   531,   532,   533,   534,     0,   536,   537,   538,   539,
       0,   540,   541,   542,   543,   544,   545,   546,   547,   548,
     549,   550,   551,   552,   553,   554,     0,   555,   556,     0,
     557,     0,   559,   560,   561,   562,   563,     0,   564,   565,
     566,     0,     0,   567,   568,   569,   570,   571,     0,   572,
     573,   574,   575,   576,   577,   578,   579,     0,  2683,   580,
     581,   582,   583,   584,     0,     0,   585,   586,   587,   588,
     589,   590,   591,     0,   592,     0,   594,   595,   596,   597,
       0,     0,   598,     0,     0,   599,   600,   601,   602,   603,
     604,   605,   606,   607,   608,   609,   610,   611,   612,   613,
     614,   615,   616,   617,   618,   626,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   236,   237,   238,   239,   240,   807,   242,   243,
     765,   244,   766,   246,     0,     0,     0,     0,     0,     0,
       0,   247,   248,   249,     0,   250,   251,   252,   253,     0,
     255,   256,   257,   258,   259,     0,   261,   262,     0,   263,
     264,   265,   266,   267,   268,   269,     0,     0,   270,   271,
     272,   273,   274,     0,   275,   276,   277,   278,   279,     0,
       0,     0,   281,   282,   283,   284,   285,   286,     0,   288,
     289,   290,     0,   291,   292,   293,   294,   295,   296,   767,
       0,   298,   299,   300,     0,     0,     0,     0,     0,     0,
       0,   302,   303,   304,   305,   306,   307,   308,   309,   310,
       0,   311,     0,   312,   313,   314,   315,   316,   317,   318,
       0,   319,   320,   321,   322,     0,     0,   323,   324,   325,
     326,   327,     0,   328,   329,   330,     0,   331,   332,   333,
       0,   334,   335,   336,   337,   338,   339,   340,   341,   342,
     343,     0,   344,     0,   345,   346,   347,   348,   349,     0,
     350,     0,   351,     0,     0,     0,   354,   355,   356,   357,
     808,   358,   359,     0,   360,   361,   362,     0,   363,   364,
     365,   366,   367,     0,   369,   370,   371,   372,     0,   373,
     374,   375,   376,   377,   378,   379,     0,   380,     0,   382,
     383,   384,   385,   386,   387,   388,     0,   389,     0,   390,
       0,     0,   393,     0,   395,   396,   397,   398,   399,     0,
       0,   400,   401,     0,   403,     0,     0,   405,   406,   407,
       0,     0,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,     0,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438,     0,   439,   440,     0,   442,     0,   443,
     444,   445,   446,   447,   448,     0,   449,   450,     0,     0,
     451,   452,   453,     0,     0,   454,   455,   456,     0,   458,
       0,   460,   461,   462,   463,   464,   465,   466,   467,   468,
     469,   470,     0,     0,   471,   472,   473,   474,   475,   476,
     477,   478,     0,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,   492,   493,   768,   494,
     495,   496,   497,   498,   499,   500,   501,   502,   503,   504,
     505,   506,     0,   507,   508,     0,   510,   511,   512,   513,
     514,   515,   516,   517,   518,   519,   520,   521,   522,   523,
     524,   769,   525,   526,   527,   528,   529,     0,   530,   531,
     532,   533,   534,     0,   536,   537,   538,   539,     0,   540,
     541,   542,   543,   544,   545,   546,   547,   548,   549,   550,
     551,   552,   553,   554,     0,   555,   556,     0,   557,     0,
     559,   560,   561,   562,   563,     0,   564,   565,   566,     0,
       0,   567,   568,   569,   570,   571,     0,   572,   573,   574,
     575,   576,   577,   578,   579,     0,     0,   580,   581,   582,
     583,   584,     0,     0,   585,   586,   587,   588,   589,   590,
     591,     0,   592,     0,   594,   595,   596,   597,     0,     0,
     598,     0,     0,   599,   600,   601,   602,   603,   604,   605,
     606,   607,   608,   609,   610,   611,   612,   613,   614,   615,
     616,   617,   618,   626,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     236,   237,   238,   239,   240,   241,   242,   243,   765,   244,
     766,   246,     0,     0,     0,     0,     0,     0,     0,   247,
     248,   249,     0,   250,   251,   252,   253,     0,   255,   256,
     257,   258,   259,     0,   261,   262,     0,   263,   264,   265,
     266,   267,   268,   269,     0,     0,   270,   271,   272,   273,
     274,     0,   275,   276,   277,   278,   279,     0,     0,     0,
     281,   282,   283,   284,   285,   286,     0,   288,   289,   290,
       0,   291,   292,   293,   294,   295,   296,   767,     0,   298,
     299,   300,     0,     0,     0,     0,     0,     0,     0,   302,
     303,   304,   305,   306,   307,   308,   309,   310,     0,   311,
       0,   312,   313,   314,   315,   316,   317,   318,     0,   319,
     320,   321,   322,     0,     0,   323,   324,   325,   326,   327,
       0,   328,   329,   330,     0,   331,   332,   333,     0,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,     0,
     344,     0,   345,   346,   347,   348,   349,     0,   350,     0,
     351,     0,     0,     0,   354,   355,   356,   357,  3442,   358,
     359,     0,   360,   361,   362,     0,   363,   364,   365,   366,
     367,     0,   369,   370,   371,   372,     0,   373,   374,   375,
     376,   377,   378,   379,     0,   380,     0,   382,   383,   384,
     385,   386,   387,   388,     0,   389,     0,   390,     0,     0,
     393,     0,   395,   396,   397,   398,   399,     0,     0,   400,
     401,     0,   403,     0,     0,   405,   406,   407,     0,     0,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,     0,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
     438,     0,   439,   440,     0,   442,     0,   443,   444,   445,
     446,   447,   448,     0,   449,   450,     0,     0,   451,   452,
     453,     0,     0,   454,   455,   456,     0,   458,     0,   460,
     461,   462,   463,   464,   465,   466,   467,   468,   469,   470,
       0,     0,   471,   472,   473,   474,   475,   476,   477,   478,
       0,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,   490,   491,   492,   493,   768,   494,   495,   496,
     497,   498,   499,   500,   501,   502,   503,   504,   505,   506,
       0,   507,   508,     0,   510,   511,   512,   513,   514,   515,
     516,   517,   518,   519,   520,   521,   522,   523,   524,   769,
     525,   526,   527,   528,   529,     0,   530,   531,   532,   533,
     534,     0,   536,   537,   538,   539,     0,   540,   541,   542,
     543,   544,   545,   546,   547,   548,   549,   550,   551,   552,
     553,   554,     0,   555,   556,     0,   557,     0,   559,   560,
     561,   562,   563,     0,   564,   565,   566,     0,     0,   567,
     568,   569,   570,   571,     0,   572,   573,   574,   575,   576,
     577,   578,   579,     0,     0,   580,   581,   582,   583,   584,
       0,     0,   585,   586,   587,   588,   589,   590,   591,     0,
     592,     0,   594,   595,   596,   597,     0,     0,   598,     0,
       0,   599,   600,   601,   602,   603,   604,   605,   606,   607,
     608,   609,   610,   611,   612,   613,   614,   615,   616,   617,
     618,   626,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   236,   237,
     238,   239,   240,   241,   242,   243,     0,   244,   245,   246,
       0,     0,     0,     0,     0,     0,     0,   247,   248,   249,
       0,   250,   251,   252,   253,     0,   255,   256,   257,   258,
     259,     0,   261,   262,     0,   263,   264,   265,   266,   267,
     268,   269,     0,     0,   270,   271,   272,   273,   274,  2678,
     275,   276,   277,   278,   279,     0,     0,     0,   281,   282,
     283,   284,   285,   286,     0,   288,   289,   290,  2679,   291,
     292,   293,   294,   295,   296,     0,     0,   298,   299,   300,
       0,     0,     0,     0,     0,     0,     0,   302,   303,   304,
     305,   306,   307,   308,   309,   310,     0,   311,     0,   312,
     313,   314,   315,   316,   317,   318,     0,   319,   320,   321,
     322,     0,     0,   323,   324,   325,   326,   327,     0,   328,
     329,   330,     0,   331,   332,   333,     0,  2748,   335,   336,
     337,   338,   339,   340,   341,   342,   343,     0,   344,     0,
     345,   346,   347,   348,   349,     0,   350,  2681,   351,     0,
       0,     0,   354,   355,   356,   357,     0,   358,   359,     0,
     360,   361,   362,     0,   363,   364,   365,   366,   367,     0,
     369,   370,   371,   372,     0,   373,   374,   375,   376,   377,
     378,   379,     0,   380,     0,   382,   383,   384,   385,   386,
     387,   388,     0,   389,     0,   390,     0,     0,   393,     0,
     395,   396,   397,   398,   399,     0,     0,   400,   401,     0,
     403,     0,     0,   405,   406,   407,     0,     0,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,     0,   428,   429,
     430,   431,   432,   433,   434,   435,   436,   437,   438,     0,
     439,   440,     0,   442,     0,   443,   444,   445,   446,   447,
     448,     0,   449,   450,     0,     0,   451,   452,   453,     0,
       0,   454,   455,   456,     0,   458,     0,   460,   461,   462,
     463,   464,   465,   466,   467,   468,   469,   470,     0,     0,
     471,   472,   473,   474,   475,   476,   477,   478,  2682,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,   493,     0,   494,   495,   496,   497,   498,
     499,   500,   501,   502,   503,   504,   505,   506,     0,   507,
     508,     0,   510,   511,   512,   513,   514,   515,   516,   517,
     518,   519,   520,   521,   522,   523,   524,     0,   525,   526,
     527,   528,   529,     0,   530,   531,   532,   533,   534,     0,
     536,   537,   538,   539,     0,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,   552,   553,   554,
       0,   555,   556,     0,   557,     0,   559,   560,   561,   562,
     563,     0,   564,   565,   566,     0,     0,   567,   568,   569,
     570,   571,     0,   572,   573,   574,   575,   576,   577,   578,
     579,     0,  2683,   580,   581,   582,   583,   584,     0,     0,
     585,   586,   587,   588,   589,   590,   591,     0,   592,     0,
     594,   595,   596,   597,     0,     0,   598,     0,     0,   599,
     600,   601,   602,   603,   604,   605,   606,   607,   608,   609,
     610,   611,   612,   613,   614,   615,   616,   617,   618,   626,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   236,   237,   238,   239,
     240,   241,   242,   243,   765,   244,   766,   246,     0,     0,
       0,     0,     0,     0,     0,   247,   248,   249,     0,   250,
     251,   252,   253,     0,   255,   256,   257,   258,   259,     0,
     261,   262,     0,   263,   264,   265,   266,   267,   268,   269,
       0,     0,   270,   271,   272,   273,   274,     0,   275,   276,
     277,   278,   279,     0,     0,     0,   281,   282,   283,   284,
     285,   286,     0,   288,   289,   290,     0,   291,   292,   293,
     294,   295,   296,   767,     0,   298,   299,   300,     0,     0,
       0,     0,     0,     0,     0,   302,   303,   304,   305,   306,
     307,   308,   309,   310,     0,   311,     0,   312,   313,   314,
     315,   316,   317,   318,     0,   319,   320,   321,   322,     0,
       0,   323,   324,   325,   326,   327,     0,   328,   329,   330,
       0,   331,   332,   333,     0,   334,   335,   336,   337,   338,
     339,   340,   341,   342,   343,     0,   344,     0,   345,   346,
     347,   348,   349,     0,   350,     0,   351,     0,     0,     0,
     354,   355,   356,   357,     0,   358,   359,     0,   360,   361,
     362,     0,   363,   364,   365,   366,   367,     0,   369,   370,
     371,   372,     0,   373,   374,   375,   376,   377,   378,   379,
       0,   380,     0,   382,   383,   384,   385,   386,   387,   388,
       0,   389,     0,   390,     0,     0,   393,     0,   395,   396,
     397,   398,   399,     0,     0,   400,   401,     0,   403,     0,
       0,   405,   406,   407,     0,     0,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,     0,   428,   429,   430,   431,
     432,   433,   434,   435,   436,   437,   438,     0,   439,   440,
       0,   442,     0,   443,   444,   445,   446,   447,   448,     0,
     449,   450,     0,     0,   451,   452,   453,     0,     0,   454,
     455,   456,     0,   458,     0,   460,   461,   462,   463,   464,
     465,   466,   467,   468,   469,   470,     0,     0,   471,   472,
     473,   474,   475,   476,   477,   478,     0,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,   490,   491,
     492,   493,   768,   494,   495,   496,   497,   498,   499,   500,
     501,   502,   503,   504,   505,   506,     0,   507,   508,     0,
     510,   511,   512,   513,   514,   515,   516,   517,   518,   519,
     520,   521,   522,   523,   524,   769,   525,   526,   527,   528,
     529,     0,   530,   531,   532,   533,   534,     0,   536,   537,
     538,   539,     0,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,   551,   552,   553,   554,     0,   555,
     556,     0,   557,     0,   559,   560,   561,   562,   563,     0,
     564,   565,   566,     0,     0,   567,   568,   569,   570,   571,
       0,   572,   573,   574,   575,   576,   577,   578,   579,     0,
       0,   580,   581,   582,   583,   584,     0,     0,   585,   586,
     587,   588,   589,   590,   591,     0,   592,     0,   594,   595,
     596,   597,     0,     0,   598,     0,     0,   599,   600,   601,
     602,   603,   604,   605,   606,   607,   608,   609,   610,   611,
     612,   613,   614,   615,   616,   617,   618,   626,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   236,   237,   238,   239,   240,   241,
     242,   243,  2813,   244,   245,   246,     0,     0,     0,     0,
       0,     0,     0,   247,   248,   249,     0,   250,   251,   252,
     253,     0,   255,   256,   257,   258,   259,     0,   261,   262,
       0,   263,   264,   265,   266,   267,   268,   269,     0,     0,
     270,   271,   272,   273,   274,     0,   275,   276,   277,   278,
     279,     0,     0,     0,   281,   282,   283,   284,   285,   286,
       0,   288,   289,   290,     0,   291,   292,   293,   294,   295,
     296,     0,     0,   298,   299,   300,     0,     0,     0,  2814,
       0,     0,     0,   302,   303,   304,   305,   306,   307,   308,
     309,   310,     0,   311,     0,   312,   313,   314,   315,   316,
     317,   318,     0,   319,   320,   321,   322,     0,     0,   323,
     324,   325,   326,   327,     0,   328,   329,   330,     0,   331,
     332,   333,     0,   334,   335,   336,   337,   338,   339,   340,
     341,   342,   343,     0,   344,     0,   345,   346,   347,   348,
     349,     0,   350,     0,   351,     0,     0,     0,   354,   355,
     356,   357,     0,   358,   359,     0,   360,   361,   362,     0,
     363,   364,   365,   366,   367,     0,   369,   370,   371,   372,
       0,   373,   374,   375,   376,   377,   378,   379,     0,   380,
       0,   382,   383,   384,   385,   386,   387,   388,     0,   389,
       0,   390,     0,     0,   393,     0,   395,   396,   397,   398,
     399,     0,     0,   400,   401,     0,   403,     0,     0,   405,
     406,   407,     0,     0,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,     0,   428,   429,   430,   431,   432,   433,
     434,   435,   436,   437,   438,     0,   439,   440,     0,   442,
       0,   443,   444,   445,   446,   447,   448,     0,   449,   450,
       0,   839,   451,   452,   453,     0,     0,   454,   455,   456,
       0,   458,     0,   460,   461,   462,   463,   464,   465,   466,
     467,   468,   469,   470,     0,     0,   471,   472,   473,   474,
     475,   476,   477,   478,     0,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   490,   491,   492,   493,
       0,   494,   495,   496,   497,   498,   499,   500,   501,   502,
     503,   504,   505,   506,     0,   507,   508,     0,   510,   511,
     512,   513,   514,   515,   516,   517,   518,   519,   520,   521,
     522,   523,   524,     0,   525,   526,   527,   528,   529,     0,
     530,   531,   532,   533,   534,     0,   536,   537,   538,   539,
       0,   540,   541,   542,   543,   544,   545,   546,   547,   548,
     549,   550,   551,   552,   553,   554,     0,   555,   556,  2815,
     557,     0,   559,   560,   561,   562,   563,     0,   564,   565,
     566,     0,     0,   567,   568,   569,   570,   571,     0,   572,
     573,   574,   575,   576,   577,   578,   579,     0,     0,   580,
     581,   582,   583,   584,     0,     0,   585,   586,   587,   588,
     589,   590,   591,     0,   592,     0,   594,   595,   596,   597,
       0,     0,   598,     0,     0,   599,   600,   601,   602,   603,
     604,   605,   606,   607,   608,   609,   610,   611,   612,   613,
     614,   615,   616,   617,   618,   626,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   236,   237,   238,   239,   240,   241,   242,   243,
    2982,   244,   245,   246,     0,     0,     0,     0,     0,     0,
       0,   247,   248,   249,     0,   250,   251,   252,   253,     0,
     255,   256,   257,   258,   259,     0,   261,   262,     0,   263,
     264,   265,   266,   267,   268,   269,     0,     0,   270,   271,
     272,   273,   274,     0,   275,   276,   277,   278,   279,     0,
       0,     0,   281,   282,   283,   284,   285,   286,     0,   288,
     289,   290,     0,   291,   292,   293,   294,   295,   296,     0,
       0,   298,   299,   300,     0,     0,     0,  2814,     0,     0,
       0,   302,   303,   304,   305,   306,   307,   308,   309,   310,
       0,   311,     0,   312,   313,   314,   315,   316,   317,   318,
       0,   319,   320,   321,   322,     0,     0,   323,   324,   325,
     326,   327,     0,   328,   329,   330,     0,   331,   332,   333,
       0,   334,   335,   336,   337,   338,   339,   340,   341,   342,
     343,     0,   344,     0,   345,   346,   347,   348,   349,     0,
     350,     0,   351,     0,     0,     0,   354,   355,   356,   357,
       0,   358,   359,     0,   360,   361,   362,     0,   363,   364,
     365,   366,   367,     0,   369,   370,   371,   372,     0,   373,
     374,   375,   376,   377,   378,   379,     0,   380,     0,   382,
     383,   384,   385,   386,   387,   388,     0,   389,     0,   390,
       0,     0,   393,     0,   395,   396,   397,   398,   399,     0,
       0,   400,   401,     0,   403,     0,     0,   405,   406,   407,
       0,     0,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,     0,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438,     0,   439,   440,     0,   442,     0,   443,
     444,   445,   446,   447,   448,     0,   449,   450,     0,   839,
     451,   452,   453,     0,     0,   454,   455,   456,     0,   458,
       0,   460,   461,   462,   463,   464,   465,   466,   467,   468,
     469,   470,     0,     0,   471,   472,   473,   474,   475,   476,
     477,   478,     0,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,   492,   493,     0,   494,
     495,   496,   497,   498,   499,   500,   501,   502,   503,   504,
     505,   506,     0,   507,   508,     0,   510,   511,   512,   513,
     514,   515,   516,   517,   518,   519,   520,   521,   522,   523,
     524,     0,   525,   526,   527,   528,   529,     0,   530,   531,
     532,   533,   534,     0,   536,   537,   538,   539,     0,   540,
     541,   542,   543,   544,   545,   546,   547,   548,   549,   550,
     551,   552,   553,   554,     0,   555,   556,  2815,   557,     0,
     559,   560,   561,   562,   563,     0,   564,   565,   566,     0,
       0,   567,   568,   569,   570,   571,     0,   572,   573,   574,
     575,   576,   577,   578,   579,     0,     0,   580,   581,   582,
     583,   584,     0,     0,   585,   586,   587,   588,   589,   590,
     591,     0,   592,     0,   594,   595,   596,   597,     0,     0,
     598,     0,     0,   599,   600,   601,   602,   603,   604,   605,
     606,   607,   608,   609,   610,   611,   612,   613,   614,   615,
     616,   617,   618,   626,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     236,   237,   238,   239,   240,   241,   242,   243,  1963,   244,
     245,   246,     0,     0,     0,     0,     0,     0,     0,   247,
     248,   249,     0,   250,   251,   252,   253,     0,   255,   256,
     257,   258,   259,     0,   261,   262,     0,   263,   264,   265,
     266,   267,   268,   269,     0,     0,   270,   271,   272,   273,
     274,     0,   275,   276,   277,   278,   279,     0,     0,     0,
     281,   282,   283,   284,   285,   286,     0,   288,   289,   290,
       0,   291,   292,   293,   294,   295,   296,     0,     0,   298,
     299,   300,     0,     0,     0,     0,     0,     0,     0,   302,
     303,   304,  1964,   306,   307,   308,   309,   310,     0,   311,
       0,   312,   313,   314,   315,   316,   317,   318,     0,   319,
     320,   321,   322,     0,     0,   323,  1965,   325,   326,   327,
       0,   328,   329,   330,     0,   331,   332,   333,     0,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,     0,
     344,     0,   345,   346,   347,   348,   349,     0,   350,  1966,
     351,     0,     0,     0,  1967,   355,   356,   357,     0,   358,
     359,     0,   360,   361,   362,     0,   363,   364,   365,   366,
     367,     0,   369,   370,   371,   372,     0,   373,   374,   375,
     376,   377,   378,   379,     0,   380,     0,   382,   383,   384,
     385,   386,   387,   388,     0,   389,     0,   390,     0,     0,
     393,     0,   395,   396,  1968,  1969,   399,     0,     0,   400,
     401,     0,   403,     0,     0,   405,   406,   407,     0,     0,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,     0,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
     438,     0,   439,   440,     0,   442,     0,   443,   444,   445,
     446,   447,   448,     0,   449,   450,     0,     0,   451,   452,
     453,     0,     0,   454,   455,   456,     0,   458,     0,   460,
     461,   462,   463,   464,  1970,   466,   467,   468,   469,   470,
       0,     0,   471,   472,   473,   474,   475,   476,   477,   478,
       0,   479,   480,   481,  1971,   483,   484,   485,   486,   487,
     488,   489,   490,   491,   492,   493,     0,   494,   495,   496,
     497,   498,   499,   500,   501,   502,   503,   504,   505,   506,
       0,   507,   508,     0,   510,   511,   512,  1972,   514,   515,
     516,   517,   518,  1973,   520,   521,   522,   523,   524,     0,
    1974,   526,   527,   528,   529,     0,   530,   531,   532,   533,
     534,     0,   536,   537,   538,   539,     0,   540,   541,   542,
     543,   544,   545,   546,   547,   548,   549,   550,   551,   552,
     553,   554,     0,   555,   556,  1975,   557,     0,  1976,   560,
     561,   562,   563,     0,   564,   565,   566,     0,     0,   567,
     568,   569,   570,   571,     0,   572,   573,  1977,   575,   576,
     577,   578,   579,     0,     0,   580,   581,   582,   583,   584,
       0,     0,   585,   586,   587,   588,   589,   590,   591,     0,
     592,     0,   594,   595,   596,   597,     0,     0,   598,     0,
       0,   599,   600,   601,   602,   603,   604,   605,   606,   607,
     608,   609,   610,   611,   612,   613,   614,   615,   616,   617,
     618,   626,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   236,   237,
     238,   239,   240,   241,   242,   243,     0,   244,   766,   246,
       0,     0,     0,     0,     0,     0,     0,   247,   248,   249,
       0,   250,   251,   252,   253,     0,   255,   256,   257,   258,
     259,     0,   261,   262,     0,   263,   264,   265,   266,   267,
     268,   269,     0,     0,   270,   271,   272,   273,   274,     0,
     275,   276,   277,   278,   279,     0,     0,     0,   281,   282,
     283,   284,   285,   286,     0,   288,   289,   290,     0,   291,
     292,   293,   294,   295,   296,   767,     0,   298,   299,   300,
       0,     0,     0,     0,     0,     0,     0,   302,   303,   304,
     305,   306,   307,   308,   309,   310,     0,   311,     0,   312,
     313,   314,   315,   316,   317,   318,     0,   319,   320,   321,
     322,     0,     0,   323,   324,   325,   326,   327,     0,   328,
     329,   330,     0,   331,   332,   333,     0,   334,   335,   336,
     337,   338,   339,   340,   341,   342,   343,     0,   344,     0,
     345,   346,   347,   348,   349,     0,   350,     0,   351,     0,
       0,     0,   354,   355,   356,   357,     0,   358,   359,     0,
     360,   361,   362,     0,   363,   364,   365,   366,   367,     0,
     369,   370,   371,   372,     0,   373,   374,   375,   376,   377,
     378,   379,     0,   380,     0,   382,   383,   384,   385,   386,
     387,   388,     0,   389,     0,   390,     0,     0,   393,     0,
     395,   396,   397,   398,   399,     0,     0,   400,   401,     0,
     403,     0,     0,   405,   406,   407,     0,     0,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,     0,   428,   429,
     430,   431,   432,   433,   434,   435,   436,   437,   438,     0,
     439,   440,     0,   442,     0,   443,   444,   445,   446,   447,
     448,     0,   449,   450,     0,     0,   451,   452,   453,     0,
       0,   454,   455,   456,     0,   458,     0,   460,   461,   462,
     463,   464,   465,   466,   467,   468,   469,   470,     0,     0,
     471,   472,   473,   474,   475,   476,   477,   478,     0,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,   493,   768,   494,   495,   496,   497,   498,
     499,   500,   501,   502,   503,   504,   505,   506,     0,   507,
     508,     0,   510,   511,   512,   513,   514,   515,   516,   517,
     518,   519,   520,   521,   522,   523,   524,   769,   525,   526,
     527,   528,   529,     0,   530,   531,   532,   533,   534,     0,
     536,   537,   538,   539,     0,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,   552,   553,   554,
       0,   555,   556,     0,   557,     0,   559,   560,   561,   562,
     563,     0,   564,   565,   566,     0,     0,   567,   568,   569,
     570,   571,     0,   572,   573,   574,   575,   576,   577,   578,
     579,     0,     0,   580,   581,   582,   583,   584,     0,     0,
     585,   586,   587,   588,   589,   590,   591,     0,   592,     0,
     594,   595,   596,   597,     0,     0,   598,     0,     0,   599,
     600,   601,   602,   603,   604,   605,   606,   607,   608,   609,
     610,   611,   612,   613,   614,   615,   616,   617,   618,   626,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   236,   237,   238,   239,
     240,   241,   242,   243,   995,   244,   245,   246,     0,     0,
       0,     0,     0,     0,     0,   247,   248,   249,     0,   250,
     251,   252,   253,     0,   255,   256,   257,   258,   259,     0,
     261,   262,     0,   263,   264,   265,   266,   267,   268,   269,
       0,     0,   270,   271,   272,   273,   274,     0,   275,   276,
     277,   278,   279,     0,     0,     0,   281,   282,   283,   284,
     285,   286,     0,   288,   289,   290,     0,   291,   292,   293,
     294,   295,   296,     0,     0,   298,   299,   300,     0,     0,
       0,     0,     0,     0,     0,   302,   303,   304,   305,   306,
     307,   308,   309,   310,     0,   311,     0,   312,   313,   314,
     315,   316,   317,   318,     0,   319,   320,   321,   322,     0,
       0,   323,   324,   325,   326,   327,     0,   328,   329,   330,
       0,   331,   332,   333,     0,   334,   335,   336,   337,   338,
     339,   340,   341,   342,   343,     0,   344,     0,   345,   346,
     347,   348,   349,     0,   350,     0,   351,     0,     0,     0,
     354,   355,   356,   357,     0,   358,   359,     0,   360,   361,
     362,     0,   363,   364,   365,   366,   996,     0,   369,   370,
     371,   372,     0,   373,   374,   375,   376,   377,   378,   379,
       0,   380,     0,   382,   383,   384,   385,   386,   387,   388,
       0,   389,     0,   390,     0,     0,   393,     0,   395,   396,
     397,   398,   399,     0,     0,   400,   401,     0,   403,     0,
       0,   405,   406,   407,     0,     0,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,     0,   428,   429,   430,   431,
     432,   433,   434,   435,   436,   437,   438,     0,   439,   440,
       0,   442,     0,   443,   444,   445,   446,   447,   448,     0,
     449,   450,     0,   839,   451,   452,   453,     0,     0,   454,
     455,   456,     0,   458,     0,   460,   461,   462,   463,   464,
     465,   466,   467,   468,   469,   470,     0,     0,   471,   472,
     473,   474,   475,   476,   477,   478,     0,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,   490,   491,
     492,   493,     0,   494,   495,   496,   497,   498,   499,   500,
     501,   502,   503,   504,   505,   506,     0,   507,   508,     0,
     510,   511,   512,   513,   514,   515,   516,   517,   518,   519,
     520,   521,   522,   523,   524,     0,   525,   526,   527,   528,
     529,     0,   530,   531,   532,   533,   534,     0,   536,   537,
     538,   539,     0,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,   551,   552,   553,   554,     0,   555,
     556,     0,   557,     0,   559,   560,   561,   562,   563,     0,
     564,   565,   566,     0,     0,   567,   568,   569,   570,   571,
       0,   572,   573,   574,   575,   576,   577,   578,   579,     0,
       0,   580,   581,   582,   583,   584,     0,     0,   585,   586,
     587,   588,   589,   590,   591,     0,   592,     0,   594,   595,
     596,   597,     0,     0,   598,     0,     0,   599,   600,   601,
     602,   603,   604,   605,   606,   607,   608,   609,   610,   611,
     612,   613,   614,   615,   616,   617,   618,   626,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   236,   237,   238,   239,   240,   241,
     242,   243,  3521,   244,   245,   246,     0,     0,     0,     0,
       0,     0,     0,   247,   248,   249,     0,   250,   251,   252,
     253,     0,   255,   256,   257,   258,   259,     0,   261,   262,
       0,   263,   264,   265,   266,   267,   268,   269,     0,     0,
     270,   271,   272,   273,   274,     0,   275,   276,   277,   278,
     279,     0,     0,     0,   281,   282,   283,   284,   285,   286,
       0,   288,   289,   290,     0,   291,   292,   293,   294,   295,
     296,     0,     0,   298,   299,   300,     0,     0,     0,     0,
       0,     0,     0,   302,   303,   304,   305,   306,   307,   308,
     309,   310,     0,   311,     0,   312,   313,   314,   315,   316,
     317,   318,     0,   319,   320,   321,   322,     0,     0,   323,
     324,   325,   326,   327,     0,   328,   329,   330,     0,   331,
     332,   333,     0,   334,   335,   336,   337,   338,   339,   340,
     341,   342,   343,     0,   344,     0,   345,   346,   347,   348,
     349,     0,   350,     0,   351,     0,     0,     0,   354,   355,
     356,   357,     0,   358,   359,     0,   360,   361,   362,     0,
     363,   364,   365,   366,   367,     0,   369,   370,   371,   372,
       0,   373,   374,   375,   376,   377,   378,   379,     0,   380,
       0,   382,   383,   384,   385,   386,   387,   388,     0,   389,
       0,   390,     0,     0,   393,     0,   395,   396,   397,   398,
     399,     0,     0,   400,   401,     0,   403,     0,     0,   405,
     406,   407,     0,     0,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,     0,   428,   429,   430,   431,   432,   433,
     434,   435,   436,   437,   438,     0,   439,   440,     0,   442,
       0,   443,   444,   445,   446,   447,   448,     0,   449,   450,
       0,     0,   451,   452,   453,     0,     0,   454,   455,   456,
       0,   458,     0,   460,   461,   462,   463,   464,   465,   466,
     467,   468,   469,   470,     0,     0,   471,   472,   473,   474,
     475,   476,   477,   478,     0,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   490,   491,   492,   493,
       0,   494,   495,   496,   497,   498,   499,   500,   501,   502,
     503,   504,   505,   506,     0,   507,   508,     0,   510,   511,
     512,   513,   514,   515,   516,   517,   518,   519,   520,   521,
     522,   523,   524,     0,   525,   526,   527,   528,   529,     0,
     530,   531,   532,   533,   534,     0,   536,   537,   538,   539,
       0,   540,   541,   542,   543,   544,   545,   546,   547,   548,
     549,   550,   551,   552,   553,   554,     0,   555,   556,     0,
     557,     0,   559,   560,   561,   562,   563,     0,   564,   565,
     566,     0,     0,   567,   568,   569,   570,   571,     0,   572,
     573,   574,   575,   576,   577,   578,   579,     0,     0,   580,
     581,   582,   583,   584,  3522,     0,   585,   586,   587,   588,
     589,   590,   591,     0,   592,     0,   594,   595,   596,   597,
       0,     0,   598,     0,     0,   599,   600,   601,   602,   603,
     604,   605,   606,   607,   608,   609,   610,   611,   612,   613,
     614,   615,   616,   617,   618,   626,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   236,   237,   238,   239,   240,   241,   242,   243,
    3534,   244,   245,   246,     0,     0,     0,     0,     0,     0,
       0,   247,   248,   249,     0,   250,   251,   252,   253,     0,
     255,   256,   257,   258,   259,     0,   261,   262,     0,   263,
     264,   265,   266,   267,   268,   269,     0,     0,   270,   271,
     272,   273,   274,     0,   275,   276,   277,   278,   279,     0,
       0,     0,   281,   282,   283,   284,   285,   286,     0,   288,
     289,   290,     0,   291,   292,   293,   294,   295,   296,     0,
       0,   298,   299,   300,     0,     0,     0,     0,     0,     0,
       0,   302,   303,   304,   305,   306,   307,   308,   309,   310,
       0,   311,     0,   312,   313,   314,   315,   316,   317,   318,
       0,   319,   320,   321,   322,     0,     0,   323,   324,   325,
     326,   327,     0,   328,   329,   330,     0,   331,   332,   333,
       0,   334,   335,   336,   337,   338,   339,   340,   341,   342,
     343,     0,   344,     0,   345,   346,   347,   348,   349,     0,
     350,     0,   351,     0,     0,     0,   354,   355,   356,   357,
       0,   358,   359,     0,   360,   361,   362,     0,   363,   364,
     365,   366,   367,     0,   369,   370,   371,   372,     0,   373,
     374,   375,   376,   377,   378,   379,     0,   380,     0,   382,
     383,   384,   385,   386,   387,   388,     0,   389,     0,   390,
       0,     0,   393,     0,   395,   396,   397,   398,   399,     0,
       0,   400,   401,     0,   403,     0,     0,   405,   406,   407,
       0,     0,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,     0,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438,     0,   439,   440,     0,   442,     0,   443,
     444,   445,   446,   447,   448,     0,   449,   450,     0,     0,
     451,   452,   453,     0,     0,   454,   455,   456,     0,   458,
       0,   460,   461,   462,   463,   464,   465,   466,   467,   468,
     469,   470,     0,     0,   471,   472,   473,   474,   475,   476,
     477,   478,     0,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,   492,   493,     0,   494,
     495,   496,   497,   498,   499,   500,   501,   502,   503,   504,
     505,   506,     0,   507,   508,     0,   510,   511,   512,   513,
     514,   515,   516,   517,   518,   519,   520,   521,   522,   523,
     524,     0,   525,   526,   527,   528,   529,     0,   530,   531,
     532,   533,   534,     0,   536,   537,   538,   539,     0,   540,
     541,   542,   543,   544,   545,   546,   547,   548,   549,   550,
     551,   552,   553,   554,     0,   555,   556,     0,   557,     0,
     559,   560,   561,   562,   563,     0,   564,   565,   566,     0,
       0,   567,   568,   569,   570,   571,     0,   572,   573,   574,
     575,   576,   577,   578,   579,     0,     0,   580,   581,   582,
     583,   584,  3535,     0,   585,   586,   587,   588,   589,   590,
     591,     0,   592,     0,   594,   595,   596,   597,     0,     0,
     598,     0,     0,   599,   600,   601,   602,   603,   604,   605,
     606,   607,   608,   609,   610,   611,   612,   613,   614,   615,
     616,   617,   618,   626,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     236,   237,   238,   239,   240,   241,   242,   243,   627,   244,
     245,   246,     0,     0,     0,     0,     0,     0,     0,   247,
     248,   249,     0,   250,   251,   252,   253,     0,   255,   256,
     257,   258,   259,     0,   261,   262,     0,   263,   264,   265,
     266,   267,   268,   269,     0,     0,   270,   271,   272,   273,
     274,     0,   275,   276,   277,   278,   279,     0,     0,     0,
     281,   282,   283,   284,   285,   286,     0,   288,   289,   290,
       0,   291,   292,   293,   294,   295,   296,     0,     0,   298,
     299,   300,     0,     0,     0,     0,     0,     0,     0,   302,
     303,   304,   305,   306,   307,   308,   309,   310,     0,   311,
       0,   312,   313,   314,   315,   316,   317,   318,     0,   319,
     320,   321,   322,     0,     0,   323,   324,   325,   326,   327,
       0,   328,   329,   330,     0,   331,   332,   333,     0,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,     0,
     344,     0,   345,   346,   347,   348,   349,     0,   350,     0,
     351,     0,     0,     0,   354,   355,   356,   357,     0,   358,
     359,     0,   360,   361,   362,     0,   363,   364,   365,   366,
     367,     0,   369,   370,   371,   372,     0,   373,   374,   375,
     376,   377,   378,   379,     0,   380,     0,   382,   383,   384,
     385,   386,   387,   388,     0,   389,     0,   390,     0,     0,
     393,     0,   395,   396,   397,   398,   399,     0,     0,   400,
     401,     0,   403,     0,     0,   405,   406,   407,     0,     0,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,     0,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
     438,     0,   439,   440,     0,   442,     0,   443,   444,   445,
     446,   447,   448,     0,   449,   450,     0,     0,   451,   452,
     453,     0,     0,   454,   455,   456,     0,   458,     0,   460,
     461,   462,   463,   464,   465,   466,   467,   468,   469,   470,
       0,     0,   471,   472,   473,   474,   475,   476,   477,   478,
       0,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,   490,   491,   492,   493,     0,   494,   495,   496,
     497,   498,   499,   500,   501,   502,   503,   504,   505,   506,
       0,   507,   508,     0,   510,   511,   512,   513,   514,   515,
     516,   517,   518,   519,   520,   521,   522,   523,   524,     0,
     525,   526,   527,   528,   529,     0,   530,   531,   532,   533,
     534,     0,   536,   537,   538,   539,     0,   540,   541,   542,
     543,   544,   545,   546,   547,   548,   549,   550,   551,   552,
     553,   554,     0,   555,   556,     0,   557,     0,   559,   560,
     561,   562,   563,     0,   564,   565,   566,     0,     0,   567,
     568,   569,   570,   571,     0,   572,   573,   574,   575,   576,
     577,   578,   579,     0,     0,   580,   581,   582,   583,   584,
       0,     0,   585,   586,   587,   588,   589,   590,   591,     0,
     592,     0,   594,   595,   596,   597,     0,     0,   598,     0,
       0,   599,   600,   601,   602,   603,   604,   605,   606,   607,
     608,   609,   610,   611,   612,   613,   614,   615,   616,   617,
     618,   626,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   236,   237,
     238,   239,   240,   241,   242,   243,   676,   244,   245,   246,
       0,     0,     0,     0,     0,     0,     0,   247,   248,   249,
       0,   250,   251,   252,   253,     0,   255,   256,   257,   258,
     259,     0,   261,   262,     0,   263,   264,   265,   266,   267,
     268,   269,     0,     0,   270,   271,   272,   273,   274,     0,
     275,   276,   277,   278,   279,     0,     0,     0,   281,   282,
     283,   284,   285,   286,     0,   288,   289,   290,     0,   291,
     292,   293,   294,   295,   296,     0,     0,   298,   299,   300,
       0,     0,     0,     0,     0,     0,     0,   302,   303,   304,
     305,   306,   307,   308,   309,   310,     0,   311,     0,   312,
     313,   314,   315,   316,   317,   318,     0,   319,   320,   321,
     322,     0,     0,   323,   324,   325,   326,   327,     0,   328,
     329,   330,     0,   331,   332,   333,     0,   334,   335,   336,
     337,   338,   339,   340,   341,   342,   343,     0,   344,     0,
     345,   346,   347,   348,   349,     0,   350,     0,   351,     0,
       0,     0,   354,   355,   356,   357,     0,   358,   359,     0,
     360,   361,   362,     0,   363,   364,   365,   366,   367,     0,
     369,   370,   371,   372,     0,   373,   374,   375,   376,   377,
     378,   379,     0,   380,     0,   382,   383,   384,   385,   386,
     387,   388,     0,   389,     0,   390,     0,     0,   393,     0,
     395,   396,   397,   398,   399,     0,     0,   400,   401,     0,
     403,     0,     0,   405,   406,   407,     0,     0,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,     0,   428,   429,
     430,   431,   432,   433,   434,   435,   436,   437,   438,     0,
     439,   440,     0,   442,     0,   443,   444,   445,   446,   447,
     448,     0,   449,   450,     0,     0,   451,   452,   453,     0,
       0,   454,   455,   456,     0,   458,     0,   460,   461,   462,
     463,   464,   465,   466,   467,   468,   469,   470,     0,     0,
     471,   472,   473,   474,   475,   476,   677,   478,     0,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,   493,     0,   494,   495,   496,   497,   498,
     499,   500,   501,   502,   503,   504,   505,   506,     0,   507,
     508,     0,   510,   511,   512,   513,   514,   515,   516,   517,
     518,   519,   520,   521,   522,   523,   524,     0,   525,   526,
     527,   528,   529,     0,   530,   531,   532,   533,   534,     0,
     536,   537,   538,   539,     0,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,   552,   553,   554,
       0,   555,   556,     0,   557,     0,   559,   560,   561,   562,
     563,     0,   564,   565,   566,     0,     0,   567,   568,   569,
     570,   571,     0,   572,   573,   574,   575,   576,   577,   578,
     579,     0,     0,   580,   581,   582,   583,   584,     0,     0,
     585,   586,   587,   588,   589,   590,   591,     0,   592,     0,
     594,   595,   596,   597,     0,     0,   598,     0,     0,   599,
     600,   601,   602,   603,   604,   605,   606,   607,   608,   609,
     610,   611,   612,   613,   614,   615,   616,   617,   618,   626,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   236,   237,   238,   239,
     240,   241,   242,   243,   799,   244,   245,   246,     0,     0,
       0,     0,     0,     0,     0,   247,   248,   249,     0,   250,
     251,   252,   253,     0,   255,   256,   257,   258,   259,     0,
     261,   262,     0,   263,   264,   265,   266,   267,   268,   269,
       0,     0,   270,   271,   272,   273,   274,     0,   275,   276,
     277,   278,   279,     0,     0,     0,   281,   282,   283,   284,
     285,   286,     0,   288,   289,   290,     0,   291,   292,   293,
     294,   295,   296,     0,     0,   298,   299,   300,     0,     0,
       0,     0,     0,     0,     0,   302,   303,   304,   305,   306,
     307,   308,   309,   310,     0,   311,     0,   312,   313,   314,
     315,   316,   317,   318,     0,   319,   320,   321,   322,     0,
       0,   323,   324,   325,   326,   327,     0,   328,   329,   330,
       0,   331,   332,   333,     0,   334,   335,   336,   337,   338,
     339,   340,   341,   342,   343,     0,   344,     0,   345,   346,
     347,   348,   349,     0,   350,     0,   351,     0,     0,     0,
     354,   355,   356,   357,     0,   358,   359,     0,   360,   361,
     362,     0,   363,   364,   365,   366,   367,     0,   369,   370,
     371,   372,     0,   373,   374,   375,   376,   377,   378,   379,
       0,   380,     0,   382,   383,   384,   385,   386,   387,   388,
       0,   389,     0,   390,     0,     0,   393,     0,   395,   396,
     397,   398,   399,     0,     0,   400,   401,     0,   403,     0,
       0,   405,   406,   407,     0,     0,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,     0,   428,   429,   430,   431,
     432,   433,   434,   435,   436,   437,   438,     0,   439,   440,
       0,   442,     0,   443,   444,   445,   446,   447,   448,     0,
     449,   450,     0,     0,   451,   452,   453,     0,     0,   454,
     455,   456,     0,   458,     0,   460,   461,   462,   463,   464,
     465,   466,   467,   468,   469,   470,     0,     0,   471,   472,
     473,   474,   475,   476,   477,   478,     0,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,   490,   491,
     492,   493,     0,   494,   495,   496,   497,   498,   499,   500,
     501,   502,   503,   504,   505,   506,     0,   507,   508,     0,
     510,   511,   512,   513,   514,   515,   516,   517,   518,   519,
     520,   521,   522,   523,   524,     0,   525,   526,   527,   528,
     800,     0,   530,   531,   532,   533,   534,     0,   536,   537,
     538,   539,     0,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,   551,   552,   553,   554,     0,   555,
     556,     0,   557,     0,   559,   560,   561,   562,   563,     0,
     564,   801,   566,     0,     0,   802,   568,   569,   570,   571,
       0,   572,   573,   574,   575,   576,   577,   578,   579,     0,
       0,   580,   581,   582,   583,   584,     0,     0,   585,   586,
     587,   588,   589,   590,   591,     0,   592,     0,   594,   595,
     596,   597,     0,     0,   598,     0,     0,   599,   600,   601,
     602,   603,   604,   605,   606,   607,   608,   609,   610,   611,
     612,   613,   614,   615,   616,   617,   618,   626,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   236,   237,   238,   239,   240,   241,
     242,   243,   833,   244,   245,   246,     0,     0,     0,     0,
       0,     0,     0,   247,   248,   249,     0,   250,   251,   252,
     253,     0,   255,   256,   257,   258,   259,     0,   261,   262,
       0,   263,   264,   265,   266,   267,   268,   269,     0,     0,
     270,   271,   272,   273,   274,     0,   275,   276,   277,   278,
     279,     0,     0,     0,   281,   282,   283,   284,   285,   286,
       0,   288,   289,   290,     0,   291,   292,   293,   294,   295,
     296,     0,     0,   298,   299,   300,     0,     0,     0,     0,
       0,     0,     0,   302,   303,   304,   305,   306,   307,   308,
     309,   310,     0,   311,     0,   312,   313,   314,   315,   316,
     317,   318,     0,   319,   320,   321,   322,     0,     0,   323,
     324,   325,   326,   327,     0,   328,   329,   330,     0,   331,
     332,   333,     0,   334,   335,   336,   337,   338,   339,   340,
     341,   342,   343,     0,   344,     0,   345,   346,   347,   348,
     349,     0,   350,     0,   351,     0,     0,     0,   354,   355,
     356,   357,     0,   358,   359,     0,   360,   361,   362,     0,
     363,   364,   365,   366,   367,     0,   369,   370,   371,   372,
       0,   373,   374,   375,   376,   377,   378,   379,     0,   380,
       0,   382,   383,   384,   385,   386,   387,   388,     0,   389,
       0,   390,     0,     0,   393,     0,   395,   396,   397,   398,
     399,     0,     0,   400,   401,     0,   403,     0,     0,   405,
     406,   407,     0,     0,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,     0,   428,   429,   430,   431,   432,   433,
     434,   435,   436,   437,   438,     0,   439,   440,     0,   442,
       0,   443,   444,   445,   446,   447,   448,     0,   449,   450,
       0,     0,   451,   452,   453,     0,     0,   454,   455,   456,
       0,   458,     0,   460,   461,   462,   463,   464,   465,   466,
     467,   468,   469,   470,     0,     0,   471,   472,   473,   474,
     475,   476,   477,   478,     0,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   490,   491,   492,   493,
       0,   494,   495,   496,   497,   498,   499,   500,   501,   502,
     503,   504,   505,   506,     0,   507,   508,     0,   510,   511,
     512,   513,   514,   515,   516,   517,   518,   519,   520,   521,
     522,   523,   524,     0,   525,   526,   527,   528,   834,     0,
     530,   531,   532,   533,   534,     0,   536,   537,   538,   539,
       0,   540,   541,   542,   543,   544,   545,   546,   547,   548,
     549,   550,   551,   552,   553,   554,     0,   555,   556,     0,
     557,     0,   559,   560,   561,   562,   563,     0,   564,   835,
     566,     0,     0,   836,   568,   569,   570,   571,     0,   572,
     573,   574,   575,   576,   577,   578,   579,     0,     0,   580,
     581,   582,   583,   584,     0,     0,   585,   586,   587,   588,
     589,   590,   591,     0,   592,     0,   594,   595,   596,   597,
       0,     0,   598,     0,     0,   599,   600,   601,   602,   603,
     604,   605,   606,   607,   608,   609,   610,   611,   612,   613,
     614,   615,   616,   617,   618,   626,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   236,   237,   238,   239,   240,   241,   242,   243,
       0,   244,   245,   246,     0,     0,     0,     0,     0,     0,
       0,   247,   248,   249,     0,   250,   251,   252,   253,     0,
     255,   256,   257,   258,   259,     0,   261,   262,     0,   263,
     264,   265,   266,   267,   268,   269,     0,     0,   270,   271,
     272,   273,   274,     0,   275,   276,   277,   278,   279,     0,
       0,     0,   281,   282,   283,   284,   285,   286,     0,   288,
     289,   290,     0,   291,   292,   293,   294,   295,   296,     0,
       0,   298,   299,   300,     0,     0,     0,     0,     0,     0,
       0,   302,   303,   304,   305,   306,   307,   308,   309,   310,
       0,   311,     0,   312,   313,   314,   315,   316,   317,   318,
       0,   319,   320,   321,   322,     0,     0,   323,   324,   325,
     326,   327,     0,   328,   329,   330,     0,   331,   332,   333,
       0,   334,   335,   336,   337,   338,   339,   340,   341,   342,
     343,     0,   344,     0,   345,   346,   347,   348,   349,     0,
     350,     0,   351,     0,     0,     0,   354,   355,   356,   357,
       0,   358,   359,     0,   360,   361,   362,     0,   363,   364,
     365,   366,   367,     0,   369,   370,   371,   372,     0,   373,
     374,   375,   376,   377,   378,   379,     0,   380,     0,   382,
     383,   384,   385,   386,   387,   388,     0,   389,     0,   390,
       0,     0,   393,     0,   395,   396,   397,   398,   399,     0,
       0,   400,   401,     0,   403,     0,     0,   405,   406,   407,
       0,     0,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,     0,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438,     0,   439,   440,     0,   442,     0,   443,
     444,   445,   446,   447,   448,     0,   449,   450,     0,   839,
     451,   452,   453,     0,     0,   454,   455,   456,     0,   458,
       0,   460,   461,   462,   463,   464,   465,   466,   467,   468,
     469,   470,     0,     0,   471,   472,   473,   474,   475,   476,
     477,   478,     0,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,   492,   493,     0,   494,
     495,   496,   497,   498,   499,   500,   501,   502,   503,   504,
     505,   506,     0,   507,   508,     0,   510,   511,   512,   513,
     514,   515,   516,   517,   518,   519,   520,   521,   522,   523,
     524,     0,   525,   526,   527,   528,   529,     0,   530,   531,
     532,   533,   534,     0,   536,   537,   538,   539,     0,   540,
     541,   542,   543,   544,   545,   546,   547,   548,   549,   550,
     551,   552,   553,   554,     0,   555,   556,     0,   557,     0,
     559,   560,   561,   562,   563,     0,   564,   565,   566,     0,
       0,   567,   568,   569,   570,   571,     0,   572,   573,   574,
     575,   576,   577,   578,   579,     0,     0,   580,   581,   582,
     583,   584,     0,     0,   585,   586,   587,   588,   589,   590,
     591,     0,   592,     0,   594,   595,   596,   597,     0,     0,
     598,     0,     0,   599,   600,   601,   602,   603,   604,   605,
     606,   607,   608,   609,   610,   611,   612,   613,   614,   615,
     616,   617,   618,   626,     0,     0,     0,     0,     0,     0,
       0,     0,   897,     0,     0,     0,     0,     0,     0,     0,
     236,   237,   238,   239,   240,   241,   242,   243,     0,   244,
     245,   246,     0,     0,     0,     0,     0,     0,     0,   247,
     248,   249,     0,   250,   251,   252,   253,     0,   255,   256,
     257,   258,   259,     0,   261,   262,     0,   263,   264,   265,
     266,   267,   268,   269,     0,     0,   270,   271,   272,   273,
     274,     0,   275,   276,   277,   278,   279,     0,     0,     0,
     281,   282,   283,   284,   285,   286,     0,   288,   289,   290,
       0,   291,   292,   293,   294,   295,   296,     0,     0,   298,
     299,   300,     0,     0,     0,     0,     0,     0,     0,   302,
     303,   304,   305,   306,   307,   308,   309,   310,     0,   311,
       0,   312,   313,   314,   315,   316,   317,   318,     0,   319,
     320,   321,   322,     0,     0,   323,   324,   325,   326,   327,
       0,   328,   329,   330,     0,   331,   332,   333,     0,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,     0,
     344,     0,   345,   346,   347,   348,   349,     0,   350,     0,
     351,     0,     0,     0,   354,   355,   356,   357,     0,   358,
     359,     0,   360,   361,   362,     0,   363,   364,   365,   366,
     367,     0,   369,   370,   371,   372,     0,   373,   374,   375,
     376,   377,   378,   379,     0,   380,     0,   382,   383,   384,
     385,   386,   387,   388,     0,   389,     0,   390,     0,     0,
     393,     0,   395,   396,   397,   398,   399,     0,     0,   400,
     401,     0,   403,     0,     0,   405,   406,   407,     0,     0,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,     0,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
     438,     0,   439,   440,     0,   442,     0,   443,   444,   445,
     446,   447,   448,     0,   449,   450,     0,     0,   451,   452,
     453,     0,     0,   454,   455,   456,     0,   458,     0,   460,
     461,   462,   463,   464,   465,   466,   467,   468,   469,   470,
       0,     0,   471,   472,   473,   474,   475,   476,   477,   478,
       0,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,   490,   491,   492,   493,     0,   494,   495,   496,
     497,   498,   499,   500,   501,   502,   503,   504,   505,   506,
       0,   507,   508,     0,   510,   511,   512,   513,   514,   515,
     516,   517,   518,   519,   520,   521,   522,   523,   524,     0,
     525,   526,   527,   528,   529,     0,   530,   531,   532,   533,
     534,     0,   536,   537,   538,   539,     0,   540,   541,   542,
     543,   544,   545,   546,   547,   548,   549,   550,   551,   552,
     553,   554,     0,   555,   556,     0,   557,     0,   559,   560,
     561,   562,   563,     0,   564,   565,   566,     0,     0,   567,
     568,   569,   570,   571,     0,   572,   573,   574,   575,   576,
     577,   578,   579,     0,     0,   580,   581,   582,   583,   584,
       0,     0,   585,   586,   587,   588,   589,   590,   591,     0,
     592,     0,   594,   595,   596,   597,     0,     0,   598,     0,
       0,   599,   600,   601,   602,   603,   604,   605,   606,   607,
     608,   609,   610,   611,   612,   613,   614,   615,   616,   617,
     618,   626,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   236,   237,
     238,   239,   240,   241,   242,   243,   952,   244,   245,   246,
       0,     0,     0,     0,     0,     0,     0,   247,   248,   249,
       0,   250,   251,   252,   253,     0,   255,   256,   257,   258,
     259,     0,   261,   262,     0,   263,   264,   265,   266,   267,
     268,   269,     0,     0,   270,   271,   272,   273,   274,     0,
     275,   276,   277,   278,   279,     0,     0,     0,   281,   282,
     283,   284,   285,   286,     0,   288,   289,   290,     0,   291,
     292,   293,   294,   295,   296,     0,     0,   298,   299,   300,
       0,     0,     0,     0,     0,     0,     0,   302,   303,   304,
     305,   306,   307,   308,   309,   310,     0,   311,     0,   312,
     313,   314,   315,   316,   317,   318,     0,   319,   320,   321,
     322,     0,     0,   323,   324,   325,   326,   327,     0,   328,
     329,   330,     0,   331,   332,   333,     0,   334,   335,   336,
     337,   338,   339,   340,   341,   342,   343,     0,   344,     0,
     345,   346,   347,   348,   349,     0,   350,     0,   351,     0,
       0,     0,   354,   355,   356,   357,     0,   358,   359,     0,
     360,   361,   362,     0,   363,   364,   365,   366,   953,     0,
     369,   370,   371,   372,     0,   373,   374,   375,   376,   377,
     378,   379,     0,   380,     0,   382,   383,   384,   385,   386,
     387,   388,     0,   389,     0,   390,     0,     0,   393,     0,
     395,   396,   397,   398,   399,     0,     0,   400,   401,     0,
     403,     0,     0,   405,   406,   407,     0,     0,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,     0,   428,   429,
     430,   431,   432,   433,   434,   435,   436,   437,   438,     0,
     439,   440,     0,   442,     0,   443,   444,   445,   446,   447,
     448,     0,   449,   450,     0,     0,   451,   452,   453,     0,
       0,   454,   455,   456,     0,   458,     0,   460,   461,   462,
     463,   464,   465,   466,   467,   468,   469,   470,     0,     0,
     471,   472,   473,   474,   475,   476,   477,   478,     0,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,   493,     0,   494,   495,   496,   497,   498,
     499,   500,   501,   502,   503,   504,   505,   506,     0,   507,
     508,     0,   510,   511,   512,   513,   514,   515,   516,   517,
     518,   519,   520,   521,   522,   523,   524,     0,   525,   526,
     527,   528,   529,     0,   530,   531,   532,   533,   534,     0,
     536,   537,   538,   539,     0,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,   552,   553,   554,
       0,   555,   556,     0,   557,     0,   559,   560,   561,   562,
     563,     0,   564,   565,   566,     0,     0,   567,   568,   569,
     570,   571,     0,   572,   573,   574,   575,   576,   577,   578,
     579,     0,     0,   580,   581,   582,   583,   584,     0,     0,
     585,   586,   587,   588,   589,   590,   591,     0,   592,     0,
     594,   595,   596,   597,     0,     0,   598,     0,     0,   599,
     600,   601,   602,   603,   604,   605,   606,   607,   608,   609,
     610,   611,   612,   613,   614,   615,   616,   617,   618,   626,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   236,   237,   238,   239,
     240,   241,   242,   243,  1113,   244,   245,   246,     0,     0,
       0,     0,     0,     0,     0,   247,   248,   249,     0,   250,
     251,   252,   253,     0,   255,   256,   257,   258,   259,     0,
     261,   262,     0,   263,   264,   265,   266,   267,   268,   269,
       0,     0,   270,   271,   272,   273,   274,     0,   275,   276,
     277,   278,   279,     0,     0,     0,   281,   282,   283,   284,
     285,   286,     0,   288,   289,   290,     0,   291,   292,   293,
     294,   295,   296,     0,     0,   298,   299,   300,     0,     0,
       0,     0,     0,     0,     0,   302,   303,   304,   305,   306,
     307,   308,   309,   310,     0,   311,     0,   312,   313,   314,
     315,   316,   317,   318,     0,   319,   320,   321,   322,     0,
       0,   323,   324,   325,   326,   327,     0,   328,   329,   330,
       0,   331,   332,   333,     0,   334,   335,   336,   337,   338,
     339,   340,   341,   342,   343,     0,   344,     0,   345,   346,
     347,   348,   349,     0,   350,     0,   351,     0,     0,     0,
     354,   355,   356,   357,     0,   358,   359,     0,   360,   361,
     362,     0,   363,   364,   365,   366,   367,     0,   369,   370,
     371,   372,     0,   373,   374,   375,   376,   377,   378,   379,
       0,   380,     0,   382,   383,   384,   385,   386,   387,   388,
       0,   389,     0,   390,     0,     0,   393,     0,   395,   396,
     397,   398,   399,     0,     0,   400,   401,     0,   403,     0,
       0,   405,   406,   407,     0,     0,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,     0,   428,   429,   430,   431,
     432,   433,   434,   435,   436,   437,   438,     0,   439,   440,
       0,   442,     0,   443,   444,   445,   446,   447,   448,     0,
     449,   450,     0,     0,   451,   452,   453,     0,     0,   454,
     455,   456,     0,   458,     0,   460,   461,   462,   463,   464,
     465,   466,   467,   468,   469,   470,     0,     0,   471,   472,
     473,   474,   475,   476,   477,   478,     0,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,   490,   491,
     492,   493,     0,   494,   495,   496,   497,   498,   499,   500,
     501,   502,   503,   504,   505,   506,     0,   507,   508,     0,
     510,   511,   512,   513,   514,   515,   516,   517,   518,   519,
     520,   521,   522,   523,   524,     0,   525,   526,   527,   528,
     529,     0,   530,   531,   532,   533,   534,     0,   536,   537,
     538,   539,     0,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,   551,   552,   553,   554,     0,   555,
     556,     0,   557,     0,   559,   560,   561,   562,   563,     0,
     564,   565,   566,     0,     0,   567,   568,   569,   570,   571,
       0,   572,   573,   574,   575,   576,   577,   578,   579,     0,
       0,   580,   581,   582,   583,   584,     0,     0,   585,   586,
     587,   588,   589,   590,   591,     0,   592,     0,   594,   595,
     596,   597,     0,     0,   598,     0,     0,   599,   600,   601,
     602,   603,   604,   605,   606,   607,   608,   609,   610,   611,
     612,   613,   614,   615,   616,   617,   618,   626,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   236,   237,   238,   239,   240,   241,
     242,   243,   799,   244,   245,   246,     0,     0,     0,     0,
       0,     0,     0,   247,   248,   249,     0,   250,   251,   252,
     253,     0,   255,   256,   257,   258,   259,     0,   261,   262,
       0,   263,   264,   265,   266,   267,   268,   269,     0,     0,
     270,   271,   272,   273,   274,     0,   275,   276,   277,   278,
     279,     0,     0,     0,   281,   282,   283,   284,   285,   286,
       0,   288,   289,   290,     0,   291,   292,   293,   294,   295,
     296,     0,     0,   298,   299,   300,     0,     0,     0,     0,
       0,     0,     0,   302,   303,   304,   305,   306,   307,   308,
     309,   310,     0,   311,     0,   312,   313,   314,   315,   316,
     317,   318,     0,   319,   320,   321,   322,     0,     0,   323,
     324,   325,   326,   327,     0,   328,   329,   330,     0,   331,
     332,   333,     0,   334,   335,   336,   337,   338,   339,   340,
     341,   342,   343,     0,   344,     0,   345,   346,   347,   348,
     349,     0,   350,     0,   351,     0,     0,     0,   354,   355,
     356,   357,     0,   358,   359,     0,   360,   361,   362,     0,
     363,   364,   365,   366,   367,     0,   369,   370,   371,   372,
       0,   373,   374,   375,   376,   377,   378,   379,     0,   380,
       0,   382,   383,   384,   385,   386,   387,   388,     0,   389,
       0,   390,     0,     0,   393,     0,   395,   396,   397,   398,
     399,     0,     0,   400,   401,     0,   403,     0,     0,   405,
     406,   407,     0,     0,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,     0,   428,   429,   430,   431,   432,   433,
     434,   435,   436,   437,   438,     0,   439,   440,     0,   442,
       0,   443,   444,   445,   446,   447,   448,     0,   449,   450,
       0,     0,   451,   452,   453,     0,     0,   454,   455,   456,
       0,   458,     0,   460,   461,   462,   463,   464,   465,   466,
     467,   468,   469,   470,     0,     0,   471,   472,   473,   474,
     475,   476,   477,   478,     0,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   490,   491,   492,   493,
       0,   494,   495,   496,   497,   498,   499,   500,   501,   502,
     503,   504,   505,   506,     0,   507,   508,     0,   510,   511,
     512,   513,   514,   515,   516,   517,   518,   519,   520,   521,
     522,   523,   524,     0,   525,   526,   527,   528,   529,     0,
     530,   531,   532,   533,   534,     0,   536,   537,   538,   539,
       0,   540,   541,   542,   543,   544,   545,   546,   547,   548,
     549,   550,   551,   552,   553,   554,     0,   555,   556,     0,
     557,     0,   559,   560,   561,   562,   563,     0,   564,   565,
     566,     0,     0,   567,   568,   569,   570,   571,     0,   572,
     573,   574,   575,   576,   577,   578,   579,     0,     0,   580,
     581,   582,   583,   584,     0,     0,   585,   586,   587,   588,
     589,   590,   591,     0,   592,     0,   594,   595,   596,   597,
       0,     0,   598,     0,     0,   599,   600,   601,   602,   603,
     604,   605,   606,   607,   608,   609,   610,   611,   612,   613,
     614,   615,   616,   617,   618,   626,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   236,   237,   238,   239,   240,   241,   242,   243,
    1219,   244,   245,   246,     0,     0,     0,     0,     0,     0,
       0,   247,   248,   249,     0,   250,   251,   252,   253,     0,
     255,   256,   257,   258,   259,     0,   261,   262,     0,   263,
     264,   265,   266,   267,   268,   269,     0,     0,   270,   271,
     272,   273,   274,     0,   275,   276,   277,   278,   279,     0,
       0,     0,   281,   282,   283,   284,   285,   286,     0,   288,
     289,   290,     0,   291,   292,   293,   294,   295,   296,     0,
       0,   298,   299,   300,     0,     0,     0,     0,     0,     0,
       0,   302,   303,   304,   305,   306,   307,   308,   309,   310,
       0,   311,     0,   312,   313,   314,   315,   316,   317,   318,
       0,   319,   320,   321,   322,     0,     0,   323,   324,   325,
     326,   327,     0,   328,   329,   330,     0,   331,   332,   333,
       0,   334,   335,   336,   337,   338,   339,   340,   341,   342,
     343,     0,   344,     0,   345,   346,   347,   348,   349,     0,
     350,     0,   351,     0,     0,     0,   354,   355,   356,   357,
       0,   358,   359,     0,   360,   361,   362,     0,   363,   364,
     365,   366,   367,     0,   369,   370,   371,   372,     0,   373,
     374,   375,   376,   377,   378,   379,     0,   380,     0,   382,
     383,   384,   385,   386,   387,   388,     0,   389,     0,   390,
       0,     0,   393,     0,   395,   396,   397,   398,   399,     0,
       0,   400,   401,     0,   403,     0,     0,   405,   406,   407,
       0,     0,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,     0,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438,     0,   439,   440,     0,   442,     0,   443,
     444,   445,   446,   447,   448,     0,   449,   450,     0,     0,
     451,   452,   453,     0,     0,   454,   455,   456,     0,   458,
       0,   460,   461,   462,   463,   464,   465,   466,   467,   468,
     469,   470,     0,     0,   471,   472,   473,   474,   475,   476,
     477,   478,     0,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,   492,   493,     0,   494,
     495,   496,   497,   498,   499,   500,   501,   502,   503,   504,
     505,   506,     0,   507,   508,     0,   510,   511,   512,   513,
     514,   515,   516,   517,   518,   519,   520,   521,   522,   523,
     524,     0,   525,   526,   527,   528,   529,     0,   530,   531,
     532,   533,   534,     0,   536,   537,   538,   539,     0,   540,
     541,   542,   543,   544,   545,   546,   547,   548,   549,   550,
     551,   552,   553,   554,     0,   555,   556,     0,   557,     0,
     559,   560,   561,   562,   563,     0,   564,   565,   566,     0,
       0,   567,   568,   569,   570,   571,     0,   572,   573,   574,
     575,   576,   577,   578,   579,     0,     0,   580,   581,   582,
     583,   584,     0,     0,   585,   586,   587,   588,   589,   590,
     591,     0,   592,     0,   594,   595,   596,   597,     0,     0,
     598,     0,     0,   599,   600,   601,   602,   603,   604,   605,
     606,   607,   608,   609,   610,   611,   612,   613,   614,   615,
     616,   617,   618,   626,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     236,   237,   238,   239,   240,   241,   242,   243,  1350,   244,
     245,   246,     0,     0,     0,     0,     0,     0,     0,   247,
     248,   249,     0,   250,   251,   252,   253,     0,   255,   256,
     257,   258,   259,     0,   261,   262,     0,   263,   264,   265,
     266,   267,   268,   269,     0,     0,   270,   271,   272,   273,
     274,     0,   275,   276,   277,   278,   279,     0,     0,     0,
     281,   282,   283,   284,   285,   286,     0,   288,   289,   290,
       0,   291,   292,   293,   294,   295,   296,     0,     0,   298,
     299,   300,     0,     0,     0,     0,     0,     0,     0,   302,
     303,   304,   305,   306,   307,   308,   309,   310,     0,   311,
       0,   312,   313,   314,   315,   316,   317,   318,     0,   319,
     320,   321,   322,     0,     0,   323,   324,   325,   326,   327,
       0,   328,   329,   330,     0,   331,   332,   333,     0,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,     0,
     344,     0,   345,   346,   347,   348,   349,     0,   350,     0,
     351,     0,     0,     0,   354,   355,   356,   357,     0,   358,
     359,     0,   360,   361,   362,     0,   363,   364,   365,   366,
     367,     0,   369,   370,   371,   372,     0,   373,   374,   375,
     376,   377,   378,   379,     0,   380,     0,   382,   383,   384,
     385,   386,   387,   388,     0,   389,     0,   390,     0,     0,
     393,     0,   395,   396,   397,   398,   399,     0,     0,   400,
     401,     0,   403,     0,     0,   405,   406,   407,     0,     0,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,     0,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
     438,     0,   439,   440,     0,   442,     0,   443,   444,   445,
     446,   447,   448,     0,   449,   450,     0,     0,   451,   452,
     453,     0,     0,   454,   455,   456,     0,   458,     0,   460,
     461,   462,   463,   464,   465,   466,   467,   468,   469,   470,
       0,     0,   471,   472,   473,   474,   475,   476,   477,   478,
       0,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,   490,   491,   492,   493,     0,   494,   495,   496,
     497,   498,   499,   500,   501,   502,   503,   504,   505,   506,
       0,   507,   508,     0,   510,   511,   512,   513,   514,   515,
     516,   517,   518,   519,   520,   521,   522,   523,   524,     0,
     525,   526,   527,   528,   529,     0,   530,   531,   532,   533,
     534,     0,   536,   537,   538,   539,     0,   540,   541,   542,
     543,   544,   545,   546,   547,   548,   549,   550,   551,   552,
     553,   554,     0,   555,   556,     0,   557,     0,   559,   560,
     561,   562,   563,     0,   564,   565,   566,     0,     0,   567,
     568,   569,   570,   571,     0,   572,   573,   574,   575,   576,
     577,   578,   579,     0,     0,   580,   581,   582,   583,   584,
       0,     0,   585,   586,   587,   588,   589,   590,   591,     0,
     592,     0,   594,   595,   596,   597,     0,     0,   598,     0,
       0,   599,   600,   601,   602,   603,   604,   605,   606,   607,
     608,   609,   610,   611,   612,   613,   614,   615,   616,   617,
     618,   626,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   236,   237,
     238,   239,   240,   241,   242,   243,     0,   244,   245,   246,
       0,     0,     0,     0,     0,     0,     0,   247,   248,   249,
       0,   250,   251,   252,   253,  1361,   255,   256,   257,   258,
     259,     0,   261,   262,     0,   263,   264,   265,   266,   267,
     268,   269,     0,     0,   819,   271,   272,   273,  1362,     0,
     275,   276,   277,   278,   279,     0,     0,     0,   281,   282,
     283,   284,   285,   286,     0,   288,   289,   290,     0,   291,
     292,   293,   294,   295,   296,     0,     0,   298,   299,   300,
       0,     0,     0,     0,     0,     0,     0,   302,   303,   304,
     305,   306,   307,   308,   309,   310,     0,   311,     0,   312,
     313,   314,   315,   316,   317,   318,     0,   319,   320,   321,
     322,     0,     0,   323,   324,   325,   326,   327,     0,   328,
     329,   330,     0,   331,   332,   333,     0,   334,   335,   336,
     337,   338,   339,   340,   341,   342,   343,     0,   344,     0,
     345,   346,   347,   348,   349,     0,   350,     0,   351,     0,
       0,     0,   354,   355,   356,   357,     0,   358,   359,     0,
     360,   361,   362,     0,   363,   364,   365,   366,   367,     0,
     369,   370,   371,   372,     0,   373,   374,   375,   376,   377,
     378,   379,     0,   380,     0,   382,   383,   384,   385,   386,
     387,   388,     0,   389,     0,   390,     0,     0,   393,     0,
     395,   396,   397,   398,   399,     0,     0,   400,   401,     0,
     403,     0,     0,   405,   406,   407,     0,     0,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   822,   426,     0,   428,   429,
     430,   431,   432,   433,   434,   435,   436,   437,   438,     0,
     439,   440,     0,   442,     0,   443,   444,   445,   446,   447,
     448,     0,   449,   450,     0,     0,   451,   452,   453,     0,
       0,   454,   455,   456,     0,   458,     0,   460,   461,   462,
     463,   464,   465,   466,   467,   468,   469,   470,     0,     0,
     471,   472,   473,   474,   475,   476,   477,   478,     0,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,   493,     0,   494,   495,   496,   497,   498,
     499,   500,   501,   502,   503,   504,   505,   506,     0,   507,
     508,     0,   823,   511,   512,   513,   514,   515,   516,   517,
     518,   824,   520,   521,   522,   523,   524,     0,   525,   526,
     527,   528,  1354,     0,   530,   531,   532,   533,   534,     0,
     536,   537,   538,   539,     0,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,   552,   553,   554,
       0,   555,   556,     0,   557,     0,   559,   560,   561,   562,
     563,     0,   564,   826,   566,     0,     0,   827,   568,   569,
     570,   571,     0,   572,   573,   574,   575,   576,   577,   578,
     579,     0,     0,   580,   581,   582,   583,   584,     0,     0,
     585,   586,   587,   588,   589,   590,   591,     0,   592,     0,
     594,   595,   596,   597,     0,     0,   598,     0,     0,   599,
     600,   601,   602,   603,   828,   605,   606,   607,   608,   609,
     610,   611,   612,   613,   614,   615,   616,   617,   618,   626,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   236,   237,   238,   239,
     240,   241,   242,   243,     0,   244,   245,   246,     0,     0,
       0,     0,     0,     0,     0,   247,   248,   249,     0,   250,
     251,   252,   253,     0,   255,   256,   257,   258,   259,     0,
     261,   262,     0,   263,   264,   265,   266,   267,   268,   269,
       0,     0,   270,   271,   272,   273,   274,     0,   275,   276,
     277,   278,   279,     0,     0,     0,   281,   282,   283,   284,
     285,   286,     0,   288,   289,   290,     0,   291,   292,   293,
     294,   295,   296,     0,     0,   298,   299,   300,     0,     0,
       0,     0,     0,     0,     0,   302,   303,   304,   305,   306,
     307,   308,   309,   310,     0,   311,     0,   312,   313,   314,
     315,   316,   317,   318,     0,   319,   320,   321,   322,     0,
       0,   323,   324,   325,   326,   327,     0,   328,   329,   330,
       0,   331,   332,   333,     0,   334,   335,   336,   337,   338,
     339,   340,   341,   342,   343,     0,   344,     0,   345,   346,
     347,   348,   349,     0,   350,     0,   351,     0,     0,     0,
     354,   355,   356,   357,     0,   358,   359,     0,   360,   361,
     362,     0,   363,   364,   365,   366,  1508,     0,   369,   370,
     371,   372,     0,   373,   374,   375,   376,   377,   378,   379,
       0,   380,     0,   382,   383,   384,   385,   386,   387,   388,
       0,   389,     0,   390,     0,     0,   393,     0,   395,   396,
     397,   398,   399,     0,     0,   400,   401,     0,   403,     0,
       0,   405,   406,   407,     0,     0,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,     0,   428,   429,   430,   431,
     432,   433,   434,   435,   436,   437,   438,     0,   439,   440,
       0,   442,     0,   443,   444,   445,   446,   447,   448,     0,
     449,   450,     0,   839,   451,   452,   453,     0,     0,   454,
     455,   456,     0,   458,     0,   460,   461,   462,   463,   464,
     465,   466,   467,   468,   469,   470,     0,     0,   471,   472,
     473,   474,   475,   476,   477,   478,     0,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,   490,   491,
     492,   493,     0,   494,   495,   496,   497,   498,   499,   500,
     501,   502,   503,   504,   505,   506,     0,   507,   508,     0,
     510,   511,   512,   513,   514,   515,   516,   517,   518,   519,
     520,   521,   522,   523,   524,     0,   525,   526,   527,   528,
     529,     0,   530,   531,   532,   533,   534,     0,   536,   537,
     538,   539,     0,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,   551,   552,   553,   554,     0,   555,
     556,     0,   557,     0,   559,   560,   561,   562,   563,     0,
     564,   565,   566,     0,     0,   567,   568,   569,   570,   571,
       0,   572,   573,   574,   575,   576,   577,   578,   579,     0,
       0,   580,   581,   582,   583,   584,     0,     0,   585,   586,
     587,   588,   589,   590,   591,     0,   592,     0,   594,   595,
     596,   597,     0,     0,   598,     0,     0,   599,   600,   601,
     602,   603,   604,   605,   606,   607,   608,   609,   610,   611,
     612,   613,   614,   615,   616,   617,   618,   626,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   236,   237,   238,   239,   240,   241,
     242,   243,  1569,   244,   245,   246,     0,     0,     0,     0,
       0,     0,     0,   247,   248,   249,     0,   250,   251,   252,
     253,     0,   255,   256,   257,   258,   259,     0,   261,   262,
       0,   263,   264,   265,   266,   267,   268,   269,     0,     0,
     270,   271,   272,   273,   274,     0,   275,   276,   277,   278,
     279,     0,     0,     0,   281,   282,   283,   284,   285,   286,
       0,   288,   289,   290,     0,   291,   292,   293,   294,   295,
     296,     0,     0,   298,   299,   300,     0,     0,     0,     0,
       0,     0,     0,   302,   303,   304,   305,   306,   307,   308,
     309,   310,     0,   311,     0,   312,   313,   314,   315,   316,
     317,   318,     0,   319,   320,   321,   322,     0,     0,   323,
     324,   325,   326,   327,     0,   328,   329,   330,     0,   331,
     332,   333,     0,   334,   335,   336,   337,   338,   339,   340,
     341,   342,   343,     0,   344,     0,   345,   346,   347,   348,
     349,     0,   350,     0,   351,     0,     0,     0,   354,   355,
     356,   357,     0,   358,   359,     0,   360,   361,   362,     0,
     363,   364,   365,   366,  1570,     0,   369,   370,   371,   372,
       0,   373,   374,   375,   376,   377,   378,   379,     0,   380,
       0,   382,   383,   384,   385,   386,   387,   388,     0,   389,
       0,   390,     0,     0,   393,     0,   395,   396,   397,   398,
     399,     0,     0,   400,   401,     0,   403,     0,     0,   405,
     406,   407,     0,     0,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,     0,   428,   429,   430,   431,   432,   433,
     434,   435,   436,   437,   438,     0,   439,   440,     0,   442,
       0,   443,   444,   445,   446,   447,   448,     0,   449,   450,
       0,     0,   451,   452,   453,     0,     0,   454,   455,   456,
       0,   458,     0,   460,   461,   462,   463,   464,   465,   466,
     467,   468,   469,   470,     0,     0,   471,   472,   473,   474,
     475,   476,   477,   478,     0,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   490,   491,   492,   493,
       0,   494,   495,   496,   497,   498,   499,   500,   501,   502,
     503,   504,   505,   506,     0,   507,   508,     0,   510,   511,
     512,   513,   514,   515,   516,   517,   518,   519,   520,   521,
     522,   523,   524,     0,   525,   526,   527,   528,   529,     0,
     530,   531,   532,   533,   534,     0,   536,   537,   538,   539,
       0,   540,   541,   542,   543,   544,   545,   546,   547,   548,
     549,   550,   551,   552,   553,   554,     0,   555,   556,     0,
     557,     0,   559,   560,   561,   562,   563,     0,   564,   565,
     566,     0,     0,   567,   568,   569,   570,   571,     0,   572,
     573,   574,   575,   576,   577,   578,   579,     0,     0,   580,
     581,   582,   583,   584,     0,     0,   585,   586,   587,   588,
     589,   590,   591,     0,   592,     0,   594,   595,   596,   597,
       0,     0,   598,     0,     0,   599,   600,   601,   602,   603,
     604,   605,   606,   607,   608,   609,   610,   611,   612,   613,
     614,   615,   616,   617,   618,   626,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   236,   237,   238,   239,   240,   241,   242,   243,
       0,   244,   245,   246,     0,     0,     0,     0,     0,     0,
       0,   247,   248,   249,     0,   250,   251,   252,   253,     0,
     255,   256,   257,   258,   259,     0,   261,   262,     0,   263,
     264,   265,   266,   267,   268,   269,     0,     0,   270,   271,
     272,   273,   274,     0,   275,   276,   277,   278,   279,     0,
       0,     0,   281,   282,   283,   284,   285,   286,     0,   288,
     289,   290,     0,   291,   292,   293,   294,   295,   296,     0,
       0,   298,   299,   300,     0,     0,     0,     0,     0,     0,
       0,   302,   303,   304,   305,   306,   307,   308,   309,   310,
       0,   311,     0,   312,   313,   314,   315,   316,   317,   318,
       0,   319,   320,   321,   322,     0,     0,   323,   324,   325,
     326,   327,     0,   328,   329,   330,     0,   331,   332,   333,
       0,   334,   335,   336,   337,   338,   339,   340,   341,   342,
     343,     0,   344,     0,   345,   346,   347,   348,   349,     0,
     350,     0,   351,     0,     0,     0,   354,   355,   356,  3293,
       0,   358,   359,     0,   360,   361,   362,     0,   363,   364,
     365,   366,   367,     0,   369,   370,   371,   372,     0,   373,
     374,   375,   376,   377,   378,   379,     0,   380,     0,   382,
     383,   384,   385,   386,   387,   388,     0,   389,     0,   390,
       0,     0,   393,     0,   395,   396,   397,   398,   399,     0,
       0,   400,   401,     0,   403,     0,     0,   405,   406,  3294,
       0,     0,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,     0,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438,     0,   439,   440,     0,   442,     0,   443,
     444,   445,   446,   447,   448,     0,   449,   450,     0,     0,
     451,   452,   453,     0,     0,   454,   455,   456,     0,   458,
       0,   460,   461,   462,   463,   464,   465,   466,   467,   468,
     469,   470,     0,     0,   471,   472,   473,   474,   475,   476,
     477,   478,     0,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,   492,   493,     0,   494,
     495,   496,   497,   498,   499,   500,   501,   502,   503,   504,
     505,   506,     0,   507,   508,     0,   510,   511,   512,   513,
     514,   515,   516,   517,   518,   519,   520,   521,   522,   523,
     524,     0,   525,   526,   527,   528,   529,     0,   530,   531,
     532,   533,   534,     0,   536,   537,   538,   539,     0,   540,
     541,   542,   543,   544,   545,   546,   547,   548,   549,   550,
     551,   552,   553,   554,     0,   555,   556,  3295,   557,     0,
     559,  3296,   561,  3297,   563,     0,   564,   565,   566,     0,
       0,   567,   568,   569,   570,   571,     0,   572,   573,   574,
     575,   576,   577,   578,   579,     0,     0,   580,   581,  3298,
     583,   584,     0,     0,   585,   586,   587,   588,   589,   590,
     591,     0,   592,     0,   594,   595,   596,   597,     0,     0,
     598,     0,     0,   599,   600,   601,   602,   603,   604,   605,
     606,   607,   608,   609,   610,   611,   612,   613,   614,   615,
     616,   617,   618,   626,     0,     0,   685,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     236,   237,   238,   239,   240,   241,   242,   243,     0,   244,
     245,   246,     0,     0,     0,     0,     0,     0,     0,   247,
     248,   249,     0,   250,   251,   252,   253,     0,   255,   256,
     257,   258,   259,     0,   261,   262,     0,   263,   264,   265,
     266,   267,   268,   269,     0,     0,   270,   271,   272,   273,
     274,     0,   275,   276,   277,   278,   279,     0,     0,     0,
     281,   282,   283,   284,   285,   286,     0,   288,   289,   290,
       0,   291,   292,   293,   294,   295,   296,     0,     0,   298,
     299,   300,     0,     0,     0,     0,     0,     0,     0,   302,
     303,   304,   305,   306,   307,   308,   309,   310,     0,   311,
       0,   312,   313,   314,   315,   316,   317,   318,     0,   319,
     320,   321,   322,     0,     0,   323,   324,   325,   326,   327,
       0,   328,   329,   330,     0,   331,   332,   333,     0,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,     0,
     344,     0,   345,   346,   347,   348,   349,     0,   350,     0,
     351,     0,     0,     0,   354,   355,   356,   357,     0,   358,
     359,     0,   360,   361,   362,     0,   363,   364,   365,   366,
     367,     0,   369,   370,   371,   372,     0,   373,   374,   375,
     376,   377,   378,   379,     0,   380,     0,   382,   383,   384,
     385,   386,   387,   388,     0,   389,     0,   390,     0,     0,
     393,     0,   395,   396,   397,   398,   399,     0,     0,   400,
     401,     0,   403,     0,     0,   405,   406,   407,     0,     0,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,     0,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
     438,     0,   439,   440,     0,   442,     0,   443,   444,   445,
     446,   447,   448,     0,   449,   450,     0,     0,   451,   452,
     453,     0,     0,   454,   455,   456,     0,   458,     0,   460,
     461,   462,   463,   464,   465,   466,   467,   468,   469,   470,
       0,     0,   471,   472,   473,   474,   475,   476,   477,   478,
       0,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,   490,   491,   492,   493,     0,   494,   495,   496,
     497,   498,   499,   500,   501,   502,   503,   504,   505,   506,
       0,   507,   508,     0,   510,   511,   512,   513,   514,   515,
     516,   517,   518,   519,   520,   521,   522,   523,   524,     0,
     525,   526,   527,   528,   529,     0,   530,   531,   532,   533,
     534,     0,   536,   537,   538,   539,     0,   540,   541,   542,
     543,   544,   545,   546,   547,   548,   549,   550,   551,   552,
     553,   554,     0,   555,   556,     0,   557,     0,   559,   560,
     561,   562,   563,     0,   564,   565,   566,     0,     0,   567,
     568,   569,   570,   571,     0,   572,   573,   574,   575,   576,
     577,   578,   579,     0,     0,   580,   581,   582,   583,   584,
       0,     0,   585,   586,   587,   588,   589,   590,   591,     0,
     592,     0,   594,   595,   596,   597,     0,     0,   598,     0,
       0,   599,   600,   601,   602,   603,   604,   605,   606,   607,
     608,   609,   610,   611,   612,   613,   614,   615,   616,   617,
     618,   626,     0,     0,     0,     0,     0,     0,     0,   746,
       0,     0,     0,     0,     0,     0,     0,     0,   236,   237,
     238,   239,   240,   241,   242,   243,     0,   244,   245,   246,
       0,     0,     0,     0,     0,     0,     0,   247,   248,   249,
       0,   250,   251,   252,   253,     0,   255,   256,   257,   258,
     259,     0,   261,   262,     0,   263,   264,   265,   266,   267,
     268,   269,     0,     0,   270,   271,   272,   273,   274,     0,
     275,   276,   277,   278,   279,     0,     0,     0,   281,   282,
     283,   284,   285,   286,     0,   288,   289,   290,     0,   291,
     292,   293,   294,   295,   296,     0,     0,   298,   299,   300,
       0,     0,     0,     0,     0,     0,     0,   302,   303,   304,
     305,   306,   307,   308,   309,   310,     0,   311,     0,   312,
     313,   314,   315,   316,   317,   318,     0,   319,   320,   321,
     322,     0,     0,   323,   324,   325,   326,   327,     0,   328,
     329,   330,     0,   331,   332,   333,     0,   334,   335,   336,
     337,   338,   339,   340,   341,   342,   343,     0,   344,     0,
     345,   346,   347,   348,   349,     0,   350,     0,   351,     0,
       0,     0,   354,   355,   356,   357,     0,   358,   359,     0,
     360,   361,   362,     0,   363,   364,   365,   366,   367,     0,
     369,   370,   371,   372,     0,   373,   374,   375,   376,   377,
     378,   379,     0,   380,     0,   382,   383,   384,   385,   386,
     387,   388,     0,   389,     0,   390,     0,     0,   393,     0,
     395,   396,   397,   398,   399,     0,     0,   400,   401,     0,
     403,     0,     0,   405,   406,   407,     0,     0,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,     0,   428,   429,
     430,   431,   432,   433,   434,   435,   436,   437,   438,     0,
     439,   440,     0,   442,     0,   443,   444,   445,   446,   447,
     448,     0,   449,   450,     0,     0,   451,   452,   453,     0,
       0,   454,   455,   456,     0,   458,     0,   460,   461,   462,
     463,   464,   465,   466,   467,   468,   469,   470,     0,     0,
     471,   472,   473,   474,   475,   476,   477,   478,     0,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,   493,     0,   494,   495,   496,   497,   498,
     499,   500,   501,   502,   503,   504,   505,   506,     0,   507,
     508,     0,   510,   511,   512,   513,   514,   515,   516,   517,
     518,   519,   520,   521,   522,   523,   524,     0,   525,   526,
     527,   528,   529,     0,   530,   531,   532,   533,   534,     0,
     536,   537,   538,   539,     0,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,   552,   553,   554,
       0,   555,   556,     0,   557,     0,   559,   560,   561,   562,
     563,     0,   564,   565,   566,     0,     0,   567,   568,   569,
     570,   571,     0,   572,   573,   574,   575,   576,   577,   578,
     579,     0,     0,   580,   581,   582,   583,   584,     0,     0,
     585,   586,   587,   588,   589,   590,   591,     0,   592,     0,
     594,   595,   596,   597,     0,     0,   598,     0,     0,   599,
     600,   601,   602,   603,   604,   605,   606,   607,   608,   609,
     610,   611,   612,   613,   614,   615,   616,   617,   618,   626,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   236,   237,   238,   239,
     240,   241,   242,   243,     0,   244,   245,   246,     0,     0,
       0,     0,     0,  4070,     0,   247,   248,   249,     0,   250,
     251,   252,   253,     0,   255,   256,   257,   258,   259,     0,
     261,   262,     0,   263,   264,   265,   266,   267,   268,   269,
       0,     0,   270,   271,   272,   273,   274,     0,   275,   276,
     277,   278,   279,     0,     0,     0,   281,   282,   283,   284,
     285,   286,     0,   288,   289,   290,     0,   291,   292,   293,
     294,   295,   296,     0,     0,   298,   299,   300,     0,     0,
       0,     0,     0,     0,     0,   302,   303,   304,   305,   306,
     307,   308,   309,   310,     0,   311,     0,   312,   313,   314,
     315,   316,   317,   318,     0,   319,   320,   321,   322,     0,
       0,   323,   324,   325,   326,   327,     0,   328,   329,   330,
       0,   331,   332,   333,     0,   334,   335,   336,   337,   338,
     339,   340,   341,   342,   343,     0,   344,     0,   345,   346,
     347,   348,   349,     0,   350,     0,   351,     0,     0,     0,
     354,   355,   356,   357,     0,   358,   359,     0,   360,   361,
     362,     0,   363,   364,   365,   366,   367,     0,   369,   370,
     371,   372,     0,   373,   374,   375,   376,   377,   378,   379,
       0,   380,     0,   382,   383,   384,   385,   386,   387,   388,
       0,   389,     0,   390,     0,     0,   393,     0,   395,   396,
     397,   398,   399,     0,     0,   400,   401,     0,   403,     0,
       0,   405,   406,   407,     0,     0,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,     0,   428,   429,   430,   431,
     432,   433,   434,   435,   436,   437,   438,     0,   439,   440,
       0,   442,     0,   443,   444,   445,   446,   447,   448,     0,
     449,   450,     0,     0,   451,   452,   453,     0,     0,   454,
     455,   456,     0,   458,     0,   460,   461,   462,   463,   464,
     465,   466,   467,   468,   469,   470,     0,     0,   471,   472,
     473,   474,   475,   476,   477,   478,     0,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,   490,   491,
     492,   493,     0,   494,   495,   496,   497,   498,   499,   500,
     501,   502,   503,   504,   505,   506,     0,   507,   508,     0,
     510,   511,   512,   513,   514,   515,   516,   517,   518,   519,
     520,   521,   522,   523,   524,     0,   525,   526,   527,   528,
     529,     0,   530,   531,   532,   533,   534,     0,   536,   537,
     538,   539,     0,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,   551,   552,   553,   554,     0,   555,
     556,     0,   557,     0,   559,   560,   561,   562,   563,     0,
     564,   565,   566,     0,     0,   567,   568,   569,   570,   571,
       0,   572,   573,   574,   575,   576,   577,   578,   579,     0,
       0,   580,   581,   582,   583,   584,     0,     0,   585,   586,
     587,   588,   589,   590,   591,     0,   592,     0,   594,   595,
     596,   597,     0,     0,   598,     0,     0,   599,   600,   601,
     602,   603,   604,   605,   606,   607,   608,   609,   610,   611,
     612,   613,   614,   615,   616,   617,   618,   626,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   236,   237,   238,   239,   240,   241,
     242,   243,     0,   244,   245,   246,     0,     0,     0,     0,
       0,  4084,     0,   247,   248,   249,     0,   250,   251,   252,
     253,     0,   255,   256,   257,   258,   259,     0,   261,   262,
       0,   263,   264,   265,   266,   267,   268,   269,     0,     0,
     270,   271,   272,   273,   274,     0,   275,   276,   277,   278,
     279,     0,     0,     0,   281,   282,   283,   284,   285,   286,
       0,   288,   289,   290,     0,   291,   292,   293,   294,   295,
     296,     0,     0,   298,   299,   300,     0,     0,     0,     0,
       0,     0,     0,   302,   303,   304,   305,   306,   307,   308,
     309,   310,     0,   311,     0,   312,   313,   314,   315,   316,
     317,   318,     0,   319,   320,   321,   322,     0,     0,   323,
     324,   325,   326,   327,     0,   328,   329,   330,     0,   331,
     332,   333,     0,   334,   335,   336,   337,   338,   339,   340,
     341,   342,   343,     0,   344,     0,   345,   346,   347,   348,
     349,     0,   350,     0,   351,     0,     0,     0,   354,   355,
     356,   357,     0,   358,   359,     0,   360,   361,   362,     0,
     363,   364,   365,   366,   367,     0,   369,   370,   371,   372,
       0,   373,   374,   375,   376,   377,   378,   379,     0,   380,
       0,   382,   383,   384,   385,   386,   387,   388,     0,   389,
       0,   390,     0,     0,   393,     0,   395,   396,   397,   398,
     399,     0,     0,   400,   401,     0,   403,     0,     0,   405,
     406,   407,     0,     0,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,     0,   428,   429,   430,   431,   432,   433,
     434,   435,   436,   437,   438,     0,   439,   440,     0,   442,
       0,   443,   444,   445,   446,   447,   448,     0,   449,   450,
       0,     0,   451,   452,   453,     0,     0,   454,   455,   456,
       0,   458,     0,   460,   461,   462,   463,   464,   465,   466,
     467,   468,   469,   470,     0,     0,   471,   472,   473,   474,
     475,   476,   477,   478,     0,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   490,   491,   492,   493,
       0,   494,   495,   496,   497,   498,   499,   500,   501,   502,
     503,   504,   505,   506,     0,   507,   508,     0,   510,   511,
     512,   513,   514,   515,   516,   517,   518,   519,   520,   521,
     522,   523,   524,     0,   525,   526,   527,   528,   529,     0,
     530,   531,   532,   533,   534,     0,   536,   537,   538,   539,
       0,   540,   541,   542,   543,   544,   545,   546,   547,   548,
     549,   550,   551,   552,   553,   554,     0,   555,   556,     0,
     557,     0,   559,   560,   561,   562,   563,     0,   564,   565,
     566,     0,     0,   567,   568,   569,   570,   571,     0,   572,
     573,   574,   575,   576,   577,   578,   579,     0,     0,   580,
     581,   582,   583,   584,     0,     0,   585,   586,   587,   588,
     589,   590,   591,     0,   592,     0,   594,   595,   596,   597,
       0,     0,   598,     0,     0,   599,   600,   601,   602,   603,
     604,   605,   606,   607,   608,   609,   610,   611,   612,   613,
     614,   615,   616,   617,   618,   626,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   236,   237,   238,   239,   240,   241,   242,   243,
       0,   244,   245,   246,     0,     0,     0,     0,     0,     0,
       0,   247,   248,   249,     0,   250,   251,   252,   253,     0,
     255,   256,   257,   258,   259,     0,   261,   262,     0,   263,
     264,   265,   266,   267,   268,   269,     0,     0,   270,   271,
     272,   273,   274,     0,   275,   276,   277,   278,   279,     0,
       0,     0,   281,   282,   283,   284,   285,   286,     0,   288,
     289,   290,     0,   291,   292,   293,   294,   295,   296,     0,
       0,   298,   299,   300,     0,     0,     0,     0,     0,     0,
       0,   302,   303,   304,   305,   306,   307,   308,   309,   310,
    4717,   311,     0,   312,   313,   314,   315,   316,   317,   318,
       0,   319,   320,   321,   322,     0,     0,   323,   324,   325,
     326,   327,     0,   328,   329,   330,     0,   331,   332,   333,
       0,   334,   335,   336,   337,   338,   339,   340,   341,   342,
     343,     0,   344,     0,   345,   346,   347,   348,   349,     0,
     350,     0,   351,     0,     0,     0,   354,   355,   356,   357,
       0,   358,   359,     0,   360,   361,   362,     0,   363,   364,
     365,   366,   367,     0,   369,   370,   371,   372,     0,   373,
     374,   375,   376,   377,   378,   379,     0,   380,     0,   382,
     383,   384,   385,   386,   387,   388,     0,   389,     0,   390,
       0,     0,   393,     0,   395,   396,   397,   398,   399,     0,
       0,   400,   401,     0,   403,     0,     0,   405,   406,   407,
       0,     0,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,     0,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438,     0,   439,   440,     0,   442,     0,   443,
     444,   445,   446,   447,   448,     0,   449,   450,     0,     0,
     451,   452,   453,     0,     0,   454,   455,   456,     0,   458,
       0,   460,   461,   462,   463,   464,   465,   466,   467,   468,
     469,   470,     0,     0,   471,   472,   473,   474,   475,   476,
     477,   478,     0,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,   492,   493,     0,   494,
     495,   496,   497,   498,   499,   500,   501,   502,   503,   504,
     505,   506,     0,   507,   508,     0,   510,   511,   512,   513,
     514,   515,   516,   517,   518,   519,   520,   521,   522,   523,
     524,     0,   525,   526,   527,   528,   529,     0,   530,   531,
     532,   533,   534,     0,   536,   537,   538,   539,     0,   540,
     541,   542,   543,   544,   545,   546,   547,   548,   549,   550,
     551,   552,   553,   554,     0,   555,   556,     0,   557,     0,
     559,   560,   561,   562,   563,     0,   564,   565,   566,     0,
       0,   567,   568,   569,   570,   571,     0,   572,   573,   574,
     575,   576,   577,   578,   579,     0,     0,   580,   581,   582,
     583,   584,     0,     0,   585,   586,   587,   588,   589,   590,
     591,     0,   592,     0,   594,   595,   596,   597,     0,     0,
     598,     0,     0,   599,   600,   601,   602,   603,   604,   605,
     606,   607,   608,   609,   610,   611,   612,   613,   614,   615,
     616,   617,   618,   626,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     236,   237,   238,   239,   240,   241,   242,   243,     0,   244,
     245,   246,     0,     0,     0,     0,     0,     0,     0,   247,
     248,   249,     0,   250,   251,   252,   253,     0,   255,   256,
     257,   258,   259,     0,   261,   262,     0,   263,   264,   265,
     266,   267,   268,   269,     0,     0,   270,   271,   272,   273,
     274,     0,   275,   276,   277,   278,   279,     0,     0,     0,
     281,   282,   283,   284,   285,   286,     0,   288,   289,   290,
       0,   291,   292,   293,   294,   295,   296,     0,     0,   298,
     299,   300,     0,     0,     0,  5163,     0,     0,     0,   302,
     303,   304,   305,   306,   307,   308,   309,   310,     0,   311,
       0,   312,   313,   314,   315,   316,   317,   318,     0,   319,
     320,   321,   322,     0,     0,   323,   324,   325,   326,   327,
       0,   328,   329,   330,     0,   331,   332,   333,     0,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,     0,
     344,     0,   345,   346,   347,   348,   349,     0,   350,     0,
     351,     0,     0,     0,   354,   355,   356,   357,     0,   358,
     359,     0,   360,   361,   362,     0,   363,   364,   365,   366,
     367,     0,   369,   370,   371,   372,     0,   373,   374,   375,
     376,   377,   378,   379,     0,   380,     0,   382,   383,   384,
     385,   386,   387,   388,     0,   389,     0,   390,     0,     0,
     393,     0,   395,   396,   397,   398,   399,     0,     0,   400,
     401,     0,   403,     0,     0,   405,   406,   407,     0,     0,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,     0,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
     438,     0,   439,   440,     0,   442,     0,   443,   444,   445,
     446,   447,   448,     0,   449,   450,     0,     0,   451,   452,
     453,     0,     0,   454,   455,   456,     0,   458,     0,   460,
     461,   462,   463,   464,   465,   466,   467,   468,   469,   470,
       0,     0,   471,   472,   473,   474,   475,   476,   477,   478,
       0,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,   490,   491,   492,   493,     0,   494,   495,   496,
     497,   498,   499,   500,   501,   502,   503,   504,   505,   506,
       0,   507,   508,     0,   510,   511,   512,   513,   514,   515,
     516,   517,   518,   519,   520,   521,   522,   523,   524,     0,
     525,   526,   527,   528,   529,     0,   530,   531,   532,   533,
     534,     0,   536,   537,   538,   539,     0,   540,   541,   542,
     543,   544,   545,   546,   547,   548,   549,   550,   551,   552,
     553,   554,     0,   555,   556,     0,   557,     0,   559,   560,
     561,   562,   563,     0,   564,   565,   566,     0,     0,   567,
     568,   569,   570,   571,     0,   572,   573,   574,   575,   576,
     577,   578,   579,     0,     0,   580,   581,   582,   583,   584,
       0,     0,   585,   586,   587,   588,   589,   590,   591,     0,
     592,     0,   594,   595,   596,   597,     0,     0,   598,     0,
       0,   599,   600,   601,   602,   603,   604,   605,   606,   607,
     608,   609,   610,   611,   612,   613,   614,   615,   616,   617,
     618,   626,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   236,   237,
     238,   239,   240,   241,   242,   243,     0,   244,   245,   246,
       0,     0,     0,     0,     0,     0,     0,   247,   248,   249,
       0,   250,   251,   252,   253,     0,   255,   256,   257,   258,
     259,     0,   261,   262,     0,   263,   264,   265,   266,   267,
     268,   269,     0,     0,   270,   271,   272,   273,   274,     0,
     275,   276,   277,   278,   279,     0,     0,     0,   281,   282,
     283,   284,   285,   286,     0,   288,   289,   290,     0,   291,
     292,   293,   294,   295,   296,     0,     0,   298,   299,   300,
       0,     0,     0,     0,     0,     0,     0,   302,   303,   304,
     305,   306,   307,   308,   309,   310,     0,   311,     0,   312,
     313,   314,   315,   316,   317,   318,     0,   319,   320,   321,
     322,     0,     0,   323,   324,   325,   326,   327,     0,   328,
     329,   330,     0,   331,   332,   333,     0,   334,   335,   336,
     337,   338,   339,   340,   341,   342,   343,     0,   344,     0,
     345,   346,   347,   348,   349,     0,   350,     0,   351,     0,
       0,     0,   354,   355,   356,   357,     0,   358,   359,     0,
     360,   361,   362,     0,   363,   364,   365,   366,   367,     0,
     369,   370,   371,   372,     0,   373,   374,   375,   376,   377,
     378,   379,     0,   380,     0,   382,   383,   384,   385,   386,
     387,   388,     0,   389,     0,   390,     0,     0,   393,     0,
     395,   396,   397,   398,   399,     0,     0,   400,   401,     0,
     403,     0,     0,   405,   406,   407,     0,     0,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,     0,   428,   429,
     430,   431,   432,   433,   434,   435,   436,   437,   438,     0,
     439,   440,     0,   442,     0,   443,   444,   445,   446,   447,
     448,     0,   449,   450,     0,     0,   451,   452,   453,     0,
       0,   454,   455,   456,     0,   458,     0,   460,   461,   462,
     463,   464,   465,   466,   467,   468,   469,   470,     0,     0,
     471,   472,   473,   474,   475,   476,   477,   478,     0,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,   493,     0,   494,   495,   496,   497,   498,
     499,   500,   501,   502,   503,   504,   505,   506,     0,   507,
     508,     0,   510,   511,   512,   513,   514,   515,   516,   517,
     518,   519,   520,   521,   522,   523,   524,     0,   525,   526,
     527,   528,   529,     0,   530,   531,   532,   533,   534,     0,
     536,   537,   538,   539,     0,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,   552,   553,   554,
       0,   555,   556,     0,   557,     0,   559,   560,   561,   562,
     563,     0,   564,   565,   566,     0,     0,   567,   568,   569,
     570,   571,     0,   572,   573,   574,   575,   576,   577,   578,
     579,     0,     0,   580,   581,   582,   583,   584,     0,     0,
     585,   586,   587,   588,   589,   590,   591,     0,   592,     0,
     594,   595,   596,   597,     0,     0,   598,     0,     0,   599,
     600,   601,   602,   603,   604,   605,   606,   607,   608,   609,
     610,   611,   612,   613,   614,   615,   616,   617,   618,   626,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   236,   237,   238,   239,
     240,   241,   242,   243,     0,   244,   245,   246,     0,     0,
       0,     0,     0,     0,     0,   247,   248,   249,     0,   250,
     251,   252,   253,     0,   255,   256,   257,   258,   259,     0,
     261,   262,     0,   263,   264,   265,   266,   267,   268,   269,
       0,     0,   270,   271,   272,   273,   274,     0,   275,   276,
     277,   278,   279,     0,     0,     0,   281,   282,   283,   284,
     285,   286,     0,   288,   289,   290,     0,   291,   292,   293,
     294,   295,   296,     0,     0,   298,   299,   300,     0,     0,
       0,     0,     0,     0,     0,   302,   303,   304,   305,   306,
     307,   308,   309,   310,     0,   311,     0,   312,   313,   314,
     315,   316,   317,   318,     0,   319,   320,   321,   322,     0,
       0,   323,   324,   325,   326,   327,     0,   328,   329,   330,
       0,   331,   332,   333,     0,   334,   335,   336,   337,   338,
     339,   340,   341,   342,   343,     0,   344,     0,   345,   346,
     347,   348,   349,     0,   350,     0,   351,     0,     0,     0,
     354,   355,   356,   357,     0,   358,   359,     0,   360,   361,
     362,     0,   363,   364,   365,   366,   367,     0,   369,   370,
     371,   372,     0,   373,   374,   375,   376,   377,   378,   379,
       0,   380,     0,   382,   383,   384,   385,   386,   387,   388,
       0,   389,     0,   390,     0,     0,   393,     0,   395,   396,
     397,   398,   399,     0,     0,   400,   401,     0,   403,     0,
       0,   405,   406,   407,     0,     0,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,     0,   428,   429,   430,   431,
     432,   433,   434,   435,   436,   437,   438,     0,   439,   440,
       0,   442,     0,   443,   444,   445,   446,   447,   448,     0,
     449,   450,     0,     0,   451,   452,   453,     0,     0,   454,
     455,   456,     0,   458,     0,   460,   461,   462,   463,   464,
     465,   466,   467,   468,   469,   470,     0,     0,   471,   472,
     473,   474,   475,   476,   477,   478,     0,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,   490,   491,
     492,   493,     0,   494,   495,   496,   497,   498,   499,   500,
     501,   502,   503,   504,   505,   506,     0,   507,   508,     0,
     510,   511,   512,   513,   514,   515,   516,   517,   518,   519,
     520,   521,   522,   523,   524,     0,   525,   526,   527,   528,
     529,     0,   530,   531,   532,   533,   534,     0,   536,   537,
     538,   539,     0,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,   551,   552,   553,   554,     0,   555,
     556,     0,   557,     0,   559,   560,   561,   562,   563,     0,
     564,   565,   566,     0,     0,   785,   568,   569,   570,   571,
       0,   572,   573,   574,   575,   576,   577,   578,   579,     0,
       0,   580,   581,   582,   583,   584,     0,     0,   585,   586,
     587,   588,   589,   590,   591,     0,   592,     0,   594,   595,
     596,   597,     0,     0,   598,     0,     0,   599,   600,   601,
     602,   603,   604,   605,   606,   607,   608,   609,   610,   611,
     612,   613,   614,   615,   616,   617,   618,   626,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   236,   237,   238,   239,   240,   241,
     242,   243,     0,   244,   245,   246,     0,     0,     0,     0,
       0,     0,     0,   247,   248,   249,     0,   250,   251,   252,
     253,     0,   255,   256,   257,   258,   259,     0,   261,   262,
       0,   263,   264,   265,   266,   267,   268,   269,     0,     0,
     270,   271,   272,   273,   274,     0,   275,   276,   277,   278,
     279,     0,     0,     0,   281,   282,   283,   284,   285,   286,
       0,   288,   289,   290,     0,   291,   292,   293,   294,   295,
     296,     0,     0,   298,   299,   300,     0,     0,     0,     0,
       0,     0,     0,   302,   303,   304,   305,   306,   307,   308,
     309,   310,     0,   311,     0,   312,   313,   314,   315,   316,
     317,   318,     0,   319,   320,   321,   322,     0,     0,   323,
     324,   325,   326,   327,     0,   328,   329,   330,     0,   331,
     332,   333,     0,   334,   335,   336,   337,   338,   339,   340,
     341,   342,   343,     0,   344,     0,   345,   346,   347,   348,
     349,     0,   350,     0,   351,     0,     0,     0,   354,   355,
     356,   357,     0,   358,   359,     0,   360,   361,   362,     0,
     363,   364,   365,   366,   367,     0,   369,   370,   371,   372,
       0,   373,   374,   375,   376,   377,   378,   379,     0,   380,
       0,   382,   383,   384,   385,   386,   387,   388,     0,   389,
       0,   390,     0,     0,   393,     0,   395,   396,   397,   398,
     399,     0,     0,   400,   401,     0,   403,     0,     0,   405,
     406,   407,     0,     0,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,     0,   428,   429,   430,   431,   432,   433,
     434,   435,   436,   437,   438,     0,   439,   440,     0,   442,
       0,   443,   444,   445,   446,   447,   448,     0,   449,   450,
       0,     0,   451,   452,   453,     0,     0,   454,   455,   456,
       0,   458,     0,   460,   461,   462,   463,   464,   465,   466,
     467,   468,   469,   470,     0,     0,   471,   472,   473,   474,
     475,   476,   477,   478,     0,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   490,   491,   492,   493,
       0,   494,   495,   496,   497,   498,   499,   500,   501,   502,
     503,   504,   505,   506,     0,   507,   508,     0,   510,   511,
     512,   513,   514,   515,   516,   517,   797,   519,   520,   521,
     522,   523,   524,     0,   525,   526,   527,   528,   529,     0,
     530,   531,   532,   533,   534,     0,   536,   537,   538,   539,
       0,   540,   541,   542,   543,   544,   545,   546,   547,   548,
     549,   550,   551,   552,   553,   554,     0,   555,   556,     0,
     557,     0,   559,   560,   561,   562,   563,     0,   564,   565,
     566,     0,     0,   567,   568,   569,   570,   571,     0,   572,
     573,   574,   575,   576,   577,   578,   579,     0,     0,   580,
     581,   582,   583,   584,     0,     0,   585,   586,   587,   588,
     589,   590,   591,     0,   592,     0,   594,   595,   596,   597,
       0,     0,   598,     0,     0,   599,   600,   601,   602,   603,
     604,   605,   606,   607,   608,   609,   610,   611,   612,   613,
     614,   615,   616,   617,   618,   626,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   236,   237,   238,   239,   240,   241,   242,   243,
       0,   244,   245,   246,     0,     0,     0,     0,     0,     0,
       0,   247,   248,   249,     0,   250,   251,   252,   253,     0,
     255,   256,   257,   258,   259,     0,   261,   262,     0,   263,
     264,   265,   266,   267,   268,   269,     0,     0,   819,   271,
     272,   273,   274,     0,   275,   276,   277,   278,   279,     0,
       0,     0,   281,   282,   283,   284,   285,   286,     0,   288,
     289,   290,     0,   820,   292,   293,   294,   295,   296,     0,
       0,   298,   299,   300,     0,     0,     0,     0,     0,     0,
       0,   302,   303,   304,   305,   306,   307,   308,   309,   310,
       0,   311,     0,   312,   313,   314,   315,   316,   317,   318,
       0,   319,   320,   321,   322,     0,     0,   323,   324,   325,
     326,   327,     0,   328,   329,   330,     0,   331,   332,   333,
       0,   334,   335,   336,   337,   338,   339,   340,   341,   342,
     343,     0,   344,     0,   345,   346,   347,   348,   349,     0,
     350,     0,   351,     0,     0,     0,   354,   355,   356,   357,
       0,   358,   359,     0,   360,   361,   362,     0,   363,   364,
     365,   366,   367,     0,   369,   370,   371,   372,     0,   373,
     374,   375,   376,   377,   378,   379,     0,   380,     0,   382,
     383,   384,   385,   386,   387,   388,     0,   389,     0,   390,
       0,     0,   393,     0,   395,   396,   397,   398,   399,     0,
       0,   400,   401,     0,   403,     0,     0,   405,   406,   821,
       0,     0,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   822,
     426,     0,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438,     0,   439,   440,     0,   442,     0,   443,
     444,   445,   446,   447,   448,     0,   449,   450,     0,     0,
     451,   452,   453,     0,     0,   454,   455,   456,     0,   458,
       0,   460,   461,   462,   463,   464,   465,   466,   467,   468,
     469,   470,     0,     0,   471,   472,   473,   474,   475,   476,
     477,   478,     0,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,   492,   493,     0,   494,
     495,   496,   497,   498,   499,   500,   501,   502,   503,   504,
     505,   506,     0,   507,   508,     0,   823,   511,   512,   513,
     514,   515,   516,   517,   518,   824,   520,   521,   522,   523,
     524,     0,   525,   526,   527,   528,   825,     0,   530,   531,
     532,   533,   534,     0,   536,   537,   538,   539,     0,   540,
     541,   542,   543,   544,   545,   546,   547,   548,   549,   550,
     551,   552,   553,   554,     0,   555,   556,     0,   557,     0,
     559,   560,   561,   562,   563,     0,   564,   826,   566,     0,
       0,   827,   568,   569,   570,   571,     0,   572,   573,   574,
     575,   576,   577,   578,   579,     0,     0,   580,   581,   582,
     583,   584,     0,     0,   585,   586,   587,   588,   589,   590,
     591,     0,   592,     0,   594,   595,   596,   597,     0,     0,
     598,     0,     0,   599,   600,   601,   602,   603,   828,   605,
     606,   607,   608,   609,   610,   611,   612,   613,   614,   615,
     616,   617,   618,   626,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     236,   237,   238,   239,   240,   241,   242,   243,     0,   244,
     245,   246,     0,     0,     0,     0,     0,     0,     0,   247,
     248,   249,     0,   250,   251,   252,   253,     0,   255,   256,
     257,   258,   259,     0,   261,   262,     0,   263,   264,   265,
     266,   267,   268,   269,     0,     0,   270,   271,   272,   273,
     274,     0,   275,   276,   277,   278,   279,     0,     0,     0,
     281,   282,   283,   284,   285,   286,     0,   288,   289,   290,
       0,   291,   292,   293,   294,   295,   296,     0,     0,   298,
     299,   300,     0,     0,     0,     0,     0,     0,     0,   302,
     303,   304,   305,   306,   307,   308,   309,   310,     0,   311,
       0,   312,   313,   314,   315,   316,   317,   318,     0,   319,
     320,   321,   322,     0,     0,   323,   324,   325,   326,   327,
       0,   328,   329,   330,     0,   331,   332,   333,     0,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,     0,
     344,     0,   345,   346,   347,   348,   349,     0,   350,     0,
     351,     0,     0,     0,   354,   355,   356,   357,     0,   358,
     359,     0,   360,   361,   362,     0,   363,   364,   365,   366,
     367,     0,   369,   370,   371,   372,     0,   373,   374,   375,
     376,   377,   378,   379,     0,   380,     0,   382,   383,   384,
     385,   386,   387,   388,     0,   389,     0,   390,     0,     0,
     393,     0,   395,   396,   397,   398,   399,     0,     0,   400,
     401,     0,   403,     0,     0,   405,   406,   407,     0,     0,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,     0,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
     438,     0,   439,   440,     0,   442,     0,   443,   444,   445,
     446,   447,   448,     0,   449,   450,     0,     0,   451,   452,
     453,     0,     0,   454,   455,   456,     0,   458,     0,   460,
     461,   462,   463,   464,   465,   466,   467,   468,   469,   470,
       0,     0,   471,   472,   473,   474,   475,   476,   477,   478,
       0,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,   490,   491,   851,   493,     0,   494,   495,   496,
     497,   498,   499,   500,   501,   502,   503,   504,   505,   506,
       0,   507,   508,     0,   510,   511,   512,   513,   514,   515,
     516,   517,   518,   519,   520,   521,   522,   523,   524,     0,
     525,   526,   527,   528,   529,     0,   530,   531,   532,   533,
     534,     0,   536,   537,   538,   539,     0,   540,   541,   542,
     543,   544,   545,   546,   547,   548,   549,   550,   551,   552,
     553,   554,     0,   555,   556,     0,   557,     0,   559,   560,
     561,   562,   563,     0,   564,   565,   566,     0,     0,   567,
     568,   569,   570,   571,     0,   572,   573,   574,   575,   576,
     577,   578,   579,     0,     0,   580,   581,   582,   583,   584,
       0,     0,   585,   586,   587,   588,   589,   590,   591,     0,
     592,     0,   594,   595,   596,   597,     0,     0,   598,     0,
       0,   599,   600,   601,   602,   603,   604,   605,   606,   607,
     608,   609,   610,   611,   612,   613,   614,   615,   616,   617,
     618,   626,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   236,   237,
     238,   239,   240,   241,   242,   243,     0,   244,   245,   246,
       0,     0,     0,     0,     0,     0,     0,   247,   248,   249,
       0,   250,   251,   252,   253,     0,   255,   256,   257,   258,
     259,     0,   261,   262,     0,   263,   264,   265,   266,   267,
     268,   269,     0,     0,   270,   271,   272,   273,   274,     0,
     275,   276,   277,   278,   279,     0,     0,     0,   281,   282,
     283,   284,   285,   286,     0,   288,   289,   290,     0,   291,
     292,   293,   294,   295,   296,     0,     0,   298,   299,   300,
       0,     0,     0,     0,     0,     0,     0,   302,   303,   304,
     305,   306,   307,   308,   309,   310,     0,   311,     0,   312,
     313,   314,   315,   316,   317,   318,     0,   319,   320,   321,
     322,     0,     0,   323,   324,   325,   326,   327,     0,   328,
     329,   330,     0,   331,   332,   333,     0,   334,   335,   336,
     337,   338,   339,   340,   341,   342,   343,     0,   344,     0,
     345,   346,   347,   348,   349,     0,   350,     0,   351,     0,
       0,     0,   354,   355,   356,   357,     0,   358,   359,     0,
     360,   361,   362,     0,   363,   364,   365,   366,   977,     0,
     369,   370,   371,   372,     0,   373,   374,   375,   376,   377,
     378,   379,     0,   380,     0,   382,   383,   384,   385,   386,
     387,   388,     0,   389,     0,   390,     0,     0,   393,     0,
     395,   396,   397,   398,   399,     0,     0,   400,   401,     0,
     403,     0,     0,   405,   406,   407,     0,     0,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,     0,   428,   429,
     430,   431,   432,   433,   434,   435,   436,   437,   438,     0,
     439,   440,     0,   442,     0,   443,   444,   445,   446,   447,
     448,     0,   449,   450,     0,     0,   451,   452,   453,     0,
       0,   454,   455,   456,     0,   458,     0,   460,   461,   462,
     463,   464,   465,   466,   467,   468,   469,   470,     0,     0,
     471,   472,   473,   474,   475,   476,   477,   478,     0,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,   493,     0,   494,   495,   496,   497,   498,
     499,   500,   501,   502,   503,   504,   505,   506,     0,   507,
     508,     0,   510,   511,   512,   513,   514,   515,   516,   517,
     518,   519,   520,   521,   522,   523,   524,     0,   525,   526,
     527,   528,   529,     0,   530,   531,   532,   533,   534,     0,
     536,   537,   538,   539,     0,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,   552,   553,   554,
       0,   555,   556,     0,   557,     0,   559,   560,   561,   562,
     563,     0,   564,   565,   566,     0,     0,   567,   568,   569,
     570,   571,     0,   572,   573,   574,   575,   576,   577,   578,
     579,     0,     0,   580,   581,   582,   583,   584,     0,     0,
     585,   586,   587,   588,   589,   590,   591,     0,   592,     0,
     594,   595,   596,   597,     0,     0,   598,     0,     0,   599,
     600,   601,   602,   603,   604,   605,   606,   607,   608,   609,
     610,   611,   612,   613,   614,   615,   616,   617,   618,   626,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   236,   237,   238,   239,
     240,   241,   242,   243,     0,   244,   245,   246,     0,     0,
       0,     0,     0,     0,     0,   247,   248,   249,     0,   250,
     251,   252,   253,     0,   255,   256,   257,   258,   259,     0,
     261,   262,     0,   263,   264,   265,   266,   267,   268,   269,
       0,     0,   270,   271,   272,   273,   274,     0,   275,   276,
     277,   278,   279,     0,     0,     0,   281,   282,   283,   284,
     285,   286,     0,   288,   289,   290,     0,   291,   292,   293,
     294,   295,   296,     0,     0,   298,   299,   300,     0,     0,
       0,     0,     0,     0,     0,   302,   303,   304,   305,   306,
     307,   308,   309,   310,     0,   311,     0,   312,   313,   314,
     315,   316,   317,   318,     0,   319,   320,   321,   322,     0,
       0,   323,   324,   325,   326,   327,     0,   328,   329,   330,
       0,   331,   332,   333,     0,   334,   335,   336,   337,   338,
     339,   340,   341,   342,   343,     0,   344,     0,   345,   346,
     347,   348,   349,     0,   350,     0,   351,     0,     0,     0,
     354,   355,   356,   357,     0,   358,   359,     0,   360,   361,
     362,     0,   363,   364,   365,   366,   987,     0,   369,   370,
     371,   372,     0,   373,   374,   375,   376,   377,   378,   379,
       0,   380,     0,   382,   383,   384,   385,   386,   387,   388,
       0,   389,     0,   390,     0,     0,   393,     0,   395,   396,
     397,   398,   399,     0,     0,   400,   401,     0,   403,     0,
       0,   405,   406,   407,     0,     0,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,     0,   428,   429,   430,   431,
     432,   433,   434,   435,   436,   437,   438,     0,   439,   440,
       0,   442,     0,   443,   444,   445,   446,   447,   448,     0,
     449,   450,     0,     0,   451,   452,   453,     0,     0,   454,
     455,   456,     0,   458,     0,   460,   461,   462,   463,   464,
     465,   466,   467,   468,   469,   470,     0,     0,   471,   472,
     473,   474,   475,   476,   477,   478,     0,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,   490,   491,
     492,   493,     0,   494,   495,   496,   497,   498,   499,   500,
     501,   502,   503,   504,   505,   506,     0,   507,   508,     0,
     510,   511,   512,   513,   514,   515,   516,   517,   518,   519,
     520,   521,   522,   523,   524,     0,   525,   526,   527,   528,
     529,     0,   530,   531,   532,   533,   534,     0,   536,   537,
     538,   539,     0,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,   551,   552,   553,   554,     0,   555,
     556,     0,   557,     0,   559,   560,   561,   562,   563,     0,
     564,   565,   566,     0,     0,   567,   568,   569,   570,   571,
       0,   572,   573,   574,   575,   576,   577,   578,   579,     0,
       0,   580,   581,   582,   583,   584,     0,     0,   585,   586,
     587,   588,   589,   590,   591,     0,   592,     0,   594,   595,
     596,   597,     0,     0,   598,     0,     0,   599,   600,   601,
     602,   603,   604,   605,   606,   607,   608,   609,   610,   611,
     612,   613,   614,   615,   616,   617,   618,   626,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   236,   237,   238,   239,   240,   241,
     242,   243,     0,   244,   245,   246,     0,     0,     0,     0,
       0,     0,     0,   247,   248,   249,     0,   250,   251,   252,
     253,     0,   255,   256,   257,   258,   259,     0,   261,   262,
       0,   263,   264,   265,   266,   267,   268,   269,     0,     0,
     270,   271,   272,   273,   274,     0,   275,   276,   277,   278,
     279,     0,     0,     0,   281,   282,   283,   284,   285,   286,
       0,   288,   289,   290,     0,   291,   292,   293,   294,   295,
     296,     0,     0,   298,   299,   300,     0,     0,     0,     0,
       0,     0,     0,   302,   303,   304,   305,   306,   307,   308,
     309,   310,     0,   311,     0,   312,   313,   314,   315,   316,
     317,   318,     0,   319,   320,   321,   322,     0,     0,   323,
     324,   325,   326,   327,     0,   328,   329,   330,     0,   331,
     332,   333,     0,   334,   335,   336,   337,   338,   339,   340,
     341,   342,   343,     0,   344,     0,   345,   346,   347,   348,
     349,     0,   350,     0,   351,     0,     0,     0,   354,   355,
     356,   357,     0,   358,   359,     0,   360,   361,   362,     0,
     363,   364,   365,   366,   990,     0,   369,   370,   371,   372,
       0,   373,   374,   375,   376,   377,   378,   379,     0,   380,
       0,   382,   383,   384,   385,   386,   387,   388,     0,   389,
       0,   390,     0,     0,   393,     0,   395,   396,   397,   398,
     399,     0,     0,   400,   401,     0,   403,     0,     0,   405,
     406,   407,     0,     0,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,     0,   428,   429,   430,   431,   432,   433,
     434,   435,   436,   437,   438,     0,   439,   440,     0,   442,
       0,   443,   444,   445,   446,   447,   448,     0,   449,   450,
       0,     0,   451,   452,   453,     0,     0,   454,   455,   456,
       0,   458,     0,   460,   461,   462,   463,   464,   465,   466,
     467,   468,   469,   470,     0,     0,   471,   472,   473,   474,
     475,   476,   477,   478,     0,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   490,   491,   492,   493,
       0,   494,   495,   496,   497,   498,   499,   500,   501,   502,
     503,   504,   505,   506,     0,   507,   508,     0,   510,   511,
     512,   513,   514,   515,   516,   517,   518,   519,   520,   521,
     522,   523,   524,     0,   525,   526,   527,   528,   529,     0,
     530,   531,   532,   533,   534,     0,   536,   537,   538,   539,
       0,   540,   541,   542,   543,   544,   545,   546,   547,   548,
     549,   550,   551,   552,   553,   554,     0,   555,   556,     0,
     557,     0,   559,   560,   561,   562,   563,     0,   564,   565,
     566,     0,     0,   567,   568,   569,   570,   571,     0,   572,
     573,   574,   575,   576,   577,   578,   579,     0,     0,   580,
     581,   582,   583,   584,     0,     0,   585,   586,   587,   588,
     589,   590,   591,     0,   592,     0,   594,   595,   596,   597,
       0,     0,   598,     0,     0,   599,   600,   601,   602,   603,
     604,   605,   606,   607,   608,   609,   610,   611,   612,   613,
     614,   615,   616,   617,   618,   626,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   236,   237,   238,   239,   240,   241,   242,   243,
       0,   244,   245,   246,     0,     0,     0,     0,     0,     0,
       0,   247,   248,   249,     0,   250,   251,   252,   253,     0,
     255,   256,   257,   258,   259,     0,   261,   262,     0,   263,
     264,   265,   266,   267,   268,   269,     0,     0,   270,   271,
     272,   273,   274,     0,   275,   276,   277,   278,   279,     0,
       0,     0,   281,   282,   283,   284,   285,   286,     0,   288,
     289,   290,     0,   291,   292,   293,   294,   295,   296,     0,
       0,   298,   299,   300,     0,     0,     0,     0,     0,     0,
       0,   302,   303,   304,   305,   306,   307,   308,   309,   310,
       0,   311,     0,   312,   313,   314,   315,   316,   317,   318,
       0,   319,   320,   321,   322,     0,     0,   323,   324,   325,
     326,   327,     0,   328,   329,   330,     0,   331,   332,   333,
       0,   334,   335,   336,   337,   338,   339,   340,   341,   342,
     343,     0,   344,     0,   345,   346,   347,   348,   349,     0,
     350,     0,   351,     0,     0,     0,   354,   355,   356,   357,
       0,   358,   359,     0,   360,   361,   362,     0,   363,   364,
     365,   366,  1006,     0,   369,   370,   371,   372,     0,   373,
     374,   375,   376,   377,   378,   379,     0,   380,     0,   382,
     383,   384,   385,   386,   387,   388,     0,   389,     0,   390,
       0,     0,   393,     0,   395,   396,   397,   398,   399,     0,
       0,   400,   401,     0,   403,     0,     0,   405,   406,   407,
       0,     0,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,     0,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438,     0,   439,   440,     0,   442,     0,   443,
     444,   445,   446,   447,   448,     0,   449,   450,     0,     0,
     451,   452,   453,     0,     0,   454,   455,   456,     0,   458,
       0,   460,   461,   462,   463,   464,   465,   466,   467,   468,
     469,   470,     0,     0,   471,   472,   473,   474,   475,   476,
     477,   478,     0,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,   492,   493,     0,   494,
     495,   496,   497,   498,   499,   500,   501,   502,   503,   504,
     505,   506,     0,   507,   508,     0,   510,   511,   512,   513,
     514,   515,   516,   517,   518,   519,   520,   521,   522,   523,
     524,     0,   525,   526,   527,   528,   529,     0,   530,   531,
     532,   533,   534,     0,   536,   537,   538,   539,     0,   540,
     541,   542,   543,   544,   545,   546,   547,   548,   549,   550,
     551,   552,   553,   554,     0,   555,   556,     0,   557,     0,
     559,   560,   561,   562,   563,     0,   564,   565,   566,     0,
       0,   567,   568,   569,   570,   571,     0,   572,   573,   574,
     575,   576,   577,   578,   579,     0,     0,   580,   581,   582,
     583,   584,     0,     0,   585,   586,   587,   588,   589,   590,
     591,     0,   592,     0,   594,   595,   596,   597,     0,     0,
     598,     0,     0,   599,   600,   601,   602,   603,   604,   605,
     606,   607,   608,   609,   610,   611,   612,   613,   614,   615,
     616,   617,   618,   626,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     236,   237,   238,   239,   240,   241,   242,   243,     0,   244,
     245,   246,     0,     0,     0,     0,     0,     0,     0,   247,
     248,   249,     0,   250,   251,   252,   253,     0,   255,   256,
     257,   258,   259,     0,   261,   262,     0,   263,   264,   265,
     266,   267,   268,   269,     0,     0,   270,   271,   272,   273,
     274,     0,   275,   276,   277,   278,   279,     0,     0,     0,
     281,   282,   283,   284,   285,   286,     0,   288,   289,   290,
       0,   291,   292,   293,   294,   295,   296,     0,     0,   298,
     299,   300,     0,     0,     0,     0,     0,     0,     0,   302,
     303,   304,   305,   306,   307,   308,   309,   310,     0,   311,
       0,   312,   313,   314,   315,   316,   317,   318,     0,   319,
     320,   321,   322,     0,     0,   323,   324,   325,   326,   327,
       0,   328,   329,   330,     0,   331,   332,   333,     0,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,     0,
     344,     0,   345,   346,   347,   348,   349,     0,   350,     0,
     351,     0,     0,     0,   354,   355,   356,   357,     0,   358,
     359,     0,   360,   361,   362,     0,   363,   364,   365,   366,
    1062,     0,   369,   370,   371,   372,     0,   373,   374,   375,
     376,   377,   378,   379,     0,   380,     0,   382,   383,   384,
     385,   386,   387,   388,     0,   389,     0,   390,     0,     0,
     393,     0,   395,   396,   397,   398,   399,     0,     0,   400,
     401,     0,   403,     0,     0,   405,   406,   407,     0,     0,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,     0,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
     438,     0,   439,   440,     0,   442,     0,   443,   444,   445,
     446,   447,   448,     0,   449,   450,     0,     0,   451,   452,
     453,     0,     0,   454,   455,   456,     0,   458,     0,   460,
     461,   462,   463,   464,   465,   466,   467,   468,   469,   470,
       0,     0,   471,   472,   473,   474,   475,   476,   477,   478,
       0,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,   490,   491,   492,   493,     0,   494,   495,   496,
     497,   498,   499,   500,   501,   502,   503,   504,   505,   506,
       0,   507,   508,     0,   510,   511,   512,   513,   514,   515,
     516,   517,   518,   519,   520,   521,   522,   523,   524,     0,
     525,   526,   527,   528,   529,     0,   530,   531,   532,   533,
     534,     0,   536,   537,   538,   539,     0,   540,   541,   542,
     543,   544,   545,   546,   547,   548,   549,   550,   551,   552,
     553,   554,     0,   555,   556,     0,   557,     0,   559,   560,
     561,   562,   563,     0,   564,   565,   566,     0,     0,   567,
     568,   569,   570,   571,     0,   572,   573,   574,   575,   576,
     577,   578,   579,     0,     0,   580,   581,   582,   583,   584,
       0,     0,   585,   586,   587,   588,   589,   590,   591,     0,
     592,     0,   594,   595,   596,   597,     0,     0,   598,     0,
       0,   599,   600,   601,   602,   603,   604,   605,   606,   607,
     608,   609,   610,   611,   612,   613,   614,   615,   616,   617,
     618,   626,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   236,   237,
     238,   239,   240,   241,   242,   243,     0,   244,   245,   246,
       0,     0,     0,     0,     0,     0,     0,   247,   248,   249,
       0,   250,   251,   252,   253,     0,   255,   256,   257,   258,
     259,     0,   261,   262,     0,   263,   264,   265,   266,   267,
     268,   269,     0,     0,   270,   271,   272,   273,   274,     0,
     275,   276,   277,   278,   279,     0,     0,     0,   281,   282,
     283,   284,   285,   286,     0,   288,   289,   290,     0,   291,
     292,   293,   294,   295,   296,     0,     0,   298,   299,   300,
       0,     0,     0,     0,     0,     0,     0,   302,   303,   304,
     305,   306,   307,   308,   309,   310,     0,   311,     0,   312,
     313,   314,   315,   316,   317,   318,     0,   319,   320,   321,
     322,     0,     0,   323,   324,   325,   326,   327,     0,   328,
     329,   330,     0,   331,   332,   333,     0,   334,   335,   336,
     337,   338,   339,   340,   341,   342,   343,     0,   344,     0,
     345,   346,   347,   348,   349,     0,   350,     0,   351,     0,
       0,     0,   354,   355,   356,   357,     0,   358,   359,     0,
     360,   361,   362,     0,   363,   364,   365,   366,  1067,     0,
     369,   370,   371,   372,     0,   373,   374,   375,   376,   377,
     378,   379,     0,   380,     0,   382,   383,   384,   385,   386,
     387,   388,     0,   389,     0,   390,     0,     0,   393,     0,
     395,   396,   397,   398,   399,     0,     0,   400,   401,     0,
     403,     0,     0,   405,   406,   407,     0,     0,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,     0,   428,   429,
     430,   431,   432,   433,   434,   435,   436,   437,   438,     0,
     439,   440,     0,   442,     0,   443,   444,   445,   446,   447,
     448,     0,   449,   450,     0,     0,   451,   452,   453,     0,
       0,   454,   455,   456,     0,   458,     0,   460,   461,   462,
     463,   464,   465,   466,   467,   468,   469,   470,     0,     0,
     471,   472,   473,   474,   475,   476,   477,   478,     0,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,   493,     0,   494,   495,   496,   497,   498,
     499,   500,   501,   502,   503,   504,   505,   506,     0,   507,
     508,     0,   510,   511,   512,   513,   514,   515,   516,   517,
     518,   519,   520,   521,   522,   523,   524,     0,   525,   526,
     527,   528,   529,     0,   530,   531,   532,   533,   534,     0,
     536,   537,   538,   539,     0,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,   552,   553,   554,
       0,   555,   556,     0,   557,     0,   559,   560,   561,   562,
     563,     0,   564,   565,   566,     0,     0,   567,   568,   569,
     570,   571,     0,   572,   573,   574,   575,   576,   577,   578,
     579,     0,     0,   580,   581,   582,   583,   584,     0,     0,
     585,   586,   587,   588,   589,   590,   591,     0,   592,     0,
     594,   595,   596,   597,     0,     0,   598,     0,     0,   599,
     600,   601,   602,   603,   604,   605,   606,   607,   608,   609,
     610,   611,   612,   613,   614,   615,   616,   617,   618,   626,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   236,   237,   238,   239,
     240,   241,   242,   243,     0,   244,   245,   246,     0,     0,
       0,     0,     0,     0,     0,   247,   248,   249,     0,   250,
     251,   252,   253,     0,   255,   256,   257,   258,   259,     0,
     261,   262,     0,   263,   264,   265,   266,   267,   268,   269,
       0,     0,   270,   271,   272,   273,   274,     0,   275,   276,
     277,   278,   279,     0,     0,     0,   281,   282,   283,   284,
     285,   286,     0,   288,   289,   290,     0,   291,   292,   293,
     294,   295,   296,     0,     0,   298,   299,   300,     0,     0,
       0,     0,     0,     0,     0,   302,   303,   304,   305,   306,
     307,   308,   309,   310,     0,   311,     0,   312,   313,   314,
     315,   316,   317,   318,     0,   319,   320,   321,   322,     0,
       0,   323,   324,   325,   326,   327,     0,   328,   329,   330,
       0,   331,   332,   333,     0,   334,   335,   336,   337,   338,
     339,   340,   341,   342,   343,     0,   344,     0,   345,   346,
     347,   348,   349,     0,   350,     0,   351,     0,     0,     0,
     354,   355,   356,   357,     0,   358,   359,     0,   360,   361,
     362,     0,   363,   364,   365,   366,  1084,     0,   369,   370,
     371,   372,     0,   373,   374,   375,   376,   377,   378,   379,
       0,   380,     0,   382,   383,   384,   385,   386,   387,   388,
       0,   389,     0,   390,     0,     0,   393,     0,   395,   396,
     397,   398,   399,     0,     0,   400,   401,     0,   403,     0,
       0,   405,   406,   407,     0,     0,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,     0,   428,   429,   430,   431,
     432,   433,   434,   435,   436,   437,   438,     0,   439,   440,
       0,   442,     0,   443,   444,   445,   446,   447,   448,     0,
     449,   450,     0,     0,   451,   452,   453,     0,     0,   454,
     455,   456,     0,   458,     0,   460,   461,   462,   463,   464,
     465,   466,   467,   468,   469,   470,     0,     0,   471,   472,
     473,   474,   475,   476,   477,   478,     0,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,   490,   491,
     492,   493,     0,   494,   495,   496,   497,   498,   499,   500,
     501,   502,   503,   504,   505,   506,     0,   507,   508,     0,
     510,   511,   512,   513,   514,   515,   516,   517,   518,   519,
     520,   521,   522,   523,   524,     0,   525,   526,   527,   528,
     529,     0,   530,   531,   532,   533,   534,     0,   536,   537,
     538,   539,     0,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,   551,   552,   553,   554,     0,   555,
     556,     0,   557,     0,   559,   560,   561,   562,   563,     0,
     564,   565,   566,     0,     0,   567,   568,   569,   570,   571,
       0,   572,   573,   574,   575,   576,   577,   578,   579,     0,
       0,   580,   581,   582,   583,   584,     0,     0,   585,   586,
     587,   588,   589,   590,   591,     0,   592,     0,   594,   595,
     596,   597,     0,     0,   598,     0,     0,   599,   600,   601,
     602,   603,   604,   605,   606,   607,   608,   609,   610,   611,
     612,   613,   614,   615,   616,   617,   618,   626,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   236,   237,   238,   239,   240,   241,
     242,   243,     0,   244,   245,   246,     0,     0,     0,     0,
       0,     0,     0,   247,   248,   249,     0,   250,   251,   252,
     253,     0,   255,   256,   257,   258,   259,     0,   261,   262,
       0,   263,   264,   265,   266,   267,   268,   269,     0,     0,
     270,   271,   272,   273,   274,     0,   275,   276,   277,   278,
     279,     0,     0,     0,   281,   282,   283,   284,   285,   286,
       0,   288,   289,   290,     0,   291,   292,   293,   294,   295,
     296,     0,     0,   298,   299,   300,     0,     0,     0,     0,
       0,     0,     0,   302,   303,   304,   305,   306,   307,   308,
     309,   310,     0,   311,     0,   312,   313,   314,   315,   316,
     317,   318,     0,   319,   320,   321,   322,     0,     0,   323,
     324,   325,   326,   327,     0,   328,   329,   330,     0,   331,
     332,   333,     0,   334,   335,   336,   337,   338,   339,   340,
     341,   342,   343,     0,   344,     0,   345,   346,   347,   348,
     349,     0,   350,     0,   351,     0,     0,     0,   354,   355,
     356,   357,     0,   358,   359,     0,   360,   361,   362,     0,
     363,   364,   365,   366,  1087,     0,   369,   370,   371,   372,
       0,   373,   374,   375,   376,   377,   378,   379,     0,   380,
       0,   382,   383,   384,   385,   386,   387,   388,     0,   389,
       0,   390,     0,     0,   393,     0,   395,   396,   397,   398,
     399,     0,     0,   400,   401,     0,   403,     0,     0,   405,
     406,   407,     0,     0,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,     0,   428,   429,   430,   431,   432,   433,
     434,   435,   436,   437,   438,     0,   439,   440,     0,   442,
       0,   443,   444,   445,   446,   447,   448,     0,   449,   450,
       0,     0,   451,   452,   453,     0,     0,   454,   455,   456,
       0,   458,     0,   460,   461,   462,   463,   464,   465,   466,
     467,   468,   469,   470,     0,     0,   471,   472,   473,   474,
     475,   476,   477,   478,     0,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   490,   491,   492,   493,
       0,   494,   495,   496,   497,   498,   499,   500,   501,   502,
     503,   504,   505,   506,     0,   507,   508,     0,   510,   511,
     512,   513,   514,   515,   516,   517,   518,   519,   520,   521,
     522,   523,   524,     0,   525,   526,   527,   528,   529,     0,
     530,   531,   532,   533,   534,     0,   536,   537,   538,   539,
       0,   540,   541,   542,   543,   544,   545,   546,   547,   548,
     549,   550,   551,   552,   553,   554,     0,   555,   556,     0,
     557,     0,   559,   560,   561,   562,   563,     0,   564,   565,
     566,     0,     0,   567,   568,   569,   570,   571,     0,   572,
     573,   574,   575,   576,   577,   578,   579,     0,     0,   580,
     581,   582,   583,   584,     0,     0,   585,   586,   587,   588,
     589,   590,   591,     0,   592,     0,   594,   595,   596,   597,
       0,     0,   598,     0,     0,   599,   600,   601,   602,   603,
     604,   605,   606,   607,   608,   609,   610,   611,   612,   613,
     614,   615,   616,   617,   618,   626,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   236,   237,   238,   239,   240,   241,   242,   243,
       0,   244,   245,   246,     0,     0,     0,     0,     0,     0,
       0,   247,   248,   249,     0,   250,   251,   252,   253,     0,
     255,   256,   257,   258,   259,     0,   261,   262,     0,   263,
     264,   265,   266,   267,   268,   269,     0,     0,   270,   271,
     272,   273,   274,     0,   275,   276,   277,   278,   279,     0,
       0,     0,   281,   282,   283,   284,   285,   286,     0,   288,
     289,   290,     0,   291,   292,   293,   294,   295,   296,     0,
       0,   298,   299,   300,     0,     0,     0,     0,     0,     0,
       0,   302,   303,   304,   305,   306,   307,   308,   309,   310,
       0,   311,     0,   312,   313,   314,   315,   316,   317,   318,
       0,   319,   320,   321,   322,     0,     0,   323,   324,   325,
     326,   327,     0,   328,   329,   330,     0,   331,   332,   333,
       0,   334,   335,   336,   337,   338,   339,   340,   341,   342,
     343,     0,   344,     0,   345,   346,   347,   348,   349,     0,
     350,     0,   351,     0,     0,     0,   354,   355,   356,   357,
       0,   358,   359,     0,   360,   361,   362,     0,   363,   364,
     365,   366,  1089,     0,   369,   370,   371,   372,     0,   373,
     374,   375,   376,   377,   378,   379,     0,   380,     0,   382,
     383,   384,   385,   386,   387,   388,     0,   389,     0,   390,
       0,     0,   393,     0,   395,   396,   397,   398,   399,     0,
       0,   400,   401,     0,   403,     0,     0,   405,   406,   407,
       0,     0,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,     0,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438,     0,   439,   440,     0,   442,     0,   443,
     444,   445,   446,   447,   448,     0,   449,   450,     0,     0,
     451,   452,   453,     0,     0,   454,   455,   456,     0,   458,
       0,   460,   461,   462,   463,   464,   465,   466,   467,   468,
     469,   470,     0,     0,   471,   472,   473,   474,   475,   476,
     477,   478,     0,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,   492,   493,     0,   494,
     495,   496,   497,   498,   499,   500,   501,   502,   503,   504,
     505,   506,     0,   507,   508,     0,   510,   511,   512,   513,
     514,   515,   516,   517,   518,   519,   520,   521,   522,   523,
     524,     0,   525,   526,   527,   528,   529,     0,   530,   531,
     532,   533,   534,     0,   536,   537,   538,   539,     0,   540,
     541,   542,   543,   544,   545,   546,   547,   548,   549,   550,
     551,   552,   553,   554,     0,   555,   556,     0,   557,     0,
     559,   560,   561,   562,   563,     0,   564,   565,   566,     0,
       0,   567,   568,   569,   570,   571,     0,   572,   573,   574,
     575,   576,   577,   578,   579,     0,     0,   580,   581,   582,
     583,   584,     0,     0,   585,   586,   587,   588,   589,   590,
     591,     0,   592,     0,   594,   595,   596,   597,     0,     0,
     598,     0,     0,   599,   600,   601,   602,   603,   604,   605,
     606,   607,   608,   609,   610,   611,   612,   613,   614,   615,
     616,   617,   618,   626,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     236,   237,   238,   239,   240,   241,   242,   243,     0,   244,
     245,   246,     0,     0,     0,     0,     0,     0,     0,   247,
     248,   249,     0,   250,   251,   252,   253,     0,   255,   256,
     257,   258,   259,     0,   261,   262,     0,   263,   264,   265,
     266,   267,   268,   269,     0,     0,   270,   271,   272,   273,
     274,     0,   275,   276,   277,   278,   279,     0,     0,     0,
     281,   282,   283,   284,   285,   286,     0,   288,   289,   290,
       0,   291,   292,   293,   294,   295,   296,     0,     0,   298,
     299,   300,     0,     0,     0,     0,     0,     0,     0,   302,
     303,   304,   305,   306,   307,   308,   309,   310,     0,   311,
       0,   312,   313,   314,   315,   316,   317,   318,     0,   319,
     320,   321,   322,     0,     0,   323,   324,   325,   326,   327,
       0,   328,   329,   330,     0,   331,   332,   333,     0,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,     0,
     344,     0,   345,   346,   347,   348,   349,     0,   350,     0,
     351,     0,     0,     0,   354,   355,   356,   357,     0,   358,
     359,     0,   360,   361,   362,     0,   363,   364,   365,   366,
    1126,     0,   369,   370,   371,   372,     0,   373,   374,   375,
     376,   377,   378,   379,     0,   380,     0,   382,   383,   384,
     385,   386,   387,   388,     0,   389,     0,   390,     0,     0,
     393,     0,   395,   396,   397,   398,   399,     0,     0,   400,
     401,     0,   403,     0,     0,   405,   406,   407,     0,     0,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,     0,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
     438,     0,   439,   440,     0,   442,     0,   443,   444,   445,
     446,   447,   448,     0,   449,   450,     0,     0,   451,   452,
     453,     0,     0,   454,   455,   456,     0,   458,     0,   460,
     461,   462,   463,   464,   465,   466,   467,   468,   469,   470,
       0,     0,   471,   472,   473,   474,   475,   476,   477,   478,
       0,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,   490,   491,   492,   493,     0,   494,   495,   496,
     497,   498,   499,   500,   501,   502,   503,   504,   505,   506,
       0,   507,   508,     0,   510,   511,   512,   513,   514,   515,
     516,   517,   518,   519,   520,   521,   522,   523,   524,     0,
     525,   526,   527,   528,   529,     0,   530,   531,   532,   533,
     534,     0,   536,   537,   538,   539,     0,   540,   541,   542,
     543,   544,   545,   546,   547,   548,   549,   550,   551,   552,
     553,   554,     0,   555,   556,     0,   557,     0,   559,   560,
     561,   562,   563,     0,   564,   565,   566,     0,     0,   567,
     568,   569,   570,   571,     0,   572,   573,   574,   575,   576,
     577,   578,   579,     0,     0,   580,   581,   582,   583,   584,
       0,     0,   585,   586,   587,   588,   589,   590,   591,     0,
     592,     0,   594,   595,   596,   597,     0,     0,   598,     0,
       0,   599,   600,   601,   602,   603,   604,   605,   606,   607,
     608,   609,   610,   611,   612,   613,   614,   615,   616,   617,
     618,   626,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   236,   237,
     238,   239,   240,   241,   242,   243,     0,   244,   245,   246,
       0,     0,     0,     0,     0,     0,     0,   247,   248,   249,
       0,   250,   251,   252,   253,     0,   255,   256,   257,   258,
     259,     0,   261,   262,     0,   263,   264,   265,   266,   267,
     268,   269,     0,     0,   270,   271,   272,   273,   274,     0,
     275,   276,   277,   278,   279,     0,     0,     0,   281,   282,
     283,   284,   285,   286,     0,   288,   289,   290,     0,   291,
     292,   293,   294,   295,   296,     0,     0,   298,   299,   300,
       0,     0,     0,     0,     0,     0,     0,   302,   303,   304,
     305,   306,   307,   308,   309,   310,     0,   311,     0,   312,
     313,   314,   315,   316,   317,   318,     0,   319,   320,   321,
     322,     0,     0,   323,   324,   325,   326,   327,     0,   328,
     329,   330,     0,   331,   332,   333,     0,   334,   335,   336,
     337,   338,   339,   340,   341,   342,   343,     0,   344,     0,
     345,   346,   347,   348,   349,     0,   350,     0,   351,     0,
       0,     0,   354,   355,   356,   357,     0,   358,   359,     0,
     360,   361,   362,     0,   363,   364,   365,   366,  1154,     0,
     369,   370,   371,   372,     0,   373,   374,   375,   376,   377,
     378,   379,     0,   380,     0,   382,   383,   384,   385,   386,
     387,   388,     0,   389,     0,   390,     0,     0,   393,     0,
     395,   396,   397,   398,   399,     0,     0,   400,   401,     0,
     403,     0,     0,   405,   406,   407,     0,     0,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,     0,   428,   429,
     430,   431,   432,   433,   434,   435,   436,   437,   438,     0,
     439,   440,     0,   442,     0,   443,   444,   445,   446,   447,
     448,     0,   449,   450,     0,     0,   451,   452,   453,     0,
       0,   454,   455,   456,     0,   458,     0,   460,   461,   462,
     463,   464,   465,   466,   467,   468,   469,   470,     0,     0,
     471,   472,   473,   474,   475,   476,   477,   478,     0,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,   493,     0,   494,   495,   496,   497,   498,
     499,   500,   501,   502,   503,   504,   505,   506,     0,   507,
     508,     0,   510,   511,   512,   513,   514,   515,   516,   517,
     518,   519,   520,   521,   522,   523,   524,     0,   525,   526,
     527,   528,   529,     0,   530,   531,   532,   533,   534,     0,
     536,   537,   538,   539,     0,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,   552,   553,   554,
       0,   555,   556,     0,   557,     0,   559,   560,   561,   562,
     563,     0,   564,   565,   566,     0,     0,   567,   568,   569,
     570,   571,     0,   572,   573,   574,   575,   576,   577,   578,
     579,     0,     0,   580,   581,   582,   583,   584,     0,     0,
     585,   586,   587,   588,   589,   590,   591,     0,   592,     0,
     594,   595,   596,   597,     0,     0,   598,     0,     0,   599,
     600,   601,   602,   603,   604,   605,   606,   607,   608,   609,
     610,   611,   612,   613,   614,   615,   616,   617,   618,   626,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   236,   237,   238,   239,
     240,   241,   242,   243,     0,   244,   245,   246,     0,     0,
       0,     0,     0,     0,     0,   247,   248,   249,     0,   250,
     251,   252,   253,     0,   255,   256,   257,   258,   259,     0,
     261,   262,     0,   263,   264,   265,   266,   267,   268,   269,
       0,     0,   270,   271,   272,   273,   274,     0,   275,   276,
     277,   278,   279,     0,     0,     0,   281,   282,   283,   284,
     285,   286,     0,   288,   289,   290,     0,   291,   292,   293,
     294,   295,   296,     0,     0,   298,   299,   300,     0,     0,
       0,     0,     0,     0,     0,   302,   303,   304,   305,   306,
     307,   308,   309,   310,     0,   311,     0,   312,   313,   314,
     315,   316,   317,   318,     0,   319,   320,   321,   322,     0,
       0,   323,   324,   325,   326,   327,     0,   328,   329,   330,
       0,   331,   332,   333,     0,   334,   335,   336,   337,   338,
     339,   340,   341,   342,   343,     0,   344,     0,   345,   346,
     347,   348,   349,     0,   350,     0,   351,     0,     0,     0,
     354,   355,   356,   357,     0,   358,   359,     0,   360,   361,
     362,     0,   363,   364,   365,   366,  1156,     0,   369,   370,
     371,   372,     0,   373,   374,   375,   376,   377,   378,   379,
       0,   380,     0,   382,   383,   384,   385,   386,   387,   388,
       0,   389,     0,   390,     0,     0,   393,     0,   395,   396,
     397,   398,   399,     0,     0,   400,   401,     0,   403,     0,
       0,   405,   406,   407,     0,     0,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,     0,   428,   429,   430,   431,
     432,   433,   434,   435,   436,   437,   438,     0,   439,   440,
       0,   442,     0,   443,   444,   445,   446,   447,   448,     0,
     449,   450,     0,     0,   451,   452,   453,     0,     0,   454,
     455,   456,     0,   458,     0,   460,   461,   462,   463,   464,
     465,   466,   467,   468,   469,   470,     0,     0,   471,   472,
     473,   474,   475,   476,   477,   478,     0,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,   490,   491,
     492,   493,     0,   494,   495,   496,   497,   498,   499,   500,
     501,   502,   503,   504,   505,   506,     0,   507,   508,     0,
     510,   511,   512,   513,   514,   515,   516,   517,   518,   519,
     520,   521,   522,   523,   524,     0,   525,   526,   527,   528,
     529,     0,   530,   531,   532,   533,   534,     0,   536,   537,
     538,   539,     0,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,   551,   552,   553,   554,     0,   555,
     556,     0,   557,     0,   559,   560,   561,   562,   563,     0,
     564,   565,   566,     0,     0,   567,   568,   569,   570,   571,
       0,   572,   573,   574,   575,   576,   577,   578,   579,     0,
       0,   580,   581,   582,   583,   584,     0,     0,   585,   586,
     587,   588,   589,   590,   591,     0,   592,     0,   594,   595,
     596,   597,     0,     0,   598,     0,     0,   599,   600,   601,
     602,   603,   604,   605,   606,   607,   608,   609,   610,   611,
     612,   613,   614,   615,   616,   617,   618,   626,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   236,   237,   238,   239,   240,   241,
     242,   243,     0,   244,   245,   246,     0,     0,     0,     0,
       0,     0,     0,   247,   248,   249,     0,   250,   251,   252,
     253,     0,   255,   256,   257,   258,   259,     0,   261,   262,
       0,   263,   264,   265,   266,   267,   268,   269,     0,     0,
     270,   271,   272,   273,   274,     0,   275,   276,   277,   278,
     279,     0,     0,     0,   281,   282,   283,   284,   285,   286,
       0,   288,   289,   290,     0,   291,   292,   293,   294,   295,
     296,     0,     0,   298,   299,   300,     0,     0,     0,     0,
       0,     0,     0,   302,   303,   304,   305,   306,   307,   308,
     309,   310,     0,   311,     0,   312,   313,   314,   315,   316,
     317,   318,     0,   319,   320,   321,   322,     0,     0,   323,
     324,   325,   326,   327,     0,   328,   329,   330,     0,   331,
     332,   333,     0,   334,   335,   336,   337,   338,   339,   340,
     341,   342,   343,     0,   344,     0,   345,   346,   347,   348,
     349,     0,   350,     0,   351,     0,     0,     0,   354,   355,
     356,   357,     0,   358,   359,     0,   360,   361,   362,     0,
     363,   364,   365,   366,  1166,     0,   369,   370,   371,   372,
       0,   373,   374,   375,   376,   377,   378,   379,     0,   380,
       0,   382,   383,   384,   385,   386,   387,   388,     0,   389,
       0,   390,     0,     0,   393,     0,   395,   396,   397,   398,
     399,     0,     0,   400,   401,     0,   403,     0,     0,   405,
     406,   407,     0,     0,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,     0,   428,   429,   430,   431,   432,   433,
     434,   435,   436,   437,   438,     0,   439,   440,     0,   442,
       0,   443,   444,   445,   446,   447,   448,     0,   449,   450,
       0,     0,   451,   452,   453,     0,     0,   454,   455,   456,
       0,   458,     0,   460,   461,   462,   463,   464,   465,   466,
     467,   468,   469,   470,     0,     0,   471,   472,   473,   474,
     475,   476,   477,   478,     0,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   490,   491,   492,   493,
       0,   494,   495,   496,   497,   498,   499,   500,   501,   502,
     503,   504,   505,   506,     0,   507,   508,     0,   510,   511,
     512,   513,   514,   515,   516,   517,   518,   519,   520,   521,
     522,   523,   524,     0,   525,   526,   527,   528,   529,     0,
     530,   531,   532,   533,   534,     0,   536,   537,   538,   539,
       0,   540,   541,   542,   543,   544,   545,   546,   547,   548,
     549,   550,   551,   552,   553,   554,     0,   555,   556,     0,
     557,     0,   559,   560,   561,   562,   563,     0,   564,   565,
     566,     0,     0,   567,   568,   569,   570,   571,     0,   572,
     573,   574,   575,   576,   577,   578,   579,     0,     0,   580,
     581,   582,   583,   584,     0,     0,   585,   586,   587,   588,
     589,   590,   591,     0,   592,     0,   594,   595,   596,   597,
       0,     0,   598,     0,     0,   599,   600,   601,   602,   603,
     604,   605,   606,   607,   608,   609,   610,   611,   612,   613,
     614,   615,   616,   617,   618,   626,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   236,   237,   238,   239,   240,   241,   242,   243,
       0,   244,   245,   246,     0,     0,     0,     0,     0,     0,
       0,   247,   248,   249,     0,   250,   251,   252,   253,     0,
     255,   256,   257,   258,   259,     0,   261,   262,     0,   263,
     264,   265,   266,   267,   268,   269,     0,     0,   270,   271,
     272,   273,   274,     0,   275,   276,   277,   278,   279,     0,
       0,     0,   281,   282,   283,   284,   285,   286,     0,   288,
     289,   290,     0,   291,   292,   293,   294,   295,   296,     0,
       0,   298,   299,   300,     0,     0,     0,     0,     0,     0,
       0,   302,   303,   304,   305,   306,   307,   308,   309,   310,
       0,   311,     0,   312,   313,   314,   315,   316,   317,   318,
       0,   319,   320,   321,   322,     0,     0,   323,   324,   325,
     326,   327,     0,   328,   329,   330,     0,   331,   332,   333,
       0,   334,   335,   336,   337,   338,   339,   340,   341,   342,
     343,     0,   344,     0,   345,   346,   347,   348,   349,     0,
     350,     0,   351,     0,     0,     0,   354,   355,   356,   357,
       0,   358,   359,     0,   360,   361,   362,     0,   363,   364,
     365,   366,  1169,     0,   369,   370,   371,   372,     0,   373,
     374,   375,   376,   377,   378,   379,     0,   380,     0,   382,
     383,   384,   385,   386,   387,   388,     0,   389,     0,   390,
       0,     0,   393,     0,   395,   396,   397,   398,   399,     0,
       0,   400,   401,     0,   403,     0,     0,   405,   406,   407,
       0,     0,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,     0,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438,     0,   439,   440,     0,   442,     0,   443,
     444,   445,   446,   447,   448,     0,   449,   450,     0,     0,
     451,   452,   453,     0,     0,   454,   455,   456,     0,   458,
       0,   460,   461,   462,   463,   464,   465,   466,   467,   468,
     469,   470,     0,     0,   471,   472,   473,   474,   475,   476,
     477,   478,     0,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,   492,   493,     0,   494,
     495,   496,   497,   498,   499,   500,   501,   502,   503,   504,
     505,   506,     0,   507,   508,     0,   510,   511,   512,   513,
     514,   515,   516,   517,   518,   519,   520,   521,   522,   523,
     524,     0,   525,   526,   527,   528,   529,     0,   530,   531,
     532,   533,   534,     0,   536,   537,   538,   539,     0,   540,
     541,   542,   543,   544,   545,   546,   547,   548,   549,   550,
     551,   552,   553,   554,     0,   555,   556,     0,   557,     0,
     559,   560,   561,   562,   563,     0,   564,   565,   566,     0,
       0,   567,   568,   569,   570,   571,     0,   572,   573,   574,
     575,   576,   577,   578,   579,     0,     0,   580,   581,   582,
     583,   584,     0,     0,   585,   586,   587,   588,   589,   590,
     591,     0,   592,     0,   594,   595,   596,   597,     0,     0,
     598,     0,     0,   599,   600,   601,   602,   603,   604,   605,
     606,   607,   608,   609,   610,   611,   612,   613,   614,   615,
     616,   617,   618,   626,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     236,   237,   238,   239,   240,   241,   242,   243,     0,   244,
     245,   246,     0,     0,     0,     0,     0,     0,     0,   247,
     248,   249,     0,   250,   251,   252,   253,     0,   255,   256,
     257,   258,   259,     0,   261,   262,     0,   263,   264,   265,
     266,   267,   268,   269,     0,     0,   270,   271,   272,   273,
     274,     0,   275,   276,   277,   278,   279,     0,     0,     0,
     281,   282,   283,   284,   285,   286,     0,   288,   289,   290,
       0,   291,   292,   293,   294,   295,   296,     0,     0,   298,
     299,   300,     0,     0,     0,     0,     0,     0,     0,   302,
     303,   304,   305,   306,   307,   308,   309,   310,     0,   311,
       0,   312,   313,   314,   315,   316,   317,   318,     0,   319,
     320,   321,   322,     0,     0,   323,   324,   325,   326,   327,
       0,   328,   329,   330,     0,   331,   332,   333,     0,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,     0,
     344,     0,   345,   346,   347,   348,   349,     0,   350,     0,
     351,     0,     0,     0,   354,   355,   356,   357,     0,   358,
     359,     0,   360,   361,   362,     0,   363,   364,   365,   366,
    1172,     0,   369,   370,   371,   372,     0,   373,   374,   375,
     376,   377,   378,   379,     0,   380,     0,   382,   383,   384,
     385,   386,   387,   388,     0,   389,     0,   390,     0,     0,
     393,     0,   395,   396,   397,   398,   399,     0,     0,   400,
     401,     0,   403,     0,     0,   405,   406,   407,     0,     0,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,     0,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
     438,     0,   439,   440,     0,   442,     0,   443,   444,   445,
     446,   447,   448,     0,   449,   450,     0,     0,   451,   452,
     453,     0,     0,   454,   455,   456,     0,   458,     0,   460,
     461,   462,   463,   464,   465,   466,   467,   468,   469,   470,
       0,     0,   471,   472,   473,   474,   475,   476,   477,   478,
       0,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,   490,   491,   492,   493,     0,   494,   495,   496,
     497,   498,   499,   500,   501,   502,   503,   504,   505,   506,
       0,   507,   508,     0,   510,   511,   512,   513,   514,   515,
     516,   517,   518,   519,   520,   521,   522,   523,   524,     0,
     525,   526,   527,   528,   529,     0,   530,   531,   532,   533,
     534,     0,   536,   537,   538,   539,     0,   540,   541,   542,
     543,   544,   545,   546,   547,   548,   549,   550,   551,   552,
     553,   554,     0,   555,   556,     0,   557,     0,   559,   560,
     561,   562,   563,     0,   564,   565,   566,     0,     0,   567,
     568,   569,   570,   571,     0,   572,   573,   574,   575,   576,
     577,   578,   579,     0,     0,   580,   581,   582,   583,   584,
       0,     0,   585,   586,   587,   588,   589,   590,   591,     0,
     592,     0,   594,   595,   596,   597,     0,     0,   598,     0,
       0,   599,   600,   601,   602,   603,   604,   605,   606,   607,
     608,   609,   610,   611,   612,   613,   614,   615,   616,   617,
     618,   626,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   236,   237,
     238,   239,   240,   241,   242,   243,     0,   244,   245,   246,
       0,     0,     0,     0,     0,     0,     0,   247,   248,   249,
       0,   250,   251,   252,   253,     0,   255,   256,   257,   258,
     259,     0,   261,   262,     0,   263,   264,   265,   266,   267,
     268,   269,     0,     0,   819,   271,   272,   273,   274,     0,
     275,   276,   277,   278,   279,     0,     0,     0,   281,   282,
     283,   284,   285,   286,     0,   288,   289,   290,     0,   291,
     292,   293,   294,   295,   296,     0,     0,   298,   299,   300,
       0,     0,     0,     0,     0,     0,     0,   302,   303,   304,
     305,   306,   307,   308,   309,   310,     0,   311,     0,   312,
     313,   314,   315,   316,   317,   318,     0,   319,   320,   321,
     322,     0,     0,   323,   324,   325,   326,   327,     0,   328,
     329,   330,     0,   331,   332,   333,     0,   334,   335,   336,
     337,   338,   339,   340,   341,   342,   343,     0,   344,     0,
     345,   346,   347,   348,   349,     0,   350,     0,   351,     0,
       0,     0,   354,   355,   356,   357,     0,   358,   359,     0,
     360,   361,   362,     0,   363,   364,   365,   366,   367,     0,
     369,   370,   371,   372,     0,   373,   374,   375,   376,   377,
     378,   379,     0,   380,     0,   382,   383,   384,   385,   386,
     387,   388,     0,   389,     0,   390,     0,     0,   393,     0,
     395,   396,   397,   398,   399,     0,     0,   400,   401,     0,
     403,     0,     0,   405,   406,   407,     0,     0,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   822,   426,     0,   428,   429,
     430,   431,   432,   433,   434,   435,   436,   437,   438,     0,
     439,   440,     0,   442,     0,   443,   444,   445,   446,   447,
     448,     0,   449,   450,     0,     0,   451,   452,   453,     0,
       0,   454,   455,   456,     0,   458,     0,   460,   461,   462,
     463,   464,   465,   466,   467,   468,   469,   470,     0,     0,
     471,   472,   473,   474,   475,   476,   477,   478,     0,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,   493,     0,   494,   495,   496,   497,   498,
     499,   500,   501,   502,   503,   504,   505,   506,     0,   507,
     508,     0,   823,   511,   512,   513,   514,   515,   516,   517,
     518,   824,   520,   521,   522,   523,   524,     0,   525,   526,
     527,   528,  1354,     0,   530,   531,   532,   533,   534,     0,
     536,   537,   538,   539,     0,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,   552,   553,   554,
       0,   555,   556,     0,   557,     0,   559,   560,   561,   562,
     563,     0,   564,   826,   566,     0,     0,   827,   568,   569,
     570,   571,     0,   572,   573,   574,   575,   576,   577,   578,
     579,     0,     0,   580,   581,   582,   583,   584,     0,     0,
     585,   586,   587,   588,   589,   590,   591,     0,   592,     0,
     594,   595,   596,   597,     0,     0,   598,     0,     0,   599,
     600,   601,   602,   603,   828,   605,   606,   607,   608,   609,
     610,   611,   612,   613,   614,   615,   616,   617,   618,   626,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   236,   237,   238,   239,
     240,   241,   242,   243,     0,   244,   245,   246,     0,     0,
       0,     0,     0,     0,     0,   247,   248,   249,     0,   250,
     251,   252,   253,     0,   255,   256,   257,   258,   259,     0,
     261,   262,     0,   263,   264,   265,   266,   267,   268,   269,
       0,     0,   270,   271,   272,   273,   274,     0,   275,   276,
     277,   278,   279,     0,     0,     0,   281,   282,   283,   284,
     285,   286,     0,   288,   289,   290,     0,   291,   292,   293,
     294,   295,   296,     0,     0,   298,   299,   300,     0,     0,
       0,     0,     0,     0,     0,   302,   303,   304,   305,   306,
     307,   308,   309,   310,     0,   311,     0,   312,   313,   314,
     315,   316,   317,   318,     0,   319,   320,   321,   322,     0,
       0,   323,   324,   325,   326,   327,     0,   328,   329,   330,
       0,   331,   332,   333,     0,   334,   335,   336,   337,   338,
     339,   340,   341,   342,   343,     0,   344,     0,   345,   346,
     347,   348,   349,     0,   350,     0,   351,     0,     0,     0,
     354,   355,   356,   357,     0,   358,   359,     0,   360,   361,
     362,     0,   363,   364,   365,   366,  1829,     0,   369,   370,
     371,   372,     0,   373,   374,   375,   376,   377,   378,   379,
       0,   380,     0,   382,   383,   384,   385,   386,   387,   388,
       0,   389,     0,   390,     0,     0,   393,     0,   395,   396,
     397,   398,   399,     0,     0,   400,   401,     0,   403,     0,
       0,   405,   406,   407,     0,     0,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,     0,   428,   429,   430,   431,
     432,   433,   434,   435,   436,   437,   438,     0,   439,   440,
       0,   442,     0,   443,   444,   445,   446,   447,   448,     0,
     449,   450,     0,     0,   451,   452,   453,     0,     0,   454,
     455,   456,     0,   458,     0,   460,   461,   462,   463,   464,
     465,   466,   467,   468,   469,   470,     0,     0,   471,   472,
     473,   474,   475,   476,   477,   478,     0,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,   490,   491,
     492,   493,     0,   494,   495,   496,   497,   498,   499,   500,
     501,   502,   503,   504,   505,   506,     0,   507,   508,     0,
     510,   511,   512,   513,   514,   515,   516,   517,   518,   519,
     520,   521,   522,   523,   524,     0,   525,   526,   527,   528,
     529,     0,   530,   531,   532,   533,   534,     0,   536,   537,
     538,   539,     0,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,   551,   552,   553,   554,     0,   555,
     556,     0,   557,     0,   559,   560,   561,   562,   563,     0,
     564,   565,   566,     0,     0,   567,   568,   569,   570,   571,
       0,   572,   573,   574,   575,   576,   577,   578,   579,     0,
       0,   580,   581,   582,   583,   584,     0,     0,   585,   586,
     587,   588,   589,   590,   591,     0,   592,     0,   594,   595,
     596,   597,     0,     0,   598,     0,     0,   599,   600,   601,
     602,   603,   604,   605,   606,   607,   608,   609,   610,   611,
     612,   613,   614,   615,   616,   617,   618,   626,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   236,   237,   238,   239,   240,   241,
     242,   243,     0,   244,   245,   246,     0,     0,     0,     0,
       0,     0,     0,   247,   248,   249,     0,   250,   251,   252,
     253,     0,   255,   256,   257,   258,   259,     0,   261,   262,
       0,   263,   264,   265,   266,   267,   268,   269,     0,     0,
     270,   271,   272,   273,   274,     0,   275,   276,   277,   278,
     279,     0,     0,     0,   281,   282,   283,   284,   285,   286,
       0,   288,   289,   290,     0,   291,   292,   293,   294,   295,
     296,     0,     0,   298,   299,   300,     0,     0,     0,     0,
       0,     0,     0,   302,   303,   304,   305,   306,   307,   308,
     309,   310,     0,   311,     0,   312,   313,   314,   315,   316,
     317,   318,     0,   319,   320,   321,   322,     0,     0,   323,
     324,   325,   326,   327,     0,   328,   329,   330,     0,   331,
     332,   333,     0,   334,   335,   336,   337,   338,   339,   340,
     341,   342,   343,     0,   344,     0,   345,   346,   347,   348,
     349,     0,   350,     0,   351,     0,     0,     0,   354,   355,
     356,   357,     0,   358,   359,     0,   360,   361,   362,     0,
     363,   364,   365,   366,  1863,     0,   369,   370,   371,   372,
       0,   373,   374,   375,   376,   377,   378,   379,     0,   380,
       0,   382,   383,   384,   385,   386,   387,   388,     0,   389,
       0,   390,     0,     0,   393,     0,   395,   396,   397,   398,
     399,     0,     0,   400,   401,     0,   403,     0,     0,   405,
     406,   407,     0,     0,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,     0,   428,   429,   430,   431,   432,   433,
     434,   435,   436,   437,   438,     0,   439,   440,     0,   442,
       0,   443,   444,   445,   446,   447,   448,     0,   449,   450,
       0,     0,   451,   452,   453,     0,     0,   454,   455,   456,
       0,   458,     0,   460,   461,   462,   463,   464,   465,   466,
     467,   468,   469,   470,     0,     0,   471,   472,   473,   474,
     475,   476,   477,   478,     0,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   490,   491,   492,   493,
       0,   494,   495,   496,   497,   498,   499,   500,   501,   502,
     503,   504,   505,   506,     0,   507,   508,     0,   510,   511,
     512,   513,   514,   515,   516,   517,   518,   519,   520,   521,
     522,   523,   524,     0,   525,   526,   527,   528,   529,     0,
     530,   531,   532,   533,   534,     0,   536,   537,   538,   539,
       0,   540,   541,   542,   543,   544,   545,   546,   547,   548,
     549,   550,   551,   552,   553,   554,     0,   555,   556,     0,
     557,     0,   559,   560,   561,   562,   563,     0,   564,   565,
     566,     0,     0,   567,   568,   569,   570,   571,     0,   572,
     573,   574,   575,   576,   577,   578,   579,     0,     0,   580,
     581,   582,   583,   584,     0,     0,   585,   586,   587,   588,
     589,   590,   591,     0,   592,     0,   594,   595,   596,   597,
       0,     0,   598,     0,     0,   599,   600,   601,   602,   603,
     604,   605,   606,   607,   608,   609,   610,   611,   612,   613,
     614,   615,   616,   617,   618,   626,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   236,   237,   238,   239,   240,   241,   242,   243,
       0,   244,   245,   246,     0,     0,     0,     0,     0,     0,
       0,   247,   248,   249,     0,   250,   251,   252,   253,     0,
     255,   256,   257,   258,   259,     0,   261,   262,     0,   263,
     264,   265,   266,   267,   268,   269,     0,     0,   270,   271,
     272,   273,   274,     0,   275,   276,   277,   278,   279,     0,
       0,     0,   281,   282,   283,   284,   285,   286,     0,   288,
     289,   290,     0,   291,   292,   293,   294,   295,   296,     0,
       0,   298,   299,   300,     0,     0,     0,     0,     0,     0,
       0,   302,   303,   304,   305,   306,   307,   308,   309,   310,
       0,   311,     0,   312,   313,   314,   315,   316,   317,   318,
       0,   319,   320,   321,   322,     0,     0,   323,   324,   325,
     326,   327,     0,   328,   329,   330,     0,   331,   332,   333,
       0,   334,   335,   336,   337,   338,   339,   340,   341,   342,
     343,     0,   344,     0,   345,   346,   347,   348,   349,     0,
     350,     0,   351,     0,     0,     0,   354,   355,   356,   357,
       0,   358,   359,     0,   360,   361,   362,     0,   363,   364,
     365,   366,  1865,     0,   369,   370,   371,   372,     0,   373,
     374,   375,   376,   377,   378,   379,     0,   380,     0,   382,
     383,   384,   385,   386,   387,   388,     0,   389,     0,   390,
       0,     0,   393,     0,   395,   396,   397,   398,   399,     0,
       0,   400,   401,     0,   403,     0,     0,   405,   406,   407,
       0,     0,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,     0,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438,     0,   439,   440,     0,   442,     0,   443,
     444,   445,   446,   447,   448,     0,   449,   450,     0,     0,
     451,   452,   453,     0,     0,   454,   455,   456,     0,   458,
       0,   460,   461,   462,   463,   464,   465,   466,   467,   468,
     469,   470,     0,     0,   471,   472,   473,   474,   475,   476,
     477,   478,     0,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,   492,   493,     0,   494,
     495,   496,   497,   498,   499,   500,   501,   502,   503,   504,
     505,   506,     0,   507,   508,     0,   510,   511,   512,   513,
     514,   515,   516,   517,   518,   519,   520,   521,   522,   523,
     524,     0,   525,   526,   527,   528,   529,     0,   530,   531,
     532,   533,   534,     0,   536,   537,   538,   539,     0,   540,
     541,   542,   543,   544,   545,   546,   547,   548,   549,   550,
     551,   552,   553,   554,     0,   555,   556,     0,   557,     0,
     559,   560,   561,   562,   563,     0,   564,   565,   566,     0,
       0,   567,   568,   569,   570,   571,     0,   572,   573,   574,
     575,   576,   577,   578,   579,     0,     0,   580,   581,   582,
     583,   584,     0,     0,   585,   586,   587,   588,   589,   590,
     591,     0,   592,     0,   594,   595,   596,   597,     0,     0,
     598,     0,     0,   599,   600,   601,   602,   603,   604,   605,
     606,   607,   608,   609,   610,   611,   612,   613,   614,   615,
     616,   617,   618,   626,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     236,   237,   238,   239,   240,   241,   242,   243,     0,   244,
     245,   246,     0,     0,     0,     0,     0,     0,     0,   247,
     248,   249,     0,   250,   251,   252,   253,     0,   255,   256,
     257,   258,   259,     0,   261,   262,     0,   263,   264,   265,
     266,   267,   268,   269,     0,     0,   270,   271,   272,   273,
     274,     0,   275,   276,   277,   278,   279,     0,     0,     0,
     281,   282,   283,   284,   285,   286,     0,   288,   289,   290,
       0,   291,   292,   293,   294,   295,   296,     0,     0,   298,
     299,   300,     0,     0,     0,     0,     0,     0,     0,   302,
     303,   304,   305,   306,   307,   308,   309,   310,     0,   311,
       0,   312,   313,   314,   315,   316,   317,   318,     0,   319,
     320,   321,   322,     0,     0,   323,   324,   325,   326,   327,
       0,   328,   329,   330,     0,   331,   332,   333,     0,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,     0,
     344,     0,   345,   346,   347,   348,   349,     0,   350,     0,
     351,     0,     0,     0,   354,   355,   356,   357,     0,   358,
     359,     0,   360,   361,   362,     0,   363,   364,   365,   366,
    1904,     0,   369,   370,   371,   372,     0,   373,   374,   375,
     376,   377,   378,   379,     0,   380,     0,   382,   383,   384,
     385,   386,   387,   388,     0,   389,     0,   390,     0,     0,
     393,     0,   395,   396,   397,   398,   399,     0,     0,   400,
     401,     0,   403,     0,     0,   405,   406,   407,     0,     0,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,     0,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
     438,     0,   439,   440,     0,   442,     0,   443,   444,   445,
     446,   447,   448,     0,   449,   450,     0,     0,   451,   452,
     453,     0,     0,   454,   455,   456,     0,   458,     0,   460,
     461,   462,   463,   464,   465,   466,   467,   468,   469,   470,
       0,     0,   471,   472,   473,   474,   475,   476,   477,   478,
       0,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,   490,   491,   492,   493,     0,   494,   495,   496,
     497,   498,   499,   500,   501,   502,   503,   504,   505,   506,
       0,   507,   508,     0,   510,   511,   512,   513,   514,   515,
     516,   517,   518,   519,   520,   521,   522,   523,   524,     0,
     525,   526,   527,   528,   529,     0,   530,   531,   532,   533,
     534,     0,   536,   537,   538,   539,     0,   540,   541,   542,
     543,   544,   545,   546,   547,   548,   549,   550,   551,   552,
     553,   554,     0,   555,   556,     0,   557,     0,   559,   560,
     561,   562,   563,     0,   564,   565,   566,     0,     0,   567,
     568,   569,   570,   571,     0,   572,   573,   574,   575,   576,
     577,   578,   579,     0,     0,   580,   581,   582,   583,   584,
       0,     0,   585,   586,   587,   588,   589,   590,   591,     0,
     592,     0,   594,   595,   596,   597,     0,     0,   598,     0,
       0,   599,   600,   601,   602,   603,   604,   605,   606,   607,
     608,   609,   610,   611,   612,   613,   614,   615,   616,   617,
     618,   626,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   236,   237,
     238,   239,   240,   241,   242,   243,     0,   244,   245,   246,
       0,     0,     0,     0,     0,     0,     0,   247,   248,   249,
       0,   250,   251,   252,   253,     0,   255,   256,   257,   258,
     259,     0,   261,   262,     0,   263,   264,   265,   266,   267,
     268,   269,     0,     0,   270,   271,   272,   273,   274,     0,
     275,   276,   277,   278,   279,     0,     0,     0,   281,   282,
     283,   284,   285,   286,     0,   288,   289,   290,     0,   291,
     292,   293,   294,   295,   296,     0,     0,   298,   299,   300,
       0,     0,     0,     0,     0,     0,     0,   302,   303,   304,
     305,   306,   307,   308,   309,   310,     0,   311,     0,   312,
     313,   314,   315,   316,   317,   318,     0,   319,   320,   321,
     322,     0,     0,   323,   324,   325,   326,   327,     0,   328,
     329,   330,     0,   331,   332,   333,     0,   334,   335,   336,
     337,   338,   339,   340,   341,   342,   343,     0,   344,     0,
     345,   346,   347,   348,   349,     0,   350,     0,   351,     0,
       0,     0,   354,   355,   356,   357,     0,   358,   359,     0,
     360,   361,   362,     0,   363,   364,   365,   366,  1906,     0,
     369,   370,   371,   372,     0,   373,   374,   375,   376,   377,
     378,   379,     0,   380,     0,   382,   383,   384,   385,   386,
     387,   388,     0,   389,     0,   390,     0,     0,   393,     0,
     395,   396,   397,   398,   399,     0,     0,   400,   401,     0,
     403,     0,     0,   405,   406,   407,     0,     0,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,     0,   428,   429,
     430,   431,   432,   433,   434,   435,   436,   437,   438,     0,
     439,   440,     0,   442,     0,   443,   444,   445,   446,   447,
     448,     0,   449,   450,     0,     0,   451,   452,   453,     0,
       0,   454,   455,   456,     0,   458,     0,   460,   461,   462,
     463,   464,   465,   466,   467,   468,   469,   470,     0,     0,
     471,   472,   473,   474,   475,   476,   477,   478,     0,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,   493,     0,   494,   495,   496,   497,   498,
     499,   500,   501,   502,   503,   504,   505,   506,     0,   507,
     508,     0,   510,   511,   512,   513,   514,   515,   516,   517,
     518,   519,   520,   521,   522,   523,   524,     0,   525,   526,
     527,   528,   529,     0,   530,   531,   532,   533,   534,     0,
     536,   537,   538,   539,     0,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,   552,   553,   554,
       0,   555,   556,     0,   557,     0,   559,   560,   561,   562,
     563,     0,   564,   565,   566,     0,     0,   567,   568,   569,
     570,   571,     0,   572,   573,   574,   575,   576,   577,   578,
     579,     0,     0,   580,   581,   582,   583,   584,     0,     0,
     585,   586,   587,   588,   589,   590,   591,     0,   592,     0,
     594,   595,   596,   597,     0,     0,   598,     0,     0,   599,
     600,   601,   602,   603,   604,   605,   606,   607,   608,   609,
     610,   611,   612,   613,   614,   615,   616,   617,   618,   626,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   236,   237,   238,   239,
     240,   241,   242,   243,     0,   244,   245,   246,     0,     0,
       0,     0,     0,     0,     0,   247,   248,   249,     0,   250,
     251,   252,   253,     0,   255,   256,   257,   258,   259,     0,
     261,   262,     0,   263,   264,   265,   266,   267,   268,   269,
       0,     0,   270,   271,   272,   273,   274,     0,   275,   276,
     277,   278,   279,     0,     0,     0,   281,   282,   283,   284,
     285,   286,     0,   288,   289,   290,     0,   291,   292,   293,
     294,   295,   296,     0,     0,   298,   299,   300,     0,     0,
       0,     0,     0,     0,     0,   302,   303,   304,   305,   306,
     307,   308,   309,   310,     0,   311,     0,   312,   313,   314,
     315,   316,   317,   318,     0,   319,   320,   321,   322,     0,
       0,   323,   324,   325,   326,   327,     0,   328,   329,   330,
       0,   331,   332,   333,     0,   334,   335,   336,   337,   338,
     339,   340,   341,   342,   343,     0,   344,     0,   345,   346,
     347,   348,   349,     0,   350,     0,   351,     0,     0,     0,
     354,   355,   356,   357,     0,   358,   359,     0,   360,   361,
     362,     0,   363,   364,   365,   366,  1908,     0,   369,   370,
     371,   372,     0,   373,   374,   375,   376,   377,   378,   379,
       0,   380,     0,   382,   383,   384,   385,   386,   387,   388,
       0,   389,     0,   390,     0,     0,   393,     0,   395,   396,
     397,   398,   399,     0,     0,   400,   401,     0,   403,     0,
       0,   405,   406,   407,     0,     0,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,     0,   428,   429,   430,   431,
     432,   433,   434,   435,   436,   437,   438,     0,   439,   440,
       0,   442,     0,   443,   444,   445,   446,   447,   448,     0,
     449,   450,     0,     0,   451,   452,   453,     0,     0,   454,
     455,   456,     0,   458,     0,   460,   461,   462,   463,   464,
     465,   466,   467,   468,   469,   470,     0,     0,   471,   472,
     473,   474,   475,   476,   477,   478,     0,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,   490,   491,
     492,   493,     0,   494,   495,   496,   497,   498,   499,   500,
     501,   502,   503,   504,   505,   506,     0,   507,   508,     0,
     510,   511,   512,   513,   514,   515,   516,   517,   518,   519,
     520,   521,   522,   523,   524,     0,   525,   526,   527,   528,
     529,     0,   530,   531,   532,   533,   534,     0,   536,   537,
     538,   539,     0,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,   551,   552,   553,   554,     0,   555,
     556,     0,   557,     0,   559,   560,   561,   562,   563,     0,
     564,   565,   566,     0,     0,   567,   568,   569,   570,   571,
       0,   572,   573,   574,   575,   576,   577,   578,   579,     0,
       0,   580,   581,   582,   583,   584,     0,     0,   585,   586,
     587,   588,   589,   590,   591,     0,   592,     0,   594,   595,
     596,   597,     0,     0,   598,     0,     0,   599,   600,   601,
     602,   603,   604,   605,   606,   607,   608,   609,   610,   611,
     612,   613,   614,   615,   616,   617,   618,   626,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   236,   237,   238,   239,   240,   241,
     242,   243,     0,   244,   245,   246,     0,     0,     0,     0,
       0,     0,     0,   247,   248,   249,     0,   250,   251,   252,
     253,     0,   255,   256,   257,   258,   259,     0,   261,   262,
       0,   263,   264,   265,   266,   267,   268,   269,     0,     0,
     270,   271,   272,   273,   274,     0,   275,   276,   277,   278,
     279,     0,     0,     0,   281,   282,   283,   284,   285,   286,
       0,   288,   289,   290,     0,   291,   292,   293,   294,   295,
     296,     0,     0,   298,   299,   300,     0,     0,     0,     0,
       0,     0,     0,   302,   303,   304,   305,   306,   307,   308,
     309,   310,     0,   311,     0,   312,   313,   314,   315,   316,
     317,   318,     0,   319,   320,   321,   322,     0,     0,   323,
     324,   325,   326,   327,     0,   328,   329,   330,     0,   331,
     332,   333,     0,   334,   335,   336,   337,   338,   339,   340,
     341,   342,   343,     0,   344,     0,   345,   346,   347,   348,
     349,     0,   350,     0,   351,     0,     0,     0,   354,   355,
     356,   357,     0,   358,   359,     0,   360,   361,   362,     0,
     363,   364,   365,   366,   367,     0,   369,   370,   371,   372,
       0,   373,   374,   375,   376,   377,   378,   379,     0,   380,
       0,   382,   383,   384,   385,   386,   387,   388,     0,   389,
       0,   390,     0,     0,   393,     0,   395,   396,   397,   398,
     399,     0,     0,   400,   401,     0,   403,     0,     0,   405,
     406,   407,     0,     0,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,     0,   428,   429,   430,   431,   432,   433,
     434,   435,   436,   437,   438,     0,   439,   440,     0,   442,
       0,   443,   444,   445,   446,   447,   448,     0,   449,   450,
       0,     0,   451,   452,   453,     0,     0,   454,   455,   456,
       0,   458,     0,   460,   461,   462,   463,   464,   465,   466,
     467,   468,   469,   470,     0,     0,   471,   472,   473,   474,
     475,   476,   477,   478,     0,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   490,   491,   492,   493,
       0,   494,   495,   496,   497,   498,   499,   500,   501,   502,
     503,   504,   505,   506,     0,   507,   508,     0,   510,   511,
     512,   513,   514,   515,   516,   517,  2001,   519,   520,   521,
     522,   523,   524,     0,   525,   526,   527,   528,   529,     0,
     530,   531,   532,   533,   534,     0,   536,   537,   538,   539,
       0,   540,   541,   542,   543,   544,   545,   546,   547,   548,
     549,   550,   551,   552,   553,   554,     0,   555,   556,     0,
     557,     0,   559,   560,   561,   562,   563,     0,   564,   565,
     566,     0,     0,   567,   568,   569,   570,   571,     0,   572,
     573,   574,   575,   576,   577,   578,   579,     0,     0,   580,
     581,   582,   583,   584,     0,     0,   585,   586,   587,   588,
     589,   590,   591,     0,   592,     0,   594,   595,   596,   597,
       0,     0,   598,     0,     0,   599,   600,   601,   602,   603,
     604,   605,   606,   607,   608,   609,   610,   611,   612,   613,
     614,   615,   616,   617,   618,   626,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   236,   237,   238,   239,   240,   241,   242,   243,
       0,   244,   245,   246,     0,     0,     0,     0,     0,  2631,
       0,   247,   248,   249,     0,   250,   251,   252,   253,     0,
     255,   256,   257,   258,   259,     0,   261,   262,     0,   263,
     264,   265,   266,   267,   268,   269,     0,     0,   270,   271,
     272,   273,   274,     0,   275,   276,   277,   278,   279,     0,
       0,     0,   281,   282,   283,   284,   285,   286,     0,   288,
     289,   290,     0,   291,   292,   293,   294,   295,   296,     0,
       0,   298,   299,   300,     0,     0,     0,     0,     0,     0,
       0,   302,   303,   304,   305,   306,   307,   308,   309,   310,
       0,   311,     0,   312,   313,   314,   315,   316,   317,   318,
       0,   319,   320,   321,   322,     0,     0,   323,   324,   325,
     326,   327,     0,   328,   329,   330,     0,   331,   332,   333,
       0,   334,   335,   336,   337,   338,   339,   340,   341,   342,
     343,     0,   344,     0,   345,   346,   347,   348,   349,     0,
     350,     0,   351,     0,     0,     0,   354,   355,   356,   357,
       0,   358,   359,     0,   360,   361,   362,     0,   363,   364,
     365,   366,   367,     0,   369,   370,   371,   372,     0,   373,
     374,   375,   376,   377,   378,   379,     0,   380,     0,   382,
     383,   384,   385,   386,   387,   388,     0,   389,     0,   390,
       0,     0,   393,     0,   395,   396,   397,   398,   399,     0,
       0,   400,   401,     0,   403,     0,     0,   405,   406,   407,
       0,     0,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,     0,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438,     0,   439,   440,     0,   442,     0,   443,
     444,   445,   446,   447,   448,     0,   449,   450,     0,     0,
     451,   452,   453,     0,     0,   454,   455,   456,     0,   458,
       0,   460,   461,   462,   463,   464,   465,   466,   467,   468,
     469,   470,     0,     0,   471,   472,   473,   474,   475,   476,
     477,   478,     0,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,   492,   493,     0,   494,
     495,   496,   497,   498,   499,   500,   501,   502,   503,   504,
     505,   506,     0,   507,   508,     0,   510,   511,   512,   513,
     514,   515,   516,   517,   518,   519,   520,   521,   522,   523,
     524,     0,   525,   526,   527,   528,   529,     0,     0,   531,
     532,   533,   534,     0,   536,   537,   538,   539,     0,   540,
     541,   542,   543,   544,   545,   546,   547,   548,   549,   550,
     551,   552,   553,   554,     0,   555,   556,     0,   557,     0,
     559,   560,   561,   562,   563,     0,   564,   565,   566,     0,
       0,   567,   568,   569,   570,   571,     0,   572,   573,   574,
     575,   576,   577,   578,   579,     0,     0,   580,   581,   582,
     583,   584,     0,     0,   585,   586,   587,   588,   589,   590,
     591,     0,   592,     0,   594,   595,   596,   597,     0,     0,
     598,     0,     0,   599,   600,   601,   602,   603,   604,   605,
     606,   607,   608,   609,   610,   611,   612,   613,   614,   615,
     616,   617,   618,   626,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     236,   237,   238,   239,   240,   241,   242,   243,     0,   244,
     245,   246,     0,     0,     0,     0,     0,     0,     0,   247,
     248,   249,     0,   250,   251,   252,   253,     0,   255,   256,
     257,   258,   259,     0,   261,   262,     0,   263,   264,   265,
     266,   267,   268,   269,     0,     0,   819,   271,   272,   273,
     274,     0,   275,   276,   277,   278,   279,     0,     0,     0,
     281,   282,   283,   284,   285,   286,     0,   288,   289,   290,
       0,   291,   292,   293,   294,   295,   296,     0,     0,   298,
     299,   300,     0,     0,     0,     0,     0,     0,     0,   302,
     303,   304,   305,   306,   307,   308,   309,   310,     0,   311,
       0,   312,   313,   314,   315,   316,   317,   318,     0,   319,
     320,   321,   322,     0,     0,   323,   324,   325,   326,   327,
       0,   328,   329,   330,     0,   331,   332,   333,     0,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,     0,
     344,     0,   345,   346,   347,   348,   349,     0,   350,     0,
     351,     0,     0,     0,   354,   355,   356,   357,     0,   358,
     359,     0,   360,   361,   362,     0,   363,   364,   365,   366,
     367,     0,   369,   370,   371,   372,     0,   373,   374,   375,
     376,   377,   378,   379,     0,   380,     0,   382,   383,   384,
     385,   386,   387,   388,     0,   389,     0,   390,     0,     0,
     393,     0,   395,   396,   397,   398,   399,     0,     0,   400,
     401,     0,   403,     0,     0,   405,   406,   407,     0,     0,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   822,   426,     0,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
     438,     0,   439,   440,     0,   442,     0,   443,   444,   445,
     446,   447,   448,     0,   449,   450,     0,     0,   451,   452,
     453,     0,     0,   454,   455,   456,     0,   458,     0,   460,
     461,   462,   463,   464,   465,   466,   467,   468,   469,   470,
       0,     0,   471,   472,   473,   474,   475,   476,   477,   478,
       0,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,   490,   491,   492,   493,     0,   494,   495,   496,
     497,   498,   499,   500,   501,   502,   503,   504,   505,   506,
       0,   507,   508,     0,   823,   511,   512,   513,   514,   515,
     516,   517,   518,   824,   520,   521,   522,   523,   524,     0,
     525,   526,   527,   528,  1354,     0,   530,   531,   532,   533,
     534,     0,   536,   537,   538,   539,     0,   540,   541,   542,
     543,   544,   545,   546,   547,   548,   549,   550,   551,   552,
     553,   554,     0,   555,   556,     0,   557,     0,  2665,   560,
     561,   562,   563,     0,   564,   826,   566,     0,     0,   827,
     568,   569,   570,   571,     0,   572,   573,   574,   575,   576,
     577,   578,   579,     0,     0,   580,   581,   582,   583,   584,
       0,     0,   585,   586,   587,   588,   589,   590,   591,     0,
     592,     0,   594,   595,   596,   597,     0,     0,   598,     0,
       0,   599,   600,   601,   602,   603,   828,   605,   606,   607,
     608,   609,   610,   611,   612,   613,   614,   615,   616,   617,
     618,   626,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   236,   237,
     238,   239,   240,   241,   242,   243,     0,   244,   245,   246,
       0,     0,     0,     0,     0,     0,     0,   247,   248,   249,
       0,   250,   251,   252,   253,     0,   255,   256,   257,   258,
     259,     0,   261,   262,     0,   263,   264,   265,   266,   267,
     268,   269,     0,     0,   819,   271,   272,   273,   274,     0,
     275,   276,   277,   278,   279,     0,     0,     0,   281,   282,
     283,   284,   285,   286,     0,   288,   289,   290,     0,   291,
     292,   293,   294,   295,   296,     0,     0,   298,   299,   300,
       0,     0,     0,     0,     0,     0,     0,   302,   303,   304,
     305,   306,   307,   308,   309,   310,     0,   311,     0,   312,
     313,   314,   315,   316,   317,   318,     0,   319,   320,   321,
     322,     0,     0,   323,   324,   325,   326,   327,     0,   328,
     329,   330,     0,   331,   332,   333,     0,   334,   335,   336,
     337,   338,   339,   340,   341,   342,   343,     0,   344,     0,
     345,   346,   347,   348,   349,     0,   350,     0,   351,     0,
       0,     0,   354,   355,   356,   357,     0,   358,   359,     0,
     360,   361,   362,     0,   363,   364,   365,   366,   367,     0,
     369,   370,   371,   372,     0,   373,   374,   375,   376,   377,
     378,   379,     0,   380,     0,   382,   383,   384,   385,   386,
     387,   388,     0,   389,     0,   390,     0,     0,   393,     0,
     395,   396,   397,   398,   399,     0,     0,   400,   401,     0,
     403,     0,     0,   405,   406,   407,     0,     0,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   822,   426,     0,   428,   429,
     430,   431,   432,   433,   434,   435,   436,   437,   438,     0,
     439,   440,     0,   442,     0,   443,   444,   445,   446,   447,
     448,     0,   449,   450,     0,     0,   451,   452,   453,     0,
       0,   454,   455,   456,     0,   458,     0,   460,   461,   462,
     463,   464,   465,   466,   467,   468,   469,   470,     0,     0,
     471,   472,   473,   474,   475,   476,   477,   478,     0,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,   493,     0,   494,   495,   496,   497,   498,
     499,   500,   501,   502,   503,   504,   505,   506,     0,   507,
     508,     0,   823,   511,   512,   513,   514,   515,   516,   517,
     518,  2730,   520,   521,   522,   523,   524,     0,   525,   526,
     527,   528,  2731,     0,   530,   531,   532,   533,   534,     0,
     536,   537,   538,   539,     0,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,   552,   553,   554,
       0,   555,   556,     0,   557,     0,   559,   560,   561,   562,
     563,     0,   564,   826,   566,     0,     0,  2732,   568,   569,
     570,   571,     0,   572,   573,   574,   575,   576,   577,   578,
     579,     0,     0,   580,   581,   582,   583,   584,     0,     0,
     585,   586,   587,   588,   589,   590,   591,     0,   592,     0,
     594,   595,   596,   597,     0,     0,   598,     0,     0,   599,
     600,   601,   602,   603,   828,   605,   606,   607,   608,   609,
     610,   611,   612,   613,   614,   615,   616,   617,   618,   626,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   236,   237,   238,   239,
     240,   241,   242,   243,     0,   244,   245,   246,     0,     0,
       0,     0,     0,     0,     0,   247,   248,   249,     0,   250,
     251,   252,   253,     0,   255,   256,   257,   258,   259,     0,
     261,   262,     0,   263,   264,   265,   266,   267,   268,   269,
       0,     0,   819,   271,   272,   273,   274,     0,   275,   276,
     277,   278,   279,     0,     0,     0,   281,   282,   283,   284,
     285,   286,     0,   288,   289,   290,     0,   291,   292,   293,
     294,   295,   296,     0,     0,   298,   299,   300,     0,     0,
       0,     0,     0,     0,     0,   302,   303,   304,   305,   306,
     307,   308,   309,   310,     0,   311,     0,   312,   313,   314,
     315,   316,   317,   318,     0,   319,   320,   321,   322,     0,
       0,   323,   324,   325,   326,   327,     0,   328,   329,   330,
       0,   331,   332,   333,     0,   334,   335,   336,   337,   338,
     339,   340,   341,   342,   343,     0,   344,     0,   345,   346,
     347,   348,   349,     0,   350,     0,   351,     0,     0,     0,
     354,   355,   356,   357,     0,   358,   359,     0,   360,   361,
     362,     0,   363,   364,   365,   366,   367,     0,   369,   370,
     371,   372,     0,   373,   374,   375,   376,   377,   378,   379,
       0,   380,     0,   382,   383,   384,   385,   386,   387,   388,
       0,   389,     0,   390,     0,     0,   393,     0,   395,   396,
     397,   398,   399,     0,     0,   400,   401,     0,   403,     0,
       0,   405,   406,   407,     0,     0,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   822,   426,     0,   428,   429,   430,   431,
     432,   433,   434,   435,   436,   437,   438,     0,   439,   440,
       0,   442,     0,   443,   444,   445,   446,   447,   448,     0,
     449,   450,     0,     0,   451,   452,   453,     0,     0,   454,
     455,   456,     0,   458,     0,   460,   461,   462,   463,   464,
     465,   466,   467,   468,   469,   470,     0,     0,   471,   472,
     473,   474,   475,   476,   477,   478,     0,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,   490,   491,
     492,   493,     0,   494,   495,   496,   497,   498,   499,   500,
     501,   502,   503,   504,   505,   506,     0,   507,   508,     0,
     823,   511,   512,   513,   514,   515,   516,   517,   518,  2810,
     520,   521,   522,   523,   524,     0,   525,   526,   527,   528,
    2731,     0,   530,   531,   532,   533,   534,     0,   536,   537,
     538,   539,     0,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,   551,   552,   553,   554,     0,   555,
     556,     0,   557,     0,   559,   560,   561,   562,   563,     0,
     564,   826,   566,     0,     0,  2732,   568,   569,   570,   571,
       0,   572,   573,   574,   575,   576,   577,   578,   579,     0,
       0,   580,   581,   582,   583,   584,     0,     0,   585,   586,
     587,   588,   589,   590,   591,     0,   592,     0,   594,   595,
     596,   597,     0,     0,   598,     0,     0,   599,   600,   601,
     602,   603,   828,   605,   606,   607,   608,   609,   610,   611,
     612,   613,   614,   615,   616,   617,   618,   626,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   236,   237,   238,   239,   240,   241,
     242,   243,     0,   244,   245,   246,     0,     0,     0,     0,
       0,     0,     0,   247,   248,   249,     0,   250,   251,   252,
     253,     0,   255,   256,   257,   258,   259,     0,   261,   262,
       0,   263,   264,   265,   266,   267,   268,   269,     0,     0,
     819,   271,   272,   273,   274,     0,   275,   276,   277,   278,
     279,     0,     0,     0,   281,   282,   283,   284,   285,   286,
       0,   288,   289,   290,     0,   291,   292,   293,   294,   295,
     296,     0,     0,   298,   299,   300,     0,     0,     0,     0,
       0,     0,     0,   302,   303,   304,   305,   306,   307,   308,
     309,   310,     0,   311,     0,   312,   313,   314,   315,   316,
     317,   318,     0,   319,   320,   321,   322,     0,     0,   323,
     324,   325,   326,   327,     0,   328,   329,   330,     0,   331,
     332,   333,     0,   334,   335,   336,   337,   338,   339,   340,
     341,   342,   343,     0,   344,     0,   345,   346,   347,   348,
     349,     0,   350,     0,   351,     0,     0,     0,   354,   355,
     356,   357,     0,   358,   359,     0,   360,   361,   362,     0,
     363,   364,   365,   366,   367,     0,   369,   370,   371,   372,
       0,   373,   374,   375,   376,   377,   378,   379,     0,   380,
       0,   382,   383,   384,   385,   386,   387,   388,     0,   389,
       0,   390,     0,     0,   393,     0,   395,   396,   397,   398,
     399,     0,     0,   400,   401,     0,   403,     0,     0,   405,
     406,   407,     0,     0,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   822,   426,     0,   428,   429,   430,   431,   432,   433,
     434,   435,   436,   437,   438,     0,   439,   440,     0,   442,
       0,   443,   444,   445,   446,   447,   448,     0,   449,   450,
       0,     0,   451,   452,   453,     0,     0,   454,   455,   456,
       0,   458,     0,   460,   461,   462,   463,   464,   465,   466,
     467,   468,   469,   470,     0,     0,   471,   472,   473,   474,
     475,   476,   477,   478,     0,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   490,   491,   492,   493,
       0,   494,   495,   496,   497,   498,   499,   500,   501,   502,
     503,   504,   505,   506,     0,   507,   508,     0,   823,   511,
     512,   513,   514,   515,   516,   517,   518,  2834,   520,   521,
     522,   523,   524,     0,   525,   526,   527,   528,  2731,     0,
     530,   531,   532,   533,   534,     0,   536,   537,   538,   539,
       0,   540,   541,   542,   543,   544,   545,   546,   547,   548,
     549,   550,   551,   552,   553,   554,     0,   555,   556,     0,
     557,     0,   559,   560,   561,   562,   563,     0,   564,   826,
     566,     0,     0,  2732,   568,   569,   570,   571,     0,   572,
     573,   574,   575,   576,   577,   578,   579,     0,     0,   580,
     581,   582,   583,   584,     0,     0,   585,   586,   587,   588,
     589,   590,   591,     0,   592,     0,   594,   595,   596,   597,
       0,     0,   598,     0,     0,   599,   600,   601,   602,   603,
     828,   605,   606,   607,   608,   609,   610,   611,   612,   613,
     614,   615,   616,   617,   618,   626,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   236,   237,   238,   239,   240,   241,   242,   243,
       0,   244,   245,   246,     0,     0,     0,     0,     0,     0,
       0,   247,   248,   249,     0,   250,   251,   252,   253,     0,
     255,   256,   257,   258,   259,     0,   261,   262,     0,   263,
     264,   265,   266,   267,   268,   269,     0,     0,   270,   271,
     272,   273,   274,     0,   275,   276,   277,   278,   279,     0,
       0,     0,   281,   282,   283,   284,   285,   286,     0,   288,
     289,   290,     0,   291,   292,   293,   294,   295,   296,     0,
       0,   298,   299,   300,     0,     0,     0,     0,     0,     0,
       0,   302,   303,   304,   305,   306,   307,   308,   309,   310,
       0,   311,     0,   312,   313,   314,   315,   316,   317,   318,
       0,   319,   320,   321,   322,     0,     0,   323,   324,   325,
     326,   327,     0,   328,   329,   330,     0,   331,   332,   333,
       0,   334,   335,   336,   337,   338,   339,   340,   341,   342,
     343,     0,   344,     0,   345,   346,   347,   348,   349,     0,
     350,     0,   351,     0,     0,     0,   354,   355,   356,   357,
       0,   358,   359,     0,   360,   361,   362,     0,   363,   364,
     365,   366,  3027,     0,   369,   370,   371,   372,     0,   373,
     374,   375,   376,   377,   378,   379,     0,   380,     0,   382,
     383,   384,   385,   386,   387,   388,     0,   389,     0,   390,
       0,     0,   393,     0,   395,   396,   397,   398,   399,     0,
       0,   400,   401,     0,   403,     0,     0,   405,   406,   407,
       0,     0,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,     0,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438,     0,   439,   440,     0,   442,     0,   443,
     444,   445,   446,   447,   448,     0,   449,   450,     0,     0,
     451,   452,   453,     0,     0,   454,   455,   456,     0,   458,
       0,   460,   461,   462,   463,   464,   465,   466,   467,   468,
     469,   470,     0,     0,   471,   472,   473,   474,   475,   476,
     477,   478,     0,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,   492,   493,     0,   494,
     495,   496,   497,   498,   499,   500,   501,   502,   503,   504,
     505,   506,     0,   507,   508,     0,   510,   511,   512,   513,
     514,   515,   516,   517,   518,   519,   520,   521,   522,   523,
     524,     0,   525,   526,   527,   528,   529,     0,   530,   531,
     532,   533,   534,     0,   536,   537,   538,   539,     0,   540,
     541,   542,   543,   544,   545,   546,   547,   548,   549,   550,
     551,   552,   553,   554,     0,   555,   556,     0,   557,     0,
     559,   560,   561,   562,   563,     0,   564,   565,   566,     0,
       0,   567,   568,   569,   570,   571,     0,   572,   573,   574,
     575,   576,   577,   578,   579,     0,     0,   580,   581,   582,
     583,   584,     0,     0,   585,   586,   587,   588,   589,   590,
     591,     0,   592,     0,   594,   595,   596,   597,     0,     0,
     598,     0,     0,   599,   600,   601,   602,   603,   604,   605,
     606,   607,   608,   609,   610,   611,   612,   613,   614,   615,
     616,   617,   618,   626,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     236,   237,   238,   239,   240,   241,   242,   243,     0,   244,
     245,   246,     0,     0,     0,     0,     0,     0,     0,   247,
     248,   249,     0,   250,   251,   252,   253,     0,   255,   256,
     257,   258,   259,     0,   261,   262,     0,   263,   264,   265,
     266,   267,   268,   269,     0,     0,   270,   271,   272,   273,
     274,     0,   275,   276,   277,   278,   279,     0,     0,     0,
     281,   282,   283,   284,   285,   286,     0,   288,   289,   290,
       0,   291,   292,   293,   294,   295,   296,     0,     0,   298,
     299,   300,     0,     0,     0,     0,     0,     0,     0,   302,
     303,   304,   305,   306,   307,   308,   309,   310,     0,   311,
       0,   312,   313,   314,   315,   316,   317,   318,     0,   319,
     320,   321,   322,     0,     0,   323,   324,   325,   326,   327,
       0,   328,   329,   330,     0,   331,   332,   333,     0,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,     0,
     344,     0,   345,   346,   347,   348,   349,     0,   350,     0,
     351,     0,     0,     0,   354,   355,   356,   357,     0,   358,
     359,     0,   360,   361,   362,     0,   363,   364,   365,   366,
    3031,     0,   369,   370,   371,   372,     0,   373,   374,   375,
     376,   377,   378,   379,     0,   380,     0,   382,   383,   384,
     385,   386,   387,   388,     0,   389,     0,   390,     0,     0,
     393,     0,   395,   396,   397,   398,   399,     0,     0,   400,
     401,     0,   403,     0,     0,   405,   406,   407,     0,     0,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,     0,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
     438,     0,   439,   440,     0,   442,     0,   443,   444,   445,
     446,   447,   448,     0,   449,   450,     0,     0,   451,   452,
     453,     0,     0,   454,   455,   456,     0,   458,     0,   460,
     461,   462,   463,   464,   465,   466,   467,   468,   469,   470,
       0,     0,   471,   472,   473,   474,   475,   476,   477,   478,
       0,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,   490,   491,   492,   493,     0,   494,   495,   496,
     497,   498,   499,   500,   501,   502,   503,   504,   505,   506,
       0,   507,   508,     0,   510,   511,   512,   513,   514,   515,
     516,   517,   518,   519,   520,   521,   522,   523,   524,     0,
     525,   526,   527,   528,   529,     0,   530,   531,   532,   533,
     534,     0,   536,   537,   538,   539,     0,   540,   541,   542,
     543,   544,   545,   546,   547,   548,   549,   550,   551,   552,
     553,   554,     0,   555,   556,     0,   557,     0,   559,   560,
     561,   562,   563,     0,   564,   565,   566,     0,     0,   567,
     568,   569,   570,   571,     0,   572,   573,   574,   575,   576,
     577,   578,   579,     0,     0,   580,   581,   582,   583,   584,
       0,     0,   585,   586,   587,   588,   589,   590,   591,     0,
     592,     0,   594,   595,   596,   597,     0,     0,   598,     0,
       0,   599,   600,   601,   602,   603,   604,   605,   606,   607,
     608,   609,   610,   611,   612,   613,   614,   615,   616,   617,
     618,   626,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   236,   237,
     238,   239,   240,   241,   242,   243,     0,   244,   245,   246,
       0,     0,     0,     0,     0,     0,     0,   247,   248,   249,
       0,   250,   251,   252,   253,     0,   255,   256,   257,   258,
     259,     0,   261,   262,     0,   263,   264,   265,   266,   267,
     268,   269,     0,     0,   270,   271,   272,   273,   274,     0,
     275,   276,   277,   278,   279,     0,     0,     0,   281,   282,
     283,   284,   285,   286,     0,   288,   289,   290,     0,   291,
     292,   293,   294,   295,   296,     0,     0,   298,   299,   300,
       0,     0,     0,     0,     0,     0,     0,   302,   303,   304,
     305,   306,   307,   308,   309,   310,     0,   311,     0,   312,
     313,   314,   315,   316,   317,   318,     0,   319,   320,   321,
     322,     0,     0,   323,   324,   325,   326,   327,     0,   328,
     329,   330,     0,   331,   332,   333,     0,   334,   335,   336,
     337,   338,   339,   340,   341,   342,   343,     0,   344,     0,
     345,   346,   347,   348,   349,     0,   350,     0,   351,     0,
       0,     0,   354,   355,   356,   357,     0,   358,   359,     0,
     360,   361,   362,     0,   363,   364,   365,   366,  3089,     0,
     369,   370,   371,   372,     0,   373,   374,   375,   376,   377,
     378,   379,     0,   380,     0,   382,   383,   384,   385,   386,
     387,   388,     0,   389,     0,   390,     0,     0,   393,     0,
     395,   396,   397,   398,   399,     0,     0,   400,   401,     0,
     403,     0,     0,   405,   406,   407,     0,     0,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,     0,   428,   429,
     430,   431,   432,   433,   434,   435,   436,   437,   438,     0,
     439,   440,     0,   442,     0,   443,   444,   445,   446,   447,
     448,     0,   449,   450,     0,     0,   451,   452,   453,     0,
       0,   454,   455,   456,     0,   458,     0,   460,   461,   462,
     463,   464,   465,   466,   467,   468,   469,   470,     0,     0,
     471,   472,   473,   474,   475,   476,   477,   478,     0,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,   493,     0,   494,   495,   496,   497,   498,
     499,   500,   501,   502,   503,   504,   505,   506,     0,   507,
     508,     0,   510,   511,   512,   513,   514,   515,   516,   517,
     518,   519,   520,   521,   522,   523,   524,     0,   525,   526,
     527,   528,   529,     0,   530,   531,   532,   533,   534,     0,
     536,   537,   538,   539,     0,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,   552,   553,   554,
       0,   555,   556,     0,   557,     0,   559,   560,   561,   562,
     563,     0,   564,   565,   566,     0,     0,   567,   568,   569,
     570,   571,     0,   572,   573,   574,   575,   576,   577,   578,
     579,     0,     0,   580,   581,   582,   583,   584,     0,     0,
     585,   586,   587,   588,   589,   590,   591,     0,   592,     0,
     594,   595,   596,   597,     0,     0,   598,     0,     0,   599,
     600,   601,   602,   603,   604,   605,   606,   607,   608,   609,
     610,   611,   612,   613,   614,   615,   616,   617,   618,   626,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   236,   237,   238,   239,
     240,   241,   242,   243,     0,   244,   245,   246,     0,     0,
       0,     0,     0,     0,     0,   247,   248,   249,     0,   250,
     251,   252,   253,     0,   255,   256,   257,   258,   259,     0,
     261,   262,     0,   263,   264,   265,   266,   267,   268,   269,
       0,     0,   270,   271,   272,   273,   274,     0,   275,   276,
     277,   278,   279,     0,     0,     0,   281,   282,   283,   284,
     285,   286,     0,   288,   289,   290,     0,   291,   292,   293,
     294,   295,   296,     0,     0,   298,   299,   300,     0,     0,
       0,     0,     0,     0,     0,   302,   303,   304,   305,   306,
     307,   308,   309,   310,     0,   311,     0,   312,   313,   314,
     315,   316,   317,   318,     0,   319,   320,   321,   322,     0,
       0,   323,   324,   325,   326,   327,     0,   328,   329,   330,
       0,   331,   332,   333,     0,   334,   335,   336,   337,   338,
     339,   340,   341,   342,   343,     0,   344,     0,   345,   346,
     347,   348,   349,     0,   350,     0,   351,     0,     0,     0,
     354,   355,   356,   357,     0,   358,   359,     0,   360,   361,
     362,     0,   363,   364,   365,   366,  3453,     0,   369,   370,
     371,   372,     0,   373,   374,   375,   376,   377,   378,   379,
       0,   380,     0,   382,   383,   384,   385,   386,   387,   388,
       0,   389,     0,   390,     0,     0,   393,     0,   395,   396,
     397,   398,   399,     0,     0,   400,   401,     0,   403,     0,
       0,   405,   406,   407,     0,     0,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,     0,   428,   429,   430,   431,
     432,   433,   434,   435,   436,   437,   438,     0,   439,   440,
       0,   442,     0,   443,   444,   445,   446,   447,   448,     0,
     449,   450,     0,     0,   451,   452,   453,     0,     0,   454,
     455,   456,     0,   458,     0,   460,   461,   462,   463,   464,
     465,   466,   467,   468,   469,   470,     0,     0,   471,   472,
     473,   474,   475,   476,   477,   478,     0,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,   490,   491,
     492,   493,     0,   494,   495,   496,   497,   498,   499,   500,
     501,   502,   503,   504,   505,   506,     0,   507,   508,     0,
     510,   511,   512,   513,   514,   515,   516,   517,   518,   519,
     520,   521,   522,   523,   524,     0,   525,   526,   527,   528,
     529,     0,   530,   531,   532,   533,   534,     0,   536,   537,
     538,   539,     0,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,   551,   552,   553,   554,     0,   555,
     556,     0,   557,     0,   559,   560,   561,   562,   563,     0,
     564,   565,   566,     0,     0,   567,   568,   569,   570,   571,
       0,   572,   573,   574,   575,   576,   577,   578,   579,     0,
       0,   580,   581,   582,   583,   584,     0,     0,   585,   586,
     587,   588,   589,   590,   591,     0,   592,     0,   594,   595,
     596,   597,     0,     0,   598,     0,     0,   599,   600,   601,
     602,   603,   604,   605,   606,   607,   608,   609,   610,   611,
     612,   613,   614,   615,   616,   617,   618,   626,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   236,   237,   238,   239,   240,   241,
     242,   243,     0,   244,   245,   246,     0,     0,     0,     0,
       0,     0,     0,   247,   248,   249,     0,   250,   251,   252,
     253,     0,   255,   256,   257,   258,   259,     0,   261,   262,
       0,   263,   264,   265,   266,   267,   268,   269,     0,     0,
     819,   271,   272,   273,   274,     0,   275,   276,   277,   278,
     279,     0,     0,     0,   281,   282,   283,   284,   285,   286,
       0,   288,   289,   290,     0,   291,   292,   293,   294,   295,
     296,     0,     0,   298,   299,   300,     0,     0,     0,     0,
       0,     0,     0,   302,   303,   304,   305,   306,   307,   308,
     309,   310,     0,   311,     0,   312,   313,   314,   315,   316,
     317,   318,     0,   319,   320,   321,   322,     0,     0,   323,
     324,   325,   326,   327,     0,   328,   329,   330,     0,   331,
     332,   333,     0,   334,   335,   336,   337,   338,   339,   340,
     341,   342,   343,     0,   344,     0,   345,   346,   347,   348,
     349,     0,   350,     0,   351,     0,     0,     0,   354,   355,
     356,   357,     0,   358,   359,     0,   360,   361,   362,     0,
     363,   364,   365,   366,   367,     0,   369,   370,   371,   372,
       0,   373,   374,   375,   376,   377,   378,   379,     0,   380,
       0,   382,   383,   384,   385,   386,   387,   388,     0,   389,
       0,   390,     0,     0,   393,     0,   395,   396,   397,   398,
     399,     0,     0,   400,   401,     0,   403,     0,     0,   405,
     406,   407,     0,     0,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   822,   426,     0,   428,   429,   430,   431,   432,   433,
     434,   435,   436,   437,   438,     0,   439,   440,     0,   442,
       0,   443,   444,   445,   446,   447,   448,     0,   449,   450,
       0,     0,   451,   452,   453,     0,     0,   454,   455,   456,
       0,   458,     0,   460,   461,   462,   463,   464,   465,   466,
     467,   468,   469,   470,     0,     0,   471,   472,   473,   474,
     475,   476,   477,   478,     0,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   490,   491,   492,   493,
       0,   494,   495,   496,   497,   498,   499,   500,   501,   502,
     503,   504,   505,   506,     0,   507,   508,     0,   823,   511,
     512,   513,   514,   515,   516,   517,   518,   824,   520,   521,
     522,   523,   524,     0,   525,   526,   527,   528,  2731,     0,
     530,   531,   532,   533,   534,     0,   536,   537,   538,   539,
       0,   540,   541,   542,   543,   544,   545,   546,   547,   548,
     549,   550,   551,   552,   553,   554,     0,   555,   556,     0,
     557,     0,   559,   560,   561,   562,   563,     0,   564,   826,
     566,     0,     0,  2732,   568,   569,   570,   571,     0,   572,
     573,   574,   575,   576,   577,   578,   579,     0,     0,   580,
     581,   582,   583,   584,     0,     0,   585,   586,   587,   588,
     589,   590,   591,     0,   592,     0,   594,   595,   596,   597,
       0,     0,   598,     0,     0,   599,   600,   601,   602,   603,
     828,   605,   606,   607,   608,   609,   610,   611,   612,   613,
     614,   615,   616,   617,   618,   626,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   236,   237,   238,   239,   240,   241,   242,   243,
       0,   244,   245,   246,     0,     0,     0,     0,     0,     0,
       0,   247,   248,   249,     0,   250,   251,   252,   253,     0,
     255,   256,   257,   258,   259,     0,   261,   262,     0,   263,
     264,   265,   266,   267,   268,   269,     0,     0,   270,   271,
     272,   273,   274,     0,   275,   276,   277,   278,   279,     0,
       0,     0,   281,   282,   283,   284,   285,   286,     0,   288,
     289,   290,     0,   291,   292,   293,   294,   295,   296,     0,
       0,   298,   299,   300,     0,     0,     0,     0,     0,     0,
       0,   302,   303,   304,   305,   306,   307,   308,   309,   310,
       0,   311,     0,   312,   313,   314,   315,   316,   317,   318,
       0,   319,   320,   321,   322,     0,     0,   323,   324,   325,
     326,   327,     0,   328,   329,   330,     0,   331,   332,   333,
       0,   334,   335,   336,   337,   338,   339,   340,   341,   342,
     343,     0,   344,     0,   345,   346,   347,   348,   349,     0,
     350,     0,   351,     0,     0,     0,   354,   355,   356,   357,
       0,   358,   359,     0,   360,   361,   362,     0,   363,   364,
     365,   366,  3510,     0,   369,   370,   371,   372,     0,   373,
     374,   375,   376,   377,   378,   379,     0,   380,     0,   382,
     383,   384,   385,   386,   387,   388,     0,   389,     0,   390,
       0,     0,   393,     0,   395,   396,   397,   398,   399,     0,
       0,   400,   401,     0,   403,     0,     0,   405,   406,   407,
       0,     0,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,     0,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438,     0,   439,   440,     0,   442,     0,   443,
     444,   445,   446,   447,   448,     0,   449,   450,     0,     0,
     451,   452,   453,     0,     0,   454,   455,   456,     0,   458,
       0,   460,   461,   462,   463,   464,   465,   466,   467,   468,
     469,   470,     0,     0,   471,   472,   473,   474,   475,   476,
     477,   478,     0,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,   492,   493,     0,   494,
     495,   496,   497,   498,   499,   500,   501,   502,   503,   504,
     505,   506,     0,   507,   508,     0,   510,   511,   512,   513,
     514,   515,   516,   517,   518,   519,   520,   521,   522,   523,
     524,     0,   525,   526,   527,   528,   529,     0,   530,   531,
     532,   533,   534,     0,   536,   537,   538,   539,     0,   540,
     541,   542,   543,   544,   545,   546,   547,   548,   549,   550,
     551,   552,   553,   554,     0,   555,   556,     0,   557,     0,
     559,   560,   561,   562,   563,     0,   564,   565,   566,     0,
       0,   567,   568,   569,   570,   571,     0,   572,   573,   574,
     575,   576,   577,   578,   579,     0,     0,   580,   581,   582,
     583,   584,     0,     0,   585,   586,   587,   588,   589,   590,
     591,     0,   592,     0,   594,   595,   596,   597,     0,     0,
     598,     0,     0,   599,   600,   601,   602,   603,   604,   605,
     606,   607,   608,   609,   610,   611,   612,   613,   614,   615,
     616,   617,   618,   626,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     236,   237,   238,   239,   240,   241,   242,   243,     0,   244,
     245,   246,     0,     0,     0,     0,     0,     0,     0,   247,
     248,   249,     0,   250,   251,   252,   253,     0,   255,   256,
     257,   258,   259,     0,   261,   262,     0,   263,   264,   265,
     266,   267,   268,   269,     0,     0,   270,   271,   272,   273,
     274,     0,   275,   276,   277,   278,   279,     0,     0,     0,
     281,   282,   283,   284,   285,   286,     0,   288,   289,   290,
       0,   291,   292,   293,   294,   295,   296,     0,     0,   298,
     299,   300,     0,     0,     0,     0,     0,     0,     0,   302,
     303,   304,   305,   306,   307,   308,   309,   310,     0,   311,
       0,   312,   313,   314,   315,   316,   317,   318,     0,   319,
     320,   321,   322,     0,     0,   323,   324,   325,   326,   327,
       0,   328,   329,   330,     0,   331,   332,   333,     0,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,     0,
     344,     0,   345,   346,   347,   348,   349,     0,   350,     0,
     351,     0,     0,     0,   354,   355,   356,   357,     0,   358,
     359,     0,   360,   361,   362,     0,   363,   364,   365,   366,
    3524,     0,   369,   370,   371,   372,     0,   373,   374,   375,
     376,   377,   378,   379,     0,   380,     0,   382,   383,   384,
     385,   386,   387,   388,     0,   389,     0,   390,     0,     0,
     393,     0,   395,   396,   397,   398,   399,     0,     0,   400,
     401,     0,   403,     0,     0,   405,   406,   407,     0,     0,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,     0,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
     438,     0,   439,   440,     0,   442,     0,   443,   444,   445,
     446,   447,   448,     0,   449,   450,     0,     0,   451,   452,
     453,     0,     0,   454,   455,   456,     0,   458,     0,   460,
     461,   462,   463,   464,   465,   466,   467,   468,   469,   470,
       0,     0,   471,   472,   473,   474,   475,   476,   477,   478,
       0,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,   490,   491,   492,   493,     0,   494,   495,   496,
     497,   498,   499,   500,   501,   502,   503,   504,   505,   506,
       0,   507,   508,     0,   510,   511,   512,   513,   514,   515,
     516,   517,   518,   519,   520,   521,   522,   523,   524,     0,
     525,   526,   527,   528,   529,     0,   530,   531,   532,   533,
     534,     0,   536,   537,   538,   539,     0,   540,   541,   542,
     543,   544,   545,   546,   547,   548,   549,   550,   551,   552,
     553,   554,     0,   555,   556,     0,   557,     0,   559,   560,
     561,   562,   563,     0,   564,   565,   566,     0,     0,   567,
     568,   569,   570,   571,     0,   572,   573,   574,   575,   576,
     577,   578,   579,     0,     0,   580,   581,   582,   583,   584,
       0,     0,   585,   586,   587,   588,   589,   590,   591,     0,
     592,     0,   594,   595,   596,   597,     0,     0,   598,     0,
       0,   599,   600,   601,   602,   603,   604,   605,   606,   607,
     608,   609,   610,   611,   612,   613,   614,   615,   616,   617,
     618,   626,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   236,   237,
     238,   239,   240,   241,   242,   243,     0,   244,   245,   246,
       0,     0,     0,     0,     0,     0,     0,   247,   248,   249,
       0,   250,   251,   252,   253,     0,   255,   256,   257,   258,
     259,     0,   261,   262,     0,   263,   264,   265,   266,   267,
     268,   269,     0,     0,   270,   271,   272,   273,   274,     0,
     275,   276,   277,   278,   279,     0,     0,     0,   281,   282,
     283,   284,   285,   286,     0,   288,   289,   290,     0,   291,
     292,   293,   294,   295,   296,     0,     0,   298,   299,   300,
       0,     0,     0,     0,     0,     0,     0,   302,   303,   304,
     305,   306,   307,   308,   309,   310,     0,   311,     0,   312,
     313,   314,   315,   316,   317,   318,     0,   319,   320,   321,
     322,     0,     0,   323,   324,   325,   326,   327,     0,   328,
     329,   330,     0,   331,   332,   333,     0,   334,   335,   336,
     337,   338,   339,   340,   341,   342,   343,     0,   344,     0,
     345,   346,   347,   348,   349,     0,   350,     0,   351,     0,
       0,     0,   354,   355,   356,   357,     0,   358,   359,     0,
     360,   361,   362,     0,   363,   364,   365,   366,  3526,     0,
     369,   370,   371,   372,     0,   373,   374,   375,   376,   377,
     378,   379,     0,   380,     0,   382,   383,   384,   385,   386,
     387,   388,     0,   389,     0,   390,     0,     0,   393,     0,
     395,   396,   397,   398,   399,     0,     0,   400,   401,     0,
     403,     0,     0,   405,   406,   407,     0,     0,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,     0,   428,   429,
     430,   431,   432,   433,   434,   435,   436,   437,   438,     0,
     439,   440,     0,   442,     0,   443,   444,   445,   446,   447,
     448,     0,   449,   450,     0,     0,   451,   452,   453,     0,
       0,   454,   455,   456,     0,   458,     0,   460,   461,   462,
     463,   464,   465,   466,   467,   468,   469,   470,     0,     0,
     471,   472,   473,   474,   475,   476,   477,   478,     0,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,   493,     0,   494,   495,   496,   497,   498,
     499,   500,   501,   502,   503,   504,   505,   506,     0,   507,
     508,     0,   510,   511,   512,   513,   514,   515,   516,   517,
     518,   519,   520,   521,   522,   523,   524,     0,   525,   526,
     527,   528,   529,     0,   530,   531,   532,   533,   534,     0,
     536,   537,   538,   539,     0,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,   552,   553,   554,
       0,   555,   556,     0,   557,     0,   559,   560,   561,   562,
     563,     0,   564,   565,   566,     0,     0,   567,   568,   569,
     570,   571,     0,   572,   573,   574,   575,   576,   577,   578,
     579,     0,     0,   580,   581,   582,   583,   584,     0,     0,
     585,   586,   587,   588,   589,   590,   591,     0,   592,     0,
     594,   595,   596,   597,     0,     0,   598,     0,     0,   599,
     600,   601,   602,   603,   604,   605,   606,   607,   608,   609,
     610,   611,   612,   613,   614,   615,   616,   617,   618,   626,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   236,   237,   238,   239,
     240,   241,   242,   243,     0,   244,   245,   246,     0,     0,
       0,     0,     0,     0,     0,   247,   248,   249,     0,   250,
     251,   252,   253,     0,   255,   256,   257,   258,   259,     0,
     261,   262,     0,   263,   264,   265,   266,   267,   268,   269,
       0,     0,   270,   271,   272,   273,   274,     0,   275,   276,
     277,   278,   279,     0,     0,     0,   281,   282,   283,   284,
     285,   286,     0,   288,   289,   290,     0,   291,   292,   293,
     294,   295,   296,     0,     0,   298,   299,   300,     0,     0,
       0,     0,     0,     0,     0,   302,   303,   304,   305,   306,
     307,   308,   309,   310,     0,   311,     0,   312,   313,   314,
     315,   316,   317,   318,     0,   319,   320,   321,   322,     0,
       0,   323,   324,   325,   326,   327,     0,   328,   329,   330,
       0,   331,   332,   333,     0,   334,   335,   336,   337,   338,
     339,   340,   341,   342,   343,     0,   344,     0,   345,   346,
     347,   348,   349,     0,   350,     0,   351,     0,     0,     0,
     354,   355,   356,   357,     0,   358,   359,     0,   360,   361,
     362,     0,   363,   364,   365,   366,  3674,     0,   369,   370,
     371,   372,     0,   373,   374,   375,   376,   377,   378,   379,
       0,   380,     0,   382,   383,   384,   385,   386,   387,   388,
       0,   389,     0,   390,     0,     0,   393,     0,   395,   396,
     397,   398,   399,     0,     0,   400,   401,     0,   403,     0,
       0,   405,   406,   407,     0,     0,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,     0,   428,   429,   430,   431,
     432,   433,   434,   435,   436,   437,   438,     0,   439,   440,
       0,   442,     0,   443,   444,   445,   446,   447,   448,     0,
     449,   450,     0,     0,   451,   452,   453,     0,     0,   454,
     455,   456,     0,   458,     0,   460,   461,   462,   463,   464,
     465,   466,   467,   468,   469,   470,     0,     0,   471,   472,
     473,   474,   475,   476,   477,   478,     0,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,   490,   491,
     492,   493,     0,   494,   495,   496,   497,   498,   499,   500,
     501,   502,   503,   504,   505,   506,     0,   507,   508,     0,
     510,   511,   512,   513,   514,   515,   516,   517,   518,   519,
     520,   521,   522,   523,   524,     0,   525,   526,   527,   528,
     529,     0,   530,   531,   532,   533,   534,     0,   536,   537,
     538,   539,     0,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,   551,   552,   553,   554,     0,   555,
     556,     0,   557,     0,   559,   560,   561,   562,   563,     0,
     564,   565,   566,     0,     0,   567,   568,   569,   570,   571,
       0,   572,   573,   574,   575,   576,   577,   578,   579,     0,
       0,   580,   581,   582,   583,   584,     0,     0,   585,   586,
     587,   588,   589,   590,   591,     0,   592,     0,   594,   595,
     596,   597,     0,     0,   598,     0,     0,   599,   600,   601,
     602,   603,   604,   605,   606,   607,   608,   609,   610,   611,
     612,   613,   614,   615,   616,   617,   618,   626,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   236,   237,   238,   239,   240,   241,
     242,   243,     0,   244,   245,   246,     0,     0,     0,     0,
       0,     0,     0,   247,   248,   249,     0,   250,   251,   252,
     253,     0,   255,   256,   257,   258,   259,     0,   261,   262,
       0,   263,   264,   265,   266,   267,   268,   269,     0,     0,
     270,   271,   272,   273,   274,     0,   275,   276,   277,   278,
     279,     0,     0,     0,   281,   282,   283,   284,   285,   286,
       0,   288,   289,   290,     0,   291,   292,   293,   294,   295,
     296,     0,     0,   298,   299,   300,     0,     0,     0,     0,
       0,     0,     0,   302,   303,   304,   305,   306,   307,   308,
     309,   310,     0,   311,     0,   312,   313,   314,   315,   316,
     317,   318,     0,   319,   320,   321,   322,     0,     0,   323,
    3714,   325,   326,   327,     0,   328,   329,   330,     0,   331,
     332,   333,     0,   334,   335,   336,   337,   338,   339,   340,
     341,   342,   343,     0,   344,     0,   345,   346,   347,   348,
     349,     0,   350,     0,   351,     0,     0,     0,   354,   355,
     356,   357,     0,   358,   359,     0,   360,   361,   362,     0,
     363,   364,   365,   366,   367,     0,   369,   370,   371,   372,
       0,   373,   374,   375,   376,   377,   378,   379,     0,   380,
       0,   382,   383,   384,   385,   386,   387,   388,     0,   389,
       0,   390,     0,     0,   393,     0,   395,   396,   397,   398,
     399,     0,     0,   400,   401,     0,   403,     0,     0,   405,
     406,   407,     0,     0,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,     0,   428,   429,   430,   431,   432,   433,
     434,   435,   436,   437,   438,     0,   439,   440,     0,   442,
       0,   443,   444,   445,   446,   447,   448,     0,   449,   450,
       0,     0,   451,   452,   453,     0,     0,   454,   455,   456,
       0,   458,     0,   460,   461,   462,   463,   464,   465,   466,
     467,   468,   469,   470,     0,     0,   471,   472,   473,   474,
     475,   476,   477,   478,     0,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   490,   491,   492,   493,
       0,   494,   495,   496,   497,   498,   499,   500,   501,   502,
     503,   504,   505,   506,     0,   507,   508,     0,   510,   511,
     512,   513,   514,   515,   516,   517,   518,   519,   520,   521,
     522,   523,   524,     0,   525,   526,   527,   528,   529,     0,
     530,   531,   532,   533,   534,     0,   536,   537,   538,   539,
       0,   540,   541,   542,   543,   544,   545,   546,   547,   548,
     549,   550,   551,   552,   553,   554,     0,   555,   556,     0,
     557,     0,   559,   560,   561,   562,   563,     0,   564,   565,
     566,     0,     0,   567,   568,   569,   570,   571,     0,   572,
     573,   574,   575,   576,   577,   578,   579,     0,     0,   580,
     581,   582,   583,   584,     0,     0,   585,   586,   587,   588,
     589,   590,   591,     0,   592,     0,   594,   595,   596,   597,
       0,     0,   598,     0,     0,   599,   600,   601,   602,   603,
     604,   605,   606,   607,   608,   609,   610,   611,   612,   613,
     614,   615,   616,   617,   618,   626,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   236,   237,   238,   239,   240,   241,   242,   243,
       0,   244,   245,   246,     0,     0,     0,     0,     0,     0,
       0,   247,   248,   249,     0,   250,   251,   252,   253,     0,
     255,   256,   257,   258,   259,     0,   261,   262,     0,   263,
     264,   265,   266,   267,   268,   269,     0,     0,   270,   271,
     272,   273,   274,     0,   275,   276,   277,   278,   279,     0,
       0,     0,   281,   282,   283,   284,   285,   286,     0,   288,
     289,   290,     0,   291,   292,   293,   294,   295,   296,     0,
       0,   298,   299,   300,     0,     0,     0,     0,     0,     0,
       0,   302,   303,   304,   305,   306,   307,   308,   309,   310,
       0,   311,     0,   312,   313,   314,   315,   316,   317,   318,
       0,   319,   320,   321,   322,     0,     0,   323,   324,   325,
     326,   327,     0,   328,   329,   330,     0,   331,   332,   333,
       0,   334,   335,   336,   337,   338,   339,   340,   341,   342,
     343,     0,   344,     0,   345,   346,   347,   348,   349,     0,
     350,     0,   351,     0,     0,     0,   354,   355,   356,   357,
       0,   358,   359,     0,   360,   361,   362,     0,   363,   364,
     365,   366,  4899,     0,   369,   370,   371,   372,     0,   373,
     374,   375,   376,   377,   378,   379,     0,   380,     0,   382,
     383,   384,   385,   386,   387,   388,     0,   389,     0,   390,
       0,     0,   393,     0,   395,   396,   397,   398,   399,     0,
       0,   400,   401,     0,   403,     0,     0,   405,   406,   407,
       0,     0,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,     0,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438,     0,   439,   440,     0,   442,     0,   443,
     444,   445,   446,   447,   448,     0,   449,   450,     0,     0,
     451,   452,   453,     0,     0,   454,   455,   456,     0,   458,
       0,   460,   461,   462,   463,   464,   465,   466,   467,   468,
     469,   470,     0,     0,   471,   472,   473,   474,   475,   476,
     477,   478,     0,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,   492,   493,     0,   494,
     495,   496,   497,   498,   499,   500,   501,   502,   503,   504,
     505,   506,     0,   507,   508,     0,   510,   511,   512,   513,
     514,   515,   516,   517,   518,   519,   520,   521,   522,   523,
     524,     0,   525,   526,   527,   528,   529,     0,   530,   531,
     532,   533,   534,     0,   536,   537,   538,   539,     0,   540,
     541,   542,   543,   544,   545,   546,   547,   548,   549,   550,
     551,   552,   553,   554,     0,   555,   556,     0,   557,     0,
     559,   560,   561,   562,   563,     0,   564,   565,   566,     0,
       0,   567,   568,   569,   570,   571,     0,   572,   573,   574,
     575,   576,   577,   578,   579,     0,     0,   580,   581,   582,
     583,   584,     0,     0,   585,   586,   587,   588,   589,   590,
     591,     0,   592,     0,   594,   595,   596,   597,     0,     0,
     598,     0,     0,   599,   600,   601,   602,   603,   604,   605,
     606,   607,   608,   609,   610,   611,   612,   613,   614,   615,
     616,   617,   618,   856,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     236,   237,   238,   239,   240,   241,   242,   243,     0,   244,
     245,   246,     0,     0,     0,     0,     0,     0,     0,   247,
     248,   249,     0,   250,   251,   252,   253,   254,   255,   256,
     257,     0,   857,   260,   858,   859,     0,   263,   264,   265,
     266,   267,   268,   269,     0,     0,   270,   271,   860,   861,
     274,     0,   275,   276,   277,   278,     0,     0,   280,     0,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
       0,   291,   292,   293,   294,   295,   296,     0,   297,   298,
     299,   300,     0,     0,     0,   301,     0,     0,     0,   302,
     303,   304,   305,   306,   307,   862,   863,   310,     0,   311,
       0,   312,   313,   314,   315,   316,   317,   318,     0,   319,
     320,   321,   322,     0,     0,   323,   324,   864,   326,   327,
       0,   328,   329,   330,     0,   331,   332,   333,     0,   334,
     335,   336,   337,     0,   339,   340,   341,   342,     0,     0,
     344,     0,   345,   346,   347,   865,   349,     0,   350,     0,
     351,   352,     0,   353,   354,   355,   356,   357,     0,   358,
       0,     0,     0,   361,   362,     0,   363,   364,   365,   366,
     367,   368,   369,   370,   371,   372,  2639,   373,   374,   375,
     376,   377,   378,   379,     0,   380,   381,  2640,   383,   384,
     385,   386,   866,   867,     0,   868,     0,   390,   391,   392,
     393,   394,   395,   396,   397,   398,   399,     0,     0,   400,
       0,   402,   403,   404,     0,   405,   406,   407,     0,     0,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   869,   427,
     870,   429,   430,   431,   432,   433,   434,   435,     0,     0,
     438,     0,   439,   440,   441,   442,     0,     0,   444,   871,
     446,   447,   448,     0,   449,   450,     0,     0,   451,   452,
     453,     0,     0,   454,   455,  2642,   457,   458,   459,     0,
     461,   462,   463,   464,   465,   466,   467,   468,   469,   470,
       0,     0,   471,   472,     0,   474,     0,   476,   477,   478,
       0,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   872,   490,   491,   492,   493,     0,   494,   495,   496,
     497,   498,   499,   500,   501,   502,   503,   504,   505,   506,
       0,   507,   508,   509,   510,   511,   512,   513,   514,     0,
     516,   517,   518,   519,   520,   521,   522,   523,   524,     0,
     525,   526,   527,   528,   529,     0,   530,   531,  2643,   533,
     534,   535,   536,   537,   874,   539,     0,   540,   541,   542,
     543,   544,   545,   546,   547,   548,   549,   550,   551,   552,
       0,   554,     0,   555,   556,     0,   557,   558,   559,   560,
     561,   562,   563,     0,   564,   875,   876,     0,     0,   567,
     568,     0,   570,     0,     0,   572,   573,   574,   575,   576,
     577,   578,   579,     0,     0,   580,   581,   582,   583,   584,
       0,     0,   585,   586,   587,   588,   589,     0,   877,  2644,
     592,   593,   594,   595,   596,   597,     0,     0,   598,     0,
       0,   599,   600,   601,   602,   603,   604,   626,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   616,   617,
     618,     0,     0,     0,   236,   237,   238,   239,   240,   241,
     242,   243,     0,   244,   245,   246,     0,     0,     0,     0,
       0,     0,     0,   247,   248,   249,     0,   250,   251,   252,
     253,     0,   255,   256,   257,   258,   259,     0,   261,   262,
       0,   263,   264,   265,   266,   267,   268,   269,     0,     0,
     270,   271,   272,   273,   274,     0,   275,   276,   277,   278,
     279,     0,     0,     0,   281,   282,   283,   284,   285,   286,
       0,   288,   289,   290,     0,   291,   292,   293,   294,   295,
     296,     0,     0,   298,   299,   300,     0,     0,     0,     0,
       0,     0,     0,   302,   303,   304,   305,   306,   307,   308,
     309,   310,     0,   311,     0,   312,   313,   314,   315,   316,
     317,   318,     0,   319,   320,   321,   322,     0,     0,   323,
     324,   325,   326,   327,     0,   328,   329,   330,     0,   331,
     332,   333,     0,   334,   335,   336,   337,   338,   339,   340,
     341,   342,   343,     0,   344,     0,   345,   346,   347,   348,
     349,     0,   350,     0,   351,     0,     0,     0,   354,   355,
     356,   357,     0,   358,   359,     0,   360,     0,   362,     0,
     363,   364,   365,   366,   367,     0,   369,   370,   371,   372,
       0,   373,   374,   375,   376,   377,   378,   379,     0,   380,
       0,   382,   383,   384,   385,   386,   387,   388,     0,   389,
       0,   390,     0,     0,   393,     0,   395,   396,   397,   398,
     399,     0,     0,   400,   401,     0,   403,     0,     0,   405,
     406,   407,     0,     0,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,     0,   428,   429,   430,   431,   432,   433,
     434,   435,   436,   437,   438,     0,   439,   440,     0,   442,
       0,   443,   444,   445,   446,   447,   448,     0,   449,   450,
       0,     0,   451,   452,   453,     0,     0,   454,   455,   456,
       0,   458,     0,   460,   461,   462,   463,   464,   465,   466,
     467,     0,   469,   470,     0,     0,   471,   472,   473,   474,
     475,   476,   477,   478,     0,   479,   480,   481,   482,   483,
     484,   485,   486,     0,   488,   489,   490,   491,   492,   493,
       0,   494,   495,   496,   497,   498,   499,   500,   501,   502,
     503,   504,   505,   506,     0,   507,   508,     0,   510,   511,
     512,   513,   514,   515,     0,   517,   518,   519,   520,   521,
     522,   523,   524,     0,   525,   526,   527,   528,   529,     0,
     530,   531,   532,   533,   534,     0,   536,   537,   538,   539,
       0,   540,   541,   542,   543,   544,   545,   546,   547,   548,
     549,   550,   551,   552,   553,   554,     0,   555,   556,     0,
     557,     0,   559,   560,   561,   562,   563,     0,   564,   565,
     566,     0,     0,   567,   568,   569,   570,   571,     0,   572,
     573,   574,   575,   576,   577,   578,   579,     0,     0,   580,
     581,   582,   583,   584,     0,     0,   585,   586,   587,   588,
     589,   590,   591,     0,   592,     0,   594,   595,   596,   597,
       0,     0,   598,     0,     0,   599,   600,   601,   602,   603,
     604,   605,   606,   607,   608,   609,   610,   611,   612,   613,
     614,   615,   616,   617,   618,   856,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   236,   237,   238,   239,   240,   241,   242,   243,
       0,   244,   245,   246,     0,     0,     0,     0,     0,     0,
       0,   247,   248,   249,     0,   250,   251,   252,   253,   254,
     255,   256,   257,     0,   857,   260,   858,   859,     0,   263,
     264,   265,   266,   267,   268,   269,     0,     0,   270,   271,
     860,   861,   274,     0,   275,   276,   277,   278,     0,     0,
     280,     0,   281,   282,   283,   284,   285,   286,   287,   288,
     289,   290,     0,   291,   292,   293,   294,   295,   296,     0,
     297,   298,   299,   300,     0,     0,     0,   301,     0,     0,
       0,   302,   303,   304,   305,   306,   307,   862,   863,   310,
       0,   311,     0,   312,   313,   314,   315,   316,   317,   318,
       0,   319,   320,   321,   322,     0,     0,   323,   324,   864,
     326,   327,     0,   328,   329,   330,     0,   331,   332,   333,
       0,   334,   335,   336,   337,     0,   339,   340,   341,   342,
       0,     0,   344,     0,   345,   346,   347,   865,   349,     0,
     350,     0,   351,   352,     0,   353,   354,   355,   356,   357,
       0,   358,     0,     0,     0,   361,   362,     0,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,     0,   373,
     374,   375,   376,   377,   378,   379,     0,   380,   381,     0,
     383,   384,   385,   386,   866,   867,     0,   868,     0,   390,
     391,   392,   393,   394,   395,   396,   397,   398,   399,     0,
       0,   400,     0,   402,   403,   404,     0,   405,   406,   407,
       0,     0,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     869,   427,   870,   429,   430,   431,   432,   433,   434,   435,
       0,     0,   438,     0,   439,   440,   441,   442,  2726,     0,
     444,   871,   446,   447,   448,     0,   449,   450,     0,     0,
     451,   452,   453,     0,     0,   454,   455,     0,   457,   458,
     459,     0,   461,   462,   463,   464,   465,   466,   467,   468,
     469,   470,     0,     0,   471,   472,     0,   474,     0,   476,
     477,   478,     0,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   872,   490,   491,   492,   493,     0,   494,
     495,   496,   497,   498,   499,   500,   501,   502,   503,   504,
     505,   506,     0,   507,   508,   509,   510,   511,   512,   513,
     514,     0,   516,   517,   518,   519,   520,   521,   522,   523,
     524,     0,   525,   526,   527,   528,   529,     0,   530,   531,
    2643,   533,   534,   535,   536,   537,   874,   539,     0,   540,
     541,   542,   543,   544,   545,   546,   547,   548,   549,   550,
     551,   552,     0,   554,     0,   555,   556,  4449,   557,   558,
     559,   560,   561,   562,   563,     0,   564,   875,   876,     0,
       0,   567,   568,     0,   570,     0,     0,   572,   573,   574,
     575,   576,   577,   578,   579,     0,     0,   580,   581,   582,
     583,   584,     0,     0,   585,   586,   587,   588,   589,     0,
     877,     0,   592,   593,   594,   595,   596,   597,     0,     0,
     598,     0,     0,   599,   600,   601,   602,   603,   604,   856,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     616,   617,   618,     0,     0,     0,   236,   237,   238,   239,
     240,   241,   242,   243,     0,   244,   245,   246,     0,     0,
       0,     0,     0,     0,     0,   247,   248,   249,     0,   250,
     251,   252,   253,   254,   255,   256,   257,     0,   857,   260,
     858,   859,     0,   263,   264,   265,   266,   267,   268,   269,
       0,     0,   270,   271,   860,   861,   274,     0,   275,   276,
     277,   278,     0,     0,   280,     0,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,     0,   291,   292,   293,
     294,   295,   296,     0,   297,   298,   299,   300,     0,     0,
       0,   301,     0,     0,     0,   302,   303,   304,   305,   306,
     307,   862,   863,   310,     0,   311,     0,   312,   313,   314,
     315,   316,   317,   318,     0,   319,   320,   321,   322,     0,
       0,   323,   324,   864,   326,   327,     0,   328,   329,   330,
       0,   331,   332,   333,     0,   334,   335,   336,   337,     0,
     339,   340,   341,   342,     0,     0,   344,     0,   345,   346,
     347,   865,   349,     0,   350,     0,   351,   352,     0,   353,
     354,   355,   356,   357,     0,   358,     0,     0,     0,   361,
     362,     0,   363,   364,   365,   366,   367,   368,   369,   370,
     371,   372,     0,   373,   374,   375,   376,   377,   378,   379,
       0,   380,   381,     0,   383,   384,   385,   386,   866,   867,
       0,   868,     0,   390,   391,   392,   393,   394,   395,   396,
     397,   398,   399,     0,     0,   400,     0,   402,   403,   404,
       0,   405,   406,   407,     0,     0,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   869,   427,   870,   429,   430,   431,
     432,   433,   434,   435,  2800,     0,   438,     0,   439,   440,
     441,   442,     0,     0,   444,   871,   446,   447,   448,     0,
     449,   450,     0,     0,   451,   452,   453,     0,     0,   454,
     455,     0,   457,   458,   459,     0,   461,   462,   463,   464,
     465,   466,   467,   468,   469,   470,     0,     0,   471,   472,
       0,   474,     0,   476,   477,   478,     0,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   872,   490,   491,
     492,   493,     0,   494,   495,   496,   497,   498,   499,   500,
     501,   502,   503,   504,   505,   506,     0,   507,   508,   509,
     510,   511,   512,   513,   514,     0,   516,   517,   518,   519,
     520,   521,   522,   523,   524,     0,   525,   526,   527,   528,
     529,     0,   530,   531,   873,   533,   534,   535,   536,   537,
     874,   539,     0,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,   551,   552,     0,   554,     0,   555,
     556,     0,   557,   558,   559,   560,   561,   562,   563,     0,
     564,   875,   876,     0,     0,   567,   568,     0,   570,     0,
       0,   572,   573,   574,   575,   576,   577,   578,   579,     0,
       0,   580,   581,   582,   583,   584,     0,     0,   585,   586,
     587,   588,   589,     0,   877,     0,   592,   593,   594,   595,
     596,   597,     0,     0,   598,     0,     0,   599,   600,   601,
     602,   603,   604,   856,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   616,   617,   618,     0,     0,     0,
     236,   237,   238,   239,   240,   241,   242,   243,     0,   244,
     245,   246,     0,     0,     0,     0,     0,     0,     0,   247,
     248,   249,     0,   250,   251,   252,   253,   254,   255,   256,
     257,     0,   857,   260,   858,   859,     0,   263,   264,   265,
     266,   267,   268,   269,     0,     0,   270,   271,   860,   861,
     274,     0,   275,   276,   277,   278,     0,     0,   280,     0,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
       0,   291,   292,   293,   294,   295,   296,     0,   297,   298,
     299,   300,     0,     0,     0,   301,     0,     0,     0,   302,
     303,   304,   305,   306,   307,   862,   863,   310,     0,   311,
       0,   312,   313,   314,   315,   316,   317,   318,     0,   319,
     320,   321,   322,     0,     0,   323,   324,   864,   326,   327,
       0,   328,   329,   330,     0,   331,   332,   333,     0,   334,
     335,   336,   337,     0,   339,   340,   341,   342,     0,     0,
     344,     0,   345,   346,   347,   865,   349,     0,   350,     0,
     351,   352,     0,   353,   354,   355,   356,   357,     0,   358,
       0,     0,     0,   361,   362,     0,   363,   364,   365,   366,
     367,   368,   369,   370,   371,   372,     0,   373,   374,   375,
     376,   377,   378,   379,     0,   380,   381,     0,   383,   384,
     385,   386,   866,   867,     0,   868,     0,   390,   391,   392,
     393,   394,   395,   396,   397,   398,   399,     0,     0,   400,
       0,   402,   403,   404,     0,   405,   406,   407,     0,     0,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   869,   427,
     870,   429,   430,   431,   432,   433,   434,   435,  4245,     0,
     438,     0,   439,   440,   441,   442,     0,     0,   444,   871,
     446,   447,   448,     0,   449,   450,     0,     0,   451,   452,
     453,     0,     0,   454,   455,     0,   457,   458,   459,     0,
     461,   462,   463,   464,   465,   466,   467,   468,   469,   470,
       0,     0,   471,   472,     0,   474,     0,   476,   477,   478,
       0,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   872,   490,   491,   492,   493,     0,   494,   495,   496,
     497,   498,   499,   500,   501,   502,   503,   504,   505,   506,
       0,   507,   508,   509,   510,   511,   512,   513,   514,     0,
     516,   517,   518,   519,   520,   521,   522,   523,   524,     0,
     525,   526,   527,   528,   529,     0,   530,   531,   873,   533,
     534,   535,   536,   537,   874,   539,     0,   540,   541,   542,
     543,   544,   545,   546,   547,   548,   549,   550,   551,   552,
       0,   554,     0,   555,   556,     0,   557,   558,   559,   560,
     561,   562,   563,     0,   564,   875,   876,     0,     0,   567,
     568,     0,   570,     0,     0,   572,   573,   574,   575,   576,
     577,   578,   579,     0,     0,   580,   581,   582,   583,   584,
       0,     0,   585,   586,   587,   588,   589,     0,   877,     0,
     592,   593,   594,   595,   596,   597,     0,     0,   598,     0,
       0,   599,   600,   601,   602,   603,   604,   856,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   616,   617,
     618,     0,     0,     0,   236,   237,   238,   239,   240,   241,
     242,   243,     0,   244,   245,   246,     0,     0,     0,     0,
       0,     0,     0,   247,   248,   249,     0,   250,   251,   252,
     253,   254,   255,   256,   257,     0,   857,   260,   858,   859,
       0,   263,   264,   265,   266,   267,   268,   269,     0,     0,
     270,   271,   860,   861,   274,     0,   275,   276,   277,   278,
       0,     0,   280,     0,   281,   282,   283,   284,   285,   286,
     287,   288,   289,   290,     0,   291,   292,   293,   294,   295,
     296,     0,   297,   298,   299,   300,     0,     0,     0,   301,
       0,     0,     0,   302,   303,   304,   305,   306,   307,   862,
     863,   310,     0,   311,     0,   312,   313,   314,   315,   316,
     317,   318,     0,   319,   320,   321,   322,     0,     0,   323,
     324,   864,   326,   327,     0,   328,   329,   330,     0,   331,
     332,   333,     0,   334,   335,   336,   337,     0,   339,   340,
     341,   342,     0,     0,   344,     0,   345,   346,   347,   865,
     349,  5717,   350,     0,   351,   352,     0,   353,   354,   355,
     356,   357,     0,   358,     0,     0,     0,   361,   362,     0,
     363,   364,   365,   366,   367,   368,   369,   370,   371,   372,
       0,   373,   374,   375,   376,   377,   378,   379,     0,   380,
     381,     0,   383,   384,   385,   386,   866,   867,     0,   868,
       0,   390,   391,   392,   393,   394,   395,   396,   397,   398,
     399,     0,     0,   400,     0,   402,   403,   404,     0,   405,
     406,   407,     0,     0,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   869,   427,   870,   429,   430,   431,   432,   433,
     434,   435,     0,     0,   438,     0,   439,   440,   441,   442,
       0,     0,   444,   871,   446,   447,   448,     0,   449,   450,
       0,     0,   451,   452,   453,     0,     0,   454,   455,     0,
     457,   458,   459,     0,   461,   462,   463,   464,   465,   466,
     467,   468,   469,   470,     0,     0,   471,   472,     0,   474,
       0,   476,   477,   478,     0,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   872,   490,   491,   492,   493,
       0,   494,   495,   496,   497,   498,   499,   500,   501,   502,
     503,   504,   505,   506,     0,   507,   508,   509,   510,   511,
     512,   513,   514,     0,   516,   517,   518,   519,   520,   521,
     522,   523,   524,     0,   525,   526,   527,   528,   529,     0,
     530,   531,   873,   533,   534,   535,   536,   537,   874,   539,
       0,   540,   541,   542,   543,   544,   545,   546,   547,   548,
     549,   550,   551,   552,     0,   554,     0,   555,   556,     0,
     557,   558,   559,   560,   561,   562,   563,     0,   564,   875,
     876,     0,     0,   567,   568,     0,   570,     0,     0,   572,
     573,   574,   575,   576,   577,   578,   579,     0,     0,   580,
     581,   582,   583,   584,     0,     0,   585,   586,   587,   588,
     589,     0,   877,     0,   592,   593,   594,   595,   596,   597,
       0,     0,   598,     0,     0,   599,   600,   601,   602,   603,
     604,   856,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   616,   617,   618,     0,     0,     0,   236,   237,
     238,   239,   240,   241,   242,   243,     0,   244,   245,   246,
       0,     0,     0,     0,     0,     0,     0,   247,   248,   249,
       0,   250,   251,   252,   253,   254,   255,   256,   257,     0,
     857,   260,   858,   859,     0,   263,   264,   265,   266,   267,
     268,   269,     0,     0,   270,   271,   860,   861,   274,     0,
     275,   276,   277,   278,     0,     0,   280,     0,   281,   282,
     283,   284,   285,   286,   287,   288,   289,   290,     0,   291,
     292,   293,   294,   295,   296,     0,   297,   298,   299,   300,
       0,     0,     0,   301,     0,     0,     0,   302,   303,   304,
     305,   306,   307,   862,   863,   310,     0,   311,     0,   312,
     313,   314,   315,   316,   317,   318,     0,   319,   320,   321,
     322,     0,     0,   323,   324,   864,   326,   327,     0,   328,
     329,   330,     0,   331,   332,   333,     0,   334,   335,   336,
     337,     0,   339,   340,   341,   342,     0,     0,   344,     0,
     345,   346,   347,   865,   349,     0,   350,     0,   351,   352,
       0,   353,   354,   355,   356,   357,     0,   358,     0,     0,
       0,   361,   362,     0,   363,   364,   365,   366,   367,   368,
     369,   370,   371,   372,     0,   373,   374,   375,   376,   377,
     378,   379,     0,   380,   381,     0,   383,   384,   385,   386,
     866,   867,     0,   868,     0,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,     0,     0,   400,     0,   402,
     403,   404,     0,   405,   406,   407,     0,     0,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   869,   427,   870,   429,
     430,   431,   432,   433,   434,   435,     0,     0,   438,     0,
     439,   440,   441,   442,     0,     0,   444,   871,   446,   447,
     448,     0,   449,   450,     0,     0,   451,   452,   453,     0,
       0,   454,   455,     0,   457,   458,   459,     0,   461,   462,
     463,   464,   465,   466,   467,   468,   469,   470,     0,     0,
     471,   472,     0,   474,     0,   476,   477,   478,     0,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   872,
     490,   491,   492,   493,     0,   494,   495,   496,   497,   498,
     499,   500,   501,   502,   503,   504,   505,   506,     0,   507,
     508,   509,   510,   511,   512,   513,   514,     0,   516,   517,
     518,   519,   520,   521,   522,   523,   524,     0,   525,   526,
     527,   528,   529,     0,   530,   531,   873,   533,   534,   535,
     536,   537,   874,   539,     0,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,   552,     0,   554,
       0,   555,   556,     0,   557,   558,   559,   560,   561,   562,
     563,     0,   564,   875,   876,     0,     0,   567,   568,     0,
     570,     0,     0,   572,   573,   574,   575,   576,   577,   578,
     579,     0,     0,   580,   581,   582,   583,   584,     0,     0,
     585,   586,   587,   588,   589,     0,   877,     0,   592,   593,
     594,   595,   596,   597,     0,     0,   598,     0,     0,   599,
     600,   601,   602,   603,   604,   856,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   616,   617,   618,     0,
       0,     0,   236,   237,   238,   239,   240,   241,   242,   243,
       0,   244,   245,   246,     0,     0,     0,     0,     0,     0,
       0,   247,   248,   249,     0,   250,   251,   252,   253,   254,
     255,   256,   257,     0,   857,   260,   858,   859,     0,   263,
     264,   265,   266,   267,   268,   269,     0,     0,   270,   271,
     860,   861,   274,     0,   275,   276,   277,   278,     0,     0,
     280,     0,   281,   282,   283,   284,   285,   286,   287,   288,
     289,   290,     0,   291,   292,   293,   294,   295,   296,     0,
     297,   298,   299,   300,     0,     0,     0,   301,     0,     0,
       0,   302,   303,   304,   305,   306,   307,   862,   863,   310,
       0,   311,     0,   312,   313,   314,   315,   316,   317,   318,
       0,   319,   320,   321,   322,     0,     0,   323,   324,   864,
     326,   327,     0,   328,   329,   330,     0,   331,   332,   333,
       0,   334,   335,   336,   337,     0,   339,   340,   341,   342,
       0,     0,   344,     0,   345,   346,   347,   865,   349,     0,
     350,     0,   351,   352,     0,   353,   354,   355,   356,   357,
       0,   358,     0,     0,     0,   361,   362,     0,   363,   364,
     365,   366,  1128,   368,   369,   370,   371,   372,     0,   373,
     374,   375,   376,   377,   378,   379,     0,   380,   381,     0,
     383,   384,   385,   386,   866,   867,     0,   868,     0,   390,
     391,   392,   393,   394,   395,   396,   397,   398,   399,     0,
       0,   400,     0,   402,   403,   404,     0,   405,   406,   407,
       0,     0,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     869,   427,   870,   429,   430,   431,   432,   433,   434,   435,
       0,     0,   438,     0,   439,   440,   441,   442,     0,     0,
     444,   871,   446,   447,   448,     0,   449,   450,     0,     0,
     451,   452,   453,     0,     0,   454,   455,     0,   457,   458,
     459,     0,   461,   462,   463,   464,   465,   466,   467,   468,
     469,   470,     0,     0,   471,   472,     0,   474,     0,   476,
     477,   478,     0,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   872,   490,   491,   492,   493,     0,   494,
     495,   496,   497,   498,   499,   500,   501,   502,   503,   504,
     505,   506,     0,   507,   508,   509,   510,   511,   512,   513,
     514,     0,   516,   517,   518,   519,   520,   521,   522,   523,
     524,     0,   525,   526,   527,   528,   529,     0,   530,   531,
     873,   533,   534,   535,   536,   537,   874,   539,     0,   540,
     541,   542,   543,   544,   545,   546,   547,   548,   549,   550,
     551,   552,     0,   554,     0,   555,   556,     0,   557,   558,
     559,   560,   561,   562,   563,     0,   564,   875,   876,     0,
       0,   567,   568,     0,   570,     0,     0,   572,   573,   574,
     575,   576,   577,   578,   579,     0,     0,   580,   581,   582,
     583,   584,     0,     0,   585,   586,   587,   588,   589,     0,
     877,     0,   592,   593,   594,   595,   596,   597,     0,     0,
     598,     0,     0,   599,   600,   601,   602,   603,   604,   856,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     616,   617,   618,     0,     0,     0,   236,   237,   238,   239,
     240,   241,   242,   243,     0,   244,   245,   246,     0,     0,
       0,     0,     0,     0,     0,   247,   248,   249,     0,   250,
     251,   252,   253,   254,   255,   256,   257,     0,   857,   260,
     858,   859,     0,   263,   264,   265,   266,   267,   268,   269,
       0,     0,   270,   271,   860,   861,   274,     0,   275,   276,
     277,   278,     0,     0,   280,     0,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,     0,   291,   292,   293,
     294,   295,   296,     0,   297,   298,   299,   300,     0,     0,
       0,   301,     0,     0,     0,   302,   303,   304,   305,   306,
     307,   862,   863,   310,     0,   311,     0,   312,   313,   314,
     315,   316,   317,   318,     0,   319,   320,   321,   322,     0,
       0,   323,   324,   864,   326,   327,     0,   328,   329,   330,
       0,   331,   332,   333,     0,   334,   335,   336,   337,     0,
     339,   340,   341,   342,     0,     0,   344,     0,   345,   346,
     347,   865,   349,     0,   350,     0,   351,   352,     0,   353,
     354,   355,   356,   357,     0,   358,     0,     0,     0,   361,
     362,     0,   363,   364,   365,   366,  1160,   368,   369,   370,
     371,   372,     0,   373,   374,   375,   376,   377,   378,   379,
       0,   380,   381,     0,   383,   384,   385,   386,   866,   867,
       0,   868,     0,   390,   391,   392,   393,   394,   395,   396,
     397,   398,   399,     0,     0,   400,     0,   402,   403,   404,
       0,   405,   406,   407,     0,     0,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   869,   427,   870,   429,   430,   431,
     432,   433,   434,   435,     0,     0,   438,     0,   439,   440,
     441,   442,     0,     0,   444,   871,   446,   447,   448,     0,
     449,   450,     0,     0,   451,   452,   453,     0,     0,   454,
     455,     0,   457,   458,   459,     0,   461,   462,   463,   464,
     465,   466,   467,   468,   469,   470,     0,     0,   471,   472,
       0,   474,     0,   476,   477,   478,     0,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   872,   490,   491,
     492,   493,     0,   494,   495,   496,   497,   498,   499,   500,
     501,   502,   503,   504,   505,   506,     0,   507,   508,   509,
     510,   511,   512,   513,   514,     0,   516,   517,   518,   519,
     520,   521,   522,   523,   524,     0,   525,   526,   527,   528,
     529,     0,   530,   531,   873,   533,   534,   535,   536,   537,
     874,   539,     0,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,   551,   552,     0,   554,     0,   555,
     556,     0,   557,   558,   559,   560,   561,   562,   563,     0,
     564,   875,   876,     0,     0,   567,   568,     0,   570,     0,
       0,   572,   573,   574,   575,   576,   577,   578,   579,     0,
       0,   580,   581,   582,   583,   584,     0,     0,   585,   586,
     587,   588,   589,     0,   877,     0,   592,   593,   594,   595,
     596,   597,     0,     0,   598,     0,     0,   599,   600,   601,
     602,   603,   604,   856,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   616,   617,   618,     0,     0,     0,
     236,   237,   238,   239,   240,   241,   242,   243,     0,   244,
     245,   246,     0,     0,     0,     0,     0,     0,     0,   247,
     248,   249,     0,   250,   251,   252,   253,   254,   255,   256,
     257,     0,   857,   260,   858,   859,     0,   263,   264,   265,
     266,   267,   268,   269,     0,     0,   270,   271,   860,   861,
     274,     0,   275,   276,   277,   278,     0,     0,   280,     0,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
       0,   291,   292,   293,   294,   295,   296,     0,   297,   298,
     299,   300,     0,     0,     0,   301,     0,     0,     0,   302,
     303,   304,   305,   306,   307,   862,   863,   310,     0,   311,
       0,   312,   313,   314,   315,   316,   317,   318,     0,   319,
     320,   321,   322,     0,     0,   323,   324,   864,   326,   327,
       0,   328,   329,   330,     0,   331,   332,   333,     0,   334,
     335,   336,   337,     0,   339,   340,   341,   342,     0,     0,
     344,     0,   345,   346,   347,   865,   349,     0,   350,     0,
     351,   352,     0,   353,   354,   355,   356,   357,     0,   358,
       0,     0,     0,   361,   362,     0,   363,   364,   365,   366,
     367,   368,   369,   370,   371,   372,     0,   373,   374,   375,
     376,   377,   378,   379,     0,   380,   381,     0,   383,   384,
     385,   386,   866,   867,     0,   868,     0,   390,   391,   392,
     393,   394,   395,   396,   397,   398,   399,     0,     0,   400,
       0,   402,   403,   404,     0,   405,   406,   407,     0,     0,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   869,   427,
     870,   429,   430,   431,   432,   433,   434,   435,     0,     0,
     438,     0,   439,   440,   441,   442,     0,     0,   444,   871,
     446,   447,   448,     0,   449,   450,     0,     0,   451,   452,
     453,     0,     0,   454,   455,     0,   457,   458,   459,     0,
     461,   462,   463,   464,   465,   466,   467,   468,   469,   470,
       0,     0,   471,   472,     0,   474,     0,   476,   477,   478,
       0,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   872,   490,   491,   492,   493,     0,   494,   495,   496,
     497,   498,   499,   500,   501,   502,   503,   504,   505,   506,
       0,   507,   508,   509,   510,   511,   512,   513,   514,     0,
     516,   517,   518,   519,   520,   521,   522,   523,   524,     0,
     525,   526,   527,   528,   529,     0,   530,   531,  2643,   533,
     534,   535,   536,   537,   874,   539,     0,   540,   541,   542,
     543,   544,   545,   546,   547,   548,   549,   550,   551,   552,
       0,   554,     0,   555,   556,     0,   557,   558,   559,   560,
     561,   562,   563,     0,   564,   875,   876,     0,     0,   567,
     568,     0,   570,     0,     0,   572,   573,   574,   575,   576,
     577,   578,   579,     0,     0,   580,   581,   582,   583,   584,
       0,     0,   585,   586,   587,   588,   589,     0,   877,     0,
     592,   593,   594,   595,   596,   597,     0,     0,   598,     0,
       0,   599,   600,   601,   602,   603,   604,   856,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   616,   617,
     618,     0,     0,     0,   236,   237,   238,   239,   240,   241,
     242,   243,     0,   244,   245,   246,     0,     0,     0,     0,
       0,     0,     0,   247,   248,   249,     0,   250,   251,   252,
     253,   254,   255,   256,   257,     0,   857,   260,   858,   859,
       0,   263,   264,   265,   266,   267,   268,   269,     0,     0,
     270,   271,   860,   861,   274,     0,   275,   276,   277,   278,
       0,     0,   280,     0,   281,   282,   283,   284,   285,   286,
     287,   288,   289,   290,     0,   291,   292,   293,   294,   295,
     296,     0,   297,   298,   299,   300,     0,     0,     0,   301,
       0,     0,     0,   302,   303,   304,   305,   306,   307,   862,
     863,   310,     0,   311,     0,   312,   313,   314,   315,   316,
     317,   318,     0,   319,   320,   321,   322,     0,     0,   323,
     324,   864,   326,   327,     0,   328,   329,   330,     0,   331,
     332,   333,     0,   334,   335,   336,   337,     0,   339,   340,
     341,   342,     0,     0,   344,     0,   345,   346,   347,   865,
     349,     0,   350,     0,   351,   352,     0,   353,   354,   355,
     356,   357,     0,   358,     0,     0,     0,   361,   362,     0,
     363,   364,   365,   366,   367,   368,   369,   370,   371,   372,
       0,   373,   374,   375,   376,   377,   378,   379,     0,   380,
     381,     0,   383,   384,   385,   386,   866,   867,     0,   868,
       0,   390,   391,   392,   393,   394,   395,   396,   397,   398,
     399,     0,     0,   400,     0,   402,   403,   404,     0,   405,
     406,   407,     0,     0,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   869,   427,   870,   429,   430,   431,   432,   433,
     434,   435,     0,     0,   438,     0,   439,   440,   441,   442,
       0,     0,   444,   871,   446,   447,   448,     0,   449,   450,
       0,     0,   451,   452,   453,     0,     0,   454,   455,     0,
     457,   458,   459,     0,   461,   462,   463,   464,   465,   466,
     467,   468,   469,   470,     0,     0,   471,   472,     0,   474,
       0,   476,   477,   478,     0,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   872,   490,   491,   492,   493,
       0,   494,   495,   496,   497,   498,   499,   500,   501,   502,
     503,   504,   505,   506,     0,   507,   508,   509,   510,   511,
     512,   513,   514,     0,   516,   517,   518,   519,   520,   521,
     522,   523,   524,     0,   525,   526,   527,   528,   529,     0,
     530,   531,     0,   533,   534,   535,   536,   537,   874,   539,
       0,   540,   541,   542,   543,   544,   545,   546,   547,   548,
     549,   550,   551,   552,     0,   554,     0,   555,   556,     0,
     557,   558,   559,   560,   561,   562,   563,     0,   564,   875,
     876,     0,     0,   567,   568,     0,   570,     0,     0,   572,
     573,   574,   575,   576,   577,   578,   579,     0,     0,   580,
     581,   582,   583,   584,     0,     0,   585,   586,   587,   588,
     589,     0,   877,     0,   592,   593,   594,   595,   596,   597,
       0,     0,   598,     0,     0,   599,   600,   601,   602,   603,
     604,   856,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   616,   617,   618,     0,     0,     0,   236,   237,
     238,   239,   240,   241,   242,   243,     0,   244,   245,   246,
       0,     0,     0,     0,     0,     0,     0,   247,   248,   249,
       0,   250,   251,   252,   253,   254,   255,   256,   257,     0,
       0,   260,     0,     0,     0,   263,   264,   265,   266,   267,
     268,   269,     0,     0,   270,   271,     0,     0,   274,     0,
     275,   276,   277,   278,     0,     0,   280,     0,   281,   282,
     283,   284,   285,   286,   287,   288,   289,   290,     0,   291,
     292,   293,   294,   295,   296,     0,   297,   298,   299,   300,
       0,     0,     0,   301,     0,     0,     0,   302,   303,   304,
     305,   306,   307,     0,     0,   310,     0,   311,     0,   312,
     313,   314,   315,   316,   317,   318,     0,   319,   320,   321,
     322,     0,     0,   323,   324,   325,   326,   327,     0,   328,
     329,   330,     0,   331,   332,   333,     0,   334,   335,   336,
     337,     0,   339,   340,   341,   342,     0,     0,   344,     0,
     345,   346,   347,     0,   349,     0,   350,     0,   351,   352,
       0,   353,   354,   355,   356,   357,     0,   358,     0,     0,
       0,   361,   362,     0,   363,   364,   365,   366,   367,   368,
     369,   370,   371,   372,     0,   373,   374,   375,   376,   377,
     378,   379,     0,   380,   381,     0,   383,   384,   385,   386,
       0,     0,     0,     0,     0,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,     0,     0,   400,     0,   402,
     403,   404,     0,   405,   406,   407,     0,     0,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,     0,   427,     0,   429,
     430,   431,   432,   433,   434,   435,     0,     0,   438,     0,
     439,   440,   441,   442,     0,     0,   444,     0,   446,   447,
     448,     0,   449,   450,     0,     0,   451,   452,   453,     0,
       0,   454,   455,     0,   457,   458,   459,     0,   461,   462,
     463,   464,   465,   466,   467,   468,   469,   470,     0,     0,
     471,   472,     0,   474,     0,   476,   477,   478,     0,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,     0,
     490,   491,   492,   493,     0,   494,   495,   496,   497,   498,
     499,   500,   501,   502,   503,   504,   505,   506,     0,   507,
     508,   509,   510,   511,   512,   513,   514,     0,   516,   517,
     518,   519,   520,   521,   522,   523,   524,     0,   525,   526,
     527,   528,   529,     0,   530,   531,     0,   533,   534,   535,
     536,   537,     0,   539,     0,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,   552,     0,   554,
       0,   555,   556,     0,   557,   558,   559,   560,   561,   562,
     563,     0,   564,     0,     0,     0,     0,   567,   568,     0,
     570,     0,     0,   572,   573,   574,   575,   576,   577,   578,
     579,     0,     0,   580,   581,   582,   583,   584,     0,     0,
     585,   586,   587,   588,   589,     0,     0,     0,   592,   593,
     594,   595,   596,   597,     0,     0,   598,     0,     0,   599,
     600,   601,   602,   603,   604,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   616,   617,   618
};

static const yytype_int16 yycheck[] =
{
       6,     0,     0,  1016,     0,     0,     0,     0,     0,   727,
     212,     0,    57,  1024,     0,     0,   654,     0,     0,     0,
     820,     0,   212,     0,   988,    37,   207,     0,     0,    21,
       0,     0,   917,   190,   215,   817,    21,   218,  1494,   767,
     768,   769,    22,  1621,    46,   773,    52,  1005,    28,   911,
     873,   913,  2683,  1556,   955,   989,   891,   844,   686,  1140,
     198,  1465,  1540,  1090,  1533,  1014,  2625,   862,   863,   217,
    1018,  2626,  1237,   827,  3040,  3815,   871,  1201,  3302,   796,
    3304,   731,  1249,   231,  1540,  3126,   843,  1859,  2975,  1020,
     633,   876,  3393,  1989,   929,  1545,  3487,  2647,  2648,  4145,
      23,  3837,  1688,  3788,  4098,    45,  1064,  3594,     6,  4188,
    1068,  3804,  3149,  2894,    37,  1073,  1586,  1587,   635,  2872,
    1590,  3353,  3740,  1024,  3403,  1083,  2007,  2053,  3347,  1533,
    4141,  4621,  2987,   192,  1422,   732,  1523,     8,  1096,  3514,
    4437,   176,     2,   686,    15,  4420,  3002,   722,   954,  4425,
     192,  5081,  1655,  1656,  4223,   850,   988,  3540,  1930,  3542,
     709,  4637,  4937,  4639,  2505,   997,  4382,   707,  2509,  1127,
     710,    51,  3367,   979,   723,  1007,  1079,  4719,   984,    42,
    2612,  4929,  3401,   940,  2610,  3413,  5210,  2542,  3259,  4880,
     733,  1094,   198,  3802,  4686,   823,  1583,    36,  5258,  1649,
    4120,   207,   208,  5123,    43,   914,  2583,   938,  4424,   215,
     914,   217,   218,  1600,  1506,     0,    11,  3352,     0,  3354,
    2940,    46,  2942,  2943,  4563,   231,  1676,  2947,  2948,  2949,
    2983,  2951,  2952,  2953,  2589,  5486,    13,  4928,     0,     6,
     860,   861,    13,  5246,    53,    37,     6,  5167,   979,    11,
     870,   794,  5470,   984,     0,     0,    46,    77,     6,     6,
    5174,  5175,   118,    62,     0,    62,    28,     6,    15,    16,
      28,  1028,    93,    44,   118,    11,    15,    16,    62,     6,
     823,    24,    62,     6,    34,    79,   226,     6,    15,    16,
       6,     6,    28,    84,     6,     6,     6,     6,     6,   172,
      79,    62,    90,  1486,    79,   848,    77,     5,   140,     3,
       6,     5,     6,    11,   145,    90,   173,    11,   172,   172,
       6,    42,   111,     3,     0,     6,     5,   151,    11,    62,
    1058,  5731,    11,   286,   167,  4414,     6,    71,   172,   111,
      62,   216,  5199,   292,   286,    21,  1587,   151,    79,  1590,
     307,   118,   783,    42,  4512,  4513,  4514,    15,  4516,  4517,
    4518,  4519,  4520,    62,   172,   908,   307,     6,  1838,  4438,
     281,   782,    75,   272,   287,   172,  5805,  5806,   120,   111,
     118,    57,  4924,  5828,   417,    62,  1103,   172,   319,   363,
     172,    79,   120,   251,    34,   138,   307,   359,   275,   377,
      87,   369,    90,    13,    24,   172,  2830,  1434,    79,   334,
     172,   196,  2029,   335,   196,   149,    13,  1366,  5669,  5997,
    1444,   342,   419,   457,   118,   451,   172,   172,   363,    38,
    1080,   460,   347,  1841,   196,   169,   172,   405,   118,  4721,
     500,   286,  5660,   130,    79,   505,  4728,  1378,    79,   169,
     196,   196,   654,  1861,   483,    90,   300,   392,   491,    90,
     196,   376,     6,  1364,    79,  5385,   463,    77,  1369,  1370,
     503,   505,  1267,  1268,  1422,   501,   505,    28,   220,   447,
    1175,  1024,  6060,    79,    35,  5488,  2910,  5207,   419,    52,
     172,   123,   460,  1288,    13,  1426,   417,   172,   329,  5247,
     125,    71,   704,    13,   652,   172,   383,    28,  1225,   367,
     658,    13,   152,  1298,    35,   483,   192,   179,   138,   128,
      90,   215,   670,   501,   446,    44,   347,   501,   453,   271,
      28,   179,   463,   501,    44,   267,   123,    35,   276,   501,
     439,  5970,    90,   237,   501,  5990,   499,   134,   276,   348,
     503,   120,   465,   502,   312,   379,   505,  5808,    77,   501,
     501,  1318,    10,   994,   348,    13,   363,    77,   348,    17,
      18,    19,   152,   189,   196,   379,  5433,   123,   210,   149,
      31,   284,   993,   417,  1181,   224,   320,   348,   330,  1346,
     501,   271,   417,  5069,   167,   276,   276,  1838,  1147,   169,
      10,   373,  6002,   447,  1535,  4223,   276,    17,    18,    19,
    1511,    50,   111,   371,  1242,   348,   405,   249,   305,    28,
    1521,   446,  1317,   417,   456,  3002,   348,   633,  1423,    87,
     505,  4249,   505,   376,   422,   491,  1256,  1257,   417,  1822,
     431,   639,   417,   639,   501,  5896,   652,   501,   501,   348,
     417,   409,   658,   411,   639,   452,   446,   501,  1616,  1208,
     639,  1619,   639,  1283,   670,  5668,   639,   417,   501,  1387,
     501,   348,   130,  1686,  1687,  1224,  5894,  1509,  5017,   499,
     686,   402,    22,   503,   505,   691,   417,  1590,   733,  1238,
     696,  5605,   501,  1627,   700,   701,   439,   505,  1393,  1242,
     434,   707,   737,   709,   710,   500,   505,  1608,  4393,   501,
    1611,  1612,  2004,   402,   123,    24,   722,   723,  5969,   504,
     497,   505,   504,   410,   491,   505,   497,   733,    22,   417,
     492,   493,  5480,  1361,   450,  1684,   503,  1640,  1641,  1571,
    4433,   501,   504,  1452,   505,  4665,   417,   732,  1452,  4434,
     320,   499,  5812,   501,   501,   503,   492,   493,   504,   504,
     917,  6012,   501,   505,  1459,  1571,   462,   747,   504,   749,
    4257,   751,   505,  4148,   501,  4262,   462,   757,   501,  1399,
    1400,   460,   501,   505,  1607,   501,   501,   483,   794,   501,
     501,   501,   501,   501,   492,   493,  5799,   483,   492,   493,
    1531,   210,   417,  5827,   483,   501,   505,   439,  1693,   492,
     493,   817,   818,   492,   493,   501,   441,   823,  1361,    22,
    4438,   417,    31,   505,  5744,    22,  1369,  1370,   505,   138,
     505,  4063,  4990,   491,  1958,   386,  1038,  5757,   505,   779,
     288,   499,   848,   505,   850,   503,   905,   305,  1038,   393,
     394,  1932,   439,  1584,  1035,  4074,  5576,   505,  1039,  4078,
    1041,  5581,  5582,   905,   434,   386,  3416,   873,  3418,   417,
    1601,  5363,  1820,  3914,   443,  4484,   456,  3948,   288,   118,
     172,  3634,  3635,   505,  1965,   501,  3639,   460,   386,   895,
     761,  1029,  5667,   439,   345,  5898,  1977,   494,   495,   496,
     497,  1802,   908,   243,   844,  4133,   405,    62,   907,   907,
     349,   907,   907,   907,   907,   907,  5664,   123,   907,   196,
    3775,   907,   907,   267,   907,   907,   907,  4062,   907,  4064,
     907,    51,   931,   111,   907,   907,  1839,   907,   907,    62,
    1578,  3373,  5484,   782,   783,   784,  3372,   322,    67,   243,
    5870,  4342,   410,   118,   151,  3489,  5647,   292,   821,    87,
     369,  3316,   825,   639,    29,  5968,   148,  3344,  4343,     6,
    3347,   851,  5663,   492,   493,   494,   495,   496,   497,   172,
    5371,   290,   922,   113,   494,   495,   496,   497,   184,  1506,
     492,   493,   494,   495,   496,   497,  5819,   937,  3718,    22,
       6,   174,   130,   196,   210,  2029,     3,   267,   173,     6,
    1016,  1017,  1018,   184,  2038,   172,  3393,   292,  1024,  3772,
      22,  5237,   164,  1029,  3401,  6049,   327,    41,  1034,  1035,
     439,   278,   214,  1039,  5809,  1041,    28,   346,   347,  1045,
     243,   489,   490,   491,   492,   493,   494,   495,   496,   497,
      22,    97,  5800,  5099,  4249,  1061,   732,   733,   188,   118,
      22,   300,   359,  3404,    90,   112,  5542,   376,   408,   363,
    5139,   191,   148,    28,    28,  2006,   196,   281,  4469,   489,
     490,   491,   492,   493,   494,   495,   496,   497,  5911,   200,
      82,   123,   118,    85,   123,   460,   267,   437,  1104,    91,
    1106,  1107,   123,   307,  4405,     6,   138,   272,  6038,    22,
     292,    22,   405,   233,   408,   288,   113,    22,   483,  2050,
     262,   251,   462,   167,   254,   417,   501,   119,  2076,  5904,
     369,  5819,   178,   696,   174,   479,   345,    36,     3,    22,
    1868,  1147,   439,   437,   267,   110,   211,   166,   267,   301,
     359,  5230,   361,   200,   993,   994,   287,  6087,   234,   722,
     363,   501,   359,   369,    10,   113,   405,    13,   462,  1175,
     505,    17,    18,    19,  1974,  1975,  5452,   305,   133,   133,
     194,   210,   379,   460,   176,   445,  4926,  5578,    34,   210,
    3740,   188,  5967,   348,   441,   287,  1181,   189,  6021,   491,
     501,  5498,  1208,  5478,  5979,   408,  5482,   501,   447,   201,
     287,   503,   271,   422,  4950,  3749,  1222,  1935,  1224,   118,
     243,   460,   395,  5911,    89,   348,  4919,   405,  4913,   905,
     505,   907,  1238,   439,   437,  5451,  1242,   367,  6013,   276,
     188,   243,  1785,  2647,   483,   271,  1964,   281,  1254,   445,
    1968,   433,  1112,   376,   251,  1973,   184,   254,  1976,   462,
     417,   381,   501,   376,   300,  5481,  2716,   460,  6043,  2747,
     276,   243,  1317,   307,   445,   361,   441,   417,   143,  1285,
    3830,   243,   410,   248,   324,   317,   177,   252,   247,  4145,
    2047,   188,  6067,  2581,   405,   173,   315,   501,   501,   223,
     344,    32,    33,   251,   363,  4680,   254,  1313,  1314,  1315,
    2005,  1317,  2007,  1184,    97,  1186,   363,  1188,  2013,  1190,
    1895,  1192,  1193,  1194,  2019,  2020,  2021,   122,  1199,   460,
     243,  1337,   243,  6021,   117,  2030,   422,   202,   243,   267,
     363,  2036,   417,  2929,  2794,  1942,   237,  1382,   478,  2736,
    5361,  5841,  1927,  1902,   251,  1361,   419,   404,   405,  1899,
     243,   363,   290,  1369,  1370,   505,    97,  1916,   460,   152,
     367,   501,   218,   733,  1914,     0,  1578,  1917,  1437,  1438,
    1929,  1440,  3308,   460,  4663,   408,   117,  1393,  5467,  2027,
    4622,   363,   505,   292,   281,  1437,  1438,  5476,  1440,     3,
     392,   363,   363,   395,   425,     3,   408,  4626,    24,   501,
     439,   447,  4631,   120,   437,  4634,  1422,    24,   439,   367,
     307,   152,   217,    30,   181,   504,   287,  1967,   306,   101,
     505,  1971,  1972,  1439,   794,   437,   408,  1443,  1444,   462,
     167,  3019,   288,   334,   309,    10,   408,  5526,    13,    24,
     363,   178,   363,  1459,    10,    30,  4497,    13,   363,  1465,
     462,    17,    18,    19,   118,   437,  4507,   501,   120,   196,
     367,  1034,    97,   441,   133,   437,   135,    24,   501,    44,
     363,   478,  1045,   112,  4450,    89,    51,  2004,   848,   183,
     462,    89,   131,  2506,  4877,   408,   222,   408,  1061,   501,
     462,   155,   141,   408,   382,  1181,   175,   501,  5248,   181,
      27,    26,    77,   220,  1454,    24,  1456,   445,   409,  5565,
     411,  5139,   138,   148,   437,   408,   437,  1533,    86,   501,
     478,   138,   437,   501,    49,   189,   161,   134,   142,   501,
     501,   267,   167,  5236,   142,     0,   437,   172,   908,   462,
    4406,   462,   204,   178,   437,   338,   181,   462,   505,  5422,
     185,  5424,   453,   138,   271,  5428,  5429,   432,  1574,  3038,
    5649,   200,    63,    90,  1250,   440,  2600,  2508,   443,   462,
      71,   146,  3199,  3200,   637,  5579,   369,  3204,   501,   214,
     501,   138,   491,  1592,  1270,   267,   501,   354,  1597,   460,
     499,  1607,   501,   502,   503,   163,   505,   338,   354,   234,
     161,  4331,   271,   210,   501,   267,  4336,   271,   501,   271,
     133,   376,   405,   330,    34,   352,   191,  3244,  3245,   138,
    3034,   196,  4413,  2581,  3038,   329,   240,   376,   369,   184,
     196,  1317,   240,   489,   490,   491,   492,   493,   494,   495,
     496,   497,   376,   379,  4407,   267,   325,   174,   283,  1222,
    2671,   286,   218,   302,   447,  1671,   360,   292,   233,   174,
     376,  1670,   361,  4223,   405,  1674,   729,   460,   385,   122,
    1686,  1687,  1688,   234,    10,   120,   302,    13,   376,   358,
    5136,    17,    18,    19,   440,   302,   211,  4074,   302,  4249,
     483,  4078,   371,   342,   302,  1645,   451,   301,  1910,  1911,
     462,    37,   310,   439,   302,   453,   447,  5796,   501,  1900,
     451,  1911,   267,   288,   319,   350,   342,   302,   280,   460,
     342,   483,   288,   422,   363,   342,  5182,   406,  4369,    57,
     338,   369,   414,   344,   342,  5739,   237,  5487,   346,   164,
     505,  1889,   483,   290,   342,   302,   501,   302,   271,   812,
     376,  1437,  1438,  4619,  1440,   302,   505,   342,  4145,   376,
     501,   441,    39,   118,   217,   404,   405,   405,   376,  1785,
     405,   505,   376,   288,  5469,   220,    53,   322,   376,  5902,
    5903,  1797,    24,   302,   460,   342,   161,   342,    30,   505,
     422,   376,  1808,  5496,   408,   342,   410,   324,   433,   127,
     408,   226,   410,  5892,  1820,   150,   381,   505,  1824,   447,
    2643,   404,   167,  2623,   419,  2027,   302,  5690,   444,   376,
    2778,   501,   457,   342,   459,   460,   271,  1843,   359,   505,
      10,   366,   109,    13,   361,  1851,  5065,    17,    18,    19,
     500,   301,   161,  1859,   173,   505,  2804,   440,   167,   460,
     224,  5907,   460,   198,    34,  2560,   342,   376,   463,   234,
     391,  1877,   501,   501,   499,   161,  2840,   502,   503,   504,
    1886,   167,   483,  1889,  5275,  5964,  1892,   206,  4438,  1895,
    1896,   501,   218,  1899,  1900,   330,  1902,  1903,   301,   121,
     445,  6014,   221,   420,   505,   422,   138,   302,  1914,   426,
    1916,  1917,   231,   501,  2746,   452,   481,   359,   283,   361,
    1926,  1927,  5662,  1929,  1930,   234,   376,   492,   493,   494,
     495,   496,   497,   489,   490,   491,   492,   493,   494,   495,
     496,   497,   209,  2844,  5680,  4982,   346,   175,   234,    71,
      31,  2852,   167,   246,  2855,  2903,   167,  1942,     5,   250,
     491,  1967,   288,   292,    11,  1971,  1972,   501,  5661,   152,
     192,  6017,   503,   376,   283,   190,   376,    58,   271,   190,
     422,   376,  3063,   749,   750,   751,  1998,  2890,   754,   755,
     756,  1989,  4879,  1989,   208,   121,   118,   283,   764,  2005,
     267,  2007,   110,   217,  1989,   196,  2012,  2013,  2840,  3413,
    1989,  1574,  1989,  2019,  2020,  2021,  1989,   231,  2024,  3423,
    2026,  2969,  2028,  2029,  2030,  2031,  2032,  2033,  4405,  4406,
    2036,  4918,  2038,  2039,   353,  3504,  2042,   366,  2923,  2924,
    2925,  3619,   177,  4898,  1984,  5269,  2878,  4903,   218,  3930,
    2056,  2057,  2058,  2059,   176,    47,  5093,  1592,  5095,   172,
     168,  5801,  1597,  2820,   359,  3232,   192,  5450,  2074,   302,
    2076,   334,   460,  1944,  1997,  1946,   422,  1948,    70,  1950,
    2912,  1952,    71,   196,    92,  1956,   168,  2893,    77,   222,
    2818,   121,  2820,   152,   202,   483,    24,  3055,   365,  3871,
    3504,    90,   237,  3006,  3007,  3008,  3009,   370,  3011,   342,
     405,  3697,   247,   501,  4867,    90,  4869,  3703,   288,   310,
     202,  4841,  3592,  4843,  4844,  4845,  5501,   135,  2671,   118,
     358,   120,  5523,  3036,   267,  1670,   364,    53,   344,  1674,
     248,    13,   405,   371,   252,   366,   334,   120,   174,   271,
    2868,   342,  2870,   302,   276,   346,  2874,  5897,  4054,   302,
     247,    89,   192,   489,   490,   491,   492,   493,   494,   495,
     496,   497,    44,   310,  5475,  3199,  3200,   247,   406,   302,
    3204,   207,   370,    99,   302,   376,   369,   176,    94,   338,
     453,  3641,   460,   342,   167,  2744,   460,   330,   320,   342,
     428,   271,   177,   131,   409,    77,   411,  5431,   124,   346,
     138,  2217,  3113,   141,   336,   204,   302,   405,   247,   342,
    3244,  3245,   405,  5908,   342,   200,   142,   376,   346,  5085,
     146,   204,   200,   376,  1797,   460,  3686,   505,    37,   376,
    3407,   505,  4619,  5099,  5285,  1808,   379,   422,   261,  4626,
    5737,  2257,   168,   376,  4631,   171,   342,  4634,   376,   342,
      59,  1824,   237,   302,   447,   453,  1942,   417,   462,   460,
     186,   342,   285,   271,   409,  3223,   411,   460,   276,  5387,
     505,  3229,   271,   286,  5392,  5393,   330,   276,   291,   483,
     376,   441,   483,   376,   267,   409,   462,   411,   271,   343,
     483,  3029,   437,   342,  2310,   376,   439,   501,  3811,     5,
     369,   110,   434,  1989,  1877,    11,   291,   483,   501,   489,
     490,   491,   492,   493,   494,   495,   496,   497,   372,  1892,
     328,   320,  1895,  1896,   496,   501,   250,   376,  2988,   501,
    5564,   503,  3959,  3960,  3961,  3962,   405,   336,  3965,  3966,
    3967,  3968,  3969,  3970,  3971,  3972,  3973,  3974,   167,  2035,
     276,  6046,    10,  1926,  1927,    13,    26,  5742,  5743,    17,
      18,    19,   983,   190,   302,   460,     5,   176,     5,  1129,
    2040,   190,    11,  2043,    11,  1135,    34,    22,   447,    49,
      19,  1002,  3110,    28,  1005,  1145,   346,    86,   483,  1149,
     199,   460,  5258,  1153,    58,  1155,  4023,  4024,  3309,    38,
     338,  1161,   328,  6075,   342,  6077,  1182,  1167,  3303,  1185,
    1170,  1187,  1584,  1189,   483,  1191,   376,  3144,  3145,  1195,
     380,   499,   286,   501,   409,  6097,   411,   291,   652,  1601,
     502,   979,   501,   505,   658,   434,   984,   422,   376,   248,
     499,   453,   501,   252,   503,   383,   670,   499,   366,   434,
    5316,   503,   437,    68,    69,    98,   494,  5187,   267,   494,
     501,   499,   503,   501,   499,   503,   501,   224,   503,  2485,
    2486,  2487,  2488,  2489,  2490,  2491,  2492,  2493,  5863,  2495,
     496,   502,   501,  2056,   505,   501,   451,   503,  2504,    11,
    2506,   148,   301,   404,    10,  2707,  3201,    13,  2574,  2575,
    2576,    17,    18,    19,   161,   286,   502,  2707,  3213,   505,
     167,   263,   264,   265,   266,  2706,  4903,  2708,  2709,  3212,
     502,  3214,  3215,   505,    15,    16,   502,  5503,  2544,   505,
     173,   501,  2548,  3328,  3329,  2551,  2222,  2553,   347,   363,
    2556,  2543,  3306,  3248,  2560,   502,  3490,   502,   505,   502,
     505,   505,   505,   502,     3,  2703,   505,   214,    58,   502,
     218,   370,   505,   206,   501,  2581,   503,  2583,   501,  3414,
     502,  5956,  3516,   505,    32,    33,    25,   234,   221,  5139,
      10,   390,   453,    13,  2600,  2743,  3291,    47,   231,    10,
      37,  3358,    13,  2609,  2610,   480,    17,    18,    19,    86,
     502,   502,  5365,   505,   505,   502,   502,  4195,   505,   505,
    5373,  5374,    59,    34,    44,   502,   259,  3265,   505,  3424,
    2636,    51,   502,  5857,   220,   505,   283,  2643,   359,   360,
     288,  2647,  2648,  4415,   502,   292,   502,   505,  2654,   505,
      89,  2628,  2658,   286,   503,   502,  2662,    77,   505,  3491,
     460,  2673,   462,  2675,  3595,  2671,   502,   502,   502,   505,
     505,   505,   502,   110,   148,   505,  3800,   502,   289,   502,
     505,  2829,   505,  2689,   286,  2583,  2692,   161,  5065,   289,
    4193,  2671,  4195,   167,   409,   480,   411,  2703,  5735,  2705,
    2706,   167,  2708,  2709,   143,  2711,   286,  4185,  5085,  5565,
     502,  5261,   218,   505,   289,   502,   502,  2723,   505,   505,
     353,  4171,  5099,  3441,   502,   502,   146,   505,   505,  4133,
     502,   359,   360,   505,   148,  3567,    47,  2743,  2744,   148,
     214,   409,   502,   411,  4361,   505,  2752,   161,  3913,   460,
     480,   462,   161,   167,  3781,   494,   502,   196,   167,   505,
     234,  2909,   199,   202,   502,   220,  3309,   505,  2774,  2775,
     502,   191,  2778,   505,   502,  2715,   196,   505,   502,  4229,
     502,   505,   288,   505,   502,  3743,   433,   505,   460,   502,
     462,  3739,   505,  5348,  6018,   505,  2802,    98,  2804,   171,
     214,   502,  2808,   502,   505,   214,   505,   218,   441,   283,
    5666,   248,   450,   233,   502,   252,  2822,   505,   292,   502,
     234,   502,   505,  2829,   505,   234,  2832,   133,   502,   135,
     267,   505,  2838,   502,  3737,   501,   505,   272,   273,   501,
    3468,   489,   490,   491,   492,   493,   494,   495,   496,   497,
     502,   501,  2858,   505,  6078,   316,   502,   502,  2864,   505,
     505,   359,   360,  3591,   301,  2871,    36,  3595,   288,   283,
     309,   501,   173,  2549,   283,  2815,   502,   288,   292,  2885,
     502,  5258,   502,   292,   502,   505,   504,  2867,   502,  3438,
    3439,   505,  2898,   502,    58,   502,   505,  2903,   505,   502,
     172,   502,   505,  2909,   505,   206,   502,  2583,  5795,   505,
     347,   502,   216,   502,   505,   354,   505,   502,   216,   504,
     221,  2927,  2928,  2929,  4427,  3468,   503,  2933,   502,  3646,
     231,   505,   501,   370,   369,  3959,  3960,  3961,  3962,  5316,
     501,  3965,  3966,  3967,  3968,  3969,  3970,  3971,  3972,  3973,
    3974,  4118,  2628,   390,  2960,  2961,  5812,   502,   259,   433,
     505,   381,   502,  2969,   403,   505,  4422,   196,   502,  3993,
     405,   505,   464,   502,  4443,  3156,   505,  3158,  3159,   502,
     359,   360,   505,   489,   490,   491,   492,   493,   494,   495,
     496,   497,   501,   432,   502,    10,  3002,   505,    13,  4023,
    4024,   440,  5561,   502,   443,   502,   505,   502,   505,   342,
     505,   502,   447,   502,   505,  3153,   505,   153,   502,   433,
    3921,   505,  4146,  4147,   433,   460,  4150,   300,  3034,    44,
     502,   502,  3038,   505,   505,  3584,    51,   502,   501,  4443,
     505,  3769,  4066,   502,  3021,  5901,   505,  3995,   483,   503,
     502,  5907,   353,   505,   153,   502,   502,  3606,   505,   505,
     501,   481,    77,  3265,   502,   502,   501,   505,  4045,  3787,
    4047,  4002,   492,   493,   494,   495,   496,   497,   489,   490,
     491,   492,   493,   494,   495,   496,   497,  5106,  5107,   502,
     499,   286,   505,   502,   503,  4610,   369,  4612,  5475,  4048,
      10,   196,   502,    13,  3002,   505,   342,    17,    18,    19,
    3897,   502,   502,   502,   505,   505,   505,  3745,  3124,  3747,
     502,   502,   502,   505,   505,   505,   502,   502,   286,   505,
     505,   146,   405,    24,  3140,  4079,  3142,  4081,   133,    30,
     135,   502,  2705,  3149,   505,  5705,  5706,  3153,  2711,  3155,
    3156,   153,  3158,  3159,  3160,  1905,  3201,  4735,     0,    98,
    4091,  6017,  3168,  1913,   159,  3367,  3884,  3173,   502,   153,
    1454,   505,  1456,  5047,   447,  5049,   191,  5834,  5835,    55,
      56,   196,   196,  5814,    75,   153,   286,   460,  5565,  2752,
     167,   342,   153,  3199,  3200,  3201,   232,  4128,  3204,   120,
      42,  3829,  3745,  3248,  3747,   286,  3212,  3213,  3214,  3215,
     483,  3760,   501,  3762,   441,   280,   167,  3223,   233,   502,
      71,   271,  3228,  3229,    37,  3231,   271,  3233,   501,   464,
     501,   286,   271,    47,   173,    47,  4194,  4715,  3244,  3245,
     131,   271,  3248,   427,   271,    89,   302,   138,   453,   453,
     141,   422,   167,   323,   153,    97,   153,   501,   153,  3954,
     153,  3267,   464,  3269,   153,  3271,   153,   206,   263,   264,
     265,   266,   505,   288,  4222,   270,  4224,   168,   153,   153,
     153,   276,   221,   153,   153,  3291,  3829,   153,   167,  5666,
     153,   153,   231,  3988,  3296,  3297,  3298,   153,   153,   153,
    4248,   286,  3347,  3309,   405,   501,   148,    37,   218,   232,
      10,   202,   286,    13,   167,   167,   501,     6,     6,   161,
     259,   501,   501,   501,   167,   167,   501,   501,  4163,   501,
     172,     6,    37,   501,   501,  4130,   178,  4361,  3344,   181,
    4035,  3347,  4466,   185,    44,  3021,     6,   286,  4249,   501,
       6,    51,  3397,  3359,    59,   501,   501,   501,  3364,   501,
     501,   501,   501,  3912,   501,     6,   381,   501,   501,   501,
     278,   501,   214,  3379,   216,   501,   267,    77,   288,   501,
     271,  4339,   501,  4317,  6015,   501,  5003,  3393,   501,   501,
     281,   501,   234,   461,   298,  3401,   216,   505,  2961,   290,
     505,    37,   101,   232,    37,   110,    36,  3413,   501,   415,
    3416,   302,  3418,   499,   353,   415,   499,  3423,   417,   417,
     417,   501,   172,   417,   273,   167,   505,   167,   376,   424,
      67,   281,  3438,  3439,   417,  5812,   283,   417,  3444,   363,
     435,   283,  4327,   452,   286,   417,  3344,   417,   417,  3347,
     292,   342,   363,   417,   345,   346,   503,  1671,   363,  3465,
     234,   417,  3468,   346,    78,  3471,   481,   417,   491,    90,
     417,   363,   153,  3479,   368,   286,   229,   492,   493,   494,
     495,   496,   497,   417,   417,   376,   276,   126,   417,   408,
     307,   191,   286,   281,   199,  3393,   196,   440,  3504,    22,
     359,   417,   189,  3401,    27,   501,    90,   126,   350,   501,
     417,   302,   505,   196,   441,   153,   441,   417,   126,   417,
     369,   417,   112,   126,  5901,  3201,    58,   417,    58,   417,
    5907,   417,   417,   233,  3540,  3541,  3542,   417,  3740,   417,
    4564,   256,    65,   248,   290,  4949,   417,   252,   327,   417,
     417,   327,   417,   444,   327,    78,   405,   417,   307,  3565,
     402,    46,   267,   408,   307,    46,   502,   505,  3574,   417,
    3576,    94,  3248,   218,   506,   218,   417,  3140,  3584,   489,
     490,   491,   492,   493,   494,   495,   496,   497,   288,   112,
    4491,   433,  3155,   417,  3270,   417,   301,  3160,   447,   133,
    3606,   135,   417,   218,   286,   218,   218,   417,   417,   218,
    3286,   460,   218,   136,   218,   457,   218,   459,   460,   218,
     286,   417,   427,    37,   147,   159,   153,   286,   153,  1843,
     118,   271,   153,   156,   483,   441,   153,  1851,   153,   286,
    6017,    37,   347,   501,   452,  1859,   169,   240,   271,   271,
      37,   174,   501,   502,   271,   504,   167,   224,   365,   153,
     502,   501,   504,   505,  3670,   370,   501,   501,  3344,   153,
     441,  3347,   441,  5290,   153,   153,   417,   200,   275,   280,
     172,   381,   501,   256,   456,   390,  3692,   256,    13,  1903,
     415,  3697,   181,   417,   162,   480,   419,  3703,   505,   501,
     501,   505,  5319,   502,   502,   480,  3712,   189,   254,   189,
     499,   214,   367,   457,   379,   502,  1930,  3393,   502,   502,
     502,  3397,   222,   287,   247,  3401,    37,  4658,   505,   263,
     264,   265,   266,  3739,  3740,   505,   270,   271,   441,  3745,
     441,  3747,   276,   295,    58,   502,   452,   363,   441,   501,
     222,   222,  4575,   417,  3760,   417,  3762,   276,   276,   417,
     167,    47,   501,   276,  4888,   288,   286,  4485,  4486,  4487,
    4488,  4489,   286,   271,   385,   232,  3782,   232,   232,  4641,
     359,   481,   286,   250,   408,   417,  5242,   126,   505,   286,
     286,  2541,   492,   493,   494,   495,   496,   497,   342,   406,
     323,   324,  3808,   505,   327,   376,   460,   190,   373,   286,
     502,    37,   417,   218,   330,   441,   292,   417,   224,   326,
     491,   441,   153,  3829,  3830,  4726,   167,    37,   281,   406,
     373,   354,   169,   501,   357,   453,   327,  3814,  4387,  4388,
     363,   153,   281,   153,   501,   153,  3852,   370,   271,   441,
     373,    37,   271,   286,    26,   286,   224,   281,   187,   187,
     167,    37,   460,   168,   224,  3871,  4561,  5370,   373,   392,
     167,  4653,   271,  3850,  4031,   286,   399,   196,  3818,   196,
     196,   196,   405,   196,  3890,   408,   464,    25,   179,   412,
     424,  4849,   172,   417,   253,   505,   286,   420,   460,    58,
     280,   435,   172,   298,   427,   133,  3912,   503,  3471,  3915,
     505,   505,   501,   172,   505,   502,  3479,   505,   270,   502,
     502,   502,   502,   308,   480,   501,  3932,   502,   297,  3935,
     453,   505,   502,   505,   502,  3941,   502,   172,   247,   502,
     181,   502,   502,  3949,   502,  3951,   501,   417,  3954,   502,
     501,   501,  3958,  3959,  3960,  3961,  3962,  3897,   500,  3965,
    3966,  3967,  3968,  3969,  3970,  3971,  3972,  3973,  3974,   500,
       0,   483,  3978,  3979,  3980,   501,   505,  3983,   439,  5003,
     482,   242,  3988,   457,  4029,   447,   286,  3993,    58,  3995,
     491,  3997,   501,   501,   286,   289,   286,   200,   153,  4005,
     417,   417,  4008,   208,  4010,   417,  4644,   276,   501,   156,
     153,  3574,    85,  3576,  4020,   501,   417,  4023,  4024,   271,
       0,  4223,  4028,  4029,   368,   376,   501,   153,   153,  4035,
     368,  5055,   368,   232,   200,  4037,  4038,  4039,  4040,   156,
     286,   491,   417,   441,   156,   196,   234,  4249,   457,   309,
     438,   309,   156,   417,   417,   417,  4054,   392,  4054,   417,
    4066,   244,   244,   244,   417,   363,   126,    97,  4074,  4054,
     417,   417,  4078,   271,   417,  4054,   363,  4054,   363,   363,
     376,  4054,   153,   417,   417,   417,    46,   417,   218,   502,
    4808,  4809,   502,  4811,   417,    24,   417,   500,   502,   218,
    5504,    30,   184,   290,  4110,   502,     3,  3670,   502,   427,
     167,    47,   505,   111,   505,   167,    45,    97,   148,    37,
     502,  4127,   501,   167,   502,   153,   153,  4133,   417,   281,
     491,   161,   153,   184,   501,   441,   363,   167,  3814,  4145,
    4868,   363,   172,   363,   363,   363,    75,   289,   178,  3712,
     505,   181,   373,   441,   151,   185,   151,   218,   144,   218,
    4166,    13,   218,  4712,   218,   218,   298,   172,   148,   218,
     218,   218,   218,   499,  3850,   452,  4074,   270,   505,   457,
    4078,   161,   502,   505,   214,   221,   296,   167,   221,    58,
    5075,   407,   172,   293,   185,   446,   500,   414,   178,  5777,
     129,   181,   131,   502,   234,   185,   350,   502,   501,   138,
      88,  4217,   141,   427,   167,    37,  4222,  4223,  4224,   502,
     502,   502,   224,   502,   417,   208,   502,  5844,  5845,   501,
     501,    58,   441,   501,   214,   441,  4438,   408,   153,   168,
     368,   176,  4248,  4249,  5192,  3808,   392,  4145,   427,   417,
    4799,   156,   417,   283,   234,   417,   286,   363,   363,   417,
     417,   342,   292,   502,   502,   502,  5290,   501,   460,   363,
     501,    58,   408,   202,   447,   167,   286,    77,   153,   111,
     218,   218,   427,  4263,   218,   218,   203,   502,  4294,  3852,
     501,  4297,   222,   501,  4274,  5319,   417,   501,   286,    37,
     464,   502,  3052,   283,   307,   505,   286,  3057,   284,  3059,
       3,   286,   292,   427,   505,   505,   501,    43,   417,  3069,
     350,   501,  3072,   373,  3074,  3075,   111,  5408,  3078,  5410,
     178,   172,  3082,   502,  3084,   218,   172,  3087,   267,   502,
    5058,   502,   271,    58,   298,   458,   502,  4896,   502,   458,
     221,  5069,   281,  4029,   502,  4361,   505,   459,   281,   414,
     501,   290,   502,   427,   501,   172,   501,   491,   460,    77,
     350,   202,  3935,   302,   417,   405,   190,   190,  4054,    58,
     276,  4387,  4388,   276,   491,  4391,   408,   505,   417,   505,
      71,   417,  4398,   417,   153,  3958,   156,   417,  4074,  4405,
    4406,  3151,  4078,   433,   502,   501,   218,   125,  5419,  4415,
     174,   118,    37,   342,  5538,   196,   345,   346,   281,  5219,
    3983,   501,  2636,   373,  5309,   405,   441,   457,    37,   459,
     460,   271,  4438,   169,   373,   281,    58,  4443,  4444,  4445,
    2654,   460,  4644,    83,  2658,   408,   460,   376,  2662,  4455,
      37,  5575,   172,   433,  4431,   167,   286,   337,   205,   501,
     505,   289,  5100,   216,   501,   446,   172,   389,   502,   499,
     502,   366,   502,   503,   504,  2689,    37,   457,   307,   459,
     460,    80,    90,   501,   501,   134,   502,   286,   197,   336,
    4496,   502,   417,    37,   153,   153,   417,  5621,  5622,   167,
     501,   501,   501,    37,   276,   501,   245,  4405,  4406,  2723,
     441,   501,   501,  5151,   501,   444,  4522,   501,  5419,   499,
     502,  5545,   502,   503,   504,   153,   111,  4533,   373,  2743,
      37,   502,   290,   172,   387,   502,   427,   387,   167,    58,
     110,   505,   501,   501,   501,    37,   446,   456,   408,   505,
     501,   189,   501,   441,   167,  4561,   267,   408,  4564,   501,
       6,  2775,   286,   200,   160,   464,  4572,  4573,   360,  4575,
     502,   360,    71,  4579,  4580,   501,   289,     6,  4584,   134,
      71,   460,  4588,   460,   504,  4591,  4592,   139,  2802,   456,
    4596,  5140,   446,   164,  2808,   164,  4602,   505,  5546,   501,
     501,  5296,  5613,   445,    34,   376,   172,   408,  2822,  5327,
     246,   333,   276,  4619,   202,  2829,   286,   408,  2832,   286,
    4626,   373,    37,    37,  2838,  4631,   289,   501,  4634,  4635,
     197,   501,   289,   174,   174,  5330,  4642,   501,   152,    58,
     502,    58,  5337,   293,  2858,    37,  5770,  4653,   343,    58,
    2864,   413,   417,   502,   396,  4661,   123,  2871,   502,   439,
       6,   139,   501,  5611,   149,   359,  4678,  5631,   373,   276,
     413,  2885,    23,   359,    34,  4681,   501,   501,  4655,  4656,
      80,   272,   505,   417,  2898,   505,   376,   359,  5712,   172,
     501,   294,   272,  4699,  5412,  2909,   152,   118,   387,   387,
     505,   447,   446,   501,  3454,   460,  4712,   447,  5403,  5404,
     460,   174,   174,  5837,  5838,   501,   441,   446,   502,  1673,
    5268,  4619,   947,   907,  2986,  3309,  1370,  2878,  4626,  4405,
    2787,  4737,  3516,  4631,  4222,  4197,  4634,  2904,  5761,  2958,
    4720,  3731,  5195,  5611,  5878,  5242,  4195,  4385,  4754,  4858,
    4730,  5218,  3445,  4759,  5741,  4431,  3100,  5099,  5866,  5641,
    4766,  5640,  5781,  5901,  3449,  4406,  4903,  4432,  4417,   198,
    5585,  4375,  2972,  2972,  4217,  3525,  4782,  3527,   207,  3541,
    3779,  4897,  4788,  4401,  5225,  3823,   215,   989,  5980,   218,
    4468,  5516,  6090,  4799,  6072,  5209,  3739,  4440,  5793,  5153,
    1832,  5390,  5594,  5156,    18,    28,  3888,  1209,  5360,   635,
    5976,  4496,  2988,  1875,  4443,  2648,  3834,  3423,  1872,  1886,
    5844,  5845,    10,  5268,  4830,    13,  5504,  1992,  4391,    17,
      18,    19,  1910,   720,  3673,  1992,  2903,  4248,  3592,  5534,
    5819,  6021,  1490,  2934,   687,   838,    34,  4474,  4472,  2590,
    4856,  6040,  5580,  4125,    10,  1785,    44,    13,  5357,  5554,
    5734,  5556,  5405,    51,  4657,    41,  4872,  5878,    41,  3364,
    5722,  4877,  3379,  2600,  1347,  3347,  5419,  5558,  4063,  4080,
    1386,  5066,  3344,  5316,  4126,  5315,  3344,  1446,    44,    77,
    4896,  5716,  1449,  1447,  5999,    51,  5848,  4903,  5100,  5545,
    5294,  3997,  5559,  2501,  1403,  5560,  2031,  3270,  3169,  2933,
    3124,  3268,  2504,  2588,    -1,    -1,   895,    -1,    -1,  3669,
      -1,    77,    -1,    -1,    -1,  3675,    -1,    -1,  3142,    -1,
      -1,    -1,    -1,    -1,     6,  3149,    -1,  5139,  4915,  5577,
      -1,    -1,    -1,  4949,    -1,  4951,    -1,    -1,    -1,  5151,
    4626,    23,    -1,    25,    -1,  4631,    -1,    29,  4634,    -1,
      -1,  5151,    -1,    35,    36,    37,    -1,    39,    -1,  5150,
      42,    43,    -1,    45,    -1,    47,  4982,    -1,    -1,  4655,
    4656,    -1,    54,    55,    56,    -1,    -1,    -1,    -1,    -1,
     146,    -1,    -1,    -1,  5000,    -1,    -1,  5003,    -1,    -1,
    5006,  5007,  5008,   191,    -1,  4903,    -1,    -1,   196,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  5197,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  5031,  5032,    -1,    -1,  5035,
     218,   219,    -1,    -1,    10,   191,    -1,    13,    -1,    -1,
     196,    17,    18,    19,    -1,   233,  6059,    -1,    -1,  5055,
      -1,    -1,    -1,    -1,    -1,  5061,    -1,    -1,    -1,  5065,
      -1,    -1,    -1,    -1,    -1,  5071,  5072,    -1,    44,    -1,
    5613,    -1,    -1,    -1,    -1,    51,  6024,   233,    -1,  5085,
      -1,    -1,  5088,    -1,    -1,    -1,   274,  5093,    -1,  5095,
      -1,    -1,    -1,  5099,    -1,    -1,    -1,    -1,    -1,    -1,
     288,    77,    -1,   291,    -1,    -1,    -1,    -1,    -1,  3859,
      -1,  3861,    -1,  3863,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  6072,    -1,   198,   199,   200,    -1,
      -1,   203,   288,  5139,  5140,   207,  4699,   209,    -1,    -1,
     212,    -1,  6090,   215,  5150,    -1,   218,    -1,    -1,   221,
      -1,   223,    -1,    -1,   226,    -1,    -1,    -1,   230,    -1,
     232,    -1,    -1,    -1,    -1,    -1,    -1,  5065,    -1,    -1,
      -1,    -1,    -1,    -1,  4737,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  5192,  5085,  6073,    -1,
      -1,  5197,    -1,   381,    -1,    -1,  4759,    -1,    -1,    -1,
      -1,  5099,    -1,    -1,    -1,    -1,    -1,  5078,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   191,    -1,    -1,  5761,    -1,
     196,    -1,    -1,    -1,    -1,   381,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  5962,  5963,    -1,    -1,    -1,  4915,
      -1,    -1,    -1,    -1,    -1,    -1,  5223,    -1,    -1,    -1,
      -1,  3465,  5258,    -1,    -1,  5261,    -1,   233,    -1,    -1,
      -1,    -1,   691,    -1,  5959,    -1,    -1,  4830,    -1,  5268,
    5268,   700,  5268,  5268,  5268,  5268,  5268,  5254,   707,  5268,
      -1,   710,  5268,  5268,  5290,  5268,  5268,  5268,  5294,  5268,
    5296,  5268,  5337,   481,    -1,  5268,  5268,    -1,  5268,  5268,
      -1,   489,   490,   491,   492,   493,   494,   495,   496,   497,
    5316,    -1,   288,  5319,   502,    -1,    -1,  5257,    -1,    -1,
      -1,    -1,    -1,    -1,  5330,   481,    -1,    -1,    -1,    -1,
      -1,  5337,    -1,    -1,    -1,  5878,   492,   493,   494,   495,
     496,   497,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3565,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    5258,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    24,  6064,
      10,    -1,    -1,    13,    30,  5577,    -1,    -1,    -1,    -1,
      -1,  5387,    -1,    -1,    -1,    -1,  5392,  5393,  4951,  5065,
      -1,  5397,    -1,    10,    -1,    -1,    13,  5403,  5404,  5405,
      -1,    -1,    -1,    -1,    44,   381,    -1,    -1,    -1,    -1,
      -1,    51,    -1,  5419,    -1,    -1,    -1,    -1,  5316,    75,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    44,    -1,    -1,
      -1,    -1,    -1,  5439,    51,    -1,    -1,    77,    -1,    -1,
      -1,  5447,    -1,    -1,  5450,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      77,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5475,
      -1,    -1,    -1,    -1,    -1,   131,    -1,    -1,  3692,    -1,
      -1,    -1,   138,    -1,    -1,   141,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5504,  5505,
    5477,    -1,    -1,    -1,    -1,   481,   146,    -1,  5071,    -1,
      -1,    -1,   168,   489,   490,   491,   492,   493,   494,   495,
     496,   497,  5528,    -1,    -1,    -1,    -1,    -1,  5534,   146,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5545,
    5546,    -1,    -1,  5549,    -1,    -1,   202,  5223,  5554,    -1,
    5556,   191,  5558,    -1,    -1,    -1,   196,    -1,    -1,  5565,
      -1,    -1,   634,    -1,    -1,    -1,    -1,  5748,   640,    -1,
     642,    -1,   644,    -1,   191,   647,    -1,  5475,  5254,   196,
    5586,    -1,   654,    -1,    -1,  5562,    -1,   659,    -1,   661,
      -1,    -1,  5268,   233,    -1,   667,    -1,    -1,    -1,    -1,
    1029,    -1,    -1,    -1,    -1,  5611,  1035,  5613,    -1,    -1,
    1039,   267,  1041,    -1,    -1,   271,   233,    -1,    -1,   691,
      -1,    -1,    -1,    -1,    -1,   281,    -1,    -1,   700,    -1,
      -1,    -1,   704,    -1,   290,   707,    -1,    -1,   710,  5820,
    5821,    -1,    -1,    -1,    -1,    -1,   302,    -1,   288,    -1,
      -1,    -1,    -1,    -1,   726,    -1,    -1,  3871,    -1,    -1,
    5666,  5337,    -1,    -1,    -1,    -1,    -1,  5565,    -1,    -1,
      -1,   288,    -1,    -1,    -1,  1104,  3890,  1106,  1107,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   342,    -1,    -1,   345,
     346,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5704,  5705,
    5706,  3915,    -1,    -1,    -1,    -1,  5712,   779,    -1,    -1,
     782,   783,   784,    -1,    -1,    -1,  5722,    -1,    -1,    -1,
     376,    -1,    -1,    -1,    -1,   797,  5732,    -1,    -1,  5735,
    4480,    -1,    -1,  4483,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   381,  5748,    -1,    -1,   817,   818,    -1,   820,   821,
      -1,    -1,    -1,   825,    -1,  5761,    -1,    -1,    -1,  4509,
      -1,    -1,    -1,    -1,   381,    -1,    -1,   839,  5666,    -1,
      -1,    -1,   844,    -1,    -1,    -1,    -1,    -1,   850,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   444,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  5802,    -1,    -1,  5475,
      -1,  5477,    -1,    -1,    -1,    -1,  5812,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  5820,  5821,    -1,  5794,    -1,    -1,
    5826,  5819,  5828,   895,  5387,    -1,    -1,    -1,    -1,  5392,
    5393,    -1,    -1,    -1,  5819,    -1,    -1,   909,  5844,  5845,
    5819,   481,  5819,    -1,    -1,    -1,  5819,    -1,    -1,    -1,
     922,    -1,   492,   493,   494,   495,   496,   497,    -1,    -1,
      -1,    -1,    -1,    -1,   481,   937,  5911,    -1,    -1,    -1,
      -1,    -1,  5878,    -1,    -1,   492,   493,   494,   495,   496,
     497,    -1,    -1,    -1,   956,    -1,  5562,    -1,    -1,   961,
     962,    -1,    -1,    -1,    -1,  5901,    -1,    -1,    -1,  6080,
    6081,  5907,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  5911,  5812,    -1,    -1,    -1,    -1,  5925,
      -1,   993,   994,    -1,    -1,    -1,  5911,    -1,    -1,    -1,
      -1,    -1,  5911,    -1,  5911,    -1,    -1,    -1,  5911,  5945,
      -1,    -1,  5505,    -1,  1016,  1017,    -1,  4697,    -1,    -1,
      -1,    -1,  4166,  5959,    -1,    -1,    -1,  1029,    -1,  1031,
      -1,    -1,    -1,  1035,    -1,    -1,  1038,  1039,    -1,  1041,
      -1,    -1,    -1,    -1,  1046,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  5990,    -1,  5549,    -1,  4738,  4739,
      -1,  5997,    -1,    -1,    -1,    -1,    -1,    -1,  1070,    -1,
      -1,    -1,    -1,  5901,    -1,  1077,  1078,    -1,    -1,  5907,
      -1,  6017,    -1,    -1,    -1,    -1,    -1,    -1,  6024,    -1,
      -1,    -1,    -1,  6021,    -1,    -1,  1098,  1099,  1100,    -1,
    1102,    -1,  1104,    -1,  1106,  1107,  6021,    -1,    -1,    -1,
      -1,    -1,  6021,    -1,  6021,    -1,    -1,    -1,  6021,    -1,
      -1,    -1,    -1,  6059,  6060,    -1,    -1,    -1,  6064,    -1,
      -1,    -1,  6068,    -1,    -1,    -1,  6072,    -1,  1140,    -1,
    1142,  1143,    24,    -1,  6080,  6081,    -1,    -1,    30,    -1,
    4294,  4831,  4832,  4297,  6090,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    45,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  1175,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5794,  6017,
      -1,    -1,    -1,    75,    -1,    -1,    -1,    -1,    -1,  1201,
      -1,  1203,    -1,    -1,    -1,  1207,    -1,  1209,    -1,    10,
      -1,    -1,    13,  5819,    -1,    -1,    17,    18,    19,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  1228,    -1,    -1,    -1,
      -1,    -1,  1234,    34,    -1,  1237,    -1,    -1,  1240,    -1,
      -1,    -1,    -1,    44,    -1,    -1,    -1,   129,    -1,   131,
      51,    -1,  1254,    -1,  4398,    -1,   138,    -1,    -1,   141,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  4415,    -1,    -1,    -1,    -1,    77,    -1,    -1,    -1,
      -1,  4961,    -1,  1285,  4964,  4965,   168,    -1,    -1,    -1,
      10,    -1,    -1,    13,    -1,    -1,    -1,    17,    18,    19,
      -1,  4981,    -1,    -1,    -1,  5911,    -1,    -1,    -1,    -1,
      -1,  1313,  1314,  1315,    34,  1317,    -1,    -1,    -1,    -1,
     202,    -1,    -1,    37,    44,    -1,    -1,    -1,    -1,    -1,
      -1,    51,    -1,    -1,    -1,  1337,    -1,    -1,    -1,    -1,
      -1,    -1,    10,    -1,    -1,    13,    -1,    61,    -1,    17,
      18,    19,  4496,    -1,    -1,    -1,    -1,    77,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    34,    -1,    -1,    -1,
      -1,    -1,    -1,  1375,    -1,    -1,    44,    -1,    -1,    -1,
      -1,    -1,    96,    51,    -1,   267,    -1,    -1,    -1,   271,
     191,  1393,    -1,    -1,    -1,   196,    -1,    -1,    -1,   281,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   290,    77,
      -1,    -1,    -1,    -1,    -1,  6021,    -1,   218,   219,    -1,
     302,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   233,    -1,    -1,    -1,    -1,  1439,    -1,    -1,
      -1,  1443,  1444,   157,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  1454,  1455,  1456,  1457,    -1,  1459,    -1,    -1,
     342,    -1,    -1,   345,   346,    -1,    -1,    -1,    -1,    -1,
      -1,   191,    -1,   274,    -1,    -1,   196,    -1,    -1,   193,
      -1,  1483,    -1,    -1,    -1,    -1,    -1,   288,    -1,    -1,
     291,    -1,    -1,    -1,   376,    -1,    -1,    -1,   218,   219,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     224,    -1,    -1,   233,    -1,   229,  1518,    -1,    -1,    -1,
      -1,  1523,    -1,   191,  1526,    -1,    -1,  1886,   196,    -1,
    1889,    -1,    -1,    -1,    -1,    -1,    -1,  1539,  1540,    -1,
    1899,  1900,    -1,    -1,    -1,    -1,  1548,    -1,    -1,  1551,
     218,   219,    -1,    -1,   274,  1914,    -1,   271,  1917,    -1,
      -1,    -1,   444,    -1,    -1,   233,    -1,    -1,   288,    -1,
      -1,   291,    -1,    -1,    -1,    -1,  1578,    -1,  1580,    -1,
     381,  1583,    -1,    -1,  1586,  1587,    -1,    -1,  1590,   303,
      -1,    -1,    -1,    -1,    -1,    -1,   310,    -1,  1600,    -1,
      -1,  1603,    -1,    -1,  1606,    -1,   274,    -1,  1967,    -1,
    4754,    -1,  1971,  1972,    -1,    -1,    -1,    -1,    -1,    -1,
     288,    -1,  4766,   291,    -1,    -1,  1628,    -1,    -1,    -1,
      -1,    -1,   346,    -1,    -1,    -1,    -1,   351,    -1,    -1,
      -1,    -1,    -1,  1645,    -1,    -1,   360,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   368,  1657,  1658,  1659,  1660,  1661,
      -1,   381,   376,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  1675,   388,    -1,    -1,    -1,    -1,    -1,
     481,    -1,  5362,   397,  1686,  1687,  1688,   401,   489,   490,
     491,   492,   493,   494,   495,   496,   497,    -1,    -1,    -1,
      -1,   502,    -1,    -1,   505,    -1,   420,    -1,    -1,    -1,
      -1,    -1,    -1,   381,    -1,    -1,    -1,    -1,    -1,    10,
      -1,    -1,    13,    -1,    -1,    -1,    17,    18,    19,    -1,
      -1,    -1,    -1,    -1,  5414,    -1,    -1,    -1,    -1,    -1,
      -1,   455,    -1,    34,    -1,   459,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    44,    -1,    -1,    -1,    -1,    -1,    -1,
      51,   481,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   489,
     490,   491,   492,   493,   494,   495,   496,   497,    -1,    -1,
      -1,    -1,  1784,    -1,    -1,   505,    77,    -1,    -1,    -1,
      -1,    -1,    -1,  1795,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  1803,  1804,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   481,    -1,    -1,    -1,  1819,    -1,    -1,
      -1,   489,   490,   491,   492,   493,   494,   495,   496,   497,
      -1,    -1,    -1,    -1,    -1,  1837,  1838,   505,  4982,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  5527,    -1,    -1,
      -1,  1853,  1854,  1855,  1856,    -1,    -1,    -1,    -1,    -1,
    1862,    -1,    -1,    -1,    -1,    -1,    -1,  1869,    -1,    -1,
      -1,    24,    -1,    -1,    -1,    -1,    -1,    30,    -1,    -1,
      -1,    -1,    -1,    -1,  1886,    -1,    -1,  1889,    -1,    -1,
      -1,    -1,    45,    -1,    -1,    -1,    -1,  1899,  1900,    -1,
     191,    -1,    -1,    -1,    -1,   196,    -1,    -1,  1910,  1911,
      -1,    -1,  1914,    -1,    -1,  1917,    -1,    -1,    -1,    -1,
      -1,    -1,    75,    -1,    -1,    -1,    -1,   218,   219,    -1,
    1932,  1933,    -1,    -1,    -1,    -1,    -1,  1939,    -1,  1941,
      -1,    -1,   233,    -1,    -1,    -1,    -1,    -1,    -1,  5093,
      -1,  5095,    -1,    -1,    -1,    -1,  1958,    -1,    -1,    -1,
      -1,    -1,    -1,  1965,    -1,  1967,    -1,    -1,  1970,  1971,
    1972,    -1,  1974,  1975,    -1,  1977,    -1,    -1,   131,    -1,
      -1,    -1,  1984,   274,    -1,   138,    -1,    -1,   141,  1991,
      -1,    -1,    -1,    -1,    -1,  1997,  1998,   288,    -1,  2001,
     291,    -1,    -1,  2005,    -1,  2007,    -1,    -1,    -1,    -1,
    2012,  2013,    -1,     0,    -1,   168,    -1,  2019,  2020,  2021,
      -1,    -1,  2024,    -1,  2026,  2027,  2028,  2029,  2030,  2031,
    2032,  2033,    -1,    20,  2036,    -1,  2038,  2039,    -1,    -1,
    2042,    -1,    -1,    30,    -1,    32,    33,    -1,    -1,   202,
      -1,    -1,    -1,    -1,    -1,  2057,  2058,  2059,    -1,    -1,
      -1,    -1,    -1,    50,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  2074,    60,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    72,    -1,    74,    75,    -1,
     381,    -1,    10,    -1,    81,    13,    83,    -1,    -1,    17,
      18,    19,    -1,    -1,    -1,    -1,    -1,    -1,    95,    -1,
      97,    -1,  2114,    -1,   267,    -1,    34,    -1,   271,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    44,   114,   281,    -1,
     117,    -1,    -1,    51,    -1,    -1,    -1,   290,    61,    -1,
      -1,    -1,    -1,    -1,    -1,   132,    22,   134,    -1,   302,
      -1,   138,    28,    10,    -1,    -1,    13,   144,    -1,    77,
      17,    18,    19,    -1,    -1,   152,    -1,   154,    -1,    -1,
      -1,    -1,    -1,    96,   161,    -1,    -1,    34,    -1,    -1,
      -1,  5861,    -1,    -1,    -1,    -1,    -1,    44,    -1,   342,
     481,   178,   345,   346,    51,    -1,    -1,    -1,   489,   490,
     491,   492,   493,   494,   495,   496,   497,    -1,   195,    -1,
      -1,   502,    -1,    -1,    -1,  2217,    -1,    -1,    -1,    -1,
      77,    -1,    -1,   376,  2583,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   157,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    10,    -1,    -1,    13,    -1,   235,   236,
      17,    18,    19,    -1,   241,  2257,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    34,   255,    -1,
     193,    -1,    -1,   191,    -1,    -1,    -1,    44,   196,    -1,
      -1,    -1,    -1,    -1,    51,    -1,   273,    -1,    -1,    -1,
      -1,   444,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     218,   219,    -1,    -1,    -1,    -1,   229,    -1,  2310,    -1,
      77,    -1,    -1,    -1,    -1,   233,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   310,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   318,    -1,    -1,   191,    -1,    -1,    -1,    -1,   196,
      -1,    -1,    -1,    -1,  2703,   332,    -1,  2706,   271,  2708,
    2709,   338,   339,    -1,   341,    -1,   274,    -1,    -1,   346,
      -1,   218,   219,    -1,    -1,   352,    -1,    -1,   355,    -1,
     288,    -1,    -1,   291,    17,   362,   233,    -1,    -1,    -1,
     303,   368,   369,    26,    -1,    -1,    -1,   310,    37,   376,
      -1,    -1,    -1,   380,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   390,    -1,    -1,    -1,    -1,    -1,    -1,
      59,    -1,    -1,    -1,    -1,    -1,    -1,   274,   405,    -1,
      -1,    -1,    -1,   346,   191,   348,    -1,    -1,   351,   196,
      -1,   288,    -1,    -1,   291,    -1,    85,   360,   425,    -1,
      -1,    -1,    -1,    -1,    -1,   368,    -1,    -1,    -1,   436,
      -1,   218,   219,   376,    -1,   442,    -1,    -1,    -1,    -1,
     447,   110,   111,   381,    -1,   388,   233,    -1,    -1,   118,
      -1,    -1,    -1,   460,   397,    -1,    -1,    -1,   401,    -1,
      -1,    -1,    -1,  2485,  2486,  2487,  2488,  2489,  2490,  2491,
    2492,  2493,    -1,  2495,    -1,    -1,   483,    -1,    -1,    -1,
      -1,  2503,  2504,    -1,  2506,    -1,    -1,   274,    -1,    -1,
      -1,  2513,    -1,    -1,   501,    -1,    -1,   504,    -1,    -1,
      -1,   288,    -1,    -1,   381,    -1,    -1,   176,    -1,    -1,
      -1,    -1,   455,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    2542,    -1,  2544,    -1,    -1,  2547,  2548,    -1,    -1,  2551,
     199,  2553,    -1,    -1,  2556,    -1,    -1,    -1,  2560,    -1,
      -1,    -1,    -1,   481,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   489,   490,   491,   492,   493,   494,   495,   496,   497,
      -1,  2583,    -1,    -1,   502,    -1,    -1,  2589,  2590,    -1,
      -1,  5735,    -1,    -1,    -1,    -1,    -1,    -1,  2600,   248,
      -1,    -1,    -1,   252,    -1,    -1,    -1,  2609,  2610,    -1,
      -1,    -1,    -1,    -1,   381,    -1,    -1,    -1,   267,    -1,
      -1,  2623,   271,    -1,   481,    -1,    -1,    -1,    -1,  2631,
      -1,  2633,   489,   490,   491,   492,   493,   494,   495,   496,
     497,    10,    -1,  3002,    13,   502,    -1,    -1,    17,    18,
      19,    -1,   301,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    34,    -1,    -1,    -1,    -1,
      -1,  2673,    -1,  2675,    -1,    44,    -1,    -1,    -1,    -1,
      -1,    -1,    51,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    2692,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   347,    -1,
      -1,  2703,    -1,    -1,  2706,  2707,  2708,  2709,    77,    -1,
    2712,    -1,    -1,  2715,   481,    -1,    -1,    -1,    -1,    -1,
      -1,   370,   489,   490,   491,   492,   493,   494,   495,   496,
     497,    -1,    -1,    -1,  2736,    -1,    -1,    -1,    -1,    -1,
      -1,   390,    -1,   392,    -1,  2747,   395,    -1,    -1,    -1,
      -1,    -1,    -1,  2755,  2756,    -1,    -1,    -1,    -1,    -1,
    2762,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    10,  2771,
      -1,    13,    -1,    -1,    -1,    17,    18,    19,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2793,    34,    -1,  3153,    -1,    -1,  3156,    -1,  3158,
    3159,    -1,    44,    -1,    -1,    -1,    -1,    -1,    -1,    51,
      -1,    -1,    -1,  2815,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   191,    -1,    -1,  2827,    -1,   196,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    77,    -1,    -1,    -1,    24,
      -1,    -1,    -1,    -1,    -1,    30,    -1,    -1,  2850,   218,
     219,  2853,   501,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   233,    -1,    -1,    -1,    -1,    -1,
      -1,   747,    -1,   749,    -1,   751,    -1,  2879,  2880,    -1,
      -1,   757,   758,   759,    -1,    -1,    -1,    -1,    -1,    -1,
      75,    -1,  2894,    -1,  2896,  2897,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   274,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   288,
      -1,    -1,   291,    -1,    -1,  2927,  2928,  2929,    -1,    -1,
      -1,  2933,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2941,
      -1,    -1,    -1,    -1,    -1,    -1,   131,    -1,    -1,   191,
      -1,    -1,  2954,   138,   196,    -1,   141,    -1,  2960,    -1,
    2962,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2975,    -1,    -1,   218,   219,  2980,    -1,
      -1,    -1,    -1,   168,  2986,  3344,    -1,  2989,  3347,    -1,
      -1,   233,    -1,   636,    -1,    -1,    -1,    -1,    -1,  3001,
    3002,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3012,    -1,   381,    -1,    -1,    -1,    -1,   202,    -1,    -1,
    3022,    -1,  3024,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   274,    -1,  3393,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3401,   686,   687,    -1,   288,    -1,    -1,   291,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3063,    -1,  3065,    -1,  3067,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   955,
      -1,    -1,   267,    -1,    -1,    -1,   271,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   281,    -1,  3100,    -1,
      -1,    -1,    -1,    -1,    -1,   290,    -1,    -1,    -1,    -1,
      -1,    -1,   481,    -1,    -1,    -1,    -1,   302,    -1,    -1,
     489,   490,   491,   492,   493,   494,   495,   496,   497,    -1,
      -1,    -1,    -1,   502,    -1,    -1,    -1,    -1,    -1,   381,
      -1,    -1,   785,    -1,    -1,    -1,    -1,    -1,  1024,    -1,
      -1,  3153,  3154,    -1,  3156,    -1,  3158,  3159,    -1,  3161,
     345,   346,    -1,    -1,    -1,    -1,  3168,    -1,   811,    -1,
      -1,  3173,    -1,    -1,    -1,    -1,   819,    -1,    -1,   822,
     823,   824,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   376,    -1,    -1,    -1,    -1,    -1,  3199,  3200,  3201,
      -1,    -1,  3204,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3212,  3213,  3214,  3215,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3228,    -1,    -1,  3231,
      -1,  3233,    -1,    -1,    -1,    -1,    -1,    -1,    61,   481,
      -1,    -1,  3244,  3245,    -1,    -1,  3248,   489,   490,   491,
     492,   493,   494,   495,   496,   497,    -1,    -1,    -1,   444,
     502,    -1,    -1,  3265,    -1,  3267,    -1,  3269,    -1,  3271,
      -1,    -1,    -1,    96,    -1,    -1,    10,    -1,    -1,    13,
      -1,    -1,    -1,    17,    18,    19,    -1,    -1,    -1,  3291,
      -1,    -1,    -1,  3295,    -1,    -1,    -1,    -1,    -1,    -1,
      34,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      44,    -1,    -1,    -1,  3316,    37,    -1,    51,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   157,    -1,    -1,    -1,    -1,    61,
      -1,    -1,  3344,    77,    -1,  3347,  3348,    -1,    -1,    -1,
    3352,  3353,  3354,    -1,    -1,    -1,    -1,  3359,    -1,    -1,
      -1,    -1,  3364,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     193,    -1,    -1,    -1,    96,    -1,    -1,  3379,    -1,    -1,
      -1,  1024,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3393,    -1,    -1,    -1,  3397,    -1,    -1,  3400,  3401,
      -1,  3403,    -1,    -1,    -1,    -1,   229,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    10,
      -1,    -1,    13,    -1,    -1,    -1,    17,    18,    19,    -1,
      -1,    -1,    -1,    -1,    -1,   157,    -1,    -1,    -1,    -1,
      -1,    -1,  3444,    34,   267,    -1,    -1,    -1,   271,    -1,
      -1,    -1,    -1,    44,    -1,    -1,    -1,   191,    -1,    -1,
      51,    -1,   196,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   193,  3474,  3475,    -1,    -1,    -1,    -1,    -1,   302,
     303,    -1,    -1,    -1,   218,   219,    77,   310,  1364,    -1,
      -1,    -1,    -1,  1369,  1370,    -1,    -1,    -1,    -1,   233,
      -1,    -1,   224,    -1,    -1,    -1,    -1,   229,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   342,
      -1,  1397,    -1,   346,    -1,    -1,    -1,    -1,   351,    -1,
    1406,    -1,  1408,    -1,    -1,    -1,  1412,   360,    -1,    -1,
     274,    -1,    -1,  1419,    -1,   368,    -1,    -1,    -1,   271,
      -1,    -1,    -1,   376,   288,    -1,    -1,   291,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   388,    -1,    -1,    -1,    -1,
      -1,  1214,    -1,    -1,   397,    -1,    -1,    -1,   401,    -1,
    3582,   303,    -1,    -1,    -1,    -1,    -1,    -1,   310,    -1,
    3592,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1242,
     191,    -1,    -1,    -1,    -1,   196,    -1,    -1,    -1,    -1,
      10,    -1,    -1,    13,    -1,    -1,    -1,    17,    18,    19,
      -1,    -1,    -1,    -1,   346,    -1,    -1,   218,   219,   351,
      -1,    -1,   455,    -1,    34,  1511,    -1,    -1,   360,    -1,
      -1,    -1,   233,    -1,    44,  1521,   368,   381,    -1,    -1,
      -1,    51,    -1,    -1,   376,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   388,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   397,  1319,    77,    24,   401,
      -1,    -1,    -1,   274,    30,  1328,    -1,    -1,    -1,  1565,
    1566,    -1,    -1,    -1,    -1,  3697,    -1,   288,   420,  1342,
     291,  3703,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3714,    -1,    -1,  4074,    -1,    -1,  1361,  4078,
      -1,  1364,  1365,    -1,    -1,    -1,  1369,  1370,    -1,    75,
      -1,    -1,  1608,   455,    -1,  1611,  1612,   459,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   481,    -1,  3751,
    3752,  3753,    -1,    -1,    -1,   489,   490,   491,   492,   493,
     494,   495,   496,   497,    -1,    -1,  3768,    -1,   502,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3782,    -1,    -1,    -1,    -1,   131,  4145,    -1,    -1,    -1,
     381,   191,   138,    -1,    -1,   141,   196,    -1,  3800,  3801,
    3802,    -1,    10,    -1,  3806,    13,    -1,    -1,    -1,    17,
      18,    19,    -1,    -1,    -1,    -1,  3818,    -1,   218,   219,
      -1,    -1,   168,    -1,    -1,    -1,    34,    -1,    -1,    -1,
      -1,    -1,    -1,   233,    -1,    -1,    44,    -1,    -1,    -1,
      -1,    -1,    -1,    51,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   202,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    77,
      -1,    -1,  3874,    -1,   274,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3888,  3889,   288,    -1,
     481,   291,    -1,    -1,    -1,  3897,    -1,    -1,   489,   490,
     491,   492,   493,   494,   495,   496,   497,    -1,  3910,   500,
      -1,  3913,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   267,    -1,    -1,    -1,   271,  1802,    -1,    -1,    -1,
    3932,    -1,    -1,    -1,    -1,   281,    -1,    -1,    -1,  3941,
      -1,    -1,    -1,    -1,   290,    -1,    -1,  3949,    -1,  3951,
      -1,    -1,  3954,    -1,    -1,    52,   302,  3959,  3960,  3961,
    3962,    -1,    -1,  3965,  3966,  3967,  3968,  3969,  3970,  3971,
    3972,  3973,  3974,    -1,    -1,    -1,  3978,  3979,  3980,    -1,
      -1,   381,  1625,   191,    -1,    -1,  3988,    -1,   196,    -1,
    1633,  3993,    -1,    -1,    -1,  3997,   342,    -1,    -1,   345,
     346,    -1,    -1,  4005,    -1,    -1,  4008,    -1,  4010,    -1,
     218,   219,    -1,    -1,    -1,    -1,    -1,    -1,  4020,    -1,
      -1,  4023,  4024,    -1,    -1,   233,  4028,  4029,    -1,    -1,
     376,  4033,    -1,  4035,    -1,    -1,    -1,    -1,    -1,    -1,
    4042,  4043,  4044,    -1,    -1,    -1,  4405,  4406,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    4062,  4063,  4064,    -1,  4066,  4067,   274,    -1,  4070,    -1,
      10,    -1,  4074,    13,    -1,    -1,  4078,    17,    18,    19,
     288,   481,  4084,   291,    -1,    -1,    -1,    -1,    -1,   489,
     490,   491,   492,   493,   494,   495,   496,   497,   444,    -1,
      -1,    -1,   502,    -1,    44,    -1,    -1,    -1,  4110,    -1,
      -1,    51,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  4125,    -1,  4127,    -1,    10,    -1,    -1,
      13,    -1,    -1,    -1,    17,    18,    19,    77,    -1,  2015,
    2016,    -1,    -1,  4145,  4146,  4147,  2022,  2023,  4150,    -1,
      -1,    34,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    44,    -1,    -1,    -1,    -1,    -1,    -1,    51,    -1,
      -1,    -1,    -1,   381,    -1,    -1,  2052,    -1,    -1,    -1,
      -1,    -1,    -1,  4185,  4186,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    77,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  4204,  1846,    -1,    -1,    -1,  1850,    -1,    -1,
      -1,    24,    -1,    -1,    -1,    -1,    -1,    30,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   191,    -1,    -1,    -1,    -1,   196,    -1,    -1,    -1,
    4619,    -1,    75,    -1,    -1,    -1,    -1,  4626,    -1,    -1,
      -1,    -1,  4631,   481,    -1,  4634,  4635,    -1,   218,   219,
      -1,   489,   490,   491,   492,   493,   494,   495,   496,   497,
      -1,    -1,    -1,   233,   502,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   191,    -1,
    4312,    -1,    -1,   196,    -1,    -1,    -1,    -1,   131,    -1,
      -1,    -1,    -1,    -1,    -1,   138,    -1,    -1,   141,    -1,
      -1,    -1,    -1,    -1,   274,   218,   219,    -1,    -1,    -1,
      -1,    -1,    -1,  4345,    -1,    -1,    -1,    -1,   288,    -1,
     233,    -1,    -1,    -1,    -1,   168,    -1,  4359,    -1,  4361,
      -1,    -1,    -1,    -1,    -1,    -1,  4368,    -1,    -1,    -1,
      -1,    -1,  4374,    -1,    -1,  2018,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  4385,    -1,    -1,    -1,    -1,    -1,   202,
      -1,   274,    -1,    -1,    -1,    -1,    -1,    -1,  4400,    -1,
      -1,    -1,    -1,  4405,  4406,   288,    -1,    -1,   291,    -1,
      -1,  4413,    -1,    22,    -1,    -1,    -1,    -1,    27,    -1,
    4422,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    4432,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   381,  4444,  4445,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  4455,   267,    -1,    -1,    -1,   271,    -1,
      -1,    -1,    -1,    -1,  4466,  4467,    -1,    -1,   281,    78,
      79,    -1,    -1,    -1,    -1,    -1,    -1,   290,    -1,    -1,
      -1,    -1,  4484,    -1,    -1,    94,    -1,    -1,    -1,   302,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   381,    -1,
      -1,    10,    -1,   112,    13,    -1,    -1,    -1,    17,    18,
      19,    -1,    -1,  4872,    -1,    -1,    -1,    -1,    -1,    -1,
    4522,    -1,    -1,    -1,    -1,    34,    -1,   136,    -1,   342,
      -1,  4533,   345,   346,    -1,    44,    -1,    -1,   147,    -1,
      -1,   481,    51,    -1,  4903,    -1,    -1,   156,    -1,   489,
     490,   491,   492,   493,   494,   495,   496,   497,    -1,  4561,
     169,    -1,  4564,   376,    -1,   174,    -1,    -1,    77,    -1,
    4572,  4573,    -1,    -1,    -1,    -1,    -1,  4579,  4580,    -1,
      -1,    -1,  4584,    -1,    -1,    -1,  4588,    -1,    -1,  4591,
    4592,   200,    -1,    -1,  4596,  4597,    -1,    -1,   481,   696,
    4602,  4603,  4604,  4605,  4606,    -1,   489,   490,   491,   492,
     493,   494,   495,   496,   497,    -1,   225,  4619,    -1,   502,
    4622,    -1,    -1,    -1,  4626,   722,    -1,    -1,    -1,  4631,
      -1,   444,  4634,  4635,    -1,  4637,    -1,  4639,   247,    -1,
    4642,    -1,  4644,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  4653,    -1,    -1,    -1,  4657,    -1,    -1,    -1,  4661,
      -1,  4663,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  4678,    -1,    -1,  4681,
      -1,    -1,   191,    -1,    -1,    -1,    -1,   196,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  2571,  2572,    -1,    -1,    -1,
      -1,  2577,    -1,    -1,    -1,    -1,  5065,    -1,    -1,   218,
     219,    -1,    -1,  4715,   323,   324,    -1,    -1,   327,    -1,
      -1,    -1,    -1,    -1,   233,    -1,  5085,    -1,    -1,  4731,
      -1,    -1,    -1,  2609,  2610,    -1,    -1,    -1,    -1,    -1,
    5099,    -1,    -1,    -1,    -1,   354,    -1,    -1,   357,    -1,
      -1,    -1,    -1,    -1,   363,    -1,    -1,    -1,    -1,    -1,
      -1,   370,    -1,    -1,   373,   274,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   873,    -1,    -1,   288,
    4782,    -1,   291,   392,  4786,    -1,  4788,    -1,    -1,    -1,
     399,  5150,    -1,    -1,    -1,  2671,   405,    -1,    -1,   408,
      -1,    -1,    -1,   412,    -1,    -1,    -1,    -1,  4810,    -1,
      -1,    -1,    -1,    -1,    24,    -1,    -1,    -1,   427,    -1,
      30,    -1,    -1,  4825,    -1,    -1,    -1,    37,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5197,    -1,
      -1,    -1,    -1,    -1,   453,    -1,    -1,    -1,    -1,    59,
      -1,    -1,    -1,    24,  4856,    -1,    -1,    -1,    -1,    30,
      -1,    -1,    -1,    -1,    -1,    75,    -1,    -1,    -1,    -1,
    4872,    -1,   381,    -1,    -1,    -1,    -1,  4879,    -1,  2755,
    2523,    -1,    -1,    -1,    -1,    -1,  4888,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5258,
     110,  4903,    -1,    -1,    75,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  4916,    -1,  4918,    -1,    -1,  1016,
      -1,   131,    -1,    -1,    -1,    -1,    -1,    -1,   138,    -1,
      -1,   141,    10,    -1,    -1,    13,    -1,  1034,    -1,    17,
      18,    19,  4944,    -1,    -1,    -1,    -1,    -1,  1045,    -1,
      -1,    -1,    -1,  4955,    -1,    -1,    34,  5316,   168,    -1,
     131,    -1,    -1,    -1,  1061,    -1,    44,   138,  2844,    -1,
     141,    -1,   481,    51,    -1,    -1,  2852,    -1,    -1,  2855,
     489,   490,   491,   492,   493,   494,   495,   496,   497,   199,
      -1,  2867,   202,   502,    -1,    -1,    -1,   168,  5000,    77,
      -1,  5003,    -1,    -1,  5006,  5007,  5008,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2671,  5031,
    5032,   202,    -1,  5035,    -1,    -1,    -1,    -1,   248,    -1,
      -1,    -1,   252,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  5055,    -1,    -1,    -1,   267,    -1,  5061,
      -1,   271,    -1,  5065,    -1,    -1,    -1,  5069,    -1,    -1,
    5072,   281,  5074,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     290,    -1,    -1,  5085,    -1,    -1,  5088,  2730,  5447,    -1,
      -1,   301,   302,    -1,    -1,    -1,   267,  5099,  5100,  5101,
     271,  5103,    -1,    -1,    -1,    -1,    -1,    -1,    24,    -1,
     281,    -1,    -1,   191,    30,    -1,  5475,    -1,   196,   290,
      -1,    -1,    -1,    -1,    -1,  1222,    -1,    -1,    -1,    -1,
      -1,   302,   342,    -1,    -1,   345,   346,   347,    -1,    -1,
     218,   219,    -1,    -1,    -1,    -1,    -1,    -1,  5150,  5151,
      -1,    -1,    -1,    -1,    -1,   233,    -1,    -1,    -1,    75,
     370,    -1,    -1,    -1,    -1,    -1,   376,  2810,    -1,    -1,
      -1,   342,    -1,    -1,   345,   346,    -1,    -1,    -1,    -1,
     390,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2834,    -1,    -1,    -1,  5197,   274,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   376,  5565,  5209,    -1,    -1,
     288,    -1,  5214,   291,    -1,   131,    -1,  5219,    -1,    -1,
      -1,    -1,   138,    -1,    -1,   141,  5228,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   444,    -1,  5238,  3113,    -1,    -1,
    5242,    -1,    -1,  5245,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   168,    -1,  5256,  5257,  5258,    10,  2901,    -1,
      13,    -1,    -1,    -1,    17,    18,    19,    -1,    -1,    -1,
      -1,    -1,    -1,   444,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    34,    -1,    -1,    -1,    -1,   202,    -1,  5290,    -1,
      -1,    44,  5294,    -1,  5296,  2938,    -1,  2940,    51,  2942,
    2943,    -1,    -1,   381,  2947,  2948,  2949,  5666,  2951,  2952,
    2953,    -1,    -1,    -1,  5316,    -1,    -1,  5319,    -1,    -1,
      -1,  5323,    -1,    -1,    77,    -1,    -1,    -1,  5330,    -1,
      -1,    -1,    -1,    -1,    -1,  5337,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   267,    -1,    -1,    -1,   271,    -1,    -1,    -1,    -1,
      -1,    -1,  3005,    -1,    -1,   281,    -1,    -1,  1465,    -1,
    5372,    -1,    -1,    -1,   290,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   302,  3030,    -1,  5748,
      -1,    -1,    -1,    -1,    -1,  5397,    -1,    -1,    -1,    -1,
      -1,  5403,  5404,   481,    -1,    -1,  5408,  5409,  5410,  5411,
      -1,   489,   490,   491,   492,   493,   494,   495,   496,   497,
      -1,    -1,    -1,    -1,   502,    -1,   342,    -1,    -1,   345,
     346,  3307,    -1,  3309,    -1,    -1,  1533,  5439,   191,    -1,
      -1,    -1,    -1,   196,    -1,  5447,    -1,    -1,    -1,  3325,
      -1,    -1,    -1,  5812,    -1,    -1,    -1,    -1,    -1,    -1,
     376,  5820,  5821,    -1,    -1,   218,   219,    -1,    -1,    24,
    5472,    -1,    -1,  5475,    -1,    30,    -1,  1574,    -1,    -1,
     233,    -1,    -1,    -1,    10,    -1,    -1,    13,    -1,    -1,
      -1,    17,    18,    19,    -1,  3371,  3372,    -1,  5500,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    34,    -1,
    1607,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    44,    -1,
      75,   274,    -1,    -1,    -1,    51,  5528,    -1,   444,    -1,
      -1,    -1,  5534,    -1,    -1,   288,  5538,    -1,   291,    -1,
    5542,    -1,  5901,  5545,    -1,    -1,    -1,    -1,  5907,    -1,
      -1,    77,  5554,    -1,  5556,    -1,  5558,  5559,    -1,    -1,
      -1,    -1,    -1,  5565,    -1,    -1,  5925,    -1,    -1,    -1,
      -1,    -1,    -1,  5575,    -1,  5577,   131,    -1,    -1,    -1,
      -1,    -1,    -1,   138,  5586,    -1,   141,    -1,    -1,  1686,
    1687,  1688,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   168,    -1,    -1,    -1,    -1,    -1,  5621,
    5622,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   381,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5997,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   202,    -1,    -1,
    5652,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  6017,    -1,
      -1,    -1,    -1,    -1,  5666,   191,  3309,    -1,    -1,    -1,
     196,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   218,   219,    -1,    -1,    -1,    -1,    -1,    -1,
    1797,  6060,  5704,  5705,  5706,    -1,    -1,   233,    -1,  6068,
    5712,  1808,   267,    -1,  5716,    -1,   271,    -1,    -1,    -1,
    5722,  6080,  6081,    -1,    -1,    -1,   281,  1824,   481,  5731,
    5732,    -1,    -1,    -1,    -1,   290,   489,   490,   491,   492,
     493,   494,   495,   496,   497,    -1,  5748,   302,   274,   502,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  5763,   288,    -1,    -1,   291,    -1,    -1,  5770,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    1877,    -1,    -1,    -1,    -1,    -1,    -1,   342,    -1,    -1,
     345,   346,    -1,  5795,    -1,  1892,    -1,    -1,  1895,  1896,
    5802,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    5812,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5820,  5821,
    5822,   376,    -1,    -1,  5826,  3468,  5828,    -1,    -1,  1926,
    1927,    -1,    -1,    -1,    -1,  5837,  5838,  5839,    -1,    -1,
      -1,    -1,  5844,  5845,    -1,    -1,    -1,    -1,  5850,    -1,
      -1,    -1,    -1,    -1,    -1,   381,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3740,    -1,    -1,    -1,    -1,    -1,
    5872,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3763,    -1,   444,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5901,
    5902,  5903,    -1,  3546,    -1,  5907,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  5925,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2028,    -1,    -1,  2031,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  5945,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   481,    -1,  5959,    -1,  2056,
      -1,  3604,    -1,   489,   490,   491,   492,   493,   494,   495,
     496,   497,    -1,    -1,    -1,    -1,   502,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5990,    -1,
      -1,    -1,    -1,  5995,  5996,  5997,  5998,  5999,    -1,    -1,
    6002,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  6014,    10,    -1,  6017,    13,    -1,    -1,    -1,
      17,    18,    19,    -1,    -1,    -1,    -1,    -1,    -1,  3672,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    34,  6040,    -1,
      -1,    -1,    -1,    -1,    -1,  3921,    -1,    44,    -1,     8,
      -1,    -1,    -1,    -1,    51,    14,    15,  6059,  6060,    -1,
      -1,    20,  6064,    22,    -1,    -1,  6068,    -1,    -1,    28,
      -1,    -1,    31,    -1,    -1,  3718,    -1,    -1,  6080,  6081,
      77,    -1,  6084,    -1,    -1,    -1,    -1,  3730,  3731,    -1,
      -1,    50,    51,    -1,    -1,    -1,    -1,  3740,    -1,    -1,
      -1,     0,  3745,    -1,  3747,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    20,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    30,    -1,    32,    33,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3793,    50,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    60,    -1,    10,    -1,    -1,    13,    -1,    -1,    -1,
      17,    18,    19,    72,    -1,    74,    75,    -1,    -1,    -1,
      -1,    -1,    81,    -1,    83,  3828,  3829,    34,    -1,    -1,
      -1,    38,    -1,    -1,   191,    -1,    95,    44,    97,   196,
      -1,    -1,    -1,    -1,    51,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   114,    -1,    -1,   117,    -1,
      -1,   218,   219,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      77,    -1,    -1,   132,    -1,   134,   233,    -1,    -1,   138,
      -1,    -1,   201,    -1,    -1,   144,   205,    -1,    -1,    -1,
      -1,    -1,    -1,   152,   213,   154,    -1,   216,    -1,    -1,
     219,   220,   161,   222,    10,   224,    -1,    13,   227,    -1,
     229,    17,    18,    19,    -1,    -1,    -1,   274,    -1,   178,
      -1,   128,    -1,    -1,    -1,    -1,    -1,    -1,    34,    -1,
      -1,   288,    -1,    -1,   291,    -1,   195,    -1,    44,    -1,
      -1,    -1,    -1,    -1,    -1,    51,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    77,    -1,    -1,    -1,    -1,   235,   236,    -1,    -1,
      -1,    -1,   241,    -1,   191,    -1,    -1,  4223,    -1,   196,
      -1,    -1,    -1,    -1,    -1,    10,   255,    -1,    13,    -1,
      -1,  4004,    17,    18,    19,    -1,    -1,    -1,    -1,    -1,
      -1,   218,   219,  4249,   273,    -1,    -1,    -1,    -1,    34,
      -1,    -1,    -1,    -1,   381,    -1,   233,  4263,    -1,    44,
      -1,    -1,    -1,    -1,    -1,    -1,    51,    -1,  4274,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2506,
      -1,   310,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   318,
      -1,    -1,    77,    -1,    -1,    -1,    -1,   274,    -1,    -1,
      -1,    -1,    -1,   332,    -1,    -1,    -1,    -1,    -1,   338,
     339,   288,   341,    -1,   291,   191,    -1,   346,    -1,    -1,
     196,    -1,    -1,   352,    -1,    -1,   355,    -1,    -1,    -1,
      -1,    -1,    -1,   362,    -1,    -1,    -1,    -1,    -1,   368,
     369,    -1,   218,   219,  4350,  4351,    -1,   376,    -1,    -1,
      -1,   380,    -1,    -1,   481,    -1,    -1,   233,    -1,    -1,
      -1,   390,   489,   490,   491,   492,   493,   494,   495,   496,
     497,    -1,    -1,    -1,    -1,   502,   405,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   425,    -1,   274,    -1,
      -1,    -1,    -1,    -1,   381,    -1,   191,   436,    -1,    -1,
      -1,   196,   288,   442,    -1,   291,  2643,    -1,   447,    -1,
    2647,  2648,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   460,  4438,   218,   219,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   233,    -1,
    4223,    -1,    -1,    -1,   483,   484,   485,   486,   487,   488,
      -1,    -1,    -1,    -1,   441,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   501,    -1,    -1,   504,  4249,    -1,  2705,    -1,
      -1,    -1,    -1,    -1,  2711,  4491,    -1,    -1,    -1,   274,
      -1,  4264,    -1,    -1,  4267,    -1,  4269,    -1,    -1,    -1,
      -1,    -1,    -1,   288,   481,   381,   291,    -1,    -1,    -1,
      -1,    -1,   489,   490,   491,   492,   493,   494,   495,   496,
     497,    -1,    -1,    -1,    -1,  2752,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  4315,    -1,    -1,   634,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   645,    -1,  4331,    -1,
     649,    -1,    -1,  4336,    -1,    -1,    -1,   656,   657,    -1,
      -1,   660,    -1,   662,   663,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   677,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   381,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   481,   695,    -1,    -1,    -1,
      -1,    -1,    -1,   489,   490,   491,   492,   493,   494,   495,
     496,   497,    -1,    -1,    -1,    -1,   502,   716,    -1,   718,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   728,
      -1,    -1,    -1,    -1,    -1,    -1,    24,    -1,    -1,    -1,
      -1,    -1,    30,    -1,    -1,    -1,    -1,    -1,    -1,    37,
      -1,    -1,  4435,    -1,    -1,  4438,    -1,    -1,    -1,    -1,
      -1,    -1,   761,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    59,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   481,    75,    -1,    -1,
      -1,    -1,  2929,    -1,   489,   490,   491,   492,   493,   494,
     495,   496,   497,    -1,  4720,    -1,    -1,   502,    -1,    -1,
    4726,    -1,    -1,    -1,  4730,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   110,    -1,  2961,    -1,    -1,    -1,  4511,  4512,
    4513,  4514,    -1,  4516,  4517,  4518,  4519,  4520,    -1,    -1,
      -1,  4757,  4758,   131,    -1,    -1,  4762,  4763,    -1,    -1,
     138,    -1,   851,   141,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    10,   199,   200,    13,
      -1,   203,    -1,    17,    18,    19,    -1,    -1,    -1,    -1,
     168,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      34,   223,    -1,    -1,    -1,    -1,    -1,  3034,   230,    -1,
      44,  3038,    -1,    -1,    -1,    -1,    -1,    51,    -1,    -1,
      -1,   199,    -1,    -1,   202,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4611,    -1,
    4613,    -1,    -1,    77,    -1,   934,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    10,    -1,    -1,    13,    -1,    -1,    -1,
      17,    18,    19,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     248,    -1,    -1,    -1,   252,    -1,    -1,    34,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    44,    -1,   267,
      -1,    -1,    -1,   271,    51,    -1,    -1,    -1,    10,    -1,
      -1,    13,    -1,   281,    -1,    17,    18,    19,    -1,    -1,
      -1,    -1,   290,  3140,    -1,    -1,    -1,    -1,    -1,  1008,
      77,    -1,    34,   301,   302,    -1,    -1,    -1,  3155,    -1,
      -1,    -1,    44,  3160,    -1,    -1,    -1,    -1,    -1,    51,
      -1,    -1,    -1,  1032,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   191,  1047,    -1,
    1049,    -1,   196,    -1,   342,    77,    -1,   345,   346,   347,
    1059,    -1,    -1,    -1,    -1,    -1,    -1,  1066,    -1,    -1,
      -1,    -1,    -1,    -1,   218,   219,    -1,    -1,    -1,    -1,
      -1,    -1,   370,    -1,    -1,    -1,    -1,    -1,   376,   233,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   390,    -1,    -1,    -1,    -1,    -1,    -1,  1108,
      -1,  1110,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   191,    -1,    -1,    -1,    -1,   196,
     274,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   288,  4828,  4829,   291,    -1,    -1,
      -1,   218,   219,    -1,    -1,    -1,   444,    -1,  4841,    -1,
    4843,  4844,  4845,    -1,    -1,    -1,   233,    -1,    -1,   191,
      -1,    -1,    -1,    -1,   196,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  1184,    -1,  1186,    -1,  1188,
      -1,  1190,    -1,  1192,  1193,  1194,   218,   219,    -1,    -1,
    1199,    -1,    -1,    -1,    -1,    -1,    -1,   274,    -1,    -1,
      -1,   233,  1211,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   288,    -1,  5139,   291,    -1,  4909,    -1,    -1,    -1,
    1229,    -1,    -1,    -1,    -1,    -1,    -1,   381,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   274,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  4948,   288,    -1,    -1,   291,
      -1,    -1,    -1,    -1,    -1,    -1,  3413,    -1,    -1,  3416,
      -1,  3418,    -1,    -1,    -1,    -1,  3423,    61,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  4990,    -1,    -1,
     642,    -1,   644,    -1,   381,   647,    -1,    -1,    -1,    -1,
      -1,    -1,    96,    -1,    -1,    -1,    -1,    -1,    -1,   661,
      -1,    -1,    -1,    -1,  3471,   667,    -1,   481,    -1,    -1,
      -1,    -1,  3479,    -1,    -1,   489,   490,   491,   492,   493,
     494,   495,   496,   497,    -1,    -1,    -1,    -1,   502,   381,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3504,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   157,    -1,    -1,    -1,  1386,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   207,   208,    -1,
      -1,    -1,    -1,    -1,    -1,   215,    -1,   217,   218,    -1,
      -1,    -1,    -1,    -1,   481,    -1,    -1,    -1,    -1,   193,
      -1,   231,   489,   490,   491,   492,   493,   494,   495,   496,
     497,    -1,    -1,    -1,    -1,   502,    -1,  3574,    -1,  3576,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   229,  5139,    -1,    -1,   481,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   489,   490,   491,
     492,   493,   494,   495,   496,   497,    -1,    -1,    -1,    -1,
     502,    -1,    -1,    10,    -1,    -1,    13,    -1,    -1,    -1,
      17,    18,    19,   267,    -1,    -1,    -1,   271,    -1,    -1,
      -1,    -1,    -1,  5419,  5187,    -1,    -1,    34,  1507,    -1,
      -1,    -1,    -1,  5196,    -1,    -1,    -1,    44,    -1,    -1,
      -1,    -1,    -1,    -1,    51,    -1,    -1,    -1,   302,   303,
      -1,    -1,    -1,  3670,    -1,    -1,   310,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      77,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3697,    -1,    -1,    -1,    -1,    -1,  3703,    -1,   342,    -1,
      -1,    -1,   346,    -1,    -1,  3712,    -1,   351,    -1,    -1,
    1579,    10,    -1,    -1,    13,    -1,   360,    -1,    17,    18,
      19,    -1,    -1,    -1,   368,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   376,  3740,    -1,    34,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   388,    44,    -1,    -1,    -1,    -1,
      -1,    -1,    51,   397,    -1,    -1,    -1,   401,    -1,   961,
     962,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    22,    -1,    -1,    -1,    -1,    27,    -1,    77,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   191,    -1,    -1,    -1,    -1,   196,
      -1,  3808,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   455,    -1,    -1,    65,    -1,    -1,  5603,    -1,    -1,
      -1,   218,   219,  3830,    -1,    -1,    -1,    78,    79,  1031,
      -1,    -1,    -1,    -1,    -1,    -1,   233,    -1,    -1,    90,
      -1,    -1,    -1,    94,  1046,  3852,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   112,    -1,    -1,    -1,    -1,  5419,    -1,   167,    -1,
    5423,    -1,    -1,   172,    -1,  1077,  1078,   274,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   136,    -1,    -1,    -1,    -1,
      -1,   288,   191,    -1,   291,    -1,   147,   196,    -1,    -1,
    1102,    -1,    -1,    -1,    -1,   156,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   169,   218,
     219,    -1,    -1,   174,  1793,    -1,    -1,    -1,  3935,    -1,
      -1,    -1,    -1,    -1,   233,    -1,    -1,    -1,    -1,    -1,
    1142,  1143,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   200,
      -1,  3958,    -1,   633,    -1,    -1,    -1,    -1,    -1,  1828,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   652,    -1,   225,   274,  3983,    -1,   658,    -1,
      -1,    -1,    -1,    -1,   381,    -1,    -1,    -1,    -1,   288,
     670,    -1,   291,    -1,    -1,    -1,   247,    -1,    -1,    -1,
      -1,    -1,  1871,    -1,  1873,    -1,   686,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     700,   701,    -1,    -1,  1893,    -1,    -1,   707,    52,   709,
     710,    -1,    -1,    -1,    -1,    -1,    -1,   288,    -1,    -1,
      -1,    -1,    -1,   723,    -1,    -1,    -1,    -1,    -1,    -1,
    1919,    -1,  1921,   733,    -1,    -1,    -1,    -1,    -1,    -1,
    5613,    -1,   313,    -1,  5617,    -1,  5619,  1936,    -1,  1938,
    5623,  5624,   323,   324,    -1,  1944,   327,  1946,    -1,  1948,
      -1,  1950,   381,  1952,   481,    -1,    -1,  1956,    -1,    -1,
      -1,    -1,   489,   490,   491,   492,   493,   494,   495,   496,
     497,    -1,    -1,   354,    -1,   502,   357,    -1,    10,    -1,
     361,    13,   363,    -1,   794,    17,    18,    19,    -1,   370,
      -1,    -1,   373,    -1,    -1,    -1,  4133,    -1,    -1,    -1,
      -1,    -1,    34,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   392,    44,   823,    -1,    -1,    -1,    -1,   399,    51,
      -1,    -1,    -1,    -1,   405,    -1,    -1,   408,    -1,    -1,
      -1,   412,    -1,    -1,    -1,    -1,    -1,    -1,   848,   420,
      -1,   422,    -1,    -1,    -1,    77,   427,    -1,    -1,    -1,
      -1,    -1,   481,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     489,   490,   491,   492,   493,   494,   495,   496,   497,    -1,
      -1,    -1,   453,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  4223,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   908,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    10,    -1,  6024,    13,
      -1,    -1,  4249,    17,    18,    19,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      34,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      44,    -1,    -1,    -1,    -1,    -1,    -1,    51,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  6072,    -1,    -1,   191,
      -1,    -1,    -1,    -1,   196,    -1,    -1,    -1,    -1,    10,
      -1,    -1,    13,    77,  6090,    -1,    17,    18,    19,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   218,   219,    -1,    -1,
      -1,    -1,    -1,    34,  1526,  5878,    37,    -1,    -1,    -1,
      -1,   233,    -1,    44,    -1,    -1,    -1,    -1,  1018,    -1,
      51,    -1,    -1,    -1,  1024,    -1,    -1,    -1,    -1,  1551,
      -1,    -1,    -1,    -1,    -1,  1035,    -1,    -1,    -1,  1039,
      -1,  1041,    -1,    -1,    -1,    -1,    77,    -1,    -1,    -1,
      -1,    -1,   274,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  4391,    -1,   288,    -1,    -1,   291,
      -1,    -1,   166,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   317,    -1,   191,    -1,    -1,
      -1,    -1,   196,    -1,    -1,    -1,  1628,    -1,    -1,    -1,
      -1,  4438,    -1,    -1,    -1,    -1,  4443,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   218,   219,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  1657,  1658,  1659,  1660,   233,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  1147,    -1,    -1,
      -1,  6024,    -1,    -1,    -1,    -1,    -1,  6030,    -1,   381,
     191,    -1,    -1,    -1,    -1,   196,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   398,    -1,    -1,    -1,
     274,    -1,    -1,    -1,    -1,    -1,    -1,   218,   219,    -1,
      -1,    -1,    -1,    -1,   288,    -1,    -1,   291,    -1,  6072,
      -1,    -1,   233,    -1,    -1,    -1,    -1,    -1,  1208,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  6090,    -1,    -1,
    6093,   315,    -1,    -1,  1224,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1238,    -1,
      -1,    -1,  1242,   274,    -1,    -1,    -1,    -1,  4575,    -1,
      -1,    -1,    -1,    -1,   208,    -1,    -1,   288,    -1,   481,
     291,    -1,    -1,   217,    -1,    -1,    -1,   489,   490,   491,
     492,   493,   494,   495,   496,   497,    -1,   231,    -1,    -1,
      -1,  1803,  1804,    -1,    -1,    -1,    -1,   381,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  1819,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  1853,  1854,  1855,  1856,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     381,    10,   696,    -1,    13,    -1,    -1,    -1,    17,    18,
      19,  1361,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1369,
    1370,    -1,  4699,    -1,    -1,    34,    -1,    -1,   722,    -1,
      -1,    -1,    -1,    -1,    -1,    44,    -1,   481,    -1,    -1,
      -1,    -1,    51,    -1,    -1,   489,   490,   491,   492,   493,
     494,   495,   496,   497,    -1,    -1,    -1,    -1,    -1,    -1,
    4737,  1933,    -1,    -1,    -1,    -1,    -1,  1939,    77,    -1,
      -1,    -1,  1422,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  4759,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2637,  2638,
     481,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   489,   490,
     491,   492,   493,   494,   495,   496,   497,  2656,  2657,    -1,
    2659,  2660,    -1,    -1,    -1,  2664,  2665,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    2679,    -1,    -1,    -1,    -1,    -1,    -1,  2686,    -1,    -1,
      -1,  2690,  2691,  4830,    -1,  2694,  2695,    -1,    -1,    -1,
      -1,    -1,  2701,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2713,    -1,    -1,    -1,    -1,   873,
      -1,    -1,   191,    -1,    -1,    -1,  2725,   196,    -1,    -1,
      -1,  2730,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2745,    -1,    -1,   218,
     219,    -1,    -1,    -1,    -1,  2754,    -1,    -1,  2757,    -1,
    2759,  2760,  2761,    -1,   233,    -1,    -1,  2766,  2767,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  2776,    -1,    -1,
      -1,    -1,  2114,  2782,    -1,    -1,    -1,  2786,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2798,
    2799,    -1,    -1,    -1,  2803,   274,    -1,    -1,    -1,    -1,
    2809,  2810,  4949,    -1,  4951,    -1,    -1,    -1,    -1,   288,
      -1,    -1,   291,    -1,  2823,    -1,    -1,  2826,    -1,    -1,
      -1,    -1,    -1,    -1,  2833,  2834,    -1,    -1,    -1,    -1,
    2839,    -1,   311,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  2851,    -1,    52,  2854,    -1,    -1,    -1,    -1,
    2859,  1671,    -1,    -1,    -1,    -1,  2865,  2866,    -1,   633,
      -1,    -1,    -1,    -1,  2873,    -1,    -1,    -1,  2877,    -1,
    1034,    -1,  2881,  2882,  2883,  2884,    -1,  2886,   652,    -1,
      -1,  1045,    -1,    -1,   658,    -1,    -1,    -1,    -1,    -1,
    2899,  2900,    -1,  2902,    -1,    -1,   670,  1061,    -1,    -1,
      -1,    -1,   381,    -1,  2913,  2914,  2915,    10,    -1,    -1,
      13,    -1,   686,    -1,    17,    18,    19,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  5071,    -1,    -1,   701,    -1,    -1,
      -1,    34,    61,    -1,    37,   709,    -1,    -1,    -1,    -1,
      -1,    44,    -1,    -1,    -1,    -1,    -1,    -1,    51,   723,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   733,
      -1,  2970,    -1,    -1,    -1,  1785,    -1,    96,    -1,  2978,
      -1,    -1,    -1,    -1,    77,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2997,    -1,
      -1,    -1,  5139,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    1820,    -1,   481,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     489,   490,   491,   492,   493,   494,   495,   496,   497,    -1,
     794,    -1,    -1,  1843,    -1,    -1,    -1,    -1,   157,    -1,
      -1,  1851,    -1,    -1,    -1,    -1,    -1,    -1,  3047,  1859,
      -1,    -1,    -1,    -1,    10,    -1,    -1,    13,    -1,   823,
      -1,    17,    18,    19,    -1,    -1,    -1,  3066,  1222,  3068,
      -1,    -1,    -1,    -1,   193,    -1,    -1,    -1,    34,    -1,
      -1,    -1,    -1,    -1,   848,    -1,    -1,    -1,    44,  1899,
    1900,    -1,  1902,  1903,    -1,    51,    -1,    -1,   191,    -1,
      -1,    -1,    -1,   196,  1914,    -1,  1916,  1917,    10,    -1,
     229,    13,    -1,    -1,    -1,    17,    18,    19,    -1,  1929,
    1930,    77,    -1,    -1,  5261,   218,   219,    -1,    -1,    -1,
      -1,    -1,    34,    -1,    -1,    37,    -1,    -1,    -1,    -1,
     233,    -1,    44,    -1,   908,    -1,    -1,    -1,   267,    51,
      -1,    -1,   271,    -1,    -1,    -1,    -1,  1967,    -1,    -1,
      -1,  1971,  1972,  3162,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    77,    -1,    -1,    -1,    -1,
      -1,   274,    -1,   302,   303,    -1,    -1,    -1,    -1,    -1,
      -1,   310,    -1,    -1,    -1,   288,    -1,    -1,   291,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    1364,    -1,    -1,    -1,    -1,  2547,   172,    -1,    -1,    -1,
      -1,    -1,    -1,   342,    -1,    -1,    -1,   346,    -1,    -1,
      -1,    -1,   351,    -1,    -1,   191,    -1,    -1,    -1,    -1,
     196,   360,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   368,
    5387,    -1,    -1,    -1,  1018,  5392,  5393,   376,    -1,    -1,
    1024,    -1,   218,   219,    -1,    -1,  2076,    -1,    -1,   388,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   233,   397,    -1,
      -1,    -1,   401,    -1,    -1,    -1,    -1,    -1,   381,   191,
      -1,    -1,    -1,    -1,   196,    -1,    10,    -1,    -1,    13,
      -1,    -1,    -1,    17,    18,    19,    -1,    -1,    -1,    -1,
      -1,  1465,    -1,    -1,    -1,    -1,   218,   219,   274,    -1,
      34,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      44,   233,   288,    -1,    -1,   291,   455,    51,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    77,    -1,    -1,    -1,  5504,  5505,    -1,
      -1,    -1,   274,    -1,    -1,    -1,    -1,    -1,    -1,  1533,
    2712,    -1,    -1,  1147,    -1,    -1,   288,    -1,   481,   291,
      -1,    -1,    -1,    -1,    -1,    -1,   489,   490,   491,   492,
     493,   494,   495,   496,   497,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  5549,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    1574,    -1,    -1,    -1,    -1,   381,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  1208,    -1,    -1,  3446,    -1,    -1,
      -1,    -1,    -1,  1607,    -1,    -1,    -1,    -1,    -1,    -1,
    1224,    -1,    -1,    -1,    -1,    -1,    -1,  3466,    -1,    -1,
      -1,    -1,    -1,    -1,  1238,    -1,    -1,   191,  1242,   381,
      -1,    -1,   196,    -1,  3483,    -1,    -1,    -1,  3487,    -1,
      -1,    -1,    -1,  3492,  3493,  3494,    -1,    -1,   696,    -1,
      -1,    -1,    -1,    -1,   218,   219,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2850,   233,
      -1,  2853,    -1,    52,   722,   481,    -1,    -1,    -1,  3528,
    3529,  3530,  3531,   489,   490,   491,   492,   493,   494,   495,
     496,   497,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3558,
     274,    -1,    -1,    -1,    -1,    -1,    -1,  3566,    -1,  3568,
    3569,  3570,    -1,    -1,   288,    -1,    -1,   291,    -1,   481,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   489,   490,   491,
     492,   493,   494,   495,   496,   497,    -1,  1361,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  1369,  1370,    -1,    -1,  2941,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  2954,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    2962,    -1,    -1,    -1,    -1,    -1,    -1,    10,    -1,    -1,
      13,    -1,    -1,  1797,    17,    18,    19,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  1808,    -1,    -1,    -1,  1422,    -1,
      -1,    34,    -1,    -1,    37,    -1,    -1,   381,    -1,  3001,
    1824,    44,    -1,    -1,    -1,   873,    -1,    -1,    51,    -1,
      -1,    -1,    -1,    -1,    -1,  3684,    -1,    -1,    -1,    -1,
    3022,    -1,    -1,    -1,  3693,    -1,    -1,    -1,    -1,   413,
      -1,    -1,    -1,    -1,    77,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3719,  3720,    -1,  1877,    -1,  3724,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3065,    -1,  3067,    -1,    -1,  1892,    -1,
      -1,  1895,  1896,    -1,    -1,    -1,    -1,  3746,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    10,    -1,    -1,    13,    -1,    -1,   481,    17,    18,
      19,  2581,  1926,  1927,    -1,   489,   490,   491,   492,   493,
     494,   495,   496,   497,    -1,    34,    -1,    -1,    -1,    -1,
      52,    -1,    -1,    -1,    -1,    44,    -1,    -1,    -1,  3798,
      -1,    -1,    51,    -1,  3803,    -1,    -1,    -1,    -1,    -1,
    3809,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   191,    -1,
      -1,    -1,  3154,   196,    -1,    -1,  2636,    -1,    77,  3161,
      -1,    -1,    -1,    -1,    -1,    -1,  1034,    -1,    -1,    -1,
    3839,    -1,    -1,    -1,  2654,   218,   219,  1045,  2658,    -1,
      -1,    -1,  2662,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     233,  2671,    -1,  1061,    -1,    -1,    -1,    -1,    -1,  3868,
      -1,  3870,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2689,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2706,    -1,  2708,  2709,
      -1,   274,  2056,    -1,    -1,    -1,    -1,  1671,    -1,    -1,
      -1,    -1,  3911,  2723,    -1,   288,    -1,    -1,   291,    -1,
      -1,    10,  6059,   172,    13,    -1,    -1,    -1,    17,    18,
      19,    -1,    -1,  2743,  2744,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   191,    -1,    -1,    34,    -1,   196,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    44,    -1,    -1,    -1,    -1,
      -1,    -1,    51,    -1,  2774,  2775,    -1,    -1,  2778,   218,
     219,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   233,    -1,    -1,    -1,    77,    -1,
      -1,    -1,  2802,    -1,  2804,    -1,    -1,    -1,  2808,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   381,    -1,
      -1,    -1,  2822,    -1,    -1,    -1,    -1,    -1,    -1,  2829,
      -1,  1785,  2832,    -1,  1222,   274,    -1,    -1,  2838,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   288,
      -1,    -1,   291,    -1,    -1,    -1,    -1,    -1,  2858,    -1,
      -1,    -1,    -1,    -1,  2864,    -1,  1820,    -1,    -1,    -1,
      -1,  2871,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  2885,    -1,    -1,    -1,  1843,
      -1,    -1,    -1,   172,    -1,    -1,    -1,  1851,  2898,    -1,
      -1,    -1,    -1,  2903,    -1,  1859,    -1,    -1,    -1,  2909,
      -1,    -1,   191,    -1,    -1,    -1,    -1,   196,   481,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   489,   490,   491,   492,
     493,   494,   495,   496,   497,    -1,    -1,    -1,    -1,   218,
     219,    -1,   381,    -1,    -1,    -1,    -1,    -1,  1902,  1903,
      -1,    -1,  3474,  3475,   233,    -1,    -1,    -1,    -1,    -1,
    4149,    -1,  1916,  4152,    -1,  4154,    -1,    -1,    -1,  2969,
      -1,    -1,    -1,    -1,    -1,  1929,  1930,   696,  4167,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    4179,    -1,    -1,    -1,  4183,   274,    -1,    -1,    10,    -1,
      -1,    13,    -1,   722,    -1,    17,    18,    19,    -1,   288,
      -1,    -1,   291,  4202,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    34,    -1,    -1,    -1,    -1,    -1,    52,    -1,
      -1,  4220,    44,    -1,    -1,    -1,    -1,  4226,    -1,    51,
      -1,    -1,   481,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     489,   490,   491,   492,   493,   494,   495,   496,   497,    -1,
      -1,    -1,  4251,    -1,    -1,    77,  4255,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  1465,    -1,    -1,
      -1,  4270,  4271,  4272,  4273,    -1,    -1,    -1,    -1,    -1,
      -1,  4280,  4281,  4282,  4283,    -1,    -1,    -1,    -1,    -1,
    4289,  4290,   381,    -1,    -1,    -1,  4295,  4296,    -1,  4298,
    4299,  4300,  4301,  4302,  4303,  4304,    -1,    -1,    -1,    -1,
      -1,    -1,  2076,    -1,  3124,  4314,    -1,    -1,    -1,  4318,
    4319,  4320,  4321,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3142,    -1,    -1,  1533,    -1,    -1,    -1,  3149,
      -1,    -1,    -1,  4342,   873,   167,  3156,    -1,  3158,  3159,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  4360,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   191,
      -1,    -1,    -1,    -1,   196,    -1,  1574,    -1,    -1,    -1,
      -1,    -1,  3714,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   481,    -1,    -1,    -1,   218,   219,    -1,    -1,
     489,   490,   491,   492,   493,   494,   495,   496,   497,  1607,
      -1,   233,    -1,  3223,    -1,    -1,    -1,    -1,    -1,  3229,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   696,    -1,    -1,  4436,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   274,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     722,    -1,    -1,    -1,    -1,    -1,   288,    -1,    -1,   291,
    4469,    -1,    -1,    -1,    -1,    -1,    -1,  4476,    -1,  4478,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2643,
      -1,    -1,    -1,  2647,  2648,    -1,    -1,    -1,    -1,  3309,
      -1,  4500,    -1,    -1,    -1,  1034,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  1045,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  1061,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3874,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2705,    -1,    -1,    -1,    -1,    -1,  2711,    -1,   381,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2752,  1797,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    1808,   873,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  1824,    -1,  3438,  3439,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    10,    -1,    -1,    13,    -1,    -1,
      -1,    17,    18,    19,    -1,  3465,    -1,    -1,  3468,   481,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   489,   490,   491,
     492,   493,   494,   495,   496,   497,    -1,    -1,    44,  1877,
      -1,    -1,    -1,    -1,    -1,    51,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  1222,  1892,    -1,    -1,  1895,  1896,    -1,
      -1,  4700,  4701,  4702,    -1,    -1,    -1,  4706,  4707,  4708,
    4709,    77,    -1,    -1,  4713,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1926,  1927,
    3540,  3541,  3542,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    4749,  4750,  4751,  4752,  4753,  3565,  4755,  4756,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4767,  4768,
      -1,    -1,  1034,    -1,  3584,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  1045,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3606,    -1,    -1,  1061,
      -1,  4800,    -1,    -1,    -1,    -1,    -1,  2961,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  2581,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   191,    -1,    -1,    -1,    -1,
     196,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    52,    -1,    -1,    -1,    -1,
      -1,    -1,   218,   219,    -1,    -1,    -1,    -1,  2056,    -1,
      -1,    -1,   696,    -1,    -1,    -1,    -1,   233,    -1,    -1,
      -1,    -1,  2636,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3034,    -1,  3692,    -1,  3038,    -1,    -1,    -1,   722,    -1,
    2654,    -1,    -1,    -1,  2658,    -1,    -1,    -1,  2662,    -1,
      -1,    -1,    -1,  4902,    -1,    -1,    -1,  2671,   274,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   288,    -1,    -1,  2689,    -1,    -1,    -1,  3739,
      -1,    -1,    -1,    -1,    -1,  3745,  1465,  3747,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3760,    -1,  3762,    -1,    -1,    -1,    -1,    -1,    -1,  2723,
    1222,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4967,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2743,
    2744,    -1,    -1,    -1,    -1,    -1,  3140,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3155,    -1,    -1,  1533,    -1,  3160,    -1,    -1,    -1,
    2774,  2775,    -1,  4345,  2778,   381,    -1,    -1,    -1,  3829,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  4359,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2802,   873,
    2804,    -1,    -1,    -1,  2808,  1574,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2822,    -1,
      -1,  3871,    -1,    -1,    -1,  2829,    -1,    -1,  2832,    -1,
      -1,    -1,    -1,    -1,  2838,    -1,    -1,    -1,  1607,  5078,
    3890,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2858,    -1,    -1,    -1,    -1,    -1,
    2864,    -1,  3912,    -1,    -1,  3915,    -1,  2871,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   481,    -1,    -1,    -1,    -1,
      -1,  2885,    -1,   489,   490,   491,   492,   493,   494,   495,
     496,   497,    -1,    -1,  2898,    -1,    -1,    -1,    -1,  2903,
      52,    -1,  5141,    -1,    -1,  2909,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  5160,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5168,
    5169,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5178,
      -1,    -1,    -1,    -1,    -1,  3995,  5185,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    1034,    -1,    -1,  1465,    -1,  2969,    -1,    -1,    -1,    -1,
      -1,  1045,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  5220,  5221,    -1,    -1,    -1,    -1,  1061,    -1,    -1,
      -1,    -1,    -1,    -1,  5233,    -1,  5235,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  5250,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3413,
      -1,    -1,  3416,    -1,  3418,    -1,    -1,    -1,  1797,  3423,
      -1,  1533,    -1,    -1,    10,    -1,  5275,    13,    -1,  1808,
      -1,    17,    18,    19,  5283,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  1824,    -1,    -1,    34,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    44,    -1,
      -1,    -1,  1574,    -1,    -1,    51,    -1,  3471,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3479,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    77,    -1,    -1,    -1,  1607,    -1,    -1,  1877,    -1,
    3504,    -1,    -1,  5352,    -1,    -1,  4166,    -1,    -1,    -1,
    3124,    -1,    -1,  1892,    -1,    -1,  1895,  1896,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  5376,  3142,    -1,
      -1,    -1,    -1,    -1,    -1,  3149,    -1,  5386,  1222,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  1926,  1927,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  4217,    -1,    -1,
     146,    -1,  4222,    -1,  4224,    -1,    -1,    -1,    -1,    -1,
    3574,    -1,  3576,    -1,    -1,    -1,    -1,    10,    -1,    -1,
      13,    -1,    -1,    -1,    17,    18,    19,    -1,  4248,    -1,
      -1,    -1,    -1,    -1,    -1,  2643,    -1,    -1,    -1,  2647,
    2648,    34,    -1,    -1,  5453,   191,    -1,    -1,    -1,  3223,
     196,    44,    -1,    -1,    -1,  3229,    -1,    -1,    51,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4810,    -1,
      -1,    -1,   218,   219,  4294,    -1,    -1,  4297,    -1,   696,
      -1,    -1,    -1,  4825,    77,    -1,    -1,   233,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  2705,    -1,    -1,
      -1,    -1,    -1,  2711,    -1,   722,  3670,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  5523,    -1,    -1,  2056,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  1797,    -1,    -1,   274,    -1,
      -1,    -1,    -1,    -1,    -1,  3309,  1808,    -1,    -1,    -1,
      -1,    -1,   288,    -1,  2752,   291,    -1,    -1,  3712,    -1,
      -1,    -1,  1824,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  4387,  4388,    -1,
      -1,    -1,    -1,    -1,  4916,  5584,  3740,    -1,  4398,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5598,
      -1,    -1,    -1,    -1,    -1,  4415,    -1,    -1,   191,    -1,
      -1,    -1,    -1,   196,    -1,  1877,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    1892,  1465,    -1,  1895,  1896,   218,   219,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   381,    -1,    -1,    -1,    -1,
     233,    -1,    -1,    -1,  3808,    -1,    -1,    -1,  5657,    -1,
      -1,    -1,    -1,    -1,  1926,  1927,   873,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3438,  3439,  3830,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  4496,    -1,    -1,    -1,
      -1,   274,    -1,    -1,    -1,    -1,    -1,    -1,  3852,  1533,
      -1,  3465,    -1,    -1,  3468,   288,    -1,   209,   291,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   221,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     232,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    1574,    -1,    -1,    -1,    -1,   481,    -1,    -1,  5747,    -1,
      -1,    -1,    -1,   489,   490,   491,   492,   493,   494,   495,
     496,   497,    -1,  2961,    -1,    -1,    -1,    -1,    -1,  5101,
      -1,  5103,    -1,  1607,    -1,    -1,  3540,  3541,  3542,    -1,
    5779,  3935,    -1,    -1,   696,    -1,    -1,    -1,    -1,    -1,
      -1,  5790,    -1,    -1,  2056,    -1,    -1,    -1,   381,    -1,
      -1,  3565,    -1,    -1,  3958,    -1,    -1,    -1,    -1,    -1,
     722,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3584,    -1,    -1,    -1,    -1,    -1,    -1,  1034,    -1,  3983,
      -1,    -1,    -1,    -1,    -1,    -1,  3034,    -1,  1045,    -1,
    3038,    -1,  3606,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  1061,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   456,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  5891,    -1,    -1,    -1,    -1,    -1,   481,    -1,
      -1,    -1,  4712,    -1,    -1,    -1,   489,   490,   491,   492,
     493,   494,   495,   496,   497,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  5256,    -1,    -1,    -1,  3692,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3140,    -1,  4754,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  4766,  3155,    -1,    -1,
      -1,   873,  3160,  1797,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  1808,  3739,    -1,    -1,    -1,  4133,
      -1,  3745,    -1,  3747,    10,    -1,    -1,    13,    -1,  4799,
    1824,    17,    18,    19,    -1,    -1,  3760,    -1,  3762,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    34,    -1,
      -1,    -1,    -1,    -1,    -1,  1222,    -1,    -1,    44,    -1,
      -1,    -1,    -1,    -1,    -1,    51,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  1877,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    77,    -1,    -1,    -1,    -1,    -1,    -1,  1892,    -1,
      -1,  1895,  1896,    -1,    -1,  3829,    -1,  4877,    -1,  4223,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  5409,    -1,  5411,
      -1,    -1,    -1,    -1,    -1,    -1,  4896,    -1,    -1,    -1,
      -1,    -1,  1926,  1927,    -1,  4249,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3871,    -1,    -1,
      -1,    -1,    -1,    -1,  2643,    -1,    -1,    -1,  2647,  2648,
      -1,    -1,  1034,    -1,    -1,    -1,  3890,    -1,    -1,    -1,
      -1,    -1,   634,  1045,    -1,    -1,    -1,    -1,   640,    -1,
      -1,   167,    -1,    -1,    -1,    -1,    -1,    -1,  3912,  1061,
      -1,  3915,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   191,    -1,    -1,    -1,    -1,
     196,    -1,  4982,    -1,    -1,    -1,  2705,    -1,    -1,    -1,
      -1,    -1,  2711,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   218,   219,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   233,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3413,    -1,    -1,  3416,    -1,
    3418,    -1,  2056,  2752,    -1,  3423,    -1,    -1,    -1,    -1,
      -1,  3995,    -1,    -1,    -1,    -1,    -1,  4391,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   274,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1465,    -1,
      -1,    -1,   288,    -1,    -1,   291,    -1,    -1,    -1,    -1,
      -1,    10,    -1,  3471,    13,    -1,    -1,    -1,    17,    18,
      19,  3479,    -1,  5093,  4438,  5095,    -1,    -1,    -1,  4443,
      -1,    -1,    -1,    -1,    -1,    34,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    44,  3504,    -1,    -1,    -1,
    1222,    -1,    51,    -1,    -1,    -1,    -1,    -1,   820,    -1,
    5652,    -1,    -1,    -1,    -1,    -1,  1533,    -1,    -1,    -1,
    5140,    -1,    -1,    -1,    -1,    -1,    -1,   839,    77,    -1,
    5150,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   381,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  1574,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3574,    -1,  3576,    -1,
      -1,  2643,  5192,    -1,    -1,  2647,  2648,  5197,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    1607,    -1,  4166,    -1,    -1,    -1,    -1,   909,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  4575,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  5763,  2961,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2705,    -1,    -1,    -1,    -1,    -1,  2711,
      -1,    -1,   191,  4217,   956,   481,    -1,   196,  4222,    -1,
    4224,    -1,    -1,   489,   490,   491,   492,   493,   494,   495,
     496,   497,  3670,    -1,    -1,    -1,    -1,    -1,    -1,   218,
     219,    -1,    -1,    -1,  4248,    -1,    -1,    -1,    -1,    -1,
    2752,    -1,    -1,    -1,   233,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3034,    -1,    -1,    -1,  3038,
      -1,    -1,    -1,    -1,  3712,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    4294,    -1,    -1,  4297,    -1,   274,    -1,    -1,    -1,    -1,
    5872,    -1,  3740,    -1,    -1,  4699,    -1,    -1,    -1,   288,
      -1,    -1,   291,  1465,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1070,    -1,
    5902,  5903,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  4737,    -1,    -1,    -1,    -1,    -1,    -1,
    1797,    -1,    -1,    -1,    -1,  5405,  1098,  1099,  1100,    -1,
      -1,  1808,    -1,    -1,    -1,  4759,    -1,    -1,    -1,  5419,
    3808,  3140,    -1,    -1,    -1,    -1,    -1,  1824,    -1,    -1,
      -1,  1533,    -1,  4387,  4388,    -1,  3155,    -1,    -1,    -1,
      -1,  3160,  3830,    -1,  4398,    -1,    -1,    -1,    -1,    -1,
    5450,    -1,   381,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  4415,    -1,    -1,  3852,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  1574,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    1877,    -1,    -1,    -1,    -1,    -1,  4830,    -1,    -1,    -1,
      -1,    -1,  6014,    -1,    -1,  1892,    -1,    -1,  1895,  1896,
      -1,    -1,    -1,    -1,    -1,  1607,    -1,    -1,    -1,  2961,
      -1,    -1,    -1,    -1,    -1,  1207,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1926,
    1927,    -1,    -1,    -1,    -1,    -1,  1228,    -1,    -1,    -1,
      -1,    -1,  4496,    -1,    -1,  1237,  5546,  3935,    -1,    -1,
      -1,    -1,   481,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     489,   490,   491,   492,   493,   494,   495,   496,   497,    -1,
    3958,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3034,    -1,    -1,    -1,  3038,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3983,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  4951,    -1,    -1,
      -1,  5611,    -1,  5613,    -1,    -1,    -1,    -1,    -1,  2643,
      -1,    -1,    -1,  2647,  2648,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2056,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2705,    -1,  1375,    -1,    -1,    -1,  2711,  3140,    -1,
      -1,    -1,    -1,    -1,  3413,  1797,    -1,  3416,    -1,  3418,
      -1,    -1,    -1,  3155,  3423,    -1,  1808,    -1,  3160,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  1824,    -1,    -1,    -1,    -1,  5071,  2752,    -1,
      -1,    -1,    -1,    -1,    -1,  5735,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  4133,    -1,    -1,  5748,    -1,
      -1,    -1,  3471,    -1,    -1,    -1,    -1,    -1,  4712,    -1,
    3479,  5761,    -1,  1455,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  1877,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3504,    -1,    -1,    -1,    -1,
    1892,    -1,    -1,  1895,  1896,  5139,    -1,    -1,    -1,    -1,
    4754,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  4766,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    5820,  5821,    -1,    -1,  1926,  1927,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  4223,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  4799,    -1,  1539,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3574,  1548,  3576,    -1,    -1,
      -1,  4249,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5878,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1580,    -1,
      -1,    -1,    -1,    -1,  1586,  1587,    -1,    -1,  1590,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  1603,    -1,    -1,  1606,    -1,    -1,  5261,    -1,    -1,
      -1,    -1,    -1,  4877,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  2961,    -1,    -1,
      -1,    -1,  4896,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3670,    -1,    -1,  2056,    -1,    -1,    -1,    -1,    -1,
      -1,  3413,    -1,    -1,  3416,    -1,  3418,    -1,    -1,  1661,
      -1,  3423,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  1675,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3712,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  4391,    -1,    -1,    -1,    -1,    -1,    -1,
    3034,    -1,    -1,    -1,  3038,    -1,    -1,    -1,    -1,  3471,
      -1,  3740,    -1,    -1,  6024,    -1,    -1,  3479,  4982,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  5387,    -1,    -1,    -1,    -1,  5392,  5393,
    4438,    -1,  3504,    -1,    -1,  4443,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  6072,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    6080,  6081,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3808,
    6090,    -1,  1784,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  1795,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3830,    -1,    -1,    -1,    -1,  3140,    -1,    -1,    -1,
      -1,    -1,  3574,    -1,  3576,    -1,    -1,    -1,    -1,    -1,
      -1,  3155,    -1,  3852,    -1,    -1,  3160,    -1,    -1,  5093,
      -1,  5095,    -1,    -1,    -1,  1837,  1838,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  5505,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    1862,    -1,    -1,    -1,    -1,    -1,    -1,  1869,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  5140,  4575,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  5549,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3935,    -1,  3670,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5192,  3958,
      -1,    -1,    -1,    -1,    -1,    -1,  2643,    -1,    -1,  1941,
    2647,  2648,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3712,    -1,    -1,    -1,  3983,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  1974,  1975,    -1,    -1,    -1,    -1,  3740,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1991,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2705,    -1,
      -1,  4699,    -1,    -1,  2711,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    22,    -1,    -1,    -1,    -1,    27,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4737,
      -1,    -1,    -1,    -1,    -1,  2752,  3808,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    65,    -1,    -1,    -1,
      -1,  4759,    -1,    -1,    -1,    -1,    -1,    -1,  3830,    78,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3413,
      -1,    -1,  3416,    -1,  3418,    94,    -1,    -1,    -1,  3423,
    3852,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   112,  4133,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   136,    -1,    -1,
      -1,    -1,  4830,    -1,    -1,    -1,    -1,  3471,   147,    -1,
      -1,  5405,    -1,    -1,    -1,  3479,    -1,   156,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  5419,    -1,    -1,    -1,    -1,
     169,    22,    -1,    -1,    -1,   174,    -1,    -1,    -1,    -1,
    3504,    -1,   181,  3935,    -1,    -1,    -1,    -1,    -1,    40,
      -1,    -1,    -1,    -1,    -1,    -1,  5450,    -1,    -1,    -1,
      -1,   200,    -1,    -1,  4223,    -1,  3958,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    65,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    78,    -1,    -1,
    4249,  3983,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2643,    -1,    94,    -1,  2647,  2648,    -1,   247,    -1,
    3574,    -1,  3576,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   112,    -1,  4951,  2961,    -1,    -1,   118,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   136,    -1,    -1,    -1,   288,
      -1,    -1,  5546,    -1,    -1,    -1,   147,    -1,    -1,    -1,
      -1,    -1,   301,  2705,    -1,   156,    -1,    -1,    -1,  2711,
      -1,    -1,    -1,    -1,   313,    -1,    -1,    -1,   169,    -1,
      -1,    -1,    -1,    -1,   323,   324,   177,    -1,   327,    -1,
     181,    -1,    -1,    -1,    -1,    -1,    -1,  3034,    -1,    -1,
      -1,  3038,    -1,    -1,    -1,    -1,  3670,    -1,    -1,   200,
    2752,    -1,    -1,    -1,    -1,   354,    -1,  5611,   357,  5613,
      -1,    -1,   361,    -1,   363,    -1,    -1,    -1,    -1,    -1,
      -1,   370,  4391,    -1,   373,    -1,    -1,    -1,    -1,    -1,
      -1,  4133,    -1,  5071,    -1,    -1,   237,    -1,  3712,    -1,
      -1,    -1,    -1,   392,    -1,    -1,   247,    -1,    -1,    -1,
     399,    -1,    -1,    -1,   817,   818,   405,    -1,    -1,   408,
      -1,    -1,    -1,   412,    -1,    -1,  3740,    -1,    -1,  4438,
      -1,   420,    -1,   422,  4443,    -1,    -1,    -1,   427,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   288,    -1,    -1,
     291,   440,    -1,  3140,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  5139,    -1,    -1,   453,    -1,    -1,    -1,  3155,    -1,
      -1,    -1,   313,  3160,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  4223,    -1,    -1,    -1,    -1,   327,    -1,    -1,    -1,
      -1,  5735,   895,   334,  3808,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  4249,    -1,    -1,
      -1,    -1,    -1,   354,    -1,    -1,  3830,  5761,    -1,    -1,
      -1,  2503,   363,    -1,    -1,    -1,    -1,    -1,    -1,   370,
      -1,  2513,   373,    -1,    -1,    -1,    -1,    -1,  3852,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   392,    -1,    -1,    -1,    -1,    -1,    -1,   399,    -1,
    2542,    -1,    -1,    -1,   405,    -1,  4575,   408,   409,  2961,
     411,   412,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  5261,    -1,    -1,   427,    -1,    -1,    -1,
      -1,    -1,    -1,   434,    -1,    -1,   437,    -1,    -1,   440,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  2589,  2590,    -1,
      -1,    -1,   453,  1016,  1017,    -1,    -1,    -1,    -1,    -1,
      -1,  3935,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  5878,    -1,    -1,    -1,    -1,    -1,
      -1,  2623,  3034,    -1,  3958,    -1,  3038,    -1,    -1,  4391,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3983,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    4699,    -1,    -1,    -1,    -1,    -1,  4438,    -1,    -1,    -1,
      -1,  4443,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5387,
      -1,    -1,    -1,    -1,  5392,  5393,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3413,    -1,  4737,  3416,
      -1,  3418,    -1,    -1,    -1,    -1,  3423,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3140,    -1,
    4759,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3155,    -1,    -1,    -1,    -1,  3160,    -1,
      -1,    -1,    -1,    -1,  2756,    -1,    -1,    -1,    -1,    -1,
    6024,    -1,    -1,    -1,  3471,    -1,    -1,    -1,    -1,  2771,
      -1,    -1,  3479,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2793,    -1,    -1,    -1,    -1,    -1,  3504,    -1,  4133,
      -1,  4830,    -1,    -1,    -1,    -1,    -1,  5505,  6072,    -1,
      -1,    -1,    -1,  4575,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  6090,    -1,    -1,    -1,
      -1,  1254,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  5549,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  1285,    -1,    -1,    -1,    -1,  3574,    -1,  3576,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  2879,  2880,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4223,
    1313,  1314,  1315,    -1,  1317,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  1337,  4249,    -1,    -1,    -1,    -1,
      -1,    -1,  4951,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  4699,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3670,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  4737,    -1,    -1,  2980,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  4759,    -1,    -1,
      -1,  3413,    -1,    -1,  3416,  3712,  3418,    -1,    -1,    -1,
      -1,  3423,    -1,    -1,    -1,    -1,  1439,    -1,    -1,    -1,
    1443,  1444,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3740,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  5071,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  4391,    -1,  3471,
      -1,    -1,    -1,    20,    -1,    -1,    -1,  3479,  4830,    -1,
      -1,    -1,    -1,    30,    -1,    32,    33,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3504,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3808,    -1,    60,  4438,    -1,    -1,    -1,    -1,  4443,
    5139,    -1,    -1,    -1,    -1,    72,    -1,    74,    75,    -1,
      -1,    -1,    -1,  3830,    81,    -1,    83,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    95,    -1,
      97,    -1,    -1,    -1,    -1,  3852,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   114,    -1,    -1,
     117,    -1,  3574,    -1,  3576,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   132,    -1,   134,    -1,    -1,
      -1,   138,    -1,    -1,    -1,    -1,    -1,   144,    -1,  4951,
      -1,    -1,    -1,    -1,    -1,   152,    -1,   154,    -1,    -1,
      -1,    -1,    -1,    -1,   161,    -1,    -1,  1329,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   178,    -1,    -1,    -1,    -1,    -1,    -1,  3935,    -1,
      -1,    -1,  5261,    -1,    -1,    -1,    -1,    -1,   195,    -1,
      -1,  4575,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3958,    -1,    -1,    -1,    -1,    -1,    -1,  3670,    -1,
      -1,  1383,    -1,  1686,  1687,  1688,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3983,    -1,   235,   236,
      -1,    -1,    -1,    -1,   241,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3295,    -1,    -1,    -1,    -1,   255,    -1,
    3712,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5071,
      -1,    -1,    -1,    -1,  3316,    -1,   273,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3740,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   310,    -1,    -1,    -1,    -1,  5387,    -1,
      -1,   318,    -1,  5392,  5393,  4699,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   332,    -1,  5139,    -1,    -1,
      27,   338,   339,    -1,   341,    -1,    -1,    -1,    -1,   346,
      -1,    -1,   349,    -1,    -1,   352,  3808,    -1,   355,    -1,
      -1,    -1,    -1,  4737,    -1,   362,    -1,    -1,    -1,    -1,
      -1,   368,   369,    -1,    -1,    -1,    -1,    -1,  3830,   376,
      -1,    -1,    -1,   380,    -1,  4759,  4133,    -1,    -1,    -1,
      -1,    78,    -1,   390,    -1,    -1,    -1,    -1,    -1,    -1,
    3852,    -1,    -1,    -1,    -1,    -1,    -1,    94,   405,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   112,    -1,    -1,   425,    -1,
      -1,   118,    -1,    -1,    -1,    -1,  5505,    -1,    -1,   436,
      -1,    -1,    -1,    -1,    -1,   442,    -1,    -1,    -1,   136,
     447,    -1,    -1,    -1,    -1,    -1,  4830,    -1,    -1,  5261,
     147,    -1,    -1,   460,    -1,    -1,    -1,    -1,    -1,   156,
      -1,    -1,    -1,    -1,    -1,    -1,  4223,    -1,    -1,    -1,
    5549,    -1,   169,  3935,    -1,    -1,   483,   174,    -1,    -1,
      -1,    -1,    -1,    -1,   181,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  4249,    -1,   501,    -1,  3958,   504,    -1,    -1,
      -1,    -1,    -1,   200,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    1692,  3983,    -1,    -1,  1696,    -1,    -1,    -1,   225,    -1,
    3582,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2012,
    3592,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     247,  2024,    -1,  2026,    -1,  2028,    -1,    -1,  2031,  2032,
    2033,    -1,    -1,    -1,    -1,    -1,  2039,  4951,    -1,  2042,
      -1,    -1,    -1,    -1,    -1,  5387,    -1,    -1,    -1,    -1,
    5392,  5393,    -1,    -1,  2057,  2058,  2059,    -1,    -1,    -1,
      -1,   288,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2074,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   313,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   323,   324,    -1,    -1,
     327,    -1,    -1,    -1,  4391,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   354,    -1,    -1,
     357,    -1,    -1,    -1,   361,    -1,   363,    -1,    -1,    -1,
      -1,  4133,    -1,   370,    -1,    -1,   373,    -1,    -1,    -1,
      -1,  4438,    -1,    -1,    -1,    -1,  4443,  5071,    -1,    -1,
      -1,    -1,    -1,  5505,    -1,   392,    -1,    -1,    -1,  3751,
    3752,  3753,   399,    -1,    -1,    -1,    -1,   404,   405,    -1,
      -1,   408,    -1,    -1,    -1,   412,  3768,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   422,    -1,    -1,    -1,    -1,
     427,    -1,    -1,    -1,    -1,    -1,    -1,  5549,    -1,    -1,
      -1,    -1,    -1,   440,  2217,    -1,    -1,    -1,    -1,  3801,
    3802,    -1,    -1,    -1,  3806,  5139,   453,    -1,    -1,    -1,
      -1,  4223,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2257,    -1,    -1,  4249,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4575,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  2310,  2010,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2025,    -1,    -1,    -1,  2029,  3910,    -1,
      -1,  3913,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  2044,  2045,  2046,    -1,  2048,  5261,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4391,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  4699,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  4438,    -1,    -1,    -1,
    4737,  4443,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    4042,  4043,  4044,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  4759,  5387,    -1,    -1,    -1,    -1,  5392,  5393,
      -1,    -1,  2485,  2486,  2487,  2488,  2489,  2490,  2491,  2492,
    2493,    -1,  2495,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2504,    -1,  2506,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2544,    -1,  4830,    -1,  2548,    -1,    -1,  2551,    -1,
    2553,    -1,    -1,  2556,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  4575,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  5505,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2609,  2610,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  5549,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  4951,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2692,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  4699,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  4737,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  4759,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  5071,    -1,  4368,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    2502,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4400,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4830,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    4432,    -1,  5139,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  4467,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2596,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  4484,    -1,    -1,    -1,  2608,    -1,    -1,    -1,
      -1,  2613,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2927,  2928,  2929,    -1,    -1,    -1,
    2933,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  2960,    -1,  4951,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  5261,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  4603,  4604,  4605,  4606,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5071,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    5387,    -1,    -1,    -1,    -1,  5392,  5393,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  5139,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3168,    -1,    -1,    -1,    -1,
    3173,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3201,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3212,
      -1,  3214,  3215,    -1,    -1,    -1,    -1,    -1,  5505,    -1,
      -1,    -1,    -1,    -1,    -1,  3228,    -1,    -1,  3231,    -1,
    3233,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  5549,    -1,  3267,    -1,  3269,    -1,  3271,  5261,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3359,    -1,    -1,    -1,
      -1,  3364,  4944,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  4955,    -1,    -1,  3379,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  5387,    -1,    -1,    -1,    -1,
    5392,  5393,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3444,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3171,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3191,
    3192,    -1,  3194,    -1,    -1,    -1,    -1,  3199,  3200,    -1,
    3202,    -1,  3204,    -1,    -1,    -1,  3208,    -1,    -1,  3211,
      -1,    -1,    -1,  5505,  3216,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3225,    -1,    -1,    -1,    -1,  3230,    -1,
      -1,    -1,    -1,    -1,    -1,  3237,  3238,  3239,  3240,    -1,
      -1,    -1,  3244,  3245,    -1,  3247,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  5549,    -1,    -1,
      -1,    -1,  3264,    -1,  3266,    -1,    -1,    -1,    -1,    -1,
      -1,  3273,  3274,  3275,  3276,  3277,  3278,  3279,  3280,  3281,
    3282,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3317,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  5214,    -1,    -1,    -1,    -1,  5219,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  5238,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3697,    -1,    -1,    -1,    -1,    -1,
    3703,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3459,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3782,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    5372,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    5472,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5500,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3932,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3941,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3949,    -1,  3951,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3978,  3979,  3980,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3997,    -1,    -1,    -1,    -1,  3701,
    3702,    -1,  4005,    -1,  3706,  4008,    -1,  4010,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  4020,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  4028,  4029,    -1,    -1,    -1,
      -1,    -1,    -1,  3735,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  4110,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  4127,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3931,
      -1,    -1,    -1,    -1,    -1,  3937,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3955,  3956,    -1,    -1,  3959,  3960,  3961,
    3962,    -1,    -1,  3965,  3966,  3967,  3968,  3969,  3970,  3971,
    3972,  3973,  3974,  3975,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3998,    -1,    -1,  4001,
      -1,  4003,    -1,    -1,  4006,  4007,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    4022,  4023,  4024,  4025,    -1,  4027,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    4092,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    4142,  4444,  4445,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  4455,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4522,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    4533,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4572,
    4573,    -1,    -1,    -1,    -1,    -1,  4579,  4580,    -1,    -1,
      -1,  4584,    -1,    -1,    -1,  4588,    -1,    -1,  4591,  4592,
      -1,    -1,    -1,  4596,    -1,    -1,    -1,    -1,    -1,  4602,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4642,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    4653,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4661,  4361,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4681,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  4404,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4782,
      -1,    -1,    -1,    -1,    -1,  4788,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  4523,    -1,    -1,    -1,  4527,    -1,  4529,  4530,    -1,
      -1,    -1,    -1,  4535,  4536,  4537,  4538,    -1,    -1,    -1,
    4542,  4543,  4544,  4545,  4546,  4547,  4548,  4549,  4550,  4551,
    4552,  4553,  4554,  4856,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  4578,    -1,    -1,  4581,
      -1,  4583,    -1,    -1,  4586,    -1,    -1,  4589,  4590,    -1,
      -1,  4593,  4594,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    4652,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  4666,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  5000,    -1,    -1,
      -1,    -1,    -1,  5006,  5007,  5008,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5031,  5032,
      -1,    -1,  5035,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5061,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5072,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  5088,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  4859,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  4946,  4947,    -1,    -1,    -1,    -1,
      -1,    -1,  4954,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  5294,    -1,    -1,  4996,    -1,    -1,    -1,    -1,    -1,
    5002,  5003,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5021,
      -1,  5023,    -1,    -1,    -1,  5027,  5028,  5029,  5030,    -1,
      -1,  5033,  5034,    -1,  5337,    -1,  5038,    -1,    -1,    -1,
    5042,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  5055,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  5073,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  5087,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  5397,  5097,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  5439,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5161,
      -1,    -1,    -1,  5165,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5200,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  5528,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  5558,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  5586,    -1,  5287,    -1,  5289,  5290,  5291,
    5292,  5293,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  5304,  5305,  5306,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  5319,    -1,    -1,
    5322,    -1,    -1,    -1,  5326,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  5344,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  5359,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  5704,  5705,  5706,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5722,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5732,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5802,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  5826,    -1,  5828,    -1,  5529,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  5543,    -1,  5545,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  5597,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  5633,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  5945,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  5990,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  5699,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  5746,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  6059,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5831,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  5844,  5845,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  5858,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  5899,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  5924,    -1,     3,    -1,     5,     6,    -1,     8,
       9,    10,    11,    12,    -1,    -1,    -1,    -1,  5940,  5941,
      -1,    20,    21,    22,    23,    24,    25,    26,    27,    28,
      29,    30,    31,    -1,    -1,    -1,    -1,    36,    -1,    -1,
      39,    40,    41,    -1,    43,    44,    45,    46,    47,    48,
      49,    50,    51,    52,    53,    54,    55,    -1,    57,    58,
      59,    60,    61,    62,    63,    64,    65,    66,    67,    68,
      69,    70,    -1,    72,    73,    74,    75,    76,  6000,    78,
      -1,    80,    81,    82,    83,    84,    85,    86,    87,    88,
      89,    -1,    91,    92,    93,    94,    95,    96,    -1,    98,
      99,   100,   101,   102,   103,   104,   105,   106,   107,   108,
     109,   110,   111,   112,   113,   114,   115,   116,   117,   118,
     119,    -1,   121,   122,   123,   124,   125,   126,   127,    -1,
     129,   130,   131,   132,   133,    -1,   135,   136,   137,   138,
     139,    -1,   141,   142,   143,    -1,   145,   146,   147,    -1,
     149,   150,   151,   152,   153,   154,   155,   156,   157,   158,
     159,   160,    -1,   162,   163,   164,   165,   166,    -1,   168,
      -1,   170,   171,    -1,   173,   174,   175,   176,   177,    -1,
     179,   180,    -1,   182,   183,   184,    -1,   186,   187,   188,
     189,   190,   191,   192,   193,   194,   195,    -1,   197,   198,
     199,   200,   201,   202,   203,    -1,   205,   206,   207,   208,
     209,   210,   211,   212,   213,    -1,   215,    -1,   217,   218,
     219,   220,   221,   222,   223,   224,   225,   226,    -1,    -1,
     229,   230,   231,   232,   233,    -1,   235,   236,   237,   238,
     239,   240,   241,   242,   243,   244,   245,   246,   247,   248,
     249,   250,   251,   252,   253,   254,   255,   256,   257,   258,
     259,   260,   261,   262,   263,   264,   265,   266,   267,   268,
     269,   270,   271,   272,   273,   274,   275,   276,   277,   278,
     279,   280,   281,   282,    -1,   284,   285,    -1,    -1,   288,
     289,   290,    -1,    -1,   293,   294,   295,   296,   297,   298,
     299,   300,   301,   302,   303,   304,   305,   306,   307,   308,
     309,    -1,    -1,   312,   313,   314,   315,   316,   317,   318,
     319,    -1,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,   333,   334,   335,    -1,   337,   338,
     339,   340,   341,   342,   343,   344,   345,   346,   347,   348,
     349,    -1,   351,   352,   353,   354,   355,   356,   357,   358,
     359,   360,   361,   362,   363,   364,   365,   366,   367,   368,
      -1,   370,   371,   372,   373,   374,   375,   376,   377,   378,
     379,   380,   381,   382,   383,   384,   385,    -1,   387,   388,
     389,   390,   391,   392,   393,   394,   395,   396,   397,   398,
     399,   400,   401,    -1,   403,   404,    -1,   406,   407,   408,
     409,   410,   411,   412,    -1,   414,   415,   416,    -1,    -1,
     419,   420,   421,   422,   423,   424,   425,   426,   427,   428,
     429,   430,   431,   432,    -1,   434,   435,   436,   437,   438,
     439,   440,    -1,   442,   443,   444,   445,   446,   447,   448,
     449,   450,   451,   452,   453,   454,   455,    -1,    -1,   458,
      -1,    -1,   461,   462,   463,   464,   465,   466,   467,   468,
     469,   470,   471,   472,   473,   474,   475,   476,   477,   478,
     479,   480,   481,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   492,   493,   494,    -1,    -1,    -1,    -1,
      -1,    -1,   501,   502,     3,    -1,     5,     6,    -1,     8,
       9,    10,    11,    12,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    20,    21,    22,    23,    24,    25,    26,    27,    -1,
      29,    30,    31,    -1,    -1,    -1,    -1,    36,    -1,    -1,
      39,    40,    41,    -1,    43,    44,    45,    46,    47,    48,
      49,    50,    51,    52,    53,    54,    55,    -1,    57,    58,
      59,    60,    61,    62,    63,    64,    65,    66,    67,    68,
      69,    70,    -1,    72,    73,    74,    75,    76,    -1,    78,
      -1,    80,    81,    82,    83,    84,    85,    86,    87,    88,
      89,    -1,    91,    92,    93,    94,    95,    96,    -1,    98,
      99,   100,   101,   102,   103,   104,   105,   106,   107,   108,
     109,   110,   111,   112,   113,   114,   115,   116,   117,   118,
     119,    -1,   121,   122,   123,   124,   125,   126,   127,    -1,
     129,   130,   131,   132,    -1,    -1,   135,   136,   137,   138,
     139,    -1,   141,   142,   143,    -1,   145,   146,   147,    -1,
     149,   150,   151,   152,   153,   154,   155,   156,   157,   158,
     159,   160,    -1,   162,   163,   164,   165,   166,    -1,   168,
      -1,   170,   171,    -1,   173,   174,   175,   176,   177,    -1,
     179,   180,    -1,   182,   183,   184,    -1,   186,   187,   188,
     189,   190,   191,   192,   193,   194,   195,    -1,   197,   198,
     199,   200,   201,   202,   203,    -1,   205,   206,   207,   208,
     209,   210,   211,   212,   213,    -1,   215,    -1,   217,   218,
     219,   220,   221,   222,   223,   224,   225,   226,    -1,    -1,
     229,   230,   231,   232,   233,    -1,   235,   236,   237,   238,
     239,   240,   241,   242,   243,   244,   245,   246,   247,   248,
     249,   250,   251,   252,   253,   254,   255,   256,   257,   258,
     259,   260,   261,   262,   263,   264,   265,   266,   267,   268,
     269,   270,   271,   272,   273,   274,   275,   276,   277,   278,
     279,   280,   281,   282,    -1,   284,   285,    -1,    -1,   288,
     289,   290,    -1,    -1,   293,   294,   295,   296,   297,   298,
     299,   300,   301,   302,   303,   304,   305,   306,   307,   308,
     309,    -1,    -1,   312,   313,   314,   315,   316,   317,   318,
     319,    -1,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,   333,   334,   335,    -1,   337,   338,
     339,   340,   341,   342,   343,   344,   345,   346,   347,   348,
     349,    -1,   351,   352,   353,   354,   355,   356,   357,   358,
     359,   360,   361,   362,   363,   364,   365,   366,   367,   368,
     369,   370,   371,   372,   373,   374,   375,   376,   377,   378,
     379,   380,   381,   382,   383,   384,   385,    -1,   387,   388,
     389,   390,   391,   392,   393,   394,   395,   396,   397,   398,
     399,   400,   401,    -1,   403,   404,   405,   406,   407,   408,
     409,   410,   411,   412,    -1,   414,   415,   416,    -1,    -1,
     419,   420,   421,   422,   423,   424,   425,   426,   427,   428,
     429,   430,   431,   432,    -1,   434,   435,   436,   437,   438,
     439,   440,    -1,   442,   443,   444,   445,   446,   447,   448,
      -1,   450,   451,   452,   453,   454,   455,    -1,    -1,   458,
      -1,   460,   461,   462,   463,   464,   465,   466,   467,   468,
     469,   470,   471,   472,   473,   474,   475,   476,   477,   478,
     479,   480,   481,    -1,   483,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   492,   493,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   501,   502,     3,    -1,     5,     6,    -1,     8,
       9,    10,    11,    12,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    20,    21,    22,    23,    24,    25,    26,    27,    -1,
      29,    30,    31,    -1,    -1,    -1,    -1,    36,    -1,    -1,
      39,    40,    41,    -1,    43,    44,    45,    46,    47,    48,
      49,    50,    51,    52,    53,    54,    55,    -1,    57,    58,
      59,    60,    61,    62,    63,    64,    65,    66,    67,    68,
      69,    70,    -1,    72,    73,    74,    75,    76,    -1,    78,
      -1,    80,    81,    82,    83,    84,    85,    86,    87,    88,
      89,    -1,    91,    92,    93,    94,    95,    96,    -1,    98,
      99,   100,   101,   102,   103,   104,   105,   106,   107,   108,
     109,   110,   111,   112,   113,   114,   115,   116,   117,   118,
     119,    -1,   121,   122,   123,   124,   125,   126,   127,    -1,
     129,   130,   131,   132,    -1,    -1,   135,   136,   137,   138,
     139,    -1,   141,   142,   143,    -1,   145,   146,   147,    -1,
     149,   150,   151,   152,   153,   154,   155,   156,   157,   158,
     159,   160,    -1,   162,   163,   164,   165,   166,    -1,   168,
      -1,   170,   171,    -1,   173,   174,   175,   176,   177,    -1,
     179,   180,    -1,   182,   183,   184,    -1,   186,   187,   188,
     189,   190,   191,   192,   193,   194,   195,    -1,   197,   198,
     199,   200,   201,   202,   203,    -1,   205,   206,   207,   208,
     209,   210,   211,   212,   213,    -1,   215,    -1,   217,   218,
     219,   220,   221,   222,   223,   224,   225,   226,    -1,    -1,
     229,   230,   231,   232,   233,    -1,   235,   236,   237,   238,
     239,   240,   241,   242,   243,   244,   245,   246,   247,   248,
     249,   250,   251,   252,   253,   254,   255,   256,   257,   258,
     259,   260,   261,   262,   263,   264,   265,   266,   267,   268,
     269,   270,   271,   272,   273,   274,   275,   276,   277,   278,
     279,   280,   281,   282,    -1,   284,   285,    -1,    -1,   288,
     289,   290,    -1,    -1,   293,   294,   295,   296,   297,   298,
     299,   300,   301,   302,   303,   304,   305,   306,   307,   308,
     309,    -1,    -1,   312,   313,   314,   315,   316,   317,   318,
     319,    -1,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,   333,   334,   335,    -1,   337,   338,
     339,   340,   341,   342,   343,   344,   345,   346,   347,   348,
     349,    -1,   351,   352,   353,   354,   355,   356,   357,   358,
     359,   360,   361,   362,   363,   364,   365,   366,   367,   368,
      -1,   370,   371,   372,   373,   374,   375,   376,   377,   378,
     379,   380,   381,   382,   383,   384,   385,    -1,   387,   388,
     389,   390,   391,   392,   393,   394,   395,   396,   397,   398,
     399,   400,   401,    -1,   403,   404,    -1,   406,   407,   408,
     409,   410,   411,   412,    -1,   414,   415,   416,    -1,    -1,
     419,   420,   421,   422,   423,   424,   425,   426,   427,   428,
     429,   430,   431,   432,    -1,   434,   435,   436,   437,   438,
     439,   440,    -1,   442,   443,   444,   445,   446,   447,   448,
      -1,   450,   451,   452,   453,   454,   455,    -1,    -1,   458,
      -1,    -1,   461,   462,   463,   464,   465,   466,   467,   468,
     469,   470,   471,   472,   473,   474,   475,   476,   477,   478,
     479,   480,   481,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   492,   493,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   501,   502,     3,    -1,     5,     6,    -1,     8,
       9,    10,    11,    12,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    20,    21,    22,    23,    24,    25,    26,    27,    -1,
      29,    30,    31,    -1,    -1,    -1,    -1,    36,    -1,    -1,
      39,    40,    41,    -1,    43,    44,    45,    46,    47,    48,
      49,    50,    51,    52,    53,    54,    55,    -1,    57,    58,
      59,    60,    61,    62,    63,    64,    65,    66,    67,    68,
      69,    70,    -1,    72,    73,    74,    75,    76,    -1,    78,
      -1,    80,    81,    82,    83,    84,    85,    86,    87,    88,
      89,    -1,    91,    92,    93,    94,    95,    96,    -1,    98,
      99,   100,   101,   102,   103,   104,   105,   106,   107,   108,
     109,   110,   111,   112,   113,   114,   115,   116,   117,   118,
     119,    -1,   121,   122,   123,   124,   125,   126,   127,    -1,
     129,   130,   131,   132,    -1,    -1,   135,   136,   137,   138,
     139,    -1,   141,   142,   143,    -1,   145,   146,   147,    -1,
     149,   150,   151,   152,   153,   154,   155,   156,   157,   158,
     159,   160,    -1,   162,   163,   164,   165,   166,    -1,   168,
      -1,   170,   171,    -1,   173,   174,   175,   176,   177,    -1,
     179,   180,    -1,   182,   183,   184,    -1,   186,   187,   188,
     189,   190,   191,   192,   193,   194,   195,    -1,   197,   198,
     199,   200,   201,   202,   203,    -1,   205,   206,   207,   208,
     209,   210,   211,   212,   213,    -1,   215,    -1,   217,   218,
     219,   220,   221,   222,   223,   224,   225,   226,    -1,    -1,
     229,   230,   231,   232,   233,    -1,   235,   236,   237,   238,
     239,   240,   241,   242,   243,   244,   245,   246,   247,   248,
     249,   250,   251,   252,   253,   254,   255,   256,   257,   258,
     259,   260,   261,   262,   263,   264,   265,   266,   267,   268,
     269,   270,   271,   272,   273,   274,   275,   276,   277,   278,
     279,   280,   281,   282,    -1,   284,   285,    -1,    -1,   288,
     289,   290,    -1,    -1,   293,   294,   295,   296,   297,   298,
     299,   300,   301,   302,   303,   304,   305,   306,   307,   308,
     309,    -1,    -1,   312,   313,   314,   315,   316,   317,   318,
     319,    -1,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,   333,   334,   335,    -1,   337,   338,
     339,   340,   341,   342,   343,   344,   345,   346,   347,   348,
     349,    -1,   351,   352,   353,   354,   355,   356,   357,   358,
     359,   360,   361,   362,   363,   364,   365,   366,   367,   368,
      -1,   370,   371,   372,   373,   374,   375,   376,   377,   378,
     379,   380,   381,   382,   383,   384,   385,    -1,   387,   388,
     389,   390,   391,   392,   393,   394,   395,   396,   397,   398,
     399,   400,   401,    -1,   403,   404,    -1,   406,   407,   408,
     409,   410,   411,   412,    -1,   414,   415,   416,    -1,    -1,
     419,   420,   421,   422,   423,   424,   425,   426,   427,   428,
     429,   430,   431,   432,    -1,   434,   435,   436,   437,   438,
     439,   440,    -1,   442,   443,   444,   445,   446,   447,   448,
      -1,   450,   451,   452,   453,   454,   455,    -1,    -1,   458,
      -1,    -1,   461,   462,   463,   464,   465,   466,   467,   468,
     469,   470,   471,   472,   473,   474,   475,   476,   477,   478,
     479,   480,   481,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   492,   493,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   501,   502,     3,    -1,     5,     6,    -1,     8,
       9,    10,    11,    12,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    20,    21,    22,    23,    24,    25,    26,    27,    -1,
      29,    30,    31,    -1,    -1,    -1,    -1,    36,    -1,    -1,
      39,    40,    41,    -1,    43,    44,    45,    46,    47,    48,
      49,    50,    51,    52,    53,    54,    55,    -1,    57,    58,
      59,    60,    61,    62,    63,    64,    65,    66,    67,    68,
      69,    70,    -1,    72,    73,    74,    75,    76,    -1,    78,
      -1,    80,    81,    82,    83,    84,    85,    86,    87,    88,
      89,    -1,    91,    92,    93,    94,    95,    96,    -1,    98,
      99,   100,   101,   102,   103,   104,   105,   106,   107,   108,
     109,   110,   111,   112,   113,   114,   115,   116,   117,   118,
     119,    -1,   121,   122,   123,   124,   125,   126,   127,    -1,
     129,   130,   131,   132,    -1,    -1,   135,   136,   137,   138,
     139,    -1,   141,   142,   143,    -1,   145,   146,   147,    -1,
     149,   150,   151,   152,   153,   154,   155,   156,   157,   158,
     159,   160,    -1,   162,   163,   164,   165,   166,    -1,   168,
      -1,   170,   171,    -1,   173,   174,   175,   176,   177,    -1,
     179,   180,    -1,   182,   183,   184,    -1,   186,   187,   188,
     189,   190,   191,   192,   193,   194,   195,    -1,   197,   198,
     199,   200,   201,   202,   203,    -1,   205,   206,   207,   208,
     209,   210,   211,   212,   213,    -1,   215,    -1,   217,   218,
     219,   220,   221,   222,   223,   224,   225,   226,    -1,    -1,
     229,   230,   231,   232,   233,    -1,   235,   236,   237,   238,
     239,   240,   241,   242,   243,   244,   245,   246,   247,   248,
     249,   250,   251,   252,   253,   254,   255,   256,   257,   258,
     259,   260,   261,   262,   263,   264,   265,   266,   267,   268,
     269,   270,   271,   272,   273,   274,   275,   276,   277,   278,
     279,   280,   281,   282,    -1,   284,   285,    -1,    -1,   288,
     289,   290,    -1,    -1,   293,   294,   295,   296,   297,   298,
     299,   300,   301,   302,   303,   304,   305,   306,   307,   308,
     309,    -1,    -1,   312,   313,   314,   315,   316,   317,   318,
     319,    -1,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,   333,   334,   335,    -1,   337,   338,
     339,   340,   341,   342,   343,   344,   345,   346,   347,   348,
     349,    -1,   351,   352,   353,   354,   355,   356,   357,   358,
     359,   360,   361,   362,   363,   364,   365,   366,   367,   368,
      -1,   370,   371,   372,   373,   374,   375,   376,   377,   378,
     379,   380,   381,   382,   383,   384,   385,    -1,   387,   388,
     389,   390,   391,   392,   393,   394,   395,   396,   397,   398,
     399,   400,   401,    -1,   403,   404,    -1,   406,   407,   408,
     409,   410,   411,   412,    -1,   414,   415,   416,    -1,    -1,
     419,   420,   421,   422,   423,   424,   425,   426,   427,   428,
     429,   430,   431,   432,    -1,   434,   435,   436,   437,   438,
     439,   440,    -1,   442,   443,   444,   445,   446,   447,   448,
      -1,   450,   451,   452,   453,   454,   455,    -1,    -1,   458,
      -1,    -1,   461,   462,   463,   464,   465,   466,   467,   468,
     469,   470,   471,   472,   473,   474,   475,   476,   477,   478,
     479,   480,   481,    -1,    -1,    -1,    -1,     3,    -1,    -1,
      -1,    -1,    -1,   492,   493,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   501,   502,    20,    21,    22,    23,    24,    25,
      26,    27,    -1,    29,    30,    31,    -1,    -1,    -1,    -1,
      -1,    37,    -1,    39,    40,    41,    -1,    43,    44,    45,
      46,    -1,    48,    49,    50,    51,    52,    -1,    54,    55,
      -1,    57,    58,    59,    60,    61,    62,    63,    -1,    -1,
      66,    67,    68,    69,    70,    -1,    72,    73,    74,    75,
      76,    -1,    -1,    -1,    80,    81,    82,    83,    84,    85,
      -1,    87,    88,    89,    -1,    91,    92,    93,    94,    95,
      96,    -1,    98,    99,   100,   101,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   109,   110,   111,   112,   113,   114,   115,
     116,   117,    -1,   119,    -1,   121,   122,   123,   124,   125,
     126,   127,    -1,   129,   130,   131,   132,    -1,    -1,   135,
     136,   137,   138,   139,    -1,   141,   142,   143,    -1,   145,
     146,   147,    -1,   149,   150,   151,   152,   153,   154,   155,
     156,   157,   158,    -1,   160,    -1,   162,   163,   164,   165,
     166,    -1,   168,    -1,   170,    -1,    -1,   173,   174,   175,
     176,   177,    -1,   179,   180,    -1,   182,   183,   184,    -1,
     186,   187,   188,   189,   190,    -1,   192,   193,   194,   195,
      -1,   197,   198,   199,   200,   201,   202,   203,    -1,   205,
     206,   207,   208,   209,   210,   211,   212,   213,    -1,   215,
      -1,   217,    -1,    -1,   220,   221,   222,   223,   224,   225,
     226,    -1,    -1,   229,   230,   231,   232,    -1,    -1,   235,
     236,   237,    -1,    -1,   240,   241,   242,   243,   244,   245,
     246,   247,   248,   249,   250,   251,   252,   253,   254,   255,
     256,   257,   258,   259,   260,   261,   262,   263,   264,   265,
     266,   267,   268,   269,   270,    -1,   272,   273,    -1,   275,
      -1,   277,   278,   279,   280,   281,   282,    -1,   284,   285,
      -1,    -1,   288,   289,   290,    -1,    -1,   293,   294,   295,
      -1,   297,    -1,   299,   300,   301,   302,   303,   304,   305,
     306,   307,   308,   309,    -1,    -1,   312,   313,   314,   315,
     316,   317,   318,   319,    -1,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
      -1,   337,   338,   339,   340,   341,   342,   343,   344,   345,
     346,   347,   348,   349,    -1,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
     366,   367,   368,    -1,   370,   371,   372,   373,   374,    -1,
     376,   377,   378,   379,   380,    -1,   382,   383,   384,   385,
      -1,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,   399,   400,   401,    -1,   403,   404,    -1,
     406,    -1,   408,   409,   410,   411,   412,    -1,   414,   415,
     416,    -1,    -1,   419,   420,   421,   422,   423,    -1,   425,
     426,   427,   428,   429,   430,   431,   432,    -1,    -1,   435,
     436,   437,   438,   439,    -1,    -1,   442,   443,   444,   445,
     446,   447,   448,    -1,   450,    -1,   452,   453,   454,   455,
      -1,    -1,   458,    -1,    -1,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,   478,   479,   480,    -1,    -1,    -1,    -1,    -1,
       3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   502,    20,    21,    22,
      23,    24,    25,    26,    27,    -1,    29,    30,    31,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    39,    40,    41,    -1,
      43,    44,    45,    46,    47,    48,    49,    50,    -1,    52,
      53,    54,    55,    -1,    57,    58,    59,    60,    61,    62,
      63,    -1,    -1,    66,    67,    68,    69,    70,    -1,    72,
      73,    74,    75,    -1,    -1,    78,    -1,    80,    81,    82,
      83,    84,    85,    86,    87,    88,    89,    -1,    91,    92,
      93,    94,    95,    96,    -1,    98,    99,   100,   101,    -1,
      -1,    -1,   105,    -1,    -1,    -1,   109,   110,   111,   112,
     113,   114,   115,   116,   117,    -1,   119,    -1,   121,   122,
     123,   124,   125,   126,   127,    -1,   129,   130,   131,   132,
      -1,    -1,   135,   136,   137,   138,   139,    -1,   141,   142,
     143,    -1,   145,   146,   147,    -1,   149,   150,   151,   152,
      -1,   154,   155,   156,   157,    -1,    -1,   160,    -1,   162,
     163,   164,   165,   166,    -1,   168,    -1,   170,   171,    -1,
     173,   174,   175,   176,   177,    -1,   179,    -1,    -1,    -1,
     183,   184,    -1,   186,   187,   188,   189,   190,   191,   192,
     193,   194,   195,   196,   197,   198,   199,   200,   201,   202,
     203,    -1,   205,   206,   207,   208,   209,   210,   211,   212,
     213,    -1,   215,    -1,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,    -1,    -1,   229,    -1,   231,   232,
     233,    -1,   235,   236,   237,    -1,    -1,   240,   241,   242,
     243,   244,   245,   246,   247,   248,   249,   250,   251,   252,
     253,   254,   255,   256,   257,   258,   259,   260,   261,   262,
     263,   264,   265,   266,   267,    -1,    -1,   270,    -1,   272,
     273,   274,   275,    -1,    -1,   278,   279,   280,   281,   282,
      -1,   284,   285,    -1,    -1,   288,   289,   290,    -1,    -1,
     293,   294,   295,   296,   297,   298,    -1,   300,   301,   302,
     303,   304,   305,   306,   307,   308,   309,    -1,    -1,   312,
     313,    -1,   315,    -1,   317,   318,   319,    -1,   321,   322,
     323,   324,   325,   326,   327,   328,   329,   330,   331,   332,
     333,   334,   335,    -1,   337,   338,   339,   340,   341,   342,
     343,   344,   345,   346,   347,   348,   349,    -1,   351,   352,
     353,   354,   355,   356,   357,   358,    -1,   360,   361,   362,
     363,   364,   365,   366,   367,   368,    -1,   370,   371,   372,
     373,   374,    -1,   376,   377,   378,   379,   380,   381,   382,
     383,   384,   385,    -1,   387,   388,   389,   390,   391,   392,
     393,   394,   395,   396,   397,   398,   399,    -1,   401,    -1,
     403,   404,    -1,   406,   407,   408,   409,   410,   411,   412,
      -1,   414,   415,   416,    -1,    -1,   419,   420,    -1,   422,
      -1,    -1,   425,   426,   427,   428,   429,   430,   431,   432,
      -1,    -1,   435,   436,   437,   438,   439,    -1,    -1,   442,
     443,   444,   445,   446,    -1,   448,   449,   450,   451,   452,
     453,   454,   455,    -1,    -1,   458,    -1,    -1,   461,   462,
     463,   464,   465,   466,     3,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   478,   479,   480,    -1,    -1,
      -1,    20,    21,    22,    23,    24,    25,    26,    27,    -1,
      29,    30,    31,    -1,    -1,    -1,    -1,    -1,    -1,   502,
      39,    40,    41,    -1,    43,    44,    45,    46,    47,    48,
      49,    50,    -1,    52,    53,    54,    55,    -1,    57,    58,
      59,    60,    61,    62,    63,    -1,    -1,    66,    67,    68,
      69,    70,    -1,    72,    73,    74,    75,    -1,    -1,    78,
      -1,    80,    81,    82,    83,    84,    85,    86,    87,    88,
      89,    -1,    91,    92,    93,    94,    95,    96,    -1,    98,
      99,   100,   101,    -1,    -1,    -1,   105,    -1,    -1,    -1,
     109,   110,   111,   112,   113,   114,   115,   116,   117,    -1,
     119,    -1,   121,   122,   123,   124,   125,   126,   127,    -1,
     129,   130,   131,   132,    -1,    -1,   135,   136,   137,   138,
     139,    -1,   141,   142,   143,    -1,   145,   146,   147,    -1,
     149,   150,   151,   152,    -1,   154,   155,   156,   157,    -1,
      -1,   160,    -1,   162,   163,   164,   165,   166,    -1,   168,
      -1,   170,   171,    -1,   173,   174,   175,   176,   177,    -1,
     179,    -1,    -1,    -1,   183,   184,    -1,   186,   187,   188,
     189,   190,   191,   192,   193,   194,   195,   196,   197,   198,
     199,   200,   201,   202,   203,    -1,   205,   206,   207,   208,
     209,   210,   211,   212,   213,    -1,   215,    -1,   217,   218,
     219,   220,   221,   222,   223,   224,   225,   226,    -1,    -1,
     229,    -1,   231,   232,   233,    -1,   235,   236,   237,    -1,
      -1,   240,   241,   242,   243,   244,   245,   246,   247,   248,
     249,   250,   251,   252,   253,   254,   255,   256,   257,   258,
     259,   260,   261,   262,   263,   264,   265,   266,   267,    -1,
      -1,   270,    -1,   272,   273,   274,   275,    -1,    -1,   278,
     279,   280,   281,   282,    -1,   284,   285,    -1,    -1,   288,
     289,   290,    -1,    -1,   293,   294,   295,   296,   297,   298,
      -1,   300,   301,   302,   303,   304,   305,   306,   307,   308,
     309,    -1,    -1,   312,   313,    -1,   315,    -1,   317,   318,
     319,    -1,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,   333,   334,   335,    -1,   337,   338,
     339,   340,   341,   342,   343,   344,   345,   346,   347,   348,
     349,    -1,   351,   352,   353,   354,   355,   356,   357,   358,
      -1,   360,   361,   362,   363,   364,   365,   366,   367,   368,
      -1,   370,   371,   372,   373,   374,    -1,   376,   377,   378,
     379,   380,   381,   382,   383,   384,   385,    -1,   387,   388,
     389,   390,   391,   392,   393,   394,   395,   396,   397,   398,
     399,    -1,   401,    -1,   403,   404,    -1,   406,   407,   408,
     409,   410,   411,   412,    -1,   414,   415,   416,    -1,    -1,
     419,   420,    -1,   422,    -1,    -1,   425,   426,   427,   428,
     429,   430,   431,   432,    -1,    -1,   435,   436,   437,   438,
     439,    -1,    -1,   442,   443,   444,   445,   446,    -1,   448,
     449,   450,   451,   452,   453,   454,   455,    -1,    -1,   458,
      -1,    -1,   461,   462,   463,   464,   465,   466,     3,    -1,
       5,     6,    -1,     8,     9,    10,    11,    12,    -1,   478,
     479,   480,    -1,    -1,    -1,    20,    21,    22,    23,    24,
      25,    26,    27,    -1,    29,    30,    31,    -1,    -1,    -1,
      -1,    36,    -1,   502,    39,    40,    41,    -1,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    -1,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    -1,    72,    73,    74,
      75,    76,    -1,    78,    -1,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    -1,    91,    92,    93,    94,
      95,    96,    -1,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,   116,   117,   118,   119,    -1,   121,   122,   123,   124,
     125,   126,   127,    -1,   129,   130,   131,   132,    -1,    -1,
     135,   136,   137,   138,   139,    -1,   141,   142,   143,    -1,
     145,   146,   147,    -1,   149,   150,   151,   152,   153,   154,
     155,   156,   157,   158,   159,   160,    -1,   162,   163,   164,
     165,   166,    -1,   168,    -1,   170,   171,    -1,   173,   174,
     175,   176,   177,    -1,   179,   180,    -1,   182,   183,   184,
      -1,   186,   187,   188,   189,   190,   191,   192,   193,   194,
     195,    -1,   197,   198,   199,   200,   201,   202,   203,    -1,
     205,   206,   207,   208,   209,   210,   211,   212,   213,    -1,
     215,    -1,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,    -1,    -1,   229,   230,   231,   232,   233,    -1,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,   246,   247,   248,   249,   250,   251,   252,   253,   254,
     255,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,    -1,   284,
     285,    -1,    -1,   288,   289,   290,    -1,    -1,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,    -1,    -1,   312,   313,   314,
     315,   316,   317,   318,   319,    -1,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,    -1,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,    -1,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,    -1,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,   400,   401,    -1,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,    -1,   414,
     415,   416,    -1,    -1,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,   431,   432,    -1,   434,
     435,   436,   437,   438,   439,   440,    -1,   442,   443,   444,
     445,   446,   447,   448,    -1,   450,   451,   452,   453,   454,
     455,    -1,    -1,   458,    -1,   460,   461,   462,   463,   464,
     465,   466,   467,   468,   469,   470,   471,   472,   473,   474,
     475,   476,   477,   478,   479,   480,   481,    -1,   483,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   492,   493,    -1,
      -1,    -1,     3,    -1,     5,     6,   501,     8,     9,    10,
      11,    12,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,
      21,    22,    23,    24,    25,    26,    27,    -1,    29,    30,
      31,    -1,    -1,    -1,    -1,    36,    -1,    -1,    39,    40,
      41,    -1,    43,    44,    45,    46,    47,    48,    49,    50,
      51,    52,    53,    54,    55,    56,    57,    58,    59,    60,
      61,    62,    63,    64,    65,    66,    67,    68,    69,    70,
      -1,    72,    73,    74,    75,    76,    -1,    78,    -1,    80,
      81,    82,    83,    84,    85,    86,    87,    88,    89,    -1,
      91,    92,    93,    94,    95,    96,    -1,    98,    99,   100,
     101,   102,   103,   104,   105,   106,   107,   108,   109,   110,
     111,   112,   113,   114,   115,   116,   117,   118,   119,    -1,
     121,   122,   123,   124,   125,   126,   127,    -1,   129,   130,
     131,   132,    -1,    -1,   135,   136,   137,   138,   139,    -1,
     141,   142,   143,    -1,   145,   146,   147,    -1,   149,   150,
     151,   152,   153,   154,   155,   156,   157,   158,   159,   160,
      -1,   162,   163,   164,   165,   166,    -1,   168,    -1,   170,
     171,   172,   173,   174,   175,   176,   177,    -1,   179,   180,
      -1,   182,   183,   184,    -1,   186,   187,   188,   189,   190,
     191,   192,   193,   194,   195,    -1,   197,   198,   199,   200,
     201,   202,   203,    -1,   205,   206,   207,   208,   209,   210,
     211,   212,   213,    -1,   215,    -1,   217,   218,   219,   220,
     221,   222,   223,   224,   225,   226,    -1,   228,   229,   230,
     231,   232,   233,    -1,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,   246,   247,   248,   249,   250,
     251,   252,   253,   254,   255,   256,   257,   258,   259,   260,
     261,   262,   263,   264,   265,   266,   267,   268,   269,   270,
     271,   272,   273,   274,   275,   276,   277,   278,   279,   280,
     281,   282,    -1,   284,   285,    -1,    -1,   288,   289,   290,
      -1,    -1,   293,   294,   295,   296,   297,   298,   299,   300,
     301,   302,   303,   304,   305,   306,   307,   308,   309,    -1,
      -1,   312,   313,   314,   315,   316,   317,   318,   319,    -1,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,   333,   334,   335,    -1,   337,   338,   339,   340,
     341,   342,   343,   344,   345,   346,   347,   348,   349,    -1,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   360,
     361,   362,   363,   364,   365,   366,   367,   368,    -1,   370,
     371,   372,   373,   374,   375,   376,   377,   378,   379,   380,
     381,   382,   383,   384,   385,    -1,   387,   388,   389,   390,
     391,   392,   393,   394,   395,   396,   397,   398,   399,   400,
     401,    -1,   403,   404,    -1,   406,   407,   408,   409,   410,
     411,   412,    -1,   414,   415,   416,    -1,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,   428,   429,   430,
     431,   432,    -1,   434,   435,   436,   437,   438,   439,   440,
      -1,   442,   443,   444,   445,   446,   447,   448,    -1,   450,
     451,   452,   453,   454,   455,    -1,    -1,   458,    -1,    -1,
     461,   462,   463,   464,   465,   466,   467,   468,   469,   470,
     471,   472,   473,   474,   475,   476,   477,   478,   479,   480,
     481,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   492,   493,    -1,    -1,    -1,     3,    -1,     5,     6,
     501,     8,     9,    10,    11,    12,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    20,    21,    22,    23,    24,    25,    26,
      27,    28,    29,    30,    31,    -1,    -1,    -1,    35,    36,
      -1,    -1,    39,    40,    41,    -1,    43,    44,    45,    46,
      47,    48,    49,    50,    51,    52,    53,    54,    55,    -1,
      57,    58,    59,    60,    61,    62,    63,    64,    65,    66,
      67,    68,    69,    70,    -1,    72,    73,    74,    75,    76,
      -1,    78,    -1,    80,    81,    82,    83,    84,    85,    86,
      87,    88,    89,    -1,    91,    92,    93,    94,    95,    96,
      -1,    98,    99,   100,   101,   102,   103,   104,   105,   106,
     107,   108,   109,   110,   111,   112,   113,   114,   115,   116,
     117,   118,   119,    -1,   121,   122,   123,   124,   125,   126,
     127,    -1,   129,   130,   131,   132,    -1,    -1,   135,   136,
     137,   138,   139,    -1,   141,   142,   143,    -1,   145,   146,
     147,    -1,   149,   150,   151,   152,   153,   154,   155,   156,
     157,   158,   159,   160,    -1,   162,   163,   164,   165,   166,
      -1,   168,    -1,   170,   171,    -1,   173,   174,   175,   176,
     177,    -1,   179,   180,    -1,   182,   183,   184,    -1,   186,
     187,   188,   189,   190,   191,   192,   193,   194,   195,    -1,
     197,   198,   199,   200,   201,   202,   203,    -1,   205,   206,
     207,   208,   209,   210,   211,   212,   213,    -1,   215,    -1,
     217,   218,   219,   220,   221,   222,   223,   224,   225,   226,
      -1,    -1,   229,   230,   231,   232,   233,    -1,   235,   236,
     237,   238,   239,   240,   241,   242,   243,   244,   245,   246,
     247,   248,   249,   250,   251,   252,   253,   254,   255,   256,
     257,   258,   259,   260,   261,   262,   263,   264,   265,   266,
     267,   268,   269,   270,   271,   272,   273,   274,   275,   276,
     277,   278,   279,   280,   281,   282,    -1,   284,   285,    -1,
      -1,   288,   289,   290,    -1,    -1,   293,   294,   295,   296,
     297,   298,   299,   300,   301,   302,   303,   304,   305,   306,
     307,   308,   309,    -1,    -1,   312,   313,   314,   315,   316,
     317,   318,   319,    -1,   321,   322,   323,   324,   325,   326,
     327,   328,   329,   330,   331,   332,   333,   334,   335,    -1,
     337,   338,   339,   340,   341,   342,   343,   344,   345,   346,
     347,   348,   349,    -1,   351,   352,   353,   354,   355,   356,
     357,   358,   359,   360,   361,   362,   363,   364,   365,   366,
     367,   368,    -1,   370,   371,   372,   373,   374,   375,   376,
     377,   378,   379,   380,   381,   382,   383,   384,   385,   386,
     387,   388,   389,   390,   391,   392,   393,   394,   395,   396,
     397,   398,   399,   400,   401,    -1,   403,   404,    -1,   406,
     407,   408,   409,   410,   411,   412,    -1,   414,   415,   416,
      -1,    -1,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,   430,   431,   432,    -1,   434,   435,   436,
     437,   438,   439,   440,    -1,   442,   443,   444,   445,   446,
     447,   448,    -1,   450,   451,   452,   453,   454,   455,    -1,
      -1,   458,    -1,    -1,   461,   462,   463,   464,   465,   466,
     467,   468,   469,   470,   471,   472,   473,   474,   475,   476,
     477,   478,   479,   480,   481,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   492,   493,    -1,    -1,    -1,
       3,    -1,     5,     6,   501,     8,     9,    10,    11,    12,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,    21,    22,
      23,    24,    25,    26,    27,    28,    29,    30,    31,    -1,
      -1,    -1,    35,    36,    -1,    -1,    39,    40,    41,    -1,
      43,    44,    45,    46,    47,    48,    49,    50,    51,    52,
      53,    54,    55,    -1,    57,    58,    59,    60,    61,    62,
      63,    64,    65,    66,    67,    68,    69,    70,    -1,    72,
      73,    74,    75,    76,    -1,    78,    -1,    80,    81,    82,
      83,    84,    85,    86,    87,    88,    89,    -1,    91,    92,
      93,    94,    95,    96,    -1,    98,    99,   100,   101,   102,
     103,   104,   105,   106,   107,   108,   109,   110,   111,   112,
     113,   114,   115,   116,   117,   118,   119,    -1,   121,   122,
     123,   124,   125,   126,   127,    -1,   129,   130,   131,   132,
      -1,    -1,   135,   136,   137,   138,   139,    -1,   141,   142,
     143,    -1,   145,   146,   147,    -1,   149,   150,   151,   152,
     153,   154,   155,   156,   157,   158,   159,   160,    -1,   162,
     163,   164,   165,   166,    -1,   168,    -1,   170,   171,    -1,
     173,   174,   175,   176,   177,    -1,   179,   180,    -1,   182,
     183,   184,    -1,   186,   187,   188,   189,   190,   191,   192,
     193,   194,   195,    -1,   197,   198,   199,   200,   201,   202,
     203,    -1,   205,   206,   207,   208,   209,   210,   211,   212,
     213,    -1,   215,    -1,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,    -1,    -1,   229,   230,   231,   232,
     233,    -1,   235,   236,   237,   238,   239,   240,   241,   242,
     243,   244,   245,   246,   247,   248,   249,   250,   251,   252,
     253,   254,   255,   256,   257,   258,   259,   260,   261,   262,
     263,   264,   265,   266,   267,   268,   269,   270,   271,   272,
     273,   274,   275,   276,   277,   278,   279,   280,   281,   282,
      -1,   284,   285,    -1,    -1,   288,   289,   290,    -1,    -1,
     293,   294,   295,   296,   297,   298,   299,   300,   301,   302,
     303,   304,   305,   306,   307,   308,   309,    -1,    -1,   312,
     313,   314,   315,   316,   317,   318,   319,    -1,   321,   322,
     323,   324,   325,   326,   327,   328,   329,   330,   331,   332,
     333,   334,   335,    -1,   337,   338,   339,   340,   341,   342,
     343,   344,   345,   346,   347,   348,   349,    -1,   351,   352,
     353,   354,   355,   356,   357,   358,   359,   360,   361,   362,
     363,   364,   365,   366,   367,   368,    -1,   370,   371,   372,
     373,   374,   375,   376,   377,   378,   379,   380,   381,   382,
     383,   384,   385,   386,   387,   388,   389,   390,   391,   392,
     393,   394,   395,   396,   397,   398,   399,   400,   401,    -1,
     403,   404,    -1,   406,   407,   408,   409,   410,   411,   412,
      -1,   414,   415,   416,    -1,    -1,   419,   420,   421,   422,
     423,   424,   425,   426,   427,   428,   429,   430,   431,   432,
      -1,   434,   435,   436,   437,   438,   439,   440,    -1,   442,
     443,   444,   445,   446,   447,   448,    -1,   450,   451,   452,
     453,   454,   455,    -1,    -1,   458,    -1,    -1,   461,   462,
     463,   464,   465,   466,   467,   468,   469,   470,   471,   472,
     473,   474,   475,   476,   477,   478,   479,   480,   481,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   492,
     493,    -1,    -1,    -1,     3,    -1,     5,     6,   501,     8,
       9,    10,    11,    12,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    20,    21,    22,    23,    24,    25,    26,    27,    -1,
      29,    30,    31,    -1,    -1,    -1,    -1,    36,    -1,    -1,
      39,    40,    41,    -1,    43,    44,    45,    46,    47,    48,
      49,    50,    51,    52,    53,    54,    55,    -1,    57,    58,
      59,    60,    61,    62,    63,    64,    65,    66,    67,    68,
      69,    70,    -1,    72,    73,    74,    75,    76,    -1,    78,
      -1,    80,    81,    82,    83,    84,    85,    86,    87,    88,
      89,    -1,    91,    92,    93,    94,    95,    96,    -1,    98,
      99,   100,   101,   102,   103,   104,   105,   106,   107,   108,
     109,   110,   111,   112,   113,   114,   115,   116,   117,   118,
     119,    -1,   121,   122,   123,   124,   125,   126,   127,    -1,
     129,   130,   131,   132,    -1,    -1,   135,   136,   137,   138,
     139,    -1,   141,   142,   143,    -1,   145,   146,   147,    -1,
     149,   150,   151,   152,   153,   154,   155,   156,   157,   158,
     159,   160,    -1,   162,   163,   164,   165,   166,    -1,   168,
      -1,   170,   171,    -1,   173,   174,   175,   176,   177,    -1,
     179,   180,    -1,   182,   183,   184,    -1,   186,   187,   188,
     189,   190,   191,   192,   193,   194,   195,    -1,   197,   198,
     199,   200,   201,   202,   203,    -1,   205,   206,   207,   208,
     209,   210,   211,   212,   213,    -1,   215,    -1,   217,   218,
     219,   220,   221,   222,   223,   224,   225,   226,    -1,    -1,
     229,   230,   231,   232,   233,    -1,   235,   236,   237,   238,
     239,   240,   241,   242,   243,   244,   245,   246,   247,   248,
     249,   250,   251,   252,   253,   254,   255,   256,   257,   258,
     259,   260,   261,   262,   263,   264,   265,   266,   267,   268,
     269,   270,   271,   272,   273,   274,   275,   276,   277,   278,
     279,   280,   281,   282,    -1,   284,   285,    -1,    -1,   288,
     289,   290,    -1,    -1,   293,   294,   295,   296,   297,   298,
     299,   300,   301,   302,   303,   304,   305,   306,   307,   308,
     309,    -1,    -1,   312,   313,   314,   315,   316,   317,   318,
     319,    -1,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,   333,   334,   335,    -1,   337,   338,
     339,   340,   341,   342,   343,   344,   345,   346,   347,   348,
     349,    -1,   351,   352,   353,   354,   355,   356,   357,   358,
     359,   360,   361,   362,   363,   364,   365,   366,   367,   368,
      -1,   370,   371,   372,   373,   374,   375,   376,   377,   378,
     379,   380,   381,   382,   383,   384,   385,    -1,   387,   388,
     389,   390,   391,   392,   393,   394,   395,   396,   397,   398,
     399,   400,   401,    -1,   403,   404,    -1,   406,   407,   408,
     409,   410,   411,   412,    -1,   414,   415,   416,    -1,    -1,
     419,   420,   421,   422,   423,   424,   425,   426,   427,   428,
     429,   430,   431,   432,    -1,   434,   435,   436,   437,   438,
     439,   440,    -1,   442,   443,   444,   445,   446,   447,   448,
      -1,   450,   451,   452,   453,   454,   455,    -1,    -1,   458,
      -1,    -1,   461,   462,   463,   464,   465,   466,   467,   468,
     469,   470,   471,   472,   473,   474,   475,   476,   477,   478,
     479,   480,   481,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   492,   493,    -1,    -1,    -1,    -1,    -1,
     499,   500,   501,     3,    -1,     5,     6,    -1,     8,     9,
      10,    11,    12,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      20,    21,    22,    23,    24,    25,    26,    27,    -1,    29,
      30,    31,    -1,    -1,    -1,    -1,    36,    -1,    -1,    39,
      40,    41,    -1,    43,    44,    45,    46,    47,    48,    49,
      50,    51,    52,    53,    54,    55,    -1,    57,    58,    59,
      60,    61,    62,    63,    64,    65,    66,    67,    68,    69,
      70,    -1,    72,    73,    74,    75,    76,    -1,    78,    -1,
      80,    81,    82,    83,    84,    85,    86,    87,    88,    89,
      -1,    91,    92,    93,    94,    95,    96,    -1,    98,    99,
     100,   101,   102,   103,   104,   105,   106,   107,   108,   109,
     110,   111,   112,   113,   114,   115,   116,   117,   118,   119,
      -1,   121,   122,   123,   124,   125,   126,   127,    -1,   129,
     130,   131,   132,    -1,    -1,   135,   136,   137,   138,   139,
      -1,   141,   142,   143,    -1,   145,   146,   147,    -1,   149,
     150,   151,   152,   153,   154,   155,   156,   157,   158,   159,
     160,    -1,   162,   163,   164,   165,   166,    -1,   168,    -1,
     170,   171,    -1,   173,   174,   175,   176,   177,    -1,   179,
     180,    -1,   182,   183,   184,    -1,   186,   187,   188,   189,
     190,   191,   192,   193,   194,   195,    -1,   197,   198,   199,
     200,   201,   202,   203,    -1,   205,   206,   207,   208,   209,
     210,   211,   212,   213,    -1,   215,    -1,   217,   218,   219,
     220,   221,   222,   223,   224,   225,   226,    -1,    -1,   229,
     230,   231,   232,   233,    -1,   235,   236,   237,   238,   239,
     240,   241,   242,   243,   244,   245,   246,   247,   248,   249,
     250,   251,   252,   253,   254,   255,   256,   257,   258,   259,
     260,   261,   262,   263,   264,   265,   266,   267,   268,   269,
     270,   271,   272,   273,   274,   275,   276,   277,   278,   279,
     280,   281,   282,    -1,   284,   285,    -1,    -1,   288,   289,
     290,    -1,    -1,   293,   294,   295,   296,   297,   298,   299,
     300,   301,   302,   303,   304,   305,   306,   307,   308,   309,
      -1,    -1,   312,   313,   314,   315,   316,   317,   318,   319,
      -1,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,    -1,   337,   338,   339,
     340,   341,   342,   343,   344,   345,   346,   347,   348,   349,
      -1,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,   365,   366,   367,   368,    -1,
     370,   371,   372,   373,   374,   375,   376,   377,   378,   379,
     380,   381,   382,   383,   384,   385,    -1,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,   399,
     400,   401,    -1,   403,   404,    -1,   406,   407,   408,   409,
     410,   411,   412,    -1,   414,   415,   416,    -1,    -1,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,   432,    -1,   434,   435,   436,   437,   438,   439,
     440,    -1,   442,   443,   444,   445,   446,   447,   448,    -1,
     450,   451,   452,   453,   454,   455,    -1,    -1,   458,    -1,
      -1,   461,   462,   463,   464,   465,   466,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,   481,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   492,   493,   494,    -1,    -1,     3,    -1,     5,
       6,   501,     8,     9,    10,    11,    12,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,    25,
      26,    27,    28,    29,    30,    31,    -1,    -1,    -1,    -1,
      36,    -1,    -1,    39,    40,    41,    -1,    43,    44,    45,
      46,    47,    48,    49,    50,    51,    52,    53,    54,    55,
      -1,    57,    58,    59,    60,    61,    62,    63,    64,    65,
      66,    67,    68,    69,    70,    -1,    72,    73,    74,    75,
      76,    -1,    78,    -1,    80,    81,    82,    83,    84,    85,
      86,    87,    88,    89,    -1,    91,    92,    93,    94,    95,
      96,    -1,    98,    99,   100,   101,   102,   103,   104,   105,
     106,   107,   108,   109,   110,   111,   112,   113,   114,   115,
     116,   117,   118,   119,    -1,   121,   122,   123,   124,   125,
     126,   127,    -1,   129,   130,   131,   132,    -1,    -1,   135,
     136,   137,   138,   139,    -1,   141,   142,   143,    -1,   145,
     146,   147,    -1,   149,   150,   151,   152,   153,   154,   155,
     156,   157,   158,   159,   160,    -1,   162,   163,   164,   165,
     166,    -1,   168,    -1,   170,   171,    -1,   173,   174,   175,
     176,   177,    -1,   179,   180,    -1,   182,   183,   184,    -1,
     186,   187,   188,   189,   190,   191,   192,   193,   194,   195,
      -1,   197,   198,   199,   200,   201,   202,   203,    -1,   205,
     206,   207,   208,   209,   210,   211,   212,   213,    -1,   215,
      -1,   217,   218,   219,   220,   221,   222,   223,   224,   225,
     226,    -1,    -1,   229,   230,   231,   232,   233,    -1,   235,
     236,   237,   238,   239,   240,   241,   242,   243,   244,   245,
     246,   247,   248,   249,   250,   251,   252,   253,   254,   255,
     256,   257,   258,   259,   260,   261,   262,   263,   264,   265,
     266,   267,   268,   269,   270,   271,   272,   273,   274,   275,
     276,   277,   278,   279,   280,   281,   282,    -1,   284,   285,
      -1,    -1,   288,   289,   290,    -1,    -1,   293,   294,   295,
     296,   297,   298,   299,   300,   301,   302,   303,   304,   305,
     306,   307,   308,   309,    -1,    -1,   312,   313,   314,   315,
     316,   317,   318,   319,    -1,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
      -1,   337,   338,   339,   340,   341,   342,   343,   344,   345,
     346,   347,   348,   349,    -1,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
     366,   367,   368,    -1,   370,   371,   372,   373,   374,   375,
     376,   377,   378,   379,   380,   381,   382,   383,   384,   385,
      -1,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,   399,   400,   401,    -1,   403,   404,    -1,
     406,   407,   408,   409,   410,   411,   412,    -1,   414,   415,
     416,    -1,    -1,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,   432,    -1,   434,   435,
     436,   437,   438,   439,   440,    -1,   442,   443,   444,   445,
     446,   447,   448,    -1,   450,   451,   452,   453,   454,   455,
      -1,    -1,   458,    -1,    -1,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,   478,   479,   480,   481,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   492,   493,    -1,    -1,
      -1,     3,    -1,     5,     6,   501,     8,     9,    10,    11,
      12,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,    21,
      22,    23,    24,    25,    26,    27,    -1,    29,    30,    31,
      -1,    -1,    -1,    -1,    36,    -1,    -1,    39,    40,    41,
      -1,    43,    44,    45,    46,    47,    48,    49,    50,    51,
      52,    53,    54,    55,    -1,    57,    58,    59,    60,    61,
      62,    63,    64,    65,    66,    67,    68,    69,    70,    -1,
      72,    73,    74,    75,    76,    -1,    78,    -1,    80,    81,
      82,    83,    84,    85,    86,    87,    88,    89,    -1,    91,
      92,    93,    94,    95,    96,    -1,    98,    99,   100,   101,
     102,   103,   104,   105,   106,   107,   108,   109,   110,   111,
     112,   113,   114,   115,   116,   117,   118,   119,    -1,   121,
     122,   123,   124,   125,   126,   127,    -1,   129,   130,   131,
     132,    -1,    -1,   135,   136,   137,   138,   139,    -1,   141,
     142,   143,    -1,   145,   146,   147,    -1,   149,   150,   151,
     152,   153,   154,   155,   156,   157,   158,   159,   160,    -1,
     162,   163,   164,   165,   166,    -1,   168,    -1,   170,   171,
      -1,   173,   174,   175,   176,   177,    -1,   179,   180,    -1,
     182,   183,   184,    -1,   186,   187,   188,   189,   190,   191,
     192,   193,   194,   195,    -1,   197,   198,   199,   200,   201,
     202,   203,    -1,   205,   206,   207,   208,   209,   210,   211,
     212,   213,    -1,   215,    -1,   217,   218,   219,   220,   221,
     222,   223,   224,   225,   226,    -1,    -1,   229,   230,   231,
     232,   233,    -1,   235,   236,   237,   238,   239,   240,   241,
     242,   243,   244,   245,   246,   247,   248,   249,   250,   251,
     252,   253,   254,   255,   256,   257,   258,   259,   260,   261,
     262,   263,   264,   265,   266,   267,   268,   269,   270,   271,
     272,   273,   274,   275,   276,   277,   278,   279,   280,   281,
     282,    -1,   284,   285,    -1,    -1,   288,   289,   290,    -1,
      -1,   293,   294,   295,   296,   297,   298,   299,   300,   301,
     302,   303,   304,   305,   306,   307,   308,   309,    -1,    -1,
     312,   313,   314,   315,   316,   317,   318,   319,    -1,   321,
     322,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,   333,   334,   335,    -1,   337,   338,   339,   340,   341,
     342,   343,   344,   345,   346,   347,   348,   349,    -1,   351,
     352,   353,   354,   355,   356,   357,   358,   359,   360,   361,
     362,   363,   364,   365,   366,   367,   368,    -1,   370,   371,
     372,   373,   374,   375,   376,   377,   378,   379,   380,   381,
     382,   383,   384,   385,    -1,   387,   388,   389,   390,   391,
     392,   393,   394,   395,   396,   397,   398,   399,   400,   401,
      -1,   403,   404,    -1,   406,   407,   408,   409,   410,   411,
     412,    -1,   414,   415,   416,    -1,    -1,   419,   420,   421,
     422,   423,   424,   425,   426,   427,   428,   429,   430,   431,
     432,    -1,   434,   435,   436,   437,   438,   439,   440,    -1,
     442,   443,   444,   445,   446,   447,   448,   449,   450,   451,
     452,   453,   454,   455,    -1,    -1,   458,    -1,    -1,   461,
     462,   463,   464,   465,   466,   467,   468,   469,   470,   471,
     472,   473,   474,   475,   476,   477,   478,   479,   480,   481,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     492,   493,    -1,    -1,    -1,     3,    -1,     5,     6,   501,
       8,     9,    10,    11,    12,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    20,    21,    22,    23,    24,    25,    26,    27,
      -1,    29,    30,    31,    -1,    -1,    -1,    -1,    36,    -1,
      -1,    39,    40,    41,    -1,    43,    44,    45,    46,    47,
      48,    49,    50,    51,    52,    53,    54,    55,    -1,    57,
      58,    59,    60,    61,    62,    63,    64,    65,    66,    67,
      68,    69,    70,    -1,    72,    73,    74,    75,    76,    -1,
      78,    -1,    80,    81,    82,    83,    84,    85,    86,    87,
      88,    89,    -1,    91,    92,    93,    94,    95,    96,    -1,
      98,    99,   100,   101,   102,   103,   104,   105,   106,   107,
     108,   109,   110,   111,   112,   113,   114,   115,   116,   117,
     118,   119,    -1,   121,   122,   123,   124,   125,   126,   127,
      -1,   129,   130,   131,   132,    -1,    -1,   135,   136,   137,
     138,   139,    -1,   141,   142,   143,    -1,   145,   146,   147,
      -1,   149,   150,   151,   152,   153,   154,   155,   156,   157,
     158,   159,   160,    -1,   162,   163,   164,   165,   166,    -1,
     168,    -1,   170,   171,   172,   173,   174,   175,   176,   177,
      -1,   179,   180,    -1,   182,   183,   184,    -1,   186,   187,
     188,   189,   190,   191,   192,   193,   194,   195,    -1,   197,
     198,   199,   200,   201,   202,   203,    -1,   205,   206,   207,
     208,   209,   210,   211,   212,   213,    -1,   215,    -1,   217,
     218,   219,   220,   221,   222,   223,   224,   225,   226,    -1,
      -1,   229,   230,   231,   232,   233,    -1,   235,   236,   237,
     238,   239,   240,   241,   242,   243,   244,   245,   246,   247,
     248,   249,   250,   251,   252,   253,   254,   255,   256,   257,
     258,   259,   260,   261,   262,   263,   264,   265,   266,   267,
     268,   269,   270,   271,   272,   273,   274,   275,   276,   277,
     278,   279,   280,   281,   282,    -1,   284,   285,    -1,    -1,
     288,   289,   290,    -1,    -1,   293,   294,   295,   296,   297,
     298,   299,   300,   301,   302,   303,   304,   305,   306,   307,
     308,   309,    -1,    -1,   312,   313,   314,   315,   316,   317,
     318,   319,    -1,   321,   322,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,   333,   334,   335,    -1,   337,
     338,   339,   340,   341,   342,   343,   344,   345,   346,   347,
     348,   349,    -1,   351,   352,   353,   354,   355,   356,   357,
     358,   359,   360,   361,   362,   363,   364,   365,   366,   367,
     368,    -1,   370,   371,   372,   373,   374,   375,   376,   377,
     378,   379,   380,   381,   382,   383,   384,   385,    -1,   387,
     388,   389,   390,   391,   392,   393,   394,   395,   396,   397,
     398,   399,   400,   401,    -1,   403,   404,    -1,   406,   407,
     408,   409,   410,   411,   412,    -1,   414,   415,   416,    -1,
      -1,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,   432,    -1,   434,   435,   436,   437,
     438,   439,   440,    -1,   442,   443,   444,   445,   446,   447,
     448,    -1,   450,   451,   452,   453,   454,   455,    -1,    -1,
     458,    -1,    -1,   461,   462,   463,   464,   465,   466,   467,
     468,   469,   470,   471,   472,   473,   474,   475,   476,   477,
     478,   479,   480,   481,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   492,   493,    -1,    -1,    -1,     3,
      -1,     5,     6,   501,     8,     9,    10,    11,    12,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    20,    21,    22,    23,
      24,    25,    26,    27,    -1,    29,    30,    31,    -1,    -1,
      -1,    -1,    36,    -1,    -1,    39,    40,    41,    -1,    43,
      44,    45,    46,    47,    48,    49,    50,    51,    52,    53,
      54,    55,    -1,    57,    58,    59,    60,    61,    62,    63,
      64,    65,    66,    67,    68,    69,    70,    -1,    72,    73,
      74,    75,    76,    -1,    78,    -1,    80,    81,    82,    83,
      84,    85,    86,    87,    88,    89,    -1,    91,    92,    93,
      94,    95,    96,    -1,    98,    99,   100,   101,   102,   103,
     104,   105,   106,   107,   108,   109,   110,   111,   112,   113,
     114,   115,   116,   117,   118,   119,    -1,   121,   122,   123,
     124,   125,   126,   127,    -1,   129,   130,   131,   132,    -1,
      -1,   135,   136,   137,   138,   139,    -1,   141,   142,   143,
      -1,   145,   146,   147,    -1,   149,   150,   151,   152,   153,
     154,   155,   156,   157,   158,   159,   160,    -1,   162,   163,
     164,   165,   166,    -1,   168,    -1,   170,   171,    -1,   173,
     174,   175,   176,   177,    -1,   179,   180,    -1,   182,   183,
     184,    -1,   186,   187,   188,   189,   190,   191,   192,   193,
     194,   195,    -1,   197,   198,   199,   200,   201,   202,   203,
      -1,   205,   206,   207,   208,   209,   210,   211,   212,   213,
      -1,   215,    -1,   217,   218,   219,   220,   221,   222,   223,
     224,   225,   226,    -1,    -1,   229,   230,   231,   232,   233,
      -1,   235,   236,   237,   238,   239,   240,   241,   242,   243,
     244,   245,   246,   247,   248,   249,   250,   251,   252,   253,
     254,   255,   256,   257,   258,   259,   260,   261,   262,   263,
     264,   265,   266,   267,   268,   269,   270,   271,   272,   273,
     274,   275,   276,   277,   278,   279,   280,   281,   282,    -1,
     284,   285,    -1,    -1,   288,   289,   290,    -1,    -1,   293,
     294,   295,   296,   297,   298,   299,   300,   301,   302,   303,
     304,   305,   306,   307,   308,   309,    -1,    -1,   312,   313,
     314,   315,   316,   317,   318,   319,    -1,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,   333,
     334,   335,    -1,   337,   338,   339,   340,   341,   342,   343,
     344,   345,   346,   347,   348,   349,    -1,   351,   352,   353,
     354,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,   365,   366,   367,   368,    -1,   370,   371,   372,   373,
     374,   375,   376,   377,   378,   379,   380,   381,   382,   383,
     384,   385,    -1,   387,   388,   389,   390,   391,   392,   393,
     394,   395,   396,   397,   398,   399,   400,   401,    -1,   403,
     404,    -1,   406,   407,   408,   409,   410,   411,   412,    -1,
     414,   415,   416,   417,    -1,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   431,   432,    -1,
     434,   435,   436,   437,   438,   439,   440,    -1,   442,   443,
     444,   445,   446,   447,   448,    -1,   450,   451,   452,   453,
     454,   455,    -1,    -1,   458,    -1,    -1,   461,   462,   463,
     464,   465,   466,   467,   468,   469,   470,   471,   472,   473,
     474,   475,   476,   477,   478,   479,   480,   481,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   492,   493,
      -1,    -1,    -1,     3,    -1,     5,     6,   501,     8,     9,
      10,    11,    12,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      20,    21,    22,    23,    24,    25,    26,    27,    -1,    29,
      30,    31,    -1,    -1,    -1,    -1,    36,    -1,    -1,    39,
      40,    41,    -1,    43,    44,    45,    46,    47,    48,    49,
      50,    51,    52,    53,    54,    55,    -1,    57,    58,    59,
      60,    61,    62,    63,    64,    65,    66,    67,    68,    69,
      70,    -1,    72,    73,    74,    75,    76,    -1,    78,    -1,
      80,    81,    82,    83,    84,    85,    86,    87,    88,    89,
      -1,    91,    92,    93,    94,    95,    96,    -1,    98,    99,
     100,   101,   102,   103,   104,   105,   106,   107,   108,   109,
     110,   111,   112,   113,   114,   115,   116,   117,   118,   119,
      -1,   121,   122,   123,   124,   125,   126,   127,    -1,   129,
     130,   131,   132,    -1,    -1,   135,   136,   137,   138,   139,
      -1,   141,   142,   143,    -1,   145,   146,   147,    -1,   149,
     150,   151,   152,   153,   154,   155,   156,   157,   158,   159,
     160,    -1,   162,   163,   164,   165,   166,    -1,   168,    -1,
     170,   171,    -1,   173,   174,   175,   176,   177,    -1,   179,
     180,    -1,   182,   183,   184,    -1,   186,   187,   188,   189,
     190,   191,   192,   193,   194,   195,    -1,   197,   198,   199,
     200,   201,   202,   203,    -1,   205,   206,   207,   208,   209,
     210,   211,   212,   213,    -1,   215,    -1,   217,   218,   219,
     220,   221,   222,   223,   224,   225,   226,    -1,    -1,   229,
     230,   231,   232,   233,    -1,   235,   236,   237,   238,   239,
     240,   241,   242,   243,   244,   245,   246,   247,   248,   249,
     250,   251,   252,   253,   254,   255,   256,   257,   258,   259,
     260,   261,   262,   263,   264,   265,   266,   267,   268,   269,
     270,   271,   272,   273,   274,   275,   276,   277,   278,   279,
     280,   281,   282,    -1,   284,   285,    -1,    -1,   288,   289,
     290,    -1,    -1,   293,   294,   295,   296,   297,   298,   299,
     300,   301,   302,   303,   304,   305,   306,   307,   308,   309,
      -1,    -1,   312,   313,   314,   315,   316,   317,   318,   319,
      -1,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,    -1,   337,   338,   339,
     340,   341,   342,   343,   344,   345,   346,   347,   348,   349,
      -1,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,   365,   366,   367,   368,    -1,
     370,   371,   372,   373,   374,   375,   376,   377,   378,   379,
     380,   381,   382,   383,   384,   385,    -1,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,   399,
     400,   401,    -1,   403,   404,    -1,   406,   407,   408,   409,
     410,   411,   412,    -1,   414,   415,   416,    -1,    -1,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,   432,    -1,   434,   435,   436,   437,   438,   439,
     440,    -1,   442,   443,   444,   445,   446,   447,   448,    -1,
     450,   451,   452,   453,   454,   455,    -1,    -1,   458,    -1,
      -1,   461,   462,   463,   464,   465,   466,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,   481,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   492,   493,    -1,    -1,    -1,     3,    -1,     5,
       6,   501,     8,     9,    10,    11,    12,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,    25,
      26,    27,    -1,    29,    30,    31,    -1,    -1,    -1,    -1,
      36,    -1,    -1,    39,    40,    41,    -1,    43,    44,    45,
      46,    47,    48,    49,    50,    51,    52,    53,    54,    55,
      -1,    57,    58,    59,    60,    61,    62,    63,    64,    65,
      66,    67,    68,    69,    70,    -1,    72,    73,    74,    75,
      76,    -1,    78,    -1,    80,    81,    82,    83,    84,    85,
      86,    87,    88,    89,    -1,    91,    92,    93,    94,    95,
      96,    -1,    98,    99,   100,   101,   102,   103,   104,   105,
     106,   107,   108,   109,   110,   111,   112,   113,   114,   115,
     116,   117,   118,   119,    -1,   121,   122,   123,   124,   125,
     126,   127,    -1,   129,   130,   131,   132,    -1,    -1,   135,
     136,   137,   138,   139,    -1,   141,   142,   143,    -1,   145,
     146,   147,    -1,   149,   150,   151,   152,   153,   154,   155,
     156,   157,   158,   159,   160,    -1,   162,   163,   164,   165,
     166,    -1,   168,    -1,   170,   171,    -1,   173,   174,   175,
     176,   177,    -1,   179,   180,    -1,   182,   183,   184,    -1,
     186,   187,   188,   189,   190,   191,   192,   193,   194,   195,
      -1,   197,   198,   199,   200,   201,   202,   203,    -1,   205,
     206,   207,   208,   209,   210,   211,   212,   213,    -1,   215,
      -1,   217,   218,   219,   220,   221,   222,   223,   224,   225,
     226,    -1,    -1,   229,   230,   231,   232,   233,    -1,   235,
     236,   237,   238,   239,   240,   241,   242,   243,   244,   245,
     246,   247,   248,   249,   250,   251,   252,   253,   254,   255,
     256,   257,   258,   259,   260,   261,   262,   263,   264,   265,
     266,   267,   268,   269,   270,   271,   272,   273,   274,   275,
     276,   277,   278,   279,   280,   281,   282,    -1,   284,   285,
      -1,    -1,   288,   289,   290,    -1,    -1,   293,   294,   295,
     296,   297,   298,   299,   300,   301,   302,   303,   304,   305,
     306,   307,   308,   309,    -1,    -1,   312,   313,   314,   315,
     316,   317,   318,   319,    -1,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
      -1,   337,   338,   339,   340,   341,   342,   343,   344,   345,
     346,   347,   348,   349,    -1,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
     366,   367,   368,    -1,   370,   371,   372,   373,   374,   375,
     376,   377,   378,   379,   380,   381,   382,   383,   384,   385,
      -1,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,   399,   400,   401,    -1,   403,   404,    -1,
     406,   407,   408,   409,   410,   411,   412,    -1,   414,   415,
     416,    -1,    -1,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,   432,    -1,   434,   435,
     436,   437,   438,   439,   440,    -1,   442,   443,   444,   445,
     446,   447,   448,    -1,   450,   451,   452,   453,   454,   455,
      -1,    -1,   458,    -1,    -1,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,   478,   479,   480,   481,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   492,   493,    -1,    -1,
      -1,     3,    -1,     5,     6,   501,     8,     9,    10,    11,
      12,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,    21,
      22,    23,    24,    25,    26,    27,    -1,    29,    30,    31,
      -1,    -1,    -1,    -1,    36,    -1,    -1,    39,    40,    41,
      -1,    43,    44,    45,    46,    47,    48,    49,    50,    51,
      52,    53,    54,    55,    -1,    57,    58,    59,    60,    61,
      62,    63,    64,    65,    66,    67,    68,    69,    70,    -1,
      72,    73,    74,    75,    76,    -1,    78,    -1,    80,    81,
      82,    83,    84,    85,    86,    87,    88,    89,    -1,    91,
      92,    93,    94,    95,    96,    -1,    98,    99,   100,   101,
     102,   103,   104,   105,   106,   107,   108,   109,   110,   111,
     112,   113,   114,   115,   116,   117,   118,   119,    -1,   121,
     122,   123,   124,   125,   126,   127,    -1,   129,   130,   131,
     132,    -1,    -1,   135,   136,   137,   138,   139,    -1,   141,
     142,   143,    -1,   145,   146,   147,    -1,   149,   150,   151,
     152,   153,   154,   155,   156,   157,   158,   159,   160,    -1,
     162,   163,   164,   165,   166,    -1,   168,    -1,   170,   171,
      -1,   173,   174,   175,   176,   177,    -1,   179,   180,    -1,
     182,   183,   184,    -1,   186,   187,   188,   189,   190,   191,
     192,   193,   194,   195,    -1,   197,   198,   199,   200,   201,
     202,   203,    -1,   205,   206,   207,   208,   209,   210,   211,
     212,   213,    -1,   215,    -1,   217,   218,   219,   220,   221,
     222,   223,   224,   225,   226,    -1,    -1,   229,   230,   231,
     232,   233,    -1,   235,   236,   237,   238,   239,   240,   241,
     242,   243,   244,   245,   246,   247,   248,   249,   250,   251,
     252,   253,   254,   255,   256,   257,   258,   259,   260,   261,
     262,   263,   264,   265,   266,   267,   268,   269,   270,   271,
     272,   273,   274,   275,   276,   277,   278,   279,   280,   281,
     282,    -1,   284,   285,    -1,    -1,   288,   289,   290,    -1,
      -1,   293,   294,   295,   296,   297,   298,   299,   300,   301,
     302,   303,   304,   305,   306,   307,   308,   309,    -1,    -1,
     312,   313,   314,   315,   316,   317,   318,   319,    -1,   321,
     322,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,   333,   334,   335,    -1,   337,   338,   339,   340,   341,
     342,   343,   344,   345,   346,   347,   348,   349,    -1,   351,
     352,   353,   354,   355,   356,   357,   358,   359,   360,   361,
     362,   363,   364,   365,   366,   367,   368,    -1,   370,   371,
     372,   373,   374,   375,   376,   377,   378,   379,   380,   381,
     382,   383,   384,   385,    -1,   387,   388,   389,   390,   391,
     392,   393,   394,   395,   396,   397,   398,   399,   400,   401,
      -1,   403,   404,    -1,   406,   407,   408,   409,   410,   411,
     412,    -1,   414,   415,   416,    -1,    -1,   419,   420,   421,
     422,   423,   424,   425,   426,   427,   428,   429,   430,   431,
     432,    -1,   434,   435,   436,   437,   438,   439,   440,    -1,
     442,   443,   444,   445,   446,   447,   448,    -1,   450,   451,
     452,   453,   454,   455,    -1,    -1,   458,    -1,    -1,   461,
     462,   463,   464,   465,   466,   467,   468,   469,   470,   471,
     472,   473,   474,   475,   476,   477,   478,   479,   480,   481,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     492,   493,    -1,    -1,    -1,     3,    -1,     5,     6,   501,
       8,     9,    10,    11,    12,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    20,    21,    22,    23,    24,    25,    26,    27,
      -1,    29,    30,    31,    -1,    -1,    -1,    -1,    36,    -1,
      -1,    39,    40,    41,    -1,    43,    44,    45,    46,    47,
      48,    49,    50,    51,    52,    53,    54,    55,    -1,    57,
      58,    59,    60,    61,    62,    63,    64,    65,    66,    67,
      68,    69,    70,    -1,    72,    73,    74,    75,    76,    -1,
      78,    -1,    80,    81,    82,    83,    84,    85,    86,    87,
      88,    89,    -1,    91,    92,    93,    94,    95,    96,    -1,
      98,    99,   100,   101,   102,   103,   104,   105,   106,   107,
     108,   109,   110,   111,   112,   113,   114,   115,   116,   117,
     118,   119,    -1,   121,   122,   123,   124,   125,   126,   127,
      -1,   129,   130,   131,   132,    -1,    -1,   135,   136,   137,
     138,   139,    -1,   141,   142,   143,    -1,   145,   146,   147,
      -1,   149,   150,   151,   152,   153,   154,   155,   156,   157,
     158,   159,   160,    -1,   162,   163,   164,   165,   166,    -1,
     168,    -1,   170,   171,    -1,   173,   174,   175,   176,   177,
      -1,   179,   180,    -1,   182,   183,   184,    -1,   186,   187,
     188,   189,   190,   191,   192,   193,   194,   195,    -1,   197,
     198,   199,   200,   201,   202,   203,    -1,   205,   206,   207,
     208,   209,   210,   211,   212,   213,    -1,   215,    -1,   217,
     218,   219,   220,   221,   222,   223,   224,   225,   226,    -1,
      -1,   229,   230,   231,   232,   233,    -1,   235,   236,   237,
     238,   239,   240,   241,   242,   243,   244,   245,   246,   247,
     248,   249,   250,   251,   252,   253,   254,   255,   256,   257,
     258,   259,   260,   261,   262,   263,   264,   265,   266,   267,
     268,   269,   270,   271,   272,   273,   274,   275,   276,   277,
     278,   279,   280,   281,   282,    -1,   284,   285,    -1,    -1,
     288,   289,   290,    -1,    -1,   293,   294,   295,   296,   297,
     298,   299,   300,   301,   302,   303,   304,   305,   306,   307,
     308,   309,    -1,    -1,   312,   313,   314,   315,   316,   317,
     318,   319,    -1,   321,   322,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,   333,   334,   335,    -1,   337,
     338,   339,   340,   341,   342,   343,   344,   345,   346,   347,
     348,   349,    -1,   351,   352,   353,   354,   355,   356,   357,
     358,   359,   360,   361,   362,   363,   364,   365,   366,   367,
     368,    -1,   370,   371,   372,   373,   374,   375,   376,   377,
     378,   379,   380,   381,   382,   383,   384,   385,    -1,   387,
     388,   389,   390,   391,   392,   393,   394,   395,   396,   397,
     398,   399,   400,   401,    -1,   403,   404,    -1,   406,   407,
     408,   409,   410,   411,   412,    -1,   414,   415,   416,    -1,
      -1,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,   432,    -1,   434,   435,   436,   437,
     438,   439,   440,    -1,   442,   443,   444,   445,   446,   447,
     448,    -1,   450,   451,   452,   453,   454,   455,    -1,    -1,
     458,    -1,    -1,   461,   462,   463,   464,   465,   466,   467,
     468,   469,   470,   471,   472,   473,   474,   475,   476,   477,
     478,   479,   480,   481,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   492,   493,    -1,    -1,    -1,     3,
      -1,     5,     6,   501,     8,     9,    10,    11,    12,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    20,    21,    22,    23,
      24,    25,    26,    27,    -1,    29,    30,    31,    -1,    -1,
      -1,    -1,    36,    -1,    -1,    39,    40,    41,    -1,    43,
      44,    45,    46,    47,    48,    49,    50,    51,    52,    53,
      54,    55,    -1,    57,    58,    59,    60,    61,    62,    63,
      64,    65,    66,    67,    68,    69,    70,    -1,    72,    73,
      74,    75,    76,    -1,    78,    -1,    80,    81,    82,    83,
      84,    85,    86,    87,    88,    89,    -1,    91,    92,    93,
      94,    95,    96,    -1,    98,    99,   100,   101,   102,   103,
     104,   105,   106,   107,   108,   109,   110,   111,   112,   113,
     114,   115,   116,   117,   118,   119,    -1,   121,   122,   123,
     124,   125,   126,   127,    -1,   129,   130,   131,   132,    -1,
      -1,   135,   136,   137,   138,   139,    -1,   141,   142,   143,
      -1,   145,   146,   147,    -1,   149,   150,   151,   152,   153,
     154,   155,   156,   157,   158,   159,   160,    -1,   162,   163,
     164,   165,   166,    -1,   168,    -1,   170,   171,    -1,   173,
     174,   175,   176,   177,    -1,   179,   180,    -1,   182,   183,
     184,    -1,   186,   187,   188,   189,   190,   191,   192,   193,
     194,   195,    -1,   197,   198,   199,   200,   201,   202,   203,
      -1,   205,   206,   207,   208,   209,   210,   211,   212,   213,
      -1,   215,    -1,   217,   218,   219,   220,   221,   222,   223,
     224,   225,   226,    -1,    -1,   229,   230,   231,   232,   233,
      -1,   235,   236,   237,   238,   239,   240,   241,   242,   243,
     244,   245,   246,   247,   248,   249,   250,   251,   252,   253,
     254,   255,   256,   257,   258,   259,   260,   261,   262,   263,
     264,   265,   266,   267,   268,   269,   270,   271,   272,   273,
     274,   275,   276,   277,   278,   279,   280,   281,   282,    -1,
     284,   285,    -1,    -1,   288,   289,   290,    -1,    -1,   293,
     294,   295,   296,   297,   298,   299,   300,   301,   302,   303,
     304,   305,   306,   307,   308,   309,    -1,    -1,   312,   313,
     314,   315,   316,   317,   318,   319,    -1,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,   333,
     334,   335,    -1,   337,   338,   339,   340,   341,   342,   343,
     344,   345,   346,   347,   348,   349,    -1,   351,   352,   353,
     354,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,   365,   366,   367,   368,    -1,   370,   371,   372,   373,
     374,   375,   376,   377,   378,   379,   380,   381,   382,   383,
     384,   385,    -1,   387,   388,   389,   390,   391,   392,   393,
     394,   395,   396,   397,   398,   399,   400,   401,    -1,   403,
     404,    -1,   406,   407,   408,   409,   410,   411,   412,    -1,
     414,   415,   416,    -1,    -1,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   431,   432,    -1,
     434,   435,   436,   437,   438,   439,   440,    -1,   442,   443,
     444,   445,   446,   447,   448,    -1,   450,   451,   452,   453,
     454,   455,    -1,    -1,   458,    -1,    -1,   461,   462,   463,
     464,   465,   466,   467,   468,   469,   470,   471,   472,   473,
     474,   475,   476,   477,   478,   479,   480,   481,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   492,   493,
      -1,    -1,    -1,     3,    -1,     5,     6,   501,     8,     9,
      10,    11,    12,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      20,    21,    22,    23,    24,    25,    26,    27,    -1,    29,
      30,    31,    -1,    -1,    -1,    -1,    36,    -1,    -1,    39,
      40,    41,    -1,    43,    44,    45,    46,    47,    48,    49,
      50,    51,    52,    53,    54,    55,    -1,    57,    58,    59,
      60,    61,    62,    63,    64,    65,    66,    67,    68,    69,
      70,    -1,    72,    73,    74,    75,    76,    -1,    78,    -1,
      80,    81,    82,    83,    84,    85,    86,    87,    88,    89,
      -1,    91,    92,    93,    94,    95,    96,    -1,    98,    99,
     100,   101,   102,   103,   104,   105,   106,   107,   108,   109,
     110,   111,   112,   113,   114,   115,   116,   117,   118,   119,
      -1,   121,   122,   123,   124,   125,   126,   127,    -1,   129,
     130,   131,   132,    -1,    -1,   135,   136,   137,   138,   139,
      -1,   141,   142,   143,    -1,   145,   146,   147,    -1,   149,
     150,   151,   152,   153,   154,   155,   156,   157,   158,   159,
     160,    -1,   162,   163,   164,   165,   166,    -1,   168,    -1,
     170,   171,    -1,   173,   174,   175,   176,   177,    -1,   179,
     180,    -1,   182,   183,   184,    -1,   186,   187,   188,   189,
     190,   191,   192,   193,   194,   195,    -1,   197,   198,   199,
     200,   201,   202,   203,    -1,   205,   206,   207,   208,   209,
     210,   211,   212,   213,    -1,   215,    -1,   217,   218,   219,
     220,   221,   222,   223,   224,   225,   226,    -1,    -1,   229,
     230,   231,   232,   233,    -1,   235,   236,   237,   238,   239,
     240,   241,   242,   243,   244,   245,   246,   247,   248,   249,
     250,   251,   252,   253,   254,   255,   256,   257,   258,   259,
     260,   261,   262,   263,   264,   265,   266,   267,   268,   269,
     270,   271,   272,   273,   274,   275,   276,   277,   278,   279,
     280,   281,   282,    -1,   284,   285,    -1,    -1,   288,   289,
     290,    -1,    -1,   293,   294,   295,   296,   297,   298,   299,
     300,   301,   302,   303,   304,   305,   306,   307,   308,   309,
      -1,    -1,   312,   313,   314,   315,   316,   317,   318,   319,
      -1,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,    -1,   337,   338,   339,
     340,   341,   342,   343,   344,   345,   346,   347,   348,   349,
      -1,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,   365,   366,   367,   368,    -1,
     370,   371,   372,   373,   374,   375,   376,   377,   378,   379,
     380,   381,   382,   383,   384,   385,    -1,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,   399,
     400,   401,    -1,   403,   404,    -1,   406,   407,   408,   409,
     410,   411,   412,    -1,   414,   415,   416,    -1,    -1,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,   432,    -1,   434,   435,   436,   437,   438,   439,
     440,    -1,   442,   443,   444,   445,   446,   447,   448,    -1,
     450,   451,   452,   453,   454,   455,    -1,    -1,   458,    -1,
      -1,   461,   462,   463,   464,   465,   466,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,   481,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   492,   493,    -1,    -1,    -1,     3,    -1,     5,
       6,   501,     8,     9,    10,    11,    12,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,    25,
      26,    27,    -1,    29,    30,    31,    -1,    -1,    -1,    -1,
      36,    -1,    -1,    39,    40,    41,    -1,    43,    44,    45,
      46,    47,    48,    49,    50,    51,    52,    53,    54,    55,
      -1,    57,    58,    59,    60,    61,    62,    63,    64,    65,
      66,    67,    68,    69,    70,    -1,    72,    73,    74,    75,
      76,    -1,    78,    -1,    80,    81,    82,    83,    84,    85,
      86,    87,    88,    89,    -1,    91,    92,    93,    94,    95,
      96,    -1,    98,    99,   100,   101,   102,   103,   104,   105,
     106,   107,   108,   109,   110,   111,   112,   113,   114,   115,
     116,   117,   118,   119,    -1,   121,   122,   123,   124,   125,
     126,   127,    -1,   129,   130,   131,   132,    -1,    -1,   135,
     136,   137,   138,   139,    -1,   141,   142,   143,    -1,   145,
     146,   147,    -1,   149,   150,   151,   152,   153,   154,   155,
     156,   157,   158,   159,   160,    -1,   162,   163,   164,   165,
     166,    -1,   168,    -1,   170,   171,    -1,   173,   174,   175,
     176,   177,    -1,   179,   180,    -1,   182,   183,   184,    -1,
     186,   187,   188,   189,   190,   191,   192,   193,   194,   195,
      -1,   197,   198,   199,   200,   201,   202,   203,    -1,   205,
     206,   207,   208,   209,   210,   211,   212,   213,    -1,   215,
      -1,   217,   218,   219,   220,   221,   222,   223,   224,   225,
     226,    -1,    -1,   229,   230,   231,   232,   233,    -1,   235,
     236,   237,   238,   239,   240,   241,   242,   243,   244,   245,
     246,   247,   248,   249,   250,   251,   252,   253,   254,   255,
     256,   257,   258,   259,   260,   261,   262,   263,   264,   265,
     266,   267,   268,   269,   270,   271,   272,   273,   274,   275,
     276,   277,   278,   279,   280,   281,   282,    -1,   284,   285,
      -1,    -1,   288,   289,   290,    -1,    -1,   293,   294,   295,
     296,   297,   298,   299,   300,   301,   302,   303,   304,   305,
     306,   307,   308,   309,    -1,    -1,   312,   313,   314,   315,
     316,   317,   318,   319,    -1,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
      -1,   337,   338,   339,   340,   341,   342,   343,   344,   345,
     346,   347,   348,   349,    -1,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
     366,   367,   368,    -1,   370,   371,   372,   373,   374,   375,
     376,   377,   378,   379,   380,   381,   382,   383,   384,   385,
      -1,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,   399,   400,   401,    -1,   403,   404,    -1,
     406,   407,   408,   409,   410,   411,   412,    -1,   414,   415,
     416,    -1,    -1,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,   432,    -1,   434,   435,
     436,   437,   438,   439,   440,    -1,   442,   443,   444,   445,
     446,   447,   448,    -1,   450,   451,   452,   453,   454,   455,
      -1,    -1,   458,    -1,    -1,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,   478,   479,   480,   481,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   492,   493,    -1,    -1,
      -1,     3,    -1,     5,     6,   501,     8,     9,    10,    11,
      12,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,    21,
      22,    23,    24,    25,    26,    27,    -1,    29,    30,    31,
      -1,    -1,    -1,    -1,    36,    -1,    -1,    39,    40,    41,
      -1,    43,    44,    45,    46,    47,    48,    49,    50,    51,
      52,    53,    54,    55,    -1,    57,    58,    59,    60,    61,
      62,    63,    64,    65,    66,    67,    68,    69,    70,    -1,
      72,    73,    74,    75,    76,    -1,    78,    -1,    80,    81,
      82,    83,    84,    85,    86,    87,    88,    89,    -1,    91,
      92,    93,    94,    95,    96,    -1,    98,    99,   100,   101,
     102,   103,   104,   105,   106,   107,   108,   109,   110,   111,
     112,   113,   114,   115,   116,   117,   118,   119,    -1,   121,
     122,   123,   124,   125,   126,   127,    -1,   129,   130,   131,
     132,    -1,    -1,   135,   136,   137,   138,   139,    -1,   141,
     142,   143,    -1,   145,   146,   147,    -1,   149,   150,   151,
     152,   153,   154,   155,   156,   157,   158,   159,   160,    -1,
     162,   163,   164,   165,   166,    -1,   168,    -1,   170,   171,
      -1,   173,   174,   175,   176,   177,    -1,   179,   180,    -1,
     182,   183,   184,    -1,   186,   187,   188,   189,   190,   191,
     192,   193,   194,   195,    -1,   197,   198,   199,   200,   201,
     202,   203,    -1,   205,   206,   207,   208,   209,   210,   211,
     212,   213,    -1,   215,    -1,   217,   218,   219,   220,   221,
     222,   223,   224,   225,   226,    -1,    -1,   229,   230,   231,
     232,   233,    -1,   235,   236,   237,   238,   239,   240,   241,
     242,   243,   244,   245,   246,   247,   248,   249,   250,   251,
     252,   253,   254,   255,   256,   257,   258,   259,   260,   261,
     262,   263,   264,   265,   266,   267,   268,   269,   270,   271,
     272,   273,   274,   275,   276,   277,   278,   279,   280,   281,
     282,    -1,   284,   285,    -1,    -1,   288,   289,   290,    -1,
      -1,   293,   294,   295,   296,   297,   298,   299,   300,   301,
     302,   303,   304,   305,   306,   307,   308,   309,    -1,    -1,
     312,   313,   314,   315,   316,   317,   318,   319,    -1,   321,
     322,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,   333,   334,   335,    -1,   337,   338,   339,   340,   341,
     342,   343,   344,   345,   346,   347,   348,   349,    -1,   351,
     352,   353,   354,   355,   356,   357,   358,   359,   360,   361,
     362,   363,   364,   365,   366,   367,   368,    -1,   370,   371,
     372,   373,   374,   375,   376,   377,   378,   379,   380,   381,
     382,   383,   384,   385,    -1,   387,   388,   389,   390,   391,
     392,   393,   394,   395,   396,   397,   398,   399,   400,   401,
      -1,   403,   404,    -1,   406,   407,   408,   409,   410,   411,
     412,    -1,   414,   415,   416,    -1,    -1,   419,   420,   421,
     422,   423,   424,   425,   426,   427,   428,   429,   430,   431,
     432,    -1,   434,   435,   436,   437,   438,   439,   440,    -1,
     442,   443,   444,   445,   446,   447,   448,    -1,   450,   451,
     452,   453,   454,   455,    -1,    -1,   458,    -1,    -1,   461,
     462,   463,   464,   465,   466,   467,   468,   469,   470,   471,
     472,   473,   474,   475,   476,   477,   478,   479,   480,   481,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     492,   493,    -1,    -1,    -1,     3,    -1,     5,     6,   501,
       8,     9,    10,    11,    12,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    20,    21,    22,    23,    24,    25,    26,    27,
      -1,    29,    30,    31,    -1,    -1,    -1,    -1,    36,    -1,
      -1,    39,    40,    41,    -1,    43,    44,    45,    46,    47,
      48,    49,    50,    51,    52,    53,    54,    55,    -1,    57,
      58,    59,    60,    61,    62,    63,    64,    65,    66,    67,
      68,    69,    70,    -1,    72,    73,    74,    75,    76,    -1,
      78,    -1,    80,    81,    82,    83,    84,    85,    86,    87,
      88,    89,    -1,    91,    92,    93,    94,    95,    96,    -1,
      98,    99,   100,   101,   102,   103,   104,   105,   106,   107,
     108,   109,   110,   111,   112,   113,   114,   115,   116,   117,
     118,   119,    -1,   121,   122,   123,   124,   125,   126,   127,
      -1,   129,   130,   131,   132,    -1,    -1,   135,   136,   137,
     138,   139,    -1,   141,   142,   143,    -1,   145,   146,   147,
      -1,   149,   150,   151,   152,   153,   154,   155,   156,   157,
     158,   159,   160,    -1,   162,   163,   164,   165,   166,    -1,
     168,    -1,   170,   171,    -1,   173,   174,   175,   176,   177,
      -1,   179,   180,    -1,   182,   183,   184,    -1,   186,   187,
     188,   189,   190,   191,   192,   193,   194,   195,    -1,   197,
     198,   199,   200,   201,   202,   203,    -1,   205,   206,   207,
     208,   209,   210,   211,   212,   213,    -1,   215,    -1,   217,
     218,   219,   220,   221,   222,   223,   224,   225,   226,    -1,
      -1,   229,   230,   231,   232,   233,    -1,   235,   236,   237,
     238,   239,   240,   241,   242,   243,   244,   245,   246,   247,
     248,   249,   250,   251,   252,   253,   254,   255,   256,   257,
     258,   259,   260,   261,   262,   263,   264,   265,   266,   267,
     268,   269,   270,   271,   272,   273,   274,   275,   276,   277,
     278,   279,   280,   281,   282,    -1,   284,   285,    -1,    -1,
     288,   289,   290,    -1,    -1,   293,   294,   295,   296,   297,
     298,   299,   300,   301,   302,   303,   304,   305,   306,   307,
     308,   309,    -1,    -1,   312,   313,   314,   315,   316,   317,
     318,   319,    -1,   321,   322,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,   333,   334,   335,    -1,   337,
     338,   339,   340,   341,   342,   343,   344,   345,   346,   347,
     348,   349,    -1,   351,   352,   353,   354,   355,   356,   357,
     358,   359,   360,   361,   362,   363,   364,   365,   366,   367,
     368,    -1,   370,   371,   372,   373,   374,   375,   376,   377,
     378,   379,   380,   381,   382,   383,   384,   385,    -1,   387,
     388,   389,   390,   391,   392,   393,   394,   395,   396,   397,
     398,   399,   400,   401,    -1,   403,   404,    -1,   406,   407,
     408,   409,   410,   411,   412,    -1,   414,   415,   416,    -1,
      -1,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,   432,    -1,   434,   435,   436,   437,
     438,   439,   440,    -1,   442,   443,   444,   445,   446,   447,
     448,    -1,   450,   451,   452,   453,   454,   455,    -1,    -1,
     458,    -1,    -1,   461,   462,   463,   464,   465,   466,   467,
     468,   469,   470,   471,   472,   473,   474,   475,   476,   477,
     478,   479,   480,   481,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   492,   493,    -1,    -1,    -1,     3,
      -1,     5,     6,   501,     8,     9,    10,    11,    12,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    20,    21,    22,    23,
      24,    25,    26,    27,    -1,    29,    30,    31,    -1,    -1,
      -1,    -1,    36,    -1,    -1,    39,    40,    41,    -1,    43,
      44,    45,    46,    47,    48,    49,    50,    51,    52,    53,
      54,    55,    -1,    57,    58,    59,    60,    61,    62,    63,
      64,    65,    66,    67,    68,    69,    70,    -1,    72,    73,
      74,    75,    76,    -1,    78,    -1,    80,    81,    82,    83,
      84,    85,    86,    87,    88,    89,    -1,    91,    92,    93,
      94,    95,    96,    -1,    98,    99,   100,   101,   102,   103,
     104,   105,   106,   107,   108,   109,   110,   111,   112,   113,
     114,   115,   116,   117,   118,   119,    -1,   121,   122,   123,
     124,   125,   126,   127,    -1,   129,   130,   131,   132,    -1,
      -1,   135,   136,   137,   138,   139,    -1,   141,   142,   143,
      -1,   145,   146,   147,    -1,   149,   150,   151,   152,   153,
     154,   155,   156,   157,   158,   159,   160,    -1,   162,   163,
     164,   165,   166,    -1,   168,    -1,   170,   171,    -1,   173,
     174,   175,   176,   177,    -1,   179,   180,    -1,   182,   183,
     184,    -1,   186,   187,   188,   189,   190,   191,   192,   193,
     194,   195,    -1,   197,   198,   199,   200,   201,   202,   203,
      -1,   205,   206,   207,   208,   209,   210,   211,   212,   213,
      -1,   215,    -1,   217,   218,   219,   220,   221,   222,   223,
     224,   225,   226,    -1,    -1,   229,   230,   231,   232,   233,
      -1,   235,   236,   237,   238,   239,   240,   241,   242,   243,
     244,   245,   246,   247,   248,   249,   250,   251,   252,   253,
     254,   255,   256,   257,   258,   259,   260,   261,   262,   263,
     264,   265,   266,   267,   268,   269,   270,    -1,   272,   273,
     274,   275,   276,   277,   278,   279,   280,   281,   282,    -1,
     284,   285,    -1,    -1,   288,   289,   290,    -1,    -1,   293,
     294,   295,   296,   297,   298,   299,   300,   301,   302,   303,
     304,   305,   306,   307,   308,   309,    -1,    -1,   312,   313,
     314,   315,   316,   317,   318,   319,    -1,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,   333,
     334,   335,    -1,   337,   338,   339,   340,   341,   342,   343,
     344,   345,   346,   347,   348,   349,    -1,   351,   352,   353,
     354,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,   365,   366,   367,   368,    -1,   370,   371,   372,   373,
     374,   375,   376,   377,   378,   379,   380,   381,   382,   383,
     384,   385,    -1,   387,   388,   389,   390,   391,   392,   393,
     394,   395,   396,   397,   398,   399,   400,   401,    -1,   403,
     404,    -1,   406,   407,   408,   409,   410,   411,   412,    -1,
     414,   415,   416,    -1,    -1,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   431,   432,    -1,
      -1,   435,   436,   437,   438,   439,   440,    -1,   442,   443,
     444,   445,   446,   447,   448,    -1,   450,   451,   452,   453,
     454,   455,    -1,    -1,   458,    -1,    -1,   461,   462,   463,
     464,   465,   466,   467,   468,   469,   470,   471,   472,   473,
     474,   475,   476,   477,   478,   479,   480,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   492,   493,
      -1,    -1,    -1,     3,    -1,     5,     6,   501,     8,     9,
      10,    11,    12,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      20,    21,    22,    23,    24,    25,    26,    27,    -1,    29,
      30,    31,    -1,    -1,    -1,    -1,    36,    -1,    -1,    39,
      40,    41,    -1,    43,    44,    45,    46,    47,    48,    49,
      50,    51,    52,    53,    54,    55,    -1,    57,    58,    59,
      60,    61,    62,    63,    64,    65,    66,    67,    68,    69,
      70,    -1,    72,    73,    74,    75,    76,    -1,    78,    -1,
      80,    81,    82,    83,    84,    85,    86,    87,    88,    89,
      -1,    91,    92,    93,    94,    95,    96,    -1,    98,    99,
     100,   101,   102,   103,   104,   105,   106,   107,   108,   109,
     110,   111,   112,   113,   114,   115,   116,   117,   118,   119,
      -1,   121,   122,   123,   124,   125,   126,   127,    -1,   129,
     130,   131,   132,    -1,    -1,   135,   136,   137,   138,   139,
      -1,   141,   142,   143,    -1,   145,   146,   147,    -1,   149,
     150,   151,   152,   153,   154,   155,   156,   157,   158,   159,
     160,    -1,   162,   163,   164,   165,   166,    -1,   168,    -1,
     170,   171,    -1,   173,   174,   175,   176,   177,    -1,   179,
     180,    -1,   182,   183,   184,    -1,   186,   187,   188,   189,
     190,   191,   192,   193,   194,   195,    -1,   197,   198,   199,
     200,   201,   202,   203,    -1,   205,   206,   207,   208,   209,
     210,   211,   212,   213,    -1,   215,    -1,   217,    -1,    -1,
     220,   221,   222,   223,   224,   225,   226,    -1,    -1,   229,
     230,   231,   232,   233,    -1,   235,   236,   237,   238,   239,
     240,   241,   242,   243,   244,   245,   246,   247,   248,   249,
     250,   251,   252,   253,   254,   255,   256,   257,   258,   259,
     260,   261,   262,   263,   264,   265,   266,   267,   268,   269,
     270,   271,   272,   273,    -1,   275,   276,   277,   278,   279,
     280,   281,   282,    -1,   284,   285,    -1,    -1,   288,   289,
     290,    -1,    -1,   293,   294,   295,   296,   297,   298,   299,
     300,   301,   302,   303,   304,   305,   306,   307,   308,   309,
      -1,    -1,   312,   313,   314,   315,   316,   317,   318,   319,
      -1,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,    -1,   337,   338,   339,
     340,   341,   342,   343,   344,   345,   346,   347,   348,   349,
      -1,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,   365,   366,   367,   368,    -1,
     370,   371,   372,   373,   374,   375,   376,   377,   378,   379,
     380,   381,   382,   383,   384,   385,    -1,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,   399,
     400,   401,    -1,   403,   404,    -1,   406,   407,   408,   409,
     410,   411,   412,    -1,   414,   415,   416,    -1,    -1,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,   432,    -1,   434,   435,   436,   437,   438,   439,
     440,    -1,   442,   443,   444,   445,   446,   447,   448,    -1,
     450,   451,   452,   453,   454,   455,    -1,    -1,   458,    -1,
      -1,   461,   462,   463,   464,   465,   466,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,   481,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   492,   493,    -1,    -1,    -1,     3,    -1,     5,
       6,   501,     8,     9,    10,    11,    12,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,    25,
      26,    27,    -1,    29,    30,    31,    -1,    -1,    -1,    -1,
      36,    -1,    -1,    39,    40,    41,    -1,    43,    44,    45,
      46,    47,    48,    49,    50,    51,    52,    53,    54,    55,
      -1,    57,    58,    59,    60,    61,    62,    63,    64,    65,
      66,    67,    68,    69,    70,    -1,    72,    73,    74,    75,
      76,    -1,    78,    -1,    80,    81,    82,    83,    84,    85,
      86,    87,    88,    89,    -1,    91,    92,    93,    94,    95,
      96,    -1,    98,    99,   100,   101,   102,   103,   104,   105,
     106,   107,   108,   109,   110,   111,   112,   113,   114,   115,
     116,   117,    -1,   119,    -1,   121,   122,   123,   124,   125,
     126,   127,    -1,   129,   130,   131,   132,    -1,    -1,   135,
     136,   137,   138,   139,    -1,   141,   142,   143,    -1,   145,
     146,   147,    -1,   149,   150,   151,   152,   153,   154,   155,
     156,   157,   158,   159,   160,    -1,   162,   163,   164,   165,
     166,    -1,   168,    -1,   170,   171,    -1,   173,   174,   175,
     176,   177,    -1,   179,   180,    -1,   182,   183,   184,    -1,
     186,   187,   188,   189,   190,   191,   192,   193,   194,   195,
      -1,   197,   198,   199,   200,   201,   202,   203,    -1,   205,
     206,   207,   208,   209,   210,   211,   212,   213,    -1,   215,
      -1,   217,   218,   219,   220,   221,   222,   223,   224,   225,
     226,    -1,    -1,   229,   230,   231,   232,   233,    -1,   235,
     236,   237,   238,   239,   240,   241,   242,   243,   244,   245,
     246,   247,   248,   249,   250,   251,   252,   253,   254,   255,
     256,   257,   258,   259,   260,   261,   262,   263,   264,   265,
     266,   267,   268,   269,   270,    -1,   272,   273,   274,   275,
     276,   277,   278,   279,   280,   281,   282,    -1,   284,   285,
      -1,    -1,   288,   289,   290,    -1,    -1,   293,   294,   295,
     296,   297,   298,   299,   300,   301,   302,   303,   304,   305,
     306,   307,   308,   309,    -1,    -1,   312,   313,   314,   315,
     316,   317,   318,   319,    -1,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
      -1,   337,   338,   339,   340,   341,   342,   343,   344,   345,
     346,   347,   348,   349,    -1,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
     366,   367,   368,    -1,   370,   371,   372,   373,   374,   375,
     376,   377,   378,   379,   380,   381,   382,   383,   384,   385,
      -1,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,   399,   400,   401,    -1,   403,   404,    -1,
     406,   407,   408,   409,   410,   411,   412,    -1,   414,   415,
     416,    -1,    -1,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,   432,    -1,    -1,   435,
     436,   437,   438,   439,   440,    -1,   442,   443,   444,   445,
     446,   447,   448,    -1,   450,   451,   452,   453,   454,   455,
      -1,    -1,   458,    -1,    -1,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,   478,   479,   480,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   492,   493,     3,    -1,
       5,     6,    -1,     8,     9,   501,    11,    12,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,
      25,    26,    27,    -1,    29,    30,    31,    -1,    -1,    -1,
      -1,    36,    -1,    -1,    39,    40,    41,    -1,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    -1,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    -1,    72,    73,    74,
      75,    76,    -1,    78,    -1,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    -1,    91,    92,    93,    94,
      95,    96,    -1,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,   116,   117,    -1,   119,    -1,   121,   122,   123,   124,
     125,   126,   127,    -1,   129,   130,   131,   132,    -1,    -1,
     135,   136,   137,   138,   139,    -1,   141,   142,   143,    -1,
     145,   146,   147,    -1,   149,   150,   151,   152,   153,   154,
     155,   156,   157,   158,   159,   160,    -1,   162,   163,   164,
     165,   166,    -1,   168,    -1,   170,   171,    -1,   173,   174,
     175,   176,   177,    -1,   179,   180,    -1,   182,   183,   184,
      -1,   186,   187,   188,   189,   190,   191,   192,   193,   194,
     195,    -1,   197,   198,   199,   200,   201,   202,   203,    -1,
     205,   206,   207,   208,   209,   210,   211,   212,   213,    -1,
     215,    -1,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,    -1,    -1,   229,   230,   231,   232,   233,    -1,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,   246,   247,   248,   249,   250,   251,   252,   253,   254,
     255,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,    -1,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,    -1,   284,
     285,    -1,    -1,   288,   289,   290,    -1,    -1,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,    -1,    -1,   312,   313,   314,
     315,   316,   317,   318,   319,    -1,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,    -1,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,    -1,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,   366,   367,   368,    -1,   370,   371,   372,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,    -1,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,   400,   401,    -1,   403,   404,
      -1,   406,   407,   408,   409,   410,   411,   412,    -1,   414,
     415,   416,    -1,    -1,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,   431,   432,    -1,    -1,
     435,   436,   437,   438,   439,   440,    -1,   442,   443,   444,
     445,   446,   447,   448,    -1,   450,   451,   452,   453,   454,
     455,    -1,    -1,   458,    -1,    -1,   461,   462,   463,   464,
     465,   466,   467,   468,   469,   470,   471,   472,   473,   474,
     475,   476,   477,   478,   479,   480,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   492,   493,     3,
      -1,     5,     6,    -1,     8,     9,   501,    11,    12,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    20,    21,    22,    23,
      24,    25,    26,    27,    -1,    29,    30,    31,    -1,    -1,
      -1,    -1,    36,    -1,    -1,    39,    40,    41,    -1,    43,
      44,    45,    46,    47,    48,    49,    50,    51,    52,    53,
      54,    55,    -1,    57,    58,    59,    60,    61,    62,    63,
      64,    65,    66,    67,    68,    69,    70,    -1,    72,    73,
      74,    75,    76,    -1,    78,    -1,    80,    81,    82,    83,
      84,    85,    86,    87,    88,    89,    -1,    91,    92,    93,
      94,    95,    96,    -1,    98,    99,   100,   101,   102,   103,
     104,   105,   106,   107,   108,   109,   110,   111,   112,   113,
     114,   115,   116,   117,    -1,   119,    -1,   121,   122,   123,
     124,   125,   126,   127,    -1,   129,   130,   131,   132,    -1,
      -1,   135,   136,   137,   138,   139,    -1,   141,   142,   143,
      -1,   145,   146,   147,    -1,   149,   150,   151,   152,   153,
     154,   155,   156,   157,   158,   159,   160,    -1,   162,   163,
     164,   165,   166,    -1,   168,    -1,   170,   171,    -1,   173,
     174,   175,   176,   177,    -1,   179,   180,    -1,   182,   183,
     184,    -1,   186,   187,   188,   189,   190,   191,   192,   193,
     194,   195,    -1,   197,   198,   199,   200,   201,   202,   203,
      -1,   205,   206,   207,   208,   209,   210,   211,   212,   213,
      -1,   215,    -1,   217,   218,   219,   220,   221,   222,   223,
     224,   225,   226,    -1,    -1,   229,   230,   231,   232,   233,
      -1,   235,   236,   237,   238,   239,   240,   241,   242,   243,
     244,   245,   246,   247,   248,   249,   250,   251,   252,   253,
     254,   255,   256,   257,   258,   259,   260,   261,   262,   263,
     264,   265,   266,   267,   268,   269,   270,    -1,   272,   273,
     274,   275,   276,   277,   278,   279,   280,   281,   282,    -1,
     284,   285,    -1,    -1,   288,   289,   290,    -1,    -1,   293,
     294,   295,   296,   297,   298,   299,   300,   301,   302,   303,
     304,   305,   306,   307,   308,   309,    -1,    -1,   312,   313,
     314,   315,   316,   317,   318,   319,    -1,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,   333,
     334,   335,    -1,   337,   338,   339,   340,   341,   342,   343,
     344,   345,   346,   347,   348,   349,    -1,   351,   352,   353,
     354,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,   365,   366,   367,   368,    -1,   370,   371,   372,   373,
     374,   375,   376,   377,   378,   379,   380,   381,   382,   383,
     384,   385,    -1,   387,   388,   389,   390,   391,   392,   393,
     394,   395,   396,   397,   398,   399,   400,   401,    -1,   403,
     404,    -1,   406,   407,   408,   409,   410,   411,   412,    -1,
     414,   415,   416,    -1,    -1,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   431,   432,    -1,
      -1,   435,   436,   437,   438,   439,   440,    -1,   442,   443,
     444,   445,   446,   447,   448,    -1,   450,   451,   452,   453,
     454,   455,    -1,    -1,   458,    -1,    -1,   461,   462,   463,
     464,   465,   466,   467,   468,   469,   470,   471,   472,   473,
     474,   475,   476,   477,   478,   479,   480,    -1,    -1,    -1,
      -1,     3,    -1,     5,     6,    -1,     8,     9,    -1,    11,
      12,    -1,    -1,    -1,    -1,    -1,    -1,   501,    20,    21,
      22,    23,    24,    25,    26,    27,    -1,    29,    30,    31,
      -1,    -1,    -1,    -1,    36,    -1,    -1,    39,    40,    41,
      -1,    43,    44,    45,    46,    47,    48,    49,    50,    51,
      52,    53,    54,    55,    -1,    57,    58,    59,    60,    61,
      62,    63,    64,    65,    66,    67,    68,    69,    70,    -1,
      72,    73,    74,    75,    76,    -1,    78,    -1,    80,    81,
      82,    83,    84,    85,    86,    87,    88,    89,    -1,    91,
      92,    93,    94,    95,    96,    -1,    98,    99,   100,   101,
     102,   103,   104,   105,   106,   107,   108,   109,   110,   111,
     112,   113,   114,   115,   116,   117,    -1,   119,    -1,   121,
     122,   123,   124,   125,   126,   127,    -1,   129,   130,   131,
     132,    -1,    -1,   135,   136,   137,   138,   139,    -1,   141,
     142,   143,    -1,   145,   146,   147,    -1,   149,   150,   151,
     152,   153,   154,   155,   156,   157,   158,   159,   160,    -1,
     162,   163,   164,   165,   166,    -1,   168,    -1,   170,   171,
      -1,   173,   174,   175,   176,   177,    -1,   179,   180,    -1,
     182,   183,   184,    -1,   186,   187,   188,   189,   190,   191,
     192,   193,   194,   195,    -1,   197,   198,   199,   200,   201,
     202,   203,    -1,   205,   206,   207,   208,   209,   210,   211,
     212,   213,    -1,   215,    -1,   217,   218,   219,   220,   221,
     222,   223,   224,   225,   226,    -1,    -1,   229,   230,   231,
     232,   233,    -1,   235,   236,   237,   238,   239,   240,   241,
     242,   243,   244,   245,   246,   247,   248,   249,   250,   251,
     252,   253,   254,   255,   256,   257,   258,   259,   260,   261,
     262,   263,   264,   265,   266,   267,   268,   269,   270,    -1,
     272,   273,   274,   275,   276,   277,   278,   279,   280,   281,
     282,    -1,   284,   285,    -1,    -1,   288,   289,   290,    -1,
      -1,   293,   294,   295,   296,   297,   298,   299,   300,   301,
     302,   303,   304,   305,   306,   307,   308,   309,    -1,    -1,
     312,   313,   314,   315,   316,   317,   318,   319,    -1,   321,
     322,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,   333,   334,   335,    -1,   337,   338,   339,   340,   341,
     342,   343,   344,   345,   346,   347,   348,   349,    -1,   351,
     352,   353,   354,   355,   356,   357,   358,   359,   360,   361,
     362,   363,   364,   365,   366,   367,   368,    -1,   370,   371,
     372,   373,   374,   375,   376,   377,   378,   379,   380,   381,
     382,   383,   384,   385,    -1,   387,   388,   389,   390,   391,
     392,   393,   394,   395,   396,   397,   398,   399,   400,   401,
      -1,   403,   404,    -1,   406,   407,   408,   409,   410,   411,
     412,    -1,   414,   415,   416,    -1,    -1,   419,   420,   421,
     422,   423,   424,   425,   426,   427,   428,   429,   430,   431,
     432,    -1,    -1,   435,   436,   437,   438,   439,   440,    -1,
     442,   443,   444,   445,   446,   447,   448,    -1,   450,   451,
     452,   453,   454,   455,    -1,    -1,   458,    -1,    -1,   461,
     462,   463,   464,   465,   466,   467,   468,   469,   470,   471,
     472,   473,   474,   475,   476,   477,   478,   479,   480,    -1,
      -1,    -1,    -1,     3,    -1,     5,     6,    -1,     8,     9,
      -1,    11,    12,    -1,    -1,    -1,    -1,    -1,    -1,   501,
      20,    21,    22,    23,    24,    25,    26,    27,    -1,    29,
      30,    31,    -1,    -1,    -1,    -1,    36,    -1,    -1,    39,
      40,    41,    -1,    43,    44,    45,    46,    47,    48,    49,
      50,    51,    52,    53,    54,    55,    -1,    57,    58,    59,
      60,    61,    62,    63,    64,    65,    66,    67,    68,    69,
      70,    -1,    72,    73,    74,    75,    76,    -1,    78,    -1,
      80,    81,    82,    83,    84,    85,    86,    87,    88,    89,
      -1,    91,    92,    93,    94,    95,    96,    -1,    98,    99,
     100,   101,   102,   103,   104,   105,   106,   107,   108,   109,
     110,   111,   112,   113,   114,   115,   116,   117,    -1,   119,
      -1,   121,   122,   123,   124,   125,   126,   127,    -1,   129,
     130,   131,   132,    -1,    -1,   135,   136,   137,   138,   139,
      -1,   141,   142,   143,    -1,   145,   146,   147,    -1,   149,
     150,   151,   152,   153,   154,   155,   156,   157,   158,   159,
     160,    -1,   162,   163,   164,   165,   166,    -1,   168,    -1,
     170,   171,    -1,   173,   174,   175,   176,   177,    -1,   179,
     180,    -1,   182,   183,   184,    -1,   186,   187,   188,   189,
     190,   191,   192,   193,   194,   195,    -1,   197,   198,   199,
     200,   201,   202,   203,    -1,   205,   206,   207,   208,   209,
     210,   211,   212,   213,    -1,   215,    -1,   217,   218,   219,
     220,   221,   222,   223,   224,   225,   226,    -1,    -1,   229,
     230,   231,   232,   233,    -1,   235,   236,   237,   238,   239,
     240,   241,   242,   243,   244,   245,   246,   247,   248,   249,
     250,   251,   252,   253,   254,   255,   256,   257,   258,   259,
     260,   261,   262,   263,   264,   265,   266,   267,   268,   269,
     270,    -1,   272,   273,   274,   275,   276,   277,   278,   279,
     280,   281,   282,    -1,   284,   285,    -1,    -1,   288,   289,
     290,    -1,    -1,   293,   294,   295,   296,   297,   298,   299,
     300,   301,   302,   303,   304,   305,   306,   307,   308,   309,
      -1,    -1,   312,   313,   314,   315,   316,   317,   318,   319,
      -1,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,    -1,   337,   338,   339,
     340,   341,   342,   343,   344,   345,   346,   347,   348,   349,
      -1,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,   365,   366,   367,   368,    -1,
     370,   371,   372,   373,   374,   375,   376,   377,   378,   379,
     380,   381,   382,   383,   384,   385,    -1,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,   399,
     400,   401,    -1,   403,   404,    -1,   406,   407,   408,   409,
     410,   411,   412,    -1,   414,   415,   416,    -1,    -1,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,   432,    -1,    -1,   435,   436,   437,   438,   439,
     440,    -1,   442,   443,   444,   445,   446,   447,   448,    -1,
     450,   451,   452,   453,   454,   455,    -1,    -1,   458,    -1,
      -1,   461,   462,   463,   464,   465,   466,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,    -1,    -1,    -1,    -1,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   501,    20,    21,    22,    23,    24,    25,    26,    27,
      -1,    29,    30,    31,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    39,    40,    41,    -1,    43,    44,    45,    46,    47,
      48,    49,    50,    51,    52,    53,    54,    55,    -1,    57,
      58,    59,    60,    61,    62,    63,    -1,    65,    66,    67,
      68,    69,    70,    -1,    72,    73,    74,    75,    76,    -1,
      78,    -1,    80,    81,    82,    83,    84,    85,    86,    87,
      88,    89,    -1,    91,    92,    93,    94,    95,    96,    -1,
      98,    99,   100,   101,   102,   103,   104,   105,   106,   107,
     108,   109,   110,   111,   112,   113,   114,   115,   116,   117,
      -1,   119,    -1,   121,   122,   123,   124,   125,   126,   127,
      -1,   129,   130,   131,   132,    -1,    -1,   135,   136,   137,
     138,   139,    -1,   141,   142,   143,    -1,   145,   146,   147,
      -1,   149,   150,   151,   152,   153,   154,   155,   156,   157,
     158,    -1,   160,    -1,   162,   163,   164,   165,   166,    -1,
     168,    -1,   170,   171,    -1,   173,   174,   175,   176,   177,
      -1,   179,   180,    -1,   182,   183,   184,    -1,   186,   187,
     188,   189,   190,   191,   192,   193,   194,   195,    -1,   197,
     198,   199,   200,   201,   202,   203,    -1,   205,   206,   207,
     208,   209,   210,   211,   212,   213,    -1,   215,    -1,   217,
     218,   219,   220,   221,   222,   223,   224,   225,   226,   227,
      -1,   229,   230,   231,   232,   233,    -1,   235,   236,   237,
     238,   239,   240,   241,   242,   243,   244,   245,   246,   247,
     248,   249,   250,   251,   252,   253,   254,   255,   256,   257,
     258,   259,   260,   261,   262,   263,   264,   265,   266,   267,
     268,   269,   270,    -1,   272,   273,   274,   275,    -1,   277,
     278,   279,   280,   281,   282,    -1,   284,   285,    -1,   287,
     288,   289,   290,    -1,    -1,   293,   294,   295,   296,   297,
     298,   299,   300,   301,   302,   303,   304,   305,   306,   307,
     308,   309,    -1,    -1,   312,   313,   314,   315,   316,   317,
     318,   319,    -1,   321,   322,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,   333,   334,   335,    -1,   337,
     338,   339,   340,   341,   342,   343,   344,   345,   346,   347,
     348,   349,    -1,   351,   352,   353,   354,   355,   356,   357,
     358,   359,   360,   361,   362,   363,   364,   365,   366,   367,
     368,   369,   370,   371,   372,   373,   374,   375,   376,   377,
     378,   379,   380,   381,   382,   383,   384,   385,    -1,   387,
     388,   389,   390,   391,   392,   393,   394,   395,   396,   397,
     398,   399,   400,   401,    -1,   403,   404,   405,   406,   407,
     408,   409,   410,   411,   412,    -1,   414,   415,   416,    -1,
      -1,   419,   420,   421,   422,   423,    -1,   425,   426,   427,
     428,   429,   430,   431,   432,    -1,    -1,   435,   436,   437,
     438,   439,   440,    -1,   442,   443,   444,   445,   446,   447,
     448,    -1,   450,   451,   452,   453,   454,   455,    -1,    -1,
     458,    -1,   460,   461,   462,   463,   464,   465,   466,   467,
     468,   469,   470,   471,   472,   473,   474,   475,   476,   477,
     478,   479,   480,    -1,    -1,   483,    -1,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   501,    20,    21,    22,    23,    24,    25,
      26,    27,    -1,    29,    30,    31,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    39,    40,    41,    -1,    43,    44,    45,
      46,    47,    48,    49,    50,    51,    52,    53,    54,    55,
      -1,    57,    58,    59,    60,    61,    62,    63,    -1,    65,
      66,    67,    68,    69,    70,    -1,    72,    73,    74,    75,
      76,    -1,    78,    -1,    80,    81,    82,    83,    84,    85,
      86,    87,    88,    89,    -1,    91,    92,    93,    94,    95,
      96,    -1,    98,    99,   100,   101,   102,   103,   104,   105,
     106,   107,   108,   109,   110,   111,   112,   113,   114,   115,
     116,   117,    -1,   119,    -1,   121,   122,   123,   124,   125,
     126,   127,    -1,   129,   130,   131,   132,    -1,    -1,   135,
     136,   137,   138,   139,    -1,   141,   142,   143,    -1,   145,
     146,   147,    -1,   149,   150,   151,   152,   153,   154,   155,
     156,   157,   158,    -1,   160,    -1,   162,   163,   164,   165,
     166,    -1,   168,    -1,   170,   171,    -1,   173,   174,   175,
     176,   177,    -1,   179,   180,    -1,   182,   183,   184,    -1,
     186,   187,   188,   189,   190,   191,   192,   193,   194,   195,
      -1,   197,   198,   199,   200,   201,   202,   203,    -1,   205,
     206,   207,   208,   209,   210,   211,   212,   213,    -1,   215,
      -1,   217,   218,   219,   220,   221,   222,   223,   224,   225,
     226,   227,    -1,   229,   230,   231,   232,   233,    -1,   235,
     236,   237,   238,   239,   240,   241,   242,   243,   244,   245,
     246,   247,   248,   249,   250,   251,   252,   253,   254,   255,
     256,   257,   258,   259,   260,   261,   262,   263,   264,   265,
     266,   267,   268,   269,   270,    -1,   272,   273,   274,   275,
      -1,   277,   278,   279,   280,   281,   282,    -1,   284,   285,
      -1,   287,   288,   289,   290,    -1,    -1,   293,   294,   295,
     296,   297,   298,   299,   300,   301,   302,   303,   304,   305,
     306,   307,   308,   309,    -1,    -1,   312,   313,   314,   315,
     316,   317,   318,   319,    -1,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
      -1,   337,   338,   339,   340,   341,   342,   343,   344,   345,
     346,   347,   348,   349,    -1,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
     366,   367,   368,    -1,   370,   371,   372,   373,   374,   375,
     376,   377,   378,   379,   380,   381,   382,   383,   384,   385,
      -1,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,   399,   400,   401,    -1,   403,   404,    -1,
     406,   407,   408,   409,   410,   411,   412,    -1,   414,   415,
     416,    -1,    -1,   419,   420,   421,   422,   423,    -1,   425,
     426,   427,   428,   429,   430,   431,   432,    -1,    -1,   435,
     436,   437,   438,   439,   440,    -1,   442,   443,   444,   445,
     446,   447,   448,    -1,   450,   451,   452,   453,   454,   455,
      -1,    -1,   458,    -1,    -1,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,   478,   479,   480,    -1,    -1,    -1,    -1,     3,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   501,    20,    21,    22,    23,
      24,    25,    26,    27,    -1,    29,    30,    31,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    39,    40,    41,    -1,    43,
      44,    45,    46,    47,    48,    49,    50,    51,    52,    53,
      54,    55,    -1,    57,    58,    59,    60,    61,    62,    63,
      -1,    65,    66,    67,    68,    69,    70,    -1,    72,    73,
      74,    75,    76,    -1,    78,    -1,    80,    81,    82,    83,
      84,    85,    86,    87,    88,    89,    -1,    91,    92,    93,
      94,    95,    96,    -1,    98,    99,   100,   101,   102,   103,
     104,   105,   106,   107,   108,   109,   110,   111,   112,   113,
     114,   115,   116,   117,    -1,   119,    -1,   121,   122,   123,
     124,   125,   126,   127,    -1,   129,   130,   131,   132,    -1,
      -1,   135,   136,   137,   138,   139,    -1,   141,   142,   143,
      -1,   145,   146,   147,    -1,   149,   150,   151,   152,   153,
     154,   155,   156,   157,   158,    -1,   160,    -1,   162,   163,
     164,   165,   166,    -1,   168,    -1,   170,   171,    -1,   173,
     174,   175,   176,   177,    -1,   179,   180,    -1,   182,   183,
     184,    -1,   186,   187,   188,   189,   190,   191,   192,   193,
     194,   195,    -1,   197,   198,   199,   200,   201,   202,   203,
      -1,   205,   206,   207,   208,   209,   210,   211,   212,   213,
      -1,   215,    -1,   217,   218,   219,   220,   221,   222,   223,
     224,   225,   226,    -1,    -1,   229,   230,   231,   232,   233,
      -1,   235,   236,   237,   238,   239,   240,   241,   242,   243,
     244,   245,   246,   247,   248,   249,   250,   251,   252,   253,
     254,   255,   256,   257,   258,   259,   260,   261,   262,   263,
     264,   265,   266,   267,   268,   269,   270,    -1,   272,   273,
     274,   275,    -1,   277,   278,   279,   280,   281,   282,    -1,
     284,   285,    -1,    -1,   288,   289,   290,    -1,    -1,   293,
     294,   295,   296,   297,   298,   299,   300,   301,   302,   303,
     304,   305,   306,   307,   308,   309,    -1,    -1,   312,   313,
     314,   315,   316,   317,   318,   319,    -1,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,   333,
     334,   335,    -1,   337,   338,   339,   340,   341,   342,   343,
     344,   345,   346,   347,   348,   349,    -1,   351,   352,   353,
     354,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,   365,   366,   367,   368,    -1,   370,   371,   372,   373,
     374,   375,   376,   377,   378,   379,   380,   381,   382,   383,
     384,   385,    -1,   387,   388,   389,   390,   391,   392,   393,
     394,   395,   396,   397,   398,   399,   400,   401,    -1,   403,
     404,    -1,   406,   407,   408,   409,   410,   411,   412,    -1,
     414,   415,   416,    -1,    -1,   419,   420,   421,   422,   423,
      -1,   425,   426,   427,   428,   429,   430,   431,   432,    -1,
      -1,   435,   436,   437,   438,   439,   440,    -1,   442,   443,
     444,   445,   446,   447,   448,    -1,   450,   451,   452,   453,
     454,   455,    -1,    -1,   458,    -1,    -1,   461,   462,   463,
     464,   465,   466,   467,   468,   469,   470,   471,   472,   473,
     474,   475,   476,   477,   478,   479,   480,    -1,    -1,    -1,
      -1,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   501,    20,    21,
      22,    23,    24,    25,    26,    27,    -1,    29,    30,    31,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    39,    40,    41,
      -1,    43,    44,    45,    46,    47,    48,    49,    50,    51,
      52,    53,    54,    55,    -1,    57,    58,    59,    60,    61,
      62,    63,    -1,    65,    66,    67,    68,    69,    70,    -1,
      72,    73,    74,    75,    76,    -1,    78,    -1,    80,    81,
      82,    83,    84,    85,    86,    87,    88,    89,    -1,    91,
      92,    93,    94,    95,    96,    -1,    98,    99,   100,   101,
     102,   103,   104,   105,   106,   107,   108,   109,   110,   111,
     112,   113,   114,   115,   116,   117,    -1,   119,    -1,   121,
     122,   123,   124,   125,   126,   127,    -1,   129,   130,   131,
     132,    -1,    -1,   135,   136,   137,   138,   139,    -1,   141,
     142,   143,    -1,   145,   146,   147,    -1,   149,   150,   151,
     152,   153,   154,   155,   156,   157,   158,    -1,   160,    -1,
     162,   163,   164,   165,   166,    -1,   168,    -1,   170,   171,
      -1,   173,   174,   175,   176,   177,    -1,   179,   180,    -1,
     182,   183,   184,    -1,   186,   187,   188,   189,   190,   191,
     192,   193,   194,   195,    -1,   197,   198,   199,   200,   201,
     202,   203,    -1,   205,   206,   207,   208,   209,   210,   211,
     212,   213,    -1,   215,    -1,   217,   218,   219,   220,   221,
     222,   223,   224,   225,   226,    -1,    -1,   229,   230,   231,
     232,   233,    -1,   235,   236,   237,   238,   239,   240,   241,
     242,   243,   244,   245,   246,   247,   248,   249,   250,   251,
     252,   253,   254,   255,   256,   257,   258,   259,   260,   261,
     262,   263,   264,   265,   266,   267,   268,   269,   270,    -1,
     272,   273,   274,   275,    -1,   277,   278,   279,   280,   281,
     282,    -1,   284,   285,    -1,    -1,   288,   289,   290,    -1,
      -1,   293,   294,   295,   296,   297,   298,   299,   300,   301,
     302,   303,   304,   305,   306,   307,   308,   309,    -1,    -1,
     312,   313,   314,   315,   316,   317,   318,   319,    -1,   321,
     322,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,   333,   334,   335,    -1,   337,   338,   339,   340,   341,
     342,   343,   344,   345,   346,   347,   348,   349,    -1,   351,
     352,   353,   354,   355,   356,   357,   358,   359,   360,   361,
     362,   363,   364,   365,   366,   367,   368,    -1,   370,   371,
     372,   373,   374,   375,   376,   377,   378,   379,   380,   381,
     382,   383,   384,   385,    -1,   387,   388,   389,   390,   391,
     392,   393,   394,   395,   396,   397,   398,   399,   400,   401,
      -1,   403,   404,    -1,   406,   407,   408,   409,   410,   411,
     412,    -1,   414,   415,   416,    -1,    -1,   419,   420,   421,
     422,   423,    -1,   425,   426,   427,   428,   429,   430,   431,
     432,    -1,    -1,   435,   436,   437,   438,   439,   440,    -1,
     442,   443,   444,   445,   446,   447,   448,    -1,   450,   451,
     452,   453,   454,   455,    -1,    -1,   458,    -1,    -1,   461,
     462,   463,   464,   465,   466,   467,   468,   469,   470,   471,
     472,   473,   474,   475,   476,   477,   478,   479,   480,    -1,
      -1,    -1,    -1,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   501,
      20,    21,    22,    23,    24,    25,    26,    27,    -1,    29,
      30,    31,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    39,
      40,    41,    -1,    43,    44,    45,    46,    47,    48,    49,
      50,    51,    52,    53,    54,    55,    -1,    57,    58,    59,
      60,    61,    62,    63,    -1,    65,    66,    67,    68,    69,
      70,    -1,    72,    73,    74,    75,    76,    -1,    78,    -1,
      80,    81,    82,    83,    84,    85,    86,    87,    88,    89,
      -1,    91,    92,    93,    94,    95,    96,    -1,    98,    99,
     100,   101,   102,   103,   104,   105,   106,   107,   108,   109,
     110,   111,   112,   113,   114,   115,   116,   117,    -1,   119,
      -1,   121,   122,   123,   124,   125,   126,   127,    -1,   129,
     130,   131,   132,    -1,    -1,   135,   136,   137,   138,   139,
      -1,   141,   142,   143,    -1,   145,   146,   147,    -1,   149,
     150,   151,   152,   153,   154,   155,   156,   157,   158,    -1,
     160,    -1,   162,   163,   164,   165,   166,    -1,   168,    -1,
     170,   171,    -1,   173,   174,   175,   176,   177,    -1,   179,
     180,    -1,   182,   183,   184,    -1,   186,   187,   188,   189,
     190,   191,   192,   193,   194,   195,    -1,   197,   198,   199,
     200,   201,   202,   203,    -1,   205,   206,   207,   208,   209,
     210,   211,   212,   213,    -1,   215,    -1,   217,   218,   219,
     220,   221,   222,   223,   224,   225,   226,    -1,    -1,   229,
     230,   231,   232,   233,    -1,   235,   236,   237,   238,   239,
     240,   241,   242,   243,   244,   245,   246,   247,   248,   249,
     250,   251,   252,   253,   254,   255,   256,   257,   258,   259,
     260,   261,   262,   263,   264,   265,   266,   267,   268,   269,
     270,    -1,   272,   273,   274,   275,    -1,   277,   278,   279,
     280,   281,   282,    -1,   284,   285,    -1,    -1,   288,   289,
     290,    -1,    -1,   293,   294,   295,   296,   297,   298,   299,
     300,   301,   302,   303,   304,   305,   306,   307,   308,   309,
      -1,    -1,   312,   313,   314,   315,   316,   317,   318,   319,
      -1,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,    -1,   337,   338,   339,
     340,   341,   342,   343,   344,   345,   346,   347,   348,   349,
      -1,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,   365,   366,   367,   368,    -1,
     370,   371,   372,   373,   374,   375,   376,   377,   378,   379,
     380,   381,   382,   383,   384,   385,    -1,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,   399,
     400,   401,    -1,   403,   404,    -1,   406,   407,   408,   409,
     410,   411,   412,    -1,   414,   415,   416,    -1,    -1,   419,
     420,   421,   422,   423,    -1,   425,   426,   427,   428,   429,
     430,   431,   432,    -1,    -1,   435,   436,   437,   438,   439,
     440,    -1,   442,   443,   444,   445,   446,   447,   448,    -1,
     450,   451,   452,   453,   454,   455,    -1,    -1,   458,    -1,
      -1,   461,   462,   463,   464,   465,   466,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,    -1,    -1,    -1,    -1,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   501,    20,    21,    22,    23,    24,    25,    26,    27,
      -1,    29,    30,    31,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    39,    40,    41,    -1,    43,    44,    45,    46,    47,
      48,    49,    50,    51,    52,    53,    54,    55,    -1,    57,
      58,    59,    60,    61,    62,    63,    -1,    65,    66,    67,
      68,    69,    70,    -1,    72,    73,    74,    75,    76,    -1,
      78,    -1,    80,    81,    82,    83,    84,    85,    86,    87,
      88,    89,    -1,    91,    92,    93,    94,    95,    96,    -1,
      98,    99,   100,   101,   102,   103,   104,   105,   106,   107,
     108,   109,   110,   111,   112,   113,   114,   115,   116,   117,
      -1,   119,    -1,   121,   122,   123,   124,   125,   126,   127,
      -1,   129,   130,   131,   132,    -1,    -1,   135,   136,   137,
     138,   139,    -1,   141,   142,   143,    -1,   145,   146,   147,
      -1,   149,   150,   151,   152,   153,   154,   155,   156,   157,
     158,    -1,   160,    -1,   162,   163,   164,   165,   166,    -1,
     168,    -1,   170,   171,    -1,   173,   174,   175,   176,   177,
      -1,   179,   180,    -1,   182,   183,   184,    -1,   186,   187,
     188,   189,   190,   191,   192,   193,   194,   195,    -1,   197,
     198,   199,   200,   201,   202,   203,    -1,   205,   206,   207,
     208,   209,   210,   211,   212,   213,    -1,   215,    -1,   217,
     218,   219,   220,   221,   222,   223,   224,   225,   226,    -1,
      -1,   229,   230,   231,   232,   233,    -1,   235,   236,   237,
     238,   239,   240,   241,   242,   243,   244,   245,   246,   247,
     248,   249,   250,   251,   252,   253,   254,   255,   256,   257,
     258,   259,   260,   261,   262,   263,   264,   265,   266,   267,
     268,   269,   270,    -1,   272,   273,   274,   275,    -1,   277,
     278,   279,   280,   281,   282,    -1,   284,   285,    -1,    -1,
     288,   289,   290,    -1,    -1,   293,   294,   295,   296,   297,
     298,   299,   300,   301,   302,   303,   304,   305,   306,   307,
     308,   309,    -1,    -1,   312,   313,   314,   315,   316,   317,
     318,   319,    -1,   321,   322,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,   333,   334,   335,    -1,   337,
     338,   339,   340,   341,   342,   343,   344,   345,   346,   347,
     348,   349,    -1,   351,   352,   353,   354,   355,   356,   357,
     358,   359,   360,   361,   362,   363,   364,   365,   366,   367,
     368,    -1,   370,   371,   372,   373,   374,   375,   376,   377,
     378,   379,   380,   381,   382,   383,   384,   385,    -1,   387,
     388,   389,   390,   391,   392,   393,   394,   395,   396,   397,
     398,   399,   400,   401,    -1,   403,   404,    -1,   406,   407,
     408,   409,   410,   411,   412,    -1,   414,   415,   416,    -1,
      -1,   419,   420,   421,   422,   423,    -1,   425,   426,   427,
     428,   429,   430,   431,   432,    -1,    -1,   435,   436,   437,
     438,   439,   440,    -1,   442,   443,   444,   445,   446,   447,
     448,    -1,   450,   451,   452,   453,   454,   455,    -1,    -1,
     458,    -1,    -1,   461,   462,   463,   464,   465,   466,   467,
     468,   469,   470,   471,   472,   473,   474,   475,   476,   477,
     478,   479,   480,    -1,    -1,    -1,    -1,     3,    -1,     5,
       6,    -1,    -1,    -1,    -1,    11,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   501,    20,    21,    22,    23,    24,    25,
      26,    27,    -1,    29,    30,    31,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    39,    40,    41,    -1,    43,    44,    45,
      46,    47,    48,    49,    50,    51,    52,    53,    54,    55,
      -1,    57,    58,    59,    60,    61,    62,    63,    -1,    -1,
      66,    67,    68,    69,    70,    -1,    72,    73,    74,    75,
      76,    -1,    78,    -1,    80,    81,    82,    83,    84,    85,
      86,    87,    88,    89,    -1,    91,    92,    93,    94,    95,
      96,    -1,    98,    99,   100,   101,    -1,    -1,    -1,   105,
      -1,    -1,    -1,   109,   110,   111,   112,   113,   114,   115,
     116,   117,    -1,   119,    -1,   121,   122,   123,   124,   125,
     126,   127,    -1,   129,   130,   131,   132,    -1,    -1,   135,
     136,   137,   138,   139,    -1,   141,   142,   143,    -1,   145,
     146,   147,    -1,   149,   150,   151,   152,   153,   154,   155,
     156,   157,   158,   159,   160,    -1,   162,   163,   164,   165,
     166,    -1,   168,    -1,   170,   171,    -1,   173,   174,   175,
     176,   177,    -1,   179,   180,    -1,   182,   183,   184,    -1,
     186,   187,   188,   189,   190,   191,   192,   193,   194,   195,
      -1,   197,   198,   199,   200,   201,   202,   203,    -1,   205,
     206,   207,   208,   209,   210,   211,   212,   213,    -1,   215,
      -1,   217,   218,   219,   220,   221,   222,   223,   224,   225,
     226,    -1,    -1,   229,   230,   231,   232,   233,    -1,   235,
     236,   237,    -1,    -1,   240,   241,   242,   243,   244,   245,
     246,   247,   248,   249,   250,   251,   252,   253,   254,   255,
     256,   257,   258,   259,   260,   261,   262,   263,   264,   265,
     266,   267,   268,   269,   270,    -1,   272,   273,   274,   275,
      -1,   277,   278,   279,   280,   281,   282,    -1,   284,   285,
     286,    -1,   288,   289,   290,    -1,    -1,   293,   294,   295,
     296,   297,   298,   299,   300,   301,   302,   303,   304,   305,
     306,   307,   308,   309,    -1,    -1,   312,   313,   314,   315,
     316,   317,   318,   319,    -1,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
      -1,   337,   338,   339,   340,   341,   342,   343,   344,   345,
     346,   347,   348,   349,    -1,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
     366,   367,   368,    -1,   370,   371,   372,   373,   374,    -1,
     376,   377,   378,   379,   380,   381,   382,   383,   384,   385,
      -1,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,   399,   400,   401,    -1,   403,   404,    -1,
     406,   407,   408,   409,   410,   411,   412,    -1,   414,   415,
     416,    -1,    -1,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,   432,    -1,    -1,   435,
     436,   437,   438,   439,    -1,    -1,   442,   443,   444,   445,
     446,   447,   448,    -1,   450,   451,   452,   453,   454,   455,
      -1,    -1,   458,    -1,    -1,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,   478,   479,   480,    -1,    -1,    -1,    -1,     3,
      -1,    -1,    -1,    -1,    -1,    -1,   492,   493,   494,    -1,
      -1,    -1,    -1,    -1,    -1,   501,    20,    21,    22,    23,
      24,    25,    26,    27,    -1,    29,    30,    31,    32,    33,
      -1,    -1,    -1,    -1,    -1,    39,    40,    41,    -1,    43,
      44,    45,    46,    47,    48,    49,    50,    51,    52,    53,
      54,    55,    -1,    57,    58,    59,    60,    61,    62,    63,
      -1,    -1,    66,    67,    68,    69,    70,    -1,    72,    73,
      74,    75,    76,    -1,    78,    -1,    80,    81,    82,    83,
      84,    85,    86,    87,    88,    89,    -1,    91,    92,    93,
      94,    95,    96,    -1,    98,    99,   100,   101,    -1,    -1,
      -1,   105,    -1,    -1,    -1,   109,   110,   111,   112,   113,
     114,   115,   116,   117,    -1,   119,    -1,   121,   122,   123,
     124,   125,   126,   127,    -1,   129,   130,   131,   132,    -1,
      -1,   135,   136,   137,   138,   139,    -1,   141,   142,   143,
      -1,   145,   146,   147,    -1,   149,   150,   151,   152,   153,
     154,   155,   156,   157,   158,    -1,   160,    -1,   162,   163,
     164,   165,   166,    -1,   168,    -1,   170,   171,    -1,   173,
     174,   175,   176,   177,    -1,   179,   180,    -1,   182,   183,
     184,    -1,   186,   187,   188,   189,   190,   191,   192,   193,
     194,   195,    -1,   197,   198,   199,   200,   201,   202,   203,
      -1,   205,   206,   207,   208,   209,   210,   211,   212,   213,
      -1,   215,    -1,   217,   218,   219,   220,   221,   222,   223,
     224,   225,   226,    -1,    -1,   229,   230,   231,   232,   233,
      -1,   235,   236,   237,    -1,    -1,   240,   241,   242,   243,
     244,   245,   246,   247,   248,   249,   250,   251,   252,   253,
     254,   255,   256,   257,   258,   259,   260,   261,   262,   263,
     264,   265,   266,   267,   268,   269,   270,    -1,   272,   273,
     274,   275,    -1,   277,   278,   279,   280,   281,   282,    -1,
     284,   285,    -1,    -1,   288,   289,   290,    -1,    -1,   293,
     294,   295,   296,   297,   298,   299,   300,   301,   302,   303,
     304,   305,   306,   307,   308,   309,    -1,    -1,   312,   313,
     314,   315,   316,   317,   318,   319,    -1,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,   333,
     334,   335,    -1,   337,   338,   339,   340,   341,   342,   343,
     344,   345,   346,   347,   348,   349,    -1,   351,   352,   353,
     354,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,   365,   366,   367,   368,   369,   370,   371,   372,   373,
     374,    -1,   376,   377,   378,   379,   380,   381,   382,   383,
     384,   385,    -1,   387,   388,   389,   390,   391,   392,   393,
     394,   395,   396,   397,   398,   399,   400,   401,    -1,   403,
     404,   405,   406,   407,   408,   409,   410,   411,   412,    -1,
     414,   415,   416,    -1,    -1,   419,   420,   421,   422,   423,
      -1,   425,   426,   427,   428,   429,   430,   431,   432,    -1,
      -1,   435,   436,   437,   438,   439,    -1,    -1,   442,   443,
     444,   445,   446,   447,   448,    -1,   450,   451,   452,   453,
     454,   455,    -1,    -1,   458,    -1,   460,   461,   462,   463,
     464,   465,   466,   467,   468,   469,   470,   471,   472,   473,
     474,   475,   476,   477,   478,   479,   480,    -1,    -1,   483,
      -1,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   501,    20,    21,
      22,    23,    24,    25,    26,    27,    -1,    29,    30,    31,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    39,    40,    41,
      -1,    43,    44,    45,    46,    47,    48,    49,    50,    51,
      52,    53,    54,    55,    -1,    57,    58,    59,    60,    61,
      62,    63,    -1,    -1,    66,    67,    68,    69,    70,    -1,
      72,    73,    74,    75,    76,    -1,    78,    -1,    80,    81,
      82,    83,    84,    85,    86,    87,    88,    89,    -1,    91,
      92,    93,    94,    95,    96,    -1,    98,    99,   100,   101,
      -1,    -1,    -1,   105,    -1,    -1,    -1,   109,   110,   111,
     112,   113,   114,   115,   116,   117,    -1,   119,    -1,   121,
     122,   123,   124,   125,   126,   127,    -1,   129,   130,   131,
     132,    -1,    -1,   135,   136,   137,   138,   139,    -1,   141,
     142,   143,    -1,   145,   146,   147,    -1,   149,   150,   151,
     152,   153,   154,   155,   156,   157,   158,    -1,   160,    -1,
     162,   163,   164,   165,   166,    -1,   168,    -1,   170,   171,
      -1,   173,   174,   175,   176,   177,    -1,   179,   180,    -1,
     182,   183,   184,    -1,   186,   187,   188,   189,   190,   191,
     192,   193,   194,   195,    -1,   197,   198,   199,   200,   201,
     202,   203,    -1,   205,   206,   207,   208,   209,   210,   211,
     212,   213,    -1,   215,    -1,   217,   218,   219,   220,   221,
     222,   223,   224,   225,   226,    -1,    -1,   229,   230,   231,
     232,   233,    -1,   235,   236,   237,    -1,    -1,   240,   241,
     242,   243,   244,   245,   246,   247,   248,   249,   250,   251,
     252,   253,   254,   255,   256,   257,   258,   259,   260,   261,
     262,   263,   264,   265,   266,   267,   268,   269,   270,    -1,
     272,   273,   274,   275,    -1,   277,   278,   279,   280,   281,
     282,    -1,   284,   285,    -1,    -1,   288,   289,   290,    -1,
      -1,   293,   294,   295,   296,   297,   298,   299,   300,   301,
     302,   303,   304,   305,   306,   307,   308,   309,    -1,    -1,
     312,   313,   314,   315,   316,   317,   318,   319,    -1,   321,
     322,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,   333,   334,   335,    -1,   337,   338,   339,   340,   341,
     342,   343,   344,   345,   346,   347,   348,   349,    -1,   351,
     352,   353,   354,   355,   356,   357,   358,   359,   360,   361,
     362,   363,   364,   365,   366,   367,   368,    -1,   370,   371,
     372,   373,   374,    -1,   376,   377,   378,   379,   380,   381,
     382,   383,   384,   385,    -1,   387,   388,   389,   390,   391,
     392,   393,   394,   395,   396,   397,   398,   399,   400,   401,
      -1,   403,   404,    -1,   406,   407,   408,   409,   410,   411,
     412,    -1,   414,   415,   416,    -1,    -1,   419,   420,   421,
     422,   423,    -1,   425,   426,   427,   428,   429,   430,   431,
     432,    -1,    -1,   435,   436,   437,   438,   439,    -1,    -1,
     442,   443,   444,   445,   446,   447,   448,    -1,   450,   451,
     452,   453,   454,   455,    -1,    -1,   458,    -1,    -1,   461,
     462,   463,   464,   465,   466,   467,   468,   469,   470,   471,
     472,   473,   474,   475,   476,   477,   478,   479,   480,    -1,
      -1,    -1,    -1,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   501,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    29,
      30,    31,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    39,
      40,    41,    -1,    43,    44,    45,    46,    -1,    48,    49,
      50,    51,    52,    -1,    54,    55,    -1,    57,    58,    59,
      60,    61,    62,    63,    -1,    -1,    66,    67,    68,    69,
      70,    -1,    72,    73,    74,    75,    76,    -1,    -1,    -1,
      80,    81,    82,    83,    84,    85,    -1,    87,    88,    89,
      -1,    91,    92,    93,    94,    95,    96,    -1,    -1,    99,
     100,   101,    -1,    -1,    -1,   105,    -1,    -1,    -1,   109,
     110,   111,   112,   113,   114,   115,   116,   117,    -1,   119,
      -1,   121,   122,   123,   124,   125,   126,   127,    -1,   129,
     130,   131,   132,    -1,    -1,   135,   136,   137,   138,   139,
      -1,   141,   142,   143,    -1,   145,   146,   147,    -1,   149,
     150,   151,   152,   153,   154,   155,   156,   157,   158,    -1,
     160,    -1,   162,   163,   164,   165,   166,    -1,   168,    -1,
     170,    -1,    -1,    -1,   174,   175,   176,   177,    -1,   179,
     180,    -1,   182,   183,   184,    -1,   186,   187,   188,   189,
     190,    -1,   192,   193,   194,   195,    -1,   197,   198,   199,
     200,   201,   202,   203,    -1,   205,    -1,   207,   208,   209,
     210,   211,   212,   213,    -1,   215,    -1,   217,    -1,    -1,
     220,    -1,   222,   223,   224,   225,   226,    -1,    -1,   229,
     230,    -1,   232,    -1,    -1,   235,   236,   237,    -1,    -1,
     240,   241,   242,   243,   244,   245,   246,   247,   248,   249,
     250,   251,   252,   253,   254,   255,   256,   257,   258,    -1,
     260,   261,   262,   263,   264,   265,   266,   267,   268,   269,
     270,    -1,   272,   273,    -1,   275,    -1,   277,   278,   279,
     280,   281,   282,    -1,   284,   285,    -1,   287,   288,   289,
     290,    -1,    -1,   293,   294,   295,    -1,   297,    -1,   299,
     300,   301,   302,   303,   304,   305,   306,   307,   308,   309,
      -1,    -1,   312,   313,   314,   315,   316,   317,   318,   319,
      -1,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,    -1,   337,   338,   339,
     340,   341,   342,   343,   344,   345,   346,   347,   348,   349,
      -1,   351,   352,    -1,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,   365,   366,   367,   368,    -1,
     370,   371,   372,   373,   374,    -1,   376,   377,   378,   379,
     380,    -1,   382,   383,   384,   385,    -1,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,   399,
     400,   401,    -1,   403,   404,   405,   406,    -1,   408,   409,
     410,   411,   412,    -1,   414,   415,   416,    -1,    -1,   419,
     420,   421,   422,   423,    -1,   425,   426,   427,   428,   429,
     430,   431,   432,    -1,    -1,   435,   436,   437,   438,   439,
      -1,    -1,   442,   443,   444,   445,   446,   447,   448,    -1,
     450,    -1,   452,   453,   454,   455,    -1,    -1,   458,    -1,
      -1,   461,   462,   463,   464,   465,   466,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,    -1,    -1,    -1,    -1,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   501,    20,    21,    22,    23,    24,    25,    26,    27,
      -1,    29,    30,    31,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    39,    40,    41,    -1,    43,    44,    45,    46,    -1,
      48,    49,    50,    51,    52,    -1,    54,    55,    -1,    57,
      58,    59,    60,    61,    62,    63,    -1,    -1,    66,    67,
      68,    69,    70,    -1,    72,    73,    74,    75,    76,    -1,
      -1,    -1,    80,    81,    82,    83,    84,    85,    -1,    87,
      88,    89,    -1,    91,    92,    93,    94,    95,    96,    -1,
      -1,    99,   100,   101,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   109,   110,   111,   112,   113,   114,   115,   116,   117,
      -1,   119,    -1,   121,   122,   123,   124,   125,   126,   127,
      -1,   129,   130,   131,   132,    -1,    -1,   135,   136,   137,
     138,   139,    -1,   141,   142,   143,    -1,   145,   146,   147,
      -1,   149,   150,   151,   152,   153,   154,   155,   156,   157,
     158,    -1,   160,    -1,   162,   163,   164,   165,   166,    -1,
     168,    -1,   170,    -1,    -1,    -1,   174,   175,   176,   177,
      -1,   179,   180,    -1,   182,   183,   184,    -1,   186,   187,
     188,   189,   190,    -1,   192,   193,   194,   195,    -1,   197,
     198,   199,   200,   201,   202,   203,    -1,   205,    -1,   207,
     208,   209,   210,   211,   212,   213,    -1,   215,    -1,   217,
      -1,    -1,   220,    -1,   222,   223,   224,   225,   226,    -1,
      -1,   229,   230,    -1,   232,    -1,    -1,   235,   236,   237,
      -1,    -1,   240,   241,   242,   243,   244,   245,   246,   247,
     248,   249,   250,   251,   252,   253,   254,   255,   256,   257,
     258,    -1,   260,   261,   262,   263,   264,   265,   266,   267,
     268,   269,   270,    -1,   272,   273,    -1,   275,    -1,   277,
     278,   279,   280,   281,   282,    -1,   284,   285,    -1,    -1,
     288,   289,   290,    -1,    -1,   293,   294,   295,    -1,   297,
      -1,   299,   300,   301,   302,   303,   304,   305,   306,   307,
     308,   309,    -1,    -1,   312,   313,   314,   315,   316,   317,
     318,   319,    -1,   321,   322,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,   333,   334,   335,    -1,   337,
     338,   339,   340,   341,   342,   343,   344,   345,   346,   347,
     348,   349,    -1,   351,   352,    -1,   354,   355,   356,   357,
     358,   359,   360,   361,   362,   363,   364,   365,   366,   367,
     368,   369,   370,   371,   372,   373,   374,    -1,   376,   377,
     378,   379,   380,    -1,   382,   383,   384,   385,    -1,   387,
     388,   389,   390,   391,   392,   393,   394,   395,   396,   397,
     398,   399,   400,   401,    -1,   403,   404,   405,   406,    -1,
     408,   409,   410,   411,   412,    -1,   414,   415,   416,    -1,
      -1,   419,   420,   421,   422,   423,    -1,   425,   426,   427,
     428,   429,   430,   431,   432,    -1,    -1,   435,   436,   437,
     438,   439,    -1,    -1,   442,   443,   444,   445,   446,   447,
     448,    -1,   450,    -1,   452,   453,   454,   455,    -1,    -1,
     458,    -1,   460,   461,   462,   463,   464,   465,   466,   467,
     468,   469,   470,   471,   472,   473,   474,   475,   476,   477,
     478,   479,   480,    -1,    -1,   483,    -1,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   501,    20,    21,    22,    23,    24,    25,
      26,    27,    -1,    29,    30,    31,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    39,    40,    41,    -1,    43,    44,    45,
      46,    -1,    48,    49,    50,    51,    52,    -1,    54,    55,
      -1,    57,    58,    59,    60,    61,    62,    63,    -1,    -1,
      66,    67,    68,    69,    70,    -1,    72,    73,    74,    75,
      76,    -1,    -1,    -1,    80,    81,    82,    83,    84,    85,
      -1,    87,    88,    89,    -1,    91,    92,    93,    94,    95,
      96,    -1,    -1,    99,   100,   101,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   109,   110,   111,   112,   113,   114,   115,
     116,   117,    -1,   119,    -1,   121,   122,   123,   124,   125,
     126,   127,    -1,   129,   130,   131,   132,    -1,    -1,   135,
     136,   137,   138,   139,    -1,   141,   142,   143,    -1,   145,
     146,   147,    -1,   149,   150,   151,   152,   153,   154,   155,
     156,   157,   158,    -1,   160,    -1,   162,   163,   164,   165,
     166,    -1,   168,    -1,   170,    -1,    -1,    -1,   174,   175,
     176,   177,    -1,   179,   180,    -1,   182,   183,   184,    -1,
     186,   187,   188,   189,   190,    -1,   192,   193,   194,   195,
      -1,   197,   198,   199,   200,   201,   202,   203,    -1,   205,
      -1,   207,   208,   209,   210,   211,   212,   213,    -1,   215,
      -1,   217,    -1,    -1,   220,    -1,   222,   223,   224,   225,
     226,    -1,    -1,   229,   230,    -1,   232,    -1,    -1,   235,
     236,   237,    -1,    -1,   240,   241,   242,   243,   244,   245,
     246,   247,   248,   249,   250,   251,   252,   253,   254,   255,
     256,   257,   258,    -1,   260,   261,   262,   263,   264,   265,
     266,   267,   268,   269,   270,    -1,   272,   273,    -1,   275,
      -1,   277,   278,   279,   280,   281,   282,    -1,   284,   285,
      -1,    -1,   288,   289,   290,    -1,    -1,   293,   294,   295,
      -1,   297,    -1,   299,   300,   301,   302,   303,   304,   305,
     306,   307,   308,   309,    -1,    -1,   312,   313,   314,   315,
     316,   317,   318,   319,    -1,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
      -1,   337,   338,   339,   340,   341,   342,   343,   344,   345,
     346,   347,   348,   349,    -1,   351,   352,    -1,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
     366,   367,   368,    -1,   370,   371,   372,   373,   374,    -1,
     376,   377,   378,   379,   380,    -1,   382,   383,   384,   385,
      -1,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,   399,   400,   401,    -1,   403,   404,    -1,
     406,    -1,   408,   409,   410,   411,   412,    -1,   414,   415,
     416,    -1,    -1,   419,   420,   421,   422,   423,    -1,   425,
     426,   427,   428,   429,   430,   431,   432,    -1,    -1,   435,
     436,   437,   438,   439,    -1,    -1,   442,   443,   444,   445,
     446,   447,   448,    -1,   450,    -1,   452,   453,   454,   455,
      -1,    -1,   458,    -1,    -1,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,   478,   479,   480,    -1,    -1,    -1,    -1,     3,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   501,    20,    21,    22,    23,
      24,    25,    26,    27,    -1,    29,    30,    31,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    39,    40,    41,    -1,    43,
      44,    45,    46,    -1,    48,    49,    50,    51,    52,    -1,
      54,    55,    -1,    57,    58,    59,    60,    61,    62,    63,
      -1,    -1,    66,    67,    68,    69,    70,    -1,    72,    73,
      74,    75,    76,    -1,    -1,    -1,    80,    81,    82,    83,
      84,    85,    -1,    87,    88,    89,    -1,    91,    92,    93,
      94,    95,    96,    -1,    -1,    99,   100,   101,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   109,   110,   111,   112,   113,
     114,   115,   116,   117,    -1,   119,    -1,   121,   122,   123,
     124,   125,   126,   127,    -1,   129,   130,   131,   132,    -1,
      -1,   135,   136,   137,   138,   139,    -1,   141,   142,   143,
      -1,   145,   146,   147,    -1,   149,   150,   151,   152,   153,
     154,   155,   156,   157,   158,    -1,   160,    -1,   162,   163,
     164,   165,   166,    -1,   168,    -1,   170,    -1,    -1,    -1,
     174,   175,   176,   177,    -1,   179,   180,    -1,   182,   183,
     184,    -1,   186,   187,   188,   189,   190,    -1,   192,   193,
     194,   195,    -1,   197,   198,   199,   200,   201,   202,   203,
      -1,   205,    -1,   207,   208,   209,   210,   211,   212,   213,
      -1,   215,    -1,   217,    -1,    -1,   220,    -1,   222,   223,
     224,   225,   226,    -1,    -1,   229,   230,    -1,   232,    -1,
      -1,   235,   236,   237,    -1,    -1,   240,   241,   242,   243,
     244,   245,   246,   247,   248,   249,   250,   251,   252,   253,
     254,   255,   256,   257,   258,    -1,   260,   261,   262,   263,
     264,   265,   266,   267,   268,   269,   270,    -1,   272,   273,
      -1,   275,    -1,   277,   278,   279,   280,   281,   282,    -1,
     284,   285,    -1,    -1,   288,   289,   290,    -1,    -1,   293,
     294,   295,    -1,   297,    -1,   299,   300,   301,   302,   303,
     304,   305,   306,   307,   308,   309,    -1,    -1,   312,   313,
     314,   315,   316,   317,   318,   319,    -1,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,   333,
     334,   335,    -1,   337,   338,   339,   340,   341,   342,   343,
     344,   345,   346,   347,   348,   349,    -1,   351,   352,    -1,
     354,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,   365,   366,   367,   368,    -1,   370,   371,   372,   373,
     374,    -1,   376,   377,   378,   379,   380,    -1,   382,   383,
     384,   385,    -1,   387,   388,   389,   390,   391,   392,   393,
     394,   395,   396,   397,   398,   399,   400,   401,    -1,   403,
     404,    -1,   406,    -1,   408,   409,   410,   411,   412,    -1,
     414,   415,   416,    -1,    -1,   419,   420,   421,   422,   423,
      -1,   425,   426,   427,   428,   429,   430,   431,   432,    -1,
      -1,   435,   436,   437,   438,   439,    -1,    -1,   442,   443,
     444,   445,   446,   447,   448,    -1,   450,    -1,   452,   453,
     454,   455,    -1,    -1,   458,    -1,    -1,   461,   462,   463,
     464,   465,   466,   467,   468,   469,   470,   471,   472,   473,
     474,   475,   476,   477,   478,   479,   480,    -1,    -1,    -1,
      -1,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   501,    20,    21,
      22,    23,    24,    25,    26,    27,    -1,    29,    30,    31,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    39,    40,    41,
      -1,    43,    44,    45,    46,    -1,    48,    49,    50,    51,
      52,    -1,    54,    55,    -1,    57,    58,    59,    60,    61,
      62,    63,    -1,    -1,    66,    67,    68,    69,    70,    -1,
      72,    73,    74,    75,    76,    -1,    -1,    -1,    80,    81,
      82,    83,    84,    85,    -1,    87,    88,    89,    -1,    91,
      92,    93,    94,    95,    96,    -1,    -1,    99,   100,   101,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   109,   110,   111,
     112,   113,   114,   115,   116,   117,    -1,   119,    -1,   121,
     122,   123,   124,   125,   126,   127,    -1,   129,   130,   131,
     132,    -1,    -1,   135,   136,   137,   138,   139,    -1,   141,
     142,   143,    -1,   145,   146,   147,    -1,   149,   150,   151,
     152,   153,   154,   155,   156,   157,   158,    -1,   160,    -1,
     162,   163,   164,   165,   166,    -1,   168,    -1,   170,    -1,
      -1,    -1,   174,   175,   176,   177,    -1,   179,   180,    -1,
     182,   183,   184,    -1,   186,   187,   188,   189,   190,    -1,
     192,   193,   194,   195,    -1,   197,   198,   199,   200,   201,
     202,   203,    -1,   205,    -1,   207,   208,   209,   210,   211,
     212,   213,    -1,   215,    -1,   217,    -1,    -1,   220,    -1,
     222,   223,   224,   225,   226,    -1,    -1,   229,   230,    -1,
     232,    -1,    -1,   235,   236,   237,    -1,    -1,   240,   241,
     242,   243,   244,   245,   246,   247,   248,   249,   250,   251,
     252,   253,   254,   255,   256,   257,   258,    -1,   260,   261,
     262,   263,   264,   265,   266,   267,   268,   269,   270,    -1,
     272,   273,    -1,   275,    -1,   277,   278,   279,   280,   281,
     282,    -1,   284,   285,    -1,    -1,   288,   289,   290,    -1,
      -1,   293,   294,   295,    -1,   297,    -1,   299,   300,   301,
     302,   303,   304,   305,   306,   307,   308,   309,    -1,    -1,
     312,   313,   314,   315,   316,   317,   318,   319,    -1,   321,
     322,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,   333,   334,   335,    -1,   337,   338,   339,   340,   341,
     342,   343,   344,   345,   346,   347,   348,   349,    -1,   351,
     352,    -1,   354,   355,   356,   357,   358,   359,   360,   361,
     362,   363,   364,   365,   366,   367,   368,    -1,   370,   371,
     372,   373,   374,    -1,   376,   377,   378,   379,   380,    -1,
     382,   383,   384,   385,    -1,   387,   388,   389,   390,   391,
     392,   393,   394,   395,   396,   397,   398,   399,   400,   401,
      -1,   403,   404,    -1,   406,    -1,   408,   409,   410,   411,
     412,    -1,   414,   415,   416,    -1,    -1,   419,   420,   421,
     422,   423,    -1,   425,   426,   427,   428,   429,   430,   431,
     432,    -1,    -1,   435,   436,   437,   438,   439,    -1,    -1,
     442,   443,   444,   445,   446,   447,   448,    -1,   450,    -1,
     452,   453,   454,   455,    -1,    -1,   458,    -1,    -1,   461,
     462,   463,   464,   465,   466,   467,   468,   469,   470,   471,
     472,   473,   474,   475,   476,   477,   478,   479,   480,    -1,
      -1,    -1,    -1,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   501,
      20,    21,    22,    23,    24,    25,    26,    27,    -1,    29,
      30,    31,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    39,
      40,    41,    -1,    43,    44,    45,    46,    -1,    48,    49,
      50,    51,    52,    -1,    54,    55,    -1,    57,    58,    59,
      60,    61,    62,    63,    -1,    -1,    66,    67,    68,    69,
      70,    -1,    72,    73,    74,    75,    76,    -1,    -1,    -1,
      80,    81,    82,    83,    84,    85,    -1,    87,    88,    89,
      -1,    91,    92,    93,    94,    95,    96,    -1,    -1,    99,
     100,   101,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   109,
     110,   111,   112,   113,   114,   115,   116,   117,    -1,   119,
      -1,   121,   122,   123,   124,   125,   126,   127,    -1,   129,
     130,   131,   132,    -1,    -1,   135,   136,   137,   138,   139,
      -1,   141,   142,   143,    -1,   145,   146,   147,    -1,   149,
     150,   151,   152,   153,   154,   155,   156,   157,   158,    -1,
     160,    -1,   162,   163,   164,   165,   166,    -1,   168,    -1,
     170,    -1,    -1,    -1,   174,   175,   176,   177,    -1,   179,
     180,    -1,   182,   183,   184,    -1,   186,   187,   188,   189,
     190,    -1,   192,   193,   194,   195,    -1,   197,   198,   199,
     200,   201,   202,   203,    -1,   205,    -1,   207,   208,   209,
     210,   211,   212,   213,    -1,   215,    -1,   217,    -1,    -1,
     220,    -1,   222,   223,   224,   225,   226,    -1,    -1,   229,
     230,    -1,   232,    -1,    -1,   235,   236,   237,    -1,    -1,
     240,   241,   242,   243,   244,   245,   246,   247,   248,   249,
     250,   251,   252,   253,   254,   255,   256,   257,   258,    -1,
     260,   261,   262,   263,   264,   265,   266,   267,   268,   269,
     270,    -1,   272,   273,    -1,   275,    -1,   277,   278,   279,
     280,   281,   282,    -1,   284,   285,    -1,    -1,   288,   289,
     290,    -1,    -1,   293,   294,   295,    -1,   297,    -1,   299,
     300,   301,   302,   303,   304,   305,   306,   307,   308,   309,
      -1,    -1,   312,   313,   314,   315,   316,   317,   318,   319,
      -1,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,    -1,   337,   338,   339,
     340,   341,   342,   343,   344,   345,   346,   347,   348,   349,
      -1,   351,   352,    -1,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,   365,   366,   367,   368,    -1,
     370,   371,   372,   373,   374,    -1,   376,   377,   378,   379,
     380,    -1,   382,   383,   384,   385,    -1,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,   399,
     400,   401,    -1,   403,   404,    -1,   406,    -1,   408,   409,
     410,   411,   412,    -1,   414,   415,   416,    -1,    -1,   419,
     420,   421,   422,   423,    -1,   425,   426,   427,   428,   429,
     430,   431,   432,    -1,    -1,   435,   436,   437,   438,   439,
      -1,    -1,   442,   443,   444,   445,   446,   447,   448,    -1,
     450,    -1,   452,   453,   454,   455,    -1,    -1,   458,    -1,
      -1,   461,   462,   463,   464,   465,   466,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,    -1,    -1,    -1,    -1,    -1,    -1,    -1,     3,    -1,
       5,     6,    -1,    -1,    -1,    10,    11,    -1,    -1,    -1,
      -1,   501,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    -1,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    -1,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,   116,   117,   118,   119,   120,   121,   122,   123,   124,
     125,   126,   127,   128,   129,   130,   131,   132,   133,   134,
     135,   136,   137,   138,   139,   140,   141,   142,   143,   144,
     145,   146,   147,   148,   149,   150,   151,   152,    -1,   154,
     155,   156,   157,    -1,   159,   160,   161,   162,   163,   164,
     165,   166,   167,   168,   169,   170,   171,   172,   173,   174,
     175,   176,   177,   178,   179,    -1,   181,    -1,   183,   184,
     185,   186,   187,   188,   189,   190,   191,   192,   193,   194,
     195,   196,   197,   198,   199,   200,   201,   202,   203,   204,
     205,   206,    -1,   208,   209,   210,   211,   212,   213,   214,
     215,   216,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,    -1,   231,   232,   233,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,   246,   247,   248,   249,   250,   251,   252,   253,   254,
     255,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,    -1,   270,   271,   272,   273,   274,
     275,   276,    -1,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
      -1,   296,   297,   298,    -1,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,    -1,   311,   312,   313,    -1,
     315,    -1,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,    -1,   360,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,    -1,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,    -1,   422,    -1,   424,
     425,   426,   427,   428,   429,   430,   431,   432,   433,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446,    -1,   448,   449,   450,   451,   452,   453,   454,
     455,   456,   457,   458,   459,   460,   461,   462,   463,   464,
     465,   466,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   478,   479,   480,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   489,   490,   491,   492,   493,   494,
     495,   496,   497,     3,    -1,     5,     6,    -1,    -1,    -1,
      10,    11,    -1,    -1,    -1,    -1,    -1,    17,    18,    19,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    29,
      30,    31,    32,    33,    34,    35,    36,    37,    38,    39,
      40,    41,    42,    43,    44,    45,    46,    47,    48,    49,
      50,    -1,    52,    53,    54,    55,    56,    57,    58,    59,
      60,    61,    62,    63,    64,    65,    66,    67,    68,    69,
      70,    71,    72,    73,    74,    75,    -1,    77,    78,    79,
      80,    81,    82,    83,    84,    85,    86,    87,    88,    89,
      90,    91,    92,    93,    94,    95,    96,    97,    98,    99,
     100,   101,   102,   103,   104,   105,   106,   107,   108,   109,
     110,   111,   112,   113,   114,   115,   116,   117,   118,   119,
     120,   121,   122,   123,   124,   125,   126,   127,   128,   129,
     130,   131,   132,   133,   134,   135,   136,   137,   138,   139,
     140,   141,   142,   143,   144,   145,   146,   147,   148,   149,
     150,   151,   152,    -1,   154,   155,   156,   157,    -1,   159,
     160,   161,   162,   163,   164,   165,   166,   167,   168,   169,
     170,   171,   172,   173,   174,   175,   176,   177,   178,   179,
      -1,   181,    -1,   183,   184,   185,   186,   187,   188,   189,
     190,   191,   192,   193,   194,   195,   196,   197,   198,   199,
     200,   201,   202,   203,   204,   205,   206,    -1,   208,   209,
     210,   211,   212,   213,   214,   215,   216,   217,   218,   219,
     220,   221,   222,   223,   224,   225,   226,   227,   228,   229,
      -1,   231,   232,   233,   234,   235,   236,   237,   238,   239,
     240,   241,   242,   243,   244,   245,   246,   247,   248,   249,
     250,   251,   252,   253,   254,   255,   256,   257,   258,   259,
     260,   261,   262,   263,   264,   265,   266,   267,   268,    -1,
     270,   271,   272,   273,   274,   275,   276,    -1,   278,   279,
     280,   281,   282,   283,   284,   285,   286,   287,   288,   289,
     290,   291,   292,   293,   294,    -1,   296,   297,   298,    -1,
     300,   301,   302,   303,   304,   305,   306,   307,   308,   309,
      -1,   311,   312,   313,    -1,   315,    -1,   317,   318,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,   344,   345,   346,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,    -1,
     360,   361,   362,   363,   364,   365,   366,   367,   368,   369,
     370,   371,   372,   373,   374,   375,   376,   377,   378,   379,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,   399,
      -1,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
     420,    -1,   422,    -1,   424,   425,   426,   427,   428,   429,
     430,   431,   432,   433,   434,   435,   436,   437,   438,   439,
     440,   441,   442,   443,   444,   445,   446,    -1,   448,   449,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
     460,   461,   462,   463,   464,   465,   466,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   478,   479,
     480,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   489,
     490,   491,   492,   493,   494,   495,   496,   497,     3,    -1,
      -1,    -1,    -1,    -1,    -1,    10,    -1,    -1,    13,    -1,
      -1,    -1,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    -1,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    -1,    -1,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    96,    -1,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,    -1,   114,
     115,   116,   117,   118,   119,   120,   121,   122,   123,   124,
     125,   126,   127,   128,   129,   130,   131,   132,   133,   134,
     135,   136,   137,   138,   139,   140,   141,   142,   143,   144,
     145,   146,   147,    -1,   149,   150,   151,   152,   153,   154,
     155,   156,   157,   158,   159,   160,    -1,    -1,   163,   164,
     165,   166,    -1,   168,   169,   170,   171,    -1,   173,   174,
     175,   176,   177,    -1,   179,   180,    -1,   182,   183,   184,
      -1,   186,   187,    -1,   189,   190,   191,   192,   193,   194,
     195,   196,   197,   198,   199,   200,   201,   202,   203,   204,
     205,   206,   207,   208,   209,   210,   211,   212,   213,    -1,
     215,    -1,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,   230,   231,   232,   233,    -1,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,   246,   247,   248,   249,   250,    -1,   252,   253,    -1,
     255,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,    -1,   284,
     285,    -1,   287,   288,   289,   290,   291,    -1,   293,   294,
     295,   296,    -1,    -1,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,    -1,   311,   312,   313,   314,
     315,    -1,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,    -1,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,   366,    -1,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,    -1,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,   431,   432,    -1,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446,   447,   448,   449,    -1,   451,   452,   453,   454,
     455,   456,    -1,   458,    -1,    -1,    -1,    -1,   463,   464,
     465,   466,   467,   468,   469,   470,   471,   472,   473,   474,
     475,   476,   477,    -1,   479,   480,   481,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   489,   490,   491,   492,   493,   494,
     495,   496,   497,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      10,    -1,    -1,    -1,    -1,    -1,    -1,    17,    18,    19,
      20,    21,    22,    23,    24,    25,    26,    27,    -1,    29,
      30,    31,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    39,
      40,    41,    -1,    43,    44,    45,    46,    -1,    48,    49,
      50,    51,    52,    -1,    54,    55,    -1,    57,    58,    59,
      60,    61,    62,    63,    -1,    -1,    66,    67,    68,    69,
      70,    -1,    72,    73,    74,    75,    76,    -1,    -1,    -1,
      80,    81,    82,    83,    84,    85,    -1,    87,    88,    89,
      -1,    91,    92,    93,    94,    95,    96,    -1,    -1,    99,
     100,   101,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   109,
     110,   111,   112,   113,   114,   115,   116,   117,    -1,   119,
      -1,   121,   122,   123,   124,   125,   126,   127,    -1,   129,
     130,   131,   132,    -1,    -1,   135,   136,   137,   138,   139,
      -1,   141,   142,   143,    -1,   145,   146,   147,    -1,   149,
     150,   151,   152,   153,   154,   155,   156,   157,   158,    -1,
     160,    -1,   162,   163,   164,   165,   166,    -1,   168,    -1,
     170,    -1,    -1,    -1,   174,   175,   176,   177,    -1,   179,
     180,    -1,   182,   183,   184,    -1,   186,   187,   188,   189,
     190,    -1,   192,   193,   194,   195,    -1,   197,   198,   199,
     200,   201,   202,   203,    -1,   205,    -1,   207,   208,   209,
     210,   211,   212,   213,    -1,   215,    -1,   217,    -1,    -1,
     220,    -1,   222,   223,   224,   225,   226,    -1,    -1,   229,
     230,    -1,   232,    -1,    -1,   235,   236,   237,    -1,    -1,
     240,   241,   242,   243,   244,   245,   246,   247,   248,   249,
     250,   251,   252,   253,   254,   255,   256,   257,   258,    -1,
     260,   261,   262,   263,   264,   265,   266,   267,   268,   269,
     270,    -1,   272,   273,    -1,   275,    -1,   277,   278,   279,
     280,   281,   282,    -1,   284,   285,    -1,    -1,   288,   289,
     290,    -1,    -1,   293,   294,   295,    -1,   297,    -1,   299,
     300,   301,   302,   303,   304,   305,   306,   307,   308,   309,
      -1,    -1,   312,   313,   314,   315,   316,   317,   318,   319,
      -1,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,    -1,   337,   338,   339,
     340,   341,   342,   343,   344,   345,   346,   347,   348,   349,
      -1,   351,   352,    -1,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,   365,   366,   367,   368,    -1,
     370,   371,   372,   373,   374,    -1,   376,   377,   378,   379,
     380,    -1,   382,   383,   384,   385,    -1,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,   399,
     400,   401,    -1,   403,   404,    -1,   406,    -1,   408,   409,
     410,   411,   412,    -1,   414,   415,   416,    -1,    -1,   419,
     420,   421,   422,   423,    -1,   425,   426,   427,   428,   429,
     430,   431,   432,    -1,    -1,   435,   436,   437,   438,   439,
      -1,    -1,   442,   443,   444,   445,   446,   447,   448,    -1,
     450,    -1,   452,   453,   454,   455,    -1,    -1,   458,    -1,
      -1,   461,   462,   463,   464,   465,   466,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   489,
     490,   491,   492,   493,   494,   495,   496,   497,     3,    -1,
      -1,    -1,    -1,    -1,    -1,    10,    -1,    -1,    -1,    -1,
      -1,    -1,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    -1,    29,    30,    31,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    39,    40,    41,    -1,    43,    44,
      45,    46,    -1,    48,    49,    50,    51,    52,    -1,    54,
      55,    -1,    57,    58,    59,    60,    61,    62,    63,    -1,
      -1,    66,    67,    68,    69,    70,    -1,    72,    73,    74,
      75,    76,    -1,    -1,    -1,    80,    81,    82,    83,    84,
      85,    -1,    87,    88,    89,    -1,    91,    92,    93,    94,
      95,    96,    -1,    -1,    99,   100,   101,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   109,   110,   111,   112,   113,   114,
     115,   116,   117,    -1,   119,    -1,   121,   122,   123,   124,
     125,   126,   127,    -1,   129,   130,   131,   132,    -1,    -1,
     135,   136,   137,   138,   139,    -1,   141,   142,   143,    -1,
     145,   146,   147,    -1,   149,   150,   151,   152,   153,   154,
     155,   156,   157,   158,    -1,   160,    -1,   162,   163,   164,
     165,   166,    -1,   168,    -1,   170,    -1,    -1,    -1,   174,
     175,   176,   177,    -1,   179,   180,    -1,   182,   183,   184,
      -1,   186,   187,   188,   189,   190,    -1,   192,   193,   194,
     195,    -1,   197,   198,   199,   200,   201,   202,   203,    -1,
     205,    -1,   207,   208,   209,   210,   211,   212,   213,    -1,
     215,    -1,   217,    -1,    -1,   220,    -1,   222,   223,   224,
     225,   226,    -1,    -1,   229,   230,    -1,   232,    -1,    -1,
     235,   236,   237,    -1,    -1,   240,   241,   242,   243,   244,
     245,   246,   247,   248,   249,   250,   251,   252,   253,   254,
     255,   256,   257,   258,    -1,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,    -1,   272,   273,    -1,
     275,    -1,   277,   278,   279,   280,   281,   282,    -1,   284,
     285,    -1,    -1,   288,   289,   290,    -1,    -1,   293,   294,
     295,    -1,   297,    -1,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,    -1,    -1,   312,   313,   314,
     315,   316,   317,   318,   319,    -1,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,    -1,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,    -1,   351,   352,    -1,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,   366,   367,   368,    -1,   370,   371,   372,   373,   374,
      -1,   376,   377,   378,   379,   380,    -1,   382,   383,   384,
     385,    -1,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,   400,   401,    -1,   403,   404,
      -1,   406,    -1,   408,   409,   410,   411,   412,    -1,   414,
     415,   416,    -1,    -1,   419,   420,   421,   422,   423,    -1,
     425,   426,   427,   428,   429,   430,   431,   432,    -1,    -1,
     435,   436,   437,   438,   439,    -1,    -1,   442,   443,   444,
     445,   446,   447,   448,    -1,   450,    -1,   452,   453,   454,
     455,    -1,    -1,   458,    -1,    -1,   461,   462,   463,   464,
     465,   466,   467,   468,   469,   470,   471,   472,   473,   474,
     475,   476,   477,   478,   479,   480,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   489,   490,   491,   492,   493,   494,
     495,   496,   497,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      10,    -1,    -1,    -1,    -1,    -1,    -1,    17,    18,    19,
      20,    21,    22,    23,    24,    25,    26,    27,    -1,    29,
      30,    31,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    39,
      40,    41,    -1,    43,    44,    45,    46,    -1,    48,    49,
      50,    51,    52,    -1,    54,    55,    -1,    57,    58,    59,
      60,    61,    62,    63,    -1,    -1,    66,    67,    68,    69,
      70,    -1,    72,    73,    74,    75,    76,    -1,    -1,    -1,
      80,    81,    82,    83,    84,    85,    -1,    87,    88,    89,
      -1,    91,    92,    93,    94,    95,    96,    -1,    -1,    99,
     100,   101,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   109,
     110,   111,   112,   113,   114,   115,   116,   117,    -1,   119,
      -1,   121,   122,   123,   124,   125,   126,   127,    -1,   129,
     130,   131,   132,    -1,    -1,   135,   136,   137,   138,   139,
      -1,   141,   142,   143,    -1,   145,   146,   147,    -1,   149,
     150,   151,   152,   153,   154,   155,   156,   157,   158,    -1,
     160,    -1,   162,   163,   164,   165,   166,    -1,   168,    -1,
     170,    -1,    -1,    -1,   174,   175,   176,   177,    -1,   179,
     180,    -1,   182,   183,   184,    -1,   186,   187,   188,   189,
     190,    -1,   192,   193,   194,   195,    -1,   197,   198,   199,
     200,   201,   202,   203,    -1,   205,    -1,   207,   208,   209,
     210,   211,   212,   213,    -1,   215,    -1,   217,    -1,    -1,
     220,    -1,   222,   223,   224,   225,   226,    -1,    -1,   229,
     230,    -1,   232,    -1,    -1,   235,   236,   237,    -1,    -1,
     240,   241,   242,   243,   244,   245,   246,   247,   248,   249,
     250,   251,   252,   253,   254,   255,   256,   257,   258,    -1,
     260,   261,   262,   263,   264,   265,   266,   267,   268,   269,
     270,    -1,   272,   273,    -1,   275,    -1,   277,   278,   279,
     280,   281,   282,    -1,   284,   285,    -1,    -1,   288,   289,
     290,    -1,    -1,   293,   294,   295,    -1,   297,    -1,   299,
     300,   301,   302,   303,   304,   305,   306,   307,   308,   309,
      -1,    -1,   312,   313,   314,   315,   316,   317,   318,   319,
      -1,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,    -1,   337,   338,   339,
     340,   341,   342,   343,   344,   345,   346,   347,   348,   349,
      -1,   351,   352,    -1,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,   365,   366,   367,   368,    -1,
     370,   371,   372,   373,   374,    -1,   376,   377,   378,   379,
     380,    -1,   382,   383,   384,   385,    -1,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,   399,
     400,   401,    -1,   403,   404,    -1,   406,    -1,   408,   409,
     410,   411,   412,    -1,   414,   415,   416,    -1,    -1,   419,
     420,   421,   422,   423,    -1,   425,   426,   427,   428,   429,
     430,   431,   432,    -1,    -1,   435,   436,   437,   438,   439,
      -1,    -1,   442,   443,   444,   445,   446,   447,   448,    -1,
     450,    -1,   452,   453,   454,   455,    -1,    -1,   458,    -1,
      -1,   461,   462,   463,   464,   465,   466,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   489,
     490,   491,   492,   493,   494,   495,   496,   497,     3,    -1,
      -1,    -1,    -1,    -1,    -1,    10,    -1,    -1,    -1,    -1,
      -1,    -1,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    -1,    29,    30,    31,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    39,    40,    41,    -1,    43,    44,
      45,    46,    -1,    48,    49,    50,    51,    52,    -1,    54,
      55,    -1,    57,    58,    59,    60,    61,    62,    63,    -1,
      -1,    66,    67,    68,    69,    70,    -1,    72,    73,    74,
      75,    76,    -1,    -1,    -1,    80,    81,    82,    83,    84,
      85,    -1,    87,    88,    89,    -1,    91,    92,    93,    94,
      95,    96,    -1,    -1,    99,   100,   101,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   109,   110,   111,   112,   113,   114,
     115,   116,   117,    -1,   119,    -1,   121,   122,   123,   124,
     125,   126,   127,    -1,   129,   130,   131,   132,    -1,    -1,
     135,   136,   137,   138,   139,    -1,   141,   142,   143,    -1,
     145,   146,   147,    -1,   149,   150,   151,   152,   153,   154,
     155,   156,   157,   158,    -1,   160,    -1,   162,   163,   164,
     165,   166,    -1,   168,    -1,   170,    -1,    -1,    -1,   174,
     175,   176,   177,    -1,   179,   180,    -1,   182,   183,   184,
      -1,   186,   187,   188,   189,   190,    -1,   192,   193,   194,
     195,    -1,   197,   198,   199,   200,   201,   202,   203,    -1,
     205,    -1,   207,   208,   209,   210,   211,   212,   213,    -1,
     215,    -1,   217,    -1,    -1,   220,    -1,   222,   223,   224,
     225,   226,    -1,    -1,   229,   230,    -1,   232,    -1,    -1,
     235,   236,   237,    -1,    -1,   240,   241,   242,   243,   244,
     245,   246,   247,   248,   249,   250,   251,   252,   253,   254,
     255,   256,   257,   258,    -1,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,    -1,   272,   273,    -1,
     275,    -1,   277,   278,   279,   280,   281,   282,    -1,   284,
     285,    -1,    -1,   288,   289,   290,    -1,    -1,   293,   294,
     295,    -1,   297,    -1,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,    -1,    -1,   312,   313,   314,
     315,   316,   317,   318,   319,    -1,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,    -1,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,    -1,   351,   352,    -1,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,   366,   367,   368,    -1,   370,   371,   372,   373,   374,
      -1,   376,   377,   378,   379,   380,    -1,   382,   383,   384,
     385,    -1,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,   400,   401,    -1,   403,   404,
      -1,   406,    -1,   408,   409,   410,   411,   412,    -1,   414,
     415,   416,    -1,    -1,   419,   420,   421,   422,   423,    -1,
     425,   426,   427,   428,   429,   430,   431,   432,    -1,    -1,
     435,   436,   437,   438,   439,    -1,    -1,   442,   443,   444,
     445,   446,   447,   448,    -1,   450,    -1,   452,   453,   454,
     455,    -1,    -1,   458,    -1,    -1,   461,   462,   463,   464,
     465,   466,   467,   468,   469,   470,   471,   472,   473,   474,
     475,   476,   477,   478,   479,   480,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   489,   490,   491,   492,   493,   494,
     495,   496,   497,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      10,    -1,    -1,    -1,    -1,    -1,    -1,    17,    18,    19,
      20,    21,    22,    23,    24,    25,    26,    27,    -1,    29,
      30,    31,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    39,
      40,    41,    -1,    43,    44,    45,    46,    -1,    48,    49,
      50,    51,    52,    -1,    54,    55,    -1,    57,    58,    59,
      60,    61,    62,    63,    -1,    -1,    66,    67,    68,    69,
      70,    -1,    72,    73,    74,    75,    76,    -1,    -1,    -1,
      80,    81,    82,    83,    84,    85,    -1,    87,    88,    89,
      -1,    91,    92,    93,    94,    95,    96,    -1,    -1,    99,
     100,   101,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   109,
     110,   111,   112,   113,   114,   115,   116,   117,    -1,   119,
      -1,   121,   122,   123,   124,   125,   126,   127,    -1,   129,
     130,   131,   132,    -1,    -1,   135,   136,   137,   138,   139,
      -1,   141,   142,   143,    -1,   145,   146,   147,    -1,   149,
     150,   151,   152,   153,   154,   155,   156,   157,   158,    -1,
     160,    -1,   162,   163,   164,   165,   166,    -1,   168,    -1,
     170,    -1,    -1,    -1,   174,   175,   176,   177,    -1,   179,
     180,    -1,   182,   183,   184,    -1,   186,   187,   188,   189,
     190,    -1,   192,   193,   194,   195,    -1,   197,   198,   199,
     200,   201,   202,   203,    -1,   205,    -1,   207,   208,   209,
     210,   211,   212,   213,    -1,   215,    -1,   217,    -1,    -1,
     220,    -1,   222,   223,   224,   225,   226,    -1,    -1,   229,
     230,    -1,   232,    -1,    -1,   235,   236,   237,    -1,    -1,
     240,   241,   242,   243,   244,   245,   246,   247,   248,   249,
     250,   251,   252,   253,   254,   255,   256,   257,   258,    -1,
     260,   261,   262,   263,   264,   265,   266,   267,   268,   269,
     270,    -1,   272,   273,    -1,   275,    -1,   277,   278,   279,
     280,   281,   282,    -1,   284,   285,    -1,    -1,   288,   289,
     290,    -1,    -1,   293,   294,   295,    -1,   297,    -1,   299,
     300,   301,   302,   303,   304,   305,   306,   307,   308,   309,
      -1,    -1,   312,   313,   314,   315,   316,   317,   318,   319,
      -1,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,    -1,   337,   338,   339,
     340,   341,   342,   343,   344,   345,   346,   347,   348,   349,
      -1,   351,   352,    -1,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,   365,   366,   367,   368,    -1,
     370,   371,   372,   373,   374,    -1,   376,   377,   378,   379,
     380,    -1,   382,   383,   384,   385,    -1,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,   399,
     400,   401,    -1,   403,   404,    -1,   406,    -1,   408,   409,
     410,   411,   412,    -1,   414,   415,   416,    -1,    -1,   419,
     420,   421,   422,   423,    -1,   425,   426,   427,   428,   429,
     430,   431,   432,    -1,    -1,   435,   436,   437,   438,   439,
      -1,    -1,   442,   443,   444,   445,   446,   447,   448,    -1,
     450,    -1,   452,   453,   454,   455,    -1,    -1,   458,    -1,
      -1,   461,   462,   463,   464,   465,   466,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   489,
     490,   491,   492,   493,   494,   495,   496,   497,     3,    -1,
      -1,    -1,    -1,    -1,    -1,    10,    -1,    -1,    -1,    -1,
      -1,    -1,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    -1,    29,    30,    31,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    39,    40,    41,    -1,    43,    44,
      45,    46,    -1,    48,    49,    50,    51,    52,    -1,    54,
      55,    -1,    57,    58,    59,    60,    61,    62,    63,    -1,
      -1,    66,    67,    68,    69,    70,    -1,    72,    73,    74,
      75,    76,    -1,    -1,    -1,    80,    81,    82,    83,    84,
      85,    -1,    87,    88,    89,    -1,    91,    92,    93,    94,
      95,    96,    -1,    -1,    99,   100,   101,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   109,   110,   111,   112,   113,   114,
     115,   116,   117,    -1,   119,    -1,   121,   122,   123,   124,
     125,   126,   127,    -1,   129,   130,   131,   132,    -1,    -1,
     135,   136,   137,   138,   139,    -1,   141,   142,   143,    -1,
     145,   146,   147,    -1,   149,   150,   151,   152,   153,   154,
     155,   156,   157,   158,    -1,   160,    -1,   162,   163,   164,
     165,   166,    -1,   168,    -1,   170,    -1,    -1,    -1,   174,
     175,   176,   177,    -1,   179,   180,    -1,   182,   183,   184,
      -1,   186,   187,   188,   189,   190,    -1,   192,   193,   194,
     195,    -1,   197,   198,   199,   200,   201,   202,   203,    -1,
     205,    -1,   207,   208,   209,   210,   211,   212,   213,    -1,
     215,    -1,   217,    -1,    -1,   220,    -1,   222,   223,   224,
     225,   226,    -1,    -1,   229,   230,    -1,   232,    -1,    -1,
     235,   236,   237,    -1,    -1,   240,   241,   242,   243,   244,
     245,   246,   247,   248,   249,   250,   251,   252,   253,   254,
     255,   256,   257,   258,    -1,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,    -1,   272,   273,    -1,
     275,    -1,   277,   278,   279,   280,   281,   282,    -1,   284,
     285,    -1,    -1,   288,   289,   290,    -1,    -1,   293,   294,
     295,    -1,   297,    -1,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,    -1,    -1,   312,   313,   314,
     315,   316,   317,   318,   319,    -1,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,    -1,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,    -1,   351,   352,    -1,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,   366,   367,   368,    -1,   370,   371,   372,   373,   374,
      -1,   376,   377,   378,   379,   380,    -1,   382,   383,   384,
     385,    -1,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,   400,   401,    -1,   403,   404,
      -1,   406,    -1,   408,   409,   410,   411,   412,    -1,   414,
     415,   416,    -1,    -1,   419,   420,   421,   422,   423,    -1,
     425,   426,   427,   428,   429,   430,   431,   432,    -1,    -1,
     435,   436,   437,   438,   439,    -1,    -1,   442,   443,   444,
     445,   446,   447,   448,    -1,   450,    -1,   452,   453,   454,
     455,    -1,    -1,   458,    -1,    -1,   461,   462,   463,   464,
     465,   466,   467,   468,   469,   470,   471,   472,   473,   474,
     475,   476,   477,   478,   479,   480,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   489,   490,   491,   492,   493,   494,
     495,   496,   497,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      10,    -1,    -1,    -1,    -1,    -1,    -1,    17,    18,    19,
      20,    21,    22,    23,    24,    25,    26,    27,    -1,    29,
      30,    31,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    39,
      40,    41,    -1,    43,    44,    45,    46,    -1,    48,    49,
      50,    51,    52,    -1,    54,    55,    -1,    57,    58,    59,
      60,    61,    62,    63,    -1,    -1,    66,    67,    68,    69,
      70,    -1,    72,    73,    74,    75,    76,    -1,    -1,    -1,
      80,    81,    82,    83,    84,    85,    -1,    87,    88,    89,
      -1,    91,    92,    93,    94,    95,    96,    -1,    -1,    99,
     100,   101,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   109,
     110,   111,   112,   113,   114,   115,   116,   117,    -1,   119,
      -1,   121,   122,   123,   124,   125,   126,   127,    -1,   129,
     130,   131,   132,    -1,    -1,   135,   136,   137,   138,   139,
      -1,   141,   142,   143,    -1,   145,   146,   147,    -1,   149,
     150,   151,   152,   153,   154,   155,   156,   157,   158,    -1,
     160,    -1,   162,   163,   164,   165,   166,    -1,   168,    -1,
     170,    -1,    -1,    -1,   174,   175,   176,   177,    -1,   179,
     180,    -1,   182,   183,   184,    -1,   186,   187,   188,   189,
     190,    -1,   192,   193,   194,   195,    -1,   197,   198,   199,
     200,   201,   202,   203,    -1,   205,    -1,   207,   208,   209,
     210,   211,   212,   213,    -1,   215,    -1,   217,    -1,    -1,
     220,    -1,   222,   223,   224,   225,   226,    -1,    -1,   229,
     230,    -1,   232,    -1,    -1,   235,   236,   237,    -1,    -1,
     240,   241,   242,   243,   244,   245,   246,   247,   248,   249,
     250,   251,   252,   253,   254,   255,   256,   257,   258,    -1,
     260,   261,   262,   263,   264,   265,   266,   267,   268,   269,
     270,    -1,   272,   273,    -1,   275,    -1,   277,   278,   279,
     280,   281,   282,    -1,   284,   285,    -1,    -1,   288,   289,
     290,    -1,    -1,   293,   294,   295,    -1,   297,    -1,   299,
     300,   301,   302,   303,   304,   305,   306,   307,   308,   309,
      -1,    -1,   312,   313,   314,   315,   316,   317,   318,   319,
      -1,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,    -1,   337,   338,   339,
     340,   341,   342,   343,   344,   345,   346,   347,   348,   349,
      -1,   351,   352,    -1,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,   365,   366,   367,   368,    -1,
     370,   371,   372,   373,   374,    -1,   376,   377,   378,   379,
     380,    -1,   382,   383,   384,   385,    -1,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,   399,
     400,   401,    -1,   403,   404,    -1,   406,    -1,   408,   409,
     410,   411,   412,    -1,   414,   415,   416,    -1,    -1,   419,
     420,   421,   422,   423,    -1,   425,   426,   427,   428,   429,
     430,   431,   432,    -1,    -1,   435,   436,   437,   438,   439,
      -1,    -1,   442,   443,   444,   445,   446,   447,   448,    -1,
     450,    -1,   452,   453,   454,   455,    -1,    -1,   458,    -1,
      -1,   461,   462,   463,   464,   465,   466,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   489,
     490,   491,   492,   493,   494,   495,   496,   497,    20,    21,
      22,    23,    24,    25,    26,    27,    28,    29,    30,    31,
      32,    33,    34,    35,    36,    37,    38,    39,    40,    41,
      42,    43,    44,    45,    46,    47,    48,    49,    50,    51,
      52,    53,    54,    55,    56,    57,    58,    59,    60,    61,
      62,    63,    64,    65,    66,    67,    68,    69,    70,    71,
      72,    73,    74,    75,    76,    77,    78,    79,    80,    81,
      82,    83,    84,    85,    86,    87,    88,    89,    90,    91,
      92,    93,    94,    95,    96,    97,    98,    99,   100,   101,
     102,   103,   104,   105,   106,   107,   108,   109,   110,   111,
     112,   113,   114,   115,   116,   117,   118,   119,   120,   121,
     122,   123,   124,   125,   126,   127,   128,   129,   130,   131,
     132,   133,   134,   135,   136,   137,   138,   139,   140,   141,
     142,   143,   144,   145,   146,   147,   148,   149,   150,   151,
     152,   153,   154,   155,   156,   157,   158,   159,   160,   161,
     162,   163,   164,   165,   166,   167,   168,   169,   170,   171,
     172,   173,   174,   175,   176,   177,   178,   179,   180,   181,
     182,   183,   184,   185,   186,   187,   188,   189,   190,   191,
     192,   193,   194,   195,   196,   197,   198,   199,   200,   201,
     202,   203,   204,   205,   206,   207,   208,   209,   210,   211,
     212,   213,   214,   215,   216,   217,   218,   219,   220,   221,
     222,   223,   224,   225,   226,   227,   228,   229,   230,   231,
     232,   233,   234,   235,   236,   237,   238,   239,   240,   241,
     242,   243,   244,   245,   246,   247,   248,   249,   250,   251,
     252,   253,   254,   255,   256,   257,   258,   259,   260,   261,
     262,   263,   264,   265,   266,   267,   268,   269,   270,   271,
     272,   273,   274,   275,   276,   277,   278,   279,   280,   281,
     282,   283,   284,   285,   286,   287,   288,   289,   290,   291,
     292,   293,   294,   295,   296,   297,   298,   299,   300,   301,
     302,   303,   304,   305,   306,   307,   308,   309,    -1,   311,
     312,   313,   314,   315,   316,   317,   318,   319,   320,   321,
     322,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,   333,   334,   335,   336,   337,   338,   339,   340,   341,
     342,   343,   344,   345,   346,   347,   348,   349,   350,   351,
     352,   353,   354,   355,   356,   357,   358,   359,   360,   361,
     362,   363,   364,   365,   366,   367,   368,   369,   370,   371,
     372,   373,   374,   375,   376,   377,   378,   379,   380,   381,
     382,   383,   384,   385,   386,   387,   388,   389,   390,   391,
     392,   393,   394,   395,   396,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,   427,   428,   429,   430,   431,
     432,   433,   434,   435,   436,   437,   438,   439,   440,   441,
     442,   443,   444,   445,   446,   447,   448,   449,   450,   451,
     452,   453,   454,   455,   456,   457,   458,   459,   460,   461,
     462,   463,   464,   465,   466,   467,   468,   469,   470,   471,
     472,   473,   474,   475,   476,   477,   478,   479,   480,     3,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   494,    -1,    -1,    -1,    20,    21,    22,    23,
      24,    25,    26,    27,    -1,    29,    30,    31,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    39,    40,    41,    -1,    43,
      44,    45,    46,    -1,    48,    49,    50,    51,    52,    -1,
      54,    55,    -1,    57,    58,    59,    60,    61,    62,    63,
      -1,    -1,    66,    67,    68,    69,    70,    -1,    72,    73,
      74,    75,    76,    -1,    -1,    -1,    80,    81,    82,    83,
      84,    85,    -1,    87,    88,    89,    -1,    91,    92,    93,
      94,    95,    96,    -1,    -1,    99,   100,   101,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   109,   110,   111,   112,   113,
     114,   115,   116,   117,    -1,   119,    -1,   121,   122,   123,
     124,   125,   126,   127,    -1,   129,   130,   131,   132,    -1,
      -1,   135,   136,   137,   138,   139,    -1,   141,   142,   143,
      -1,   145,   146,   147,    -1,   149,   150,   151,   152,   153,
     154,   155,   156,   157,   158,    -1,   160,    -1,   162,   163,
     164,   165,   166,    -1,   168,    -1,   170,    -1,    -1,    -1,
     174,   175,   176,   177,    -1,   179,   180,    -1,   182,   183,
     184,    -1,   186,   187,   188,   189,   190,    -1,   192,   193,
     194,   195,    -1,   197,   198,   199,   200,   201,   202,   203,
      -1,   205,    -1,   207,   208,   209,   210,   211,   212,   213,
      -1,   215,    -1,   217,    -1,    -1,   220,    -1,   222,   223,
     224,   225,   226,    -1,    -1,   229,   230,    -1,   232,    -1,
      -1,   235,   236,   237,    -1,    -1,   240,   241,   242,   243,
     244,   245,   246,   247,   248,   249,   250,   251,   252,   253,
     254,   255,   256,   257,   258,    -1,   260,   261,   262,   263,
     264,   265,   266,   267,   268,   269,   270,    -1,   272,   273,
      -1,   275,    -1,   277,   278,   279,   280,   281,   282,    -1,
     284,   285,    -1,    -1,   288,   289,   290,    -1,    -1,   293,
     294,   295,    -1,   297,    -1,   299,   300,   301,   302,   303,
     304,   305,   306,   307,   308,   309,    -1,    -1,   312,   313,
     314,   315,   316,   317,   318,   319,    -1,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,   333,
     334,   335,    -1,   337,   338,   339,   340,   341,   342,   343,
     344,   345,   346,   347,   348,   349,    -1,   351,   352,    -1,
     354,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,   365,   366,   367,   368,    -1,   370,   371,   372,   373,
     374,    -1,   376,   377,   378,   379,   380,    -1,   382,   383,
     384,   385,    -1,   387,   388,   389,   390,   391,   392,   393,
     394,   395,   396,   397,   398,   399,   400,   401,    -1,   403,
     404,    -1,   406,    -1,   408,   409,   410,   411,   412,    -1,
     414,   415,   416,    -1,    -1,   419,   420,   421,   422,   423,
      -1,   425,   426,   427,   428,   429,   430,   431,   432,    -1,
      -1,   435,   436,   437,   438,   439,    -1,    -1,   442,   443,
     444,   445,   446,   447,   448,    -1,   450,    -1,   452,   453,
     454,   455,    -1,    -1,   458,    -1,    -1,   461,   462,   463,
     464,   465,   466,   467,   468,   469,   470,   471,   472,   473,
     474,   475,   476,   477,   478,   479,   480,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     494,    -1,    -1,    -1,    20,    21,    22,    23,    24,    25,
      26,    27,    -1,    29,    30,    31,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    39,    40,    41,    -1,    43,    44,    45,
      46,    -1,    48,    49,    50,    51,    52,    -1,    54,    55,
      -1,    57,    58,    59,    60,    61,    62,    63,    -1,    -1,
      66,    67,    68,    69,    70,    -1,    72,    73,    74,    75,
      76,    -1,    -1,    -1,    80,    81,    82,    83,    84,    85,
      -1,    87,    88,    89,    -1,    91,    92,    93,    94,    95,
      96,    -1,    -1,    99,   100,   101,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   109,   110,   111,   112,   113,   114,   115,
     116,   117,    -1,   119,    -1,   121,   122,   123,   124,   125,
     126,   127,    -1,   129,   130,   131,   132,    -1,    -1,   135,
     136,   137,   138,   139,    -1,   141,   142,   143,    -1,   145,
     146,   147,    -1,   149,   150,   151,   152,   153,   154,   155,
     156,   157,   158,    -1,   160,    -1,   162,   163,   164,   165,
     166,    -1,   168,    -1,   170,    -1,    -1,    -1,   174,   175,
     176,   177,    -1,   179,   180,    -1,   182,   183,   184,    -1,
     186,   187,   188,   189,   190,    -1,   192,   193,   194,   195,
      -1,   197,   198,   199,   200,   201,   202,   203,    -1,   205,
      -1,   207,   208,   209,   210,   211,   212,   213,    -1,   215,
      -1,   217,    -1,    -1,   220,    -1,   222,   223,   224,   225,
     226,    -1,    -1,   229,   230,    -1,   232,    -1,    -1,   235,
     236,   237,    -1,    -1,   240,   241,   242,   243,   244,   245,
     246,   247,   248,   249,   250,   251,   252,   253,   254,   255,
     256,   257,   258,    -1,   260,   261,   262,   263,   264,   265,
     266,   267,   268,   269,   270,    -1,   272,   273,    -1,   275,
      -1,   277,   278,   279,   280,   281,   282,    -1,   284,   285,
      -1,    -1,   288,   289,   290,    -1,    -1,   293,   294,   295,
      -1,   297,    -1,   299,   300,   301,   302,   303,   304,   305,
     306,   307,   308,   309,    -1,    -1,   312,   313,   314,   315,
     316,   317,   318,   319,    -1,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
      -1,   337,   338,   339,   340,   341,   342,   343,   344,   345,
     346,   347,   348,   349,    -1,   351,   352,    -1,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
     366,   367,   368,    -1,   370,   371,   372,   373,   374,    -1,
     376,   377,   378,   379,   380,    -1,   382,   383,   384,   385,
      -1,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,   399,   400,   401,    -1,   403,   404,    -1,
     406,    -1,   408,   409,   410,   411,   412,    -1,   414,   415,
     416,    -1,    -1,   419,   420,   421,   422,   423,    -1,   425,
     426,   427,   428,   429,   430,   431,   432,    -1,    -1,   435,
     436,   437,   438,   439,    -1,    -1,   442,   443,   444,   445,
     446,   447,   448,    -1,   450,    -1,   452,   453,   454,   455,
      -1,    -1,   458,    -1,    -1,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,   478,   479,   480,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   494,    -1,
      -1,    -1,    20,    21,    22,    23,    24,    25,    26,    27,
      -1,    29,    30,    31,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    39,    40,    41,    -1,    43,    44,    45,    46,    47,
      48,    49,    50,    -1,    52,    53,    54,    55,    -1,    57,
      58,    59,    60,    61,    62,    63,    -1,    -1,    66,    67,
      68,    69,    70,    -1,    72,    73,    74,    75,    -1,    -1,
      78,    -1,    80,    81,    82,    83,    84,    85,    86,    87,
      88,    89,    -1,    91,    92,    93,    94,    95,    96,    -1,
      98,    99,   100,   101,    -1,    -1,    -1,   105,    -1,    -1,
      -1,   109,   110,   111,   112,   113,   114,   115,   116,   117,
      -1,   119,    -1,   121,   122,   123,   124,   125,   126,   127,
      -1,   129,   130,   131,   132,    -1,    -1,   135,   136,   137,
     138,   139,    -1,   141,   142,   143,    -1,   145,   146,   147,
      -1,   149,   150,   151,   152,    -1,   154,   155,   156,   157,
      -1,    -1,   160,    -1,   162,   163,   164,   165,   166,    -1,
     168,    -1,   170,   171,    -1,   173,   174,   175,   176,   177,
      -1,   179,    -1,    -1,    -1,   183,   184,    -1,   186,   187,
     188,   189,   190,   191,   192,   193,   194,   195,   196,   197,
     198,   199,   200,   201,   202,   203,    -1,   205,   206,   207,
     208,   209,   210,   211,   212,   213,    -1,   215,    -1,   217,
     218,   219,   220,   221,   222,   223,   224,   225,   226,    -1,
      -1,   229,    -1,   231,   232,   233,    -1,   235,   236,   237,
      -1,    -1,   240,   241,   242,   243,   244,   245,   246,   247,
     248,   249,   250,   251,   252,   253,   254,   255,   256,   257,
     258,   259,   260,   261,   262,   263,   264,   265,   266,   267,
      -1,    -1,   270,    -1,   272,   273,   274,   275,    -1,    -1,
     278,   279,   280,   281,   282,    -1,   284,   285,    -1,    -1,
     288,   289,   290,    -1,   292,   293,   294,   295,   296,   297,
     298,    -1,   300,   301,   302,   303,   304,   305,   306,   307,
     308,   309,    -1,    -1,   312,   313,    -1,   315,    -1,   317,
     318,   319,    -1,   321,   322,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,   333,   334,   335,    -1,   337,
     338,   339,   340,   341,   342,   343,   344,   345,   346,   347,
     348,   349,    -1,   351,   352,   353,   354,   355,   356,   357,
     358,    -1,   360,   361,   362,   363,   364,   365,   366,   367,
     368,    -1,   370,   371,   372,   373,   374,    -1,   376,   377,
     378,   379,   380,   381,   382,   383,   384,   385,    -1,   387,
     388,   389,   390,   391,   392,   393,   394,   395,   396,   397,
     398,   399,    -1,   401,    -1,   403,   404,    -1,   406,   407,
     408,   409,   410,   411,   412,    -1,   414,   415,   416,    -1,
      -1,   419,   420,    -1,   422,    -1,    -1,   425,   426,   427,
     428,   429,   430,   431,   432,    -1,    -1,   435,   436,   437,
     438,   439,    -1,    -1,   442,   443,   444,   445,   446,    -1,
     448,   449,   450,   451,   452,   453,   454,   455,    -1,    -1,
     458,    -1,    -1,   461,   462,   463,   464,   465,   466,    -1,
      -1,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     478,   479,   480,    -1,    -1,    -1,    -1,    -1,    20,    21,
      22,    23,    24,    25,    26,    27,   494,    29,    30,    31,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    39,    40,    41,
      -1,    43,    44,    45,    46,    47,    48,    49,    50,    -1,
      52,    53,    54,    55,    -1,    57,    58,    59,    60,    61,
      62,    63,    -1,    -1,    66,    67,    68,    69,    70,    -1,
      72,    73,    74,    75,    -1,    -1,    78,    -1,    80,    81,
      82,    83,    84,    85,    86,    87,    88,    89,    -1,    91,
      92,    93,    94,    95,    96,    -1,    98,    99,   100,   101,
      -1,    -1,    -1,   105,    -1,    -1,    -1,   109,   110,   111,
     112,   113,   114,   115,   116,   117,    -1,   119,    -1,   121,
     122,   123,   124,   125,   126,   127,    -1,   129,   130,   131,
     132,    -1,    -1,   135,   136,   137,   138,   139,    -1,   141,
     142,   143,    -1,   145,   146,   147,    -1,   149,   150,   151,
     152,    -1,   154,   155,   156,   157,    -1,    -1,   160,    -1,
     162,   163,   164,   165,   166,    -1,   168,    -1,   170,   171,
      -1,   173,   174,   175,   176,   177,    -1,   179,    -1,    -1,
      -1,   183,   184,    -1,   186,   187,   188,   189,   190,   191,
     192,   193,   194,   195,   196,   197,   198,   199,   200,   201,
     202,   203,    -1,   205,   206,   207,   208,   209,   210,   211,
     212,   213,    -1,   215,    -1,   217,   218,   219,   220,   221,
     222,   223,   224,   225,   226,    -1,    -1,   229,    -1,   231,
     232,   233,    -1,   235,   236,   237,    -1,    -1,   240,   241,
     242,   243,   244,   245,   246,   247,   248,   249,   250,   251,
     252,   253,   254,   255,   256,   257,   258,   259,   260,   261,
     262,   263,   264,   265,   266,   267,    -1,    -1,   270,    -1,
     272,   273,   274,   275,    -1,    -1,   278,   279,   280,   281,
     282,    -1,   284,   285,    -1,    -1,   288,   289,   290,    -1,
     292,   293,   294,   295,   296,   297,   298,    -1,   300,   301,
     302,   303,   304,   305,   306,   307,   308,   309,    -1,    -1,
     312,   313,    -1,   315,    -1,   317,   318,   319,    -1,   321,
     322,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,   333,   334,   335,    -1,   337,   338,   339,   340,   341,
     342,   343,   344,   345,   346,   347,   348,   349,    -1,   351,
     352,   353,   354,   355,   356,   357,   358,    -1,   360,   361,
     362,   363,   364,   365,   366,   367,   368,    -1,   370,   371,
     372,   373,   374,    -1,   376,   377,   378,   379,   380,   381,
     382,   383,   384,   385,    -1,   387,   388,   389,   390,   391,
     392,   393,   394,   395,   396,   397,   398,   399,    -1,   401,
      -1,   403,   404,    -1,   406,   407,   408,   409,   410,   411,
     412,    -1,   414,   415,   416,    -1,    -1,   419,   420,    -1,
     422,    -1,    -1,   425,   426,   427,   428,   429,   430,   431,
     432,    -1,    -1,   435,   436,   437,   438,   439,    -1,    -1,
     442,   443,   444,   445,   446,    -1,   448,   449,   450,   451,
     452,   453,   454,   455,    -1,    -1,   458,    -1,    -1,   461,
     462,   463,   464,   465,   466,    -1,    -1,     3,    -1,     5,
       6,    -1,    -1,    -1,    -1,    11,   478,   479,   480,    -1,
      -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,    25,
      26,    27,   494,    29,    30,    31,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    39,    40,    41,    -1,    43,    44,    45,
      46,    47,    48,    49,    50,    51,    52,    53,    54,    55,
      -1,    57,    58,    59,    60,    61,    62,    63,    -1,    -1,
      66,    67,    68,    69,    70,    -1,    72,    73,    74,    75,
      76,    -1,    78,    -1,    80,    81,    82,    83,    84,    85,
      86,    87,    88,    89,    -1,    91,    92,    93,    94,    95,
      96,    -1,    98,    99,   100,   101,    -1,    -1,    -1,   105,
      -1,    -1,    -1,   109,   110,   111,   112,   113,   114,   115,
     116,   117,   118,   119,    -1,   121,   122,   123,   124,   125,
     126,   127,    -1,   129,   130,   131,   132,    -1,    -1,   135,
     136,   137,   138,   139,    -1,   141,   142,   143,    -1,   145,
     146,   147,    -1,   149,   150,   151,   152,   153,   154,   155,
     156,   157,   158,   159,   160,    -1,   162,   163,   164,   165,
     166,    -1,   168,    -1,   170,   171,    -1,   173,   174,   175,
     176,   177,    -1,   179,   180,    -1,   182,   183,   184,    -1,
     186,   187,   188,   189,   190,   191,   192,   193,   194,   195,
      -1,   197,   198,   199,   200,   201,   202,   203,    -1,   205,
     206,   207,   208,   209,   210,   211,   212,   213,    -1,   215,
      -1,   217,   218,   219,   220,   221,   222,   223,   224,   225,
     226,    -1,    -1,   229,   230,   231,   232,   233,    -1,   235,
     236,   237,    -1,    -1,   240,   241,   242,   243,   244,   245,
     246,   247,   248,   249,   250,   251,   252,   253,   254,   255,
     256,   257,   258,   259,   260,   261,   262,   263,   264,   265,
     266,   267,   268,   269,   270,    -1,   272,   273,   274,   275,
      -1,   277,   278,   279,   280,   281,   282,    -1,   284,   285,
     286,    -1,   288,   289,   290,    -1,    -1,   293,   294,   295,
     296,   297,   298,   299,   300,   301,   302,   303,   304,   305,
     306,   307,   308,   309,    -1,    -1,   312,   313,   314,   315,
     316,   317,   318,   319,    -1,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
      -1,   337,   338,   339,   340,   341,   342,   343,   344,   345,
     346,   347,   348,   349,    -1,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
     366,   367,   368,    -1,   370,   371,   372,   373,   374,    -1,
     376,   377,   378,   379,   380,   381,   382,   383,   384,   385,
      -1,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,   399,   400,   401,    -1,   403,   404,    -1,
     406,   407,   408,   409,   410,   411,   412,    -1,   414,   415,
     416,    -1,    -1,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,   432,    -1,    -1,   435,
     436,   437,   438,   439,    -1,    -1,   442,   443,   444,   445,
     446,   447,   448,    -1,   450,   451,   452,   453,   454,   455,
      -1,    -1,   458,    -1,    -1,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,   478,   479,   480,     3,    -1,     5,     6,    -1,
      -1,    -1,    -1,    11,    -1,    -1,   492,   493,    -1,    -1,
      -1,    -1,    20,    21,    22,    23,    24,    25,    26,    27,
      -1,    29,    30,    31,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    39,    40,    41,    -1,    43,    44,    45,    46,    47,
      48,    49,    50,    51,    52,    53,    54,    55,    -1,    57,
      58,    59,    60,    61,    62,    63,    -1,    -1,    66,    67,
      68,    69,    70,    -1,    72,    73,    74,    75,    76,    -1,
      78,    -1,    80,    81,    82,    83,    84,    85,    86,    87,
      88,    89,    -1,    91,    92,    93,    94,    95,    96,    -1,
      98,    99,   100,   101,    -1,    -1,    -1,   105,    -1,    -1,
      -1,   109,   110,   111,   112,   113,   114,   115,   116,   117,
     118,   119,    -1,   121,   122,   123,   124,   125,   126,   127,
      -1,   129,   130,   131,   132,    -1,    -1,   135,   136,   137,
     138,   139,    -1,   141,   142,   143,    -1,   145,   146,   147,
      -1,   149,   150,   151,   152,   153,   154,   155,   156,   157,
     158,   159,   160,    -1,   162,   163,   164,   165,   166,    -1,
     168,    -1,   170,   171,    -1,   173,   174,   175,   176,   177,
      -1,   179,   180,    -1,   182,   183,   184,    -1,   186,   187,
     188,   189,   190,   191,   192,   193,   194,   195,    -1,   197,
     198,   199,   200,   201,   202,   203,    -1,   205,   206,   207,
     208,   209,   210,   211,   212,   213,    -1,   215,    -1,   217,
     218,   219,   220,   221,   222,   223,   224,   225,   226,    -1,
      -1,   229,   230,   231,   232,   233,    -1,   235,   236,   237,
      -1,    -1,   240,   241,   242,   243,   244,   245,   246,   247,
     248,   249,   250,   251,   252,   253,   254,   255,   256,   257,
     258,   259,   260,   261,   262,   263,   264,   265,   266,   267,
     268,   269,   270,    -1,   272,   273,   274,   275,    -1,   277,
     278,   279,   280,   281,   282,    -1,   284,   285,   286,    -1,
     288,   289,   290,    -1,    -1,   293,   294,   295,   296,   297,
     298,   299,   300,   301,   302,   303,   304,   305,   306,   307,
     308,   309,    -1,    -1,   312,   313,   314,   315,   316,   317,
     318,   319,    -1,   321,   322,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,   333,   334,   335,    -1,   337,
     338,   339,   340,   341,   342,   343,   344,   345,   346,   347,
     348,   349,    -1,   351,   352,   353,   354,   355,   356,   357,
     358,   359,   360,   361,   362,   363,   364,   365,   366,   367,
     368,    -1,   370,   371,   372,   373,   374,    -1,   376,   377,
     378,   379,   380,   381,   382,   383,   384,   385,    -1,   387,
     388,   389,   390,   391,   392,   393,   394,   395,   396,   397,
     398,   399,   400,   401,    -1,   403,   404,    -1,   406,   407,
     408,   409,   410,   411,   412,    -1,   414,   415,   416,    -1,
      -1,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,   432,    -1,    -1,   435,   436,   437,
     438,   439,    -1,    -1,   442,   443,   444,   445,   446,   447,
     448,    -1,   450,   451,   452,   453,   454,   455,    -1,    -1,
     458,    -1,    -1,   461,   462,   463,   464,   465,   466,   467,
     468,   469,   470,   471,   472,   473,   474,   475,   476,   477,
     478,   479,   480,     3,    -1,     5,     6,    -1,    -1,    -1,
      -1,    11,    -1,    -1,   492,   493,    -1,    -1,    -1,    -1,
      20,    21,    22,    23,    24,    25,    26,    27,    -1,    29,
      30,    31,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    39,
      40,    41,    -1,    43,    44,    45,    46,    47,    48,    49,
      50,    51,    52,    53,    54,    55,    -1,    57,    58,    59,
      60,    61,    62,    63,    -1,    -1,    66,    67,    68,    69,
      70,    -1,    72,    73,    74,    75,    76,    -1,    78,    -1,
      80,    81,    82,    83,    84,    85,    86,    87,    88,    89,
      -1,    91,    92,    93,    94,    95,    96,    -1,    98,    99,
     100,   101,    -1,    -1,    -1,   105,    -1,    -1,    -1,   109,
     110,   111,   112,   113,   114,   115,   116,   117,    -1,   119,
      -1,   121,   122,   123,   124,   125,   126,   127,    -1,   129,
     130,   131,   132,    -1,    -1,   135,   136,   137,   138,   139,
      -1,   141,   142,   143,    -1,   145,   146,   147,    -1,   149,
     150,   151,   152,   153,   154,   155,   156,   157,   158,   159,
     160,    -1,   162,   163,   164,   165,   166,    -1,   168,    -1,
     170,   171,    -1,   173,   174,   175,   176,   177,    -1,   179,
     180,    -1,   182,   183,   184,    -1,   186,   187,   188,   189,
     190,   191,   192,   193,   194,   195,    -1,   197,   198,   199,
     200,   201,   202,   203,    -1,   205,   206,   207,   208,   209,
     210,   211,   212,   213,    -1,   215,    -1,   217,   218,   219,
     220,   221,   222,   223,   224,   225,   226,    -1,    -1,   229,
     230,   231,   232,   233,    -1,   235,   236,   237,    -1,    -1,
     240,   241,   242,   243,   244,   245,   246,   247,   248,   249,
     250,   251,   252,   253,   254,   255,   256,   257,   258,   259,
     260,   261,   262,   263,   264,   265,   266,   267,   268,   269,
     270,    -1,   272,   273,   274,   275,    -1,   277,   278,   279,
     280,   281,   282,    -1,   284,   285,   286,    -1,   288,   289,
     290,    -1,    -1,   293,   294,   295,   296,   297,   298,   299,
     300,   301,   302,   303,   304,   305,   306,   307,   308,   309,
      -1,    -1,   312,   313,   314,   315,   316,   317,   318,   319,
      -1,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,    -1,   337,   338,   339,
     340,   341,   342,   343,   344,   345,   346,   347,   348,   349,
      -1,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,   365,   366,   367,   368,    -1,
     370,   371,   372,   373,   374,    -1,   376,   377,   378,   379,
     380,   381,   382,   383,   384,   385,    -1,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,   399,
     400,   401,    -1,   403,   404,    -1,   406,   407,   408,   409,
     410,   411,   412,    -1,   414,   415,   416,    -1,    -1,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,   432,    -1,    -1,   435,   436,   437,   438,   439,
      -1,    -1,   442,   443,   444,   445,   446,   447,   448,    -1,
     450,   451,   452,   453,   454,   455,    -1,    -1,   458,    -1,
      -1,   461,   462,   463,   464,   465,   466,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,     3,    -1,    -1,     6,    -1,    -1,    -1,    -1,    11,
      -1,    -1,   492,   493,    -1,    -1,    -1,    -1,    20,    21,
      22,    23,    24,    25,    26,    27,    -1,    29,    30,    31,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    39,    40,    41,
      -1,    43,    44,    45,    46,    47,    48,    49,    50,    51,
      52,    53,    54,    55,    -1,    57,    58,    59,    60,    61,
      62,    63,    -1,    -1,    66,    67,    68,    69,    70,    -1,
      72,    73,    74,    75,    76,    -1,    78,    -1,    80,    81,
      82,    83,    84,    85,    86,    87,    88,    89,    -1,    91,
      92,    93,    94,    95,    96,    -1,    98,    99,   100,   101,
      -1,    -1,    -1,   105,    -1,    -1,    -1,   109,   110,   111,
     112,   113,   114,   115,   116,   117,   118,   119,    -1,   121,
     122,   123,   124,   125,   126,   127,    -1,   129,   130,   131,
     132,    -1,    -1,   135,   136,   137,   138,   139,    -1,   141,
     142,   143,    -1,   145,   146,   147,    -1,   149,   150,   151,
     152,   153,   154,   155,   156,   157,   158,   159,   160,    -1,
     162,   163,   164,   165,   166,    -1,   168,    -1,   170,   171,
      -1,   173,   174,   175,   176,   177,    -1,   179,   180,    -1,
     182,   183,   184,    -1,   186,   187,   188,   189,   190,   191,
     192,   193,   194,   195,    -1,   197,   198,   199,   200,   201,
     202,   203,    -1,   205,   206,   207,   208,   209,   210,   211,
     212,   213,    -1,   215,    -1,   217,   218,   219,   220,   221,
     222,   223,   224,   225,   226,    -1,    -1,   229,   230,   231,
     232,   233,    -1,   235,   236,   237,    -1,    -1,   240,   241,
     242,   243,   244,   245,   246,   247,   248,   249,   250,   251,
     252,   253,   254,   255,   256,   257,   258,   259,   260,   261,
     262,   263,   264,   265,   266,   267,   268,   269,   270,    -1,
     272,   273,   274,   275,    -1,   277,   278,   279,   280,   281,
     282,    -1,   284,   285,   286,    -1,   288,   289,   290,    -1,
      -1,   293,   294,   295,   296,   297,   298,   299,   300,   301,
     302,   303,   304,   305,   306,   307,   308,   309,    -1,    -1,
     312,   313,   314,   315,   316,   317,   318,   319,    -1,   321,
     322,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,   333,   334,   335,    -1,   337,   338,   339,   340,   341,
     342,   343,   344,   345,   346,   347,   348,   349,    -1,   351,
     352,   353,   354,   355,   356,   357,   358,   359,   360,   361,
     362,   363,   364,   365,   366,   367,   368,    -1,   370,   371,
     372,   373,   374,    -1,   376,   377,   378,   379,   380,   381,
     382,   383,   384,   385,    -1,   387,   388,   389,   390,   391,
     392,   393,   394,   395,   396,   397,   398,   399,   400,   401,
      -1,   403,   404,    -1,   406,   407,   408,   409,   410,   411,
     412,    -1,   414,   415,   416,    -1,    -1,   419,   420,   421,
     422,   423,   424,   425,   426,   427,   428,   429,   430,   431,
     432,    -1,    -1,   435,   436,   437,   438,   439,    -1,    -1,
     442,   443,   444,   445,   446,   447,   448,    -1,   450,   451,
     452,   453,   454,   455,    -1,    -1,   458,    -1,    -1,   461,
     462,   463,   464,   465,   466,   467,   468,   469,   470,   471,
     472,   473,   474,   475,   476,   477,   478,   479,   480,     3,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    11,    -1,    -1,
     492,   493,    -1,    -1,    -1,    -1,    20,    21,    22,    23,
      24,    25,    26,    27,    28,    29,    30,    31,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    39,    40,    41,    -1,    43,
      44,    45,    46,    -1,    48,    49,    50,    51,    52,    -1,
      54,    55,    -1,    57,    58,    59,    60,    61,    62,    63,
      -1,    -1,    66,    67,    68,    69,    70,    -1,    72,    73,
      74,    75,    76,    -1,    -1,    -1,    80,    81,    82,    83,
      84,    85,    -1,    87,    88,    89,    -1,    91,    92,    93,
      94,    95,    96,    -1,    -1,    99,   100,   101,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   109,   110,   111,   112,   113,
     114,   115,   116,   117,    -1,   119,    -1,   121,   122,   123,
     124,   125,   126,   127,    -1,   129,   130,   131,   132,    -1,
      -1,   135,   136,   137,   138,   139,    -1,   141,   142,   143,
      -1,   145,   146,   147,    -1,   149,   150,   151,   152,   153,
     154,   155,   156,   157,   158,    -1,   160,    -1,   162,   163,
     164,   165,   166,    -1,   168,    -1,   170,    -1,   172,    -1,
     174,   175,   176,   177,    -1,   179,   180,    -1,   182,   183,
     184,    -1,   186,   187,   188,   189,   190,    -1,   192,   193,
     194,   195,   196,   197,   198,   199,   200,   201,   202,   203,
      -1,   205,    -1,   207,   208,   209,   210,   211,   212,   213,
      -1,   215,    -1,   217,    -1,    -1,   220,    -1,   222,   223,
     224,   225,   226,    -1,    -1,   229,   230,    -1,   232,    -1,
      -1,   235,   236,   237,    -1,    -1,   240,   241,   242,   243,
     244,   245,   246,   247,   248,   249,   250,   251,   252,   253,
     254,   255,   256,   257,   258,    -1,   260,   261,   262,   263,
     264,   265,   266,   267,   268,   269,   270,    -1,   272,   273,
      -1,   275,    -1,   277,   278,   279,   280,   281,   282,    -1,
     284,   285,    -1,    -1,   288,   289,   290,    -1,    -1,   293,
     294,   295,    -1,   297,    -1,   299,   300,   301,   302,   303,
     304,   305,   306,   307,   308,   309,    -1,    -1,   312,   313,
     314,   315,   316,   317,   318,   319,    -1,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,   333,
     334,   335,    -1,   337,   338,   339,   340,   341,   342,   343,
     344,   345,   346,   347,   348,   349,    -1,   351,   352,    -1,
     354,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,   365,   366,   367,   368,    -1,   370,   371,   372,   373,
     374,    -1,   376,   377,   378,   379,   380,    -1,   382,   383,
     384,   385,    -1,   387,   388,   389,   390,   391,   392,   393,
     394,   395,   396,   397,   398,   399,   400,   401,    -1,   403,
     404,    -1,   406,    -1,   408,   409,   410,   411,   412,    -1,
     414,   415,   416,    -1,    -1,   419,   420,   421,   422,   423,
      -1,   425,   426,   427,   428,   429,   430,   431,   432,    -1,
      -1,   435,   436,   437,   438,   439,    -1,    -1,   442,   443,
     444,   445,   446,   447,   448,    -1,   450,    -1,   452,   453,
     454,   455,    -1,    -1,   458,    -1,    -1,   461,   462,   463,
     464,   465,   466,   467,   468,   469,   470,   471,   472,   473,
     474,   475,   476,   477,   478,   479,   480,     3,    -1,     5,
       6,    -1,    -1,    -1,    -1,    11,    -1,    -1,   492,   493,
      -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,    25,
      26,    27,    28,    29,    30,    31,    32,    33,    34,    35,
      36,    37,    38,    39,    40,    41,    42,    43,    44,    45,
      46,    47,    48,    49,    50,    51,    52,    53,    54,    55,
      56,    57,    58,    59,    60,    61,    62,    63,    64,    65,
      66,    67,    68,    69,    70,    71,    72,    73,    74,    75,
      76,    77,    78,    79,    80,    81,    82,    83,    84,    85,
      86,    87,    88,    89,    90,    91,    92,    93,    94,    95,
      96,    97,    98,    99,   100,   101,   102,   103,   104,   105,
     106,   107,   108,   109,   110,   111,   112,   113,   114,   115,
     116,   117,   118,   119,   120,   121,   122,   123,   124,   125,
     126,   127,   128,   129,   130,   131,   132,   133,   134,   135,
     136,   137,   138,   139,   140,   141,   142,   143,   144,   145,
     146,   147,   148,   149,   150,   151,   152,   153,   154,   155,
     156,   157,   158,   159,   160,   161,   162,   163,   164,   165,
     166,   167,   168,   169,   170,   171,   172,   173,   174,   175,
     176,   177,   178,   179,   180,   181,   182,   183,   184,   185,
     186,   187,   188,   189,   190,   191,   192,   193,   194,   195,
     196,   197,   198,   199,   200,   201,   202,   203,   204,   205,
     206,   207,   208,   209,   210,   211,   212,   213,   214,   215,
     216,   217,   218,   219,   220,   221,   222,   223,   224,   225,
     226,   227,   228,   229,   230,   231,   232,   233,   234,   235,
     236,   237,   238,   239,   240,   241,   242,   243,   244,   245,
     246,   247,   248,   249,   250,   251,   252,   253,   254,   255,
     256,   257,   258,   259,   260,   261,   262,   263,   264,   265,
     266,   267,   268,   269,   270,   271,   272,   273,   274,   275,
     276,   277,   278,   279,   280,   281,   282,   283,   284,   285,
     286,   287,   288,   289,   290,   291,   292,   293,   294,   295,
     296,   297,   298,   299,   300,   301,   302,   303,   304,   305,
     306,   307,   308,   309,    -1,   311,   312,   313,   314,   315,
     316,   317,   318,   319,   320,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   344,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,   374,   375,
     376,   377,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438,   439,   440,   441,   442,   443,   444,   445,
     446,   447,   448,   449,   450,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,   478,   479,   480,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    20,    21,    22,    23,    24,    25,    26,    27,
      28,    29,    30,    31,    32,    33,    34,    35,    36,    37,
      38,    39,    40,    41,    42,    43,    44,    45,    46,    47,
      48,    49,    50,    51,    52,    53,    54,    55,    56,    57,
      58,    59,    60,    61,    62,    63,    64,    65,    66,    67,
      68,    69,    70,    71,    72,    73,    74,    75,    76,    77,
      78,    79,    80,    81,    82,    83,    84,    85,    86,    87,
      88,    89,    90,    91,    92,    93,    94,    95,    96,    97,
      98,    99,   100,   101,   102,   103,   104,   105,   106,   107,
     108,   109,   110,   111,   112,   113,   114,   115,   116,   117,
     118,   119,   120,   121,   122,   123,   124,   125,   126,   127,
     128,   129,   130,   131,   132,   133,   134,   135,   136,   137,
     138,   139,   140,   141,   142,   143,   144,   145,   146,   147,
     148,   149,   150,   151,   152,   153,   154,   155,   156,   157,
     158,   159,   160,   161,   162,   163,   164,   165,   166,   167,
     168,   169,   170,   171,   172,   173,   174,   175,   176,   177,
     178,   179,   180,   181,   182,   183,   184,   185,   186,   187,
     188,   189,   190,   191,   192,   193,   194,   195,   196,   197,
     198,   199,   200,   201,   202,   203,   204,   205,   206,   207,
     208,   209,   210,   211,   212,   213,   214,   215,   216,   217,
     218,   219,   220,   221,   222,   223,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,   236,   237,
     238,   239,   240,   241,   242,   243,   244,   245,   246,   247,
     248,   249,   250,   251,   252,   253,   254,   255,   256,   257,
     258,   259,   260,   261,   262,   263,   264,   265,   266,   267,
     268,   269,   270,   271,   272,   273,   274,   275,   276,   277,
     278,   279,   280,   281,   282,   283,   284,   285,   286,   287,
     288,   289,   290,   291,   292,   293,   294,   295,   296,   297,
     298,   299,   300,   301,   302,   303,   304,   305,   306,   307,
     308,   309,    -1,   311,   312,   313,   314,   315,   316,   317,
     318,   319,   320,   321,   322,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,   333,   334,   335,   336,   337,
     338,   339,   340,   341,   342,   343,   344,   345,   346,   347,
     348,   349,   350,   351,   352,   353,   354,   355,   356,   357,
     358,   359,   360,   361,   362,   363,   364,   365,   366,   367,
     368,   369,   370,   371,   372,   373,   374,   375,   376,   377,
     378,   379,   380,   381,   382,   383,   384,   385,   386,   387,
     388,   389,   390,   391,   392,   393,   394,   395,   396,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   443,   444,   445,   446,   447,
     448,   449,   450,   451,   452,   453,   454,   455,   456,   457,
     458,   459,   460,   461,   462,   463,   464,   465,   466,   467,
     468,   469,   470,   471,   472,   473,   474,   475,   476,   477,
     478,   479,   480,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    29,
      30,    31,    32,    33,    34,    35,    36,    37,    38,    39,
      40,    41,    42,    43,    44,    45,    46,    47,    48,    49,
      50,    51,    52,    53,    54,    55,    56,    57,    58,    59,
      60,    61,    62,    63,    64,    65,    66,    67,    68,    69,
      70,    71,    72,    73,    74,    75,    76,    77,    78,    79,
      80,    81,    82,    83,    84,    85,    86,    87,    88,    89,
      90,    91,    92,    93,    94,    95,    96,    97,    98,    99,
     100,   101,   102,   103,   104,   105,   106,   107,   108,   109,
     110,   111,   112,   113,   114,   115,   116,   117,   118,   119,
     120,   121,   122,   123,   124,   125,   126,   127,   128,   129,
     130,   131,   132,   133,   134,   135,   136,   137,   138,   139,
     140,   141,   142,   143,   144,   145,   146,   147,   148,   149,
     150,   151,   152,   153,   154,   155,   156,   157,   158,   159,
     160,   161,   162,   163,   164,   165,   166,   167,   168,   169,
     170,   171,   172,   173,   174,   175,   176,   177,   178,   179,
     180,   181,   182,   183,   184,   185,   186,   187,   188,   189,
     190,   191,   192,   193,   194,   195,   196,   197,   198,   199,
     200,   201,   202,   203,   204,   205,   206,   207,   208,   209,
     210,   211,   212,   213,   214,   215,   216,   217,   218,   219,
     220,   221,   222,   223,   224,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,   236,   237,   238,   239,
     240,   241,   242,   243,   244,   245,   246,   247,   248,   249,
     250,   251,   252,   253,   254,   255,   256,   257,   258,   259,
     260,   261,   262,   263,   264,   265,   266,   267,   268,   269,
     270,   271,   272,   273,   274,   275,   276,   277,   278,   279,
     280,   281,   282,   283,   284,   285,   286,   287,   288,   289,
     290,   291,   292,   293,   294,   295,   296,   297,   298,   299,
     300,   301,   302,   303,   304,   305,   306,   307,   308,   309,
      -1,   311,   312,   313,   314,   315,   316,   317,   318,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,   344,   345,   346,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,   365,   366,   367,   368,   369,
     370,   371,   372,   373,   374,   375,   376,   377,   378,   379,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,   432,   433,   434,   435,   436,   437,   438,   439,
     440,   441,   442,   443,   444,   445,   446,   447,   448,   449,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
     460,   461,   462,   463,   464,   465,   466,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,    21,
      22,    23,    24,    25,    26,    27,    -1,    29,    30,    31,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    39,    40,    41,
      -1,    43,    44,    45,    46,    47,    48,    49,    50,    51,
      52,    53,    54,    55,    -1,    57,    58,    59,    60,    61,
      62,    63,    -1,    65,    66,    67,    68,    69,    70,    -1,
      72,    73,    74,    75,    76,    -1,    78,    -1,    80,    81,
      82,    83,    84,    85,    86,    87,    88,    89,    -1,    91,
      92,    93,    94,    95,    96,    -1,    98,    99,   100,   101,
     102,   103,   104,   105,   106,   107,   108,   109,   110,   111,
     112,   113,   114,   115,   116,   117,    -1,   119,    -1,   121,
     122,   123,   124,   125,   126,   127,    -1,   129,   130,   131,
     132,    -1,    -1,   135,   136,   137,   138,   139,    -1,   141,
     142,   143,    -1,   145,   146,   147,    -1,   149,   150,   151,
     152,   153,   154,   155,   156,   157,   158,    -1,   160,    -1,
     162,   163,   164,   165,   166,    -1,   168,    -1,   170,   171,
      -1,   173,   174,   175,   176,   177,    -1,   179,   180,    -1,
     182,   183,   184,    -1,   186,   187,   188,   189,   190,   191,
     192,   193,   194,   195,    -1,   197,   198,   199,   200,   201,
     202,   203,    -1,   205,   206,   207,   208,   209,   210,   211,
     212,   213,    -1,   215,    -1,   217,   218,   219,   220,   221,
     222,   223,   224,   225,   226,    -1,    -1,   229,   230,   231,
     232,   233,    -1,   235,   236,   237,   238,   239,   240,   241,
     242,   243,   244,   245,   246,   247,   248,   249,   250,   251,
     252,   253,   254,   255,   256,   257,   258,   259,   260,   261,
     262,   263,   264,   265,   266,   267,   268,   269,   270,    -1,
     272,   273,   274,   275,    -1,   277,   278,   279,   280,   281,
     282,    -1,   284,   285,    -1,    -1,   288,   289,   290,    -1,
      -1,   293,   294,   295,   296,   297,   298,   299,   300,   301,
     302,   303,   304,   305,   306,   307,   308,   309,    -1,    -1,
     312,   313,   314,   315,   316,   317,   318,   319,    -1,   321,
     322,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,   333,   334,   335,    -1,   337,   338,   339,   340,   341,
     342,   343,   344,   345,   346,   347,   348,   349,    -1,   351,
     352,   353,   354,   355,   356,   357,   358,   359,   360,   361,
     362,   363,   364,   365,   366,   367,   368,    -1,   370,   371,
     372,   373,   374,   375,   376,   377,   378,   379,   380,   381,
     382,   383,   384,   385,    -1,   387,   388,   389,   390,   391,
     392,   393,   394,   395,   396,   397,   398,   399,   400,   401,
      -1,   403,   404,    -1,   406,   407,   408,   409,   410,   411,
     412,    -1,   414,   415,   416,    -1,    -1,   419,   420,   421,
     422,   423,    -1,   425,   426,   427,   428,   429,   430,   431,
     432,    -1,    -1,   435,   436,   437,   438,   439,   440,    -1,
     442,   443,   444,   445,   446,   447,   448,    -1,   450,   451,
     452,   453,   454,   455,    -1,    -1,   458,    -1,    -1,   461,
     462,   463,   464,   465,   466,   467,   468,   469,   470,   471,
     472,   473,   474,   475,   476,   477,   478,   479,   480,     3,
      -1,     5,     6,    -1,     8,     9,    -1,    11,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    20,    21,    22,    23,
      24,    25,    26,    27,    -1,    29,    30,    31,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    39,    40,    41,    -1,    43,
      44,    45,    46,    47,    48,    49,    50,    51,    52,    53,
      54,    55,    -1,    57,    58,    59,    60,    61,    62,    63,
      -1,    -1,    66,    67,    68,    69,    70,    -1,    72,    73,
      74,    75,    76,    -1,    78,    -1,    80,    81,    82,    83,
      84,    85,    86,    87,    88,    89,    -1,    91,    92,    93,
      94,    95,    96,    -1,    98,    99,   100,   101,    -1,    -1,
      -1,   105,    -1,    -1,    -1,   109,   110,   111,   112,   113,
     114,   115,   116,   117,    -1,   119,    -1,   121,   122,   123,
     124,   125,   126,   127,    -1,   129,   130,   131,   132,    -1,
      -1,   135,   136,   137,   138,   139,    -1,   141,   142,   143,
      -1,   145,   146,   147,    -1,   149,   150,   151,   152,   153,
     154,   155,   156,   157,   158,   159,   160,    -1,   162,   163,
     164,   165,   166,    -1,   168,    -1,   170,   171,    -1,   173,
     174,   175,   176,   177,    -1,   179,   180,    -1,   182,   183,
     184,    -1,   186,   187,   188,   189,   190,   191,   192,   193,
     194,   195,    -1,   197,   198,   199,   200,   201,   202,   203,
      -1,   205,   206,   207,   208,   209,   210,   211,   212,   213,
      -1,   215,    -1,   217,   218,   219,   220,   221,   222,   223,
     224,   225,   226,    -1,    -1,   229,   230,   231,   232,   233,
      -1,   235,   236,   237,    -1,    -1,   240,   241,   242,   243,
     244,   245,   246,   247,   248,   249,   250,   251,   252,   253,
     254,   255,   256,   257,   258,   259,   260,   261,   262,   263,
     264,   265,   266,   267,   268,   269,   270,    -1,   272,   273,
     274,   275,   276,   277,   278,   279,   280,   281,   282,    -1,
     284,   285,    -1,    -1,   288,   289,   290,    -1,    -1,   293,
     294,   295,   296,   297,   298,   299,   300,   301,   302,   303,
     304,   305,   306,   307,   308,   309,    -1,    -1,   312,   313,
     314,   315,   316,   317,   318,   319,    -1,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,   333,
     334,   335,    -1,   337,   338,   339,   340,   341,   342,   343,
     344,   345,   346,   347,   348,   349,    -1,   351,   352,   353,
     354,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,   365,   366,   367,   368,    -1,   370,   371,   372,   373,
     374,    -1,   376,   377,   378,   379,   380,   381,   382,   383,
     384,   385,    -1,   387,   388,   389,   390,   391,   392,   393,
     394,   395,   396,   397,   398,   399,   400,   401,    -1,   403,
     404,    -1,   406,   407,   408,   409,   410,   411,   412,    -1,
     414,   415,   416,    -1,    -1,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   431,   432,    -1,
      -1,   435,   436,   437,   438,   439,    -1,    -1,   442,   443,
     444,   445,   446,   447,   448,    -1,   450,   451,   452,   453,
     454,   455,    -1,    -1,   458,    -1,    -1,   461,   462,   463,
     464,   465,   466,   467,   468,   469,   470,   471,   472,   473,
     474,   475,   476,   477,   478,   479,   480,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,    25,
      26,    27,    28,    29,    30,    31,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    39,    40,    41,    -1,    43,    44,    45,
      46,    47,    48,    49,    50,    51,    52,    53,    54,    55,
      -1,    57,    58,    59,    60,    61,    62,    63,    -1,    -1,
      66,    67,    68,    69,    70,    -1,    72,    73,    74,    75,
      76,    -1,    78,    -1,    80,    81,    82,    83,    84,    85,
      86,    87,    88,    89,    -1,    91,    92,    93,    94,    95,
      96,    -1,    98,    99,   100,   101,    -1,    -1,   104,   105,
      -1,    -1,   108,   109,   110,   111,   112,   113,   114,   115,
     116,   117,    -1,   119,    -1,   121,   122,   123,   124,   125,
     126,   127,    -1,   129,   130,   131,   132,    -1,    -1,   135,
     136,   137,   138,   139,    -1,   141,   142,   143,    -1,   145,
     146,   147,    -1,   149,   150,   151,   152,   153,   154,   155,
     156,   157,   158,    -1,   160,    -1,   162,   163,   164,   165,
     166,    -1,   168,    -1,   170,   171,    -1,   173,   174,   175,
     176,   177,    -1,   179,   180,    -1,   182,   183,   184,    -1,
     186,   187,   188,   189,   190,   191,   192,   193,   194,   195,
      -1,   197,   198,   199,   200,   201,   202,   203,    -1,   205,
     206,   207,   208,   209,   210,   211,   212,   213,    -1,   215,
      -1,   217,   218,   219,   220,   221,   222,   223,   224,   225,
     226,    -1,    -1,   229,   230,   231,   232,   233,    -1,   235,
     236,   237,    -1,    -1,   240,   241,   242,   243,   244,   245,
     246,   247,   248,   249,   250,   251,   252,   253,   254,   255,
     256,   257,   258,   259,   260,   261,   262,   263,   264,   265,
     266,   267,   268,   269,   270,    -1,   272,   273,   274,   275,
      -1,   277,   278,   279,   280,   281,   282,    -1,   284,   285,
      -1,    -1,   288,   289,   290,    -1,    -1,   293,   294,   295,
     296,   297,   298,   299,   300,   301,   302,   303,   304,   305,
     306,   307,   308,   309,    -1,    -1,   312,   313,   314,   315,
     316,   317,   318,   319,    -1,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
      -1,   337,   338,   339,   340,   341,   342,   343,   344,   345,
     346,   347,   348,   349,    -1,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
     366,   367,   368,    -1,   370,   371,   372,   373,   374,   375,
     376,   377,   378,   379,   380,   381,   382,   383,   384,   385,
      -1,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,   399,   400,   401,    -1,   403,   404,    -1,
     406,   407,   408,   409,   410,   411,   412,    -1,   414,   415,
     416,    -1,    -1,   419,   420,   421,   422,   423,    -1,   425,
     426,   427,   428,   429,   430,   431,   432,    -1,    -1,   435,
     436,   437,   438,   439,    -1,    -1,   442,   443,   444,   445,
     446,   447,   448,    -1,   450,   451,   452,   453,   454,   455,
      -1,    -1,   458,    -1,    -1,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,   478,   479,   480,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    20,    21,    22,    23,    24,    25,    26,    27,
      28,    29,    30,    31,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    39,    40,    41,    -1,    43,    44,    45,    46,    47,
      48,    49,    50,    51,    52,    53,    54,    55,    -1,    57,
      58,    59,    60,    61,    62,    63,    -1,    -1,    66,    67,
      68,    69,    70,    -1,    72,    73,    74,    75,    76,    -1,
      78,    -1,    80,    81,    82,    83,    84,    85,    86,    87,
      88,    89,    -1,    91,    92,    93,    94,    95,    96,    -1,
      98,    99,   100,   101,    -1,    -1,   104,   105,    -1,    -1,
     108,   109,   110,   111,   112,   113,   114,   115,   116,   117,
      -1,   119,    -1,   121,   122,   123,   124,   125,   126,   127,
      -1,   129,   130,   131,   132,    -1,    -1,   135,   136,   137,
     138,   139,    -1,   141,   142,   143,    -1,   145,   146,   147,
      -1,   149,   150,   151,   152,   153,   154,   155,   156,   157,
     158,    -1,   160,    -1,   162,   163,   164,   165,   166,    -1,
     168,    -1,   170,   171,    -1,   173,   174,   175,   176,   177,
      -1,   179,   180,    -1,   182,   183,   184,    -1,   186,   187,
     188,   189,   190,   191,   192,   193,   194,   195,    -1,   197,
     198,   199,   200,   201,   202,   203,    -1,   205,   206,   207,
     208,   209,   210,   211,   212,   213,    -1,   215,    -1,   217,
     218,   219,   220,   221,   222,   223,   224,   225,   226,    -1,
      -1,   229,   230,   231,   232,   233,    -1,   235,   236,   237,
      -1,    -1,   240,   241,   242,   243,   244,   245,   246,   247,
     248,   249,   250,   251,   252,   253,   254,   255,   256,   257,
     258,   259,   260,   261,   262,   263,   264,   265,   266,   267,
     268,   269,   270,    -1,   272,   273,   274,   275,    -1,   277,
     278,   279,   280,   281,   282,    -1,   284,   285,    -1,    -1,
     288,   289,   290,    -1,    -1,   293,   294,   295,   296,   297,
     298,   299,   300,   301,   302,   303,   304,   305,   306,   307,
     308,   309,    -1,    -1,   312,   313,   314,   315,   316,   317,
     318,   319,    -1,   321,   322,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,   333,   334,   335,    -1,   337,
     338,   339,   340,   341,   342,   343,   344,   345,   346,   347,
     348,   349,    -1,   351,   352,   353,   354,   355,   356,   357,
     358,   359,   360,   361,   362,   363,   364,   365,   366,   367,
     368,    -1,   370,   371,   372,   373,   374,   375,   376,   377,
     378,   379,   380,   381,   382,   383,   384,   385,    -1,   387,
     388,   389,   390,   391,   392,   393,   394,   395,   396,   397,
     398,   399,   400,   401,    -1,   403,   404,    -1,   406,   407,
     408,   409,   410,   411,   412,    -1,   414,   415,   416,    -1,
      -1,   419,   420,   421,   422,   423,    -1,   425,   426,   427,
     428,   429,   430,   431,   432,    -1,    -1,   435,   436,   437,
     438,   439,    -1,    -1,   442,   443,   444,   445,   446,   447,
     448,    -1,   450,   451,   452,   453,   454,   455,    -1,    -1,
     458,    -1,    -1,   461,   462,   463,   464,   465,   466,   467,
     468,   469,   470,   471,   472,   473,   474,   475,   476,   477,
     478,   479,   480,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      20,    21,    22,    23,    24,    25,    26,    27,    -1,    29,
      30,    31,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    39,
      40,    41,    -1,    43,    44,    45,    46,    47,    48,    49,
      50,    51,    52,    53,    54,    55,    -1,    57,    58,    59,
      60,    61,    62,    63,    -1,    -1,    66,    67,    68,    69,
      70,    -1,    72,    73,    74,    75,    76,    -1,    78,    -1,
      80,    81,    82,    83,    84,    85,    86,    87,    88,    89,
      -1,    91,    92,    93,    94,    95,    96,    -1,    98,    99,
     100,   101,    -1,    -1,   104,   105,    -1,    -1,   108,   109,
     110,   111,   112,   113,   114,   115,   116,   117,    -1,   119,
      -1,   121,   122,   123,   124,   125,   126,   127,    -1,   129,
     130,   131,   132,    -1,    -1,   135,   136,   137,   138,   139,
      -1,   141,   142,   143,    -1,   145,   146,   147,    -1,   149,
     150,   151,   152,   153,   154,   155,   156,   157,   158,    -1,
     160,    -1,   162,   163,   164,   165,   166,    -1,   168,    -1,
     170,   171,    -1,   173,   174,   175,   176,   177,    -1,   179,
     180,    -1,   182,   183,   184,    -1,   186,   187,   188,   189,
     190,   191,   192,   193,   194,   195,    -1,   197,   198,   199,
     200,   201,   202,   203,    -1,   205,   206,   207,   208,   209,
     210,   211,   212,   213,    -1,   215,    -1,   217,   218,   219,
     220,   221,   222,   223,   224,   225,   226,    -1,    -1,   229,
     230,   231,   232,   233,    -1,   235,   236,   237,    -1,    -1,
     240,   241,   242,   243,   244,   245,   246,   247,   248,   249,
     250,   251,   252,   253,   254,   255,   256,   257,   258,   259,
     260,   261,   262,   263,   264,   265,   266,   267,   268,   269,
     270,    -1,   272,   273,   274,   275,    -1,   277,   278,   279,
     280,   281,   282,    -1,   284,   285,    -1,    -1,   288,   289,
     290,    -1,    -1,   293,   294,   295,   296,   297,   298,   299,
     300,   301,   302,   303,   304,   305,   306,   307,   308,   309,
      -1,    -1,   312,   313,   314,   315,   316,   317,   318,   319,
      -1,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,    -1,   337,   338,   339,
     340,   341,   342,   343,   344,   345,   346,   347,   348,   349,
      -1,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,   365,   366,   367,   368,    -1,
     370,   371,   372,   373,   374,   375,   376,   377,   378,   379,
     380,   381,   382,   383,   384,   385,    -1,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,   399,
     400,   401,    -1,   403,   404,    -1,   406,   407,   408,   409,
     410,   411,   412,    -1,   414,   415,   416,    -1,    -1,   419,
     420,   421,   422,   423,    -1,   425,   426,   427,   428,   429,
     430,   431,   432,    -1,    -1,   435,   436,   437,   438,   439,
     440,    -1,   442,   443,   444,   445,   446,   447,   448,    -1,
     450,   451,   452,   453,   454,   455,    -1,    -1,   458,    -1,
      -1,   461,   462,   463,   464,   465,   466,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,    21,
      22,    23,    24,    25,    26,    27,    -1,    29,    30,    31,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    39,    40,    41,
      -1,    43,    44,    45,    46,    47,    48,    49,    50,    51,
      52,    53,    54,    55,    -1,    57,    58,    59,    60,    61,
      62,    63,    -1,    -1,    66,    67,    68,    69,    70,    -1,
      72,    73,    74,    75,    76,    -1,    78,    -1,    80,    81,
      82,    83,    84,    85,    86,    87,    88,    89,    -1,    91,
      92,    93,    94,    95,    96,    -1,    98,    99,   100,   101,
      -1,    -1,   104,   105,    -1,    -1,   108,   109,   110,   111,
     112,   113,   114,   115,   116,   117,    -1,   119,    -1,   121,
     122,   123,   124,   125,   126,   127,    -1,   129,   130,   131,
     132,    -1,    -1,   135,   136,   137,   138,   139,    -1,   141,
     142,   143,    -1,   145,   146,   147,    -1,   149,   150,   151,
     152,   153,   154,   155,   156,   157,   158,    -1,   160,    -1,
     162,   163,   164,   165,   166,    -1,   168,    -1,   170,   171,
      -1,   173,   174,   175,   176,   177,    -1,   179,   180,   181,
     182,   183,   184,    -1,   186,   187,   188,   189,   190,   191,
     192,   193,   194,   195,    -1,   197,   198,   199,   200,   201,
     202,   203,    -1,   205,   206,   207,   208,   209,   210,   211,
     212,   213,    -1,   215,    -1,   217,   218,   219,   220,   221,
     222,   223,   224,   225,   226,    -1,    -1,   229,   230,   231,
     232,   233,    -1,   235,   236,   237,    -1,    -1,   240,   241,
     242,   243,   244,   245,   246,   247,   248,   249,   250,   251,
     252,   253,   254,   255,   256,   257,   258,   259,   260,   261,
     262,   263,   264,   265,   266,   267,   268,   269,   270,    -1,
     272,   273,   274,   275,    -1,   277,   278,   279,   280,   281,
     282,    -1,   284,   285,    -1,    -1,   288,   289,   290,    -1,
      -1,   293,   294,   295,   296,   297,   298,   299,   300,   301,
     302,   303,   304,   305,   306,   307,   308,   309,    -1,    -1,
     312,   313,   314,   315,   316,   317,   318,   319,    -1,   321,
     322,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,   333,   334,   335,    -1,   337,   338,   339,   340,   341,
     342,   343,   344,   345,   346,   347,   348,   349,    -1,   351,
     352,   353,   354,   355,   356,   357,   358,   359,   360,   361,
     362,   363,   364,   365,   366,   367,   368,    -1,   370,   371,
     372,   373,   374,   375,   376,   377,   378,   379,   380,   381,
     382,   383,   384,   385,    -1,   387,   388,   389,   390,   391,
     392,   393,   394,   395,   396,   397,   398,   399,   400,   401,
      -1,   403,   404,    -1,   406,   407,   408,   409,   410,   411,
     412,    -1,   414,   415,   416,    -1,    -1,   419,   420,   421,
     422,   423,    -1,   425,   426,   427,   428,   429,   430,   431,
     432,    -1,    -1,   435,   436,   437,   438,   439,    -1,    -1,
     442,   443,   444,   445,   446,   447,   448,    -1,   450,   451,
     452,   453,   454,   455,    -1,    -1,   458,    -1,    -1,   461,
     462,   463,   464,   465,   466,   467,   468,   469,   470,   471,
     472,   473,   474,   475,   476,   477,   478,   479,   480,     3,
      -1,    -1,     6,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    20,    21,    22,    23,
      24,    25,    26,    27,    -1,    29,    30,    31,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    39,    40,    41,    -1,    43,
      44,    45,    46,    47,    48,    49,    50,    51,    52,    53,
      54,    55,    -1,    57,    58,    59,    60,    61,    62,    63,
      -1,    -1,    66,    67,    68,    69,    70,    -1,    72,    73,
      74,    75,    76,    -1,    78,    -1,    80,    81,    82,    83,
      84,    85,    86,    87,    88,    89,    -1,    91,    92,    93,
      94,    95,    96,    -1,    98,    99,   100,   101,    -1,    -1,
      -1,   105,    -1,    -1,    -1,   109,   110,   111,   112,   113,
     114,   115,   116,   117,    -1,   119,    -1,   121,   122,   123,
     124,   125,   126,   127,    -1,   129,   130,   131,   132,    -1,
      -1,   135,   136,   137,   138,   139,    -1,   141,   142,   143,
      -1,   145,   146,   147,    -1,   149,   150,   151,   152,   153,
     154,   155,   156,   157,   158,   159,   160,    -1,   162,   163,
     164,   165,   166,    -1,   168,    -1,   170,   171,    -1,   173,
     174,   175,   176,   177,    -1,   179,   180,    -1,   182,   183,
     184,    -1,   186,   187,   188,   189,   190,   191,   192,   193,
     194,   195,    -1,   197,   198,   199,   200,   201,   202,   203,
      -1,   205,   206,   207,   208,   209,   210,   211,   212,   213,
      -1,   215,    -1,   217,   218,   219,   220,   221,   222,   223,
     224,   225,   226,    -1,    -1,   229,   230,   231,   232,   233,
      -1,   235,   236,   237,    -1,    -1,   240,   241,   242,   243,
     244,   245,   246,   247,   248,   249,   250,   251,   252,   253,
     254,   255,   256,   257,   258,   259,   260,   261,   262,   263,
     264,   265,   266,   267,   268,   269,   270,    -1,   272,   273,
     274,   275,    -1,   277,   278,   279,   280,   281,   282,    -1,
     284,   285,   286,    -1,   288,   289,   290,    -1,    -1,   293,
     294,   295,   296,   297,   298,   299,   300,   301,   302,   303,
     304,   305,   306,   307,   308,   309,    -1,    -1,   312,   313,
     314,   315,   316,   317,   318,   319,    -1,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,   333,
     334,   335,    -1,   337,   338,   339,   340,   341,   342,   343,
     344,   345,   346,   347,   348,   349,    -1,   351,   352,   353,
     354,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,   365,   366,   367,   368,    -1,   370,   371,   372,   373,
     374,    -1,   376,   377,   378,   379,   380,   381,   382,   383,
     384,   385,    -1,   387,   388,   389,   390,   391,   392,   393,
     394,   395,   396,   397,   398,   399,   400,   401,    -1,   403,
     404,    -1,   406,   407,   408,   409,   410,   411,   412,    -1,
     414,   415,   416,    -1,    -1,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   431,   432,    -1,
      -1,   435,   436,   437,   438,   439,    -1,    -1,   442,   443,
     444,   445,   446,   447,   448,    -1,   450,   451,   452,   453,
     454,   455,    -1,    -1,   458,    -1,    -1,   461,   462,   463,
     464,   465,   466,   467,   468,   469,   470,   471,   472,   473,
     474,   475,   476,   477,   478,   479,   480,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,    25,
      26,    27,    -1,    29,    30,    31,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    39,    40,    41,    -1,    43,    44,    45,
      46,    47,    48,    49,    50,    51,    52,    53,    54,    55,
      -1,    57,    58,    59,    60,    61,    62,    63,    -1,    -1,
      66,    67,    68,    69,    70,    -1,    72,    73,    74,    75,
      76,    -1,    78,    -1,    80,    81,    82,    83,    84,    85,
      86,    87,    88,    89,    -1,    91,    92,    93,    94,    95,
      96,    -1,    98,    99,   100,   101,    -1,    -1,   104,   105,
      -1,    -1,   108,   109,   110,   111,   112,   113,   114,   115,
     116,   117,    -1,   119,    -1,   121,   122,   123,   124,   125,
     126,   127,    -1,   129,   130,   131,   132,    -1,    -1,   135,
     136,   137,   138,   139,    -1,   141,   142,   143,    -1,   145,
     146,   147,    -1,   149,   150,   151,   152,   153,   154,   155,
     156,   157,   158,    -1,   160,    -1,   162,   163,   164,   165,
     166,    -1,   168,    -1,   170,   171,    -1,   173,   174,   175,
     176,   177,    -1,   179,   180,    -1,   182,   183,   184,    -1,
     186,   187,   188,   189,   190,   191,   192,   193,   194,   195,
      -1,   197,   198,   199,   200,   201,   202,   203,    -1,   205,
     206,   207,   208,   209,   210,   211,   212,   213,    -1,   215,
      -1,   217,   218,   219,   220,   221,   222,   223,   224,   225,
     226,    -1,    -1,   229,   230,   231,   232,   233,    -1,   235,
     236,   237,    -1,    -1,   240,   241,   242,   243,   244,   245,
     246,   247,   248,   249,   250,   251,   252,   253,   254,   255,
     256,   257,   258,   259,   260,   261,   262,   263,   264,   265,
     266,   267,   268,   269,   270,    -1,   272,   273,   274,   275,
      -1,   277,   278,   279,   280,   281,   282,    -1,   284,   285,
      -1,    -1,   288,   289,   290,    -1,    -1,   293,   294,   295,
     296,   297,   298,   299,   300,   301,   302,   303,   304,   305,
     306,   307,   308,   309,    -1,    -1,   312,   313,   314,   315,
     316,   317,   318,   319,    -1,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
      -1,   337,   338,   339,   340,   341,   342,   343,   344,   345,
     346,   347,   348,   349,    -1,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
     366,   367,   368,    -1,   370,   371,   372,   373,   374,   375,
     376,   377,   378,   379,   380,   381,   382,   383,   384,   385,
      -1,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,   399,   400,   401,    -1,   403,   404,    -1,
     406,   407,   408,   409,   410,   411,   412,    -1,   414,   415,
     416,    -1,    -1,   419,   420,   421,   422,   423,    -1,   425,
     426,   427,   428,   429,   430,   431,   432,    -1,    -1,   435,
     436,   437,   438,   439,    -1,    -1,   442,   443,   444,   445,
     446,   447,   448,    -1,   450,   451,   452,   453,   454,   455,
      -1,    -1,   458,    -1,    -1,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,   478,   479,   480,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    20,    21,    22,    23,    24,    25,    26,    27,
      -1,    29,    30,    31,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    39,    40,    41,    -1,    43,    44,    45,    46,    47,
      48,    49,    50,    51,    52,    53,    54,    55,    -1,    57,
      58,    59,    60,    61,    62,    63,    -1,    -1,    66,    67,
      68,    69,    70,    -1,    72,    73,    74,    75,    76,    -1,
      78,    -1,    80,    81,    82,    83,    84,    85,    86,    87,
      88,    89,    -1,    91,    92,    93,    94,    95,    96,    -1,
      98,    99,   100,   101,    -1,    -1,   104,   105,    -1,    -1,
     108,   109,   110,   111,   112,   113,   114,   115,   116,   117,
      -1,   119,    -1,   121,   122,   123,   124,   125,   126,   127,
      -1,   129,   130,   131,   132,    -1,    -1,   135,   136,   137,
     138,   139,    -1,   141,   142,   143,    -1,   145,   146,   147,
      -1,   149,   150,   151,   152,   153,   154,   155,   156,   157,
     158,    -1,   160,    -1,   162,   163,   164,   165,   166,    -1,
     168,    -1,   170,   171,    -1,   173,   174,   175,   176,   177,
      -1,   179,   180,    -1,   182,   183,   184,    -1,   186,   187,
     188,   189,   190,   191,   192,   193,   194,   195,    -1,   197,
     198,   199,   200,   201,   202,   203,    -1,   205,   206,   207,
     208,   209,   210,   211,   212,   213,    -1,   215,    -1,   217,
     218,   219,   220,   221,   222,   223,   224,   225,   226,    -1,
      -1,   229,   230,   231,   232,   233,    -1,   235,   236,   237,
      -1,    -1,   240,   241,   242,   243,   244,   245,   246,   247,
     248,   249,   250,   251,   252,   253,   254,   255,   256,   257,
     258,   259,   260,   261,   262,   263,   264,   265,   266,   267,
     268,   269,   270,    -1,   272,   273,   274,   275,    -1,   277,
     278,   279,   280,   281,   282,    -1,   284,   285,    -1,    -1,
     288,   289,   290,    -1,    -1,   293,   294,   295,   296,   297,
     298,   299,   300,   301,   302,   303,   304,   305,   306,   307,
     308,   309,    -1,    -1,   312,   313,   314,   315,   316,   317,
     318,   319,    -1,   321,   322,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,   333,   334,   335,    -1,   337,
     338,   339,   340,   341,   342,   343,   344,   345,   346,   347,
     348,   349,    -1,   351,   352,   353,   354,   355,   356,   357,
     358,   359,   360,   361,   362,   363,   364,   365,   366,   367,
     368,    -1,   370,   371,   372,   373,   374,   375,   376,   377,
     378,   379,   380,   381,   382,   383,   384,   385,    -1,   387,
     388,   389,   390,   391,   392,   393,   394,   395,   396,   397,
     398,   399,   400,   401,    -1,   403,   404,    -1,   406,   407,
     408,   409,   410,   411,   412,    -1,   414,   415,   416,    -1,
      -1,   419,   420,   421,   422,   423,    -1,   425,   426,   427,
     428,   429,   430,   431,   432,    -1,    -1,   435,   436,   437,
     438,   439,    -1,    -1,   442,   443,   444,   445,   446,   447,
     448,    -1,   450,   451,   452,   453,   454,   455,    -1,    -1,
     458,    -1,    -1,   461,   462,   463,   464,   465,   466,   467,
     468,   469,   470,   471,   472,   473,   474,   475,   476,   477,
     478,   479,   480,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      20,    21,    22,    23,    24,    25,    26,    27,    -1,    29,
      30,    31,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    39,
      40,    41,    -1,    43,    44,    45,    46,    47,    48,    49,
      50,    51,    52,    53,    54,    55,    -1,    57,    58,    59,
      60,    61,    62,    63,    -1,    -1,    66,    67,    68,    69,
      70,    -1,    72,    73,    74,    75,    76,    -1,    78,    -1,
      80,    81,    82,    83,    84,    85,    86,    87,    88,    89,
      -1,    91,    92,    93,    94,    95,    96,    -1,    98,    99,
     100,   101,    -1,    -1,   104,   105,    -1,    -1,   108,   109,
     110,   111,   112,   113,   114,   115,   116,   117,    -1,   119,
      -1,   121,   122,   123,   124,   125,   126,   127,    -1,   129,
     130,   131,   132,    -1,    -1,   135,   136,   137,   138,   139,
      -1,   141,   142,   143,    -1,   145,   146,   147,    -1,   149,
     150,   151,   152,   153,   154,   155,   156,   157,   158,    -1,
     160,    -1,   162,   163,   164,   165,   166,    -1,   168,    -1,
     170,   171,    -1,   173,   174,   175,   176,   177,    -1,   179,
     180,    -1,   182,   183,   184,    -1,   186,   187,   188,   189,
     190,   191,   192,   193,   194,   195,    -1,   197,   198,   199,
     200,   201,   202,   203,    -1,   205,   206,   207,   208,   209,
     210,   211,   212,   213,    -1,   215,    -1,   217,   218,   219,
     220,   221,   222,   223,   224,   225,   226,    -1,    -1,   229,
     230,   231,   232,   233,    -1,   235,   236,   237,    -1,    -1,
     240,   241,   242,   243,   244,   245,   246,   247,   248,   249,
     250,   251,   252,   253,   254,   255,   256,   257,   258,   259,
     260,   261,   262,   263,   264,   265,   266,   267,   268,   269,
     270,    -1,   272,   273,   274,   275,    -1,   277,   278,   279,
     280,   281,   282,    -1,   284,   285,    -1,    -1,   288,   289,
     290,    -1,    -1,   293,   294,   295,   296,   297,   298,   299,
     300,   301,   302,   303,   304,   305,   306,   307,   308,   309,
      -1,    -1,   312,   313,   314,   315,   316,   317,   318,   319,
      -1,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,    -1,   337,   338,   339,
     340,   341,   342,   343,   344,   345,   346,   347,   348,   349,
      -1,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,   365,   366,   367,   368,    -1,
     370,   371,   372,   373,   374,   375,   376,   377,   378,   379,
     380,   381,   382,   383,   384,   385,    -1,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,   399,
     400,   401,    -1,   403,   404,    -1,   406,   407,   408,   409,
     410,   411,   412,    -1,   414,   415,   416,    -1,    -1,   419,
     420,   421,   422,   423,    -1,   425,   426,   427,   428,   429,
     430,   431,   432,    -1,    -1,   435,   436,   437,   438,   439,
      -1,    -1,   442,   443,   444,   445,   446,   447,   448,    -1,
     450,   451,   452,   453,   454,   455,    -1,    -1,   458,    -1,
      -1,   461,   462,   463,   464,   465,   466,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,    21,
      22,    23,    24,    25,    26,    27,    -1,    29,    30,    31,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    39,    40,    41,
      -1,    43,    44,    45,    46,    47,    48,    49,    50,    51,
      52,    53,    54,    55,    -1,    57,    58,    59,    60,    61,
      62,    63,    -1,    -1,    66,    67,    68,    69,    70,    -1,
      72,    73,    74,    75,    76,    -1,    78,    -1,    80,    81,
      82,    83,    84,    85,    86,    87,    88,    89,    -1,    91,
      92,    93,    94,    95,    96,    -1,    98,    99,   100,   101,
      -1,    -1,   104,   105,    -1,    -1,   108,   109,   110,   111,
     112,   113,   114,   115,   116,   117,    -1,   119,    -1,   121,
     122,   123,   124,   125,   126,   127,    -1,   129,   130,   131,
     132,    -1,    -1,   135,   136,   137,   138,   139,    -1,   141,
     142,   143,    -1,   145,   146,   147,    -1,   149,   150,   151,
     152,   153,   154,   155,   156,   157,   158,    -1,   160,    -1,
     162,   163,   164,   165,   166,    -1,   168,    -1,   170,   171,
      -1,   173,   174,   175,   176,   177,    -1,   179,   180,    -1,
     182,   183,   184,    -1,   186,   187,   188,   189,   190,   191,
     192,   193,   194,   195,    -1,   197,   198,   199,   200,   201,
     202,   203,    -1,   205,   206,   207,   208,   209,   210,   211,
     212,   213,    -1,   215,    -1,   217,   218,   219,   220,   221,
     222,   223,   224,   225,   226,    -1,    -1,   229,   230,   231,
     232,   233,    -1,   235,   236,   237,    -1,    -1,   240,   241,
     242,   243,   244,   245,   246,   247,   248,   249,   250,   251,
     252,   253,   254,   255,   256,   257,   258,   259,   260,   261,
     262,   263,   264,   265,   266,   267,   268,   269,   270,    -1,
     272,   273,   274,   275,    -1,   277,   278,   279,   280,   281,
     282,    -1,   284,   285,    -1,    -1,   288,   289,   290,    -1,
      -1,   293,   294,   295,   296,   297,   298,   299,   300,   301,
     302,   303,   304,   305,   306,   307,   308,   309,    -1,    -1,
     312,   313,   314,   315,   316,   317,   318,   319,    -1,   321,
     322,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,   333,   334,   335,    -1,   337,   338,   339,   340,   341,
     342,   343,   344,   345,   346,   347,   348,   349,    -1,   351,
     352,   353,   354,   355,   356,   357,   358,   359,   360,   361,
     362,   363,   364,   365,   366,   367,   368,    -1,   370,   371,
     372,   373,   374,   375,   376,   377,   378,   379,   380,   381,
     382,   383,   384,   385,    -1,   387,   388,   389,   390,   391,
     392,   393,   394,   395,   396,   397,   398,   399,   400,   401,
      -1,   403,   404,    -1,   406,   407,   408,   409,   410,   411,
     412,    -1,   414,   415,   416,    -1,    -1,   419,   420,   421,
     422,   423,    -1,   425,   426,   427,   428,   429,   430,   431,
     432,    -1,    -1,   435,   436,   437,   438,   439,    -1,    -1,
     442,   443,   444,   445,   446,   447,   448,    -1,   450,   451,
     452,   453,   454,   455,    -1,    -1,   458,    -1,    -1,   461,
     462,   463,   464,   465,   466,   467,   468,   469,   470,   471,
     472,   473,   474,   475,   476,   477,   478,   479,   480,     3,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    20,    21,    22,    23,
      24,    25,    26,    27,    -1,    29,    30,    31,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    39,    40,    41,    -1,    43,
      44,    45,    46,    47,    48,    49,    50,    51,    52,    53,
      54,    55,    -1,    57,    58,    59,    60,    61,    62,    63,
      -1,    -1,    66,    67,    68,    69,    70,    -1,    72,    73,
      74,    75,    76,    -1,    78,    -1,    80,    81,    82,    83,
      84,    85,    86,    87,    88,    89,    -1,    91,    92,    93,
      94,    95,    96,    -1,    98,    99,   100,   101,    -1,    -1,
     104,   105,    -1,    -1,   108,   109,   110,   111,   112,   113,
     114,   115,   116,   117,    -1,   119,    -1,   121,   122,   123,
     124,   125,   126,   127,    -1,   129,   130,   131,   132,    -1,
      -1,   135,   136,   137,   138,   139,    -1,   141,   142,   143,
      -1,   145,   146,   147,    -1,   149,   150,   151,   152,   153,
     154,   155,   156,   157,   158,    -1,   160,    -1,   162,   163,
     164,   165,   166,    -1,   168,    -1,   170,   171,    -1,   173,
     174,   175,   176,   177,    -1,   179,   180,    -1,   182,   183,
     184,    -1,   186,   187,   188,   189,   190,   191,   192,   193,
     194,   195,    -1,   197,   198,   199,   200,   201,   202,   203,
      -1,   205,   206,   207,   208,   209,   210,   211,   212,   213,
      -1,   215,    -1,   217,   218,   219,   220,   221,   222,   223,
     224,   225,   226,    -1,    -1,   229,   230,   231,   232,   233,
      -1,   235,   236,   237,    -1,    -1,   240,   241,   242,   243,
     244,   245,   246,   247,   248,   249,   250,   251,   252,   253,
     254,   255,   256,   257,   258,   259,   260,   261,   262,   263,
     264,   265,   266,   267,   268,   269,   270,    -1,   272,   273,
     274,   275,    -1,   277,   278,   279,   280,   281,   282,    -1,
     284,   285,    -1,    -1,   288,   289,   290,    -1,    -1,   293,
     294,   295,   296,   297,   298,   299,   300,   301,   302,   303,
     304,   305,   306,   307,   308,   309,    -1,    -1,   312,   313,
     314,   315,   316,   317,   318,   319,    -1,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,   333,
     334,   335,    -1,   337,   338,   339,   340,   341,   342,   343,
     344,   345,   346,   347,   348,   349,    -1,   351,   352,   353,
     354,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,   365,   366,   367,   368,    -1,   370,   371,   372,   373,
     374,   375,   376,   377,   378,   379,   380,   381,   382,   383,
     384,   385,    -1,   387,   388,   389,   390,   391,   392,   393,
     394,   395,   396,   397,   398,   399,   400,   401,    -1,   403,
     404,    -1,   406,   407,   408,   409,   410,   411,   412,    -1,
     414,   415,   416,    -1,    -1,   419,   420,   421,   422,   423,
      -1,   425,   426,   427,   428,   429,   430,   431,   432,    -1,
      -1,   435,   436,   437,   438,   439,    -1,    -1,   442,   443,
     444,   445,   446,   447,   448,    -1,   450,   451,   452,   453,
     454,   455,    -1,    -1,   458,    -1,    -1,   461,   462,   463,
     464,   465,   466,   467,   468,   469,   470,   471,   472,   473,
     474,   475,   476,   477,   478,   479,   480,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,    25,
      26,    27,    -1,    29,    30,    31,    32,    33,    -1,    -1,
      -1,    -1,    -1,    39,    40,    41,    -1,    43,    44,    45,
      46,    47,    48,    49,    50,    51,    52,    53,    54,    55,
      -1,    57,    58,    59,    60,    61,    62,    63,    -1,    -1,
      66,    67,    68,    69,    70,    -1,    72,    73,    74,    75,
      76,    -1,    78,    -1,    80,    81,    82,    83,    84,    85,
      86,    87,    88,    89,    -1,    91,    92,    93,    94,    95,
      96,    -1,    98,    99,   100,   101,    -1,    -1,    -1,   105,
      -1,    -1,    -1,   109,   110,   111,   112,   113,   114,   115,
     116,   117,    -1,   119,    -1,   121,   122,   123,   124,   125,
     126,   127,    -1,   129,   130,   131,   132,    -1,    -1,   135,
     136,   137,   138,   139,    -1,   141,   142,   143,    -1,   145,
     146,   147,    -1,   149,   150,   151,   152,   153,   154,   155,
     156,   157,   158,    -1,   160,    -1,   162,   163,   164,   165,
     166,    -1,   168,    -1,   170,   171,    -1,   173,   174,   175,
     176,   177,    -1,   179,   180,    -1,   182,   183,   184,    -1,
     186,   187,   188,   189,   190,   191,   192,   193,   194,   195,
      -1,   197,   198,   199,   200,   201,   202,   203,    -1,   205,
     206,   207,   208,   209,   210,   211,   212,   213,    -1,   215,
      -1,   217,   218,   219,   220,   221,   222,   223,   224,   225,
     226,    -1,    -1,   229,   230,   231,   232,   233,    -1,   235,
     236,   237,    -1,    -1,   240,   241,   242,   243,   244,   245,
     246,   247,   248,   249,   250,   251,   252,   253,   254,   255,
     256,   257,   258,   259,   260,   261,   262,   263,   264,   265,
     266,   267,   268,   269,   270,    -1,   272,   273,   274,   275,
      -1,   277,   278,   279,   280,   281,   282,    -1,   284,   285,
      -1,    -1,   288,   289,   290,    -1,    -1,   293,   294,   295,
     296,   297,   298,   299,   300,   301,   302,   303,   304,   305,
     306,   307,   308,   309,    -1,    -1,   312,   313,   314,   315,
     316,   317,   318,   319,    -1,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
      -1,   337,   338,   339,   340,   341,   342,   343,   344,   345,
     346,   347,   348,   349,    -1,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
     366,   367,   368,    -1,   370,   371,   372,   373,   374,    -1,
     376,   377,   378,   379,   380,   381,   382,   383,   384,   385,
      -1,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,   399,   400,   401,    -1,   403,   404,    -1,
     406,   407,   408,   409,   410,   411,   412,    -1,   414,   415,
     416,    -1,    -1,   419,   420,   421,   422,   423,    -1,   425,
     426,   427,   428,   429,   430,   431,   432,    -1,    -1,   435,
     436,   437,   438,   439,    -1,    -1,   442,   443,   444,   445,
     446,   447,   448,    -1,   450,   451,   452,   453,   454,   455,
      -1,    -1,   458,    -1,    -1,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,   478,   479,   480,     3,    -1,    -1,     6,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    20,    21,    22,    23,    24,    25,    26,    27,
      -1,    29,    30,    31,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    39,    40,    41,    -1,    43,    44,    45,    46,    47,
      48,    49,    50,    51,    52,    53,    54,    55,    -1,    57,
      58,    59,    60,    61,    62,    63,    -1,    -1,    66,    67,
      68,    69,    70,    -1,    72,    73,    74,    75,    76,    -1,
      78,    -1,    80,    81,    82,    83,    84,    85,    86,    87,
      88,    89,    -1,    91,    92,    93,    94,    95,    96,    -1,
      98,    99,   100,   101,    -1,    -1,    -1,   105,    -1,    -1,
      -1,   109,   110,   111,   112,   113,   114,   115,   116,   117,
     118,   119,    -1,   121,   122,   123,   124,   125,   126,   127,
      -1,   129,   130,   131,   132,    -1,    -1,   135,   136,   137,
     138,   139,    -1,   141,   142,   143,    -1,   145,   146,   147,
      -1,   149,   150,   151,   152,   153,   154,   155,   156,   157,
     158,    -1,   160,    -1,   162,   163,   164,   165,   166,    -1,
     168,    -1,   170,   171,    -1,   173,   174,   175,   176,   177,
      -1,   179,   180,    -1,   182,   183,   184,    -1,   186,   187,
     188,   189,   190,   191,   192,   193,   194,   195,    -1,   197,
     198,   199,   200,   201,   202,   203,    -1,   205,   206,   207,
     208,   209,   210,   211,   212,   213,    -1,   215,    -1,   217,
     218,   219,   220,   221,   222,   223,   224,   225,   226,    -1,
      -1,   229,   230,   231,   232,   233,    -1,   235,   236,   237,
      -1,    -1,   240,   241,   242,   243,   244,   245,   246,   247,
     248,   249,   250,   251,   252,   253,   254,   255,   256,   257,
     258,   259,   260,   261,   262,   263,   264,   265,   266,   267,
     268,   269,   270,    -1,   272,   273,   274,   275,    -1,   277,
     278,   279,   280,   281,   282,    -1,   284,   285,    -1,    -1,
     288,   289,   290,    -1,    -1,   293,   294,   295,   296,   297,
     298,   299,   300,   301,   302,   303,   304,   305,   306,   307,
     308,   309,    -1,    -1,   312,   313,   314,   315,   316,   317,
     318,   319,    -1,   321,   322,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,   333,   334,   335,    -1,   337,
     338,   339,   340,   341,   342,   343,   344,   345,   346,   347,
     348,   349,    -1,   351,   352,   353,   354,   355,   356,   357,
     358,   359,   360,   361,   362,   363,   364,   365,   366,   367,
     368,    -1,   370,   371,   372,   373,   374,    -1,   376,   377,
     378,   379,   380,   381,   382,   383,   384,   385,    -1,   387,
     388,   389,   390,   391,   392,   393,   394,   395,   396,   397,
     398,   399,   400,   401,    -1,   403,   404,    -1,   406,   407,
     408,   409,   410,   411,   412,    -1,   414,   415,   416,    -1,
      -1,   419,   420,   421,   422,   423,    -1,   425,   426,   427,
     428,   429,   430,   431,   432,    -1,    -1,   435,   436,   437,
     438,   439,    -1,    -1,   442,   443,   444,   445,   446,   447,
     448,    -1,   450,   451,   452,   453,   454,   455,    -1,    -1,
     458,    -1,    -1,   461,   462,   463,   464,   465,   466,   467,
     468,   469,   470,   471,   472,   473,   474,   475,   476,   477,
     478,   479,   480,     3,    -1,    -1,     6,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      20,    21,    22,    23,    24,    25,    26,    27,    -1,    29,
      30,    31,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    39,
      40,    41,    -1,    43,    44,    45,    46,    47,    48,    49,
      50,    51,    52,    53,    54,    55,    -1,    57,    58,    59,
      60,    61,    62,    63,    -1,    -1,    66,    67,    68,    69,
      70,    -1,    72,    73,    74,    75,    76,    -1,    78,    -1,
      80,    81,    82,    83,    84,    85,    86,    87,    88,    89,
      -1,    91,    92,    93,    94,    95,    96,    -1,    98,    99,
     100,   101,    -1,    -1,    -1,   105,    -1,    -1,    -1,   109,
     110,   111,   112,   113,   114,   115,   116,   117,    -1,   119,
      -1,   121,   122,   123,   124,   125,   126,   127,    -1,   129,
     130,   131,   132,    -1,    -1,   135,   136,   137,   138,   139,
      -1,   141,   142,   143,    -1,   145,   146,   147,    -1,   149,
     150,   151,   152,   153,   154,   155,   156,   157,   158,    -1,
     160,    -1,   162,   163,   164,   165,   166,    -1,   168,    -1,
     170,   171,    -1,   173,   174,   175,   176,   177,    -1,   179,
     180,    -1,   182,   183,   184,    -1,   186,   187,   188,   189,
     190,   191,   192,   193,   194,   195,    -1,   197,   198,   199,
     200,   201,   202,   203,    -1,   205,   206,   207,   208,   209,
     210,   211,   212,   213,    -1,   215,    -1,   217,   218,   219,
     220,   221,   222,   223,   224,   225,   226,    -1,    -1,   229,
     230,   231,   232,   233,    -1,   235,   236,   237,    -1,    -1,
     240,   241,   242,   243,   244,   245,   246,   247,   248,   249,
     250,   251,   252,   253,   254,   255,   256,   257,   258,   259,
     260,   261,   262,   263,   264,   265,   266,   267,   268,   269,
     270,    -1,   272,   273,   274,   275,    -1,   277,   278,   279,
     280,   281,   282,    -1,   284,   285,    -1,    -1,   288,   289,
     290,    -1,    -1,   293,   294,   295,   296,   297,   298,   299,
     300,   301,   302,   303,   304,   305,   306,   307,   308,   309,
      -1,    -1,   312,   313,   314,   315,   316,   317,   318,   319,
      -1,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,    -1,   337,   338,   339,
     340,   341,   342,   343,   344,   345,   346,   347,   348,   349,
      -1,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,   365,   366,   367,   368,    -1,
     370,   371,   372,   373,   374,    -1,   376,   377,   378,   379,
     380,   381,   382,   383,   384,   385,    -1,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,   399,
     400,   401,    -1,   403,   404,    -1,   406,   407,   408,   409,
     410,   411,   412,    -1,   414,   415,   416,    -1,    -1,   419,
     420,   421,   422,   423,    -1,   425,   426,   427,   428,   429,
     430,   431,   432,    -1,    -1,   435,   436,   437,   438,   439,
      -1,    -1,   442,   443,   444,   445,   446,   447,   448,    -1,
     450,   451,   452,   453,   454,   455,    -1,    -1,   458,    -1,
      -1,   461,   462,   463,   464,   465,   466,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,    21,
      22,    23,    24,    25,    26,    27,    -1,    29,    30,    31,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    39,    40,    41,
      -1,    43,    44,    45,    46,    47,    48,    49,    50,    51,
      52,    53,    54,    55,    -1,    57,    58,    59,    60,    61,
      62,    63,    -1,    -1,    66,    67,    68,    69,    70,    -1,
      72,    73,    74,    75,    76,    -1,    78,    -1,    80,    81,
      82,    83,    84,    85,    86,    87,    88,    89,    -1,    91,
      92,    93,    94,    95,    96,    -1,    98,    99,   100,   101,
      -1,    -1,    -1,   105,    -1,    -1,    -1,   109,   110,   111,
     112,   113,   114,   115,   116,   117,    -1,   119,    -1,   121,
     122,   123,   124,   125,   126,   127,    -1,   129,   130,   131,
     132,    -1,    -1,   135,   136,   137,   138,   139,    -1,   141,
     142,   143,    -1,   145,   146,   147,    -1,   149,   150,   151,
     152,   153,   154,   155,   156,   157,   158,    -1,   160,    -1,
     162,   163,   164,   165,   166,    -1,   168,    -1,   170,   171,
      -1,   173,   174,   175,   176,   177,    -1,   179,   180,    -1,
     182,   183,   184,    -1,   186,   187,   188,   189,   190,   191,
     192,   193,   194,   195,    -1,   197,   198,   199,   200,   201,
     202,   203,    -1,   205,   206,   207,   208,   209,   210,   211,
     212,   213,    -1,   215,    -1,   217,   218,   219,   220,   221,
     222,   223,   224,   225,   226,    -1,    -1,   229,   230,   231,
     232,   233,    -1,   235,   236,   237,    -1,    -1,   240,   241,
     242,   243,   244,   245,   246,   247,   248,   249,   250,   251,
     252,   253,   254,   255,   256,   257,   258,   259,   260,   261,
     262,   263,   264,   265,   266,   267,   268,   269,   270,    -1,
     272,   273,   274,   275,    -1,   277,   278,   279,   280,   281,
     282,    -1,   284,   285,    -1,    -1,   288,   289,   290,    -1,
      -1,   293,   294,   295,   296,   297,   298,   299,   300,   301,
     302,   303,   304,   305,   306,   307,   308,   309,    -1,    -1,
     312,   313,   314,   315,   316,   317,   318,   319,    -1,   321,
     322,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,   333,   334,   335,    -1,   337,   338,   339,   340,   341,
     342,   343,   344,   345,   346,   347,   348,   349,    -1,   351,
     352,   353,   354,   355,   356,   357,   358,   359,   360,   361,
     362,   363,   364,   365,   366,   367,   368,    -1,   370,   371,
     372,   373,   374,    -1,   376,   377,   378,   379,   380,   381,
     382,   383,   384,   385,    -1,   387,   388,   389,   390,   391,
     392,   393,   394,   395,   396,   397,   398,   399,   400,   401,
      -1,   403,   404,    -1,   406,   407,   408,   409,   410,   411,
     412,    -1,   414,   415,   416,    -1,    -1,   419,   420,   421,
     422,   423,    -1,   425,   426,   427,   428,   429,   430,   431,
     432,    -1,    -1,   435,   436,   437,   438,   439,    -1,    -1,
     442,   443,   444,   445,   446,   447,   448,    -1,   450,   451,
     452,   453,   454,   455,    -1,    -1,   458,    -1,    -1,   461,
     462,   463,   464,   465,   466,   467,   468,   469,   470,   471,
     472,   473,   474,   475,   476,   477,   478,   479,   480,     3,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    20,    21,    22,    23,
      24,    25,    26,    27,    -1,    29,    30,    31,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    39,    40,    41,    -1,    43,
      44,    45,    46,    47,    48,    49,    50,    51,    52,    53,
      54,    55,    -1,    57,    58,    59,    60,    61,    62,    63,
      -1,    -1,    66,    67,    68,    69,    70,    -1,    72,    73,
      74,    75,    76,    -1,    78,    -1,    80,    81,    82,    83,
      84,    85,    86,    87,    88,    89,    -1,    91,    92,    93,
      94,    95,    96,    -1,    98,    99,   100,   101,    -1,    -1,
      -1,   105,    -1,    -1,    -1,   109,   110,   111,   112,   113,
     114,   115,   116,   117,    -1,   119,    -1,   121,   122,   123,
     124,   125,   126,   127,    -1,   129,   130,   131,   132,    -1,
      -1,   135,   136,   137,   138,   139,    -1,   141,   142,   143,
      -1,   145,   146,   147,    -1,   149,   150,   151,   152,   153,
     154,   155,   156,   157,   158,    -1,   160,    -1,   162,   163,
     164,   165,   166,    -1,   168,    -1,   170,   171,    -1,   173,
     174,   175,   176,   177,    -1,   179,   180,    -1,   182,   183,
     184,    -1,   186,   187,   188,   189,   190,   191,   192,   193,
     194,   195,    -1,   197,   198,   199,   200,   201,   202,   203,
      -1,   205,   206,   207,   208,   209,   210,   211,   212,   213,
      -1,   215,    -1,   217,   218,   219,   220,   221,   222,   223,
     224,   225,   226,    -1,    -1,   229,   230,   231,   232,   233,
      -1,   235,   236,   237,    -1,    -1,   240,   241,   242,   243,
     244,   245,   246,   247,   248,   249,   250,   251,   252,   253,
     254,   255,   256,   257,   258,   259,   260,   261,   262,   263,
     264,   265,   266,   267,   268,   269,   270,    -1,   272,   273,
     274,   275,    -1,   277,   278,   279,   280,   281,   282,    -1,
     284,   285,    -1,    -1,   288,   289,   290,    -1,    -1,   293,
     294,   295,   296,   297,   298,   299,   300,   301,   302,   303,
     304,   305,   306,   307,   308,   309,    -1,    -1,   312,   313,
     314,   315,   316,   317,   318,   319,    -1,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,   333,
     334,   335,    -1,   337,   338,   339,   340,   341,   342,   343,
     344,   345,   346,   347,   348,   349,    -1,   351,   352,   353,
     354,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,   365,   366,   367,   368,    -1,   370,   371,   372,   373,
     374,    -1,   376,   377,   378,   379,   380,   381,   382,   383,
     384,   385,    -1,   387,   388,   389,   390,   391,   392,   393,
     394,   395,   396,   397,   398,   399,   400,   401,    -1,   403,
     404,    -1,   406,   407,   408,   409,   410,   411,   412,    -1,
     414,   415,   416,    -1,    -1,   419,   420,   421,   422,   423,
      -1,   425,   426,   427,   428,   429,   430,   431,   432,    -1,
      -1,   435,   436,   437,   438,   439,    -1,    -1,   442,   443,
     444,   445,   446,   447,   448,    -1,   450,   451,   452,   453,
     454,   455,    -1,    -1,   458,    -1,    -1,   461,   462,   463,
     464,   465,   466,   467,   468,   469,   470,   471,   472,   473,
     474,   475,   476,   477,   478,   479,   480,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,    25,
      26,    27,    -1,    29,    30,    31,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    39,    40,    41,    -1,    43,    44,    45,
      46,    47,    48,    49,    50,    51,    52,    53,    54,    55,
      -1,    57,    58,    59,    60,    61,    62,    63,    -1,    -1,
      66,    67,    68,    69,    70,    -1,    72,    73,    74,    75,
      76,    -1,    78,    -1,    80,    81,    82,    83,    84,    85,
      86,    87,    88,    89,    -1,    91,    92,    93,    94,    95,
      96,    -1,    98,    99,   100,   101,    -1,    -1,    -1,   105,
      -1,    -1,    -1,   109,   110,   111,   112,   113,   114,   115,
     116,   117,    -1,   119,    -1,   121,   122,   123,   124,   125,
     126,   127,    -1,   129,   130,   131,   132,    -1,    -1,   135,
     136,   137,   138,   139,    -1,   141,   142,   143,    -1,   145,
     146,   147,    -1,   149,   150,   151,   152,   153,   154,   155,
     156,   157,   158,    -1,   160,    -1,   162,   163,   164,   165,
     166,    -1,   168,    -1,   170,   171,    -1,   173,   174,   175,
     176,   177,    -1,   179,   180,    -1,   182,   183,   184,    -1,
     186,   187,   188,   189,   190,   191,   192,   193,   194,   195,
      -1,   197,   198,   199,   200,   201,   202,   203,    -1,   205,
     206,   207,   208,   209,   210,   211,   212,   213,    -1,   215,
      -1,   217,   218,   219,   220,   221,   222,   223,   224,   225,
     226,    -1,    -1,   229,   230,   231,   232,   233,    -1,   235,
     236,   237,    -1,    -1,   240,   241,   242,   243,   244,   245,
     246,   247,   248,   249,   250,   251,   252,   253,   254,   255,
     256,   257,   258,   259,   260,   261,   262,   263,   264,   265,
     266,   267,   268,   269,   270,    -1,   272,   273,   274,   275,
      -1,   277,   278,   279,   280,   281,   282,    -1,   284,   285,
      -1,    -1,   288,   289,   290,    -1,    -1,   293,   294,   295,
     296,   297,   298,   299,   300,   301,   302,   303,   304,   305,
     306,   307,   308,   309,    -1,    -1,   312,   313,   314,   315,
     316,   317,   318,   319,    -1,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
      -1,   337,   338,   339,   340,   341,   342,   343,   344,   345,
     346,   347,   348,   349,    -1,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
     366,   367,   368,    -1,   370,   371,   372,   373,   374,    -1,
     376,   377,   378,   379,   380,   381,   382,   383,   384,   385,
      -1,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,   399,   400,   401,    -1,   403,   404,    -1,
     406,   407,   408,   409,   410,   411,   412,    -1,   414,   415,
     416,    -1,    -1,   419,   420,   421,   422,   423,    -1,   425,
     426,   427,   428,   429,   430,   431,   432,    -1,    -1,   435,
     436,   437,   438,   439,    -1,    -1,   442,   443,   444,   445,
     446,   447,   448,    -1,   450,   451,   452,   453,   454,   455,
      -1,    -1,   458,    -1,    -1,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,   478,   479,   480,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    20,    21,    22,    23,    24,    25,    26,    27,
      -1,    29,    30,    31,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    39,    40,    41,    -1,    43,    44,    45,    46,    47,
      48,    49,    50,    51,    52,    53,    54,    55,    -1,    57,
      58,    59,    60,    61,    62,    63,    -1,    -1,    66,    67,
      68,    69,    70,    -1,    72,    73,    74,    75,    76,    -1,
      78,    -1,    80,    81,    82,    83,    84,    85,    86,    87,
      88,    89,    -1,    91,    92,    93,    94,    95,    96,    -1,
      98,    99,   100,   101,    -1,    -1,    -1,   105,    -1,    -1,
      -1,   109,   110,   111,   112,   113,   114,   115,   116,   117,
      -1,   119,    -1,   121,   122,   123,   124,   125,   126,   127,
      -1,   129,   130,   131,   132,    -1,    -1,   135,   136,   137,
     138,   139,    -1,   141,   142,   143,    -1,   145,   146,   147,
      -1,   149,   150,   151,   152,   153,   154,   155,   156,   157,
     158,    -1,   160,    -1,   162,   163,   164,   165,   166,    -1,
     168,    -1,   170,   171,    -1,   173,   174,   175,   176,   177,
      -1,   179,   180,    -1,   182,   183,   184,    -1,   186,   187,
     188,   189,   190,   191,   192,   193,   194,   195,    -1,   197,
     198,   199,   200,   201,   202,   203,    -1,   205,   206,   207,
     208,   209,   210,   211,   212,   213,    -1,   215,    -1,   217,
     218,   219,   220,   221,   222,   223,   224,   225,   226,    -1,
      -1,   229,   230,   231,   232,   233,    -1,   235,   236,   237,
      -1,    -1,   240,   241,   242,   243,   244,   245,   246,   247,
     248,   249,   250,   251,   252,   253,   254,   255,   256,   257,
     258,   259,   260,   261,   262,   263,   264,   265,   266,   267,
     268,   269,   270,    -1,   272,   273,   274,   275,    -1,   277,
     278,   279,   280,   281,   282,    -1,   284,   285,    -1,    -1,
     288,   289,   290,    -1,    -1,   293,   294,   295,   296,   297,
     298,   299,   300,   301,   302,   303,   304,   305,   306,   307,
     308,   309,    -1,    -1,   312,   313,   314,   315,   316,   317,
     318,   319,    -1,   321,   322,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,   333,   334,   335,    -1,   337,
     338,   339,   340,   341,   342,   343,   344,   345,   346,   347,
     348,   349,    -1,   351,   352,   353,   354,   355,   356,   357,
     358,   359,   360,   361,   362,   363,   364,   365,   366,   367,
     368,    -1,   370,   371,   372,   373,   374,    -1,   376,   377,
     378,   379,   380,   381,   382,   383,   384,   385,    -1,   387,
     388,   389,   390,   391,   392,   393,   394,   395,   396,   397,
     398,   399,   400,   401,    -1,   403,   404,    -1,   406,   407,
     408,   409,   410,   411,   412,    -1,   414,   415,   416,    -1,
      -1,   419,   420,   421,   422,   423,    -1,   425,   426,   427,
     428,   429,   430,   431,   432,    -1,    -1,   435,   436,   437,
     438,   439,    -1,    -1,   442,   443,   444,   445,   446,   447,
     448,    -1,   450,   451,   452,   453,   454,   455,    -1,    -1,
     458,    -1,    -1,   461,   462,   463,   464,   465,   466,   467,
     468,   469,   470,   471,   472,   473,   474,   475,   476,   477,
     478,   479,   480,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      20,    21,    22,    23,    24,    25,    26,    27,    -1,    29,
      30,    31,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    39,
      40,    41,    -1,    43,    44,    45,    46,    47,    48,    49,
      50,    51,    52,    53,    54,    55,    -1,    57,    58,    59,
      60,    61,    62,    63,    -1,    -1,    66,    67,    68,    69,
      70,    -1,    72,    73,    74,    75,    76,    -1,    78,    -1,
      80,    81,    82,    83,    84,    85,    86,    87,    88,    89,
      -1,    91,    92,    93,    94,    95,    96,    -1,    98,    99,
     100,   101,    -1,    -1,    -1,   105,    -1,    -1,    -1,   109,
     110,   111,   112,   113,   114,   115,   116,   117,    -1,   119,
      -1,   121,   122,   123,   124,   125,   126,   127,    -1,   129,
     130,   131,   132,    -1,    -1,   135,   136,   137,   138,   139,
      -1,   141,   142,   143,    -1,   145,   146,   147,    -1,   149,
     150,   151,   152,   153,   154,   155,   156,   157,   158,    -1,
     160,    -1,   162,   163,   164,   165,   166,    -1,   168,    -1,
     170,   171,    -1,   173,   174,   175,   176,   177,    -1,   179,
     180,    -1,   182,   183,   184,    -1,   186,   187,   188,   189,
     190,   191,   192,   193,   194,   195,    -1,   197,   198,   199,
     200,   201,   202,   203,    -1,   205,   206,   207,   208,   209,
     210,   211,   212,   213,    -1,   215,    -1,   217,   218,   219,
     220,   221,   222,   223,   224,   225,   226,    -1,    -1,   229,
     230,   231,   232,   233,    -1,   235,   236,   237,    -1,    -1,
     240,   241,   242,   243,   244,   245,   246,   247,   248,   249,
     250,   251,   252,   253,   254,   255,   256,   257,   258,   259,
     260,   261,   262,   263,   264,   265,   266,   267,   268,   269,
     270,    -1,   272,   273,   274,   275,    -1,   277,   278,   279,
     280,   281,   282,    -1,   284,   285,    -1,    -1,   288,   289,
     290,    -1,    -1,   293,   294,   295,   296,   297,   298,   299,
     300,   301,   302,   303,   304,   305,   306,   307,   308,   309,
      -1,    -1,   312,   313,   314,   315,   316,   317,   318,   319,
      -1,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,    -1,   337,   338,   339,
     340,   341,   342,   343,   344,   345,   346,   347,   348,   349,
      -1,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,   365,   366,   367,   368,    -1,
     370,   371,   372,   373,   374,    -1,   376,   377,   378,   379,
     380,   381,   382,   383,   384,   385,    -1,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,   399,
     400,   401,    -1,   403,   404,    -1,   406,   407,   408,   409,
     410,   411,   412,    -1,   414,   415,   416,    -1,    -1,   419,
     420,   421,   422,   423,    -1,   425,   426,   427,   428,   429,
     430,   431,   432,    -1,    -1,   435,   436,   437,   438,   439,
      -1,    -1,   442,   443,   444,   445,   446,   447,   448,    -1,
     450,   451,   452,   453,   454,   455,    -1,    -1,   458,    -1,
      -1,   461,   462,   463,   464,   465,   466,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,    21,
      22,    23,    24,    25,    26,    27,    -1,    29,    30,    31,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    39,    40,    41,
      -1,    43,    44,    45,    46,    47,    48,    49,    50,    51,
      52,    53,    54,    55,    -1,    57,    58,    59,    60,    61,
      62,    63,    -1,    -1,    66,    67,    68,    69,    70,    -1,
      72,    73,    74,    75,    76,    -1,    78,    -1,    80,    81,
      82,    83,    84,    85,    86,    87,    88,    89,    -1,    91,
      92,    93,    94,    95,    96,    -1,    98,    99,   100,   101,
      -1,    -1,    -1,   105,    -1,    -1,    -1,   109,   110,   111,
     112,   113,   114,   115,   116,   117,    -1,   119,    -1,   121,
     122,   123,   124,   125,   126,   127,    -1,   129,   130,   131,
     132,    -1,    -1,   135,   136,   137,   138,   139,    -1,   141,
     142,   143,    -1,   145,   146,   147,    -1,   149,   150,   151,
     152,   153,   154,   155,   156,   157,   158,    -1,   160,    -1,
     162,   163,   164,   165,   166,    -1,   168,    -1,   170,   171,
      -1,   173,   174,   175,   176,   177,    -1,   179,   180,    -1,
     182,   183,   184,    -1,   186,   187,   188,   189,   190,   191,
     192,   193,   194,   195,    -1,   197,   198,   199,   200,   201,
     202,   203,    -1,   205,   206,   207,   208,   209,   210,   211,
     212,   213,    -1,   215,    -1,   217,   218,   219,   220,   221,
     222,   223,   224,   225,   226,    -1,    -1,   229,   230,   231,
     232,   233,    -1,   235,   236,   237,    -1,    -1,   240,   241,
     242,   243,   244,   245,   246,   247,   248,   249,   250,   251,
     252,   253,   254,   255,   256,   257,   258,   259,   260,   261,
     262,   263,   264,   265,   266,   267,   268,   269,   270,    -1,
     272,   273,   274,   275,    -1,   277,   278,   279,   280,   281,
     282,    -1,   284,   285,    -1,    -1,   288,   289,   290,    -1,
      -1,   293,   294,   295,   296,   297,   298,   299,   300,   301,
     302,   303,   304,   305,   306,   307,   308,   309,    -1,    -1,
     312,   313,   314,   315,   316,   317,   318,   319,    -1,   321,
     322,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,   333,   334,   335,    -1,   337,   338,   339,   340,   341,
     342,   343,   344,   345,   346,   347,   348,   349,    -1,   351,
     352,   353,   354,   355,   356,   357,   358,   359,   360,   361,
     362,   363,   364,   365,   366,   367,   368,    -1,   370,   371,
     372,   373,   374,    -1,   376,   377,   378,   379,   380,   381,
     382,   383,   384,   385,    -1,   387,   388,   389,   390,   391,
     392,   393,   394,   395,   396,   397,   398,   399,   400,   401,
      -1,   403,   404,    -1,   406,   407,   408,   409,   410,   411,
     412,    -1,   414,   415,   416,    -1,    -1,   419,   420,   421,
     422,   423,    -1,   425,   426,   427,   428,   429,   430,   431,
     432,    -1,    -1,   435,   436,   437,   438,   439,    -1,    -1,
     442,   443,   444,   445,   446,   447,   448,    -1,   450,   451,
     452,   453,   454,   455,    -1,    -1,   458,    -1,    -1,   461,
     462,   463,   464,   465,   466,   467,   468,   469,   470,   471,
     472,   473,   474,   475,   476,   477,   478,   479,   480,     3,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    20,    21,    22,    23,
      24,    25,    26,    27,    -1,    29,    30,    31,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    39,    40,    41,    -1,    43,
      44,    45,    46,    -1,    48,    49,    50,    51,    52,    -1,
      54,    55,    -1,    57,    58,    59,    60,    61,    62,    63,
      -1,    -1,    66,    67,    68,    69,    70,    71,    72,    73,
      74,    75,    76,    -1,    -1,    79,    80,    81,    82,    83,
      84,    85,    -1,    87,    88,    89,    90,    91,    92,    93,
      94,    95,    96,    -1,    -1,    99,   100,   101,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   109,   110,   111,   112,   113,
     114,   115,   116,   117,    -1,   119,    -1,   121,   122,   123,
     124,   125,   126,   127,    -1,   129,   130,   131,   132,    -1,
      -1,   135,   136,   137,   138,   139,    -1,   141,   142,   143,
      -1,   145,   146,   147,    -1,   149,   150,   151,   152,   153,
     154,   155,   156,   157,   158,    -1,   160,    -1,   162,   163,
     164,   165,   166,    -1,   168,   169,   170,    -1,    -1,    -1,
     174,   175,   176,   177,    -1,   179,   180,    -1,   182,   183,
     184,    -1,   186,   187,   188,   189,   190,    -1,   192,   193,
     194,   195,    -1,   197,   198,   199,   200,   201,   202,   203,
      -1,   205,    -1,   207,   208,   209,   210,   211,   212,   213,
      -1,   215,    -1,   217,    -1,    -1,   220,    -1,   222,   223,
     224,   225,   226,    -1,    -1,   229,   230,    -1,   232,    -1,
      -1,   235,   236,   237,    -1,    -1,   240,   241,   242,   243,
     244,   245,   246,   247,   248,   249,   250,   251,   252,   253,
     254,   255,   256,   257,   258,    -1,   260,   261,   262,   263,
     264,   265,   266,   267,   268,   269,   270,    -1,   272,   273,
      -1,   275,    -1,   277,   278,   279,   280,   281,   282,    -1,
     284,   285,    -1,    -1,   288,   289,   290,    -1,    -1,   293,
     294,   295,    -1,   297,    -1,   299,   300,   301,   302,   303,
     304,   305,   306,   307,   308,   309,    -1,    -1,   312,   313,
     314,   315,   316,   317,   318,   319,   320,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,   333,
     334,   335,    -1,   337,   338,   339,   340,   341,   342,   343,
     344,   345,   346,   347,   348,   349,    -1,   351,   352,    -1,
     354,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,   365,   366,   367,   368,    -1,   370,   371,   372,   373,
     374,    -1,   376,   377,   378,   379,   380,    -1,   382,   383,
     384,   385,    -1,   387,   388,   389,   390,   391,   392,   393,
     394,   395,   396,   397,   398,   399,   400,   401,    -1,   403,
     404,    -1,   406,    -1,   408,   409,   410,   411,   412,    -1,
     414,   415,   416,    -1,    -1,   419,   420,   421,   422,   423,
      -1,   425,   426,   427,   428,   429,   430,   431,   432,    -1,
     434,   435,   436,   437,   438,   439,    -1,    -1,   442,   443,
     444,   445,   446,   447,   448,    -1,   450,    -1,   452,   453,
     454,   455,    -1,    -1,   458,    -1,    -1,   461,   462,   463,
     464,   465,   466,   467,   468,   469,   470,   471,   472,   473,
     474,   475,   476,   477,   478,   479,   480,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,    25,
      26,    27,    -1,    29,    30,    31,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    39,    40,    41,    -1,    43,    44,    45,
      46,    -1,    48,    49,    50,    51,    52,    -1,    54,    55,
      -1,    57,    58,    59,    60,    61,    62,    63,    -1,    -1,
      66,    67,    68,    69,    70,    71,    72,    73,    74,    75,
      76,    -1,    -1,    -1,    80,    81,    82,    83,    84,    85,
      -1,    87,    88,    89,    90,    91,    92,    93,    94,    95,
      96,    -1,    -1,    99,   100,   101,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   109,   110,   111,   112,   113,   114,   115,
     116,   117,    -1,   119,    -1,   121,   122,   123,   124,   125,
     126,   127,    -1,   129,   130,   131,   132,    -1,    -1,   135,
     136,   137,   138,   139,    -1,   141,   142,   143,    -1,   145,
     146,   147,    -1,   149,   150,   151,   152,   153,   154,   155,
     156,   157,   158,    -1,   160,    -1,   162,   163,   164,   165,
     166,    -1,   168,   169,   170,    -1,    -1,    -1,   174,   175,
     176,   177,    -1,   179,   180,    -1,   182,   183,   184,    -1,
     186,   187,   188,   189,   190,    -1,   192,   193,   194,   195,
      -1,   197,   198,   199,   200,   201,   202,   203,    -1,   205,
      -1,   207,   208,   209,   210,   211,   212,   213,    -1,   215,
      -1,   217,    -1,    -1,   220,    -1,   222,   223,   224,   225,
     226,    -1,    -1,   229,   230,    -1,   232,   233,    -1,   235,
     236,   237,    -1,    -1,   240,   241,   242,   243,   244,   245,
     246,   247,   248,   249,   250,   251,   252,   253,   254,   255,
     256,   257,   258,    -1,   260,   261,   262,   263,   264,   265,
     266,   267,   268,   269,   270,    -1,   272,   273,    -1,   275,
      -1,   277,   278,   279,   280,   281,   282,    -1,   284,   285,
      -1,    -1,   288,   289,   290,    -1,    -1,   293,   294,   295,
      -1,   297,    -1,   299,   300,   301,   302,   303,   304,   305,
     306,   307,   308,   309,    -1,    -1,   312,   313,   314,   315,
     316,   317,   318,   319,   320,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
      -1,   337,   338,   339,   340,   341,   342,   343,   344,   345,
     346,   347,   348,   349,    -1,   351,   352,    -1,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
     366,   367,   368,    -1,   370,   371,   372,   373,   374,    -1,
     376,   377,   378,   379,   380,    -1,   382,   383,   384,   385,
      -1,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,   399,   400,   401,    -1,   403,   404,    -1,
     406,    -1,   408,   409,   410,   411,   412,    -1,   414,   415,
     416,    -1,    -1,   419,   420,   421,   422,   423,    -1,   425,
     426,   427,   428,   429,   430,   431,   432,    -1,   434,   435,
     436,   437,   438,   439,    -1,    -1,   442,   443,   444,   445,
     446,   447,   448,    -1,   450,    -1,   452,   453,   454,   455,
      -1,    -1,   458,    -1,    -1,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,   478,   479,   480,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    20,    21,    22,    23,    24,    25,    26,    27,
      28,    29,    30,    31,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    39,    40,    41,    -1,    43,    44,    45,    46,    -1,
      48,    49,    50,    51,    52,    -1,    54,    55,    -1,    57,
      58,    59,    60,    61,    62,    63,    -1,    -1,    66,    67,
      68,    69,    70,    -1,    72,    73,    74,    75,    76,    -1,
      -1,    -1,    80,    81,    82,    83,    84,    85,    -1,    87,
      88,    89,    -1,    91,    92,    93,    94,    95,    96,    97,
      -1,    99,   100,   101,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   109,   110,   111,   112,   113,   114,   115,   116,   117,
      -1,   119,    -1,   121,   122,   123,   124,   125,   126,   127,
      -1,   129,   130,   131,   132,    -1,    -1,   135,   136,   137,
     138,   139,    -1,   141,   142,   143,    -1,   145,   146,   147,
      -1,   149,   150,   151,   152,   153,   154,   155,   156,   157,
     158,    -1,   160,    -1,   162,   163,   164,   165,   166,    -1,
     168,    -1,   170,    -1,    -1,    -1,   174,   175,   176,   177,
     178,   179,   180,    -1,   182,   183,   184,    -1,   186,   187,
     188,   189,   190,    -1,   192,   193,   194,   195,    -1,   197,
     198,   199,   200,   201,   202,   203,    -1,   205,    -1,   207,
     208,   209,   210,   211,   212,   213,    -1,   215,    -1,   217,
      -1,    -1,   220,    -1,   222,   223,   224,   225,   226,    -1,
      -1,   229,   230,    -1,   232,    -1,    -1,   235,   236,   237,
      -1,    -1,   240,   241,   242,   243,   244,   245,   246,   247,
     248,   249,   250,   251,   252,   253,   254,   255,   256,   257,
     258,    -1,   260,   261,   262,   263,   264,   265,   266,   267,
     268,   269,   270,    -1,   272,   273,    -1,   275,    -1,   277,
     278,   279,   280,   281,   282,    -1,   284,   285,    -1,    -1,
     288,   289,   290,    -1,    -1,   293,   294,   295,    -1,   297,
      -1,   299,   300,   301,   302,   303,   304,   305,   306,   307,
     308,   309,    -1,    -1,   312,   313,   314,   315,   316,   317,
     318,   319,    -1,   321,   322,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,   333,   334,   335,   336,   337,
     338,   339,   340,   341,   342,   343,   344,   345,   346,   347,
     348,   349,    -1,   351,   352,    -1,   354,   355,   356,   357,
     358,   359,   360,   361,   362,   363,   364,   365,   366,   367,
     368,   369,   370,   371,   372,   373,   374,    -1,   376,   377,
     378,   379,   380,    -1,   382,   383,   384,   385,    -1,   387,
     388,   389,   390,   391,   392,   393,   394,   395,   396,   397,
     398,   399,   400,   401,    -1,   403,   404,    -1,   406,    -1,
     408,   409,   410,   411,   412,    -1,   414,   415,   416,    -1,
      -1,   419,   420,   421,   422,   423,    -1,   425,   426,   427,
     428,   429,   430,   431,   432,    -1,    -1,   435,   436,   437,
     438,   439,    -1,    -1,   442,   443,   444,   445,   446,   447,
     448,    -1,   450,    -1,   452,   453,   454,   455,    -1,    -1,
     458,    -1,    -1,   461,   462,   463,   464,   465,   466,   467,
     468,   469,   470,   471,   472,   473,   474,   475,   476,   477,
     478,   479,   480,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    29,
      30,    31,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    39,
      40,    41,    -1,    43,    44,    45,    46,    -1,    48,    49,
      50,    51,    52,    -1,    54,    55,    -1,    57,    58,    59,
      60,    61,    62,    63,    -1,    -1,    66,    67,    68,    69,
      70,    -1,    72,    73,    74,    75,    76,    -1,    -1,    -1,
      80,    81,    82,    83,    84,    85,    -1,    87,    88,    89,
      -1,    91,    92,    93,    94,    95,    96,    97,    -1,    99,
     100,   101,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   109,
     110,   111,   112,   113,   114,   115,   116,   117,    -1,   119,
      -1,   121,   122,   123,   124,   125,   126,   127,    -1,   129,
     130,   131,   132,    -1,    -1,   135,   136,   137,   138,   139,
      -1,   141,   142,   143,    -1,   145,   146,   147,    -1,   149,
     150,   151,   152,   153,   154,   155,   156,   157,   158,    -1,
     160,    -1,   162,   163,   164,   165,   166,    -1,   168,    -1,
     170,    -1,    -1,    -1,   174,   175,   176,   177,   178,   179,
     180,    -1,   182,   183,   184,    -1,   186,   187,   188,   189,
     190,    -1,   192,   193,   194,   195,    -1,   197,   198,   199,
     200,   201,   202,   203,    -1,   205,    -1,   207,   208,   209,
     210,   211,   212,   213,    -1,   215,    -1,   217,    -1,    -1,
     220,    -1,   222,   223,   224,   225,   226,    -1,    -1,   229,
     230,    -1,   232,    -1,    -1,   235,   236,   237,    -1,    -1,
     240,   241,   242,   243,   244,   245,   246,   247,   248,   249,
     250,   251,   252,   253,   254,   255,   256,   257,   258,    -1,
     260,   261,   262,   263,   264,   265,   266,   267,   268,   269,
     270,    -1,   272,   273,    -1,   275,    -1,   277,   278,   279,
     280,   281,   282,    -1,   284,   285,    -1,    -1,   288,   289,
     290,    -1,    -1,   293,   294,   295,    -1,   297,    -1,   299,
     300,   301,   302,   303,   304,   305,   306,   307,   308,   309,
      -1,    -1,   312,   313,   314,   315,   316,   317,   318,   319,
      -1,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,   344,   345,   346,   347,   348,   349,
      -1,   351,   352,    -1,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,   365,   366,   367,   368,   369,
     370,   371,   372,   373,   374,    -1,   376,   377,   378,   379,
     380,    -1,   382,   383,   384,   385,    -1,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,   399,
     400,   401,    -1,   403,   404,    -1,   406,    -1,   408,   409,
     410,   411,   412,    -1,   414,   415,   416,    -1,    -1,   419,
     420,   421,   422,   423,    -1,   425,   426,   427,   428,   429,
     430,   431,   432,    -1,    -1,   435,   436,   437,   438,   439,
      -1,    -1,   442,   443,   444,   445,   446,   447,   448,    -1,
     450,    -1,   452,   453,   454,   455,    -1,    -1,   458,    -1,
      -1,   461,   462,   463,   464,   465,   466,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,    21,
      22,    23,    24,    25,    26,    27,    -1,    29,    30,    31,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    39,    40,    41,
      -1,    43,    44,    45,    46,    -1,    48,    49,    50,    51,
      52,    -1,    54,    55,    -1,    57,    58,    59,    60,    61,
      62,    63,    -1,    -1,    66,    67,    68,    69,    70,    71,
      72,    73,    74,    75,    76,    -1,    -1,    -1,    80,    81,
      82,    83,    84,    85,    -1,    87,    88,    89,    90,    91,
      92,    93,    94,    95,    96,    -1,    -1,    99,   100,   101,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   109,   110,   111,
     112,   113,   114,   115,   116,   117,    -1,   119,    -1,   121,
     122,   123,   124,   125,   126,   127,    -1,   129,   130,   131,
     132,    -1,    -1,   135,   136,   137,   138,   139,    -1,   141,
     142,   143,    -1,   145,   146,   147,    -1,   149,   150,   151,
     152,   153,   154,   155,   156,   157,   158,    -1,   160,    -1,
     162,   163,   164,   165,   166,    -1,   168,   169,   170,    -1,
      -1,    -1,   174,   175,   176,   177,    -1,   179,   180,    -1,
     182,   183,   184,    -1,   186,   187,   188,   189,   190,    -1,
     192,   193,   194,   195,    -1,   197,   198,   199,   200,   201,
     202,   203,    -1,   205,    -1,   207,   208,   209,   210,   211,
     212,   213,    -1,   215,    -1,   217,    -1,    -1,   220,    -1,
     222,   223,   224,   225,   226,    -1,    -1,   229,   230,    -1,
     232,    -1,    -1,   235,   236,   237,    -1,    -1,   240,   241,
     242,   243,   244,   245,   246,   247,   248,   249,   250,   251,
     252,   253,   254,   255,   256,   257,   258,    -1,   260,   261,
     262,   263,   264,   265,   266,   267,   268,   269,   270,    -1,
     272,   273,    -1,   275,    -1,   277,   278,   279,   280,   281,
     282,    -1,   284,   285,    -1,    -1,   288,   289,   290,    -1,
      -1,   293,   294,   295,    -1,   297,    -1,   299,   300,   301,
     302,   303,   304,   305,   306,   307,   308,   309,    -1,    -1,
     312,   313,   314,   315,   316,   317,   318,   319,   320,   321,
     322,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,   333,   334,   335,    -1,   337,   338,   339,   340,   341,
     342,   343,   344,   345,   346,   347,   348,   349,    -1,   351,
     352,    -1,   354,   355,   356,   357,   358,   359,   360,   361,
     362,   363,   364,   365,   366,   367,   368,    -1,   370,   371,
     372,   373,   374,    -1,   376,   377,   378,   379,   380,    -1,
     382,   383,   384,   385,    -1,   387,   388,   389,   390,   391,
     392,   393,   394,   395,   396,   397,   398,   399,   400,   401,
      -1,   403,   404,    -1,   406,    -1,   408,   409,   410,   411,
     412,    -1,   414,   415,   416,    -1,    -1,   419,   420,   421,
     422,   423,    -1,   425,   426,   427,   428,   429,   430,   431,
     432,    -1,   434,   435,   436,   437,   438,   439,    -1,    -1,
     442,   443,   444,   445,   446,   447,   448,    -1,   450,    -1,
     452,   453,   454,   455,    -1,    -1,   458,    -1,    -1,   461,
     462,   463,   464,   465,   466,   467,   468,   469,   470,   471,
     472,   473,   474,   475,   476,   477,   478,   479,   480,     3,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    20,    21,    22,    23,
      24,    25,    26,    27,    28,    29,    30,    31,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    39,    40,    41,    -1,    43,
      44,    45,    46,    -1,    48,    49,    50,    51,    52,    -1,
      54,    55,    -1,    57,    58,    59,    60,    61,    62,    63,
      -1,    -1,    66,    67,    68,    69,    70,    -1,    72,    73,
      74,    75,    76,    -1,    -1,    -1,    80,    81,    82,    83,
      84,    85,    -1,    87,    88,    89,    -1,    91,    92,    93,
      94,    95,    96,    97,    -1,    99,   100,   101,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   109,   110,   111,   112,   113,
     114,   115,   116,   117,    -1,   119,    -1,   121,   122,   123,
     124,   125,   126,   127,    -1,   129,   130,   131,   132,    -1,
      -1,   135,   136,   137,   138,   139,    -1,   141,   142,   143,
      -1,   145,   146,   147,    -1,   149,   150,   151,   152,   153,
     154,   155,   156,   157,   158,    -1,   160,    -1,   162,   163,
     164,   165,   166,    -1,   168,    -1,   170,    -1,    -1,    -1,
     174,   175,   176,   177,    -1,   179,   180,    -1,   182,   183,
     184,    -1,   186,   187,   188,   189,   190,    -1,   192,   193,
     194,   195,    -1,   197,   198,   199,   200,   201,   202,   203,
      -1,   205,    -1,   207,   208,   209,   210,   211,   212,   213,
      -1,   215,    -1,   217,    -1,    -1,   220,    -1,   222,   223,
     224,   225,   226,    -1,    -1,   229,   230,    -1,   232,    -1,
      -1,   235,   236,   237,    -1,    -1,   240,   241,   242,   243,
     244,   245,   246,   247,   248,   249,   250,   251,   252,   253,
     254,   255,   256,   257,   258,    -1,   260,   261,   262,   263,
     264,   265,   266,   267,   268,   269,   270,    -1,   272,   273,
      -1,   275,    -1,   277,   278,   279,   280,   281,   282,    -1,
     284,   285,    -1,    -1,   288,   289,   290,    -1,    -1,   293,
     294,   295,    -1,   297,    -1,   299,   300,   301,   302,   303,
     304,   305,   306,   307,   308,   309,    -1,    -1,   312,   313,
     314,   315,   316,   317,   318,   319,    -1,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,   333,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
     344,   345,   346,   347,   348,   349,    -1,   351,   352,    -1,
     354,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,   365,   366,   367,   368,   369,   370,   371,   372,   373,
     374,    -1,   376,   377,   378,   379,   380,    -1,   382,   383,
     384,   385,    -1,   387,   388,   389,   390,   391,   392,   393,
     394,   395,   396,   397,   398,   399,   400,   401,    -1,   403,
     404,    -1,   406,    -1,   408,   409,   410,   411,   412,    -1,
     414,   415,   416,    -1,    -1,   419,   420,   421,   422,   423,
      -1,   425,   426,   427,   428,   429,   430,   431,   432,    -1,
      -1,   435,   436,   437,   438,   439,    -1,    -1,   442,   443,
     444,   445,   446,   447,   448,    -1,   450,    -1,   452,   453,
     454,   455,    -1,    -1,   458,    -1,    -1,   461,   462,   463,
     464,   465,   466,   467,   468,   469,   470,   471,   472,   473,
     474,   475,   476,   477,   478,   479,   480,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,    25,
      26,    27,    28,    29,    30,    31,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    39,    40,    41,    -1,    43,    44,    45,
      46,    -1,    48,    49,    50,    51,    52,    -1,    54,    55,
      -1,    57,    58,    59,    60,    61,    62,    63,    -1,    -1,
      66,    67,    68,    69,    70,    -1,    72,    73,    74,    75,
      76,    -1,    -1,    -1,    80,    81,    82,    83,    84,    85,
      -1,    87,    88,    89,    -1,    91,    92,    93,    94,    95,
      96,    -1,    -1,    99,   100,   101,    -1,    -1,    -1,   105,
      -1,    -1,    -1,   109,   110,   111,   112,   113,   114,   115,
     116,   117,    -1,   119,    -1,   121,   122,   123,   124,   125,
     126,   127,    -1,   129,   130,   131,   132,    -1,    -1,   135,
     136,   137,   138,   139,    -1,   141,   142,   143,    -1,   145,
     146,   147,    -1,   149,   150,   151,   152,   153,   154,   155,
     156,   157,   158,    -1,   160,    -1,   162,   163,   164,   165,
     166,    -1,   168,    -1,   170,    -1,    -1,    -1,   174,   175,
     176,   177,    -1,   179,   180,    -1,   182,   183,   184,    -1,
     186,   187,   188,   189,   190,    -1,   192,   193,   194,   195,
      -1,   197,   198,   199,   200,   201,   202,   203,    -1,   205,
      -1,   207,   208,   209,   210,   211,   212,   213,    -1,   215,
      -1,   217,    -1,    -1,   220,    -1,   222,   223,   224,   225,
     226,    -1,    -1,   229,   230,    -1,   232,    -1,    -1,   235,
     236,   237,    -1,    -1,   240,   241,   242,   243,   244,   245,
     246,   247,   248,   249,   250,   251,   252,   253,   254,   255,
     256,   257,   258,    -1,   260,   261,   262,   263,   264,   265,
     266,   267,   268,   269,   270,    -1,   272,   273,    -1,   275,
      -1,   277,   278,   279,   280,   281,   282,    -1,   284,   285,
      -1,   287,   288,   289,   290,    -1,    -1,   293,   294,   295,
      -1,   297,    -1,   299,   300,   301,   302,   303,   304,   305,
     306,   307,   308,   309,    -1,    -1,   312,   313,   314,   315,
     316,   317,   318,   319,    -1,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
      -1,   337,   338,   339,   340,   341,   342,   343,   344,   345,
     346,   347,   348,   349,    -1,   351,   352,    -1,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
     366,   367,   368,    -1,   370,   371,   372,   373,   374,    -1,
     376,   377,   378,   379,   380,    -1,   382,   383,   384,   385,
      -1,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,   399,   400,   401,    -1,   403,   404,   405,
     406,    -1,   408,   409,   410,   411,   412,    -1,   414,   415,
     416,    -1,    -1,   419,   420,   421,   422,   423,    -1,   425,
     426,   427,   428,   429,   430,   431,   432,    -1,    -1,   435,
     436,   437,   438,   439,    -1,    -1,   442,   443,   444,   445,
     446,   447,   448,    -1,   450,    -1,   452,   453,   454,   455,
      -1,    -1,   458,    -1,    -1,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,   478,   479,   480,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    20,    21,    22,    23,    24,    25,    26,    27,
      28,    29,    30,    31,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    39,    40,    41,    -1,    43,    44,    45,    46,    -1,
      48,    49,    50,    51,    52,    -1,    54,    55,    -1,    57,
      58,    59,    60,    61,    62,    63,    -1,    -1,    66,    67,
      68,    69,    70,    -1,    72,    73,    74,    75,    76,    -1,
      -1,    -1,    80,    81,    82,    83,    84,    85,    -1,    87,
      88,    89,    -1,    91,    92,    93,    94,    95,    96,    -1,
      -1,    99,   100,   101,    -1,    -1,    -1,   105,    -1,    -1,
      -1,   109,   110,   111,   112,   113,   114,   115,   116,   117,
      -1,   119,    -1,   121,   122,   123,   124,   125,   126,   127,
      -1,   129,   130,   131,   132,    -1,    -1,   135,   136,   137,
     138,   139,    -1,   141,   142,   143,    -1,   145,   146,   147,
      -1,   149,   150,   151,   152,   153,   154,   155,   156,   157,
     158,    -1,   160,    -1,   162,   163,   164,   165,   166,    -1,
     168,    -1,   170,    -1,    -1,    -1,   174,   175,   176,   177,
      -1,   179,   180,    -1,   182,   183,   184,    -1,   186,   187,
     188,   189,   190,    -1,   192,   193,   194,   195,    -1,   197,
     198,   199,   200,   201,   202,   203,    -1,   205,    -1,   207,
     208,   209,   210,   211,   212,   213,    -1,   215,    -1,   217,
      -1,    -1,   220,    -1,   222,   223,   224,   225,   226,    -1,
      -1,   229,   230,    -1,   232,    -1,    -1,   235,   236,   237,
      -1,    -1,   240,   241,   242,   243,   244,   245,   246,   247,
     248,   249,   250,   251,   252,   253,   254,   255,   256,   257,
     258,    -1,   260,   261,   262,   263,   264,   265,   266,   267,
     268,   269,   270,    -1,   272,   273,    -1,   275,    -1,   277,
     278,   279,   280,   281,   282,    -1,   284,   285,    -1,   287,
     288,   289,   290,    -1,    -1,   293,   294,   295,    -1,   297,
      -1,   299,   300,   301,   302,   303,   304,   305,   306,   307,
     308,   309,    -1,    -1,   312,   313,   314,   315,   316,   317,
     318,   319,    -1,   321,   322,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,   333,   334,   335,    -1,   337,
     338,   339,   340,   341,   342,   343,   344,   345,   346,   347,
     348,   349,    -1,   351,   352,    -1,   354,   355,   356,   357,
     358,   359,   360,   361,   362,   363,   364,   365,   366,   367,
     368,    -1,   370,   371,   372,   373,   374,    -1,   376,   377,
     378,   379,   380,    -1,   382,   383,   384,   385,    -1,   387,
     388,   389,   390,   391,   392,   393,   394,   395,   396,   397,
     398,   399,   400,   401,    -1,   403,   404,   405,   406,    -1,
     408,   409,   410,   411,   412,    -1,   414,   415,   416,    -1,
      -1,   419,   420,   421,   422,   423,    -1,   425,   426,   427,
     428,   429,   430,   431,   432,    -1,    -1,   435,   436,   437,
     438,   439,    -1,    -1,   442,   443,   444,   445,   446,   447,
     448,    -1,   450,    -1,   452,   453,   454,   455,    -1,    -1,
     458,    -1,    -1,   461,   462,   463,   464,   465,   466,   467,
     468,   469,   470,   471,   472,   473,   474,   475,   476,   477,
     478,   479,   480,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    29,
      30,    31,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    39,
      40,    41,    -1,    43,    44,    45,    46,    -1,    48,    49,
      50,    51,    52,    -1,    54,    55,    -1,    57,    58,    59,
      60,    61,    62,    63,    -1,    -1,    66,    67,    68,    69,
      70,    -1,    72,    73,    74,    75,    76,    -1,    -1,    -1,
      80,    81,    82,    83,    84,    85,    -1,    87,    88,    89,
      -1,    91,    92,    93,    94,    95,    96,    -1,    -1,    99,
     100,   101,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   109,
     110,   111,   112,   113,   114,   115,   116,   117,    -1,   119,
      -1,   121,   122,   123,   124,   125,   126,   127,    -1,   129,
     130,   131,   132,    -1,    -1,   135,   136,   137,   138,   139,
      -1,   141,   142,   143,    -1,   145,   146,   147,    -1,   149,
     150,   151,   152,   153,   154,   155,   156,   157,   158,    -1,
     160,    -1,   162,   163,   164,   165,   166,    -1,   168,   169,
     170,    -1,    -1,    -1,   174,   175,   176,   177,    -1,   179,
     180,    -1,   182,   183,   184,    -1,   186,   187,   188,   189,
     190,    -1,   192,   193,   194,   195,    -1,   197,   198,   199,
     200,   201,   202,   203,    -1,   205,    -1,   207,   208,   209,
     210,   211,   212,   213,    -1,   215,    -1,   217,    -1,    -1,
     220,    -1,   222,   223,   224,   225,   226,    -1,    -1,   229,
     230,    -1,   232,    -1,    -1,   235,   236,   237,    -1,    -1,
     240,   241,   242,   243,   244,   245,   246,   247,   248,   249,
     250,   251,   252,   253,   254,   255,   256,   257,   258,    -1,
     260,   261,   262,   263,   264,   265,   266,   267,   268,   269,
     270,    -1,   272,   273,    -1,   275,    -1,   277,   278,   279,
     280,   281,   282,    -1,   284,   285,    -1,    -1,   288,   289,
     290,    -1,    -1,   293,   294,   295,    -1,   297,    -1,   299,
     300,   301,   302,   303,   304,   305,   306,   307,   308,   309,
      -1,    -1,   312,   313,   314,   315,   316,   317,   318,   319,
      -1,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,    -1,   337,   338,   339,
     340,   341,   342,   343,   344,   345,   346,   347,   348,   349,
      -1,   351,   352,    -1,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,   365,   366,   367,   368,    -1,
     370,   371,   372,   373,   374,    -1,   376,   377,   378,   379,
     380,    -1,   382,   383,   384,   385,    -1,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,   399,
     400,   401,    -1,   403,   404,   405,   406,    -1,   408,   409,
     410,   411,   412,    -1,   414,   415,   416,    -1,    -1,   419,
     420,   421,   422,   423,    -1,   425,   426,   427,   428,   429,
     430,   431,   432,    -1,    -1,   435,   436,   437,   438,   439,
      -1,    -1,   442,   443,   444,   445,   446,   447,   448,    -1,
     450,    -1,   452,   453,   454,   455,    -1,    -1,   458,    -1,
      -1,   461,   462,   463,   464,   465,   466,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,    21,
      22,    23,    24,    25,    26,    27,    -1,    29,    30,    31,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    39,    40,    41,
      -1,    43,    44,    45,    46,    -1,    48,    49,    50,    51,
      52,    -1,    54,    55,    -1,    57,    58,    59,    60,    61,
      62,    63,    -1,    -1,    66,    67,    68,    69,    70,    -1,
      72,    73,    74,    75,    76,    -1,    -1,    -1,    80,    81,
      82,    83,    84,    85,    -1,    87,    88,    89,    -1,    91,
      92,    93,    94,    95,    96,    97,    -1,    99,   100,   101,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   109,   110,   111,
     112,   113,   114,   115,   116,   117,    -1,   119,    -1,   121,
     122,   123,   124,   125,   126,   127,    -1,   129,   130,   131,
     132,    -1,    -1,   135,   136,   137,   138,   139,    -1,   141,
     142,   143,    -1,   145,   146,   147,    -1,   149,   150,   151,
     152,   153,   154,   155,   156,   157,   158,    -1,   160,    -1,
     162,   163,   164,   165,   166,    -1,   168,    -1,   170,    -1,
      -1,    -1,   174,   175,   176,   177,    -1,   179,   180,    -1,
     182,   183,   184,    -1,   186,   187,   188,   189,   190,    -1,
     192,   193,   194,   195,    -1,   197,   198,   199,   200,   201,
     202,   203,    -1,   205,    -1,   207,   208,   209,   210,   211,
     212,   213,    -1,   215,    -1,   217,    -1,    -1,   220,    -1,
     222,   223,   224,   225,   226,    -1,    -1,   229,   230,    -1,
     232,    -1,    -1,   235,   236,   237,    -1,    -1,   240,   241,
     242,   243,   244,   245,   246,   247,   248,   249,   250,   251,
     252,   253,   254,   255,   256,   257,   258,    -1,   260,   261,
     262,   263,   264,   265,   266,   267,   268,   269,   270,    -1,
     272,   273,    -1,   275,    -1,   277,   278,   279,   280,   281,
     282,    -1,   284,   285,    -1,    -1,   288,   289,   290,    -1,
      -1,   293,   294,   295,    -1,   297,    -1,   299,   300,   301,
     302,   303,   304,   305,   306,   307,   308,   309,    -1,    -1,
     312,   313,   314,   315,   316,   317,   318,   319,    -1,   321,
     322,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,   333,   334,   335,   336,   337,   338,   339,   340,   341,
     342,   343,   344,   345,   346,   347,   348,   349,    -1,   351,
     352,    -1,   354,   355,   356,   357,   358,   359,   360,   361,
     362,   363,   364,   365,   366,   367,   368,   369,   370,   371,
     372,   373,   374,    -1,   376,   377,   378,   379,   380,    -1,
     382,   383,   384,   385,    -1,   387,   388,   389,   390,   391,
     392,   393,   394,   395,   396,   397,   398,   399,   400,   401,
      -1,   403,   404,    -1,   406,    -1,   408,   409,   410,   411,
     412,    -1,   414,   415,   416,    -1,    -1,   419,   420,   421,
     422,   423,    -1,   425,   426,   427,   428,   429,   430,   431,
     432,    -1,    -1,   435,   436,   437,   438,   439,    -1,    -1,
     442,   443,   444,   445,   446,   447,   448,    -1,   450,    -1,
     452,   453,   454,   455,    -1,    -1,   458,    -1,    -1,   461,
     462,   463,   464,   465,   466,   467,   468,   469,   470,   471,
     472,   473,   474,   475,   476,   477,   478,   479,   480,     3,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    20,    21,    22,    23,
      24,    25,    26,    27,    28,    29,    30,    31,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    39,    40,    41,    -1,    43,
      44,    45,    46,    -1,    48,    49,    50,    51,    52,    -1,
      54,    55,    -1,    57,    58,    59,    60,    61,    62,    63,
      -1,    -1,    66,    67,    68,    69,    70,    -1,    72,    73,
      74,    75,    76,    -1,    -1,    -1,    80,    81,    82,    83,
      84,    85,    -1,    87,    88,    89,    -1,    91,    92,    93,
      94,    95,    96,    -1,    -1,    99,   100,   101,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   109,   110,   111,   112,   113,
     114,   115,   116,   117,    -1,   119,    -1,   121,   122,   123,
     124,   125,   126,   127,    -1,   129,   130,   131,   132,    -1,
      -1,   135,   136,   137,   138,   139,    -1,   141,   142,   143,
      -1,   145,   146,   147,    -1,   149,   150,   151,   152,   153,
     154,   155,   156,   157,   158,    -1,   160,    -1,   162,   163,
     164,   165,   166,    -1,   168,    -1,   170,    -1,    -1,    -1,
     174,   175,   176,   177,    -1,   179,   180,    -1,   182,   183,
     184,    -1,   186,   187,   188,   189,   190,    -1,   192,   193,
     194,   195,    -1,   197,   198,   199,   200,   201,   202,   203,
      -1,   205,    -1,   207,   208,   209,   210,   211,   212,   213,
      -1,   215,    -1,   217,    -1,    -1,   220,    -1,   222,   223,
     224,   225,   226,    -1,    -1,   229,   230,    -1,   232,    -1,
      -1,   235,   236,   237,    -1,    -1,   240,   241,   242,   243,
     244,   245,   246,   247,   248,   249,   250,   251,   252,   253,
     254,   255,   256,   257,   258,    -1,   260,   261,   262,   263,
     264,   265,   266,   267,   268,   269,   270,    -1,   272,   273,
      -1,   275,    -1,   277,   278,   279,   280,   281,   282,    -1,
     284,   285,    -1,   287,   288,   289,   290,    -1,    -1,   293,
     294,   295,    -1,   297,    -1,   299,   300,   301,   302,   303,
     304,   305,   306,   307,   308,   309,    -1,    -1,   312,   313,
     314,   315,   316,   317,   318,   319,    -1,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,   333,
     334,   335,    -1,   337,   338,   339,   340,   341,   342,   343,
     344,   345,   346,   347,   348,   349,    -1,   351,   352,    -1,
     354,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,   365,   366,   367,   368,    -1,   370,   371,   372,   373,
     374,    -1,   376,   377,   378,   379,   380,    -1,   382,   383,
     384,   385,    -1,   387,   388,   389,   390,   391,   392,   393,
     394,   395,   396,   397,   398,   399,   400,   401,    -1,   403,
     404,    -1,   406,    -1,   408,   409,   410,   411,   412,    -1,
     414,   415,   416,    -1,    -1,   419,   420,   421,   422,   423,
      -1,   425,   426,   427,   428,   429,   430,   431,   432,    -1,
      -1,   435,   436,   437,   438,   439,    -1,    -1,   442,   443,
     444,   445,   446,   447,   448,    -1,   450,    -1,   452,   453,
     454,   455,    -1,    -1,   458,    -1,    -1,   461,   462,   463,
     464,   465,   466,   467,   468,   469,   470,   471,   472,   473,
     474,   475,   476,   477,   478,   479,   480,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,    25,
      26,    27,    28,    29,    30,    31,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    39,    40,    41,    -1,    43,    44,    45,
      46,    -1,    48,    49,    50,    51,    52,    -1,    54,    55,
      -1,    57,    58,    59,    60,    61,    62,    63,    -1,    -1,
      66,    67,    68,    69,    70,    -1,    72,    73,    74,    75,
      76,    -1,    -1,    -1,    80,    81,    82,    83,    84,    85,
      -1,    87,    88,    89,    -1,    91,    92,    93,    94,    95,
      96,    -1,    -1,    99,   100,   101,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   109,   110,   111,   112,   113,   114,   115,
     116,   117,    -1,   119,    -1,   121,   122,   123,   124,   125,
     126,   127,    -1,   129,   130,   131,   132,    -1,    -1,   135,
     136,   137,   138,   139,    -1,   141,   142,   143,    -1,   145,
     146,   147,    -1,   149,   150,   151,   152,   153,   154,   155,
     156,   157,   158,    -1,   160,    -1,   162,   163,   164,   165,
     166,    -1,   168,    -1,   170,    -1,    -1,    -1,   174,   175,
     176,   177,    -1,   179,   180,    -1,   182,   183,   184,    -1,
     186,   187,   188,   189,   190,    -1,   192,   193,   194,   195,
      -1,   197,   198,   199,   200,   201,   202,   203,    -1,   205,
      -1,   207,   208,   209,   210,   211,   212,   213,    -1,   215,
      -1,   217,    -1,    -1,   220,    -1,   222,   223,   224,   225,
     226,    -1,    -1,   229,   230,    -1,   232,    -1,    -1,   235,
     236,   237,    -1,    -1,   240,   241,   242,   243,   244,   245,
     246,   247,   248,   249,   250,   251,   252,   253,   254,   255,
     256,   257,   258,    -1,   260,   261,   262,   263,   264,   265,
     266,   267,   268,   269,   270,    -1,   272,   273,    -1,   275,
      -1,   277,   278,   279,   280,   281,   282,    -1,   284,   285,
      -1,    -1,   288,   289,   290,    -1,    -1,   293,   294,   295,
      -1,   297,    -1,   299,   300,   301,   302,   303,   304,   305,
     306,   307,   308,   309,    -1,    -1,   312,   313,   314,   315,
     316,   317,   318,   319,    -1,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
      -1,   337,   338,   339,   340,   341,   342,   343,   344,   345,
     346,   347,   348,   349,    -1,   351,   352,    -1,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
     366,   367,   368,    -1,   370,   371,   372,   373,   374,    -1,
     376,   377,   378,   379,   380,    -1,   382,   383,   384,   385,
      -1,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,   399,   400,   401,    -1,   403,   404,    -1,
     406,    -1,   408,   409,   410,   411,   412,    -1,   414,   415,
     416,    -1,    -1,   419,   420,   421,   422,   423,    -1,   425,
     426,   427,   428,   429,   430,   431,   432,    -1,    -1,   435,
     436,   437,   438,   439,   440,    -1,   442,   443,   444,   445,
     446,   447,   448,    -1,   450,    -1,   452,   453,   454,   455,
      -1,    -1,   458,    -1,    -1,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,   478,   479,   480,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    20,    21,    22,    23,    24,    25,    26,    27,
      28,    29,    30,    31,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    39,    40,    41,    -1,    43,    44,    45,    46,    -1,
      48,    49,    50,    51,    52,    -1,    54,    55,    -1,    57,
      58,    59,    60,    61,    62,    63,    -1,    -1,    66,    67,
      68,    69,    70,    -1,    72,    73,    74,    75,    76,    -1,
      -1,    -1,    80,    81,    82,    83,    84,    85,    -1,    87,
      88,    89,    -1,    91,    92,    93,    94,    95,    96,    -1,
      -1,    99,   100,   101,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   109,   110,   111,   112,   113,   114,   115,   116,   117,
      -1,   119,    -1,   121,   122,   123,   124,   125,   126,   127,
      -1,   129,   130,   131,   132,    -1,    -1,   135,   136,   137,
     138,   139,    -1,   141,   142,   143,    -1,   145,   146,   147,
      -1,   149,   150,   151,   152,   153,   154,   155,   156,   157,
     158,    -1,   160,    -1,   162,   163,   164,   165,   166,    -1,
     168,    -1,   170,    -1,    -1,    -1,   174,   175,   176,   177,
      -1,   179,   180,    -1,   182,   183,   184,    -1,   186,   187,
     188,   189,   190,    -1,   192,   193,   194,   195,    -1,   197,
     198,   199,   200,   201,   202,   203,    -1,   205,    -1,   207,
     208,   209,   210,   211,   212,   213,    -1,   215,    -1,   217,
      -1,    -1,   220,    -1,   222,   223,   224,   225,   226,    -1,
      -1,   229,   230,    -1,   232,    -1,    -1,   235,   236,   237,
      -1,    -1,   240,   241,   242,   243,   244,   245,   246,   247,
     248,   249,   250,   251,   252,   253,   254,   255,   256,   257,
     258,    -1,   260,   261,   262,   263,   264,   265,   266,   267,
     268,   269,   270,    -1,   272,   273,    -1,   275,    -1,   277,
     278,   279,   280,   281,   282,    -1,   284,   285,    -1,    -1,
     288,   289,   290,    -1,    -1,   293,   294,   295,    -1,   297,
      -1,   299,   300,   301,   302,   303,   304,   305,   306,   307,
     308,   309,    -1,    -1,   312,   313,   314,   315,   316,   317,
     318,   319,    -1,   321,   322,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,   333,   334,   335,    -1,   337,
     338,   339,   340,   341,   342,   343,   344,   345,   346,   347,
     348,   349,    -1,   351,   352,    -1,   354,   355,   356,   357,
     358,   359,   360,   361,   362,   363,   364,   365,   366,   367,
     368,    -1,   370,   371,   372,   373,   374,    -1,   376,   377,
     378,   379,   380,    -1,   382,   383,   384,   385,    -1,   387,
     388,   389,   390,   391,   392,   393,   394,   395,   396,   397,
     398,   399,   400,   401,    -1,   403,   404,    -1,   406,    -1,
     408,   409,   410,   411,   412,    -1,   414,   415,   416,    -1,
      -1,   419,   420,   421,   422,   423,    -1,   425,   426,   427,
     428,   429,   430,   431,   432,    -1,    -1,   435,   436,   437,
     438,   439,   440,    -1,   442,   443,   444,   445,   446,   447,
     448,    -1,   450,    -1,   452,   453,   454,   455,    -1,    -1,
     458,    -1,    -1,   461,   462,   463,   464,   465,   466,   467,
     468,   469,   470,   471,   472,   473,   474,   475,   476,   477,
     478,   479,   480,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    29,
      30,    31,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    39,
      40,    41,    -1,    43,    44,    45,    46,    -1,    48,    49,
      50,    51,    52,    -1,    54,    55,    -1,    57,    58,    59,
      60,    61,    62,    63,    -1,    -1,    66,    67,    68,    69,
      70,    -1,    72,    73,    74,    75,    76,    -1,    -1,    -1,
      80,    81,    82,    83,    84,    85,    -1,    87,    88,    89,
      -1,    91,    92,    93,    94,    95,    96,    -1,    -1,    99,
     100,   101,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   109,
     110,   111,   112,   113,   114,   115,   116,   117,    -1,   119,
      -1,   121,   122,   123,   124,   125,   126,   127,    -1,   129,
     130,   131,   132,    -1,    -1,   135,   136,   137,   138,   139,
      -1,   141,   142,   143,    -1,   145,   146,   147,    -1,   149,
     150,   151,   152,   153,   154,   155,   156,   157,   158,    -1,
     160,    -1,   162,   163,   164,   165,   166,    -1,   168,    -1,
     170,    -1,    -1,    -1,   174,   175,   176,   177,    -1,   179,
     180,    -1,   182,   183,   184,    -1,   186,   187,   188,   189,
     190,    -1,   192,   193,   194,   195,    -1,   197,   198,   199,
     200,   201,   202,   203,    -1,   205,    -1,   207,   208,   209,
     210,   211,   212,   213,    -1,   215,    -1,   217,    -1,    -1,
     220,    -1,   222,   223,   224,   225,   226,    -1,    -1,   229,
     230,    -1,   232,    -1,    -1,   235,   236,   237,    -1,    -1,
     240,   241,   242,   243,   244,   245,   246,   247,   248,   249,
     250,   251,   252,   253,   254,   255,   256,   257,   258,    -1,
     260,   261,   262,   263,   264,   265,   266,   267,   268,   269,
     270,    -1,   272,   273,    -1,   275,    -1,   277,   278,   279,
     280,   281,   282,    -1,   284,   285,    -1,    -1,   288,   289,
     290,    -1,    -1,   293,   294,   295,    -1,   297,    -1,   299,
     300,   301,   302,   303,   304,   305,   306,   307,   308,   309,
      -1,    -1,   312,   313,   314,   315,   316,   317,   318,   319,
      -1,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,    -1,   337,   338,   339,
     340,   341,   342,   343,   344,   345,   346,   347,   348,   349,
      -1,   351,   352,    -1,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,   365,   366,   367,   368,    -1,
     370,   371,   372,   373,   374,    -1,   376,   377,   378,   379,
     380,    -1,   382,   383,   384,   385,    -1,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,   399,
     400,   401,    -1,   403,   404,    -1,   406,    -1,   408,   409,
     410,   411,   412,    -1,   414,   415,   416,    -1,    -1,   419,
     420,   421,   422,   423,    -1,   425,   426,   427,   428,   429,
     430,   431,   432,    -1,    -1,   435,   436,   437,   438,   439,
      -1,    -1,   442,   443,   444,   445,   446,   447,   448,    -1,
     450,    -1,   452,   453,   454,   455,    -1,    -1,   458,    -1,
      -1,   461,   462,   463,   464,   465,   466,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,    21,
      22,    23,    24,    25,    26,    27,    28,    29,    30,    31,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    39,    40,    41,
      -1,    43,    44,    45,    46,    -1,    48,    49,    50,    51,
      52,    -1,    54,    55,    -1,    57,    58,    59,    60,    61,
      62,    63,    -1,    -1,    66,    67,    68,    69,    70,    -1,
      72,    73,    74,    75,    76,    -1,    -1,    -1,    80,    81,
      82,    83,    84,    85,    -1,    87,    88,    89,    -1,    91,
      92,    93,    94,    95,    96,    -1,    -1,    99,   100,   101,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   109,   110,   111,
     112,   113,   114,   115,   116,   117,    -1,   119,    -1,   121,
     122,   123,   124,   125,   126,   127,    -1,   129,   130,   131,
     132,    -1,    -1,   135,   136,   137,   138,   139,    -1,   141,
     142,   143,    -1,   145,   146,   147,    -1,   149,   150,   151,
     152,   153,   154,   155,   156,   157,   158,    -1,   160,    -1,
     162,   163,   164,   165,   166,    -1,   168,    -1,   170,    -1,
      -1,    -1,   174,   175,   176,   177,    -1,   179,   180,    -1,
     182,   183,   184,    -1,   186,   187,   188,   189,   190,    -1,
     192,   193,   194,   195,    -1,   197,   198,   199,   200,   201,
     202,   203,    -1,   205,    -1,   207,   208,   209,   210,   211,
     212,   213,    -1,   215,    -1,   217,    -1,    -1,   220,    -1,
     222,   223,   224,   225,   226,    -1,    -1,   229,   230,    -1,
     232,    -1,    -1,   235,   236,   237,    -1,    -1,   240,   241,
     242,   243,   244,   245,   246,   247,   248,   249,   250,   251,
     252,   253,   254,   255,   256,   257,   258,    -1,   260,   261,
     262,   263,   264,   265,   266,   267,   268,   269,   270,    -1,
     272,   273,    -1,   275,    -1,   277,   278,   279,   280,   281,
     282,    -1,   284,   285,    -1,    -1,   288,   289,   290,    -1,
      -1,   293,   294,   295,    -1,   297,    -1,   299,   300,   301,
     302,   303,   304,   305,   306,   307,   308,   309,    -1,    -1,
     312,   313,   314,   315,   316,   317,   318,   319,    -1,   321,
     322,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,   333,   334,   335,    -1,   337,   338,   339,   340,   341,
     342,   343,   344,   345,   346,   347,   348,   349,    -1,   351,
     352,    -1,   354,   355,   356,   357,   358,   359,   360,   361,
     362,   363,   364,   365,   366,   367,   368,    -1,   370,   371,
     372,   373,   374,    -1,   376,   377,   378,   379,   380,    -1,
     382,   383,   384,   385,    -1,   387,   388,   389,   390,   391,
     392,   393,   394,   395,   396,   397,   398,   399,   400,   401,
      -1,   403,   404,    -1,   406,    -1,   408,   409,   410,   411,
     412,    -1,   414,   415,   416,    -1,    -1,   419,   420,   421,
     422,   423,    -1,   425,   426,   427,   428,   429,   430,   431,
     432,    -1,    -1,   435,   436,   437,   438,   439,    -1,    -1,
     442,   443,   444,   445,   446,   447,   448,    -1,   450,    -1,
     452,   453,   454,   455,    -1,    -1,   458,    -1,    -1,   461,
     462,   463,   464,   465,   466,   467,   468,   469,   470,   471,
     472,   473,   474,   475,   476,   477,   478,   479,   480,     3,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    20,    21,    22,    23,
      24,    25,    26,    27,    28,    29,    30,    31,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    39,    40,    41,    -1,    43,
      44,    45,    46,    -1,    48,    49,    50,    51,    52,    -1,
      54,    55,    -1,    57,    58,    59,    60,    61,    62,    63,
      -1,    -1,    66,    67,    68,    69,    70,    -1,    72,    73,
      74,    75,    76,    -1,    -1,    -1,    80,    81,    82,    83,
      84,    85,    -1,    87,    88,    89,    -1,    91,    92,    93,
      94,    95,    96,    -1,    -1,    99,   100,   101,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   109,   110,   111,   112,   113,
     114,   115,   116,   117,    -1,   119,    -1,   121,   122,   123,
     124,   125,   126,   127,    -1,   129,   130,   131,   132,    -1,
      -1,   135,   136,   137,   138,   139,    -1,   141,   142,   143,
      -1,   145,   146,   147,    -1,   149,   150,   151,   152,   153,
     154,   155,   156,   157,   158,    -1,   160,    -1,   162,   163,
     164,   165,   166,    -1,   168,    -1,   170,    -1,    -1,    -1,
     174,   175,   176,   177,    -1,   179,   180,    -1,   182,   183,
     184,    -1,   186,   187,   188,   189,   190,    -1,   192,   193,
     194,   195,    -1,   197,   198,   199,   200,   201,   202,   203,
      -1,   205,    -1,   207,   208,   209,   210,   211,   212,   213,
      -1,   215,    -1,   217,    -1,    -1,   220,    -1,   222,   223,
     224,   225,   226,    -1,    -1,   229,   230,    -1,   232,    -1,
      -1,   235,   236,   237,    -1,    -1,   240,   241,   242,   243,
     244,   245,   246,   247,   248,   249,   250,   251,   252,   253,
     254,   255,   256,   257,   258,    -1,   260,   261,   262,   263,
     264,   265,   266,   267,   268,   269,   270,    -1,   272,   273,
      -1,   275,    -1,   277,   278,   279,   280,   281,   282,    -1,
     284,   285,    -1,    -1,   288,   289,   290,    -1,    -1,   293,
     294,   295,    -1,   297,    -1,   299,   300,   301,   302,   303,
     304,   305,   306,   307,   308,   309,    -1,    -1,   312,   313,
     314,   315,   316,   317,   318,   319,    -1,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,   333,
     334,   335,    -1,   337,   338,   339,   340,   341,   342,   343,
     344,   345,   346,   347,   348,   349,    -1,   351,   352,    -1,
     354,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,   365,   366,   367,   368,    -1,   370,   371,   372,   373,
     374,    -1,   376,   377,   378,   379,   380,    -1,   382,   383,
     384,   385,    -1,   387,   388,   389,   390,   391,   392,   393,
     394,   395,   396,   397,   398,   399,   400,   401,    -1,   403,
     404,    -1,   406,    -1,   408,   409,   410,   411,   412,    -1,
     414,   415,   416,    -1,    -1,   419,   420,   421,   422,   423,
      -1,   425,   426,   427,   428,   429,   430,   431,   432,    -1,
      -1,   435,   436,   437,   438,   439,    -1,    -1,   442,   443,
     444,   445,   446,   447,   448,    -1,   450,    -1,   452,   453,
     454,   455,    -1,    -1,   458,    -1,    -1,   461,   462,   463,
     464,   465,   466,   467,   468,   469,   470,   471,   472,   473,
     474,   475,   476,   477,   478,   479,   480,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,    25,
      26,    27,    28,    29,    30,    31,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    39,    40,    41,    -1,    43,    44,    45,
      46,    -1,    48,    49,    50,    51,    52,    -1,    54,    55,
      -1,    57,    58,    59,    60,    61,    62,    63,    -1,    -1,
      66,    67,    68,    69,    70,    -1,    72,    73,    74,    75,
      76,    -1,    -1,    -1,    80,    81,    82,    83,    84,    85,
      -1,    87,    88,    89,    -1,    91,    92,    93,    94,    95,
      96,    -1,    -1,    99,   100,   101,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   109,   110,   111,   112,   113,   114,   115,
     116,   117,    -1,   119,    -1,   121,   122,   123,   124,   125,
     126,   127,    -1,   129,   130,   131,   132,    -1,    -1,   135,
     136,   137,   138,   139,    -1,   141,   142,   143,    -1,   145,
     146,   147,    -1,   149,   150,   151,   152,   153,   154,   155,
     156,   157,   158,    -1,   160,    -1,   162,   163,   164,   165,
     166,    -1,   168,    -1,   170,    -1,    -1,    -1,   174,   175,
     176,   177,    -1,   179,   180,    -1,   182,   183,   184,    -1,
     186,   187,   188,   189,   190,    -1,   192,   193,   194,   195,
      -1,   197,   198,   199,   200,   201,   202,   203,    -1,   205,
      -1,   207,   208,   209,   210,   211,   212,   213,    -1,   215,
      -1,   217,    -1,    -1,   220,    -1,   222,   223,   224,   225,
     226,    -1,    -1,   229,   230,    -1,   232,    -1,    -1,   235,
     236,   237,    -1,    -1,   240,   241,   242,   243,   244,   245,
     246,   247,   248,   249,   250,   251,   252,   253,   254,   255,
     256,   257,   258,    -1,   260,   261,   262,   263,   264,   265,
     266,   267,   268,   269,   270,    -1,   272,   273,    -1,   275,
      -1,   277,   278,   279,   280,   281,   282,    -1,   284,   285,
      -1,    -1,   288,   289,   290,    -1,    -1,   293,   294,   295,
      -1,   297,    -1,   299,   300,   301,   302,   303,   304,   305,
     306,   307,   308,   309,    -1,    -1,   312,   313,   314,   315,
     316,   317,   318,   319,    -1,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
      -1,   337,   338,   339,   340,   341,   342,   343,   344,   345,
     346,   347,   348,   349,    -1,   351,   352,    -1,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
     366,   367,   368,    -1,   370,   371,   372,   373,   374,    -1,
     376,   377,   378,   379,   380,    -1,   382,   383,   384,   385,
      -1,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,   399,   400,   401,    -1,   403,   404,    -1,
     406,    -1,   408,   409,   410,   411,   412,    -1,   414,   415,
     416,    -1,    -1,   419,   420,   421,   422,   423,    -1,   425,
     426,   427,   428,   429,   430,   431,   432,    -1,    -1,   435,
     436,   437,   438,   439,    -1,    -1,   442,   443,   444,   445,
     446,   447,   448,    -1,   450,    -1,   452,   453,   454,   455,
      -1,    -1,   458,    -1,    -1,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,   478,   479,   480,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    20,    21,    22,    23,    24,    25,    26,    27,
      -1,    29,    30,    31,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    39,    40,    41,    -1,    43,    44,    45,    46,    -1,
      48,    49,    50,    51,    52,    -1,    54,    55,    -1,    57,
      58,    59,    60,    61,    62,    63,    -1,    -1,    66,    67,
      68,    69,    70,    -1,    72,    73,    74,    75,    76,    -1,
      -1,    -1,    80,    81,    82,    83,    84,    85,    -1,    87,
      88,    89,    -1,    91,    92,    93,    94,    95,    96,    -1,
      -1,    99,   100,   101,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   109,   110,   111,   112,   113,   114,   115,   116,   117,
      -1,   119,    -1,   121,   122,   123,   124,   125,   126,   127,
      -1,   129,   130,   131,   132,    -1,    -1,   135,   136,   137,
     138,   139,    -1,   141,   142,   143,    -1,   145,   146,   147,
      -1,   149,   150,   151,   152,   153,   154,   155,   156,   157,
     158,    -1,   160,    -1,   162,   163,   164,   165,   166,    -1,
     168,    -1,   170,    -1,    -1,    -1,   174,   175,   176,   177,
      -1,   179,   180,    -1,   182,   183,   184,    -1,   186,   187,
     188,   189,   190,    -1,   192,   193,   194,   195,    -1,   197,
     198,   199,   200,   201,   202,   203,    -1,   205,    -1,   207,
     208,   209,   210,   211,   212,   213,    -1,   215,    -1,   217,
      -1,    -1,   220,    -1,   222,   223,   224,   225,   226,    -1,
      -1,   229,   230,    -1,   232,    -1,    -1,   235,   236,   237,
      -1,    -1,   240,   241,   242,   243,   244,   245,   246,   247,
     248,   249,   250,   251,   252,   253,   254,   255,   256,   257,
     258,    -1,   260,   261,   262,   263,   264,   265,   266,   267,
     268,   269,   270,    -1,   272,   273,    -1,   275,    -1,   277,
     278,   279,   280,   281,   282,    -1,   284,   285,    -1,   287,
     288,   289,   290,    -1,    -1,   293,   294,   295,    -1,   297,
      -1,   299,   300,   301,   302,   303,   304,   305,   306,   307,
     308,   309,    -1,    -1,   312,   313,   314,   315,   316,   317,
     318,   319,    -1,   321,   322,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,   333,   334,   335,    -1,   337,
     338,   339,   340,   341,   342,   343,   344,   345,   346,   347,
     348,   349,    -1,   351,   352,    -1,   354,   355,   356,   357,
     358,   359,   360,   361,   362,   363,   364,   365,   366,   367,
     368,    -1,   370,   371,   372,   373,   374,    -1,   376,   377,
     378,   379,   380,    -1,   382,   383,   384,   385,    -1,   387,
     388,   389,   390,   391,   392,   393,   394,   395,   396,   397,
     398,   399,   400,   401,    -1,   403,   404,    -1,   406,    -1,
     408,   409,   410,   411,   412,    -1,   414,   415,   416,    -1,
      -1,   419,   420,   421,   422,   423,    -1,   425,   426,   427,
     428,   429,   430,   431,   432,    -1,    -1,   435,   436,   437,
     438,   439,    -1,    -1,   442,   443,   444,   445,   446,   447,
     448,    -1,   450,    -1,   452,   453,   454,   455,    -1,    -1,
     458,    -1,    -1,   461,   462,   463,   464,   465,   466,   467,
     468,   469,   470,   471,   472,   473,   474,   475,   476,   477,
     478,   479,   480,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    12,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      20,    21,    22,    23,    24,    25,    26,    27,    -1,    29,
      30,    31,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    39,
      40,    41,    -1,    43,    44,    45,    46,    -1,    48,    49,
      50,    51,    52,    -1,    54,    55,    -1,    57,    58,    59,
      60,    61,    62,    63,    -1,    -1,    66,    67,    68,    69,
      70,    -1,    72,    73,    74,    75,    76,    -1,    -1,    -1,
      80,    81,    82,    83,    84,    85,    -1,    87,    88,    89,
      -1,    91,    92,    93,    94,    95,    96,    -1,    -1,    99,
     100,   101,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   109,
     110,   111,   112,   113,   114,   115,   116,   117,    -1,   119,
      -1,   121,   122,   123,   124,   125,   126,   127,    -1,   129,
     130,   131,   132,    -1,    -1,   135,   136,   137,   138,   139,
      -1,   141,   142,   143,    -1,   145,   146,   147,    -1,   149,
     150,   151,   152,   153,   154,   155,   156,   157,   158,    -1,
     160,    -1,   162,   163,   164,   165,   166,    -1,   168,    -1,
     170,    -1,    -1,    -1,   174,   175,   176,   177,    -1,   179,
     180,    -1,   182,   183,   184,    -1,   186,   187,   188,   189,
     190,    -1,   192,   193,   194,   195,    -1,   197,   198,   199,
     200,   201,   202,   203,    -1,   205,    -1,   207,   208,   209,
     210,   211,   212,   213,    -1,   215,    -1,   217,    -1,    -1,
     220,    -1,   222,   223,   224,   225,   226,    -1,    -1,   229,
     230,    -1,   232,    -1,    -1,   235,   236,   237,    -1,    -1,
     240,   241,   242,   243,   244,   245,   246,   247,   248,   249,
     250,   251,   252,   253,   254,   255,   256,   257,   258,    -1,
     260,   261,   262,   263,   264,   265,   266,   267,   268,   269,
     270,    -1,   272,   273,    -1,   275,    -1,   277,   278,   279,
     280,   281,   282,    -1,   284,   285,    -1,    -1,   288,   289,
     290,    -1,    -1,   293,   294,   295,    -1,   297,    -1,   299,
     300,   301,   302,   303,   304,   305,   306,   307,   308,   309,
      -1,    -1,   312,   313,   314,   315,   316,   317,   318,   319,
      -1,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,    -1,   337,   338,   339,
     340,   341,   342,   343,   344,   345,   346,   347,   348,   349,
      -1,   351,   352,    -1,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,   365,   366,   367,   368,    -1,
     370,   371,   372,   373,   374,    -1,   376,   377,   378,   379,
     380,    -1,   382,   383,   384,   385,    -1,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,   399,
     400,   401,    -1,   403,   404,    -1,   406,    -1,   408,   409,
     410,   411,   412,    -1,   414,   415,   416,    -1,    -1,   419,
     420,   421,   422,   423,    -1,   425,   426,   427,   428,   429,
     430,   431,   432,    -1,    -1,   435,   436,   437,   438,   439,
      -1,    -1,   442,   443,   444,   445,   446,   447,   448,    -1,
     450,    -1,   452,   453,   454,   455,    -1,    -1,   458,    -1,
      -1,   461,   462,   463,   464,   465,   466,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,    21,
      22,    23,    24,    25,    26,    27,    28,    29,    30,    31,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    39,    40,    41,
      -1,    43,    44,    45,    46,    -1,    48,    49,    50,    51,
      52,    -1,    54,    55,    -1,    57,    58,    59,    60,    61,
      62,    63,    -1,    -1,    66,    67,    68,    69,    70,    -1,
      72,    73,    74,    75,    76,    -1,    -1,    -1,    80,    81,
      82,    83,    84,    85,    -1,    87,    88,    89,    -1,    91,
      92,    93,    94,    95,    96,    -1,    -1,    99,   100,   101,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   109,   110,   111,
     112,   113,   114,   115,   116,   117,    -1,   119,    -1,   121,
     122,   123,   124,   125,   126,   127,    -1,   129,   130,   131,
     132,    -1,    -1,   135,   136,   137,   138,   139,    -1,   141,
     142,   143,    -1,   145,   146,   147,    -1,   149,   150,   151,
     152,   153,   154,   155,   156,   157,   158,    -1,   160,    -1,
     162,   163,   164,   165,   166,    -1,   168,    -1,   170,    -1,
      -1,    -1,   174,   175,   176,   177,    -1,   179,   180,    -1,
     182,   183,   184,    -1,   186,   187,   188,   189,   190,    -1,
     192,   193,   194,   195,    -1,   197,   198,   199,   200,   201,
     202,   203,    -1,   205,    -1,   207,   208,   209,   210,   211,
     212,   213,    -1,   215,    -1,   217,    -1,    -1,   220,    -1,
     222,   223,   224,   225,   226,    -1,    -1,   229,   230,    -1,
     232,    -1,    -1,   235,   236,   237,    -1,    -1,   240,   241,
     242,   243,   244,   245,   246,   247,   248,   249,   250,   251,
     252,   253,   254,   255,   256,   257,   258,    -1,   260,   261,
     262,   263,   264,   265,   266,   267,   268,   269,   270,    -1,
     272,   273,    -1,   275,    -1,   277,   278,   279,   280,   281,
     282,    -1,   284,   285,    -1,    -1,   288,   289,   290,    -1,
      -1,   293,   294,   295,    -1,   297,    -1,   299,   300,   301,
     302,   303,   304,   305,   306,   307,   308,   309,    -1,    -1,
     312,   313,   314,   315,   316,   317,   318,   319,    -1,   321,
     322,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,   333,   334,   335,    -1,   337,   338,   339,   340,   341,
     342,   343,   344,   345,   346,   347,   348,   349,    -1,   351,
     352,    -1,   354,   355,   356,   357,   358,   359,   360,   361,
     362,   363,   364,   365,   366,   367,   368,    -1,   370,   371,
     372,   373,   374,    -1,   376,   377,   378,   379,   380,    -1,
     382,   383,   384,   385,    -1,   387,   388,   389,   390,   391,
     392,   393,   394,   395,   396,   397,   398,   399,   400,   401,
      -1,   403,   404,    -1,   406,    -1,   408,   409,   410,   411,
     412,    -1,   414,   415,   416,    -1,    -1,   419,   420,   421,
     422,   423,    -1,   425,   426,   427,   428,   429,   430,   431,
     432,    -1,    -1,   435,   436,   437,   438,   439,    -1,    -1,
     442,   443,   444,   445,   446,   447,   448,    -1,   450,    -1,
     452,   453,   454,   455,    -1,    -1,   458,    -1,    -1,   461,
     462,   463,   464,   465,   466,   467,   468,   469,   470,   471,
     472,   473,   474,   475,   476,   477,   478,   479,   480,     3,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    20,    21,    22,    23,
      24,    25,    26,    27,    28,    29,    30,    31,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    39,    40,    41,    -1,    43,
      44,    45,    46,    -1,    48,    49,    50,    51,    52,    -1,
      54,    55,    -1,    57,    58,    59,    60,    61,    62,    63,
      -1,    -1,    66,    67,    68,    69,    70,    -1,    72,    73,
      74,    75,    76,    -1,    -1,    -1,    80,    81,    82,    83,
      84,    85,    -1,    87,    88,    89,    -1,    91,    92,    93,
      94,    95,    96,    -1,    -1,    99,   100,   101,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   109,   110,   111,   112,   113,
     114,   115,   116,   117,    -1,   119,    -1,   121,   122,   123,
     124,   125,   126,   127,    -1,   129,   130,   131,   132,    -1,
      -1,   135,   136,   137,   138,   139,    -1,   141,   142,   143,
      -1,   145,   146,   147,    -1,   149,   150,   151,   152,   153,
     154,   155,   156,   157,   158,    -1,   160,    -1,   162,   163,
     164,   165,   166,    -1,   168,    -1,   170,    -1,    -1,    -1,
     174,   175,   176,   177,    -1,   179,   180,    -1,   182,   183,
     184,    -1,   186,   187,   188,   189,   190,    -1,   192,   193,
     194,   195,    -1,   197,   198,   199,   200,   201,   202,   203,
      -1,   205,    -1,   207,   208,   209,   210,   211,   212,   213,
      -1,   215,    -1,   217,    -1,    -1,   220,    -1,   222,   223,
     224,   225,   226,    -1,    -1,   229,   230,    -1,   232,    -1,
      -1,   235,   236,   237,    -1,    -1,   240,   241,   242,   243,
     244,   245,   246,   247,   248,   249,   250,   251,   252,   253,
     254,   255,   256,   257,   258,    -1,   260,   261,   262,   263,
     264,   265,   266,   267,   268,   269,   270,    -1,   272,   273,
      -1,   275,    -1,   277,   278,   279,   280,   281,   282,    -1,
     284,   285,    -1,    -1,   288,   289,   290,    -1,    -1,   293,
     294,   295,    -1,   297,    -1,   299,   300,   301,   302,   303,
     304,   305,   306,   307,   308,   309,    -1,    -1,   312,   313,
     314,   315,   316,   317,   318,   319,    -1,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,   333,
     334,   335,    -1,   337,   338,   339,   340,   341,   342,   343,
     344,   345,   346,   347,   348,   349,    -1,   351,   352,    -1,
     354,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,   365,   366,   367,   368,    -1,   370,   371,   372,   373,
     374,    -1,   376,   377,   378,   379,   380,    -1,   382,   383,
     384,   385,    -1,   387,   388,   389,   390,   391,   392,   393,
     394,   395,   396,   397,   398,   399,   400,   401,    -1,   403,
     404,    -1,   406,    -1,   408,   409,   410,   411,   412,    -1,
     414,   415,   416,    -1,    -1,   419,   420,   421,   422,   423,
      -1,   425,   426,   427,   428,   429,   430,   431,   432,    -1,
      -1,   435,   436,   437,   438,   439,    -1,    -1,   442,   443,
     444,   445,   446,   447,   448,    -1,   450,    -1,   452,   453,
     454,   455,    -1,    -1,   458,    -1,    -1,   461,   462,   463,
     464,   465,   466,   467,   468,   469,   470,   471,   472,   473,
     474,   475,   476,   477,   478,   479,   480,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,    25,
      26,    27,    28,    29,    30,    31,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    39,    40,    41,    -1,    43,    44,    45,
      46,    -1,    48,    49,    50,    51,    52,    -1,    54,    55,
      -1,    57,    58,    59,    60,    61,    62,    63,    -1,    -1,
      66,    67,    68,    69,    70,    -1,    72,    73,    74,    75,
      76,    -1,    -1,    -1,    80,    81,    82,    83,    84,    85,
      -1,    87,    88,    89,    -1,    91,    92,    93,    94,    95,
      96,    -1,    -1,    99,   100,   101,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   109,   110,   111,   112,   113,   114,   115,
     116,   117,    -1,   119,    -1,   121,   122,   123,   124,   125,
     126,   127,    -1,   129,   130,   131,   132,    -1,    -1,   135,
     136,   137,   138,   139,    -1,   141,   142,   143,    -1,   145,
     146,   147,    -1,   149,   150,   151,   152,   153,   154,   155,
     156,   157,   158,    -1,   160,    -1,   162,   163,   164,   165,
     166,    -1,   168,    -1,   170,    -1,    -1,    -1,   174,   175,
     176,   177,    -1,   179,   180,    -1,   182,   183,   184,    -1,
     186,   187,   188,   189,   190,    -1,   192,   193,   194,   195,
      -1,   197,   198,   199,   200,   201,   202,   203,    -1,   205,
      -1,   207,   208,   209,   210,   211,   212,   213,    -1,   215,
      -1,   217,    -1,    -1,   220,    -1,   222,   223,   224,   225,
     226,    -1,    -1,   229,   230,    -1,   232,    -1,    -1,   235,
     236,   237,    -1,    -1,   240,   241,   242,   243,   244,   245,
     246,   247,   248,   249,   250,   251,   252,   253,   254,   255,
     256,   257,   258,    -1,   260,   261,   262,   263,   264,   265,
     266,   267,   268,   269,   270,    -1,   272,   273,    -1,   275,
      -1,   277,   278,   279,   280,   281,   282,    -1,   284,   285,
      -1,    -1,   288,   289,   290,    -1,    -1,   293,   294,   295,
      -1,   297,    -1,   299,   300,   301,   302,   303,   304,   305,
     306,   307,   308,   309,    -1,    -1,   312,   313,   314,   315,
     316,   317,   318,   319,    -1,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
      -1,   337,   338,   339,   340,   341,   342,   343,   344,   345,
     346,   347,   348,   349,    -1,   351,   352,    -1,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
     366,   367,   368,    -1,   370,   371,   372,   373,   374,    -1,
     376,   377,   378,   379,   380,    -1,   382,   383,   384,   385,
      -1,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,   399,   400,   401,    -1,   403,   404,    -1,
     406,    -1,   408,   409,   410,   411,   412,    -1,   414,   415,
     416,    -1,    -1,   419,   420,   421,   422,   423,    -1,   425,
     426,   427,   428,   429,   430,   431,   432,    -1,    -1,   435,
     436,   437,   438,   439,    -1,    -1,   442,   443,   444,   445,
     446,   447,   448,    -1,   450,    -1,   452,   453,   454,   455,
      -1,    -1,   458,    -1,    -1,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,   478,   479,   480,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    20,    21,    22,    23,    24,    25,    26,    27,
      28,    29,    30,    31,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    39,    40,    41,    -1,    43,    44,    45,    46,    -1,
      48,    49,    50,    51,    52,    -1,    54,    55,    -1,    57,
      58,    59,    60,    61,    62,    63,    -1,    -1,    66,    67,
      68,    69,    70,    -1,    72,    73,    74,    75,    76,    -1,
      -1,    -1,    80,    81,    82,    83,    84,    85,    -1,    87,
      88,    89,    -1,    91,    92,    93,    94,    95,    96,    -1,
      -1,    99,   100,   101,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   109,   110,   111,   112,   113,   114,   115,   116,   117,
      -1,   119,    -1,   121,   122,   123,   124,   125,   126,   127,
      -1,   129,   130,   131,   132,    -1,    -1,   135,   136,   137,
     138,   139,    -1,   141,   142,   143,    -1,   145,   146,   147,
      -1,   149,   150,   151,   152,   153,   154,   155,   156,   157,
     158,    -1,   160,    -1,   162,   163,   164,   165,   166,    -1,
     168,    -1,   170,    -1,    -1,    -1,   174,   175,   176,   177,
      -1,   179,   180,    -1,   182,   183,   184,    -1,   186,   187,
     188,   189,   190,    -1,   192,   193,   194,   195,    -1,   197,
     198,   199,   200,   201,   202,   203,    -1,   205,    -1,   207,
     208,   209,   210,   211,   212,   213,    -1,   215,    -1,   217,
      -1,    -1,   220,    -1,   222,   223,   224,   225,   226,    -1,
      -1,   229,   230,    -1,   232,    -1,    -1,   235,   236,   237,
      -1,    -1,   240,   241,   242,   243,   244,   245,   246,   247,
     248,   249,   250,   251,   252,   253,   254,   255,   256,   257,
     258,    -1,   260,   261,   262,   263,   264,   265,   266,   267,
     268,   269,   270,    -1,   272,   273,    -1,   275,    -1,   277,
     278,   279,   280,   281,   282,    -1,   284,   285,    -1,    -1,
     288,   289,   290,    -1,    -1,   293,   294,   295,    -1,   297,
      -1,   299,   300,   301,   302,   303,   304,   305,   306,   307,
     308,   309,    -1,    -1,   312,   313,   314,   315,   316,   317,
     318,   319,    -1,   321,   322,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,   333,   334,   335,    -1,   337,
     338,   339,   340,   341,   342,   343,   344,   345,   346,   347,
     348,   349,    -1,   351,   352,    -1,   354,   355,   356,   357,
     358,   359,   360,   361,   362,   363,   364,   365,   366,   367,
     368,    -1,   370,   371,   372,   373,   374,    -1,   376,   377,
     378,   379,   380,    -1,   382,   383,   384,   385,    -1,   387,
     388,   389,   390,   391,   392,   393,   394,   395,   396,   397,
     398,   399,   400,   401,    -1,   403,   404,    -1,   406,    -1,
     408,   409,   410,   411,   412,    -1,   414,   415,   416,    -1,
      -1,   419,   420,   421,   422,   423,    -1,   425,   426,   427,
     428,   429,   430,   431,   432,    -1,    -1,   435,   436,   437,
     438,   439,    -1,    -1,   442,   443,   444,   445,   446,   447,
     448,    -1,   450,    -1,   452,   453,   454,   455,    -1,    -1,
     458,    -1,    -1,   461,   462,   463,   464,   465,   466,   467,
     468,   469,   470,   471,   472,   473,   474,   475,   476,   477,
     478,   479,   480,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    29,
      30,    31,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    39,
      40,    41,    -1,    43,    44,    45,    46,    -1,    48,    49,
      50,    51,    52,    -1,    54,    55,    -1,    57,    58,    59,
      60,    61,    62,    63,    -1,    -1,    66,    67,    68,    69,
      70,    -1,    72,    73,    74,    75,    76,    -1,    -1,    -1,
      80,    81,    82,    83,    84,    85,    -1,    87,    88,    89,
      -1,    91,    92,    93,    94,    95,    96,    -1,    -1,    99,
     100,   101,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   109,
     110,   111,   112,   113,   114,   115,   116,   117,    -1,   119,
      -1,   121,   122,   123,   124,   125,   126,   127,    -1,   129,
     130,   131,   132,    -1,    -1,   135,   136,   137,   138,   139,
      -1,   141,   142,   143,    -1,   145,   146,   147,    -1,   149,
     150,   151,   152,   153,   154,   155,   156,   157,   158,    -1,
     160,    -1,   162,   163,   164,   165,   166,    -1,   168,    -1,
     170,    -1,    -1,    -1,   174,   175,   176,   177,    -1,   179,
     180,    -1,   182,   183,   184,    -1,   186,   187,   188,   189,
     190,    -1,   192,   193,   194,   195,    -1,   197,   198,   199,
     200,   201,   202,   203,    -1,   205,    -1,   207,   208,   209,
     210,   211,   212,   213,    -1,   215,    -1,   217,    -1,    -1,
     220,    -1,   222,   223,   224,   225,   226,    -1,    -1,   229,
     230,    -1,   232,    -1,    -1,   235,   236,   237,    -1,    -1,
     240,   241,   242,   243,   244,   245,   246,   247,   248,   249,
     250,   251,   252,   253,   254,   255,   256,   257,   258,    -1,
     260,   261,   262,   263,   264,   265,   266,   267,   268,   269,
     270,    -1,   272,   273,    -1,   275,    -1,   277,   278,   279,
     280,   281,   282,    -1,   284,   285,    -1,    -1,   288,   289,
     290,    -1,    -1,   293,   294,   295,    -1,   297,    -1,   299,
     300,   301,   302,   303,   304,   305,   306,   307,   308,   309,
      -1,    -1,   312,   313,   314,   315,   316,   317,   318,   319,
      -1,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,    -1,   337,   338,   339,
     340,   341,   342,   343,   344,   345,   346,   347,   348,   349,
      -1,   351,   352,    -1,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,   365,   366,   367,   368,    -1,
     370,   371,   372,   373,   374,    -1,   376,   377,   378,   379,
     380,    -1,   382,   383,   384,   385,    -1,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,   399,
     400,   401,    -1,   403,   404,    -1,   406,    -1,   408,   409,
     410,   411,   412,    -1,   414,   415,   416,    -1,    -1,   419,
     420,   421,   422,   423,    -1,   425,   426,   427,   428,   429,
     430,   431,   432,    -1,    -1,   435,   436,   437,   438,   439,
      -1,    -1,   442,   443,   444,   445,   446,   447,   448,    -1,
     450,    -1,   452,   453,   454,   455,    -1,    -1,   458,    -1,
      -1,   461,   462,   463,   464,   465,   466,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,    21,
      22,    23,    24,    25,    26,    27,    -1,    29,    30,    31,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    39,    40,    41,
      -1,    43,    44,    45,    46,    47,    48,    49,    50,    51,
      52,    -1,    54,    55,    -1,    57,    58,    59,    60,    61,
      62,    63,    -1,    -1,    66,    67,    68,    69,    70,    -1,
      72,    73,    74,    75,    76,    -1,    -1,    -1,    80,    81,
      82,    83,    84,    85,    -1,    87,    88,    89,    -1,    91,
      92,    93,    94,    95,    96,    -1,    -1,    99,   100,   101,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   109,   110,   111,
     112,   113,   114,   115,   116,   117,    -1,   119,    -1,   121,
     122,   123,   124,   125,   126,   127,    -1,   129,   130,   131,
     132,    -1,    -1,   135,   136,   137,   138,   139,    -1,   141,
     142,   143,    -1,   145,   146,   147,    -1,   149,   150,   151,
     152,   153,   154,   155,   156,   157,   158,    -1,   160,    -1,
     162,   163,   164,   165,   166,    -1,   168,    -1,   170,    -1,
      -1,    -1,   174,   175,   176,   177,    -1,   179,   180,    -1,
     182,   183,   184,    -1,   186,   187,   188,   189,   190,    -1,
     192,   193,   194,   195,    -1,   197,   198,   199,   200,   201,
     202,   203,    -1,   205,    -1,   207,   208,   209,   210,   211,
     212,   213,    -1,   215,    -1,   217,    -1,    -1,   220,    -1,
     222,   223,   224,   225,   226,    -1,    -1,   229,   230,    -1,
     232,    -1,    -1,   235,   236,   237,    -1,    -1,   240,   241,
     242,   243,   244,   245,   246,   247,   248,   249,   250,   251,
     252,   253,   254,   255,   256,   257,   258,    -1,   260,   261,
     262,   263,   264,   265,   266,   267,   268,   269,   270,    -1,
     272,   273,    -1,   275,    -1,   277,   278,   279,   280,   281,
     282,    -1,   284,   285,    -1,    -1,   288,   289,   290,    -1,
      -1,   293,   294,   295,    -1,   297,    -1,   299,   300,   301,
     302,   303,   304,   305,   306,   307,   308,   309,    -1,    -1,
     312,   313,   314,   315,   316,   317,   318,   319,    -1,   321,
     322,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,   333,   334,   335,    -1,   337,   338,   339,   340,   341,
     342,   343,   344,   345,   346,   347,   348,   349,    -1,   351,
     352,    -1,   354,   355,   356,   357,   358,   359,   360,   361,
     362,   363,   364,   365,   366,   367,   368,    -1,   370,   371,
     372,   373,   374,    -1,   376,   377,   378,   379,   380,    -1,
     382,   383,   384,   385,    -1,   387,   388,   389,   390,   391,
     392,   393,   394,   395,   396,   397,   398,   399,   400,   401,
      -1,   403,   404,    -1,   406,    -1,   408,   409,   410,   411,
     412,    -1,   414,   415,   416,    -1,    -1,   419,   420,   421,
     422,   423,    -1,   425,   426,   427,   428,   429,   430,   431,
     432,    -1,    -1,   435,   436,   437,   438,   439,    -1,    -1,
     442,   443,   444,   445,   446,   447,   448,    -1,   450,    -1,
     452,   453,   454,   455,    -1,    -1,   458,    -1,    -1,   461,
     462,   463,   464,   465,   466,   467,   468,   469,   470,   471,
     472,   473,   474,   475,   476,   477,   478,   479,   480,     3,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    20,    21,    22,    23,
      24,    25,    26,    27,    -1,    29,    30,    31,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    39,    40,    41,    -1,    43,
      44,    45,    46,    -1,    48,    49,    50,    51,    52,    -1,
      54,    55,    -1,    57,    58,    59,    60,    61,    62,    63,
      -1,    -1,    66,    67,    68,    69,    70,    -1,    72,    73,
      74,    75,    76,    -1,    -1,    -1,    80,    81,    82,    83,
      84,    85,    -1,    87,    88,    89,    -1,    91,    92,    93,
      94,    95,    96,    -1,    -1,    99,   100,   101,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   109,   110,   111,   112,   113,
     114,   115,   116,   117,    -1,   119,    -1,   121,   122,   123,
     124,   125,   126,   127,    -1,   129,   130,   131,   132,    -1,
      -1,   135,   136,   137,   138,   139,    -1,   141,   142,   143,
      -1,   145,   146,   147,    -1,   149,   150,   151,   152,   153,
     154,   155,   156,   157,   158,    -1,   160,    -1,   162,   163,
     164,   165,   166,    -1,   168,    -1,   170,    -1,    -1,    -1,
     174,   175,   176,   177,    -1,   179,   180,    -1,   182,   183,
     184,    -1,   186,   187,   188,   189,   190,    -1,   192,   193,
     194,   195,    -1,   197,   198,   199,   200,   201,   202,   203,
      -1,   205,    -1,   207,   208,   209,   210,   211,   212,   213,
      -1,   215,    -1,   217,    -1,    -1,   220,    -1,   222,   223,
     224,   225,   226,    -1,    -1,   229,   230,    -1,   232,    -1,
      -1,   235,   236,   237,    -1,    -1,   240,   241,   242,   243,
     244,   245,   246,   247,   248,   249,   250,   251,   252,   253,
     254,   255,   256,   257,   258,    -1,   260,   261,   262,   263,
     264,   265,   266,   267,   268,   269,   270,    -1,   272,   273,
      -1,   275,    -1,   277,   278,   279,   280,   281,   282,    -1,
     284,   285,    -1,   287,   288,   289,   290,    -1,    -1,   293,
     294,   295,    -1,   297,    -1,   299,   300,   301,   302,   303,
     304,   305,   306,   307,   308,   309,    -1,    -1,   312,   313,
     314,   315,   316,   317,   318,   319,    -1,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,   333,
     334,   335,    -1,   337,   338,   339,   340,   341,   342,   343,
     344,   345,   346,   347,   348,   349,    -1,   351,   352,    -1,
     354,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,   365,   366,   367,   368,    -1,   370,   371,   372,   373,
     374,    -1,   376,   377,   378,   379,   380,    -1,   382,   383,
     384,   385,    -1,   387,   388,   389,   390,   391,   392,   393,
     394,   395,   396,   397,   398,   399,   400,   401,    -1,   403,
     404,    -1,   406,    -1,   408,   409,   410,   411,   412,    -1,
     414,   415,   416,    -1,    -1,   419,   420,   421,   422,   423,
      -1,   425,   426,   427,   428,   429,   430,   431,   432,    -1,
      -1,   435,   436,   437,   438,   439,    -1,    -1,   442,   443,
     444,   445,   446,   447,   448,    -1,   450,    -1,   452,   453,
     454,   455,    -1,    -1,   458,    -1,    -1,   461,   462,   463,
     464,   465,   466,   467,   468,   469,   470,   471,   472,   473,
     474,   475,   476,   477,   478,   479,   480,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,    25,
      26,    27,    28,    29,    30,    31,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    39,    40,    41,    -1,    43,    44,    45,
      46,    -1,    48,    49,    50,    51,    52,    -1,    54,    55,
      -1,    57,    58,    59,    60,    61,    62,    63,    -1,    -1,
      66,    67,    68,    69,    70,    -1,    72,    73,    74,    75,
      76,    -1,    -1,    -1,    80,    81,    82,    83,    84,    85,
      -1,    87,    88,    89,    -1,    91,    92,    93,    94,    95,
      96,    -1,    -1,    99,   100,   101,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   109,   110,   111,   112,   113,   114,   115,
     116,   117,    -1,   119,    -1,   121,   122,   123,   124,   125,
     126,   127,    -1,   129,   130,   131,   132,    -1,    -1,   135,
     136,   137,   138,   139,    -1,   141,   142,   143,    -1,   145,
     146,   147,    -1,   149,   150,   151,   152,   153,   154,   155,
     156,   157,   158,    -1,   160,    -1,   162,   163,   164,   165,
     166,    -1,   168,    -1,   170,    -1,    -1,    -1,   174,   175,
     176,   177,    -1,   179,   180,    -1,   182,   183,   184,    -1,
     186,   187,   188,   189,   190,    -1,   192,   193,   194,   195,
      -1,   197,   198,   199,   200,   201,   202,   203,    -1,   205,
      -1,   207,   208,   209,   210,   211,   212,   213,    -1,   215,
      -1,   217,    -1,    -1,   220,    -1,   222,   223,   224,   225,
     226,    -1,    -1,   229,   230,    -1,   232,    -1,    -1,   235,
     236,   237,    -1,    -1,   240,   241,   242,   243,   244,   245,
     246,   247,   248,   249,   250,   251,   252,   253,   254,   255,
     256,   257,   258,    -1,   260,   261,   262,   263,   264,   265,
     266,   267,   268,   269,   270,    -1,   272,   273,    -1,   275,
      -1,   277,   278,   279,   280,   281,   282,    -1,   284,   285,
      -1,    -1,   288,   289,   290,    -1,    -1,   293,   294,   295,
      -1,   297,    -1,   299,   300,   301,   302,   303,   304,   305,
     306,   307,   308,   309,    -1,    -1,   312,   313,   314,   315,
     316,   317,   318,   319,    -1,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
      -1,   337,   338,   339,   340,   341,   342,   343,   344,   345,
     346,   347,   348,   349,    -1,   351,   352,    -1,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
     366,   367,   368,    -1,   370,   371,   372,   373,   374,    -1,
     376,   377,   378,   379,   380,    -1,   382,   383,   384,   385,
      -1,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,   399,   400,   401,    -1,   403,   404,    -1,
     406,    -1,   408,   409,   410,   411,   412,    -1,   414,   415,
     416,    -1,    -1,   419,   420,   421,   422,   423,    -1,   425,
     426,   427,   428,   429,   430,   431,   432,    -1,    -1,   435,
     436,   437,   438,   439,    -1,    -1,   442,   443,   444,   445,
     446,   447,   448,    -1,   450,    -1,   452,   453,   454,   455,
      -1,    -1,   458,    -1,    -1,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,   478,   479,   480,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    20,    21,    22,    23,    24,    25,    26,    27,
      -1,    29,    30,    31,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    39,    40,    41,    -1,    43,    44,    45,    46,    -1,
      48,    49,    50,    51,    52,    -1,    54,    55,    -1,    57,
      58,    59,    60,    61,    62,    63,    -1,    -1,    66,    67,
      68,    69,    70,    -1,    72,    73,    74,    75,    76,    -1,
      -1,    -1,    80,    81,    82,    83,    84,    85,    -1,    87,
      88,    89,    -1,    91,    92,    93,    94,    95,    96,    -1,
      -1,    99,   100,   101,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   109,   110,   111,   112,   113,   114,   115,   116,   117,
      -1,   119,    -1,   121,   122,   123,   124,   125,   126,   127,
      -1,   129,   130,   131,   132,    -1,    -1,   135,   136,   137,
     138,   139,    -1,   141,   142,   143,    -1,   145,   146,   147,
      -1,   149,   150,   151,   152,   153,   154,   155,   156,   157,
     158,    -1,   160,    -1,   162,   163,   164,   165,   166,    -1,
     168,    -1,   170,    -1,    -1,    -1,   174,   175,   176,   177,
      -1,   179,   180,    -1,   182,   183,   184,    -1,   186,   187,
     188,   189,   190,    -1,   192,   193,   194,   195,    -1,   197,
     198,   199,   200,   201,   202,   203,    -1,   205,    -1,   207,
     208,   209,   210,   211,   212,   213,    -1,   215,    -1,   217,
      -1,    -1,   220,    -1,   222,   223,   224,   225,   226,    -1,
      -1,   229,   230,    -1,   232,    -1,    -1,   235,   236,   237,
      -1,    -1,   240,   241,   242,   243,   244,   245,   246,   247,
     248,   249,   250,   251,   252,   253,   254,   255,   256,   257,
     258,    -1,   260,   261,   262,   263,   264,   265,   266,   267,
     268,   269,   270,    -1,   272,   273,    -1,   275,    -1,   277,
     278,   279,   280,   281,   282,    -1,   284,   285,    -1,    -1,
     288,   289,   290,    -1,    -1,   293,   294,   295,    -1,   297,
      -1,   299,   300,   301,   302,   303,   304,   305,   306,   307,
     308,   309,    -1,    -1,   312,   313,   314,   315,   316,   317,
     318,   319,    -1,   321,   322,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,   333,   334,   335,    -1,   337,
     338,   339,   340,   341,   342,   343,   344,   345,   346,   347,
     348,   349,    -1,   351,   352,    -1,   354,   355,   356,   357,
     358,   359,   360,   361,   362,   363,   364,   365,   366,   367,
     368,    -1,   370,   371,   372,   373,   374,    -1,   376,   377,
     378,   379,   380,    -1,   382,   383,   384,   385,    -1,   387,
     388,   389,   390,   391,   392,   393,   394,   395,   396,   397,
     398,   399,   400,   401,    -1,   403,   404,   405,   406,    -1,
     408,   409,   410,   411,   412,    -1,   414,   415,   416,    -1,
      -1,   419,   420,   421,   422,   423,    -1,   425,   426,   427,
     428,   429,   430,   431,   432,    -1,    -1,   435,   436,   437,
     438,   439,    -1,    -1,   442,   443,   444,   445,   446,   447,
     448,    -1,   450,    -1,   452,   453,   454,   455,    -1,    -1,
     458,    -1,    -1,   461,   462,   463,   464,   465,   466,   467,
     468,   469,   470,   471,   472,   473,   474,   475,   476,   477,
     478,   479,   480,     3,    -1,    -1,     6,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      20,    21,    22,    23,    24,    25,    26,    27,    -1,    29,
      30,    31,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    39,
      40,    41,    -1,    43,    44,    45,    46,    -1,    48,    49,
      50,    51,    52,    -1,    54,    55,    -1,    57,    58,    59,
      60,    61,    62,    63,    -1,    -1,    66,    67,    68,    69,
      70,    -1,    72,    73,    74,    75,    76,    -1,    -1,    -1,
      80,    81,    82,    83,    84,    85,    -1,    87,    88,    89,
      -1,    91,    92,    93,    94,    95,    96,    -1,    -1,    99,
     100,   101,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   109,
     110,   111,   112,   113,   114,   115,   116,   117,    -1,   119,
      -1,   121,   122,   123,   124,   125,   126,   127,    -1,   129,
     130,   131,   132,    -1,    -1,   135,   136,   137,   138,   139,
      -1,   141,   142,   143,    -1,   145,   146,   147,    -1,   149,
     150,   151,   152,   153,   154,   155,   156,   157,   158,    -1,
     160,    -1,   162,   163,   164,   165,   166,    -1,   168,    -1,
     170,    -1,    -1,    -1,   174,   175,   176,   177,    -1,   179,
     180,    -1,   182,   183,   184,    -1,   186,   187,   188,   189,
     190,    -1,   192,   193,   194,   195,    -1,   197,   198,   199,
     200,   201,   202,   203,    -1,   205,    -1,   207,   208,   209,
     210,   211,   212,   213,    -1,   215,    -1,   217,    -1,    -1,
     220,    -1,   222,   223,   224,   225,   226,    -1,    -1,   229,
     230,    -1,   232,    -1,    -1,   235,   236,   237,    -1,    -1,
     240,   241,   242,   243,   244,   245,   246,   247,   248,   249,
     250,   251,   252,   253,   254,   255,   256,   257,   258,    -1,
     260,   261,   262,   263,   264,   265,   266,   267,   268,   269,
     270,    -1,   272,   273,    -1,   275,    -1,   277,   278,   279,
     280,   281,   282,    -1,   284,   285,    -1,    -1,   288,   289,
     290,    -1,    -1,   293,   294,   295,    -1,   297,    -1,   299,
     300,   301,   302,   303,   304,   305,   306,   307,   308,   309,
      -1,    -1,   312,   313,   314,   315,   316,   317,   318,   319,
      -1,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,    -1,   337,   338,   339,
     340,   341,   342,   343,   344,   345,   346,   347,   348,   349,
      -1,   351,   352,    -1,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,   365,   366,   367,   368,    -1,
     370,   371,   372,   373,   374,    -1,   376,   377,   378,   379,
     380,    -1,   382,   383,   384,   385,    -1,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,   399,
     400,   401,    -1,   403,   404,    -1,   406,    -1,   408,   409,
     410,   411,   412,    -1,   414,   415,   416,    -1,    -1,   419,
     420,   421,   422,   423,    -1,   425,   426,   427,   428,   429,
     430,   431,   432,    -1,    -1,   435,   436,   437,   438,   439,
      -1,    -1,   442,   443,   444,   445,   446,   447,   448,    -1,
     450,    -1,   452,   453,   454,   455,    -1,    -1,   458,    -1,
      -1,   461,   462,   463,   464,   465,   466,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    11,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,    21,
      22,    23,    24,    25,    26,    27,    -1,    29,    30,    31,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    39,    40,    41,
      -1,    43,    44,    45,    46,    -1,    48,    49,    50,    51,
      52,    -1,    54,    55,    -1,    57,    58,    59,    60,    61,
      62,    63,    -1,    -1,    66,    67,    68,    69,    70,    -1,
      72,    73,    74,    75,    76,    -1,    -1,    -1,    80,    81,
      82,    83,    84,    85,    -1,    87,    88,    89,    -1,    91,
      92,    93,    94,    95,    96,    -1,    -1,    99,   100,   101,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   109,   110,   111,
     112,   113,   114,   115,   116,   117,    -1,   119,    -1,   121,
     122,   123,   124,   125,   126,   127,    -1,   129,   130,   131,
     132,    -1,    -1,   135,   136,   137,   138,   139,    -1,   141,
     142,   143,    -1,   145,   146,   147,    -1,   149,   150,   151,
     152,   153,   154,   155,   156,   157,   158,    -1,   160,    -1,
     162,   163,   164,   165,   166,    -1,   168,    -1,   170,    -1,
      -1,    -1,   174,   175,   176,   177,    -1,   179,   180,    -1,
     182,   183,   184,    -1,   186,   187,   188,   189,   190,    -1,
     192,   193,   194,   195,    -1,   197,   198,   199,   200,   201,
     202,   203,    -1,   205,    -1,   207,   208,   209,   210,   211,
     212,   213,    -1,   215,    -1,   217,    -1,    -1,   220,    -1,
     222,   223,   224,   225,   226,    -1,    -1,   229,   230,    -1,
     232,    -1,    -1,   235,   236,   237,    -1,    -1,   240,   241,
     242,   243,   244,   245,   246,   247,   248,   249,   250,   251,
     252,   253,   254,   255,   256,   257,   258,    -1,   260,   261,
     262,   263,   264,   265,   266,   267,   268,   269,   270,    -1,
     272,   273,    -1,   275,    -1,   277,   278,   279,   280,   281,
     282,    -1,   284,   285,    -1,    -1,   288,   289,   290,    -1,
      -1,   293,   294,   295,    -1,   297,    -1,   299,   300,   301,
     302,   303,   304,   305,   306,   307,   308,   309,    -1,    -1,
     312,   313,   314,   315,   316,   317,   318,   319,    -1,   321,
     322,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,   333,   334,   335,    -1,   337,   338,   339,   340,   341,
     342,   343,   344,   345,   346,   347,   348,   349,    -1,   351,
     352,    -1,   354,   355,   356,   357,   358,   359,   360,   361,
     362,   363,   364,   365,   366,   367,   368,    -1,   370,   371,
     372,   373,   374,    -1,   376,   377,   378,   379,   380,    -1,
     382,   383,   384,   385,    -1,   387,   388,   389,   390,   391,
     392,   393,   394,   395,   396,   397,   398,   399,   400,   401,
      -1,   403,   404,    -1,   406,    -1,   408,   409,   410,   411,
     412,    -1,   414,   415,   416,    -1,    -1,   419,   420,   421,
     422,   423,    -1,   425,   426,   427,   428,   429,   430,   431,
     432,    -1,    -1,   435,   436,   437,   438,   439,    -1,    -1,
     442,   443,   444,   445,   446,   447,   448,    -1,   450,    -1,
     452,   453,   454,   455,    -1,    -1,   458,    -1,    -1,   461,
     462,   463,   464,   465,   466,   467,   468,   469,   470,   471,
     472,   473,   474,   475,   476,   477,   478,   479,   480,     3,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    20,    21,    22,    23,
      24,    25,    26,    27,    -1,    29,    30,    31,    -1,    -1,
      -1,    -1,    -1,    37,    -1,    39,    40,    41,    -1,    43,
      44,    45,    46,    -1,    48,    49,    50,    51,    52,    -1,
      54,    55,    -1,    57,    58,    59,    60,    61,    62,    63,
      -1,    -1,    66,    67,    68,    69,    70,    -1,    72,    73,
      74,    75,    76,    -1,    -1,    -1,    80,    81,    82,    83,
      84,    85,    -1,    87,    88,    89,    -1,    91,    92,    93,
      94,    95,    96,    -1,    -1,    99,   100,   101,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   109,   110,   111,   112,   113,
     114,   115,   116,   117,    -1,   119,    -1,   121,   122,   123,
     124,   125,   126,   127,    -1,   129,   130,   131,   132,    -1,
      -1,   135,   136,   137,   138,   139,    -1,   141,   142,   143,
      -1,   145,   146,   147,    -1,   149,   150,   151,   152,   153,
     154,   155,   156,   157,   158,    -1,   160,    -1,   162,   163,
     164,   165,   166,    -1,   168,    -1,   170,    -1,    -1,    -1,
     174,   175,   176,   177,    -1,   179,   180,    -1,   182,   183,
     184,    -1,   186,   187,   188,   189,   190,    -1,   192,   193,
     194,   195,    -1,   197,   198,   199,   200,   201,   202,   203,
      -1,   205,    -1,   207,   208,   209,   210,   211,   212,   213,
      -1,   215,    -1,   217,    -1,    -1,   220,    -1,   222,   223,
     224,   225,   226,    -1,    -1,   229,   230,    -1,   232,    -1,
      -1,   235,   236,   237,    -1,    -1,   240,   241,   242,   243,
     244,   245,   246,   247,   248,   249,   250,   251,   252,   253,
     254,   255,   256,   257,   258,    -1,   260,   261,   262,   263,
     264,   265,   266,   267,   268,   269,   270,    -1,   272,   273,
      -1,   275,    -1,   277,   278,   279,   280,   281,   282,    -1,
     284,   285,    -1,    -1,   288,   289,   290,    -1,    -1,   293,
     294,   295,    -1,   297,    -1,   299,   300,   301,   302,   303,
     304,   305,   306,   307,   308,   309,    -1,    -1,   312,   313,
     314,   315,   316,   317,   318,   319,    -1,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,   333,
     334,   335,    -1,   337,   338,   339,   340,   341,   342,   343,
     344,   345,   346,   347,   348,   349,    -1,   351,   352,    -1,
     354,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,   365,   366,   367,   368,    -1,   370,   371,   372,   373,
     374,    -1,   376,   377,   378,   379,   380,    -1,   382,   383,
     384,   385,    -1,   387,   388,   389,   390,   391,   392,   393,
     394,   395,   396,   397,   398,   399,   400,   401,    -1,   403,
     404,    -1,   406,    -1,   408,   409,   410,   411,   412,    -1,
     414,   415,   416,    -1,    -1,   419,   420,   421,   422,   423,
      -1,   425,   426,   427,   428,   429,   430,   431,   432,    -1,
      -1,   435,   436,   437,   438,   439,    -1,    -1,   442,   443,
     444,   445,   446,   447,   448,    -1,   450,    -1,   452,   453,
     454,   455,    -1,    -1,   458,    -1,    -1,   461,   462,   463,
     464,   465,   466,   467,   468,   469,   470,   471,   472,   473,
     474,   475,   476,   477,   478,   479,   480,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,    25,
      26,    27,    -1,    29,    30,    31,    -1,    -1,    -1,    -1,
      -1,    37,    -1,    39,    40,    41,    -1,    43,    44,    45,
      46,    -1,    48,    49,    50,    51,    52,    -1,    54,    55,
      -1,    57,    58,    59,    60,    61,    62,    63,    -1,    -1,
      66,    67,    68,    69,    70,    -1,    72,    73,    74,    75,
      76,    -1,    -1,    -1,    80,    81,    82,    83,    84,    85,
      -1,    87,    88,    89,    -1,    91,    92,    93,    94,    95,
      96,    -1,    -1,    99,   100,   101,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   109,   110,   111,   112,   113,   114,   115,
     116,   117,    -1,   119,    -1,   121,   122,   123,   124,   125,
     126,   127,    -1,   129,   130,   131,   132,    -1,    -1,   135,
     136,   137,   138,   139,    -1,   141,   142,   143,    -1,   145,
     146,   147,    -1,   149,   150,   151,   152,   153,   154,   155,
     156,   157,   158,    -1,   160,    -1,   162,   163,   164,   165,
     166,    -1,   168,    -1,   170,    -1,    -1,    -1,   174,   175,
     176,   177,    -1,   179,   180,    -1,   182,   183,   184,    -1,
     186,   187,   188,   189,   190,    -1,   192,   193,   194,   195,
      -1,   197,   198,   199,   200,   201,   202,   203,    -1,   205,
      -1,   207,   208,   209,   210,   211,   212,   213,    -1,   215,
      -1,   217,    -1,    -1,   220,    -1,   222,   223,   224,   225,
     226,    -1,    -1,   229,   230,    -1,   232,    -1,    -1,   235,
     236,   237,    -1,    -1,   240,   241,   242,   243,   244,   245,
     246,   247,   248,   249,   250,   251,   252,   253,   254,   255,
     256,   257,   258,    -1,   260,   261,   262,   263,   264,   265,
     266,   267,   268,   269,   270,    -1,   272,   273,    -1,   275,
      -1,   277,   278,   279,   280,   281,   282,    -1,   284,   285,
      -1,    -1,   288,   289,   290,    -1,    -1,   293,   294,   295,
      -1,   297,    -1,   299,   300,   301,   302,   303,   304,   305,
     306,   307,   308,   309,    -1,    -1,   312,   313,   314,   315,
     316,   317,   318,   319,    -1,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
      -1,   337,   338,   339,   340,   341,   342,   343,   344,   345,
     346,   347,   348,   349,    -1,   351,   352,    -1,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
     366,   367,   368,    -1,   370,   371,   372,   373,   374,    -1,
     376,   377,   378,   379,   380,    -1,   382,   383,   384,   385,
      -1,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,   399,   400,   401,    -1,   403,   404,    -1,
     406,    -1,   408,   409,   410,   411,   412,    -1,   414,   415,
     416,    -1,    -1,   419,   420,   421,   422,   423,    -1,   425,
     426,   427,   428,   429,   430,   431,   432,    -1,    -1,   435,
     436,   437,   438,   439,    -1,    -1,   442,   443,   444,   445,
     446,   447,   448,    -1,   450,    -1,   452,   453,   454,   455,
      -1,    -1,   458,    -1,    -1,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,   478,   479,   480,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    20,    21,    22,    23,    24,    25,    26,    27,
      -1,    29,    30,    31,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    39,    40,    41,    -1,    43,    44,    45,    46,    -1,
      48,    49,    50,    51,    52,    -1,    54,    55,    -1,    57,
      58,    59,    60,    61,    62,    63,    -1,    -1,    66,    67,
      68,    69,    70,    -1,    72,    73,    74,    75,    76,    -1,
      -1,    -1,    80,    81,    82,    83,    84,    85,    -1,    87,
      88,    89,    -1,    91,    92,    93,    94,    95,    96,    -1,
      -1,    99,   100,   101,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   109,   110,   111,   112,   113,   114,   115,   116,   117,
     118,   119,    -1,   121,   122,   123,   124,   125,   126,   127,
      -1,   129,   130,   131,   132,    -1,    -1,   135,   136,   137,
     138,   139,    -1,   141,   142,   143,    -1,   145,   146,   147,
      -1,   149,   150,   151,   152,   153,   154,   155,   156,   157,
     158,    -1,   160,    -1,   162,   163,   164,   165,   166,    -1,
     168,    -1,   170,    -1,    -1,    -1,   174,   175,   176,   177,
      -1,   179,   180,    -1,   182,   183,   184,    -1,   186,   187,
     188,   189,   190,    -1,   192,   193,   194,   195,    -1,   197,
     198,   199,   200,   201,   202,   203,    -1,   205,    -1,   207,
     208,   209,   210,   211,   212,   213,    -1,   215,    -1,   217,
      -1,    -1,   220,    -1,   222,   223,   224,   225,   226,    -1,
      -1,   229,   230,    -1,   232,    -1,    -1,   235,   236,   237,
      -1,    -1,   240,   241,   242,   243,   244,   245,   246,   247,
     248,   249,   250,   251,   252,   253,   254,   255,   256,   257,
     258,    -1,   260,   261,   262,   263,   264,   265,   266,   267,
     268,   269,   270,    -1,   272,   273,    -1,   275,    -1,   277,
     278,   279,   280,   281,   282,    -1,   284,   285,    -1,    -1,
     288,   289,   290,    -1,    -1,   293,   294,   295,    -1,   297,
      -1,   299,   300,   301,   302,   303,   304,   305,   306,   307,
     308,   309,    -1,    -1,   312,   313,   314,   315,   316,   317,
     318,   319,    -1,   321,   322,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,   333,   334,   335,    -1,   337,
     338,   339,   340,   341,   342,   343,   344,   345,   346,   347,
     348,   349,    -1,   351,   352,    -1,   354,   355,   356,   357,
     358,   359,   360,   361,   362,   363,   364,   365,   366,   367,
     368,    -1,   370,   371,   372,   373,   374,    -1,   376,   377,
     378,   379,   380,    -1,   382,   383,   384,   385,    -1,   387,
     388,   389,   390,   391,   392,   393,   394,   395,   396,   397,
     398,   399,   400,   401,    -1,   403,   404,    -1,   406,    -1,
     408,   409,   410,   411,   412,    -1,   414,   415,   416,    -1,
      -1,   419,   420,   421,   422,   423,    -1,   425,   426,   427,
     428,   429,   430,   431,   432,    -1,    -1,   435,   436,   437,
     438,   439,    -1,    -1,   442,   443,   444,   445,   446,   447,
     448,    -1,   450,    -1,   452,   453,   454,   455,    -1,    -1,
     458,    -1,    -1,   461,   462,   463,   464,   465,   466,   467,
     468,   469,   470,   471,   472,   473,   474,   475,   476,   477,
     478,   479,   480,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      20,    21,    22,    23,    24,    25,    26,    27,    -1,    29,
      30,    31,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    39,
      40,    41,    -1,    43,    44,    45,    46,    -1,    48,    49,
      50,    51,    52,    -1,    54,    55,    -1,    57,    58,    59,
      60,    61,    62,    63,    -1,    -1,    66,    67,    68,    69,
      70,    -1,    72,    73,    74,    75,    76,    -1,    -1,    -1,
      80,    81,    82,    83,    84,    85,    -1,    87,    88,    89,
      -1,    91,    92,    93,    94,    95,    96,    -1,    -1,    99,
     100,   101,    -1,    -1,    -1,   105,    -1,    -1,    -1,   109,
     110,   111,   112,   113,   114,   115,   116,   117,    -1,   119,
      -1,   121,   122,   123,   124,   125,   126,   127,    -1,   129,
     130,   131,   132,    -1,    -1,   135,   136,   137,   138,   139,
      -1,   141,   142,   143,    -1,   145,   146,   147,    -1,   149,
     150,   151,   152,   153,   154,   155,   156,   157,   158,    -1,
     160,    -1,   162,   163,   164,   165,   166,    -1,   168,    -1,
     170,    -1,    -1,    -1,   174,   175,   176,   177,    -1,   179,
     180,    -1,   182,   183,   184,    -1,   186,   187,   188,   189,
     190,    -1,   192,   193,   194,   195,    -1,   197,   198,   199,
     200,   201,   202,   203,    -1,   205,    -1,   207,   208,   209,
     210,   211,   212,   213,    -1,   215,    -1,   217,    -1,    -1,
     220,    -1,   222,   223,   224,   225,   226,    -1,    -1,   229,
     230,    -1,   232,    -1,    -1,   235,   236,   237,    -1,    -1,
     240,   241,   242,   243,   244,   245,   246,   247,   248,   249,
     250,   251,   252,   253,   254,   255,   256,   257,   258,    -1,
     260,   261,   262,   263,   264,   265,   266,   267,   268,   269,
     270,    -1,   272,   273,    -1,   275,    -1,   277,   278,   279,
     280,   281,   282,    -1,   284,   285,    -1,    -1,   288,   289,
     290,    -1,    -1,   293,   294,   295,    -1,   297,    -1,   299,
     300,   301,   302,   303,   304,   305,   306,   307,   308,   309,
      -1,    -1,   312,   313,   314,   315,   316,   317,   318,   319,
      -1,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,    -1,   337,   338,   339,
     340,   341,   342,   343,   344,   345,   346,   347,   348,   349,
      -1,   351,   352,    -1,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,   365,   366,   367,   368,    -1,
     370,   371,   372,   373,   374,    -1,   376,   377,   378,   379,
     380,    -1,   382,   383,   384,   385,    -1,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,   399,
     400,   401,    -1,   403,   404,    -1,   406,    -1,   408,   409,
     410,   411,   412,    -1,   414,   415,   416,    -1,    -1,   419,
     420,   421,   422,   423,    -1,   425,   426,   427,   428,   429,
     430,   431,   432,    -1,    -1,   435,   436,   437,   438,   439,
      -1,    -1,   442,   443,   444,   445,   446,   447,   448,    -1,
     450,    -1,   452,   453,   454,   455,    -1,    -1,   458,    -1,
      -1,   461,   462,   463,   464,   465,   466,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,    21,
      22,    23,    24,    25,    26,    27,    -1,    29,    30,    31,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    39,    40,    41,
      -1,    43,    44,    45,    46,    -1,    48,    49,    50,    51,
      52,    -1,    54,    55,    -1,    57,    58,    59,    60,    61,
      62,    63,    -1,    -1,    66,    67,    68,    69,    70,    -1,
      72,    73,    74,    75,    76,    -1,    -1,    -1,    80,    81,
      82,    83,    84,    85,    -1,    87,    88,    89,    -1,    91,
      92,    93,    94,    95,    96,    -1,    -1,    99,   100,   101,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   109,   110,   111,
     112,   113,   114,   115,   116,   117,    -1,   119,    -1,   121,
     122,   123,   124,   125,   126,   127,    -1,   129,   130,   131,
     132,    -1,    -1,   135,   136,   137,   138,   139,    -1,   141,
     142,   143,    -1,   145,   146,   147,    -1,   149,   150,   151,
     152,   153,   154,   155,   156,   157,   158,    -1,   160,    -1,
     162,   163,   164,   165,   166,    -1,   168,    -1,   170,    -1,
      -1,    -1,   174,   175,   176,   177,    -1,   179,   180,    -1,
     182,   183,   184,    -1,   186,   187,   188,   189,   190,    -1,
     192,   193,   194,   195,    -1,   197,   198,   199,   200,   201,
     202,   203,    -1,   205,    -1,   207,   208,   209,   210,   211,
     212,   213,    -1,   215,    -1,   217,    -1,    -1,   220,    -1,
     222,   223,   224,   225,   226,    -1,    -1,   229,   230,    -1,
     232,    -1,    -1,   235,   236,   237,    -1,    -1,   240,   241,
     242,   243,   244,   245,   246,   247,   248,   249,   250,   251,
     252,   253,   254,   255,   256,   257,   258,    -1,   260,   261,
     262,   263,   264,   265,   266,   267,   268,   269,   270,    -1,
     272,   273,    -1,   275,    -1,   277,   278,   279,   280,   281,
     282,    -1,   284,   285,    -1,    -1,   288,   289,   290,    -1,
      -1,   293,   294,   295,    -1,   297,    -1,   299,   300,   301,
     302,   303,   304,   305,   306,   307,   308,   309,    -1,    -1,
     312,   313,   314,   315,   316,   317,   318,   319,    -1,   321,
     322,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,   333,   334,   335,    -1,   337,   338,   339,   340,   341,
     342,   343,   344,   345,   346,   347,   348,   349,    -1,   351,
     352,    -1,   354,   355,   356,   357,   358,   359,   360,   361,
     362,   363,   364,   365,   366,   367,   368,    -1,   370,   371,
     372,   373,   374,    -1,   376,   377,   378,   379,   380,    -1,
     382,   383,   384,   385,    -1,   387,   388,   389,   390,   391,
     392,   393,   394,   395,   396,   397,   398,   399,   400,   401,
      -1,   403,   404,    -1,   406,    -1,   408,   409,   410,   411,
     412,    -1,   414,   415,   416,    -1,    -1,   419,   420,   421,
     422,   423,    -1,   425,   426,   427,   428,   429,   430,   431,
     432,    -1,    -1,   435,   436,   437,   438,   439,    -1,    -1,
     442,   443,   444,   445,   446,   447,   448,    -1,   450,    -1,
     452,   453,   454,   455,    -1,    -1,   458,    -1,    -1,   461,
     462,   463,   464,   465,   466,   467,   468,   469,   470,   471,
     472,   473,   474,   475,   476,   477,   478,   479,   480,     3,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    20,    21,    22,    23,
      24,    25,    26,    27,    -1,    29,    30,    31,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    39,    40,    41,    -1,    43,
      44,    45,    46,    -1,    48,    49,    50,    51,    52,    -1,
      54,    55,    -1,    57,    58,    59,    60,    61,    62,    63,
      -1,    -1,    66,    67,    68,    69,    70,    -1,    72,    73,
      74,    75,    76,    -1,    -1,    -1,    80,    81,    82,    83,
      84,    85,    -1,    87,    88,    89,    -1,    91,    92,    93,
      94,    95,    96,    -1,    -1,    99,   100,   101,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   109,   110,   111,   112,   113,
     114,   115,   116,   117,    -1,   119,    -1,   121,   122,   123,
     124,   125,   126,   127,    -1,   129,   130,   131,   132,    -1,
      -1,   135,   136,   137,   138,   139,    -1,   141,   142,   143,
      -1,   145,   146,   147,    -1,   149,   150,   151,   152,   153,
     154,   155,   156,   157,   158,    -1,   160,    -1,   162,   163,
     164,   165,   166,    -1,   168,    -1,   170,    -1,    -1,    -1,
     174,   175,   176,   177,    -1,   179,   180,    -1,   182,   183,
     184,    -1,   186,   187,   188,   189,   190,    -1,   192,   193,
     194,   195,    -1,   197,   198,   199,   200,   201,   202,   203,
      -1,   205,    -1,   207,   208,   209,   210,   211,   212,   213,
      -1,   215,    -1,   217,    -1,    -1,   220,    -1,   222,   223,
     224,   225,   226,    -1,    -1,   229,   230,    -1,   232,    -1,
      -1,   235,   236,   237,    -1,    -1,   240,   241,   242,   243,
     244,   245,   246,   247,   248,   249,   250,   251,   252,   253,
     254,   255,   256,   257,   258,    -1,   260,   261,   262,   263,
     264,   265,   266,   267,   268,   269,   270,    -1,   272,   273,
      -1,   275,    -1,   277,   278,   279,   280,   281,   282,    -1,
     284,   285,    -1,    -1,   288,   289,   290,    -1,    -1,   293,
     294,   295,    -1,   297,    -1,   299,   300,   301,   302,   303,
     304,   305,   306,   307,   308,   309,    -1,    -1,   312,   313,
     314,   315,   316,   317,   318,   319,    -1,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,   333,
     334,   335,    -1,   337,   338,   339,   340,   341,   342,   343,
     344,   345,   346,   347,   348,   349,    -1,   351,   352,    -1,
     354,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,   365,   366,   367,   368,    -1,   370,   371,   372,   373,
     374,    -1,   376,   377,   378,   379,   380,    -1,   382,   383,
     384,   385,    -1,   387,   388,   389,   390,   391,   392,   393,
     394,   395,   396,   397,   398,   399,   400,   401,    -1,   403,
     404,    -1,   406,    -1,   408,   409,   410,   411,   412,    -1,
     414,   415,   416,    -1,    -1,   419,   420,   421,   422,   423,
      -1,   425,   426,   427,   428,   429,   430,   431,   432,    -1,
      -1,   435,   436,   437,   438,   439,    -1,    -1,   442,   443,
     444,   445,   446,   447,   448,    -1,   450,    -1,   452,   453,
     454,   455,    -1,    -1,   458,    -1,    -1,   461,   462,   463,
     464,   465,   466,   467,   468,   469,   470,   471,   472,   473,
     474,   475,   476,   477,   478,   479,   480,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,    25,
      26,    27,    -1,    29,    30,    31,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    39,    40,    41,    -1,    43,    44,    45,
      46,    -1,    48,    49,    50,    51,    52,    -1,    54,    55,
      -1,    57,    58,    59,    60,    61,    62,    63,    -1,    -1,
      66,    67,    68,    69,    70,    -1,    72,    73,    74,    75,
      76,    -1,    -1,    -1,    80,    81,    82,    83,    84,    85,
      -1,    87,    88,    89,    -1,    91,    92,    93,    94,    95,
      96,    -1,    -1,    99,   100,   101,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   109,   110,   111,   112,   113,   114,   115,
     116,   117,    -1,   119,    -1,   121,   122,   123,   124,   125,
     126,   127,    -1,   129,   130,   131,   132,    -1,    -1,   135,
     136,   137,   138,   139,    -1,   141,   142,   143,    -1,   145,
     146,   147,    -1,   149,   150,   151,   152,   153,   154,   155,
     156,   157,   158,    -1,   160,    -1,   162,   163,   164,   165,
     166,    -1,   168,    -1,   170,    -1,    -1,    -1,   174,   175,
     176,   177,    -1,   179,   180,    -1,   182,   183,   184,    -1,
     186,   187,   188,   189,   190,    -1,   192,   193,   194,   195,
      -1,   197,   198,   199,   200,   201,   202,   203,    -1,   205,
      -1,   207,   208,   209,   210,   211,   212,   213,    -1,   215,
      -1,   217,    -1,    -1,   220,    -1,   222,   223,   224,   225,
     226,    -1,    -1,   229,   230,    -1,   232,    -1,    -1,   235,
     236,   237,    -1,    -1,   240,   241,   242,   243,   244,   245,
     246,   247,   248,   249,   250,   251,   252,   253,   254,   255,
     256,   257,   258,    -1,   260,   261,   262,   263,   264,   265,
     266,   267,   268,   269,   270,    -1,   272,   273,    -1,   275,
      -1,   277,   278,   279,   280,   281,   282,    -1,   284,   285,
      -1,    -1,   288,   289,   290,    -1,    -1,   293,   294,   295,
      -1,   297,    -1,   299,   300,   301,   302,   303,   304,   305,
     306,   307,   308,   309,    -1,    -1,   312,   313,   314,   315,
     316,   317,   318,   319,    -1,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
      -1,   337,   338,   339,   340,   341,   342,   343,   344,   345,
     346,   347,   348,   349,    -1,   351,   352,    -1,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
     366,   367,   368,    -1,   370,   371,   372,   373,   374,    -1,
     376,   377,   378,   379,   380,    -1,   382,   383,   384,   385,
      -1,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,   399,   400,   401,    -1,   403,   404,    -1,
     406,    -1,   408,   409,   410,   411,   412,    -1,   414,   415,
     416,    -1,    -1,   419,   420,   421,   422,   423,    -1,   425,
     426,   427,   428,   429,   430,   431,   432,    -1,    -1,   435,
     436,   437,   438,   439,    -1,    -1,   442,   443,   444,   445,
     446,   447,   448,    -1,   450,    -1,   452,   453,   454,   455,
      -1,    -1,   458,    -1,    -1,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,   478,   479,   480,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    20,    21,    22,    23,    24,    25,    26,    27,
      -1,    29,    30,    31,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    39,    40,    41,    -1,    43,    44,    45,    46,    -1,
      48,    49,    50,    51,    52,    -1,    54,    55,    -1,    57,
      58,    59,    60,    61,    62,    63,    -1,    -1,    66,    67,
      68,    69,    70,    -1,    72,    73,    74,    75,    76,    -1,
      -1,    -1,    80,    81,    82,    83,    84,    85,    -1,    87,
      88,    89,    -1,    91,    92,    93,    94,    95,    96,    -1,
      -1,    99,   100,   101,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   109,   110,   111,   112,   113,   114,   115,   116,   117,
      -1,   119,    -1,   121,   122,   123,   124,   125,   126,   127,
      -1,   129,   130,   131,   132,    -1,    -1,   135,   136,   137,
     138,   139,    -1,   141,   142,   143,    -1,   145,   146,   147,
      -1,   149,   150,   151,   152,   153,   154,   155,   156,   157,
     158,    -1,   160,    -1,   162,   163,   164,   165,   166,    -1,
     168,    -1,   170,    -1,    -1,    -1,   174,   175,   176,   177,
      -1,   179,   180,    -1,   182,   183,   184,    -1,   186,   187,
     188,   189,   190,    -1,   192,   193,   194,   195,    -1,   197,
     198,   199,   200,   201,   202,   203,    -1,   205,    -1,   207,
     208,   209,   210,   211,   212,   213,    -1,   215,    -1,   217,
      -1,    -1,   220,    -1,   222,   223,   224,   225,   226,    -1,
      -1,   229,   230,    -1,   232,    -1,    -1,   235,   236,   237,
      -1,    -1,   240,   241,   242,   243,   244,   245,   246,   247,
     248,   249,   250,   251,   252,   253,   254,   255,   256,   257,
     258,    -1,   260,   261,   262,   263,   264,   265,   266,   267,
     268,   269,   270,    -1,   272,   273,    -1,   275,    -1,   277,
     278,   279,   280,   281,   282,    -1,   284,   285,    -1,    -1,
     288,   289,   290,    -1,    -1,   293,   294,   295,    -1,   297,
      -1,   299,   300,   301,   302,   303,   304,   305,   306,   307,
     308,   309,    -1,    -1,   312,   313,   314,   315,   316,   317,
     318,   319,    -1,   321,   322,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,   333,   334,   335,    -1,   337,
     338,   339,   340,   341,   342,   343,   344,   345,   346,   347,
     348,   349,    -1,   351,   352,    -1,   354,   355,   356,   357,
     358,   359,   360,   361,   362,   363,   364,   365,   366,   367,
     368,    -1,   370,   371,   372,   373,   374,    -1,   376,   377,
     378,   379,   380,    -1,   382,   383,   384,   385,    -1,   387,
     388,   389,   390,   391,   392,   393,   394,   395,   396,   397,
     398,   399,   400,   401,    -1,   403,   404,    -1,   406,    -1,
     408,   409,   410,   411,   412,    -1,   414,   415,   416,    -1,
      -1,   419,   420,   421,   422,   423,    -1,   425,   426,   427,
     428,   429,   430,   431,   432,    -1,    -1,   435,   436,   437,
     438,   439,    -1,    -1,   442,   443,   444,   445,   446,   447,
     448,    -1,   450,    -1,   452,   453,   454,   455,    -1,    -1,
     458,    -1,    -1,   461,   462,   463,   464,   465,   466,   467,
     468,   469,   470,   471,   472,   473,   474,   475,   476,   477,
     478,   479,   480,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      20,    21,    22,    23,    24,    25,    26,    27,    -1,    29,
      30,    31,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    39,
      40,    41,    -1,    43,    44,    45,    46,    -1,    48,    49,
      50,    51,    52,    -1,    54,    55,    -1,    57,    58,    59,
      60,    61,    62,    63,    -1,    -1,    66,    67,    68,    69,
      70,    -1,    72,    73,    74,    75,    76,    -1,    -1,    -1,
      80,    81,    82,    83,    84,    85,    -1,    87,    88,    89,
      -1,    91,    92,    93,    94,    95,    96,    -1,    -1,    99,
     100,   101,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   109,
     110,   111,   112,   113,   114,   115,   116,   117,    -1,   119,
      -1,   121,   122,   123,   124,   125,   126,   127,    -1,   129,
     130,   131,   132,    -1,    -1,   135,   136,   137,   138,   139,
      -1,   141,   142,   143,    -1,   145,   146,   147,    -1,   149,
     150,   151,   152,   153,   154,   155,   156,   157,   158,    -1,
     160,    -1,   162,   163,   164,   165,   166,    -1,   168,    -1,
     170,    -1,    -1,    -1,   174,   175,   176,   177,    -1,   179,
     180,    -1,   182,   183,   184,    -1,   186,   187,   188,   189,
     190,    -1,   192,   193,   194,   195,    -1,   197,   198,   199,
     200,   201,   202,   203,    -1,   205,    -1,   207,   208,   209,
     210,   211,   212,   213,    -1,   215,    -1,   217,    -1,    -1,
     220,    -1,   222,   223,   224,   225,   226,    -1,    -1,   229,
     230,    -1,   232,    -1,    -1,   235,   236,   237,    -1,    -1,
     240,   241,   242,   243,   244,   245,   246,   247,   248,   249,
     250,   251,   252,   253,   254,   255,   256,   257,   258,    -1,
     260,   261,   262,   263,   264,   265,   266,   267,   268,   269,
     270,    -1,   272,   273,    -1,   275,    -1,   277,   278,   279,
     280,   281,   282,    -1,   284,   285,    -1,    -1,   288,   289,
     290,    -1,    -1,   293,   294,   295,    -1,   297,    -1,   299,
     300,   301,   302,   303,   304,   305,   306,   307,   308,   309,
      -1,    -1,   312,   313,   314,   315,   316,   317,   318,   319,
      -1,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,    -1,   337,   338,   339,
     340,   341,   342,   343,   344,   345,   346,   347,   348,   349,
      -1,   351,   352,    -1,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,   365,   366,   367,   368,    -1,
     370,   371,   372,   373,   374,    -1,   376,   377,   378,   379,
     380,    -1,   382,   383,   384,   385,    -1,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,   399,
     400,   401,    -1,   403,   404,    -1,   406,    -1,   408,   409,
     410,   411,   412,    -1,   414,   415,   416,    -1,    -1,   419,
     420,   421,   422,   423,    -1,   425,   426,   427,   428,   429,
     430,   431,   432,    -1,    -1,   435,   436,   437,   438,   439,
      -1,    -1,   442,   443,   444,   445,   446,   447,   448,    -1,
     450,    -1,   452,   453,   454,   455,    -1,    -1,   458,    -1,
      -1,   461,   462,   463,   464,   465,   466,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,    21,
      22,    23,    24,    25,    26,    27,    -1,    29,    30,    31,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    39,    40,    41,
      -1,    43,    44,    45,    46,    -1,    48,    49,    50,    51,
      52,    -1,    54,    55,    -1,    57,    58,    59,    60,    61,
      62,    63,    -1,    -1,    66,    67,    68,    69,    70,    -1,
      72,    73,    74,    75,    76,    -1,    -1,    -1,    80,    81,
      82,    83,    84,    85,    -1,    87,    88,    89,    -1,    91,
      92,    93,    94,    95,    96,    -1,    -1,    99,   100,   101,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   109,   110,   111,
     112,   113,   114,   115,   116,   117,    -1,   119,    -1,   121,
     122,   123,   124,   125,   126,   127,    -1,   129,   130,   131,
     132,    -1,    -1,   135,   136,   137,   138,   139,    -1,   141,
     142,   143,    -1,   145,   146,   147,    -1,   149,   150,   151,
     152,   153,   154,   155,   156,   157,   158,    -1,   160,    -1,
     162,   163,   164,   165,   166,    -1,   168,    -1,   170,    -1,
      -1,    -1,   174,   175,   176,   177,    -1,   179,   180,    -1,
     182,   183,   184,    -1,   186,   187,   188,   189,   190,    -1,
     192,   193,   194,   195,    -1,   197,   198,   199,   200,   201,
     202,   203,    -1,   205,    -1,   207,   208,   209,   210,   211,
     212,   213,    -1,   215,    -1,   217,    -1,    -1,   220,    -1,
     222,   223,   224,   225,   226,    -1,    -1,   229,   230,    -1,
     232,    -1,    -1,   235,   236,   237,    -1,    -1,   240,   241,
     242,   243,   244,   245,   246,   247,   248,   249,   250,   251,
     252,   253,   254,   255,   256,   257,   258,    -1,   260,   261,
     262,   263,   264,   265,   266,   267,   268,   269,   270,    -1,
     272,   273,    -1,   275,    -1,   277,   278,   279,   280,   281,
     282,    -1,   284,   285,    -1,    -1,   288,   289,   290,    -1,
      -1,   293,   294,   295,    -1,   297,    -1,   299,   300,   301,
     302,   303,   304,   305,   306,   307,   308,   309,    -1,    -1,
     312,   313,   314,   315,   316,   317,   318,   319,    -1,   321,
     322,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,   333,   334,   335,    -1,   337,   338,   339,   340,   341,
     342,   343,   344,   345,   346,   347,   348,   349,    -1,   351,
     352,    -1,   354,   355,   356,   357,   358,   359,   360,   361,
     362,   363,   364,   365,   366,   367,   368,    -1,   370,   371,
     372,   373,   374,    -1,   376,   377,   378,   379,   380,    -1,
     382,   383,   384,   385,    -1,   387,   388,   389,   390,   391,
     392,   393,   394,   395,   396,   397,   398,   399,   400,   401,
      -1,   403,   404,    -1,   406,    -1,   408,   409,   410,   411,
     412,    -1,   414,   415,   416,    -1,    -1,   419,   420,   421,
     422,   423,    -1,   425,   426,   427,   428,   429,   430,   431,
     432,    -1,    -1,   435,   436,   437,   438,   439,    -1,    -1,
     442,   443,   444,   445,   446,   447,   448,    -1,   450,    -1,
     452,   453,   454,   455,    -1,    -1,   458,    -1,    -1,   461,
     462,   463,   464,   465,   466,   467,   468,   469,   470,   471,
     472,   473,   474,   475,   476,   477,   478,   479,   480,     3,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    20,    21,    22,    23,
      24,    25,    26,    27,    -1,    29,    30,    31,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    39,    40,    41,    -1,    43,
      44,    45,    46,    -1,    48,    49,    50,    51,    52,    -1,
      54,    55,    -1,    57,    58,    59,    60,    61,    62,    63,
      -1,    -1,    66,    67,    68,    69,    70,    -1,    72,    73,
      74,    75,    76,    -1,    -1,    -1,    80,    81,    82,    83,
      84,    85,    -1,    87,    88,    89,    -1,    91,    92,    93,
      94,    95,    96,    -1,    -1,    99,   100,   101,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   109,   110,   111,   112,   113,
     114,   115,   116,   117,    -1,   119,    -1,   121,   122,   123,
     124,   125,   126,   127,    -1,   129,   130,   131,   132,    -1,
      -1,   135,   136,   137,   138,   139,    -1,   141,   142,   143,
      -1,   145,   146,   147,    -1,   149,   150,   151,   152,   153,
     154,   155,   156,   157,   158,    -1,   160,    -1,   162,   163,
     164,   165,   166,    -1,   168,    -1,   170,    -1,    -1,    -1,
     174,   175,   176,   177,    -1,   179,   180,    -1,   182,   183,
     184,    -1,   186,   187,   188,   189,   190,    -1,   192,   193,
     194,   195,    -1,   197,   198,   199,   200,   201,   202,   203,
      -1,   205,    -1,   207,   208,   209,   210,   211,   212,   213,
      -1,   215,    -1,   217,    -1,    -1,   220,    -1,   222,   223,
     224,   225,   226,    -1,    -1,   229,   230,    -1,   232,    -1,
      -1,   235,   236,   237,    -1,    -1,   240,   241,   242,   243,
     244,   245,   246,   247,   248,   249,   250,   251,   252,   253,
     254,   255,   256,   257,   258,    -1,   260,   261,   262,   263,
     264,   265,   266,   267,   268,   269,   270,    -1,   272,   273,
      -1,   275,    -1,   277,   278,   279,   280,   281,   282,    -1,
     284,   285,    -1,    -1,   288,   289,   290,    -1,    -1,   293,
     294,   295,    -1,   297,    -1,   299,   300,   301,   302,   303,
     304,   305,   306,   307,   308,   309,    -1,    -1,   312,   313,
     314,   315,   316,   317,   318,   319,    -1,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,   333,
     334,   335,    -1,   337,   338,   339,   340,   341,   342,   343,
     344,   345,   346,   347,   348,   349,    -1,   351,   352,    -1,
     354,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,   365,   366,   367,   368,    -1,   370,   371,   372,   373,
     374,    -1,   376,   377,   378,   379,   380,    -1,   382,   383,
     384,   385,    -1,   387,   388,   389,   390,   391,   392,   393,
     394,   395,   396,   397,   398,   399,   400,   401,    -1,   403,
     404,    -1,   406,    -1,   408,   409,   410,   411,   412,    -1,
     414,   415,   416,    -1,    -1,   419,   420,   421,   422,   423,
      -1,   425,   426,   427,   428,   429,   430,   431,   432,    -1,
      -1,   435,   436,   437,   438,   439,    -1,    -1,   442,   443,
     444,   445,   446,   447,   448,    -1,   450,    -1,   452,   453,
     454,   455,    -1,    -1,   458,    -1,    -1,   461,   462,   463,
     464,   465,   466,   467,   468,   469,   470,   471,   472,   473,
     474,   475,   476,   477,   478,   479,   480,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,    25,
      26,    27,    -1,    29,    30,    31,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    39,    40,    41,    -1,    43,    44,    45,
      46,    -1,    48,    49,    50,    51,    52,    -1,    54,    55,
      -1,    57,    58,    59,    60,    61,    62,    63,    -1,    -1,
      66,    67,    68,    69,    70,    -1,    72,    73,    74,    75,
      76,    -1,    -1,    -1,    80,    81,    82,    83,    84,    85,
      -1,    87,    88,    89,    -1,    91,    92,    93,    94,    95,
      96,    -1,    -1,    99,   100,   101,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   109,   110,   111,   112,   113,   114,   115,
     116,   117,    -1,   119,    -1,   121,   122,   123,   124,   125,
     126,   127,    -1,   129,   130,   131,   132,    -1,    -1,   135,
     136,   137,   138,   139,    -1,   141,   142,   143,    -1,   145,
     146,   147,    -1,   149,   150,   151,   152,   153,   154,   155,
     156,   157,   158,    -1,   160,    -1,   162,   163,   164,   165,
     166,    -1,   168,    -1,   170,    -1,    -1,    -1,   174,   175,
     176,   177,    -1,   179,   180,    -1,   182,   183,   184,    -1,
     186,   187,   188,   189,   190,    -1,   192,   193,   194,   195,
      -1,   197,   198,   199,   200,   201,   202,   203,    -1,   205,
      -1,   207,   208,   209,   210,   211,   212,   213,    -1,   215,
      -1,   217,    -1,    -1,   220,    -1,   222,   223,   224,   225,
     226,    -1,    -1,   229,   230,    -1,   232,    -1,    -1,   235,
     236,   237,    -1,    -1,   240,   241,   242,   243,   244,   245,
     246,   247,   248,   249,   250,   251,   252,   253,   254,   255,
     256,   257,   258,    -1,   260,   261,   262,   263,   264,   265,
     266,   267,   268,   269,   270,    -1,   272,   273,    -1,   275,
      -1,   277,   278,   279,   280,   281,   282,    -1,   284,   285,
      -1,    -1,   288,   289,   290,    -1,    -1,   293,   294,   295,
      -1,   297,    -1,   299,   300,   301,   302,   303,   304,   305,
     306,   307,   308,   309,    -1,    -1,   312,   313,   314,   315,
     316,   317,   318,   319,    -1,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
      -1,   337,   338,   339,   340,   341,   342,   343,   344,   345,
     346,   347,   348,   349,    -1,   351,   352,    -1,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
     366,   367,   368,    -1,   370,   371,   372,   373,   374,    -1,
     376,   377,   378,   379,   380,    -1,   382,   383,   384,   385,
      -1,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,   399,   400,   401,    -1,   403,   404,    -1,
     406,    -1,   408,   409,   410,   411,   412,    -1,   414,   415,
     416,    -1,    -1,   419,   420,   421,   422,   423,    -1,   425,
     426,   427,   428,   429,   430,   431,   432,    -1,    -1,   435,
     436,   437,   438,   439,    -1,    -1,   442,   443,   444,   445,
     446,   447,   448,    -1,   450,    -1,   452,   453,   454,   455,
      -1,    -1,   458,    -1,    -1,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,   478,   479,   480,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    20,    21,    22,    23,    24,    25,    26,    27,
      -1,    29,    30,    31,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    39,    40,    41,    -1,    43,    44,    45,    46,    -1,
      48,    49,    50,    51,    52,    -1,    54,    55,    -1,    57,
      58,    59,    60,    61,    62,    63,    -1,    -1,    66,    67,
      68,    69,    70,    -1,    72,    73,    74,    75,    76,    -1,
      -1,    -1,    80,    81,    82,    83,    84,    85,    -1,    87,
      88,    89,    -1,    91,    92,    93,    94,    95,    96,    -1,
      -1,    99,   100,   101,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   109,   110,   111,   112,   113,   114,   115,   116,   117,
      -1,   119,    -1,   121,   122,   123,   124,   125,   126,   127,
      -1,   129,   130,   131,   132,    -1,    -1,   135,   136,   137,
     138,   139,    -1,   141,   142,   143,    -1,   145,   146,   147,
      -1,   149,   150,   151,   152,   153,   154,   155,   156,   157,
     158,    -1,   160,    -1,   162,   163,   164,   165,   166,    -1,
     168,    -1,   170,    -1,    -1,    -1,   174,   175,   176,   177,
      -1,   179,   180,    -1,   182,   183,   184,    -1,   186,   187,
     188,   189,   190,    -1,   192,   193,   194,   195,    -1,   197,
     198,   199,   200,   201,   202,   203,    -1,   205,    -1,   207,
     208,   209,   210,   211,   212,   213,    -1,   215,    -1,   217,
      -1,    -1,   220,    -1,   222,   223,   224,   225,   226,    -1,
      -1,   229,   230,    -1,   232,    -1,    -1,   235,   236,   237,
      -1,    -1,   240,   241,   242,   243,   244,   245,   246,   247,
     248,   249,   250,   251,   252,   253,   254,   255,   256,   257,
     258,    -1,   260,   261,   262,   263,   264,   265,   266,   267,
     268,   269,   270,    -1,   272,   273,    -1,   275,    -1,   277,
     278,   279,   280,   281,   282,    -1,   284,   285,    -1,    -1,
     288,   289,   290,    -1,    -1,   293,   294,   295,    -1,   297,
      -1,   299,   300,   301,   302,   303,   304,   305,   306,   307,
     308,   309,    -1,    -1,   312,   313,   314,   315,   316,   317,
     318,   319,    -1,   321,   322,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,   333,   334,   335,    -1,   337,
     338,   339,   340,   341,   342,   343,   344,   345,   346,   347,
     348,   349,    -1,   351,   352,    -1,   354,   355,   356,   357,
     358,   359,   360,   361,   362,   363,   364,   365,   366,   367,
     368,    -1,   370,   371,   372,   373,   374,    -1,   376,   377,
     378,   379,   380,    -1,   382,   383,   384,   385,    -1,   387,
     388,   389,   390,   391,   392,   393,   394,   395,   396,   397,
     398,   399,   400,   401,    -1,   403,   404,    -1,   406,    -1,
     408,   409,   410,   411,   412,    -1,   414,   415,   416,    -1,
      -1,   419,   420,   421,   422,   423,    -1,   425,   426,   427,
     428,   429,   430,   431,   432,    -1,    -1,   435,   436,   437,
     438,   439,    -1,    -1,   442,   443,   444,   445,   446,   447,
     448,    -1,   450,    -1,   452,   453,   454,   455,    -1,    -1,
     458,    -1,    -1,   461,   462,   463,   464,   465,   466,   467,
     468,   469,   470,   471,   472,   473,   474,   475,   476,   477,
     478,   479,   480,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      20,    21,    22,    23,    24,    25,    26,    27,    -1,    29,
      30,    31,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    39,
      40,    41,    -1,    43,    44,    45,    46,    -1,    48,    49,
      50,    51,    52,    -1,    54,    55,    -1,    57,    58,    59,
      60,    61,    62,    63,    -1,    -1,    66,    67,    68,    69,
      70,    -1,    72,    73,    74,    75,    76,    -1,    -1,    -1,
      80,    81,    82,    83,    84,    85,    -1,    87,    88,    89,
      -1,    91,    92,    93,    94,    95,    96,    -1,    -1,    99,
     100,   101,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   109,
     110,   111,   112,   113,   114,   115,   116,   117,    -1,   119,
      -1,   121,   122,   123,   124,   125,   126,   127,    -1,   129,
     130,   131,   132,    -1,    -1,   135,   136,   137,   138,   139,
      -1,   141,   142,   143,    -1,   145,   146,   147,    -1,   149,
     150,   151,   152,   153,   154,   155,   156,   157,   158,    -1,
     160,    -1,   162,   163,   164,   165,   166,    -1,   168,    -1,
     170,    -1,    -1,    -1,   174,   175,   176,   177,    -1,   179,
     180,    -1,   182,   183,   184,    -1,   186,   187,   188,   189,
     190,    -1,   192,   193,   194,   195,    -1,   197,   198,   199,
     200,   201,   202,   203,    -1,   205,    -1,   207,   208,   209,
     210,   211,   212,   213,    -1,   215,    -1,   217,    -1,    -1,
     220,    -1,   222,   223,   224,   225,   226,    -1,    -1,   229,
     230,    -1,   232,    -1,    -1,   235,   236,   237,    -1,    -1,
     240,   241,   242,   243,   244,   245,   246,   247,   248,   249,
     250,   251,   252,   253,   254,   255,   256,   257,   258,    -1,
     260,   261,   262,   263,   264,   265,   266,   267,   268,   269,
     270,    -1,   272,   273,    -1,   275,    -1,   277,   278,   279,
     280,   281,   282,    -1,   284,   285,    -1,    -1,   288,   289,
     290,    -1,    -1,   293,   294,   295,    -1,   297,    -1,   299,
     300,   301,   302,   303,   304,   305,   306,   307,   308,   309,
      -1,    -1,   312,   313,   314,   315,   316,   317,   318,   319,
      -1,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,    -1,   337,   338,   339,
     340,   341,   342,   343,   344,   345,   346,   347,   348,   349,
      -1,   351,   352,    -1,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,   365,   366,   367,   368,    -1,
     370,   371,   372,   373,   374,    -1,   376,   377,   378,   379,
     380,    -1,   382,   383,   384,   385,    -1,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,   399,
     400,   401,    -1,   403,   404,    -1,   406,    -1,   408,   409,
     410,   411,   412,    -1,   414,   415,   416,    -1,    -1,   419,
     420,   421,   422,   423,    -1,   425,   426,   427,   428,   429,
     430,   431,   432,    -1,    -1,   435,   436,   437,   438,   439,
      -1,    -1,   442,   443,   444,   445,   446,   447,   448,    -1,
     450,    -1,   452,   453,   454,   455,    -1,    -1,   458,    -1,
      -1,   461,   462,   463,   464,   465,   466,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,    21,
      22,    23,    24,    25,    26,    27,    -1,    29,    30,    31,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    39,    40,    41,
      -1,    43,    44,    45,    46,    -1,    48,    49,    50,    51,
      52,    -1,    54,    55,    -1,    57,    58,    59,    60,    61,
      62,    63,    -1,    -1,    66,    67,    68,    69,    70,    -1,
      72,    73,    74,    75,    76,    -1,    -1,    -1,    80,    81,
      82,    83,    84,    85,    -1,    87,    88,    89,    -1,    91,
      92,    93,    94,    95,    96,    -1,    -1,    99,   100,   101,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   109,   110,   111,
     112,   113,   114,   115,   116,   117,    -1,   119,    -1,   121,
     122,   123,   124,   125,   126,   127,    -1,   129,   130,   131,
     132,    -1,    -1,   135,   136,   137,   138,   139,    -1,   141,
     142,   143,    -1,   145,   146,   147,    -1,   149,   150,   151,
     152,   153,   154,   155,   156,   157,   158,    -1,   160,    -1,
     162,   163,   164,   165,   166,    -1,   168,    -1,   170,    -1,
      -1,    -1,   174,   175,   176,   177,    -1,   179,   180,    -1,
     182,   183,   184,    -1,   186,   187,   188,   189,   190,    -1,
     192,   193,   194,   195,    -1,   197,   198,   199,   200,   201,
     202,   203,    -1,   205,    -1,   207,   208,   209,   210,   211,
     212,   213,    -1,   215,    -1,   217,    -1,    -1,   220,    -1,
     222,   223,   224,   225,   226,    -1,    -1,   229,   230,    -1,
     232,    -1,    -1,   235,   236,   237,    -1,    -1,   240,   241,
     242,   243,   244,   245,   246,   247,   248,   249,   250,   251,
     252,   253,   254,   255,   256,   257,   258,    -1,   260,   261,
     262,   263,   264,   265,   266,   267,   268,   269,   270,    -1,
     272,   273,    -1,   275,    -1,   277,   278,   279,   280,   281,
     282,    -1,   284,   285,    -1,    -1,   288,   289,   290,    -1,
      -1,   293,   294,   295,    -1,   297,    -1,   299,   300,   301,
     302,   303,   304,   305,   306,   307,   308,   309,    -1,    -1,
     312,   313,   314,   315,   316,   317,   318,   319,    -1,   321,
     322,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,   333,   334,   335,    -1,   337,   338,   339,   340,   341,
     342,   343,   344,   345,   346,   347,   348,   349,    -1,   351,
     352,    -1,   354,   355,   356,   357,   358,   359,   360,   361,
     362,   363,   364,   365,   366,   367,   368,    -1,   370,   371,
     372,   373,   374,    -1,   376,   377,   378,   379,   380,    -1,
     382,   383,   384,   385,    -1,   387,   388,   389,   390,   391,
     392,   393,   394,   395,   396,   397,   398,   399,   400,   401,
      -1,   403,   404,    -1,   406,    -1,   408,   409,   410,   411,
     412,    -1,   414,   415,   416,    -1,    -1,   419,   420,   421,
     422,   423,    -1,   425,   426,   427,   428,   429,   430,   431,
     432,    -1,    -1,   435,   436,   437,   438,   439,    -1,    -1,
     442,   443,   444,   445,   446,   447,   448,    -1,   450,    -1,
     452,   453,   454,   455,    -1,    -1,   458,    -1,    -1,   461,
     462,   463,   464,   465,   466,   467,   468,   469,   470,   471,
     472,   473,   474,   475,   476,   477,   478,   479,   480,     3,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    20,    21,    22,    23,
      24,    25,    26,    27,    -1,    29,    30,    31,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    39,    40,    41,    -1,    43,
      44,    45,    46,    -1,    48,    49,    50,    51,    52,    -1,
      54,    55,    -1,    57,    58,    59,    60,    61,    62,    63,
      -1,    -1,    66,    67,    68,    69,    70,    -1,    72,    73,
      74,    75,    76,    -1,    -1,    -1,    80,    81,    82,    83,
      84,    85,    -1,    87,    88,    89,    -1,    91,    92,    93,
      94,    95,    96,    -1,    -1,    99,   100,   101,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   109,   110,   111,   112,   113,
     114,   115,   116,   117,    -1,   119,    -1,   121,   122,   123,
     124,   125,   126,   127,    -1,   129,   130,   131,   132,    -1,
      -1,   135,   136,   137,   138,   139,    -1,   141,   142,   143,
      -1,   145,   146,   147,    -1,   149,   150,   151,   152,   153,
     154,   155,   156,   157,   158,    -1,   160,    -1,   162,   163,
     164,   165,   166,    -1,   168,    -1,   170,    -1,    -1,    -1,
     174,   175,   176,   177,    -1,   179,   180,    -1,   182,   183,
     184,    -1,   186,   187,   188,   189,   190,    -1,   192,   193,
     194,   195,    -1,   197,   198,   199,   200,   201,   202,   203,
      -1,   205,    -1,   207,   208,   209,   210,   211,   212,   213,
      -1,   215,    -1,   217,    -1,    -1,   220,    -1,   222,   223,
     224,   225,   226,    -1,    -1,   229,   230,    -1,   232,    -1,
      -1,   235,   236,   237,    -1,    -1,   240,   241,   242,   243,
     244,   245,   246,   247,   248,   249,   250,   251,   252,   253,
     254,   255,   256,   257,   258,    -1,   260,   261,   262,   263,
     264,   265,   266,   267,   268,   269,   270,    -1,   272,   273,
      -1,   275,    -1,   277,   278,   279,   280,   281,   282,    -1,
     284,   285,    -1,    -1,   288,   289,   290,    -1,    -1,   293,
     294,   295,    -1,   297,    -1,   299,   300,   301,   302,   303,
     304,   305,   306,   307,   308,   309,    -1,    -1,   312,   313,
     314,   315,   316,   317,   318,   319,    -1,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,   333,
     334,   335,    -1,   337,   338,   339,   340,   341,   342,   343,
     344,   345,   346,   347,   348,   349,    -1,   351,   352,    -1,
     354,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,   365,   366,   367,   368,    -1,   370,   371,   372,   373,
     374,    -1,   376,   377,   378,   379,   380,    -1,   382,   383,
     384,   385,    -1,   387,   388,   389,   390,   391,   392,   393,
     394,   395,   396,   397,   398,   399,   400,   401,    -1,   403,
     404,    -1,   406,    -1,   408,   409,   410,   411,   412,    -1,
     414,   415,   416,    -1,    -1,   419,   420,   421,   422,   423,
      -1,   425,   426,   427,   428,   429,   430,   431,   432,    -1,
      -1,   435,   436,   437,   438,   439,    -1,    -1,   442,   443,
     444,   445,   446,   447,   448,    -1,   450,    -1,   452,   453,
     454,   455,    -1,    -1,   458,    -1,    -1,   461,   462,   463,
     464,   465,   466,   467,   468,   469,   470,   471,   472,   473,
     474,   475,   476,   477,   478,   479,   480,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,    25,
      26,    27,    -1,    29,    30,    31,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    39,    40,    41,    -1,    43,    44,    45,
      46,    -1,    48,    49,    50,    51,    52,    -1,    54,    55,
      -1,    57,    58,    59,    60,    61,    62,    63,    -1,    -1,
      66,    67,    68,    69,    70,    -1,    72,    73,    74,    75,
      76,    -1,    -1,    -1,    80,    81,    82,    83,    84,    85,
      -1,    87,    88,    89,    -1,    91,    92,    93,    94,    95,
      96,    -1,    -1,    99,   100,   101,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   109,   110,   111,   112,   113,   114,   115,
     116,   117,    -1,   119,    -1,   121,   122,   123,   124,   125,
     126,   127,    -1,   129,   130,   131,   132,    -1,    -1,   135,
     136,   137,   138,   139,    -1,   141,   142,   143,    -1,   145,
     146,   147,    -1,   149,   150,   151,   152,   153,   154,   155,
     156,   157,   158,    -1,   160,    -1,   162,   163,   164,   165,
     166,    -1,   168,    -1,   170,    -1,    -1,    -1,   174,   175,
     176,   177,    -1,   179,   180,    -1,   182,   183,   184,    -1,
     186,   187,   188,   189,   190,    -1,   192,   193,   194,   195,
      -1,   197,   198,   199,   200,   201,   202,   203,    -1,   205,
      -1,   207,   208,   209,   210,   211,   212,   213,    -1,   215,
      -1,   217,    -1,    -1,   220,    -1,   222,   223,   224,   225,
     226,    -1,    -1,   229,   230,    -1,   232,    -1,    -1,   235,
     236,   237,    -1,    -1,   240,   241,   242,   243,   244,   245,
     246,   247,   248,   249,   250,   251,   252,   253,   254,   255,
     256,   257,   258,    -1,   260,   261,   262,   263,   264,   265,
     266,   267,   268,   269,   270,    -1,   272,   273,    -1,   275,
      -1,   277,   278,   279,   280,   281,   282,    -1,   284,   285,
      -1,    -1,   288,   289,   290,    -1,    -1,   293,   294,   295,
      -1,   297,    -1,   299,   300,   301,   302,   303,   304,   305,
     306,   307,   308,   309,    -1,    -1,   312,   313,   314,   315,
     316,   317,   318,   319,    -1,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
      -1,   337,   338,   339,   340,   341,   342,   343,   344,   345,
     346,   347,   348,   349,    -1,   351,   352,    -1,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
     366,   367,   368,    -1,   370,   371,   372,   373,   374,    -1,
     376,   377,   378,   379,   380,    -1,   382,   383,   384,   385,
      -1,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,   399,   400,   401,    -1,   403,   404,    -1,
     406,    -1,   408,   409,   410,   411,   412,    -1,   414,   415,
     416,    -1,    -1,   419,   420,   421,   422,   423,    -1,   425,
     426,   427,   428,   429,   430,   431,   432,    -1,    -1,   435,
     436,   437,   438,   439,    -1,    -1,   442,   443,   444,   445,
     446,   447,   448,    -1,   450,    -1,   452,   453,   454,   455,
      -1,    -1,   458,    -1,    -1,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,   478,   479,   480,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    20,    21,    22,    23,    24,    25,    26,    27,
      -1,    29,    30,    31,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    39,    40,    41,    -1,    43,    44,    45,    46,    -1,
      48,    49,    50,    51,    52,    -1,    54,    55,    -1,    57,
      58,    59,    60,    61,    62,    63,    -1,    -1,    66,    67,
      68,    69,    70,    -1,    72,    73,    74,    75,    76,    -1,
      -1,    -1,    80,    81,    82,    83,    84,    85,    -1,    87,
      88,    89,    -1,    91,    92,    93,    94,    95,    96,    -1,
      -1,    99,   100,   101,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   109,   110,   111,   112,   113,   114,   115,   116,   117,
      -1,   119,    -1,   121,   122,   123,   124,   125,   126,   127,
      -1,   129,   130,   131,   132,    -1,    -1,   135,   136,   137,
     138,   139,    -1,   141,   142,   143,    -1,   145,   146,   147,
      -1,   149,   150,   151,   152,   153,   154,   155,   156,   157,
     158,    -1,   160,    -1,   162,   163,   164,   165,   166,    -1,
     168,    -1,   170,    -1,    -1,    -1,   174,   175,   176,   177,
      -1,   179,   180,    -1,   182,   183,   184,    -1,   186,   187,
     188,   189,   190,    -1,   192,   193,   194,   195,    -1,   197,
     198,   199,   200,   201,   202,   203,    -1,   205,    -1,   207,
     208,   209,   210,   211,   212,   213,    -1,   215,    -1,   217,
      -1,    -1,   220,    -1,   222,   223,   224,   225,   226,    -1,
      -1,   229,   230,    -1,   232,    -1,    -1,   235,   236,   237,
      -1,    -1,   240,   241,   242,   243,   244,   245,   246,   247,
     248,   249,   250,   251,   252,   253,   254,   255,   256,   257,
     258,    -1,   260,   261,   262,   263,   264,   265,   266,   267,
     268,   269,   270,    -1,   272,   273,    -1,   275,    -1,   277,
     278,   279,   280,   281,   282,    -1,   284,   285,    -1,    -1,
     288,   289,   290,    -1,    -1,   293,   294,   295,    -1,   297,
      -1,   299,   300,   301,   302,   303,   304,   305,   306,   307,
     308,   309,    -1,    -1,   312,   313,   314,   315,   316,   317,
     318,   319,    -1,   321,   322,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,   333,   334,   335,    -1,   337,
     338,   339,   340,   341,   342,   343,   344,   345,   346,   347,
     348,   349,    -1,   351,   352,    -1,   354,   355,   356,   357,
     358,   359,   360,   361,   362,   363,   364,   365,   366,   367,
     368,    -1,   370,   371,   372,   373,   374,    -1,   376,   377,
     378,   379,   380,    -1,   382,   383,   384,   385,    -1,   387,
     388,   389,   390,   391,   392,   393,   394,   395,   396,   397,
     398,   399,   400,   401,    -1,   403,   404,    -1,   406,    -1,
     408,   409,   410,   411,   412,    -1,   414,   415,   416,    -1,
      -1,   419,   420,   421,   422,   423,    -1,   425,   426,   427,
     428,   429,   430,   431,   432,    -1,    -1,   435,   436,   437,
     438,   439,    -1,    -1,   442,   443,   444,   445,   446,   447,
     448,    -1,   450,    -1,   452,   453,   454,   455,    -1,    -1,
     458,    -1,    -1,   461,   462,   463,   464,   465,   466,   467,
     468,   469,   470,   471,   472,   473,   474,   475,   476,   477,
     478,   479,   480,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      20,    21,    22,    23,    24,    25,    26,    27,    -1,    29,
      30,    31,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    39,
      40,    41,    -1,    43,    44,    45,    46,    -1,    48,    49,
      50,    51,    52,    -1,    54,    55,    -1,    57,    58,    59,
      60,    61,    62,    63,    -1,    -1,    66,    67,    68,    69,
      70,    -1,    72,    73,    74,    75,    76,    -1,    -1,    -1,
      80,    81,    82,    83,    84,    85,    -1,    87,    88,    89,
      -1,    91,    92,    93,    94,    95,    96,    -1,    -1,    99,
     100,   101,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   109,
     110,   111,   112,   113,   114,   115,   116,   117,    -1,   119,
      -1,   121,   122,   123,   124,   125,   126,   127,    -1,   129,
     130,   131,   132,    -1,    -1,   135,   136,   137,   138,   139,
      -1,   141,   142,   143,    -1,   145,   146,   147,    -1,   149,
     150,   151,   152,   153,   154,   155,   156,   157,   158,    -1,
     160,    -1,   162,   163,   164,   165,   166,    -1,   168,    -1,
     170,    -1,    -1,    -1,   174,   175,   176,   177,    -1,   179,
     180,    -1,   182,   183,   184,    -1,   186,   187,   188,   189,
     190,    -1,   192,   193,   194,   195,    -1,   197,   198,   199,
     200,   201,   202,   203,    -1,   205,    -1,   207,   208,   209,
     210,   211,   212,   213,    -1,   215,    -1,   217,    -1,    -1,
     220,    -1,   222,   223,   224,   225,   226,    -1,    -1,   229,
     230,    -1,   232,    -1,    -1,   235,   236,   237,    -1,    -1,
     240,   241,   242,   243,   244,   245,   246,   247,   248,   249,
     250,   251,   252,   253,   254,   255,   256,   257,   258,    -1,
     260,   261,   262,   263,   264,   265,   266,   267,   268,   269,
     270,    -1,   272,   273,    -1,   275,    -1,   277,   278,   279,
     280,   281,   282,    -1,   284,   285,    -1,    -1,   288,   289,
     290,    -1,    -1,   293,   294,   295,    -1,   297,    -1,   299,
     300,   301,   302,   303,   304,   305,   306,   307,   308,   309,
      -1,    -1,   312,   313,   314,   315,   316,   317,   318,   319,
      -1,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,    -1,   337,   338,   339,
     340,   341,   342,   343,   344,   345,   346,   347,   348,   349,
      -1,   351,   352,    -1,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,   365,   366,   367,   368,    -1,
     370,   371,   372,   373,   374,    -1,   376,   377,   378,   379,
     380,    -1,   382,   383,   384,   385,    -1,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,   399,
     400,   401,    -1,   403,   404,    -1,   406,    -1,   408,   409,
     410,   411,   412,    -1,   414,   415,   416,    -1,    -1,   419,
     420,   421,   422,   423,    -1,   425,   426,   427,   428,   429,
     430,   431,   432,    -1,    -1,   435,   436,   437,   438,   439,
      -1,    -1,   442,   443,   444,   445,   446,   447,   448,    -1,
     450,    -1,   452,   453,   454,   455,    -1,    -1,   458,    -1,
      -1,   461,   462,   463,   464,   465,   466,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,    21,
      22,    23,    24,    25,    26,    27,    -1,    29,    30,    31,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    39,    40,    41,
      -1,    43,    44,    45,    46,    -1,    48,    49,    50,    51,
      52,    -1,    54,    55,    -1,    57,    58,    59,    60,    61,
      62,    63,    -1,    -1,    66,    67,    68,    69,    70,    -1,
      72,    73,    74,    75,    76,    -1,    -1,    -1,    80,    81,
      82,    83,    84,    85,    -1,    87,    88,    89,    -1,    91,
      92,    93,    94,    95,    96,    -1,    -1,    99,   100,   101,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   109,   110,   111,
     112,   113,   114,   115,   116,   117,    -1,   119,    -1,   121,
     122,   123,   124,   125,   126,   127,    -1,   129,   130,   131,
     132,    -1,    -1,   135,   136,   137,   138,   139,    -1,   141,
     142,   143,    -1,   145,   146,   147,    -1,   149,   150,   151,
     152,   153,   154,   155,   156,   157,   158,    -1,   160,    -1,
     162,   163,   164,   165,   166,    -1,   168,    -1,   170,    -1,
      -1,    -1,   174,   175,   176,   177,    -1,   179,   180,    -1,
     182,   183,   184,    -1,   186,   187,   188,   189,   190,    -1,
     192,   193,   194,   195,    -1,   197,   198,   199,   200,   201,
     202,   203,    -1,   205,    -1,   207,   208,   209,   210,   211,
     212,   213,    -1,   215,    -1,   217,    -1,    -1,   220,    -1,
     222,   223,   224,   225,   226,    -1,    -1,   229,   230,    -1,
     232,    -1,    -1,   235,   236,   237,    -1,    -1,   240,   241,
     242,   243,   244,   245,   246,   247,   248,   249,   250,   251,
     252,   253,   254,   255,   256,   257,   258,    -1,   260,   261,
     262,   263,   264,   265,   266,   267,   268,   269,   270,    -1,
     272,   273,    -1,   275,    -1,   277,   278,   279,   280,   281,
     282,    -1,   284,   285,    -1,    -1,   288,   289,   290,    -1,
      -1,   293,   294,   295,    -1,   297,    -1,   299,   300,   301,
     302,   303,   304,   305,   306,   307,   308,   309,    -1,    -1,
     312,   313,   314,   315,   316,   317,   318,   319,    -1,   321,
     322,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,   333,   334,   335,    -1,   337,   338,   339,   340,   341,
     342,   343,   344,   345,   346,   347,   348,   349,    -1,   351,
     352,    -1,   354,   355,   356,   357,   358,   359,   360,   361,
     362,   363,   364,   365,   366,   367,   368,    -1,   370,   371,
     372,   373,   374,    -1,   376,   377,   378,   379,   380,    -1,
     382,   383,   384,   385,    -1,   387,   388,   389,   390,   391,
     392,   393,   394,   395,   396,   397,   398,   399,   400,   401,
      -1,   403,   404,    -1,   406,    -1,   408,   409,   410,   411,
     412,    -1,   414,   415,   416,    -1,    -1,   419,   420,   421,
     422,   423,    -1,   425,   426,   427,   428,   429,   430,   431,
     432,    -1,    -1,   435,   436,   437,   438,   439,    -1,    -1,
     442,   443,   444,   445,   446,   447,   448,    -1,   450,    -1,
     452,   453,   454,   455,    -1,    -1,   458,    -1,    -1,   461,
     462,   463,   464,   465,   466,   467,   468,   469,   470,   471,
     472,   473,   474,   475,   476,   477,   478,   479,   480,     3,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    20,    21,    22,    23,
      24,    25,    26,    27,    -1,    29,    30,    31,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    39,    40,    41,    -1,    43,
      44,    45,    46,    -1,    48,    49,    50,    51,    52,    -1,
      54,    55,    -1,    57,    58,    59,    60,    61,    62,    63,
      -1,    -1,    66,    67,    68,    69,    70,    -1,    72,    73,
      74,    75,    76,    -1,    -1,    -1,    80,    81,    82,    83,
      84,    85,    -1,    87,    88,    89,    -1,    91,    92,    93,
      94,    95,    96,    -1,    -1,    99,   100,   101,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   109,   110,   111,   112,   113,
     114,   115,   116,   117,    -1,   119,    -1,   121,   122,   123,
     124,   125,   126,   127,    -1,   129,   130,   131,   132,    -1,
      -1,   135,   136,   137,   138,   139,    -1,   141,   142,   143,
      -1,   145,   146,   147,    -1,   149,   150,   151,   152,   153,
     154,   155,   156,   157,   158,    -1,   160,    -1,   162,   163,
     164,   165,   166,    -1,   168,    -1,   170,    -1,    -1,    -1,
     174,   175,   176,   177,    -1,   179,   180,    -1,   182,   183,
     184,    -1,   186,   187,   188,   189,   190,    -1,   192,   193,
     194,   195,    -1,   197,   198,   199,   200,   201,   202,   203,
      -1,   205,    -1,   207,   208,   209,   210,   211,   212,   213,
      -1,   215,    -1,   217,    -1,    -1,   220,    -1,   222,   223,
     224,   225,   226,    -1,    -1,   229,   230,    -1,   232,    -1,
      -1,   235,   236,   237,    -1,    -1,   240,   241,   242,   243,
     244,   245,   246,   247,   248,   249,   250,   251,   252,   253,
     254,   255,   256,   257,   258,    -1,   260,   261,   262,   263,
     264,   265,   266,   267,   268,   269,   270,    -1,   272,   273,
      -1,   275,    -1,   277,   278,   279,   280,   281,   282,    -1,
     284,   285,    -1,    -1,   288,   289,   290,    -1,    -1,   293,
     294,   295,    -1,   297,    -1,   299,   300,   301,   302,   303,
     304,   305,   306,   307,   308,   309,    -1,    -1,   312,   313,
     314,   315,   316,   317,   318,   319,    -1,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,   333,
     334,   335,    -1,   337,   338,   339,   340,   341,   342,   343,
     344,   345,   346,   347,   348,   349,    -1,   351,   352,    -1,
     354,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,   365,   366,   367,   368,    -1,   370,   371,   372,   373,
     374,    -1,   376,   377,   378,   379,   380,    -1,   382,   383,
     384,   385,    -1,   387,   388,   389,   390,   391,   392,   393,
     394,   395,   396,   397,   398,   399,   400,   401,    -1,   403,
     404,    -1,   406,    -1,   408,   409,   410,   411,   412,    -1,
     414,   415,   416,    -1,    -1,   419,   420,   421,   422,   423,
      -1,   425,   426,   427,   428,   429,   430,   431,   432,    -1,
      -1,   435,   436,   437,   438,   439,    -1,    -1,   442,   443,
     444,   445,   446,   447,   448,    -1,   450,    -1,   452,   453,
     454,   455,    -1,    -1,   458,    -1,    -1,   461,   462,   463,
     464,   465,   466,   467,   468,   469,   470,   471,   472,   473,
     474,   475,   476,   477,   478,   479,   480,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,    25,
      26,    27,    -1,    29,    30,    31,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    39,    40,    41,    -1,    43,    44,    45,
      46,    -1,    48,    49,    50,    51,    52,    -1,    54,    55,
      -1,    57,    58,    59,    60,    61,    62,    63,    -1,    -1,
      66,    67,    68,    69,    70,    -1,    72,    73,    74,    75,
      76,    -1,    -1,    -1,    80,    81,    82,    83,    84,    85,
      -1,    87,    88,    89,    -1,    91,    92,    93,    94,    95,
      96,    -1,    -1,    99,   100,   101,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   109,   110,   111,   112,   113,   114,   115,
     116,   117,    -1,   119,    -1,   121,   122,   123,   124,   125,
     126,   127,    -1,   129,   130,   131,   132,    -1,    -1,   135,
     136,   137,   138,   139,    -1,   141,   142,   143,    -1,   145,
     146,   147,    -1,   149,   150,   151,   152,   153,   154,   155,
     156,   157,   158,    -1,   160,    -1,   162,   163,   164,   165,
     166,    -1,   168,    -1,   170,    -1,    -1,    -1,   174,   175,
     176,   177,    -1,   179,   180,    -1,   182,   183,   184,    -1,
     186,   187,   188,   189,   190,    -1,   192,   193,   194,   195,
      -1,   197,   198,   199,   200,   201,   202,   203,    -1,   205,
      -1,   207,   208,   209,   210,   211,   212,   213,    -1,   215,
      -1,   217,    -1,    -1,   220,    -1,   222,   223,   224,   225,
     226,    -1,    -1,   229,   230,    -1,   232,    -1,    -1,   235,
     236,   237,    -1,    -1,   240,   241,   242,   243,   244,   245,
     246,   247,   248,   249,   250,   251,   252,   253,   254,   255,
     256,   257,   258,    -1,   260,   261,   262,   263,   264,   265,
     266,   267,   268,   269,   270,    -1,   272,   273,    -1,   275,
      -1,   277,   278,   279,   280,   281,   282,    -1,   284,   285,
      -1,    -1,   288,   289,   290,    -1,    -1,   293,   294,   295,
      -1,   297,    -1,   299,   300,   301,   302,   303,   304,   305,
     306,   307,   308,   309,    -1,    -1,   312,   313,   314,   315,
     316,   317,   318,   319,    -1,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
      -1,   337,   338,   339,   340,   341,   342,   343,   344,   345,
     346,   347,   348,   349,    -1,   351,   352,    -1,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
     366,   367,   368,    -1,   370,   371,   372,   373,   374,    -1,
     376,   377,   378,   379,   380,    -1,   382,   383,   384,   385,
      -1,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,   399,   400,   401,    -1,   403,   404,    -1,
     406,    -1,   408,   409,   410,   411,   412,    -1,   414,   415,
     416,    -1,    -1,   419,   420,   421,   422,   423,    -1,   425,
     426,   427,   428,   429,   430,   431,   432,    -1,    -1,   435,
     436,   437,   438,   439,    -1,    -1,   442,   443,   444,   445,
     446,   447,   448,    -1,   450,    -1,   452,   453,   454,   455,
      -1,    -1,   458,    -1,    -1,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,   478,   479,   480,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    20,    21,    22,    23,    24,    25,    26,    27,
      -1,    29,    30,    31,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    39,    40,    41,    -1,    43,    44,    45,    46,    -1,
      48,    49,    50,    51,    52,    -1,    54,    55,    -1,    57,
      58,    59,    60,    61,    62,    63,    -1,    -1,    66,    67,
      68,    69,    70,    -1,    72,    73,    74,    75,    76,    -1,
      -1,    -1,    80,    81,    82,    83,    84,    85,    -1,    87,
      88,    89,    -1,    91,    92,    93,    94,    95,    96,    -1,
      -1,    99,   100,   101,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   109,   110,   111,   112,   113,   114,   115,   116,   117,
      -1,   119,    -1,   121,   122,   123,   124,   125,   126,   127,
      -1,   129,   130,   131,   132,    -1,    -1,   135,   136,   137,
     138,   139,    -1,   141,   142,   143,    -1,   145,   146,   147,
      -1,   149,   150,   151,   152,   153,   154,   155,   156,   157,
     158,    -1,   160,    -1,   162,   163,   164,   165,   166,    -1,
     168,    -1,   170,    -1,    -1,    -1,   174,   175,   176,   177,
      -1,   179,   180,    -1,   182,   183,   184,    -1,   186,   187,
     188,   189,   190,    -1,   192,   193,   194,   195,    -1,   197,
     198,   199,   200,   201,   202,   203,    -1,   205,    -1,   207,
     208,   209,   210,   211,   212,   213,    -1,   215,    -1,   217,
      -1,    -1,   220,    -1,   222,   223,   224,   225,   226,    -1,
      -1,   229,   230,    -1,   232,    -1,    -1,   235,   236,   237,
      -1,    -1,   240,   241,   242,   243,   244,   245,   246,   247,
     248,   249,   250,   251,   252,   253,   254,   255,   256,   257,
     258,    -1,   260,   261,   262,   263,   264,   265,   266,   267,
     268,   269,   270,    -1,   272,   273,    -1,   275,    -1,   277,
     278,   279,   280,   281,   282,    -1,   284,   285,    -1,    -1,
     288,   289,   290,    -1,    -1,   293,   294,   295,    -1,   297,
      -1,   299,   300,   301,   302,   303,   304,   305,   306,   307,
     308,   309,    -1,    -1,   312,   313,   314,   315,   316,   317,
     318,   319,    -1,   321,   322,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,   333,   334,   335,    -1,   337,
     338,   339,   340,   341,   342,   343,   344,   345,   346,   347,
     348,   349,    -1,   351,   352,    -1,   354,   355,   356,   357,
     358,   359,   360,   361,   362,   363,   364,   365,   366,   367,
     368,    -1,   370,   371,   372,   373,   374,    -1,   376,   377,
     378,   379,   380,    -1,   382,   383,   384,   385,    -1,   387,
     388,   389,   390,   391,   392,   393,   394,   395,   396,   397,
     398,   399,   400,   401,    -1,   403,   404,    -1,   406,    -1,
     408,   409,   410,   411,   412,    -1,   414,   415,   416,    -1,
      -1,   419,   420,   421,   422,   423,    -1,   425,   426,   427,
     428,   429,   430,   431,   432,    -1,    -1,   435,   436,   437,
     438,   439,    -1,    -1,   442,   443,   444,   445,   446,   447,
     448,    -1,   450,    -1,   452,   453,   454,   455,    -1,    -1,
     458,    -1,    -1,   461,   462,   463,   464,   465,   466,   467,
     468,   469,   470,   471,   472,   473,   474,   475,   476,   477,
     478,   479,   480,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      20,    21,    22,    23,    24,    25,    26,    27,    -1,    29,
      30,    31,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    39,
      40,    41,    -1,    43,    44,    45,    46,    -1,    48,    49,
      50,    51,    52,    -1,    54,    55,    -1,    57,    58,    59,
      60,    61,    62,    63,    -1,    -1,    66,    67,    68,    69,
      70,    -1,    72,    73,    74,    75,    76,    -1,    -1,    -1,
      80,    81,    82,    83,    84,    85,    -1,    87,    88,    89,
      -1,    91,    92,    93,    94,    95,    96,    -1,    -1,    99,
     100,   101,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   109,
     110,   111,   112,   113,   114,   115,   116,   117,    -1,   119,
      -1,   121,   122,   123,   124,   125,   126,   127,    -1,   129,
     130,   131,   132,    -1,    -1,   135,   136,   137,   138,   139,
      -1,   141,   142,   143,    -1,   145,   146,   147,    -1,   149,
     150,   151,   152,   153,   154,   155,   156,   157,   158,    -1,
     160,    -1,   162,   163,   164,   165,   166,    -1,   168,    -1,
     170,    -1,    -1,    -1,   174,   175,   176,   177,    -1,   179,
     180,    -1,   182,   183,   184,    -1,   186,   187,   188,   189,
     190,    -1,   192,   193,   194,   195,    -1,   197,   198,   199,
     200,   201,   202,   203,    -1,   205,    -1,   207,   208,   209,
     210,   211,   212,   213,    -1,   215,    -1,   217,    -1,    -1,
     220,    -1,   222,   223,   224,   225,   226,    -1,    -1,   229,
     230,    -1,   232,    -1,    -1,   235,   236,   237,    -1,    -1,
     240,   241,   242,   243,   244,   245,   246,   247,   248,   249,
     250,   251,   252,   253,   254,   255,   256,   257,   258,    -1,
     260,   261,   262,   263,   264,   265,   266,   267,   268,   269,
     270,    -1,   272,   273,    -1,   275,    -1,   277,   278,   279,
     280,   281,   282,    -1,   284,   285,    -1,    -1,   288,   289,
     290,    -1,    -1,   293,   294,   295,    -1,   297,    -1,   299,
     300,   301,   302,   303,   304,   305,   306,   307,   308,   309,
      -1,    -1,   312,   313,   314,   315,   316,   317,   318,   319,
      -1,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,    -1,   337,   338,   339,
     340,   341,   342,   343,   344,   345,   346,   347,   348,   349,
      -1,   351,   352,    -1,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,   365,   366,   367,   368,    -1,
     370,   371,   372,   373,   374,    -1,   376,   377,   378,   379,
     380,    -1,   382,   383,   384,   385,    -1,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,   399,
     400,   401,    -1,   403,   404,    -1,   406,    -1,   408,   409,
     410,   411,   412,    -1,   414,   415,   416,    -1,    -1,   419,
     420,   421,   422,   423,    -1,   425,   426,   427,   428,   429,
     430,   431,   432,    -1,    -1,   435,   436,   437,   438,   439,
      -1,    -1,   442,   443,   444,   445,   446,   447,   448,    -1,
     450,    -1,   452,   453,   454,   455,    -1,    -1,   458,    -1,
      -1,   461,   462,   463,   464,   465,   466,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,    21,
      22,    23,    24,    25,    26,    27,    -1,    29,    30,    31,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    39,    40,    41,
      -1,    43,    44,    45,    46,    -1,    48,    49,    50,    51,
      52,    -1,    54,    55,    -1,    57,    58,    59,    60,    61,
      62,    63,    -1,    -1,    66,    67,    68,    69,    70,    -1,
      72,    73,    74,    75,    76,    -1,    -1,    -1,    80,    81,
      82,    83,    84,    85,    -1,    87,    88,    89,    -1,    91,
      92,    93,    94,    95,    96,    -1,    -1,    99,   100,   101,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   109,   110,   111,
     112,   113,   114,   115,   116,   117,    -1,   119,    -1,   121,
     122,   123,   124,   125,   126,   127,    -1,   129,   130,   131,
     132,    -1,    -1,   135,   136,   137,   138,   139,    -1,   141,
     142,   143,    -1,   145,   146,   147,    -1,   149,   150,   151,
     152,   153,   154,   155,   156,   157,   158,    -1,   160,    -1,
     162,   163,   164,   165,   166,    -1,   168,    -1,   170,    -1,
      -1,    -1,   174,   175,   176,   177,    -1,   179,   180,    -1,
     182,   183,   184,    -1,   186,   187,   188,   189,   190,    -1,
     192,   193,   194,   195,    -1,   197,   198,   199,   200,   201,
     202,   203,    -1,   205,    -1,   207,   208,   209,   210,   211,
     212,   213,    -1,   215,    -1,   217,    -1,    -1,   220,    -1,
     222,   223,   224,   225,   226,    -1,    -1,   229,   230,    -1,
     232,    -1,    -1,   235,   236,   237,    -1,    -1,   240,   241,
     242,   243,   244,   245,   246,   247,   248,   249,   250,   251,
     252,   253,   254,   255,   256,   257,   258,    -1,   260,   261,
     262,   263,   264,   265,   266,   267,   268,   269,   270,    -1,
     272,   273,    -1,   275,    -1,   277,   278,   279,   280,   281,
     282,    -1,   284,   285,    -1,    -1,   288,   289,   290,    -1,
      -1,   293,   294,   295,    -1,   297,    -1,   299,   300,   301,
     302,   303,   304,   305,   306,   307,   308,   309,    -1,    -1,
     312,   313,   314,   315,   316,   317,   318,   319,    -1,   321,
     322,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,   333,   334,   335,    -1,   337,   338,   339,   340,   341,
     342,   343,   344,   345,   346,   347,   348,   349,    -1,   351,
     352,    -1,   354,   355,   356,   357,   358,   359,   360,   361,
     362,   363,   364,   365,   366,   367,   368,    -1,   370,   371,
     372,   373,   374,    -1,   376,   377,   378,   379,   380,    -1,
     382,   383,   384,   385,    -1,   387,   388,   389,   390,   391,
     392,   393,   394,   395,   396,   397,   398,   399,   400,   401,
      -1,   403,   404,    -1,   406,    -1,   408,   409,   410,   411,
     412,    -1,   414,   415,   416,    -1,    -1,   419,   420,   421,
     422,   423,    -1,   425,   426,   427,   428,   429,   430,   431,
     432,    -1,    -1,   435,   436,   437,   438,   439,    -1,    -1,
     442,   443,   444,   445,   446,   447,   448,    -1,   450,    -1,
     452,   453,   454,   455,    -1,    -1,   458,    -1,    -1,   461,
     462,   463,   464,   465,   466,   467,   468,   469,   470,   471,
     472,   473,   474,   475,   476,   477,   478,   479,   480,     3,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    20,    21,    22,    23,
      24,    25,    26,    27,    -1,    29,    30,    31,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    39,    40,    41,    -1,    43,
      44,    45,    46,    -1,    48,    49,    50,    51,    52,    -1,
      54,    55,    -1,    57,    58,    59,    60,    61,    62,    63,
      -1,    -1,    66,    67,    68,    69,    70,    -1,    72,    73,
      74,    75,    76,    -1,    -1,    -1,    80,    81,    82,    83,
      84,    85,    -1,    87,    88,    89,    -1,    91,    92,    93,
      94,    95,    96,    -1,    -1,    99,   100,   101,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   109,   110,   111,   112,   113,
     114,   115,   116,   117,    -1,   119,    -1,   121,   122,   123,
     124,   125,   126,   127,    -1,   129,   130,   131,   132,    -1,
      -1,   135,   136,   137,   138,   139,    -1,   141,   142,   143,
      -1,   145,   146,   147,    -1,   149,   150,   151,   152,   153,
     154,   155,   156,   157,   158,    -1,   160,    -1,   162,   163,
     164,   165,   166,    -1,   168,    -1,   170,    -1,    -1,    -1,
     174,   175,   176,   177,    -1,   179,   180,    -1,   182,   183,
     184,    -1,   186,   187,   188,   189,   190,    -1,   192,   193,
     194,   195,    -1,   197,   198,   199,   200,   201,   202,   203,
      -1,   205,    -1,   207,   208,   209,   210,   211,   212,   213,
      -1,   215,    -1,   217,    -1,    -1,   220,    -1,   222,   223,
     224,   225,   226,    -1,    -1,   229,   230,    -1,   232,    -1,
      -1,   235,   236,   237,    -1,    -1,   240,   241,   242,   243,
     244,   245,   246,   247,   248,   249,   250,   251,   252,   253,
     254,   255,   256,   257,   258,    -1,   260,   261,   262,   263,
     264,   265,   266,   267,   268,   269,   270,    -1,   272,   273,
      -1,   275,    -1,   277,   278,   279,   280,   281,   282,    -1,
     284,   285,    -1,    -1,   288,   289,   290,    -1,    -1,   293,
     294,   295,    -1,   297,    -1,   299,   300,   301,   302,   303,
     304,   305,   306,   307,   308,   309,    -1,    -1,   312,   313,
     314,   315,   316,   317,   318,   319,    -1,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,   333,
     334,   335,    -1,   337,   338,   339,   340,   341,   342,   343,
     344,   345,   346,   347,   348,   349,    -1,   351,   352,    -1,
     354,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,   365,   366,   367,   368,    -1,   370,   371,   372,   373,
     374,    -1,   376,   377,   378,   379,   380,    -1,   382,   383,
     384,   385,    -1,   387,   388,   389,   390,   391,   392,   393,
     394,   395,   396,   397,   398,   399,   400,   401,    -1,   403,
     404,    -1,   406,    -1,   408,   409,   410,   411,   412,    -1,
     414,   415,   416,    -1,    -1,   419,   420,   421,   422,   423,
      -1,   425,   426,   427,   428,   429,   430,   431,   432,    -1,
      -1,   435,   436,   437,   438,   439,    -1,    -1,   442,   443,
     444,   445,   446,   447,   448,    -1,   450,    -1,   452,   453,
     454,   455,    -1,    -1,   458,    -1,    -1,   461,   462,   463,
     464,   465,   466,   467,   468,   469,   470,   471,   472,   473,
     474,   475,   476,   477,   478,   479,   480,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,    25,
      26,    27,    -1,    29,    30,    31,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    39,    40,    41,    -1,    43,    44,    45,
      46,    -1,    48,    49,    50,    51,    52,    -1,    54,    55,
      -1,    57,    58,    59,    60,    61,    62,    63,    -1,    -1,
      66,    67,    68,    69,    70,    -1,    72,    73,    74,    75,
      76,    -1,    -1,    -1,    80,    81,    82,    83,    84,    85,
      -1,    87,    88,    89,    -1,    91,    92,    93,    94,    95,
      96,    -1,    -1,    99,   100,   101,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   109,   110,   111,   112,   113,   114,   115,
     116,   117,    -1,   119,    -1,   121,   122,   123,   124,   125,
     126,   127,    -1,   129,   130,   131,   132,    -1,    -1,   135,
     136,   137,   138,   139,    -1,   141,   142,   143,    -1,   145,
     146,   147,    -1,   149,   150,   151,   152,   153,   154,   155,
     156,   157,   158,    -1,   160,    -1,   162,   163,   164,   165,
     166,    -1,   168,    -1,   170,    -1,    -1,    -1,   174,   175,
     176,   177,    -1,   179,   180,    -1,   182,   183,   184,    -1,
     186,   187,   188,   189,   190,    -1,   192,   193,   194,   195,
      -1,   197,   198,   199,   200,   201,   202,   203,    -1,   205,
      -1,   207,   208,   209,   210,   211,   212,   213,    -1,   215,
      -1,   217,    -1,    -1,   220,    -1,   222,   223,   224,   225,
     226,    -1,    -1,   229,   230,    -1,   232,    -1,    -1,   235,
     236,   237,    -1,    -1,   240,   241,   242,   243,   244,   245,
     246,   247,   248,   249,   250,   251,   252,   253,   254,   255,
     256,   257,   258,    -1,   260,   261,   262,   263,   264,   265,
     266,   267,   268,   269,   270,    -1,   272,   273,    -1,   275,
      -1,   277,   278,   279,   280,   281,   282,    -1,   284,   285,
      -1,    -1,   288,   289,   290,    -1,    -1,   293,   294,   295,
      -1,   297,    -1,   299,   300,   301,   302,   303,   304,   305,
     306,   307,   308,   309,    -1,    -1,   312,   313,   314,   315,
     316,   317,   318,   319,    -1,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
      -1,   337,   338,   339,   340,   341,   342,   343,   344,   345,
     346,   347,   348,   349,    -1,   351,   352,    -1,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
     366,   367,   368,    -1,   370,   371,   372,   373,   374,    -1,
     376,   377,   378,   379,   380,    -1,   382,   383,   384,   385,
      -1,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,   399,   400,   401,    -1,   403,   404,    -1,
     406,    -1,   408,   409,   410,   411,   412,    -1,   414,   415,
     416,    -1,    -1,   419,   420,   421,   422,   423,    -1,   425,
     426,   427,   428,   429,   430,   431,   432,    -1,    -1,   435,
     436,   437,   438,   439,    -1,    -1,   442,   443,   444,   445,
     446,   447,   448,    -1,   450,    -1,   452,   453,   454,   455,
      -1,    -1,   458,    -1,    -1,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,   478,   479,   480,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    20,    21,    22,    23,    24,    25,    26,    27,
      -1,    29,    30,    31,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    39,    40,    41,    -1,    43,    44,    45,    46,    -1,
      48,    49,    50,    51,    52,    -1,    54,    55,    -1,    57,
      58,    59,    60,    61,    62,    63,    -1,    -1,    66,    67,
      68,    69,    70,    -1,    72,    73,    74,    75,    76,    -1,
      -1,    -1,    80,    81,    82,    83,    84,    85,    -1,    87,
      88,    89,    -1,    91,    92,    93,    94,    95,    96,    -1,
      -1,    99,   100,   101,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   109,   110,   111,   112,   113,   114,   115,   116,   117,
      -1,   119,    -1,   121,   122,   123,   124,   125,   126,   127,
      -1,   129,   130,   131,   132,    -1,    -1,   135,   136,   137,
     138,   139,    -1,   141,   142,   143,    -1,   145,   146,   147,
      -1,   149,   150,   151,   152,   153,   154,   155,   156,   157,
     158,    -1,   160,    -1,   162,   163,   164,   165,   166,    -1,
     168,    -1,   170,    -1,    -1,    -1,   174,   175,   176,   177,
      -1,   179,   180,    -1,   182,   183,   184,    -1,   186,   187,
     188,   189,   190,    -1,   192,   193,   194,   195,    -1,   197,
     198,   199,   200,   201,   202,   203,    -1,   205,    -1,   207,
     208,   209,   210,   211,   212,   213,    -1,   215,    -1,   217,
      -1,    -1,   220,    -1,   222,   223,   224,   225,   226,    -1,
      -1,   229,   230,    -1,   232,    -1,    -1,   235,   236,   237,
      -1,    -1,   240,   241,   242,   243,   244,   245,   246,   247,
     248,   249,   250,   251,   252,   253,   254,   255,   256,   257,
     258,    -1,   260,   261,   262,   263,   264,   265,   266,   267,
     268,   269,   270,    -1,   272,   273,    -1,   275,    -1,   277,
     278,   279,   280,   281,   282,    -1,   284,   285,    -1,    -1,
     288,   289,   290,    -1,    -1,   293,   294,   295,    -1,   297,
      -1,   299,   300,   301,   302,   303,   304,   305,   306,   307,
     308,   309,    -1,    -1,   312,   313,   314,   315,   316,   317,
     318,   319,    -1,   321,   322,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,   333,   334,   335,    -1,   337,
     338,   339,   340,   341,   342,   343,   344,   345,   346,   347,
     348,   349,    -1,   351,   352,    -1,   354,   355,   356,   357,
     358,   359,   360,   361,   362,   363,   364,   365,   366,   367,
     368,    -1,   370,   371,   372,   373,   374,    -1,   376,   377,
     378,   379,   380,    -1,   382,   383,   384,   385,    -1,   387,
     388,   389,   390,   391,   392,   393,   394,   395,   396,   397,
     398,   399,   400,   401,    -1,   403,   404,    -1,   406,    -1,
     408,   409,   410,   411,   412,    -1,   414,   415,   416,    -1,
      -1,   419,   420,   421,   422,   423,    -1,   425,   426,   427,
     428,   429,   430,   431,   432,    -1,    -1,   435,   436,   437,
     438,   439,    -1,    -1,   442,   443,   444,   445,   446,   447,
     448,    -1,   450,    -1,   452,   453,   454,   455,    -1,    -1,
     458,    -1,    -1,   461,   462,   463,   464,   465,   466,   467,
     468,   469,   470,   471,   472,   473,   474,   475,   476,   477,
     478,   479,   480,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      20,    21,    22,    23,    24,    25,    26,    27,    -1,    29,
      30,    31,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    39,
      40,    41,    -1,    43,    44,    45,    46,    -1,    48,    49,
      50,    51,    52,    -1,    54,    55,    -1,    57,    58,    59,
      60,    61,    62,    63,    -1,    -1,    66,    67,    68,    69,
      70,    -1,    72,    73,    74,    75,    76,    -1,    -1,    -1,
      80,    81,    82,    83,    84,    85,    -1,    87,    88,    89,
      -1,    91,    92,    93,    94,    95,    96,    -1,    -1,    99,
     100,   101,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   109,
     110,   111,   112,   113,   114,   115,   116,   117,    -1,   119,
      -1,   121,   122,   123,   124,   125,   126,   127,    -1,   129,
     130,   131,   132,    -1,    -1,   135,   136,   137,   138,   139,
      -1,   141,   142,   143,    -1,   145,   146,   147,    -1,   149,
     150,   151,   152,   153,   154,   155,   156,   157,   158,    -1,
     160,    -1,   162,   163,   164,   165,   166,    -1,   168,    -1,
     170,    -1,    -1,    -1,   174,   175,   176,   177,    -1,   179,
     180,    -1,   182,   183,   184,    -1,   186,   187,   188,   189,
     190,    -1,   192,   193,   194,   195,    -1,   197,   198,   199,
     200,   201,   202,   203,    -1,   205,    -1,   207,   208,   209,
     210,   211,   212,   213,    -1,   215,    -1,   217,    -1,    -1,
     220,    -1,   222,   223,   224,   225,   226,    -1,    -1,   229,
     230,    -1,   232,    -1,    -1,   235,   236,   237,    -1,    -1,
     240,   241,   242,   243,   244,   245,   246,   247,   248,   249,
     250,   251,   252,   253,   254,   255,   256,   257,   258,    -1,
     260,   261,   262,   263,   264,   265,   266,   267,   268,   269,
     270,    -1,   272,   273,    -1,   275,    -1,   277,   278,   279,
     280,   281,   282,    -1,   284,   285,    -1,    -1,   288,   289,
     290,    -1,    -1,   293,   294,   295,    -1,   297,    -1,   299,
     300,   301,   302,   303,   304,   305,   306,   307,   308,   309,
      -1,    -1,   312,   313,   314,   315,   316,   317,   318,   319,
      -1,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,    -1,   337,   338,   339,
     340,   341,   342,   343,   344,   345,   346,   347,   348,   349,
      -1,   351,   352,    -1,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,   365,   366,   367,   368,    -1,
     370,   371,   372,   373,   374,    -1,   376,   377,   378,   379,
     380,    -1,   382,   383,   384,   385,    -1,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,   399,
     400,   401,    -1,   403,   404,    -1,   406,    -1,   408,   409,
     410,   411,   412,    -1,   414,   415,   416,    -1,    -1,   419,
     420,   421,   422,   423,    -1,   425,   426,   427,   428,   429,
     430,   431,   432,    -1,    -1,   435,   436,   437,   438,   439,
      -1,    -1,   442,   443,   444,   445,   446,   447,   448,    -1,
     450,    -1,   452,   453,   454,   455,    -1,    -1,   458,    -1,
      -1,   461,   462,   463,   464,   465,   466,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,    21,
      22,    23,    24,    25,    26,    27,    -1,    29,    30,    31,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    39,    40,    41,
      -1,    43,    44,    45,    46,    -1,    48,    49,    50,    51,
      52,    -1,    54,    55,    -1,    57,    58,    59,    60,    61,
      62,    63,    -1,    -1,    66,    67,    68,    69,    70,    -1,
      72,    73,    74,    75,    76,    -1,    -1,    -1,    80,    81,
      82,    83,    84,    85,    -1,    87,    88,    89,    -1,    91,
      92,    93,    94,    95,    96,    -1,    -1,    99,   100,   101,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   109,   110,   111,
     112,   113,   114,   115,   116,   117,    -1,   119,    -1,   121,
     122,   123,   124,   125,   126,   127,    -1,   129,   130,   131,
     132,    -1,    -1,   135,   136,   137,   138,   139,    -1,   141,
     142,   143,    -1,   145,   146,   147,    -1,   149,   150,   151,
     152,   153,   154,   155,   156,   157,   158,    -1,   160,    -1,
     162,   163,   164,   165,   166,    -1,   168,    -1,   170,    -1,
      -1,    -1,   174,   175,   176,   177,    -1,   179,   180,    -1,
     182,   183,   184,    -1,   186,   187,   188,   189,   190,    -1,
     192,   193,   194,   195,    -1,   197,   198,   199,   200,   201,
     202,   203,    -1,   205,    -1,   207,   208,   209,   210,   211,
     212,   213,    -1,   215,    -1,   217,    -1,    -1,   220,    -1,
     222,   223,   224,   225,   226,    -1,    -1,   229,   230,    -1,
     232,    -1,    -1,   235,   236,   237,    -1,    -1,   240,   241,
     242,   243,   244,   245,   246,   247,   248,   249,   250,   251,
     252,   253,   254,   255,   256,   257,   258,    -1,   260,   261,
     262,   263,   264,   265,   266,   267,   268,   269,   270,    -1,
     272,   273,    -1,   275,    -1,   277,   278,   279,   280,   281,
     282,    -1,   284,   285,    -1,    -1,   288,   289,   290,    -1,
      -1,   293,   294,   295,    -1,   297,    -1,   299,   300,   301,
     302,   303,   304,   305,   306,   307,   308,   309,    -1,    -1,
     312,   313,   314,   315,   316,   317,   318,   319,    -1,   321,
     322,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,   333,   334,   335,    -1,   337,   338,   339,   340,   341,
     342,   343,   344,   345,   346,   347,   348,   349,    -1,   351,
     352,    -1,   354,   355,   356,   357,   358,   359,   360,   361,
     362,   363,   364,   365,   366,   367,   368,    -1,   370,   371,
     372,   373,   374,    -1,   376,   377,   378,   379,   380,    -1,
     382,   383,   384,   385,    -1,   387,   388,   389,   390,   391,
     392,   393,   394,   395,   396,   397,   398,   399,   400,   401,
      -1,   403,   404,    -1,   406,    -1,   408,   409,   410,   411,
     412,    -1,   414,   415,   416,    -1,    -1,   419,   420,   421,
     422,   423,    -1,   425,   426,   427,   428,   429,   430,   431,
     432,    -1,    -1,   435,   436,   437,   438,   439,    -1,    -1,
     442,   443,   444,   445,   446,   447,   448,    -1,   450,    -1,
     452,   453,   454,   455,    -1,    -1,   458,    -1,    -1,   461,
     462,   463,   464,   465,   466,   467,   468,   469,   470,   471,
     472,   473,   474,   475,   476,   477,   478,   479,   480,     3,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    20,    21,    22,    23,
      24,    25,    26,    27,    -1,    29,    30,    31,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    39,    40,    41,    -1,    43,
      44,    45,    46,    -1,    48,    49,    50,    51,    52,    -1,
      54,    55,    -1,    57,    58,    59,    60,    61,    62,    63,
      -1,    -1,    66,    67,    68,    69,    70,    -1,    72,    73,
      74,    75,    76,    -1,    -1,    -1,    80,    81,    82,    83,
      84,    85,    -1,    87,    88,    89,    -1,    91,    92,    93,
      94,    95,    96,    -1,    -1,    99,   100,   101,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   109,   110,   111,   112,   113,
     114,   115,   116,   117,    -1,   119,    -1,   121,   122,   123,
     124,   125,   126,   127,    -1,   129,   130,   131,   132,    -1,
      -1,   135,   136,   137,   138,   139,    -1,   141,   142,   143,
      -1,   145,   146,   147,    -1,   149,   150,   151,   152,   153,
     154,   155,   156,   157,   158,    -1,   160,    -1,   162,   163,
     164,   165,   166,    -1,   168,    -1,   170,    -1,    -1,    -1,
     174,   175,   176,   177,    -1,   179,   180,    -1,   182,   183,
     184,    -1,   186,   187,   188,   189,   190,    -1,   192,   193,
     194,   195,    -1,   197,   198,   199,   200,   201,   202,   203,
      -1,   205,    -1,   207,   208,   209,   210,   211,   212,   213,
      -1,   215,    -1,   217,    -1,    -1,   220,    -1,   222,   223,
     224,   225,   226,    -1,    -1,   229,   230,    -1,   232,    -1,
      -1,   235,   236,   237,    -1,    -1,   240,   241,   242,   243,
     244,   245,   246,   247,   248,   249,   250,   251,   252,   253,
     254,   255,   256,   257,   258,    -1,   260,   261,   262,   263,
     264,   265,   266,   267,   268,   269,   270,    -1,   272,   273,
      -1,   275,    -1,   277,   278,   279,   280,   281,   282,    -1,
     284,   285,    -1,    -1,   288,   289,   290,    -1,    -1,   293,
     294,   295,    -1,   297,    -1,   299,   300,   301,   302,   303,
     304,   305,   306,   307,   308,   309,    -1,    -1,   312,   313,
     314,   315,   316,   317,   318,   319,    -1,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,   333,
     334,   335,    -1,   337,   338,   339,   340,   341,   342,   343,
     344,   345,   346,   347,   348,   349,    -1,   351,   352,    -1,
     354,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,   365,   366,   367,   368,    -1,   370,   371,   372,   373,
     374,    -1,   376,   377,   378,   379,   380,    -1,   382,   383,
     384,   385,    -1,   387,   388,   389,   390,   391,   392,   393,
     394,   395,   396,   397,   398,   399,   400,   401,    -1,   403,
     404,    -1,   406,    -1,   408,   409,   410,   411,   412,    -1,
     414,   415,   416,    -1,    -1,   419,   420,   421,   422,   423,
      -1,   425,   426,   427,   428,   429,   430,   431,   432,    -1,
      -1,   435,   436,   437,   438,   439,    -1,    -1,   442,   443,
     444,   445,   446,   447,   448,    -1,   450,    -1,   452,   453,
     454,   455,    -1,    -1,   458,    -1,    -1,   461,   462,   463,
     464,   465,   466,   467,   468,   469,   470,   471,   472,   473,
     474,   475,   476,   477,   478,   479,   480,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,    25,
      26,    27,    -1,    29,    30,    31,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    39,    40,    41,    -1,    43,    44,    45,
      46,    -1,    48,    49,    50,    51,    52,    -1,    54,    55,
      -1,    57,    58,    59,    60,    61,    62,    63,    -1,    -1,
      66,    67,    68,    69,    70,    -1,    72,    73,    74,    75,
      76,    -1,    -1,    -1,    80,    81,    82,    83,    84,    85,
      -1,    87,    88,    89,    -1,    91,    92,    93,    94,    95,
      96,    -1,    -1,    99,   100,   101,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   109,   110,   111,   112,   113,   114,   115,
     116,   117,    -1,   119,    -1,   121,   122,   123,   124,   125,
     126,   127,    -1,   129,   130,   131,   132,    -1,    -1,   135,
     136,   137,   138,   139,    -1,   141,   142,   143,    -1,   145,
     146,   147,    -1,   149,   150,   151,   152,   153,   154,   155,
     156,   157,   158,    -1,   160,    -1,   162,   163,   164,   165,
     166,    -1,   168,    -1,   170,    -1,    -1,    -1,   174,   175,
     176,   177,    -1,   179,   180,    -1,   182,   183,   184,    -1,
     186,   187,   188,   189,   190,    -1,   192,   193,   194,   195,
      -1,   197,   198,   199,   200,   201,   202,   203,    -1,   205,
      -1,   207,   208,   209,   210,   211,   212,   213,    -1,   215,
      -1,   217,    -1,    -1,   220,    -1,   222,   223,   224,   225,
     226,    -1,    -1,   229,   230,    -1,   232,    -1,    -1,   235,
     236,   237,    -1,    -1,   240,   241,   242,   243,   244,   245,
     246,   247,   248,   249,   250,   251,   252,   253,   254,   255,
     256,   257,   258,    -1,   260,   261,   262,   263,   264,   265,
     266,   267,   268,   269,   270,    -1,   272,   273,    -1,   275,
      -1,   277,   278,   279,   280,   281,   282,    -1,   284,   285,
      -1,    -1,   288,   289,   290,    -1,    -1,   293,   294,   295,
      -1,   297,    -1,   299,   300,   301,   302,   303,   304,   305,
     306,   307,   308,   309,    -1,    -1,   312,   313,   314,   315,
     316,   317,   318,   319,    -1,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
      -1,   337,   338,   339,   340,   341,   342,   343,   344,   345,
     346,   347,   348,   349,    -1,   351,   352,    -1,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
     366,   367,   368,    -1,   370,   371,   372,   373,   374,    -1,
     376,   377,   378,   379,   380,    -1,   382,   383,   384,   385,
      -1,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,   399,   400,   401,    -1,   403,   404,    -1,
     406,    -1,   408,   409,   410,   411,   412,    -1,   414,   415,
     416,    -1,    -1,   419,   420,   421,   422,   423,    -1,   425,
     426,   427,   428,   429,   430,   431,   432,    -1,    -1,   435,
     436,   437,   438,   439,    -1,    -1,   442,   443,   444,   445,
     446,   447,   448,    -1,   450,    -1,   452,   453,   454,   455,
      -1,    -1,   458,    -1,    -1,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,   478,   479,   480,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    20,    21,    22,    23,    24,    25,    26,    27,
      -1,    29,    30,    31,    -1,    -1,    -1,    -1,    -1,    37,
      -1,    39,    40,    41,    -1,    43,    44,    45,    46,    -1,
      48,    49,    50,    51,    52,    -1,    54,    55,    -1,    57,
      58,    59,    60,    61,    62,    63,    -1,    -1,    66,    67,
      68,    69,    70,    -1,    72,    73,    74,    75,    76,    -1,
      -1,    -1,    80,    81,    82,    83,    84,    85,    -1,    87,
      88,    89,    -1,    91,    92,    93,    94,    95,    96,    -1,
      -1,    99,   100,   101,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   109,   110,   111,   112,   113,   114,   115,   116,   117,
      -1,   119,    -1,   121,   122,   123,   124,   125,   126,   127,
      -1,   129,   130,   131,   132,    -1,    -1,   135,   136,   137,
     138,   139,    -1,   141,   142,   143,    -1,   145,   146,   147,
      -1,   149,   150,   151,   152,   153,   154,   155,   156,   157,
     158,    -1,   160,    -1,   162,   163,   164,   165,   166,    -1,
     168,    -1,   170,    -1,    -1,    -1,   174,   175,   176,   177,
      -1,   179,   180,    -1,   182,   183,   184,    -1,   186,   187,
     188,   189,   190,    -1,   192,   193,   194,   195,    -1,   197,
     198,   199,   200,   201,   202,   203,    -1,   205,    -1,   207,
     208,   209,   210,   211,   212,   213,    -1,   215,    -1,   217,
      -1,    -1,   220,    -1,   222,   223,   224,   225,   226,    -1,
      -1,   229,   230,    -1,   232,    -1,    -1,   235,   236,   237,
      -1,    -1,   240,   241,   242,   243,   244,   245,   246,   247,
     248,   249,   250,   251,   252,   253,   254,   255,   256,   257,
     258,    -1,   260,   261,   262,   263,   264,   265,   266,   267,
     268,   269,   270,    -1,   272,   273,    -1,   275,    -1,   277,
     278,   279,   280,   281,   282,    -1,   284,   285,    -1,    -1,
     288,   289,   290,    -1,    -1,   293,   294,   295,    -1,   297,
      -1,   299,   300,   301,   302,   303,   304,   305,   306,   307,
     308,   309,    -1,    -1,   312,   313,   314,   315,   316,   317,
     318,   319,    -1,   321,   322,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,   333,   334,   335,    -1,   337,
     338,   339,   340,   341,   342,   343,   344,   345,   346,   347,
     348,   349,    -1,   351,   352,    -1,   354,   355,   356,   357,
     358,   359,   360,   361,   362,   363,   364,   365,   366,   367,
     368,    -1,   370,   371,   372,   373,   374,    -1,    -1,   377,
     378,   379,   380,    -1,   382,   383,   384,   385,    -1,   387,
     388,   389,   390,   391,   392,   393,   394,   395,   396,   397,
     398,   399,   400,   401,    -1,   403,   404,    -1,   406,    -1,
     408,   409,   410,   411,   412,    -1,   414,   415,   416,    -1,
      -1,   419,   420,   421,   422,   423,    -1,   425,   426,   427,
     428,   429,   430,   431,   432,    -1,    -1,   435,   436,   437,
     438,   439,    -1,    -1,   442,   443,   444,   445,   446,   447,
     448,    -1,   450,    -1,   452,   453,   454,   455,    -1,    -1,
     458,    -1,    -1,   461,   462,   463,   464,   465,   466,   467,
     468,   469,   470,   471,   472,   473,   474,   475,   476,   477,
     478,   479,   480,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      20,    21,    22,    23,    24,    25,    26,    27,    -1,    29,
      30,    31,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    39,
      40,    41,    -1,    43,    44,    45,    46,    -1,    48,    49,
      50,    51,    52,    -1,    54,    55,    -1,    57,    58,    59,
      60,    61,    62,    63,    -1,    -1,    66,    67,    68,    69,
      70,    -1,    72,    73,    74,    75,    76,    -1,    -1,    -1,
      80,    81,    82,    83,    84,    85,    -1,    87,    88,    89,
      -1,    91,    92,    93,    94,    95,    96,    -1,    -1,    99,
     100,   101,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   109,
     110,   111,   112,   113,   114,   115,   116,   117,    -1,   119,
      -1,   121,   122,   123,   124,   125,   126,   127,    -1,   129,
     130,   131,   132,    -1,    -1,   135,   136,   137,   138,   139,
      -1,   141,   142,   143,    -1,   145,   146,   147,    -1,   149,
     150,   151,   152,   153,   154,   155,   156,   157,   158,    -1,
     160,    -1,   162,   163,   164,   165,   166,    -1,   168,    -1,
     170,    -1,    -1,    -1,   174,   175,   176,   177,    -1,   179,
     180,    -1,   182,   183,   184,    -1,   186,   187,   188,   189,
     190,    -1,   192,   193,   194,   195,    -1,   197,   198,   199,
     200,   201,   202,   203,    -1,   205,    -1,   207,   208,   209,
     210,   211,   212,   213,    -1,   215,    -1,   217,    -1,    -1,
     220,    -1,   222,   223,   224,   225,   226,    -1,    -1,   229,
     230,    -1,   232,    -1,    -1,   235,   236,   237,    -1,    -1,
     240,   241,   242,   243,   244,   245,   246,   247,   248,   249,
     250,   251,   252,   253,   254,   255,   256,   257,   258,    -1,
     260,   261,   262,   263,   264,   265,   266,   267,   268,   269,
     270,    -1,   272,   273,    -1,   275,    -1,   277,   278,   279,
     280,   281,   282,    -1,   284,   285,    -1,    -1,   288,   289,
     290,    -1,    -1,   293,   294,   295,    -1,   297,    -1,   299,
     300,   301,   302,   303,   304,   305,   306,   307,   308,   309,
      -1,    -1,   312,   313,   314,   315,   316,   317,   318,   319,
      -1,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,    -1,   337,   338,   339,
     340,   341,   342,   343,   344,   345,   346,   347,   348,   349,
      -1,   351,   352,    -1,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,   365,   366,   367,   368,    -1,
     370,   371,   372,   373,   374,    -1,   376,   377,   378,   379,
     380,    -1,   382,   383,   384,   385,    -1,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,   399,
     400,   401,    -1,   403,   404,    -1,   406,    -1,   408,   409,
     410,   411,   412,    -1,   414,   415,   416,    -1,    -1,   419,
     420,   421,   422,   423,    -1,   425,   426,   427,   428,   429,
     430,   431,   432,    -1,    -1,   435,   436,   437,   438,   439,
      -1,    -1,   442,   443,   444,   445,   446,   447,   448,    -1,
     450,    -1,   452,   453,   454,   455,    -1,    -1,   458,    -1,
      -1,   461,   462,   463,   464,   465,   466,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,    21,
      22,    23,    24,    25,    26,    27,    -1,    29,    30,    31,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    39,    40,    41,
      -1,    43,    44,    45,    46,    -1,    48,    49,    50,    51,
      52,    -1,    54,    55,    -1,    57,    58,    59,    60,    61,
      62,    63,    -1,    -1,    66,    67,    68,    69,    70,    -1,
      72,    73,    74,    75,    76,    -1,    -1,    -1,    80,    81,
      82,    83,    84,    85,    -1,    87,    88,    89,    -1,    91,
      92,    93,    94,    95,    96,    -1,    -1,    99,   100,   101,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   109,   110,   111,
     112,   113,   114,   115,   116,   117,    -1,   119,    -1,   121,
     122,   123,   124,   125,   126,   127,    -1,   129,   130,   131,
     132,    -1,    -1,   135,   136,   137,   138,   139,    -1,   141,
     142,   143,    -1,   145,   146,   147,    -1,   149,   150,   151,
     152,   153,   154,   155,   156,   157,   158,    -1,   160,    -1,
     162,   163,   164,   165,   166,    -1,   168,    -1,   170,    -1,
      -1,    -1,   174,   175,   176,   177,    -1,   179,   180,    -1,
     182,   183,   184,    -1,   186,   187,   188,   189,   190,    -1,
     192,   193,   194,   195,    -1,   197,   198,   199,   200,   201,
     202,   203,    -1,   205,    -1,   207,   208,   209,   210,   211,
     212,   213,    -1,   215,    -1,   217,    -1,    -1,   220,    -1,
     222,   223,   224,   225,   226,    -1,    -1,   229,   230,    -1,
     232,    -1,    -1,   235,   236,   237,    -1,    -1,   240,   241,
     242,   243,   244,   245,   246,   247,   248,   249,   250,   251,
     252,   253,   254,   255,   256,   257,   258,    -1,   260,   261,
     262,   263,   264,   265,   266,   267,   268,   269,   270,    -1,
     272,   273,    -1,   275,    -1,   277,   278,   279,   280,   281,
     282,    -1,   284,   285,    -1,    -1,   288,   289,   290,    -1,
      -1,   293,   294,   295,    -1,   297,    -1,   299,   300,   301,
     302,   303,   304,   305,   306,   307,   308,   309,    -1,    -1,
     312,   313,   314,   315,   316,   317,   318,   319,    -1,   321,
     322,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,   333,   334,   335,    -1,   337,   338,   339,   340,   341,
     342,   343,   344,   345,   346,   347,   348,   349,    -1,   351,
     352,    -1,   354,   355,   356,   357,   358,   359,   360,   361,
     362,   363,   364,   365,   366,   367,   368,    -1,   370,   371,
     372,   373,   374,    -1,   376,   377,   378,   379,   380,    -1,
     382,   383,   384,   385,    -1,   387,   388,   389,   390,   391,
     392,   393,   394,   395,   396,   397,   398,   399,   400,   401,
      -1,   403,   404,    -1,   406,    -1,   408,   409,   410,   411,
     412,    -1,   414,   415,   416,    -1,    -1,   419,   420,   421,
     422,   423,    -1,   425,   426,   427,   428,   429,   430,   431,
     432,    -1,    -1,   435,   436,   437,   438,   439,    -1,    -1,
     442,   443,   444,   445,   446,   447,   448,    -1,   450,    -1,
     452,   453,   454,   455,    -1,    -1,   458,    -1,    -1,   461,
     462,   463,   464,   465,   466,   467,   468,   469,   470,   471,
     472,   473,   474,   475,   476,   477,   478,   479,   480,     3,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    20,    21,    22,    23,
      24,    25,    26,    27,    -1,    29,    30,    31,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    39,    40,    41,    -1,    43,
      44,    45,    46,    -1,    48,    49,    50,    51,    52,    -1,
      54,    55,    -1,    57,    58,    59,    60,    61,    62,    63,
      -1,    -1,    66,    67,    68,    69,    70,    -1,    72,    73,
      74,    75,    76,    -1,    -1,    -1,    80,    81,    82,    83,
      84,    85,    -1,    87,    88,    89,    -1,    91,    92,    93,
      94,    95,    96,    -1,    -1,    99,   100,   101,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   109,   110,   111,   112,   113,
     114,   115,   116,   117,    -1,   119,    -1,   121,   122,   123,
     124,   125,   126,   127,    -1,   129,   130,   131,   132,    -1,
      -1,   135,   136,   137,   138,   139,    -1,   141,   142,   143,
      -1,   145,   146,   147,    -1,   149,   150,   151,   152,   153,
     154,   155,   156,   157,   158,    -1,   160,    -1,   162,   163,
     164,   165,   166,    -1,   168,    -1,   170,    -1,    -1,    -1,
     174,   175,   176,   177,    -1,   179,   180,    -1,   182,   183,
     184,    -1,   186,   187,   188,   189,   190,    -1,   192,   193,
     194,   195,    -1,   197,   198,   199,   200,   201,   202,   203,
      -1,   205,    -1,   207,   208,   209,   210,   211,   212,   213,
      -1,   215,    -1,   217,    -1,    -1,   220,    -1,   222,   223,
     224,   225,   226,    -1,    -1,   229,   230,    -1,   232,    -1,
      -1,   235,   236,   237,    -1,    -1,   240,   241,   242,   243,
     244,   245,   246,   247,   248,   249,   250,   251,   252,   253,
     254,   255,   256,   257,   258,    -1,   260,   261,   262,   263,
     264,   265,   266,   267,   268,   269,   270,    -1,   272,   273,
      -1,   275,    -1,   277,   278,   279,   280,   281,   282,    -1,
     284,   285,    -1,    -1,   288,   289,   290,    -1,    -1,   293,
     294,   295,    -1,   297,    -1,   299,   300,   301,   302,   303,
     304,   305,   306,   307,   308,   309,    -1,    -1,   312,   313,
     314,   315,   316,   317,   318,   319,    -1,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,   333,
     334,   335,    -1,   337,   338,   339,   340,   341,   342,   343,
     344,   345,   346,   347,   348,   349,    -1,   351,   352,    -1,
     354,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,   365,   366,   367,   368,    -1,   370,   371,   372,   373,
     374,    -1,   376,   377,   378,   379,   380,    -1,   382,   383,
     384,   385,    -1,   387,   388,   389,   390,   391,   392,   393,
     394,   395,   396,   397,   398,   399,   400,   401,    -1,   403,
     404,    -1,   406,    -1,   408,   409,   410,   411,   412,    -1,
     414,   415,   416,    -1,    -1,   419,   420,   421,   422,   423,
      -1,   425,   426,   427,   428,   429,   430,   431,   432,    -1,
      -1,   435,   436,   437,   438,   439,    -1,    -1,   442,   443,
     444,   445,   446,   447,   448,    -1,   450,    -1,   452,   453,
     454,   455,    -1,    -1,   458,    -1,    -1,   461,   462,   463,
     464,   465,   466,   467,   468,   469,   470,   471,   472,   473,
     474,   475,   476,   477,   478,   479,   480,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,    25,
      26,    27,    -1,    29,    30,    31,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    39,    40,    41,    -1,    43,    44,    45,
      46,    -1,    48,    49,    50,    51,    52,    -1,    54,    55,
      -1,    57,    58,    59,    60,    61,    62,    63,    -1,    -1,
      66,    67,    68,    69,    70,    -1,    72,    73,    74,    75,
      76,    -1,    -1,    -1,    80,    81,    82,    83,    84,    85,
      -1,    87,    88,    89,    -1,    91,    92,    93,    94,    95,
      96,    -1,    -1,    99,   100,   101,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   109,   110,   111,   112,   113,   114,   115,
     116,   117,    -1,   119,    -1,   121,   122,   123,   124,   125,
     126,   127,    -1,   129,   130,   131,   132,    -1,    -1,   135,
     136,   137,   138,   139,    -1,   141,   142,   143,    -1,   145,
     146,   147,    -1,   149,   150,   151,   152,   153,   154,   155,
     156,   157,   158,    -1,   160,    -1,   162,   163,   164,   165,
     166,    -1,   168,    -1,   170,    -1,    -1,    -1,   174,   175,
     176,   177,    -1,   179,   180,    -1,   182,   183,   184,    -1,
     186,   187,   188,   189,   190,    -1,   192,   193,   194,   195,
      -1,   197,   198,   199,   200,   201,   202,   203,    -1,   205,
      -1,   207,   208,   209,   210,   211,   212,   213,    -1,   215,
      -1,   217,    -1,    -1,   220,    -1,   222,   223,   224,   225,
     226,    -1,    -1,   229,   230,    -1,   232,    -1,    -1,   235,
     236,   237,    -1,    -1,   240,   241,   242,   243,   244,   245,
     246,   247,   248,   249,   250,   251,   252,   253,   254,   255,
     256,   257,   258,    -1,   260,   261,   262,   263,   264,   265,
     266,   267,   268,   269,   270,    -1,   272,   273,    -1,   275,
      -1,   277,   278,   279,   280,   281,   282,    -1,   284,   285,
      -1,    -1,   288,   289,   290,    -1,    -1,   293,   294,   295,
      -1,   297,    -1,   299,   300,   301,   302,   303,   304,   305,
     306,   307,   308,   309,    -1,    -1,   312,   313,   314,   315,
     316,   317,   318,   319,    -1,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
      -1,   337,   338,   339,   340,   341,   342,   343,   344,   345,
     346,   347,   348,   349,    -1,   351,   352,    -1,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
     366,   367,   368,    -1,   370,   371,   372,   373,   374,    -1,
     376,   377,   378,   379,   380,    -1,   382,   383,   384,   385,
      -1,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,   399,   400,   401,    -1,   403,   404,    -1,
     406,    -1,   408,   409,   410,   411,   412,    -1,   414,   415,
     416,    -1,    -1,   419,   420,   421,   422,   423,    -1,   425,
     426,   427,   428,   429,   430,   431,   432,    -1,    -1,   435,
     436,   437,   438,   439,    -1,    -1,   442,   443,   444,   445,
     446,   447,   448,    -1,   450,    -1,   452,   453,   454,   455,
      -1,    -1,   458,    -1,    -1,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,   478,   479,   480,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    20,    21,    22,    23,    24,    25,    26,    27,
      -1,    29,    30,    31,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    39,    40,    41,    -1,    43,    44,    45,    46,    -1,
      48,    49,    50,    51,    52,    -1,    54,    55,    -1,    57,
      58,    59,    60,    61,    62,    63,    -1,    -1,    66,    67,
      68,    69,    70,    -1,    72,    73,    74,    75,    76,    -1,
      -1,    -1,    80,    81,    82,    83,    84,    85,    -1,    87,
      88,    89,    -1,    91,    92,    93,    94,    95,    96,    -1,
      -1,    99,   100,   101,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   109,   110,   111,   112,   113,   114,   115,   116,   117,
      -1,   119,    -1,   121,   122,   123,   124,   125,   126,   127,
      -1,   129,   130,   131,   132,    -1,    -1,   135,   136,   137,
     138,   139,    -1,   141,   142,   143,    -1,   145,   146,   147,
      -1,   149,   150,   151,   152,   153,   154,   155,   156,   157,
     158,    -1,   160,    -1,   162,   163,   164,   165,   166,    -1,
     168,    -1,   170,    -1,    -1,    -1,   174,   175,   176,   177,
      -1,   179,   180,    -1,   182,   183,   184,    -1,   186,   187,
     188,   189,   190,    -1,   192,   193,   194,   195,    -1,   197,
     198,   199,   200,   201,   202,   203,    -1,   205,    -1,   207,
     208,   209,   210,   211,   212,   213,    -1,   215,    -1,   217,
      -1,    -1,   220,    -1,   222,   223,   224,   225,   226,    -1,
      -1,   229,   230,    -1,   232,    -1,    -1,   235,   236,   237,
      -1,    -1,   240,   241,   242,   243,   244,   245,   246,   247,
     248,   249,   250,   251,   252,   253,   254,   255,   256,   257,
     258,    -1,   260,   261,   262,   263,   264,   265,   266,   267,
     268,   269,   270,    -1,   272,   273,    -1,   275,    -1,   277,
     278,   279,   280,   281,   282,    -1,   284,   285,    -1,    -1,
     288,   289,   290,    -1,    -1,   293,   294,   295,    -1,   297,
      -1,   299,   300,   301,   302,   303,   304,   305,   306,   307,
     308,   309,    -1,    -1,   312,   313,   314,   315,   316,   317,
     318,   319,    -1,   321,   322,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,   333,   334,   335,    -1,   337,
     338,   339,   340,   341,   342,   343,   344,   345,   346,   347,
     348,   349,    -1,   351,   352,    -1,   354,   355,   356,   357,
     358,   359,   360,   361,   362,   363,   364,   365,   366,   367,
     368,    -1,   370,   371,   372,   373,   374,    -1,   376,   377,
     378,   379,   380,    -1,   382,   383,   384,   385,    -1,   387,
     388,   389,   390,   391,   392,   393,   394,   395,   396,   397,
     398,   399,   400,   401,    -1,   403,   404,    -1,   406,    -1,
     408,   409,   410,   411,   412,    -1,   414,   415,   416,    -1,
      -1,   419,   420,   421,   422,   423,    -1,   425,   426,   427,
     428,   429,   430,   431,   432,    -1,    -1,   435,   436,   437,
     438,   439,    -1,    -1,   442,   443,   444,   445,   446,   447,
     448,    -1,   450,    -1,   452,   453,   454,   455,    -1,    -1,
     458,    -1,    -1,   461,   462,   463,   464,   465,   466,   467,
     468,   469,   470,   471,   472,   473,   474,   475,   476,   477,
     478,   479,   480,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      20,    21,    22,    23,    24,    25,    26,    27,    -1,    29,
      30,    31,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    39,
      40,    41,    -1,    43,    44,    45,    46,    -1,    48,    49,
      50,    51,    52,    -1,    54,    55,    -1,    57,    58,    59,
      60,    61,    62,    63,    -1,    -1,    66,    67,    68,    69,
      70,    -1,    72,    73,    74,    75,    76,    -1,    -1,    -1,
      80,    81,    82,    83,    84,    85,    -1,    87,    88,    89,
      -1,    91,    92,    93,    94,    95,    96,    -1,    -1,    99,
     100,   101,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   109,
     110,   111,   112,   113,   114,   115,   116,   117,    -1,   119,
      -1,   121,   122,   123,   124,   125,   126,   127,    -1,   129,
     130,   131,   132,    -1,    -1,   135,   136,   137,   138,   139,
      -1,   141,   142,   143,    -1,   145,   146,   147,    -1,   149,
     150,   151,   152,   153,   154,   155,   156,   157,   158,    -1,
     160,    -1,   162,   163,   164,   165,   166,    -1,   168,    -1,
     170,    -1,    -1,    -1,   174,   175,   176,   177,    -1,   179,
     180,    -1,   182,   183,   184,    -1,   186,   187,   188,   189,
     190,    -1,   192,   193,   194,   195,    -1,   197,   198,   199,
     200,   201,   202,   203,    -1,   205,    -1,   207,   208,   209,
     210,   211,   212,   213,    -1,   215,    -1,   217,    -1,    -1,
     220,    -1,   222,   223,   224,   225,   226,    -1,    -1,   229,
     230,    -1,   232,    -1,    -1,   235,   236,   237,    -1,    -1,
     240,   241,   242,   243,   244,   245,   246,   247,   248,   249,
     250,   251,   252,   253,   254,   255,   256,   257,   258,    -1,
     260,   261,   262,   263,   264,   265,   266,   267,   268,   269,
     270,    -1,   272,   273,    -1,   275,    -1,   277,   278,   279,
     280,   281,   282,    -1,   284,   285,    -1,    -1,   288,   289,
     290,    -1,    -1,   293,   294,   295,    -1,   297,    -1,   299,
     300,   301,   302,   303,   304,   305,   306,   307,   308,   309,
      -1,    -1,   312,   313,   314,   315,   316,   317,   318,   319,
      -1,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,    -1,   337,   338,   339,
     340,   341,   342,   343,   344,   345,   346,   347,   348,   349,
      -1,   351,   352,    -1,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,   365,   366,   367,   368,    -1,
     370,   371,   372,   373,   374,    -1,   376,   377,   378,   379,
     380,    -1,   382,   383,   384,   385,    -1,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,   399,
     400,   401,    -1,   403,   404,    -1,   406,    -1,   408,   409,
     410,   411,   412,    -1,   414,   415,   416,    -1,    -1,   419,
     420,   421,   422,   423,    -1,   425,   426,   427,   428,   429,
     430,   431,   432,    -1,    -1,   435,   436,   437,   438,   439,
      -1,    -1,   442,   443,   444,   445,   446,   447,   448,    -1,
     450,    -1,   452,   453,   454,   455,    -1,    -1,   458,    -1,
      -1,   461,   462,   463,   464,   465,   466,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,    21,
      22,    23,    24,    25,    26,    27,    -1,    29,    30,    31,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    39,    40,    41,
      -1,    43,    44,    45,    46,    -1,    48,    49,    50,    51,
      52,    -1,    54,    55,    -1,    57,    58,    59,    60,    61,
      62,    63,    -1,    -1,    66,    67,    68,    69,    70,    -1,
      72,    73,    74,    75,    76,    -1,    -1,    -1,    80,    81,
      82,    83,    84,    85,    -1,    87,    88,    89,    -1,    91,
      92,    93,    94,    95,    96,    -1,    -1,    99,   100,   101,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   109,   110,   111,
     112,   113,   114,   115,   116,   117,    -1,   119,    -1,   121,
     122,   123,   124,   125,   126,   127,    -1,   129,   130,   131,
     132,    -1,    -1,   135,   136,   137,   138,   139,    -1,   141,
     142,   143,    -1,   145,   146,   147,    -1,   149,   150,   151,
     152,   153,   154,   155,   156,   157,   158,    -1,   160,    -1,
     162,   163,   164,   165,   166,    -1,   168,    -1,   170,    -1,
      -1,    -1,   174,   175,   176,   177,    -1,   179,   180,    -1,
     182,   183,   184,    -1,   186,   187,   188,   189,   190,    -1,
     192,   193,   194,   195,    -1,   197,   198,   199,   200,   201,
     202,   203,    -1,   205,    -1,   207,   208,   209,   210,   211,
     212,   213,    -1,   215,    -1,   217,    -1,    -1,   220,    -1,
     222,   223,   224,   225,   226,    -1,    -1,   229,   230,    -1,
     232,    -1,    -1,   235,   236,   237,    -1,    -1,   240,   241,
     242,   243,   244,   245,   246,   247,   248,   249,   250,   251,
     252,   253,   254,   255,   256,   257,   258,    -1,   260,   261,
     262,   263,   264,   265,   266,   267,   268,   269,   270,    -1,
     272,   273,    -1,   275,    -1,   277,   278,   279,   280,   281,
     282,    -1,   284,   285,    -1,    -1,   288,   289,   290,    -1,
      -1,   293,   294,   295,    -1,   297,    -1,   299,   300,   301,
     302,   303,   304,   305,   306,   307,   308,   309,    -1,    -1,
     312,   313,   314,   315,   316,   317,   318,   319,    -1,   321,
     322,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,   333,   334,   335,    -1,   337,   338,   339,   340,   341,
     342,   343,   344,   345,   346,   347,   348,   349,    -1,   351,
     352,    -1,   354,   355,   356,   357,   358,   359,   360,   361,
     362,   363,   364,   365,   366,   367,   368,    -1,   370,   371,
     372,   373,   374,    -1,   376,   377,   378,   379,   380,    -1,
     382,   383,   384,   385,    -1,   387,   388,   389,   390,   391,
     392,   393,   394,   395,   396,   397,   398,   399,   400,   401,
      -1,   403,   404,    -1,   406,    -1,   408,   409,   410,   411,
     412,    -1,   414,   415,   416,    -1,    -1,   419,   420,   421,
     422,   423,    -1,   425,   426,   427,   428,   429,   430,   431,
     432,    -1,    -1,   435,   436,   437,   438,   439,    -1,    -1,
     442,   443,   444,   445,   446,   447,   448,    -1,   450,    -1,
     452,   453,   454,   455,    -1,    -1,   458,    -1,    -1,   461,
     462,   463,   464,   465,   466,   467,   468,   469,   470,   471,
     472,   473,   474,   475,   476,   477,   478,   479,   480,     3,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    20,    21,    22,    23,
      24,    25,    26,    27,    -1,    29,    30,    31,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    39,    40,    41,    -1,    43,
      44,    45,    46,    -1,    48,    49,    50,    51,    52,    -1,
      54,    55,    -1,    57,    58,    59,    60,    61,    62,    63,
      -1,    -1,    66,    67,    68,    69,    70,    -1,    72,    73,
      74,    75,    76,    -1,    -1,    -1,    80,    81,    82,    83,
      84,    85,    -1,    87,    88,    89,    -1,    91,    92,    93,
      94,    95,    96,    -1,    -1,    99,   100,   101,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   109,   110,   111,   112,   113,
     114,   115,   116,   117,    -1,   119,    -1,   121,   122,   123,
     124,   125,   126,   127,    -1,   129,   130,   131,   132,    -1,
      -1,   135,   136,   137,   138,   139,    -1,   141,   142,   143,
      -1,   145,   146,   147,    -1,   149,   150,   151,   152,   153,
     154,   155,   156,   157,   158,    -1,   160,    -1,   162,   163,
     164,   165,   166,    -1,   168,    -1,   170,    -1,    -1,    -1,
     174,   175,   176,   177,    -1,   179,   180,    -1,   182,   183,
     184,    -1,   186,   187,   188,   189,   190,    -1,   192,   193,
     194,   195,    -1,   197,   198,   199,   200,   201,   202,   203,
      -1,   205,    -1,   207,   208,   209,   210,   211,   212,   213,
      -1,   215,    -1,   217,    -1,    -1,   220,    -1,   222,   223,
     224,   225,   226,    -1,    -1,   229,   230,    -1,   232,    -1,
      -1,   235,   236,   237,    -1,    -1,   240,   241,   242,   243,
     244,   245,   246,   247,   248,   249,   250,   251,   252,   253,
     254,   255,   256,   257,   258,    -1,   260,   261,   262,   263,
     264,   265,   266,   267,   268,   269,   270,    -1,   272,   273,
      -1,   275,    -1,   277,   278,   279,   280,   281,   282,    -1,
     284,   285,    -1,    -1,   288,   289,   290,    -1,    -1,   293,
     294,   295,    -1,   297,    -1,   299,   300,   301,   302,   303,
     304,   305,   306,   307,   308,   309,    -1,    -1,   312,   313,
     314,   315,   316,   317,   318,   319,    -1,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,   333,
     334,   335,    -1,   337,   338,   339,   340,   341,   342,   343,
     344,   345,   346,   347,   348,   349,    -1,   351,   352,    -1,
     354,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,   365,   366,   367,   368,    -1,   370,   371,   372,   373,
     374,    -1,   376,   377,   378,   379,   380,    -1,   382,   383,
     384,   385,    -1,   387,   388,   389,   390,   391,   392,   393,
     394,   395,   396,   397,   398,   399,   400,   401,    -1,   403,
     404,    -1,   406,    -1,   408,   409,   410,   411,   412,    -1,
     414,   415,   416,    -1,    -1,   419,   420,   421,   422,   423,
      -1,   425,   426,   427,   428,   429,   430,   431,   432,    -1,
      -1,   435,   436,   437,   438,   439,    -1,    -1,   442,   443,
     444,   445,   446,   447,   448,    -1,   450,    -1,   452,   453,
     454,   455,    -1,    -1,   458,    -1,    -1,   461,   462,   463,
     464,   465,   466,   467,   468,   469,   470,   471,   472,   473,
     474,   475,   476,   477,   478,   479,   480,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,    25,
      26,    27,    -1,    29,    30,    31,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    39,    40,    41,    -1,    43,    44,    45,
      46,    -1,    48,    49,    50,    51,    52,    -1,    54,    55,
      -1,    57,    58,    59,    60,    61,    62,    63,    -1,    -1,
      66,    67,    68,    69,    70,    -1,    72,    73,    74,    75,
      76,    -1,    -1,    -1,    80,    81,    82,    83,    84,    85,
      -1,    87,    88,    89,    -1,    91,    92,    93,    94,    95,
      96,    -1,    -1,    99,   100,   101,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   109,   110,   111,   112,   113,   114,   115,
     116,   117,    -1,   119,    -1,   121,   122,   123,   124,   125,
     126,   127,    -1,   129,   130,   131,   132,    -1,    -1,   135,
     136,   137,   138,   139,    -1,   141,   142,   143,    -1,   145,
     146,   147,    -1,   149,   150,   151,   152,   153,   154,   155,
     156,   157,   158,    -1,   160,    -1,   162,   163,   164,   165,
     166,    -1,   168,    -1,   170,    -1,    -1,    -1,   174,   175,
     176,   177,    -1,   179,   180,    -1,   182,   183,   184,    -1,
     186,   187,   188,   189,   190,    -1,   192,   193,   194,   195,
      -1,   197,   198,   199,   200,   201,   202,   203,    -1,   205,
      -1,   207,   208,   209,   210,   211,   212,   213,    -1,   215,
      -1,   217,    -1,    -1,   220,    -1,   222,   223,   224,   225,
     226,    -1,    -1,   229,   230,    -1,   232,    -1,    -1,   235,
     236,   237,    -1,    -1,   240,   241,   242,   243,   244,   245,
     246,   247,   248,   249,   250,   251,   252,   253,   254,   255,
     256,   257,   258,    -1,   260,   261,   262,   263,   264,   265,
     266,   267,   268,   269,   270,    -1,   272,   273,    -1,   275,
      -1,   277,   278,   279,   280,   281,   282,    -1,   284,   285,
      -1,    -1,   288,   289,   290,    -1,    -1,   293,   294,   295,
      -1,   297,    -1,   299,   300,   301,   302,   303,   304,   305,
     306,   307,   308,   309,    -1,    -1,   312,   313,   314,   315,
     316,   317,   318,   319,    -1,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
      -1,   337,   338,   339,   340,   341,   342,   343,   344,   345,
     346,   347,   348,   349,    -1,   351,   352,    -1,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
     366,   367,   368,    -1,   370,   371,   372,   373,   374,    -1,
     376,   377,   378,   379,   380,    -1,   382,   383,   384,   385,
      -1,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,   399,   400,   401,    -1,   403,   404,    -1,
     406,    -1,   408,   409,   410,   411,   412,    -1,   414,   415,
     416,    -1,    -1,   419,   420,   421,   422,   423,    -1,   425,
     426,   427,   428,   429,   430,   431,   432,    -1,    -1,   435,
     436,   437,   438,   439,    -1,    -1,   442,   443,   444,   445,
     446,   447,   448,    -1,   450,    -1,   452,   453,   454,   455,
      -1,    -1,   458,    -1,    -1,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,   478,   479,   480,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    20,    21,    22,    23,    24,    25,    26,    27,
      -1,    29,    30,    31,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    39,    40,    41,    -1,    43,    44,    45,    46,    -1,
      48,    49,    50,    51,    52,    -1,    54,    55,    -1,    57,
      58,    59,    60,    61,    62,    63,    -1,    -1,    66,    67,
      68,    69,    70,    -1,    72,    73,    74,    75,    76,    -1,
      -1,    -1,    80,    81,    82,    83,    84,    85,    -1,    87,
      88,    89,    -1,    91,    92,    93,    94,    95,    96,    -1,
      -1,    99,   100,   101,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   109,   110,   111,   112,   113,   114,   115,   116,   117,
      -1,   119,    -1,   121,   122,   123,   124,   125,   126,   127,
      -1,   129,   130,   131,   132,    -1,    -1,   135,   136,   137,
     138,   139,    -1,   141,   142,   143,    -1,   145,   146,   147,
      -1,   149,   150,   151,   152,   153,   154,   155,   156,   157,
     158,    -1,   160,    -1,   162,   163,   164,   165,   166,    -1,
     168,    -1,   170,    -1,    -1,    -1,   174,   175,   176,   177,
      -1,   179,   180,    -1,   182,   183,   184,    -1,   186,   187,
     188,   189,   190,    -1,   192,   193,   194,   195,    -1,   197,
     198,   199,   200,   201,   202,   203,    -1,   205,    -1,   207,
     208,   209,   210,   211,   212,   213,    -1,   215,    -1,   217,
      -1,    -1,   220,    -1,   222,   223,   224,   225,   226,    -1,
      -1,   229,   230,    -1,   232,    -1,    -1,   235,   236,   237,
      -1,    -1,   240,   241,   242,   243,   244,   245,   246,   247,
     248,   249,   250,   251,   252,   253,   254,   255,   256,   257,
     258,    -1,   260,   261,   262,   263,   264,   265,   266,   267,
     268,   269,   270,    -1,   272,   273,    -1,   275,    -1,   277,
     278,   279,   280,   281,   282,    -1,   284,   285,    -1,    -1,
     288,   289,   290,    -1,    -1,   293,   294,   295,    -1,   297,
      -1,   299,   300,   301,   302,   303,   304,   305,   306,   307,
     308,   309,    -1,    -1,   312,   313,   314,   315,   316,   317,
     318,   319,    -1,   321,   322,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,   333,   334,   335,    -1,   337,
     338,   339,   340,   341,   342,   343,   344,   345,   346,   347,
     348,   349,    -1,   351,   352,    -1,   354,   355,   356,   357,
     358,   359,   360,   361,   362,   363,   364,   365,   366,   367,
     368,    -1,   370,   371,   372,   373,   374,    -1,   376,   377,
     378,   379,   380,    -1,   382,   383,   384,   385,    -1,   387,
     388,   389,   390,   391,   392,   393,   394,   395,   396,   397,
     398,   399,   400,   401,    -1,   403,   404,    -1,   406,    -1,
     408,   409,   410,   411,   412,    -1,   414,   415,   416,    -1,
      -1,   419,   420,   421,   422,   423,    -1,   425,   426,   427,
     428,   429,   430,   431,   432,    -1,    -1,   435,   436,   437,
     438,   439,    -1,    -1,   442,   443,   444,   445,   446,   447,
     448,    -1,   450,    -1,   452,   453,   454,   455,    -1,    -1,
     458,    -1,    -1,   461,   462,   463,   464,   465,   466,   467,
     468,   469,   470,   471,   472,   473,   474,   475,   476,   477,
     478,   479,   480,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      20,    21,    22,    23,    24,    25,    26,    27,    -1,    29,
      30,    31,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    39,
      40,    41,    -1,    43,    44,    45,    46,    -1,    48,    49,
      50,    51,    52,    -1,    54,    55,    -1,    57,    58,    59,
      60,    61,    62,    63,    -1,    -1,    66,    67,    68,    69,
      70,    -1,    72,    73,    74,    75,    76,    -1,    -1,    -1,
      80,    81,    82,    83,    84,    85,    -1,    87,    88,    89,
      -1,    91,    92,    93,    94,    95,    96,    -1,    -1,    99,
     100,   101,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   109,
     110,   111,   112,   113,   114,   115,   116,   117,    -1,   119,
      -1,   121,   122,   123,   124,   125,   126,   127,    -1,   129,
     130,   131,   132,    -1,    -1,   135,   136,   137,   138,   139,
      -1,   141,   142,   143,    -1,   145,   146,   147,    -1,   149,
     150,   151,   152,   153,   154,   155,   156,   157,   158,    -1,
     160,    -1,   162,   163,   164,   165,   166,    -1,   168,    -1,
     170,    -1,    -1,    -1,   174,   175,   176,   177,    -1,   179,
     180,    -1,   182,   183,   184,    -1,   186,   187,   188,   189,
     190,    -1,   192,   193,   194,   195,    -1,   197,   198,   199,
     200,   201,   202,   203,    -1,   205,    -1,   207,   208,   209,
     210,   211,   212,   213,    -1,   215,    -1,   217,    -1,    -1,
     220,    -1,   222,   223,   224,   225,   226,    -1,    -1,   229,
     230,    -1,   232,    -1,    -1,   235,   236,   237,    -1,    -1,
     240,   241,   242,   243,   244,   245,   246,   247,   248,   249,
     250,   251,   252,   253,   254,   255,   256,   257,   258,    -1,
     260,   261,   262,   263,   264,   265,   266,   267,   268,   269,
     270,    -1,   272,   273,    -1,   275,    -1,   277,   278,   279,
     280,   281,   282,    -1,   284,   285,    -1,    -1,   288,   289,
     290,    -1,    -1,   293,   294,   295,    -1,   297,    -1,   299,
     300,   301,   302,   303,   304,   305,   306,   307,   308,   309,
      -1,    -1,   312,   313,   314,   315,   316,   317,   318,   319,
      -1,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,    -1,   337,   338,   339,
     340,   341,   342,   343,   344,   345,   346,   347,   348,   349,
      -1,   351,   352,    -1,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,   365,   366,   367,   368,    -1,
     370,   371,   372,   373,   374,    -1,   376,   377,   378,   379,
     380,    -1,   382,   383,   384,   385,    -1,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,   399,
     400,   401,    -1,   403,   404,    -1,   406,    -1,   408,   409,
     410,   411,   412,    -1,   414,   415,   416,    -1,    -1,   419,
     420,   421,   422,   423,    -1,   425,   426,   427,   428,   429,
     430,   431,   432,    -1,    -1,   435,   436,   437,   438,   439,
      -1,    -1,   442,   443,   444,   445,   446,   447,   448,    -1,
     450,    -1,   452,   453,   454,   455,    -1,    -1,   458,    -1,
      -1,   461,   462,   463,   464,   465,   466,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,    21,
      22,    23,    24,    25,    26,    27,    -1,    29,    30,    31,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    39,    40,    41,
      -1,    43,    44,    45,    46,    -1,    48,    49,    50,    51,
      52,    -1,    54,    55,    -1,    57,    58,    59,    60,    61,
      62,    63,    -1,    -1,    66,    67,    68,    69,    70,    -1,
      72,    73,    74,    75,    76,    -1,    -1,    -1,    80,    81,
      82,    83,    84,    85,    -1,    87,    88,    89,    -1,    91,
      92,    93,    94,    95,    96,    -1,    -1,    99,   100,   101,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   109,   110,   111,
     112,   113,   114,   115,   116,   117,    -1,   119,    -1,   121,
     122,   123,   124,   125,   126,   127,    -1,   129,   130,   131,
     132,    -1,    -1,   135,   136,   137,   138,   139,    -1,   141,
     142,   143,    -1,   145,   146,   147,    -1,   149,   150,   151,
     152,   153,   154,   155,   156,   157,   158,    -1,   160,    -1,
     162,   163,   164,   165,   166,    -1,   168,    -1,   170,    -1,
      -1,    -1,   174,   175,   176,   177,    -1,   179,   180,    -1,
     182,   183,   184,    -1,   186,   187,   188,   189,   190,    -1,
     192,   193,   194,   195,    -1,   197,   198,   199,   200,   201,
     202,   203,    -1,   205,    -1,   207,   208,   209,   210,   211,
     212,   213,    -1,   215,    -1,   217,    -1,    -1,   220,    -1,
     222,   223,   224,   225,   226,    -1,    -1,   229,   230,    -1,
     232,    -1,    -1,   235,   236,   237,    -1,    -1,   240,   241,
     242,   243,   244,   245,   246,   247,   248,   249,   250,   251,
     252,   253,   254,   255,   256,   257,   258,    -1,   260,   261,
     262,   263,   264,   265,   266,   267,   268,   269,   270,    -1,
     272,   273,    -1,   275,    -1,   277,   278,   279,   280,   281,
     282,    -1,   284,   285,    -1,    -1,   288,   289,   290,    -1,
      -1,   293,   294,   295,    -1,   297,    -1,   299,   300,   301,
     302,   303,   304,   305,   306,   307,   308,   309,    -1,    -1,
     312,   313,   314,   315,   316,   317,   318,   319,    -1,   321,
     322,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,   333,   334,   335,    -1,   337,   338,   339,   340,   341,
     342,   343,   344,   345,   346,   347,   348,   349,    -1,   351,
     352,    -1,   354,   355,   356,   357,   358,   359,   360,   361,
     362,   363,   364,   365,   366,   367,   368,    -1,   370,   371,
     372,   373,   374,    -1,   376,   377,   378,   379,   380,    -1,
     382,   383,   384,   385,    -1,   387,   388,   389,   390,   391,
     392,   393,   394,   395,   396,   397,   398,   399,   400,   401,
      -1,   403,   404,    -1,   406,    -1,   408,   409,   410,   411,
     412,    -1,   414,   415,   416,    -1,    -1,   419,   420,   421,
     422,   423,    -1,   425,   426,   427,   428,   429,   430,   431,
     432,    -1,    -1,   435,   436,   437,   438,   439,    -1,    -1,
     442,   443,   444,   445,   446,   447,   448,    -1,   450,    -1,
     452,   453,   454,   455,    -1,    -1,   458,    -1,    -1,   461,
     462,   463,   464,   465,   466,   467,   468,   469,   470,   471,
     472,   473,   474,   475,   476,   477,   478,   479,   480,     3,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    20,    21,    22,    23,
      24,    25,    26,    27,    -1,    29,    30,    31,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    39,    40,    41,    -1,    43,
      44,    45,    46,    -1,    48,    49,    50,    51,    52,    -1,
      54,    55,    -1,    57,    58,    59,    60,    61,    62,    63,
      -1,    -1,    66,    67,    68,    69,    70,    -1,    72,    73,
      74,    75,    76,    -1,    -1,    -1,    80,    81,    82,    83,
      84,    85,    -1,    87,    88,    89,    -1,    91,    92,    93,
      94,    95,    96,    -1,    -1,    99,   100,   101,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   109,   110,   111,   112,   113,
     114,   115,   116,   117,    -1,   119,    -1,   121,   122,   123,
     124,   125,   126,   127,    -1,   129,   130,   131,   132,    -1,
      -1,   135,   136,   137,   138,   139,    -1,   141,   142,   143,
      -1,   145,   146,   147,    -1,   149,   150,   151,   152,   153,
     154,   155,   156,   157,   158,    -1,   160,    -1,   162,   163,
     164,   165,   166,    -1,   168,    -1,   170,    -1,    -1,    -1,
     174,   175,   176,   177,    -1,   179,   180,    -1,   182,   183,
     184,    -1,   186,   187,   188,   189,   190,    -1,   192,   193,
     194,   195,    -1,   197,   198,   199,   200,   201,   202,   203,
      -1,   205,    -1,   207,   208,   209,   210,   211,   212,   213,
      -1,   215,    -1,   217,    -1,    -1,   220,    -1,   222,   223,
     224,   225,   226,    -1,    -1,   229,   230,    -1,   232,    -1,
      -1,   235,   236,   237,    -1,    -1,   240,   241,   242,   243,
     244,   245,   246,   247,   248,   249,   250,   251,   252,   253,
     254,   255,   256,   257,   258,    -1,   260,   261,   262,   263,
     264,   265,   266,   267,   268,   269,   270,    -1,   272,   273,
      -1,   275,    -1,   277,   278,   279,   280,   281,   282,    -1,
     284,   285,    -1,    -1,   288,   289,   290,    -1,    -1,   293,
     294,   295,    -1,   297,    -1,   299,   300,   301,   302,   303,
     304,   305,   306,   307,   308,   309,    -1,    -1,   312,   313,
     314,   315,   316,   317,   318,   319,    -1,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,   333,
     334,   335,    -1,   337,   338,   339,   340,   341,   342,   343,
     344,   345,   346,   347,   348,   349,    -1,   351,   352,    -1,
     354,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,   365,   366,   367,   368,    -1,   370,   371,   372,   373,
     374,    -1,   376,   377,   378,   379,   380,    -1,   382,   383,
     384,   385,    -1,   387,   388,   389,   390,   391,   392,   393,
     394,   395,   396,   397,   398,   399,   400,   401,    -1,   403,
     404,    -1,   406,    -1,   408,   409,   410,   411,   412,    -1,
     414,   415,   416,    -1,    -1,   419,   420,   421,   422,   423,
      -1,   425,   426,   427,   428,   429,   430,   431,   432,    -1,
      -1,   435,   436,   437,   438,   439,    -1,    -1,   442,   443,
     444,   445,   446,   447,   448,    -1,   450,    -1,   452,   453,
     454,   455,    -1,    -1,   458,    -1,    -1,   461,   462,   463,
     464,   465,   466,   467,   468,   469,   470,   471,   472,   473,
     474,   475,   476,   477,   478,   479,   480,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,    25,
      26,    27,    -1,    29,    30,    31,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    39,    40,    41,    -1,    43,    44,    45,
      46,    -1,    48,    49,    50,    51,    52,    -1,    54,    55,
      -1,    57,    58,    59,    60,    61,    62,    63,    -1,    -1,
      66,    67,    68,    69,    70,    -1,    72,    73,    74,    75,
      76,    -1,    -1,    -1,    80,    81,    82,    83,    84,    85,
      -1,    87,    88,    89,    -1,    91,    92,    93,    94,    95,
      96,    -1,    -1,    99,   100,   101,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   109,   110,   111,   112,   113,   114,   115,
     116,   117,    -1,   119,    -1,   121,   122,   123,   124,   125,
     126,   127,    -1,   129,   130,   131,   132,    -1,    -1,   135,
     136,   137,   138,   139,    -1,   141,   142,   143,    -1,   145,
     146,   147,    -1,   149,   150,   151,   152,   153,   154,   155,
     156,   157,   158,    -1,   160,    -1,   162,   163,   164,   165,
     166,    -1,   168,    -1,   170,    -1,    -1,    -1,   174,   175,
     176,   177,    -1,   179,   180,    -1,   182,   183,   184,    -1,
     186,   187,   188,   189,   190,    -1,   192,   193,   194,   195,
      -1,   197,   198,   199,   200,   201,   202,   203,    -1,   205,
      -1,   207,   208,   209,   210,   211,   212,   213,    -1,   215,
      -1,   217,    -1,    -1,   220,    -1,   222,   223,   224,   225,
     226,    -1,    -1,   229,   230,    -1,   232,    -1,    -1,   235,
     236,   237,    -1,    -1,   240,   241,   242,   243,   244,   245,
     246,   247,   248,   249,   250,   251,   252,   253,   254,   255,
     256,   257,   258,    -1,   260,   261,   262,   263,   264,   265,
     266,   267,   268,   269,   270,    -1,   272,   273,    -1,   275,
      -1,   277,   278,   279,   280,   281,   282,    -1,   284,   285,
      -1,    -1,   288,   289,   290,    -1,    -1,   293,   294,   295,
      -1,   297,    -1,   299,   300,   301,   302,   303,   304,   305,
     306,   307,   308,   309,    -1,    -1,   312,   313,   314,   315,
     316,   317,   318,   319,    -1,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
      -1,   337,   338,   339,   340,   341,   342,   343,   344,   345,
     346,   347,   348,   349,    -1,   351,   352,    -1,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
     366,   367,   368,    -1,   370,   371,   372,   373,   374,    -1,
     376,   377,   378,   379,   380,    -1,   382,   383,   384,   385,
      -1,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,   399,   400,   401,    -1,   403,   404,    -1,
     406,    -1,   408,   409,   410,   411,   412,    -1,   414,   415,
     416,    -1,    -1,   419,   420,   421,   422,   423,    -1,   425,
     426,   427,   428,   429,   430,   431,   432,    -1,    -1,   435,
     436,   437,   438,   439,    -1,    -1,   442,   443,   444,   445,
     446,   447,   448,    -1,   450,    -1,   452,   453,   454,   455,
      -1,    -1,   458,    -1,    -1,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,   478,   479,   480,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    20,    21,    22,    23,    24,    25,    26,    27,
      -1,    29,    30,    31,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    39,    40,    41,    -1,    43,    44,    45,    46,    -1,
      48,    49,    50,    51,    52,    -1,    54,    55,    -1,    57,
      58,    59,    60,    61,    62,    63,    -1,    -1,    66,    67,
      68,    69,    70,    -1,    72,    73,    74,    75,    76,    -1,
      -1,    -1,    80,    81,    82,    83,    84,    85,    -1,    87,
      88,    89,    -1,    91,    92,    93,    94,    95,    96,    -1,
      -1,    99,   100,   101,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   109,   110,   111,   112,   113,   114,   115,   116,   117,
      -1,   119,    -1,   121,   122,   123,   124,   125,   126,   127,
      -1,   129,   130,   131,   132,    -1,    -1,   135,   136,   137,
     138,   139,    -1,   141,   142,   143,    -1,   145,   146,   147,
      -1,   149,   150,   151,   152,   153,   154,   155,   156,   157,
     158,    -1,   160,    -1,   162,   163,   164,   165,   166,    -1,
     168,    -1,   170,    -1,    -1,    -1,   174,   175,   176,   177,
      -1,   179,   180,    -1,   182,   183,   184,    -1,   186,   187,
     188,   189,   190,    -1,   192,   193,   194,   195,    -1,   197,
     198,   199,   200,   201,   202,   203,    -1,   205,    -1,   207,
     208,   209,   210,   211,   212,   213,    -1,   215,    -1,   217,
      -1,    -1,   220,    -1,   222,   223,   224,   225,   226,    -1,
      -1,   229,   230,    -1,   232,    -1,    -1,   235,   236,   237,
      -1,    -1,   240,   241,   242,   243,   244,   245,   246,   247,
     248,   249,   250,   251,   252,   253,   254,   255,   256,   257,
     258,    -1,   260,   261,   262,   263,   264,   265,   266,   267,
     268,   269,   270,    -1,   272,   273,    -1,   275,    -1,   277,
     278,   279,   280,   281,   282,    -1,   284,   285,    -1,    -1,
     288,   289,   290,    -1,    -1,   293,   294,   295,    -1,   297,
      -1,   299,   300,   301,   302,   303,   304,   305,   306,   307,
     308,   309,    -1,    -1,   312,   313,   314,   315,   316,   317,
     318,   319,    -1,   321,   322,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,   333,   334,   335,    -1,   337,
     338,   339,   340,   341,   342,   343,   344,   345,   346,   347,
     348,   349,    -1,   351,   352,    -1,   354,   355,   356,   357,
     358,   359,   360,   361,   362,   363,   364,   365,   366,   367,
     368,    -1,   370,   371,   372,   373,   374,    -1,   376,   377,
     378,   379,   380,    -1,   382,   383,   384,   385,    -1,   387,
     388,   389,   390,   391,   392,   393,   394,   395,   396,   397,
     398,   399,   400,   401,    -1,   403,   404,    -1,   406,    -1,
     408,   409,   410,   411,   412,    -1,   414,   415,   416,    -1,
      -1,   419,   420,   421,   422,   423,    -1,   425,   426,   427,
     428,   429,   430,   431,   432,    -1,    -1,   435,   436,   437,
     438,   439,    -1,    -1,   442,   443,   444,   445,   446,   447,
     448,    -1,   450,    -1,   452,   453,   454,   455,    -1,    -1,
     458,    -1,    -1,   461,   462,   463,   464,   465,   466,   467,
     468,   469,   470,   471,   472,   473,   474,   475,   476,   477,
     478,   479,   480,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      20,    21,    22,    23,    24,    25,    26,    27,    -1,    29,
      30,    31,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    39,
      40,    41,    -1,    43,    44,    45,    46,    47,    48,    49,
      50,    -1,    52,    53,    54,    55,    -1,    57,    58,    59,
      60,    61,    62,    63,    -1,    -1,    66,    67,    68,    69,
      70,    -1,    72,    73,    74,    75,    -1,    -1,    78,    -1,
      80,    81,    82,    83,    84,    85,    86,    87,    88,    89,
      -1,    91,    92,    93,    94,    95,    96,    -1,    98,    99,
     100,   101,    -1,    -1,    -1,   105,    -1,    -1,    -1,   109,
     110,   111,   112,   113,   114,   115,   116,   117,    -1,   119,
      -1,   121,   122,   123,   124,   125,   126,   127,    -1,   129,
     130,   131,   132,    -1,    -1,   135,   136,   137,   138,   139,
      -1,   141,   142,   143,    -1,   145,   146,   147,    -1,   149,
     150,   151,   152,    -1,   154,   155,   156,   157,    -1,    -1,
     160,    -1,   162,   163,   164,   165,   166,    -1,   168,    -1,
     170,   171,    -1,   173,   174,   175,   176,   177,    -1,   179,
      -1,    -1,    -1,   183,   184,    -1,   186,   187,   188,   189,
     190,   191,   192,   193,   194,   195,   196,   197,   198,   199,
     200,   201,   202,   203,    -1,   205,   206,   207,   208,   209,
     210,   211,   212,   213,    -1,   215,    -1,   217,   218,   219,
     220,   221,   222,   223,   224,   225,   226,    -1,    -1,   229,
      -1,   231,   232,   233,    -1,   235,   236,   237,    -1,    -1,
     240,   241,   242,   243,   244,   245,   246,   247,   248,   249,
     250,   251,   252,   253,   254,   255,   256,   257,   258,   259,
     260,   261,   262,   263,   264,   265,   266,   267,    -1,    -1,
     270,    -1,   272,   273,   274,   275,    -1,    -1,   278,   279,
     280,   281,   282,    -1,   284,   285,    -1,    -1,   288,   289,
     290,    -1,    -1,   293,   294,   295,   296,   297,   298,    -1,
     300,   301,   302,   303,   304,   305,   306,   307,   308,   309,
      -1,    -1,   312,   313,    -1,   315,    -1,   317,   318,   319,
      -1,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,    -1,   337,   338,   339,
     340,   341,   342,   343,   344,   345,   346,   347,   348,   349,
      -1,   351,   352,   353,   354,   355,   356,   357,   358,    -1,
     360,   361,   362,   363,   364,   365,   366,   367,   368,    -1,
     370,   371,   372,   373,   374,    -1,   376,   377,   378,   379,
     380,   381,   382,   383,   384,   385,    -1,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,   399,
      -1,   401,    -1,   403,   404,    -1,   406,   407,   408,   409,
     410,   411,   412,    -1,   414,   415,   416,    -1,    -1,   419,
     420,    -1,   422,    -1,    -1,   425,   426,   427,   428,   429,
     430,   431,   432,    -1,    -1,   435,   436,   437,   438,   439,
      -1,    -1,   442,   443,   444,   445,   446,    -1,   448,   449,
     450,   451,   452,   453,   454,   455,    -1,    -1,   458,    -1,
      -1,   461,   462,   463,   464,   465,   466,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   478,   479,
     480,    -1,    -1,    -1,    20,    21,    22,    23,    24,    25,
      26,    27,    -1,    29,    30,    31,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    39,    40,    41,    -1,    43,    44,    45,
      46,    -1,    48,    49,    50,    51,    52,    -1,    54,    55,
      -1,    57,    58,    59,    60,    61,    62,    63,    -1,    -1,
      66,    67,    68,    69,    70,    -1,    72,    73,    74,    75,
      76,    -1,    -1,    -1,    80,    81,    82,    83,    84,    85,
      -1,    87,    88,    89,    -1,    91,    92,    93,    94,    95,
      96,    -1,    -1,    99,   100,   101,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   109,   110,   111,   112,   113,   114,   115,
     116,   117,    -1,   119,    -1,   121,   122,   123,   124,   125,
     126,   127,    -1,   129,   130,   131,   132,    -1,    -1,   135,
     136,   137,   138,   139,    -1,   141,   142,   143,    -1,   145,
     146,   147,    -1,   149,   150,   151,   152,   153,   154,   155,
     156,   157,   158,    -1,   160,    -1,   162,   163,   164,   165,
     166,    -1,   168,    -1,   170,    -1,    -1,    -1,   174,   175,
     176,   177,    -1,   179,   180,    -1,   182,    -1,   184,    -1,
     186,   187,   188,   189,   190,    -1,   192,   193,   194,   195,
      -1,   197,   198,   199,   200,   201,   202,   203,    -1,   205,
      -1,   207,   208,   209,   210,   211,   212,   213,    -1,   215,
      -1,   217,    -1,    -1,   220,    -1,   222,   223,   224,   225,
     226,    -1,    -1,   229,   230,    -1,   232,    -1,    -1,   235,
     236,   237,    -1,    -1,   240,   241,   242,   243,   244,   245,
     246,   247,   248,   249,   250,   251,   252,   253,   254,   255,
     256,   257,   258,    -1,   260,   261,   262,   263,   264,   265,
     266,   267,   268,   269,   270,    -1,   272,   273,    -1,   275,
      -1,   277,   278,   279,   280,   281,   282,    -1,   284,   285,
      -1,    -1,   288,   289,   290,    -1,    -1,   293,   294,   295,
      -1,   297,    -1,   299,   300,   301,   302,   303,   304,   305,
     306,    -1,   308,   309,    -1,    -1,   312,   313,   314,   315,
     316,   317,   318,   319,    -1,   321,   322,   323,   324,   325,
     326,   327,   328,    -1,   330,   331,   332,   333,   334,   335,
      -1,   337,   338,   339,   340,   341,   342,   343,   344,   345,
     346,   347,   348,   349,    -1,   351,   352,    -1,   354,   355,
     356,   357,   358,   359,    -1,   361,   362,   363,   364,   365,
     366,   367,   368,    -1,   370,   371,   372,   373,   374,    -1,
     376,   377,   378,   379,   380,    -1,   382,   383,   384,   385,
      -1,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,   399,   400,   401,    -1,   403,   404,    -1,
     406,    -1,   408,   409,   410,   411,   412,    -1,   414,   415,
     416,    -1,    -1,   419,   420,   421,   422,   423,    -1,   425,
     426,   427,   428,   429,   430,   431,   432,    -1,    -1,   435,
     436,   437,   438,   439,    -1,    -1,   442,   443,   444,   445,
     446,   447,   448,    -1,   450,    -1,   452,   453,   454,   455,
      -1,    -1,   458,    -1,    -1,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,   478,   479,   480,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    20,    21,    22,    23,    24,    25,    26,    27,
      -1,    29,    30,    31,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    39,    40,    41,    -1,    43,    44,    45,    46,    47,
      48,    49,    50,    -1,    52,    53,    54,    55,    -1,    57,
      58,    59,    60,    61,    62,    63,    -1,    -1,    66,    67,
      68,    69,    70,    -1,    72,    73,    74,    75,    -1,    -1,
      78,    -1,    80,    81,    82,    83,    84,    85,    86,    87,
      88,    89,    -1,    91,    92,    93,    94,    95,    96,    -1,
      98,    99,   100,   101,    -1,    -1,    -1,   105,    -1,    -1,
      -1,   109,   110,   111,   112,   113,   114,   115,   116,   117,
      -1,   119,    -1,   121,   122,   123,   124,   125,   126,   127,
      -1,   129,   130,   131,   132,    -1,    -1,   135,   136,   137,
     138,   139,    -1,   141,   142,   143,    -1,   145,   146,   147,
      -1,   149,   150,   151,   152,    -1,   154,   155,   156,   157,
      -1,    -1,   160,    -1,   162,   163,   164,   165,   166,    -1,
     168,    -1,   170,   171,    -1,   173,   174,   175,   176,   177,
      -1,   179,    -1,    -1,    -1,   183,   184,    -1,   186,   187,
     188,   189,   190,   191,   192,   193,   194,   195,    -1,   197,
     198,   199,   200,   201,   202,   203,    -1,   205,   206,    -1,
     208,   209,   210,   211,   212,   213,    -1,   215,    -1,   217,
     218,   219,   220,   221,   222,   223,   224,   225,   226,    -1,
      -1,   229,    -1,   231,   232,   233,    -1,   235,   236,   237,
      -1,    -1,   240,   241,   242,   243,   244,   245,   246,   247,
     248,   249,   250,   251,   252,   253,   254,   255,   256,   257,
     258,   259,   260,   261,   262,   263,   264,   265,   266,   267,
      -1,    -1,   270,    -1,   272,   273,   274,   275,   276,    -1,
     278,   279,   280,   281,   282,    -1,   284,   285,    -1,    -1,
     288,   289,   290,    -1,    -1,   293,   294,    -1,   296,   297,
     298,    -1,   300,   301,   302,   303,   304,   305,   306,   307,
     308,   309,    -1,    -1,   312,   313,    -1,   315,    -1,   317,
     318,   319,    -1,   321,   322,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,   333,   334,   335,    -1,   337,
     338,   339,   340,   341,   342,   343,   344,   345,   346,   347,
     348,   349,    -1,   351,   352,   353,   354,   355,   356,   357,
     358,    -1,   360,   361,   362,   363,   364,   365,   366,   367,
     368,    -1,   370,   371,   372,   373,   374,    -1,   376,   377,
     378,   379,   380,   381,   382,   383,   384,   385,    -1,   387,
     388,   389,   390,   391,   392,   393,   394,   395,   396,   397,
     398,   399,    -1,   401,    -1,   403,   404,   405,   406,   407,
     408,   409,   410,   411,   412,    -1,   414,   415,   416,    -1,
      -1,   419,   420,    -1,   422,    -1,    -1,   425,   426,   427,
     428,   429,   430,   431,   432,    -1,    -1,   435,   436,   437,
     438,   439,    -1,    -1,   442,   443,   444,   445,   446,    -1,
     448,    -1,   450,   451,   452,   453,   454,   455,    -1,    -1,
     458,    -1,    -1,   461,   462,   463,   464,   465,   466,     3,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     478,   479,   480,    -1,    -1,    -1,    20,    21,    22,    23,
      24,    25,    26,    27,    -1,    29,    30,    31,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    39,    40,    41,    -1,    43,
      44,    45,    46,    47,    48,    49,    50,    -1,    52,    53,
      54,    55,    -1,    57,    58,    59,    60,    61,    62,    63,
      -1,    -1,    66,    67,    68,    69,    70,    -1,    72,    73,
      74,    75,    -1,    -1,    78,    -1,    80,    81,    82,    83,
      84,    85,    86,    87,    88,    89,    -1,    91,    92,    93,
      94,    95,    96,    -1,    98,    99,   100,   101,    -1,    -1,
      -1,   105,    -1,    -1,    -1,   109,   110,   111,   112,   113,
     114,   115,   116,   117,    -1,   119,    -1,   121,   122,   123,
     124,   125,   126,   127,    -1,   129,   130,   131,   132,    -1,
      -1,   135,   136,   137,   138,   139,    -1,   141,   142,   143,
      -1,   145,   146,   147,    -1,   149,   150,   151,   152,    -1,
     154,   155,   156,   157,    -1,    -1,   160,    -1,   162,   163,
     164,   165,   166,    -1,   168,    -1,   170,   171,    -1,   173,
     174,   175,   176,   177,    -1,   179,    -1,    -1,    -1,   183,
     184,    -1,   186,   187,   188,   189,   190,   191,   192,   193,
     194,   195,    -1,   197,   198,   199,   200,   201,   202,   203,
      -1,   205,   206,    -1,   208,   209,   210,   211,   212,   213,
      -1,   215,    -1,   217,   218,   219,   220,   221,   222,   223,
     224,   225,   226,    -1,    -1,   229,    -1,   231,   232,   233,
      -1,   235,   236,   237,    -1,    -1,   240,   241,   242,   243,
     244,   245,   246,   247,   248,   249,   250,   251,   252,   253,
     254,   255,   256,   257,   258,   259,   260,   261,   262,   263,
     264,   265,   266,   267,   268,    -1,   270,    -1,   272,   273,
     274,   275,    -1,    -1,   278,   279,   280,   281,   282,    -1,
     284,   285,    -1,    -1,   288,   289,   290,    -1,    -1,   293,
     294,    -1,   296,   297,   298,    -1,   300,   301,   302,   303,
     304,   305,   306,   307,   308,   309,    -1,    -1,   312,   313,
      -1,   315,    -1,   317,   318,   319,    -1,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,   333,
     334,   335,    -1,   337,   338,   339,   340,   341,   342,   343,
     344,   345,   346,   347,   348,   349,    -1,   351,   352,   353,
     354,   355,   356,   357,   358,    -1,   360,   361,   362,   363,
     364,   365,   366,   367,   368,    -1,   370,   371,   372,   373,
     374,    -1,   376,   377,   378,   379,   380,   381,   382,   383,
     384,   385,    -1,   387,   388,   389,   390,   391,   392,   393,
     394,   395,   396,   397,   398,   399,    -1,   401,    -1,   403,
     404,    -1,   406,   407,   408,   409,   410,   411,   412,    -1,
     414,   415,   416,    -1,    -1,   419,   420,    -1,   422,    -1,
      -1,   425,   426,   427,   428,   429,   430,   431,   432,    -1,
      -1,   435,   436,   437,   438,   439,    -1,    -1,   442,   443,
     444,   445,   446,    -1,   448,    -1,   450,   451,   452,   453,
     454,   455,    -1,    -1,   458,    -1,    -1,   461,   462,   463,
     464,   465,   466,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   478,   479,   480,    -1,    -1,    -1,
      20,    21,    22,    23,    24,    25,    26,    27,    -1,    29,
      30,    31,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    39,
      40,    41,    -1,    43,    44,    45,    46,    47,    48,    49,
      50,    -1,    52,    53,    54,    55,    -1,    57,    58,    59,
      60,    61,    62,    63,    -1,    -1,    66,    67,    68,    69,
      70,    -1,    72,    73,    74,    75,    -1,    -1,    78,    -1,
      80,    81,    82,    83,    84,    85,    86,    87,    88,    89,
      -1,    91,    92,    93,    94,    95,    96,    -1,    98,    99,
     100,   101,    -1,    -1,    -1,   105,    -1,    -1,    -1,   109,
     110,   111,   112,   113,   114,   115,   116,   117,    -1,   119,
      -1,   121,   122,   123,   124,   125,   126,   127,    -1,   129,
     130,   131,   132,    -1,    -1,   135,   136,   137,   138,   139,
      -1,   141,   142,   143,    -1,   145,   146,   147,    -1,   149,
     150,   151,   152,    -1,   154,   155,   156,   157,    -1,    -1,
     160,    -1,   162,   163,   164,   165,   166,    -1,   168,    -1,
     170,   171,    -1,   173,   174,   175,   176,   177,    -1,   179,
      -1,    -1,    -1,   183,   184,    -1,   186,   187,   188,   189,
     190,   191,   192,   193,   194,   195,    -1,   197,   198,   199,
     200,   201,   202,   203,    -1,   205,   206,    -1,   208,   209,
     210,   211,   212,   213,    -1,   215,    -1,   217,   218,   219,
     220,   221,   222,   223,   224,   225,   226,    -1,    -1,   229,
      -1,   231,   232,   233,    -1,   235,   236,   237,    -1,    -1,
     240,   241,   242,   243,   244,   245,   246,   247,   248,   249,
     250,   251,   252,   253,   254,   255,   256,   257,   258,   259,
     260,   261,   262,   263,   264,   265,   266,   267,   268,    -1,
     270,    -1,   272,   273,   274,   275,    -1,    -1,   278,   279,
     280,   281,   282,    -1,   284,   285,    -1,    -1,   288,   289,
     290,    -1,    -1,   293,   294,    -1,   296,   297,   298,    -1,
     300,   301,   302,   303,   304,   305,   306,   307,   308,   309,
      -1,    -1,   312,   313,    -1,   315,    -1,   317,   318,   319,
      -1,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,    -1,   337,   338,   339,
     340,   341,   342,   343,   344,   345,   346,   347,   348,   349,
      -1,   351,   352,   353,   354,   355,   356,   357,   358,    -1,
     360,   361,   362,   363,   364,   365,   366,   367,   368,    -1,
     370,   371,   372,   373,   374,    -1,   376,   377,   378,   379,
     380,   381,   382,   383,   384,   385,    -1,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,   399,
      -1,   401,    -1,   403,   404,    -1,   406,   407,   408,   409,
     410,   411,   412,    -1,   414,   415,   416,    -1,    -1,   419,
     420,    -1,   422,    -1,    -1,   425,   426,   427,   428,   429,
     430,   431,   432,    -1,    -1,   435,   436,   437,   438,   439,
      -1,    -1,   442,   443,   444,   445,   446,    -1,   448,    -1,
     450,   451,   452,   453,   454,   455,    -1,    -1,   458,    -1,
      -1,   461,   462,   463,   464,   465,   466,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   478,   479,
     480,    -1,    -1,    -1,    20,    21,    22,    23,    24,    25,
      26,    27,    -1,    29,    30,    31,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    39,    40,    41,    -1,    43,    44,    45,
      46,    47,    48,    49,    50,    -1,    52,    53,    54,    55,
      -1,    57,    58,    59,    60,    61,    62,    63,    -1,    -1,
      66,    67,    68,    69,    70,    -1,    72,    73,    74,    75,
      -1,    -1,    78,    -1,    80,    81,    82,    83,    84,    85,
      86,    87,    88,    89,    -1,    91,    92,    93,    94,    95,
      96,    -1,    98,    99,   100,   101,    -1,    -1,    -1,   105,
      -1,    -1,    -1,   109,   110,   111,   112,   113,   114,   115,
     116,   117,    -1,   119,    -1,   121,   122,   123,   124,   125,
     126,   127,    -1,   129,   130,   131,   132,    -1,    -1,   135,
     136,   137,   138,   139,    -1,   141,   142,   143,    -1,   145,
     146,   147,    -1,   149,   150,   151,   152,    -1,   154,   155,
     156,   157,    -1,    -1,   160,    -1,   162,   163,   164,   165,
     166,   167,   168,    -1,   170,   171,    -1,   173,   174,   175,
     176,   177,    -1,   179,    -1,    -1,    -1,   183,   184,    -1,
     186,   187,   188,   189,   190,   191,   192,   193,   194,   195,
      -1,   197,   198,   199,   200,   201,   202,   203,    -1,   205,
     206,    -1,   208,   209,   210,   211,   212,   213,    -1,   215,
      -1,   217,   218,   219,   220,   221,   222,   223,   224,   225,
     226,    -1,    -1,   229,    -1,   231,   232,   233,    -1,   235,
     236,   237,    -1,    -1,   240,   241,   242,   243,   244,   245,
     246,   247,   248,   249,   250,   251,   252,   253,   254,   255,
     256,   257,   258,   259,   260,   261,   262,   263,   264,   265,
     266,   267,    -1,    -1,   270,    -1,   272,   273,   274,   275,
      -1,    -1,   278,   279,   280,   281,   282,    -1,   284,   285,
      -1,    -1,   288,   289,   290,    -1,    -1,   293,   294,    -1,
     296,   297,   298,    -1,   300,   301,   302,   303,   304,   305,
     306,   307,   308,   309,    -1,    -1,   312,   313,    -1,   315,
      -1,   317,   318,   319,    -1,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
      -1,   337,   338,   339,   340,   341,   342,   343,   344,   345,
     346,   347,   348,   349,    -1,   351,   352,   353,   354,   355,
     356,   357,   358,    -1,   360,   361,   362,   363,   364,   365,
     366,   367,   368,    -1,   370,   371,   372,   373,   374,    -1,
     376,   377,   378,   379,   380,   381,   382,   383,   384,   385,
      -1,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,   399,    -1,   401,    -1,   403,   404,    -1,
     406,   407,   408,   409,   410,   411,   412,    -1,   414,   415,
     416,    -1,    -1,   419,   420,    -1,   422,    -1,    -1,   425,
     426,   427,   428,   429,   430,   431,   432,    -1,    -1,   435,
     436,   437,   438,   439,    -1,    -1,   442,   443,   444,   445,
     446,    -1,   448,    -1,   450,   451,   452,   453,   454,   455,
      -1,    -1,   458,    -1,    -1,   461,   462,   463,   464,   465,
     466,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   478,   479,   480,    -1,    -1,    -1,    20,    21,
      22,    23,    24,    25,    26,    27,    -1,    29,    30,    31,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    39,    40,    41,
      -1,    43,    44,    45,    46,    47,    48,    49,    50,    -1,
      52,    53,    54,    55,    -1,    57,    58,    59,    60,    61,
      62,    63,    -1,    -1,    66,    67,    68,    69,    70,    -1,
      72,    73,    74,    75,    -1,    -1,    78,    -1,    80,    81,
      82,    83,    84,    85,    86,    87,    88,    89,    -1,    91,
      92,    93,    94,    95,    96,    -1,    98,    99,   100,   101,
      -1,    -1,    -1,   105,    -1,    -1,    -1,   109,   110,   111,
     112,   113,   114,   115,   116,   117,    -1,   119,    -1,   121,
     122,   123,   124,   125,   126,   127,    -1,   129,   130,   131,
     132,    -1,    -1,   135,   136,   137,   138,   139,    -1,   141,
     142,   143,    -1,   145,   146,   147,    -1,   149,   150,   151,
     152,    -1,   154,   155,   156,   157,    -1,    -1,   160,    -1,
     162,   163,   164,   165,   166,    -1,   168,    -1,   170,   171,
      -1,   173,   174,   175,   176,   177,    -1,   179,    -1,    -1,
      -1,   183,   184,    -1,   186,   187,   188,   189,   190,   191,
     192,   193,   194,   195,    -1,   197,   198,   199,   200,   201,
     202,   203,    -1,   205,   206,    -1,   208,   209,   210,   211,
     212,   213,    -1,   215,    -1,   217,   218,   219,   220,   221,
     222,   223,   224,   225,   226,    -1,    -1,   229,    -1,   231,
     232,   233,    -1,   235,   236,   237,    -1,    -1,   240,   241,
     242,   243,   244,   245,   246,   247,   248,   249,   250,   251,
     252,   253,   254,   255,   256,   257,   258,   259,   260,   261,
     262,   263,   264,   265,   266,   267,    -1,    -1,   270,    -1,
     272,   273,   274,   275,    -1,    -1,   278,   279,   280,   281,
     282,    -1,   284,   285,    -1,    -1,   288,   289,   290,    -1,
      -1,   293,   294,    -1,   296,   297,   298,    -1,   300,   301,
     302,   303,   304,   305,   306,   307,   308,   309,    -1,    -1,
     312,   313,    -1,   315,    -1,   317,   318,   319,    -1,   321,
     322,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,   333,   334,   335,    -1,   337,   338,   339,   340,   341,
     342,   343,   344,   345,   346,   347,   348,   349,    -1,   351,
     352,   353,   354,   355,   356,   357,   358,    -1,   360,   361,
     362,   363,   364,   365,   366,   367,   368,    -1,   370,   371,
     372,   373,   374,    -1,   376,   377,   378,   379,   380,   381,
     382,   383,   384,   385,    -1,   387,   388,   389,   390,   391,
     392,   393,   394,   395,   396,   397,   398,   399,    -1,   401,
      -1,   403,   404,    -1,   406,   407,   408,   409,   410,   411,
     412,    -1,   414,   415,   416,    -1,    -1,   419,   420,    -1,
     422,    -1,    -1,   425,   426,   427,   428,   429,   430,   431,
     432,    -1,    -1,   435,   436,   437,   438,   439,    -1,    -1,
     442,   443,   444,   445,   446,    -1,   448,    -1,   450,   451,
     452,   453,   454,   455,    -1,    -1,   458,    -1,    -1,   461,
     462,   463,   464,   465,   466,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   478,   479,   480,    -1,
      -1,    -1,    20,    21,    22,    23,    24,    25,    26,    27,
      -1,    29,    30,    31,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    39,    40,    41,    -1,    43,    44,    45,    46,    47,
      48,    49,    50,    -1,    52,    53,    54,    55,    -1,    57,
      58,    59,    60,    61,    62,    63,    -1,    -1,    66,    67,
      68,    69,    70,    -1,    72,    73,    74,    75,    -1,    -1,
      78,    -1,    80,    81,    82,    83,    84,    85,    86,    87,
      88,    89,    -1,    91,    92,    93,    94,    95,    96,    -1,
      98,    99,   100,   101,    -1,    -1,    -1,   105,    -1,    -1,
      -1,   109,   110,   111,   112,   113,   114,   115,   116,   117,
      -1,   119,    -1,   121,   122,   123,   124,   125,   126,   127,
      -1,   129,   130,   131,   132,    -1,    -1,   135,   136,   137,
     138,   139,    -1,   141,   142,   143,    -1,   145,   146,   147,
      -1,   149,   150,   151,   152,    -1,   154,   155,   156,   157,
      -1,    -1,   160,    -1,   162,   163,   164,   165,   166,    -1,
     168,    -1,   170,   171,    -1,   173,   174,   175,   176,   177,
      -1,   179,    -1,    -1,    -1,   183,   184,    -1,   186,   187,
     188,   189,   190,   191,   192,   193,   194,   195,    -1,   197,
     198,   199,   200,   201,   202,   203,    -1,   205,   206,    -1,
     208,   209,   210,   211,   212,   213,    -1,   215,    -1,   217,
     218,   219,   220,   221,   222,   223,   224,   225,   226,    -1,
      -1,   229,    -1,   231,   232,   233,    -1,   235,   236,   237,
      -1,    -1,   240,   241,   242,   243,   244,   245,   246,   247,
     248,   249,   250,   251,   252,   253,   254,   255,   256,   257,
     258,   259,   260,   261,   262,   263,   264,   265,   266,   267,
      -1,    -1,   270,    -1,   272,   273,   274,   275,    -1,    -1,
     278,   279,   280,   281,   282,    -1,   284,   285,    -1,    -1,
     288,   289,   290,    -1,    -1,   293,   294,    -1,   296,   297,
     298,    -1,   300,   301,   302,   303,   304,   305,   306,   307,
     308,   309,    -1,    -1,   312,   313,    -1,   315,    -1,   317,
     318,   319,    -1,   321,   322,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,   333,   334,   335,    -1,   337,
     338,   339,   340,   341,   342,   343,   344,   345,   346,   347,
     348,   349,    -1,   351,   352,   353,   354,   355,   356,   357,
     358,    -1,   360,   361,   362,   363,   364,   365,   366,   367,
     368,    -1,   370,   371,   372,   373,   374,    -1,   376,   377,
     378,   379,   380,   381,   382,   383,   384,   385,    -1,   387,
     388,   389,   390,   391,   392,   393,   394,   395,   396,   397,
     398,   399,    -1,   401,    -1,   403,   404,    -1,   406,   407,
     408,   409,   410,   411,   412,    -1,   414,   415,   416,    -1,
      -1,   419,   420,    -1,   422,    -1,    -1,   425,   426,   427,
     428,   429,   430,   431,   432,    -1,    -1,   435,   436,   437,
     438,   439,    -1,    -1,   442,   443,   444,   445,   446,    -1,
     448,    -1,   450,   451,   452,   453,   454,   455,    -1,    -1,
     458,    -1,    -1,   461,   462,   463,   464,   465,   466,     3,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     478,   479,   480,    -1,    -1,    -1,    20,    21,    22,    23,
      24,    25,    26,    27,    -1,    29,    30,    31,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    39,    40,    41,    -1,    43,
      44,    45,    46,    47,    48,    49,    50,    -1,    52,    53,
      54,    55,    -1,    57,    58,    59,    60,    61,    62,    63,
      -1,    -1,    66,    67,    68,    69,    70,    -1,    72,    73,
      74,    75,    -1,    -1,    78,    -1,    80,    81,    82,    83,
      84,    85,    86,    87,    88,    89,    -1,    91,    92,    93,
      94,    95,    96,    -1,    98,    99,   100,   101,    -1,    -1,
      -1,   105,    -1,    -1,    -1,   109,   110,   111,   112,   113,
     114,   115,   116,   117,    -1,   119,    -1,   121,   122,   123,
     124,   125,   126,   127,    -1,   129,   130,   131,   132,    -1,
      -1,   135,   136,   137,   138,   139,    -1,   141,   142,   143,
      -1,   145,   146,   147,    -1,   149,   150,   151,   152,    -1,
     154,   155,   156,   157,    -1,    -1,   160,    -1,   162,   163,
     164,   165,   166,    -1,   168,    -1,   170,   171,    -1,   173,
     174,   175,   176,   177,    -1,   179,    -1,    -1,    -1,   183,
     184,    -1,   186,   187,   188,   189,   190,   191,   192,   193,
     194,   195,    -1,   197,   198,   199,   200,   201,   202,   203,
      -1,   205,   206,    -1,   208,   209,   210,   211,   212,   213,
      -1,   215,    -1,   217,   218,   219,   220,   221,   222,   223,
     224,   225,   226,    -1,    -1,   229,    -1,   231,   232,   233,
      -1,   235,   236,   237,    -1,    -1,   240,   241,   242,   243,
     244,   245,   246,   247,   248,   249,   250,   251,   252,   253,
     254,   255,   256,   257,   258,   259,   260,   261,   262,   263,
     264,   265,   266,   267,    -1,    -1,   270,    -1,   272,   273,
     274,   275,    -1,    -1,   278,   279,   280,   281,   282,    -1,
     284,   285,    -1,    -1,   288,   289,   290,    -1,    -1,   293,
     294,    -1,   296,   297,   298,    -1,   300,   301,   302,   303,
     304,   305,   306,   307,   308,   309,    -1,    -1,   312,   313,
      -1,   315,    -1,   317,   318,   319,    -1,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,   333,
     334,   335,    -1,   337,   338,   339,   340,   341,   342,   343,
     344,   345,   346,   347,   348,   349,    -1,   351,   352,   353,
     354,   355,   356,   357,   358,    -1,   360,   361,   362,   363,
     364,   365,   366,   367,   368,    -1,   370,   371,   372,   373,
     374,    -1,   376,   377,   378,   379,   380,   381,   382,   383,
     384,   385,    -1,   387,   388,   389,   390,   391,   392,   393,
     394,   395,   396,   397,   398,   399,    -1,   401,    -1,   403,
     404,    -1,   406,   407,   408,   409,   410,   411,   412,    -1,
     414,   415,   416,    -1,    -1,   419,   420,    -1,   422,    -1,
      -1,   425,   426,   427,   428,   429,   430,   431,   432,    -1,
      -1,   435,   436,   437,   438,   439,    -1,    -1,   442,   443,
     444,   445,   446,    -1,   448,    -1,   450,   451,   452,   453,
     454,   455,    -1,    -1,   458,    -1,    -1,   461,   462,   463,
     464,   465,   466,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   478,   479,   480,    -1,    -1,    -1,
      20,    21,    22,    23,    24,    25,    26,    27,    -1,    29,
      30,    31,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    39,
      40,    41,    -1,    43,    44,    45,    46,    47,    48,    49,
      50,    -1,    52,    53,    54,    55,    -1,    57,    58,    59,
      60,    61,    62,    63,    -1,    -1,    66,    67,    68,    69,
      70,    -1,    72,    73,    74,    75,    -1,    -1,    78,    -1,
      80,    81,    82,    83,    84,    85,    86,    87,    88,    89,
      -1,    91,    92,    93,    94,    95,    96,    -1,    98,    99,
     100,   101,    -1,    -1,    -1,   105,    -1,    -1,    -1,   109,
     110,   111,   112,   113,   114,   115,   116,   117,    -1,   119,
      -1,   121,   122,   123,   124,   125,   126,   127,    -1,   129,
     130,   131,   132,    -1,    -1,   135,   136,   137,   138,   139,
      -1,   141,   142,   143,    -1,   145,   146,   147,    -1,   149,
     150,   151,   152,    -1,   154,   155,   156,   157,    -1,    -1,
     160,    -1,   162,   163,   164,   165,   166,    -1,   168,    -1,
     170,   171,    -1,   173,   174,   175,   176,   177,    -1,   179,
      -1,    -1,    -1,   183,   184,    -1,   186,   187,   188,   189,
     190,   191,   192,   193,   194,   195,    -1,   197,   198,   199,
     200,   201,   202,   203,    -1,   205,   206,    -1,   208,   209,
     210,   211,   212,   213,    -1,   215,    -1,   217,   218,   219,
     220,   221,   222,   223,   224,   225,   226,    -1,    -1,   229,
      -1,   231,   232,   233,    -1,   235,   236,   237,    -1,    -1,
     240,   241,   242,   243,   244,   245,   246,   247,   248,   249,
     250,   251,   252,   253,   254,   255,   256,   257,   258,   259,
     260,   261,   262,   263,   264,   265,   266,   267,    -1,    -1,
     270,    -1,   272,   273,   274,   275,    -1,    -1,   278,   279,
     280,   281,   282,    -1,   284,   285,    -1,    -1,   288,   289,
     290,    -1,    -1,   293,   294,    -1,   296,   297,   298,    -1,
     300,   301,   302,   303,   304,   305,   306,   307,   308,   309,
      -1,    -1,   312,   313,    -1,   315,    -1,   317,   318,   319,
      -1,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,    -1,   337,   338,   339,
     340,   341,   342,   343,   344,   345,   346,   347,   348,   349,
      -1,   351,   352,   353,   354,   355,   356,   357,   358,    -1,
     360,   361,   362,   363,   364,   365,   366,   367,   368,    -1,
     370,   371,   372,   373,   374,    -1,   376,   377,   378,   379,
     380,   381,   382,   383,   384,   385,    -1,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,   399,
      -1,   401,    -1,   403,   404,    -1,   406,   407,   408,   409,
     410,   411,   412,    -1,   414,   415,   416,    -1,    -1,   419,
     420,    -1,   422,    -1,    -1,   425,   426,   427,   428,   429,
     430,   431,   432,    -1,    -1,   435,   436,   437,   438,   439,
      -1,    -1,   442,   443,   444,   445,   446,    -1,   448,    -1,
     450,   451,   452,   453,   454,   455,    -1,    -1,   458,    -1,
      -1,   461,   462,   463,   464,   465,   466,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   478,   479,
     480,    -1,    -1,    -1,    20,    21,    22,    23,    24,    25,
      26,    27,    -1,    29,    30,    31,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    39,    40,    41,    -1,    43,    44,    45,
      46,    47,    48,    49,    50,    -1,    52,    53,    54,    55,
      -1,    57,    58,    59,    60,    61,    62,    63,    -1,    -1,
      66,    67,    68,    69,    70,    -1,    72,    73,    74,    75,
      -1,    -1,    78,    -1,    80,    81,    82,    83,    84,    85,
      86,    87,    88,    89,    -1,    91,    92,    93,    94,    95,
      96,    -1,    98,    99,   100,   101,    -1,    -1,    -1,   105,
      -1,    -1,    -1,   109,   110,   111,   112,   113,   114,   115,
     116,   117,    -1,   119,    -1,   121,   122,   123,   124,   125,
     126,   127,    -1,   129,   130,   131,   132,    -1,    -1,   135,
     136,   137,   138,   139,    -1,   141,   142,   143,    -1,   145,
     146,   147,    -1,   149,   150,   151,   152,    -1,   154,   155,
     156,   157,    -1,    -1,   160,    -1,   162,   163,   164,   165,
     166,    -1,   168,    -1,   170,   171,    -1,   173,   174,   175,
     176,   177,    -1,   179,    -1,    -1,    -1,   183,   184,    -1,
     186,   187,   188,   189,   190,   191,   192,   193,   194,   195,
      -1,   197,   198,   199,   200,   201,   202,   203,    -1,   205,
     206,    -1,   208,   209,   210,   211,   212,   213,    -1,   215,
      -1,   217,   218,   219,   220,   221,   222,   223,   224,   225,
     226,    -1,    -1,   229,    -1,   231,   232,   233,    -1,   235,
     236,   237,    -1,    -1,   240,   241,   242,   243,   244,   245,
     246,   247,   248,   249,   250,   251,   252,   253,   254,   255,
     256,   257,   258,   259,   260,   261,   262,   263,   264,   265,
     266,   267,    -1,    -1,   270,    -1,   272,   273,   274,   275,
      -1,    -1,   278,   279,   280,   281,   282,    -1,   284,   285,
      -1,    -1,   288,   289,   290,    -1,    -1,   293,   294,    -1,
     296,   297,   298,    -1,   300,   301,   302,   303,   304,   305,
     306,   307,   308,   309,    -1,    -1,   312,   313,    -1,   315,
      -1,   317,   318,   319,    -1,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
      -1,   337,   338,   339,   340,   341,   342,   343,   344,   345,
     346,   347,   348,   349,    -1,   351,   352,   353,   354,   355,
     356,   357,   358,    -1,   360,   361,   362,   363,   364,   365,
     366,   367,   368,    -1,   370,   371,   372,   373,   374,    -1,
     376,   377,    -1,   379,   380,   381,   382,   383,   384,   385,
      -1,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,   399,    -1,   401,    -1,   403,   404,    -1,
     406,   407,   408,   409,   410,   411,   412,    -1,   414,   415,
     416,    -1,    -1,   419,   420,    -1,   422,    -1,    -1,   425,
     426,   427,   428,   429,   430,   431,   432,    -1,    -1,   435,
     436,   437,   438,   439,    -1,    -1,   442,   443,   444,   445,
     446,    -1,   448,    -1,   450,   451,   452,   453,   454,   455,
      -1,    -1,   458,    -1,    -1,   461,   462,   463,   464,   465,
     466,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   478,   479,   480,    -1,    -1,    -1,    20,    21,
      22,    23,    24,    25,    26,    27,    -1,    29,    30,    31,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    39,    40,    41,
      -1,    43,    44,    45,    46,    47,    48,    49,    50,    -1,
      -1,    53,    -1,    -1,    -1,    57,    58,    59,    60,    61,
      62,    63,    -1,    -1,    66,    67,    -1,    -1,    70,    -1,
      72,    73,    74,    75,    -1,    -1,    78,    -1,    80,    81,
      82,    83,    84,    85,    86,    87,    88,    89,    -1,    91,
      92,    93,    94,    95,    96,    -1,    98,    99,   100,   101,
      -1,    -1,    -1,   105,    -1,    -1,    -1,   109,   110,   111,
     112,   113,   114,    -1,    -1,   117,    -1,   119,    -1,   121,
     122,   123,   124,   125,   126,   127,    -1,   129,   130,   131,
     132,    -1,    -1,   135,   136,   137,   138,   139,    -1,   141,
     142,   143,    -1,   145,   146,   147,    -1,   149,   150,   151,
     152,    -1,   154,   155,   156,   157,    -1,    -1,   160,    -1,
     162,   163,   164,    -1,   166,    -1,   168,    -1,   170,   171,
      -1,   173,   174,   175,   176,   177,    -1,   179,    -1,    -1,
      -1,   183,   184,    -1,   186,   187,   188,   189,   190,   191,
     192,   193,   194,   195,    -1,   197,   198,   199,   200,   201,
     202,   203,    -1,   205,   206,    -1,   208,   209,   210,   211,
      -1,    -1,    -1,    -1,    -1,   217,   218,   219,   220,   221,
     222,   223,   224,   225,   226,    -1,    -1,   229,    -1,   231,
     232,   233,    -1,   235,   236,   237,    -1,    -1,   240,   241,
     242,   243,   244,   245,   246,   247,   248,   249,   250,   251,
     252,   253,   254,   255,   256,   257,    -1,   259,    -1,   261,
     262,   263,   264,   265,   266,   267,    -1,    -1,   270,    -1,
     272,   273,   274,   275,    -1,    -1,   278,    -1,   280,   281,
     282,    -1,   284,   285,    -1,    -1,   288,   289,   290,    -1,
      -1,   293,   294,    -1,   296,   297,   298,    -1,   300,   301,
     302,   303,   304,   305,   306,   307,   308,   309,    -1,    -1,
     312,   313,    -1,   315,    -1,   317,   318,   319,    -1,   321,
     322,   323,   324,   325,   326,   327,   328,   329,   330,    -1,
     332,   333,   334,   335,    -1,   337,   338,   339,   340,   341,
     342,   343,   344,   345,   346,   347,   348,   349,    -1,   351,
     352,   353,   354,   355,   356,   357,   358,    -1,   360,   361,
     362,   363,   364,   365,   366,   367,   368,    -1,   370,   371,
     372,   373,   374,    -1,   376,   377,    -1,   379,   380,   381,
     382,   383,    -1,   385,    -1,   387,   388,   389,   390,   391,
     392,   393,   394,   395,   396,   397,   398,   399,    -1,   401,
      -1,   403,   404,    -1,   406,   407,   408,   409,   410,   411,
     412,    -1,   414,    -1,    -1,    -1,    -1,   419,   420,    -1,
     422,    -1,    -1,   425,   426,   427,   428,   429,   430,   431,
     432,    -1,    -1,   435,   436,   437,   438,   439,    -1,    -1,
     442,   443,   444,   445,   446,    -1,    -1,    -1,   450,   451,
     452,   453,   454,   455,    -1,    -1,   458,    -1,    -1,   461,
     462,   463,   464,   465,   466,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   478,   479,   480
};

  /* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
     symbol of state STATE-NUM.  */
static const yytype_uint16 yystos[] =
{
       0,    20,    30,    32,    33,    50,    60,    72,    74,    75,
      81,    83,    95,    97,   114,   117,   132,   134,   138,   144,
     152,   154,   161,   178,   195,   235,   236,   241,   255,   273,
     310,   318,   332,   338,   339,   341,   346,   352,   355,   362,
     368,   369,   376,   380,   390,   405,   425,   436,   442,   447,
     460,   483,   484,   485,   486,   487,   488,   501,   508,   509,
     510,   511,   512,   513,   519,   520,   522,   523,   524,   525,
     527,   531,   543,   548,   549,   552,   553,   554,   573,   576,
     577,   592,   639,   642,   643,   646,   649,   650,   651,   659,
     666,   668,   669,   672,   675,   676,   680,   689,   693,   694,
     695,   698,   700,   701,   702,   703,   711,   713,   733,   737,
     739,   740,   750,   752,   759,   760,   763,   764,   765,   766,
     767,   776,   778,   780,   783,   787,   788,   798,   799,   802,
     807,   821,   853,   856,   857,   858,   863,   866,   868,   870,
     872,   873,   876,   877,   880,   882,   883,   887,   888,   889,
     892,   893,   894,   895,   896,   903,   905,   906,   907,   908,
     914,   916,   917,   923,   924,   925,   928,   929,   930,   931,
     933,   934,   936,   937,   939,   940,   942,   954,   956,   959,
     961,   962,   971,   973,   978,   983,   991,   995,   996,   997,
     998,   999,  1000,  1006,  1042,   419,   463,   909,    27,    78,
      94,   112,   118,   136,   147,   156,   169,   174,   181,   200,
     225,   247,   288,   313,   323,   324,   327,   354,   357,   361,
     363,   370,   373,   392,   399,   404,   405,   408,   412,   422,
     427,   440,   453,   665,   909,     3,    20,    21,    22,    23,
      24,    25,    26,    27,    29,    30,    31,    39,    40,    41,
      43,    44,    45,    46,    47,    48,    49,    50,    51,    52,
      53,    54,    55,    57,    58,    59,    60,    61,    62,    63,
      66,    67,    68,    69,    70,    72,    73,    74,    75,    76,
      78,    80,    81,    82,    83,    84,    85,    86,    87,    88,
      89,    91,    92,    93,    94,    95,    96,    98,    99,   100,
     101,   105,   109,   110,   111,   112,   113,   114,   115,   116,
     117,   119,   121,   122,   123,   124,   125,   126,   127,   129,
     130,   131,   132,   135,   136,   137,   138,   139,   141,   142,
     143,   145,   146,   147,   149,   150,   151,   152,   153,   154,
     155,   156,   157,   158,   160,   162,   163,   164,   165,   166,
     168,   170,   171,   173,   174,   175,   176,   177,   179,   180,
     182,   183,   184,   186,   187,   188,   189,   190,   191,   192,
     193,   194,   195,   197,   198,   199,   200,   201,   202,   203,
     205,   206,   207,   208,   209,   210,   211,   212,   213,   215,
     217,   218,   219,   220,   221,   222,   223,   224,   225,   226,
     229,   230,   231,   232,   233,   235,   236,   237,   240,   241,
     242,   243,   244,   245,   246,   247,   248,   249,   250,   251,
     252,   253,   254,   255,   256,   257,   258,   259,   260,   261,
     262,   263,   264,   265,   266,   267,   268,   269,   270,   272,
     273,   274,   275,   277,   278,   279,   280,   281,   282,   284,
     285,   288,   289,   290,   293,   294,   295,   296,   297,   298,
     299,   300,   301,   302,   303,   304,   305,   306,   307,   308,
     309,   312,   313,   314,   315,   316,   317,   318,   319,   321,
     322,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,   333,   334,   335,   337,   338,   339,   340,   341,   342,
     343,   344,   345,   346,   347,   348,   349,   351,   352,   353,
     354,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,   365,   366,   367,   368,   370,   371,   372,   373,   374,
     376,   377,   378,   379,   380,   381,   382,   383,   384,   385,
     387,   388,   389,   390,   391,   392,   393,   394,   395,   396,
     397,   398,   399,   400,   401,   403,   404,   406,   407,   408,
     409,   410,   411,   412,   414,   415,   416,   419,   420,   421,
     422,   423,   425,   426,   427,   428,   429,   430,   431,   432,
     435,   436,   437,   438,   439,   442,   443,   444,   445,   446,
     447,   448,   450,   451,   452,   453,   454,   455,   458,   461,
     462,   463,   464,   465,   466,   467,   468,   469,   470,   471,
     472,   473,   474,   475,   476,   477,   478,   479,   480,  1103,
    1173,  1185,  1186,  1190,  1191,  1192,     3,    28,   992,  1170,
    1185,  1190,   451,   501,   947,   286,   319,   909,    53,   501,
     584,    22,    40,    65,    78,   112,   118,   136,   147,   156,
     169,   177,   181,   237,   288,   291,   313,   327,   354,   363,
     373,   392,   399,   408,   409,   411,   412,   427,   434,   437,
     440,   593,   648,   755,   808,   822,    28,   318,  1170,   992,
      28,   312,   371,   409,   411,     6,   224,   864,   865,  1176,
      22,    27,    65,    78,    94,   112,   136,   147,   156,   169,
     174,   181,   200,   247,   288,   301,   313,   324,   327,   354,
     357,   361,   363,   370,   373,   392,   399,   405,   408,   412,
     420,   422,   427,   440,   453,   665,   768,   770,   771,   909,
    1170,    97,   451,   501,   643,   646,   649,   942,   955,   959,
     962,   971,   978,   983,   991,   995,    11,    21,    28,    48,
     164,   170,   172,   196,   226,   262,   321,   340,   492,   493,
     784,   785,   992,  1175,  1177,    28,    30,    97,   336,   369,
     789,   790,   791,  1185,   169,  1185,  1172,  1176,   405,  1009,
     784,  1185,   346,   376,   380,   419,  1170,   301,   247,   112,
     200,   363,   404,   405,   501,   874,   875,   362,  1185,    28,
     374,   415,   419,   535,   544,   545,  1185,    25,   178,   789,
     790,   319,   909,  1185,   223,    28,   133,  1011,  1012,    66,
      91,   237,   257,   354,   363,   374,   415,   419,   466,   532,
     533,   534,   535,    28,   374,   415,   419,   535,   419,   287,
    1054,  1055,  1168,  1185,  1009,   494,  1185,   173,   501,   948,
     501,   334,  1001,  1002,  1170,  1001,     3,    52,    54,    55,
      68,    69,   115,   116,   137,   165,   212,   213,   215,   258,
     260,   279,   331,   378,   384,   415,   416,   448,  1077,  1079,
    1081,  1083,  1085,  1087,  1088,  1089,  1091,  1092,  1093,  1095,
    1096,  1186,  1190,  1011,  1012,  1013,  1181,    12,  1182,  1183,
    1185,  1182,  1182,   996,   997,  1000,     0,   504,   501,   947,
     148,   214,   292,   433,  1014,  1015,   996,   998,   999,   123,
     210,   249,   439,   505,    34,   913,   838,  1173,   773,  1185,
     773,  1170,   322,   773,   422,  1170,   111,   405,   826,  1173,
    1185,  1192,     3,   104,   108,   375,  1178,  1179,  1187,  1190,
    1191,  1192,    28,   190,  1168,   280,   453,    10,    17,    18,
      19,    73,   160,   489,   490,   491,   492,   493,   494,   495,
     496,   497,   860,   862,  1133,  1134,  1185,   190,  1170,   826,
    1170,    28,  1178,  1179,   826,  1170,  1170,   190,  1168,  1170,
     190,   773,  1170,   346,   376,    28,   190,  1054,  1170,   366,
    1170,   773,    28,   244,  1178,  1179,   190,  1168,   224,   120,
     220,   271,   330,   910,   911,   912,   501,   499,   503,  1159,
    1161,   941,   942,   943,   944,  1187,  1168,  1170,  1185,    27,
      65,    79,    90,   112,   136,   174,   200,   225,   288,   324,
     354,   357,   399,   408,   420,   427,   768,   769,   770,   771,
    1176,   913,   958,   962,   971,   978,   983,   995,  1168,   250,
     773,   501,   190,   773,  1170,   773,   422,   190,  1170,   111,
     405,   409,   411,  1178,  1179,   409,   411,    73,   160,   860,
     344,  1170,  1170,  1178,   190,   528,  1185,   190,  1170,   190,
     773,  1170,  1170,   366,   773,   244,  1178,   334,   370,   405,
     453,   247,    94,   200,    27,    90,   174,   324,   361,   420,
     422,   426,   660,    28,  1170,   993,   542,  1176,  1187,   865,
     250,   190,   838,   839,   190,   869,   190,  1170,   190,   775,
    1077,   422,   111,   405,   190,   825,   826,   190,  1179,  1180,
      86,   453,    73,   160,   190,   861,   862,    58,   190,   825,
     190,  1180,   190,   825,   190,  1170,   190,  1170,   366,   869,
     190,   775,   190,   244,  1180,   224,   190,   772,   773,   190,
    1169,  1170,   190,  1170,   913,   501,   960,   593,   955,   447,
     941,   947,  1177,   785,   786,    28,   786,  1177,   786,    28,
     786,  1177,   786,   786,   786,  1177,  1175,  1175,   992,   786,
     322,   501,   404,   501,   616,   616,   616,   286,   417,   505,
     616,   363,  1054,  1056,   505,   904,   545,   533,   535,    28,
     535,  1176,   501,   957,    58,   453,   941,    86,   809,   809,
    1185,    47,   480,   220,   503,   289,   289,   286,   172,  1176,
     417,   913,   167,   781,   286,     5,     8,     9,    10,    12,
      36,    52,    54,    55,    64,    65,    68,    69,    76,    78,
     102,   103,   104,   105,   106,   107,   108,   115,   116,   118,
     153,   158,   159,   165,   180,   182,   212,   213,   215,   230,
     238,   239,   258,   260,   269,   271,   276,   277,   279,   288,
     299,   314,   331,   359,   375,   384,   400,   415,   416,   421,
     423,   424,   434,   440,   448,   468,   469,   470,   471,   473,
     474,   475,   476,   481,   492,   493,   494,   501,   996,  1080,
    1083,  1086,  1087,  1088,  1090,  1091,  1092,  1095,  1096,  1100,
    1102,  1103,  1104,  1106,  1129,  1130,  1131,  1135,  1153,  1158,
    1165,  1166,  1173,  1174,  1175,  1176,  1185,  1164,  1165,  1176,
      28,   550,  1167,  1168,   374,   532,   118,   541,  1176,   542,
    1176,    47,    70,   532,   480,   385,   911,   289,   172,   417,
     491,    47,   480,   220,   912,   501,  1168,   494,  1161,  1056,
     941,   171,   949,  1100,  1138,  1001,   505,   501,   950,   450,
    1094,  1094,  1094,   501,  1082,  1082,   316,   501,  1084,    68,
      69,  1094,  1082,  1079,   462,   483,   501,  1097,   501,  1097,
      36,  1078,   501,   113,   188,   251,   254,   367,   478,   501,
    1098,  1099,   503,   774,  1082,  1164,  1162,   502,   502,   510,
     941,   951,   952,   953,  1168,    28,   133,  1010,  1010,    58,
    1010,   161,   167,   234,   283,  1018,  1020,  1021,  1036,  1038,
    1039,  1040,  1014,  1015,   172,   216,   216,  1054,  1057,   501,
      67,   267,   302,   342,   376,   501,   836,   302,   338,   342,
     376,   774,   302,   342,   376,     3,    89,   142,   240,   302,
     310,   338,   342,   376,   408,   410,   460,   543,   546,   918,
     919,   920,   921,   803,    24,   138,   302,   342,   376,   444,
     559,  1170,    24,   138,   376,   439,   526,   464,   190,  1054,
      61,    96,   157,   193,   229,   267,   271,   302,   303,   342,
     351,   360,   368,   376,   388,   397,   401,   455,   543,   547,
     842,   854,   881,   501,   823,  1161,   342,   526,   196,   153,
      24,    30,    45,    75,   131,   138,   141,   168,   202,   267,
     271,   281,   290,   302,   342,   345,   346,   376,   444,   555,
     557,   558,   683,   881,     5,   492,   493,   657,  1177,    28,
     190,  1168,   773,   773,   501,   859,   302,   376,   503,   153,
     286,   302,   342,   376,   854,   881,    24,   138,   302,   342,
     376,   196,   521,   342,   460,   483,   514,   521,   302,   342,
     376,   854,   881,   286,   302,   342,   153,    37,    59,   110,
     199,   248,   252,   267,   301,   342,   347,   370,   376,   390,
     555,   654,   655,   302,   342,   452,   683,   691,   153,   302,
     342,   376,    24,    89,   131,   138,   141,   302,   338,   342,
     376,   383,   545,   533,   196,   153,    45,   129,   267,   342,
     376,   555,   556,   302,   342,   346,   376,    87,   130,   305,
     410,   286,    24,    30,   138,   302,   342,   376,   574,   575,
     521,   167,   342,   514,   521,   153,   342,   376,   555,  1170,
     232,   120,   287,   465,   505,   910,    28,   133,   449,   494,
     502,   831,  1100,  1139,  1140,  1186,  1100,  1160,     3,    28,
      32,    33,    34,    35,    36,    37,    38,    42,    56,    64,
      65,    71,    77,    79,    90,    97,   102,   103,   104,   106,
     107,   108,   118,   120,   128,   133,   134,   140,   144,   148,
     159,   161,   167,   169,   172,   178,   181,   185,   196,   204,
     214,   216,   227,   228,   234,   238,   239,   271,   276,   283,
     286,   287,   291,   292,   311,   320,   336,   350,   369,   375,
     386,   402,   405,   413,   417,   418,   424,   433,   434,   440,
     441,   449,   456,   457,   459,   460,   494,  1171,  1188,  1190,
    1191,  1192,  1193,  1159,   502,   505,   159,   286,   424,   539,
     542,   657,   945,   441,   938,   286,   838,   501,   773,  1170,
    1077,   826,   280,    73,   160,   862,   826,   826,   167,  1077,
     773,  1170,  1170,   502,   616,  1170,    71,  1077,   271,   172,
     501,   741,   514,    37,   932,  1170,   271,   514,   464,   190,
    1168,   514,   773,   773,   741,   437,   593,   286,   167,   460,
     850,   514,   271,    47,   529,   271,   427,   690,   271,   950,
      89,   302,   667,    87,   130,   305,   410,    37,   741,   167,
     190,   514,   453,   190,  1168,   190,   644,  1168,  1168,   453,
     773,   809,  1173,   422,  1173,  1173,  1170,   167,  1170,   665,
      39,    53,   109,   209,   267,   365,   153,    62,   348,   505,
     560,   153,   501,   153,   514,   153,   505,   560,   464,   153,
     505,   560,   153,   505,   190,   772,   190,   773,   190,   773,
     153,   505,   560,  1180,   153,   560,   153,   153,   560,   153,
     560,   153,    87,   130,   305,   410,   167,   153,   560,   153,
     167,   190,   153,   505,   560,   153,   505,   560,   153,   286,
    1138,   405,   502,   955,   786,   992,   786,   992,   786,   992,
     786,   992,   786,   992,   992,   992,   786,   992,   501,   617,
     618,  1185,   617,    28,   112,   136,   169,   174,   224,   225,
     304,   324,   357,   363,   370,   405,   408,   427,   794,  1167,
    1180,   791,  1170,   196,   505,   974,  1176,  1077,  1142,    37,
    1180,   809,   502,  1168,  1170,   232,  1185,   167,   167,   794,
    1180,   362,  1185,   542,   286,   501,  1162,   499,   996,  1143,
    1100,  1157,   501,   501,   167,   501,   501,   996,   501,   501,
     501,   501,   501,   501,   501,  1100,   501,   501,   501,   501,
     501,   501,   501,   501,   278,   607,   501,   501,   501,   501,
     501,   501,   501,   501,  1100,  1100,  1100,   996,  1100,  1138,
    1161,  1176,   501,  1176,     3,    10,    13,    17,    18,    19,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    29,
      30,    31,    32,    33,    34,    35,    37,    38,    39,    40,
      41,    42,    43,    44,    45,    46,    47,    48,    49,    50,
      51,    52,    53,    54,    55,    56,    57,    58,    59,    60,
      61,    62,    63,    64,    65,    66,    67,    70,    71,    72,
      73,    74,    75,    76,    77,    78,    79,    80,    81,    82,
      83,    84,    85,    86,    87,    88,    89,    90,    91,    92,
      93,    94,    95,    96,    98,    99,   100,   101,   102,   103,
     104,   105,   106,   107,   108,   109,   110,   111,   112,   114,
     115,   116,   117,   118,   119,   120,   121,   122,   123,   124,
     125,   126,   127,   128,   129,   130,   131,   132,   133,   134,
     135,   136,   137,   138,   139,   140,   141,   142,   143,   144,
     145,   146,   147,   149,   150,   151,   152,   153,   154,   155,
     156,   157,   158,   159,   160,   163,   164,   165,   166,   168,
     169,   170,   171,   173,   174,   175,   176,   177,   179,   180,
     182,   183,   184,   186,   187,   189,   190,   191,   192,   193,
     194,   195,   196,   197,   198,   199,   200,   201,   202,   203,
     204,   205,   206,   207,   208,   209,   210,   211,   212,   213,
     215,   217,   218,   219,   220,   221,   222,   223,   224,   225,
     226,   227,   228,   229,   230,   231,   232,   233,   235,   236,
     237,   238,   239,   240,   241,   242,   243,   244,   245,   246,
     247,   248,   249,   250,   252,   253,   255,   256,   257,   258,
     259,   260,   261,   262,   263,   264,   265,   266,   267,   268,
     269,   270,   271,   272,   273,   274,   275,   276,   277,   278,
     279,   280,   281,   282,   284,   285,   287,   288,   289,   290,
     291,   293,   294,   295,   296,   299,   300,   301,   302,   303,
     304,   305,   306,   307,   308,   309,   311,   312,   313,   314,
     315,   317,   318,   319,   320,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   344,   345,
     346,   347,   348,   349,   351,   352,   353,   354,   355,   356,
     357,   358,   359,   360,   361,   362,   363,   364,   365,   366,
     368,   369,   370,   371,   372,   373,   374,   375,   376,   377,
     378,   379,   380,   381,   382,   383,   384,   385,   386,   387,
     388,   389,   390,   391,   392,   393,   394,   395,   396,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   418,
     419,   420,   421,   422,   423,   424,   425,   426,   427,   428,
     429,   430,   431,   432,   434,   435,   436,   437,   438,   439,
     440,   441,   442,   443,   444,   445,   446,   447,   448,   449,
     451,   452,   453,   454,   455,   456,   458,   463,   464,   465,
     466,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,   479,   480,   481,   489,   490,   491,   492,   493,
     494,   495,   496,   497,  1133,  1135,  1137,  1189,  1194,   461,
    1116,   298,  1100,   216,   505,  1007,   501,  1176,  1161,  1007,
     121,   192,   551,   505,    70,   118,   542,    37,     3,   118,
     237,   540,   657,  1096,  1176,  1176,    92,   135,  1112,   101,
     118,   536,   537,   539,   657,   118,   536,   232,  1168,    93,
     347,   777,   502,   947,    34,    44,    51,    77,   191,   196,
     218,   233,   288,   291,   381,   502,   505,  1002,  1169,    37,
     501,  1138,  1175,  1094,  1094,    36,  1078,   415,   415,  1175,
    1175,   499,   499,  1175,   417,   417,   417,   501,   417,  1175,
    1171,   503,  1082,   172,  1043,    15,   491,  1159,  1184,   502,
     505,   950,   998,   998,  1016,  1017,  1100,   998,   164,   262,
    1027,   222,   267,   330,   379,   439,    28,  1022,  1100,   492,
     493,  1023,  1024,  1100,  1102,  1036,  1037,  1021,  1020,  1018,
    1019,   167,  1039,   281,  1041,  1018,  1036,  1057,   963,  1168,
    1057,    37,  1185,   376,  1138,    67,   417,   417,   363,   196,
     207,   292,   295,   378,   449,   494,   829,   830,   831,   833,
     835,   837,  1077,  1186,   417,   452,   417,   363,   417,   417,
     363,   234,   417,    78,   417,   408,   532,   302,   918,   920,
     491,   922,   167,   178,   196,   352,   804,   805,    71,    90,
     149,   169,   320,   434,   613,   614,    90,   118,   271,   417,
      90,   417,   118,   271,   363,    90,   131,   141,   302,   342,
     738,   363,   673,    27,    65,   136,   174,   288,   324,   357,
     420,   427,   768,   769,  1170,   153,   342,   376,   555,   286,
     657,   368,   229,   417,  1185,   417,   276,   657,   122,   217,
     363,   374,   419,   534,   773,   348,   376,   842,   855,   126,
     502,   824,   829,   417,   440,   408,  1168,    79,   149,   190,
     600,   613,  1185,    79,    90,   878,   307,   286,   359,   361,
     422,    90,   878,    31,   345,   359,   361,   422,   359,  1168,
     168,   202,   281,   773,   501,   417,   417,   189,   501,   564,
      22,   243,   408,   437,   462,   564,    90,   505,   126,     5,
       5,   302,   196,   153,   342,   376,   555,   881,   441,   441,
     268,  1077,   417,   363,   501,   860,  1170,  1168,   417,   417,
     363,   855,   126,    28,   105,   405,   890,   891,  1055,  1168,
    1185,   891,   417,   417,   741,   891,   112,   376,   546,   417,
     516,   546,   417,   417,   363,   855,   126,  1168,   417,   417,
    1168,  1079,   657,    58,   656,   657,   657,   110,   248,   252,
      58,   417,   514,   256,   363,   514,   267,   655,   417,   417,
     276,  1176,   683,   773,   417,   417,   363,   392,   327,  1176,
     327,   417,   327,   417,   327,   741,   741,   408,  1054,   307,
     307,    90,   417,   878,   363,   417,   417,   564,   564,   773,
     773,   773,   773,  1168,    46,   446,    46,    46,   417,    46,
     417,   446,   363,   501,   505,   546,   440,   699,  1179,   417,
     516,   546,  1168,   417,   878,   363,   302,   342,   330,   343,
     372,   538,   910,  1139,  1139,  1140,   502,    15,    16,   505,
    1014,  1015,   500,   506,  1168,   943,  1170,  1168,   218,  1077,
     218,   286,   218,   218,   657,   773,   773,   218,   218,   218,
    1077,   218,   218,   218,   286,   417,   172,   417,   578,   427,
     501,    37,   153,   773,   742,   743,  1188,   918,  1077,   286,
     153,   670,  1170,   271,   307,   501,   515,   755,   441,   334,
     453,  1168,    28,   891,   741,   515,   153,  1179,    97,   178,
     530,   592,   650,   713,   787,   807,   914,   153,  1176,   691,
     692,   153,   286,  1176,  1179,   240,   773,   773,   773,   773,
     145,   329,   501,   699,   271,   515,  1168,   271,   652,   654,
     271,    37,   281,   307,   501,   616,   616,   190,   647,  1168,
     167,   190,   810,  1170,   501,   745,   836,  1170,   501,   827,
     827,    37,  1077,    26,    49,   211,   714,   224,   460,   462,
     994,   365,   839,   838,  1077,  1170,   501,   775,  1077,   825,
     826,  1180,  1179,   153,   560,   153,   441,   153,   441,   861,
     862,   560,   825,  1180,   825,  1170,  1170,  1077,   775,  1180,
     699,   153,   772,   773,  1169,  1170,  1170,   773,   502,   190,
    1168,   955,   992,   992,   992,   992,   992,   992,   617,   502,
     505,   502,   175,   325,   358,   371,   406,  1169,   772,   111,
     373,   825,  1169,   280,   792,   793,  1185,   825,   825,  1169,
    1167,  1167,  1169,   772,   417,   460,   800,   148,   234,   696,
     697,    22,   151,   359,   379,   975,  1054,   275,   976,   502,
     505,   958,   417,  1168,   874,   875,   790,   789,   790,   172,
     179,   801,  1185,    27,    79,   136,   174,   225,   324,   357,
     427,   768,   769,  1138,   500,  1138,  1143,  1144,   456,  1154,
    1155,  1100,  1138,   501,  1175,  1175,     3,   113,   188,   251,
     254,   367,   478,  1145,  1146,  1176,  1138,  1138,  1138,  1175,
    1175,  1100,  1100,   860,  1100,  1139,  1141,  1148,   359,   492,
     493,   501,  1101,  1102,  1135,  1149,   502,  1138,  1100,  1141,
    1150,  1100,    56,   172,   228,   418,  1100,  1138,  1151,   133,
     271,   996,  1138,   256,  1102,  1100,  1110,  1111,  1112,   256,
    1100,  1112,   502,   505,  1175,  1098,  1077,  1100,  1100,  1100,
    1100,  1188,   415,    42,   402,  1163,   773,  1100,   501,   996,
    1152,   133,   135,   159,   263,   264,   265,   266,   270,   271,
     276,   424,   435,  1147,  1100,   501,  1100,   417,    51,   191,
     196,   233,   381,  1100,  1100,  1100,  1100,  1100,  1100,  1100,
    1100,  1100,  1100,    28,    35,   386,  1132,   181,   162,  1117,
     359,   501,  1129,   177,   237,   405,   409,   411,   437,  1008,
    1168,  1166,  1043,  1139,  1043,  1168,   419,   501,  1176,   505,
     502,   189,   189,   560,   953,   942,   946,  1100,   502,   247,
     271,  1003,  1138,   502,   502,   499,   480,   480,   502,   502,
    1175,   500,  1175,   502,   188,   251,  1099,   251,  1099,  1099,
    1175,   254,   502,  1171,   227,   360,   477,   501,   996,  1044,
    1045,  1046,  1054,  1060,  1070,  1103,  1105,  1106,  1185,   457,
    1065,  1181,   953,   951,   505,    38,   128,   441,   819,   359,
     360,   492,   493,  1024,  1026,  1102,   379,   222,   287,   505,
       5,  1025,  1175,  1025,   359,   360,  1026,  1167,   275,   383,
     977,  1037,  1019,   441,   972,   118,   300,   501,   964,   995,
      37,   441,  1185,   501,   979,   980,   981,  1185,   502,  1179,
    1170,  1170,   295,    58,  1186,   502,   831,   833,   830,   833,
    1186,   292,   502,   505,   774,  1179,  1170,  1170,  1179,  1170,
    1170,  1179,   452,  1170,  1170,   118,   539,  1177,   354,   440,
     789,   363,   178,   789,   501,  1170,   441,   811,   222,   222,
     441,   607,   638,   190,  1170,   276,  1179,  1170,  1170,  1100,
     276,  1170,  1170,    31,   345,   417,   417,  1170,   417,   674,
     838,   501,  1077,   826,    73,   160,   862,   826,   826,   167,
    1077,   773,  1170,   184,   267,   302,   342,   445,   677,   678,
     679,  1054,   417,   878,   363,   276,   122,   217,  1179,  1170,
     286,  1170,   286,   502,   505,  1178,  1180,  1170,   342,   555,
     190,   600,   271,  1077,  1170,  1175,  1185,  1168,  1170,   232,
    1170,    28,   440,  1170,   190,  1170,   190,  1185,   361,   422,
     361,   422,   232,  1170,    28,   440,  1170,   232,   359,  1168,
      24,   138,   376,   684,   685,   686,   687,  1188,  1179,  1170,
     118,   173,   272,   441,   563,   566,   567,  1188,   250,  1170,
      75,   284,  1170,   558,   286,   417,   408,  1168,   417,   878,
     363,   126,  1170,  1170,   505,   502,   505,  1179,  1170,   884,
     885,  1188,   286,   342,   417,   707,  1179,  1170,  1170,   286,
     406,  1054,   505,   616,   616,  1161,  1179,  1170,  1170,  1178,
       3,    89,   143,   202,   309,   432,   440,   443,   517,  1179,
    1170,  1170,   286,   342,  1179,  1170,   342,   376,   555,   654,
     657,   773,  1170,   657,   773,  1170,   657,  1179,  1170,   376,
    1179,  1170,  1170,  1177,  1169,  1169,  1179,   850,  1170,  1169,
    1170,   342,   376,   555,   556,  1168,  1168,  1170,  1170,  1170,
    1170,  1179,  1170,    24,    30,   138,   302,   342,   376,   302,
     342,   376,   741,   342,   376,   342,   376,   342,   881,  1069,
    1185,   190,   751,  1185,   190,  1185,  1179,  1170,  1170,  1176,
    1170,   884,    24,   575,   373,  1178,   342,   376,   555,  1170,
    1170,  1170,   417,   417,    84,   431,   330,   505,  1014,  1014,
    1014,  1100,  1100,   449,  1140,   502,  1100,  1160,   938,   276,
     779,  1176,    37,   779,   136,   773,   779,   779,   218,   441,
     441,   779,   779,   779,   224,   779,   779,   779,   773,   326,
     579,   579,   200,   405,   712,  1100,  1077,   773,   502,   505,
     491,   604,  1188,  1170,    62,   172,   363,   452,   671,   678,
     679,   153,   281,   233,   594,   596,   598,   600,   610,   613,
      25,   196,   354,   403,   517,   518,   167,  1170,   453,  1168,
      37,   708,   406,   850,   528,  1185,   529,   593,   822,  1170,
     169,   773,   501,   640,   641,  1105,  1185,   327,  1176,   741,
     741,   741,   741,   501,   741,  1067,  1068,  1069,   373,   153,
     501,   153,   153,   152,   995,   773,   281,   594,  1185,   441,
     633,   460,   565,   271,    37,   616,  1176,   271,   286,     3,
     746,   747,   741,    26,   502,   828,   829,   834,    37,   224,
     351,   420,   459,   840,   841,   842,   843,   840,   286,   224,
     281,   123,   210,   425,   439,   715,   716,  1170,   187,   187,
     167,   560,    37,   514,   168,   926,   927,   560,   560,   772,
     773,  1170,   773,  1170,   560,   560,   560,   560,   224,   560,
     373,   167,   560,   560,   286,   560,   271,   502,   618,   196,
     196,   196,   196,   196,   464,  1169,   657,   658,   505,   503,
     181,   795,   796,  1179,    25,   801,   417,   501,   172,   151,
     379,   151,   379,   359,   439,   253,  1077,  1179,   460,   645,
     809,   809,   172,   286,   795,    58,   560,   838,   773,  1077,
     826,   280,   826,   826,  1077,   773,  1170,   502,   500,   500,
     505,  1100,   140,  1155,  1156,    37,   502,  1100,   502,   502,
     502,   172,   502,   502,   502,   502,   502,   502,   505,   505,
     502,   311,   502,   502,   501,  1101,  1101,  1138,    13,    17,
      18,    19,   196,   218,   288,   489,   490,   491,   492,   493,
     494,   495,   496,   497,  1135,  1101,   502,   502,   167,   172,
     381,   502,   502,    37,  1151,  1138,  1151,  1151,   172,   502,
     133,   502,  1188,   308,  1114,    37,   502,   505,  1100,  1188,
     505,  1100,  1162,  1100,   502,   480,  1101,  1101,   146,  1138,
     172,   133,   135,   159,   270,   276,   424,   435,  1147,   270,
     146,   860,  1100,   402,  1163,  1100,  1152,  1100,   417,   501,
     996,   501,   501,   297,  1121,   501,  1138,   409,   411,   409,
     411,  1168,  1009,  1009,  1009,  1065,  1014,  1065,   911,  1175,
    1098,   537,   953,   247,   501,   502,  1175,  1097,  1097,   500,
     500,   502,   996,  1060,  1070,   172,   501,   996,  1045,  1046,
      37,  1047,  1048,  1185,   505,    98,   173,   206,   221,   231,
     259,   353,  1051,  1048,    37,  1047,  1050,  1185,  1048,   483,
    1064,  1161,  1100,   181,  1028,  1017,   288,  1133,  1136,   482,
     820,     5,  1175,  1026,   287,   460,   439,  1023,   242,  1044,
     457,  1066,   447,   404,   440,   965,   966,   967,  1185,   286,
     968,  1185,  1045,   981,   982,   505,  1043,   491,  1162,   837,
     774,   833,   833,    58,   835,   496,  1180,  1180,   286,  1169,
     289,   286,  1100,   614,  1170,   501,   501,   501,   638,   200,
     501,   731,   153,   560,   417,  1179,  1170,   542,  1077,   773,
     773,  1077,   661,  1170,   184,   445,   417,   417,   661,   677,
     683,   342,   376,   555,  1170,  1170,  1170,   208,   276,   156,
     829,   301,   376,   417,   271,   153,    85,   602,   603,   731,
     376,    24,   138,   346,   347,   376,   559,   568,   569,   683,
     879,   368,   153,   560,   153,   560,  1170,  1170,  1170,  1170,
     368,   368,   232,   686,   687,   686,   502,   505,   688,  1176,
     200,   502,   505,   491,   503,  1170,   156,  1179,  1170,   342,
     376,   555,  1170,  1170,  1170,   286,   302,   342,   376,    24,
     138,   302,   342,   376,  1077,   268,  1077,   502,   505,   491,
    1168,   417,  1180,   441,   704,   156,   196,   616,   890,   457,
     623,   623,   616,   234,   309,   276,  1176,   309,  1180,   438,
     156,   417,   417,   363,   392,   850,   850,   850,   301,   376,
      90,   417,   878,   363,   118,   167,   570,   163,   809,   417,
     417,   244,   244,   244,   417,   417,   363,   417,   417,   363,
     417,   363,   417,   363,   417,   126,   560,  1077,   271,  1176,
     376,   879,   153,   560,   417,   417,   502,  1170,   417,   878,
     363,   417,  1179,  1170,   502,   502,   502,  1140,   500,  1077,
     773,   218,   779,  1170,  1170,  1170,   218,   393,   394,   580,
    1176,   580,   184,   502,   502,   172,   741,   743,   268,   288,
     492,   493,   657,   744,   833,  1136,  1176,  1193,    71,    77,
      90,   118,   120,   176,   204,   271,   276,   320,   336,   434,
     605,   606,   609,   152,   456,   514,   542,  1170,   542,   290,
     681,  1168,  1168,  1168,   502,   505,  1180,   181,   354,  1180,
    1175,   427,  1168,   616,     3,   167,   709,   850,    47,   529,
     405,   690,   111,   950,  1100,   172,   505,  1169,   565,   748,
     749,  1176,   502,   505,  1170,   167,   617,  1168,   644,  1168,
    1170,   645,   501,   595,  1168,   502,  1170,   460,   462,   634,
     564,    37,   153,   995,   633,   417,   153,  1054,   491,   502,
     505,   715,   502,   505,   118,   491,   844,  1176,   542,   405,
     832,   833,   167,   849,    50,   349,   845,   846,   843,   846,
     123,   210,   369,   439,   901,  1170,   281,   286,   291,   184,
     995,  1077,   501,   502,   505,   560,   441,   560,   441,   560,
    1170,  1170,   699,   773,   153,   363,   363,   363,   363,   363,
    1169,   505,   793,  1185,  1179,   460,   505,   797,   289,  1056,
     373,   151,   151,   111,   267,  1168,  1170,  1180,   794,   801,
    1179,   218,   218,   218,   218,   657,   218,   218,   218,   218,
     218,  1143,   413,  1100,   144,  1077,   502,  1100,  1147,  1100,
    1100,   502,  1138,   505,  1077,  1101,  1101,  1101,  1101,   133,
     135,   271,  1101,  1101,  1101,  1101,  1101,  1101,  1101,  1101,
    1101,  1101,  1100,  1100,  1100,  1077,   502,   502,   502,  1138,
     502,   505,    58,  1102,  1115,   502,  1188,  1111,   317,   398,
    1113,   502,   505,   452,  1107,    37,   502,  1176,  1100,    34,
      34,  1100,   502,  1100,   172,   270,  1100,   502,   146,  1101,
    1101,   146,   146,  1100,  1100,  1015,   457,   501,  1122,  1185,
     502,  1138,   505,  1009,  1009,  1009,  1009,  1168,  1168,  1168,
    1028,   502,  1028,   502,   958,   500,  1048,  1050,  1048,   501,
     472,  1102,   502,  1185,   501,  1045,   221,   296,  1052,  1045,
    1052,   221,  1051,  1052,   221,   407,  1058,   501,  1185,   501,
     293,    58,   185,  1035,   501,   820,   164,   226,   287,   460,
     414,   101,  1100,   350,   970,   446,   502,   505,  1162,    88,
     970,   286,   502,   505,   980,  1066,  1100,   502,   496,   837,
     427,   175,   358,   364,   371,   406,   428,   806,   167,   806,
     502,   501,   621,   622,   814,  1105,  1185,   617,   617,   731,
    1170,   617,   120,   204,   267,   271,   732,  1170,  1170,    37,
     441,   441,   224,   774,  1179,  1170,   417,   878,   363,   417,
     208,  1170,    58,   408,  1170,   153,   600,   118,  1185,   681,
     392,   176,   155,   189,   271,   564,   514,   111,   176,   271,
     392,   395,   564,   602,   655,   376,   569,   427,  1170,  1185,
     368,   685,  1170,   567,   744,  1188,  1170,   301,   376,   417,
     878,   363,   417,   156,   417,   417,   363,   174,   288,   395,
     753,   754,   174,   288,   761,   762,   417,   417,   363,   502,
     502,   502,   885,   268,   657,   833,   886,  1136,  1176,  1193,
     342,  1170,   501,   460,   705,  1170,   363,   623,   501,   623,
    1177,  1176,  1176,  1176,  1170,  1170,  1170,  1170,  1177,    58,
     408,  1170,  1170,  1170,  1170,   447,  1170,  1170,   167,   167,
     344,   167,   190,  1179,  1170,  1170,  1179,  1170,  1170,  1170,
    1170,  1170,  1170,  1170,   286,    77,   561,   153,    26,    49,
     427,  1185,  1170,  1176,   683,  1170,  1170,  1170,  1170,  1014,
     502,   218,   779,   218,   218,   218,   779,   514,   441,   585,
     586,   661,   731,   460,   462,   773,   501,   773,  1170,  1101,
      31,    58,   608,   121,   192,   120,   276,   222,  1168,   607,
     174,   324,   727,   734,   735,  1185,   670,   501,   307,   501,
     595,   611,   203,   628,   598,  1180,  1180,  1077,   501,   565,
      28,   123,   210,   369,   439,   710,   417,   706,  1179,   190,
    1168,   692,   464,   286,   502,  1044,   641,   850,   502,   505,
    1069,   681,   699,   502,   652,    37,   281,   307,   501,   960,
     597,   599,   601,   613,  1185,   307,   629,   630,   595,   628,
     564,   284,   286,   635,   995,   647,   645,   565,  1176,  1170,
     811,   744,     3,   747,   286,   834,  1100,  1100,   505,   501,
     840,   427,   505,    43,  1100,   417,   501,   617,  1168,   716,
     661,   502,   926,   927,  1170,  1170,   560,   373,   560,  1169,
    1169,  1169,  1169,  1169,   657,   178,   796,   801,   502,  1170,
     111,   801,   172,   560,   276,   782,  1176,   782,   782,   782,
     218,   782,   782,   782,   782,   782,  1100,   502,   502,   502,
     172,   502,  1100,   172,   133,   135,   172,   167,   146,   502,
     467,  1109,  1138,   335,   446,    58,  1115,  1102,   458,   458,
     502,  1100,   267,  1100,   505,  1108,  1079,  1100,  1100,  1100,
    1100,    34,    34,  1100,  1100,   146,   502,   502,  1100,  1123,
    1185,   502,  1100,  1168,  1168,  1168,  1168,  1035,  1176,  1035,
    1176,   502,  1061,  1062,  1105,   501,  1114,  1047,   501,  1169,
    1045,   286,   441,  1053,  1045,   221,  1045,  1173,  1068,   501,
    1068,  1185,  1010,  1100,   459,  1118,   860,   414,   281,  1165,
     995,   300,   995,   967,   286,   501,   969,  1100,   491,   981,
     970,   427,   502,   417,   789,   172,   731,  1100,   502,   505,
     460,    77,   813,   817,   813,   502,   502,   502,   121,   192,
     202,   120,   443,   560,  1077,  1170,  1170,  1170,  1170,  1170,
    1170,  1170,  1180,  1170,   600,   604,  1177,   608,   190,   190,
     276,   657,   608,   276,  1177,  1185,  1077,   560,   560,   491,
      58,   408,  1170,  1170,  1170,  1170,  1170,  1179,  1170,  1170,
    1175,  1175,  1077,   505,  1175,  1175,   505,  1179,  1170,  1170,
     417,  1100,    71,   105,  1185,  1100,  1180,  1170,   417,   417,
     172,   196,   460,  1169,  1169,   773,  1169,   153,   156,   773,
    1176,  1176,  1077,   560,   560,   417,   502,   218,   779,   779,
     779,   779,   501,   581,   582,   514,   125,   174,   207,   174,
    1100,   271,   606,   118,    37,   850,   616,   850,  1173,    34,
     152,   196,   682,   686,   281,   594,   570,   150,   198,   501,
     373,   441,   617,    37,  1180,   704,   529,   271,   501,   169,
    1170,   640,  1176,   373,   565,   152,   995,   773,   281,   594,
     645,   502,   505,   460,   604,    58,   633,   570,   629,    83,
     408,   636,   460,   915,    37,   636,   172,   286,   501,  1168,
    1176,   831,   851,   852,  1186,   846,  1077,   167,   847,  1168,
     172,   417,   871,   337,   717,   205,   662,   560,   502,   560,
     560,  1170,   289,   216,   560,   795,   782,  1100,   502,  1101,
     172,  1100,  1100,  1100,   501,   502,   505,   502,  1115,   502,
     446,   389,   502,   502,  1100,  1100,  1100,   502,   307,  1124,
     502,  1118,  1118,   366,  1004,   502,   505,    37,  1063,   118,
    1075,  1076,  1101,    80,  1169,   502,  1100,   501,  1045,  1053,
     501,   502,  1068,   502,   100,   182,   356,   501,  1029,  1030,
    1031,  1032,  1033,  1034,  1100,  1119,  1120,  1185,  1014,   502,
     992,   965,    90,   812,   814,   134,   456,   984,   985,  1100,
     795,   286,   795,   502,   197,   619,   622,   288,   860,   773,
     773,   818,   336,   619,   619,   502,   417,   376,   976,    37,
     153,   153,   561,   744,  1180,  1170,   417,   501,   826,   860,
     862,   754,   501,   501,   762,  1170,   502,   501,   502,   376,
     976,  1170,  1170,   501,   501,   501,   460,   483,   935,   344,
     935,   935,   167,  1170,   561,  1170,   779,   587,   588,  1188,
      53,    99,   124,   142,   146,   168,   171,   186,   276,   328,
     583,   581,  1176,   826,    37,   867,   867,   502,   189,   501,
     441,   637,   245,   620,   637,   501,   735,   727,   501,   502,
     505,  1168,   502,   373,    28,    82,    85,    91,   119,   176,
     189,   201,   392,   395,   612,   612,  1167,  1170,  1170,   502,
     995,   705,   153,   111,   681,   172,  1170,    37,  1170,   645,
     595,  1168,   502,   599,   290,  1185,   634,   629,   633,   123,
     138,   317,  1170,    63,    71,   237,   995,   773,  1054,   812,
     172,   730,   833,   502,   505,   427,   144,   511,   845,   848,
    1065,   387,   387,   502,   261,   285,   718,   719,   720,   167,
     723,   661,   267,   445,   663,   664,  1170,   801,   167,  1101,
    1110,  1138,   267,   479,    58,  1014,    57,   127,   110,  1005,
    1064,  1061,   501,  1101,   502,   505,    37,  1071,  1072,  1185,
     502,  1169,  1138,   502,   501,   377,   501,   502,   505,   505,
      37,  1019,   446,  1170,   502,   505,   272,   439,   246,   271,
     985,   797,   806,   560,   813,   501,   850,   501,   564,   819,
    1168,   850,   850,  1170,   408,   189,   441,   562,   376,   976,
    1170,  1142,   167,   757,   757,  1142,  1142,  1100,   408,  1138,
    1138,   571,   572,  1187,   772,   773,   772,   773,  1169,   560,
     502,   505,   494,   501,   539,   589,   657,   932,  1176,   932,
     271,   276,   328,   932,   932,  1065,   867,    41,   194,   267,
     615,   501,   653,  1100,   200,   173,   306,   382,   286,   624,
     625,   626,   502,  1173,     6,   736,   686,   595,   628,  1170,
     502,   681,   160,   756,   565,   915,  1168,   464,  1044,   681,
     995,   960,   629,   595,   628,   604,   501,   635,   633,   634,
     360,   360,    71,   289,    71,   645,   811,   502,  1168,   731,
     840,   851,  1077,   504,   134,   460,   460,   719,   359,   405,
     721,   139,   724,   456,   726,   445,   661,   681,   560,  1100,
     502,   502,   446,  1138,   183,   329,   360,  1125,   164,   164,
     617,  1068,   505,  1076,  1188,   502,   505,   167,  1077,   502,
     502,  1138,   501,  1138,  1030,  1120,  1122,  1037,   995,  1065,
     814,   376,    34,   986,   246,   172,   617,   637,   860,   819,
     820,   616,   637,   637,  1170,   653,  1100,   408,   502,   292,
     366,   333,   758,   758,   502,   502,   502,  1170,   502,   502,
     502,   505,  1175,   935,   588,   539,   590,   591,  1176,  1176,
     276,   617,   494,   617,  1176,  1176,   202,   654,   502,   408,
     123,   439,   286,   626,   286,   625,   501,   502,   505,   570,
     373,   681,   773,    37,    37,   501,  1170,   915,   645,   633,
     570,   629,   501,   631,   632,  1105,  1185,   636,   634,   635,
     289,   289,   501,   197,   815,   167,   846,    29,   211,   902,
     174,   174,   932,   359,   391,   725,   501,   152,    51,   101,
     430,  1100,  1126,  1127,  1126,  1126,   502,    58,    58,   376,
     502,  1102,  1072,   293,     3,   118,   271,   276,  1073,  1074,
      37,  1049,   343,  1059,   502,  1029,   502,   979,  1100,   413,
     986,   795,   502,   623,   502,   820,   620,   731,   731,   976,
    1170,   826,    58,   976,   417,   571,   773,   502,   505,   617,
     502,   396,  1170,    62,   267,   348,   376,   627,   627,   502,
       6,   373,  1170,   753,   995,   681,   634,   629,   633,  1100,
     502,   505,   817,   817,   635,   636,   812,   501,   607,   139,
     272,   501,   897,   899,   903,   962,   971,   978,   995,  1006,
     826,   826,   722,  1185,  1100,   727,  1127,   359,   166,   315,
     166,   315,   149,  1128,  1128,  1128,   617,   617,  1185,  1114,
    1101,  1101,   276,  1074,  1185,   501,   502,  1065,   123,   134,
     439,   987,   988,   413,   560,   731,   624,   976,   773,   501,
     591,    23,   118,   276,  1170,   681,   915,   635,   633,   634,
     502,   632,   773,   818,   818,   636,   502,   814,   816,   565,
     359,   898,   899,   900,   996,   997,   505,   505,   502,  1173,
      34,   101,   181,   267,   414,   376,   376,   417,   441,    80,
    1100,   272,   376,   134,   210,   989,   731,  1138,   616,   616,
     681,   636,   634,   635,   817,   815,   502,   505,   636,   726,
     502,   504,   417,   172,   501,  1127,   359,   294,  1185,  1185,
    1173,  1174,  1185,  1071,   502,   979,   272,   118,   300,   447,
     501,   990,   502,   635,   636,   818,   607,   814,  1065,   152,
     900,   387,   387,     5,   728,   729,  1175,  1176,  1188,   501,
     118,   502,   447,   965,   501,   966,   636,   565,   727,   460,
     460,   502,   505,  1139,  1174,   446,  1138,   502,   636,  1173,
     174,   174,   729,  1014,   441,   990,   502,   300,   990,  1065,
     501,   826,   826,   502,  1185,   965,   728,   446,   502,   990
};

  /* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_uint16 yyr1[] =
{
       0,   507,   508,   508,   508,   508,   508,   508,   509,   509,
     510,   510,   511,   511,   511,   511,   511,   511,   511,   511,
     511,   511,   511,   511,   511,   511,   511,   511,   511,   511,
     511,   511,   511,   511,   511,   511,   511,   511,   511,   511,
     511,   511,   511,   511,   511,   511,   511,   511,   511,   511,
     511,   511,   511,   511,   511,   511,   511,   511,   511,   511,
     511,   511,   511,   511,   511,   511,   511,   511,   511,   511,
     511,   511,   511,   511,   511,   511,   511,   511,   511,   511,
     511,   511,   511,   511,   511,   511,   511,   511,   511,   511,
     511,   511,   511,   511,   511,   511,   511,   511,   511,   511,
     511,   511,   511,   511,   511,   511,   511,   511,   511,   511,
     511,   511,   511,   511,   511,   511,   511,   511,   511,   511,
     511,   511,   511,   511,   511,   511,   511,   511,   511,   511,
     511,   511,   511,   511,   511,   511,   511,   512,   513,   514,
     514,   514,   515,   515,   516,   516,   517,   517,   517,   517,
     517,   517,   517,   517,   517,   518,   518,   518,   518,   518,
     518,   519,   520,   520,   521,   521,   522,   522,   522,   522,
     523,   523,   523,   523,   523,   523,   524,   525,   526,   526,
     527,   527,   527,   527,   528,   528,   529,   529,   530,   530,
     530,   530,   530,   530,   531,   531,   531,   531,   532,   532,
     532,   533,   533,   533,   533,   534,   534,   534,   534,   534,
     534,   534,   534,   534,   534,   534,   535,   535,   536,   536,
     537,   537,   538,   538,   538,   538,   539,   539,   539,   539,
     540,   540,   540,   540,   540,   540,   540,   541,   541,   541,
     542,   542,   543,   543,   544,   544,   544,   544,   545,   545,
     546,   546,   547,   547,   548,   548,   548,   548,   548,   548,
     548,   549,   550,   550,   551,   551,   552,   553,   553,   553,
     553,   553,   554,   554,   554,   554,   554,   554,   554,   554,
     554,   554,   554,   554,   554,   554,   554,   554,   554,   554,
     554,   554,   554,   555,   555,   556,   556,   556,   557,   558,
     558,   558,   558,   558,   558,   558,   558,   558,   558,   558,
     558,   558,   558,   558,   558,   558,   558,   558,   558,   558,
     558,   558,   558,   558,   558,   558,   558,   558,   558,   558,
     558,   558,   558,   558,   558,   558,   558,   558,   558,   558,
     558,   558,   558,   558,   558,   558,   558,   558,   558,   558,
     558,   558,   558,   558,   558,   558,   558,   558,   558,   559,
     559,   560,   560,   560,   561,   561,   562,   562,   563,   563,
     563,   563,   564,   565,   565,   566,   566,   567,   567,   567,
     567,   568,   568,   569,   569,   569,   569,   570,   570,   570,
     570,   571,   572,   572,   573,   574,   574,   575,   575,   575,
     575,   576,   576,   577,   577,   578,   578,   579,   579,   580,
     580,   580,   581,   581,   582,   582,   583,   583,   583,   583,
     583,   583,   583,   583,   583,   583,   583,   583,   583,   584,
     584,   585,   585,   586,   586,   587,   587,   588,   589,   589,
     589,   589,   589,   590,   590,   591,   592,   592,   592,   592,
     592,   592,   593,   593,   593,   593,   593,   593,   593,   593,
     594,   594,   595,   595,   596,   596,   597,   597,   598,   598,
     598,   599,   599,   600,   601,   601,   602,   602,   603,   603,
     604,   604,   605,   605,   605,   605,   606,   606,   606,   606,
     606,   606,   606,   606,   606,   607,   607,   607,   608,   608,
     609,   609,   609,   609,   610,   611,   611,   611,   612,   612,
     612,   612,   612,   612,   612,   612,   612,   612,   613,   613,
     614,   614,   614,   614,   614,   614,   614,   615,   615,   616,
     616,   617,   617,   618,   619,   619,   620,   620,   620,   620,
     621,   621,   622,   622,   623,   623,   624,   624,   624,   624,
     624,   625,   626,   627,   627,   627,   627,   627,   628,   628,
     629,   629,   630,   631,   631,   632,   632,   632,   633,   633,
     634,   634,   634,   635,   635,   635,   635,   636,   636,   637,
     637,   638,   639,   639,   640,   640,   641,   641,   641,   642,
     642,   643,   643,   644,   645,   645,   645,   646,   646,   647,
     648,   648,   649,   650,   650,   651,   651,   652,   652,   653,
     653,   654,   654,   655,   655,   655,   655,   655,   655,   655,
     655,   655,   655,   655,   655,   655,   655,   656,   656,   657,
     657,   657,   657,   658,   658,   659,   659,   660,   660,   661,
     661,   662,   662,   663,   663,   664,   664,   665,   665,   666,
     667,   667,   668,   668,   669,   669,   670,   670,   671,   671,
     671,   671,   672,   673,   673,   674,   675,   675,   675,   675,
     675,   675,   675,   675,   675,   675,   675,   675,   675,   676,
     677,   677,   677,   677,   678,   678,   679,   679,   680,   680,
     681,   681,   682,   682,   683,   684,   684,   685,   685,   685,
     685,   686,   687,   688,   689,   689,   690,   690,   691,   691,
     692,   692,   693,   693,   693,   694,   694,   694,   694,   695,
     696,   696,   697,   697,   698,   698,   699,   699,   700,   700,
     701,   702,   703,   704,   704,   705,   705,   706,   706,   707,
     707,   708,   708,   709,   709,   710,   710,   710,   710,   710,
     711,   712,   712,   713,   713,   714,   714,   714,   715,   715,
     716,   716,   716,   716,   716,   717,   717,   718,   718,   719,
     720,   720,   721,   721,   722,   723,   723,   724,   724,   725,
     725,   726,   726,   727,   727,   728,   728,   728,   729,   729,
     729,   729,   730,   730,   731,   731,   732,   732,   732,   732,
     732,   732,   733,   733,   734,   734,   735,   736,   736,   737,
     738,   738,   738,   738,   739,   740,   740,   740,   740,   740,
     740,   740,   740,   740,   740,   740,   740,   740,   740,   740,
     740,   741,   742,   742,   743,   743,   744,   744,   744,   744,
     744,   744,   745,   746,   746,   747,   748,   748,   749,   749,
     750,   750,   750,   750,   751,   751,   752,   753,   753,   754,
     754,   754,   754,   754,   755,   755,   756,   756,   757,   757,
     757,   758,   758,   759,   760,   760,   761,   761,   762,   762,
     763,   763,   764,   764,   765,   766,   767,   767,   767,   767,
     767,   767,   767,   767,   767,   767,   767,   767,   768,   768,
     768,   768,   768,   768,   768,   768,   768,   768,   768,   768,
     768,   769,   769,   769,   769,   769,   770,   770,   770,   770,
     770,   770,   770,   770,   771,   771,   771,   772,   772,   773,
     773,   774,   774,   775,   775,   776,   777,   777,   777,   778,
     778,   778,   778,   778,   778,   778,   778,   778,   778,   778,
     778,   778,   778,   778,   778,   778,   778,   779,   779,   780,
     780,   780,   780,   780,   780,   780,   780,   780,   780,   781,
     781,   782,   782,   783,   783,   784,   784,   784,   784,   784,
     784,   784,   784,   784,   784,   784,   784,   784,   784,   784,
     784,   785,   785,   786,   786,   787,   788,   788,   789,   789,
     789,   789,   789,   790,   790,   791,   791,   791,   791,   791,
     792,   792,   793,   793,   794,   794,   794,   794,   794,   794,
     794,   794,   794,   794,   794,   794,   794,   794,   794,   794,
     794,   794,   794,   794,   794,   795,   795,   796,   796,   797,
     797,   798,   799,   799,   800,   800,   801,   801,   802,   803,
     803,   804,   804,   804,   805,   805,   805,   806,   806,   806,
     806,   806,   806,   807,   807,   808,   808,   809,   809,   810,
     810,   811,   811,   812,   812,   813,   813,   814,   814,   814,
     815,   815,   816,   816,   817,   817,   818,   818,   819,   819,
     819,   820,   820,   820,   821,   821,   821,   821,   822,   822,
     823,   823,   824,   824,   825,   825,   826,   826,   826,   826,
     827,   827,   828,   828,   829,   829,   829,   829,   829,   830,
     830,   830,   830,   830,   831,   832,   833,   833,   833,   834,
     834,   834,   835,   836,   836,   836,   836,   837,   837,   838,
     839,   839,   840,   840,   841,   841,   842,   842,   842,   842,
     842,   842,   842,   842,   842,   842,   842,   842,   842,   842,
     842,   842,   842,   843,   843,   843,   843,   843,   844,   844,
     845,   846,   846,   846,   847,   847,   848,   848,   849,   849,
     850,   850,   851,   852,   852,   853,   853,   853,   854,   854,
     855,   855,   856,   856,   856,   856,   856,   856,   857,   857,
     858,   858,   859,   859,   859,   859,   860,   860,   861,   861,
     862,   863,   864,   864,   865,   865,   866,   866,   866,   867,
     867,   867,   868,   869,   869,   870,   871,   871,   871,   871,
     872,   873,   873,   873,   873,   874,   874,   875,   875,   875,
     876,   876,   877,   877,   877,   877,   877,   877,   877,   877,
     877,   877,   877,   877,   877,   877,   877,   877,   877,   877,
     877,   877,   877,   877,   877,   877,   877,   877,   877,   877,
     877,   877,   877,   877,   877,   877,   877,   877,   877,   877,
     877,   877,   877,   877,   877,   877,   877,   877,   877,   877,
     877,   877,   877,   877,   877,   877,   877,   878,   878,   879,
     879,   880,   880,   880,   880,   880,   880,   881,   881,   882,
     882,   882,   882,   882,   882,   882,   882,   882,   882,   882,
     882,   882,   882,   882,   882,   882,   882,   882,   882,   882,
     882,   882,   882,   882,   882,   882,   883,   884,   884,   885,
     885,   886,   886,   886,   886,   886,   887,   888,   888,   888,
     888,   888,   888,   888,   888,   888,   888,   888,   888,   888,
     888,   888,   888,   888,   888,   888,   888,   888,   888,   888,
     888,   889,   889,   889,   890,   890,   890,   890,   890,   890,
     890,   891,   891,   892,   892,   892,   892,   893,   894,   894,
     894,   894,   894,   894,   894,   894,   894,   895,   895,   896,
     897,   897,   897,   898,   898,   899,   899,   899,   899,   899,
     900,   900,   901,   901,   901,   901,   902,   902,   902,   903,
     904,   904,   905,   906,   906,   907,   907,   907,   907,   907,
     907,   907,   907,   907,   907,   907,   907,   908,   908,   909,
     909,   909,   910,   910,   910,   910,   910,   911,   911,   911,
     912,   912,   913,   913,   913,   914,   914,   914,   914,   915,
     915,   915,   915,   916,   917,   918,   918,   919,   919,   920,
     920,   920,   921,   921,   921,   921,   921,   921,   921,   922,
     922,   923,   923,   923,   923,   924,   925,   925,   925,   925,
     926,   926,   927,   928,   929,   929,   930,   931,   931,   931,
     931,   931,   931,   931,   932,   932,   933,   934,   934,   934,
     934,   934,   934,   935,   935,   936,   937,   937,   937,   937,
     938,   938,   939,   939,   940,   940,   941,   941,   942,   942,
     943,   944,   944,   945,   945,   945,   946,   946,   947,   947,
     948,   948,   949,   949,   950,   950,   951,   952,   952,   953,
     953,   954,   954,   954,   954,   955,   955,   955,   955,   955,
     955,   955,   955,   955,   955,   956,   957,   957,   958,   958,
     958,   958,   958,   959,   959,   959,   960,   960,   961,   961,
     961,   961,   962,   963,   963,   964,   964,   964,   964,   964,
     965,   965,   966,   966,   967,   968,   968,   968,   969,   969,
     969,   970,   970,   971,   972,   972,   973,   974,   974,   975,
     975,   975,   975,   975,   975,   975,   975,   976,   976,   977,
     977,   977,   978,   979,   979,   980,   980,   981,   982,   982,
     983,   984,   984,   985,   985,   985,   985,   985,   986,   986,
     987,   988,   989,   989,   989,   989,   989,   990,   991,   992,
     993,   993,   993,   993,   993,   993,   994,   994,   994,   995,
     995,   996,   996,   997,   997,   997,   997,   997,   997,   997,
     997,   998,   998,   999,   999,   999,   999,   999,   999,   999,
    1000,  1000,  1000,  1001,  1001,  1002,  1003,  1003,  1003,  1004,
    1004,  1004,  1005,  1005,  1005,  1006,  1006,  1007,  1007,  1008,
    1008,  1008,  1008,  1008,  1008,  1008,  1008,  1008,  1009,  1009,
    1010,  1010,  1010,  1011,  1011,  1012,  1012,  1013,  1013,  1014,
    1014,  1015,  1016,  1016,  1017,  1017,  1018,  1018,  1018,  1018,
    1019,  1019,  1020,  1020,  1020,  1020,  1020,  1020,  1021,  1021,
    1022,  1022,  1023,  1024,  1024,  1024,  1025,  1025,  1026,  1026,
    1027,  1027,  1028,  1028,  1029,  1029,  1030,  1030,  1030,  1030,
    1030,  1031,  1032,  1033,  1034,  1035,  1035,  1036,  1036,  1037,
    1037,  1038,  1038,  1039,  1040,  1040,  1040,  1040,  1041,  1041,
    1042,  1042,  1043,  1043,  1044,  1044,  1045,  1045,  1045,  1045,
    1045,  1045,  1045,  1045,  1045,  1045,  1046,  1046,  1046,  1046,
    1046,  1046,  1047,  1047,  1047,  1047,  1048,  1048,  1049,  1049,
    1050,  1050,  1050,  1050,  1050,  1051,  1051,  1051,  1051,  1052,
    1052,  1053,  1053,  1054,  1054,  1055,  1055,  1055,  1056,  1056,
    1057,  1057,  1057,  1058,  1059,  1059,  1060,  1060,  1061,  1062,
    1062,  1063,  1063,  1064,  1064,  1065,  1065,  1066,  1066,  1066,
    1067,  1067,  1068,  1068,  1069,  1070,  1070,  1071,  1071,  1072,
    1072,  1072,  1073,  1073,  1074,  1074,  1074,  1074,  1075,  1075,
    1076,  1076,  1077,  1077,  1077,  1077,  1077,  1077,  1078,  1078,
    1078,  1079,  1079,  1079,  1079,  1079,  1079,  1079,  1080,  1080,
    1080,  1080,  1081,  1081,  1082,  1082,  1083,  1083,  1083,  1083,
    1083,  1083,  1083,  1083,  1083,  1083,  1083,  1084,  1084,  1085,
    1085,  1086,  1086,  1087,  1088,  1089,  1089,  1090,  1090,  1091,
    1092,  1093,  1093,  1093,  1093,  1093,  1093,  1094,  1094,  1095,
    1095,  1095,  1095,  1096,  1097,  1097,  1097,  1098,  1098,  1098,
    1098,  1098,  1098,  1098,  1098,  1098,  1098,  1098,  1098,  1098,
    1098,  1099,  1099,  1100,  1100,  1100,  1100,  1100,  1100,  1100,
    1100,  1100,  1100,  1100,  1100,  1100,  1100,  1100,  1100,  1100,
    1100,  1100,  1100,  1100,  1100,  1100,  1100,  1100,  1100,  1100,
    1100,  1100,  1100,  1100,  1100,  1100,  1100,  1100,  1100,  1100,
    1100,  1100,  1100,  1100,  1100,  1100,  1100,  1100,  1100,  1100,
    1100,  1100,  1100,  1100,  1100,  1100,  1100,  1100,  1100,  1100,
    1100,  1100,  1100,  1100,  1100,  1100,  1100,  1100,  1101,  1101,
    1101,  1101,  1101,  1101,  1101,  1101,  1101,  1101,  1101,  1101,
    1101,  1101,  1101,  1101,  1101,  1101,  1101,  1101,  1101,  1101,
    1102,  1102,  1102,  1102,  1102,  1102,  1102,  1102,  1102,  1102,
    1102,  1102,  1102,  1102,  1103,  1103,  1103,  1103,  1103,  1103,
    1103,  1104,  1104,  1105,  1105,  1106,  1106,  1106,  1106,  1106,
    1106,  1106,  1106,  1106,  1106,  1106,  1106,  1106,  1106,  1106,
    1106,  1106,  1106,  1106,  1106,  1106,  1106,  1106,  1106,  1106,
    1106,  1106,  1106,  1106,  1106,  1106,  1106,  1106,  1106,  1106,
    1106,  1106,  1106,  1106,  1106,  1106,  1106,  1106,  1106,  1106,
    1106,  1107,  1107,  1108,  1108,  1108,  1108,  1109,  1110,  1110,
    1111,  1111,  1112,  1112,  1113,  1113,  1113,  1114,  1114,  1114,
    1114,  1115,  1115,  1116,  1116,  1117,  1117,  1118,  1118,  1119,
    1119,  1120,  1121,  1121,  1121,  1122,  1123,  1123,  1124,  1124,
    1125,  1125,  1125,  1125,  1126,  1126,  1127,  1127,  1127,  1127,
    1127,  1128,  1128,  1128,  1128,  1128,  1129,  1129,  1129,  1130,
    1130,  1131,  1132,  1132,  1132,  1133,  1133,  1134,  1134,  1134,
    1134,  1134,  1134,  1134,  1134,  1134,  1134,  1134,  1134,  1135,
    1135,  1136,  1136,  1137,  1137,  1137,  1137,  1137,  1137,  1138,
    1138,  1139,  1139,  1140,  1140,  1140,  1141,  1141,  1142,  1142,
    1143,  1143,  1143,  1144,  1144,  1145,  1146,  1146,  1146,  1146,
    1146,  1146,  1146,  1146,  1147,  1147,  1147,  1147,  1148,  1148,
    1149,  1150,  1150,  1150,  1150,  1150,  1151,  1151,  1151,  1152,
    1152,  1153,  1154,  1154,  1155,  1156,  1156,  1157,  1157,  1158,
    1158,  1159,  1159,  1159,  1159,  1160,  1160,  1161,  1161,  1162,
    1162,  1163,  1163,  1164,  1164,  1165,  1165,  1166,  1166,  1166,
    1166,  1167,  1167,  1168,  1168,  1169,  1169,  1170,  1171,  1172,
    1173,  1173,  1174,  1174,  1174,  1174,  1174,  1174,  1174,  1174,
    1174,  1174,  1174,  1174,  1174,  1175,  1176,  1177,  1177,  1177,
    1178,  1179,  1179,  1179,  1179,  1180,  1180,  1181,  1182,  1183,
    1183,  1184,  1184,  1185,  1185,  1185,  1186,  1186,  1186,  1187,
    1187,  1187,  1187,  1188,  1188,  1188,  1188,  1188,  1189,  1189,
    1190,  1190,  1190,  1190,  1190,  1190,  1190,  1190,  1190,  1190,
    1190,  1190,  1190,  1190,  1190,  1190,  1190,  1190,  1190,  1190,
    1190,  1190,  1190,  1190,  1190,  1190,  1190,  1190,  1190,  1190,
    1190,  1190,  1190,  1190,  1190,  1190,  1190,  1190,  1190,  1190,
    1190,  1190,  1190,  1190,  1190,  1190,  1190,  1190,  1190,  1190,
    1190,  1190,  1190,  1190,  1190,  1190,  1190,  1190,  1190,  1190,
    1190,  1190,  1190,  1190,  1190,  1190,  1190,  1190,  1190,  1190,
    1190,  1190,  1190,  1190,  1190,  1190,  1190,  1190,  1190,  1190,
    1190,  1190,  1190,  1190,  1190,  1190,  1190,  1190,  1190,  1190,
    1190,  1190,  1190,  1190,  1190,  1190,  1190,  1190,  1190,  1190,
    1190,  1190,  1190,  1190,  1190,  1190,  1190,  1190,  1190,  1190,
    1190,  1190,  1190,  1190,  1190,  1190,  1190,  1190,  1190,  1190,
    1190,  1190,  1190,  1190,  1190,  1190,  1190,  1190,  1190,  1190,
    1190,  1190,  1190,  1190,  1190,  1190,  1190,  1190,  1190,  1190,
    1190,  1190,  1190,  1190,  1190,  1190,  1190,  1190,  1190,  1190,
    1190,  1190,  1190,  1190,  1190,  1190,  1190,  1190,  1190,  1190,
    1190,  1190,  1190,  1190,  1190,  1190,  1190,  1190,  1190,  1190,
    1190,  1190,  1190,  1190,  1190,  1190,  1190,  1190,  1190,  1190,
    1190,  1190,  1190,  1190,  1190,  1190,  1190,  1190,  1190,  1190,
    1190,  1190,  1190,  1190,  1190,  1190,  1190,  1190,  1190,  1190,
    1190,  1190,  1190,  1190,  1190,  1190,  1190,  1190,  1190,  1190,
    1190,  1190,  1190,  1190,  1190,  1190,  1190,  1190,  1190,  1190,
    1190,  1190,  1190,  1190,  1190,  1190,  1190,  1190,  1190,  1190,
    1190,  1190,  1190,  1190,  1190,  1190,  1190,  1190,  1190,  1190,
    1190,  1190,  1190,  1190,  1190,  1190,  1190,  1190,  1190,  1190,
    1190,  1190,  1190,  1190,  1190,  1190,  1190,  1190,  1190,  1190,
    1190,  1190,  1190,  1190,  1190,  1190,  1190,  1190,  1190,  1190,
    1190,  1190,  1190,  1190,  1190,  1190,  1190,  1190,  1190,  1190,
    1190,  1190,  1190,  1190,  1190,  1190,  1190,  1190,  1190,  1190,
    1190,  1190,  1190,  1190,  1190,  1190,  1190,  1190,  1190,  1190,
    1190,  1190,  1190,  1190,  1190,  1190,  1190,  1190,  1190,  1191,
    1191,  1191,  1191,  1191,  1191,  1191,  1191,  1191,  1191,  1191,
    1191,  1191,  1191,  1191,  1191,  1191,  1191,  1191,  1191,  1191,
    1191,  1191,  1191,  1191,  1191,  1191,  1191,  1191,  1191,  1191,
    1191,  1191,  1191,  1191,  1191,  1191,  1191,  1191,  1191,  1191,
    1191,  1191,  1191,  1191,  1191,  1191,  1191,  1191,  1191,  1191,
    1192,  1192,  1192,  1192,  1192,  1192,  1192,  1192,  1192,  1192,
    1192,  1192,  1192,  1192,  1192,  1192,  1192,  1192,  1192,  1192,
    1192,  1192,  1192,  1193,  1193,  1193,  1193,  1193,  1193,  1193,
    1193,  1193,  1193,  1193,  1193,  1193,  1193,  1193,  1193,  1193,
    1193,  1193,  1193,  1193,  1193,  1193,  1193,  1193,  1193,  1193,
    1193,  1193,  1193,  1193,  1193,  1193,  1193,  1193,  1193,  1193,
    1193,  1193,  1193,  1193,  1193,  1193,  1193,  1193,  1193,  1193,
    1193,  1193,  1193,  1193,  1193,  1193,  1193,  1193,  1193,  1193,
    1193,  1193,  1193,  1193,  1193,  1193,  1193,  1193,  1193,  1193,
    1193,  1193,  1193,  1193,  1193,  1193,  1193,  1193,  1193,  1193,
    1194,  1194,  1194,  1194,  1194,  1194,  1194,  1194,  1194,  1194,
    1194,  1194,  1194,  1194,  1194,  1194,  1194,  1194,  1194,  1194,
    1194,  1194,  1194,  1194,  1194,  1194,  1194,  1194,  1194,  1194,
    1194,  1194,  1194,  1194,  1194,  1194,  1194,  1194,  1194,  1194,
    1194,  1194,  1194,  1194,  1194,  1194,  1194,  1194,  1194,  1194,
    1194,  1194,  1194,  1194,  1194,  1194,  1194,  1194,  1194,  1194,
    1194,  1194,  1194,  1194,  1194,  1194,  1194,  1194,  1194,  1194,
    1194,  1194,  1194,  1194,  1194,  1194,  1194,  1194,  1194,  1194,
    1194,  1194,  1194,  1194,  1194,  1194,  1194,  1194,  1194,  1194,
    1194,  1194,  1194,  1194,  1194,  1194,  1194,  1194,  1194,  1194,
    1194,  1194,  1194,  1194,  1194,  1194,  1194,  1194,  1194,  1194,
    1194,  1194,  1194,  1194,  1194,  1194,  1194,  1194,  1194,  1194,
    1194,  1194,  1194,  1194,  1194,  1194,  1194,  1194,  1194,  1194,
    1194,  1194,  1194,  1194,  1194,  1194,  1194,  1194,  1194,  1194,
    1194,  1194,  1194,  1194,  1194,  1194,  1194,  1194,  1194,  1194,
    1194,  1194,  1194,  1194,  1194,  1194,  1194,  1194,  1194,  1194,
    1194,  1194,  1194,  1194,  1194,  1194,  1194,  1194,  1194,  1194,
    1194,  1194,  1194,  1194,  1194,  1194,  1194,  1194,  1194,  1194,
    1194,  1194,  1194,  1194,  1194,  1194,  1194,  1194,  1194,  1194,
    1194,  1194,  1194,  1194,  1194,  1194,  1194,  1194,  1194,  1194,
    1194,  1194,  1194,  1194,  1194,  1194,  1194,  1194,  1194,  1194,
    1194,  1194,  1194,  1194,  1194,  1194,  1194,  1194,  1194,  1194,
    1194,  1194,  1194,  1194,  1194,  1194,  1194,  1194,  1194,  1194,
    1194,  1194,  1194,  1194,  1194,  1194,  1194,  1194,  1194,  1194,
    1194,  1194,  1194,  1194,  1194,  1194,  1194,  1194,  1194,  1194,
    1194,  1194,  1194,  1194,  1194,  1194,  1194,  1194,  1194,  1194,
    1194,  1194,  1194,  1194,  1194,  1194,  1194,  1194,  1194,  1194,
    1194,  1194,  1194,  1194,  1194,  1194,  1194,  1194,  1194,  1194,
    1194,  1194,  1194,  1194,  1194,  1194,  1194,  1194,  1194,  1194,
    1194,  1194,  1194,  1194,  1194,  1194,  1194,  1194,  1194,  1194,
    1194,  1194,  1194,  1194,  1194,  1194,  1194,  1194,  1194,  1194,
    1194,  1194,  1194,  1194,  1194,  1194,  1194,  1194,  1194,  1194,
    1194,  1194,  1194,  1194,  1194,  1194,  1194,  1194,  1194,  1194,
    1194,  1194,  1194,  1194,  1194,  1194,  1194,  1194,  1194,  1194,
    1194,  1194,  1194,  1194,  1194,  1194,  1194,  1194,  1194,  1194,
    1194,  1194,  1194,  1194,  1194,  1194,  1194,  1194,  1194,  1194,
    1194,  1194,  1194,  1194,  1194,  1194,  1194,  1194,  1194,  1194,
    1194,  1194,  1194,  1194,  1194,  1194,  1194,  1194,  1194,  1194,
    1194,  1194,  1194,  1194,  1194,  1194,  1194,  1194,  1194,  1194,
    1194,  1194,  1194,  1194,  1194,  1194,  1194,  1194,  1194,  1194,
    1194,  1194,  1194,  1194,  1194,  1194,  1194,  1194,  1194,  1194,
    1194,  1194,  1194,  1194,  1194,  1194,  1194,  1194,  1194,  1194,
    1194
};

  /* YYR2[YYN] -- Number of symbols on the right hand side of rule YYN.  */
static const yytype_uint8 yyr2[] =
{
       0,     2,     1,     2,     2,     2,     2,     2,     3,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     0,     2,     5,     1,
       1,     0,     2,     0,     2,     0,     2,     2,     3,     3,
       1,     3,     3,     2,     1,     1,     2,     2,     2,     3,
       3,     5,     5,     5,     0,     3,     5,     5,     5,     5,
       3,     5,     3,     5,     3,     5,     5,     6,     1,     1,
       6,     4,     9,     7,     1,     0,     2,     0,     1,     1,
       1,     1,     1,     1,     3,     2,     3,     3,     2,     5,
       1,     3,     3,     3,     3,     1,     3,     3,     2,     2,
       2,     2,     3,     3,     3,     3,     1,     3,     1,     3,
       1,     1,     2,     2,     2,     1,     1,     1,     1,     1,
       1,     1,     3,     5,     1,     1,     1,     1,     1,     0,
       1,     1,     2,     3,     1,     2,     3,     2,     1,     1,
       2,     1,     2,     1,     3,     3,     2,     3,     4,     3,
       2,     4,     1,     1,     1,     1,     1,     2,     2,     2,
       2,     2,     4,     6,     4,     6,    10,    13,     4,     6,
       4,    10,    13,     4,     6,     4,     6,     5,     7,    11,
      14,     5,     7,     1,     3,     4,     4,     4,     3,     2,
       5,     3,     6,     4,     6,     6,     5,     7,     6,     6,
       5,     5,     6,     5,     9,     4,     5,     7,     6,     4,
       8,     4,     2,     4,     3,     6,     4,     3,     3,     3,
       2,     2,     3,     4,     4,     3,     3,     3,     3,     3,
       3,     4,     4,     3,     2,     3,     2,     2,     3,     4,
       3,     2,     2,     3,     4,     4,     4,     5,     1,     3,
       2,     1,     1,     0,     2,     0,     2,     0,     1,     1,
       1,     3,     3,     2,     0,     1,     3,     3,     1,     5,
       3,     1,     2,     1,     3,     2,     3,     6,     6,    10,
       1,     2,     1,     3,     4,     1,     3,     4,     6,     4,
       8,     2,     2,    11,     9,     1,     1,     1,     0,     1,
       1,     1,     1,     3,     2,     0,     1,     1,     3,     3,
       1,     1,     3,     3,     3,     3,     4,     3,     2,     1,
       0,     3,     0,     1,     0,     1,     3,     2,     1,     1,
       1,     3,     0,     1,     3,     1,    13,    16,    12,    15,
      14,    17,     1,     1,     2,     2,     2,     2,     1,     0,
       1,     0,     3,     0,     1,     3,     1,     3,     1,     1,
       1,     1,     1,     5,     2,     4,     2,     2,     1,     0,
       2,     0,     3,     1,     1,     2,     2,     1,     4,     4,
       5,     2,     5,     7,     5,     2,     3,     0,     1,     2,
       1,     2,     2,     2,     3,     3,     3,     0,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     3,     1,
       5,     9,     3,     9,     4,    10,    11,     2,     0,     3,
       0,     1,     3,     1,     4,     0,     2,     2,     2,     0,
       1,     3,     3,     6,     4,     0,     1,     1,     2,     2,
       0,     3,     3,     2,     1,     1,     3,     3,     4,     0,
       1,     0,     6,     1,     3,     3,     3,     5,     2,     0,
       2,     2,     0,     3,     4,     4,     0,     2,     0,     4,
       0,     3,     8,    11,     1,     3,     1,     1,     3,     6,
       8,     7,    10,     6,     2,     3,     0,     8,    11,     5,
       1,     0,     6,     5,     8,     4,     6,     1,     0,     3,
       0,     1,     2,     2,     2,     1,     2,     3,     2,     2,
       2,     2,     3,     3,     3,     1,     3,     1,     0,     1,
       2,     2,     1,     1,     3,     6,    10,     1,     0,     1,
       2,     2,     0,     2,     2,     1,     0,     1,     0,     7,
       2,     0,     3,     5,     5,     8,     2,     0,     2,     2,
       2,     1,     5,     2,     0,     2,     6,     6,     6,    10,
       6,     6,     6,     9,     9,     6,     6,     9,     6,     7,
       2,     2,     2,     2,     1,     2,     1,     0,     7,     6,
       4,     0,     1,     3,     4,     1,     3,     1,     2,     2,
       2,     2,     1,     1,    10,    13,     2,     0,     2,     2,
       1,     0,     5,     4,     4,    11,    14,    12,    15,    11,
       2,     1,     4,     0,     8,    11,     1,     1,     7,     9,
       8,    10,     8,     4,     0,     5,     0,     2,     0,     2,
       0,     2,     0,     2,     0,     1,     1,     1,     1,     1,
       8,     1,     1,    17,    21,     1,     1,     2,     1,     3,
       1,     1,     1,     3,     1,     2,     0,     1,     2,     4,
       1,     1,     1,     1,     1,     3,     0,     1,     0,     1,
       1,     4,     0,     1,     1,     1,     3,     0,     1,     1,
       1,     1,     2,     0,     0,     2,     2,     1,     2,     2,
       2,     2,    11,    13,     1,     3,     5,     1,     3,     5,
       1,     2,     2,     1,     8,     6,     5,     4,     4,     3,
       7,     8,     6,     6,     6,     6,     6,     4,     7,     5,
       8,     3,     1,     3,     3,     1,     1,     1,     1,     1,
       1,     1,     3,     1,     3,     3,     1,     0,     1,     3,
       7,     9,     9,     8,     3,     0,    13,     1,     3,     5,
       5,     3,     6,     2,     1,     0,     2,     0,     2,     4,
       0,     1,     0,     6,     8,     8,     1,     3,     5,     5,
       7,     9,     7,     9,     5,     6,     6,     4,     6,     4,
       6,     8,     4,     6,     4,     6,     5,     7,     1,     1,
       1,     2,     1,     2,     1,     1,     1,     3,     3,     3,
       3,     1,     1,     1,     1,     1,     2,     2,     1,     3,
       2,     1,     1,     1,     1,     1,     1,     1,     3,     1,
       2,     2,     3,     1,     3,     5,     2,     2,     0,     6,
       6,     6,     6,     6,     6,     6,     6,     8,     9,     8,
       6,     6,     9,     9,     9,     7,    10,     1,     1,     8,
       8,     8,     8,     8,     8,     8,     9,     8,     8,     2,
       0,     1,     1,     2,     2,     1,     2,     3,     3,     3,
       3,     4,     4,     3,     3,     3,     4,     4,     3,     4,
       4,     1,     1,     1,     0,     8,     8,    11,     1,     1,
       2,     4,     5,     1,     3,     2,     2,     2,     2,     2,
       1,     3,     1,     3,     1,     2,     2,     4,     3,     2,
       2,     2,     2,     2,     2,     3,     2,     2,     2,     2,
       5,     5,     5,     5,     5,     1,     3,     1,     2,     3,
       0,     6,     6,     9,     3,     0,     3,     0,     5,     2,
       0,     3,     3,     3,     7,     7,    10,     1,     1,     1,
       1,     1,     1,    16,    19,     1,     0,     1,     0,     1,
       0,     2,     0,     1,     3,     4,     5,     2,     2,     4,
       4,     0,     1,     3,     2,     0,     1,     0,     1,     1,
       0,     2,     2,     0,     9,    12,     7,     7,     2,     0,
       3,     2,     1,     3,     1,     3,     2,     1,     1,     2,
       3,     2,     1,     3,     3,     3,     2,     2,     1,     1,
       1,     1,     2,     1,     1,     1,     1,     4,     5,     1,
       3,     3,     1,     3,     3,     5,     6,     1,     3,     2,
       1,     3,     1,     0,     1,     2,     4,     5,     1,     1,
       1,     1,     3,     3,     2,     2,     1,     2,     2,     2,
       2,     1,     2,     2,     2,     2,     1,     1,     1,     3,
       2,     1,     4,     0,     3,     0,     1,     1,     3,     5,
       2,     0,     2,     1,     3,     5,     5,     5,     1,     2,
       1,     0,     4,     6,     4,     6,     4,     6,     4,     6,
       4,     6,     3,     5,     5,     5,     1,     3,     1,     3,
       2,     2,     1,     2,     1,     2,    11,    10,    10,     2,
       2,     0,     9,     2,     0,    10,    11,    11,     5,     5,
       8,     4,     4,     7,     7,     1,     1,     1,     1,     1,
       5,     5,     6,     6,     6,     6,     6,     8,     8,     6,
       6,     7,     9,     9,     8,    10,     6,     6,     6,     6,
       6,     6,     6,     8,     6,     8,     6,     8,     7,     9,
       6,     8,     7,     9,     8,    10,     8,    10,     9,    11,
       8,    10,     9,    11,     8,     8,     7,     6,     6,     6,
       6,     8,     8,     8,     8,     6,     9,     1,     0,     2,
       0,     8,     8,     8,    10,     9,     8,     1,     0,     6,
       6,     6,     6,     6,     6,     6,     9,     9,     6,     6,
       6,     8,     6,     8,     8,     8,     8,     6,     8,     6,
       8,     7,     9,     7,     9,     6,     7,     1,     3,     3,
       3,     1,     1,     1,     1,     1,     7,     6,     6,     6,
       6,     6,     6,     7,     7,     6,     9,     9,     6,     6,
       6,     6,     6,     6,     8,     8,     8,     6,     7,     6,
       6,     4,     7,     6,     4,     5,     5,     3,     4,     3,
       1,     1,     3,     5,     5,     5,     5,     8,     5,     5,
       6,     7,     7,     7,     4,     4,     5,     4,     6,    13,
       1,     1,     3,     3,     1,     1,     1,     1,     1,     1,
       1,     0,     1,     1,     1,     1,     1,     1,     0,     3,
       2,     0,     2,     2,     2,     3,     3,     3,     3,     2,
       3,     2,     5,     4,     3,     3,     3,     3,     3,     1,
       1,     0,     3,     2,     2,     1,     2,     1,     3,     2,
       1,     0,     2,     3,     0,     9,    11,    12,    14,     3,
       4,     4,     0,     2,     5,     1,     0,     1,     2,     3,
       3,     3,     1,     2,     1,     1,     1,     1,     1,     1,
       0,     5,     4,     6,     6,     4,     3,     5,     7,     9,
       1,     3,     1,     5,     4,     4,     6,     4,     6,     6,
       5,     7,     9,     6,     1,     0,     6,    11,    11,    11,
      13,     9,    11,     1,     1,    10,     4,     6,     2,     5,
       2,     0,     6,     5,     3,     5,     1,     3,     1,     1,
       2,     1,     1,     1,     1,     0,     1,     0,     1,     0,
       1,     0,     1,     0,     3,     0,     2,     1,     3,     1,
       0,     2,     4,     3,     5,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     5,     3,     0,     1,     1,
       1,     1,     1,     3,     9,    12,     3,     0,     2,     3,
       2,     3,     7,     1,     3,     1,     4,     4,     7,     2,
       1,     1,     1,     3,     2,     8,     5,     0,     4,     3,
       0,     2,     0,     7,     2,     0,     5,     3,     0,     2,
       2,     2,     3,     1,     3,     1,     2,     1,     0,     1,
       2,     0,     8,     1,     3,     3,     5,     2,     1,     3,
       9,     1,     2,     5,     5,     6,     6,     7,     2,     0,
       3,     1,     2,     5,     5,     8,     3,     4,     7,     1,
       0,     3,     2,     2,     2,     2,     0,     2,     2,     1,
       1,     3,     3,     1,     2,     4,     4,     2,     3,     5,
       5,     1,     1,     9,     9,     1,     2,     4,     4,     4,
       2,     2,     3,     1,     3,     9,     1,     2,     0,     7,
       7,     0,    10,     6,     0,     1,     0,     2,     0,     3,
       3,     4,     4,     4,     4,     3,     2,     1,     1,     0,
       1,     1,     0,     1,     5,     1,     0,     1,     1,     1,
       0,     3,     1,     3,     4,     3,     2,     2,     1,     1,
       1,     0,     2,     4,     5,     6,     4,     5,     2,     3,
       1,     1,     1,     1,     2,     2,     1,     1,     1,     1,
       1,     1,     4,     0,     1,     3,     1,     1,     1,     1,
       1,     2,     4,     4,     5,     2,     0,     1,     3,     1,
       0,     1,     2,     3,     2,     4,     2,     3,     2,     0,
       4,     5,     2,     0,     1,     3,     2,     3,     2,     3,
       2,     3,     2,     3,     1,     4,     3,     4,     5,     4,
       5,     4,     5,     2,     4,     1,     1,     0,     2,     0,
       1,     4,     5,     4,     0,     2,     2,     2,     1,     1,
       0,     5,     2,     1,     1,     2,     2,     4,     1,     3,
       1,     2,     3,     6,     4,     0,     2,     6,     2,     1,
       3,     4,     0,     2,     0,     2,     0,     2,     4,     0,
       1,     0,     1,     3,     3,     7,    12,     1,     3,     2,
       3,     3,     1,     2,     2,     2,     2,     1,     1,     3,
       3,     2,     2,     3,     5,     6,     2,     3,     3,     4,
       0,     1,     1,     1,     1,     1,     2,     4,     1,     1,
       1,     1,     2,     3,     3,     0,     1,     1,     1,     1,
       1,     2,     2,     2,     2,     2,     1,     3,     0,     1,
       1,     1,     1,     5,     2,     1,     1,     1,     1,     4,
       1,     2,     2,     1,     3,     3,     2,     1,     0,     5,
       2,     5,     2,     1,     3,     3,     0,     1,     1,     1,
       1,     1,     1,     3,     3,     3,     3,     3,     3,     3,
       0,     1,     4,     1,     3,     3,     5,     2,     2,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     2,     3,     3,     2,     2,     3,     5,     4,
       6,     3,     5,     4,     6,     4,     6,     5,     7,     3,
       2,     4,     2,     3,     3,     4,     3,     4,     3,     4,
       5,     6,     6,     7,     6,     7,     3,     4,     4,     6,
       3,     3,     4,     3,     4,     4,     5,     1,     1,     3,
       2,     2,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     2,     5,     6,     3,     4,
       1,     1,     2,     4,     1,     1,     1,     2,     2,     2,
       2,     1,     1,     4,     3,     5,     6,     8,     6,     6,
       4,     4,     1,     1,     1,     5,     1,     1,     4,     1,
       4,     1,     4,     1,     4,     1,     1,     1,     1,     1,
       1,     6,     4,     4,     6,     4,     4,     4,     4,     4,
       6,     5,     5,     5,     4,     6,     4,     4,     4,     4,
       5,     7,     7,     9,     5,     4,     6,     5,     7,     7,
       7,     2,     3,     3,     3,     4,     0,     4,     1,     3,
       3,     1,     1,     1,     2,     2,     0,     2,     3,     3,
       4,     2,     2,     5,     0,     5,     0,     2,     0,     1,
       3,     3,     2,     2,     0,     6,     1,     0,     3,     0,
       3,     3,     3,     0,     1,     4,     2,     2,     2,     2,
       2,     3,     2,     2,     3,     0,     4,     3,     5,     4,
       3,     5,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       4,     1,     4,     1,     4,     1,     2,     1,     2,     1,
       3,     1,     3,     1,     3,     3,     1,     0,     1,     3,
       3,     3,     2,     1,     3,     3,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     7,     5,
       3,     5,     5,     3,     3,     5,     3,     2,     1,     1,
       3,     5,     1,     2,     4,     2,     0,     1,     0,     1,
       2,     2,     2,     3,     5,     1,     0,     1,     2,     0,
       2,     1,     0,     1,     0,     1,     3,     3,     2,     1,
       1,     1,     3,     1,     2,     1,     3,     1,     1,     1,
       1,     2,     1,     1,     1,     1,     1,     2,     6,     2,
       3,     5,     1,     1,     1,     1,     1,     1,     2,     2,
       1,     1,     1,     1,     1,     1,     3,    10,     4,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1
};


#define yyerrok         (yyerrstatus = 0)
#define yyclearin       (yychar = YYEMPTY)
#define YYEMPTY         (-2)
#define YYEOF           0

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab


#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                  \
do                                                              \
  if (yychar == YYEMPTY)                                        \
    {                                                           \
      yychar = (Token);                                         \
      yylval = (Value);                                         \
      YYPOPSTACK (yylen);                                       \
      yystate = *yyssp;                                         \
      goto yybackup;                                            \
    }                                                           \
  else                                                          \
    {                                                           \
      yyerror (&yylloc, yyscanner, YY_("syntax error: cannot back up")); \
      YYERROR;                                                  \
    }                                                           \
while (0)

/* Error token number */
#define YYTERROR        1
#define YYERRCODE       256


/* YYLLOC_DEFAULT -- Set CURRENT to span from RHS[1] to RHS[N].
   If N is 0, then set CURRENT to the empty location which ends
   the previous symbol: RHS[0] (always defined).  */

#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)                                \
    do                                                                  \
      if (N)                                                            \
        {                                                               \
          (Current).first_line   = YYRHSLOC (Rhs, 1).first_line;        \
          (Current).first_column = YYRHSLOC (Rhs, 1).first_column;      \
          (Current).last_line    = YYRHSLOC (Rhs, N).last_line;         \
          (Current).last_column  = YYRHSLOC (Rhs, N).last_column;       \
        }                                                               \
      else                                                              \
        {                                                               \
          (Current).first_line   = (Current).last_line   =              \
            YYRHSLOC (Rhs, 0).last_line;                                \
          (Current).first_column = (Current).last_column =              \
            YYRHSLOC (Rhs, 0).last_column;                              \
        }                                                               \
    while (0)
#endif

#define YYRHSLOC(Rhs, K) ((Rhs)[K])


/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)                        \
do {                                            \
  if (yydebug)                                  \
    YYFPRINTF Args;                             \
} while (0)


/* YY_LOCATION_PRINT -- Print the location on the stream.
   This macro was not mandated originally: define only if we know
   we won't break user code: when these are the locations we know.  */

#ifndef YY_LOCATION_PRINT
# if defined YYLTYPE_IS_TRIVIAL && YYLTYPE_IS_TRIVIAL

/* Print *YYLOCP on YYO.  Private, do not rely on its existence. */

YY_ATTRIBUTE_UNUSED
static unsigned
yy_location_print_ (FILE *yyo, YYLTYPE const * const yylocp)
{
  unsigned res = 0;
  int end_col = 0 != yylocp->last_column ? yylocp->last_column - 1 : 0;
  if (0 <= yylocp->first_line)
    {
      res += YYFPRINTF (yyo, "%d", yylocp->first_line);
      if (0 <= yylocp->first_column)
        res += YYFPRINTF (yyo, ".%d", yylocp->first_column);
    }
  if (0 <= yylocp->last_line)
    {
      if (yylocp->first_line < yylocp->last_line)
        {
          res += YYFPRINTF (yyo, "-%d", yylocp->last_line);
          if (0 <= end_col)
            res += YYFPRINTF (yyo, ".%d", end_col);
        }
      else if (0 <= end_col && yylocp->first_column < end_col)
        res += YYFPRINTF (yyo, "-%d", end_col);
    }
  return res;
 }

#  define YY_LOCATION_PRINT(File, Loc)          \
  yy_location_print_ (File, &(Loc))

# else
#  define YY_LOCATION_PRINT(File, Loc) ((void) 0)
# endif
#endif


# define YY_SYMBOL_PRINT(Title, Type, Value, Location)                    \
do {                                                                      \
  if (yydebug)                                                            \
    {                                                                     \
      YYFPRINTF (stderr, "%s ", Title);                                   \
      yy_symbol_print (stderr,                                            \
                  Type, Value, Location, yyscanner); \
      YYFPRINTF (stderr, "\n");                                           \
    }                                                                     \
} while (0)


/*----------------------------------------.
| Print this symbol's value on YYOUTPUT.  |
`----------------------------------------*/

static void
yy_symbol_value_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep, YYLTYPE const * const yylocationp, core_yyscan_t yyscanner)
{
  FILE *yyo = yyoutput;
  YYUSE (yyo);
  YYUSE (yylocationp);
  YYUSE (yyscanner);
  if (!yyvaluep)
    return;
# ifdef YYPRINT
  if (yytype < YYNTOKENS)
    YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# endif
  YYUSE (yytype);
}


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

static void
yy_symbol_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep, YYLTYPE const * const yylocationp, core_yyscan_t yyscanner)
{
  YYFPRINTF (yyoutput, "%s %s (",
             yytype < YYNTOKENS ? "token" : "nterm", yytname[yytype]);

  YY_LOCATION_PRINT (yyoutput, *yylocationp);
  YYFPRINTF (yyoutput, ": ");
  yy_symbol_value_print (yyoutput, yytype, yyvaluep, yylocationp, yyscanner);
  YYFPRINTF (yyoutput, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

static void
yy_stack_print (yytype_int16 *yybottom, yytype_int16 *yytop)
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)                            \
do {                                                            \
  if (yydebug)                                                  \
    yy_stack_print ((Bottom), (Top));                           \
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

static void
yy_reduce_print (yytype_int16 *yyssp, YYSTYPE *yyvsp, YYLTYPE *yylsp, int yyrule, core_yyscan_t yyscanner)
{
  unsigned long int yylno = yyrline[yyrule];
  int yynrhs = yyr2[yyrule];
  int yyi;
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %lu):\n",
             yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr,
                       yystos[yyssp[yyi + 1 - yynrhs]],
                       &(yyvsp[(yyi + 1) - (yynrhs)])
                       , &(yylsp[(yyi + 1) - (yynrhs)])                       , yyscanner);
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)          \
do {                                    \
  if (yydebug)                          \
    yy_reduce_print (yyssp, yyvsp, yylsp, Rule, yyscanner); \
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif


#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined __GLIBC__ && defined _STRING_H
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
static YYSIZE_T
yystrlen (const char *yystr)
{
  YYSIZE_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
static char *
yystpcpy (char *yydest, const char *yysrc)
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

# ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYSIZE_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYSIZE_T yyn = 0;
      char const *yyp = yystr;

      for (;;)
        switch (*++yyp)
          {
          case '\'':
          case ',':
            goto do_not_strip_quotes;

          case '\\':
            if (*++yyp != '\\')
              goto do_not_strip_quotes;
            /* Fall through.  */
          default:
            if (yyres)
              yyres[yyn] = *yyp;
            yyn++;
            break;

          case '"':
            if (yyres)
              yyres[yyn] = '\0';
            return yyn;
          }
    do_not_strip_quotes: ;
    }

  if (! yyres)
    return yystrlen (yystr);

  return yystpcpy (yyres, yystr) - yyres;
}
# endif

/* Copy into *YYMSG, which is of size *YYMSG_ALLOC, an error message
   about the unexpected token YYTOKEN for the state stack whose top is
   YYSSP.

   Return 0 if *YYMSG was successfully written.  Return 1 if *YYMSG is
   not large enough to hold the message.  In that case, also set
   *YYMSG_ALLOC to the required number of bytes.  Return 2 if the
   required number of bytes is too large to store.  */
static int
yysyntax_error (YYSIZE_T *yymsg_alloc, char **yymsg,
                yytype_int16 *yyssp, int yytoken)
{
  YYSIZE_T yysize0 = yytnamerr (YY_NULLPTR, yytname[yytoken]);
  YYSIZE_T yysize = yysize0;
  enum { YYERROR_VERBOSE_ARGS_MAXIMUM = 5 };
  /* Internationalized format string. */
  const char *yyformat = YY_NULLPTR;
  /* Arguments of yyformat. */
  char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];
  /* Number of reported tokens (one for the "unexpected", one per
     "expected"). */
  int yycount = 0;

  /* There are many possibilities here to consider:
     - If this state is a consistent state with a default action, then
       the only way this function was invoked is if the default action
       is an error action.  In that case, don't check for expected
       tokens because there are none.
     - The only way there can be no lookahead present (in yychar) is if
       this state is a consistent state with a default action.  Thus,
       detecting the absence of a lookahead is sufficient to determine
       that there is no unexpected or expected token to report.  In that
       case, just report a simple "syntax error".
     - Don't assume there isn't a lookahead just because this state is a
       consistent state with a default action.  There might have been a
       previous inconsistent state, consistent state with a non-default
       action, or user semantic action that manipulated yychar.
     - Of course, the expected token list depends on states to have
       correct lookahead information, and it depends on the parser not
       to perform extra reductions after fetching a lookahead from the
       scanner and before detecting a syntax error.  Thus, state merging
       (from LALR or IELR) and default reductions corrupt the expected
       token list.  However, the list is correct for canonical LR with
       one exception: it will still contain any token that will not be
       accepted due to an error action in a later state.
  */
  if (yytoken != YYEMPTY)
    {
      int yyn = yypact[*yyssp];
      yyarg[yycount++] = yytname[yytoken];
      if (!yypact_value_is_default (yyn))
        {
          /* Start YYX at -YYN if negative to avoid negative indexes in
             YYCHECK.  In other words, skip the first -YYN actions for
             this state because they are default actions.  */
          int yyxbegin = yyn < 0 ? -yyn : 0;
          /* Stay within bounds of both yycheck and yytname.  */
          int yychecklim = YYLAST - yyn + 1;
          int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
          int yyx;

          for (yyx = yyxbegin; yyx < yyxend; ++yyx)
            if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR
                && !yytable_value_is_error (yytable[yyx + yyn]))
              {
                if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
                  {
                    yycount = 1;
                    yysize = yysize0;
                    break;
                  }
                yyarg[yycount++] = yytname[yyx];
                {
                  YYSIZE_T yysize1 = yysize + yytnamerr (YY_NULLPTR, yytname[yyx]);
                  if (! (yysize <= yysize1
                         && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
                    return 2;
                  yysize = yysize1;
                }
              }
        }
    }

  switch (yycount)
    {
# define YYCASE_(N, S)                      \
      case N:                               \
        yyformat = S;                       \
      break
      YYCASE_(0, YY_("syntax error"));
      YYCASE_(1, YY_("syntax error, unexpected %s"));
      YYCASE_(2, YY_("syntax error, unexpected %s, expecting %s"));
      YYCASE_(3, YY_("syntax error, unexpected %s, expecting %s or %s"));
      YYCASE_(4, YY_("syntax error, unexpected %s, expecting %s or %s or %s"));
      YYCASE_(5, YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s"));
# undef YYCASE_
    }

  {
    YYSIZE_T yysize1 = yysize + yystrlen (yyformat);
    if (! (yysize <= yysize1 && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
      return 2;
    yysize = yysize1;
  }

  if (*yymsg_alloc < yysize)
    {
      *yymsg_alloc = 2 * yysize;
      if (! (yysize <= *yymsg_alloc
             && *yymsg_alloc <= YYSTACK_ALLOC_MAXIMUM))
        *yymsg_alloc = YYSTACK_ALLOC_MAXIMUM;
      return 1;
    }

  /* Avoid sprintf, as that infringes on the user's name space.
     Don't have undefined behavior even if the translation
     produced a string with the wrong number of "%s"s.  */
  {
    char *yyp = *yymsg;
    int yyi = 0;
    while ((*yyp = *yyformat) != '\0')
      if (*yyp == '%' && yyformat[1] == 's' && yyi < yycount)
        {
          yyp += yytnamerr (yyp, yyarg[yyi++]);
          yyformat += 2;
        }
      else
        {
          yyp++;
          yyformat++;
        }
  }
  return 0;
}
#endif /* YYERROR_VERBOSE */

/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

static void
yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep, YYLTYPE *yylocationp, core_yyscan_t yyscanner)
{
  YYUSE (yyvaluep);
  YYUSE (yylocationp);
  YYUSE (yyscanner);
  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YYUSE (yytype);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}




/*----------.
| yyparse.  |
`----------*/

int
yyparse (core_yyscan_t yyscanner)
{
/* The lookahead symbol.  */
int yychar;


/* The semantic value of the lookahead symbol.  */
/* Default value used for initialization, for pacifying older GCCs
   or non-GCC compilers.  */
YY_INITIAL_VALUE (static YYSTYPE yyval_default;)
YYSTYPE yylval YY_INITIAL_VALUE (= yyval_default);

/* Location data for the lookahead symbol.  */
static YYLTYPE yyloc_default
# if defined YYLTYPE_IS_TRIVIAL && YYLTYPE_IS_TRIVIAL
  = { 1, 1, 1, 1 }
# endif
;
YYLTYPE yylloc = yyloc_default;

    /* Number of syntax errors so far.  */
    int yynerrs;

    int yystate;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus;

    /* The stacks and their tools:
       'yyss': related to states.
       'yyvs': related to semantic values.
       'yyls': related to locations.

       Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* The state stack.  */
    yytype_int16 yyssa[YYINITDEPTH];
    yytype_int16 *yyss;
    yytype_int16 *yyssp;

    /* The semantic value stack.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs;
    YYSTYPE *yyvsp;

    /* The location stack.  */
    YYLTYPE yylsa[YYINITDEPTH];
    YYLTYPE *yyls;
    YYLTYPE *yylsp;

    /* The locations where the error started and ended.  */
    YYLTYPE yyerror_range[3];

    YYSIZE_T yystacksize;

  int yyn;
  int yyresult;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken = 0;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;
  YYLTYPE yyloc;

#if YYERROR_VERBOSE
  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYSIZE_T yymsg_alloc = sizeof yymsgbuf;
#endif

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N), yylsp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  yyssp = yyss = yyssa;
  yyvsp = yyvs = yyvsa;
  yylsp = yyls = yylsa;
  yystacksize = YYINITDEPTH;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY; /* Cause a token to be read.  */
  yylsp[0] = yylloc;
  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
        /* Give user a chance to reallocate the stack.  Use copies of
           these so that the &'s don't force the real ones into
           memory.  */
        YYSTYPE *yyvs1 = yyvs;
        yytype_int16 *yyss1 = yyss;
        YYLTYPE *yyls1 = yyls;

        /* Each stack pointer address is followed by the size of the
           data in use in that stack, in bytes.  This used to be a
           conditional around just the two extra args, but that might
           be undefined if yyoverflow is a macro.  */
        yyoverflow (YY_("memory exhausted"),
                    &yyss1, yysize * sizeof (*yyssp),
                    &yyvs1, yysize * sizeof (*yyvsp),
                    &yyls1, yysize * sizeof (*yylsp),
                    &yystacksize);

        yyls = yyls1;
        yyss = yyss1;
        yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyexhaustedlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
        goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
        yystacksize = YYMAXDEPTH;

      {
        yytype_int16 *yyss1 = yyss;
        union yyalloc *yyptr =
          (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
        if (! yyptr)
          goto yyexhaustedlab;
        YYSTACK_RELOCATE (yyss_alloc, yyss);
        YYSTACK_RELOCATE (yyvs_alloc, yyvs);
        YYSTACK_RELOCATE (yyls_alloc, yyls);
#  undef YYSTACK_RELOCATE
        if (yyss1 != yyssa)
          YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;
      yylsp = yyls + yysize - 1;

      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
                  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
        YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = yylex (&yylval, &yylloc, yyscanner);
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);

  /* Discard the shifted token.  */
  yychar = YYEMPTY;

  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END
  *++yylsp = yylloc;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     '$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];

  /* Default location.  */
  YYLLOC_DEFAULT (yyloc, (yylsp - yylen), yylen);
  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 2:
#line 892 "gram.y" /* yacc.c:1646  */
    {
				pg_yyget_extra(yyscanner)->parsetree = (yyvsp[0].list);
			}
#line 28349 "gram.c" /* yacc.c:1646  */
    break;

  case 3:
#line 896 "gram.y" /* yacc.c:1646  */
    {
				pg_yyget_extra(yyscanner)->parsetree = list_make1((yyvsp[0].typnam));
			}
#line 28357 "gram.c" /* yacc.c:1646  */
    break;

  case 4:
#line 900 "gram.y" /* yacc.c:1646  */
    {
				pg_yyget_extra(yyscanner)->parsetree =
					list_make1(makeRawStmt((yyvsp[0].node), 0));
			}
#line 28366 "gram.c" /* yacc.c:1646  */
    break;

  case 5:
#line 905 "gram.y" /* yacc.c:1646  */
    {
				PLAssignStmt *n = (PLAssignStmt *) (yyvsp[0].node);

				n->nnames = 1;
				pg_yyget_extra(yyscanner)->parsetree =
					list_make1(makeRawStmt((Node *) n, 0));
			}
#line 28378 "gram.c" /* yacc.c:1646  */
    break;

  case 6:
#line 913 "gram.y" /* yacc.c:1646  */
    {
				PLAssignStmt *n = (PLAssignStmt *) (yyvsp[0].node);

				n->nnames = 2;
				pg_yyget_extra(yyscanner)->parsetree =
					list_make1(makeRawStmt((Node *) n, 0));
			}
#line 28390 "gram.c" /* yacc.c:1646  */
    break;

  case 7:
#line 921 "gram.y" /* yacc.c:1646  */
    {
				PLAssignStmt *n = (PLAssignStmt *) (yyvsp[0].node);

				n->nnames = 3;
				pg_yyget_extra(yyscanner)->parsetree =
					list_make1(makeRawStmt((Node *) n, 0));
			}
#line 28402 "gram.c" /* yacc.c:1646  */
    break;

  case 8:
#line 941 "gram.y" /* yacc.c:1646  */
    {
					if ((yyvsp[-2].list) != NIL)
					{
						/* update length of previous stmt */
						updateRawStmtEnd(llast_node(RawStmt, (yyvsp[-2].list)), (yylsp[-1]));
					}
					if ((yyvsp[0].node) != NULL)
						(yyval.list) = lappend((yyvsp[-2].list), makeRawStmt((yyvsp[0].node), (yylsp[-1]) + 1));
					else
						(yyval.list) = (yyvsp[-2].list);
				}
#line 28418 "gram.c" /* yacc.c:1646  */
    break;

  case 9:
#line 953 "gram.y" /* yacc.c:1646  */
    {
					if ((yyvsp[0].node) != NULL)
						(yyval.list) = list_make1(makeRawStmt((yyvsp[0].node), 0));
					else
						(yyval.list) = NIL;
				}
#line 28429 "gram.c" /* yacc.c:1646  */
    break;

  case 136:
#line 1096 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 28435 "gram.c" /* yacc.c:1646  */
    break;

  case 137:
#line 1106 "gram.y" /* yacc.c:1646  */
    {
					CallStmt   *n = makeNode(CallStmt);

					n->funccall = castNode(FuncCall, (yyvsp[0].node));
					(yyval.node) = (Node *) n;
				}
#line 28446 "gram.c" /* yacc.c:1646  */
    break;

  case 138:
#line 1122 "gram.y" /* yacc.c:1646  */
    {
					CreateRoleStmt *n = makeNode(CreateRoleStmt);

					n->stmt_type = ROLESTMT_ROLE;
					n->role = (yyvsp[-2].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 28459 "gram.c" /* yacc.c:1646  */
    break;

  case 142:
#line 1144 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].defelt)); }
#line 28465 "gram.c" /* yacc.c:1646  */
    break;

  case 143:
#line 1145 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 28471 "gram.c" /* yacc.c:1646  */
    break;

  case 144:
#line 1149 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].defelt)); }
#line 28477 "gram.c" /* yacc.c:1646  */
    break;

  case 145:
#line 1150 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 28483 "gram.c" /* yacc.c:1646  */
    break;

  case 146:
#line 1155 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("password",
									 (Node *) makeString((yyvsp[0].str)), (yylsp[-1]));
				}
#line 28492 "gram.c" /* yacc.c:1646  */
    break;

  case 147:
#line 1160 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("password", NULL, (yylsp[-1]));
				}
#line 28500 "gram.c" /* yacc.c:1646  */
    break;

  case 148:
#line 1164 "gram.y" /* yacc.c:1646  */
    {
					/*
					 * These days, passwords are always stored in encrypted
					 * form, so there is no difference between PASSWORD and
					 * ENCRYPTED PASSWORD.
					 */
					(yyval.defelt) = makeDefElem("password",
									 (Node *) makeString((yyvsp[0].str)), (yylsp[-2]));
				}
#line 28514 "gram.c" /* yacc.c:1646  */
    break;

  case 149:
#line 1174 "gram.y" /* yacc.c:1646  */
    {
					ereport(ERROR,
							(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
							 errmsg("UNENCRYPTED PASSWORD is no longer supported"),
							 errhint("Remove UNENCRYPTED to store the password in encrypted form instead."),
							 parser_errposition((yylsp[-2]))));
				}
#line 28526 "gram.c" /* yacc.c:1646  */
    break;

  case 150:
#line 1182 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("inherit", (Node *) makeBoolean(true), (yylsp[0]));
				}
#line 28534 "gram.c" /* yacc.c:1646  */
    break;

  case 151:
#line 1186 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("connectionlimit", (Node *) makeInteger((yyvsp[0].ival)), (yylsp[-2]));
				}
#line 28542 "gram.c" /* yacc.c:1646  */
    break;

  case 152:
#line 1190 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("validUntil", (Node *) makeString((yyvsp[0].str)), (yylsp[-2]));
				}
#line 28550 "gram.c" /* yacc.c:1646  */
    break;

  case 153:
#line 1195 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("rolemembers", (Node *) (yyvsp[0].list), (yylsp[-1]));
				}
#line 28558 "gram.c" /* yacc.c:1646  */
    break;

  case 154:
#line 1199 "gram.y" /* yacc.c:1646  */
    {
					/*
					 * We handle identifiers that aren't parser keywords with
					 * the following special-case codes, to avoid bloating the
					 * size of the main parser.
					 */
					if (strcmp((yyvsp[0].str), "superuser") == 0)
						(yyval.defelt) = makeDefElem("superuser", (Node *) makeBoolean(true), (yylsp[0]));
					else if (strcmp((yyvsp[0].str), "nosuperuser") == 0)
						(yyval.defelt) = makeDefElem("superuser", (Node *) makeBoolean(false), (yylsp[0]));
					else if (strcmp((yyvsp[0].str), "createrole") == 0)
						(yyval.defelt) = makeDefElem("createrole", (Node *) makeBoolean(true), (yylsp[0]));
					else if (strcmp((yyvsp[0].str), "nocreaterole") == 0)
						(yyval.defelt) = makeDefElem("createrole", (Node *) makeBoolean(false), (yylsp[0]));
					else if (strcmp((yyvsp[0].str), "replication") == 0)
						(yyval.defelt) = makeDefElem("isreplication", (Node *) makeBoolean(true), (yylsp[0]));
					else if (strcmp((yyvsp[0].str), "noreplication") == 0)
						(yyval.defelt) = makeDefElem("isreplication", (Node *) makeBoolean(false), (yylsp[0]));
					else if (strcmp((yyvsp[0].str), "createdb") == 0)
						(yyval.defelt) = makeDefElem("createdb", (Node *) makeBoolean(true), (yylsp[0]));
					else if (strcmp((yyvsp[0].str), "nocreatedb") == 0)
						(yyval.defelt) = makeDefElem("createdb", (Node *) makeBoolean(false), (yylsp[0]));
					else if (strcmp((yyvsp[0].str), "login") == 0)
						(yyval.defelt) = makeDefElem("canlogin", (Node *) makeBoolean(true), (yylsp[0]));
					else if (strcmp((yyvsp[0].str), "nologin") == 0)
						(yyval.defelt) = makeDefElem("canlogin", (Node *) makeBoolean(false), (yylsp[0]));
					else if (strcmp((yyvsp[0].str), "bypassrls") == 0)
						(yyval.defelt) = makeDefElem("bypassrls", (Node *) makeBoolean(true), (yylsp[0]));
					else if (strcmp((yyvsp[0].str), "nobypassrls") == 0)
						(yyval.defelt) = makeDefElem("bypassrls", (Node *) makeBoolean(false), (yylsp[0]));
					else if (strcmp((yyvsp[0].str), "noinherit") == 0)
					{
						/*
						 * Note that INHERIT is a keyword, so it's handled by main parser, but
						 * NOINHERIT is handled here.
						 */
						(yyval.defelt) = makeDefElem("inherit", (Node *) makeBoolean(false), (yylsp[0]));
					}
					else
						ereport(ERROR,
								(errcode(ERRCODE_SYNTAX_ERROR),
								 errmsg("unrecognized role option \"%s\"", (yyvsp[0].str)),
									 parser_errposition((yylsp[0]))));
				}
#line 28607 "gram.c" /* yacc.c:1646  */
    break;

  case 155:
#line 1246 "gram.y" /* yacc.c:1646  */
    { (yyval.defelt) = (yyvsp[0].defelt); }
#line 28613 "gram.c" /* yacc.c:1646  */
    break;

  case 156:
#line 1249 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("sysid", (Node *) makeInteger((yyvsp[0].ival)), (yylsp[-1]));
				}
#line 28621 "gram.c" /* yacc.c:1646  */
    break;

  case 157:
#line 1253 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("adminmembers", (Node *) (yyvsp[0].list), (yylsp[-1]));
				}
#line 28629 "gram.c" /* yacc.c:1646  */
    break;

  case 158:
#line 1257 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("rolemembers", (Node *) (yyvsp[0].list), (yylsp[-1]));
				}
#line 28637 "gram.c" /* yacc.c:1646  */
    break;

  case 159:
#line 1261 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("addroleto", (Node *) (yyvsp[0].list), (yylsp[-2]));
				}
#line 28645 "gram.c" /* yacc.c:1646  */
    break;

  case 160:
#line 1265 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("addroleto", (Node *) (yyvsp[0].list), (yylsp[-2]));
				}
#line 28653 "gram.c" /* yacc.c:1646  */
    break;

  case 161:
#line 1279 "gram.y" /* yacc.c:1646  */
    {
					CreateRoleStmt *n = makeNode(CreateRoleStmt);

					n->stmt_type = ROLESTMT_USER;
					n->role = (yyvsp[-2].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 28666 "gram.c" /* yacc.c:1646  */
    break;

  case 162:
#line 1298 "gram.y" /* yacc.c:1646  */
    {
					AlterRoleStmt *n = makeNode(AlterRoleStmt);

					n->role = (yyvsp[-2].rolespec);
					n->action = +1;	/* add, if there are members */
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				 }
#line 28679 "gram.c" /* yacc.c:1646  */
    break;

  case 163:
#line 1307 "gram.y" /* yacc.c:1646  */
    {
					AlterRoleStmt *n = makeNode(AlterRoleStmt);

					n->role = (yyvsp[-2].rolespec);
					n->action = +1;	/* add, if there are members */
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				 }
#line 28692 "gram.c" /* yacc.c:1646  */
    break;

  case 164:
#line 1318 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = NULL; }
#line 28698 "gram.c" /* yacc.c:1646  */
    break;

  case 165:
#line 1319 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 28704 "gram.c" /* yacc.c:1646  */
    break;

  case 166:
#line 1324 "gram.y" /* yacc.c:1646  */
    {
					AlterRoleSetStmt *n = makeNode(AlterRoleSetStmt);

					n->role = (yyvsp[-2].rolespec);
					n->database = (yyvsp[-1].str);
					n->setstmt = (yyvsp[0].vsetstmt);
					(yyval.node) = (Node *) n;
				}
#line 28717 "gram.c" /* yacc.c:1646  */
    break;

  case 167:
#line 1333 "gram.y" /* yacc.c:1646  */
    {
					AlterRoleSetStmt *n = makeNode(AlterRoleSetStmt);

					n->role = NULL;
					n->database = (yyvsp[-1].str);
					n->setstmt = (yyvsp[0].vsetstmt);
					(yyval.node) = (Node *) n;
				}
#line 28730 "gram.c" /* yacc.c:1646  */
    break;

  case 168:
#line 1342 "gram.y" /* yacc.c:1646  */
    {
					AlterRoleSetStmt *n = makeNode(AlterRoleSetStmt);

					n->role = (yyvsp[-2].rolespec);
					n->database = (yyvsp[-1].str);
					n->setstmt = (yyvsp[0].vsetstmt);
					(yyval.node) = (Node *) n;
				}
#line 28743 "gram.c" /* yacc.c:1646  */
    break;

  case 169:
#line 1351 "gram.y" /* yacc.c:1646  */
    {
					AlterRoleSetStmt *n = makeNode(AlterRoleSetStmt);

					n->role = NULL;
					n->database = (yyvsp[-1].str);
					n->setstmt = (yyvsp[0].vsetstmt);
					(yyval.node) = (Node *) n;
				}
#line 28756 "gram.c" /* yacc.c:1646  */
    break;

  case 170:
#line 1373 "gram.y" /* yacc.c:1646  */
    {
					DropRoleStmt *n = makeNode(DropRoleStmt);

					n->missing_ok = false;
					n->roles = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 28768 "gram.c" /* yacc.c:1646  */
    break;

  case 171:
#line 1381 "gram.y" /* yacc.c:1646  */
    {
					DropRoleStmt *n = makeNode(DropRoleStmt);

					n->missing_ok = true;
					n->roles = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 28780 "gram.c" /* yacc.c:1646  */
    break;

  case 172:
#line 1389 "gram.y" /* yacc.c:1646  */
    {
					DropRoleStmt *n = makeNode(DropRoleStmt);

					n->missing_ok = false;
					n->roles = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 28792 "gram.c" /* yacc.c:1646  */
    break;

  case 173:
#line 1397 "gram.y" /* yacc.c:1646  */
    {
					DropRoleStmt *n = makeNode(DropRoleStmt);

					n->roles = (yyvsp[0].list);
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 28804 "gram.c" /* yacc.c:1646  */
    break;

  case 174:
#line 1405 "gram.y" /* yacc.c:1646  */
    {
					DropRoleStmt *n = makeNode(DropRoleStmt);

					n->missing_ok = false;
					n->roles = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 28816 "gram.c" /* yacc.c:1646  */
    break;

  case 175:
#line 1413 "gram.y" /* yacc.c:1646  */
    {
					DropRoleStmt *n = makeNode(DropRoleStmt);

					n->missing_ok = true;
					n->roles = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 28828 "gram.c" /* yacc.c:1646  */
    break;

  case 176:
#line 1431 "gram.y" /* yacc.c:1646  */
    {
					CreateRoleStmt *n = makeNode(CreateRoleStmt);

					n->stmt_type = ROLESTMT_GROUP;
					n->role = (yyvsp[-2].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 28841 "gram.c" /* yacc.c:1646  */
    break;

  case 177:
#line 1450 "gram.y" /* yacc.c:1646  */
    {
					AlterRoleStmt *n = makeNode(AlterRoleStmt);

					n->role = (yyvsp[-3].rolespec);
					n->action = (yyvsp[-2].ival);
					n->options = list_make1(makeDefElem("rolemembers",
														(Node *) (yyvsp[0].list), (yylsp[0])));
					(yyval.node) = (Node *) n;
				}
#line 28855 "gram.c" /* yacc.c:1646  */
    break;

  case 178:
#line 1461 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = +1; }
#line 28861 "gram.c" /* yacc.c:1646  */
    break;

  case 179:
#line 1462 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = -1; }
#line 28867 "gram.c" /* yacc.c:1646  */
    break;

  case 180:
#line 1474 "gram.y" /* yacc.c:1646  */
    {
					CreateSchemaStmt *n = makeNode(CreateSchemaStmt);

					/* One can omit the schema name or the authorization id. */
					n->schemaname = (yyvsp[-3].str);
					n->authrole = (yyvsp[-1].rolespec);
					n->schemaElts = (yyvsp[0].list);
					n->if_not_exists = false;
					(yyval.node) = (Node *) n;
				}
#line 28882 "gram.c" /* yacc.c:1646  */
    break;

  case 181:
#line 1485 "gram.y" /* yacc.c:1646  */
    {
					CreateSchemaStmt *n = makeNode(CreateSchemaStmt);

					/* ...but not both */
					n->schemaname = (yyvsp[-1].str);
					n->authrole = NULL;
					n->schemaElts = (yyvsp[0].list);
					n->if_not_exists = false;
					(yyval.node) = (Node *) n;
				}
#line 28897 "gram.c" /* yacc.c:1646  */
    break;

  case 182:
#line 1496 "gram.y" /* yacc.c:1646  */
    {
					CreateSchemaStmt *n = makeNode(CreateSchemaStmt);

					/* schema name can be omitted here, too */
					n->schemaname = (yyvsp[-3].str);
					n->authrole = (yyvsp[-1].rolespec);
					if ((yyvsp[0].list) != NIL)
						ereport(ERROR,
								(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
								 errmsg("CREATE SCHEMA IF NOT EXISTS cannot include schema elements"),
								 parser_errposition((yylsp[0]))));
					n->schemaElts = (yyvsp[0].list);
					n->if_not_exists = true;
					(yyval.node) = (Node *) n;
				}
#line 28917 "gram.c" /* yacc.c:1646  */
    break;

  case 183:
#line 1512 "gram.y" /* yacc.c:1646  */
    {
					CreateSchemaStmt *n = makeNode(CreateSchemaStmt);

					/* ...but not here */
					n->schemaname = (yyvsp[-1].str);
					n->authrole = NULL;
					if ((yyvsp[0].list) != NIL)
						ereport(ERROR,
								(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
								 errmsg("CREATE SCHEMA IF NOT EXISTS cannot include schema elements"),
								 parser_errposition((yylsp[0]))));
					n->schemaElts = (yyvsp[0].list);
					n->if_not_exists = true;
					(yyval.node) = (Node *) n;
				}
#line 28937 "gram.c" /* yacc.c:1646  */
    break;

  case 184:
#line 1530 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 28943 "gram.c" /* yacc.c:1646  */
    break;

  case 185:
#line 1531 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = NULL; }
#line 28949 "gram.c" /* yacc.c:1646  */
    break;

  case 186:
#line 1536 "gram.y" /* yacc.c:1646  */
    {
					if ((yyloc) < 0)			/* see comments for YYLLOC_DEFAULT */
						(yyloc) = (yylsp[0]);
					(yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].node));
				}
#line 28959 "gram.c" /* yacc.c:1646  */
    break;

  case 187:
#line 1542 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 28965 "gram.c" /* yacc.c:1646  */
    break;

  case 194:
#line 1570 "gram.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = (yyvsp[0].vsetstmt);
					n->type = T_PgpoolVariableSetStmt; /* Hack to keep changes minimum */
					n->is_local = false;
					(yyval.node) = (Node *) n;
				}
#line 28976 "gram.c" /* yacc.c:1646  */
    break;

  case 195:
#line 1577 "gram.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = (yyvsp[0].vsetstmt);

					n->is_local = false;
					(yyval.node) = (Node *) n;
				}
#line 28987 "gram.c" /* yacc.c:1646  */
    break;

  case 196:
#line 1584 "gram.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = (yyvsp[0].vsetstmt);

					n->is_local = true;
					(yyval.node) = (Node *) n;
				}
#line 28998 "gram.c" /* yacc.c:1646  */
    break;

  case 197:
#line 1591 "gram.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = (yyvsp[0].vsetstmt);

					n->is_local = false;
					(yyval.node) = (Node *) n;
				}
#line 29009 "gram.c" /* yacc.c:1646  */
    break;

  case 198:
#line 1601 "gram.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);

					n->kind = VAR_SET_MULTI;
					n->name = "TRANSACTION";
					n->args = (yyvsp[0].list);
					(yyval.vsetstmt) = n;
				}
#line 29022 "gram.c" /* yacc.c:1646  */
    break;

  case 199:
#line 1610 "gram.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);

					n->kind = VAR_SET_MULTI;
					n->name = "SESSION CHARACTERISTICS";
					n->args = (yyvsp[0].list);
					(yyval.vsetstmt) = n;
				}
#line 29035 "gram.c" /* yacc.c:1646  */
    break;

  case 201:
#line 1623 "gram.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);

					n->kind = VAR_SET_VALUE;
					n->name = (yyvsp[-2].str);
					n->args = (yyvsp[0].list);
					(yyval.vsetstmt) = n;
				}
#line 29048 "gram.c" /* yacc.c:1646  */
    break;

  case 202:
#line 1632 "gram.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);

					n->kind = VAR_SET_VALUE;
					n->name = (yyvsp[-2].str);
					n->args = (yyvsp[0].list);
					(yyval.vsetstmt) = n;
				}
#line 29061 "gram.c" /* yacc.c:1646  */
    break;

  case 203:
#line 1641 "gram.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);

					n->kind = VAR_SET_DEFAULT;
					n->name = (yyvsp[-2].str);
					(yyval.vsetstmt) = n;
				}
#line 29073 "gram.c" /* yacc.c:1646  */
    break;

  case 204:
#line 1649 "gram.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);

					n->kind = VAR_SET_DEFAULT;
					n->name = (yyvsp[-2].str);
					(yyval.vsetstmt) = n;
				}
#line 29085 "gram.c" /* yacc.c:1646  */
    break;

  case 205:
#line 1659 "gram.y" /* yacc.c:1646  */
    {(yyval.vsetstmt) = (yyvsp[0].vsetstmt);}
#line 29091 "gram.c" /* yacc.c:1646  */
    break;

  case 206:
#line 1661 "gram.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);

					n->kind = VAR_SET_CURRENT;
					n->name = (yyvsp[-2].str);
					(yyval.vsetstmt) = n;
				}
#line 29103 "gram.c" /* yacc.c:1646  */
    break;

  case 207:
#line 1670 "gram.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);

					n->kind = VAR_SET_VALUE;
					n->name = "timezone";
					if ((yyvsp[0].node) != NULL)
						n->args = list_make1((yyvsp[0].node));
					else
						n->kind = VAR_SET_DEFAULT;
					(yyval.vsetstmt) = n;
				}
#line 29119 "gram.c" /* yacc.c:1646  */
    break;

  case 208:
#line 1682 "gram.y" /* yacc.c:1646  */
    {
					ereport(ERROR,
							(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
							 errmsg("current database cannot be changed"),
							 parser_errposition((yylsp[0]))));
					(yyval.vsetstmt) = NULL; /*not reached*/
				}
#line 29131 "gram.c" /* yacc.c:1646  */
    break;

  case 209:
#line 1690 "gram.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);

					n->kind = VAR_SET_VALUE;
					n->name = "search_path";
					n->args = list_make1(makeStringConst((yyvsp[0].str), (yylsp[0])));
					(yyval.vsetstmt) = n;
				}
#line 29144 "gram.c" /* yacc.c:1646  */
    break;

  case 210:
#line 1699 "gram.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);

					n->kind = VAR_SET_VALUE;
					n->name = "client_encoding";
					if ((yyvsp[0].str) != NULL)
						n->args = list_make1(makeStringConst((yyvsp[0].str), (yylsp[0])));
					else
						n->kind = VAR_SET_DEFAULT;
					(yyval.vsetstmt) = n;
				}
#line 29160 "gram.c" /* yacc.c:1646  */
    break;

  case 211:
#line 1711 "gram.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);

					n->kind = VAR_SET_VALUE;
					n->name = "role";
					n->args = list_make1(makeStringConst((yyvsp[0].str), (yylsp[0])));
					(yyval.vsetstmt) = n;
				}
#line 29173 "gram.c" /* yacc.c:1646  */
    break;

  case 212:
#line 1720 "gram.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);

					n->kind = VAR_SET_VALUE;
					n->name = "session_authorization";
					n->args = list_make1(makeStringConst((yyvsp[0].str), (yylsp[0])));
					(yyval.vsetstmt) = n;
				}
#line 29186 "gram.c" /* yacc.c:1646  */
    break;

  case 213:
#line 1729 "gram.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);

					n->kind = VAR_SET_DEFAULT;
					n->name = "session_authorization";
					(yyval.vsetstmt) = n;
				}
#line 29198 "gram.c" /* yacc.c:1646  */
    break;

  case 214:
#line 1737 "gram.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);

					n->kind = VAR_SET_VALUE;
					n->name = "xmloption";
					n->args = list_make1(makeStringConst((yyvsp[0].ival) == XMLOPTION_DOCUMENT ? "DOCUMENT" : "CONTENT", (yylsp[0])));
					(yyval.vsetstmt) = n;
				}
#line 29211 "gram.c" /* yacc.c:1646  */
    break;

  case 215:
#line 1747 "gram.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);

					n->kind = VAR_SET_MULTI;
					n->name = "TRANSACTION SNAPSHOT";
					n->args = list_make1(makeStringConst((yyvsp[0].str), (yylsp[0])));
					(yyval.vsetstmt) = n;
				}
#line 29224 "gram.c" /* yacc.c:1646  */
    break;

  case 216:
#line 1757 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 29230 "gram.c" /* yacc.c:1646  */
    break;

  case 217:
#line 1759 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = psprintf("%s.%s", (yyvsp[-2].str), (yyvsp[0].str)); }
#line 29236 "gram.c" /* yacc.c:1646  */
    break;

  case 218:
#line 1762 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 29242 "gram.c" /* yacc.c:1646  */
    break;

  case 219:
#line 1763 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node)); }
#line 29248 "gram.c" /* yacc.c:1646  */
    break;

  case 220:
#line 1767 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = makeStringConst((yyvsp[0].str), (yylsp[0])); }
#line 29254 "gram.c" /* yacc.c:1646  */
    break;

  case 221:
#line 1769 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = makeAConst((yyvsp[0].node), (yylsp[0])); }
#line 29260 "gram.c" /* yacc.c:1646  */
    break;

  case 222:
#line 1772 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "read uncommitted"; }
#line 29266 "gram.c" /* yacc.c:1646  */
    break;

  case 223:
#line 1773 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "read committed"; }
#line 29272 "gram.c" /* yacc.c:1646  */
    break;

  case 224:
#line 1774 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "repeatable read"; }
#line 29278 "gram.c" /* yacc.c:1646  */
    break;

  case 225:
#line 1775 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "serializable"; }
#line 29284 "gram.c" /* yacc.c:1646  */
    break;

  case 226:
#line 1779 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "true"; }
#line 29290 "gram.c" /* yacc.c:1646  */
    break;

  case 227:
#line 1780 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "false"; }
#line 29296 "gram.c" /* yacc.c:1646  */
    break;

  case 228:
#line 1781 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "on"; }
#line 29302 "gram.c" /* yacc.c:1646  */
    break;

  case 229:
#line 1787 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 29308 "gram.c" /* yacc.c:1646  */
    break;

  case 230:
#line 1800 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeStringConst((yyvsp[0].str), (yylsp[0]));
				}
#line 29316 "gram.c" /* yacc.c:1646  */
    break;

  case 231:
#line 1804 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeStringConst((yyvsp[0].str), (yylsp[0]));
				}
#line 29324 "gram.c" /* yacc.c:1646  */
    break;

  case 232:
#line 1808 "gram.y" /* yacc.c:1646  */
    {
					TypeName   *t = (yyvsp[-2].typnam);

					if ((yyvsp[0].list) != NIL)
					{
						A_Const    *n = (A_Const *) linitial((yyvsp[0].list));

						if ((n->val.ival.ival & ~(INTERVAL_MASK(HOUR) | INTERVAL_MASK(MINUTE))) != 0)
							ereport(ERROR,
									(errcode(ERRCODE_SYNTAX_ERROR),
									 errmsg("time zone interval must be HOUR or HOUR TO MINUTE"),
									 parser_errposition((yylsp[0]))));
					}
					t->typmods = (yyvsp[0].list);
					(yyval.node) = makeStringConstCast((yyvsp[-1].str), (yylsp[-1]), t);
				}
#line 29345 "gram.c" /* yacc.c:1646  */
    break;

  case 233:
#line 1825 "gram.y" /* yacc.c:1646  */
    {
					TypeName   *t = (yyvsp[-4].typnam);

					t->typmods = list_make2(makeIntConst(INTERVAL_FULL_RANGE, -1),
											makeIntConst((yyvsp[-2].ival), (yylsp[-2])));
					(yyval.node) = makeStringConstCast((yyvsp[0].str), (yylsp[0]), t);
				}
#line 29357 "gram.c" /* yacc.c:1646  */
    break;

  case 234:
#line 1832 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = makeAConst((yyvsp[0].node), (yylsp[0])); }
#line 29363 "gram.c" /* yacc.c:1646  */
    break;

  case 235:
#line 1833 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 29369 "gram.c" /* yacc.c:1646  */
    break;

  case 236:
#line 1834 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 29375 "gram.c" /* yacc.c:1646  */
    break;

  case 237:
#line 1838 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 29381 "gram.c" /* yacc.c:1646  */
    break;

  case 238:
#line 1839 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = NULL; }
#line 29387 "gram.c" /* yacc.c:1646  */
    break;

  case 239:
#line 1840 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = NULL; }
#line 29393 "gram.c" /* yacc.c:1646  */
    break;

  case 240:
#line 1844 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 29399 "gram.c" /* yacc.c:1646  */
    break;

  case 241:
#line 1845 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 29405 "gram.c" /* yacc.c:1646  */
    break;

  case 242:
#line 1849 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) (yyvsp[0].vsetstmt); }
#line 29411 "gram.c" /* yacc.c:1646  */
    break;

  case 243:
#line 1851 "gram.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = (yyvsp[0].vsetstmt);
					n->type = T_PgpoolVariableSetStmt; /* Hack to keep the changes minimum */
					(yyval.node) = (Node *) n;
				}
#line 29421 "gram.c" /* yacc.c:1646  */
    break;

  case 244:
#line 1859 "gram.y" /* yacc.c:1646  */
    { (yyval.vsetstmt) = (yyvsp[0].vsetstmt); }
#line 29427 "gram.c" /* yacc.c:1646  */
    break;

  case 245:
#line 1861 "gram.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);

					n->kind = VAR_RESET;
					n->name = "timezone";
					(yyval.vsetstmt) = n;
				}
#line 29439 "gram.c" /* yacc.c:1646  */
    break;

  case 246:
#line 1869 "gram.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);

					n->kind = VAR_RESET;
					n->name = "transaction_isolation";
					(yyval.vsetstmt) = n;
				}
#line 29451 "gram.c" /* yacc.c:1646  */
    break;

  case 247:
#line 1877 "gram.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);

					n->kind = VAR_RESET;
					n->name = "session_authorization";
					(yyval.vsetstmt) = n;
				}
#line 29463 "gram.c" /* yacc.c:1646  */
    break;

  case 248:
#line 1888 "gram.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);

					n->kind = VAR_RESET;
					n->name = (yyvsp[0].str);
					(yyval.vsetstmt) = n;
				}
#line 29475 "gram.c" /* yacc.c:1646  */
    break;

  case 249:
#line 1896 "gram.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);

					n->kind = VAR_RESET_ALL;
					(yyval.vsetstmt) = n;
				}
#line 29486 "gram.c" /* yacc.c:1646  */
    break;

  case 250:
#line 1906 "gram.y" /* yacc.c:1646  */
    { (yyval.vsetstmt) = (yyvsp[0].vsetstmt); }
#line 29492 "gram.c" /* yacc.c:1646  */
    break;

  case 251:
#line 1907 "gram.y" /* yacc.c:1646  */
    { (yyval.vsetstmt) = (VariableSetStmt *) (yyvsp[0].node); }
#line 29498 "gram.c" /* yacc.c:1646  */
    break;

  case 252:
#line 1912 "gram.y" /* yacc.c:1646  */
    { (yyval.vsetstmt) = (yyvsp[0].vsetstmt); }
#line 29504 "gram.c" /* yacc.c:1646  */
    break;

  case 253:
#line 1913 "gram.y" /* yacc.c:1646  */
    { (yyval.vsetstmt) = (VariableSetStmt *) (yyvsp[0].node); }
#line 29510 "gram.c" /* yacc.c:1646  */
    break;

  case 254:
#line 1920 "gram.y" /* yacc.c:1646  */
    {
				VariableShowStmt *n = (VariableShowStmt *)newNode(sizeof(VariableShowStmt),T_PgpoolVariableShowStmt);
				n->name = (yyvsp[0].str);
				(yyval.node) = (Node *) n;
			}
#line 29520 "gram.c" /* yacc.c:1646  */
    break;

  case 255:
#line 1926 "gram.y" /* yacc.c:1646  */
    {
				VariableShowStmt *n = (VariableShowStmt *)newNode(sizeof(VariableShowStmt),T_PgpoolVariableShowStmt);
				n->name = "all";
				(yyval.node) = (Node *) n;
			}
#line 29530 "gram.c" /* yacc.c:1646  */
    break;

  case 256:
#line 1932 "gram.y" /* yacc.c:1646  */
    {
					VariableShowStmt *n = makeNode(VariableShowStmt);

					n->name = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 29541 "gram.c" /* yacc.c:1646  */
    break;

  case 257:
#line 1939 "gram.y" /* yacc.c:1646  */
    {
					VariableShowStmt *n = makeNode(VariableShowStmt);

					n->name = "timezone";
					(yyval.node) = (Node *) n;
				}
#line 29552 "gram.c" /* yacc.c:1646  */
    break;

  case 258:
#line 1946 "gram.y" /* yacc.c:1646  */
    {
					VariableShowStmt *n = makeNode(VariableShowStmt);

					n->name = "transaction_isolation";
					(yyval.node) = (Node *) n;
				}
#line 29563 "gram.c" /* yacc.c:1646  */
    break;

  case 259:
#line 1953 "gram.y" /* yacc.c:1646  */
    {
					VariableShowStmt *n = makeNode(VariableShowStmt);

					n->name = "session_authorization";
					(yyval.node) = (Node *) n;
				}
#line 29574 "gram.c" /* yacc.c:1646  */
    break;

  case 260:
#line 1960 "gram.y" /* yacc.c:1646  */
    {
					VariableShowStmt *n = makeNode(VariableShowStmt);

					n->name = "all";
					(yyval.node) = (Node *) n;
				}
#line 29585 "gram.c" /* yacc.c:1646  */
    break;

  case 261:
#line 1971 "gram.y" /* yacc.c:1646  */
    {
					ConstraintsSetStmt *n = makeNode(ConstraintsSetStmt);

					n->constraints = (yyvsp[-1].list);
					n->deferred = (yyvsp[0].boolean);
					(yyval.node) = (Node *) n;
				}
#line 29597 "gram.c" /* yacc.c:1646  */
    break;

  case 262:
#line 1981 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 29603 "gram.c" /* yacc.c:1646  */
    break;

  case 263:
#line 1982 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 29609 "gram.c" /* yacc.c:1646  */
    break;

  case 264:
#line 1986 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 29615 "gram.c" /* yacc.c:1646  */
    break;

  case 265:
#line 1987 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 29621 "gram.c" /* yacc.c:1646  */
    break;

  case 266:
#line 1996 "gram.y" /* yacc.c:1646  */
    {
					CheckPointStmt *n = makeNode(CheckPointStmt);

					(yyval.node) = (Node *) n;
				}
#line 29631 "gram.c" /* yacc.c:1646  */
    break;

  case 267:
#line 2012 "gram.y" /* yacc.c:1646  */
    {
					DiscardStmt *n = makeNode(DiscardStmt);

					n->target = DISCARD_ALL;
					(yyval.node) = (Node *) n;
				}
#line 29642 "gram.c" /* yacc.c:1646  */
    break;

  case 268:
#line 2019 "gram.y" /* yacc.c:1646  */
    {
					DiscardStmt *n = makeNode(DiscardStmt);

					n->target = DISCARD_TEMP;
					(yyval.node) = (Node *) n;
				}
#line 29653 "gram.c" /* yacc.c:1646  */
    break;

  case 269:
#line 2026 "gram.y" /* yacc.c:1646  */
    {
					DiscardStmt *n = makeNode(DiscardStmt);

					n->target = DISCARD_TEMP;
					(yyval.node) = (Node *) n;
				}
#line 29664 "gram.c" /* yacc.c:1646  */
    break;

  case 270:
#line 2033 "gram.y" /* yacc.c:1646  */
    {
					DiscardStmt *n = makeNode(DiscardStmt);

					n->target = DISCARD_PLANS;
					(yyval.node) = (Node *) n;
				}
#line 29675 "gram.c" /* yacc.c:1646  */
    break;

  case 271:
#line 2040 "gram.y" /* yacc.c:1646  */
    {
					DiscardStmt *n = makeNode(DiscardStmt);

					n->target = DISCARD_SEQUENCES;
					(yyval.node) = (Node *) n;
				}
#line 29686 "gram.c" /* yacc.c:1646  */
    break;

  case 272:
#line 2060 "gram.y" /* yacc.c:1646  */
    {
					AlterTableStmt *n = makeNode(AlterTableStmt);

					n->relation = (yyvsp[-1].range);
					n->cmds = (yyvsp[0].list);
					n->objtype = OBJECT_TABLE;
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 29700 "gram.c" /* yacc.c:1646  */
    break;

  case 273:
#line 2070 "gram.y" /* yacc.c:1646  */
    {
					AlterTableStmt *n = makeNode(AlterTableStmt);

					n->relation = (yyvsp[-1].range);
					n->cmds = (yyvsp[0].list);
					n->objtype = OBJECT_TABLE;
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 29714 "gram.c" /* yacc.c:1646  */
    break;

  case 274:
#line 2080 "gram.y" /* yacc.c:1646  */
    {
					AlterTableStmt *n = makeNode(AlterTableStmt);

					n->relation = (yyvsp[-1].range);
					n->cmds = list_make1((yyvsp[0].node));
					n->objtype = OBJECT_TABLE;
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 29728 "gram.c" /* yacc.c:1646  */
    break;

  case 275:
#line 2090 "gram.y" /* yacc.c:1646  */
    {
					AlterTableStmt *n = makeNode(AlterTableStmt);

					n->relation = (yyvsp[-1].range);
					n->cmds = list_make1((yyvsp[0].node));
					n->objtype = OBJECT_TABLE;
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 29742 "gram.c" /* yacc.c:1646  */
    break;

  case 276:
#line 2100 "gram.y" /* yacc.c:1646  */
    {
					AlterTableMoveAllStmt *n =
						makeNode(AlterTableMoveAllStmt);

					n->orig_tablespacename = (yyvsp[-4].str);
					n->objtype = OBJECT_TABLE;
					n->roles = NIL;
					n->new_tablespacename = (yyvsp[-1].str);
					n->nowait = (yyvsp[0].boolean);
					(yyval.node) = (Node *) n;
				}
#line 29758 "gram.c" /* yacc.c:1646  */
    break;

  case 277:
#line 2112 "gram.y" /* yacc.c:1646  */
    {
					AlterTableMoveAllStmt *n =
						makeNode(AlterTableMoveAllStmt);

					n->orig_tablespacename = (yyvsp[-7].str);
					n->objtype = OBJECT_TABLE;
					n->roles = (yyvsp[-4].list);
					n->new_tablespacename = (yyvsp[-1].str);
					n->nowait = (yyvsp[0].boolean);
					(yyval.node) = (Node *) n;
				}
#line 29774 "gram.c" /* yacc.c:1646  */
    break;

  case 278:
#line 2124 "gram.y" /* yacc.c:1646  */
    {
					AlterTableStmt *n = makeNode(AlterTableStmt);

					n->relation = (yyvsp[-1].range);
					n->cmds = (yyvsp[0].list);
					n->objtype = OBJECT_INDEX;
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 29788 "gram.c" /* yacc.c:1646  */
    break;

  case 279:
#line 2134 "gram.y" /* yacc.c:1646  */
    {
					AlterTableStmt *n = makeNode(AlterTableStmt);

					n->relation = (yyvsp[-1].range);
					n->cmds = (yyvsp[0].list);
					n->objtype = OBJECT_INDEX;
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 29802 "gram.c" /* yacc.c:1646  */
    break;

  case 280:
#line 2144 "gram.y" /* yacc.c:1646  */
    {
					AlterTableStmt *n = makeNode(AlterTableStmt);

					n->relation = (yyvsp[-1].range);
					n->cmds = list_make1((yyvsp[0].node));
					n->objtype = OBJECT_INDEX;
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 29816 "gram.c" /* yacc.c:1646  */
    break;

  case 281:
#line 2154 "gram.y" /* yacc.c:1646  */
    {
					AlterTableMoveAllStmt *n =
						makeNode(AlterTableMoveAllStmt);

					n->orig_tablespacename = (yyvsp[-4].str);
					n->objtype = OBJECT_INDEX;
					n->roles = NIL;
					n->new_tablespacename = (yyvsp[-1].str);
					n->nowait = (yyvsp[0].boolean);
					(yyval.node) = (Node *) n;
				}
#line 29832 "gram.c" /* yacc.c:1646  */
    break;

  case 282:
#line 2166 "gram.y" /* yacc.c:1646  */
    {
					AlterTableMoveAllStmt *n =
						makeNode(AlterTableMoveAllStmt);

					n->orig_tablespacename = (yyvsp[-7].str);
					n->objtype = OBJECT_INDEX;
					n->roles = (yyvsp[-4].list);
					n->new_tablespacename = (yyvsp[-1].str);
					n->nowait = (yyvsp[0].boolean);
					(yyval.node) = (Node *) n;
				}
#line 29848 "gram.c" /* yacc.c:1646  */
    break;

  case 283:
#line 2178 "gram.y" /* yacc.c:1646  */
    {
					AlterTableStmt *n = makeNode(AlterTableStmt);

					n->relation = (yyvsp[-1].range);
					n->cmds = (yyvsp[0].list);
					n->objtype = OBJECT_SEQUENCE;
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 29862 "gram.c" /* yacc.c:1646  */
    break;

  case 284:
#line 2188 "gram.y" /* yacc.c:1646  */
    {
					AlterTableStmt *n = makeNode(AlterTableStmt);

					n->relation = (yyvsp[-1].range);
					n->cmds = (yyvsp[0].list);
					n->objtype = OBJECT_SEQUENCE;
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 29876 "gram.c" /* yacc.c:1646  */
    break;

  case 285:
#line 2198 "gram.y" /* yacc.c:1646  */
    {
					AlterTableStmt *n = makeNode(AlterTableStmt);

					n->relation = (yyvsp[-1].range);
					n->cmds = (yyvsp[0].list);
					n->objtype = OBJECT_VIEW;
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 29890 "gram.c" /* yacc.c:1646  */
    break;

  case 286:
#line 2208 "gram.y" /* yacc.c:1646  */
    {
					AlterTableStmt *n = makeNode(AlterTableStmt);

					n->relation = (yyvsp[-1].range);
					n->cmds = (yyvsp[0].list);
					n->objtype = OBJECT_VIEW;
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 29904 "gram.c" /* yacc.c:1646  */
    break;

  case 287:
#line 2218 "gram.y" /* yacc.c:1646  */
    {
					AlterTableStmt *n = makeNode(AlterTableStmt);

					n->relation = (yyvsp[-1].range);
					n->cmds = (yyvsp[0].list);
					n->objtype = OBJECT_MATVIEW;
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 29918 "gram.c" /* yacc.c:1646  */
    break;

  case 288:
#line 2228 "gram.y" /* yacc.c:1646  */
    {
					AlterTableStmt *n = makeNode(AlterTableStmt);

					n->relation = (yyvsp[-1].range);
					n->cmds = (yyvsp[0].list);
					n->objtype = OBJECT_MATVIEW;
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 29932 "gram.c" /* yacc.c:1646  */
    break;

  case 289:
#line 2238 "gram.y" /* yacc.c:1646  */
    {
					AlterTableMoveAllStmt *n =
						makeNode(AlterTableMoveAllStmt);

					n->orig_tablespacename = (yyvsp[-4].str);
					n->objtype = OBJECT_MATVIEW;
					n->roles = NIL;
					n->new_tablespacename = (yyvsp[-1].str);
					n->nowait = (yyvsp[0].boolean);
					(yyval.node) = (Node *) n;
				}
#line 29948 "gram.c" /* yacc.c:1646  */
    break;

  case 290:
#line 2250 "gram.y" /* yacc.c:1646  */
    {
					AlterTableMoveAllStmt *n =
						makeNode(AlterTableMoveAllStmt);

					n->orig_tablespacename = (yyvsp[-7].str);
					n->objtype = OBJECT_MATVIEW;
					n->roles = (yyvsp[-4].list);
					n->new_tablespacename = (yyvsp[-1].str);
					n->nowait = (yyvsp[0].boolean);
					(yyval.node) = (Node *) n;
				}
#line 29964 "gram.c" /* yacc.c:1646  */
    break;

  case 291:
#line 2262 "gram.y" /* yacc.c:1646  */
    {
					AlterTableStmt *n = makeNode(AlterTableStmt);

					n->relation = (yyvsp[-1].range);
					n->cmds = (yyvsp[0].list);
					n->objtype = OBJECT_FOREIGN_TABLE;
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 29978 "gram.c" /* yacc.c:1646  */
    break;

  case 292:
#line 2272 "gram.y" /* yacc.c:1646  */
    {
					AlterTableStmt *n = makeNode(AlterTableStmt);

					n->relation = (yyvsp[-1].range);
					n->cmds = (yyvsp[0].list);
					n->objtype = OBJECT_FOREIGN_TABLE;
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 29992 "gram.c" /* yacc.c:1646  */
    break;

  case 293:
#line 2284 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 29998 "gram.c" /* yacc.c:1646  */
    break;

  case 294:
#line 2285 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node)); }
#line 30004 "gram.c" /* yacc.c:1646  */
    break;

  case 295:
#line 2291 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					PartitionCmd *cmd = makeNode(PartitionCmd);

					n->subtype = AT_AttachPartition;
					cmd->name = (yyvsp[-1].range);
					cmd->bound = (yyvsp[0].partboundspec);
					cmd->concurrent = false;
					n->def = (Node *) cmd;

					(yyval.node) = (Node *) n;
				}
#line 30021 "gram.c" /* yacc.c:1646  */
    break;

  case 296:
#line 2305 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					PartitionCmd *cmd = makeNode(PartitionCmd);

					n->subtype = AT_DetachPartition;
					cmd->name = (yyvsp[-1].range);
					cmd->bound = NULL;
					cmd->concurrent = (yyvsp[0].boolean);
					n->def = (Node *) cmd;

					(yyval.node) = (Node *) n;
				}
#line 30038 "gram.c" /* yacc.c:1646  */
    break;

  case 297:
#line 2318 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					PartitionCmd *cmd = makeNode(PartitionCmd);

					n->subtype = AT_DetachPartitionFinalize;
					cmd->name = (yyvsp[-1].range);
					cmd->bound = NULL;
					cmd->concurrent = false;
					n->def = (Node *) cmd;
					(yyval.node) = (Node *) n;
				}
#line 30054 "gram.c" /* yacc.c:1646  */
    break;

  case 298:
#line 2334 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					PartitionCmd *cmd = makeNode(PartitionCmd);

					n->subtype = AT_AttachPartition;
					cmd->name = (yyvsp[0].range);
					cmd->bound = NULL;
					cmd->concurrent = false;
					n->def = (Node *) cmd;

					(yyval.node) = (Node *) n;
				}
#line 30071 "gram.c" /* yacc.c:1646  */
    break;

  case 299:
#line 2351 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_AddColumn;
					n->def = (yyvsp[0].node);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 30084 "gram.c" /* yacc.c:1646  */
    break;

  case 300:
#line 2361 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_AddColumn;
					n->def = (yyvsp[0].node);
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 30097 "gram.c" /* yacc.c:1646  */
    break;

  case 301:
#line 2371 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_AddColumn;
					n->def = (yyvsp[0].node);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 30110 "gram.c" /* yacc.c:1646  */
    break;

  case 302:
#line 2381 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_AddColumn;
					n->def = (yyvsp[0].node);
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 30123 "gram.c" /* yacc.c:1646  */
    break;

  case 303:
#line 2391 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_ColumnDefault;
					n->name = (yyvsp[-1].str);
					n->def = (yyvsp[0].node);
					(yyval.node) = (Node *) n;
				}
#line 30136 "gram.c" /* yacc.c:1646  */
    break;

  case 304:
#line 2401 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_DropNotNull;
					n->name = (yyvsp[-3].str);
					(yyval.node) = (Node *) n;
				}
#line 30148 "gram.c" /* yacc.c:1646  */
    break;

  case 305:
#line 2410 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_SetNotNull;
					n->name = (yyvsp[-3].str);
					(yyval.node) = (Node *) n;
				}
#line 30160 "gram.c" /* yacc.c:1646  */
    break;

  case 306:
#line 2419 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_DropExpression;
					n->name = (yyvsp[-2].str);
					(yyval.node) = (Node *) n;
				}
#line 30172 "gram.c" /* yacc.c:1646  */
    break;

  case 307:
#line 2428 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_DropExpression;
					n->name = (yyvsp[-4].str);
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 30185 "gram.c" /* yacc.c:1646  */
    break;

  case 308:
#line 2438 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_SetStatistics;
					n->name = (yyvsp[-3].str);
					n->def = (Node *) makeInteger((yyvsp[0].ival));
					(yyval.node) = (Node *) n;
				}
#line 30198 "gram.c" /* yacc.c:1646  */
    break;

  case 309:
#line 2448 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					if ((yyvsp[-3].ival) <= 0 || (yyvsp[-3].ival) > PG_INT16_MAX)
						ereport(ERROR,
								(errcode(ERRCODE_INVALID_PARAMETER_VALUE),
								 errmsg("column number must be in range from 1 to %d", PG_INT16_MAX),
								 parser_errposition((yylsp[-3]))));

					n->subtype = AT_SetStatistics;
					n->num = (int16) (yyvsp[-3].ival);
					n->def = (Node *) makeInteger((yyvsp[0].ival));
					(yyval.node) = (Node *) n;
				}
#line 30217 "gram.c" /* yacc.c:1646  */
    break;

  case 310:
#line 2464 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_SetOptions;
					n->name = (yyvsp[-2].str);
					n->def = (Node *) (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 30230 "gram.c" /* yacc.c:1646  */
    break;

  case 311:
#line 2474 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_ResetOptions;
					n->name = (yyvsp[-2].str);
					n->def = (Node *) (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 30243 "gram.c" /* yacc.c:1646  */
    break;

  case 312:
#line 2484 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_SetStorage;
					n->name = (yyvsp[-3].str);
					n->def = (Node *) makeString((yyvsp[0].str));
					(yyval.node) = (Node *) n;
				}
#line 30256 "gram.c" /* yacc.c:1646  */
    break;

  case 313:
#line 2494 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_SetCompression;
					n->name = (yyvsp[-2].str);
					n->def = (Node *) makeString((yyvsp[0].str));
					(yyval.node) = (Node *) n;
				}
#line 30269 "gram.c" /* yacc.c:1646  */
    break;

  case 314:
#line 2504 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					Constraint *c = makeNode(Constraint);

					c->contype = CONSTR_IDENTITY;
					c->generated_when = (yyvsp[-3].ival);
					c->options = (yyvsp[0].list);
					c->location = (yylsp[-4]);

					n->subtype = AT_AddIdentity;
					n->name = (yyvsp[-6].str);
					n->def = (Node *) c;

					(yyval.node) = (Node *) n;
				}
#line 30289 "gram.c" /* yacc.c:1646  */
    break;

  case 315:
#line 2521 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_SetIdentity;
					n->name = (yyvsp[-1].str);
					n->def = (Node *) (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 30302 "gram.c" /* yacc.c:1646  */
    break;

  case 316:
#line 2531 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_DropIdentity;
					n->name = (yyvsp[-2].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 30315 "gram.c" /* yacc.c:1646  */
    break;

  case 317:
#line 2541 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_DropIdentity;
					n->name = (yyvsp[-4].str);
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 30328 "gram.c" /* yacc.c:1646  */
    break;

  case 318:
#line 2551 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_DropColumn;
					n->name = (yyvsp[-1].str);
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 30342 "gram.c" /* yacc.c:1646  */
    break;

  case 319:
#line 2562 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_DropColumn;
					n->name = (yyvsp[-1].str);
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 30356 "gram.c" /* yacc.c:1646  */
    break;

  case 320:
#line 2576 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					ColumnDef *def = makeNode(ColumnDef);

					n->subtype = AT_AlterColumnType;
					n->name = (yyvsp[-5].str);
					n->def = (Node *) def;
					/* We only use these fields of the ColumnDef node */
					def->typeName = (yyvsp[-2].typnam);
					def->collClause = (CollateClause *) (yyvsp[-1].node);
					def->raw_default = (yyvsp[0].node);
					def->location = (yylsp[-5]);
					(yyval.node) = (Node *) n;
				}
#line 30375 "gram.c" /* yacc.c:1646  */
    break;

  case 321:
#line 2592 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_AlterColumnGenericOptions;
					n->name = (yyvsp[-1].str);
					n->def = (Node *) (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 30387 "gram.c" /* yacc.c:1646  */
    break;

  case 322:
#line 2601 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_AddConstraint;
					n->def = (yyvsp[0].node);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 30399 "gram.c" /* yacc.c:1646  */
    break;

  case 323:
#line 2610 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					Constraint *c = makeNode(Constraint);
					n->subtype = AT_AlterConstraint;
					n->def = (Node *) c;
					c->contype = CONSTR_FOREIGN; /* others not supported, yet */
					c->conname = (yyvsp[-1].str);
					processCASbits((yyvsp[0].ival), (yylsp[0]), "ALTER CONSTRAINT statement",
									&c->deferrable,
									&c->initdeferred,
									NULL, NULL, yyscanner);
					(yyval.node) = (Node *) n;
				}
#line 30417 "gram.c" /* yacc.c:1646  */
    break;

  case 324:
#line 2625 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_ValidateConstraint;
					n->name = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 30429 "gram.c" /* yacc.c:1646  */
    break;

  case 325:
#line 2634 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_DropConstraint;
					n->name = (yyvsp[-1].str);
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 30443 "gram.c" /* yacc.c:1646  */
    break;

  case 326:
#line 2645 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_DropConstraint;
					n->name = (yyvsp[-1].str);
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 30457 "gram.c" /* yacc.c:1646  */
    break;

  case 327:
#line 2656 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_DropOids;
					(yyval.node) = (Node *) n;
				}
#line 30468 "gram.c" /* yacc.c:1646  */
    break;

  case 328:
#line 2664 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_ClusterOn;
					n->name = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 30480 "gram.c" /* yacc.c:1646  */
    break;

  case 329:
#line 2673 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_DropCluster;
					n->name = NULL;
					(yyval.node) = (Node *) n;
				}
#line 30492 "gram.c" /* yacc.c:1646  */
    break;

  case 330:
#line 2682 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_SetLogged;
					(yyval.node) = (Node *) n;
				}
#line 30503 "gram.c" /* yacc.c:1646  */
    break;

  case 331:
#line 2690 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_SetUnLogged;
					(yyval.node) = (Node *) n;
				}
#line 30514 "gram.c" /* yacc.c:1646  */
    break;

  case 332:
#line 2698 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_EnableTrig;
					n->name = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 30526 "gram.c" /* yacc.c:1646  */
    break;

  case 333:
#line 2707 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_EnableAlwaysTrig;
					n->name = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 30538 "gram.c" /* yacc.c:1646  */
    break;

  case 334:
#line 2716 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_EnableReplicaTrig;
					n->name = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 30550 "gram.c" /* yacc.c:1646  */
    break;

  case 335:
#line 2725 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_EnableTrigAll;
					(yyval.node) = (Node *) n;
				}
#line 30561 "gram.c" /* yacc.c:1646  */
    break;

  case 336:
#line 2733 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_EnableTrigUser;
					(yyval.node) = (Node *) n;
				}
#line 30572 "gram.c" /* yacc.c:1646  */
    break;

  case 337:
#line 2741 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_DisableTrig;
					n->name = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 30584 "gram.c" /* yacc.c:1646  */
    break;

  case 338:
#line 2750 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_DisableTrigAll;
					(yyval.node) = (Node *) n;
				}
#line 30595 "gram.c" /* yacc.c:1646  */
    break;

  case 339:
#line 2758 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_DisableTrigUser;
					(yyval.node) = (Node *) n;
				}
#line 30606 "gram.c" /* yacc.c:1646  */
    break;

  case 340:
#line 2766 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_EnableRule;
					n->name = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 30618 "gram.c" /* yacc.c:1646  */
    break;

  case 341:
#line 2775 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_EnableAlwaysRule;
					n->name = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 30630 "gram.c" /* yacc.c:1646  */
    break;

  case 342:
#line 2784 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_EnableReplicaRule;
					n->name = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 30642 "gram.c" /* yacc.c:1646  */
    break;

  case 343:
#line 2793 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_DisableRule;
					n->name = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 30654 "gram.c" /* yacc.c:1646  */
    break;

  case 344:
#line 2802 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_AddInherit;
					n->def = (Node *) (yyvsp[0].range);
					(yyval.node) = (Node *) n;
				}
#line 30666 "gram.c" /* yacc.c:1646  */
    break;

  case 345:
#line 2811 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_DropInherit;
					n->def = (Node *) (yyvsp[0].range);
					(yyval.node) = (Node *) n;
				}
#line 30678 "gram.c" /* yacc.c:1646  */
    break;

  case 346:
#line 2820 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					TypeName   *def = makeTypeNameFromNameList((yyvsp[0].list));

					def->location = (yylsp[0]);
					n->subtype = AT_AddOf;
					n->def = (Node *) def;
					(yyval.node) = (Node *) n;
				}
#line 30692 "gram.c" /* yacc.c:1646  */
    break;

  case 347:
#line 2831 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_DropOf;
					(yyval.node) = (Node *) n;
				}
#line 30703 "gram.c" /* yacc.c:1646  */
    break;

  case 348:
#line 2839 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_ChangeOwner;
					n->newowner = (yyvsp[0].rolespec);
					(yyval.node) = (Node *) n;
				}
#line 30715 "gram.c" /* yacc.c:1646  */
    break;

  case 349:
#line 2848 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_SetAccessMethod;
					n->name = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 30727 "gram.c" /* yacc.c:1646  */
    break;

  case 350:
#line 2857 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_SetTableSpace;
					n->name = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 30739 "gram.c" /* yacc.c:1646  */
    break;

  case 351:
#line 2866 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_SetRelOptions;
					n->def = (Node *) (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 30751 "gram.c" /* yacc.c:1646  */
    break;

  case 352:
#line 2875 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_ResetRelOptions;
					n->def = (Node *) (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 30763 "gram.c" /* yacc.c:1646  */
    break;

  case 353:
#line 2884 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_ReplicaIdentity;
					n->def = (yyvsp[0].node);
					(yyval.node) = (Node *) n;
				}
#line 30775 "gram.c" /* yacc.c:1646  */
    break;

  case 354:
#line 2893 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_EnableRowSecurity;
					(yyval.node) = (Node *) n;
				}
#line 30786 "gram.c" /* yacc.c:1646  */
    break;

  case 355:
#line 2901 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_DisableRowSecurity;
					(yyval.node) = (Node *) n;
				}
#line 30797 "gram.c" /* yacc.c:1646  */
    break;

  case 356:
#line 2909 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_ForceRowSecurity;
					(yyval.node) = (Node *) n;
				}
#line 30808 "gram.c" /* yacc.c:1646  */
    break;

  case 357:
#line 2917 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_NoForceRowSecurity;
					(yyval.node) = (Node *) n;
				}
#line 30819 "gram.c" /* yacc.c:1646  */
    break;

  case 358:
#line 2924 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_GenericOptions;
					n->def = (Node *) (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 30831 "gram.c" /* yacc.c:1646  */
    break;

  case 359:
#line 2934 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 30837 "gram.c" /* yacc.c:1646  */
    break;

  case 360:
#line 2935 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 30843 "gram.c" /* yacc.c:1646  */
    break;

  case 361:
#line 2939 "gram.y" /* yacc.c:1646  */
    { (yyval.dbehavior) = DROP_CASCADE; }
#line 30849 "gram.c" /* yacc.c:1646  */
    break;

  case 362:
#line 2940 "gram.y" /* yacc.c:1646  */
    { (yyval.dbehavior) = DROP_RESTRICT; }
#line 30855 "gram.c" /* yacc.c:1646  */
    break;

  case 363:
#line 2941 "gram.y" /* yacc.c:1646  */
    { (yyval.dbehavior) = DROP_RESTRICT; /* default */ }
#line 30861 "gram.c" /* yacc.c:1646  */
    break;

  case 364:
#line 2946 "gram.y" /* yacc.c:1646  */
    {
					CollateClause *n = makeNode(CollateClause);

					n->arg = NULL;
					n->collname = (yyvsp[0].list);
					n->location = (yylsp[-1]);
					(yyval.node) = (Node *) n;
				}
#line 30874 "gram.c" /* yacc.c:1646  */
    break;

  case 365:
#line 2954 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 30880 "gram.c" /* yacc.c:1646  */
    break;

  case 366:
#line 2958 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 30886 "gram.c" /* yacc.c:1646  */
    break;

  case 367:
#line 2959 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 30892 "gram.c" /* yacc.c:1646  */
    break;

  case 368:
#line 2964 "gram.y" /* yacc.c:1646  */
    {
					ReplicaIdentityStmt *n = makeNode(ReplicaIdentityStmt);

					n->identity_type = REPLICA_IDENTITY_NOTHING;
					n->name = NULL;
					(yyval.node) = (Node *) n;
				}
#line 30904 "gram.c" /* yacc.c:1646  */
    break;

  case 369:
#line 2972 "gram.y" /* yacc.c:1646  */
    {
					ReplicaIdentityStmt *n = makeNode(ReplicaIdentityStmt);

					n->identity_type = REPLICA_IDENTITY_FULL;
					n->name = NULL;
					(yyval.node) = (Node *) n;
				}
#line 30916 "gram.c" /* yacc.c:1646  */
    break;

  case 370:
#line 2980 "gram.y" /* yacc.c:1646  */
    {
					ReplicaIdentityStmt *n = makeNode(ReplicaIdentityStmt);

					n->identity_type = REPLICA_IDENTITY_DEFAULT;
					n->name = NULL;
					(yyval.node) = (Node *) n;
				}
#line 30928 "gram.c" /* yacc.c:1646  */
    break;

  case 371:
#line 2988 "gram.y" /* yacc.c:1646  */
    {
					ReplicaIdentityStmt *n = makeNode(ReplicaIdentityStmt);

					n->identity_type = REPLICA_IDENTITY_INDEX;
					n->name = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 30940 "gram.c" /* yacc.c:1646  */
    break;

  case 372:
#line 2998 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 30946 "gram.c" /* yacc.c:1646  */
    break;

  case 373:
#line 3001 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 30952 "gram.c" /* yacc.c:1646  */
    break;

  case 374:
#line 3002 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 30958 "gram.c" /* yacc.c:1646  */
    break;

  case 375:
#line 3006 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].defelt)); }
#line 30964 "gram.c" /* yacc.c:1646  */
    break;

  case 376:
#line 3007 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].defelt)); }
#line 30970 "gram.c" /* yacc.c:1646  */
    break;

  case 377:
#line 3013 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem((yyvsp[-2].str), (Node *) (yyvsp[0].node), (yylsp[-2]));
				}
#line 30978 "gram.c" /* yacc.c:1646  */
    break;

  case 378:
#line 3017 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem((yyvsp[0].str), NULL, (yylsp[0]));
				}
#line 30986 "gram.c" /* yacc.c:1646  */
    break;

  case 379:
#line 3021 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElemExtended((yyvsp[-4].str), (yyvsp[-2].str), (Node *) (yyvsp[0].node),
											 DEFELEM_UNSPEC, (yylsp[-4]));
				}
#line 30995 "gram.c" /* yacc.c:1646  */
    break;

  case 380:
#line 3026 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElemExtended((yyvsp[-2].str), (yyvsp[0].str), NULL, DEFELEM_UNSPEC, (yylsp[-2]));
				}
#line 31003 "gram.c" /* yacc.c:1646  */
    break;

  case 381:
#line 3033 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].defelt)); }
#line 31009 "gram.c" /* yacc.c:1646  */
    break;

  case 382:
#line 3035 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].defelt)); }
#line 31015 "gram.c" /* yacc.c:1646  */
    break;

  case 383:
#line 3040 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("restart", NULL, (yylsp[0]));
				}
#line 31023 "gram.c" /* yacc.c:1646  */
    break;

  case 384:
#line 3044 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("restart", (Node *) (yyvsp[0].node), (yylsp[-2]));
				}
#line 31031 "gram.c" /* yacc.c:1646  */
    break;

  case 385:
#line 3048 "gram.y" /* yacc.c:1646  */
    {
					if (strcmp((yyvsp[0].defelt)->defname, "as") == 0 ||
						strcmp((yyvsp[0].defelt)->defname, "restart") == 0 ||
						strcmp((yyvsp[0].defelt)->defname, "owned_by") == 0)
						ereport(ERROR,
								(errcode(ERRCODE_SYNTAX_ERROR),
								 errmsg("sequence option \"%s\" not supported here", (yyvsp[0].defelt)->defname),
								 parser_errposition((yylsp[0]))));
					(yyval.defelt) = (yyvsp[0].defelt);
				}
#line 31046 "gram.c" /* yacc.c:1646  */
    break;

  case 386:
#line 3059 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("generated", (Node *) makeInteger((yyvsp[0].ival)), (yylsp[-2]));
				}
#line 31054 "gram.c" /* yacc.c:1646  */
    break;

  case 387:
#line 3067 "gram.y" /* yacc.c:1646  */
    {
					ListCell   *lc;
					PartitionBoundSpec *n = makeNode(PartitionBoundSpec);

					n->strategy = PARTITION_STRATEGY_HASH;
					n->modulus = n->remainder = -1;

					foreach (lc, (yyvsp[-1].list))
					{
						DefElem    *opt = lfirst_node(DefElem, lc);

						if (strcmp(opt->defname, "modulus") == 0)
						{
							if (n->modulus != -1)
								ereport(ERROR,
										(errcode(ERRCODE_DUPLICATE_OBJECT),
										 errmsg("modulus for hash partition provided more than once"),
										 parser_errposition(opt->location)));
							n->modulus = defGetInt32(opt);
						}
						else if (strcmp(opt->defname, "remainder") == 0)
						{
							if (n->remainder != -1)
								ereport(ERROR,
										(errcode(ERRCODE_DUPLICATE_OBJECT),
										 errmsg("remainder for hash partition provided more than once"),
										 parser_errposition(opt->location)));
							n->remainder = defGetInt32(opt);
						}
						else
							ereport(ERROR,
									(errcode(ERRCODE_SYNTAX_ERROR),
									 errmsg("unrecognized hash partition bound specification \"%s\"",
											opt->defname),
									 parser_errposition(opt->location)));
					}

					if (n->modulus == -1)
						ereport(ERROR,
								(errcode(ERRCODE_SYNTAX_ERROR),
								 errmsg("modulus for hash partition must be specified")));
					if (n->remainder == -1)
						ereport(ERROR,
								(errcode(ERRCODE_SYNTAX_ERROR),
								 errmsg("remainder for hash partition must be specified")));

					n->location = (yylsp[-3]);

					(yyval.partboundspec) = n;
				}
#line 31109 "gram.c" /* yacc.c:1646  */
    break;

  case 388:
#line 3120 "gram.y" /* yacc.c:1646  */
    {
					PartitionBoundSpec *n = makeNode(PartitionBoundSpec);

					n->strategy = PARTITION_STRATEGY_LIST;
					n->is_default = false;
					n->listdatums = (yyvsp[-1].list);
					n->location = (yylsp[-3]);

					(yyval.partboundspec) = n;
				}
#line 31124 "gram.c" /* yacc.c:1646  */
    break;

  case 389:
#line 3133 "gram.y" /* yacc.c:1646  */
    {
					PartitionBoundSpec *n = makeNode(PartitionBoundSpec);

					n->strategy = PARTITION_STRATEGY_RANGE;
					n->is_default = false;
					n->lowerdatums = (yyvsp[-5].list);
					n->upperdatums = (yyvsp[-1].list);
					n->location = (yylsp[-7]);

					(yyval.partboundspec) = n;
				}
#line 31140 "gram.c" /* yacc.c:1646  */
    break;

  case 390:
#line 3147 "gram.y" /* yacc.c:1646  */
    {
					PartitionBoundSpec *n = makeNode(PartitionBoundSpec);

					n->is_default = true;
					n->location = (yylsp[0]);

					(yyval.partboundspec) = n;
				}
#line 31153 "gram.c" /* yacc.c:1646  */
    break;

  case 391:
#line 3159 "gram.y" /* yacc.c:1646  */
    {
				(yyval.defelt) = makeDefElem((yyvsp[-1].str), (Node *) makeInteger((yyvsp[0].ival)), (yylsp[-1]));
			}
#line 31161 "gram.c" /* yacc.c:1646  */
    break;

  case 392:
#line 3166 "gram.y" /* yacc.c:1646  */
    {
				(yyval.list) = list_make1((yyvsp[0].defelt));
			}
#line 31169 "gram.c" /* yacc.c:1646  */
    break;

  case 393:
#line 3170 "gram.y" /* yacc.c:1646  */
    {
				(yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].defelt));
			}
#line 31177 "gram.c" /* yacc.c:1646  */
    break;

  case 394:
#line 3184 "gram.y" /* yacc.c:1646  */
    {
					AlterTableStmt *n = makeNode(AlterTableStmt);

					/* can't use qualified_name, sigh */
					n->relation = makeRangeVarFromAnyName((yyvsp[-1].list), (yylsp[-1]), yyscanner);
					n->cmds = (yyvsp[0].list);
					n->objtype = OBJECT_TYPE;
					(yyval.node) = (Node *) n;
				}
#line 31191 "gram.c" /* yacc.c:1646  */
    break;

  case 395:
#line 3196 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 31197 "gram.c" /* yacc.c:1646  */
    break;

  case 396:
#line 3197 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node)); }
#line 31203 "gram.c" /* yacc.c:1646  */
    break;

  case 397:
#line 3203 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_AddColumn;
					n->def = (yyvsp[-1].node);
					n->behavior = (yyvsp[0].dbehavior);
					(yyval.node) = (Node *) n;
				}
#line 31216 "gram.c" /* yacc.c:1646  */
    break;

  case 398:
#line 3213 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_DropColumn;
					n->name = (yyvsp[-1].str);
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 31230 "gram.c" /* yacc.c:1646  */
    break;

  case 399:
#line 3224 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_DropColumn;
					n->name = (yyvsp[-1].str);
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 31244 "gram.c" /* yacc.c:1646  */
    break;

  case 400:
#line 3235 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					ColumnDef *def = makeNode(ColumnDef);

					n->subtype = AT_AlterColumnType;
					n->name = (yyvsp[-5].str);
					n->def = (Node *) def;
					n->behavior = (yyvsp[0].dbehavior);
					/* We only use these fields of the ColumnDef node */
					def->typeName = (yyvsp[-2].typnam);
					def->collClause = (CollateClause *) (yyvsp[-1].node);
					def->raw_default = NULL;
					def->location = (yylsp[-5]);
					(yyval.node) = (Node *) n;
				}
#line 31264 "gram.c" /* yacc.c:1646  */
    break;

  case 401:
#line 3262 "gram.y" /* yacc.c:1646  */
    {
					ClosePortalStmt *n = makeNode(ClosePortalStmt);

					n->portalname = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 31275 "gram.c" /* yacc.c:1646  */
    break;

  case 402:
#line 3269 "gram.y" /* yacc.c:1646  */
    {
					ClosePortalStmt *n = makeNode(ClosePortalStmt);

					n->portalname = NULL;
					(yyval.node) = (Node *) n;
				}
#line 31286 "gram.c" /* yacc.c:1646  */
    break;

  case 403:
#line 3305 "gram.y" /* yacc.c:1646  */
    {
					CopyStmt *n = makeNode(CopyStmt);

					n->relation = (yyvsp[-8].range);
					n->query = NULL;
					n->attlist = (yyvsp[-7].list);
					n->is_from = (yyvsp[-6].boolean);
					n->is_program = (yyvsp[-5].boolean);
					n->filename = (yyvsp[-4].str);
					n->whereClause = (yyvsp[0].node);

					if (n->is_program && n->filename == NULL)
						ereport(ERROR,
								(errcode(ERRCODE_SYNTAX_ERROR),
								 errmsg("STDIN/STDOUT not allowed with PROGRAM"),
								 parser_errposition((yylsp[-3]))));

					if (!n->is_from && n->whereClause != NULL)
						ereport(ERROR,
								(errcode(ERRCODE_SYNTAX_ERROR),
								 errmsg("WHERE clause not allowed with COPY TO"),
								 parser_errposition((yylsp[0]))));

					n->options = NIL;
					/* Concatenate user-supplied flags */
					if ((yyvsp[-9].defelt))
						n->options = lappend(n->options, (yyvsp[-9].defelt));
					if ((yyvsp[-3].defelt))
						n->options = lappend(n->options, (yyvsp[-3].defelt));
					if ((yyvsp[-1].list))
						n->options = list_concat(n->options, (yyvsp[-1].list));
					(yyval.node) = (Node *) n;
				}
#line 31324 "gram.c" /* yacc.c:1646  */
    break;

  case 404:
#line 3339 "gram.y" /* yacc.c:1646  */
    {
					CopyStmt *n = makeNode(CopyStmt);

					n->relation = NULL;
					n->query = (yyvsp[-6].node);
					n->attlist = NIL;
					n->is_from = false;
					n->is_program = (yyvsp[-3].boolean);
					n->filename = (yyvsp[-2].str);
					n->options = (yyvsp[0].list);

					if (n->is_program && n->filename == NULL)
						ereport(ERROR,
								(errcode(ERRCODE_SYNTAX_ERROR),
								 errmsg("STDIN/STDOUT not allowed with PROGRAM"),
								 parser_errposition((yylsp[-4]))));

					(yyval.node) = (Node *) n;
				}
#line 31348 "gram.c" /* yacc.c:1646  */
    break;

  case 405:
#line 3361 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 31354 "gram.c" /* yacc.c:1646  */
    break;

  case 406:
#line 3362 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 31360 "gram.c" /* yacc.c:1646  */
    break;

  case 407:
#line 3366 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 31366 "gram.c" /* yacc.c:1646  */
    break;

  case 408:
#line 3367 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 31372 "gram.c" /* yacc.c:1646  */
    break;

  case 409:
#line 3376 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 31378 "gram.c" /* yacc.c:1646  */
    break;

  case 410:
#line 3377 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = NULL; }
#line 31384 "gram.c" /* yacc.c:1646  */
    break;

  case 411:
#line 3378 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = NULL; }
#line 31390 "gram.c" /* yacc.c:1646  */
    break;

  case 412:
#line 3381 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 31396 "gram.c" /* yacc.c:1646  */
    break;

  case 413:
#line 3382 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 31402 "gram.c" /* yacc.c:1646  */
    break;

  case 414:
#line 3387 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].defelt)); }
#line 31408 "gram.c" /* yacc.c:1646  */
    break;

  case 415:
#line 3388 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 31414 "gram.c" /* yacc.c:1646  */
    break;

  case 416:
#line 3393 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("format", (Node *) makeString("binary"), (yylsp[0]));
				}
#line 31422 "gram.c" /* yacc.c:1646  */
    break;

  case 417:
#line 3397 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("freeze", (Node *) makeBoolean(true), (yylsp[0]));
				}
#line 31430 "gram.c" /* yacc.c:1646  */
    break;

  case 418:
#line 3401 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("delimiter", (Node *) makeString((yyvsp[0].str)), (yylsp[-2]));
				}
#line 31438 "gram.c" /* yacc.c:1646  */
    break;

  case 419:
#line 3405 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("null", (Node *) makeString((yyvsp[0].str)), (yylsp[-2]));
				}
#line 31446 "gram.c" /* yacc.c:1646  */
    break;

  case 420:
#line 3409 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("format", (Node *) makeString("csv"), (yylsp[0]));
				}
#line 31454 "gram.c" /* yacc.c:1646  */
    break;

  case 421:
#line 3413 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("header", (Node *) makeBoolean(true), (yylsp[0]));
				}
#line 31462 "gram.c" /* yacc.c:1646  */
    break;

  case 422:
#line 3417 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("quote", (Node *) makeString((yyvsp[0].str)), (yylsp[-2]));
				}
#line 31470 "gram.c" /* yacc.c:1646  */
    break;

  case 423:
#line 3421 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("escape", (Node *) makeString((yyvsp[0].str)), (yylsp[-2]));
				}
#line 31478 "gram.c" /* yacc.c:1646  */
    break;

  case 424:
#line 3425 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("force_quote", (Node *) (yyvsp[0].list), (yylsp[-2]));
				}
#line 31486 "gram.c" /* yacc.c:1646  */
    break;

  case 425:
#line 3429 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("force_quote", (Node *) makeNode(A_Star), (yylsp[-2]));
				}
#line 31494 "gram.c" /* yacc.c:1646  */
    break;

  case 426:
#line 3433 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("force_not_null", (Node *) (yyvsp[0].list), (yylsp[-3]));
				}
#line 31502 "gram.c" /* yacc.c:1646  */
    break;

  case 427:
#line 3437 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("force_null", (Node *) (yyvsp[0].list), (yylsp[-2]));
				}
#line 31510 "gram.c" /* yacc.c:1646  */
    break;

  case 428:
#line 3441 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("encoding", (Node *) makeString((yyvsp[0].str)), (yylsp[-1]));
				}
#line 31518 "gram.c" /* yacc.c:1646  */
    break;

  case 429:
#line 3450 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("format", (Node *) makeString("binary"), (yylsp[0]));
				}
#line 31526 "gram.c" /* yacc.c:1646  */
    break;

  case 430:
#line 3453 "gram.y" /* yacc.c:1646  */
    { (yyval.defelt) = NULL; }
#line 31532 "gram.c" /* yacc.c:1646  */
    break;

  case 431:
#line 3458 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("delimiter", (Node *) makeString((yyvsp[0].str)), (yylsp[-1]));
				}
#line 31540 "gram.c" /* yacc.c:1646  */
    break;

  case 432:
#line 3461 "gram.y" /* yacc.c:1646  */
    { (yyval.defelt) = NULL; }
#line 31546 "gram.c" /* yacc.c:1646  */
    break;

  case 435:
#line 3472 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make1((yyvsp[0].defelt));
				}
#line 31554 "gram.c" /* yacc.c:1646  */
    break;

  case 436:
#line 3476 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].defelt));
				}
#line 31562 "gram.c" /* yacc.c:1646  */
    break;

  case 437:
#line 3483 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem((yyvsp[-1].str), (yyvsp[0].node), (yylsp[-1]));
				}
#line 31570 "gram.c" /* yacc.c:1646  */
    break;

  case 438:
#line 3489 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeString((yyvsp[0].str)); }
#line 31576 "gram.c" /* yacc.c:1646  */
    break;

  case 439:
#line 3490 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) (yyvsp[0].node); }
#line 31582 "gram.c" /* yacc.c:1646  */
    break;

  case 440:
#line 3491 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeNode(A_Star); }
#line 31588 "gram.c" /* yacc.c:1646  */
    break;

  case 441:
#line 3492 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) (yyvsp[-1].list); }
#line 31594 "gram.c" /* yacc.c:1646  */
    break;

  case 442:
#line 3493 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 31600 "gram.c" /* yacc.c:1646  */
    break;

  case 443:
#line 3498 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make1((yyvsp[0].node));
				}
#line 31608 "gram.c" /* yacc.c:1646  */
    break;

  case 444:
#line 3502 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node));
				}
#line 31616 "gram.c" /* yacc.c:1646  */
    break;

  case 445:
#line 3509 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeString((yyvsp[0].str)); }
#line 31622 "gram.c" /* yacc.c:1646  */
    break;

  case 446:
#line 3523 "gram.y" /* yacc.c:1646  */
    {
					CreateStmt *n = makeNode(CreateStmt);

					(yyvsp[-9].range)->relpersistence = (yyvsp[-11].ival);
					n->relation = (yyvsp[-9].range);
					n->tableElts = (yyvsp[-7].list);
					n->inhRelations = (yyvsp[-5].list);
					n->partspec = (yyvsp[-4].partspec);
					n->ofTypename = NULL;
					n->constraints = NIL;
					n->accessMethod = (yyvsp[-3].str);
					n->options = (yyvsp[-2].list);
					n->oncommit = (yyvsp[-1].oncommit);
					n->tablespacename = (yyvsp[0].str);
					n->if_not_exists = false;
					(yyval.node) = (Node *) n;
				}
#line 31644 "gram.c" /* yacc.c:1646  */
    break;

  case 447:
#line 3543 "gram.y" /* yacc.c:1646  */
    {
					CreateStmt *n = makeNode(CreateStmt);

					(yyvsp[-9].range)->relpersistence = (yyvsp[-14].ival);
					n->relation = (yyvsp[-9].range);
					n->tableElts = (yyvsp[-7].list);
					n->inhRelations = (yyvsp[-5].list);
					n->partspec = (yyvsp[-4].partspec);
					n->ofTypename = NULL;
					n->constraints = NIL;
					n->accessMethod = (yyvsp[-3].str);
					n->options = (yyvsp[-2].list);
					n->oncommit = (yyvsp[-1].oncommit);
					n->tablespacename = (yyvsp[0].str);
					n->if_not_exists = true;
					(yyval.node) = (Node *) n;
				}
#line 31666 "gram.c" /* yacc.c:1646  */
    break;

  case 448:
#line 3563 "gram.y" /* yacc.c:1646  */
    {
					CreateStmt *n = makeNode(CreateStmt);

					(yyvsp[-8].range)->relpersistence = (yyvsp[-10].ival);
					n->relation = (yyvsp[-8].range);
					n->tableElts = (yyvsp[-5].list);
					n->inhRelations = NIL;
					n->partspec = (yyvsp[-4].partspec);
					n->ofTypename = makeTypeNameFromNameList((yyvsp[-6].list));
					n->ofTypename->location = (yylsp[-6]);
					n->constraints = NIL;
					n->accessMethod = (yyvsp[-3].str);
					n->options = (yyvsp[-2].list);
					n->oncommit = (yyvsp[-1].oncommit);
					n->tablespacename = (yyvsp[0].str);
					n->if_not_exists = false;
					(yyval.node) = (Node *) n;
				}
#line 31689 "gram.c" /* yacc.c:1646  */
    break;

  case 449:
#line 3584 "gram.y" /* yacc.c:1646  */
    {
					CreateStmt *n = makeNode(CreateStmt);

					(yyvsp[-8].range)->relpersistence = (yyvsp[-13].ival);
					n->relation = (yyvsp[-8].range);
					n->tableElts = (yyvsp[-5].list);
					n->inhRelations = NIL;
					n->partspec = (yyvsp[-4].partspec);
					n->ofTypename = makeTypeNameFromNameList((yyvsp[-6].list));
					n->ofTypename->location = (yylsp[-6]);
					n->constraints = NIL;
					n->accessMethod = (yyvsp[-3].str);
					n->options = (yyvsp[-2].list);
					n->oncommit = (yyvsp[-1].oncommit);
					n->tablespacename = (yyvsp[0].str);
					n->if_not_exists = true;
					(yyval.node) = (Node *) n;
				}
#line 31712 "gram.c" /* yacc.c:1646  */
    break;

  case 450:
#line 3605 "gram.y" /* yacc.c:1646  */
    {
					CreateStmt *n = makeNode(CreateStmt);

					(yyvsp[-10].range)->relpersistence = (yyvsp[-12].ival);
					n->relation = (yyvsp[-10].range);
					n->tableElts = (yyvsp[-6].list);
					n->inhRelations = list_make1((yyvsp[-7].range));
					n->partbound = (yyvsp[-5].partboundspec);
					n->partspec = (yyvsp[-4].partspec);
					n->ofTypename = NULL;
					n->constraints = NIL;
					n->accessMethod = (yyvsp[-3].str);
					n->options = (yyvsp[-2].list);
					n->oncommit = (yyvsp[-1].oncommit);
					n->tablespacename = (yyvsp[0].str);
					n->if_not_exists = false;
					(yyval.node) = (Node *) n;
				}
#line 31735 "gram.c" /* yacc.c:1646  */
    break;

  case 451:
#line 3626 "gram.y" /* yacc.c:1646  */
    {
					CreateStmt *n = makeNode(CreateStmt);

					(yyvsp[-10].range)->relpersistence = (yyvsp[-15].ival);
					n->relation = (yyvsp[-10].range);
					n->tableElts = (yyvsp[-6].list);
					n->inhRelations = list_make1((yyvsp[-7].range));
					n->partbound = (yyvsp[-5].partboundspec);
					n->partspec = (yyvsp[-4].partspec);
					n->ofTypename = NULL;
					n->constraints = NIL;
					n->accessMethod = (yyvsp[-3].str);
					n->options = (yyvsp[-2].list);
					n->oncommit = (yyvsp[-1].oncommit);
					n->tablespacename = (yyvsp[0].str);
					n->if_not_exists = true;
					(yyval.node) = (Node *) n;
				}
#line 31758 "gram.c" /* yacc.c:1646  */
    break;

  case 452:
#line 3657 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = RELPERSISTENCE_TEMP; }
#line 31764 "gram.c" /* yacc.c:1646  */
    break;

  case 453:
#line 3658 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = RELPERSISTENCE_TEMP; }
#line 31770 "gram.c" /* yacc.c:1646  */
    break;

  case 454:
#line 3659 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = RELPERSISTENCE_TEMP; }
#line 31776 "gram.c" /* yacc.c:1646  */
    break;

  case 455:
#line 3660 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = RELPERSISTENCE_TEMP; }
#line 31782 "gram.c" /* yacc.c:1646  */
    break;

  case 456:
#line 3662 "gram.y" /* yacc.c:1646  */
    {
					ereport(WARNING,
							(errmsg("GLOBAL is deprecated in temporary table creation"),
							 parser_errposition((yylsp[-1]))));
					(yyval.ival) = RELPERSISTENCE_TEMP;
				}
#line 31793 "gram.c" /* yacc.c:1646  */
    break;

  case 457:
#line 3669 "gram.y" /* yacc.c:1646  */
    {
					ereport(WARNING,
							(errmsg("GLOBAL is deprecated in temporary table creation"),
							 parser_errposition((yylsp[-1]))));
					(yyval.ival) = RELPERSISTENCE_TEMP;
				}
#line 31804 "gram.c" /* yacc.c:1646  */
    break;

  case 458:
#line 3675 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = RELPERSISTENCE_UNLOGGED; }
#line 31810 "gram.c" /* yacc.c:1646  */
    break;

  case 459:
#line 3676 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = RELPERSISTENCE_PERMANENT; }
#line 31816 "gram.c" /* yacc.c:1646  */
    break;

  case 460:
#line 3680 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 31822 "gram.c" /* yacc.c:1646  */
    break;

  case 461:
#line 3681 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 31828 "gram.c" /* yacc.c:1646  */
    break;

  case 462:
#line 3685 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 31834 "gram.c" /* yacc.c:1646  */
    break;

  case 463:
#line 3686 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 31840 "gram.c" /* yacc.c:1646  */
    break;

  case 464:
#line 3691 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make1((yyvsp[0].node));
				}
#line 31848 "gram.c" /* yacc.c:1646  */
    break;

  case 465:
#line 3695 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node));
				}
#line 31856 "gram.c" /* yacc.c:1646  */
    break;

  case 466:
#line 3702 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make1((yyvsp[0].node));
				}
#line 31864 "gram.c" /* yacc.c:1646  */
    break;

  case 467:
#line 3706 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node));
				}
#line 31872 "gram.c" /* yacc.c:1646  */
    break;

  case 468:
#line 3712 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 31878 "gram.c" /* yacc.c:1646  */
    break;

  case 469:
#line 3713 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 31884 "gram.c" /* yacc.c:1646  */
    break;

  case 470:
#line 3714 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 31890 "gram.c" /* yacc.c:1646  */
    break;

  case 471:
#line 3718 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 31896 "gram.c" /* yacc.c:1646  */
    break;

  case 472:
#line 3719 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 31902 "gram.c" /* yacc.c:1646  */
    break;

  case 473:
#line 3723 "gram.y" /* yacc.c:1646  */
    {
					ColumnDef *n = makeNode(ColumnDef);

					n->colname = (yyvsp[-4].str);
					n->typeName = (yyvsp[-3].typnam);
					n->compression = (yyvsp[-2].str);
					n->inhcount = 0;
					n->is_local = true;
					n->is_not_null = false;
					n->is_from_type = false;
					n->storage = 0;
					n->raw_default = NULL;
					n->cooked_default = NULL;
					n->collOid = InvalidOid;
					n->fdwoptions = (yyvsp[-1].list);
					SplitColQualList((yyvsp[0].list), &n->constraints, &n->collClause,
									 yyscanner);
					n->location = (yylsp[-4]);
					(yyval.node) = (Node *) n;
				}
#line 31927 "gram.c" /* yacc.c:1646  */
    break;

  case 474:
#line 3746 "gram.y" /* yacc.c:1646  */
    {
					ColumnDef *n = makeNode(ColumnDef);

					n->colname = (yyvsp[-1].str);
					n->typeName = NULL;
					n->inhcount = 0;
					n->is_local = true;
					n->is_not_null = false;
					n->is_from_type = false;
					n->storage = 0;
					n->raw_default = NULL;
					n->cooked_default = NULL;
					n->collOid = InvalidOid;
					SplitColQualList((yyvsp[0].list), &n->constraints, &n->collClause,
									 yyscanner);
					n->location = (yylsp[-1]);
					(yyval.node) = (Node *) n;
				}
#line 31950 "gram.c" /* yacc.c:1646  */
    break;

  case 475:
#line 3765 "gram.y" /* yacc.c:1646  */
    {
					ColumnDef *n = makeNode(ColumnDef);

					n->colname = (yyvsp[-3].str);
					n->typeName = NULL;
					n->inhcount = 0;
					n->is_local = true;
					n->is_not_null = false;
					n->is_from_type = false;
					n->storage = 0;
					n->raw_default = NULL;
					n->cooked_default = NULL;
					n->collOid = InvalidOid;
					SplitColQualList((yyvsp[0].list), &n->constraints, &n->collClause,
									 yyscanner);
					n->location = (yylsp[-3]);
					(yyval.node) = (Node *) n;
				}
#line 31973 "gram.c" /* yacc.c:1646  */
    break;

  case 476:
#line 3786 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 31979 "gram.c" /* yacc.c:1646  */
    break;

  case 477:
#line 3787 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = pstrdup("default"); }
#line 31985 "gram.c" /* yacc.c:1646  */
    break;

  case 478:
#line 3791 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 31991 "gram.c" /* yacc.c:1646  */
    break;

  case 479:
#line 3792 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = NULL; }
#line 31997 "gram.c" /* yacc.c:1646  */
    break;

  case 480:
#line 3796 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].node)); }
#line 32003 "gram.c" /* yacc.c:1646  */
    break;

  case 481:
#line 3797 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 32009 "gram.c" /* yacc.c:1646  */
    break;

  case 482:
#line 3802 "gram.y" /* yacc.c:1646  */
    {
					Constraint *n = castNode(Constraint, (yyvsp[0].node));

					n->conname = (yyvsp[-1].str);
					n->location = (yylsp[-2]);
					(yyval.node) = (Node *) n;
				}
#line 32021 "gram.c" /* yacc.c:1646  */
    break;

  case 483:
#line 3809 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 32027 "gram.c" /* yacc.c:1646  */
    break;

  case 484:
#line 3810 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 32033 "gram.c" /* yacc.c:1646  */
    break;

  case 485:
#line 3812 "gram.y" /* yacc.c:1646  */
    {
					/*
					 * Note: the CollateClause is momentarily included in
					 * the list built by ColQualList, but we split it out
					 * again in SplitColQualList.
					 */
					CollateClause *n = makeNode(CollateClause);

					n->arg = NULL;
					n->collname = (yyvsp[0].list);
					n->location = (yylsp[-1]);
					(yyval.node) = (Node *) n;
				}
#line 32051 "gram.c" /* yacc.c:1646  */
    break;

  case 486:
#line 3844 "gram.y" /* yacc.c:1646  */
    {
					Constraint *n = makeNode(Constraint);

					n->contype = CONSTR_NOTNULL;
					n->location = (yylsp[-1]);
					(yyval.node) = (Node *) n;
				}
#line 32063 "gram.c" /* yacc.c:1646  */
    break;

  case 487:
#line 3852 "gram.y" /* yacc.c:1646  */
    {
					Constraint *n = makeNode(Constraint);

					n->contype = CONSTR_NULL;
					n->location = (yylsp[0]);
					(yyval.node) = (Node *) n;
				}
#line 32075 "gram.c" /* yacc.c:1646  */
    break;

  case 488:
#line 3860 "gram.y" /* yacc.c:1646  */
    {
					Constraint *n = makeNode(Constraint);

					n->contype = CONSTR_UNIQUE;
					n->location = (yylsp[-3]);
					n->nulls_not_distinct = !(yyvsp[-2].boolean);
					n->keys = NULL;
					n->options = (yyvsp[-1].list);
					n->indexname = NULL;
					n->indexspace = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 32092 "gram.c" /* yacc.c:1646  */
    break;

  case 489:
#line 3873 "gram.y" /* yacc.c:1646  */
    {
					Constraint *n = makeNode(Constraint);

					n->contype = CONSTR_PRIMARY;
					n->location = (yylsp[-3]);
					n->keys = NULL;
					n->options = (yyvsp[-1].list);
					n->indexname = NULL;
					n->indexspace = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 32108 "gram.c" /* yacc.c:1646  */
    break;

  case 490:
#line 3885 "gram.y" /* yacc.c:1646  */
    {
					Constraint *n = makeNode(Constraint);

					n->contype = CONSTR_CHECK;
					n->location = (yylsp[-4]);
					n->is_no_inherit = (yyvsp[0].boolean);
					n->raw_expr = (yyvsp[-2].node);
					n->cooked_expr = NULL;
					n->skip_validation = false;
					n->initially_valid = true;
					(yyval.node) = (Node *) n;
				}
#line 32125 "gram.c" /* yacc.c:1646  */
    break;

  case 491:
#line 3898 "gram.y" /* yacc.c:1646  */
    {
					Constraint *n = makeNode(Constraint);

					n->contype = CONSTR_DEFAULT;
					n->location = (yylsp[-1]);
					n->raw_expr = (yyvsp[0].node);
					n->cooked_expr = NULL;
					n->skip_validation = false;
					n->initially_valid = true;
					(yyval.node) = (Node *) n;
				}
#line 32141 "gram.c" /* yacc.c:1646  */
    break;

  case 492:
#line 3910 "gram.y" /* yacc.c:1646  */
    {
					Constraint *n = makeNode(Constraint);

					n->contype = CONSTR_IDENTITY;
					n->generated_when = (yyvsp[-3].ival);
					n->options = (yyvsp[0].list);
					n->location = (yylsp[-4]);
					(yyval.node) = (Node *) n;
				}
#line 32155 "gram.c" /* yacc.c:1646  */
    break;

  case 493:
#line 3920 "gram.y" /* yacc.c:1646  */
    {
					Constraint *n = makeNode(Constraint);

					n->contype = CONSTR_GENERATED;
					n->generated_when = (yyvsp[-5].ival);
					n->raw_expr = (yyvsp[-2].node);
					n->cooked_expr = NULL;
					n->location = (yylsp[-6]);

					/*
					 * Can't do this in the grammar because of shift/reduce
					 * conflicts.  (IDENTITY allows both ALWAYS and BY
					 * DEFAULT, but generated columns only allow ALWAYS.)  We
					 * can also give a more useful error message and location.
					 */
					if ((yyvsp[-5].ival) != ATTRIBUTE_IDENTITY_ALWAYS)
						ereport(ERROR,
								(errcode(ERRCODE_SYNTAX_ERROR),
								 errmsg("for a generated column, GENERATED ALWAYS must be specified"),
								 parser_errposition((yylsp[-5]))));

					(yyval.node) = (Node *) n;
				}
#line 32183 "gram.c" /* yacc.c:1646  */
    break;

  case 494:
#line 3944 "gram.y" /* yacc.c:1646  */
    {
					Constraint *n = makeNode(Constraint);

					n->contype = CONSTR_FOREIGN;
					n->location = (yylsp[-4]);
					n->pktable = (yyvsp[-3].range);
					n->fk_attrs = NIL;
					n->pk_attrs = (yyvsp[-2].list);
					n->fk_matchtype = (yyvsp[-1].ival);
					n->fk_upd_action = ((yyvsp[0].keyactions))->updateAction->action;
					n->fk_del_action = ((yyvsp[0].keyactions))->deleteAction->action;
					n->fk_del_set_cols = ((yyvsp[0].keyactions))->deleteAction->cols;
					n->skip_validation = false;
					n->initially_valid = true;
					(yyval.node) = (Node *) n;
				}
#line 32204 "gram.c" /* yacc.c:1646  */
    break;

  case 495:
#line 3963 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 32210 "gram.c" /* yacc.c:1646  */
    break;

  case 496:
#line 3964 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 32216 "gram.c" /* yacc.c:1646  */
    break;

  case 497:
#line 3965 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 32222 "gram.c" /* yacc.c:1646  */
    break;

  case 498:
#line 3969 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = ATTRIBUTE_IDENTITY_ALWAYS; }
#line 32228 "gram.c" /* yacc.c:1646  */
    break;

  case 499:
#line 3970 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = ATTRIBUTE_IDENTITY_BY_DEFAULT; }
#line 32234 "gram.c" /* yacc.c:1646  */
    break;

  case 500:
#line 3990 "gram.y" /* yacc.c:1646  */
    {
					Constraint *n = makeNode(Constraint);

					n->contype = CONSTR_ATTR_DEFERRABLE;
					n->location = (yylsp[0]);
					(yyval.node) = (Node *) n;
				}
#line 32246 "gram.c" /* yacc.c:1646  */
    break;

  case 501:
#line 3998 "gram.y" /* yacc.c:1646  */
    {
					Constraint *n = makeNode(Constraint);

					n->contype = CONSTR_ATTR_NOT_DEFERRABLE;
					n->location = (yylsp[-1]);
					(yyval.node) = (Node *) n;
				}
#line 32258 "gram.c" /* yacc.c:1646  */
    break;

  case 502:
#line 4006 "gram.y" /* yacc.c:1646  */
    {
					Constraint *n = makeNode(Constraint);

					n->contype = CONSTR_ATTR_DEFERRED;
					n->location = (yylsp[-1]);
					(yyval.node) = (Node *) n;
				}
#line 32270 "gram.c" /* yacc.c:1646  */
    break;

  case 503:
#line 4014 "gram.y" /* yacc.c:1646  */
    {
					Constraint *n = makeNode(Constraint);

					n->contype = CONSTR_ATTR_IMMEDIATE;
					n->location = (yylsp[-1]);
					(yyval.node) = (Node *) n;
				}
#line 32282 "gram.c" /* yacc.c:1646  */
    break;

  case 504:
#line 4026 "gram.y" /* yacc.c:1646  */
    {
					TableLikeClause *n = makeNode(TableLikeClause);

					n->relation = (yyvsp[-1].range);
					n->options = (yyvsp[0].ival);
					n->relationOid = InvalidOid;
					(yyval.node) = (Node *) n;
				}
#line 32295 "gram.c" /* yacc.c:1646  */
    break;

  case 505:
#line 4037 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = (yyvsp[-2].ival) | (yyvsp[0].ival); }
#line 32301 "gram.c" /* yacc.c:1646  */
    break;

  case 506:
#line 4038 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = (yyvsp[-2].ival) & ~(yyvsp[0].ival); }
#line 32307 "gram.c" /* yacc.c:1646  */
    break;

  case 507:
#line 4039 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = 0; }
#line 32313 "gram.c" /* yacc.c:1646  */
    break;

  case 508:
#line 4043 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = CREATE_TABLE_LIKE_COMMENTS; }
#line 32319 "gram.c" /* yacc.c:1646  */
    break;

  case 509:
#line 4044 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = CREATE_TABLE_LIKE_COMPRESSION; }
#line 32325 "gram.c" /* yacc.c:1646  */
    break;

  case 510:
#line 4045 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = CREATE_TABLE_LIKE_CONSTRAINTS; }
#line 32331 "gram.c" /* yacc.c:1646  */
    break;

  case 511:
#line 4046 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = CREATE_TABLE_LIKE_DEFAULTS; }
#line 32337 "gram.c" /* yacc.c:1646  */
    break;

  case 512:
#line 4047 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = CREATE_TABLE_LIKE_IDENTITY; }
#line 32343 "gram.c" /* yacc.c:1646  */
    break;

  case 513:
#line 4048 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = CREATE_TABLE_LIKE_GENERATED; }
#line 32349 "gram.c" /* yacc.c:1646  */
    break;

  case 514:
#line 4049 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = CREATE_TABLE_LIKE_INDEXES; }
#line 32355 "gram.c" /* yacc.c:1646  */
    break;

  case 515:
#line 4050 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = CREATE_TABLE_LIKE_STATISTICS; }
#line 32361 "gram.c" /* yacc.c:1646  */
    break;

  case 516:
#line 4051 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = CREATE_TABLE_LIKE_STORAGE; }
#line 32367 "gram.c" /* yacc.c:1646  */
    break;

  case 517:
#line 4052 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = CREATE_TABLE_LIKE_ALL; }
#line 32373 "gram.c" /* yacc.c:1646  */
    break;

  case 518:
#line 4062 "gram.y" /* yacc.c:1646  */
    {
					Constraint *n = castNode(Constraint, (yyvsp[0].node));

					n->conname = (yyvsp[-1].str);
					n->location = (yylsp[-2]);
					(yyval.node) = (Node *) n;
				}
#line 32385 "gram.c" /* yacc.c:1646  */
    break;

  case 519:
#line 4069 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 32391 "gram.c" /* yacc.c:1646  */
    break;

  case 520:
#line 4074 "gram.y" /* yacc.c:1646  */
    {
					Constraint *n = makeNode(Constraint);

					n->contype = CONSTR_CHECK;
					n->location = (yylsp[-4]);
					n->raw_expr = (yyvsp[-2].node);
					n->cooked_expr = NULL;
					processCASbits((yyvsp[0].ival), (yylsp[0]), "CHECK",
								   NULL, NULL, &n->skip_validation,
								   &n->is_no_inherit, yyscanner);
					n->initially_valid = !n->skip_validation;
					(yyval.node) = (Node *) n;
				}
#line 32409 "gram.c" /* yacc.c:1646  */
    break;

  case 521:
#line 4089 "gram.y" /* yacc.c:1646  */
    {
					Constraint *n = makeNode(Constraint);

					n->contype = CONSTR_UNIQUE;
					n->location = (yylsp[-8]);
					n->nulls_not_distinct = !(yyvsp[-7].boolean);
					n->keys = (yyvsp[-5].list);
					n->including = (yyvsp[-3].list);
					n->options = (yyvsp[-2].list);
					n->indexname = NULL;
					n->indexspace = (yyvsp[-1].str);
					processCASbits((yyvsp[0].ival), (yylsp[0]), "UNIQUE",
								   &n->deferrable, &n->initdeferred, NULL,
								   NULL, yyscanner);
					(yyval.node) = (Node *) n;
				}
#line 32430 "gram.c" /* yacc.c:1646  */
    break;

  case 522:
#line 4106 "gram.y" /* yacc.c:1646  */
    {
					Constraint *n = makeNode(Constraint);

					n->contype = CONSTR_UNIQUE;
					n->location = (yylsp[-2]);
					n->keys = NIL;
					n->including = NIL;
					n->options = NIL;
					n->indexname = (yyvsp[-1].str);
					n->indexspace = NULL;
					processCASbits((yyvsp[0].ival), (yylsp[0]), "UNIQUE",
								   &n->deferrable, &n->initdeferred, NULL,
								   NULL, yyscanner);
					(yyval.node) = (Node *) n;
				}
#line 32450 "gram.c" /* yacc.c:1646  */
    break;

  case 523:
#line 4123 "gram.y" /* yacc.c:1646  */
    {
					Constraint *n = makeNode(Constraint);

					n->contype = CONSTR_PRIMARY;
					n->location = (yylsp[-8]);
					n->keys = (yyvsp[-5].list);
					n->including = (yyvsp[-3].list);
					n->options = (yyvsp[-2].list);
					n->indexname = NULL;
					n->indexspace = (yyvsp[-1].str);
					processCASbits((yyvsp[0].ival), (yylsp[0]), "PRIMARY KEY",
								   &n->deferrable, &n->initdeferred, NULL,
								   NULL, yyscanner);
					(yyval.node) = (Node *) n;
				}
#line 32470 "gram.c" /* yacc.c:1646  */
    break;

  case 524:
#line 4139 "gram.y" /* yacc.c:1646  */
    {
					Constraint *n = makeNode(Constraint);

					n->contype = CONSTR_PRIMARY;
					n->location = (yylsp[-3]);
					n->keys = NIL;
					n->including = NIL;
					n->options = NIL;
					n->indexname = (yyvsp[-1].str);
					n->indexspace = NULL;
					processCASbits((yyvsp[0].ival), (yylsp[0]), "PRIMARY KEY",
								   &n->deferrable, &n->initdeferred, NULL,
								   NULL, yyscanner);
					(yyval.node) = (Node *) n;
				}
#line 32490 "gram.c" /* yacc.c:1646  */
    break;

  case 525:
#line 4157 "gram.y" /* yacc.c:1646  */
    {
					Constraint *n = makeNode(Constraint);

					n->contype = CONSTR_EXCLUSION;
					n->location = (yylsp[-9]);
					n->access_method = (yyvsp[-8].str);
					n->exclusions = (yyvsp[-6].list);
					n->including = (yyvsp[-4].list);
					n->options = (yyvsp[-3].list);
					n->indexname = NULL;
					n->indexspace = (yyvsp[-2].str);
					n->where_clause = (yyvsp[-1].node);
					processCASbits((yyvsp[0].ival), (yylsp[0]), "EXCLUDE",
								   &n->deferrable, &n->initdeferred, NULL,
								   NULL, yyscanner);
					(yyval.node) = (Node *) n;
				}
#line 32512 "gram.c" /* yacc.c:1646  */
    break;

  case 526:
#line 4176 "gram.y" /* yacc.c:1646  */
    {
					Constraint *n = makeNode(Constraint);

					n->contype = CONSTR_FOREIGN;
					n->location = (yylsp[-10]);
					n->pktable = (yyvsp[-4].range);
					n->fk_attrs = (yyvsp[-7].list);
					n->pk_attrs = (yyvsp[-3].list);
					n->fk_matchtype = (yyvsp[-2].ival);
					n->fk_upd_action = ((yyvsp[-1].keyactions))->updateAction->action;
					n->fk_del_action = ((yyvsp[-1].keyactions))->deleteAction->action;
					n->fk_del_set_cols = ((yyvsp[-1].keyactions))->deleteAction->cols;
					processCASbits((yyvsp[0].ival), (yylsp[0]), "FOREIGN KEY",
								   &n->deferrable, &n->initdeferred,
								   &n->skip_validation, NULL,
								   yyscanner);
					n->initially_valid = !n->skip_validation;
					(yyval.node) = (Node *) n;
				}
#line 32536 "gram.c" /* yacc.c:1646  */
    break;

  case 527:
#line 4197 "gram.y" /* yacc.c:1646  */
    {  (yyval.boolean) = true; }
#line 32542 "gram.c" /* yacc.c:1646  */
    break;

  case 528:
#line 4198 "gram.y" /* yacc.c:1646  */
    {  (yyval.boolean) = false; }
#line 32548 "gram.c" /* yacc.c:1646  */
    break;

  case 529:
#line 4202 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 32554 "gram.c" /* yacc.c:1646  */
    break;

  case 530:
#line 4203 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 32560 "gram.c" /* yacc.c:1646  */
    break;

  case 531:
#line 4207 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 32566 "gram.c" /* yacc.c:1646  */
    break;

  case 532:
#line 4208 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node)); }
#line 32572 "gram.c" /* yacc.c:1646  */
    break;

  case 533:
#line 4212 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeString((yyvsp[0].str));
				}
#line 32580 "gram.c" /* yacc.c:1646  */
    break;

  case 534:
#line 4217 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 32586 "gram.c" /* yacc.c:1646  */
    break;

  case 535:
#line 4218 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 32592 "gram.c" /* yacc.c:1646  */
    break;

  case 536:
#line 4222 "gram.y" /* yacc.c:1646  */
    {
				(yyval.ival) = FKCONSTR_MATCH_FULL;
			}
#line 32600 "gram.c" /* yacc.c:1646  */
    break;

  case 537:
#line 4226 "gram.y" /* yacc.c:1646  */
    {
				ereport(ERROR,
						(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
						 errmsg("MATCH PARTIAL not yet implemented"),
						 parser_errposition((yylsp[-1]))));
				(yyval.ival) = FKCONSTR_MATCH_PARTIAL;
			}
#line 32612 "gram.c" /* yacc.c:1646  */
    break;

  case 538:
#line 4234 "gram.y" /* yacc.c:1646  */
    {
				(yyval.ival) = FKCONSTR_MATCH_SIMPLE;
			}
#line 32620 "gram.c" /* yacc.c:1646  */
    break;

  case 539:
#line 4238 "gram.y" /* yacc.c:1646  */
    {
				(yyval.ival) = FKCONSTR_MATCH_SIMPLE;
			}
#line 32628 "gram.c" /* yacc.c:1646  */
    break;

  case 540:
#line 4244 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].list)); }
#line 32634 "gram.c" /* yacc.c:1646  */
    break;

  case 541:
#line 4246 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].list)); }
#line 32640 "gram.c" /* yacc.c:1646  */
    break;

  case 542:
#line 4250 "gram.y" /* yacc.c:1646  */
    {
				(yyval.list) = list_make2((yyvsp[-2].ielem), (yyvsp[0].list));
			}
#line 32648 "gram.c" /* yacc.c:1646  */
    break;

  case 543:
#line 4255 "gram.y" /* yacc.c:1646  */
    {
				(yyval.list) = list_make2((yyvsp[-5].ielem), (yyvsp[-1].list));
			}
#line 32656 "gram.c" /* yacc.c:1646  */
    break;

  case 544:
#line 4261 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[-1].node); }
#line 32662 "gram.c" /* yacc.c:1646  */
    break;

  case 545:
#line 4262 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 32668 "gram.c" /* yacc.c:1646  */
    break;

  case 546:
#line 4267 "gram.y" /* yacc.c:1646  */
    {
					KeyActions *n = palloc(sizeof(KeyActions));

					n->updateAction = (yyvsp[0].keyaction);
					n->deleteAction = palloc(sizeof(KeyAction));
					n->deleteAction->action = FKCONSTR_ACTION_NOACTION;
					n->deleteAction->cols = NIL;
					(yyval.keyactions) = n;
				}
#line 32682 "gram.c" /* yacc.c:1646  */
    break;

  case 547:
#line 4277 "gram.y" /* yacc.c:1646  */
    {
					KeyActions *n = palloc(sizeof(KeyActions));

					n->updateAction = palloc(sizeof(KeyAction));
					n->updateAction->action = FKCONSTR_ACTION_NOACTION;
					n->updateAction->cols = NIL;
					n->deleteAction = (yyvsp[0].keyaction);
					(yyval.keyactions) = n;
				}
#line 32696 "gram.c" /* yacc.c:1646  */
    break;

  case 548:
#line 4287 "gram.y" /* yacc.c:1646  */
    {
					KeyActions *n = palloc(sizeof(KeyActions));

					n->updateAction = (yyvsp[-1].keyaction);
					n->deleteAction = (yyvsp[0].keyaction);
					(yyval.keyactions) = n;
				}
#line 32708 "gram.c" /* yacc.c:1646  */
    break;

  case 549:
#line 4295 "gram.y" /* yacc.c:1646  */
    {
					KeyActions *n = palloc(sizeof(KeyActions));

					n->updateAction = (yyvsp[0].keyaction);
					n->deleteAction = (yyvsp[-1].keyaction);
					(yyval.keyactions) = n;
				}
#line 32720 "gram.c" /* yacc.c:1646  */
    break;

  case 550:
#line 4303 "gram.y" /* yacc.c:1646  */
    {
					KeyActions *n = palloc(sizeof(KeyActions));

					n->updateAction = palloc(sizeof(KeyAction));
					n->updateAction->action = FKCONSTR_ACTION_NOACTION;
					n->updateAction->cols = NIL;
					n->deleteAction = palloc(sizeof(KeyAction));
					n->deleteAction->action = FKCONSTR_ACTION_NOACTION;
					n->deleteAction->cols = NIL;
					(yyval.keyactions) = n;
				}
#line 32736 "gram.c" /* yacc.c:1646  */
    break;

  case 551:
#line 4317 "gram.y" /* yacc.c:1646  */
    {
					if (((yyvsp[0].keyaction))->cols)
						ereport(ERROR,
								(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
								 errmsg("a column list with %s is only supported for ON DELETE actions",
										((yyvsp[0].keyaction))->action == FKCONSTR_ACTION_SETNULL ? "SET NULL" : "SET DEFAULT"),
								 parser_errposition((yylsp[-2]))));
					(yyval.keyaction) = (yyvsp[0].keyaction);
				}
#line 32750 "gram.c" /* yacc.c:1646  */
    break;

  case 552:
#line 4329 "gram.y" /* yacc.c:1646  */
    {
					(yyval.keyaction) = (yyvsp[0].keyaction);
				}
#line 32758 "gram.c" /* yacc.c:1646  */
    break;

  case 553:
#line 4336 "gram.y" /* yacc.c:1646  */
    {
					KeyAction *n = palloc(sizeof(KeyAction));

					n->action = FKCONSTR_ACTION_NOACTION;
					n->cols = NIL;
					(yyval.keyaction) = n;
				}
#line 32770 "gram.c" /* yacc.c:1646  */
    break;

  case 554:
#line 4344 "gram.y" /* yacc.c:1646  */
    {
					KeyAction *n = palloc(sizeof(KeyAction));

					n->action = FKCONSTR_ACTION_RESTRICT;
					n->cols = NIL;
					(yyval.keyaction) = n;
				}
#line 32782 "gram.c" /* yacc.c:1646  */
    break;

  case 555:
#line 4352 "gram.y" /* yacc.c:1646  */
    {
					KeyAction *n = palloc(sizeof(KeyAction));

					n->action = FKCONSTR_ACTION_CASCADE;
					n->cols = NIL;
					(yyval.keyaction) = n;
				}
#line 32794 "gram.c" /* yacc.c:1646  */
    break;

  case 556:
#line 4360 "gram.y" /* yacc.c:1646  */
    {
					KeyAction *n = palloc(sizeof(KeyAction));

					n->action = FKCONSTR_ACTION_SETNULL;
					n->cols = (yyvsp[0].list);
					(yyval.keyaction) = n;
				}
#line 32806 "gram.c" /* yacc.c:1646  */
    break;

  case 557:
#line 4368 "gram.y" /* yacc.c:1646  */
    {
					KeyAction *n = palloc(sizeof(KeyAction));

					n->action = FKCONSTR_ACTION_SETDEFAULT;
					n->cols = (yyvsp[0].list);
					(yyval.keyaction) = n;
				}
#line 32818 "gram.c" /* yacc.c:1646  */
    break;

  case 558:
#line 4377 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 32824 "gram.c" /* yacc.c:1646  */
    break;

  case 559:
#line 4378 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 32830 "gram.c" /* yacc.c:1646  */
    break;

  case 560:
#line 4382 "gram.y" /* yacc.c:1646  */
    { (yyval.partspec) = (yyvsp[0].partspec); }
#line 32836 "gram.c" /* yacc.c:1646  */
    break;

  case 561:
#line 4383 "gram.y" /* yacc.c:1646  */
    { (yyval.partspec) = NULL; }
#line 32842 "gram.c" /* yacc.c:1646  */
    break;

  case 562:
#line 4387 "gram.y" /* yacc.c:1646  */
    {
					PartitionSpec *n = makeNode(PartitionSpec);

					n->strategy = (yyvsp[-3].str);
					n->partParams = (yyvsp[-1].list);
					n->location = (yylsp[-5]);

					(yyval.partspec) = n;
				}
#line 32856 "gram.c" /* yacc.c:1646  */
    break;

  case 563:
#line 4398 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].partelem)); }
#line 32862 "gram.c" /* yacc.c:1646  */
    break;

  case 564:
#line 4399 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].partelem)); }
#line 32868 "gram.c" /* yacc.c:1646  */
    break;

  case 565:
#line 4403 "gram.y" /* yacc.c:1646  */
    {
					PartitionElem *n = makeNode(PartitionElem);

					n->name = (yyvsp[-2].str);
					n->expr = NULL;
					n->collation = (yyvsp[-1].list);
					n->opclass = (yyvsp[0].list);
					n->location = (yylsp[-2]);
					(yyval.partelem) = n;
				}
#line 32883 "gram.c" /* yacc.c:1646  */
    break;

  case 566:
#line 4414 "gram.y" /* yacc.c:1646  */
    {
					PartitionElem *n = makeNode(PartitionElem);

					n->name = NULL;
					n->expr = (yyvsp[-2].node);
					n->collation = (yyvsp[-1].list);
					n->opclass = (yyvsp[0].list);
					n->location = (yylsp[-2]);
					(yyval.partelem) = n;
				}
#line 32898 "gram.c" /* yacc.c:1646  */
    break;

  case 567:
#line 4425 "gram.y" /* yacc.c:1646  */
    {
					PartitionElem *n = makeNode(PartitionElem);

					n->name = NULL;
					n->expr = (yyvsp[-3].node);
					n->collation = (yyvsp[-1].list);
					n->opclass = (yyvsp[0].list);
					n->location = (yylsp[-4]);
					(yyval.partelem) = n;
				}
#line 32913 "gram.c" /* yacc.c:1646  */
    break;

  case 568:
#line 4438 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 32919 "gram.c" /* yacc.c:1646  */
    break;

  case 569:
#line 4439 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = NULL; }
#line 32925 "gram.c" /* yacc.c:1646  */
    break;

  case 570:
#line 4444 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 32931 "gram.c" /* yacc.c:1646  */
    break;

  case 571:
#line 4445 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 32937 "gram.c" /* yacc.c:1646  */
    break;

  case 572:
#line 4446 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 32943 "gram.c" /* yacc.c:1646  */
    break;

  case 573:
#line 4449 "gram.y" /* yacc.c:1646  */
    { (yyval.oncommit) = ONCOMMIT_DROP; }
#line 32949 "gram.c" /* yacc.c:1646  */
    break;

  case 574:
#line 4450 "gram.y" /* yacc.c:1646  */
    { (yyval.oncommit) = ONCOMMIT_DELETE_ROWS; }
#line 32955 "gram.c" /* yacc.c:1646  */
    break;

  case 575:
#line 4451 "gram.y" /* yacc.c:1646  */
    { (yyval.oncommit) = ONCOMMIT_PRESERVE_ROWS; }
#line 32961 "gram.c" /* yacc.c:1646  */
    break;

  case 576:
#line 4452 "gram.y" /* yacc.c:1646  */
    { (yyval.oncommit) = ONCOMMIT_NOOP; }
#line 32967 "gram.c" /* yacc.c:1646  */
    break;

  case 577:
#line 4455 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 32973 "gram.c" /* yacc.c:1646  */
    break;

  case 578:
#line 4456 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = NULL; }
#line 32979 "gram.c" /* yacc.c:1646  */
    break;

  case 579:
#line 4459 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 32985 "gram.c" /* yacc.c:1646  */
    break;

  case 580:
#line 4460 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = NULL; }
#line 32991 "gram.c" /* yacc.c:1646  */
    break;

  case 581:
#line 4463 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 32997 "gram.c" /* yacc.c:1646  */
    break;

  case 582:
#line 4483 "gram.y" /* yacc.c:1646  */
    {
					CreateStatsStmt *n = makeNode(CreateStatsStmt);

					n->defnames = (yyvsp[-5].list);
					n->stat_types = (yyvsp[-4].list);
					n->exprs = (yyvsp[-2].list);
					n->relations = (yyvsp[0].list);
					n->stxcomment = NULL;
					n->if_not_exists = false;
					(yyval.node) = (Node *) n;
				}
#line 33013 "gram.c" /* yacc.c:1646  */
    break;

  case 583:
#line 4496 "gram.y" /* yacc.c:1646  */
    {
					CreateStatsStmt *n = makeNode(CreateStatsStmt);

					n->defnames = (yyvsp[-5].list);
					n->stat_types = (yyvsp[-4].list);
					n->exprs = (yyvsp[-2].list);
					n->relations = (yyvsp[0].list);
					n->stxcomment = NULL;
					n->if_not_exists = true;
					(yyval.node) = (Node *) n;
				}
#line 33029 "gram.c" /* yacc.c:1646  */
    break;

  case 584:
#line 4516 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].selem)); }
#line 33035 "gram.c" /* yacc.c:1646  */
    break;

  case 585:
#line 4517 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].selem)); }
#line 33041 "gram.c" /* yacc.c:1646  */
    break;

  case 586:
#line 4521 "gram.y" /* yacc.c:1646  */
    {
					(yyval.selem) = makeNode(StatsElem);
					(yyval.selem)->name = (yyvsp[0].str);
					(yyval.selem)->expr = NULL;
				}
#line 33051 "gram.c" /* yacc.c:1646  */
    break;

  case 587:
#line 4527 "gram.y" /* yacc.c:1646  */
    {
					(yyval.selem) = makeNode(StatsElem);
					(yyval.selem)->name = NULL;
					(yyval.selem)->expr = (yyvsp[0].node);
				}
#line 33061 "gram.c" /* yacc.c:1646  */
    break;

  case 588:
#line 4533 "gram.y" /* yacc.c:1646  */
    {
					(yyval.selem) = makeNode(StatsElem);
					(yyval.selem)->name = NULL;
					(yyval.selem)->expr = (yyvsp[-1].node);
				}
#line 33071 "gram.c" /* yacc.c:1646  */
    break;

  case 589:
#line 4550 "gram.y" /* yacc.c:1646  */
    {
					AlterStatsStmt *n = makeNode(AlterStatsStmt);

					n->defnames = (yyvsp[-3].list);
					n->missing_ok = false;
					n->stxstattarget = (yyvsp[0].ival);
					(yyval.node) = (Node *) n;
				}
#line 33084 "gram.c" /* yacc.c:1646  */
    break;

  case 590:
#line 4559 "gram.y" /* yacc.c:1646  */
    {
					AlterStatsStmt *n = makeNode(AlterStatsStmt);

					n->defnames = (yyvsp[-3].list);
					n->missing_ok = true;
					n->stxstattarget = (yyvsp[0].ival);
					(yyval.node) = (Node *) n;
				}
#line 33097 "gram.c" /* yacc.c:1646  */
    break;

  case 591:
#line 4581 "gram.y" /* yacc.c:1646  */
    {
					CreateTableAsStmt *ctas = makeNode(CreateTableAsStmt);

					ctas->query = (yyvsp[-1].node);
					ctas->into = (yyvsp[-3].into);
					ctas->objtype = OBJECT_TABLE;
					ctas->is_select_into = false;
					ctas->if_not_exists = false;
					/* cram additional flags into the IntoClause */
					(yyvsp[-3].into)->rel->relpersistence = (yyvsp[-5].ival);
					(yyvsp[-3].into)->skipData = !((yyvsp[0].boolean));
					(yyval.node) = (Node *) ctas;
				}
#line 33115 "gram.c" /* yacc.c:1646  */
    break;

  case 592:
#line 4595 "gram.y" /* yacc.c:1646  */
    {
					CreateTableAsStmt *ctas = makeNode(CreateTableAsStmt);

					ctas->query = (yyvsp[-1].node);
					ctas->into = (yyvsp[-3].into);
					ctas->objtype = OBJECT_TABLE;
					ctas->is_select_into = false;
					ctas->if_not_exists = true;
					/* cram additional flags into the IntoClause */
					(yyvsp[-3].into)->rel->relpersistence = (yyvsp[-8].ival);
					(yyvsp[-3].into)->skipData = !((yyvsp[0].boolean));
					(yyval.node) = (Node *) ctas;
				}
#line 33133 "gram.c" /* yacc.c:1646  */
    break;

  case 593:
#line 4613 "gram.y" /* yacc.c:1646  */
    {
					(yyval.into) = makeNode(IntoClause);
					(yyval.into)->rel = (yyvsp[-5].range);
					(yyval.into)->colNames = (yyvsp[-4].list);
					(yyval.into)->accessMethod = (yyvsp[-3].str);
					(yyval.into)->options = (yyvsp[-2].list);
					(yyval.into)->onCommit = (yyvsp[-1].oncommit);
					(yyval.into)->tableSpaceName = (yyvsp[0].str);
					(yyval.into)->viewQuery = NULL;
					(yyval.into)->skipData = false;		/* might get changed later */
				}
#line 33149 "gram.c" /* yacc.c:1646  */
    break;

  case 594:
#line 4627 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 33155 "gram.c" /* yacc.c:1646  */
    break;

  case 595:
#line 4628 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 33161 "gram.c" /* yacc.c:1646  */
    break;

  case 596:
#line 4629 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 33167 "gram.c" /* yacc.c:1646  */
    break;

  case 597:
#line 4642 "gram.y" /* yacc.c:1646  */
    {
					CreateTableAsStmt *ctas = makeNode(CreateTableAsStmt);

					ctas->query = (yyvsp[-1].node);
					ctas->into = (yyvsp[-3].into);
					ctas->objtype = OBJECT_MATVIEW;
					ctas->is_select_into = false;
					ctas->if_not_exists = false;
					/* cram additional flags into the IntoClause */
					(yyvsp[-3].into)->rel->relpersistence = (yyvsp[-6].ival);
					(yyvsp[-3].into)->skipData = !((yyvsp[0].boolean));
					(yyval.node) = (Node *) ctas;
				}
#line 33185 "gram.c" /* yacc.c:1646  */
    break;

  case 598:
#line 4656 "gram.y" /* yacc.c:1646  */
    {
					CreateTableAsStmt *ctas = makeNode(CreateTableAsStmt);

					ctas->query = (yyvsp[-1].node);
					ctas->into = (yyvsp[-3].into);
					ctas->objtype = OBJECT_MATVIEW;
					ctas->is_select_into = false;
					ctas->if_not_exists = true;
					/* cram additional flags into the IntoClause */
					(yyvsp[-3].into)->rel->relpersistence = (yyvsp[-9].ival);
					(yyvsp[-3].into)->skipData = !((yyvsp[0].boolean));
					(yyval.node) = (Node *) ctas;
				}
#line 33203 "gram.c" /* yacc.c:1646  */
    break;

  case 599:
#line 4673 "gram.y" /* yacc.c:1646  */
    {
					(yyval.into) = makeNode(IntoClause);
					(yyval.into)->rel = (yyvsp[-4].range);
					(yyval.into)->colNames = (yyvsp[-3].list);
					(yyval.into)->accessMethod = (yyvsp[-2].str);
					(yyval.into)->options = (yyvsp[-1].list);
					(yyval.into)->onCommit = ONCOMMIT_NOOP;
					(yyval.into)->tableSpaceName = (yyvsp[0].str);
					(yyval.into)->viewQuery = NULL;		/* filled at analysis time */
					(yyval.into)->skipData = false;		/* might get changed later */
				}
#line 33219 "gram.c" /* yacc.c:1646  */
    break;

  case 600:
#line 4686 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = RELPERSISTENCE_UNLOGGED; }
#line 33225 "gram.c" /* yacc.c:1646  */
    break;

  case 601:
#line 4687 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = RELPERSISTENCE_PERMANENT; }
#line 33231 "gram.c" /* yacc.c:1646  */
    break;

  case 602:
#line 4700 "gram.y" /* yacc.c:1646  */
    {
					RefreshMatViewStmt *n = makeNode(RefreshMatViewStmt);

					n->concurrent = (yyvsp[-2].boolean);
					n->relation = (yyvsp[-1].range);
					n->skipData = !((yyvsp[0].boolean));
					(yyval.node) = (Node *) n;
				}
#line 33244 "gram.c" /* yacc.c:1646  */
    break;

  case 603:
#line 4721 "gram.y" /* yacc.c:1646  */
    {
					CreateSeqStmt *n = makeNode(CreateSeqStmt);

					(yyvsp[-1].range)->relpersistence = (yyvsp[-3].ival);
					n->sequence = (yyvsp[-1].range);
					n->options = (yyvsp[0].list);
					n->ownerId = InvalidOid;
					n->if_not_exists = false;
					(yyval.node) = (Node *) n;
				}
#line 33259 "gram.c" /* yacc.c:1646  */
    break;

  case 604:
#line 4732 "gram.y" /* yacc.c:1646  */
    {
					CreateSeqStmt *n = makeNode(CreateSeqStmt);

					(yyvsp[-1].range)->relpersistence = (yyvsp[-6].ival);
					n->sequence = (yyvsp[-1].range);
					n->options = (yyvsp[0].list);
					n->ownerId = InvalidOid;
					n->if_not_exists = true;
					(yyval.node) = (Node *) n;
				}
#line 33274 "gram.c" /* yacc.c:1646  */
    break;

  case 605:
#line 4746 "gram.y" /* yacc.c:1646  */
    {
					AlterSeqStmt *n = makeNode(AlterSeqStmt);

					n->sequence = (yyvsp[-1].range);
					n->options = (yyvsp[0].list);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 33287 "gram.c" /* yacc.c:1646  */
    break;

  case 606:
#line 4755 "gram.y" /* yacc.c:1646  */
    {
					AlterSeqStmt *n = makeNode(AlterSeqStmt);

					n->sequence = (yyvsp[-1].range);
					n->options = (yyvsp[0].list);
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 33300 "gram.c" /* yacc.c:1646  */
    break;

  case 607:
#line 4766 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 33306 "gram.c" /* yacc.c:1646  */
    break;

  case 608:
#line 4767 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 33312 "gram.c" /* yacc.c:1646  */
    break;

  case 609:
#line 4770 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 33318 "gram.c" /* yacc.c:1646  */
    break;

  case 610:
#line 4771 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 33324 "gram.c" /* yacc.c:1646  */
    break;

  case 611:
#line 4774 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].defelt)); }
#line 33330 "gram.c" /* yacc.c:1646  */
    break;

  case 612:
#line 4775 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].defelt)); }
#line 33336 "gram.c" /* yacc.c:1646  */
    break;

  case 613:
#line 4779 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("as", (Node *) (yyvsp[0].typnam), (yylsp[-1]));
				}
#line 33344 "gram.c" /* yacc.c:1646  */
    break;

  case 614:
#line 4783 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("cache", (Node *) (yyvsp[0].node), (yylsp[-1]));
				}
#line 33352 "gram.c" /* yacc.c:1646  */
    break;

  case 615:
#line 4787 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("cycle", (Node *) makeBoolean(true), (yylsp[0]));
				}
#line 33360 "gram.c" /* yacc.c:1646  */
    break;

  case 616:
#line 4791 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("cycle", (Node *) makeBoolean(false), (yylsp[-1]));
				}
#line 33368 "gram.c" /* yacc.c:1646  */
    break;

  case 617:
#line 4795 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("increment", (Node *) (yyvsp[0].node), (yylsp[-2]));
				}
#line 33376 "gram.c" /* yacc.c:1646  */
    break;

  case 618:
#line 4799 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("maxvalue", (Node *) (yyvsp[0].node), (yylsp[-1]));
				}
#line 33384 "gram.c" /* yacc.c:1646  */
    break;

  case 619:
#line 4803 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("minvalue", (Node *) (yyvsp[0].node), (yylsp[-1]));
				}
#line 33392 "gram.c" /* yacc.c:1646  */
    break;

  case 620:
#line 4807 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("maxvalue", NULL, (yylsp[-1]));
				}
#line 33400 "gram.c" /* yacc.c:1646  */
    break;

  case 621:
#line 4811 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("minvalue", NULL, (yylsp[-1]));
				}
#line 33408 "gram.c" /* yacc.c:1646  */
    break;

  case 622:
#line 4815 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("owned_by", (Node *) (yyvsp[0].list), (yylsp[-2]));
				}
#line 33416 "gram.c" /* yacc.c:1646  */
    break;

  case 623:
#line 4819 "gram.y" /* yacc.c:1646  */
    {
					/* not documented, only used by pg_dump */
					(yyval.defelt) = makeDefElem("sequence_name", (Node *) (yyvsp[0].list), (yylsp[-2]));
				}
#line 33425 "gram.c" /* yacc.c:1646  */
    break;

  case 624:
#line 4824 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("start", (Node *) (yyvsp[0].node), (yylsp[-2]));
				}
#line 33433 "gram.c" /* yacc.c:1646  */
    break;

  case 625:
#line 4828 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("restart", NULL, (yylsp[0]));
				}
#line 33441 "gram.c" /* yacc.c:1646  */
    break;

  case 626:
#line 4832 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("restart", (Node *) (yyvsp[0].node), (yylsp[-2]));
				}
#line 33449 "gram.c" /* yacc.c:1646  */
    break;

  case 629:
#line 4842 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeFloat((yyvsp[0].str)); }
#line 33455 "gram.c" /* yacc.c:1646  */
    break;

  case 630:
#line 4843 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeFloat((yyvsp[0].str)); }
#line 33461 "gram.c" /* yacc.c:1646  */
    break;

  case 631:
#line 4845 "gram.y" /* yacc.c:1646  */
    {
					Float	   *f = makeFloat((yyvsp[0].str));

					doNegateFloat(f);
					(yyval.node) = (Node *) f;
				}
#line 33472 "gram.c" /* yacc.c:1646  */
    break;

  case 632:
#line 4851 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeInteger((yyvsp[0].ival)); }
#line 33478 "gram.c" /* yacc.c:1646  */
    break;

  case 633:
#line 4854 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 33484 "gram.c" /* yacc.c:1646  */
    break;

  case 634:
#line 4855 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node)); }
#line 33490 "gram.c" /* yacc.c:1646  */
    break;

  case 635:
#line 4868 "gram.y" /* yacc.c:1646  */
    {
				/*
				 * We now interpret parameterless CREATE LANGUAGE as
				 * CREATE EXTENSION.  "OR REPLACE" is silently translated
				 * to "IF NOT EXISTS", which isn't quite the same, but
				 * seems more useful than throwing an error.  We just
				 * ignore TRUSTED, as the previous code would have too.
				 */
				CreateExtensionStmt *n = makeNode(CreateExtensionStmt);

				n->if_not_exists = (yyvsp[-4].boolean);
				n->extname = (yyvsp[0].str);
				n->options = NIL;
				(yyval.node) = (Node *) n;
			}
#line 33510 "gram.c" /* yacc.c:1646  */
    break;

  case 636:
#line 4885 "gram.y" /* yacc.c:1646  */
    {
				CreatePLangStmt *n = makeNode(CreatePLangStmt);

				n->replace = (yyvsp[-8].boolean);
				n->plname = (yyvsp[-4].str);
				n->plhandler = (yyvsp[-2].list);
				n->plinline = (yyvsp[-1].list);
				n->plvalidator = (yyvsp[0].list);
				n->pltrusted = (yyvsp[-7].boolean);
				(yyval.node) = (Node *) n;
			}
#line 33526 "gram.c" /* yacc.c:1646  */
    break;

  case 637:
#line 4899 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 33532 "gram.c" /* yacc.c:1646  */
    break;

  case 638:
#line 4900 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 33538 "gram.c" /* yacc.c:1646  */
    break;

  case 639:
#line 4908 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeString((yyvsp[0].str))); }
#line 33544 "gram.c" /* yacc.c:1646  */
    break;

  case 640:
#line 4909 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lcons(makeString((yyvsp[-1].str)), (yyvsp[0].list)); }
#line 33550 "gram.c" /* yacc.c:1646  */
    break;

  case 641:
#line 4913 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 33556 "gram.c" /* yacc.c:1646  */
    break;

  case 642:
#line 4914 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 33562 "gram.c" /* yacc.c:1646  */
    break;

  case 643:
#line 4918 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 33568 "gram.c" /* yacc.c:1646  */
    break;

  case 644:
#line 4919 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 33574 "gram.c" /* yacc.c:1646  */
    break;

  case 645:
#line 4923 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 33580 "gram.c" /* yacc.c:1646  */
    break;

  case 646:
#line 4924 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 33586 "gram.c" /* yacc.c:1646  */
    break;

  case 649:
#line 4940 "gram.y" /* yacc.c:1646  */
    {
					CreateTableSpaceStmt *n = makeNode(CreateTableSpaceStmt);

					n->tablespacename = (yyvsp[-4].str);
					n->owner = (yyvsp[-3].rolespec);
					n->location = (yyvsp[-1].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 33600 "gram.c" /* yacc.c:1646  */
    break;

  case 650:
#line 4951 "gram.y" /* yacc.c:1646  */
    { (yyval.rolespec) = (yyvsp[0].rolespec); }
#line 33606 "gram.c" /* yacc.c:1646  */
    break;

  case 651:
#line 4952 "gram.y" /* yacc.c:1646  */
    { (yyval.rolespec) = NULL; }
#line 33612 "gram.c" /* yacc.c:1646  */
    break;

  case 652:
#line 4966 "gram.y" /* yacc.c:1646  */
    {
					DropTableSpaceStmt *n = makeNode(DropTableSpaceStmt);

					n->tablespacename = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 33624 "gram.c" /* yacc.c:1646  */
    break;

  case 653:
#line 4974 "gram.y" /* yacc.c:1646  */
    {
					DropTableSpaceStmt *n = makeNode(DropTableSpaceStmt);

					n->tablespacename = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 33636 "gram.c" /* yacc.c:1646  */
    break;

  case 654:
#line 4992 "gram.y" /* yacc.c:1646  */
    {
					CreateExtensionStmt *n = makeNode(CreateExtensionStmt);

					n->extname = (yyvsp[-2].str);
					n->if_not_exists = false;
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 33649 "gram.c" /* yacc.c:1646  */
    break;

  case 655:
#line 5001 "gram.y" /* yacc.c:1646  */
    {
					CreateExtensionStmt *n = makeNode(CreateExtensionStmt);

					n->extname = (yyvsp[-2].str);
					n->if_not_exists = true;
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 33662 "gram.c" /* yacc.c:1646  */
    break;

  case 656:
#line 5013 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].defelt)); }
#line 33668 "gram.c" /* yacc.c:1646  */
    break;

  case 657:
#line 5015 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 33674 "gram.c" /* yacc.c:1646  */
    break;

  case 658:
#line 5020 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("schema", (Node *) makeString((yyvsp[0].str)), (yylsp[-1]));
				}
#line 33682 "gram.c" /* yacc.c:1646  */
    break;

  case 659:
#line 5024 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("new_version", (Node *) makeString((yyvsp[0].str)), (yylsp[-1]));
				}
#line 33690 "gram.c" /* yacc.c:1646  */
    break;

  case 660:
#line 5028 "gram.y" /* yacc.c:1646  */
    {
					ereport(ERROR,
							(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
							 errmsg("CREATE EXTENSION ... FROM is no longer supported"),
							 parser_errposition((yylsp[-1]))));
				}
#line 33701 "gram.c" /* yacc.c:1646  */
    break;

  case 661:
#line 5035 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("cascade", (Node *) makeBoolean(true), (yylsp[0]));
				}
#line 33709 "gram.c" /* yacc.c:1646  */
    break;

  case 662:
#line 5047 "gram.y" /* yacc.c:1646  */
    {
					AlterExtensionStmt *n = makeNode(AlterExtensionStmt);

					n->extname = (yyvsp[-2].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 33721 "gram.c" /* yacc.c:1646  */
    break;

  case 663:
#line 5058 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].defelt)); }
#line 33727 "gram.c" /* yacc.c:1646  */
    break;

  case 664:
#line 5060 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 33733 "gram.c" /* yacc.c:1646  */
    break;

  case 665:
#line 5065 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("new_version", (Node *) makeString((yyvsp[0].str)), (yylsp[-1]));
				}
#line 33741 "gram.c" /* yacc.c:1646  */
    break;

  case 666:
#line 5078 "gram.y" /* yacc.c:1646  */
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);

					n->extname = (yyvsp[-3].str);
					n->action = (yyvsp[-2].ival);
					n->objtype = (yyvsp[-1].objtype);
					n->object = (Node *) makeString((yyvsp[0].str));
					(yyval.node) = (Node *) n;
				}
#line 33755 "gram.c" /* yacc.c:1646  */
    break;

  case 667:
#line 5088 "gram.y" /* yacc.c:1646  */
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);

					n->extname = (yyvsp[-3].str);
					n->action = (yyvsp[-2].ival);
					n->objtype = (yyvsp[-1].objtype);
					n->object = (Node *) (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 33769 "gram.c" /* yacc.c:1646  */
    break;

  case 668:
#line 5098 "gram.y" /* yacc.c:1646  */
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);

					n->extname = (yyvsp[-3].str);
					n->action = (yyvsp[-2].ival);
					n->objtype = OBJECT_AGGREGATE;
					n->object = (Node *) (yyvsp[0].objwithargs);
					(yyval.node) = (Node *) n;
				}
#line 33783 "gram.c" /* yacc.c:1646  */
    break;

  case 669:
#line 5108 "gram.y" /* yacc.c:1646  */
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);

					n->extname = (yyvsp[-7].str);
					n->action = (yyvsp[-6].ival);
					n->objtype = OBJECT_CAST;
					n->object = (Node *) list_make2((yyvsp[-3].typnam), (yyvsp[-1].typnam));
					(yyval.node) = (Node *) n;
				}
#line 33797 "gram.c" /* yacc.c:1646  */
    break;

  case 670:
#line 5118 "gram.y" /* yacc.c:1646  */
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);

					n->extname = (yyvsp[-3].str);
					n->action = (yyvsp[-2].ival);
					n->objtype = OBJECT_DOMAIN;
					n->object = (Node *) (yyvsp[0].typnam);
					(yyval.node) = (Node *) n;
				}
#line 33811 "gram.c" /* yacc.c:1646  */
    break;

  case 671:
#line 5128 "gram.y" /* yacc.c:1646  */
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);

					n->extname = (yyvsp[-3].str);
					n->action = (yyvsp[-2].ival);
					n->objtype = OBJECT_FUNCTION;
					n->object = (Node *) (yyvsp[0].objwithargs);
					(yyval.node) = (Node *) n;
				}
#line 33825 "gram.c" /* yacc.c:1646  */
    break;

  case 672:
#line 5138 "gram.y" /* yacc.c:1646  */
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);

					n->extname = (yyvsp[-3].str);
					n->action = (yyvsp[-2].ival);
					n->objtype = OBJECT_OPERATOR;
					n->object = (Node *) (yyvsp[0].objwithargs);
					(yyval.node) = (Node *) n;
				}
#line 33839 "gram.c" /* yacc.c:1646  */
    break;

  case 673:
#line 5148 "gram.y" /* yacc.c:1646  */
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);

					n->extname = (yyvsp[-6].str);
					n->action = (yyvsp[-5].ival);
					n->objtype = OBJECT_OPCLASS;
					n->object = (Node *) lcons(makeString((yyvsp[0].str)), (yyvsp[-2].list));
					(yyval.node) = (Node *) n;
				}
#line 33853 "gram.c" /* yacc.c:1646  */
    break;

  case 674:
#line 5158 "gram.y" /* yacc.c:1646  */
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);

					n->extname = (yyvsp[-6].str);
					n->action = (yyvsp[-5].ival);
					n->objtype = OBJECT_OPFAMILY;
					n->object = (Node *) lcons(makeString((yyvsp[0].str)), (yyvsp[-2].list));
					(yyval.node) = (Node *) n;
				}
#line 33867 "gram.c" /* yacc.c:1646  */
    break;

  case 675:
#line 5168 "gram.y" /* yacc.c:1646  */
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);

					n->extname = (yyvsp[-3].str);
					n->action = (yyvsp[-2].ival);
					n->objtype = OBJECT_PROCEDURE;
					n->object = (Node *) (yyvsp[0].objwithargs);
					(yyval.node) = (Node *) n;
				}
#line 33881 "gram.c" /* yacc.c:1646  */
    break;

  case 676:
#line 5178 "gram.y" /* yacc.c:1646  */
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);

					n->extname = (yyvsp[-3].str);
					n->action = (yyvsp[-2].ival);
					n->objtype = OBJECT_ROUTINE;
					n->object = (Node *) (yyvsp[0].objwithargs);
					(yyval.node) = (Node *) n;
				}
#line 33895 "gram.c" /* yacc.c:1646  */
    break;

  case 677:
#line 5188 "gram.y" /* yacc.c:1646  */
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);

					n->extname = (yyvsp[-6].str);
					n->action = (yyvsp[-5].ival);
					n->objtype = OBJECT_TRANSFORM;
					n->object = (Node *) list_make2((yyvsp[-2].typnam), makeString((yyvsp[0].str)));
					(yyval.node) = (Node *) n;
				}
#line 33909 "gram.c" /* yacc.c:1646  */
    break;

  case 678:
#line 5198 "gram.y" /* yacc.c:1646  */
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);

					n->extname = (yyvsp[-3].str);
					n->action = (yyvsp[-2].ival);
					n->objtype = OBJECT_TYPE;
					n->object = (Node *) (yyvsp[0].typnam);
					(yyval.node) = (Node *) n;
				}
#line 33923 "gram.c" /* yacc.c:1646  */
    break;

  case 679:
#line 5217 "gram.y" /* yacc.c:1646  */
    {
					CreateFdwStmt *n = makeNode(CreateFdwStmt);

					n->fdwname = (yyvsp[-2].str);
					n->func_options = (yyvsp[-1].list);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 33936 "gram.c" /* yacc.c:1646  */
    break;

  case 680:
#line 5228 "gram.y" /* yacc.c:1646  */
    { (yyval.defelt) = makeDefElem("handler", (Node *) (yyvsp[0].list), (yylsp[-1])); }
#line 33942 "gram.c" /* yacc.c:1646  */
    break;

  case 681:
#line 5229 "gram.y" /* yacc.c:1646  */
    { (yyval.defelt) = makeDefElem("handler", NULL, (yylsp[-1])); }
#line 33948 "gram.c" /* yacc.c:1646  */
    break;

  case 682:
#line 5230 "gram.y" /* yacc.c:1646  */
    { (yyval.defelt) = makeDefElem("validator", (Node *) (yyvsp[0].list), (yylsp[-1])); }
#line 33954 "gram.c" /* yacc.c:1646  */
    break;

  case 683:
#line 5231 "gram.y" /* yacc.c:1646  */
    { (yyval.defelt) = makeDefElem("validator", NULL, (yylsp[-1])); }
#line 33960 "gram.c" /* yacc.c:1646  */
    break;

  case 684:
#line 5235 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].defelt)); }
#line 33966 "gram.c" /* yacc.c:1646  */
    break;

  case 685:
#line 5236 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].defelt)); }
#line 33972 "gram.c" /* yacc.c:1646  */
    break;

  case 686:
#line 5240 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 33978 "gram.c" /* yacc.c:1646  */
    break;

  case 687:
#line 5241 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 33984 "gram.c" /* yacc.c:1646  */
    break;

  case 688:
#line 5252 "gram.y" /* yacc.c:1646  */
    {
					AlterFdwStmt *n = makeNode(AlterFdwStmt);

					n->fdwname = (yyvsp[-2].str);
					n->func_options = (yyvsp[-1].list);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 33997 "gram.c" /* yacc.c:1646  */
    break;

  case 689:
#line 5261 "gram.y" /* yacc.c:1646  */
    {
					AlterFdwStmt *n = makeNode(AlterFdwStmt);

					n->fdwname = (yyvsp[-1].str);
					n->func_options = (yyvsp[0].list);
					n->options = NIL;
					(yyval.node) = (Node *) n;
				}
#line 34010 "gram.c" /* yacc.c:1646  */
    break;

  case 690:
#line 5273 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 34016 "gram.c" /* yacc.c:1646  */
    break;

  case 691:
#line 5274 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 34022 "gram.c" /* yacc.c:1646  */
    break;

  case 692:
#line 5279 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make1((yyvsp[0].defelt));
				}
#line 34030 "gram.c" /* yacc.c:1646  */
    break;

  case 693:
#line 5283 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].defelt));
				}
#line 34038 "gram.c" /* yacc.c:1646  */
    break;

  case 694:
#line 5290 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 34044 "gram.c" /* yacc.c:1646  */
    break;

  case 695:
#line 5295 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make1((yyvsp[0].defelt));
				}
#line 34052 "gram.c" /* yacc.c:1646  */
    break;

  case 696:
#line 5299 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].defelt));
				}
#line 34060 "gram.c" /* yacc.c:1646  */
    break;

  case 697:
#line 5306 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = (yyvsp[0].defelt);
				}
#line 34068 "gram.c" /* yacc.c:1646  */
    break;

  case 698:
#line 5310 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = (yyvsp[0].defelt);
					(yyval.defelt)->defaction = DEFELEM_SET;
				}
#line 34077 "gram.c" /* yacc.c:1646  */
    break;

  case 699:
#line 5315 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = (yyvsp[0].defelt);
					(yyval.defelt)->defaction = DEFELEM_ADD;
				}
#line 34086 "gram.c" /* yacc.c:1646  */
    break;

  case 700:
#line 5320 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElemExtended(NULL, (yyvsp[0].str), NULL, DEFELEM_DROP, (yylsp[0]));
				}
#line 34094 "gram.c" /* yacc.c:1646  */
    break;

  case 701:
#line 5327 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem((yyvsp[-1].str), (yyvsp[0].node), (yylsp[-1]));
				}
#line 34102 "gram.c" /* yacc.c:1646  */
    break;

  case 702:
#line 5333 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 34108 "gram.c" /* yacc.c:1646  */
    break;

  case 703:
#line 5338 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeString((yyvsp[0].str)); }
#line 34114 "gram.c" /* yacc.c:1646  */
    break;

  case 704:
#line 5350 "gram.y" /* yacc.c:1646  */
    {
					CreateForeignServerStmt *n = makeNode(CreateForeignServerStmt);

					n->servername = (yyvsp[-7].str);
					n->servertype = (yyvsp[-6].str);
					n->version = (yyvsp[-5].str);
					n->fdwname = (yyvsp[-1].str);
					n->options = (yyvsp[0].list);
					n->if_not_exists = false;
					(yyval.node) = (Node *) n;
				}
#line 34130 "gram.c" /* yacc.c:1646  */
    break;

  case 705:
#line 5363 "gram.y" /* yacc.c:1646  */
    {
					CreateForeignServerStmt *n = makeNode(CreateForeignServerStmt);

					n->servername = (yyvsp[-7].str);
					n->servertype = (yyvsp[-6].str);
					n->version = (yyvsp[-5].str);
					n->fdwname = (yyvsp[-1].str);
					n->options = (yyvsp[0].list);
					n->if_not_exists = true;
					(yyval.node) = (Node *) n;
				}
#line 34146 "gram.c" /* yacc.c:1646  */
    break;

  case 706:
#line 5377 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 34152 "gram.c" /* yacc.c:1646  */
    break;

  case 707:
#line 5378 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = NULL; }
#line 34158 "gram.c" /* yacc.c:1646  */
    break;

  case 708:
#line 5383 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 34164 "gram.c" /* yacc.c:1646  */
    break;

  case 709:
#line 5384 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = NULL; }
#line 34170 "gram.c" /* yacc.c:1646  */
    break;

  case 710:
#line 5388 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 34176 "gram.c" /* yacc.c:1646  */
    break;

  case 711:
#line 5389 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = NULL; }
#line 34182 "gram.c" /* yacc.c:1646  */
    break;

  case 712:
#line 5400 "gram.y" /* yacc.c:1646  */
    {
					AlterForeignServerStmt *n = makeNode(AlterForeignServerStmt);

					n->servername = (yyvsp[-2].str);
					n->version = (yyvsp[-1].str);
					n->options = (yyvsp[0].list);
					n->has_version = true;
					(yyval.node) = (Node *) n;
				}
#line 34196 "gram.c" /* yacc.c:1646  */
    break;

  case 713:
#line 5410 "gram.y" /* yacc.c:1646  */
    {
					AlterForeignServerStmt *n = makeNode(AlterForeignServerStmt);

					n->servername = (yyvsp[-1].str);
					n->version = (yyvsp[0].str);
					n->has_version = true;
					(yyval.node) = (Node *) n;
				}
#line 34209 "gram.c" /* yacc.c:1646  */
    break;

  case 714:
#line 5419 "gram.y" /* yacc.c:1646  */
    {
					AlterForeignServerStmt *n = makeNode(AlterForeignServerStmt);

					n->servername = (yyvsp[-1].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 34221 "gram.c" /* yacc.c:1646  */
    break;

  case 715:
#line 5439 "gram.y" /* yacc.c:1646  */
    {
					CreateForeignTableStmt *n = makeNode(CreateForeignTableStmt);

					(yyvsp[-7].range)->relpersistence = RELPERSISTENCE_PERMANENT;
					n->base.relation = (yyvsp[-7].range);
					n->base.tableElts = (yyvsp[-5].list);
					n->base.inhRelations = (yyvsp[-3].list);
					n->base.ofTypename = NULL;
					n->base.constraints = NIL;
					n->base.options = NIL;
					n->base.oncommit = ONCOMMIT_NOOP;
					n->base.tablespacename = NULL;
					n->base.if_not_exists = false;
					/* FDW-specific data */
					n->servername = (yyvsp[-1].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 34244 "gram.c" /* yacc.c:1646  */
    break;

  case 716:
#line 5460 "gram.y" /* yacc.c:1646  */
    {
					CreateForeignTableStmt *n = makeNode(CreateForeignTableStmt);

					(yyvsp[-7].range)->relpersistence = RELPERSISTENCE_PERMANENT;
					n->base.relation = (yyvsp[-7].range);
					n->base.tableElts = (yyvsp[-5].list);
					n->base.inhRelations = (yyvsp[-3].list);
					n->base.ofTypename = NULL;
					n->base.constraints = NIL;
					n->base.options = NIL;
					n->base.oncommit = ONCOMMIT_NOOP;
					n->base.tablespacename = NULL;
					n->base.if_not_exists = true;
					/* FDW-specific data */
					n->servername = (yyvsp[-1].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 34267 "gram.c" /* yacc.c:1646  */
    break;

  case 717:
#line 5481 "gram.y" /* yacc.c:1646  */
    {
					CreateForeignTableStmt *n = makeNode(CreateForeignTableStmt);

					(yyvsp[-8].range)->relpersistence = RELPERSISTENCE_PERMANENT;
					n->base.relation = (yyvsp[-8].range);
					n->base.inhRelations = list_make1((yyvsp[-5].range));
					n->base.tableElts = (yyvsp[-4].list);
					n->base.partbound = (yyvsp[-3].partboundspec);
					n->base.ofTypename = NULL;
					n->base.constraints = NIL;
					n->base.options = NIL;
					n->base.oncommit = ONCOMMIT_NOOP;
					n->base.tablespacename = NULL;
					n->base.if_not_exists = false;
					/* FDW-specific data */
					n->servername = (yyvsp[-1].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 34291 "gram.c" /* yacc.c:1646  */
    break;

  case 718:
#line 5503 "gram.y" /* yacc.c:1646  */
    {
					CreateForeignTableStmt *n = makeNode(CreateForeignTableStmt);

					(yyvsp[-8].range)->relpersistence = RELPERSISTENCE_PERMANENT;
					n->base.relation = (yyvsp[-8].range);
					n->base.inhRelations = list_make1((yyvsp[-5].range));
					n->base.tableElts = (yyvsp[-4].list);
					n->base.partbound = (yyvsp[-3].partboundspec);
					n->base.ofTypename = NULL;
					n->base.constraints = NIL;
					n->base.options = NIL;
					n->base.oncommit = ONCOMMIT_NOOP;
					n->base.tablespacename = NULL;
					n->base.if_not_exists = true;
					/* FDW-specific data */
					n->servername = (yyvsp[-1].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 34315 "gram.c" /* yacc.c:1646  */
    break;

  case 719:
#line 5536 "gram.y" /* yacc.c:1646  */
    {
				ImportForeignSchemaStmt *n = makeNode(ImportForeignSchemaStmt);

				n->server_name = (yyvsp[-3].str);
				n->remote_schema = (yyvsp[-7].str);
				n->local_schema = (yyvsp[-1].str);
				n->list_type = (yyvsp[-6].importqual)->type;
				n->table_list = (yyvsp[-6].importqual)->table_names;
				n->options = (yyvsp[0].list);
				(yyval.node) = (Node *) n;
			}
#line 34331 "gram.c" /* yacc.c:1646  */
    break;

  case 720:
#line 5550 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = FDW_IMPORT_SCHEMA_LIMIT_TO; }
#line 34337 "gram.c" /* yacc.c:1646  */
    break;

  case 721:
#line 5551 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = FDW_IMPORT_SCHEMA_EXCEPT; }
#line 34343 "gram.c" /* yacc.c:1646  */
    break;

  case 722:
#line 5556 "gram.y" /* yacc.c:1646  */
    {
				ImportQual *n = (ImportQual *) palloc(sizeof(ImportQual));

				n->type = (yyvsp[-3].ival);
				n->table_names = (yyvsp[-1].list);
				(yyval.importqual) = n;
			}
#line 34355 "gram.c" /* yacc.c:1646  */
    break;

  case 723:
#line 5564 "gram.y" /* yacc.c:1646  */
    {
				ImportQual *n = (ImportQual *) palloc(sizeof(ImportQual));
				n->type = FDW_IMPORT_SCHEMA_ALL;
				n->table_names = NIL;
				(yyval.importqual) = n;
			}
#line 34366 "gram.c" /* yacc.c:1646  */
    break;

  case 724:
#line 5580 "gram.y" /* yacc.c:1646  */
    {
					CreateUserMappingStmt *n = makeNode(CreateUserMappingStmt);

					n->user = (yyvsp[-3].rolespec);
					n->servername = (yyvsp[-1].str);
					n->options = (yyvsp[0].list);
					n->if_not_exists = false;
					(yyval.node) = (Node *) n;
				}
#line 34380 "gram.c" /* yacc.c:1646  */
    break;

  case 725:
#line 5590 "gram.y" /* yacc.c:1646  */
    {
					CreateUserMappingStmt *n = makeNode(CreateUserMappingStmt);

					n->user = (yyvsp[-3].rolespec);
					n->servername = (yyvsp[-1].str);
					n->options = (yyvsp[0].list);
					n->if_not_exists = true;
					(yyval.node) = (Node *) n;
				}
#line 34394 "gram.c" /* yacc.c:1646  */
    break;

  case 726:
#line 5602 "gram.y" /* yacc.c:1646  */
    { (yyval.rolespec) = (yyvsp[0].rolespec); }
#line 34400 "gram.c" /* yacc.c:1646  */
    break;

  case 727:
#line 5603 "gram.y" /* yacc.c:1646  */
    { (yyval.rolespec) = makeRoleSpec(ROLESPEC_CURRENT_USER, (yylsp[0])); }
#line 34406 "gram.c" /* yacc.c:1646  */
    break;

  case 728:
#line 5616 "gram.y" /* yacc.c:1646  */
    {
					DropUserMappingStmt *n = makeNode(DropUserMappingStmt);

					n->user = (yyvsp[-2].rolespec);
					n->servername = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 34419 "gram.c" /* yacc.c:1646  */
    break;

  case 729:
#line 5625 "gram.y" /* yacc.c:1646  */
    {
					DropUserMappingStmt *n = makeNode(DropUserMappingStmt);

					n->user = (yyvsp[-2].rolespec);
					n->servername = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 34432 "gram.c" /* yacc.c:1646  */
    break;

  case 730:
#line 5643 "gram.y" /* yacc.c:1646  */
    {
					AlterUserMappingStmt *n = makeNode(AlterUserMappingStmt);

					n->user = (yyvsp[-3].rolespec);
					n->servername = (yyvsp[-1].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 34445 "gram.c" /* yacc.c:1646  */
    break;

  case 731:
#line 5670 "gram.y" /* yacc.c:1646  */
    {
					CreatePolicyStmt *n = makeNode(CreatePolicyStmt);

					n->policy_name = (yyvsp[-7].str);
					n->table = (yyvsp[-5].range);
					n->permissive = (yyvsp[-4].boolean);
					n->cmd_name = (yyvsp[-3].str);
					n->roles = (yyvsp[-2].list);
					n->qual = (yyvsp[-1].node);
					n->with_check = (yyvsp[0].node);
					(yyval.node) = (Node *) n;
				}
#line 34462 "gram.c" /* yacc.c:1646  */
    break;

  case 732:
#line 5687 "gram.y" /* yacc.c:1646  */
    {
					AlterPolicyStmt *n = makeNode(AlterPolicyStmt);

					n->policy_name = (yyvsp[-5].str);
					n->table = (yyvsp[-3].range);
					n->roles = (yyvsp[-2].list);
					n->qual = (yyvsp[-1].node);
					n->with_check = (yyvsp[0].node);
					(yyval.node) = (Node *) n;
				}
#line 34477 "gram.c" /* yacc.c:1646  */
    break;

  case 733:
#line 5700 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[-1].node); }
#line 34483 "gram.c" /* yacc.c:1646  */
    break;

  case 734:
#line 5701 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 34489 "gram.c" /* yacc.c:1646  */
    break;

  case 735:
#line 5705 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[-1].node); }
#line 34495 "gram.c" /* yacc.c:1646  */
    break;

  case 736:
#line 5706 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 34501 "gram.c" /* yacc.c:1646  */
    break;

  case 737:
#line 5710 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 34507 "gram.c" /* yacc.c:1646  */
    break;

  case 738:
#line 5711 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeRoleSpec(ROLESPEC_PUBLIC, -1)); }
#line 34513 "gram.c" /* yacc.c:1646  */
    break;

  case 739:
#line 5715 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 34519 "gram.c" /* yacc.c:1646  */
    break;

  case 740:
#line 5716 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NULL; }
#line 34525 "gram.c" /* yacc.c:1646  */
    break;

  case 741:
#line 5721 "gram.y" /* yacc.c:1646  */
    {
					if (strcmp((yyvsp[0].str), "permissive") == 0)
						(yyval.boolean) = true;
					else if (strcmp((yyvsp[0].str), "restrictive") == 0)
						(yyval.boolean) = false;
					else
						ereport(ERROR,
								(errcode(ERRCODE_SYNTAX_ERROR),
								 errmsg("unrecognized row security option \"%s\"", (yyvsp[0].str)),
								 errhint("Only PERMISSIVE or RESTRICTIVE policies are supported currently."),
								 parser_errposition((yylsp[0]))));

				}
#line 34543 "gram.c" /* yacc.c:1646  */
    break;

  case 742:
#line 5734 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 34549 "gram.c" /* yacc.c:1646  */
    break;

  case 743:
#line 5738 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 34555 "gram.c" /* yacc.c:1646  */
    break;

  case 744:
#line 5739 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "all"; }
#line 34561 "gram.c" /* yacc.c:1646  */
    break;

  case 745:
#line 5743 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "all"; }
#line 34567 "gram.c" /* yacc.c:1646  */
    break;

  case 746:
#line 5744 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "select"; }
#line 34573 "gram.c" /* yacc.c:1646  */
    break;

  case 747:
#line 5745 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "insert"; }
#line 34579 "gram.c" /* yacc.c:1646  */
    break;

  case 748:
#line 5746 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "update"; }
#line 34585 "gram.c" /* yacc.c:1646  */
    break;

  case 749:
#line 5747 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "delete"; }
#line 34591 "gram.c" /* yacc.c:1646  */
    break;

  case 750:
#line 5758 "gram.y" /* yacc.c:1646  */
    {
					CreateAmStmt *n = makeNode(CreateAmStmt);

					n->amname = (yyvsp[-4].str);
					n->handler_name = (yyvsp[0].list);
					n->amtype = (yyvsp[-2].chr);
					(yyval.node) = (Node *) n;
				}
#line 34604 "gram.c" /* yacc.c:1646  */
    break;

  case 751:
#line 5769 "gram.y" /* yacc.c:1646  */
    { (yyval.chr) = AMTYPE_INDEX; }
#line 34610 "gram.c" /* yacc.c:1646  */
    break;

  case 752:
#line 5770 "gram.y" /* yacc.c:1646  */
    { (yyval.chr) = AMTYPE_TABLE; }
#line 34616 "gram.c" /* yacc.c:1646  */
    break;

  case 753:
#line 5784 "gram.y" /* yacc.c:1646  */
    {
					CreateTrigStmt *n = makeNode(CreateTrigStmt);

					n->replace = (yyvsp[-15].boolean);
					n->isconstraint = false;
					n->trigname = (yyvsp[-13].str);
					n->relation = (yyvsp[-9].range);
					n->funcname = (yyvsp[-3].list);
					n->args = (yyvsp[-1].list);
					n->row = (yyvsp[-7].boolean);
					n->timing = (yyvsp[-12].ival);
					n->events = intVal(linitial((yyvsp[-11].list)));
					n->columns = (List *) lsecond((yyvsp[-11].list));
					n->whenClause = (yyvsp[-6].node);
					n->transitionRels = (yyvsp[-8].list);
					n->deferrable = false;
					n->initdeferred = false;
					n->constrrel = NULL;
					(yyval.node) = (Node *) n;
				}
#line 34641 "gram.c" /* yacc.c:1646  */
    break;

  case 754:
#line 5808 "gram.y" /* yacc.c:1646  */
    {
					CreateTrigStmt *n = makeNode(CreateTrigStmt);

					n->replace = (yyvsp[-19].boolean);
					if (n->replace) /* not supported, see CreateTrigger */
						ereport(ERROR,
								(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
								 errmsg("CREATE OR REPLACE CONSTRAINT TRIGGER is not supported")));
					n->isconstraint = true;
					n->trigname = (yyvsp[-16].str);
					n->relation = (yyvsp[-12].range);
					n->funcname = (yyvsp[-3].list);
					n->args = (yyvsp[-1].list);
					n->row = true;
					n->timing = TRIGGER_TYPE_AFTER;
					n->events = intVal(linitial((yyvsp[-14].list)));
					n->columns = (List *) lsecond((yyvsp[-14].list));
					n->whenClause = (yyvsp[-6].node);
					n->transitionRels = NIL;
					processCASbits((yyvsp[-10].ival), (yylsp[-10]), "TRIGGER",
								   &n->deferrable, &n->initdeferred, NULL,
								   NULL, yyscanner);
					n->constrrel = (yyvsp[-11].range);
					(yyval.node) = (Node *) n;
				}
#line 34671 "gram.c" /* yacc.c:1646  */
    break;

  case 755:
#line 5836 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = TRIGGER_TYPE_BEFORE; }
#line 34677 "gram.c" /* yacc.c:1646  */
    break;

  case 756:
#line 5837 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = TRIGGER_TYPE_AFTER; }
#line 34683 "gram.c" /* yacc.c:1646  */
    break;

  case 757:
#line 5838 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = TRIGGER_TYPE_INSTEAD; }
#line 34689 "gram.c" /* yacc.c:1646  */
    break;

  case 758:
#line 5843 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 34695 "gram.c" /* yacc.c:1646  */
    break;

  case 759:
#line 5845 "gram.y" /* yacc.c:1646  */
    {
					int			events1 = intVal(linitial((yyvsp[-2].list)));
					int			events2 = intVal(linitial((yyvsp[0].list)));
					List	   *columns1 = (List *) lsecond((yyvsp[-2].list));
					List	   *columns2 = (List *) lsecond((yyvsp[0].list));

					if (events1 & events2)
						parser_yyerror("duplicate trigger events specified");
					/*
					 * concat'ing the columns lists loses information about
					 * which columns went with which event, but so long as
					 * only UPDATE carries columns and we disallow multiple
					 * UPDATE items, it doesn't matter.  Command execution
					 * should just ignore the columns for non-UPDATE events.
					 */
					(yyval.list) = list_make2(makeInteger(events1 | events2),
									list_concat(columns1, columns2));
				}
#line 34718 "gram.c" /* yacc.c:1646  */
    break;

  case 760:
#line 5867 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make2(makeInteger(TRIGGER_TYPE_INSERT), NIL); }
#line 34724 "gram.c" /* yacc.c:1646  */
    break;

  case 761:
#line 5869 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make2(makeInteger(TRIGGER_TYPE_DELETE), NIL); }
#line 34730 "gram.c" /* yacc.c:1646  */
    break;

  case 762:
#line 5871 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make2(makeInteger(TRIGGER_TYPE_UPDATE), NIL); }
#line 34736 "gram.c" /* yacc.c:1646  */
    break;

  case 763:
#line 5873 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make2(makeInteger(TRIGGER_TYPE_UPDATE), (yyvsp[0].list)); }
#line 34742 "gram.c" /* yacc.c:1646  */
    break;

  case 764:
#line 5875 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make2(makeInteger(TRIGGER_TYPE_TRUNCATE), NIL); }
#line 34748 "gram.c" /* yacc.c:1646  */
    break;

  case 765:
#line 5879 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 34754 "gram.c" /* yacc.c:1646  */
    break;

  case 766:
#line 5880 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 34760 "gram.c" /* yacc.c:1646  */
    break;

  case 767:
#line 5884 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 34766 "gram.c" /* yacc.c:1646  */
    break;

  case 768:
#line 5885 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].node)); }
#line 34772 "gram.c" /* yacc.c:1646  */
    break;

  case 769:
#line 5890 "gram.y" /* yacc.c:1646  */
    {
					TriggerTransition *n = makeNode(TriggerTransition);

					n->name = (yyvsp[0].str);
					n->isNew = (yyvsp[-3].boolean);
					n->isTable = (yyvsp[-2].boolean);
					(yyval.node) = (Node *) n;
				}
#line 34785 "gram.c" /* yacc.c:1646  */
    break;

  case 770:
#line 5901 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 34791 "gram.c" /* yacc.c:1646  */
    break;

  case 771:
#line 5902 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 34797 "gram.c" /* yacc.c:1646  */
    break;

  case 772:
#line 5906 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 34803 "gram.c" /* yacc.c:1646  */
    break;

  case 773:
#line 5915 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 34809 "gram.c" /* yacc.c:1646  */
    break;

  case 774:
#line 5919 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 34815 "gram.c" /* yacc.c:1646  */
    break;

  case 775:
#line 5924 "gram.y" /* yacc.c:1646  */
    {
					(yyval.boolean) = (yyvsp[0].boolean);
				}
#line 34823 "gram.c" /* yacc.c:1646  */
    break;

  case 776:
#line 5928 "gram.y" /* yacc.c:1646  */
    {
					/*
					 * If ROW/STATEMENT not specified, default to
					 * STATEMENT, per SQL
					 */
					(yyval.boolean) = false;
				}
#line 34835 "gram.c" /* yacc.c:1646  */
    break;

  case 779:
#line 5943 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 34841 "gram.c" /* yacc.c:1646  */
    break;

  case 780:
#line 5944 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 34847 "gram.c" /* yacc.c:1646  */
    break;

  case 781:
#line 5948 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[-1].node); }
#line 34853 "gram.c" /* yacc.c:1646  */
    break;

  case 782:
#line 5949 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 34859 "gram.c" /* yacc.c:1646  */
    break;

  case 785:
#line 5958 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 34865 "gram.c" /* yacc.c:1646  */
    break;

  case 786:
#line 5959 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node)); }
#line 34871 "gram.c" /* yacc.c:1646  */
    break;

  case 787:
#line 5960 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 34877 "gram.c" /* yacc.c:1646  */
    break;

  case 788:
#line 5965 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeString(psprintf("%d", (yyvsp[0].ival)));
				}
#line 34885 "gram.c" /* yacc.c:1646  */
    break;

  case 789:
#line 5968 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeString((yyvsp[0].str)); }
#line 34891 "gram.c" /* yacc.c:1646  */
    break;

  case 790:
#line 5969 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeString((yyvsp[0].str)); }
#line 34897 "gram.c" /* yacc.c:1646  */
    break;

  case 791:
#line 5970 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeString((yyvsp[0].str)); }
#line 34903 "gram.c" /* yacc.c:1646  */
    break;

  case 792:
#line 5974 "gram.y" /* yacc.c:1646  */
    { (yyval.range) = (yyvsp[0].range); }
#line 34909 "gram.c" /* yacc.c:1646  */
    break;

  case 793:
#line 5975 "gram.y" /* yacc.c:1646  */
    { (yyval.range) = NULL; }
#line 34915 "gram.c" /* yacc.c:1646  */
    break;

  case 794:
#line 5980 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = 0; }
#line 34921 "gram.c" /* yacc.c:1646  */
    break;

  case 795:
#line 5982 "gram.y" /* yacc.c:1646  */
    {
					/*
					 * We must complain about conflicting options.
					 * We could, but choose not to, complain about redundant
					 * options (ie, where $2's bit is already set in $1).
					 */
					int		newspec = (yyvsp[-1].ival) | (yyvsp[0].ival);

					/* special message for this case */
					if ((newspec & (CAS_NOT_DEFERRABLE | CAS_INITIALLY_DEFERRED)) == (CAS_NOT_DEFERRABLE | CAS_INITIALLY_DEFERRED))
						ereport(ERROR,
								(errcode(ERRCODE_SYNTAX_ERROR),
								 errmsg("constraint declared INITIALLY DEFERRED must be DEFERRABLE"),
								 parser_errposition((yylsp[0]))));
					/* generic message for other conflicts */
					if ((newspec & (CAS_NOT_DEFERRABLE | CAS_DEFERRABLE)) == (CAS_NOT_DEFERRABLE | CAS_DEFERRABLE) ||
						(newspec & (CAS_INITIALLY_IMMEDIATE | CAS_INITIALLY_DEFERRED)) == (CAS_INITIALLY_IMMEDIATE | CAS_INITIALLY_DEFERRED))
						ereport(ERROR,
								(errcode(ERRCODE_SYNTAX_ERROR),
								 errmsg("conflicting constraint properties"),
								 parser_errposition((yylsp[0]))));
					(yyval.ival) = newspec;
				}
#line 34949 "gram.c" /* yacc.c:1646  */
    break;

  case 796:
#line 6008 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = CAS_NOT_DEFERRABLE; }
#line 34955 "gram.c" /* yacc.c:1646  */
    break;

  case 797:
#line 6009 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = CAS_DEFERRABLE; }
#line 34961 "gram.c" /* yacc.c:1646  */
    break;

  case 798:
#line 6010 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = CAS_INITIALLY_IMMEDIATE; }
#line 34967 "gram.c" /* yacc.c:1646  */
    break;

  case 799:
#line 6011 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = CAS_INITIALLY_DEFERRED; }
#line 34973 "gram.c" /* yacc.c:1646  */
    break;

  case 800:
#line 6012 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = CAS_NOT_VALID; }
#line 34979 "gram.c" /* yacc.c:1646  */
    break;

  case 801:
#line 6013 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = CAS_NO_INHERIT; }
#line 34985 "gram.c" /* yacc.c:1646  */
    break;

  case 802:
#line 6028 "gram.y" /* yacc.c:1646  */
    {
					CreateEventTrigStmt *n = makeNode(CreateEventTrigStmt);

					n->trigname = (yyvsp[-7].str);
					n->eventname = (yyvsp[-5].str);
					n->whenclause = NULL;
					n->funcname = (yyvsp[-2].list);
					(yyval.node) = (Node *) n;
				}
#line 34999 "gram.c" /* yacc.c:1646  */
    break;

  case 803:
#line 6040 "gram.y" /* yacc.c:1646  */
    {
					CreateEventTrigStmt *n = makeNode(CreateEventTrigStmt);

					n->trigname = (yyvsp[-9].str);
					n->eventname = (yyvsp[-7].str);
					n->whenclause = (yyvsp[-5].list);
					n->funcname = (yyvsp[-2].list);
					(yyval.node) = (Node *) n;
				}
#line 35013 "gram.c" /* yacc.c:1646  */
    break;

  case 804:
#line 6053 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].defelt)); }
#line 35019 "gram.c" /* yacc.c:1646  */
    break;

  case 805:
#line 6055 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].defelt)); }
#line 35025 "gram.c" /* yacc.c:1646  */
    break;

  case 806:
#line 6060 "gram.y" /* yacc.c:1646  */
    { (yyval.defelt) = makeDefElem((yyvsp[-4].str), (Node *) (yyvsp[-1].list), (yylsp[-4])); }
#line 35031 "gram.c" /* yacc.c:1646  */
    break;

  case 807:
#line 6065 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeString((yyvsp[0].str))); }
#line 35037 "gram.c" /* yacc.c:1646  */
    break;

  case 808:
#line 6067 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), makeString((yyvsp[0].str))); }
#line 35043 "gram.c" /* yacc.c:1646  */
    break;

  case 809:
#line 6072 "gram.y" /* yacc.c:1646  */
    {
					AlterEventTrigStmt *n = makeNode(AlterEventTrigStmt);

					n->trigname = (yyvsp[-1].str);
					n->tgenabled = (yyvsp[0].chr);
					(yyval.node) = (Node *) n;
				}
#line 35055 "gram.c" /* yacc.c:1646  */
    break;

  case 810:
#line 6082 "gram.y" /* yacc.c:1646  */
    { (yyval.chr) = TRIGGER_FIRES_ON_ORIGIN; }
#line 35061 "gram.c" /* yacc.c:1646  */
    break;

  case 811:
#line 6083 "gram.y" /* yacc.c:1646  */
    { (yyval.chr) = TRIGGER_FIRES_ON_REPLICA; }
#line 35067 "gram.c" /* yacc.c:1646  */
    break;

  case 812:
#line 6084 "gram.y" /* yacc.c:1646  */
    { (yyval.chr) = TRIGGER_FIRES_ALWAYS; }
#line 35073 "gram.c" /* yacc.c:1646  */
    break;

  case 813:
#line 6085 "gram.y" /* yacc.c:1646  */
    { (yyval.chr) = TRIGGER_DISABLED; }
#line 35079 "gram.c" /* yacc.c:1646  */
    break;

  case 814:
#line 6097 "gram.y" /* yacc.c:1646  */
    {
					ereport(ERROR,
							(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
							 errmsg("CREATE ASSERTION is not yet implemented")));

					(yyval.node) = NULL;
				}
#line 35091 "gram.c" /* yacc.c:1646  */
    break;

  case 815:
#line 6116 "gram.y" /* yacc.c:1646  */
    {
					DefineStmt *n = makeNode(DefineStmt);

					n->kind = OBJECT_AGGREGATE;
					n->oldstyle = false;
					n->replace = (yyvsp[-4].boolean);
					n->defnames = (yyvsp[-2].list);
					n->args = (yyvsp[-1].list);
					n->definition = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 35107 "gram.c" /* yacc.c:1646  */
    break;

  case 816:
#line 6128 "gram.y" /* yacc.c:1646  */
    {
					/* old-style (pre-8.2) syntax for CREATE AGGREGATE */
					DefineStmt *n = makeNode(DefineStmt);

					n->kind = OBJECT_AGGREGATE;
					n->oldstyle = true;
					n->replace = (yyvsp[-3].boolean);
					n->defnames = (yyvsp[-1].list);
					n->args = NIL;
					n->definition = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 35124 "gram.c" /* yacc.c:1646  */
    break;

  case 817:
#line 6141 "gram.y" /* yacc.c:1646  */
    {
					DefineStmt *n = makeNode(DefineStmt);

					n->kind = OBJECT_OPERATOR;
					n->oldstyle = false;
					n->defnames = (yyvsp[-1].list);
					n->args = NIL;
					n->definition = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 35139 "gram.c" /* yacc.c:1646  */
    break;

  case 818:
#line 6152 "gram.y" /* yacc.c:1646  */
    {
					DefineStmt *n = makeNode(DefineStmt);

					n->kind = OBJECT_TYPE;
					n->oldstyle = false;
					n->defnames = (yyvsp[-1].list);
					n->args = NIL;
					n->definition = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 35154 "gram.c" /* yacc.c:1646  */
    break;

  case 819:
#line 6163 "gram.y" /* yacc.c:1646  */
    {
					/* Shell type (identified by lack of definition) */
					DefineStmt *n = makeNode(DefineStmt);

					n->kind = OBJECT_TYPE;
					n->oldstyle = false;
					n->defnames = (yyvsp[0].list);
					n->args = NIL;
					n->definition = NIL;
					(yyval.node) = (Node *) n;
				}
#line 35170 "gram.c" /* yacc.c:1646  */
    break;

  case 820:
#line 6175 "gram.y" /* yacc.c:1646  */
    {
					CompositeTypeStmt *n = makeNode(CompositeTypeStmt);

					/* can't use qualified_name, sigh */
					n->typevar = makeRangeVarFromAnyName((yyvsp[-4].list), (yylsp[-4]), yyscanner);
					n->coldeflist = (yyvsp[-1].list);
					(yyval.node) = (Node *) n;
				}
#line 35183 "gram.c" /* yacc.c:1646  */
    break;

  case 821:
#line 6184 "gram.y" /* yacc.c:1646  */
    {
					CreateEnumStmt *n = makeNode(CreateEnumStmt);

					n->typeName = (yyvsp[-5].list);
					n->vals = (yyvsp[-1].list);
					(yyval.node) = (Node *) n;
				}
#line 35195 "gram.c" /* yacc.c:1646  */
    break;

  case 822:
#line 6192 "gram.y" /* yacc.c:1646  */
    {
					CreateRangeStmt *n = makeNode(CreateRangeStmt);

					n->typeName = (yyvsp[-3].list);
					n->params = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 35207 "gram.c" /* yacc.c:1646  */
    break;

  case 823:
#line 6200 "gram.y" /* yacc.c:1646  */
    {
					DefineStmt *n = makeNode(DefineStmt);

					n->kind = OBJECT_TSPARSER;
					n->args = NIL;
					n->defnames = (yyvsp[-1].list);
					n->definition = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 35221 "gram.c" /* yacc.c:1646  */
    break;

  case 824:
#line 6210 "gram.y" /* yacc.c:1646  */
    {
					DefineStmt *n = makeNode(DefineStmt);

					n->kind = OBJECT_TSDICTIONARY;
					n->args = NIL;
					n->defnames = (yyvsp[-1].list);
					n->definition = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 35235 "gram.c" /* yacc.c:1646  */
    break;

  case 825:
#line 6220 "gram.y" /* yacc.c:1646  */
    {
					DefineStmt *n = makeNode(DefineStmt);

					n->kind = OBJECT_TSTEMPLATE;
					n->args = NIL;
					n->defnames = (yyvsp[-1].list);
					n->definition = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 35249 "gram.c" /* yacc.c:1646  */
    break;

  case 826:
#line 6230 "gram.y" /* yacc.c:1646  */
    {
					DefineStmt *n = makeNode(DefineStmt);

					n->kind = OBJECT_TSCONFIGURATION;
					n->args = NIL;
					n->defnames = (yyvsp[-1].list);
					n->definition = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 35263 "gram.c" /* yacc.c:1646  */
    break;

  case 827:
#line 6240 "gram.y" /* yacc.c:1646  */
    {
					DefineStmt *n = makeNode(DefineStmt);

					n->kind = OBJECT_COLLATION;
					n->args = NIL;
					n->defnames = (yyvsp[-1].list);
					n->definition = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 35277 "gram.c" /* yacc.c:1646  */
    break;

  case 828:
#line 6250 "gram.y" /* yacc.c:1646  */
    {
					DefineStmt *n = makeNode(DefineStmt);

					n->kind = OBJECT_COLLATION;
					n->args = NIL;
					n->defnames = (yyvsp[-1].list);
					n->definition = (yyvsp[0].list);
					n->if_not_exists = true;
					(yyval.node) = (Node *) n;
				}
#line 35292 "gram.c" /* yacc.c:1646  */
    break;

  case 829:
#line 6261 "gram.y" /* yacc.c:1646  */
    {
					DefineStmt *n = makeNode(DefineStmt);

					n->kind = OBJECT_COLLATION;
					n->args = NIL;
					n->defnames = (yyvsp[-2].list);
					n->definition = list_make1(makeDefElem("from", (Node *) (yyvsp[0].list), (yylsp[0])));
					(yyval.node) = (Node *) n;
				}
#line 35306 "gram.c" /* yacc.c:1646  */
    break;

  case 830:
#line 6271 "gram.y" /* yacc.c:1646  */
    {
					DefineStmt *n = makeNode(DefineStmt);

					n->kind = OBJECT_COLLATION;
					n->args = NIL;
					n->defnames = (yyvsp[-2].list);
					n->definition = list_make1(makeDefElem("from", (Node *) (yyvsp[0].list), (yylsp[0])));
					n->if_not_exists = true;
					(yyval.node) = (Node *) n;
				}
#line 35321 "gram.c" /* yacc.c:1646  */
    break;

  case 831:
#line 6283 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 35327 "gram.c" /* yacc.c:1646  */
    break;

  case 832:
#line 6286 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].defelt)); }
#line 35333 "gram.c" /* yacc.c:1646  */
    break;

  case 833:
#line 6287 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].defelt)); }
#line 35339 "gram.c" /* yacc.c:1646  */
    break;

  case 834:
#line 6291 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem((yyvsp[-2].str), (Node *) (yyvsp[0].node), (yylsp[-2]));
				}
#line 35347 "gram.c" /* yacc.c:1646  */
    break;

  case 835:
#line 6295 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem((yyvsp[0].str), NULL, (yylsp[0]));
				}
#line 35355 "gram.c" /* yacc.c:1646  */
    break;

  case 836:
#line 6301 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) (yyvsp[0].typnam); }
#line 35361 "gram.c" /* yacc.c:1646  */
    break;

  case 837:
#line 6302 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeString(pstrdup((yyvsp[0].keyword))); }
#line 35367 "gram.c" /* yacc.c:1646  */
    break;

  case 838:
#line 6303 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) (yyvsp[0].list); }
#line 35373 "gram.c" /* yacc.c:1646  */
    break;

  case 839:
#line 6304 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) (yyvsp[0].node); }
#line 35379 "gram.c" /* yacc.c:1646  */
    break;

  case 840:
#line 6305 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeString((yyvsp[0].str)); }
#line 35385 "gram.c" /* yacc.c:1646  */
    break;

  case 841:
#line 6306 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeString(pstrdup((yyvsp[0].keyword))); }
#line 35391 "gram.c" /* yacc.c:1646  */
    break;

  case 842:
#line 6309 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 35397 "gram.c" /* yacc.c:1646  */
    break;

  case 843:
#line 6312 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].defelt)); }
#line 35403 "gram.c" /* yacc.c:1646  */
    break;

  case 844:
#line 6313 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].defelt)); }
#line 35409 "gram.c" /* yacc.c:1646  */
    break;

  case 845:
#line 6322 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem((yyvsp[-2].str), (Node *) (yyvsp[0].node), (yylsp[-2]));
				}
#line 35417 "gram.c" /* yacc.c:1646  */
    break;

  case 846:
#line 6328 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 35423 "gram.c" /* yacc.c:1646  */
    break;

  case 847:
#line 6329 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 35429 "gram.c" /* yacc.c:1646  */
    break;

  case 848:
#line 6333 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeString((yyvsp[0].str))); }
#line 35435 "gram.c" /* yacc.c:1646  */
    break;

  case 849:
#line 6335 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), makeString((yyvsp[0].str))); }
#line 35441 "gram.c" /* yacc.c:1646  */
    break;

  case 850:
#line 6346 "gram.y" /* yacc.c:1646  */
    {
				AlterEnumStmt *n = makeNode(AlterEnumStmt);

				n->typeName = (yyvsp[-4].list);
				n->oldVal = NULL;
				n->newVal = (yyvsp[0].str);
				n->newValNeighbor = NULL;
				n->newValIsAfter = true;
				n->skipIfNewValExists = (yyvsp[-1].boolean);
				(yyval.node) = (Node *) n;
			}
#line 35457 "gram.c" /* yacc.c:1646  */
    break;

  case 851:
#line 6358 "gram.y" /* yacc.c:1646  */
    {
				AlterEnumStmt *n = makeNode(AlterEnumStmt);

				n->typeName = (yyvsp[-6].list);
				n->oldVal = NULL;
				n->newVal = (yyvsp[-2].str);
				n->newValNeighbor = (yyvsp[0].str);
				n->newValIsAfter = false;
				n->skipIfNewValExists = (yyvsp[-3].boolean);
				(yyval.node) = (Node *) n;
			}
#line 35473 "gram.c" /* yacc.c:1646  */
    break;

  case 852:
#line 6370 "gram.y" /* yacc.c:1646  */
    {
				AlterEnumStmt *n = makeNode(AlterEnumStmt);

				n->typeName = (yyvsp[-6].list);
				n->oldVal = NULL;
				n->newVal = (yyvsp[-2].str);
				n->newValNeighbor = (yyvsp[0].str);
				n->newValIsAfter = true;
				n->skipIfNewValExists = (yyvsp[-3].boolean);
				(yyval.node) = (Node *) n;
			}
#line 35489 "gram.c" /* yacc.c:1646  */
    break;

  case 853:
#line 6382 "gram.y" /* yacc.c:1646  */
    {
				AlterEnumStmt *n = makeNode(AlterEnumStmt);

				n->typeName = (yyvsp[-5].list);
				n->oldVal = (yyvsp[-2].str);
				n->newVal = (yyvsp[0].str);
				n->newValNeighbor = NULL;
				n->newValIsAfter = false;
				n->skipIfNewValExists = false;
				(yyval.node) = (Node *) n;
			}
#line 35505 "gram.c" /* yacc.c:1646  */
    break;

  case 854:
#line 6395 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 35511 "gram.c" /* yacc.c:1646  */
    break;

  case 855:
#line 6396 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 35517 "gram.c" /* yacc.c:1646  */
    break;

  case 856:
#line 6414 "gram.y" /* yacc.c:1646  */
    {
					CreateOpClassStmt *n = makeNode(CreateOpClassStmt);

					n->opclassname = (yyvsp[-9].list);
					n->isDefault = (yyvsp[-8].boolean);
					n->datatype = (yyvsp[-5].typnam);
					n->amname = (yyvsp[-3].str);
					n->opfamilyname = (yyvsp[-2].list);
					n->items = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 35533 "gram.c" /* yacc.c:1646  */
    break;

  case 857:
#line 6428 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 35539 "gram.c" /* yacc.c:1646  */
    break;

  case 858:
#line 6429 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node)); }
#line 35545 "gram.c" /* yacc.c:1646  */
    break;

  case 859:
#line 6434 "gram.y" /* yacc.c:1646  */
    {
					CreateOpClassItem *n = makeNode(CreateOpClassItem);
					ObjectWithArgs *owa = makeNode(ObjectWithArgs);

					owa->objname = (yyvsp[-2].list);
					owa->objargs = NIL;
					n->itemtype = OPCLASS_ITEM_OPERATOR;
					n->name = owa;
					n->number = (yyvsp[-3].ival);
					n->order_family = (yyvsp[-1].list);
					(yyval.node) = (Node *) n;
				}
#line 35562 "gram.c" /* yacc.c:1646  */
    break;

  case 860:
#line 6448 "gram.y" /* yacc.c:1646  */
    {
					CreateOpClassItem *n = makeNode(CreateOpClassItem);

					n->itemtype = OPCLASS_ITEM_OPERATOR;
					n->name = (yyvsp[-2].objwithargs);
					n->number = (yyvsp[-3].ival);
					n->order_family = (yyvsp[-1].list);
					(yyval.node) = (Node *) n;
				}
#line 35576 "gram.c" /* yacc.c:1646  */
    break;

  case 861:
#line 6458 "gram.y" /* yacc.c:1646  */
    {
					CreateOpClassItem *n = makeNode(CreateOpClassItem);

					n->itemtype = OPCLASS_ITEM_FUNCTION;
					n->name = (yyvsp[0].objwithargs);
					n->number = (yyvsp[-1].ival);
					(yyval.node) = (Node *) n;
				}
#line 35589 "gram.c" /* yacc.c:1646  */
    break;

  case 862:
#line 6467 "gram.y" /* yacc.c:1646  */
    {
					CreateOpClassItem *n = makeNode(CreateOpClassItem);

					n->itemtype = OPCLASS_ITEM_FUNCTION;
					n->name = (yyvsp[0].objwithargs);
					n->number = (yyvsp[-4].ival);
					n->class_args = (yyvsp[-2].list);
					(yyval.node) = (Node *) n;
				}
#line 35603 "gram.c" /* yacc.c:1646  */
    break;

  case 863:
#line 6477 "gram.y" /* yacc.c:1646  */
    {
					CreateOpClassItem *n = makeNode(CreateOpClassItem);

					n->itemtype = OPCLASS_ITEM_STORAGETYPE;
					n->storedtype = (yyvsp[0].typnam);
					(yyval.node) = (Node *) n;
				}
#line 35615 "gram.c" /* yacc.c:1646  */
    break;

  case 864:
#line 6486 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 35621 "gram.c" /* yacc.c:1646  */
    break;

  case 865:
#line 6487 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 35627 "gram.c" /* yacc.c:1646  */
    break;

  case 866:
#line 6490 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 35633 "gram.c" /* yacc.c:1646  */
    break;

  case 867:
#line 6491 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 35639 "gram.c" /* yacc.c:1646  */
    break;

  case 868:
#line 6494 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 35645 "gram.c" /* yacc.c:1646  */
    break;

  case 869:
#line 6495 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 35651 "gram.c" /* yacc.c:1646  */
    break;

  case 870:
#line 6496 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 35657 "gram.c" /* yacc.c:1646  */
    break;

  case 871:
#line 6500 "gram.y" /* yacc.c:1646  */
    {
					/*
					 * RECHECK no longer does anything in opclass definitions,
					 * but we still accept it to ease porting of old database
					 * dumps.
					 */
					ereport(NOTICE,
							(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
							 errmsg("RECHECK is no longer required"),
							 errhint("Update your data type."),
							 parser_errposition((yylsp[0]))));
					(yyval.boolean) = true;
				}
#line 35675 "gram.c" /* yacc.c:1646  */
    break;

  case 872:
#line 6513 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 35681 "gram.c" /* yacc.c:1646  */
    break;

  case 873:
#line 6519 "gram.y" /* yacc.c:1646  */
    {
					CreateOpFamilyStmt *n = makeNode(CreateOpFamilyStmt);

					n->opfamilyname = (yyvsp[-2].list);
					n->amname = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 35693 "gram.c" /* yacc.c:1646  */
    break;

  case 874:
#line 6530 "gram.y" /* yacc.c:1646  */
    {
					AlterOpFamilyStmt *n = makeNode(AlterOpFamilyStmt);

					n->opfamilyname = (yyvsp[-4].list);
					n->amname = (yyvsp[-2].str);
					n->isDrop = false;
					n->items = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 35707 "gram.c" /* yacc.c:1646  */
    break;

  case 875:
#line 6540 "gram.y" /* yacc.c:1646  */
    {
					AlterOpFamilyStmt *n = makeNode(AlterOpFamilyStmt);

					n->opfamilyname = (yyvsp[-4].list);
					n->amname = (yyvsp[-2].str);
					n->isDrop = true;
					n->items = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 35721 "gram.c" /* yacc.c:1646  */
    break;

  case 876:
#line 6552 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 35727 "gram.c" /* yacc.c:1646  */
    break;

  case 877:
#line 6553 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node)); }
#line 35733 "gram.c" /* yacc.c:1646  */
    break;

  case 878:
#line 6558 "gram.y" /* yacc.c:1646  */
    {
					CreateOpClassItem *n = makeNode(CreateOpClassItem);

					n->itemtype = OPCLASS_ITEM_OPERATOR;
					n->number = (yyvsp[-3].ival);
					n->class_args = (yyvsp[-1].list);
					(yyval.node) = (Node *) n;
				}
#line 35746 "gram.c" /* yacc.c:1646  */
    break;

  case 879:
#line 6567 "gram.y" /* yacc.c:1646  */
    {
					CreateOpClassItem *n = makeNode(CreateOpClassItem);

					n->itemtype = OPCLASS_ITEM_FUNCTION;
					n->number = (yyvsp[-3].ival);
					n->class_args = (yyvsp[-1].list);
					(yyval.node) = (Node *) n;
				}
#line 35759 "gram.c" /* yacc.c:1646  */
    break;

  case 880:
#line 6580 "gram.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);

					n->objects = list_make1(lcons(makeString((yyvsp[-1].str)), (yyvsp[-3].list)));
					n->removeType = OBJECT_OPCLASS;
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = false;
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 35774 "gram.c" /* yacc.c:1646  */
    break;

  case 881:
#line 6591 "gram.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);

					n->objects = list_make1(lcons(makeString((yyvsp[-1].str)), (yyvsp[-3].list)));
					n->removeType = OBJECT_OPCLASS;
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = true;
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 35789 "gram.c" /* yacc.c:1646  */
    break;

  case 882:
#line 6605 "gram.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);

					n->objects = list_make1(lcons(makeString((yyvsp[-1].str)), (yyvsp[-3].list)));
					n->removeType = OBJECT_OPFAMILY;
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = false;
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 35804 "gram.c" /* yacc.c:1646  */
    break;

  case 883:
#line 6616 "gram.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);

					n->objects = list_make1(lcons(makeString((yyvsp[-1].str)), (yyvsp[-3].list)));
					n->removeType = OBJECT_OPFAMILY;
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = true;
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 35819 "gram.c" /* yacc.c:1646  */
    break;

  case 884:
#line 6639 "gram.y" /* yacc.c:1646  */
    {
					DropOwnedStmt *n = makeNode(DropOwnedStmt);

					n->roles = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					(yyval.node) = (Node *) n;
				}
#line 35831 "gram.c" /* yacc.c:1646  */
    break;

  case 885:
#line 6650 "gram.y" /* yacc.c:1646  */
    {
					ReassignOwnedStmt *n = makeNode(ReassignOwnedStmt);

					n->roles = (yyvsp[-2].list);
					n->newrole = (yyvsp[0].rolespec);
					(yyval.node) = (Node *) n;
				}
#line 35843 "gram.c" /* yacc.c:1646  */
    break;

  case 886:
#line 6669 "gram.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);

					n->removeType = (yyvsp[-4].objtype);
					n->missing_ok = true;
					n->objects = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 35858 "gram.c" /* yacc.c:1646  */
    break;

  case 887:
#line 6680 "gram.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);

					n->removeType = (yyvsp[-2].objtype);
					n->missing_ok = false;
					n->objects = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 35873 "gram.c" /* yacc.c:1646  */
    break;

  case 888:
#line 6691 "gram.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);

					n->removeType = (yyvsp[-4].objtype);
					n->missing_ok = true;
					n->objects = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 35888 "gram.c" /* yacc.c:1646  */
    break;

  case 889:
#line 6702 "gram.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);

					n->removeType = (yyvsp[-2].objtype);
					n->missing_ok = false;
					n->objects = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 35903 "gram.c" /* yacc.c:1646  */
    break;

  case 890:
#line 6713 "gram.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);

					n->removeType = (yyvsp[-4].objtype);
					n->objects = list_make1(lappend((yyvsp[-1].list), makeString((yyvsp[-3].str))));
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = false;
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 35918 "gram.c" /* yacc.c:1646  */
    break;

  case 891:
#line 6724 "gram.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);

					n->removeType = (yyvsp[-6].objtype);
					n->objects = list_make1(lappend((yyvsp[-1].list), makeString((yyvsp[-3].str))));
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = true;
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 35933 "gram.c" /* yacc.c:1646  */
    break;

  case 892:
#line 6735 "gram.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);

					n->removeType = OBJECT_TYPE;
					n->missing_ok = false;
					n->objects = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 35948 "gram.c" /* yacc.c:1646  */
    break;

  case 893:
#line 6746 "gram.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);

					n->removeType = OBJECT_TYPE;
					n->missing_ok = true;
					n->objects = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 35963 "gram.c" /* yacc.c:1646  */
    break;

  case 894:
#line 6757 "gram.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);

					n->removeType = OBJECT_DOMAIN;
					n->missing_ok = false;
					n->objects = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 35978 "gram.c" /* yacc.c:1646  */
    break;

  case 895:
#line 6768 "gram.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);

					n->removeType = OBJECT_DOMAIN;
					n->missing_ok = true;
					n->objects = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 35993 "gram.c" /* yacc.c:1646  */
    break;

  case 896:
#line 6779 "gram.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);

					n->removeType = OBJECT_INDEX;
					n->missing_ok = false;
					n->objects = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					n->concurrent = true;
					(yyval.node) = (Node *) n;
				}
#line 36008 "gram.c" /* yacc.c:1646  */
    break;

  case 897:
#line 6790 "gram.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);

					n->removeType = OBJECT_INDEX;
					n->missing_ok = true;
					n->objects = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					n->concurrent = true;
					(yyval.node) = (Node *) n;
				}
#line 36023 "gram.c" /* yacc.c:1646  */
    break;

  case 898:
#line 6804 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_TABLE; }
#line 36029 "gram.c" /* yacc.c:1646  */
    break;

  case 899:
#line 6805 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_SEQUENCE; }
#line 36035 "gram.c" /* yacc.c:1646  */
    break;

  case 900:
#line 6806 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_VIEW; }
#line 36041 "gram.c" /* yacc.c:1646  */
    break;

  case 901:
#line 6807 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_MATVIEW; }
#line 36047 "gram.c" /* yacc.c:1646  */
    break;

  case 902:
#line 6808 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_INDEX; }
#line 36053 "gram.c" /* yacc.c:1646  */
    break;

  case 903:
#line 6809 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_FOREIGN_TABLE; }
#line 36059 "gram.c" /* yacc.c:1646  */
    break;

  case 904:
#line 6810 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_COLLATION; }
#line 36065 "gram.c" /* yacc.c:1646  */
    break;

  case 905:
#line 6811 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_CONVERSION; }
#line 36071 "gram.c" /* yacc.c:1646  */
    break;

  case 906:
#line 6812 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_STATISTIC_EXT; }
#line 36077 "gram.c" /* yacc.c:1646  */
    break;

  case 907:
#line 6813 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_TSPARSER; }
#line 36083 "gram.c" /* yacc.c:1646  */
    break;

  case 908:
#line 6814 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_TSDICTIONARY; }
#line 36089 "gram.c" /* yacc.c:1646  */
    break;

  case 909:
#line 6815 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_TSTEMPLATE; }
#line 36095 "gram.c" /* yacc.c:1646  */
    break;

  case 910:
#line 6816 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_TSCONFIGURATION; }
#line 36101 "gram.c" /* yacc.c:1646  */
    break;

  case 911:
#line 6826 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = (yyvsp[0].objtype); }
#line 36107 "gram.c" /* yacc.c:1646  */
    break;

  case 912:
#line 6827 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_DATABASE; }
#line 36113 "gram.c" /* yacc.c:1646  */
    break;

  case 913:
#line 6828 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_ROLE; }
#line 36119 "gram.c" /* yacc.c:1646  */
    break;

  case 914:
#line 6829 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_SUBSCRIPTION; }
#line 36125 "gram.c" /* yacc.c:1646  */
    break;

  case 915:
#line 6830 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_TABLESPACE; }
#line 36131 "gram.c" /* yacc.c:1646  */
    break;

  case 916:
#line 6834 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_ACCESS_METHOD; }
#line 36137 "gram.c" /* yacc.c:1646  */
    break;

  case 917:
#line 6835 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_EVENT_TRIGGER; }
#line 36143 "gram.c" /* yacc.c:1646  */
    break;

  case 918:
#line 6836 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_EXTENSION; }
#line 36149 "gram.c" /* yacc.c:1646  */
    break;

  case 919:
#line 6837 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_FDW; }
#line 36155 "gram.c" /* yacc.c:1646  */
    break;

  case 920:
#line 6838 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_LANGUAGE; }
#line 36161 "gram.c" /* yacc.c:1646  */
    break;

  case 921:
#line 6839 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_PUBLICATION; }
#line 36167 "gram.c" /* yacc.c:1646  */
    break;

  case 922:
#line 6840 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_SCHEMA; }
#line 36173 "gram.c" /* yacc.c:1646  */
    break;

  case 923:
#line 6841 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_FOREIGN_SERVER; }
#line 36179 "gram.c" /* yacc.c:1646  */
    break;

  case 924:
#line 6846 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_POLICY; }
#line 36185 "gram.c" /* yacc.c:1646  */
    break;

  case 925:
#line 6847 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_RULE; }
#line 36191 "gram.c" /* yacc.c:1646  */
    break;

  case 926:
#line 6848 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_TRIGGER; }
#line 36197 "gram.c" /* yacc.c:1646  */
    break;

  case 927:
#line 6852 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].list)); }
#line 36203 "gram.c" /* yacc.c:1646  */
    break;

  case 928:
#line 6853 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].list)); }
#line 36209 "gram.c" /* yacc.c:1646  */
    break;

  case 929:
#line 6856 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeString((yyvsp[0].str))); }
#line 36215 "gram.c" /* yacc.c:1646  */
    break;

  case 930:
#line 6857 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lcons(makeString((yyvsp[-1].str)), (yyvsp[0].list)); }
#line 36221 "gram.c" /* yacc.c:1646  */
    break;

  case 931:
#line 6861 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeString((yyvsp[0].str))); }
#line 36227 "gram.c" /* yacc.c:1646  */
    break;

  case 932:
#line 6863 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), makeString((yyvsp[0].str))); }
#line 36233 "gram.c" /* yacc.c:1646  */
    break;

  case 933:
#line 6867 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].typnam)); }
#line 36239 "gram.c" /* yacc.c:1646  */
    break;

  case 934:
#line 6868 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].typnam)); }
#line 36245 "gram.c" /* yacc.c:1646  */
    break;

  case 935:
#line 6880 "gram.y" /* yacc.c:1646  */
    {
					TruncateStmt *n = makeNode(TruncateStmt);

					n->relations = (yyvsp[-2].list);
					n->restart_seqs = (yyvsp[-1].boolean);
					n->behavior = (yyvsp[0].dbehavior);
					(yyval.node) = (Node *) n;
				}
#line 36258 "gram.c" /* yacc.c:1646  */
    break;

  case 936:
#line 6891 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 36264 "gram.c" /* yacc.c:1646  */
    break;

  case 937:
#line 6892 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 36270 "gram.c" /* yacc.c:1646  */
    break;

  case 938:
#line 6893 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 36276 "gram.c" /* yacc.c:1646  */
    break;

  case 939:
#line 6904 "gram.y" /* yacc.c:1646  */
    {
					CommentStmt *n = makeNode(CommentStmt);

					n->objtype = (yyvsp[-3].objtype);
					n->object = (Node *) (yyvsp[-2].list);
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 36289 "gram.c" /* yacc.c:1646  */
    break;

  case 940:
#line 6913 "gram.y" /* yacc.c:1646  */
    {
					CommentStmt *n = makeNode(CommentStmt);

					n->objtype = OBJECT_COLUMN;
					n->object = (Node *) (yyvsp[-2].list);
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 36302 "gram.c" /* yacc.c:1646  */
    break;

  case 941:
#line 6922 "gram.y" /* yacc.c:1646  */
    {
					CommentStmt *n = makeNode(CommentStmt);

					n->objtype = (yyvsp[-3].objtype);
					n->object = (Node *) makeString((yyvsp[-2].str));
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 36315 "gram.c" /* yacc.c:1646  */
    break;

  case 942:
#line 6931 "gram.y" /* yacc.c:1646  */
    {
					CommentStmt *n = makeNode(CommentStmt);

					n->objtype = OBJECT_TYPE;
					n->object = (Node *) (yyvsp[-2].typnam);
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 36328 "gram.c" /* yacc.c:1646  */
    break;

  case 943:
#line 6940 "gram.y" /* yacc.c:1646  */
    {
					CommentStmt *n = makeNode(CommentStmt);

					n->objtype = OBJECT_DOMAIN;
					n->object = (Node *) (yyvsp[-2].typnam);
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 36341 "gram.c" /* yacc.c:1646  */
    break;

  case 944:
#line 6949 "gram.y" /* yacc.c:1646  */
    {
					CommentStmt *n = makeNode(CommentStmt);

					n->objtype = OBJECT_AGGREGATE;
					n->object = (Node *) (yyvsp[-2].objwithargs);
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 36354 "gram.c" /* yacc.c:1646  */
    break;

  case 945:
#line 6958 "gram.y" /* yacc.c:1646  */
    {
					CommentStmt *n = makeNode(CommentStmt);

					n->objtype = OBJECT_FUNCTION;
					n->object = (Node *) (yyvsp[-2].objwithargs);
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 36367 "gram.c" /* yacc.c:1646  */
    break;

  case 946:
#line 6967 "gram.y" /* yacc.c:1646  */
    {
					CommentStmt *n = makeNode(CommentStmt);

					n->objtype = OBJECT_OPERATOR;
					n->object = (Node *) (yyvsp[-2].objwithargs);
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 36380 "gram.c" /* yacc.c:1646  */
    break;

  case 947:
#line 6976 "gram.y" /* yacc.c:1646  */
    {
					CommentStmt *n = makeNode(CommentStmt);

					n->objtype = OBJECT_TABCONSTRAINT;
					n->object = (Node *) lappend((yyvsp[-2].list), makeString((yyvsp[-4].str)));
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 36393 "gram.c" /* yacc.c:1646  */
    break;

  case 948:
#line 6985 "gram.y" /* yacc.c:1646  */
    {
					CommentStmt *n = makeNode(CommentStmt);

					n->objtype = OBJECT_DOMCONSTRAINT;
					/*
					 * should use Typename not any_name in the production, but
					 * there's a shift/reduce conflict if we do that, so fix it
					 * up here.
					 */
					n->object = (Node *) list_make2(makeTypeNameFromNameList((yyvsp[-2].list)), makeString((yyvsp[-5].str)));
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 36411 "gram.c" /* yacc.c:1646  */
    break;

  case 949:
#line 6999 "gram.y" /* yacc.c:1646  */
    {
					CommentStmt *n = makeNode(CommentStmt);

					n->objtype = (yyvsp[-5].objtype);
					n->object = (Node *) lappend((yyvsp[-2].list), makeString((yyvsp[-4].str)));
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 36424 "gram.c" /* yacc.c:1646  */
    break;

  case 950:
#line 7008 "gram.y" /* yacc.c:1646  */
    {
					CommentStmt *n = makeNode(CommentStmt);

					n->objtype = OBJECT_PROCEDURE;
					n->object = (Node *) (yyvsp[-2].objwithargs);
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 36437 "gram.c" /* yacc.c:1646  */
    break;

  case 951:
#line 7017 "gram.y" /* yacc.c:1646  */
    {
					CommentStmt *n = makeNode(CommentStmt);

					n->objtype = OBJECT_ROUTINE;
					n->object = (Node *) (yyvsp[-2].objwithargs);
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 36450 "gram.c" /* yacc.c:1646  */
    break;

  case 952:
#line 7026 "gram.y" /* yacc.c:1646  */
    {
					CommentStmt *n = makeNode(CommentStmt);

					n->objtype = OBJECT_TRANSFORM;
					n->object = (Node *) list_make2((yyvsp[-4].typnam), makeString((yyvsp[-2].str)));
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 36463 "gram.c" /* yacc.c:1646  */
    break;

  case 953:
#line 7035 "gram.y" /* yacc.c:1646  */
    {
					CommentStmt *n = makeNode(CommentStmt);

					n->objtype = OBJECT_OPCLASS;
					n->object = (Node *) lcons(makeString((yyvsp[-2].str)), (yyvsp[-4].list));
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 36476 "gram.c" /* yacc.c:1646  */
    break;

  case 954:
#line 7044 "gram.y" /* yacc.c:1646  */
    {
					CommentStmt *n = makeNode(CommentStmt);

					n->objtype = OBJECT_OPFAMILY;
					n->object = (Node *) lcons(makeString((yyvsp[-2].str)), (yyvsp[-4].list));
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 36489 "gram.c" /* yacc.c:1646  */
    break;

  case 955:
#line 7053 "gram.y" /* yacc.c:1646  */
    {
					CommentStmt *n = makeNode(CommentStmt);

					n->objtype = OBJECT_LARGEOBJECT;
					n->object = (Node *) (yyvsp[-2].node);
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 36502 "gram.c" /* yacc.c:1646  */
    break;

  case 956:
#line 7062 "gram.y" /* yacc.c:1646  */
    {
					CommentStmt *n = makeNode(CommentStmt);

					n->objtype = OBJECT_CAST;
					n->object = (Node *) list_make2((yyvsp[-5].typnam), (yyvsp[-3].typnam));
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 36515 "gram.c" /* yacc.c:1646  */
    break;

  case 957:
#line 7073 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 36521 "gram.c" /* yacc.c:1646  */
    break;

  case 958:
#line 7074 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = NULL; }
#line 36527 "gram.c" /* yacc.c:1646  */
    break;

  case 959:
#line 7090 "gram.y" /* yacc.c:1646  */
    {
					SecLabelStmt *n = makeNode(SecLabelStmt);

					n->provider = (yyvsp[-5].str);
					n->objtype = (yyvsp[-3].objtype);
					n->object = (Node *) (yyvsp[-2].list);
					n->label = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 36541 "gram.c" /* yacc.c:1646  */
    break;

  case 960:
#line 7101 "gram.y" /* yacc.c:1646  */
    {
					SecLabelStmt *n = makeNode(SecLabelStmt);

					n->provider = (yyvsp[-5].str);
					n->objtype = OBJECT_COLUMN;
					n->object = (Node *) (yyvsp[-2].list);
					n->label = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 36555 "gram.c" /* yacc.c:1646  */
    break;

  case 961:
#line 7112 "gram.y" /* yacc.c:1646  */
    {
					SecLabelStmt *n = makeNode(SecLabelStmt);

					n->provider = (yyvsp[-5].str);
					n->objtype = (yyvsp[-3].objtype);
					n->object = (Node *) makeString((yyvsp[-2].str));
					n->label = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 36569 "gram.c" /* yacc.c:1646  */
    break;

  case 962:
#line 7123 "gram.y" /* yacc.c:1646  */
    {
					SecLabelStmt *n = makeNode(SecLabelStmt);

					n->provider = (yyvsp[-5].str);
					n->objtype = OBJECT_TYPE;
					n->object = (Node *) (yyvsp[-2].typnam);
					n->label = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 36583 "gram.c" /* yacc.c:1646  */
    break;

  case 963:
#line 7134 "gram.y" /* yacc.c:1646  */
    {
					SecLabelStmt *n = makeNode(SecLabelStmt);

					n->provider = (yyvsp[-5].str);
					n->objtype = OBJECT_DOMAIN;
					n->object = (Node *) (yyvsp[-2].typnam);
					n->label = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 36597 "gram.c" /* yacc.c:1646  */
    break;

  case 964:
#line 7145 "gram.y" /* yacc.c:1646  */
    {
					SecLabelStmt *n = makeNode(SecLabelStmt);

					n->provider = (yyvsp[-5].str);
					n->objtype = OBJECT_AGGREGATE;
					n->object = (Node *) (yyvsp[-2].objwithargs);
					n->label = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 36611 "gram.c" /* yacc.c:1646  */
    break;

  case 965:
#line 7156 "gram.y" /* yacc.c:1646  */
    {
					SecLabelStmt *n = makeNode(SecLabelStmt);

					n->provider = (yyvsp[-5].str);
					n->objtype = OBJECT_FUNCTION;
					n->object = (Node *) (yyvsp[-2].objwithargs);
					n->label = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 36625 "gram.c" /* yacc.c:1646  */
    break;

  case 966:
#line 7167 "gram.y" /* yacc.c:1646  */
    {
					SecLabelStmt *n = makeNode(SecLabelStmt);

					n->provider = (yyvsp[-6].str);
					n->objtype = OBJECT_LARGEOBJECT;
					n->object = (Node *) (yyvsp[-2].node);
					n->label = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 36639 "gram.c" /* yacc.c:1646  */
    break;

  case 967:
#line 7178 "gram.y" /* yacc.c:1646  */
    {
					SecLabelStmt *n = makeNode(SecLabelStmt);

					n->provider = (yyvsp[-5].str);
					n->objtype = OBJECT_PROCEDURE;
					n->object = (Node *) (yyvsp[-2].objwithargs);
					n->label = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 36653 "gram.c" /* yacc.c:1646  */
    break;

  case 968:
#line 7189 "gram.y" /* yacc.c:1646  */
    {
					SecLabelStmt *n = makeNode(SecLabelStmt);

					n->provider = (yyvsp[-5].str);
					n->objtype = OBJECT_ROUTINE;
					n->object = (Node *) (yyvsp[-2].objwithargs);
					n->label = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 36667 "gram.c" /* yacc.c:1646  */
    break;

  case 969:
#line 7200 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 36673 "gram.c" /* yacc.c:1646  */
    break;

  case 970:
#line 7201 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = NULL; }
#line 36679 "gram.c" /* yacc.c:1646  */
    break;

  case 971:
#line 7204 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 36685 "gram.c" /* yacc.c:1646  */
    break;

  case 972:
#line 7205 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = NULL; }
#line 36691 "gram.c" /* yacc.c:1646  */
    break;

  case 973:
#line 7216 "gram.y" /* yacc.c:1646  */
    {
					FetchStmt *n = (FetchStmt *) (yyvsp[0].node);

					n->ismove = false;
					(yyval.node) = (Node *) n;
				}
#line 36702 "gram.c" /* yacc.c:1646  */
    break;

  case 974:
#line 7223 "gram.y" /* yacc.c:1646  */
    {
					FetchStmt *n = (FetchStmt *) (yyvsp[0].node);

					n->ismove = true;
					(yyval.node) = (Node *) n;
				}
#line 36713 "gram.c" /* yacc.c:1646  */
    break;

  case 975:
#line 7232 "gram.y" /* yacc.c:1646  */
    {
					FetchStmt *n = makeNode(FetchStmt);

					n->portalname = (yyvsp[0].str);
					n->direction = FETCH_FORWARD;
					n->howMany = 1;
					(yyval.node) = (Node *) n;
				}
#line 36726 "gram.c" /* yacc.c:1646  */
    break;

  case 976:
#line 7241 "gram.y" /* yacc.c:1646  */
    {
					FetchStmt *n = makeNode(FetchStmt);

					n->portalname = (yyvsp[0].str);
					n->direction = FETCH_FORWARD;
					n->howMany = 1;
					(yyval.node) = (Node *) n;
				}
#line 36739 "gram.c" /* yacc.c:1646  */
    break;

  case 977:
#line 7250 "gram.y" /* yacc.c:1646  */
    {
					FetchStmt *n = makeNode(FetchStmt);

					n->portalname = (yyvsp[0].str);
					n->direction = FETCH_FORWARD;
					n->howMany = 1;
					(yyval.node) = (Node *) n;
				}
#line 36752 "gram.c" /* yacc.c:1646  */
    break;

  case 978:
#line 7259 "gram.y" /* yacc.c:1646  */
    {
					FetchStmt *n = makeNode(FetchStmt);

					n->portalname = (yyvsp[0].str);
					n->direction = FETCH_BACKWARD;
					n->howMany = 1;
					(yyval.node) = (Node *) n;
				}
#line 36765 "gram.c" /* yacc.c:1646  */
    break;

  case 979:
#line 7268 "gram.y" /* yacc.c:1646  */
    {
					FetchStmt *n = makeNode(FetchStmt);

					n->portalname = (yyvsp[0].str);
					n->direction = FETCH_ABSOLUTE;
					n->howMany = 1;
					(yyval.node) = (Node *) n;
				}
#line 36778 "gram.c" /* yacc.c:1646  */
    break;

  case 980:
#line 7277 "gram.y" /* yacc.c:1646  */
    {
					FetchStmt *n = makeNode(FetchStmt);

					n->portalname = (yyvsp[0].str);
					n->direction = FETCH_ABSOLUTE;
					n->howMany = -1;
					(yyval.node) = (Node *) n;
				}
#line 36791 "gram.c" /* yacc.c:1646  */
    break;

  case 981:
#line 7286 "gram.y" /* yacc.c:1646  */
    {
					FetchStmt *n = makeNode(FetchStmt);

					n->portalname = (yyvsp[0].str);
					n->direction = FETCH_ABSOLUTE;
					n->howMany = (yyvsp[-2].ival);
					(yyval.node) = (Node *) n;
				}
#line 36804 "gram.c" /* yacc.c:1646  */
    break;

  case 982:
#line 7295 "gram.y" /* yacc.c:1646  */
    {
					FetchStmt *n = makeNode(FetchStmt);

					n->portalname = (yyvsp[0].str);
					n->direction = FETCH_RELATIVE;
					n->howMany = (yyvsp[-2].ival);
					(yyval.node) = (Node *) n;
				}
#line 36817 "gram.c" /* yacc.c:1646  */
    break;

  case 983:
#line 7304 "gram.y" /* yacc.c:1646  */
    {
					FetchStmt *n = makeNode(FetchStmt);

					n->portalname = (yyvsp[0].str);
					n->direction = FETCH_FORWARD;
					n->howMany = (yyvsp[-2].ival);
					(yyval.node) = (Node *) n;
				}
#line 36830 "gram.c" /* yacc.c:1646  */
    break;

  case 984:
#line 7313 "gram.y" /* yacc.c:1646  */
    {
					FetchStmt *n = makeNode(FetchStmt);

					n->portalname = (yyvsp[0].str);
					n->direction = FETCH_FORWARD;
					n->howMany = FETCH_ALL;
					(yyval.node) = (Node *) n;
				}
#line 36843 "gram.c" /* yacc.c:1646  */
    break;

  case 985:
#line 7322 "gram.y" /* yacc.c:1646  */
    {
					FetchStmt *n = makeNode(FetchStmt);

					n->portalname = (yyvsp[0].str);
					n->direction = FETCH_FORWARD;
					n->howMany = 1;
					(yyval.node) = (Node *) n;
				}
#line 36856 "gram.c" /* yacc.c:1646  */
    break;

  case 986:
#line 7331 "gram.y" /* yacc.c:1646  */
    {
					FetchStmt *n = makeNode(FetchStmt);

					n->portalname = (yyvsp[0].str);
					n->direction = FETCH_FORWARD;
					n->howMany = (yyvsp[-2].ival);
					(yyval.node) = (Node *) n;
				}
#line 36869 "gram.c" /* yacc.c:1646  */
    break;

  case 987:
#line 7340 "gram.y" /* yacc.c:1646  */
    {
					FetchStmt *n = makeNode(FetchStmt);

					n->portalname = (yyvsp[0].str);
					n->direction = FETCH_FORWARD;
					n->howMany = FETCH_ALL;
					(yyval.node) = (Node *) n;
				}
#line 36882 "gram.c" /* yacc.c:1646  */
    break;

  case 988:
#line 7349 "gram.y" /* yacc.c:1646  */
    {
					FetchStmt *n = makeNode(FetchStmt);

					n->portalname = (yyvsp[0].str);
					n->direction = FETCH_BACKWARD;
					n->howMany = 1;
					(yyval.node) = (Node *) n;
				}
#line 36895 "gram.c" /* yacc.c:1646  */
    break;

  case 989:
#line 7358 "gram.y" /* yacc.c:1646  */
    {
					FetchStmt *n = makeNode(FetchStmt);

					n->portalname = (yyvsp[0].str);
					n->direction = FETCH_BACKWARD;
					n->howMany = (yyvsp[-2].ival);
					(yyval.node) = (Node *) n;
				}
#line 36908 "gram.c" /* yacc.c:1646  */
    break;

  case 990:
#line 7367 "gram.y" /* yacc.c:1646  */
    {
					FetchStmt *n = makeNode(FetchStmt);

					n->portalname = (yyvsp[0].str);
					n->direction = FETCH_BACKWARD;
					n->howMany = FETCH_ALL;
					(yyval.node) = (Node *) n;
				}
#line 36921 "gram.c" /* yacc.c:1646  */
    break;

  case 995:
#line 7394 "gram.y" /* yacc.c:1646  */
    {
					GrantStmt *n = makeNode(GrantStmt);

					n->is_grant = true;
					n->privileges = (yyvsp[-6].list);
					n->targtype = ((yyvsp[-4].privtarget))->targtype;
					n->objtype = ((yyvsp[-4].privtarget))->objtype;
					n->objects = ((yyvsp[-4].privtarget))->objs;
					n->grantees = (yyvsp[-2].list);
					n->grant_option = (yyvsp[-1].boolean);
					n->grantor = (yyvsp[0].rolespec);
					(yyval.node) = (Node *) n;
				}
#line 36939 "gram.c" /* yacc.c:1646  */
    break;

  case 996:
#line 7412 "gram.y" /* yacc.c:1646  */
    {
					GrantStmt *n = makeNode(GrantStmt);

					n->is_grant = false;
					n->grant_option = false;
					n->privileges = (yyvsp[-6].list);
					n->targtype = ((yyvsp[-4].privtarget))->targtype;
					n->objtype = ((yyvsp[-4].privtarget))->objtype;
					n->objects = ((yyvsp[-4].privtarget))->objs;
					n->grantees = (yyvsp[-2].list);
					n->grantor = (yyvsp[-1].rolespec);
					n->behavior = (yyvsp[0].dbehavior);
					(yyval.node) = (Node *) n;
				}
#line 36958 "gram.c" /* yacc.c:1646  */
    break;

  case 997:
#line 7428 "gram.y" /* yacc.c:1646  */
    {
					GrantStmt *n = makeNode(GrantStmt);

					n->is_grant = false;
					n->grant_option = true;
					n->privileges = (yyvsp[-6].list);
					n->targtype = ((yyvsp[-4].privtarget))->targtype;
					n->objtype = ((yyvsp[-4].privtarget))->objtype;
					n->objects = ((yyvsp[-4].privtarget))->objs;
					n->grantees = (yyvsp[-2].list);
					n->grantor = (yyvsp[-1].rolespec);
					n->behavior = (yyvsp[0].dbehavior);
					(yyval.node) = (Node *) n;
				}
#line 36977 "gram.c" /* yacc.c:1646  */
    break;

  case 998:
#line 7455 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 36983 "gram.c" /* yacc.c:1646  */
    break;

  case 999:
#line 7457 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 36989 "gram.c" /* yacc.c:1646  */
    break;

  case 1000:
#line 7459 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 36995 "gram.c" /* yacc.c:1646  */
    break;

  case 1001:
#line 7461 "gram.y" /* yacc.c:1646  */
    {
					AccessPriv *n = makeNode(AccessPriv);

					n->priv_name = NULL;
					n->cols = (yyvsp[-1].list);
					(yyval.list) = list_make1(n);
				}
#line 37007 "gram.c" /* yacc.c:1646  */
    break;

  case 1002:
#line 7469 "gram.y" /* yacc.c:1646  */
    {
					AccessPriv *n = makeNode(AccessPriv);

					n->priv_name = NULL;
					n->cols = (yyvsp[-1].list);
					(yyval.list) = list_make1(n);
				}
#line 37019 "gram.c" /* yacc.c:1646  */
    break;

  case 1003:
#line 7478 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].accesspriv)); }
#line 37025 "gram.c" /* yacc.c:1646  */
    break;

  case 1004:
#line 7479 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].accesspriv)); }
#line 37031 "gram.c" /* yacc.c:1646  */
    break;

  case 1005:
#line 7483 "gram.y" /* yacc.c:1646  */
    {
				AccessPriv *n = makeNode(AccessPriv);

				n->priv_name = pstrdup((yyvsp[-1].keyword));
				n->cols = (yyvsp[0].list);
				(yyval.accesspriv) = n;
			}
#line 37043 "gram.c" /* yacc.c:1646  */
    break;

  case 1006:
#line 7491 "gram.y" /* yacc.c:1646  */
    {
				AccessPriv *n = makeNode(AccessPriv);

				n->priv_name = pstrdup((yyvsp[-1].keyword));
				n->cols = (yyvsp[0].list);
				(yyval.accesspriv) = n;
			}
#line 37055 "gram.c" /* yacc.c:1646  */
    break;

  case 1007:
#line 7499 "gram.y" /* yacc.c:1646  */
    {
				AccessPriv *n = makeNode(AccessPriv);

				n->priv_name = pstrdup((yyvsp[-1].keyword));
				n->cols = (yyvsp[0].list);
				(yyval.accesspriv) = n;
			}
#line 37067 "gram.c" /* yacc.c:1646  */
    break;

  case 1008:
#line 7507 "gram.y" /* yacc.c:1646  */
    {
				AccessPriv *n = makeNode(AccessPriv);
				n->priv_name = pstrdup("alter system");
				n->cols = NIL;
				(yyval.accesspriv) = n;
			}
#line 37078 "gram.c" /* yacc.c:1646  */
    break;

  case 1009:
#line 7514 "gram.y" /* yacc.c:1646  */
    {
				AccessPriv *n = makeNode(AccessPriv);

				n->priv_name = (yyvsp[-1].str);
				n->cols = (yyvsp[0].list);
				(yyval.accesspriv) = n;
			}
#line 37090 "gram.c" /* yacc.c:1646  */
    break;

  case 1010:
#line 7525 "gram.y" /* yacc.c:1646  */
    {
				(yyval.list) = list_make1(makeString((yyvsp[0].str)));
			}
#line 37098 "gram.c" /* yacc.c:1646  */
    break;

  case 1011:
#line 7529 "gram.y" /* yacc.c:1646  */
    {
				(yyval.list) = lappend((yyvsp[-2].list), makeString((yyvsp[0].str)));
			}
#line 37106 "gram.c" /* yacc.c:1646  */
    break;

  case 1012:
#line 7536 "gram.y" /* yacc.c:1646  */
    {
				(yyval.str) = (yyvsp[0].str);
			}
#line 37114 "gram.c" /* yacc.c:1646  */
    break;

  case 1013:
#line 7540 "gram.y" /* yacc.c:1646  */
    {
				(yyval.str) = psprintf("%s.%s", (yyvsp[-2].str), (yyvsp[0].str));
			}
#line 37122 "gram.c" /* yacc.c:1646  */
    break;

  case 1014:
#line 7551 "gram.y" /* yacc.c:1646  */
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));

					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = OBJECT_TABLE;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 37135 "gram.c" /* yacc.c:1646  */
    break;

  case 1015:
#line 7560 "gram.y" /* yacc.c:1646  */
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));

					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = OBJECT_TABLE;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 37148 "gram.c" /* yacc.c:1646  */
    break;

  case 1016:
#line 7569 "gram.y" /* yacc.c:1646  */
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));

					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = OBJECT_SEQUENCE;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 37161 "gram.c" /* yacc.c:1646  */
    break;

  case 1017:
#line 7578 "gram.y" /* yacc.c:1646  */
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));

					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = OBJECT_FDW;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 37174 "gram.c" /* yacc.c:1646  */
    break;

  case 1018:
#line 7587 "gram.y" /* yacc.c:1646  */
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));

					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = OBJECT_FOREIGN_SERVER;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 37187 "gram.c" /* yacc.c:1646  */
    break;

  case 1019:
#line 7596 "gram.y" /* yacc.c:1646  */
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));

					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = OBJECT_FUNCTION;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 37200 "gram.c" /* yacc.c:1646  */
    break;

  case 1020:
#line 7605 "gram.y" /* yacc.c:1646  */
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));

					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = OBJECT_PROCEDURE;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 37213 "gram.c" /* yacc.c:1646  */
    break;

  case 1021:
#line 7614 "gram.y" /* yacc.c:1646  */
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));

					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = OBJECT_ROUTINE;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 37226 "gram.c" /* yacc.c:1646  */
    break;

  case 1022:
#line 7623 "gram.y" /* yacc.c:1646  */
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));

					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = OBJECT_DATABASE;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 37239 "gram.c" /* yacc.c:1646  */
    break;

  case 1023:
#line 7632 "gram.y" /* yacc.c:1646  */
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));

					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = OBJECT_DOMAIN;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 37252 "gram.c" /* yacc.c:1646  */
    break;

  case 1024:
#line 7641 "gram.y" /* yacc.c:1646  */
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));

					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = OBJECT_LANGUAGE;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 37265 "gram.c" /* yacc.c:1646  */
    break;

  case 1025:
#line 7650 "gram.y" /* yacc.c:1646  */
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));

					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = OBJECT_LARGEOBJECT;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 37278 "gram.c" /* yacc.c:1646  */
    break;

  case 1026:
#line 7659 "gram.y" /* yacc.c:1646  */
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = OBJECT_PARAMETER_ACL;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 37290 "gram.c" /* yacc.c:1646  */
    break;

  case 1027:
#line 7667 "gram.y" /* yacc.c:1646  */
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));

					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = OBJECT_SCHEMA;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 37303 "gram.c" /* yacc.c:1646  */
    break;

  case 1028:
#line 7676 "gram.y" /* yacc.c:1646  */
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));

					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = OBJECT_TABLESPACE;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 37316 "gram.c" /* yacc.c:1646  */
    break;

  case 1029:
#line 7685 "gram.y" /* yacc.c:1646  */
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));

					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = OBJECT_TYPE;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 37329 "gram.c" /* yacc.c:1646  */
    break;

  case 1030:
#line 7694 "gram.y" /* yacc.c:1646  */
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));

					n->targtype = ACL_TARGET_ALL_IN_SCHEMA;
					n->objtype = OBJECT_TABLE;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 37342 "gram.c" /* yacc.c:1646  */
    break;

  case 1031:
#line 7703 "gram.y" /* yacc.c:1646  */
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));

					n->targtype = ACL_TARGET_ALL_IN_SCHEMA;
					n->objtype = OBJECT_SEQUENCE;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 37355 "gram.c" /* yacc.c:1646  */
    break;

  case 1032:
#line 7712 "gram.y" /* yacc.c:1646  */
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));

					n->targtype = ACL_TARGET_ALL_IN_SCHEMA;
					n->objtype = OBJECT_FUNCTION;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 37368 "gram.c" /* yacc.c:1646  */
    break;

  case 1033:
#line 7721 "gram.y" /* yacc.c:1646  */
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));

					n->targtype = ACL_TARGET_ALL_IN_SCHEMA;
					n->objtype = OBJECT_PROCEDURE;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 37381 "gram.c" /* yacc.c:1646  */
    break;

  case 1034:
#line 7730 "gram.y" /* yacc.c:1646  */
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));

					n->targtype = ACL_TARGET_ALL_IN_SCHEMA;
					n->objtype = OBJECT_ROUTINE;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 37394 "gram.c" /* yacc.c:1646  */
    break;

  case 1035:
#line 7742 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].rolespec)); }
#line 37400 "gram.c" /* yacc.c:1646  */
    break;

  case 1036:
#line 7743 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].rolespec)); }
#line 37406 "gram.c" /* yacc.c:1646  */
    break;

  case 1037:
#line 7747 "gram.y" /* yacc.c:1646  */
    { (yyval.rolespec) = (yyvsp[0].rolespec); }
#line 37412 "gram.c" /* yacc.c:1646  */
    break;

  case 1038:
#line 7748 "gram.y" /* yacc.c:1646  */
    { (yyval.rolespec) = (yyvsp[0].rolespec); }
#line 37418 "gram.c" /* yacc.c:1646  */
    break;

  case 1039:
#line 7753 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 37424 "gram.c" /* yacc.c:1646  */
    break;

  case 1040:
#line 7754 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 37430 "gram.c" /* yacc.c:1646  */
    break;

  case 1041:
#line 7765 "gram.y" /* yacc.c:1646  */
    {
					GrantRoleStmt *n = makeNode(GrantRoleStmt);

					n->is_grant = true;
					n->granted_roles = (yyvsp[-4].list);
					n->grantee_roles = (yyvsp[-2].list);
					n->admin_opt = (yyvsp[-1].boolean);
					n->grantor = (yyvsp[0].rolespec);
					(yyval.node) = (Node *) n;
				}
#line 37445 "gram.c" /* yacc.c:1646  */
    break;

  case 1042:
#line 7779 "gram.y" /* yacc.c:1646  */
    {
					GrantRoleStmt *n = makeNode(GrantRoleStmt);

					n->is_grant = false;
					n->admin_opt = false;
					n->granted_roles = (yyvsp[-4].list);
					n->grantee_roles = (yyvsp[-2].list);
					n->behavior = (yyvsp[0].dbehavior);
					(yyval.node) = (Node *) n;
				}
#line 37460 "gram.c" /* yacc.c:1646  */
    break;

  case 1043:
#line 7790 "gram.y" /* yacc.c:1646  */
    {
					GrantRoleStmt *n = makeNode(GrantRoleStmt);

					n->is_grant = false;
					n->admin_opt = true;
					n->granted_roles = (yyvsp[-4].list);
					n->grantee_roles = (yyvsp[-2].list);
					n->behavior = (yyvsp[0].dbehavior);
					(yyval.node) = (Node *) n;
				}
#line 37475 "gram.c" /* yacc.c:1646  */
    break;

  case 1044:
#line 7802 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 37481 "gram.c" /* yacc.c:1646  */
    break;

  case 1045:
#line 7803 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 37487 "gram.c" /* yacc.c:1646  */
    break;

  case 1046:
#line 7806 "gram.y" /* yacc.c:1646  */
    { (yyval.rolespec) = (yyvsp[0].rolespec); }
#line 37493 "gram.c" /* yacc.c:1646  */
    break;

  case 1047:
#line 7807 "gram.y" /* yacc.c:1646  */
    { (yyval.rolespec) = NULL; }
#line 37499 "gram.c" /* yacc.c:1646  */
    break;

  case 1048:
#line 7818 "gram.y" /* yacc.c:1646  */
    {
					AlterDefaultPrivilegesStmt *n = makeNode(AlterDefaultPrivilegesStmt);

					n->options = (yyvsp[-1].list);
					n->action = (GrantStmt *) (yyvsp[0].node);
					(yyval.node) = (Node *) n;
				}
#line 37511 "gram.c" /* yacc.c:1646  */
    break;

  case 1049:
#line 7828 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].defelt)); }
#line 37517 "gram.c" /* yacc.c:1646  */
    break;

  case 1050:
#line 7829 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 37523 "gram.c" /* yacc.c:1646  */
    break;

  case 1051:
#line 7834 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("schemas", (Node *) (yyvsp[0].list), (yylsp[-2]));
				}
#line 37531 "gram.c" /* yacc.c:1646  */
    break;

  case 1052:
#line 7838 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("roles", (Node *) (yyvsp[0].list), (yylsp[-2]));
				}
#line 37539 "gram.c" /* yacc.c:1646  */
    break;

  case 1053:
#line 7842 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("roles", (Node *) (yyvsp[0].list), (yylsp[-2]));
				}
#line 37547 "gram.c" /* yacc.c:1646  */
    break;

  case 1054:
#line 7854 "gram.y" /* yacc.c:1646  */
    {
					GrantStmt *n = makeNode(GrantStmt);

					n->is_grant = true;
					n->privileges = (yyvsp[-5].list);
					n->targtype = ACL_TARGET_DEFAULTS;
					n->objtype = (yyvsp[-3].ival);
					n->objects = NIL;
					n->grantees = (yyvsp[-1].list);
					n->grant_option = (yyvsp[0].boolean);
					(yyval.node) = (Node *) n;
				}
#line 37564 "gram.c" /* yacc.c:1646  */
    break;

  case 1055:
#line 7868 "gram.y" /* yacc.c:1646  */
    {
					GrantStmt *n = makeNode(GrantStmt);

					n->is_grant = false;
					n->grant_option = false;
					n->privileges = (yyvsp[-5].list);
					n->targtype = ACL_TARGET_DEFAULTS;
					n->objtype = (yyvsp[-3].ival);
					n->objects = NIL;
					n->grantees = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					(yyval.node) = (Node *) n;
				}
#line 37582 "gram.c" /* yacc.c:1646  */
    break;

  case 1056:
#line 7883 "gram.y" /* yacc.c:1646  */
    {
					GrantStmt *n = makeNode(GrantStmt);

					n->is_grant = false;
					n->grant_option = true;
					n->privileges = (yyvsp[-5].list);
					n->targtype = ACL_TARGET_DEFAULTS;
					n->objtype = (yyvsp[-3].ival);
					n->objects = NIL;
					n->grantees = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					(yyval.node) = (Node *) n;
				}
#line 37600 "gram.c" /* yacc.c:1646  */
    break;

  case 1057:
#line 7899 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = OBJECT_TABLE; }
#line 37606 "gram.c" /* yacc.c:1646  */
    break;

  case 1058:
#line 7900 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = OBJECT_FUNCTION; }
#line 37612 "gram.c" /* yacc.c:1646  */
    break;

  case 1059:
#line 7901 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = OBJECT_FUNCTION; }
#line 37618 "gram.c" /* yacc.c:1646  */
    break;

  case 1060:
#line 7902 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = OBJECT_SEQUENCE; }
#line 37624 "gram.c" /* yacc.c:1646  */
    break;

  case 1061:
#line 7903 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = OBJECT_TYPE; }
#line 37630 "gram.c" /* yacc.c:1646  */
    break;

  case 1062:
#line 7904 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = OBJECT_SCHEMA; }
#line 37636 "gram.c" /* yacc.c:1646  */
    break;

  case 1063:
#line 7919 "gram.y" /* yacc.c:1646  */
    {
					IndexStmt *n = makeNode(IndexStmt);

					n->unique = (yyvsp[-14].boolean);
					n->concurrent = (yyvsp[-12].boolean);
					n->idxname = (yyvsp[-11].str);
					n->relation = (yyvsp[-9].range);
					n->accessMethod = (yyvsp[-8].str);
					n->indexParams = (yyvsp[-6].list);
					n->indexIncludingParams = (yyvsp[-4].list);
					n->nulls_not_distinct = !(yyvsp[-3].boolean);
					n->options = (yyvsp[-2].list);
					n->tableSpace = (yyvsp[-1].str);
					n->whereClause = (yyvsp[0].node);
					n->excludeOpNames = NIL;
					n->idxcomment = NULL;
					n->indexOid = InvalidOid;
					n->oldNode = InvalidOid;
					n->oldCreateSubid = InvalidSubTransactionId;
					n->oldFirstRelfilenodeSubid = InvalidSubTransactionId;
					n->primary = false;
					n->isconstraint = false;
					n->deferrable = false;
					n->initdeferred = false;
					n->transformed = false;
					n->if_not_exists = false;
					n->reset_default_tblspc = false;
					(yyval.node) = (Node *) n;
				}
#line 37670 "gram.c" /* yacc.c:1646  */
    break;

  case 1064:
#line 7951 "gram.y" /* yacc.c:1646  */
    {
					IndexStmt *n = makeNode(IndexStmt);

					n->unique = (yyvsp[-17].boolean);
					n->concurrent = (yyvsp[-15].boolean);
					n->idxname = (yyvsp[-11].str);
					n->relation = (yyvsp[-9].range);
					n->accessMethod = (yyvsp[-8].str);
					n->indexParams = (yyvsp[-6].list);
					n->indexIncludingParams = (yyvsp[-4].list);
					n->nulls_not_distinct = !(yyvsp[-3].boolean);
					n->options = (yyvsp[-2].list);
					n->tableSpace = (yyvsp[-1].str);
					n->whereClause = (yyvsp[0].node);
					n->excludeOpNames = NIL;
					n->idxcomment = NULL;
					n->indexOid = InvalidOid;
					n->oldNode = InvalidOid;
					n->oldCreateSubid = InvalidSubTransactionId;
					n->oldFirstRelfilenodeSubid = InvalidSubTransactionId;
					n->primary = false;
					n->isconstraint = false;
					n->deferrable = false;
					n->initdeferred = false;
					n->transformed = false;
					n->if_not_exists = true;
					n->reset_default_tblspc = false;
					(yyval.node) = (Node *) n;
				}
#line 37704 "gram.c" /* yacc.c:1646  */
    break;

  case 1065:
#line 7983 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 37710 "gram.c" /* yacc.c:1646  */
    break;

  case 1066:
#line 7984 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 37716 "gram.c" /* yacc.c:1646  */
    break;

  case 1067:
#line 7988 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 37722 "gram.c" /* yacc.c:1646  */
    break;

  case 1068:
#line 7989 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 37728 "gram.c" /* yacc.c:1646  */
    break;

  case 1069:
#line 7993 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 37734 "gram.c" /* yacc.c:1646  */
    break;

  case 1070:
#line 7994 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = NULL; }
#line 37740 "gram.c" /* yacc.c:1646  */
    break;

  case 1071:
#line 7998 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 37746 "gram.c" /* yacc.c:1646  */
    break;

  case 1072:
#line 7999 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = DEFAULT_INDEX_TYPE; }
#line 37752 "gram.c" /* yacc.c:1646  */
    break;

  case 1073:
#line 8002 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].ielem)); }
#line 37758 "gram.c" /* yacc.c:1646  */
    break;

  case 1074:
#line 8003 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].ielem)); }
#line 37764 "gram.c" /* yacc.c:1646  */
    break;

  case 1075:
#line 8009 "gram.y" /* yacc.c:1646  */
    {
			(yyval.ielem) = makeNode(IndexElem);
			(yyval.ielem)->name = NULL;
			(yyval.ielem)->expr = NULL;
			(yyval.ielem)->indexcolname = NULL;
			(yyval.ielem)->collation = (yyvsp[-3].list);
			(yyval.ielem)->opclass = (yyvsp[-2].list);
			(yyval.ielem)->opclassopts = NIL;
			(yyval.ielem)->ordering = (yyvsp[-1].ival);
			(yyval.ielem)->nulls_ordering = (yyvsp[0].ival);
		}
#line 37780 "gram.c" /* yacc.c:1646  */
    break;

  case 1076:
#line 8021 "gram.y" /* yacc.c:1646  */
    {
			(yyval.ielem) = makeNode(IndexElem);
			(yyval.ielem)->name = NULL;
			(yyval.ielem)->expr = NULL;
			(yyval.ielem)->indexcolname = NULL;
			(yyval.ielem)->collation = (yyvsp[-4].list);
			(yyval.ielem)->opclass = (yyvsp[-3].list);
			(yyval.ielem)->opclassopts = (yyvsp[-2].list);
			(yyval.ielem)->ordering = (yyvsp[-1].ival);
			(yyval.ielem)->nulls_ordering = (yyvsp[0].ival);
		}
#line 37796 "gram.c" /* yacc.c:1646  */
    break;

  case 1077:
#line 8040 "gram.y" /* yacc.c:1646  */
    {
					(yyval.ielem) = (yyvsp[0].ielem);
					(yyval.ielem)->name = (yyvsp[-1].str);
				}
#line 37805 "gram.c" /* yacc.c:1646  */
    break;

  case 1078:
#line 8045 "gram.y" /* yacc.c:1646  */
    {
					(yyval.ielem) = (yyvsp[0].ielem);
					(yyval.ielem)->expr = (yyvsp[-1].node);
				}
#line 37814 "gram.c" /* yacc.c:1646  */
    break;

  case 1079:
#line 8050 "gram.y" /* yacc.c:1646  */
    {
					(yyval.ielem) = (yyvsp[0].ielem);
					(yyval.ielem)->expr = (yyvsp[-2].node);
				}
#line 37823 "gram.c" /* yacc.c:1646  */
    break;

  case 1080:
#line 8056 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 37829 "gram.c" /* yacc.c:1646  */
    break;

  case 1081:
#line 8057 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 37835 "gram.c" /* yacc.c:1646  */
    break;

  case 1082:
#line 8060 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].ielem)); }
#line 37841 "gram.c" /* yacc.c:1646  */
    break;

  case 1083:
#line 8061 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].ielem)); }
#line 37847 "gram.c" /* yacc.c:1646  */
    break;

  case 1084:
#line 8064 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 37853 "gram.c" /* yacc.c:1646  */
    break;

  case 1085:
#line 8065 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 37859 "gram.c" /* yacc.c:1646  */
    break;

  case 1086:
#line 8068 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 37865 "gram.c" /* yacc.c:1646  */
    break;

  case 1087:
#line 8069 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 37871 "gram.c" /* yacc.c:1646  */
    break;

  case 1088:
#line 8072 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = SORTBY_ASC; }
#line 37877 "gram.c" /* yacc.c:1646  */
    break;

  case 1089:
#line 8073 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = SORTBY_DESC; }
#line 37883 "gram.c" /* yacc.c:1646  */
    break;

  case 1090:
#line 8074 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = SORTBY_DEFAULT; }
#line 37889 "gram.c" /* yacc.c:1646  */
    break;

  case 1091:
#line 8077 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = SORTBY_NULLS_FIRST; }
#line 37895 "gram.c" /* yacc.c:1646  */
    break;

  case 1092:
#line 8078 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = SORTBY_NULLS_LAST; }
#line 37901 "gram.c" /* yacc.c:1646  */
    break;

  case 1093:
#line 8079 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = SORTBY_NULLS_DEFAULT; }
#line 37907 "gram.c" /* yacc.c:1646  */
    break;

  case 1094:
#line 8097 "gram.y" /* yacc.c:1646  */
    {
					CreateFunctionStmt *n = makeNode(CreateFunctionStmt);

					n->is_procedure = false;
					n->replace = (yyvsp[-7].boolean);
					n->funcname = (yyvsp[-5].list);
					n->parameters = (yyvsp[-4].list);
					n->returnType = (yyvsp[-2].typnam);
					n->options = (yyvsp[-1].list);
					n->sql_body = (yyvsp[0].node);
					(yyval.node) = (Node *) n;
				}
#line 37924 "gram.c" /* yacc.c:1646  */
    break;

  case 1095:
#line 8111 "gram.y" /* yacc.c:1646  */
    {
					CreateFunctionStmt *n = makeNode(CreateFunctionStmt);

					n->is_procedure = false;
					n->replace = (yyvsp[-10].boolean);
					n->funcname = (yyvsp[-8].list);
					n->parameters = mergeTableFuncParameters((yyvsp[-7].list), (yyvsp[-3].list));
					n->returnType = TableFuncTypeName((yyvsp[-3].list));
					n->returnType->location = (yylsp[-5]);
					n->options = (yyvsp[-1].list);
					n->sql_body = (yyvsp[0].node);
					(yyval.node) = (Node *) n;
				}
#line 37942 "gram.c" /* yacc.c:1646  */
    break;

  case 1096:
#line 8126 "gram.y" /* yacc.c:1646  */
    {
					CreateFunctionStmt *n = makeNode(CreateFunctionStmt);

					n->is_procedure = false;
					n->replace = (yyvsp[-5].boolean);
					n->funcname = (yyvsp[-3].list);
					n->parameters = (yyvsp[-2].list);
					n->returnType = NULL;
					n->options = (yyvsp[-1].list);
					n->sql_body = (yyvsp[0].node);
					(yyval.node) = (Node *) n;
				}
#line 37959 "gram.c" /* yacc.c:1646  */
    break;

  case 1097:
#line 8140 "gram.y" /* yacc.c:1646  */
    {
					CreateFunctionStmt *n = makeNode(CreateFunctionStmt);

					n->is_procedure = true;
					n->replace = (yyvsp[-5].boolean);
					n->funcname = (yyvsp[-3].list);
					n->parameters = (yyvsp[-2].list);
					n->returnType = NULL;
					n->options = (yyvsp[-1].list);
					n->sql_body = (yyvsp[0].node);
					(yyval.node) = (Node *) n;
				}
#line 37976 "gram.c" /* yacc.c:1646  */
    break;

  case 1098:
#line 8155 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 37982 "gram.c" /* yacc.c:1646  */
    break;

  case 1099:
#line 8156 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 37988 "gram.c" /* yacc.c:1646  */
    break;

  case 1100:
#line 8159 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 37994 "gram.c" /* yacc.c:1646  */
    break;

  case 1101:
#line 8160 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 38000 "gram.c" /* yacc.c:1646  */
    break;

  case 1102:
#line 8164 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].fun_param)); }
#line 38006 "gram.c" /* yacc.c:1646  */
    break;

  case 1103:
#line 8165 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].fun_param)); }
#line 38012 "gram.c" /* yacc.c:1646  */
    break;

  case 1104:
#line 8169 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].objwithargs)); }
#line 38018 "gram.c" /* yacc.c:1646  */
    break;

  case 1105:
#line 8171 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].objwithargs)); }
#line 38024 "gram.c" /* yacc.c:1646  */
    break;

  case 1106:
#line 8176 "gram.y" /* yacc.c:1646  */
    {
					ObjectWithArgs *n = makeNode(ObjectWithArgs);

					n->objname = (yyvsp[-1].list);
					n->objargs = extractArgTypes((yyvsp[0].list));
					n->objfuncargs = (yyvsp[0].list);
					(yyval.objwithargs) = n;
				}
#line 38037 "gram.c" /* yacc.c:1646  */
    break;

  case 1107:
#line 8190 "gram.y" /* yacc.c:1646  */
    {
					ObjectWithArgs *n = makeNode(ObjectWithArgs);

					n->objname = list_make1(makeString(pstrdup((yyvsp[0].keyword))));
					n->args_unspecified = true;
					(yyval.objwithargs) = n;
				}
#line 38049 "gram.c" /* yacc.c:1646  */
    break;

  case 1108:
#line 8198 "gram.y" /* yacc.c:1646  */
    {
					ObjectWithArgs *n = makeNode(ObjectWithArgs);

					n->objname = list_make1(makeString((yyvsp[0].str)));
					n->args_unspecified = true;
					(yyval.objwithargs) = n;
				}
#line 38061 "gram.c" /* yacc.c:1646  */
    break;

  case 1109:
#line 8206 "gram.y" /* yacc.c:1646  */
    {
					ObjectWithArgs *n = makeNode(ObjectWithArgs);

					n->objname = check_func_name(lcons(makeString((yyvsp[-1].str)), (yyvsp[0].list)),
												  yyscanner);
					n->args_unspecified = true;
					(yyval.objwithargs) = n;
				}
#line 38074 "gram.c" /* yacc.c:1646  */
    break;

  case 1110:
#line 8221 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 38080 "gram.c" /* yacc.c:1646  */
    break;

  case 1111:
#line 8222 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 38086 "gram.c" /* yacc.c:1646  */
    break;

  case 1112:
#line 8226 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].fun_param)); }
#line 38092 "gram.c" /* yacc.c:1646  */
    break;

  case 1113:
#line 8228 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].fun_param)); }
#line 38098 "gram.c" /* yacc.c:1646  */
    break;

  case 1114:
#line 8243 "gram.y" /* yacc.c:1646  */
    {
					FunctionParameter *n = makeNode(FunctionParameter);

					n->name = (yyvsp[-1].str);
					n->argType = (yyvsp[0].typnam);
					n->mode = (yyvsp[-2].fun_param_mode);
					n->defexpr = NULL;
					(yyval.fun_param) = n;
				}
#line 38112 "gram.c" /* yacc.c:1646  */
    break;

  case 1115:
#line 8253 "gram.y" /* yacc.c:1646  */
    {
					FunctionParameter *n = makeNode(FunctionParameter);

					n->name = (yyvsp[-2].str);
					n->argType = (yyvsp[0].typnam);
					n->mode = (yyvsp[-1].fun_param_mode);
					n->defexpr = NULL;
					(yyval.fun_param) = n;
				}
#line 38126 "gram.c" /* yacc.c:1646  */
    break;

  case 1116:
#line 8263 "gram.y" /* yacc.c:1646  */
    {
					FunctionParameter *n = makeNode(FunctionParameter);

					n->name = (yyvsp[-1].str);
					n->argType = (yyvsp[0].typnam);
					n->mode = FUNC_PARAM_DEFAULT;
					n->defexpr = NULL;
					(yyval.fun_param) = n;
				}
#line 38140 "gram.c" /* yacc.c:1646  */
    break;

  case 1117:
#line 8273 "gram.y" /* yacc.c:1646  */
    {
					FunctionParameter *n = makeNode(FunctionParameter);

					n->name = NULL;
					n->argType = (yyvsp[0].typnam);
					n->mode = (yyvsp[-1].fun_param_mode);
					n->defexpr = NULL;
					(yyval.fun_param) = n;
				}
#line 38154 "gram.c" /* yacc.c:1646  */
    break;

  case 1118:
#line 8283 "gram.y" /* yacc.c:1646  */
    {
					FunctionParameter *n = makeNode(FunctionParameter);

					n->name = NULL;
					n->argType = (yyvsp[0].typnam);
					n->mode = FUNC_PARAM_DEFAULT;
					n->defexpr = NULL;
					(yyval.fun_param) = n;
				}
#line 38168 "gram.c" /* yacc.c:1646  */
    break;

  case 1119:
#line 8295 "gram.y" /* yacc.c:1646  */
    { (yyval.fun_param_mode) = FUNC_PARAM_IN; }
#line 38174 "gram.c" /* yacc.c:1646  */
    break;

  case 1120:
#line 8296 "gram.y" /* yacc.c:1646  */
    { (yyval.fun_param_mode) = FUNC_PARAM_OUT; }
#line 38180 "gram.c" /* yacc.c:1646  */
    break;

  case 1121:
#line 8297 "gram.y" /* yacc.c:1646  */
    { (yyval.fun_param_mode) = FUNC_PARAM_INOUT; }
#line 38186 "gram.c" /* yacc.c:1646  */
    break;

  case 1122:
#line 8298 "gram.y" /* yacc.c:1646  */
    { (yyval.fun_param_mode) = FUNC_PARAM_INOUT; }
#line 38192 "gram.c" /* yacc.c:1646  */
    break;

  case 1123:
#line 8299 "gram.y" /* yacc.c:1646  */
    { (yyval.fun_param_mode) = FUNC_PARAM_VARIADIC; }
#line 38198 "gram.c" /* yacc.c:1646  */
    break;

  case 1125:
#line 8310 "gram.y" /* yacc.c:1646  */
    {
					/* We can catch over-specified results here if we want to,
					 * but for now better to silently swallow typmod, etc.
					 * - thomas 2000-03-22
					 */
					(yyval.typnam) = (yyvsp[0].typnam);
				}
#line 38210 "gram.c" /* yacc.c:1646  */
    break;

  case 1126:
#line 8324 "gram.y" /* yacc.c:1646  */
    { (yyval.typnam) = (yyvsp[0].typnam); }
#line 38216 "gram.c" /* yacc.c:1646  */
    break;

  case 1127:
#line 8326 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = makeTypeNameFromNameList(lcons(makeString((yyvsp[-3].str)), (yyvsp[-2].list)));
					(yyval.typnam)->pct_type = true;
					(yyval.typnam)->location = (yylsp[-3]);
				}
#line 38226 "gram.c" /* yacc.c:1646  */
    break;

  case 1128:
#line 8332 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = makeTypeNameFromNameList(lcons(makeString((yyvsp[-3].str)), (yyvsp[-2].list)));
					(yyval.typnam)->pct_type = true;
					(yyval.typnam)->setof = true;
					(yyval.typnam)->location = (yylsp[-3]);
				}
#line 38237 "gram.c" /* yacc.c:1646  */
    break;

  case 1129:
#line 8342 "gram.y" /* yacc.c:1646  */
    {
					(yyval.fun_param) = (yyvsp[0].fun_param);
				}
#line 38245 "gram.c" /* yacc.c:1646  */
    break;

  case 1130:
#line 8346 "gram.y" /* yacc.c:1646  */
    {
					(yyval.fun_param) = (yyvsp[-2].fun_param);
					(yyval.fun_param)->defexpr = (yyvsp[0].node);
				}
#line 38254 "gram.c" /* yacc.c:1646  */
    break;

  case 1131:
#line 8351 "gram.y" /* yacc.c:1646  */
    {
					(yyval.fun_param) = (yyvsp[-2].fun_param);
					(yyval.fun_param)->defexpr = (yyvsp[0].node);
				}
#line 38263 "gram.c" /* yacc.c:1646  */
    break;

  case 1132:
#line 8359 "gram.y" /* yacc.c:1646  */
    {
					if (!((yyvsp[0].fun_param)->mode == FUNC_PARAM_DEFAULT ||
						  (yyvsp[0].fun_param)->mode == FUNC_PARAM_IN ||
						  (yyvsp[0].fun_param)->mode == FUNC_PARAM_VARIADIC))
						ereport(ERROR,
								(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
								 errmsg("aggregates cannot have output arguments"),
								 parser_errposition((yylsp[0]))));
					(yyval.fun_param) = (yyvsp[0].fun_param);
				}
#line 38278 "gram.c" /* yacc.c:1646  */
    break;

  case 1133:
#line 8401 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make2(NIL, makeInteger(-1));
				}
#line 38286 "gram.c" /* yacc.c:1646  */
    break;

  case 1134:
#line 8405 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make2((yyvsp[-1].list), makeInteger(-1));
				}
#line 38294 "gram.c" /* yacc.c:1646  */
    break;

  case 1135:
#line 8409 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make2((yyvsp[-1].list), makeInteger(0));
				}
#line 38302 "gram.c" /* yacc.c:1646  */
    break;

  case 1136:
#line 8413 "gram.y" /* yacc.c:1646  */
    {
					/* this is the only case requiring consistency checking */
					(yyval.list) = makeOrderedSetArgs((yyvsp[-4].list), (yyvsp[-1].list), yyscanner);
				}
#line 38311 "gram.c" /* yacc.c:1646  */
    break;

  case 1137:
#line 8420 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].fun_param)); }
#line 38317 "gram.c" /* yacc.c:1646  */
    break;

  case 1138:
#line 8421 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].fun_param)); }
#line 38323 "gram.c" /* yacc.c:1646  */
    break;

  case 1139:
#line 8426 "gram.y" /* yacc.c:1646  */
    {
					ObjectWithArgs *n = makeNode(ObjectWithArgs);

					n->objname = (yyvsp[-1].list);
					n->objargs = extractAggrArgTypes((yyvsp[0].list));
					n->objfuncargs = (List *) linitial((yyvsp[0].list));
					(yyval.objwithargs) = n;
				}
#line 38336 "gram.c" /* yacc.c:1646  */
    break;

  case 1140:
#line 8437 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].objwithargs)); }
#line 38342 "gram.c" /* yacc.c:1646  */
    break;

  case 1141:
#line 8439 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].objwithargs)); }
#line 38348 "gram.c" /* yacc.c:1646  */
    break;

  case 1143:
#line 8444 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 38354 "gram.c" /* yacc.c:1646  */
    break;

  case 1144:
#line 8449 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].defelt)); }
#line 38360 "gram.c" /* yacc.c:1646  */
    break;

  case 1145:
#line 8450 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].defelt)); }
#line 38366 "gram.c" /* yacc.c:1646  */
    break;

  case 1146:
#line 8458 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("strict", (Node *) makeBoolean(false), (yylsp[-3]));
				}
#line 38374 "gram.c" /* yacc.c:1646  */
    break;

  case 1147:
#line 8462 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("strict", (Node *) makeBoolean(true), (yylsp[-4]));
				}
#line 38382 "gram.c" /* yacc.c:1646  */
    break;

  case 1148:
#line 8466 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("strict", (Node *) makeBoolean(true), (yylsp[0]));
				}
#line 38390 "gram.c" /* yacc.c:1646  */
    break;

  case 1149:
#line 8470 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("volatility", (Node *) makeString("immutable"), (yylsp[0]));
				}
#line 38398 "gram.c" /* yacc.c:1646  */
    break;

  case 1150:
#line 8474 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("volatility", (Node *) makeString("stable"), (yylsp[0]));
				}
#line 38406 "gram.c" /* yacc.c:1646  */
    break;

  case 1151:
#line 8478 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("volatility", (Node *) makeString("volatile"), (yylsp[0]));
				}
#line 38414 "gram.c" /* yacc.c:1646  */
    break;

  case 1152:
#line 8482 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("security", (Node *) makeBoolean(true), (yylsp[-2]));
				}
#line 38422 "gram.c" /* yacc.c:1646  */
    break;

  case 1153:
#line 8486 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("security", (Node *) makeBoolean(false), (yylsp[-2]));
				}
#line 38430 "gram.c" /* yacc.c:1646  */
    break;

  case 1154:
#line 8490 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("security", (Node *) makeBoolean(true), (yylsp[-1]));
				}
#line 38438 "gram.c" /* yacc.c:1646  */
    break;

  case 1155:
#line 8494 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("security", (Node *) makeBoolean(false), (yylsp[-1]));
				}
#line 38446 "gram.c" /* yacc.c:1646  */
    break;

  case 1156:
#line 8498 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("leakproof", (Node *) makeBoolean(true), (yylsp[0]));
				}
#line 38454 "gram.c" /* yacc.c:1646  */
    break;

  case 1157:
#line 8502 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("leakproof", (Node *) makeBoolean(false), (yylsp[-1]));
				}
#line 38462 "gram.c" /* yacc.c:1646  */
    break;

  case 1158:
#line 8506 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("cost", (Node *) (yyvsp[0].node), (yylsp[-1]));
				}
#line 38470 "gram.c" /* yacc.c:1646  */
    break;

  case 1159:
#line 8510 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("rows", (Node *) (yyvsp[0].node), (yylsp[-1]));
				}
#line 38478 "gram.c" /* yacc.c:1646  */
    break;

  case 1160:
#line 8514 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("support", (Node *) (yyvsp[0].list), (yylsp[-1]));
				}
#line 38486 "gram.c" /* yacc.c:1646  */
    break;

  case 1161:
#line 8518 "gram.y" /* yacc.c:1646  */
    {
					/* we abuse the normal content of a DefElem here */
					(yyval.defelt) = makeDefElem("set", (Node *) (yyvsp[0].vsetstmt), (yylsp[0]));
				}
#line 38495 "gram.c" /* yacc.c:1646  */
    break;

  case 1162:
#line 8523 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("parallel", (Node *) makeString((yyvsp[0].str)), (yylsp[-1]));
				}
#line 38503 "gram.c" /* yacc.c:1646  */
    break;

  case 1163:
#line 8530 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("as", (Node *) (yyvsp[0].list), (yylsp[-1]));
				}
#line 38511 "gram.c" /* yacc.c:1646  */
    break;

  case 1164:
#line 8534 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("language", (Node *) makeString((yyvsp[0].str)), (yylsp[-1]));
				}
#line 38519 "gram.c" /* yacc.c:1646  */
    break;

  case 1165:
#line 8538 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("transform", (Node *) (yyvsp[0].list), (yylsp[-1]));
				}
#line 38527 "gram.c" /* yacc.c:1646  */
    break;

  case 1166:
#line 8542 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("window", (Node *) makeBoolean(true), (yylsp[0]));
				}
#line 38535 "gram.c" /* yacc.c:1646  */
    break;

  case 1167:
#line 8546 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = (yyvsp[0].defelt);
				}
#line 38543 "gram.c" /* yacc.c:1646  */
    break;

  case 1168:
#line 8551 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeString((yyvsp[0].str))); }
#line 38549 "gram.c" /* yacc.c:1646  */
    break;

  case 1169:
#line 8553 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make2(makeString((yyvsp[-2].str)), makeString((yyvsp[0].str)));
				}
#line 38557 "gram.c" /* yacc.c:1646  */
    break;

  case 1170:
#line 8559 "gram.y" /* yacc.c:1646  */
    {
					ReturnStmt *r = makeNode(ReturnStmt);

					r->returnval = (Node *) (yyvsp[0].node);
					(yyval.node) = (Node *) r;
				}
#line 38568 "gram.c" /* yacc.c:1646  */
    break;

  case 1171:
#line 8569 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (yyvsp[0].node);
				}
#line 38576 "gram.c" /* yacc.c:1646  */
    break;

  case 1172:
#line 8573 "gram.y" /* yacc.c:1646  */
    {
					/*
					 * A compound statement is stored as a single-item list
					 * containing the list of statements as its member.  That
					 * way, the parse analysis code can tell apart an empty
					 * body from no body at all.
					 */
					(yyval.node) = (Node *) list_make1((yyvsp[-1].list));
				}
#line 38590 "gram.c" /* yacc.c:1646  */
    break;

  case 1173:
#line 8583 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = NULL;
				}
#line 38598 "gram.c" /* yacc.c:1646  */
    break;

  case 1174:
#line 8590 "gram.y" /* yacc.c:1646  */
    {
					/* As in stmtmulti, discard empty statements */
					if ((yyvsp[-1].node) != NULL)
						(yyval.list) = lappend((yyvsp[-2].list), (yyvsp[-1].node));
					else
						(yyval.list) = (yyvsp[-2].list);
				}
#line 38610 "gram.c" /* yacc.c:1646  */
    break;

  case 1175:
#line 8598 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = NIL;
				}
#line 38618 "gram.c" /* yacc.c:1646  */
    break;

  case 1178:
#line 8609 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].typnam)); }
#line 38624 "gram.c" /* yacc.c:1646  */
    break;

  case 1179:
#line 8610 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-4].list), (yyvsp[0].typnam)); }
#line 38630 "gram.c" /* yacc.c:1646  */
    break;

  case 1180:
#line 8614 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 38636 "gram.c" /* yacc.c:1646  */
    break;

  case 1181:
#line 8615 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 38642 "gram.c" /* yacc.c:1646  */
    break;

  case 1182:
#line 8619 "gram.y" /* yacc.c:1646  */
    {
					FunctionParameter *n = makeNode(FunctionParameter);

					n->name = (yyvsp[-1].str);
					n->argType = (yyvsp[0].typnam);
					n->mode = FUNC_PARAM_TABLE;
					n->defexpr = NULL;
					(yyval.fun_param) = n;
				}
#line 38656 "gram.c" /* yacc.c:1646  */
    break;

  case 1183:
#line 8632 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make1((yyvsp[0].fun_param));
				}
#line 38664 "gram.c" /* yacc.c:1646  */
    break;

  case 1184:
#line 8636 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].fun_param));
				}
#line 38672 "gram.c" /* yacc.c:1646  */
    break;

  case 1185:
#line 8651 "gram.y" /* yacc.c:1646  */
    {
					AlterFunctionStmt *n = makeNode(AlterFunctionStmt);

					n->objtype = OBJECT_FUNCTION;
					n->func = (yyvsp[-2].objwithargs);
					n->actions = (yyvsp[-1].list);
					(yyval.node) = (Node *) n;
				}
#line 38685 "gram.c" /* yacc.c:1646  */
    break;

  case 1186:
#line 8660 "gram.y" /* yacc.c:1646  */
    {
					AlterFunctionStmt *n = makeNode(AlterFunctionStmt);

					n->objtype = OBJECT_PROCEDURE;
					n->func = (yyvsp[-2].objwithargs);
					n->actions = (yyvsp[-1].list);
					(yyval.node) = (Node *) n;
				}
#line 38698 "gram.c" /* yacc.c:1646  */
    break;

  case 1187:
#line 8669 "gram.y" /* yacc.c:1646  */
    {
					AlterFunctionStmt *n = makeNode(AlterFunctionStmt);

					n->objtype = OBJECT_ROUTINE;
					n->func = (yyvsp[-2].objwithargs);
					n->actions = (yyvsp[-1].list);
					(yyval.node) = (Node *) n;
				}
#line 38711 "gram.c" /* yacc.c:1646  */
    break;

  case 1188:
#line 8681 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].defelt)); }
#line 38717 "gram.c" /* yacc.c:1646  */
    break;

  case 1189:
#line 8682 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].defelt)); }
#line 38723 "gram.c" /* yacc.c:1646  */
    break;

  case 1192:
#line 8706 "gram.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);

					n->removeType = OBJECT_FUNCTION;
					n->objects = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = false;
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 38738 "gram.c" /* yacc.c:1646  */
    break;

  case 1193:
#line 8717 "gram.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);

					n->removeType = OBJECT_FUNCTION;
					n->objects = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = true;
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 38753 "gram.c" /* yacc.c:1646  */
    break;

  case 1194:
#line 8728 "gram.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);

					n->removeType = OBJECT_PROCEDURE;
					n->objects = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = false;
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 38768 "gram.c" /* yacc.c:1646  */
    break;

  case 1195:
#line 8739 "gram.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);

					n->removeType = OBJECT_PROCEDURE;
					n->objects = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = true;
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 38783 "gram.c" /* yacc.c:1646  */
    break;

  case 1196:
#line 8750 "gram.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);

					n->removeType = OBJECT_ROUTINE;
					n->objects = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = false;
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 38798 "gram.c" /* yacc.c:1646  */
    break;

  case 1197:
#line 8761 "gram.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);

					n->removeType = OBJECT_ROUTINE;
					n->objects = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = true;
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 38813 "gram.c" /* yacc.c:1646  */
    break;

  case 1198:
#line 8775 "gram.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);

					n->removeType = OBJECT_AGGREGATE;
					n->objects = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = false;
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 38828 "gram.c" /* yacc.c:1646  */
    break;

  case 1199:
#line 8786 "gram.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);

					n->removeType = OBJECT_AGGREGATE;
					n->objects = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = true;
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 38843 "gram.c" /* yacc.c:1646  */
    break;

  case 1200:
#line 8800 "gram.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);

					n->removeType = OBJECT_OPERATOR;
					n->objects = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = false;
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 38858 "gram.c" /* yacc.c:1646  */
    break;

  case 1201:
#line 8811 "gram.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);

					n->removeType = OBJECT_OPERATOR;
					n->objects = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = true;
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 38873 "gram.c" /* yacc.c:1646  */
    break;

  case 1202:
#line 8825 "gram.y" /* yacc.c:1646  */
    {
				   ereport(ERROR,
						   (errcode(ERRCODE_SYNTAX_ERROR),
							errmsg("missing argument"),
							errhint("Use NONE to denote the missing argument of a unary operator."),
							parser_errposition((yylsp[0]))));
				}
#line 38885 "gram.c" /* yacc.c:1646  */
    break;

  case 1203:
#line 8833 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make2((yyvsp[-3].typnam), (yyvsp[-1].typnam)); }
#line 38891 "gram.c" /* yacc.c:1646  */
    break;

  case 1204:
#line 8835 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make2(NULL, (yyvsp[-1].typnam)); }
#line 38897 "gram.c" /* yacc.c:1646  */
    break;

  case 1205:
#line 8837 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make2((yyvsp[-3].typnam), NULL); }
#line 38903 "gram.c" /* yacc.c:1646  */
    break;

  case 1206:
#line 8842 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeString((yyvsp[0].str))); }
#line 38909 "gram.c" /* yacc.c:1646  */
    break;

  case 1207:
#line 8844 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lcons(makeString((yyvsp[-2].str)), (yyvsp[0].list)); }
#line 38915 "gram.c" /* yacc.c:1646  */
    break;

  case 1208:
#line 8848 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].objwithargs)); }
#line 38921 "gram.c" /* yacc.c:1646  */
    break;

  case 1209:
#line 8850 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].objwithargs)); }
#line 38927 "gram.c" /* yacc.c:1646  */
    break;

  case 1210:
#line 8855 "gram.y" /* yacc.c:1646  */
    {
					ObjectWithArgs *n = makeNode(ObjectWithArgs);

					n->objname = (yyvsp[-1].list);
					n->objargs = (yyvsp[0].list);
					(yyval.objwithargs) = n;
				}
#line 38939 "gram.c" /* yacc.c:1646  */
    break;

  case 1211:
#line 8874 "gram.y" /* yacc.c:1646  */
    {
					DoStmt *n = makeNode(DoStmt);

					n->args = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 38950 "gram.c" /* yacc.c:1646  */
    break;

  case 1212:
#line 8883 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].defelt)); }
#line 38956 "gram.c" /* yacc.c:1646  */
    break;

  case 1213:
#line 8884 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].defelt)); }
#line 38962 "gram.c" /* yacc.c:1646  */
    break;

  case 1214:
#line 8889 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("as", (Node *) makeString((yyvsp[0].str)), (yylsp[0]));
				}
#line 38970 "gram.c" /* yacc.c:1646  */
    break;

  case 1215:
#line 8893 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("language", (Node *) makeString((yyvsp[0].str)), (yylsp[-1]));
				}
#line 38978 "gram.c" /* yacc.c:1646  */
    break;

  case 1216:
#line 8906 "gram.y" /* yacc.c:1646  */
    {
					CreateCastStmt *n = makeNode(CreateCastStmt);

					n->sourcetype = (yyvsp[-7].typnam);
					n->targettype = (yyvsp[-5].typnam);
					n->func = (yyvsp[-1].objwithargs);
					n->context = (CoercionContext) (yyvsp[0].ival);
					n->inout = false;
					(yyval.node) = (Node *) n;
				}
#line 38993 "gram.c" /* yacc.c:1646  */
    break;

  case 1217:
#line 8918 "gram.y" /* yacc.c:1646  */
    {
					CreateCastStmt *n = makeNode(CreateCastStmt);

					n->sourcetype = (yyvsp[-6].typnam);
					n->targettype = (yyvsp[-4].typnam);
					n->func = NULL;
					n->context = (CoercionContext) (yyvsp[0].ival);
					n->inout = false;
					(yyval.node) = (Node *) n;
				}
#line 39008 "gram.c" /* yacc.c:1646  */
    break;

  case 1218:
#line 8930 "gram.y" /* yacc.c:1646  */
    {
					CreateCastStmt *n = makeNode(CreateCastStmt);

					n->sourcetype = (yyvsp[-6].typnam);
					n->targettype = (yyvsp[-4].typnam);
					n->func = NULL;
					n->context = (CoercionContext) (yyvsp[0].ival);
					n->inout = true;
					(yyval.node) = (Node *) n;
				}
#line 39023 "gram.c" /* yacc.c:1646  */
    break;

  case 1219:
#line 8942 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = COERCION_IMPLICIT; }
#line 39029 "gram.c" /* yacc.c:1646  */
    break;

  case 1220:
#line 8943 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = COERCION_ASSIGNMENT; }
#line 39035 "gram.c" /* yacc.c:1646  */
    break;

  case 1221:
#line 8944 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = COERCION_EXPLICIT; }
#line 39041 "gram.c" /* yacc.c:1646  */
    break;

  case 1222:
#line 8949 "gram.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);

					n->removeType = OBJECT_CAST;
					n->objects = list_make1(list_make2((yyvsp[-4].typnam), (yyvsp[-2].typnam)));
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = (yyvsp[-6].boolean);
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 39056 "gram.c" /* yacc.c:1646  */
    break;

  case 1223:
#line 8961 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 39062 "gram.c" /* yacc.c:1646  */
    break;

  case 1224:
#line 8962 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 39068 "gram.c" /* yacc.c:1646  */
    break;

  case 1225:
#line 8973 "gram.y" /* yacc.c:1646  */
    {
					CreateTransformStmt *n = makeNode(CreateTransformStmt);

					n->replace = (yyvsp[-8].boolean);
					n->type_name = (yyvsp[-5].typnam);
					n->lang = (yyvsp[-3].str);
					n->fromsql = linitial((yyvsp[-1].list));
					n->tosql = lsecond((yyvsp[-1].list));
					(yyval.node) = (Node *) n;
				}
#line 39083 "gram.c" /* yacc.c:1646  */
    break;

  case 1226:
#line 8986 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make2((yyvsp[-6].objwithargs), (yyvsp[0].objwithargs));
				}
#line 39091 "gram.c" /* yacc.c:1646  */
    break;

  case 1227:
#line 8990 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make2((yyvsp[0].objwithargs), (yyvsp[-6].objwithargs));
				}
#line 39099 "gram.c" /* yacc.c:1646  */
    break;

  case 1228:
#line 8994 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make2((yyvsp[0].objwithargs), NULL);
				}
#line 39107 "gram.c" /* yacc.c:1646  */
    break;

  case 1229:
#line 8998 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make2(NULL, (yyvsp[0].objwithargs));
				}
#line 39115 "gram.c" /* yacc.c:1646  */
    break;

  case 1230:
#line 9005 "gram.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);

					n->removeType = OBJECT_TRANSFORM;
					n->objects = list_make1(list_make2((yyvsp[-3].typnam), makeString((yyvsp[-1].str))));
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = (yyvsp[-5].boolean);
					(yyval.node) = (Node *) n;
				}
#line 39129 "gram.c" /* yacc.c:1646  */
    break;

  case 1231:
#line 9026 "gram.y" /* yacc.c:1646  */
    {
					ReindexStmt *n = makeNode(ReindexStmt);

					n->kind = (yyvsp[-2].ival);
					n->relation = (yyvsp[0].range);
					n->name = NULL;
					n->params = NIL;
					if ((yyvsp[-1].boolean))
						n->params = lappend(n->params,
											makeDefElem("concurrently", NULL, (yylsp[-1])));
					(yyval.node) = (Node *) n;
				}
#line 39146 "gram.c" /* yacc.c:1646  */
    break;

  case 1232:
#line 9039 "gram.y" /* yacc.c:1646  */
    {
					ReindexStmt *n = makeNode(ReindexStmt);

					n->kind = (yyvsp[-2].ival);
					n->name = (yyvsp[0].str);
					n->relation = NULL;
					n->params = NIL;
					if ((yyvsp[-1].boolean))
						n->params = lappend(n->params,
											makeDefElem("concurrently", NULL, (yylsp[-1])));
					(yyval.node) = (Node *) n;
				}
#line 39163 "gram.c" /* yacc.c:1646  */
    break;

  case 1233:
#line 9052 "gram.y" /* yacc.c:1646  */
    {
					ReindexStmt *n = makeNode(ReindexStmt);

					n->kind = (yyvsp[-2].ival);
					n->relation = (yyvsp[0].range);
					n->name = NULL;
					n->params = (yyvsp[-4].list);
					if ((yyvsp[-1].boolean))
						n->params = lappend(n->params,
											makeDefElem("concurrently", NULL, (yylsp[-1])));
					(yyval.node) = (Node *) n;
				}
#line 39180 "gram.c" /* yacc.c:1646  */
    break;

  case 1234:
#line 9065 "gram.y" /* yacc.c:1646  */
    {
					ReindexStmt *n = makeNode(ReindexStmt);

					n->kind = (yyvsp[-2].ival);
					n->name = (yyvsp[0].str);
					n->relation = NULL;
					n->params = (yyvsp[-4].list);
					if ((yyvsp[-1].boolean))
						n->params = lappend(n->params,
											makeDefElem("concurrently", NULL, (yylsp[-1])));
					(yyval.node) = (Node *) n;
				}
#line 39197 "gram.c" /* yacc.c:1646  */
    break;

  case 1235:
#line 9079 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = REINDEX_OBJECT_INDEX; }
#line 39203 "gram.c" /* yacc.c:1646  */
    break;

  case 1236:
#line 9080 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = REINDEX_OBJECT_TABLE; }
#line 39209 "gram.c" /* yacc.c:1646  */
    break;

  case 1237:
#line 9083 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = REINDEX_OBJECT_SCHEMA; }
#line 39215 "gram.c" /* yacc.c:1646  */
    break;

  case 1238:
#line 9084 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = REINDEX_OBJECT_SYSTEM; }
#line 39221 "gram.c" /* yacc.c:1646  */
    break;

  case 1239:
#line 9085 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = REINDEX_OBJECT_DATABASE; }
#line 39227 "gram.c" /* yacc.c:1646  */
    break;

  case 1240:
#line 9096 "gram.y" /* yacc.c:1646  */
    {
					AlterTableSpaceOptionsStmt *n =
						makeNode(AlterTableSpaceOptionsStmt);

					n->tablespacename = (yyvsp[-2].str);
					n->options = (yyvsp[0].list);
					n->isReset = false;
					(yyval.node) = (Node *) n;
				}
#line 39241 "gram.c" /* yacc.c:1646  */
    break;

  case 1241:
#line 9106 "gram.y" /* yacc.c:1646  */
    {
					AlterTableSpaceOptionsStmt *n =
						makeNode(AlterTableSpaceOptionsStmt);

					n->tablespacename = (yyvsp[-2].str);
					n->options = (yyvsp[0].list);
					n->isReset = true;
					(yyval.node) = (Node *) n;
				}
#line 39255 "gram.c" /* yacc.c:1646  */
    break;

  case 1242:
#line 9124 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_AGGREGATE;
					n->object = (Node *) (yyvsp[-3].objwithargs);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 39269 "gram.c" /* yacc.c:1646  */
    break;

  case 1243:
#line 9134 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_COLLATION;
					n->object = (Node *) (yyvsp[-3].list);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 39283 "gram.c" /* yacc.c:1646  */
    break;

  case 1244:
#line 9144 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_CONVERSION;
					n->object = (Node *) (yyvsp[-3].list);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 39297 "gram.c" /* yacc.c:1646  */
    break;

  case 1245:
#line 9154 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_DATABASE;
					n->subname = (yyvsp[-3].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 39311 "gram.c" /* yacc.c:1646  */
    break;

  case 1246:
#line 9164 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_DOMAIN;
					n->object = (Node *) (yyvsp[-3].list);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 39325 "gram.c" /* yacc.c:1646  */
    break;

  case 1247:
#line 9174 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_DOMCONSTRAINT;
					n->object = (Node *) (yyvsp[-5].list);
					n->subname = (yyvsp[-2].str);
					n->newname = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 39339 "gram.c" /* yacc.c:1646  */
    break;

  case 1248:
#line 9184 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_FDW;
					n->object = (Node *) makeString((yyvsp[-3].str));
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 39353 "gram.c" /* yacc.c:1646  */
    break;

  case 1249:
#line 9194 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_FUNCTION;
					n->object = (Node *) (yyvsp[-3].objwithargs);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 39367 "gram.c" /* yacc.c:1646  */
    break;

  case 1250:
#line 9204 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_ROLE;
					n->subname = (yyvsp[-3].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 39381 "gram.c" /* yacc.c:1646  */
    break;

  case 1251:
#line 9214 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_LANGUAGE;
					n->object = (Node *) makeString((yyvsp[-3].str));
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 39395 "gram.c" /* yacc.c:1646  */
    break;

  case 1252:
#line 9224 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_OPCLASS;
					n->object = (Node *) lcons(makeString((yyvsp[-3].str)), (yyvsp[-5].list));
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 39409 "gram.c" /* yacc.c:1646  */
    break;

  case 1253:
#line 9234 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_OPFAMILY;
					n->object = (Node *) lcons(makeString((yyvsp[-3].str)), (yyvsp[-5].list));
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 39423 "gram.c" /* yacc.c:1646  */
    break;

  case 1254:
#line 9244 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_POLICY;
					n->relation = (yyvsp[-3].range);
					n->subname = (yyvsp[-5].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 39438 "gram.c" /* yacc.c:1646  */
    break;

  case 1255:
#line 9255 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_POLICY;
					n->relation = (yyvsp[-3].range);
					n->subname = (yyvsp[-5].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 39453 "gram.c" /* yacc.c:1646  */
    break;

  case 1256:
#line 9266 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_PROCEDURE;
					n->object = (Node *) (yyvsp[-3].objwithargs);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 39467 "gram.c" /* yacc.c:1646  */
    break;

  case 1257:
#line 9276 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_PUBLICATION;
					n->object = (Node *) makeString((yyvsp[-3].str));
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 39481 "gram.c" /* yacc.c:1646  */
    break;

  case 1258:
#line 9286 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_ROUTINE;
					n->object = (Node *) (yyvsp[-3].objwithargs);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 39495 "gram.c" /* yacc.c:1646  */
    break;

  case 1259:
#line 9296 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_SCHEMA;
					n->subname = (yyvsp[-3].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 39509 "gram.c" /* yacc.c:1646  */
    break;

  case 1260:
#line 9306 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_FOREIGN_SERVER;
					n->object = (Node *) makeString((yyvsp[-3].str));
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 39523 "gram.c" /* yacc.c:1646  */
    break;

  case 1261:
#line 9316 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_SUBSCRIPTION;
					n->object = (Node *) makeString((yyvsp[-3].str));
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 39537 "gram.c" /* yacc.c:1646  */
    break;

  case 1262:
#line 9326 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_TABLE;
					n->relation = (yyvsp[-3].range);
					n->subname = NULL;
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 39552 "gram.c" /* yacc.c:1646  */
    break;

  case 1263:
#line 9337 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_TABLE;
					n->relation = (yyvsp[-3].range);
					n->subname = NULL;
					n->newname = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 39567 "gram.c" /* yacc.c:1646  */
    break;

  case 1264:
#line 9348 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_SEQUENCE;
					n->relation = (yyvsp[-3].range);
					n->subname = NULL;
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 39582 "gram.c" /* yacc.c:1646  */
    break;

  case 1265:
#line 9359 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_SEQUENCE;
					n->relation = (yyvsp[-3].range);
					n->subname = NULL;
					n->newname = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 39597 "gram.c" /* yacc.c:1646  */
    break;

  case 1266:
#line 9370 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_VIEW;
					n->relation = (yyvsp[-3].range);
					n->subname = NULL;
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 39612 "gram.c" /* yacc.c:1646  */
    break;

  case 1267:
#line 9381 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_VIEW;
					n->relation = (yyvsp[-3].range);
					n->subname = NULL;
					n->newname = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 39627 "gram.c" /* yacc.c:1646  */
    break;

  case 1268:
#line 9392 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_MATVIEW;
					n->relation = (yyvsp[-3].range);
					n->subname = NULL;
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 39642 "gram.c" /* yacc.c:1646  */
    break;

  case 1269:
#line 9403 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_MATVIEW;
					n->relation = (yyvsp[-3].range);
					n->subname = NULL;
					n->newname = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 39657 "gram.c" /* yacc.c:1646  */
    break;

  case 1270:
#line 9414 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_INDEX;
					n->relation = (yyvsp[-3].range);
					n->subname = NULL;
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 39672 "gram.c" /* yacc.c:1646  */
    break;

  case 1271:
#line 9425 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_INDEX;
					n->relation = (yyvsp[-3].range);
					n->subname = NULL;
					n->newname = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 39687 "gram.c" /* yacc.c:1646  */
    break;

  case 1272:
#line 9436 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_FOREIGN_TABLE;
					n->relation = (yyvsp[-3].range);
					n->subname = NULL;
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 39702 "gram.c" /* yacc.c:1646  */
    break;

  case 1273:
#line 9447 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_FOREIGN_TABLE;
					n->relation = (yyvsp[-3].range);
					n->subname = NULL;
					n->newname = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 39717 "gram.c" /* yacc.c:1646  */
    break;

  case 1274:
#line 9458 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_COLUMN;
					n->relationType = OBJECT_TABLE;
					n->relation = (yyvsp[-5].range);
					n->subname = (yyvsp[-2].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 39733 "gram.c" /* yacc.c:1646  */
    break;

  case 1275:
#line 9470 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_COLUMN;
					n->relationType = OBJECT_TABLE;
					n->relation = (yyvsp[-5].range);
					n->subname = (yyvsp[-2].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 39749 "gram.c" /* yacc.c:1646  */
    break;

  case 1276:
#line 9482 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_COLUMN;
					n->relationType = OBJECT_VIEW;
					n->relation = (yyvsp[-5].range);
					n->subname = (yyvsp[-2].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 39765 "gram.c" /* yacc.c:1646  */
    break;

  case 1277:
#line 9494 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_COLUMN;
					n->relationType = OBJECT_VIEW;
					n->relation = (yyvsp[-5].range);
					n->subname = (yyvsp[-2].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 39781 "gram.c" /* yacc.c:1646  */
    break;

  case 1278:
#line 9506 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_COLUMN;
					n->relationType = OBJECT_MATVIEW;
					n->relation = (yyvsp[-5].range);
					n->subname = (yyvsp[-2].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 39797 "gram.c" /* yacc.c:1646  */
    break;

  case 1279:
#line 9518 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_COLUMN;
					n->relationType = OBJECT_MATVIEW;
					n->relation = (yyvsp[-5].range);
					n->subname = (yyvsp[-2].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 39813 "gram.c" /* yacc.c:1646  */
    break;

  case 1280:
#line 9530 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_TABCONSTRAINT;
					n->relation = (yyvsp[-5].range);
					n->subname = (yyvsp[-2].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 39828 "gram.c" /* yacc.c:1646  */
    break;

  case 1281:
#line 9541 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_TABCONSTRAINT;
					n->relation = (yyvsp[-5].range);
					n->subname = (yyvsp[-2].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 39843 "gram.c" /* yacc.c:1646  */
    break;

  case 1282:
#line 9552 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_COLUMN;
					n->relationType = OBJECT_FOREIGN_TABLE;
					n->relation = (yyvsp[-5].range);
					n->subname = (yyvsp[-2].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 39859 "gram.c" /* yacc.c:1646  */
    break;

  case 1283:
#line 9564 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_COLUMN;
					n->relationType = OBJECT_FOREIGN_TABLE;
					n->relation = (yyvsp[-5].range);
					n->subname = (yyvsp[-2].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 39875 "gram.c" /* yacc.c:1646  */
    break;

  case 1284:
#line 9576 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_RULE;
					n->relation = (yyvsp[-3].range);
					n->subname = (yyvsp[-5].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 39890 "gram.c" /* yacc.c:1646  */
    break;

  case 1285:
#line 9587 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_TRIGGER;
					n->relation = (yyvsp[-3].range);
					n->subname = (yyvsp[-5].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 39905 "gram.c" /* yacc.c:1646  */
    break;

  case 1286:
#line 9598 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_EVENT_TRIGGER;
					n->object = (Node *) makeString((yyvsp[-3].str));
					n->newname = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 39918 "gram.c" /* yacc.c:1646  */
    break;

  case 1287:
#line 9607 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_ROLE;
					n->subname = (yyvsp[-3].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 39932 "gram.c" /* yacc.c:1646  */
    break;

  case 1288:
#line 9617 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_ROLE;
					n->subname = (yyvsp[-3].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 39946 "gram.c" /* yacc.c:1646  */
    break;

  case 1289:
#line 9627 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_TABLESPACE;
					n->subname = (yyvsp[-3].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 39960 "gram.c" /* yacc.c:1646  */
    break;

  case 1290:
#line 9637 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_STATISTIC_EXT;
					n->object = (Node *) (yyvsp[-3].list);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 39974 "gram.c" /* yacc.c:1646  */
    break;

  case 1291:
#line 9647 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_TSPARSER;
					n->object = (Node *) (yyvsp[-3].list);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 39988 "gram.c" /* yacc.c:1646  */
    break;

  case 1292:
#line 9657 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_TSDICTIONARY;
					n->object = (Node *) (yyvsp[-3].list);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 40002 "gram.c" /* yacc.c:1646  */
    break;

  case 1293:
#line 9667 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_TSTEMPLATE;
					n->object = (Node *) (yyvsp[-3].list);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 40016 "gram.c" /* yacc.c:1646  */
    break;

  case 1294:
#line 9677 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_TSCONFIGURATION;
					n->object = (Node *) (yyvsp[-3].list);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 40030 "gram.c" /* yacc.c:1646  */
    break;

  case 1295:
#line 9687 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_TYPE;
					n->object = (Node *) (yyvsp[-3].list);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 40044 "gram.c" /* yacc.c:1646  */
    break;

  case 1296:
#line 9697 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_ATTRIBUTE;
					n->relationType = OBJECT_TYPE;
					n->relation = makeRangeVarFromAnyName((yyvsp[-6].list), (yylsp[-6]), yyscanner);
					n->subname = (yyvsp[-3].str);
					n->newname = (yyvsp[-1].str);
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 40061 "gram.c" /* yacc.c:1646  */
    break;

  case 1299:
#line 9715 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = 1; }
#line 40067 "gram.c" /* yacc.c:1646  */
    break;

  case 1300:
#line 9716 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = 0; }
#line 40073 "gram.c" /* yacc.c:1646  */
    break;

  case 1301:
#line 9727 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectDependsStmt *n = makeNode(AlterObjectDependsStmt);

					n->objectType = OBJECT_FUNCTION;
					n->object = (Node *) (yyvsp[-5].objwithargs);
					n->extname = makeString((yyvsp[0].str));
					n->remove = (yyvsp[-4].boolean);
					(yyval.node) = (Node *) n;
				}
#line 40087 "gram.c" /* yacc.c:1646  */
    break;

  case 1302:
#line 9737 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectDependsStmt *n = makeNode(AlterObjectDependsStmt);

					n->objectType = OBJECT_PROCEDURE;
					n->object = (Node *) (yyvsp[-5].objwithargs);
					n->extname = makeString((yyvsp[0].str));
					n->remove = (yyvsp[-4].boolean);
					(yyval.node) = (Node *) n;
				}
#line 40101 "gram.c" /* yacc.c:1646  */
    break;

  case 1303:
#line 9747 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectDependsStmt *n = makeNode(AlterObjectDependsStmt);

					n->objectType = OBJECT_ROUTINE;
					n->object = (Node *) (yyvsp[-5].objwithargs);
					n->extname = makeString((yyvsp[0].str));
					n->remove = (yyvsp[-4].boolean);
					(yyval.node) = (Node *) n;
				}
#line 40115 "gram.c" /* yacc.c:1646  */
    break;

  case 1304:
#line 9757 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectDependsStmt *n = makeNode(AlterObjectDependsStmt);

					n->objectType = OBJECT_TRIGGER;
					n->relation = (yyvsp[-5].range);
					n->object = (Node *) list_make1(makeString((yyvsp[-7].str)));
					n->extname = makeString((yyvsp[0].str));
					n->remove = (yyvsp[-4].boolean);
					(yyval.node) = (Node *) n;
				}
#line 40130 "gram.c" /* yacc.c:1646  */
    break;

  case 1305:
#line 9768 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectDependsStmt *n = makeNode(AlterObjectDependsStmt);

					n->objectType = OBJECT_MATVIEW;
					n->relation = (yyvsp[-5].range);
					n->extname = makeString((yyvsp[0].str));
					n->remove = (yyvsp[-4].boolean);
					(yyval.node) = (Node *) n;
				}
#line 40144 "gram.c" /* yacc.c:1646  */
    break;

  case 1306:
#line 9778 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectDependsStmt *n = makeNode(AlterObjectDependsStmt);

					n->objectType = OBJECT_INDEX;
					n->relation = (yyvsp[-5].range);
					n->extname = makeString((yyvsp[0].str));
					n->remove = (yyvsp[-4].boolean);
					(yyval.node) = (Node *) n;
				}
#line 40158 "gram.c" /* yacc.c:1646  */
    break;

  case 1307:
#line 9789 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 40164 "gram.c" /* yacc.c:1646  */
    break;

  case 1308:
#line 9790 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = false;	}
#line 40170 "gram.c" /* yacc.c:1646  */
    break;

  case 1309:
#line 9801 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);

					n->objectType = OBJECT_AGGREGATE;
					n->object = (Node *) (yyvsp[-3].objwithargs);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 40184 "gram.c" /* yacc.c:1646  */
    break;

  case 1310:
#line 9811 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);

					n->objectType = OBJECT_COLLATION;
					n->object = (Node *) (yyvsp[-3].list);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 40198 "gram.c" /* yacc.c:1646  */
    break;

  case 1311:
#line 9821 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);

					n->objectType = OBJECT_CONVERSION;
					n->object = (Node *) (yyvsp[-3].list);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 40212 "gram.c" /* yacc.c:1646  */
    break;

  case 1312:
#line 9831 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);

					n->objectType = OBJECT_DOMAIN;
					n->object = (Node *) (yyvsp[-3].list);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 40226 "gram.c" /* yacc.c:1646  */
    break;

  case 1313:
#line 9841 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);

					n->objectType = OBJECT_EXTENSION;
					n->object = (Node *) makeString((yyvsp[-3].str));
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 40240 "gram.c" /* yacc.c:1646  */
    break;

  case 1314:
#line 9851 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);

					n->objectType = OBJECT_FUNCTION;
					n->object = (Node *) (yyvsp[-3].objwithargs);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 40254 "gram.c" /* yacc.c:1646  */
    break;

  case 1315:
#line 9861 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);

					n->objectType = OBJECT_OPERATOR;
					n->object = (Node *) (yyvsp[-3].objwithargs);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 40268 "gram.c" /* yacc.c:1646  */
    break;

  case 1316:
#line 9871 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);

					n->objectType = OBJECT_OPCLASS;
					n->object = (Node *) lcons(makeString((yyvsp[-3].str)), (yyvsp[-5].list));
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 40282 "gram.c" /* yacc.c:1646  */
    break;

  case 1317:
#line 9881 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);

					n->objectType = OBJECT_OPFAMILY;
					n->object = (Node *) lcons(makeString((yyvsp[-3].str)), (yyvsp[-5].list));
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 40296 "gram.c" /* yacc.c:1646  */
    break;

  case 1318:
#line 9891 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);

					n->objectType = OBJECT_PROCEDURE;
					n->object = (Node *) (yyvsp[-3].objwithargs);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 40310 "gram.c" /* yacc.c:1646  */
    break;

  case 1319:
#line 9901 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);

					n->objectType = OBJECT_ROUTINE;
					n->object = (Node *) (yyvsp[-3].objwithargs);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 40324 "gram.c" /* yacc.c:1646  */
    break;

  case 1320:
#line 9911 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);

					n->objectType = OBJECT_TABLE;
					n->relation = (yyvsp[-3].range);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 40338 "gram.c" /* yacc.c:1646  */
    break;

  case 1321:
#line 9921 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);

					n->objectType = OBJECT_TABLE;
					n->relation = (yyvsp[-3].range);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 40352 "gram.c" /* yacc.c:1646  */
    break;

  case 1322:
#line 9931 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);

					n->objectType = OBJECT_STATISTIC_EXT;
					n->object = (Node *) (yyvsp[-3].list);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 40366 "gram.c" /* yacc.c:1646  */
    break;

  case 1323:
#line 9941 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);

					n->objectType = OBJECT_TSPARSER;
					n->object = (Node *) (yyvsp[-3].list);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 40380 "gram.c" /* yacc.c:1646  */
    break;

  case 1324:
#line 9951 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);

					n->objectType = OBJECT_TSDICTIONARY;
					n->object = (Node *) (yyvsp[-3].list);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 40394 "gram.c" /* yacc.c:1646  */
    break;

  case 1325:
#line 9961 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);

					n->objectType = OBJECT_TSTEMPLATE;
					n->object = (Node *) (yyvsp[-3].list);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 40408 "gram.c" /* yacc.c:1646  */
    break;

  case 1326:
#line 9971 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);

					n->objectType = OBJECT_TSCONFIGURATION;
					n->object = (Node *) (yyvsp[-3].list);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 40422 "gram.c" /* yacc.c:1646  */
    break;

  case 1327:
#line 9981 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);

					n->objectType = OBJECT_SEQUENCE;
					n->relation = (yyvsp[-3].range);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 40436 "gram.c" /* yacc.c:1646  */
    break;

  case 1328:
#line 9991 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);

					n->objectType = OBJECT_SEQUENCE;
					n->relation = (yyvsp[-3].range);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 40450 "gram.c" /* yacc.c:1646  */
    break;

  case 1329:
#line 10001 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);

					n->objectType = OBJECT_VIEW;
					n->relation = (yyvsp[-3].range);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 40464 "gram.c" /* yacc.c:1646  */
    break;

  case 1330:
#line 10011 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);

					n->objectType = OBJECT_VIEW;
					n->relation = (yyvsp[-3].range);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 40478 "gram.c" /* yacc.c:1646  */
    break;

  case 1331:
#line 10021 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);

					n->objectType = OBJECT_MATVIEW;
					n->relation = (yyvsp[-3].range);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 40492 "gram.c" /* yacc.c:1646  */
    break;

  case 1332:
#line 10031 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);

					n->objectType = OBJECT_MATVIEW;
					n->relation = (yyvsp[-3].range);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 40506 "gram.c" /* yacc.c:1646  */
    break;

  case 1333:
#line 10041 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);

					n->objectType = OBJECT_FOREIGN_TABLE;
					n->relation = (yyvsp[-3].range);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 40520 "gram.c" /* yacc.c:1646  */
    break;

  case 1334:
#line 10051 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);

					n->objectType = OBJECT_FOREIGN_TABLE;
					n->relation = (yyvsp[-3].range);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 40534 "gram.c" /* yacc.c:1646  */
    break;

  case 1335:
#line 10061 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);

					n->objectType = OBJECT_TYPE;
					n->object = (Node *) (yyvsp[-3].list);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 40548 "gram.c" /* yacc.c:1646  */
    break;

  case 1336:
#line 10080 "gram.y" /* yacc.c:1646  */
    {
					AlterOperatorStmt *n = makeNode(AlterOperatorStmt);

					n->opername = (yyvsp[-4].objwithargs);
					n->options = (yyvsp[-1].list);
					(yyval.node) = (Node *) n;
				}
#line 40560 "gram.c" /* yacc.c:1646  */
    break;

  case 1337:
#line 10089 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].defelt)); }
#line 40566 "gram.c" /* yacc.c:1646  */
    break;

  case 1338:
#line 10090 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].defelt)); }
#line 40572 "gram.c" /* yacc.c:1646  */
    break;

  case 1339:
#line 10094 "gram.y" /* yacc.c:1646  */
    { (yyval.defelt) = makeDefElem((yyvsp[-2].str), NULL, (yylsp[-2])); }
#line 40578 "gram.c" /* yacc.c:1646  */
    break;

  case 1340:
#line 10096 "gram.y" /* yacc.c:1646  */
    { (yyval.defelt) = makeDefElem((yyvsp[-2].str), (Node *) (yyvsp[0].node), (yylsp[-2])); }
#line 40584 "gram.c" /* yacc.c:1646  */
    break;

  case 1341:
#line 10101 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) (yyvsp[0].typnam); }
#line 40590 "gram.c" /* yacc.c:1646  */
    break;

  case 1342:
#line 10102 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeString(pstrdup((yyvsp[0].keyword))); }
#line 40596 "gram.c" /* yacc.c:1646  */
    break;

  case 1343:
#line 10103 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) (yyvsp[0].list); }
#line 40602 "gram.c" /* yacc.c:1646  */
    break;

  case 1344:
#line 10104 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) (yyvsp[0].node); }
#line 40608 "gram.c" /* yacc.c:1646  */
    break;

  case 1345:
#line 10105 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeString((yyvsp[0].str)); }
#line 40614 "gram.c" /* yacc.c:1646  */
    break;

  case 1346:
#line 10118 "gram.y" /* yacc.c:1646  */
    {
					AlterTypeStmt *n = makeNode(AlterTypeStmt);

					n->typeName = (yyvsp[-4].list);
					n->options = (yyvsp[-1].list);
					(yyval.node) = (Node *) n;
				}
#line 40626 "gram.c" /* yacc.c:1646  */
    break;

  case 1347:
#line 10134 "gram.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);

					n->objectType = OBJECT_AGGREGATE;
					n->object = (Node *) (yyvsp[-3].objwithargs);
					n->newowner = (yyvsp[0].rolespec);
					(yyval.node) = (Node *) n;
				}
#line 40639 "gram.c" /* yacc.c:1646  */
    break;

  case 1348:
#line 10143 "gram.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);

					n->objectType = OBJECT_COLLATION;
					n->object = (Node *) (yyvsp[-3].list);
					n->newowner = (yyvsp[0].rolespec);
					(yyval.node) = (Node *) n;
				}
#line 40652 "gram.c" /* yacc.c:1646  */
    break;

  case 1349:
#line 10152 "gram.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);

					n->objectType = OBJECT_CONVERSION;
					n->object = (Node *) (yyvsp[-3].list);
					n->newowner = (yyvsp[0].rolespec);
					(yyval.node) = (Node *) n;
				}
#line 40665 "gram.c" /* yacc.c:1646  */
    break;

  case 1350:
#line 10161 "gram.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);

					n->objectType = OBJECT_DATABASE;
					n->object = (Node *) makeString((yyvsp[-3].str));
					n->newowner = (yyvsp[0].rolespec);
					(yyval.node) = (Node *) n;
				}
#line 40678 "gram.c" /* yacc.c:1646  */
    break;

  case 1351:
#line 10170 "gram.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);

					n->objectType = OBJECT_DOMAIN;
					n->object = (Node *) (yyvsp[-3].list);
					n->newowner = (yyvsp[0].rolespec);
					(yyval.node) = (Node *) n;
				}
#line 40691 "gram.c" /* yacc.c:1646  */
    break;

  case 1352:
#line 10179 "gram.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);

					n->objectType = OBJECT_FUNCTION;
					n->object = (Node *) (yyvsp[-3].objwithargs);
					n->newowner = (yyvsp[0].rolespec);
					(yyval.node) = (Node *) n;
				}
#line 40704 "gram.c" /* yacc.c:1646  */
    break;

  case 1353:
#line 10188 "gram.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);

					n->objectType = OBJECT_LANGUAGE;
					n->object = (Node *) makeString((yyvsp[-3].str));
					n->newowner = (yyvsp[0].rolespec);
					(yyval.node) = (Node *) n;
				}
#line 40717 "gram.c" /* yacc.c:1646  */
    break;

  case 1354:
#line 10197 "gram.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);

					n->objectType = OBJECT_LARGEOBJECT;
					n->object = (Node *) (yyvsp[-3].node);
					n->newowner = (yyvsp[0].rolespec);
					(yyval.node) = (Node *) n;
				}
#line 40730 "gram.c" /* yacc.c:1646  */
    break;

  case 1355:
#line 10206 "gram.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);

					n->objectType = OBJECT_OPERATOR;
					n->object = (Node *) (yyvsp[-3].objwithargs);
					n->newowner = (yyvsp[0].rolespec);
					(yyval.node) = (Node *) n;
				}
#line 40743 "gram.c" /* yacc.c:1646  */
    break;

  case 1356:
#line 10215 "gram.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);

					n->objectType = OBJECT_OPCLASS;
					n->object = (Node *) lcons(makeString((yyvsp[-3].str)), (yyvsp[-5].list));
					n->newowner = (yyvsp[0].rolespec);
					(yyval.node) = (Node *) n;
				}
#line 40756 "gram.c" /* yacc.c:1646  */
    break;

  case 1357:
#line 10224 "gram.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);

					n->objectType = OBJECT_OPFAMILY;
					n->object = (Node *) lcons(makeString((yyvsp[-3].str)), (yyvsp[-5].list));
					n->newowner = (yyvsp[0].rolespec);
					(yyval.node) = (Node *) n;
				}
#line 40769 "gram.c" /* yacc.c:1646  */
    break;

  case 1358:
#line 10233 "gram.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);

					n->objectType = OBJECT_PROCEDURE;
					n->object = (Node *) (yyvsp[-3].objwithargs);
					n->newowner = (yyvsp[0].rolespec);
					(yyval.node) = (Node *) n;
				}
#line 40782 "gram.c" /* yacc.c:1646  */
    break;

  case 1359:
#line 10242 "gram.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);

					n->objectType = OBJECT_ROUTINE;
					n->object = (Node *) (yyvsp[-3].objwithargs);
					n->newowner = (yyvsp[0].rolespec);
					(yyval.node) = (Node *) n;
				}
#line 40795 "gram.c" /* yacc.c:1646  */
    break;

  case 1360:
#line 10251 "gram.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);

					n->objectType = OBJECT_SCHEMA;
					n->object = (Node *) makeString((yyvsp[-3].str));
					n->newowner = (yyvsp[0].rolespec);
					(yyval.node) = (Node *) n;
				}
#line 40808 "gram.c" /* yacc.c:1646  */
    break;

  case 1361:
#line 10260 "gram.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);

					n->objectType = OBJECT_TYPE;
					n->object = (Node *) (yyvsp[-3].list);
					n->newowner = (yyvsp[0].rolespec);
					(yyval.node) = (Node *) n;
				}
#line 40821 "gram.c" /* yacc.c:1646  */
    break;

  case 1362:
#line 10269 "gram.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);

					n->objectType = OBJECT_TABLESPACE;
					n->object = (Node *) makeString((yyvsp[-3].str));
					n->newowner = (yyvsp[0].rolespec);
					(yyval.node) = (Node *) n;
				}
#line 40834 "gram.c" /* yacc.c:1646  */
    break;

  case 1363:
#line 10278 "gram.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);

					n->objectType = OBJECT_STATISTIC_EXT;
					n->object = (Node *) (yyvsp[-3].list);
					n->newowner = (yyvsp[0].rolespec);
					(yyval.node) = (Node *) n;
				}
#line 40847 "gram.c" /* yacc.c:1646  */
    break;

  case 1364:
#line 10287 "gram.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);

					n->objectType = OBJECT_TSDICTIONARY;
					n->object = (Node *) (yyvsp[-3].list);
					n->newowner = (yyvsp[0].rolespec);
					(yyval.node) = (Node *) n;
				}
#line 40860 "gram.c" /* yacc.c:1646  */
    break;

  case 1365:
#line 10296 "gram.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);

					n->objectType = OBJECT_TSCONFIGURATION;
					n->object = (Node *) (yyvsp[-3].list);
					n->newowner = (yyvsp[0].rolespec);
					(yyval.node) = (Node *) n;
				}
#line 40873 "gram.c" /* yacc.c:1646  */
    break;

  case 1366:
#line 10305 "gram.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);

					n->objectType = OBJECT_FDW;
					n->object = (Node *) makeString((yyvsp[-3].str));
					n->newowner = (yyvsp[0].rolespec);
					(yyval.node) = (Node *) n;
				}
#line 40886 "gram.c" /* yacc.c:1646  */
    break;

  case 1367:
#line 10314 "gram.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);

					n->objectType = OBJECT_FOREIGN_SERVER;
					n->object = (Node *) makeString((yyvsp[-3].str));
					n->newowner = (yyvsp[0].rolespec);
					(yyval.node) = (Node *) n;
				}
#line 40899 "gram.c" /* yacc.c:1646  */
    break;

  case 1368:
#line 10323 "gram.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);

					n->objectType = OBJECT_EVENT_TRIGGER;
					n->object = (Node *) makeString((yyvsp[-3].str));
					n->newowner = (yyvsp[0].rolespec);
					(yyval.node) = (Node *) n;
				}
#line 40912 "gram.c" /* yacc.c:1646  */
    break;

  case 1369:
#line 10332 "gram.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);

					n->objectType = OBJECT_PUBLICATION;
					n->object = (Node *) makeString((yyvsp[-3].str));
					n->newowner = (yyvsp[0].rolespec);
					(yyval.node) = (Node *) n;
				}
#line 40925 "gram.c" /* yacc.c:1646  */
    break;

  case 1370:
#line 10341 "gram.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);

					n->objectType = OBJECT_SUBSCRIPTION;
					n->object = (Node *) makeString((yyvsp[-3].str));
					n->newowner = (yyvsp[0].rolespec);
					(yyval.node) = (Node *) n;
				}
#line 40938 "gram.c" /* yacc.c:1646  */
    break;

  case 1371:
#line 10369 "gram.y" /* yacc.c:1646  */
    {
					CreatePublicationStmt *n = makeNode(CreatePublicationStmt);

					n->pubname = (yyvsp[-1].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 40950 "gram.c" /* yacc.c:1646  */
    break;

  case 1372:
#line 10377 "gram.y" /* yacc.c:1646  */
    {
					CreatePublicationStmt *n = makeNode(CreatePublicationStmt);

					n->pubname = (yyvsp[-4].str);
					n->options = (yyvsp[0].list);
					n->for_all_tables = true;
					(yyval.node) = (Node *) n;
				}
#line 40963 "gram.c" /* yacc.c:1646  */
    break;

  case 1373:
#line 10386 "gram.y" /* yacc.c:1646  */
    {
					CreatePublicationStmt *n = makeNode(CreatePublicationStmt);

					n->pubname = (yyvsp[-3].str);
					n->options = (yyvsp[0].list);
					n->pubobjects = (List *) (yyvsp[-1].list);
					preprocess_pubobj_list(n->pubobjects, yyscanner);
					(yyval.node) = (Node *) n;
				}
#line 40977 "gram.c" /* yacc.c:1646  */
    break;

  case 1374:
#line 10412 "gram.y" /* yacc.c:1646  */
    {
					(yyval.publicationobjectspec) = makeNode(PublicationObjSpec);
					(yyval.publicationobjectspec)->pubobjtype = PUBLICATIONOBJ_TABLE;
					(yyval.publicationobjectspec)->pubtable = makeNode(PublicationTable);
					(yyval.publicationobjectspec)->pubtable->relation = (yyvsp[-2].range);
					(yyval.publicationobjectspec)->pubtable->columns = (yyvsp[-1].list);
					(yyval.publicationobjectspec)->pubtable->whereClause = (yyvsp[0].node);
				}
#line 40990 "gram.c" /* yacc.c:1646  */
    break;

  case 1375:
#line 10421 "gram.y" /* yacc.c:1646  */
    {
					(yyval.publicationobjectspec) = makeNode(PublicationObjSpec);
					(yyval.publicationobjectspec)->pubobjtype = PUBLICATIONOBJ_TABLES_IN_SCHEMA;
					(yyval.publicationobjectspec)->name = (yyvsp[0].str);
					(yyval.publicationobjectspec)->location = (yylsp[0]);
				}
#line 41001 "gram.c" /* yacc.c:1646  */
    break;

  case 1376:
#line 10428 "gram.y" /* yacc.c:1646  */
    {
					(yyval.publicationobjectspec) = makeNode(PublicationObjSpec);
					(yyval.publicationobjectspec)->pubobjtype = PUBLICATIONOBJ_TABLES_IN_CUR_SCHEMA;
					(yyval.publicationobjectspec)->location = (yylsp[0]);
				}
#line 41011 "gram.c" /* yacc.c:1646  */
    break;

  case 1377:
#line 10434 "gram.y" /* yacc.c:1646  */
    {
					(yyval.publicationobjectspec) = makeNode(PublicationObjSpec);
					(yyval.publicationobjectspec)->pubobjtype = PUBLICATIONOBJ_CONTINUATION;
					/*
					 * If either a row filter or column list is specified, create
					 * a PublicationTable object.
					 */
					if ((yyvsp[-1].list) || (yyvsp[0].node))
					{
						/*
						 * The OptWhereClause must be stored here but it is
						 * valid only for tables. For non-table objects, an
						 * error will be thrown later via
						 * preprocess_pubobj_list().
						 */
						(yyval.publicationobjectspec)->pubtable = makeNode(PublicationTable);
						(yyval.publicationobjectspec)->pubtable->relation = makeRangeVar(NULL, (yyvsp[-2].str), (yylsp[-2]));
						(yyval.publicationobjectspec)->pubtable->columns = (yyvsp[-1].list);
						(yyval.publicationobjectspec)->pubtable->whereClause = (yyvsp[0].node);
					}
					else
					{
						(yyval.publicationobjectspec)->name = (yyvsp[-2].str);
					}
					(yyval.publicationobjectspec)->location = (yylsp[-2]);
				}
#line 41042 "gram.c" /* yacc.c:1646  */
    break;

  case 1378:
#line 10461 "gram.y" /* yacc.c:1646  */
    {
					(yyval.publicationobjectspec) = makeNode(PublicationObjSpec);
					(yyval.publicationobjectspec)->pubobjtype = PUBLICATIONOBJ_CONTINUATION;
					(yyval.publicationobjectspec)->pubtable = makeNode(PublicationTable);
					(yyval.publicationobjectspec)->pubtable->relation = makeRangeVarFromQualifiedName((yyvsp[-3].str), (yyvsp[-2].list), (yylsp[-3]), yyscanner);
					(yyval.publicationobjectspec)->pubtable->columns = (yyvsp[-1].list);
					(yyval.publicationobjectspec)->pubtable->whereClause = (yyvsp[0].node);
					(yyval.publicationobjectspec)->location = (yylsp[-3]);
				}
#line 41056 "gram.c" /* yacc.c:1646  */
    break;

  case 1379:
#line 10472 "gram.y" /* yacc.c:1646  */
    {
					(yyval.publicationobjectspec) = makeNode(PublicationObjSpec);
					(yyval.publicationobjectspec)->pubobjtype = PUBLICATIONOBJ_CONTINUATION;
					(yyval.publicationobjectspec)->pubtable = makeNode(PublicationTable);
					(yyval.publicationobjectspec)->pubtable->relation = (yyvsp[-2].range);
					(yyval.publicationobjectspec)->pubtable->columns = (yyvsp[-1].list);
					(yyval.publicationobjectspec)->pubtable->whereClause = (yyvsp[0].node);
				}
#line 41069 "gram.c" /* yacc.c:1646  */
    break;

  case 1380:
#line 10481 "gram.y" /* yacc.c:1646  */
    {
					(yyval.publicationobjectspec) = makeNode(PublicationObjSpec);
					(yyval.publicationobjectspec)->pubobjtype = PUBLICATIONOBJ_CONTINUATION;
					(yyval.publicationobjectspec)->location = (yylsp[0]);
				}
#line 41079 "gram.c" /* yacc.c:1646  */
    break;

  case 1381:
#line 10489 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].publicationobjectspec)); }
#line 41085 "gram.c" /* yacc.c:1646  */
    break;

  case 1382:
#line 10491 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].publicationobjectspec)); }
#line 41091 "gram.c" /* yacc.c:1646  */
    break;

  case 1383:
#line 10513 "gram.y" /* yacc.c:1646  */
    {
					AlterPublicationStmt *n = makeNode(AlterPublicationStmt);

					n->pubname = (yyvsp[-2].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 41103 "gram.c" /* yacc.c:1646  */
    break;

  case 1384:
#line 10521 "gram.y" /* yacc.c:1646  */
    {
					AlterPublicationStmt *n = makeNode(AlterPublicationStmt);

					n->pubname = (yyvsp[-2].str);
					n->pubobjects = (yyvsp[0].list);
					preprocess_pubobj_list(n->pubobjects, yyscanner);
					n->action = AP_AddObjects;
					(yyval.node) = (Node *) n;
				}
#line 41117 "gram.c" /* yacc.c:1646  */
    break;

  case 1385:
#line 10531 "gram.y" /* yacc.c:1646  */
    {
					AlterPublicationStmt *n = makeNode(AlterPublicationStmt);

					n->pubname = (yyvsp[-2].str);
					n->pubobjects = (yyvsp[0].list);
					preprocess_pubobj_list(n->pubobjects, yyscanner);
					n->action = AP_SetObjects;
					(yyval.node) = (Node *) n;
				}
#line 41131 "gram.c" /* yacc.c:1646  */
    break;

  case 1386:
#line 10541 "gram.y" /* yacc.c:1646  */
    {
					AlterPublicationStmt *n = makeNode(AlterPublicationStmt);

					n->pubname = (yyvsp[-2].str);
					n->pubobjects = (yyvsp[0].list);
					preprocess_pubobj_list(n->pubobjects, yyscanner);
					n->action = AP_DropObjects;
					(yyval.node) = (Node *) n;
				}
#line 41145 "gram.c" /* yacc.c:1646  */
    break;

  case 1387:
#line 10560 "gram.y" /* yacc.c:1646  */
    {
					CreateSubscriptionStmt *n =
						makeNode(CreateSubscriptionStmt);
					n->subname = (yyvsp[-5].str);
					n->conninfo = (yyvsp[-3].str);
					n->publication = (yyvsp[-1].list);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 41159 "gram.c" /* yacc.c:1646  */
    break;

  case 1388:
#line 10579 "gram.y" /* yacc.c:1646  */
    {
					AlterSubscriptionStmt *n =
						makeNode(AlterSubscriptionStmt);

					n->kind = ALTER_SUBSCRIPTION_OPTIONS;
					n->subname = (yyvsp[-2].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 41173 "gram.c" /* yacc.c:1646  */
    break;

  case 1389:
#line 10589 "gram.y" /* yacc.c:1646  */
    {
					AlterSubscriptionStmt *n =
						makeNode(AlterSubscriptionStmt);

					n->kind = ALTER_SUBSCRIPTION_CONNECTION;
					n->subname = (yyvsp[-2].str);
					n->conninfo = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 41187 "gram.c" /* yacc.c:1646  */
    break;

  case 1390:
#line 10599 "gram.y" /* yacc.c:1646  */
    {
					AlterSubscriptionStmt *n =
						makeNode(AlterSubscriptionStmt);

					n->kind = ALTER_SUBSCRIPTION_REFRESH;
					n->subname = (yyvsp[-3].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 41201 "gram.c" /* yacc.c:1646  */
    break;

  case 1391:
#line 10609 "gram.y" /* yacc.c:1646  */
    {
					AlterSubscriptionStmt *n =
						makeNode(AlterSubscriptionStmt);

					n->kind = ALTER_SUBSCRIPTION_ADD_PUBLICATION;
					n->subname = (yyvsp[-4].str);
					n->publication = (yyvsp[-1].list);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 41216 "gram.c" /* yacc.c:1646  */
    break;

  case 1392:
#line 10620 "gram.y" /* yacc.c:1646  */
    {
					AlterSubscriptionStmt *n =
						makeNode(AlterSubscriptionStmt);

					n->kind = ALTER_SUBSCRIPTION_DROP_PUBLICATION;
					n->subname = (yyvsp[-4].str);
					n->publication = (yyvsp[-1].list);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 41231 "gram.c" /* yacc.c:1646  */
    break;

  case 1393:
#line 10631 "gram.y" /* yacc.c:1646  */
    {
					AlterSubscriptionStmt *n =
						makeNode(AlterSubscriptionStmt);

					n->kind = ALTER_SUBSCRIPTION_SET_PUBLICATION;
					n->subname = (yyvsp[-4].str);
					n->publication = (yyvsp[-1].list);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 41246 "gram.c" /* yacc.c:1646  */
    break;

  case 1394:
#line 10642 "gram.y" /* yacc.c:1646  */
    {
					AlterSubscriptionStmt *n =
						makeNode(AlterSubscriptionStmt);

					n->kind = ALTER_SUBSCRIPTION_ENABLED;
					n->subname = (yyvsp[-1].str);
					n->options = list_make1(makeDefElem("enabled",
											(Node *) makeBoolean(true), (yylsp[-3])));
					(yyval.node) = (Node *) n;
				}
#line 41261 "gram.c" /* yacc.c:1646  */
    break;

  case 1395:
#line 10653 "gram.y" /* yacc.c:1646  */
    {
					AlterSubscriptionStmt *n =
						makeNode(AlterSubscriptionStmt);

					n->kind = ALTER_SUBSCRIPTION_ENABLED;
					n->subname = (yyvsp[-1].str);
					n->options = list_make1(makeDefElem("enabled",
											(Node *) makeBoolean(false), (yylsp[-3])));
					(yyval.node) = (Node *) n;
				}
#line 41276 "gram.c" /* yacc.c:1646  */
    break;

  case 1396:
#line 10664 "gram.y" /* yacc.c:1646  */
    {
					AlterSubscriptionStmt *n =
						makeNode(AlterSubscriptionStmt);

					n->kind = ALTER_SUBSCRIPTION_SKIP;
					n->subname = (yyvsp[-2].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 41290 "gram.c" /* yacc.c:1646  */
    break;

  case 1397:
#line 10682 "gram.y" /* yacc.c:1646  */
    {
					DropSubscriptionStmt *n = makeNode(DropSubscriptionStmt);

					n->subname = (yyvsp[-1].str);
					n->missing_ok = false;
					n->behavior = (yyvsp[0].dbehavior);
					(yyval.node) = (Node *) n;
				}
#line 41303 "gram.c" /* yacc.c:1646  */
    break;

  case 1398:
#line 10691 "gram.y" /* yacc.c:1646  */
    {
					DropSubscriptionStmt *n = makeNode(DropSubscriptionStmt);

					n->subname = (yyvsp[-1].str);
					n->missing_ok = true;
					n->behavior = (yyvsp[0].dbehavior);
					(yyval.node) = (Node *) n;
				}
#line 41316 "gram.c" /* yacc.c:1646  */
    break;

  case 1399:
#line 10710 "gram.y" /* yacc.c:1646  */
    {
					RuleStmt   *n = makeNode(RuleStmt);

					n->replace = (yyvsp[-11].boolean);
					n->relation = (yyvsp[-4].range);
					n->rulename = (yyvsp[-9].str);
					n->whereClause = (yyvsp[-3].node);
					n->event = (yyvsp[-6].ival);
					n->instead = (yyvsp[-1].boolean);
					n->actions = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 41333 "gram.c" /* yacc.c:1646  */
    break;

  case 1400:
#line 10725 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 41339 "gram.c" /* yacc.c:1646  */
    break;

  case 1401:
#line 10726 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 41345 "gram.c" /* yacc.c:1646  */
    break;

  case 1402:
#line 10727 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 41351 "gram.c" /* yacc.c:1646  */
    break;

  case 1403:
#line 10733 "gram.y" /* yacc.c:1646  */
    { if ((yyvsp[0].node) != NULL)
					(yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node));
				  else
					(yyval.list) = (yyvsp[-2].list);
				}
#line 41361 "gram.c" /* yacc.c:1646  */
    break;

  case 1404:
#line 10739 "gram.y" /* yacc.c:1646  */
    { if ((yyvsp[0].node) != NULL)
					(yyval.list) = list_make1((yyvsp[0].node));
				  else
					(yyval.list) = NIL;
				}
#line 41371 "gram.c" /* yacc.c:1646  */
    break;

  case 1410:
#line 10755 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 41377 "gram.c" /* yacc.c:1646  */
    break;

  case 1411:
#line 10756 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 41383 "gram.c" /* yacc.c:1646  */
    break;

  case 1412:
#line 10759 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = CMD_SELECT; }
#line 41389 "gram.c" /* yacc.c:1646  */
    break;

  case 1413:
#line 10760 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = CMD_UPDATE; }
#line 41395 "gram.c" /* yacc.c:1646  */
    break;

  case 1414:
#line 10761 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = CMD_DELETE; }
#line 41401 "gram.c" /* yacc.c:1646  */
    break;

  case 1415:
#line 10762 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = CMD_INSERT; }
#line 41407 "gram.c" /* yacc.c:1646  */
    break;

  case 1416:
#line 10766 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 41413 "gram.c" /* yacc.c:1646  */
    break;

  case 1417:
#line 10767 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 41419 "gram.c" /* yacc.c:1646  */
    break;

  case 1418:
#line 10768 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 41425 "gram.c" /* yacc.c:1646  */
    break;

  case 1419:
#line 10781 "gram.y" /* yacc.c:1646  */
    {
					NotifyStmt *n = makeNode(NotifyStmt);

					n->conditionname = (yyvsp[-1].str);
					n->payload = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 41437 "gram.c" /* yacc.c:1646  */
    break;

  case 1420:
#line 10791 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 41443 "gram.c" /* yacc.c:1646  */
    break;

  case 1421:
#line 10792 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = NULL; }
#line 41449 "gram.c" /* yacc.c:1646  */
    break;

  case 1422:
#line 10796 "gram.y" /* yacc.c:1646  */
    {
					ListenStmt *n = makeNode(ListenStmt);

					n->conditionname = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 41460 "gram.c" /* yacc.c:1646  */
    break;

  case 1423:
#line 10806 "gram.y" /* yacc.c:1646  */
    {
					UnlistenStmt *n = makeNode(UnlistenStmt);

					n->conditionname = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 41471 "gram.c" /* yacc.c:1646  */
    break;

  case 1424:
#line 10813 "gram.y" /* yacc.c:1646  */
    {
					UnlistenStmt *n = makeNode(UnlistenStmt);

					n->conditionname = NULL;
					(yyval.node) = (Node *) n;
				}
#line 41482 "gram.c" /* yacc.c:1646  */
    break;

  case 1425:
#line 10833 "gram.y" /* yacc.c:1646  */
    {
					TransactionStmt *n = makeNode(TransactionStmt);

					n->kind = TRANS_STMT_ROLLBACK;
					n->options = NIL;
					n->chain = (yyvsp[0].boolean);
					(yyval.node) = (Node *) n;
				}
#line 41495 "gram.c" /* yacc.c:1646  */
    break;

  case 1426:
#line 10842 "gram.y" /* yacc.c:1646  */
    {
					TransactionStmt *n = makeNode(TransactionStmt);

					n->kind = TRANS_STMT_START;
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 41507 "gram.c" /* yacc.c:1646  */
    break;

  case 1427:
#line 10850 "gram.y" /* yacc.c:1646  */
    {
					TransactionStmt *n = makeNode(TransactionStmt);

					n->kind = TRANS_STMT_COMMIT;
					n->options = NIL;
					n->chain = (yyvsp[0].boolean);
					(yyval.node) = (Node *) n;
				}
#line 41520 "gram.c" /* yacc.c:1646  */
    break;

  case 1428:
#line 10859 "gram.y" /* yacc.c:1646  */
    {
					TransactionStmt *n = makeNode(TransactionStmt);

					n->kind = TRANS_STMT_ROLLBACK;
					n->options = NIL;
					n->chain = (yyvsp[0].boolean);
					(yyval.node) = (Node *) n;
				}
#line 41533 "gram.c" /* yacc.c:1646  */
    break;

  case 1429:
#line 10868 "gram.y" /* yacc.c:1646  */
    {
					TransactionStmt *n = makeNode(TransactionStmt);

					n->kind = TRANS_STMT_SAVEPOINT;
					n->savepoint_name = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 41545 "gram.c" /* yacc.c:1646  */
    break;

  case 1430:
#line 10876 "gram.y" /* yacc.c:1646  */
    {
					TransactionStmt *n = makeNode(TransactionStmt);

					n->kind = TRANS_STMT_RELEASE;
					n->savepoint_name = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 41557 "gram.c" /* yacc.c:1646  */
    break;

  case 1431:
#line 10884 "gram.y" /* yacc.c:1646  */
    {
					TransactionStmt *n = makeNode(TransactionStmt);

					n->kind = TRANS_STMT_RELEASE;
					n->savepoint_name = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 41569 "gram.c" /* yacc.c:1646  */
    break;

  case 1432:
#line 10892 "gram.y" /* yacc.c:1646  */
    {
					TransactionStmt *n = makeNode(TransactionStmt);

					n->kind = TRANS_STMT_ROLLBACK_TO;
					n->savepoint_name = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 41581 "gram.c" /* yacc.c:1646  */
    break;

  case 1433:
#line 10900 "gram.y" /* yacc.c:1646  */
    {
					TransactionStmt *n = makeNode(TransactionStmt);

					n->kind = TRANS_STMT_ROLLBACK_TO;
					n->savepoint_name = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 41593 "gram.c" /* yacc.c:1646  */
    break;

  case 1434:
#line 10908 "gram.y" /* yacc.c:1646  */
    {
					TransactionStmt *n = makeNode(TransactionStmt);

					n->kind = TRANS_STMT_PREPARE;
					n->gid = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 41605 "gram.c" /* yacc.c:1646  */
    break;

  case 1435:
#line 10916 "gram.y" /* yacc.c:1646  */
    {
					TransactionStmt *n = makeNode(TransactionStmt);

					n->kind = TRANS_STMT_COMMIT_PREPARED;
					n->gid = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 41617 "gram.c" /* yacc.c:1646  */
    break;

  case 1436:
#line 10924 "gram.y" /* yacc.c:1646  */
    {
					TransactionStmt *n = makeNode(TransactionStmt);

					n->kind = TRANS_STMT_ROLLBACK_PREPARED;
					n->gid = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 41629 "gram.c" /* yacc.c:1646  */
    break;

  case 1437:
#line 10935 "gram.y" /* yacc.c:1646  */
    {
					TransactionStmt *n = makeNode(TransactionStmt);

					n->kind = TRANS_STMT_BEGIN;
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 41641 "gram.c" /* yacc.c:1646  */
    break;

  case 1438:
#line 10943 "gram.y" /* yacc.c:1646  */
    {
					TransactionStmt *n = makeNode(TransactionStmt);

					n->kind = TRANS_STMT_COMMIT;
					n->options = NIL;
					n->chain = (yyvsp[0].boolean);
					(yyval.node) = (Node *) n;
				}
#line 41654 "gram.c" /* yacc.c:1646  */
    break;

  case 1442:
#line 10960 "gram.y" /* yacc.c:1646  */
    { (yyval.defelt) = makeDefElem("transaction_isolation",
									   makeStringConst((yyvsp[0].str), (yylsp[0])), (yylsp[-2])); }
#line 41661 "gram.c" /* yacc.c:1646  */
    break;

  case 1443:
#line 10963 "gram.y" /* yacc.c:1646  */
    { (yyval.defelt) = makeDefElem("transaction_read_only",
									   makeIntConst(true, (yylsp[-1])), (yylsp[-1])); }
#line 41668 "gram.c" /* yacc.c:1646  */
    break;

  case 1444:
#line 10966 "gram.y" /* yacc.c:1646  */
    { (yyval.defelt) = makeDefElem("transaction_read_only",
									   makeIntConst(false, (yylsp[-1])), (yylsp[-1])); }
#line 41675 "gram.c" /* yacc.c:1646  */
    break;

  case 1445:
#line 10969 "gram.y" /* yacc.c:1646  */
    { (yyval.defelt) = makeDefElem("transaction_deferrable",
									   makeIntConst(true, (yylsp[0])), (yylsp[0])); }
#line 41682 "gram.c" /* yacc.c:1646  */
    break;

  case 1446:
#line 10972 "gram.y" /* yacc.c:1646  */
    { (yyval.defelt) = makeDefElem("transaction_deferrable",
									   makeIntConst(false, (yylsp[-1])), (yylsp[-1])); }
#line 41689 "gram.c" /* yacc.c:1646  */
    break;

  case 1447:
#line 10979 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].defelt)); }
#line 41695 "gram.c" /* yacc.c:1646  */
    break;

  case 1448:
#line 10981 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].defelt)); }
#line 41701 "gram.c" /* yacc.c:1646  */
    break;

  case 1449:
#line 10983 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].defelt)); }
#line 41707 "gram.c" /* yacc.c:1646  */
    break;

  case 1451:
#line 10989 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 41713 "gram.c" /* yacc.c:1646  */
    break;

  case 1452:
#line 10993 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 41719 "gram.c" /* yacc.c:1646  */
    break;

  case 1453:
#line 10994 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 41725 "gram.c" /* yacc.c:1646  */
    break;

  case 1454:
#line 10995 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 41731 "gram.c" /* yacc.c:1646  */
    break;

  case 1455:
#line 11009 "gram.y" /* yacc.c:1646  */
    {
					ViewStmt   *n = makeNode(ViewStmt);

					n->view = (yyvsp[-5].range);
					n->view->relpersistence = (yyvsp[-7].ival);
					n->aliases = (yyvsp[-4].list);
					n->query = (yyvsp[-1].node);
					n->replace = false;
					n->options = (yyvsp[-3].list);
					n->withCheckOption = (yyvsp[0].ival);
					(yyval.node) = (Node *) n;
				}
#line 41748 "gram.c" /* yacc.c:1646  */
    break;

  case 1456:
#line 11023 "gram.y" /* yacc.c:1646  */
    {
					ViewStmt   *n = makeNode(ViewStmt);

					n->view = (yyvsp[-5].range);
					n->view->relpersistence = (yyvsp[-7].ival);
					n->aliases = (yyvsp[-4].list);
					n->query = (yyvsp[-1].node);
					n->replace = true;
					n->options = (yyvsp[-3].list);
					n->withCheckOption = (yyvsp[0].ival);
					(yyval.node) = (Node *) n;
				}
#line 41765 "gram.c" /* yacc.c:1646  */
    break;

  case 1457:
#line 11037 "gram.y" /* yacc.c:1646  */
    {
					ViewStmt   *n = makeNode(ViewStmt);

					n->view = (yyvsp[-7].range);
					n->view->relpersistence = (yyvsp[-10].ival);
					n->aliases = (yyvsp[-5].list);
					n->query = makeRecursiveViewSelect(n->view->relname, n->aliases, (yyvsp[-1].node));
					n->replace = false;
					n->options = (yyvsp[-3].list);
					n->withCheckOption = (yyvsp[0].ival);
					if (n->withCheckOption != NO_CHECK_OPTION)
						ereport(ERROR,
								(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
								 errmsg("WITH CHECK OPTION not supported on recursive views"),
								 parser_errposition((yylsp[0]))));
					(yyval.node) = (Node *) n;
				}
#line 41787 "gram.c" /* yacc.c:1646  */
    break;

  case 1458:
#line 11056 "gram.y" /* yacc.c:1646  */
    {
					ViewStmt   *n = makeNode(ViewStmt);

					n->view = (yyvsp[-7].range);
					n->view->relpersistence = (yyvsp[-10].ival);
					n->aliases = (yyvsp[-5].list);
					n->query = makeRecursiveViewSelect(n->view->relname, n->aliases, (yyvsp[-1].node));
					n->replace = true;
					n->options = (yyvsp[-3].list);
					n->withCheckOption = (yyvsp[0].ival);
					if (n->withCheckOption != NO_CHECK_OPTION)
						ereport(ERROR,
								(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
								 errmsg("WITH CHECK OPTION not supported on recursive views"),
								 parser_errposition((yylsp[0]))));
					(yyval.node) = (Node *) n;
				}
#line 41809 "gram.c" /* yacc.c:1646  */
    break;

  case 1459:
#line 11076 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = CASCADED_CHECK_OPTION; }
#line 41815 "gram.c" /* yacc.c:1646  */
    break;

  case 1460:
#line 11077 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = CASCADED_CHECK_OPTION; }
#line 41821 "gram.c" /* yacc.c:1646  */
    break;

  case 1461:
#line 11078 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = LOCAL_CHECK_OPTION; }
#line 41827 "gram.c" /* yacc.c:1646  */
    break;

  case 1462:
#line 11079 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = NO_CHECK_OPTION; }
#line 41833 "gram.c" /* yacc.c:1646  */
    break;

  case 1463:
#line 11090 "gram.y" /* yacc.c:1646  */
    {
					LoadStmt   *n = makeNode(LoadStmt);

					n->filename = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 41844 "gram.c" /* yacc.c:1646  */
    break;

  case 1464:
#line 11107 "gram.y" /* yacc.c:1646  */
    {
					CreatedbStmt *n = makeNode(CreatedbStmt);

					n->dbname = (yyvsp[-2].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 41856 "gram.c" /* yacc.c:1646  */
    break;

  case 1465:
#line 11117 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 41862 "gram.c" /* yacc.c:1646  */
    break;

  case 1466:
#line 11118 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 41868 "gram.c" /* yacc.c:1646  */
    break;

  case 1467:
#line 11122 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].defelt)); }
#line 41874 "gram.c" /* yacc.c:1646  */
    break;

  case 1468:
#line 11123 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].defelt)); }
#line 41880 "gram.c" /* yacc.c:1646  */
    break;

  case 1469:
#line 11128 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem((yyvsp[-2].str), (Node *) makeInteger((yyvsp[0].ival)), (yylsp[-2]));
				}
#line 41888 "gram.c" /* yacc.c:1646  */
    break;

  case 1470:
#line 11132 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem((yyvsp[-2].str), (Node *) makeString((yyvsp[0].str)), (yylsp[-2]));
				}
#line 41896 "gram.c" /* yacc.c:1646  */
    break;

  case 1471:
#line 11136 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem((yyvsp[-2].str), NULL, (yylsp[-2]));
				}
#line 41904 "gram.c" /* yacc.c:1646  */
    break;

  case 1472:
#line 11153 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 41910 "gram.c" /* yacc.c:1646  */
    break;

  case 1473:
#line 11154 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = pstrdup("connection_limit"); }
#line 41916 "gram.c" /* yacc.c:1646  */
    break;

  case 1474:
#line 11155 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = pstrdup((yyvsp[0].keyword)); }
#line 41922 "gram.c" /* yacc.c:1646  */
    break;

  case 1475:
#line 11156 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = pstrdup((yyvsp[0].keyword)); }
#line 41928 "gram.c" /* yacc.c:1646  */
    break;

  case 1476:
#line 11157 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = pstrdup((yyvsp[0].keyword)); }
#line 41934 "gram.c" /* yacc.c:1646  */
    break;

  case 1477:
#line 11158 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = pstrdup((yyvsp[0].keyword)); }
#line 41940 "gram.c" /* yacc.c:1646  */
    break;

  case 1478:
#line 11159 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = pstrdup((yyvsp[0].keyword)); }
#line 41946 "gram.c" /* yacc.c:1646  */
    break;

  case 1481:
#line 11179 "gram.y" /* yacc.c:1646  */
    {
					AlterDatabaseStmt *n = makeNode(AlterDatabaseStmt);

					n->dbname = (yyvsp[-2].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				 }
#line 41958 "gram.c" /* yacc.c:1646  */
    break;

  case 1482:
#line 11187 "gram.y" /* yacc.c:1646  */
    {
					AlterDatabaseStmt *n = makeNode(AlterDatabaseStmt);

					n->dbname = (yyvsp[-1].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				 }
#line 41970 "gram.c" /* yacc.c:1646  */
    break;

  case 1483:
#line 11195 "gram.y" /* yacc.c:1646  */
    {
					AlterDatabaseStmt *n = makeNode(AlterDatabaseStmt);

					n->dbname = (yyvsp[-3].str);
					n->options = list_make1(makeDefElem("tablespace",
														(Node *) makeString((yyvsp[0].str)), (yylsp[0])));
					(yyval.node) = (Node *) n;
				 }
#line 41983 "gram.c" /* yacc.c:1646  */
    break;

  case 1484:
#line 11204 "gram.y" /* yacc.c:1646  */
    {
					AlterDatabaseRefreshCollStmt *n = makeNode(AlterDatabaseRefreshCollStmt);

					n->dbname = (yyvsp[-3].str);
					(yyval.node) = (Node *) n;
				 }
#line 41994 "gram.c" /* yacc.c:1646  */
    break;

  case 1485:
#line 11214 "gram.y" /* yacc.c:1646  */
    {
					AlterDatabaseSetStmt *n = makeNode(AlterDatabaseSetStmt);

					n->dbname = (yyvsp[-1].str);
					n->setstmt = (yyvsp[0].vsetstmt);
					(yyval.node) = (Node *) n;
				}
#line 42006 "gram.c" /* yacc.c:1646  */
    break;

  case 1486:
#line 11232 "gram.y" /* yacc.c:1646  */
    {
					DropdbStmt *n = makeNode(DropdbStmt);

					n->dbname = (yyvsp[0].str);
					n->missing_ok = false;
					n->options = NULL;
					(yyval.node) = (Node *) n;
				}
#line 42019 "gram.c" /* yacc.c:1646  */
    break;

  case 1487:
#line 11241 "gram.y" /* yacc.c:1646  */
    {
					DropdbStmt *n = makeNode(DropdbStmt);

					n->dbname = (yyvsp[0].str);
					n->missing_ok = true;
					n->options = NULL;
					(yyval.node) = (Node *) n;
				}
#line 42032 "gram.c" /* yacc.c:1646  */
    break;

  case 1488:
#line 11250 "gram.y" /* yacc.c:1646  */
    {
					DropdbStmt *n = makeNode(DropdbStmt);

					n->dbname = (yyvsp[-4].str);
					n->missing_ok = false;
					n->options = (yyvsp[-1].list);
					(yyval.node) = (Node *) n;
				}
#line 42045 "gram.c" /* yacc.c:1646  */
    break;

  case 1489:
#line 11259 "gram.y" /* yacc.c:1646  */
    {
					DropdbStmt *n = makeNode(DropdbStmt);

					n->dbname = (yyvsp[-4].str);
					n->missing_ok = true;
					n->options = (yyvsp[-1].list);
					(yyval.node) = (Node *) n;
				}
#line 42058 "gram.c" /* yacc.c:1646  */
    break;

  case 1490:
#line 11271 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make1((Node *) (yyvsp[0].defelt));
				}
#line 42066 "gram.c" /* yacc.c:1646  */
    break;

  case 1491:
#line 11275 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = lappend((yyvsp[-2].list), (Node *) (yyvsp[0].defelt));
				}
#line 42074 "gram.c" /* yacc.c:1646  */
    break;

  case 1492:
#line 11286 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("force", NULL, (yylsp[0]));
				}
#line 42082 "gram.c" /* yacc.c:1646  */
    break;

  case 1493:
#line 11298 "gram.y" /* yacc.c:1646  */
    {
					AlterCollationStmt *n = makeNode(AlterCollationStmt);

					n->collname = (yyvsp[-2].list);
					(yyval.node) = (Node *) n;
				}
#line 42093 "gram.c" /* yacc.c:1646  */
    break;

  case 1494:
#line 11316 "gram.y" /* yacc.c:1646  */
    {
					AlterSystemStmt *n = makeNode(AlterSystemStmt);

					n->setstmt = (yyvsp[0].vsetstmt);
					(yyval.node) = (Node *) n;
				}
#line 42104 "gram.c" /* yacc.c:1646  */
    break;

  case 1495:
#line 11323 "gram.y" /* yacc.c:1646  */
    {
					AlterSystemStmt *n = makeNode(AlterSystemStmt);

					n->setstmt = (yyvsp[0].vsetstmt);
					(yyval.node) = (Node *) n;
				}
#line 42115 "gram.c" /* yacc.c:1646  */
    break;

  case 1496:
#line 11340 "gram.y" /* yacc.c:1646  */
    {
					CreateDomainStmt *n = makeNode(CreateDomainStmt);

					n->domainname = (yyvsp[-3].list);
					n->typeName = (yyvsp[-1].typnam);
					SplitColQualList((yyvsp[0].list), &n->constraints, &n->collClause,
									 yyscanner);
					(yyval.node) = (Node *) n;
				}
#line 42129 "gram.c" /* yacc.c:1646  */
    break;

  case 1497:
#line 11354 "gram.y" /* yacc.c:1646  */
    {
					AlterDomainStmt *n = makeNode(AlterDomainStmt);

					n->subtype = 'T';
					n->typeName = (yyvsp[-1].list);
					n->def = (yyvsp[0].node);
					(yyval.node) = (Node *) n;
				}
#line 42142 "gram.c" /* yacc.c:1646  */
    break;

  case 1498:
#line 11364 "gram.y" /* yacc.c:1646  */
    {
					AlterDomainStmt *n = makeNode(AlterDomainStmt);

					n->subtype = 'N';
					n->typeName = (yyvsp[-3].list);
					(yyval.node) = (Node *) n;
				}
#line 42154 "gram.c" /* yacc.c:1646  */
    break;

  case 1499:
#line 11373 "gram.y" /* yacc.c:1646  */
    {
					AlterDomainStmt *n = makeNode(AlterDomainStmt);

					n->subtype = 'O';
					n->typeName = (yyvsp[-3].list);
					(yyval.node) = (Node *) n;
				}
#line 42166 "gram.c" /* yacc.c:1646  */
    break;

  case 1500:
#line 11382 "gram.y" /* yacc.c:1646  */
    {
					AlterDomainStmt *n = makeNode(AlterDomainStmt);

					n->subtype = 'C';
					n->typeName = (yyvsp[-2].list);
					n->def = (yyvsp[0].node);
					(yyval.node) = (Node *) n;
				}
#line 42179 "gram.c" /* yacc.c:1646  */
    break;

  case 1501:
#line 11392 "gram.y" /* yacc.c:1646  */
    {
					AlterDomainStmt *n = makeNode(AlterDomainStmt);

					n->subtype = 'X';
					n->typeName = (yyvsp[-4].list);
					n->name = (yyvsp[-1].str);
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 42194 "gram.c" /* yacc.c:1646  */
    break;

  case 1502:
#line 11404 "gram.y" /* yacc.c:1646  */
    {
					AlterDomainStmt *n = makeNode(AlterDomainStmt);

					n->subtype = 'X';
					n->typeName = (yyvsp[-6].list);
					n->name = (yyvsp[-1].str);
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 42209 "gram.c" /* yacc.c:1646  */
    break;

  case 1503:
#line 11416 "gram.y" /* yacc.c:1646  */
    {
					AlterDomainStmt *n = makeNode(AlterDomainStmt);

					n->subtype = 'V';
					n->typeName = (yyvsp[-3].list);
					n->name = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 42222 "gram.c" /* yacc.c:1646  */
    break;

  case 1506:
#line 11439 "gram.y" /* yacc.c:1646  */
    {
					AlterTSDictionaryStmt *n = makeNode(AlterTSDictionaryStmt);

					n->dictname = (yyvsp[-1].list);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 42234 "gram.c" /* yacc.c:1646  */
    break;

  case 1507:
#line 11450 "gram.y" /* yacc.c:1646  */
    {
					AlterTSConfigurationStmt *n = makeNode(AlterTSConfigurationStmt);

					n->kind = ALTER_TSCONFIG_ADD_MAPPING;
					n->cfgname = (yyvsp[-6].list);
					n->tokentype = (yyvsp[-2].list);
					n->dicts = (yyvsp[0].list);
					n->override = false;
					n->replace = false;
					(yyval.node) = (Node *) n;
				}
#line 42250 "gram.c" /* yacc.c:1646  */
    break;

  case 1508:
#line 11462 "gram.y" /* yacc.c:1646  */
    {
					AlterTSConfigurationStmt *n = makeNode(AlterTSConfigurationStmt);

					n->kind = ALTER_TSCONFIG_ALTER_MAPPING_FOR_TOKEN;
					n->cfgname = (yyvsp[-6].list);
					n->tokentype = (yyvsp[-2].list);
					n->dicts = (yyvsp[0].list);
					n->override = true;
					n->replace = false;
					(yyval.node) = (Node *) n;
				}
#line 42266 "gram.c" /* yacc.c:1646  */
    break;

  case 1509:
#line 11474 "gram.y" /* yacc.c:1646  */
    {
					AlterTSConfigurationStmt *n = makeNode(AlterTSConfigurationStmt);

					n->kind = ALTER_TSCONFIG_REPLACE_DICT;
					n->cfgname = (yyvsp[-6].list);
					n->tokentype = NIL;
					n->dicts = list_make2((yyvsp[-2].list),(yyvsp[0].list));
					n->override = false;
					n->replace = true;
					(yyval.node) = (Node *) n;
				}
#line 42282 "gram.c" /* yacc.c:1646  */
    break;

  case 1510:
#line 11486 "gram.y" /* yacc.c:1646  */
    {
					AlterTSConfigurationStmt *n = makeNode(AlterTSConfigurationStmt);

					n->kind = ALTER_TSCONFIG_REPLACE_DICT_FOR_TOKEN;
					n->cfgname = (yyvsp[-8].list);
					n->tokentype = (yyvsp[-4].list);
					n->dicts = list_make2((yyvsp[-2].list),(yyvsp[0].list));
					n->override = false;
					n->replace = true;
					(yyval.node) = (Node *) n;
				}
#line 42298 "gram.c" /* yacc.c:1646  */
    break;

  case 1511:
#line 11498 "gram.y" /* yacc.c:1646  */
    {
					AlterTSConfigurationStmt *n = makeNode(AlterTSConfigurationStmt);

					n->kind = ALTER_TSCONFIG_DROP_MAPPING;
					n->cfgname = (yyvsp[-4].list);
					n->tokentype = (yyvsp[0].list);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 42312 "gram.c" /* yacc.c:1646  */
    break;

  case 1512:
#line 11508 "gram.y" /* yacc.c:1646  */
    {
					AlterTSConfigurationStmt *n = makeNode(AlterTSConfigurationStmt);

					n->kind = ALTER_TSCONFIG_DROP_MAPPING;
					n->cfgname = (yyvsp[-6].list);
					n->tokentype = (yyvsp[0].list);
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 42326 "gram.c" /* yacc.c:1646  */
    break;

  case 1515:
#line 11537 "gram.y" /* yacc.c:1646  */
    {
				CreateConversionStmt *n = makeNode(CreateConversionStmt);

				n->conversion_name = (yyvsp[-6].list);
				n->for_encoding_name = (yyvsp[-4].str);
				n->to_encoding_name = (yyvsp[-2].str);
				n->func_name = (yyvsp[0].list);
				n->def = (yyvsp[-8].boolean);
				(yyval.node) = (Node *) n;
			}
#line 42341 "gram.c" /* yacc.c:1646  */
    break;

  case 1516:
#line 11561 "gram.y" /* yacc.c:1646  */
    {
					ClusterStmt *n = makeNode(ClusterStmt);

					n->relation = (yyvsp[-1].range);
					n->indexname = (yyvsp[0].str);
					n->params = NIL;
					if ((yyvsp[-2].boolean))
						n->params = lappend(n->params, makeDefElem("verbose", NULL, (yylsp[-2])));
					(yyval.node) = (Node *) n;
				}
#line 42356 "gram.c" /* yacc.c:1646  */
    break;

  case 1517:
#line 11573 "gram.y" /* yacc.c:1646  */
    {
					ClusterStmt *n = makeNode(ClusterStmt);

					n->relation = (yyvsp[-1].range);
					n->indexname = (yyvsp[0].str);
					n->params = (yyvsp[-3].list);
					(yyval.node) = (Node *) n;
				}
#line 42369 "gram.c" /* yacc.c:1646  */
    break;

  case 1518:
#line 11582 "gram.y" /* yacc.c:1646  */
    {
					ClusterStmt *n = makeNode(ClusterStmt);

					n->relation = NULL;
					n->indexname = NULL;
					n->params = NIL;
					if ((yyvsp[0].boolean))
						n->params = lappend(n->params, makeDefElem("verbose", NULL, (yylsp[0])));
					(yyval.node) = (Node *) n;
				}
#line 42384 "gram.c" /* yacc.c:1646  */
    break;

  case 1519:
#line 11594 "gram.y" /* yacc.c:1646  */
    {
					ClusterStmt *n = makeNode(ClusterStmt);

					n->relation = (yyvsp[0].range);
					n->indexname = (yyvsp[-2].str);
					n->params = NIL;
					if ((yyvsp[-3].boolean))
						n->params = lappend(n->params, makeDefElem("verbose", NULL, (yylsp[-3])));
					(yyval.node) = (Node *) n;
				}
#line 42399 "gram.c" /* yacc.c:1646  */
    break;

  case 1520:
#line 11607 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 42405 "gram.c" /* yacc.c:1646  */
    break;

  case 1521:
#line 11608 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = NULL; }
#line 42411 "gram.c" /* yacc.c:1646  */
    break;

  case 1522:
#line 11621 "gram.y" /* yacc.c:1646  */
    {
					VacuumStmt *n = makeNode(VacuumStmt);

					n->options = NIL;
					if ((yyvsp[-4].boolean))
						n->options = lappend(n->options,
											 makeDefElem("full", NULL, (yylsp[-4])));
					if ((yyvsp[-3].boolean))
						n->options = lappend(n->options,
											 makeDefElem("freeze", NULL, (yylsp[-3])));
					if ((yyvsp[-2].boolean))
						n->options = lappend(n->options,
											 makeDefElem("verbose", NULL, (yylsp[-2])));
					if ((yyvsp[-1].boolean))
						n->options = lappend(n->options,
											 makeDefElem("analyze", NULL, (yylsp[-1])));
					n->rels = (yyvsp[0].list);
					n->is_vacuumcmd = true;
					(yyval.node) = (Node *) n;
				}
#line 42436 "gram.c" /* yacc.c:1646  */
    break;

  case 1523:
#line 11642 "gram.y" /* yacc.c:1646  */
    {
					VacuumStmt *n = makeNode(VacuumStmt);

					n->options = (yyvsp[-2].list);
					n->rels = (yyvsp[0].list);
					n->is_vacuumcmd = true;
					(yyval.node) = (Node *) n;
				}
#line 42449 "gram.c" /* yacc.c:1646  */
    break;

  case 1524:
#line 11653 "gram.y" /* yacc.c:1646  */
    {
					VacuumStmt *n = makeNode(VacuumStmt);

					n->options = NIL;
					if ((yyvsp[-1].boolean))
						n->options = lappend(n->options,
											 makeDefElem("verbose", NULL, (yylsp[-1])));
					n->rels = (yyvsp[0].list);
					n->is_vacuumcmd = false;
					(yyval.node) = (Node *) n;
				}
#line 42465 "gram.c" /* yacc.c:1646  */
    break;

  case 1525:
#line 11665 "gram.y" /* yacc.c:1646  */
    {
					VacuumStmt *n = makeNode(VacuumStmt);

					n->options = (yyvsp[-2].list);
					n->rels = (yyvsp[0].list);
					n->is_vacuumcmd = false;
					(yyval.node) = (Node *) n;
				}
#line 42478 "gram.c" /* yacc.c:1646  */
    break;

  case 1526:
#line 11677 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make1((yyvsp[0].defelt));
				}
#line 42486 "gram.c" /* yacc.c:1646  */
    break;

  case 1527:
#line 11681 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].defelt));
				}
#line 42494 "gram.c" /* yacc.c:1646  */
    break;

  case 1530:
#line 11693 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem((yyvsp[-1].str), (yyvsp[0].node), (yylsp[-1]));
				}
#line 42502 "gram.c" /* yacc.c:1646  */
    break;

  case 1531:
#line 11699 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 42508 "gram.c" /* yacc.c:1646  */
    break;

  case 1532:
#line 11700 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "analyze"; }
#line 42514 "gram.c" /* yacc.c:1646  */
    break;

  case 1533:
#line 11704 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeString((yyvsp[0].str)); }
#line 42520 "gram.c" /* yacc.c:1646  */
    break;

  case 1534:
#line 11705 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) (yyvsp[0].node); }
#line 42526 "gram.c" /* yacc.c:1646  */
    break;

  case 1535:
#line 11706 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 42532 "gram.c" /* yacc.c:1646  */
    break;

  case 1536:
#line 11710 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 42538 "gram.c" /* yacc.c:1646  */
    break;

  case 1537:
#line 11711 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 42544 "gram.c" /* yacc.c:1646  */
    break;

  case 1538:
#line 11715 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 42550 "gram.c" /* yacc.c:1646  */
    break;

  case 1539:
#line 11716 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 42556 "gram.c" /* yacc.c:1646  */
    break;

  case 1540:
#line 11719 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 42562 "gram.c" /* yacc.c:1646  */
    break;

  case 1541:
#line 11720 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 42568 "gram.c" /* yacc.c:1646  */
    break;

  case 1542:
#line 11723 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 42574 "gram.c" /* yacc.c:1646  */
    break;

  case 1543:
#line 11724 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 42580 "gram.c" /* yacc.c:1646  */
    break;

  case 1544:
#line 11728 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 42586 "gram.c" /* yacc.c:1646  */
    break;

  case 1545:
#line 11729 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 42592 "gram.c" /* yacc.c:1646  */
    break;

  case 1546:
#line 11734 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeVacuumRelation((yyvsp[-1].range), InvalidOid, (yyvsp[0].list));
				}
#line 42600 "gram.c" /* yacc.c:1646  */
    break;

  case 1547:
#line 11741 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 42606 "gram.c" /* yacc.c:1646  */
    break;

  case 1548:
#line 11743 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node)); }
#line 42612 "gram.c" /* yacc.c:1646  */
    break;

  case 1549:
#line 11747 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 42618 "gram.c" /* yacc.c:1646  */
    break;

  case 1550:
#line 11748 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 42624 "gram.c" /* yacc.c:1646  */
    break;

  case 1551:
#line 11762 "gram.y" /* yacc.c:1646  */
    {
					ExplainStmt *n = makeNode(ExplainStmt);

					n->query = (yyvsp[0].node);
					n->options = NIL;
					(yyval.node) = (Node *) n;
				}
#line 42636 "gram.c" /* yacc.c:1646  */
    break;

  case 1552:
#line 11770 "gram.y" /* yacc.c:1646  */
    {
					ExplainStmt *n = makeNode(ExplainStmt);

					n->query = (yyvsp[0].node);
					n->options = list_make1(makeDefElem("analyze", NULL, (yylsp[-2])));
					if ((yyvsp[-1].boolean))
						n->options = lappend(n->options,
											 makeDefElem("verbose", NULL, (yylsp[-1])));
					(yyval.node) = (Node *) n;
				}
#line 42651 "gram.c" /* yacc.c:1646  */
    break;

  case 1553:
#line 11781 "gram.y" /* yacc.c:1646  */
    {
					ExplainStmt *n = makeNode(ExplainStmt);

					n->query = (yyvsp[0].node);
					n->options = list_make1(makeDefElem("verbose", NULL, (yylsp[-1])));
					(yyval.node) = (Node *) n;
				}
#line 42663 "gram.c" /* yacc.c:1646  */
    break;

  case 1554:
#line 11789 "gram.y" /* yacc.c:1646  */
    {
					ExplainStmt *n = makeNode(ExplainStmt);

					n->query = (yyvsp[0].node);
					n->options = (yyvsp[-2].list);
					(yyval.node) = (Node *) n;
				}
#line 42675 "gram.c" /* yacc.c:1646  */
    break;

  case 1565:
#line 11819 "gram.y" /* yacc.c:1646  */
    {
					PrepareStmt *n = makeNode(PrepareStmt);

					n->name = (yyvsp[-3].str);
					n->argtypes = (yyvsp[-2].list);
					n->query = (yyvsp[0].node);
					(yyval.node) = (Node *) n;
				}
#line 42688 "gram.c" /* yacc.c:1646  */
    break;

  case 1566:
#line 11829 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 42694 "gram.c" /* yacc.c:1646  */
    break;

  case 1567:
#line 11830 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 42700 "gram.c" /* yacc.c:1646  */
    break;

  case 1573:
#line 11849 "gram.y" /* yacc.c:1646  */
    {
					ExecuteStmt *n = makeNode(ExecuteStmt);

					n->name = (yyvsp[-1].str);
					n->params = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 42712 "gram.c" /* yacc.c:1646  */
    break;

  case 1574:
#line 11858 "gram.y" /* yacc.c:1646  */
    {
					CreateTableAsStmt *ctas = makeNode(CreateTableAsStmt);
					ExecuteStmt *n = makeNode(ExecuteStmt);

					n->name = (yyvsp[-2].str);
					n->params = (yyvsp[-1].list);
					ctas->query = (Node *) n;
					ctas->into = (yyvsp[-5].into);
					ctas->objtype = OBJECT_TABLE;
					ctas->is_select_into = false;
					ctas->if_not_exists = false;
					/* cram additional flags into the IntoClause */
					(yyvsp[-5].into)->rel->relpersistence = (yyvsp[-7].ival);
					(yyvsp[-5].into)->skipData = !((yyvsp[0].boolean));
					(yyval.node) = (Node *) ctas;
				}
#line 42733 "gram.c" /* yacc.c:1646  */
    break;

  case 1575:
#line 11876 "gram.y" /* yacc.c:1646  */
    {
					CreateTableAsStmt *ctas = makeNode(CreateTableAsStmt);
					ExecuteStmt *n = makeNode(ExecuteStmt);

					n->name = (yyvsp[-2].str);
					n->params = (yyvsp[-1].list);
					ctas->query = (Node *) n;
					ctas->into = (yyvsp[-5].into);
					ctas->objtype = OBJECT_TABLE;
					ctas->is_select_into = false;
					ctas->if_not_exists = true;
					/* cram additional flags into the IntoClause */
					(yyvsp[-5].into)->rel->relpersistence = (yyvsp[-10].ival);
					(yyvsp[-5].into)->skipData = !((yyvsp[0].boolean));
					(yyval.node) = (Node *) ctas;
				}
#line 42754 "gram.c" /* yacc.c:1646  */
    break;

  case 1576:
#line 11894 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 42760 "gram.c" /* yacc.c:1646  */
    break;

  case 1577:
#line 11895 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 42766 "gram.c" /* yacc.c:1646  */
    break;

  case 1578:
#line 11906 "gram.y" /* yacc.c:1646  */
    {
						DeallocateStmt *n = makeNode(DeallocateStmt);

						n->name = (yyvsp[0].str);
						(yyval.node) = (Node *) n;
					}
#line 42777 "gram.c" /* yacc.c:1646  */
    break;

  case 1579:
#line 11913 "gram.y" /* yacc.c:1646  */
    {
						DeallocateStmt *n = makeNode(DeallocateStmt);

						n->name = (yyvsp[0].str);
						(yyval.node) = (Node *) n;
					}
#line 42788 "gram.c" /* yacc.c:1646  */
    break;

  case 1580:
#line 11920 "gram.y" /* yacc.c:1646  */
    {
						DeallocateStmt *n = makeNode(DeallocateStmt);

						n->name = NULL;
						(yyval.node) = (Node *) n;
					}
#line 42799 "gram.c" /* yacc.c:1646  */
    break;

  case 1581:
#line 11927 "gram.y" /* yacc.c:1646  */
    {
						DeallocateStmt *n = makeNode(DeallocateStmt);

						n->name = NULL;
						(yyval.node) = (Node *) n;
					}
#line 42810 "gram.c" /* yacc.c:1646  */
    break;

  case 1582:
#line 11945 "gram.y" /* yacc.c:1646  */
    {
					(yyvsp[-2].istmt)->relation = (yyvsp[-3].range);
					(yyvsp[-2].istmt)->onConflictClause = (yyvsp[-1].onconflict);
					(yyvsp[-2].istmt)->returningList = (yyvsp[0].list);
					(yyvsp[-2].istmt)->withClause = (yyvsp[-6].with);
					(yyval.node) = (Node *) (yyvsp[-2].istmt);
				}
#line 42822 "gram.c" /* yacc.c:1646  */
    break;

  case 1583:
#line 11962 "gram.y" /* yacc.c:1646  */
    {
					(yyval.range) = (yyvsp[0].range);
				}
#line 42830 "gram.c" /* yacc.c:1646  */
    break;

  case 1584:
#line 11966 "gram.y" /* yacc.c:1646  */
    {
					(yyvsp[-2].range)->alias = makeAlias((yyvsp[0].str), NIL);
					(yyval.range) = (yyvsp[-2].range);
				}
#line 42839 "gram.c" /* yacc.c:1646  */
    break;

  case 1585:
#line 11974 "gram.y" /* yacc.c:1646  */
    {
					(yyval.istmt) = makeNode(InsertStmt);
					(yyval.istmt)->cols = NIL;
					(yyval.istmt)->selectStmt = (yyvsp[0].node);
				}
#line 42849 "gram.c" /* yacc.c:1646  */
    break;

  case 1586:
#line 11980 "gram.y" /* yacc.c:1646  */
    {
					(yyval.istmt) = makeNode(InsertStmt);
					(yyval.istmt)->cols = NIL;
					(yyval.istmt)->override = (yyvsp[-2].ival);
					(yyval.istmt)->selectStmt = (yyvsp[0].node);
				}
#line 42860 "gram.c" /* yacc.c:1646  */
    break;

  case 1587:
#line 11987 "gram.y" /* yacc.c:1646  */
    {
					(yyval.istmt) = makeNode(InsertStmt);
					(yyval.istmt)->cols = (yyvsp[-2].list);
					(yyval.istmt)->selectStmt = (yyvsp[0].node);
				}
#line 42870 "gram.c" /* yacc.c:1646  */
    break;

  case 1588:
#line 11993 "gram.y" /* yacc.c:1646  */
    {
					(yyval.istmt) = makeNode(InsertStmt);
					(yyval.istmt)->cols = (yyvsp[-5].list);
					(yyval.istmt)->override = (yyvsp[-2].ival);
					(yyval.istmt)->selectStmt = (yyvsp[0].node);
				}
#line 42881 "gram.c" /* yacc.c:1646  */
    break;

  case 1589:
#line 12000 "gram.y" /* yacc.c:1646  */
    {
					(yyval.istmt) = makeNode(InsertStmt);
					(yyval.istmt)->cols = NIL;
					(yyval.istmt)->selectStmt = NULL;
				}
#line 42891 "gram.c" /* yacc.c:1646  */
    break;

  case 1590:
#line 12008 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = OVERRIDING_USER_VALUE; }
#line 42897 "gram.c" /* yacc.c:1646  */
    break;

  case 1591:
#line 12009 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = OVERRIDING_SYSTEM_VALUE; }
#line 42903 "gram.c" /* yacc.c:1646  */
    break;

  case 1592:
#line 12014 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].target)); }
#line 42909 "gram.c" /* yacc.c:1646  */
    break;

  case 1593:
#line 12016 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].target)); }
#line 42915 "gram.c" /* yacc.c:1646  */
    break;

  case 1594:
#line 12021 "gram.y" /* yacc.c:1646  */
    {
					(yyval.target) = makeNode(ResTarget);
					(yyval.target)->name = (yyvsp[-1].str);
					(yyval.target)->indirection = check_indirection((yyvsp[0].list), yyscanner);
					(yyval.target)->val = NULL;
					(yyval.target)->location = (yylsp[-1]);
				}
#line 42927 "gram.c" /* yacc.c:1646  */
    break;

  case 1595:
#line 12032 "gram.y" /* yacc.c:1646  */
    {
					(yyval.onconflict) = makeNode(OnConflictClause);
					(yyval.onconflict)->action = ONCONFLICT_UPDATE;
					(yyval.onconflict)->infer = (yyvsp[-5].infer);
					(yyval.onconflict)->targetList = (yyvsp[-1].list);
					(yyval.onconflict)->whereClause = (yyvsp[0].node);
					(yyval.onconflict)->location = (yylsp[-7]);
				}
#line 42940 "gram.c" /* yacc.c:1646  */
    break;

  case 1596:
#line 12042 "gram.y" /* yacc.c:1646  */
    {
					(yyval.onconflict) = makeNode(OnConflictClause);
					(yyval.onconflict)->action = ONCONFLICT_NOTHING;
					(yyval.onconflict)->infer = (yyvsp[-2].infer);
					(yyval.onconflict)->targetList = NIL;
					(yyval.onconflict)->whereClause = NULL;
					(yyval.onconflict)->location = (yylsp[-4]);
				}
#line 42953 "gram.c" /* yacc.c:1646  */
    break;

  case 1597:
#line 12051 "gram.y" /* yacc.c:1646  */
    {
					(yyval.onconflict) = NULL;
				}
#line 42961 "gram.c" /* yacc.c:1646  */
    break;

  case 1598:
#line 12058 "gram.y" /* yacc.c:1646  */
    {
					(yyval.infer) = makeNode(InferClause);
					(yyval.infer)->indexElems = (yyvsp[-2].list);
					(yyval.infer)->whereClause = (yyvsp[0].node);
					(yyval.infer)->conname = NULL;
					(yyval.infer)->location = (yylsp[-3]);
				}
#line 42973 "gram.c" /* yacc.c:1646  */
    break;

  case 1599:
#line 12067 "gram.y" /* yacc.c:1646  */
    {
					(yyval.infer) = makeNode(InferClause);
					(yyval.infer)->indexElems = NIL;
					(yyval.infer)->whereClause = NULL;
					(yyval.infer)->conname = (yyvsp[0].str);
					(yyval.infer)->location = (yylsp[-2]);
				}
#line 42985 "gram.c" /* yacc.c:1646  */
    break;

  case 1600:
#line 12075 "gram.y" /* yacc.c:1646  */
    {
					(yyval.infer) = NULL;
				}
#line 42993 "gram.c" /* yacc.c:1646  */
    break;

  case 1601:
#line 12081 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 42999 "gram.c" /* yacc.c:1646  */
    break;

  case 1602:
#line 12082 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 43005 "gram.c" /* yacc.c:1646  */
    break;

  case 1603:
#line 12095 "gram.y" /* yacc.c:1646  */
    {
					DeleteStmt *n = makeNode(DeleteStmt);

					n->relation = (yyvsp[-3].range);
					n->usingClause = (yyvsp[-2].list);
					n->whereClause = (yyvsp[-1].node);
					n->returningList = (yyvsp[0].list);
					n->withClause = (yyvsp[-6].with);
					(yyval.node) = (Node *) n;
				}
#line 43020 "gram.c" /* yacc.c:1646  */
    break;

  case 1604:
#line 12108 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 43026 "gram.c" /* yacc.c:1646  */
    break;

  case 1605:
#line 12109 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 43032 "gram.c" /* yacc.c:1646  */
    break;

  case 1606:
#line 12121 "gram.y" /* yacc.c:1646  */
    {
					LockStmt   *n = makeNode(LockStmt);

					n->relations = (yyvsp[-2].list);
					n->mode = (yyvsp[-1].ival);
					n->nowait = (yyvsp[0].boolean);
					(yyval.node) = (Node *) n;
				}
#line 43045 "gram.c" /* yacc.c:1646  */
    break;

  case 1607:
#line 12131 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = (yyvsp[-1].ival); }
#line 43051 "gram.c" /* yacc.c:1646  */
    break;

  case 1608:
#line 12132 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = AccessExclusiveLock; }
#line 43057 "gram.c" /* yacc.c:1646  */
    break;

  case 1609:
#line 12135 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = AccessShareLock; }
#line 43063 "gram.c" /* yacc.c:1646  */
    break;

  case 1610:
#line 12136 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = RowShareLock; }
#line 43069 "gram.c" /* yacc.c:1646  */
    break;

  case 1611:
#line 12137 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = RowExclusiveLock; }
#line 43075 "gram.c" /* yacc.c:1646  */
    break;

  case 1612:
#line 12138 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = ShareUpdateExclusiveLock; }
#line 43081 "gram.c" /* yacc.c:1646  */
    break;

  case 1613:
#line 12139 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = ShareLock; }
#line 43087 "gram.c" /* yacc.c:1646  */
    break;

  case 1614:
#line 12140 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = ShareRowExclusiveLock; }
#line 43093 "gram.c" /* yacc.c:1646  */
    break;

  case 1615:
#line 12141 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = ExclusiveLock; }
#line 43099 "gram.c" /* yacc.c:1646  */
    break;

  case 1616:
#line 12142 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = AccessExclusiveLock; }
#line 43105 "gram.c" /* yacc.c:1646  */
    break;

  case 1617:
#line 12145 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 43111 "gram.c" /* yacc.c:1646  */
    break;

  case 1618:
#line 12146 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 43117 "gram.c" /* yacc.c:1646  */
    break;

  case 1619:
#line 12150 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = LockWaitError; }
#line 43123 "gram.c" /* yacc.c:1646  */
    break;

  case 1620:
#line 12151 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = LockWaitSkip; }
#line 43129 "gram.c" /* yacc.c:1646  */
    break;

  case 1621:
#line 12152 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = LockWaitBlock; }
#line 43135 "gram.c" /* yacc.c:1646  */
    break;

  case 1622:
#line 12168 "gram.y" /* yacc.c:1646  */
    {
					UpdateStmt *n = makeNode(UpdateStmt);

					n->relation = (yyvsp[-5].range);
					n->targetList = (yyvsp[-3].list);
					n->fromClause = (yyvsp[-2].list);
					n->whereClause = (yyvsp[-1].node);
					n->returningList = (yyvsp[0].list);
					n->withClause = (yyvsp[-7].with);
					(yyval.node) = (Node *) n;
				}
#line 43151 "gram.c" /* yacc.c:1646  */
    break;

  case 1623:
#line 12181 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 43157 "gram.c" /* yacc.c:1646  */
    break;

  case 1624:
#line 12182 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_concat((yyvsp[-2].list),(yyvsp[0].list)); }
#line 43163 "gram.c" /* yacc.c:1646  */
    break;

  case 1625:
#line 12187 "gram.y" /* yacc.c:1646  */
    {
					(yyvsp[-2].target)->val = (Node *) (yyvsp[0].node);
					(yyval.list) = list_make1((yyvsp[-2].target));
				}
#line 43172 "gram.c" /* yacc.c:1646  */
    break;

  case 1626:
#line 12192 "gram.y" /* yacc.c:1646  */
    {
					int			ncolumns = list_length((yyvsp[-3].list));
					int			i = 1;
					ListCell   *col_cell;

					/* Create a MultiAssignRef source for each target */
					foreach(col_cell, (yyvsp[-3].list))
					{
						ResTarget  *res_col = (ResTarget *) lfirst(col_cell);
						MultiAssignRef *r = makeNode(MultiAssignRef);

						r->source = (Node *) (yyvsp[0].node);
						r->colno = i;
						r->ncolumns = ncolumns;
						res_col->val = (Node *) r;
						i++;
					}

					(yyval.list) = (yyvsp[-3].list);
				}
#line 43197 "gram.c" /* yacc.c:1646  */
    break;

  case 1627:
#line 12216 "gram.y" /* yacc.c:1646  */
    {
					(yyval.target) = makeNode(ResTarget);
					(yyval.target)->name = (yyvsp[-1].str);
					(yyval.target)->indirection = check_indirection((yyvsp[0].list), yyscanner);
					(yyval.target)->val = NULL;	/* upper production sets this */
					(yyval.target)->location = (yylsp[-1]);
				}
#line 43209 "gram.c" /* yacc.c:1646  */
    break;

  case 1628:
#line 12226 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].target)); }
#line 43215 "gram.c" /* yacc.c:1646  */
    break;

  case 1629:
#line 12227 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list),(yyvsp[0].target)); }
#line 43221 "gram.c" /* yacc.c:1646  */
    break;

  case 1630:
#line 12243 "gram.y" /* yacc.c:1646  */
    {
					MergeStmt  *m = makeNode(MergeStmt);

					m->withClause = (yyvsp[-8].with);
					m->relation = (yyvsp[-5].range);
					m->sourceRelation = (yyvsp[-3].node);
					m->joinCondition = (yyvsp[-1].node);
					m->mergeWhenClauses = (yyvsp[0].list);

					(yyval.node) = (Node *) m;
				}
#line 43237 "gram.c" /* yacc.c:1646  */
    break;

  case 1631:
#line 12257 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 43243 "gram.c" /* yacc.c:1646  */
    break;

  case 1632:
#line 12258 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-1].list),(yyvsp[0].node)); }
#line 43249 "gram.c" /* yacc.c:1646  */
    break;

  case 1633:
#line 12263 "gram.y" /* yacc.c:1646  */
    {
					(yyvsp[0].mergewhen)->matched = true;
					(yyvsp[0].mergewhen)->condition = (yyvsp[-2].node);

					(yyval.node) = (Node *) (yyvsp[0].mergewhen);
				}
#line 43260 "gram.c" /* yacc.c:1646  */
    break;

  case 1634:
#line 12270 "gram.y" /* yacc.c:1646  */
    {
					(yyvsp[0].mergewhen)->matched = true;
					(yyvsp[0].mergewhen)->condition = (yyvsp[-2].node);

					(yyval.node) = (Node *) (yyvsp[0].mergewhen);
				}
#line 43271 "gram.c" /* yacc.c:1646  */
    break;

  case 1635:
#line 12277 "gram.y" /* yacc.c:1646  */
    {
					(yyvsp[0].mergewhen)->matched = false;
					(yyvsp[0].mergewhen)->condition = (yyvsp[-2].node);

					(yyval.node) = (Node *) (yyvsp[0].mergewhen);
				}
#line 43282 "gram.c" /* yacc.c:1646  */
    break;

  case 1636:
#line 12284 "gram.y" /* yacc.c:1646  */
    {
					MergeWhenClause *m = makeNode(MergeWhenClause);

					m->matched = true;
					m->commandType = CMD_NOTHING;
					m->condition = (yyvsp[-3].node);

					(yyval.node) = (Node *) m;
				}
#line 43296 "gram.c" /* yacc.c:1646  */
    break;

  case 1637:
#line 12294 "gram.y" /* yacc.c:1646  */
    {
					MergeWhenClause *m = makeNode(MergeWhenClause);

					m->matched = false;
					m->commandType = CMD_NOTHING;
					m->condition = (yyvsp[-3].node);

					(yyval.node) = (Node *) m;
				}
#line 43310 "gram.c" /* yacc.c:1646  */
    break;

  case 1638:
#line 12306 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 43316 "gram.c" /* yacc.c:1646  */
    break;

  case 1639:
#line 12307 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 43322 "gram.c" /* yacc.c:1646  */
    break;

  case 1640:
#line 12312 "gram.y" /* yacc.c:1646  */
    {
					MergeWhenClause *n = makeNode(MergeWhenClause);
					n->commandType = CMD_UPDATE;
					n->override = OVERRIDING_NOT_SET;
					n->targetList = (yyvsp[0].list);
					n->values = NIL;

					(yyval.mergewhen) = n;
				}
#line 43336 "gram.c" /* yacc.c:1646  */
    break;

  case 1641:
#line 12325 "gram.y" /* yacc.c:1646  */
    {
					MergeWhenClause *n = makeNode(MergeWhenClause);
					n->commandType = CMD_DELETE;
					n->override = OVERRIDING_NOT_SET;
					n->targetList = NIL;
					n->values = NIL;

					(yyval.mergewhen) = n;
				}
#line 43350 "gram.c" /* yacc.c:1646  */
    break;

  case 1642:
#line 12338 "gram.y" /* yacc.c:1646  */
    {
					MergeWhenClause *n = makeNode(MergeWhenClause);
					n->commandType = CMD_INSERT;
					n->override = OVERRIDING_NOT_SET;
					n->targetList = NIL;
					n->values = (yyvsp[0].list);
					(yyval.mergewhen) = n;
				}
#line 43363 "gram.c" /* yacc.c:1646  */
    break;

  case 1643:
#line 12347 "gram.y" /* yacc.c:1646  */
    {
					MergeWhenClause *n = makeNode(MergeWhenClause);
					n->commandType = CMD_INSERT;
					n->override = (yyvsp[-2].ival);
					n->targetList = NIL;
					n->values = (yyvsp[0].list);
					(yyval.mergewhen) = n;
				}
#line 43376 "gram.c" /* yacc.c:1646  */
    break;

  case 1644:
#line 12356 "gram.y" /* yacc.c:1646  */
    {
					MergeWhenClause *n = makeNode(MergeWhenClause);
					n->commandType = CMD_INSERT;
					n->override = OVERRIDING_NOT_SET;
					n->targetList = (yyvsp[-2].list);
					n->values = (yyvsp[0].list);
					(yyval.mergewhen) = n;
				}
#line 43389 "gram.c" /* yacc.c:1646  */
    break;

  case 1645:
#line 12365 "gram.y" /* yacc.c:1646  */
    {
					MergeWhenClause *n = makeNode(MergeWhenClause);
					n->commandType = CMD_INSERT;
					n->override = (yyvsp[-2].ival);
					n->targetList = (yyvsp[-5].list);
					n->values = (yyvsp[0].list);
					(yyval.mergewhen) = n;
				}
#line 43402 "gram.c" /* yacc.c:1646  */
    break;

  case 1646:
#line 12374 "gram.y" /* yacc.c:1646  */
    {
					MergeWhenClause *n = makeNode(MergeWhenClause);
					n->commandType = CMD_INSERT;
					n->override = OVERRIDING_NOT_SET;
					n->targetList = NIL;
					n->values = NIL;
					(yyval.mergewhen) = n;
				}
#line 43415 "gram.c" /* yacc.c:1646  */
    break;

  case 1647:
#line 12386 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = (yyvsp[-1].list);
				}
#line 43423 "gram.c" /* yacc.c:1646  */
    break;

  case 1648:
#line 12398 "gram.y" /* yacc.c:1646  */
    {
					DeclareCursorStmt *n = makeNode(DeclareCursorStmt);

					n->portalname = (yyvsp[-5].str);
					/* currently we always set FAST_PLAN option */
					n->options = (yyvsp[-4].ival) | (yyvsp[-2].ival) | CURSOR_OPT_FAST_PLAN;
					n->query = (yyvsp[0].node);
					(yyval.node) = (Node *) n;
				}
#line 43437 "gram.c" /* yacc.c:1646  */
    break;

  case 1649:
#line 12409 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 43443 "gram.c" /* yacc.c:1646  */
    break;

  case 1650:
#line 12412 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = 0; }
#line 43449 "gram.c" /* yacc.c:1646  */
    break;

  case 1651:
#line 12413 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = (yyvsp[-2].ival) | CURSOR_OPT_NO_SCROLL; }
#line 43455 "gram.c" /* yacc.c:1646  */
    break;

  case 1652:
#line 12414 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = (yyvsp[-1].ival) | CURSOR_OPT_SCROLL; }
#line 43461 "gram.c" /* yacc.c:1646  */
    break;

  case 1653:
#line 12415 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = (yyvsp[-1].ival) | CURSOR_OPT_BINARY; }
#line 43467 "gram.c" /* yacc.c:1646  */
    break;

  case 1654:
#line 12416 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = (yyvsp[-1].ival) | CURSOR_OPT_ASENSITIVE; }
#line 43473 "gram.c" /* yacc.c:1646  */
    break;

  case 1655:
#line 12417 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = (yyvsp[-1].ival) | CURSOR_OPT_INSENSITIVE; }
#line 43479 "gram.c" /* yacc.c:1646  */
    break;

  case 1656:
#line 12420 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = 0; }
#line 43485 "gram.c" /* yacc.c:1646  */
    break;

  case 1657:
#line 12421 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = CURSOR_OPT_HOLD; }
#line 43491 "gram.c" /* yacc.c:1646  */
    break;

  case 1658:
#line 12422 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = 0; }
#line 43497 "gram.c" /* yacc.c:1646  */
    break;

  case 1661:
#line 12475 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[-1].node); }
#line 43503 "gram.c" /* yacc.c:1646  */
    break;

  case 1662:
#line 12476 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[-1].node); }
#line 43509 "gram.c" /* yacc.c:1646  */
    break;

  case 1663:
#line 12491 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 43515 "gram.c" /* yacc.c:1646  */
    break;

  case 1664:
#line 12493 "gram.y" /* yacc.c:1646  */
    {
					insertSelectOptions((SelectStmt *) (yyvsp[-1].node), (yyvsp[0].list), NIL,
										NULL, NULL,
										yyscanner);
					(yyval.node) = (yyvsp[-1].node);
				}
#line 43526 "gram.c" /* yacc.c:1646  */
    break;

  case 1665:
#line 12500 "gram.y" /* yacc.c:1646  */
    {
					insertSelectOptions((SelectStmt *) (yyvsp[-3].node), (yyvsp[-2].list), (yyvsp[-1].list),
										(yyvsp[0].selectlimit),
										NULL,
										yyscanner);
					(yyval.node) = (yyvsp[-3].node);
				}
#line 43538 "gram.c" /* yacc.c:1646  */
    break;

  case 1666:
#line 12508 "gram.y" /* yacc.c:1646  */
    {
					insertSelectOptions((SelectStmt *) (yyvsp[-3].node), (yyvsp[-2].list), (yyvsp[0].list),
										(yyvsp[-1].selectlimit),
										NULL,
										yyscanner);
					(yyval.node) = (yyvsp[-3].node);
				}
#line 43550 "gram.c" /* yacc.c:1646  */
    break;

  case 1667:
#line 12516 "gram.y" /* yacc.c:1646  */
    {
					insertSelectOptions((SelectStmt *) (yyvsp[0].node), NULL, NIL,
										NULL,
										(yyvsp[-1].with),
										yyscanner);
					(yyval.node) = (yyvsp[0].node);
				}
#line 43562 "gram.c" /* yacc.c:1646  */
    break;

  case 1668:
#line 12524 "gram.y" /* yacc.c:1646  */
    {
					insertSelectOptions((SelectStmt *) (yyvsp[-1].node), (yyvsp[0].list), NIL,
										NULL,
										(yyvsp[-2].with),
										yyscanner);
					(yyval.node) = (yyvsp[-1].node);
				}
#line 43574 "gram.c" /* yacc.c:1646  */
    break;

  case 1669:
#line 12532 "gram.y" /* yacc.c:1646  */
    {
					insertSelectOptions((SelectStmt *) (yyvsp[-3].node), (yyvsp[-2].list), (yyvsp[-1].list),
										(yyvsp[0].selectlimit),
										(yyvsp[-4].with),
										yyscanner);
					(yyval.node) = (yyvsp[-3].node);
				}
#line 43586 "gram.c" /* yacc.c:1646  */
    break;

  case 1670:
#line 12540 "gram.y" /* yacc.c:1646  */
    {
					insertSelectOptions((SelectStmt *) (yyvsp[-3].node), (yyvsp[-2].list), (yyvsp[0].list),
										(yyvsp[-1].selectlimit),
										(yyvsp[-4].with),
										yyscanner);
					(yyval.node) = (yyvsp[-3].node);
				}
#line 43598 "gram.c" /* yacc.c:1646  */
    break;

  case 1671:
#line 12550 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 43604 "gram.c" /* yacc.c:1646  */
    break;

  case 1672:
#line 12551 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 43610 "gram.c" /* yacc.c:1646  */
    break;

  case 1673:
#line 12586 "gram.y" /* yacc.c:1646  */
    {
					SelectStmt *n = makeNode(SelectStmt);

					n->targetList = (yyvsp[-6].list);
					n->intoClause = (yyvsp[-5].into);
					n->fromClause = (yyvsp[-4].list);
					n->whereClause = (yyvsp[-3].node);
					n->groupClause = ((yyvsp[-2].groupclause))->list;
					n->groupDistinct = ((yyvsp[-2].groupclause))->distinct;
					n->havingClause = (yyvsp[-1].node);
					n->windowClause = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 43628 "gram.c" /* yacc.c:1646  */
    break;

  case 1674:
#line 12602 "gram.y" /* yacc.c:1646  */
    {
					SelectStmt *n = makeNode(SelectStmt);

					n->distinctClause = (yyvsp[-7].list);
					n->targetList = (yyvsp[-6].list);
					n->intoClause = (yyvsp[-5].into);
					n->fromClause = (yyvsp[-4].list);
					n->whereClause = (yyvsp[-3].node);
					n->groupClause = ((yyvsp[-2].groupclause))->list;
					n->groupDistinct = ((yyvsp[-2].groupclause))->distinct;
					n->havingClause = (yyvsp[-1].node);
					n->windowClause = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 43647 "gram.c" /* yacc.c:1646  */
    break;

  case 1675:
#line 12616 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 43653 "gram.c" /* yacc.c:1646  */
    break;

  case 1676:
#line 12618 "gram.y" /* yacc.c:1646  */
    {
					/* same as SELECT * FROM relation_expr */
					ColumnRef  *cr = makeNode(ColumnRef);
					ResTarget  *rt = makeNode(ResTarget);
					SelectStmt *n = makeNode(SelectStmt);

					cr->fields = list_make1(makeNode(A_Star));
					cr->location = -1;

					rt->name = NULL;
					rt->indirection = NIL;
					rt->val = (Node *) cr;
					rt->location = -1;

					n->targetList = list_make1(rt);
					n->fromClause = list_make1((yyvsp[0].range));
					(yyval.node) = (Node *) n;
				}
#line 43676 "gram.c" /* yacc.c:1646  */
    break;

  case 1677:
#line 12637 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeSetOp(SETOP_UNION, (yyvsp[-1].setquantifier) == SET_QUANTIFIER_ALL, (yyvsp[-3].node), (yyvsp[0].node));
				}
#line 43684 "gram.c" /* yacc.c:1646  */
    break;

  case 1678:
#line 12641 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeSetOp(SETOP_INTERSECT, (yyvsp[-1].setquantifier) == SET_QUANTIFIER_ALL, (yyvsp[-3].node), (yyvsp[0].node));
				}
#line 43692 "gram.c" /* yacc.c:1646  */
    break;

  case 1679:
#line 12645 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeSetOp(SETOP_EXCEPT, (yyvsp[-1].setquantifier) == SET_QUANTIFIER_ALL, (yyvsp[-3].node), (yyvsp[0].node));
				}
#line 43700 "gram.c" /* yacc.c:1646  */
    break;

  case 1680:
#line 12660 "gram.y" /* yacc.c:1646  */
    {
				(yyval.with) = makeNode(WithClause);
				(yyval.with)->ctes = (yyvsp[0].list);
				(yyval.with)->recursive = false;
				(yyval.with)->location = (yylsp[-1]);
			}
#line 43711 "gram.c" /* yacc.c:1646  */
    break;

  case 1681:
#line 12667 "gram.y" /* yacc.c:1646  */
    {
				(yyval.with) = makeNode(WithClause);
				(yyval.with)->ctes = (yyvsp[0].list);
				(yyval.with)->recursive = false;
				(yyval.with)->location = (yylsp[-1]);
			}
#line 43722 "gram.c" /* yacc.c:1646  */
    break;

  case 1682:
#line 12674 "gram.y" /* yacc.c:1646  */
    {
				(yyval.with) = makeNode(WithClause);
				(yyval.with)->ctes = (yyvsp[0].list);
				(yyval.with)->recursive = true;
				(yyval.with)->location = (yylsp[-2]);
			}
#line 43733 "gram.c" /* yacc.c:1646  */
    break;

  case 1683:
#line 12683 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 43739 "gram.c" /* yacc.c:1646  */
    break;

  case 1684:
#line 12684 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node)); }
#line 43745 "gram.c" /* yacc.c:1646  */
    break;

  case 1685:
#line 12688 "gram.y" /* yacc.c:1646  */
    {
				CommonTableExpr *n = makeNode(CommonTableExpr);

				n->ctename = (yyvsp[-8].str);
				n->aliascolnames = (yyvsp[-7].list);
				n->ctematerialized = (yyvsp[-5].ival);
				n->ctequery = (yyvsp[-3].node);
				n->search_clause = castNode(CTESearchClause, (yyvsp[-1].node));
				n->cycle_clause = castNode(CTECycleClause, (yyvsp[0].node));
				n->location = (yylsp[-8]);
				(yyval.node) = (Node *) n;
			}
#line 43762 "gram.c" /* yacc.c:1646  */
    break;

  case 1686:
#line 12703 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = CTEMaterializeAlways; }
#line 43768 "gram.c" /* yacc.c:1646  */
    break;

  case 1687:
#line 12704 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = CTEMaterializeNever; }
#line 43774 "gram.c" /* yacc.c:1646  */
    break;

  case 1688:
#line 12705 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = CTEMaterializeDefault; }
#line 43780 "gram.c" /* yacc.c:1646  */
    break;

  case 1689:
#line 12710 "gram.y" /* yacc.c:1646  */
    {
				CTESearchClause *n = makeNode(CTESearchClause);

				n->search_col_list = (yyvsp[-2].list);
				n->search_breadth_first = false;
				n->search_seq_column = (yyvsp[0].str);
				n->location = (yylsp[-6]);
				(yyval.node) = (Node *) n;
			}
#line 43794 "gram.c" /* yacc.c:1646  */
    break;

  case 1690:
#line 12720 "gram.y" /* yacc.c:1646  */
    {
				CTESearchClause *n = makeNode(CTESearchClause);

				n->search_col_list = (yyvsp[-2].list);
				n->search_breadth_first = true;
				n->search_seq_column = (yyvsp[0].str);
				n->location = (yylsp[-6]);
				(yyval.node) = (Node *) n;
			}
#line 43808 "gram.c" /* yacc.c:1646  */
    break;

  case 1691:
#line 12730 "gram.y" /* yacc.c:1646  */
    {
				(yyval.node) = NULL;
			}
#line 43816 "gram.c" /* yacc.c:1646  */
    break;

  case 1692:
#line 12737 "gram.y" /* yacc.c:1646  */
    {
				CTECycleClause *n = makeNode(CTECycleClause);

				n->cycle_col_list = (yyvsp[-8].list);
				n->cycle_mark_column = (yyvsp[-6].str);
				n->cycle_mark_value = (yyvsp[-4].node);
				n->cycle_mark_default = (yyvsp[-2].node);
				n->cycle_path_column = (yyvsp[0].str);
				n->location = (yylsp[-9]);
				(yyval.node) = (Node *) n;
			}
#line 43832 "gram.c" /* yacc.c:1646  */
    break;

  case 1693:
#line 12749 "gram.y" /* yacc.c:1646  */
    {
				CTECycleClause *n = makeNode(CTECycleClause);

				n->cycle_col_list = (yyvsp[-4].list);
				n->cycle_mark_column = (yyvsp[-2].str);
				n->cycle_mark_value = makeBoolAConst(true, -1);
				n->cycle_mark_default = makeBoolAConst(false, -1);
				n->cycle_path_column = (yyvsp[0].str);
				n->location = (yylsp[-5]);
				(yyval.node) = (Node *) n;
			}
#line 43848 "gram.c" /* yacc.c:1646  */
    break;

  case 1694:
#line 12761 "gram.y" /* yacc.c:1646  */
    {
				(yyval.node) = NULL;
			}
#line 43856 "gram.c" /* yacc.c:1646  */
    break;

  case 1695:
#line 12767 "gram.y" /* yacc.c:1646  */
    { (yyval.with) = (yyvsp[0].with); }
#line 43862 "gram.c" /* yacc.c:1646  */
    break;

  case 1696:
#line 12768 "gram.y" /* yacc.c:1646  */
    { (yyval.with) = NULL; }
#line 43868 "gram.c" /* yacc.c:1646  */
    break;

  case 1697:
#line 12773 "gram.y" /* yacc.c:1646  */
    {
					(yyval.into) = makeNode(IntoClause);
					(yyval.into)->rel = (yyvsp[0].range);
					(yyval.into)->colNames = NIL;
					(yyval.into)->options = NIL;
					(yyval.into)->onCommit = ONCOMMIT_NOOP;
					(yyval.into)->tableSpaceName = NULL;
					(yyval.into)->viewQuery = NULL;
					(yyval.into)->skipData = false;
				}
#line 43883 "gram.c" /* yacc.c:1646  */
    break;

  case 1698:
#line 12784 "gram.y" /* yacc.c:1646  */
    { (yyval.into) = NULL; }
#line 43889 "gram.c" /* yacc.c:1646  */
    break;

  case 1699:
#line 12793 "gram.y" /* yacc.c:1646  */
    {
					(yyval.range) = (yyvsp[0].range);
					(yyval.range)->relpersistence = RELPERSISTENCE_TEMP;
				}
#line 43898 "gram.c" /* yacc.c:1646  */
    break;

  case 1700:
#line 12798 "gram.y" /* yacc.c:1646  */
    {
					(yyval.range) = (yyvsp[0].range);
					(yyval.range)->relpersistence = RELPERSISTENCE_TEMP;
				}
#line 43907 "gram.c" /* yacc.c:1646  */
    break;

  case 1701:
#line 12803 "gram.y" /* yacc.c:1646  */
    {
					(yyval.range) = (yyvsp[0].range);
					(yyval.range)->relpersistence = RELPERSISTENCE_TEMP;
				}
#line 43916 "gram.c" /* yacc.c:1646  */
    break;

  case 1702:
#line 12808 "gram.y" /* yacc.c:1646  */
    {
					(yyval.range) = (yyvsp[0].range);
					(yyval.range)->relpersistence = RELPERSISTENCE_TEMP;
				}
#line 43925 "gram.c" /* yacc.c:1646  */
    break;

  case 1703:
#line 12813 "gram.y" /* yacc.c:1646  */
    {
					ereport(WARNING,
							(errmsg("GLOBAL is deprecated in temporary table creation"),
							 parser_errposition((yylsp[-3]))));
					(yyval.range) = (yyvsp[0].range);
					(yyval.range)->relpersistence = RELPERSISTENCE_TEMP;
				}
#line 43937 "gram.c" /* yacc.c:1646  */
    break;

  case 1704:
#line 12821 "gram.y" /* yacc.c:1646  */
    {
					ereport(WARNING,
							(errmsg("GLOBAL is deprecated in temporary table creation"),
							 parser_errposition((yylsp[-3]))));
					(yyval.range) = (yyvsp[0].range);
					(yyval.range)->relpersistence = RELPERSISTENCE_TEMP;
				}
#line 43949 "gram.c" /* yacc.c:1646  */
    break;

  case 1705:
#line 12829 "gram.y" /* yacc.c:1646  */
    {
					(yyval.range) = (yyvsp[0].range);
					(yyval.range)->relpersistence = RELPERSISTENCE_UNLOGGED;
				}
#line 43958 "gram.c" /* yacc.c:1646  */
    break;

  case 1706:
#line 12834 "gram.y" /* yacc.c:1646  */
    {
					(yyval.range) = (yyvsp[0].range);
					(yyval.range)->relpersistence = RELPERSISTENCE_PERMANENT;
				}
#line 43967 "gram.c" /* yacc.c:1646  */
    break;

  case 1707:
#line 12839 "gram.y" /* yacc.c:1646  */
    {
					(yyval.range) = (yyvsp[0].range);
					(yyval.range)->relpersistence = RELPERSISTENCE_PERMANENT;
				}
#line 43976 "gram.c" /* yacc.c:1646  */
    break;

  case 1710:
#line 12850 "gram.y" /* yacc.c:1646  */
    { (yyval.setquantifier) = SET_QUANTIFIER_ALL; }
#line 43982 "gram.c" /* yacc.c:1646  */
    break;

  case 1711:
#line 12851 "gram.y" /* yacc.c:1646  */
    { (yyval.setquantifier) = SET_QUANTIFIER_DISTINCT; }
#line 43988 "gram.c" /* yacc.c:1646  */
    break;

  case 1712:
#line 12852 "gram.y" /* yacc.c:1646  */
    { (yyval.setquantifier) = SET_QUANTIFIER_DEFAULT; }
#line 43994 "gram.c" /* yacc.c:1646  */
    break;

  case 1713:
#line 12859 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(NIL); }
#line 44000 "gram.c" /* yacc.c:1646  */
    break;

  case 1714:
#line 12860 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 44006 "gram.c" /* yacc.c:1646  */
    break;

  case 1717:
#line 12869 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 44012 "gram.c" /* yacc.c:1646  */
    break;

  case 1718:
#line 12870 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 44018 "gram.c" /* yacc.c:1646  */
    break;

  case 1719:
#line 12874 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 44024 "gram.c" /* yacc.c:1646  */
    break;

  case 1720:
#line 12875 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 44030 "gram.c" /* yacc.c:1646  */
    break;

  case 1721:
#line 12879 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 44036 "gram.c" /* yacc.c:1646  */
    break;

  case 1722:
#line 12883 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].sortby)); }
#line 44042 "gram.c" /* yacc.c:1646  */
    break;

  case 1723:
#line 12884 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].sortby)); }
#line 44048 "gram.c" /* yacc.c:1646  */
    break;

  case 1724:
#line 12888 "gram.y" /* yacc.c:1646  */
    {
					(yyval.sortby) = makeNode(SortBy);
					(yyval.sortby)->node = (yyvsp[-3].node);
					(yyval.sortby)->sortby_dir = SORTBY_USING;
					(yyval.sortby)->sortby_nulls = (yyvsp[0].ival);
					(yyval.sortby)->useOp = (yyvsp[-1].list);
					(yyval.sortby)->location = (yylsp[-1]);
				}
#line 44061 "gram.c" /* yacc.c:1646  */
    break;

  case 1725:
#line 12897 "gram.y" /* yacc.c:1646  */
    {
					(yyval.sortby) = makeNode(SortBy);
					(yyval.sortby)->node = (yyvsp[-2].node);
					(yyval.sortby)->sortby_dir = (yyvsp[-1].ival);
					(yyval.sortby)->sortby_nulls = (yyvsp[0].ival);
					(yyval.sortby)->useOp = NIL;
					(yyval.sortby)->location = -1;		/* no operator */
				}
#line 44074 "gram.c" /* yacc.c:1646  */
    break;

  case 1726:
#line 12910 "gram.y" /* yacc.c:1646  */
    {
					(yyval.selectlimit) = (yyvsp[-1].selectlimit);
					((yyval.selectlimit))->limitOffset = (yyvsp[0].node);
				}
#line 44083 "gram.c" /* yacc.c:1646  */
    break;

  case 1727:
#line 12915 "gram.y" /* yacc.c:1646  */
    {
					(yyval.selectlimit) = (yyvsp[0].selectlimit);
					((yyval.selectlimit))->limitOffset = (yyvsp[-1].node);
				}
#line 44092 "gram.c" /* yacc.c:1646  */
    break;

  case 1728:
#line 12920 "gram.y" /* yacc.c:1646  */
    {
					(yyval.selectlimit) = (yyvsp[0].selectlimit);
				}
#line 44100 "gram.c" /* yacc.c:1646  */
    break;

  case 1729:
#line 12924 "gram.y" /* yacc.c:1646  */
    {
					SelectLimit *n = (SelectLimit *) palloc(sizeof(SelectLimit));

					n->limitOffset = (yyvsp[0].node);
					n->limitCount = NULL;
					n->limitOption = LIMIT_OPTION_COUNT;
					(yyval.selectlimit) = n;
				}
#line 44113 "gram.c" /* yacc.c:1646  */
    break;

  case 1730:
#line 12935 "gram.y" /* yacc.c:1646  */
    { (yyval.selectlimit) = (yyvsp[0].selectlimit); }
#line 44119 "gram.c" /* yacc.c:1646  */
    break;

  case 1731:
#line 12936 "gram.y" /* yacc.c:1646  */
    { (yyval.selectlimit) = NULL; }
#line 44125 "gram.c" /* yacc.c:1646  */
    break;

  case 1732:
#line 12941 "gram.y" /* yacc.c:1646  */
    {
					SelectLimit *n = (SelectLimit *) palloc(sizeof(SelectLimit));

					n->limitOffset = NULL;
					n->limitCount = (yyvsp[0].node);
					n->limitOption = LIMIT_OPTION_COUNT;
					(yyval.selectlimit) = n;
				}
#line 44138 "gram.c" /* yacc.c:1646  */
    break;

  case 1733:
#line 12950 "gram.y" /* yacc.c:1646  */
    {
					/* Disabled because it was too confusing, bjm 2002-02-18 */
					ereport(ERROR,
							(errcode(ERRCODE_SYNTAX_ERROR),
							 errmsg("LIMIT #,# syntax is not supported"),
							 errhint("Use separate LIMIT and OFFSET clauses."),
							 parser_errposition((yylsp[-3]))));
				}
#line 44151 "gram.c" /* yacc.c:1646  */
    break;

  case 1734:
#line 12966 "gram.y" /* yacc.c:1646  */
    {
					SelectLimit *n = (SelectLimit *) palloc(sizeof(SelectLimit));

					n->limitOffset = NULL;
					n->limitCount = (yyvsp[-2].node);
					n->limitOption = LIMIT_OPTION_COUNT;
					(yyval.selectlimit) = n;
				}
#line 44164 "gram.c" /* yacc.c:1646  */
    break;

  case 1735:
#line 12975 "gram.y" /* yacc.c:1646  */
    {
					SelectLimit *n = (SelectLimit *) palloc(sizeof(SelectLimit));

					n->limitOffset = NULL;
					n->limitCount = (yyvsp[-3].node);
					n->limitOption = LIMIT_OPTION_WITH_TIES;
					(yyval.selectlimit) = n;
				}
#line 44177 "gram.c" /* yacc.c:1646  */
    break;

  case 1736:
#line 12984 "gram.y" /* yacc.c:1646  */
    {
					SelectLimit *n = (SelectLimit *) palloc(sizeof(SelectLimit));

					n->limitOffset = NULL;
					n->limitCount = makeIntConst(1, -1);
					n->limitOption = LIMIT_OPTION_COUNT;
					(yyval.selectlimit) = n;
				}
#line 44190 "gram.c" /* yacc.c:1646  */
    break;

  case 1737:
#line 12993 "gram.y" /* yacc.c:1646  */
    {
					SelectLimit *n = (SelectLimit *) palloc(sizeof(SelectLimit));

					n->limitOffset = NULL;
					n->limitCount = makeIntConst(1, -1);
					n->limitOption = LIMIT_OPTION_WITH_TIES;
					(yyval.selectlimit) = n;
				}
#line 44203 "gram.c" /* yacc.c:1646  */
    break;

  case 1738:
#line 13005 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 44209 "gram.c" /* yacc.c:1646  */
    break;

  case 1739:
#line 13008 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[-1].node); }
#line 44215 "gram.c" /* yacc.c:1646  */
    break;

  case 1740:
#line 13012 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 44221 "gram.c" /* yacc.c:1646  */
    break;

  case 1741:
#line 13014 "gram.y" /* yacc.c:1646  */
    {
					/* LIMIT ALL is represented as a NULL constant */
					(yyval.node) = makeNullAConst((yylsp[0]));
				}
#line 44230 "gram.c" /* yacc.c:1646  */
    break;

  case 1742:
#line 13021 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 44236 "gram.c" /* yacc.c:1646  */
    break;

  case 1743:
#line 13041 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 44242 "gram.c" /* yacc.c:1646  */
    break;

  case 1744:
#line 13043 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "+", NULL, (yyvsp[0].node), (yylsp[-1])); }
#line 44248 "gram.c" /* yacc.c:1646  */
    break;

  case 1745:
#line 13045 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = doNegate((yyvsp[0].node), (yylsp[-1])); }
#line 44254 "gram.c" /* yacc.c:1646  */
    break;

  case 1746:
#line 13049 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = makeIntConst((yyvsp[0].ival),(yylsp[0])); }
#line 44260 "gram.c" /* yacc.c:1646  */
    break;

  case 1747:
#line 13050 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = makeFloatConst((yyvsp[0].str),(yylsp[0])); }
#line 44266 "gram.c" /* yacc.c:1646  */
    break;

  case 1748:
#line 13054 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = 0; }
#line 44272 "gram.c" /* yacc.c:1646  */
    break;

  case 1749:
#line 13055 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = 0; }
#line 44278 "gram.c" /* yacc.c:1646  */
    break;

  case 1750:
#line 13058 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = 0; }
#line 44284 "gram.c" /* yacc.c:1646  */
    break;

  case 1751:
#line 13059 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = 0; }
#line 44290 "gram.c" /* yacc.c:1646  */
    break;

  case 1752:
#line 13085 "gram.y" /* yacc.c:1646  */
    {
					GroupClause *n = (GroupClause *) palloc(sizeof(GroupClause));

					n->distinct = (yyvsp[-1].setquantifier) == SET_QUANTIFIER_DISTINCT;
					n->list = (yyvsp[0].list);
					(yyval.groupclause) = n;
				}
#line 44302 "gram.c" /* yacc.c:1646  */
    break;

  case 1753:
#line 13093 "gram.y" /* yacc.c:1646  */
    {
					GroupClause *n = (GroupClause *) palloc(sizeof(GroupClause));

					n->distinct = false;
					n->list = NIL;
					(yyval.groupclause) = n;
				}
#line 44314 "gram.c" /* yacc.c:1646  */
    break;

  case 1754:
#line 13103 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 44320 "gram.c" /* yacc.c:1646  */
    break;

  case 1755:
#line 13104 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list),(yyvsp[0].node)); }
#line 44326 "gram.c" /* yacc.c:1646  */
    break;

  case 1756:
#line 13108 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 44332 "gram.c" /* yacc.c:1646  */
    break;

  case 1757:
#line 13109 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 44338 "gram.c" /* yacc.c:1646  */
    break;

  case 1758:
#line 13110 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 44344 "gram.c" /* yacc.c:1646  */
    break;

  case 1759:
#line 13111 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 44350 "gram.c" /* yacc.c:1646  */
    break;

  case 1760:
#line 13112 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 44356 "gram.c" /* yacc.c:1646  */
    break;

  case 1761:
#line 13117 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeGroupingSet(GROUPING_SET_EMPTY, NIL, (yylsp[-1]));
				}
#line 44364 "gram.c" /* yacc.c:1646  */
    break;

  case 1762:
#line 13130 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeGroupingSet(GROUPING_SET_ROLLUP, (yyvsp[-1].list), (yylsp[-3]));
				}
#line 44372 "gram.c" /* yacc.c:1646  */
    break;

  case 1763:
#line 13137 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeGroupingSet(GROUPING_SET_CUBE, (yyvsp[-1].list), (yylsp[-3]));
				}
#line 44380 "gram.c" /* yacc.c:1646  */
    break;

  case 1764:
#line 13144 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeGroupingSet(GROUPING_SET_SETS, (yyvsp[-1].list), (yylsp[-4]));
				}
#line 44388 "gram.c" /* yacc.c:1646  */
    break;

  case 1765:
#line 13150 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 44394 "gram.c" /* yacc.c:1646  */
    break;

  case 1766:
#line 13151 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 44400 "gram.c" /* yacc.c:1646  */
    break;

  case 1767:
#line 13155 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 44406 "gram.c" /* yacc.c:1646  */
    break;

  case 1768:
#line 13156 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 44412 "gram.c" /* yacc.c:1646  */
    break;

  case 1769:
#line 13160 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 44418 "gram.c" /* yacc.c:1646  */
    break;

  case 1770:
#line 13161 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 44424 "gram.c" /* yacc.c:1646  */
    break;

  case 1771:
#line 13165 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 44430 "gram.c" /* yacc.c:1646  */
    break;

  case 1772:
#line 13166 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].node)); }
#line 44436 "gram.c" /* yacc.c:1646  */
    break;

  case 1773:
#line 13171 "gram.y" /* yacc.c:1646  */
    {
					LockingClause *n = makeNode(LockingClause);

					n->lockedRels = (yyvsp[-1].list);
					n->strength = (yyvsp[-2].ival);
					n->waitPolicy = (yyvsp[0].ival);
					(yyval.node) = (Node *) n;
				}
#line 44449 "gram.c" /* yacc.c:1646  */
    break;

  case 1774:
#line 13182 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = LCS_FORUPDATE; }
#line 44455 "gram.c" /* yacc.c:1646  */
    break;

  case 1775:
#line 13183 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = LCS_FORNOKEYUPDATE; }
#line 44461 "gram.c" /* yacc.c:1646  */
    break;

  case 1776:
#line 13184 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = LCS_FORSHARE; }
#line 44467 "gram.c" /* yacc.c:1646  */
    break;

  case 1777:
#line 13185 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = LCS_FORKEYSHARE; }
#line 44473 "gram.c" /* yacc.c:1646  */
    break;

  case 1778:
#line 13189 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 44479 "gram.c" /* yacc.c:1646  */
    break;

  case 1779:
#line 13190 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 44485 "gram.c" /* yacc.c:1646  */
    break;

  case 1780:
#line 13201 "gram.y" /* yacc.c:1646  */
    {
					SelectStmt *n = makeNode(SelectStmt);

					n->valuesLists = list_make1((yyvsp[-1].list));
					(yyval.node) = (Node *) n;
				}
#line 44496 "gram.c" /* yacc.c:1646  */
    break;

  case 1781:
#line 13208 "gram.y" /* yacc.c:1646  */
    {
					SelectStmt *n = (SelectStmt *) (yyvsp[-4].node);

					n->valuesLists = lappend(n->valuesLists, (yyvsp[-1].list));
					(yyval.node) = (Node *) n;
				}
#line 44507 "gram.c" /* yacc.c:1646  */
    break;

  case 1782:
#line 13226 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 44513 "gram.c" /* yacc.c:1646  */
    break;

  case 1783:
#line 13227 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 44519 "gram.c" /* yacc.c:1646  */
    break;

  case 1784:
#line 13231 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 44525 "gram.c" /* yacc.c:1646  */
    break;

  case 1785:
#line 13232 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node)); }
#line 44531 "gram.c" /* yacc.c:1646  */
    break;

  case 1786:
#line 13239 "gram.y" /* yacc.c:1646  */
    {
					(yyvsp[-1].range)->alias = (yyvsp[0].alias);
					(yyval.node) = (Node *) (yyvsp[-1].range);
				}
#line 44540 "gram.c" /* yacc.c:1646  */
    break;

  case 1787:
#line 13244 "gram.y" /* yacc.c:1646  */
    {
					RangeTableSample *n = (RangeTableSample *) (yyvsp[0].node);

					(yyvsp[-2].range)->alias = (yyvsp[-1].alias);
					/* relation_expr goes inside the RangeTableSample node */
					n->relation = (Node *) (yyvsp[-2].range);
					(yyval.node) = (Node *) n;
				}
#line 44553 "gram.c" /* yacc.c:1646  */
    break;

  case 1788:
#line 13253 "gram.y" /* yacc.c:1646  */
    {
					RangeFunction *n = (RangeFunction *) (yyvsp[-1].node);

					n->alias = linitial((yyvsp[0].list));
					n->coldeflist = lsecond((yyvsp[0].list));
					(yyval.node) = (Node *) n;
				}
#line 44565 "gram.c" /* yacc.c:1646  */
    break;

  case 1789:
#line 13261 "gram.y" /* yacc.c:1646  */
    {
					RangeFunction *n = (RangeFunction *) (yyvsp[-1].node);

					n->lateral = true;
					n->alias = linitial((yyvsp[0].list));
					n->coldeflist = lsecond((yyvsp[0].list));
					(yyval.node) = (Node *) n;
				}
#line 44578 "gram.c" /* yacc.c:1646  */
    break;

  case 1790:
#line 13270 "gram.y" /* yacc.c:1646  */
    {
					RangeTableFunc *n = (RangeTableFunc *) (yyvsp[-1].node);

					n->alias = (yyvsp[0].alias);
					(yyval.node) = (Node *) n;
				}
#line 44589 "gram.c" /* yacc.c:1646  */
    break;

  case 1791:
#line 13277 "gram.y" /* yacc.c:1646  */
    {
					RangeTableFunc *n = (RangeTableFunc *) (yyvsp[-1].node);

					n->lateral = true;
					n->alias = (yyvsp[0].alias);
					(yyval.node) = (Node *) n;
				}
#line 44601 "gram.c" /* yacc.c:1646  */
    break;

  case 1792:
#line 13285 "gram.y" /* yacc.c:1646  */
    {
					RangeSubselect *n = makeNode(RangeSubselect);

					n->lateral = false;
					n->subquery = (yyvsp[-1].node);
					n->alias = (yyvsp[0].alias);
					/*
					 * The SQL spec does not permit a subselect
					 * (<derived_table>) without an alias clause,
					 * so we don't either.  This avoids the problem
					 * of needing to invent a unique refname for it.
					 * That could be surmounted if there's sufficient
					 * popular demand, but for now let's just implement
					 * the spec and see if anyone complains.
					 * However, it does seem like a good idea to emit
					 * an error message that's better than "syntax error".
					 */
					if ((yyvsp[0].alias) == NULL)
					{
						if (IsA((yyvsp[-1].node), SelectStmt) &&
							((SelectStmt *) (yyvsp[-1].node))->valuesLists)
							ereport(ERROR,
									(errcode(ERRCODE_SYNTAX_ERROR),
									 errmsg("VALUES in FROM must have an alias"),
									 errhint("For example, FROM (VALUES ...) [AS] foo."),
									 parser_errposition((yylsp[-1]))));
						else
							ereport(ERROR,
									(errcode(ERRCODE_SYNTAX_ERROR),
									 errmsg("subquery in FROM must have an alias"),
									 errhint("For example, FROM (SELECT ...) [AS] foo."),
									 parser_errposition((yylsp[-1]))));
					}
					(yyval.node) = (Node *) n;
				}
#line 44641 "gram.c" /* yacc.c:1646  */
    break;

  case 1793:
#line 13321 "gram.y" /* yacc.c:1646  */
    {
					RangeSubselect *n = makeNode(RangeSubselect);

					n->lateral = true;
					n->subquery = (yyvsp[-1].node);
					n->alias = (yyvsp[0].alias);
					/* same comment as above */
					if ((yyvsp[0].alias) == NULL)
					{
						if (IsA((yyvsp[-1].node), SelectStmt) &&
							((SelectStmt *) (yyvsp[-1].node))->valuesLists)
							ereport(ERROR,
									(errcode(ERRCODE_SYNTAX_ERROR),
									 errmsg("VALUES in FROM must have an alias"),
									 errhint("For example, FROM (VALUES ...) [AS] foo."),
									 parser_errposition((yylsp[-1]))));
						else
							ereport(ERROR,
									(errcode(ERRCODE_SYNTAX_ERROR),
									 errmsg("subquery in FROM must have an alias"),
									 errhint("For example, FROM (SELECT ...) [AS] foo."),
									 parser_errposition((yylsp[-1]))));
					}
					(yyval.node) = (Node *) n;
				}
#line 44671 "gram.c" /* yacc.c:1646  */
    break;

  case 1794:
#line 13347 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) (yyvsp[0].jexpr);
				}
#line 44679 "gram.c" /* yacc.c:1646  */
    break;

  case 1795:
#line 13351 "gram.y" /* yacc.c:1646  */
    {
					(yyvsp[-2].jexpr)->alias = (yyvsp[0].alias);
					(yyval.node) = (Node *) (yyvsp[-2].jexpr);
				}
#line 44688 "gram.c" /* yacc.c:1646  */
    break;

  case 1796:
#line 13377 "gram.y" /* yacc.c:1646  */
    {
					(yyval.jexpr) = (yyvsp[-1].jexpr);
				}
#line 44696 "gram.c" /* yacc.c:1646  */
    break;

  case 1797:
#line 13381 "gram.y" /* yacc.c:1646  */
    {
					/* CROSS JOIN is same as unqualified inner join */
					JoinExpr   *n = makeNode(JoinExpr);

					n->jointype = JOIN_INNER;
					n->isNatural = false;
					n->larg = (yyvsp[-3].node);
					n->rarg = (yyvsp[0].node);
					n->usingClause = NIL;
					n->join_using_alias = NULL;
					n->quals = NULL;
					(yyval.jexpr) = n;
				}
#line 44714 "gram.c" /* yacc.c:1646  */
    break;

  case 1798:
#line 13395 "gram.y" /* yacc.c:1646  */
    {
					JoinExpr   *n = makeNode(JoinExpr);

					n->jointype = (yyvsp[-3].jtype);
					n->isNatural = false;
					n->larg = (yyvsp[-4].node);
					n->rarg = (yyvsp[-1].node);
					if ((yyvsp[0].node) != NULL && IsA((yyvsp[0].node), List))
					{
						 /* USING clause */
						n->usingClause = linitial_node(List, castNode(List, (yyvsp[0].node)));
						n->join_using_alias = lsecond_node(Alias, castNode(List, (yyvsp[0].node)));
					}
					else
					{
						/* ON clause */
						n->quals = (yyvsp[0].node);
					}
					(yyval.jexpr) = n;
				}
#line 44739 "gram.c" /* yacc.c:1646  */
    break;

  case 1799:
#line 13416 "gram.y" /* yacc.c:1646  */
    {
					/* letting join_type reduce to empty doesn't work */
					JoinExpr   *n = makeNode(JoinExpr);

					n->jointype = JOIN_INNER;
					n->isNatural = false;
					n->larg = (yyvsp[-3].node);
					n->rarg = (yyvsp[-1].node);
					if ((yyvsp[0].node) != NULL && IsA((yyvsp[0].node), List))
					{
						/* USING clause */
						n->usingClause = linitial_node(List, castNode(List, (yyvsp[0].node)));
						n->join_using_alias = lsecond_node(Alias, castNode(List, (yyvsp[0].node)));
					}
					else
					{
						/* ON clause */
						n->quals = (yyvsp[0].node);
					}
					(yyval.jexpr) = n;
				}
#line 44765 "gram.c" /* yacc.c:1646  */
    break;

  case 1800:
#line 13438 "gram.y" /* yacc.c:1646  */
    {
					JoinExpr   *n = makeNode(JoinExpr);

					n->jointype = (yyvsp[-2].jtype);
					n->isNatural = true;
					n->larg = (yyvsp[-4].node);
					n->rarg = (yyvsp[0].node);
					n->usingClause = NIL; /* figure out which columns later... */
					n->join_using_alias = NULL;
					n->quals = NULL; /* fill later */
					(yyval.jexpr) = n;
				}
#line 44782 "gram.c" /* yacc.c:1646  */
    break;

  case 1801:
#line 13451 "gram.y" /* yacc.c:1646  */
    {
					/* letting join_type reduce to empty doesn't work */
					JoinExpr   *n = makeNode(JoinExpr);

					n->jointype = JOIN_INNER;
					n->isNatural = true;
					n->larg = (yyvsp[-3].node);
					n->rarg = (yyvsp[0].node);
					n->usingClause = NIL; /* figure out which columns later... */
					n->join_using_alias = NULL;
					n->quals = NULL; /* fill later */
					(yyval.jexpr) = n;
				}
#line 44800 "gram.c" /* yacc.c:1646  */
    break;

  case 1802:
#line 13468 "gram.y" /* yacc.c:1646  */
    {
					(yyval.alias) = makeNode(Alias);
					(yyval.alias)->aliasname = (yyvsp[-3].str);
					(yyval.alias)->colnames = (yyvsp[-1].list);
				}
#line 44810 "gram.c" /* yacc.c:1646  */
    break;

  case 1803:
#line 13474 "gram.y" /* yacc.c:1646  */
    {
					(yyval.alias) = makeNode(Alias);
					(yyval.alias)->aliasname = (yyvsp[0].str);
				}
#line 44819 "gram.c" /* yacc.c:1646  */
    break;

  case 1804:
#line 13479 "gram.y" /* yacc.c:1646  */
    {
					(yyval.alias) = makeNode(Alias);
					(yyval.alias)->aliasname = (yyvsp[-3].str);
					(yyval.alias)->colnames = (yyvsp[-1].list);
				}
#line 44829 "gram.c" /* yacc.c:1646  */
    break;

  case 1805:
#line 13485 "gram.y" /* yacc.c:1646  */
    {
					(yyval.alias) = makeNode(Alias);
					(yyval.alias)->aliasname = (yyvsp[0].str);
				}
#line 44838 "gram.c" /* yacc.c:1646  */
    break;

  case 1806:
#line 13491 "gram.y" /* yacc.c:1646  */
    { (yyval.alias) = (yyvsp[0].alias); }
#line 44844 "gram.c" /* yacc.c:1646  */
    break;

  case 1807:
#line 13492 "gram.y" /* yacc.c:1646  */
    { (yyval.alias) = NULL; }
#line 44850 "gram.c" /* yacc.c:1646  */
    break;

  case 1808:
#line 13503 "gram.y" /* yacc.c:1646  */
    {
					(yyval.alias) = makeNode(Alias);
					(yyval.alias)->aliasname = (yyvsp[0].str);
					/* the column name list will be inserted later */
				}
#line 44860 "gram.c" /* yacc.c:1646  */
    break;

  case 1809:
#line 13508 "gram.y" /* yacc.c:1646  */
    { (yyval.alias) = NULL; }
#line 44866 "gram.c" /* yacc.c:1646  */
    break;

  case 1810:
#line 13517 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make2((yyvsp[0].alias), NIL);
				}
#line 44874 "gram.c" /* yacc.c:1646  */
    break;

  case 1811:
#line 13521 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make2(NULL, (yyvsp[-1].list));
				}
#line 44882 "gram.c" /* yacc.c:1646  */
    break;

  case 1812:
#line 13525 "gram.y" /* yacc.c:1646  */
    {
					Alias	   *a = makeNode(Alias);

					a->aliasname = (yyvsp[-3].str);
					(yyval.list) = list_make2(a, (yyvsp[-1].list));
				}
#line 44893 "gram.c" /* yacc.c:1646  */
    break;

  case 1813:
#line 13532 "gram.y" /* yacc.c:1646  */
    {
					Alias	   *a = makeNode(Alias);

					a->aliasname = (yyvsp[-3].str);
					(yyval.list) = list_make2(a, (yyvsp[-1].list));
				}
#line 44904 "gram.c" /* yacc.c:1646  */
    break;

  case 1814:
#line 13539 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make2(NULL, NIL);
				}
#line 44912 "gram.c" /* yacc.c:1646  */
    break;

  case 1815:
#line 13544 "gram.y" /* yacc.c:1646  */
    { (yyval.jtype) = JOIN_FULL; }
#line 44918 "gram.c" /* yacc.c:1646  */
    break;

  case 1816:
#line 13545 "gram.y" /* yacc.c:1646  */
    { (yyval.jtype) = JOIN_LEFT; }
#line 44924 "gram.c" /* yacc.c:1646  */
    break;

  case 1817:
#line 13546 "gram.y" /* yacc.c:1646  */
    { (yyval.jtype) = JOIN_RIGHT; }
#line 44930 "gram.c" /* yacc.c:1646  */
    break;

  case 1818:
#line 13547 "gram.y" /* yacc.c:1646  */
    { (yyval.jtype) = JOIN_INNER; }
#line 44936 "gram.c" /* yacc.c:1646  */
    break;

  case 1821:
#line 13568 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) list_make2((yyvsp[-2].list), (yyvsp[0].alias));
				}
#line 44944 "gram.c" /* yacc.c:1646  */
    break;

  case 1822:
#line 13572 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (yyvsp[0].node);
				}
#line 44952 "gram.c" /* yacc.c:1646  */
    break;

  case 1823:
#line 13580 "gram.y" /* yacc.c:1646  */
    {
					/* inheritance query, implicitly */
					(yyval.range) = (yyvsp[0].range);
					(yyval.range)->inh = true;
					(yyval.range)->alias = NULL;
				}
#line 44963 "gram.c" /* yacc.c:1646  */
    break;

  case 1824:
#line 13587 "gram.y" /* yacc.c:1646  */
    {
					(yyval.range) = (yyvsp[0].range);
				}
#line 44971 "gram.c" /* yacc.c:1646  */
    break;

  case 1825:
#line 13594 "gram.y" /* yacc.c:1646  */
    {
					/* inheritance query, explicitly */
					(yyval.range) = (yyvsp[-1].range);
					(yyval.range)->inh = true;
					(yyval.range)->alias = NULL;
				}
#line 44982 "gram.c" /* yacc.c:1646  */
    break;

  case 1826:
#line 13601 "gram.y" /* yacc.c:1646  */
    {
					/* no inheritance */
					(yyval.range) = (yyvsp[0].range);
					(yyval.range)->inh = false;
					(yyval.range)->alias = NULL;
				}
#line 44993 "gram.c" /* yacc.c:1646  */
    break;

  case 1827:
#line 13608 "gram.y" /* yacc.c:1646  */
    {
					/* no inheritance, SQL99-style syntax */
					(yyval.range) = (yyvsp[-1].range);
					(yyval.range)->inh = false;
					(yyval.range)->alias = NULL;
				}
#line 45004 "gram.c" /* yacc.c:1646  */
    break;

  case 1828:
#line 13618 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].range)); }
#line 45010 "gram.c" /* yacc.c:1646  */
    break;

  case 1829:
#line 13619 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].range)); }
#line 45016 "gram.c" /* yacc.c:1646  */
    break;

  case 1830:
#line 13633 "gram.y" /* yacc.c:1646  */
    {
					(yyval.range) = (yyvsp[0].range);
				}
#line 45024 "gram.c" /* yacc.c:1646  */
    break;

  case 1831:
#line 13637 "gram.y" /* yacc.c:1646  */
    {
					Alias	   *alias = makeNode(Alias);

					alias->aliasname = (yyvsp[0].str);
					(yyvsp[-1].range)->alias = alias;
					(yyval.range) = (yyvsp[-1].range);
				}
#line 45036 "gram.c" /* yacc.c:1646  */
    break;

  case 1832:
#line 13645 "gram.y" /* yacc.c:1646  */
    {
					Alias	   *alias = makeNode(Alias);

					alias->aliasname = (yyvsp[0].str);
					(yyvsp[-2].range)->alias = alias;
					(yyval.range) = (yyvsp[-2].range);
				}
#line 45048 "gram.c" /* yacc.c:1646  */
    break;

  case 1833:
#line 13659 "gram.y" /* yacc.c:1646  */
    {
					RangeTableSample *n = makeNode(RangeTableSample);

					/* n->relation will be filled in later */
					n->method = (yyvsp[-4].list);
					n->args = (yyvsp[-2].list);
					n->repeatable = (yyvsp[0].node);
					n->location = (yylsp[-4]);
					(yyval.node) = (Node *) n;
				}
#line 45063 "gram.c" /* yacc.c:1646  */
    break;

  case 1834:
#line 13672 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) (yyvsp[-1].node); }
#line 45069 "gram.c" /* yacc.c:1646  */
    break;

  case 1835:
#line 13673 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 45075 "gram.c" /* yacc.c:1646  */
    break;

  case 1836:
#line 13689 "gram.y" /* yacc.c:1646  */
    {
					RangeFunction *n = makeNode(RangeFunction);

					n->lateral = false;
					n->ordinality = (yyvsp[0].boolean);
					n->is_rowsfrom = false;
					n->functions = list_make1(list_make2((yyvsp[-1].node), NIL));
					/* alias and coldeflist are set by table_ref production */
					(yyval.node) = (Node *) n;
				}
#line 45090 "gram.c" /* yacc.c:1646  */
    break;

  case 1837:
#line 13700 "gram.y" /* yacc.c:1646  */
    {
					RangeFunction *n = makeNode(RangeFunction);

					n->lateral = false;
					n->ordinality = (yyvsp[0].boolean);
					n->is_rowsfrom = true;
					n->functions = (yyvsp[-2].list);
					/* alias and coldeflist are set by table_ref production */
					(yyval.node) = (Node *) n;
				}
#line 45105 "gram.c" /* yacc.c:1646  */
    break;

  case 1838:
#line 13713 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make2((yyvsp[-1].node), (yyvsp[0].list)); }
#line 45111 "gram.c" /* yacc.c:1646  */
    break;

  case 1839:
#line 13717 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].list)); }
#line 45117 "gram.c" /* yacc.c:1646  */
    break;

  case 1840:
#line 13718 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].list)); }
#line 45123 "gram.c" /* yacc.c:1646  */
    break;

  case 1841:
#line 13721 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 45129 "gram.c" /* yacc.c:1646  */
    break;

  case 1842:
#line 13722 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 45135 "gram.c" /* yacc.c:1646  */
    break;

  case 1843:
#line 13725 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 45141 "gram.c" /* yacc.c:1646  */
    break;

  case 1844:
#line 13726 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 45147 "gram.c" /* yacc.c:1646  */
    break;

  case 1845:
#line 13731 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 45153 "gram.c" /* yacc.c:1646  */
    break;

  case 1846:
#line 13732 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 45159 "gram.c" /* yacc.c:1646  */
    break;

  case 1847:
#line 13737 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 45165 "gram.c" /* yacc.c:1646  */
    break;

  case 1848:
#line 13739 "gram.y" /* yacc.c:1646  */
    {
					CurrentOfExpr *n = makeNode(CurrentOfExpr);

					/* cvarno is filled in by parse analysis */
					n->cursor_name = (yyvsp[0].str);
					n->cursor_param = 0;
					(yyval.node) = (Node *) n;
				}
#line 45178 "gram.c" /* yacc.c:1646  */
    break;

  case 1849:
#line 13747 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 45184 "gram.c" /* yacc.c:1646  */
    break;

  case 1850:
#line 13752 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 45190 "gram.c" /* yacc.c:1646  */
    break;

  case 1851:
#line 13753 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 45196 "gram.c" /* yacc.c:1646  */
    break;

  case 1852:
#line 13758 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make1((yyvsp[0].node));
				}
#line 45204 "gram.c" /* yacc.c:1646  */
    break;

  case 1853:
#line 13762 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node));
				}
#line 45212 "gram.c" /* yacc.c:1646  */
    break;

  case 1854:
#line 13768 "gram.y" /* yacc.c:1646  */
    {
					ColumnDef *n = makeNode(ColumnDef);

					n->colname = (yyvsp[-2].str);
					n->typeName = (yyvsp[-1].typnam);
					n->inhcount = 0;
					n->is_local = true;
					n->is_not_null = false;
					n->is_from_type = false;
					n->storage = 0;
					n->raw_default = NULL;
					n->cooked_default = NULL;
					n->collClause = (CollateClause *) (yyvsp[0].node);
					n->collOid = InvalidOid;
					n->constraints = NIL;
					n->location = (yylsp[-2]);
					(yyval.node) = (Node *) n;
				}
#line 45235 "gram.c" /* yacc.c:1646  */
    break;

  case 1855:
#line 13793 "gram.y" /* yacc.c:1646  */
    {
					RangeTableFunc *n = makeNode(RangeTableFunc);

					n->rowexpr = (yyvsp[-4].node);
					n->docexpr = (yyvsp[-3].node);
					n->columns = (yyvsp[-1].list);
					n->namespaces = NIL;
					n->location = (yylsp[-6]);
					(yyval.node) = (Node *) n;
				}
#line 45250 "gram.c" /* yacc.c:1646  */
    break;

  case 1856:
#line 13805 "gram.y" /* yacc.c:1646  */
    {
					RangeTableFunc *n = makeNode(RangeTableFunc);

					n->rowexpr = (yyvsp[-4].node);
					n->docexpr = (yyvsp[-3].node);
					n->columns = (yyvsp[-1].list);
					n->namespaces = (yyvsp[-7].list);
					n->location = (yylsp[-11]);
					(yyval.node) = (Node *) n;
				}
#line 45265 "gram.c" /* yacc.c:1646  */
    break;

  case 1857:
#line 13817 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 45271 "gram.c" /* yacc.c:1646  */
    break;

  case 1858:
#line 13818 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node)); }
#line 45277 "gram.c" /* yacc.c:1646  */
    break;

  case 1859:
#line 13823 "gram.y" /* yacc.c:1646  */
    {
					RangeTableFuncCol *fc = makeNode(RangeTableFuncCol);

					fc->colname = (yyvsp[-1].str);
					fc->for_ordinality = false;
					fc->typeName = (yyvsp[0].typnam);
					fc->is_not_null = false;
					fc->colexpr = NULL;
					fc->coldefexpr = NULL;
					fc->location = (yylsp[-1]);

					(yyval.node) = (Node *) fc;
				}
#line 45295 "gram.c" /* yacc.c:1646  */
    break;

  case 1860:
#line 13837 "gram.y" /* yacc.c:1646  */
    {
					RangeTableFuncCol *fc = makeNode(RangeTableFuncCol);
					ListCell   *option;
					bool		nullability_seen = false;

					fc->colname = (yyvsp[-2].str);
					fc->typeName = (yyvsp[-1].typnam);
					fc->for_ordinality = false;
					fc->is_not_null = false;
					fc->colexpr = NULL;
					fc->coldefexpr = NULL;
					fc->location = (yylsp[-2]);

					foreach(option, (yyvsp[0].list))
					{
						DefElem   *defel = (DefElem *) lfirst(option);

						if (strcmp(defel->defname, "default") == 0)
						{
							if (fc->coldefexpr != NULL)
								ereport(ERROR,
										(errcode(ERRCODE_SYNTAX_ERROR),
										 errmsg("only one DEFAULT value is allowed"),
										 parser_errposition(defel->location)));
							fc->coldefexpr = defel->arg;
						}
						else if (strcmp(defel->defname, "path") == 0)
						{
							if (fc->colexpr != NULL)
								ereport(ERROR,
										(errcode(ERRCODE_SYNTAX_ERROR),
										 errmsg("only one PATH value per column is allowed"),
										 parser_errposition(defel->location)));
							fc->colexpr = defel->arg;
						}
						else if (strcmp(defel->defname, "is_not_null") == 0)
						{
							if (nullability_seen)
								ereport(ERROR,
										(errcode(ERRCODE_SYNTAX_ERROR),
										 errmsg("conflicting or redundant NULL / NOT NULL declarations for column \"%s\"", fc->colname),
										 parser_errposition(defel->location)));
							fc->is_not_null = boolVal(defel->arg);
							nullability_seen = true;
						}
						else
						{
							ereport(ERROR,
									(errcode(ERRCODE_SYNTAX_ERROR),
									 errmsg("unrecognized column option \"%s\"",
											defel->defname),
									 parser_errposition(defel->location)));
						}
					}
					(yyval.node) = (Node *) fc;
				}
#line 45356 "gram.c" /* yacc.c:1646  */
    break;

  case 1861:
#line 13894 "gram.y" /* yacc.c:1646  */
    {
					RangeTableFuncCol *fc = makeNode(RangeTableFuncCol);

					fc->colname = (yyvsp[-2].str);
					fc->for_ordinality = true;
					/* other fields are ignored, initialized by makeNode */
					fc->location = (yylsp[-2]);

					(yyval.node) = (Node *) fc;
				}
#line 45371 "gram.c" /* yacc.c:1646  */
    break;

  case 1862:
#line 13908 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].defelt)); }
#line 45377 "gram.c" /* yacc.c:1646  */
    break;

  case 1863:
#line 13910 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].defelt)); }
#line 45383 "gram.c" /* yacc.c:1646  */
    break;

  case 1864:
#line 13915 "gram.y" /* yacc.c:1646  */
    { (yyval.defelt) = makeDefElem((yyvsp[-1].str), (yyvsp[0].node), (yylsp[-1])); }
#line 45389 "gram.c" /* yacc.c:1646  */
    break;

  case 1865:
#line 13917 "gram.y" /* yacc.c:1646  */
    { (yyval.defelt) = makeDefElem("default", (yyvsp[0].node), (yylsp[-1])); }
#line 45395 "gram.c" /* yacc.c:1646  */
    break;

  case 1866:
#line 13919 "gram.y" /* yacc.c:1646  */
    { (yyval.defelt) = makeDefElem("is_not_null", (Node *) makeBoolean(true), (yylsp[-1])); }
#line 45401 "gram.c" /* yacc.c:1646  */
    break;

  case 1867:
#line 13921 "gram.y" /* yacc.c:1646  */
    { (yyval.defelt) = makeDefElem("is_not_null", (Node *) makeBoolean(false), (yylsp[0])); }
#line 45407 "gram.c" /* yacc.c:1646  */
    break;

  case 1868:
#line 13926 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].target)); }
#line 45413 "gram.c" /* yacc.c:1646  */
    break;

  case 1869:
#line 13928 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].target)); }
#line 45419 "gram.c" /* yacc.c:1646  */
    break;

  case 1870:
#line 13933 "gram.y" /* yacc.c:1646  */
    {
					(yyval.target) = makeNode(ResTarget);
					(yyval.target)->name = (yyvsp[0].str);
					(yyval.target)->indirection = NIL;
					(yyval.target)->val = (yyvsp[-2].node);
					(yyval.target)->location = (yylsp[-2]);
				}
#line 45431 "gram.c" /* yacc.c:1646  */
    break;

  case 1871:
#line 13941 "gram.y" /* yacc.c:1646  */
    {
					(yyval.target) = makeNode(ResTarget);
					(yyval.target)->name = NULL;
					(yyval.target)->indirection = NIL;
					(yyval.target)->val = (yyvsp[0].node);
					(yyval.target)->location = (yylsp[-1]);
				}
#line 45443 "gram.c" /* yacc.c:1646  */
    break;

  case 1872:
#line 13961 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = (yyvsp[-1].typnam);
					(yyval.typnam)->arrayBounds = (yyvsp[0].list);
				}
#line 45452 "gram.c" /* yacc.c:1646  */
    break;

  case 1873:
#line 13966 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = (yyvsp[-1].typnam);
					(yyval.typnam)->arrayBounds = (yyvsp[0].list);
					(yyval.typnam)->setof = true;
				}
#line 45462 "gram.c" /* yacc.c:1646  */
    break;

  case 1874:
#line 13973 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = (yyvsp[-4].typnam);
					(yyval.typnam)->arrayBounds = list_make1(makeInteger((yyvsp[-1].ival)));
				}
#line 45471 "gram.c" /* yacc.c:1646  */
    break;

  case 1875:
#line 13978 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = (yyvsp[-4].typnam);
					(yyval.typnam)->arrayBounds = list_make1(makeInteger((yyvsp[-1].ival)));
					(yyval.typnam)->setof = true;
				}
#line 45481 "gram.c" /* yacc.c:1646  */
    break;

  case 1876:
#line 13984 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = (yyvsp[-1].typnam);
					(yyval.typnam)->arrayBounds = list_make1(makeInteger(-1));
				}
#line 45490 "gram.c" /* yacc.c:1646  */
    break;

  case 1877:
#line 13989 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = (yyvsp[-1].typnam);
					(yyval.typnam)->arrayBounds = list_make1(makeInteger(-1));
					(yyval.typnam)->setof = true;
				}
#line 45500 "gram.c" /* yacc.c:1646  */
    break;

  case 1878:
#line 13998 "gram.y" /* yacc.c:1646  */
    {  (yyval.list) = lappend((yyvsp[-2].list), makeInteger(-1)); }
#line 45506 "gram.c" /* yacc.c:1646  */
    break;

  case 1879:
#line 14000 "gram.y" /* yacc.c:1646  */
    {  (yyval.list) = lappend((yyvsp[-3].list), makeInteger((yyvsp[-1].ival))); }
#line 45512 "gram.c" /* yacc.c:1646  */
    break;

  case 1880:
#line 14002 "gram.y" /* yacc.c:1646  */
    {  (yyval.list) = NIL; }
#line 45518 "gram.c" /* yacc.c:1646  */
    break;

  case 1881:
#line 14006 "gram.y" /* yacc.c:1646  */
    { (yyval.typnam) = (yyvsp[0].typnam); }
#line 45524 "gram.c" /* yacc.c:1646  */
    break;

  case 1882:
#line 14007 "gram.y" /* yacc.c:1646  */
    { (yyval.typnam) = (yyvsp[0].typnam); }
#line 45530 "gram.c" /* yacc.c:1646  */
    break;

  case 1883:
#line 14008 "gram.y" /* yacc.c:1646  */
    { (yyval.typnam) = (yyvsp[0].typnam); }
#line 45536 "gram.c" /* yacc.c:1646  */
    break;

  case 1884:
#line 14009 "gram.y" /* yacc.c:1646  */
    { (yyval.typnam) = (yyvsp[0].typnam); }
#line 45542 "gram.c" /* yacc.c:1646  */
    break;

  case 1885:
#line 14010 "gram.y" /* yacc.c:1646  */
    { (yyval.typnam) = (yyvsp[0].typnam); }
#line 45548 "gram.c" /* yacc.c:1646  */
    break;

  case 1886:
#line 14012 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = (yyvsp[-1].typnam);
					(yyval.typnam)->typmods = (yyvsp[0].list);
				}
#line 45557 "gram.c" /* yacc.c:1646  */
    break;

  case 1887:
#line 14017 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = (yyvsp[-3].typnam);
					(yyval.typnam)->typmods = list_make2(makeIntConst(INTERVAL_FULL_RANGE, -1),
											 makeIntConst((yyvsp[-1].ival), (yylsp[-1])));
				}
#line 45567 "gram.c" /* yacc.c:1646  */
    break;

  case 1888:
#line 14036 "gram.y" /* yacc.c:1646  */
    { (yyval.typnam) = (yyvsp[0].typnam); }
#line 45573 "gram.c" /* yacc.c:1646  */
    break;

  case 1889:
#line 14037 "gram.y" /* yacc.c:1646  */
    { (yyval.typnam) = (yyvsp[0].typnam); }
#line 45579 "gram.c" /* yacc.c:1646  */
    break;

  case 1890:
#line 14038 "gram.y" /* yacc.c:1646  */
    { (yyval.typnam) = (yyvsp[0].typnam); }
#line 45585 "gram.c" /* yacc.c:1646  */
    break;

  case 1891:
#line 14039 "gram.y" /* yacc.c:1646  */
    { (yyval.typnam) = (yyvsp[0].typnam); }
#line 45591 "gram.c" /* yacc.c:1646  */
    break;

  case 1892:
#line 14051 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = makeTypeName((yyvsp[-1].str));
					(yyval.typnam)->typmods = (yyvsp[0].list);
					(yyval.typnam)->location = (yylsp[-1]);
				}
#line 45601 "gram.c" /* yacc.c:1646  */
    break;

  case 1893:
#line 14057 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = makeTypeNameFromNameList(lcons(makeString((yyvsp[-2].str)), (yyvsp[-1].list)));
					(yyval.typnam)->typmods = (yyvsp[0].list);
					(yyval.typnam)->location = (yylsp[-2]);
				}
#line 45611 "gram.c" /* yacc.c:1646  */
    break;

  case 1894:
#line 14064 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 45617 "gram.c" /* yacc.c:1646  */
    break;

  case 1895:
#line 14065 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 45623 "gram.c" /* yacc.c:1646  */
    break;

  case 1896:
#line 14072 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = SystemTypeName("int4");
					(yyval.typnam)->location = (yylsp[0]);
				}
#line 45632 "gram.c" /* yacc.c:1646  */
    break;

  case 1897:
#line 14077 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = SystemTypeName("int4");
					(yyval.typnam)->location = (yylsp[0]);
				}
#line 45641 "gram.c" /* yacc.c:1646  */
    break;

  case 1898:
#line 14082 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = SystemTypeName("int2");
					(yyval.typnam)->location = (yylsp[0]);
				}
#line 45650 "gram.c" /* yacc.c:1646  */
    break;

  case 1899:
#line 14087 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = SystemTypeName("int8");
					(yyval.typnam)->location = (yylsp[0]);
				}
#line 45659 "gram.c" /* yacc.c:1646  */
    break;

  case 1900:
#line 14092 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = SystemTypeName("float4");
					(yyval.typnam)->location = (yylsp[0]);
				}
#line 45668 "gram.c" /* yacc.c:1646  */
    break;

  case 1901:
#line 14097 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = (yyvsp[0].typnam);
					(yyval.typnam)->location = (yylsp[-1]);
				}
#line 45677 "gram.c" /* yacc.c:1646  */
    break;

  case 1902:
#line 14102 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = SystemTypeName("float8");
					(yyval.typnam)->location = (yylsp[-1]);
				}
#line 45686 "gram.c" /* yacc.c:1646  */
    break;

  case 1903:
#line 14107 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = SystemTypeName("numeric");
					(yyval.typnam)->typmods = (yyvsp[0].list);
					(yyval.typnam)->location = (yylsp[-1]);
				}
#line 45696 "gram.c" /* yacc.c:1646  */
    break;

  case 1904:
#line 14113 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = SystemTypeName("numeric");
					(yyval.typnam)->typmods = (yyvsp[0].list);
					(yyval.typnam)->location = (yylsp[-1]);
				}
#line 45706 "gram.c" /* yacc.c:1646  */
    break;

  case 1905:
#line 14119 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = SystemTypeName("numeric");
					(yyval.typnam)->typmods = (yyvsp[0].list);
					(yyval.typnam)->location = (yylsp[-1]);
				}
#line 45716 "gram.c" /* yacc.c:1646  */
    break;

  case 1906:
#line 14125 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = SystemTypeName("bool");
					(yyval.typnam)->location = (yylsp[0]);
				}
#line 45725 "gram.c" /* yacc.c:1646  */
    break;

  case 1907:
#line 14132 "gram.y" /* yacc.c:1646  */
    {
					/*
					 * Check FLOAT() precision limits assuming IEEE floating
					 * types - thomas 1997-09-18
					 */
					if ((yyvsp[-1].ival) < 1)
						ereport(ERROR,
								(errcode(ERRCODE_INVALID_PARAMETER_VALUE),
								 errmsg("precision for type float must be at least 1 bit"),
								 parser_errposition((yylsp[-1]))));
					else if ((yyvsp[-1].ival) <= 24)
						(yyval.typnam) = SystemTypeName("float4");
					else if ((yyvsp[-1].ival) <= 53)
						(yyval.typnam) = SystemTypeName("float8");
					else
						ereport(ERROR,
								(errcode(ERRCODE_INVALID_PARAMETER_VALUE),
								 errmsg("precision for type float must be less than 54 bits"),
								 parser_errposition((yylsp[-1]))));
				}
#line 45750 "gram.c" /* yacc.c:1646  */
    break;

  case 1908:
#line 14153 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = SystemTypeName("float8");
				}
#line 45758 "gram.c" /* yacc.c:1646  */
    break;

  case 1909:
#line 14163 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = (yyvsp[0].typnam);
				}
#line 45766 "gram.c" /* yacc.c:1646  */
    break;

  case 1910:
#line 14167 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = (yyvsp[0].typnam);
				}
#line 45774 "gram.c" /* yacc.c:1646  */
    break;

  case 1911:
#line 14175 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = (yyvsp[0].typnam);
				}
#line 45782 "gram.c" /* yacc.c:1646  */
    break;

  case 1912:
#line 14179 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = (yyvsp[0].typnam);
					(yyval.typnam)->typmods = NIL;
				}
#line 45791 "gram.c" /* yacc.c:1646  */
    break;

  case 1913:
#line 14187 "gram.y" /* yacc.c:1646  */
    {
					char *typname;

					typname = (yyvsp[-3].boolean) ? "varbit" : "bit";
					(yyval.typnam) = SystemTypeName(typname);
					(yyval.typnam)->typmods = (yyvsp[-1].list);
					(yyval.typnam)->location = (yylsp[-4]);
				}
#line 45804 "gram.c" /* yacc.c:1646  */
    break;

  case 1914:
#line 14199 "gram.y" /* yacc.c:1646  */
    {
					/* bit defaults to bit(1), varbit to no limit */
					if ((yyvsp[0].boolean))
					{
						(yyval.typnam) = SystemTypeName("varbit");
					}
					else
					{
						(yyval.typnam) = SystemTypeName("bit");
						(yyval.typnam)->typmods = list_make1(makeIntConst(1, -1));
					}
					(yyval.typnam)->location = (yylsp[-1]);
				}
#line 45822 "gram.c" /* yacc.c:1646  */
    break;

  case 1915:
#line 14220 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = (yyvsp[0].typnam);
				}
#line 45830 "gram.c" /* yacc.c:1646  */
    break;

  case 1916:
#line 14224 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = (yyvsp[0].typnam);
				}
#line 45838 "gram.c" /* yacc.c:1646  */
    break;

  case 1917:
#line 14230 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = (yyvsp[0].typnam);
				}
#line 45846 "gram.c" /* yacc.c:1646  */
    break;

  case 1918:
#line 14234 "gram.y" /* yacc.c:1646  */
    {
					/* Length was not specified so allow to be unrestricted.
					 * This handles problems with fixed-length (bpchar) strings
					 * which in column definitions must default to a length
					 * of one, but should not be constrained if the length
					 * was not specified.
					 */
					(yyval.typnam) = (yyvsp[0].typnam);
					(yyval.typnam)->typmods = NIL;
				}
#line 45861 "gram.c" /* yacc.c:1646  */
    break;

  case 1919:
#line 14247 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = SystemTypeName((yyvsp[-3].str));
					(yyval.typnam)->typmods = list_make1(makeIntConst((yyvsp[-1].ival), (yylsp[-1])));
					(yyval.typnam)->location = (yylsp[-3]);
				}
#line 45871 "gram.c" /* yacc.c:1646  */
    break;

  case 1920:
#line 14255 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = SystemTypeName((yyvsp[0].str));
					/* char defaults to char(1), varchar to no limit */
					if (strcmp((yyvsp[0].str), "bpchar") == 0)
						(yyval.typnam)->typmods = list_make1(makeIntConst(1, -1));
					(yyval.typnam)->location = (yylsp[0]);
				}
#line 45883 "gram.c" /* yacc.c:1646  */
    break;

  case 1921:
#line 14265 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].boolean) ? "varchar": "bpchar"; }
#line 45889 "gram.c" /* yacc.c:1646  */
    break;

  case 1922:
#line 14267 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].boolean) ? "varchar": "bpchar"; }
#line 45895 "gram.c" /* yacc.c:1646  */
    break;

  case 1923:
#line 14269 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "varchar"; }
#line 45901 "gram.c" /* yacc.c:1646  */
    break;

  case 1924:
#line 14271 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].boolean) ? "varchar": "bpchar"; }
#line 45907 "gram.c" /* yacc.c:1646  */
    break;

  case 1925:
#line 14273 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].boolean) ? "varchar": "bpchar"; }
#line 45913 "gram.c" /* yacc.c:1646  */
    break;

  case 1926:
#line 14275 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].boolean) ? "varchar": "bpchar"; }
#line 45919 "gram.c" /* yacc.c:1646  */
    break;

  case 1927:
#line 14279 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 45925 "gram.c" /* yacc.c:1646  */
    break;

  case 1928:
#line 14280 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 45931 "gram.c" /* yacc.c:1646  */
    break;

  case 1929:
#line 14288 "gram.y" /* yacc.c:1646  */
    {
					if ((yyvsp[0].boolean))
						(yyval.typnam) = SystemTypeName("timestamptz");
					else
						(yyval.typnam) = SystemTypeName("timestamp");
					(yyval.typnam)->typmods = list_make1(makeIntConst((yyvsp[-2].ival), (yylsp[-2])));
					(yyval.typnam)->location = (yylsp[-4]);
				}
#line 45944 "gram.c" /* yacc.c:1646  */
    break;

  case 1930:
#line 14297 "gram.y" /* yacc.c:1646  */
    {
					if ((yyvsp[0].boolean))
						(yyval.typnam) = SystemTypeName("timestamptz");
					else
						(yyval.typnam) = SystemTypeName("timestamp");
					(yyval.typnam)->location = (yylsp[-1]);
				}
#line 45956 "gram.c" /* yacc.c:1646  */
    break;

  case 1931:
#line 14305 "gram.y" /* yacc.c:1646  */
    {
					if ((yyvsp[0].boolean))
						(yyval.typnam) = SystemTypeName("timetz");
					else
						(yyval.typnam) = SystemTypeName("time");
					(yyval.typnam)->typmods = list_make1(makeIntConst((yyvsp[-2].ival), (yylsp[-2])));
					(yyval.typnam)->location = (yylsp[-4]);
				}
#line 45969 "gram.c" /* yacc.c:1646  */
    break;

  case 1932:
#line 14314 "gram.y" /* yacc.c:1646  */
    {
					if ((yyvsp[0].boolean))
						(yyval.typnam) = SystemTypeName("timetz");
					else
						(yyval.typnam) = SystemTypeName("time");
					(yyval.typnam)->location = (yylsp[-1]);
				}
#line 45981 "gram.c" /* yacc.c:1646  */
    break;

  case 1933:
#line 14325 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = SystemTypeName("interval");
					(yyval.typnam)->location = (yylsp[0]);
				}
#line 45990 "gram.c" /* yacc.c:1646  */
    break;

  case 1934:
#line 14332 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 45996 "gram.c" /* yacc.c:1646  */
    break;

  case 1935:
#line 14333 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 46002 "gram.c" /* yacc.c:1646  */
    break;

  case 1936:
#line 14334 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 46008 "gram.c" /* yacc.c:1646  */
    break;

  case 1937:
#line 14339 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeIntConst(INTERVAL_MASK(YEAR), (yylsp[0]))); }
#line 46014 "gram.c" /* yacc.c:1646  */
    break;

  case 1938:
#line 14341 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeIntConst(INTERVAL_MASK(MONTH), (yylsp[0]))); }
#line 46020 "gram.c" /* yacc.c:1646  */
    break;

  case 1939:
#line 14343 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeIntConst(INTERVAL_MASK(DAY), (yylsp[0]))); }
#line 46026 "gram.c" /* yacc.c:1646  */
    break;

  case 1940:
#line 14345 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeIntConst(INTERVAL_MASK(HOUR), (yylsp[0]))); }
#line 46032 "gram.c" /* yacc.c:1646  */
    break;

  case 1941:
#line 14347 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeIntConst(INTERVAL_MASK(MINUTE), (yylsp[0]))); }
#line 46038 "gram.c" /* yacc.c:1646  */
    break;

  case 1942:
#line 14349 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 46044 "gram.c" /* yacc.c:1646  */
    break;

  case 1943:
#line 14351 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make1(makeIntConst(INTERVAL_MASK(YEAR) |
												 INTERVAL_MASK(MONTH), (yylsp[-2])));
				}
#line 46053 "gram.c" /* yacc.c:1646  */
    break;

  case 1944:
#line 14356 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make1(makeIntConst(INTERVAL_MASK(DAY) |
												 INTERVAL_MASK(HOUR), (yylsp[-2])));
				}
#line 46062 "gram.c" /* yacc.c:1646  */
    break;

  case 1945:
#line 14361 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make1(makeIntConst(INTERVAL_MASK(DAY) |
												 INTERVAL_MASK(HOUR) |
												 INTERVAL_MASK(MINUTE), (yylsp[-2])));
				}
#line 46072 "gram.c" /* yacc.c:1646  */
    break;

  case 1946:
#line 14367 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = (yyvsp[0].list);
					linitial((yyval.list)) = makeIntConst(INTERVAL_MASK(DAY) |
												INTERVAL_MASK(HOUR) |
												INTERVAL_MASK(MINUTE) |
												INTERVAL_MASK(SECOND), (yylsp[-2]));
				}
#line 46084 "gram.c" /* yacc.c:1646  */
    break;

  case 1947:
#line 14375 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make1(makeIntConst(INTERVAL_MASK(HOUR) |
												 INTERVAL_MASK(MINUTE), (yylsp[-2])));
				}
#line 46093 "gram.c" /* yacc.c:1646  */
    break;

  case 1948:
#line 14380 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = (yyvsp[0].list);
					linitial((yyval.list)) = makeIntConst(INTERVAL_MASK(HOUR) |
												INTERVAL_MASK(MINUTE) |
												INTERVAL_MASK(SECOND), (yylsp[-2]));
				}
#line 46104 "gram.c" /* yacc.c:1646  */
    break;

  case 1949:
#line 14387 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = (yyvsp[0].list);
					linitial((yyval.list)) = makeIntConst(INTERVAL_MASK(MINUTE) |
												INTERVAL_MASK(SECOND), (yylsp[-2]));
				}
#line 46114 "gram.c" /* yacc.c:1646  */
    break;

  case 1950:
#line 14393 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 46120 "gram.c" /* yacc.c:1646  */
    break;

  case 1951:
#line 14398 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make1(makeIntConst(INTERVAL_MASK(SECOND), (yylsp[0])));
				}
#line 46128 "gram.c" /* yacc.c:1646  */
    break;

  case 1952:
#line 14402 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make2(makeIntConst(INTERVAL_MASK(SECOND), (yylsp[-3])),
									makeIntConst((yyvsp[-1].ival), (yylsp[-1])));
				}
#line 46137 "gram.c" /* yacc.c:1646  */
    break;

  case 1953:
#line 14437 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 46143 "gram.c" /* yacc.c:1646  */
    break;

  case 1954:
#line 14439 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = makeTypeCast((yyvsp[-2].node), (yyvsp[0].typnam), (yylsp[-1])); }
#line 46149 "gram.c" /* yacc.c:1646  */
    break;

  case 1955:
#line 14441 "gram.y" /* yacc.c:1646  */
    {
					CollateClause *n = makeNode(CollateClause);

					n->arg = (yyvsp[-2].node);
					n->collname = (yyvsp[0].list);
					n->location = (yylsp[-1]);
					(yyval.node) = (Node *) n;
				}
#line 46162 "gram.c" /* yacc.c:1646  */
    break;

  case 1956:
#line 14450 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("timezone"),
											   list_make2((yyvsp[0].node), (yyvsp[-4].node)),
											   COERCE_SQL_SYNTAX,
											   (yylsp[-3]));
				}
#line 46173 "gram.c" /* yacc.c:1646  */
    break;

  case 1957:
#line 14466 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "+", NULL, (yyvsp[0].node), (yylsp[-1])); }
#line 46179 "gram.c" /* yacc.c:1646  */
    break;

  case 1958:
#line 14468 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = doNegate((yyvsp[0].node), (yylsp[-1])); }
#line 46185 "gram.c" /* yacc.c:1646  */
    break;

  case 1959:
#line 14470 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "+", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 46191 "gram.c" /* yacc.c:1646  */
    break;

  case 1960:
#line 14472 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "-", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 46197 "gram.c" /* yacc.c:1646  */
    break;

  case 1961:
#line 14474 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "*", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 46203 "gram.c" /* yacc.c:1646  */
    break;

  case 1962:
#line 14476 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "/", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 46209 "gram.c" /* yacc.c:1646  */
    break;

  case 1963:
#line 14478 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "%", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 46215 "gram.c" /* yacc.c:1646  */
    break;

  case 1964:
#line 14480 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "^", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 46221 "gram.c" /* yacc.c:1646  */
    break;

  case 1965:
#line 14482 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "<", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 46227 "gram.c" /* yacc.c:1646  */
    break;

  case 1966:
#line 14484 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, ">", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 46233 "gram.c" /* yacc.c:1646  */
    break;

  case 1967:
#line 14486 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "=", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 46239 "gram.c" /* yacc.c:1646  */
    break;

  case 1968:
#line 14488 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "<=", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 46245 "gram.c" /* yacc.c:1646  */
    break;

  case 1969:
#line 14490 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, ">=", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 46251 "gram.c" /* yacc.c:1646  */
    break;

  case 1970:
#line 14492 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "<>", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 46257 "gram.c" /* yacc.c:1646  */
    break;

  case 1971:
#line 14495 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeA_Expr(AEXPR_OP, (yyvsp[-1].list), (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 46263 "gram.c" /* yacc.c:1646  */
    break;

  case 1972:
#line 14497 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeA_Expr(AEXPR_OP, (yyvsp[-1].list), NULL, (yyvsp[0].node), (yylsp[-1])); }
#line 46269 "gram.c" /* yacc.c:1646  */
    break;

  case 1973:
#line 14500 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = makeAndExpr((yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 46275 "gram.c" /* yacc.c:1646  */
    break;

  case 1974:
#line 14502 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = makeOrExpr((yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 46281 "gram.c" /* yacc.c:1646  */
    break;

  case 1975:
#line 14504 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = makeNotExpr((yyvsp[0].node), (yylsp[-1])); }
#line 46287 "gram.c" /* yacc.c:1646  */
    break;

  case 1976:
#line 14506 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = makeNotExpr((yyvsp[0].node), (yylsp[-1])); }
#line 46293 "gram.c" /* yacc.c:1646  */
    break;

  case 1977:
#line 14509 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_LIKE, "~~",
												   (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1]));
				}
#line 46302 "gram.c" /* yacc.c:1646  */
    break;

  case 1978:
#line 14514 "gram.y" /* yacc.c:1646  */
    {
					FuncCall   *n = makeFuncCall(SystemFuncName("like_escape"),
												 list_make2((yyvsp[-2].node), (yyvsp[0].node)),
												 COERCE_EXPLICIT_CALL,
												 (yylsp[-3]));
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_LIKE, "~~",
												   (yyvsp[-4].node), (Node *) n, (yylsp[-3]));
				}
#line 46315 "gram.c" /* yacc.c:1646  */
    break;

  case 1979:
#line 14523 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_LIKE, "!~~",
												   (yyvsp[-3].node), (yyvsp[0].node), (yylsp[-2]));
				}
#line 46324 "gram.c" /* yacc.c:1646  */
    break;

  case 1980:
#line 14528 "gram.y" /* yacc.c:1646  */
    {
					FuncCall   *n = makeFuncCall(SystemFuncName("like_escape"),
												 list_make2((yyvsp[-2].node), (yyvsp[0].node)),
												 COERCE_EXPLICIT_CALL,
												 (yylsp[-4]));
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_LIKE, "!~~",
												   (yyvsp[-5].node), (Node *) n, (yylsp[-4]));
				}
#line 46337 "gram.c" /* yacc.c:1646  */
    break;

  case 1981:
#line 14537 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_ILIKE, "~~*",
												   (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1]));
				}
#line 46346 "gram.c" /* yacc.c:1646  */
    break;

  case 1982:
#line 14542 "gram.y" /* yacc.c:1646  */
    {
					FuncCall   *n = makeFuncCall(SystemFuncName("like_escape"),
												 list_make2((yyvsp[-2].node), (yyvsp[0].node)),
												 COERCE_EXPLICIT_CALL,
												 (yylsp[-3]));
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_ILIKE, "~~*",
												   (yyvsp[-4].node), (Node *) n, (yylsp[-3]));
				}
#line 46359 "gram.c" /* yacc.c:1646  */
    break;

  case 1983:
#line 14551 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_ILIKE, "!~~*",
												   (yyvsp[-3].node), (yyvsp[0].node), (yylsp[-2]));
				}
#line 46368 "gram.c" /* yacc.c:1646  */
    break;

  case 1984:
#line 14556 "gram.y" /* yacc.c:1646  */
    {
					FuncCall   *n = makeFuncCall(SystemFuncName("like_escape"),
												 list_make2((yyvsp[-2].node), (yyvsp[0].node)),
												 COERCE_EXPLICIT_CALL,
												 (yylsp[-4]));
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_ILIKE, "!~~*",
												   (yyvsp[-5].node), (Node *) n, (yylsp[-4]));
				}
#line 46381 "gram.c" /* yacc.c:1646  */
    break;

  case 1985:
#line 14566 "gram.y" /* yacc.c:1646  */
    {
					FuncCall   *n = makeFuncCall(SystemFuncName("similar_to_escape"),
												 list_make1((yyvsp[0].node)),
												 COERCE_EXPLICIT_CALL,
												 (yylsp[-2]));
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_SIMILAR, "~",
												   (yyvsp[-3].node), (Node *) n, (yylsp[-2]));
				}
#line 46394 "gram.c" /* yacc.c:1646  */
    break;

  case 1986:
#line 14575 "gram.y" /* yacc.c:1646  */
    {
					FuncCall   *n = makeFuncCall(SystemFuncName("similar_to_escape"),
												 list_make2((yyvsp[-2].node), (yyvsp[0].node)),
												 COERCE_EXPLICIT_CALL,
												 (yylsp[-4]));
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_SIMILAR, "~",
												   (yyvsp[-5].node), (Node *) n, (yylsp[-4]));
				}
#line 46407 "gram.c" /* yacc.c:1646  */
    break;

  case 1987:
#line 14584 "gram.y" /* yacc.c:1646  */
    {
					FuncCall   *n = makeFuncCall(SystemFuncName("similar_to_escape"),
												 list_make1((yyvsp[0].node)),
												 COERCE_EXPLICIT_CALL,
												 (yylsp[-3]));
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_SIMILAR, "!~",
												   (yyvsp[-4].node), (Node *) n, (yylsp[-3]));
				}
#line 46420 "gram.c" /* yacc.c:1646  */
    break;

  case 1988:
#line 14593 "gram.y" /* yacc.c:1646  */
    {
					FuncCall   *n = makeFuncCall(SystemFuncName("similar_to_escape"),
												 list_make2((yyvsp[-2].node), (yyvsp[0].node)),
												 COERCE_EXPLICIT_CALL,
												 (yylsp[-5]));
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_SIMILAR, "!~",
												   (yyvsp[-6].node), (Node *) n, (yylsp[-5]));
				}
#line 46433 "gram.c" /* yacc.c:1646  */
    break;

  case 1989:
#line 14612 "gram.y" /* yacc.c:1646  */
    {
					NullTest   *n = makeNode(NullTest);

					n->arg = (Expr *) (yyvsp[-2].node);
					n->nulltesttype = IS_NULL;
					n->location = (yylsp[-1]);
					(yyval.node) = (Node *) n;
				}
#line 46446 "gram.c" /* yacc.c:1646  */
    break;

  case 1990:
#line 14621 "gram.y" /* yacc.c:1646  */
    {
					NullTest   *n = makeNode(NullTest);

					n->arg = (Expr *) (yyvsp[-1].node);
					n->nulltesttype = IS_NULL;
					n->location = (yylsp[0]);
					(yyval.node) = (Node *) n;
				}
#line 46459 "gram.c" /* yacc.c:1646  */
    break;

  case 1991:
#line 14630 "gram.y" /* yacc.c:1646  */
    {
					NullTest   *n = makeNode(NullTest);

					n->arg = (Expr *) (yyvsp[-3].node);
					n->nulltesttype = IS_NOT_NULL;
					n->location = (yylsp[-2]);
					(yyval.node) = (Node *) n;
				}
#line 46472 "gram.c" /* yacc.c:1646  */
    break;

  case 1992:
#line 14639 "gram.y" /* yacc.c:1646  */
    {
					NullTest   *n = makeNode(NullTest);

					n->arg = (Expr *) (yyvsp[-1].node);
					n->nulltesttype = IS_NOT_NULL;
					n->location = (yylsp[0]);
					(yyval.node) = (Node *) n;
				}
#line 46485 "gram.c" /* yacc.c:1646  */
    break;

  case 1993:
#line 14648 "gram.y" /* yacc.c:1646  */
    {
					if (list_length((yyvsp[-2].list)) != 2)
						ereport(ERROR,
								(errcode(ERRCODE_SYNTAX_ERROR),
								 errmsg("wrong number of parameters on left side of OVERLAPS expression"),
								 parser_errposition((yylsp[-2]))));
					if (list_length((yyvsp[0].list)) != 2)
						ereport(ERROR,
								(errcode(ERRCODE_SYNTAX_ERROR),
								 errmsg("wrong number of parameters on right side of OVERLAPS expression"),
								 parser_errposition((yylsp[0]))));
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("overlaps"),
											   list_concat((yyvsp[-2].list), (yyvsp[0].list)),
											   COERCE_SQL_SYNTAX,
											   (yylsp[-1]));
				}
#line 46506 "gram.c" /* yacc.c:1646  */
    break;

  case 1994:
#line 14665 "gram.y" /* yacc.c:1646  */
    {
					BooleanTest *b = makeNode(BooleanTest);

					b->arg = (Expr *) (yyvsp[-2].node);
					b->booltesttype = IS_TRUE;
					b->location = (yylsp[-1]);
					(yyval.node) = (Node *) b;
				}
#line 46519 "gram.c" /* yacc.c:1646  */
    break;

  case 1995:
#line 14674 "gram.y" /* yacc.c:1646  */
    {
					BooleanTest *b = makeNode(BooleanTest);

					b->arg = (Expr *) (yyvsp[-3].node);
					b->booltesttype = IS_NOT_TRUE;
					b->location = (yylsp[-2]);
					(yyval.node) = (Node *) b;
				}
#line 46532 "gram.c" /* yacc.c:1646  */
    break;

  case 1996:
#line 14683 "gram.y" /* yacc.c:1646  */
    {
					BooleanTest *b = makeNode(BooleanTest);

					b->arg = (Expr *) (yyvsp[-2].node);
					b->booltesttype = IS_FALSE;
					b->location = (yylsp[-1]);
					(yyval.node) = (Node *) b;
				}
#line 46545 "gram.c" /* yacc.c:1646  */
    break;

  case 1997:
#line 14692 "gram.y" /* yacc.c:1646  */
    {
					BooleanTest *b = makeNode(BooleanTest);

					b->arg = (Expr *) (yyvsp[-3].node);
					b->booltesttype = IS_NOT_FALSE;
					b->location = (yylsp[-2]);
					(yyval.node) = (Node *) b;
				}
#line 46558 "gram.c" /* yacc.c:1646  */
    break;

  case 1998:
#line 14701 "gram.y" /* yacc.c:1646  */
    {
					BooleanTest *b = makeNode(BooleanTest);

					b->arg = (Expr *) (yyvsp[-2].node);
					b->booltesttype = IS_UNKNOWN;
					b->location = (yylsp[-1]);
					(yyval.node) = (Node *) b;
				}
#line 46571 "gram.c" /* yacc.c:1646  */
    break;

  case 1999:
#line 14710 "gram.y" /* yacc.c:1646  */
    {
					BooleanTest *b = makeNode(BooleanTest);

					b->arg = (Expr *) (yyvsp[-3].node);
					b->booltesttype = IS_NOT_UNKNOWN;
					b->location = (yylsp[-2]);
					(yyval.node) = (Node *) b;
				}
#line 46584 "gram.c" /* yacc.c:1646  */
    break;

  case 2000:
#line 14719 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_DISTINCT, "=", (yyvsp[-4].node), (yyvsp[0].node), (yylsp[-3]));
				}
#line 46592 "gram.c" /* yacc.c:1646  */
    break;

  case 2001:
#line 14723 "gram.y" /* yacc.c:1646  */
    {
                    (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_NOT_DISTINCT, "=", (yyvsp[-5].node), (yyvsp[0].node), (yylsp[-4]));
				}
#line 46600 "gram.c" /* yacc.c:1646  */
    break;

  case 2002:
#line 14727 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_BETWEEN,
												   "BETWEEN",
												   (yyvsp[-5].node),
												   (Node *) list_make2((yyvsp[-2].node), (yyvsp[0].node)),
												   (yylsp[-4]));
				}
#line 46612 "gram.c" /* yacc.c:1646  */
    break;

  case 2003:
#line 14735 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_NOT_BETWEEN,
												   "NOT BETWEEN",
												   (yyvsp[-6].node),
												   (Node *) list_make2((yyvsp[-2].node), (yyvsp[0].node)),
												   (yylsp[-5]));
				}
#line 46624 "gram.c" /* yacc.c:1646  */
    break;

  case 2004:
#line 14743 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_BETWEEN_SYM,
												   "BETWEEN SYMMETRIC",
												   (yyvsp[-5].node),
												   (Node *) list_make2((yyvsp[-2].node), (yyvsp[0].node)),
												   (yylsp[-4]));
				}
#line 46636 "gram.c" /* yacc.c:1646  */
    break;

  case 2005:
#line 14751 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_NOT_BETWEEN_SYM,
												   "NOT BETWEEN SYMMETRIC",
												   (yyvsp[-6].node),
												   (Node *) list_make2((yyvsp[-2].node), (yyvsp[0].node)),
												   (yylsp[-5]));
				}
#line 46648 "gram.c" /* yacc.c:1646  */
    break;

  case 2006:
#line 14759 "gram.y" /* yacc.c:1646  */
    {
					/* in_expr returns a SubLink or a list of a_exprs */
					if (IsA((yyvsp[0].node), SubLink))
					{
						/* generate foo = ANY (subquery) */
						SubLink	   *n = (SubLink *) (yyvsp[0].node);

						n->subLinkType = ANY_SUBLINK;
						n->subLinkId = 0;
						n->testexpr = (yyvsp[-2].node);
						n->operName = NIL;		/* show it's IN not = ANY */
						n->location = (yylsp[-1]);
						(yyval.node) = (Node *) n;
					}
					else
					{
						/* generate scalar IN expression */
						(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_IN, "=", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1]));
					}
				}
#line 46673 "gram.c" /* yacc.c:1646  */
    break;

  case 2007:
#line 14780 "gram.y" /* yacc.c:1646  */
    {
					/* in_expr returns a SubLink or a list of a_exprs */
					if (IsA((yyvsp[0].node), SubLink))
					{
						/* generate NOT (foo = ANY (subquery)) */
						/* Make an = ANY node */
						SubLink	   *n = (SubLink *) (yyvsp[0].node);

						n->subLinkType = ANY_SUBLINK;
						n->subLinkId = 0;
						n->testexpr = (yyvsp[-3].node);
						n->operName = NIL;		/* show it's IN not = ANY */
						n->location = (yylsp[-2]);
						/* Stick a NOT on top; must have same parse location */
						(yyval.node) = makeNotExpr((Node *) n, (yylsp[-2]));
					}
					else
					{
						/* generate scalar NOT IN expression */
						(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_IN, "<>", (yyvsp[-3].node), (yyvsp[0].node), (yylsp[-2]));
					}
				}
#line 46700 "gram.c" /* yacc.c:1646  */
    break;

  case 2008:
#line 14803 "gram.y" /* yacc.c:1646  */
    {
					SubLink	   *n = makeNode(SubLink);

					n->subLinkType = (yyvsp[-1].ival);
					n->subLinkId = 0;
					n->testexpr = (yyvsp[-3].node);
					n->operName = (yyvsp[-2].list);
					n->subselect = (yyvsp[0].node);
					n->location = (yylsp[-2]);
					(yyval.node) = (Node *) n;
				}
#line 46716 "gram.c" /* yacc.c:1646  */
    break;

  case 2009:
#line 14815 "gram.y" /* yacc.c:1646  */
    {
					if ((yyvsp[-3].ival) == ANY_SUBLINK)
						(yyval.node) = (Node *) makeA_Expr(AEXPR_OP_ANY, (yyvsp[-4].list), (yyvsp[-5].node), (yyvsp[-1].node), (yylsp[-4]));
					else
						(yyval.node) = (Node *) makeA_Expr(AEXPR_OP_ALL, (yyvsp[-4].list), (yyvsp[-5].node), (yyvsp[-1].node), (yylsp[-4]));
				}
#line 46727 "gram.c" /* yacc.c:1646  */
    break;

  case 2010:
#line 14822 "gram.y" /* yacc.c:1646  */
    {
					/* Not sure how to get rid of the parentheses
					 * but there are lots of shift/reduce errors without them.
					 *
					 * Should be able to implement this by plopping the entire
					 * select into a node, then transforming the target expressions
					 * from whatever they are into count(*), and testing the
					 * entire result equal to one.
					 * But, will probably implement a separate node in the executor.
					 */
					ereport(ERROR,
							(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
							 errmsg("UNIQUE predicate is not yet implemented"),
							 parser_errposition((yylsp[-2]))));
				}
#line 46747 "gram.c" /* yacc.c:1646  */
    break;

  case 2011:
#line 14838 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeXmlExpr(IS_DOCUMENT, NULL, NIL,
									 list_make1((yyvsp[-2].node)), (yylsp[-1]));
				}
#line 46756 "gram.c" /* yacc.c:1646  */
    break;

  case 2012:
#line 14843 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeNotExpr(makeXmlExpr(IS_DOCUMENT, NULL, NIL,
												 list_make1((yyvsp[-3].node)), (yylsp[-2])),
									 (yylsp[-2]));
				}
#line 46766 "gram.c" /* yacc.c:1646  */
    break;

  case 2013:
#line 14849 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("is_normalized"),
											   list_make1((yyvsp[-2].node)),
											   COERCE_SQL_SYNTAX,
											   (yylsp[-1]));
				}
#line 46777 "gram.c" /* yacc.c:1646  */
    break;

  case 2014:
#line 14856 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("is_normalized"),
											   list_make2((yyvsp[-3].node), makeStringConst((yyvsp[-1].str), (yylsp[-1]))),
											   COERCE_SQL_SYNTAX,
											   (yylsp[-2]));
				}
#line 46788 "gram.c" /* yacc.c:1646  */
    break;

  case 2015:
#line 14863 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeNotExpr((Node *) makeFuncCall(SystemFuncName("is_normalized"),
														   list_make1((yyvsp[-3].node)),
														   COERCE_SQL_SYNTAX,
														   (yylsp[-2])),
									 (yylsp[-2]));
				}
#line 46800 "gram.c" /* yacc.c:1646  */
    break;

  case 2016:
#line 14871 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeNotExpr((Node *) makeFuncCall(SystemFuncName("is_normalized"),
														   list_make2((yyvsp[-4].node), makeStringConst((yyvsp[-1].str), (yylsp[-1]))),
														   COERCE_SQL_SYNTAX,
														   (yylsp[-3])),
									 (yylsp[-3]));
				}
#line 46812 "gram.c" /* yacc.c:1646  */
    break;

  case 2017:
#line 14879 "gram.y" /* yacc.c:1646  */
    {
					/*
					 * The SQL spec only allows DEFAULT in "contextually typed
					 * expressions", but for us, it's easier to allow it in
					 * any a_expr and then throw error during parse analysis
					 * if it's in an inappropriate context.  This way also
					 * lets us say something smarter than "syntax error".
					 */
					SetToDefault *n = makeNode(SetToDefault);

					/* parse analysis will fill in the rest */
					n->location = (yylsp[0]);
					(yyval.node) = (Node *) n;
				}
#line 46831 "gram.c" /* yacc.c:1646  */
    break;

  case 2018:
#line 14905 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 46837 "gram.c" /* yacc.c:1646  */
    break;

  case 2019:
#line 14907 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = makeTypeCast((yyvsp[-2].node), (yyvsp[0].typnam), (yylsp[-1])); }
#line 46843 "gram.c" /* yacc.c:1646  */
    break;

  case 2020:
#line 14909 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "+", NULL, (yyvsp[0].node), (yylsp[-1])); }
#line 46849 "gram.c" /* yacc.c:1646  */
    break;

  case 2021:
#line 14911 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = doNegate((yyvsp[0].node), (yylsp[-1])); }
#line 46855 "gram.c" /* yacc.c:1646  */
    break;

  case 2022:
#line 14913 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "+", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 46861 "gram.c" /* yacc.c:1646  */
    break;

  case 2023:
#line 14915 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "-", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 46867 "gram.c" /* yacc.c:1646  */
    break;

  case 2024:
#line 14917 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "*", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 46873 "gram.c" /* yacc.c:1646  */
    break;

  case 2025:
#line 14919 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "/", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 46879 "gram.c" /* yacc.c:1646  */
    break;

  case 2026:
#line 14921 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "%", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 46885 "gram.c" /* yacc.c:1646  */
    break;

  case 2027:
#line 14923 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "^", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 46891 "gram.c" /* yacc.c:1646  */
    break;

  case 2028:
#line 14925 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "<", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 46897 "gram.c" /* yacc.c:1646  */
    break;

  case 2029:
#line 14927 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, ">", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 46903 "gram.c" /* yacc.c:1646  */
    break;

  case 2030:
#line 14929 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "=", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 46909 "gram.c" /* yacc.c:1646  */
    break;

  case 2031:
#line 14931 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "<=", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 46915 "gram.c" /* yacc.c:1646  */
    break;

  case 2032:
#line 14933 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, ">=", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 46921 "gram.c" /* yacc.c:1646  */
    break;

  case 2033:
#line 14935 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "<>", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 46927 "gram.c" /* yacc.c:1646  */
    break;

  case 2034:
#line 14937 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeA_Expr(AEXPR_OP, (yyvsp[-1].list), (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 46933 "gram.c" /* yacc.c:1646  */
    break;

  case 2035:
#line 14939 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeA_Expr(AEXPR_OP, (yyvsp[-1].list), NULL, (yyvsp[0].node), (yylsp[-1])); }
#line 46939 "gram.c" /* yacc.c:1646  */
    break;

  case 2036:
#line 14941 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_DISTINCT, "=", (yyvsp[-4].node), (yyvsp[0].node), (yylsp[-3]));
				}
#line 46947 "gram.c" /* yacc.c:1646  */
    break;

  case 2037:
#line 14945 "gram.y" /* yacc.c:1646  */
    {
                    (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_NOT_DISTINCT, "=", (yyvsp[-5].node), (yyvsp[0].node), (yylsp[-4]));
				}
#line 46955 "gram.c" /* yacc.c:1646  */
    break;

  case 2038:
#line 14949 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeXmlExpr(IS_DOCUMENT, NULL, NIL,
									 list_make1((yyvsp[-2].node)), (yylsp[-1]));
				}
#line 46964 "gram.c" /* yacc.c:1646  */
    break;

  case 2039:
#line 14954 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeNotExpr(makeXmlExpr(IS_DOCUMENT, NULL, NIL,
												 list_make1((yyvsp[-3].node)), (yylsp[-2])),
									 (yylsp[-2]));
				}
#line 46974 "gram.c" /* yacc.c:1646  */
    break;

  case 2040:
#line 14969 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 46980 "gram.c" /* yacc.c:1646  */
    break;

  case 2041:
#line 14970 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 46986 "gram.c" /* yacc.c:1646  */
    break;

  case 2042:
#line 14972 "gram.y" /* yacc.c:1646  */
    {
					ParamRef   *p = makeNode(ParamRef);

					p->number = (yyvsp[-1].ival);
					p->location = (yylsp[-1]);
					if ((yyvsp[0].list))
					{
						A_Indirection *n = makeNode(A_Indirection);

						n->arg = (Node *) p;
						n->indirection = check_indirection((yyvsp[0].list), yyscanner);
						(yyval.node) = (Node *) n;
					}
					else
						(yyval.node) = (Node *) p;
				}
#line 47007 "gram.c" /* yacc.c:1646  */
    break;

  case 2043:
#line 14989 "gram.y" /* yacc.c:1646  */
    {
					if ((yyvsp[0].list))
					{
						A_Indirection *n = makeNode(A_Indirection);

						n->arg = (yyvsp[-2].node);
						n->indirection = check_indirection((yyvsp[0].list), yyscanner);
						(yyval.node) = (Node *) n;
					}
					else
						(yyval.node) = (yyvsp[-2].node);
				}
#line 47024 "gram.c" /* yacc.c:1646  */
    break;

  case 2044:
#line 15002 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 47030 "gram.c" /* yacc.c:1646  */
    break;

  case 2045:
#line 15004 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 47036 "gram.c" /* yacc.c:1646  */
    break;

  case 2046:
#line 15006 "gram.y" /* yacc.c:1646  */
    {
					SubLink	   *n = makeNode(SubLink);

					n->subLinkType = EXPR_SUBLINK;
					n->subLinkId = 0;
					n->testexpr = NULL;
					n->operName = NIL;
					n->subselect = (yyvsp[0].node);
					n->location = (yylsp[0]);
					(yyval.node) = (Node *) n;
				}
#line 47052 "gram.c" /* yacc.c:1646  */
    break;

  case 2047:
#line 15018 "gram.y" /* yacc.c:1646  */
    {
					/*
					 * Because the select_with_parens nonterminal is designed
					 * to "eat" as many levels of parens as possible, the
					 * '(' a_expr ')' opt_indirection production above will
					 * fail to match a sub-SELECT with indirection decoration;
					 * the sub-SELECT won't be regarded as an a_expr as long
					 * as there are parens around it.  To support applying
					 * subscripting or field selection to a sub-SELECT result,
					 * we need this redundant-looking production.
					 */
					SubLink	   *n = makeNode(SubLink);
					A_Indirection *a = makeNode(A_Indirection);

					n->subLinkType = EXPR_SUBLINK;
					n->subLinkId = 0;
					n->testexpr = NULL;
					n->operName = NIL;
					n->subselect = (yyvsp[-1].node);
					n->location = (yylsp[-1]);
					a->arg = (Node *) n;
					a->indirection = check_indirection((yyvsp[0].list), yyscanner);
					(yyval.node) = (Node *) a;
				}
#line 47081 "gram.c" /* yacc.c:1646  */
    break;

  case 2048:
#line 15043 "gram.y" /* yacc.c:1646  */
    {
					SubLink	   *n = makeNode(SubLink);

					n->subLinkType = EXISTS_SUBLINK;
					n->subLinkId = 0;
					n->testexpr = NULL;
					n->operName = NIL;
					n->subselect = (yyvsp[0].node);
					n->location = (yylsp[-1]);
					(yyval.node) = (Node *) n;
				}
#line 47097 "gram.c" /* yacc.c:1646  */
    break;

  case 2049:
#line 15055 "gram.y" /* yacc.c:1646  */
    {
					SubLink	   *n = makeNode(SubLink);

					n->subLinkType = ARRAY_SUBLINK;
					n->subLinkId = 0;
					n->testexpr = NULL;
					n->operName = NIL;
					n->subselect = (yyvsp[0].node);
					n->location = (yylsp[-1]);
					(yyval.node) = (Node *) n;
				}
#line 47113 "gram.c" /* yacc.c:1646  */
    break;

  case 2050:
#line 15067 "gram.y" /* yacc.c:1646  */
    {
					A_ArrayExpr *n = castNode(A_ArrayExpr, (yyvsp[0].node));

					/* point outermost A_ArrayExpr to the ARRAY keyword */
					n->location = (yylsp[-1]);
					(yyval.node) = (Node *) n;
				}
#line 47125 "gram.c" /* yacc.c:1646  */
    break;

  case 2051:
#line 15075 "gram.y" /* yacc.c:1646  */
    {
					RowExpr	   *r = makeNode(RowExpr);

					r->args = (yyvsp[0].list);
					r->row_typeid = InvalidOid;	/* not analyzed yet */
					r->colnames = NIL;	/* to be filled in during analysis */
					r->row_format = COERCE_EXPLICIT_CALL; /* abuse */
					r->location = (yylsp[0]);
					(yyval.node) = (Node *) r;
				}
#line 47140 "gram.c" /* yacc.c:1646  */
    break;

  case 2052:
#line 15086 "gram.y" /* yacc.c:1646  */
    {
					RowExpr	   *r = makeNode(RowExpr);

					r->args = (yyvsp[0].list);
					r->row_typeid = InvalidOid;	/* not analyzed yet */
					r->colnames = NIL;	/* to be filled in during analysis */
					r->row_format = COERCE_IMPLICIT_CAST; /* abuse */
					r->location = (yylsp[0]);
					(yyval.node) = (Node *) r;
				}
#line 47155 "gram.c" /* yacc.c:1646  */
    break;

  case 2053:
#line 15097 "gram.y" /* yacc.c:1646  */
    {
				  GroupingFunc *g = makeNode(GroupingFunc);

				  g->args = (yyvsp[-1].list);
				  g->location = (yylsp[-3]);
				  (yyval.node) = (Node *) g;
			  }
#line 47167 "gram.c" /* yacc.c:1646  */
    break;

  case 2054:
#line 15107 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeFuncCall((yyvsp[-2].list), NIL,
											   COERCE_EXPLICIT_CALL,
											   (yylsp[-2]));
				}
#line 47177 "gram.c" /* yacc.c:1646  */
    break;

  case 2055:
#line 15113 "gram.y" /* yacc.c:1646  */
    {
					FuncCall   *n = makeFuncCall((yyvsp[-4].list), (yyvsp[-2].list),
												 COERCE_EXPLICIT_CALL,
												 (yylsp[-4]));

					n->agg_order = (yyvsp[-1].list);
					(yyval.node) = (Node *) n;
				}
#line 47190 "gram.c" /* yacc.c:1646  */
    break;

  case 2056:
#line 15122 "gram.y" /* yacc.c:1646  */
    {
					FuncCall   *n = makeFuncCall((yyvsp[-5].list), list_make1((yyvsp[-2].node)),
												 COERCE_EXPLICIT_CALL,
												 (yylsp[-5]));

					n->func_variadic = true;
					n->agg_order = (yyvsp[-1].list);
					(yyval.node) = (Node *) n;
				}
#line 47204 "gram.c" /* yacc.c:1646  */
    break;

  case 2057:
#line 15132 "gram.y" /* yacc.c:1646  */
    {
					FuncCall   *n = makeFuncCall((yyvsp[-7].list), lappend((yyvsp[-5].list), (yyvsp[-2].node)),
												 COERCE_EXPLICIT_CALL,
												 (yylsp[-7]));

					n->func_variadic = true;
					n->agg_order = (yyvsp[-1].list);
					(yyval.node) = (Node *) n;
				}
#line 47218 "gram.c" /* yacc.c:1646  */
    break;

  case 2058:
#line 15142 "gram.y" /* yacc.c:1646  */
    {
					FuncCall   *n = makeFuncCall((yyvsp[-5].list), (yyvsp[-2].list),
												 COERCE_EXPLICIT_CALL,
												 (yylsp[-5]));

					n->agg_order = (yyvsp[-1].list);
					/* Ideally we'd mark the FuncCall node to indicate
					 * "must be an aggregate", but there's no provision
					 * for that in FuncCall at the moment.
					 */
					(yyval.node) = (Node *) n;
				}
#line 47235 "gram.c" /* yacc.c:1646  */
    break;

  case 2059:
#line 15155 "gram.y" /* yacc.c:1646  */
    {
					FuncCall   *n = makeFuncCall((yyvsp[-5].list), (yyvsp[-2].list),
												 COERCE_EXPLICIT_CALL,
												 (yylsp[-5]));

					n->agg_order = (yyvsp[-1].list);
					n->agg_distinct = true;
					(yyval.node) = (Node *) n;
				}
#line 47249 "gram.c" /* yacc.c:1646  */
    break;

  case 2060:
#line 15165 "gram.y" /* yacc.c:1646  */
    {
					/*
					 * We consider AGGREGATE(*) to invoke a parameterless
					 * aggregate.  This does the right thing for COUNT(*),
					 * and there are no other aggregates in SQL that accept
					 * '*' as parameter.
					 *
					 * The FuncCall node is also marked agg_star = true,
					 * so that later processing can detect what the argument
					 * really was.
					 */
					FuncCall   *n = makeFuncCall((yyvsp[-3].list), NIL,
												 COERCE_EXPLICIT_CALL,
												 (yylsp[-3]));

					n->agg_star = true;
					(yyval.node) = (Node *) n;
				}
#line 47272 "gram.c" /* yacc.c:1646  */
    break;

  case 2061:
#line 15196 "gram.y" /* yacc.c:1646  */
    {
					FuncCall   *n = (FuncCall *) (yyvsp[-3].node);

					/*
					 * The order clause for WITHIN GROUP and the one for
					 * plain-aggregate ORDER BY share a field, so we have to
					 * check here that at most one is present.  We also check
					 * for DISTINCT and VARIADIC here to give a better error
					 * location.  Other consistency checks are deferred to
					 * parse analysis.
					 */
					if ((yyvsp[-2].list) != NIL)
					{
						if (n->agg_order != NIL)
							ereport(ERROR,
									(errcode(ERRCODE_SYNTAX_ERROR),
									 errmsg("cannot use multiple ORDER BY clauses with WITHIN GROUP"),
									 parser_errposition((yylsp[-2]))));
						if (n->agg_distinct)
							ereport(ERROR,
									(errcode(ERRCODE_SYNTAX_ERROR),
									 errmsg("cannot use DISTINCT with WITHIN GROUP"),
									 parser_errposition((yylsp[-2]))));
						if (n->func_variadic)
							ereport(ERROR,
									(errcode(ERRCODE_SYNTAX_ERROR),
									 errmsg("cannot use VARIADIC with WITHIN GROUP"),
									 parser_errposition((yylsp[-2]))));
						n->agg_order = (yyvsp[-2].list);
						n->agg_within_group = true;
					}
					n->agg_filter = (yyvsp[-1].node);
					n->over = (yyvsp[0].windef);
					(yyval.node) = (Node *) n;
				}
#line 47312 "gram.c" /* yacc.c:1646  */
    break;

  case 2062:
#line 15232 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 47318 "gram.c" /* yacc.c:1646  */
    break;

  case 2063:
#line 15242 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 47324 "gram.c" /* yacc.c:1646  */
    break;

  case 2064:
#line 15243 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 47330 "gram.c" /* yacc.c:1646  */
    break;

  case 2065:
#line 15251 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("pg_collation_for"),
											   list_make1((yyvsp[-1].node)),
											   COERCE_SQL_SYNTAX,
											   (yylsp[-4]));
				}
#line 47341 "gram.c" /* yacc.c:1646  */
    break;

  case 2066:
#line 15258 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeSQLValueFunction(SVFOP_CURRENT_DATE, -1, (yylsp[0]));
				}
#line 47349 "gram.c" /* yacc.c:1646  */
    break;

  case 2067:
#line 15262 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeSQLValueFunction(SVFOP_CURRENT_TIME, -1, (yylsp[0]));
				}
#line 47357 "gram.c" /* yacc.c:1646  */
    break;

  case 2068:
#line 15266 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeSQLValueFunction(SVFOP_CURRENT_TIME_N, (yyvsp[-1].ival), (yylsp[-3]));
				}
#line 47365 "gram.c" /* yacc.c:1646  */
    break;

  case 2069:
#line 15270 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeSQLValueFunction(SVFOP_CURRENT_TIMESTAMP, -1, (yylsp[0]));
				}
#line 47373 "gram.c" /* yacc.c:1646  */
    break;

  case 2070:
#line 15274 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeSQLValueFunction(SVFOP_CURRENT_TIMESTAMP_N, (yyvsp[-1].ival), (yylsp[-3]));
				}
#line 47381 "gram.c" /* yacc.c:1646  */
    break;

  case 2071:
#line 15278 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeSQLValueFunction(SVFOP_LOCALTIME, -1, (yylsp[0]));
				}
#line 47389 "gram.c" /* yacc.c:1646  */
    break;

  case 2072:
#line 15282 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeSQLValueFunction(SVFOP_LOCALTIME_N, (yyvsp[-1].ival), (yylsp[-3]));
				}
#line 47397 "gram.c" /* yacc.c:1646  */
    break;

  case 2073:
#line 15286 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeSQLValueFunction(SVFOP_LOCALTIMESTAMP, -1, (yylsp[0]));
				}
#line 47405 "gram.c" /* yacc.c:1646  */
    break;

  case 2074:
#line 15290 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeSQLValueFunction(SVFOP_LOCALTIMESTAMP_N, (yyvsp[-1].ival), (yylsp[-3]));
				}
#line 47413 "gram.c" /* yacc.c:1646  */
    break;

  case 2075:
#line 15294 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeSQLValueFunction(SVFOP_CURRENT_ROLE, -1, (yylsp[0]));
				}
#line 47421 "gram.c" /* yacc.c:1646  */
    break;

  case 2076:
#line 15298 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeSQLValueFunction(SVFOP_CURRENT_USER, -1, (yylsp[0]));
				}
#line 47429 "gram.c" /* yacc.c:1646  */
    break;

  case 2077:
#line 15302 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeSQLValueFunction(SVFOP_SESSION_USER, -1, (yylsp[0]));
				}
#line 47437 "gram.c" /* yacc.c:1646  */
    break;

  case 2078:
#line 15306 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeSQLValueFunction(SVFOP_USER, -1, (yylsp[0]));
				}
#line 47445 "gram.c" /* yacc.c:1646  */
    break;

  case 2079:
#line 15310 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeSQLValueFunction(SVFOP_CURRENT_CATALOG, -1, (yylsp[0]));
				}
#line 47453 "gram.c" /* yacc.c:1646  */
    break;

  case 2080:
#line 15314 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeSQLValueFunction(SVFOP_CURRENT_SCHEMA, -1, (yylsp[0]));
				}
#line 47461 "gram.c" /* yacc.c:1646  */
    break;

  case 2081:
#line 15318 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = makeTypeCast((yyvsp[-3].node), (yyvsp[-1].typnam), (yylsp[-5])); }
#line 47467 "gram.c" /* yacc.c:1646  */
    break;

  case 2082:
#line 15320 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("extract"),
											   (yyvsp[-1].list),
											   COERCE_SQL_SYNTAX,
											   (yylsp[-3]));
				}
#line 47478 "gram.c" /* yacc.c:1646  */
    break;

  case 2083:
#line 15327 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("normalize"),
											   list_make1((yyvsp[-1].node)),
											   COERCE_SQL_SYNTAX,
											   (yylsp[-3]));
				}
#line 47489 "gram.c" /* yacc.c:1646  */
    break;

  case 2084:
#line 15334 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("normalize"),
											   list_make2((yyvsp[-3].node), makeStringConst((yyvsp[-1].str), (yylsp[-1]))),
											   COERCE_SQL_SYNTAX,
											   (yylsp[-5]));
				}
#line 47500 "gram.c" /* yacc.c:1646  */
    break;

  case 2085:
#line 15341 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("overlay"),
											   (yyvsp[-1].list),
											   COERCE_SQL_SYNTAX,
											   (yylsp[-3]));
				}
#line 47511 "gram.c" /* yacc.c:1646  */
    break;

  case 2086:
#line 15348 "gram.y" /* yacc.c:1646  */
    {
					/*
					 * allow functions named overlay() to be called without
					 * special syntax
					 */
					(yyval.node) = (Node *) makeFuncCall(list_make1(makeString("overlay")),
											   (yyvsp[-1].list),
											   COERCE_EXPLICIT_CALL,
											   (yylsp[-3]));
				}
#line 47526 "gram.c" /* yacc.c:1646  */
    break;

  case 2087:
#line 15359 "gram.y" /* yacc.c:1646  */
    {
					/*
					 * position(A in B) is converted to position(B, A)
					 *
					 * We deliberately don't offer a "plain syntax" option
					 * for position(), because the reversal of the arguments
					 * creates too much risk of confusion.
					 */
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("position"),
											   (yyvsp[-1].list),
											   COERCE_SQL_SYNTAX,
											   (yylsp[-3]));
				}
#line 47544 "gram.c" /* yacc.c:1646  */
    break;

  case 2088:
#line 15373 "gram.y" /* yacc.c:1646  */
    {
					/* substring(A from B for C) is converted to
					 * substring(A, B, C) - thomas 2000-11-28
					 */
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("substring"),
											   (yyvsp[-1].list),
											   COERCE_SQL_SYNTAX,
											   (yylsp[-3]));
				}
#line 47558 "gram.c" /* yacc.c:1646  */
    break;

  case 2089:
#line 15383 "gram.y" /* yacc.c:1646  */
    {
					/*
					 * allow functions named substring() to be called without
					 * special syntax
					 */
					(yyval.node) = (Node *) makeFuncCall(list_make1(makeString("substring")),
											   (yyvsp[-1].list),
											   COERCE_EXPLICIT_CALL,
											   (yylsp[-3]));
				}
#line 47573 "gram.c" /* yacc.c:1646  */
    break;

  case 2090:
#line 15394 "gram.y" /* yacc.c:1646  */
    {
					/* TREAT(expr AS target) converts expr of a particular type to target,
					 * which is defined to be a subtype of the original expression.
					 * In SQL99, this is intended for use with structured UDTs,
					 * but let's make this a generally useful form allowing stronger
					 * coercions than are handled by implicit casting.
					 *
					 * Convert SystemTypeName() to SystemFuncName() even though
					 * at the moment they result in the same thing.
					 */
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName(strVal(llast((yyvsp[-1].typnam)->names))),
											   list_make1((yyvsp[-3].node)),
											   COERCE_EXPLICIT_CALL,
											   (yylsp[-5]));
				}
#line 47593 "gram.c" /* yacc.c:1646  */
    break;

  case 2091:
#line 15410 "gram.y" /* yacc.c:1646  */
    {
					/* various trim expressions are defined in SQL
					 * - thomas 1997-07-19
					 */
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("btrim"),
											   (yyvsp[-1].list),
											   COERCE_SQL_SYNTAX,
											   (yylsp[-4]));
				}
#line 47607 "gram.c" /* yacc.c:1646  */
    break;

  case 2092:
#line 15420 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("ltrim"),
											   (yyvsp[-1].list),
											   COERCE_SQL_SYNTAX,
											   (yylsp[-4]));
				}
#line 47618 "gram.c" /* yacc.c:1646  */
    break;

  case 2093:
#line 15427 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("rtrim"),
											   (yyvsp[-1].list),
											   COERCE_SQL_SYNTAX,
											   (yylsp[-4]));
				}
#line 47629 "gram.c" /* yacc.c:1646  */
    break;

  case 2094:
#line 15434 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("btrim"),
											   (yyvsp[-1].list),
											   COERCE_SQL_SYNTAX,
											   (yylsp[-3]));
				}
#line 47640 "gram.c" /* yacc.c:1646  */
    break;

  case 2095:
#line 15441 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_NULLIF, "=", (yyvsp[-3].node), (yyvsp[-1].node), (yylsp[-5]));
				}
#line 47648 "gram.c" /* yacc.c:1646  */
    break;

  case 2096:
#line 15445 "gram.y" /* yacc.c:1646  */
    {
					CoalesceExpr *c = makeNode(CoalesceExpr);

					c->args = (yyvsp[-1].list);
					c->location = (yylsp[-3]);
					(yyval.node) = (Node *) c;
				}
#line 47660 "gram.c" /* yacc.c:1646  */
    break;

  case 2097:
#line 15453 "gram.y" /* yacc.c:1646  */
    {
					MinMaxExpr *v = makeNode(MinMaxExpr);

					v->args = (yyvsp[-1].list);
					v->op = IS_GREATEST;
					v->location = (yylsp[-3]);
					(yyval.node) = (Node *) v;
				}
#line 47673 "gram.c" /* yacc.c:1646  */
    break;

  case 2098:
#line 15462 "gram.y" /* yacc.c:1646  */
    {
					MinMaxExpr *v = makeNode(MinMaxExpr);

					v->args = (yyvsp[-1].list);
					v->op = IS_LEAST;
					v->location = (yylsp[-3]);
					(yyval.node) = (Node *) v;
				}
#line 47686 "gram.c" /* yacc.c:1646  */
    break;

  case 2099:
#line 15471 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeXmlExpr(IS_XMLCONCAT, NULL, NIL, (yyvsp[-1].list), (yylsp[-3]));
				}
#line 47694 "gram.c" /* yacc.c:1646  */
    break;

  case 2100:
#line 15475 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeXmlExpr(IS_XMLELEMENT, (yyvsp[-1].str), NIL, NIL, (yylsp[-4]));
				}
#line 47702 "gram.c" /* yacc.c:1646  */
    break;

  case 2101:
#line 15479 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeXmlExpr(IS_XMLELEMENT, (yyvsp[-3].str), (yyvsp[-1].list), NIL, (yylsp[-6]));
				}
#line 47710 "gram.c" /* yacc.c:1646  */
    break;

  case 2102:
#line 15483 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeXmlExpr(IS_XMLELEMENT, (yyvsp[-3].str), NIL, (yyvsp[-1].list), (yylsp[-6]));
				}
#line 47718 "gram.c" /* yacc.c:1646  */
    break;

  case 2103:
#line 15487 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeXmlExpr(IS_XMLELEMENT, (yyvsp[-5].str), (yyvsp[-3].list), (yyvsp[-1].list), (yylsp[-8]));
				}
#line 47726 "gram.c" /* yacc.c:1646  */
    break;

  case 2104:
#line 15491 "gram.y" /* yacc.c:1646  */
    {
					/* xmlexists(A PASSING [BY REF] B [BY REF]) is
					 * converted to xmlexists(A, B)*/
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("xmlexists"),
											   list_make2((yyvsp[-2].node), (yyvsp[-1].node)),
											   COERCE_SQL_SYNTAX,
											   (yylsp[-4]));
				}
#line 47739 "gram.c" /* yacc.c:1646  */
    break;

  case 2105:
#line 15500 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeXmlExpr(IS_XMLFOREST, NULL, (yyvsp[-1].list), NIL, (yylsp[-3]));
				}
#line 47747 "gram.c" /* yacc.c:1646  */
    break;

  case 2106:
#line 15504 "gram.y" /* yacc.c:1646  */
    {
					XmlExpr *x = (XmlExpr *)
						makeXmlExpr(IS_XMLPARSE, NULL, NIL,
									list_make2((yyvsp[-2].node), makeBoolAConst((yyvsp[-1].boolean), -1)),
									(yylsp[-5]));

					x->xmloption = (yyvsp[-3].ival);
					(yyval.node) = (Node *) x;
				}
#line 47761 "gram.c" /* yacc.c:1646  */
    break;

  case 2107:
#line 15514 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeXmlExpr(IS_XMLPI, (yyvsp[-1].str), NULL, NIL, (yylsp[-4]));
				}
#line 47769 "gram.c" /* yacc.c:1646  */
    break;

  case 2108:
#line 15518 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeXmlExpr(IS_XMLPI, (yyvsp[-3].str), NULL, list_make1((yyvsp[-1].node)), (yylsp[-6]));
				}
#line 47777 "gram.c" /* yacc.c:1646  */
    break;

  case 2109:
#line 15522 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeXmlExpr(IS_XMLROOT, NULL, NIL,
									 list_make3((yyvsp[-4].node), (yyvsp[-2].node), (yyvsp[-1].node)), (yylsp[-6]));
				}
#line 47786 "gram.c" /* yacc.c:1646  */
    break;

  case 2110:
#line 15527 "gram.y" /* yacc.c:1646  */
    {
					XmlSerialize *n = makeNode(XmlSerialize);

					n->xmloption = (yyvsp[-4].ival);
					n->expr = (yyvsp[-3].node);
					n->typeName = (yyvsp[-1].typnam);
					n->location = (yylsp[-6]);
					(yyval.node) = (Node *) n;
				}
#line 47800 "gram.c" /* yacc.c:1646  */
    break;

  case 2111:
#line 15542 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 47806 "gram.c" /* yacc.c:1646  */
    break;

  case 2112:
#line 15544 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = makeNullAConst(-1); }
#line 47812 "gram.c" /* yacc.c:1646  */
    break;

  case 2113:
#line 15548 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = makeIntConst(XML_STANDALONE_YES, -1); }
#line 47818 "gram.c" /* yacc.c:1646  */
    break;

  case 2114:
#line 15550 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = makeIntConst(XML_STANDALONE_NO, -1); }
#line 47824 "gram.c" /* yacc.c:1646  */
    break;

  case 2115:
#line 15552 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = makeIntConst(XML_STANDALONE_NO_VALUE, -1); }
#line 47830 "gram.c" /* yacc.c:1646  */
    break;

  case 2116:
#line 15554 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = makeIntConst(XML_STANDALONE_OMITTED, -1); }
#line 47836 "gram.c" /* yacc.c:1646  */
    break;

  case 2117:
#line 15557 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 47842 "gram.c" /* yacc.c:1646  */
    break;

  case 2118:
#line 15560 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].target)); }
#line 47848 "gram.c" /* yacc.c:1646  */
    break;

  case 2119:
#line 15561 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].target)); }
#line 47854 "gram.c" /* yacc.c:1646  */
    break;

  case 2120:
#line 15565 "gram.y" /* yacc.c:1646  */
    {
					(yyval.target) = makeNode(ResTarget);
					(yyval.target)->name = (yyvsp[0].str);
					(yyval.target)->indirection = NIL;
					(yyval.target)->val = (Node *) (yyvsp[-2].node);
					(yyval.target)->location = (yylsp[-2]);
				}
#line 47866 "gram.c" /* yacc.c:1646  */
    break;

  case 2121:
#line 15573 "gram.y" /* yacc.c:1646  */
    {
					(yyval.target) = makeNode(ResTarget);
					(yyval.target)->name = NULL;
					(yyval.target)->indirection = NIL;
					(yyval.target)->val = (Node *) (yyvsp[0].node);
					(yyval.target)->location = (yylsp[0]);
				}
#line 47878 "gram.c" /* yacc.c:1646  */
    break;

  case 2122:
#line 15582 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = XMLOPTION_DOCUMENT; }
#line 47884 "gram.c" /* yacc.c:1646  */
    break;

  case 2123:
#line 15583 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = XMLOPTION_CONTENT; }
#line 47890 "gram.c" /* yacc.c:1646  */
    break;

  case 2124:
#line 15586 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 47896 "gram.c" /* yacc.c:1646  */
    break;

  case 2125:
#line 15587 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 47902 "gram.c" /* yacc.c:1646  */
    break;

  case 2126:
#line 15588 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 47908 "gram.c" /* yacc.c:1646  */
    break;

  case 2127:
#line 15594 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (yyvsp[0].node);
				}
#line 47916 "gram.c" /* yacc.c:1646  */
    break;

  case 2128:
#line 15598 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (yyvsp[-1].node);
				}
#line 47924 "gram.c" /* yacc.c:1646  */
    break;

  case 2129:
#line 15602 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (yyvsp[0].node);
				}
#line 47932 "gram.c" /* yacc.c:1646  */
    break;

  case 2130:
#line 15606 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (yyvsp[-1].node);
				}
#line 47940 "gram.c" /* yacc.c:1646  */
    break;

  case 2133:
#line 15621 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 47946 "gram.c" /* yacc.c:1646  */
    break;

  case 2134:
#line 15622 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 47952 "gram.c" /* yacc.c:1646  */
    break;

  case 2135:
#line 15626 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[-1].node); }
#line 47958 "gram.c" /* yacc.c:1646  */
    break;

  case 2136:
#line 15627 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 47964 "gram.c" /* yacc.c:1646  */
    break;

  case 2137:
#line 15635 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 47970 "gram.c" /* yacc.c:1646  */
    break;

  case 2138:
#line 15636 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 47976 "gram.c" /* yacc.c:1646  */
    break;

  case 2139:
#line 15640 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].windef)); }
#line 47982 "gram.c" /* yacc.c:1646  */
    break;

  case 2140:
#line 15642 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].windef)); }
#line 47988 "gram.c" /* yacc.c:1646  */
    break;

  case 2141:
#line 15647 "gram.y" /* yacc.c:1646  */
    {
					WindowDef  *n = (yyvsp[0].windef);

					n->name = (yyvsp[-2].str);
					(yyval.windef) = n;
				}
#line 47999 "gram.c" /* yacc.c:1646  */
    break;

  case 2142:
#line 15656 "gram.y" /* yacc.c:1646  */
    { (yyval.windef) = (yyvsp[0].windef); }
#line 48005 "gram.c" /* yacc.c:1646  */
    break;

  case 2143:
#line 15658 "gram.y" /* yacc.c:1646  */
    {
					WindowDef  *n = makeNode(WindowDef);

					n->name = (yyvsp[0].str);
					n->refname = NULL;
					n->partitionClause = NIL;
					n->orderClause = NIL;
					n->frameOptions = FRAMEOPTION_DEFAULTS;
					n->startOffset = NULL;
					n->endOffset = NULL;
					n->location = (yylsp[0]);
					(yyval.windef) = n;
				}
#line 48023 "gram.c" /* yacc.c:1646  */
    break;

  case 2144:
#line 15672 "gram.y" /* yacc.c:1646  */
    { (yyval.windef) = NULL; }
#line 48029 "gram.c" /* yacc.c:1646  */
    break;

  case 2145:
#line 15677 "gram.y" /* yacc.c:1646  */
    {
					WindowDef  *n = makeNode(WindowDef);

					n->name = NULL;
					n->refname = (yyvsp[-4].str);
					n->partitionClause = (yyvsp[-3].list);
					n->orderClause = (yyvsp[-2].list);
					/* copy relevant fields of opt_frame_clause */
					n->frameOptions = (yyvsp[-1].windef)->frameOptions;
					n->startOffset = (yyvsp[-1].windef)->startOffset;
					n->endOffset = (yyvsp[-1].windef)->endOffset;
					n->location = (yylsp[-5]);
					(yyval.windef) = n;
				}
#line 48048 "gram.c" /* yacc.c:1646  */
    break;

  case 2146:
#line 15703 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 48054 "gram.c" /* yacc.c:1646  */
    break;

  case 2147:
#line 15704 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = NULL; }
#line 48060 "gram.c" /* yacc.c:1646  */
    break;

  case 2148:
#line 15707 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 48066 "gram.c" /* yacc.c:1646  */
    break;

  case 2149:
#line 15708 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 48072 "gram.c" /* yacc.c:1646  */
    break;

  case 2150:
#line 15717 "gram.y" /* yacc.c:1646  */
    {
					WindowDef  *n = (yyvsp[-1].windef);

					n->frameOptions |= FRAMEOPTION_NONDEFAULT | FRAMEOPTION_RANGE;
					n->frameOptions |= (yyvsp[0].ival);
					(yyval.windef) = n;
				}
#line 48084 "gram.c" /* yacc.c:1646  */
    break;

  case 2151:
#line 15725 "gram.y" /* yacc.c:1646  */
    {
					WindowDef  *n = (yyvsp[-1].windef);

					n->frameOptions |= FRAMEOPTION_NONDEFAULT | FRAMEOPTION_ROWS;
					n->frameOptions |= (yyvsp[0].ival);
					(yyval.windef) = n;
				}
#line 48096 "gram.c" /* yacc.c:1646  */
    break;

  case 2152:
#line 15733 "gram.y" /* yacc.c:1646  */
    {
					WindowDef  *n = (yyvsp[-1].windef);

					n->frameOptions |= FRAMEOPTION_NONDEFAULT | FRAMEOPTION_GROUPS;
					n->frameOptions |= (yyvsp[0].ival);
					(yyval.windef) = n;
				}
#line 48108 "gram.c" /* yacc.c:1646  */
    break;

  case 2153:
#line 15741 "gram.y" /* yacc.c:1646  */
    {
					WindowDef  *n = makeNode(WindowDef);

					n->frameOptions = FRAMEOPTION_DEFAULTS;
					n->startOffset = NULL;
					n->endOffset = NULL;
					(yyval.windef) = n;
				}
#line 48121 "gram.c" /* yacc.c:1646  */
    break;

  case 2154:
#line 15752 "gram.y" /* yacc.c:1646  */
    {
					WindowDef  *n = (yyvsp[0].windef);

					/* reject invalid cases */
					if (n->frameOptions & FRAMEOPTION_START_UNBOUNDED_FOLLOWING)
						ereport(ERROR,
								(errcode(ERRCODE_WINDOWING_ERROR),
								 errmsg("frame start cannot be UNBOUNDED FOLLOWING"),
								 parser_errposition((yylsp[0]))));
					if (n->frameOptions & FRAMEOPTION_START_OFFSET_FOLLOWING)
						ereport(ERROR,
								(errcode(ERRCODE_WINDOWING_ERROR),
								 errmsg("frame starting from following row cannot end with current row"),
								 parser_errposition((yylsp[0]))));
					n->frameOptions |= FRAMEOPTION_END_CURRENT_ROW;
					(yyval.windef) = n;
				}
#line 48143 "gram.c" /* yacc.c:1646  */
    break;

  case 2155:
#line 15770 "gram.y" /* yacc.c:1646  */
    {
					WindowDef  *n1 = (yyvsp[-2].windef);
					WindowDef  *n2 = (yyvsp[0].windef);

					/* form merged options */
					int		frameOptions = n1->frameOptions;
					/* shift converts START_ options to END_ options */
					frameOptions |= n2->frameOptions << 1;
					frameOptions |= FRAMEOPTION_BETWEEN;
					/* reject invalid cases */
					if (frameOptions & FRAMEOPTION_START_UNBOUNDED_FOLLOWING)
						ereport(ERROR,
								(errcode(ERRCODE_WINDOWING_ERROR),
								 errmsg("frame start cannot be UNBOUNDED FOLLOWING"),
								 parser_errposition((yylsp[-2]))));
					if (frameOptions & FRAMEOPTION_END_UNBOUNDED_PRECEDING)
						ereport(ERROR,
								(errcode(ERRCODE_WINDOWING_ERROR),
								 errmsg("frame end cannot be UNBOUNDED PRECEDING"),
								 parser_errposition((yylsp[0]))));
					if ((frameOptions & FRAMEOPTION_START_CURRENT_ROW) &&
						(frameOptions & FRAMEOPTION_END_OFFSET_PRECEDING))
						ereport(ERROR,
								(errcode(ERRCODE_WINDOWING_ERROR),
								 errmsg("frame starting from current row cannot have preceding rows"),
								 parser_errposition((yylsp[0]))));
					if ((frameOptions & FRAMEOPTION_START_OFFSET_FOLLOWING) &&
						(frameOptions & (FRAMEOPTION_END_OFFSET_PRECEDING |
										 FRAMEOPTION_END_CURRENT_ROW)))
						ereport(ERROR,
								(errcode(ERRCODE_WINDOWING_ERROR),
								 errmsg("frame starting from following row cannot have preceding rows"),
								 parser_errposition((yylsp[0]))));
					n1->frameOptions = frameOptions;
					n1->endOffset = n2->startOffset;
					(yyval.windef) = n1;
				}
#line 48185 "gram.c" /* yacc.c:1646  */
    break;

  case 2156:
#line 15816 "gram.y" /* yacc.c:1646  */
    {
					WindowDef  *n = makeNode(WindowDef);

					n->frameOptions = FRAMEOPTION_START_UNBOUNDED_PRECEDING;
					n->startOffset = NULL;
					n->endOffset = NULL;
					(yyval.windef) = n;
				}
#line 48198 "gram.c" /* yacc.c:1646  */
    break;

  case 2157:
#line 15825 "gram.y" /* yacc.c:1646  */
    {
					WindowDef  *n = makeNode(WindowDef);

					n->frameOptions = FRAMEOPTION_START_UNBOUNDED_FOLLOWING;
					n->startOffset = NULL;
					n->endOffset = NULL;
					(yyval.windef) = n;
				}
#line 48211 "gram.c" /* yacc.c:1646  */
    break;

  case 2158:
#line 15834 "gram.y" /* yacc.c:1646  */
    {
					WindowDef  *n = makeNode(WindowDef);

					n->frameOptions = FRAMEOPTION_START_CURRENT_ROW;
					n->startOffset = NULL;
					n->endOffset = NULL;
					(yyval.windef) = n;
				}
#line 48224 "gram.c" /* yacc.c:1646  */
    break;

  case 2159:
#line 15843 "gram.y" /* yacc.c:1646  */
    {
					WindowDef  *n = makeNode(WindowDef);

					n->frameOptions = FRAMEOPTION_START_OFFSET_PRECEDING;
					n->startOffset = (yyvsp[-1].node);
					n->endOffset = NULL;
					(yyval.windef) = n;
				}
#line 48237 "gram.c" /* yacc.c:1646  */
    break;

  case 2160:
#line 15852 "gram.y" /* yacc.c:1646  */
    {
					WindowDef  *n = makeNode(WindowDef);

					n->frameOptions = FRAMEOPTION_START_OFFSET_FOLLOWING;
					n->startOffset = (yyvsp[-1].node);
					n->endOffset = NULL;
					(yyval.windef) = n;
				}
#line 48250 "gram.c" /* yacc.c:1646  */
    break;

  case 2161:
#line 15863 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = FRAMEOPTION_EXCLUDE_CURRENT_ROW; }
#line 48256 "gram.c" /* yacc.c:1646  */
    break;

  case 2162:
#line 15864 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = FRAMEOPTION_EXCLUDE_GROUP; }
#line 48262 "gram.c" /* yacc.c:1646  */
    break;

  case 2163:
#line 15865 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = FRAMEOPTION_EXCLUDE_TIES; }
#line 48268 "gram.c" /* yacc.c:1646  */
    break;

  case 2164:
#line 15866 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = 0; }
#line 48274 "gram.c" /* yacc.c:1646  */
    break;

  case 2165:
#line 15867 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = 0; }
#line 48280 "gram.c" /* yacc.c:1646  */
    break;

  case 2166:
#line 15881 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 48286 "gram.c" /* yacc.c:1646  */
    break;

  case 2167:
#line 15882 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 48292 "gram.c" /* yacc.c:1646  */
    break;

  case 2168:
#line 15883 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-3].list), (yyvsp[-1].node)); }
#line 48298 "gram.c" /* yacc.c:1646  */
    break;

  case 2169:
#line 15886 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 48304 "gram.c" /* yacc.c:1646  */
    break;

  case 2170:
#line 15887 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 48310 "gram.c" /* yacc.c:1646  */
    break;

  case 2171:
#line 15890 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-3].list), (yyvsp[-1].node)); }
#line 48316 "gram.c" /* yacc.c:1646  */
    break;

  case 2172:
#line 15893 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = ANY_SUBLINK; }
#line 48322 "gram.c" /* yacc.c:1646  */
    break;

  case 2173:
#line 15894 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = ANY_SUBLINK; }
#line 48328 "gram.c" /* yacc.c:1646  */
    break;

  case 2174:
#line 15895 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = ALL_SUBLINK; }
#line 48334 "gram.c" /* yacc.c:1646  */
    break;

  case 2175:
#line 15898 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 48340 "gram.c" /* yacc.c:1646  */
    break;

  case 2176:
#line 15899 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 48346 "gram.c" /* yacc.c:1646  */
    break;

  case 2177:
#line 15902 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "+"; }
#line 48352 "gram.c" /* yacc.c:1646  */
    break;

  case 2178:
#line 15903 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "-"; }
#line 48358 "gram.c" /* yacc.c:1646  */
    break;

  case 2179:
#line 15904 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "*"; }
#line 48364 "gram.c" /* yacc.c:1646  */
    break;

  case 2180:
#line 15905 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "/"; }
#line 48370 "gram.c" /* yacc.c:1646  */
    break;

  case 2181:
#line 15906 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "%"; }
#line 48376 "gram.c" /* yacc.c:1646  */
    break;

  case 2182:
#line 15907 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "^"; }
#line 48382 "gram.c" /* yacc.c:1646  */
    break;

  case 2183:
#line 15908 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "<"; }
#line 48388 "gram.c" /* yacc.c:1646  */
    break;

  case 2184:
#line 15909 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = ">"; }
#line 48394 "gram.c" /* yacc.c:1646  */
    break;

  case 2185:
#line 15910 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "="; }
#line 48400 "gram.c" /* yacc.c:1646  */
    break;

  case 2186:
#line 15911 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "<="; }
#line 48406 "gram.c" /* yacc.c:1646  */
    break;

  case 2187:
#line 15912 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = ">="; }
#line 48412 "gram.c" /* yacc.c:1646  */
    break;

  case 2188:
#line 15913 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "<>"; }
#line 48418 "gram.c" /* yacc.c:1646  */
    break;

  case 2189:
#line 15917 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeString((yyvsp[0].str))); }
#line 48424 "gram.c" /* yacc.c:1646  */
    break;

  case 2190:
#line 15919 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 48430 "gram.c" /* yacc.c:1646  */
    break;

  case 2191:
#line 15924 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeString((yyvsp[0].str))); }
#line 48436 "gram.c" /* yacc.c:1646  */
    break;

  case 2192:
#line 15926 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 48442 "gram.c" /* yacc.c:1646  */
    break;

  case 2193:
#line 15931 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeString((yyvsp[0].str))); }
#line 48448 "gram.c" /* yacc.c:1646  */
    break;

  case 2194:
#line 15933 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 48454 "gram.c" /* yacc.c:1646  */
    break;

  case 2195:
#line 15935 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeString("~~")); }
#line 48460 "gram.c" /* yacc.c:1646  */
    break;

  case 2196:
#line 15937 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeString("!~~")); }
#line 48466 "gram.c" /* yacc.c:1646  */
    break;

  case 2197:
#line 15939 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeString("~~*")); }
#line 48472 "gram.c" /* yacc.c:1646  */
    break;

  case 2198:
#line 15941 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeString("!~~*")); }
#line 48478 "gram.c" /* yacc.c:1646  */
    break;

  case 2199:
#line 15953 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make1((yyvsp[0].node));
				}
#line 48486 "gram.c" /* yacc.c:1646  */
    break;

  case 2200:
#line 15957 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node));
				}
#line 48494 "gram.c" /* yacc.c:1646  */
    break;

  case 2201:
#line 15964 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make1((yyvsp[0].node));
				}
#line 48502 "gram.c" /* yacc.c:1646  */
    break;

  case 2202:
#line 15968 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node));
				}
#line 48510 "gram.c" /* yacc.c:1646  */
    break;

  case 2203:
#line 15974 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (yyvsp[0].node);
				}
#line 48518 "gram.c" /* yacc.c:1646  */
    break;

  case 2204:
#line 15978 "gram.y" /* yacc.c:1646  */
    {
					NamedArgExpr *na = makeNode(NamedArgExpr);

					na->name = (yyvsp[-2].str);
					na->arg = (Expr *) (yyvsp[0].node);
					na->argnumber = -1;		/* until determined */
					na->location = (yylsp[-2]);
					(yyval.node) = (Node *) na;
				}
#line 48532 "gram.c" /* yacc.c:1646  */
    break;

  case 2205:
#line 15988 "gram.y" /* yacc.c:1646  */
    {
					NamedArgExpr *na = makeNode(NamedArgExpr);

					na->name = (yyvsp[-2].str);
					na->arg = (Expr *) (yyvsp[0].node);
					na->argnumber = -1;		/* until determined */
					na->location = (yylsp[-2]);
					(yyval.node) = (Node *) na;
				}
#line 48546 "gram.c" /* yacc.c:1646  */
    break;

  case 2206:
#line 15999 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 48552 "gram.c" /* yacc.c:1646  */
    break;

  case 2207:
#line 16000 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 48558 "gram.c" /* yacc.c:1646  */
    break;

  case 2208:
#line 16003 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].typnam)); }
#line 48564 "gram.c" /* yacc.c:1646  */
    break;

  case 2209:
#line 16004 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].typnam)); }
#line 48570 "gram.c" /* yacc.c:1646  */
    break;

  case 2210:
#line 16008 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeAArrayExpr((yyvsp[-1].list), (yylsp[-2]));
				}
#line 48578 "gram.c" /* yacc.c:1646  */
    break;

  case 2211:
#line 16012 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeAArrayExpr((yyvsp[-1].list), (yylsp[-2]));
				}
#line 48586 "gram.c" /* yacc.c:1646  */
    break;

  case 2212:
#line 16016 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeAArrayExpr(NIL, (yylsp[-1]));
				}
#line 48594 "gram.c" /* yacc.c:1646  */
    break;

  case 2213:
#line 16021 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 48600 "gram.c" /* yacc.c:1646  */
    break;

  case 2214:
#line 16022 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node)); }
#line 48606 "gram.c" /* yacc.c:1646  */
    break;

  case 2215:
#line 16028 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make2(makeStringConst((yyvsp[-2].str), (yylsp[-2])), (yyvsp[0].node));
				}
#line 48614 "gram.c" /* yacc.c:1646  */
    break;

  case 2216:
#line 16037 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 48620 "gram.c" /* yacc.c:1646  */
    break;

  case 2217:
#line 16038 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "year"; }
#line 48626 "gram.c" /* yacc.c:1646  */
    break;

  case 2218:
#line 16039 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "month"; }
#line 48632 "gram.c" /* yacc.c:1646  */
    break;

  case 2219:
#line 16040 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "day"; }
#line 48638 "gram.c" /* yacc.c:1646  */
    break;

  case 2220:
#line 16041 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "hour"; }
#line 48644 "gram.c" /* yacc.c:1646  */
    break;

  case 2221:
#line 16042 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "minute"; }
#line 48650 "gram.c" /* yacc.c:1646  */
    break;

  case 2222:
#line 16043 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "second"; }
#line 48656 "gram.c" /* yacc.c:1646  */
    break;

  case 2223:
#line 16044 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 48662 "gram.c" /* yacc.c:1646  */
    break;

  case 2224:
#line 16048 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "NFC"; }
#line 48668 "gram.c" /* yacc.c:1646  */
    break;

  case 2225:
#line 16049 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "NFD"; }
#line 48674 "gram.c" /* yacc.c:1646  */
    break;

  case 2226:
#line 16050 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "NFKC"; }
#line 48680 "gram.c" /* yacc.c:1646  */
    break;

  case 2227:
#line 16051 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "NFKD"; }
#line 48686 "gram.c" /* yacc.c:1646  */
    break;

  case 2228:
#line 16057 "gram.y" /* yacc.c:1646  */
    {
					/* overlay(A PLACING B FROM C FOR D) is converted to overlay(A, B, C, D) */
					(yyval.list) = list_make4((yyvsp[-6].node), (yyvsp[-4].node), (yyvsp[-2].node), (yyvsp[0].node));
				}
#line 48695 "gram.c" /* yacc.c:1646  */
    break;

  case 2229:
#line 16062 "gram.y" /* yacc.c:1646  */
    {
					/* overlay(A PLACING B FROM C) is converted to overlay(A, B, C) */
					(yyval.list) = list_make3((yyvsp[-4].node), (yyvsp[-2].node), (yyvsp[0].node));
				}
#line 48704 "gram.c" /* yacc.c:1646  */
    break;

  case 2230:
#line 16070 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make2((yyvsp[0].node), (yyvsp[-2].node)); }
#line 48710 "gram.c" /* yacc.c:1646  */
    break;

  case 2231:
#line 16092 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make3((yyvsp[-4].node), (yyvsp[-2].node), (yyvsp[0].node));
				}
#line 48718 "gram.c" /* yacc.c:1646  */
    break;

  case 2232:
#line 16096 "gram.y" /* yacc.c:1646  */
    {
					/* not legal per SQL, but might as well allow it */
					(yyval.list) = list_make3((yyvsp[-4].node), (yyvsp[0].node), (yyvsp[-2].node));
				}
#line 48727 "gram.c" /* yacc.c:1646  */
    break;

  case 2233:
#line 16101 "gram.y" /* yacc.c:1646  */
    {
					/*
					 * Because we aren't restricting data types here, this
					 * syntax can end up resolving to textregexsubstr().
					 * We've historically allowed that to happen, so continue
					 * to accept it.  However, ruleutils.c will reverse-list
					 * such a call in regular function call syntax.
					 */
					(yyval.list) = list_make2((yyvsp[-2].node), (yyvsp[0].node));
				}
#line 48742 "gram.c" /* yacc.c:1646  */
    break;

  case 2234:
#line 16112 "gram.y" /* yacc.c:1646  */
    {
					/* not legal per SQL */

					/*
					 * Since there are no cases where this syntax allows
					 * a textual FOR value, we forcibly cast the argument
					 * to int4.  The possible matches in pg_proc are
					 * substring(text,int4) and substring(text,text),
					 * and we don't want the parser to choose the latter,
					 * which it is likely to do if the second argument
					 * is unknown or doesn't have an implicit cast to int4.
					 */
					(yyval.list) = list_make3((yyvsp[-2].node), makeIntConst(1, -1),
									makeTypeCast((yyvsp[0].node),
												 SystemTypeName("int4"), -1));
				}
#line 48763 "gram.c" /* yacc.c:1646  */
    break;

  case 2235:
#line 16129 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make3((yyvsp[-4].node), (yyvsp[-2].node), (yyvsp[0].node));
				}
#line 48771 "gram.c" /* yacc.c:1646  */
    break;

  case 2236:
#line 16134 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[0].list), (yyvsp[-2].node)); }
#line 48777 "gram.c" /* yacc.c:1646  */
    break;

  case 2237:
#line 16135 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 48783 "gram.c" /* yacc.c:1646  */
    break;

  case 2238:
#line 16136 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 48789 "gram.c" /* yacc.c:1646  */
    break;

  case 2239:
#line 16140 "gram.y" /* yacc.c:1646  */
    {
					SubLink	   *n = makeNode(SubLink);

					n->subselect = (yyvsp[0].node);
					/* other fields will be filled later */
					(yyval.node) = (Node *) n;
				}
#line 48801 "gram.c" /* yacc.c:1646  */
    break;

  case 2240:
#line 16147 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) (yyvsp[-1].list); }
#line 48807 "gram.c" /* yacc.c:1646  */
    break;

  case 2241:
#line 16158 "gram.y" /* yacc.c:1646  */
    {
					CaseExpr   *c = makeNode(CaseExpr);

					c->casetype = InvalidOid; /* not analyzed yet */
					c->arg = (Expr *) (yyvsp[-3].node);
					c->args = (yyvsp[-2].list);
					c->defresult = (Expr *) (yyvsp[-1].node);
					c->location = (yylsp[-4]);
					(yyval.node) = (Node *) c;
				}
#line 48822 "gram.c" /* yacc.c:1646  */
    break;

  case 2242:
#line 16172 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 48828 "gram.c" /* yacc.c:1646  */
    break;

  case 2243:
#line 16173 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].node)); }
#line 48834 "gram.c" /* yacc.c:1646  */
    break;

  case 2244:
#line 16178 "gram.y" /* yacc.c:1646  */
    {
					CaseWhen   *w = makeNode(CaseWhen);

					w->expr = (Expr *) (yyvsp[-2].node);
					w->result = (Expr *) (yyvsp[0].node);
					w->location = (yylsp[-3]);
					(yyval.node) = (Node *) w;
				}
#line 48847 "gram.c" /* yacc.c:1646  */
    break;

  case 2245:
#line 16189 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 48853 "gram.c" /* yacc.c:1646  */
    break;

  case 2246:
#line 16190 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 48859 "gram.c" /* yacc.c:1646  */
    break;

  case 2247:
#line 16193 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 48865 "gram.c" /* yacc.c:1646  */
    break;

  case 2248:
#line 16194 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 48871 "gram.c" /* yacc.c:1646  */
    break;

  case 2249:
#line 16198 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeColumnRef((yyvsp[0].str), NIL, (yylsp[0]), yyscanner);
				}
#line 48879 "gram.c" /* yacc.c:1646  */
    break;

  case 2250:
#line 16202 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeColumnRef((yyvsp[-1].str), (yyvsp[0].list), (yylsp[-1]), yyscanner);
				}
#line 48887 "gram.c" /* yacc.c:1646  */
    break;

  case 2251:
#line 16209 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeString((yyvsp[0].str));
				}
#line 48895 "gram.c" /* yacc.c:1646  */
    break;

  case 2252:
#line 16213 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeNode(A_Star);
				}
#line 48903 "gram.c" /* yacc.c:1646  */
    break;

  case 2253:
#line 16217 "gram.y" /* yacc.c:1646  */
    {
					A_Indices *ai = makeNode(A_Indices);

					ai->is_slice = false;
					ai->lidx = NULL;
					ai->uidx = (yyvsp[-1].node);
					(yyval.node) = (Node *) ai;
				}
#line 48916 "gram.c" /* yacc.c:1646  */
    break;

  case 2254:
#line 16226 "gram.y" /* yacc.c:1646  */
    {
					A_Indices *ai = makeNode(A_Indices);

					ai->is_slice = true;
					ai->lidx = (yyvsp[-3].node);
					ai->uidx = (yyvsp[-1].node);
					(yyval.node) = (Node *) ai;
				}
#line 48929 "gram.c" /* yacc.c:1646  */
    break;

  case 2255:
#line 16237 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 48935 "gram.c" /* yacc.c:1646  */
    break;

  case 2256:
#line 16238 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 48941 "gram.c" /* yacc.c:1646  */
    break;

  case 2257:
#line 16242 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 48947 "gram.c" /* yacc.c:1646  */
    break;

  case 2258:
#line 16243 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].node)); }
#line 48953 "gram.c" /* yacc.c:1646  */
    break;

  case 2259:
#line 16247 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 48959 "gram.c" /* yacc.c:1646  */
    break;

  case 2260:
#line 16248 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].node)); }
#line 48965 "gram.c" /* yacc.c:1646  */
    break;

  case 2263:
#line 16262 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 48971 "gram.c" /* yacc.c:1646  */
    break;

  case 2264:
#line 16263 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 48977 "gram.c" /* yacc.c:1646  */
    break;

  case 2265:
#line 16267 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].target)); }
#line 48983 "gram.c" /* yacc.c:1646  */
    break;

  case 2266:
#line 16268 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].target)); }
#line 48989 "gram.c" /* yacc.c:1646  */
    break;

  case 2267:
#line 16272 "gram.y" /* yacc.c:1646  */
    {
					(yyval.target) = makeNode(ResTarget);
					(yyval.target)->name = (yyvsp[0].str);
					(yyval.target)->indirection = NIL;
					(yyval.target)->val = (Node *) (yyvsp[-2].node);
					(yyval.target)->location = (yylsp[-2]);
				}
#line 49001 "gram.c" /* yacc.c:1646  */
    break;

  case 2268:
#line 16280 "gram.y" /* yacc.c:1646  */
    {
					(yyval.target) = makeNode(ResTarget);
					(yyval.target)->name = (yyvsp[0].str);
					(yyval.target)->indirection = NIL;
					(yyval.target)->val = (Node *) (yyvsp[-1].node);
					(yyval.target)->location = (yylsp[-1]);
				}
#line 49013 "gram.c" /* yacc.c:1646  */
    break;

  case 2269:
#line 16288 "gram.y" /* yacc.c:1646  */
    {
					(yyval.target) = makeNode(ResTarget);
					(yyval.target)->name = NULL;
					(yyval.target)->indirection = NIL;
					(yyval.target)->val = (Node *) (yyvsp[0].node);
					(yyval.target)->location = (yylsp[0]);
				}
#line 49025 "gram.c" /* yacc.c:1646  */
    break;

  case 2270:
#line 16296 "gram.y" /* yacc.c:1646  */
    {
					ColumnRef  *n = makeNode(ColumnRef);

					n->fields = list_make1(makeNode(A_Star));
					n->location = (yylsp[0]);

					(yyval.target) = makeNode(ResTarget);
					(yyval.target)->name = NULL;
					(yyval.target)->indirection = NIL;
					(yyval.target)->val = (Node *) n;
					(yyval.target)->location = (yylsp[0]);
				}
#line 49042 "gram.c" /* yacc.c:1646  */
    break;

  case 2271:
#line 16318 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].range)); }
#line 49048 "gram.c" /* yacc.c:1646  */
    break;

  case 2272:
#line 16319 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].range)); }
#line 49054 "gram.c" /* yacc.c:1646  */
    break;

  case 2273:
#line 16331 "gram.y" /* yacc.c:1646  */
    {
					(yyval.range) = makeRangeVar(NULL, (yyvsp[0].str), (yylsp[0]));
				}
#line 49062 "gram.c" /* yacc.c:1646  */
    break;

  case 2274:
#line 16335 "gram.y" /* yacc.c:1646  */
    {
					(yyval.range) = makeRangeVarFromQualifiedName((yyvsp[-1].str), (yyvsp[0].list), (yylsp[-1]), yyscanner);
				}
#line 49070 "gram.c" /* yacc.c:1646  */
    break;

  case 2275:
#line 16341 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeString((yyvsp[0].str))); }
#line 49076 "gram.c" /* yacc.c:1646  */
    break;

  case 2276:
#line 16343 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), makeString((yyvsp[0].str))); }
#line 49082 "gram.c" /* yacc.c:1646  */
    break;

  case 2277:
#line 16347 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 49088 "gram.c" /* yacc.c:1646  */
    break;

  case 2278:
#line 16349 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 49094 "gram.c" /* yacc.c:1646  */
    break;

  case 2279:
#line 16351 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 49100 "gram.c" /* yacc.c:1646  */
    break;

  case 2280:
#line 16362 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeString((yyvsp[0].str))); }
#line 49106 "gram.c" /* yacc.c:1646  */
    break;

  case 2281:
#line 16364 "gram.y" /* yacc.c:1646  */
    {
						(yyval.list) = check_func_name(lcons(makeString((yyvsp[-1].str)), (yyvsp[0].list)),
											 yyscanner);
					}
#line 49115 "gram.c" /* yacc.c:1646  */
    break;

  case 2282:
#line 16375 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeIntConst((yyvsp[0].ival), (yylsp[0]));
				}
#line 49123 "gram.c" /* yacc.c:1646  */
    break;

  case 2283:
#line 16379 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeFloatConst((yyvsp[0].str), (yylsp[0]));
				}
#line 49131 "gram.c" /* yacc.c:1646  */
    break;

  case 2284:
#line 16383 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeStringConst((yyvsp[0].str), (yylsp[0]));
				}
#line 49139 "gram.c" /* yacc.c:1646  */
    break;

  case 2285:
#line 16387 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeBitStringConst((yyvsp[0].str), (yylsp[0]));
				}
#line 49147 "gram.c" /* yacc.c:1646  */
    break;

  case 2286:
#line 16391 "gram.y" /* yacc.c:1646  */
    {
					/* This is a bit constant per SQL99:
					 * Without Feature F511, "BIT data type",
					 * a <general literal> shall not be a
					 * <bit string literal> or a <hex string literal>.
					 */
					(yyval.node) = makeBitStringConst((yyvsp[0].str), (yylsp[0]));
				}
#line 49160 "gram.c" /* yacc.c:1646  */
    break;

  case 2287:
#line 16400 "gram.y" /* yacc.c:1646  */
    {
					/* generic type 'literal' syntax */
					TypeName   *t = makeTypeNameFromNameList((yyvsp[-1].list));

					t->location = (yylsp[-1]);
					(yyval.node) = makeStringConstCast((yyvsp[0].str), (yylsp[0]), t);
				}
#line 49172 "gram.c" /* yacc.c:1646  */
    break;

  case 2288:
#line 16408 "gram.y" /* yacc.c:1646  */
    {
					/* generic syntax with a type modifier */
					TypeName   *t = makeTypeNameFromNameList((yyvsp[-5].list));
					ListCell   *lc;

					/*
					 * We must use func_arg_list and opt_sort_clause in the
					 * production to avoid reduce/reduce conflicts, but we
					 * don't actually wish to allow NamedArgExpr in this
					 * context, nor ORDER BY.
					 */
					foreach(lc, (yyvsp[-3].list))
					{
						NamedArgExpr *arg = (NamedArgExpr *) lfirst(lc);

						if (IsA(arg, NamedArgExpr))
							ereport(ERROR,
									(errcode(ERRCODE_SYNTAX_ERROR),
									 errmsg("type modifier cannot have parameter name"),
									 parser_errposition(arg->location)));
					}
					if ((yyvsp[-2].list) != NIL)
							ereport(ERROR,
									(errcode(ERRCODE_SYNTAX_ERROR),
									 errmsg("type modifier cannot have ORDER BY"),
									 parser_errposition((yylsp[-2]))));

					t->typmods = (yyvsp[-3].list);
					t->location = (yylsp[-5]);
					(yyval.node) = makeStringConstCast((yyvsp[0].str), (yylsp[0]), t);
				}
#line 49208 "gram.c" /* yacc.c:1646  */
    break;

  case 2289:
#line 16440 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeStringConstCast((yyvsp[0].str), (yylsp[0]), (yyvsp[-1].typnam));
				}
#line 49216 "gram.c" /* yacc.c:1646  */
    break;

  case 2290:
#line 16444 "gram.y" /* yacc.c:1646  */
    {
					TypeName   *t = (yyvsp[-2].typnam);

					t->typmods = (yyvsp[0].list);
					(yyval.node) = makeStringConstCast((yyvsp[-1].str), (yylsp[-1]), t);
				}
#line 49227 "gram.c" /* yacc.c:1646  */
    break;

  case 2291:
#line 16451 "gram.y" /* yacc.c:1646  */
    {
					TypeName   *t = (yyvsp[-4].typnam);

					t->typmods = list_make2(makeIntConst(INTERVAL_FULL_RANGE, -1),
											makeIntConst((yyvsp[-2].ival), (yylsp[-2])));
					(yyval.node) = makeStringConstCast((yyvsp[0].str), (yylsp[0]), t);
				}
#line 49239 "gram.c" /* yacc.c:1646  */
    break;

  case 2292:
#line 16459 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeBoolAConst(true, (yylsp[0]));
				}
#line 49247 "gram.c" /* yacc.c:1646  */
    break;

  case 2293:
#line 16463 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeBoolAConst(false, (yylsp[0]));
				}
#line 49255 "gram.c" /* yacc.c:1646  */
    break;

  case 2294:
#line 16467 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeNullAConst((yylsp[0]));
				}
#line 49263 "gram.c" /* yacc.c:1646  */
    break;

  case 2295:
#line 16472 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = (yyvsp[0].ival); }
#line 49269 "gram.c" /* yacc.c:1646  */
    break;

  case 2296:
#line 16473 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 49275 "gram.c" /* yacc.c:1646  */
    break;

  case 2297:
#line 16475 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = (yyvsp[0].ival); }
#line 49281 "gram.c" /* yacc.c:1646  */
    break;

  case 2298:
#line 16476 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = + (yyvsp[0].ival); }
#line 49287 "gram.c" /* yacc.c:1646  */
    break;

  case 2299:
#line 16477 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = - (yyvsp[0].ival); }
#line 49293 "gram.c" /* yacc.c:1646  */
    break;

  case 2300:
#line 16482 "gram.y" /* yacc.c:1646  */
    {
					RoleSpec   *spc = (RoleSpec *) (yyvsp[0].rolespec);

					switch (spc->roletype)
					{
						case ROLESPEC_CSTRING:
							(yyval.str) = spc->rolename;
							break;
						case ROLESPEC_PUBLIC:
							ereport(ERROR,
									(errcode(ERRCODE_RESERVED_NAME),
									 errmsg("role name \"%s\" is reserved",
											"public"),
									 parser_errposition((yylsp[0]))));
							break;
						case ROLESPEC_SESSION_USER:
							ereport(ERROR,
									(errcode(ERRCODE_RESERVED_NAME),
									 errmsg("%s cannot be used as a role name here",
											"SESSION_USER"),
									 parser_errposition((yylsp[0]))));
							break;
						case ROLESPEC_CURRENT_USER:
							ereport(ERROR,
									(errcode(ERRCODE_RESERVED_NAME),
									 errmsg("%s cannot be used as a role name here",
											"CURRENT_USER"),
									 parser_errposition((yylsp[0]))));
							break;
						case ROLESPEC_CURRENT_ROLE:
							ereport(ERROR,
									(errcode(ERRCODE_RESERVED_NAME),
									 errmsg("%s cannot be used as a role name here",
											"CURRENT_ROLE"),
									 parser_errposition((yylsp[0]))));
							break;
					}
				}
#line 49336 "gram.c" /* yacc.c:1646  */
    break;

  case 2301:
#line 16523 "gram.y" /* yacc.c:1646  */
    {
					/*
					 * "public" and "none" are not keywords, but they must
					 * be treated specially here.
					 */
					RoleSpec   *n;

					if (strcmp((yyvsp[0].str), "public") == 0)
					{
						n = (RoleSpec *) makeRoleSpec(ROLESPEC_PUBLIC, (yylsp[0]));
						n->roletype = ROLESPEC_PUBLIC;
					}
					else if (strcmp((yyvsp[0].str), "none") == 0)
					{
						ereport(ERROR,
								(errcode(ERRCODE_RESERVED_NAME),
								 errmsg("role name \"%s\" is reserved",
										"none"),
								 parser_errposition((yylsp[0]))));
					}
					else
					{
						n = makeRoleSpec(ROLESPEC_CSTRING, (yylsp[0]));
						n->rolename = pstrdup((yyvsp[0].str));
					}
					(yyval.rolespec) = n;
				}
#line 49368 "gram.c" /* yacc.c:1646  */
    break;

  case 2302:
#line 16551 "gram.y" /* yacc.c:1646  */
    {
					(yyval.rolespec) = makeRoleSpec(ROLESPEC_CURRENT_ROLE, (yylsp[0]));
				}
#line 49376 "gram.c" /* yacc.c:1646  */
    break;

  case 2303:
#line 16555 "gram.y" /* yacc.c:1646  */
    {
					(yyval.rolespec) = makeRoleSpec(ROLESPEC_CURRENT_USER, (yylsp[0]));
				}
#line 49384 "gram.c" /* yacc.c:1646  */
    break;

  case 2304:
#line 16559 "gram.y" /* yacc.c:1646  */
    {
					(yyval.rolespec) = makeRoleSpec(ROLESPEC_SESSION_USER, (yylsp[0]));
				}
#line 49392 "gram.c" /* yacc.c:1646  */
    break;

  case 2305:
#line 16565 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].rolespec)); }
#line 49398 "gram.c" /* yacc.c:1646  */
    break;

  case 2306:
#line 16567 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].rolespec)); }
#line 49404 "gram.c" /* yacc.c:1646  */
    break;

  case 2307:
#line 16584 "gram.y" /* yacc.c:1646  */
    {
					SelectStmt *n = makeNode(SelectStmt);

					n->distinctClause = (yyvsp[-9].list);
					n->targetList = (yyvsp[-8].list);
					n->fromClause = (yyvsp[-7].list);
					n->whereClause = (yyvsp[-6].node);
					n->groupClause = ((yyvsp[-5].groupclause))->list;
					n->groupDistinct = ((yyvsp[-5].groupclause))->distinct;
					n->havingClause = (yyvsp[-4].node);
					n->windowClause = (yyvsp[-3].list);
					n->sortClause = (yyvsp[-2].list);
					if ((yyvsp[-1].selectlimit))
					{
						n->limitOffset = (yyvsp[-1].selectlimit)->limitOffset;
						n->limitCount = (yyvsp[-1].selectlimit)->limitCount;
						if (!n->sortClause &&
							(yyvsp[-1].selectlimit)->limitOption == LIMIT_OPTION_WITH_TIES)
							ereport(ERROR,
									(errcode(ERRCODE_SYNTAX_ERROR),
									 errmsg("WITH TIES cannot be specified without ORDER BY clause")));
						n->limitOption = (yyvsp[-1].selectlimit)->limitOption;
					}
					n->lockingClause = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 49435 "gram.c" /* yacc.c:1646  */
    break;

  case 2308:
#line 16617 "gram.y" /* yacc.c:1646  */
    {
					PLAssignStmt *n = makeNode(PLAssignStmt);

					n->name = (yyvsp[-3].str);
					n->indirection = check_indirection((yyvsp[-2].list), yyscanner);
					/* nnames will be filled by calling production */
					n->val = (SelectStmt *) (yyvsp[0].node);
					n->location = (yylsp[-3]);
					(yyval.node) = (Node *) n;
				}
#line 49450 "gram.c" /* yacc.c:1646  */
    break;

  case 2309:
#line 16629 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 49456 "gram.c" /* yacc.c:1646  */
    break;

  case 2310:
#line 16630 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = psprintf("$%d", (yyvsp[0].ival)); }
#line 49462 "gram.c" /* yacc.c:1646  */
    break;

  case 2313:
#line 16651 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 49468 "gram.c" /* yacc.c:1646  */
    break;

  case 2314:
#line 16652 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = pstrdup((yyvsp[0].keyword)); }
#line 49474 "gram.c" /* yacc.c:1646  */
    break;

  case 2315:
#line 16653 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = pstrdup((yyvsp[0].keyword)); }
#line 49480 "gram.c" /* yacc.c:1646  */
    break;

  case 2316:
#line 16658 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 49486 "gram.c" /* yacc.c:1646  */
    break;

  case 2317:
#line 16659 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = pstrdup((yyvsp[0].keyword)); }
#line 49492 "gram.c" /* yacc.c:1646  */
    break;

  case 2318:
#line 16660 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = pstrdup((yyvsp[0].keyword)); }
#line 49498 "gram.c" /* yacc.c:1646  */
    break;

  case 2319:
#line 16665 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 49504 "gram.c" /* yacc.c:1646  */
    break;

  case 2320:
#line 16666 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = pstrdup((yyvsp[0].keyword)); }
#line 49510 "gram.c" /* yacc.c:1646  */
    break;

  case 2321:
#line 16667 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = pstrdup((yyvsp[0].keyword)); }
#line 49516 "gram.c" /* yacc.c:1646  */
    break;

  case 2322:
#line 16668 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = pstrdup((yyvsp[0].keyword)); }
#line 49522 "gram.c" /* yacc.c:1646  */
    break;

  case 2323:
#line 16674 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 49528 "gram.c" /* yacc.c:1646  */
    break;

  case 2324:
#line 16675 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = pstrdup((yyvsp[0].keyword)); }
#line 49534 "gram.c" /* yacc.c:1646  */
    break;

  case 2325:
#line 16676 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = pstrdup((yyvsp[0].keyword)); }
#line 49540 "gram.c" /* yacc.c:1646  */
    break;

  case 2326:
#line 16677 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = pstrdup((yyvsp[0].keyword)); }
#line 49546 "gram.c" /* yacc.c:1646  */
    break;

  case 2327:
#line 16678 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = pstrdup((yyvsp[0].keyword)); }
#line 49552 "gram.c" /* yacc.c:1646  */
    break;

  case 2328:
#line 16684 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 49558 "gram.c" /* yacc.c:1646  */
    break;

  case 2329:
#line 16685 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = pstrdup((yyvsp[0].keyword)); }
#line 49564 "gram.c" /* yacc.c:1646  */
    break;


#line 49568 "gram.c" /* yacc.c:1646  */
      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", yyr1[yyn], &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;
  *++yylsp = yyloc;

  /* Now 'shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*--------------------------------------.
| yyerrlab -- here on detecting error.  |
`--------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYEMPTY : YYTRANSLATE (yychar);

  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if ! YYERROR_VERBOSE
      yyerror (&yylloc, yyscanner, YY_("syntax error"));
#else
# define YYSYNTAX_ERROR yysyntax_error (&yymsg_alloc, &yymsg, \
                                        yyssp, yytoken)
      {
        char const *yymsgp = YY_("syntax error");
        int yysyntax_error_status;
        yysyntax_error_status = YYSYNTAX_ERROR;
        if (yysyntax_error_status == 0)
          yymsgp = yymsg;
        else if (yysyntax_error_status == 1)
          {
            if (yymsg != yymsgbuf)
              YYSTACK_FREE (yymsg);
            yymsg = (char *) YYSTACK_ALLOC (yymsg_alloc);
            if (!yymsg)
              {
                yymsg = yymsgbuf;
                yymsg_alloc = sizeof yymsgbuf;
                yysyntax_error_status = 2;
              }
            else
              {
                yysyntax_error_status = YYSYNTAX_ERROR;
                yymsgp = yymsg;
              }
          }
        yyerror (&yylloc, yyscanner, yymsgp);
        if (yysyntax_error_status == 2)
          goto yyexhaustedlab;
      }
# undef YYSYNTAX_ERROR
#endif
    }

  yyerror_range[1] = yylloc;

  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
         error, discard it.  */

      if (yychar <= YYEOF)
        {
          /* Return failure if at end of input.  */
          if (yychar == YYEOF)
            YYABORT;
        }
      else
        {
          yydestruct ("Error: discarding",
                      yytoken, &yylval, &yylloc, yyscanner);
          yychar = YYEMPTY;
        }
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:

  /* Pacify compilers like GCC when the user code never invokes
     YYERROR and the label yyerrorlab therefore never appears in user
     code.  */
  if (/*CONSTCOND*/ 0)
     goto yyerrorlab;

  yyerror_range[1] = yylsp[1-yylen];
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;      /* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
        {
          yyn += YYTERROR;
          if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
            {
              yyn = yytable[yyn];
              if (0 < yyn)
                break;
            }
        }

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
        YYABORT;

      yyerror_range[1] = *yylsp;
      yydestruct ("Error: popping",
                  yystos[yystate], yyvsp, yylsp, yyscanner);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  yyerror_range[2] = yylloc;
  /* Using YYLLOC is tempting, but would change the location of
     the lookahead.  YYLOC is available though.  */
  YYLLOC_DEFAULT (yyloc, yyerror_range, 2);
  *++yylsp = yyloc;

  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", yystos[yyn], yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#if !defined yyoverflow || YYERROR_VERBOSE
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (&yylloc, yyscanner, YY_("memory exhausted"));
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval, &yylloc, yyscanner);
    }
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
                  yystos[*yyssp], yyvsp, yylsp, yyscanner);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
#if YYERROR_VERBOSE
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
#endif
  return yyresult;
}
#line 17635 "gram.y" /* yacc.c:1906  */


/*
 * The signature of this function is required by bison.  However, we
 * ignore the passed yylloc and instead use the last token position
 * available from the scanner.
 */
static void
base_yyerror(YYLTYPE *yylloc, core_yyscan_t yyscanner, const char *msg)
{
	parser_yyerror(msg);
}

static RawStmt *
makeRawStmt(Node *stmt, int stmt_location)
{
	RawStmt    *rs = makeNode(RawStmt);

	rs->stmt = stmt;
	rs->stmt_location = stmt_location;
	rs->stmt_len = 0;			/* might get changed later */
	return rs;
}

/* Adjust a RawStmt to reflect that it doesn't run to the end of the string */
static void
updateRawStmtEnd(RawStmt *rs, int end_location)
{
	/*
	 * If we already set the length, don't change it.  This is for situations
	 * like "select foo ;; select bar" where the same statement will be last
	 * in the string for more than one semicolon.
	 */
	if (rs->stmt_len > 0)
		return;

	/* OK, update length of RawStmt */
	rs->stmt_len = end_location - rs->stmt_location;
}

static Node *
makeColumnRef(char *colname, List *indirection,
			  int location, core_yyscan_t yyscanner)
{
	/*
	 * Generate a ColumnRef node, with an A_Indirection node added if there
	 * is any subscripting in the specified indirection list.  However,
	 * any field selection at the start of the indirection list must be
	 * transposed into the "fields" part of the ColumnRef node.
	 */
	ColumnRef  *c = makeNode(ColumnRef);
	int			nfields = 0;
	ListCell   *l;

	c->location = location;
	foreach(l, indirection)
	{
		if (IsA(lfirst(l), A_Indices))
		{
			A_Indirection *i = makeNode(A_Indirection);

			if (nfields == 0)
			{
				/* easy case - all indirection goes to A_Indirection */
				c->fields = list_make1(makeString(colname));
				i->indirection = check_indirection(indirection, yyscanner);
			}
			else
			{
				/* got to split the list in two */
				i->indirection = check_indirection(list_copy_tail(indirection,
																  nfields),
												   yyscanner);
				indirection = list_truncate(indirection, nfields);
				c->fields = lcons(makeString(colname), indirection);
			}
			i->arg = (Node *) c;
			return (Node *) i;
		}
		else if (IsA(lfirst(l), A_Star))
		{
			/* We only allow '*' at the end of a ColumnRef */
			if (lnext(indirection, l) != NULL)
				parser_yyerror("improper use of \"*\"");
		}
		nfields++;
	}
	/* No subscripting, so all indirection gets added to field list */
	c->fields = lcons(makeString(colname), indirection);
	return (Node *) c;
}

Node *
makeTypeCast(Node *arg, TypeName *typename, int location)
{
	TypeCast   *n = makeNode(TypeCast);

	n->arg = arg;
	n->typeName = typename;
	n->location = location;
	return (Node *) n;
}

static Node *
makeStringConst(char *str, int location)
{
	A_Const    *n = makeNode(A_Const);

	n->val.sval.type = T_String;
	n->val.sval.sval = str;
	n->location = location;

	return (Node *) n;
}

Node *
makeStringConstCast(char *str, int location, TypeName *typename)
{
	Node       *s = makeStringConst(str, location);

	return makeTypeCast(s, typename, -1);
}

Node *
makeIntConst(int val, int location)
{
	A_Const    *n = makeNode(A_Const);

	n->val.ival.type = T_Integer;
	n->val.ival.ival = val;
	n->location = location;

	return (Node *)n;
}

static Node *
makeFloatConst(char *str, int location)
{
	A_Const    *n = makeNode(A_Const);

	n->val.fval.type = T_Float;
	n->val.fval.fval = str;
	n->location = location;

	return (Node *)n;
}

static Node *
makeBoolAConst(bool state, int location)
{
    A_Const    *n = makeNode(A_Const);

    n->val.boolval.type = T_Boolean;
    n->val.boolval.boolval = state;
    n->location = location;

   return (Node *) n;
}

static Node *
makeBitStringConst(char *str, int location)
{
    A_Const    *n = makeNode(A_Const);

    n->val.bsval.type = T_BitString;
    n->val.bsval.bsval = str;
	n->location = location;

	return (Node *)n;
}

static Node *
makeNullAConst(int location)
{
    A_Const    *n = makeNode(A_Const);

    n->isnull = true;
    n->location = location;

	return (Node *)n;
}

static Node *
makeAConst(Node *v, int location)
{
	Node       *n;

	switch (v->type)
	{
		case T_Float:
			n = makeFloatConst(castNode(Float, v)->fval, location);
			break;

		case T_Integer:
			n = makeIntConst(castNode(Integer, v)->ival, location);
			break;

		default:
			/* currently not used */
			Assert(false);
			n = NULL;
	}

	return n;
}

/* makeRoleSpec
 * Create a RoleSpec with the given type
 */
static RoleSpec *
makeRoleSpec(RoleSpecType type, int location)
{
	RoleSpec   *spec = makeNode(RoleSpec);

	spec->roletype = type;
	spec->location = location;

	return spec;
}

/* check_qualified_name --- check the result of qualified_name production
 *
 * It's easiest to let the grammar production for qualified_name allow
 * subscripts and '*', which we then must reject here.
 */
static void
check_qualified_name(List *names, core_yyscan_t yyscanner)
{
	ListCell   *i;

	foreach(i, names)
	{
		if (!IsA(lfirst(i), String))
			parser_yyerror("syntax error");
	}
}

/* check_func_name --- check the result of func_name production
 *
 * It's easiest to let the grammar production for func_name allow subscripts
 * and '*', which we then must reject here.
 */
static List *
check_func_name(List *names, core_yyscan_t yyscanner)
{
	ListCell   *i;

	foreach(i, names)
	{
		if (!IsA(lfirst(i), String))
			parser_yyerror("syntax error");
	}
	return names;
}

/* check_indirection --- check the result of indirection production
 *
 * We only allow '*' at the end of the list, but it's hard to enforce that
 * in the grammar, so do it here.
 */
static List *
check_indirection(List *indirection, core_yyscan_t yyscanner)
{
	ListCell *l;

	foreach(l, indirection)
	{
		if (IsA(lfirst(l), A_Star))
		{
			if (lnext(indirection, l) != NULL)
				parser_yyerror("improper use of \"*\"");
		}
	}
	return indirection;
}

/* extractArgTypes()
 * Given a list of FunctionParameter nodes, extract a list of just the
 * argument types (TypeNames) for input parameters only.  This is what
 * is needed to look up an existing function, which is what is wanted by
 * the productions that use this call.
 */
static List *
extractArgTypes(List *parameters)
{
	List	   *result = NIL;
	ListCell   *i;

	foreach(i, parameters)
	{
		FunctionParameter *p = (FunctionParameter *) lfirst(i);

		if (p->mode != FUNC_PARAM_OUT && p->mode != FUNC_PARAM_TABLE)
			result = lappend(result, p->argType);
	}
	return result;
}

/* extractAggrArgTypes()
 * As above, but work from the output of the aggr_args production.
 */
static List *
extractAggrArgTypes(List *aggrargs)
{
	Assert(list_length(aggrargs) == 2);
	return extractArgTypes((List *) linitial(aggrargs));
}

/* makeOrderedSetArgs()
 * Build the result of the aggr_args production (which see the comments for).
 * This handles only the case where both given lists are nonempty, so that
 * we have to deal with multiple VARIADIC arguments.
 */
static List *
makeOrderedSetArgs(List *directargs, List *orderedargs,
				   core_yyscan_t yyscanner)
{
	FunctionParameter *lastd = (FunctionParameter *) llast(directargs);
	Integer	   *ndirectargs;

	/* No restriction unless last direct arg is VARIADIC */
	if (lastd->mode == FUNC_PARAM_VARIADIC)
	{
		FunctionParameter *firsto = (FunctionParameter *) linitial(orderedargs);

		/*
		 * We ignore the names, though the aggr_arg production allows them;
		 * it doesn't allow default values, so those need not be checked.
		 */
		if (list_length(orderedargs) != 1 ||
			firsto->mode != FUNC_PARAM_VARIADIC)
			ereport(ERROR,
					(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
					 errmsg("an ordered-set aggregate with a VARIADIC direct argument must have one VARIADIC aggregated argument of the same data type"),
					 parser_errposition(exprLocation((Node *) firsto))));

		/* OK, drop the duplicate VARIADIC argument from the internal form */
		orderedargs = NIL;
	}

	/* don't merge into the next line, as list_concat changes directargs */
	ndirectargs = makeInteger(list_length(directargs));

	return list_make2(list_concat(directargs, orderedargs),
					  ndirectargs);
}

/* insertSelectOptions()
 * Insert ORDER BY, etc into an already-constructed SelectStmt.
 *
 * This routine is just to avoid duplicating code in SelectStmt productions.
 */
static void
insertSelectOptions(SelectStmt *stmt,
					List *sortClause, List *lockingClause,
					SelectLimit *limitClause,
					WithClause *withClause,
					core_yyscan_t yyscanner)
{
	Assert(IsA(stmt, SelectStmt));

	/*
	 * Tests here are to reject constructs like
	 *	(SELECT foo ORDER BY bar) ORDER BY baz
	 */
	if (sortClause)
	{
		if (stmt->sortClause)
			ereport(ERROR,
					(errcode(ERRCODE_SYNTAX_ERROR),
					 errmsg("multiple ORDER BY clauses not allowed"),
					 parser_errposition(exprLocation((Node *) sortClause))));
		stmt->sortClause = sortClause;
	}
	/* We can handle multiple locking clauses, though */
	stmt->lockingClause = list_concat(stmt->lockingClause, lockingClause);
	if (limitClause && limitClause->limitOffset)
	{
		if (stmt->limitOffset)
			ereport(ERROR,
					(errcode(ERRCODE_SYNTAX_ERROR),
					 errmsg("multiple OFFSET clauses not allowed"),
					 parser_errposition(exprLocation(limitClause->limitOffset))));
		stmt->limitOffset = limitClause->limitOffset;
	}
	if (limitClause && limitClause->limitCount)
	{
		if (stmt->limitCount)
			ereport(ERROR,
					(errcode(ERRCODE_SYNTAX_ERROR),
					 errmsg("multiple LIMIT clauses not allowed"),
					 parser_errposition(exprLocation(limitClause->limitCount))));
		stmt->limitCount = limitClause->limitCount;
	}
	if (limitClause && limitClause->limitOption != LIMIT_OPTION_DEFAULT)
	{
		if (stmt->limitOption)
			ereport(ERROR,
					(errcode(ERRCODE_SYNTAX_ERROR),
					 errmsg("multiple limit options not allowed")));
		if (!stmt->sortClause && limitClause->limitOption == LIMIT_OPTION_WITH_TIES)
			ereport(ERROR,
					(errcode(ERRCODE_SYNTAX_ERROR),
					 errmsg("WITH TIES cannot be specified without ORDER BY clause")));
		if (limitClause->limitOption == LIMIT_OPTION_WITH_TIES && stmt->lockingClause)
		{
			ListCell   *lc;

			foreach(lc, stmt->lockingClause)
			{
				LockingClause *lock = lfirst_node(LockingClause, lc);

				if (lock->waitPolicy == LockWaitSkip)
					ereport(ERROR,
							(errcode(ERRCODE_SYNTAX_ERROR),
							 errmsg("%s and %s options cannot be used together",
									"SKIP LOCKED", "WITH TIES")));
			}
		}
		stmt->limitOption = limitClause->limitOption;
	}
	if (withClause)
	{
		if (stmt->withClause)
			ereport(ERROR,
					(errcode(ERRCODE_SYNTAX_ERROR),
					 errmsg("multiple WITH clauses not allowed"),
					 parser_errposition(exprLocation((Node *) withClause))));
		stmt->withClause = withClause;
	}
}

static Node *
makeSetOp(SetOperation op, bool all, Node *larg, Node *rarg)
{
	SelectStmt *n = makeNode(SelectStmt);

	n->op = op;
	n->all = all;
	n->larg = (SelectStmt *) larg;
	n->rarg = (SelectStmt *) rarg;
	return (Node *) n;
}

/* SystemFuncName()
 * Build a properly-qualified reference to a built-in function.
 */
List *
SystemFuncName(char *name)
{
	return list_make2(makeString("pg_catalog"), makeString(name));
}

/* SystemTypeName()
 * Build a properly-qualified reference to a built-in type.
 *
 * typmod is defaulted, but may be changed afterwards by caller.
 * Likewise for the location.
 */
TypeName *
SystemTypeName(char *name)
{
	return makeTypeNameFromNameList(list_make2(makeString("pg_catalog"),
											   makeString(name)));
}
/* doNegate()
 * Handle negation of a numeric constant.
 *
 * Formerly, we did this here because the optimizer couldn't cope with
 * indexquals that looked like "var = -4" --- it wants "var = const"
 * and a unary minus operator applied to a constant didn't qualify.
 * As of Postgres 7.0, that problem doesn't exist anymore because there
 * is a constant-subexpression simplifier in the optimizer.  However,
 * there's still a good reason for doing this here, which is that we can
 * postpone committing to a particular internal representation for simple
 * negative constants.	It's better to leave "-123.456" in string form
 * until we know what the desired type is.
 */
static Node *
doNegate(Node *n, int location)
{
	if (IsA(n, A_Const))
	{
		A_Const	   *con = (A_Const *) n;

		/* report the constant's location as that of the '-' sign */
		con->location = location;

		if (IsA(&con->val, Integer))
		{
			con->val.ival.ival = -con->val.ival.ival;
			return n;
		}
		if (IsA(&con->val, Float))
		{
			doNegateFloat(&con->val.fval);
			return n;
		}
	}

	return (Node *) makeSimpleA_Expr(AEXPR_OP, "-", NULL, n, location);
}

static void
doNegateFloat(Float *v)
{
	char	   *oldval = v->fval;

	if (*oldval == '+')
		oldval++;
	if (*oldval == '-')
		v->fval = oldval+1;	/* just strip the '-' */
	else
		v->fval = psprintf("-%s", oldval);
}

static Node *
makeAndExpr(Node *lexpr, Node *rexpr, int location)
{
	/* Flatten "a AND b AND c ..." to a single BoolExpr on sight */
	if (IsA(lexpr, BoolExpr))
	{
		BoolExpr   *blexpr = (BoolExpr *) lexpr;

		if (blexpr->boolop == AND_EXPR)
		{
			blexpr->args = lappend(blexpr->args, rexpr);
			return (Node *) blexpr;
		}
	}
	return (Node *) makeBoolExpr(AND_EXPR, list_make2(lexpr, rexpr), location);
}

static Node *
makeOrExpr(Node *lexpr, Node *rexpr, int location)
{
	/* Flatten "a OR b OR c ..." to a single BoolExpr on sight */
	if (IsA(lexpr, BoolExpr))
	{
		BoolExpr   *blexpr = (BoolExpr *) lexpr;

		if (blexpr->boolop == OR_EXPR)
		{
			blexpr->args = lappend(blexpr->args, rexpr);
			return (Node *) blexpr;
		}
	}
	return (Node *) makeBoolExpr(OR_EXPR, list_make2(lexpr, rexpr), location);
}

static Node *
makeNotExpr(Node *expr, int location)
{
	return (Node *) makeBoolExpr(NOT_EXPR, list_make1(expr), location);
}

static Node *
makeAArrayExpr(List *elements, int location)
{
	A_ArrayExpr *n = makeNode(A_ArrayExpr);

	n->elements = elements;
	n->location = location;
	return (Node *) n;
}

static Node *
makeSQLValueFunction(SQLValueFunctionOp op, int32 typmod, int location)
{
	SQLValueFunction *svf = makeNode(SQLValueFunction);

	svf->op = op;
	/* svf->type will be filled during parse analysis */
	svf->typmod = typmod;
	svf->location = location;
	return (Node *) svf;
}

static Node *
makeXmlExpr(XmlExprOp op, char *name, List *named_args, List *args,
			int location)
{
	XmlExpr		*x = makeNode(XmlExpr);

	x->op = op;
	x->name = name;
	/*
	 * named_args is a list of ResTarget; it'll be split apart into separate
	 * expression and name lists in transformXmlExpr().
	 */
	x->named_args = named_args;
	x->arg_names = NIL;
	x->args = args;
	/* xmloption, if relevant, must be filled in by caller */
	/* type and typmod will be filled in during parse analysis */
	x->type = InvalidOid;			/* marks the node as not analyzed */
	x->location = location;
	return (Node *) x;
}

/*
 * Merge the input and output parameters of a table function.
 */
static List *
mergeTableFuncParameters(List *func_args, List *columns)
{
	ListCell   *lc;

	/* Explicit OUT and INOUT parameters shouldn't be used in this syntax */
	foreach(lc, func_args)
	{
		FunctionParameter *p = (FunctionParameter *) lfirst(lc);

		if (p->mode != FUNC_PARAM_DEFAULT &&
			p->mode != FUNC_PARAM_IN &&
			p->mode != FUNC_PARAM_VARIADIC)
			ereport(ERROR,
					(errcode(ERRCODE_SYNTAX_ERROR),
					 errmsg("OUT and INOUT arguments aren't allowed in TABLE functions")));
	}

	return list_concat(func_args, columns);
}

/*
 * Determine return type of a TABLE function.  A single result column
 * returns setof that column's type; otherwise return setof record.
 */
static TypeName *
TableFuncTypeName(List *columns)
{
	TypeName   *result;

	if (list_length(columns) == 1)
	{
		FunctionParameter *p = (FunctionParameter *) linitial(columns);

		result = copyObject(p->argType);
	}
	else
		result = SystemTypeName("record");

	result->setof = true;

	return result;
}

/*
 * Convert a list of (dotted) names to a RangeVar (like
 * makeRangeVarFromNameList, but with position support).  The
 * "AnyName" refers to the any_name production in the grammar.
 */
static RangeVar *
makeRangeVarFromAnyName(List *names, int position, core_yyscan_t yyscanner)
{
	RangeVar   *r = makeNode(RangeVar);

	switch (list_length(names))
	{
		case 1:
			r->catalogname = NULL;
			r->schemaname = NULL;
			r->relname = strVal(linitial(names));
			break;
		case 2:
			r->catalogname = NULL;
			r->schemaname = strVal(linitial(names));
			r->relname = strVal(lsecond(names));
			break;
		case 3:
			r->catalogname = strVal(linitial(names));
			r->schemaname = strVal(lsecond(names));
			r->relname = strVal(lthird(names));
			break;
		default:
			ereport(ERROR,
					(errcode(ERRCODE_SYNTAX_ERROR),
					 errmsg("improper qualified name (too many dotted names): %s",
							NameListToString(names)),
					 parser_errposition(position)));
			break;
	}

	r->relpersistence = RELPERSISTENCE_PERMANENT;
	r->location = position;

	return r;
}

/*
 * Convert a relation_name with name and namelist to a RangeVar using
 * makeRangeVar.
 */
static RangeVar *
makeRangeVarFromQualifiedName(char *name, List *namelist, int location,
							  core_yyscan_t yyscanner)
{
	RangeVar   *r;

	check_qualified_name(namelist, yyscanner);
	r = makeRangeVar(NULL, NULL, location);

	switch (list_length(namelist))
	{
		case 1:
			r->catalogname = NULL;
			r->schemaname = name;
			r->relname = strVal(linitial(namelist));
			break;
		case 2:
			r->catalogname = name;
			r->schemaname = strVal(linitial(namelist));
			r->relname = strVal(lsecond(namelist));
			break;
		default:
			ereport(ERROR,
					(errcode(ERRCODE_SYNTAX_ERROR),
					 errmsg("improper qualified name (too many dotted names): %s",
						   NameListToString(lcons(makeString(name), namelist))),
						   parser_errposition(location)));
			break;
	}

	return r;
}

/* Separate Constraint nodes from COLLATE clauses in a ColQualList */
static void
SplitColQualList(List *qualList,
				 List **constraintList, CollateClause **collClause,
				 core_yyscan_t yyscanner)
{
	ListCell   *cell;

	*collClause = NULL;
	foreach(cell, qualList)
	{
		Node	   *n = (Node *) lfirst(cell);

		if (IsA(n, Constraint))
		{
			/* keep it in list */
			continue;
		}
		if (IsA(n, CollateClause))
		{
			CollateClause *c = (CollateClause *) n;

			if (*collClause)
				ereport(ERROR,
						(errcode(ERRCODE_SYNTAX_ERROR),
						 errmsg("multiple COLLATE clauses not allowed"),
						 parser_errposition(c->location)));
			*collClause = c;
		}
		else
			elog(ERROR, "unexpected node type %d", (int) n->type);
		/* remove non-Constraint nodes from qualList */
		qualList = foreach_delete_current(qualList, cell);
	}
	*constraintList = qualList;
}

/*
 * Process result of ConstraintAttributeSpec, and set appropriate bool flags
 * in the output command node.  Pass NULL for any flags the particular
 * command doesn't support.
 */
static void
processCASbits(int cas_bits, int location, const char *constrType,
			   bool *deferrable, bool *initdeferred, bool *not_valid,
			   bool *no_inherit, core_yyscan_t yyscanner)
{
	/* defaults */
	if (deferrable)
		*deferrable = false;
	if (initdeferred)
		*initdeferred = false;
	if (not_valid)
		*not_valid = false;

	if (cas_bits & (CAS_DEFERRABLE | CAS_INITIALLY_DEFERRED))
	{
		if (deferrable)
			*deferrable = true;
		else
			ereport(ERROR,
					(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
					 /* translator: %s is CHECK, UNIQUE, or similar */
					 errmsg("%s constraints cannot be marked DEFERRABLE",
							constrType),
					 parser_errposition(location)));
	}

	if (cas_bits & CAS_INITIALLY_DEFERRED)
	{
		if (initdeferred)
			*initdeferred = true;
		else
			ereport(ERROR,
					(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
					 /* translator: %s is CHECK, UNIQUE, or similar */
					 errmsg("%s constraints cannot be marked DEFERRABLE",
							constrType),
					 parser_errposition(location)));
	}

	if (cas_bits & CAS_NOT_VALID)
	{
		if (not_valid)
			*not_valid = true;
		else
			ereport(ERROR,
					(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
					 /* translator: %s is CHECK, UNIQUE, or similar */
					 errmsg("%s constraints cannot be marked NOT VALID",
							constrType),
					 parser_errposition(location)));
	}

	if (cas_bits & CAS_NO_INHERIT)
	{
		if (no_inherit)
			*no_inherit = true;
		else
			ereport(ERROR,
					(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
					 /* translator: %s is CHECK, UNIQUE, or similar */
					 errmsg("%s constraints cannot be marked NO INHERIT",
							constrType),
					 parser_errposition(location)));
	}
}

/*
 * Process pubobjspec_list to check for errors in any of the objects and
 * convert PUBLICATIONOBJ_CONTINUATION into appropriate PublicationObjSpecType.
 */
static void
preprocess_pubobj_list(List *pubobjspec_list, core_yyscan_t yyscanner)
{
	ListCell   *cell;
	PublicationObjSpec *pubobj;
	PublicationObjSpecType prevobjtype = PUBLICATIONOBJ_CONTINUATION;

	if (!pubobjspec_list)
		return;

	pubobj = (PublicationObjSpec *) linitial(pubobjspec_list);
	if (pubobj->pubobjtype == PUBLICATIONOBJ_CONTINUATION)
		ereport(ERROR,
				(errcode(ERRCODE_SYNTAX_ERROR),
				 errmsg("invalid publication object list"),
				 errdetail("One of TABLE or ALL TABLES IN SCHEMA must be specified before a standalone table or schema name."),
				 parser_errposition(pubobj->location)));

	foreach(cell, pubobjspec_list)
	{
		pubobj = (PublicationObjSpec *) lfirst(cell);

		if (pubobj->pubobjtype == PUBLICATIONOBJ_CONTINUATION)
			pubobj->pubobjtype = prevobjtype;

		if (pubobj->pubobjtype == PUBLICATIONOBJ_TABLE)
		{
			/* relation name or pubtable must be set for this type of object */
			if (!pubobj->name && !pubobj->pubtable)
				ereport(ERROR,
						(errcode(ERRCODE_SYNTAX_ERROR),
						 errmsg("invalid table name at or near"),
						 parser_errposition(pubobj->location)));

			if (pubobj->name)
			{
				/* convert it to PublicationTable */
				PublicationTable *pubtable = makeNode(PublicationTable);

				pubtable->relation =
					makeRangeVar(NULL, pubobj->name, pubobj->location);
				pubobj->pubtable = pubtable;
				pubobj->name = NULL;
			}
		}
		else if (pubobj->pubobjtype == PUBLICATIONOBJ_TABLES_IN_SCHEMA ||
				 pubobj->pubobjtype == PUBLICATIONOBJ_TABLES_IN_CUR_SCHEMA)
		{
			/* WHERE clause is not allowed on a schema object */
			if (pubobj->pubtable && pubobj->pubtable->whereClause)
				ereport(ERROR,
						(errcode(ERRCODE_SYNTAX_ERROR),
						 errmsg("WHERE clause not allowed for schema"),
						 parser_errposition(pubobj->location)));

			/* Column list is not allowed on a schema object */
			if (pubobj->pubtable && pubobj->pubtable->columns)
				ereport(ERROR,
						(errcode(ERRCODE_SYNTAX_ERROR),
						 errmsg("column specification not allowed for schema"),
						 parser_errposition(pubobj->location)));

			/*
			 * We can distinguish between the different type of schema
			 * objects based on whether name and pubtable is set.
			 */
			if (pubobj->name)
				pubobj->pubobjtype = PUBLICATIONOBJ_TABLES_IN_SCHEMA;
			else if (!pubobj->name && !pubobj->pubtable)
				pubobj->pubobjtype = PUBLICATIONOBJ_TABLES_IN_CUR_SCHEMA;
			else
				ereport(ERROR,
						(errcode(ERRCODE_SYNTAX_ERROR),
						 errmsg("invalid schema name at or near"),
						 parser_errposition(pubobj->location)));
		}

		prevobjtype = pubobj->pubobjtype;
	}
}

/*----------
 * Recursive view transformation
 *
 * Convert
 *
 *     CREATE RECURSIVE VIEW relname (aliases) AS query
 *
 * to
 *
 *     CREATE VIEW relname (aliases) AS
 *         WITH RECURSIVE relname (aliases) AS (query)
 *         SELECT aliases FROM relname
 *
 * Actually, just the WITH ... part, which is then inserted into the original
 * view definition as the query.
 * ----------
 */
static Node *
makeRecursiveViewSelect(char *relname, List *aliases, Node *query)
{
	SelectStmt *s = makeNode(SelectStmt);
	WithClause *w = makeNode(WithClause);
	CommonTableExpr *cte = makeNode(CommonTableExpr);
	List	   *tl = NIL;
	ListCell   *lc;

	/* create common table expression */
	cte->ctename = relname;
	cte->aliascolnames = aliases;
	cte->ctematerialized = CTEMaterializeDefault;
	cte->ctequery = query;
	cte->location = -1;

	/* create WITH clause and attach CTE */
	w->recursive = true;
	w->ctes = list_make1(cte);
	w->location = -1;

	/* create target list for the new SELECT from the alias list of the
	 * recursive view specification */
	foreach (lc, aliases)
	{
		ResTarget *rt = makeNode(ResTarget);

		rt->name = NULL;
		rt->indirection = NIL;
		rt->val = makeColumnRef(strVal(lfirst(lc)), NIL, -1, 0);
		rt->location = -1;

		tl = lappend(tl, rt);
	}

	/* create new SELECT combining WITH clause, target list, and fake FROM
	 * clause */
	s->withClause = w;
	s->targetList = tl;
	s->fromClause = list_make1(makeRangeVar(NULL, relname, -1));

	return (Node *) s;
}

/* parser_init()
 * Initialize to parse one query string
 */
void
parser_init(base_yy_extra_type *yyext)
{
	yyext->parsetree = NIL;		/* in case grammar forgets to set it */
}

